/*static char *SCCSID = "@(#)alarmthd.c 6.8 92/02/18";*/

/*=========================================================================\
 *									   *
 *	 FILE:								   *
 *									   *
 *	 DESCRIPTION:	 Presentation Manager Alarm Clock Application	   *
 *									   *
 *									   *
 *									   *
 *	Copyright 1992	IBM Corp.					   *
 *									   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have been *
 *	advised of the possibility of	such damages.			   *
 *									   *
 *-------------------------------------------------------------------------*
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *--------------------------------------------------------------
 *
 *  This source file contains the following functions:
 *
 *
 *
 *
 *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/
#define INCL_PM
#define INCL_WINMENUS
#define INCL_GPITRANSFORMS
#define INCL_WINHELP
#define INCL_WINWINDOWMGR
#define INCL_WINMESSAGEMGR
#define INCL_DOSSEMAPHORES
#define INCL_DOSDATETIME
#define INCL_DOSQUEUES
#define INCL_DOSPROCESS
#define INCL_WINDIALOGS

#include <os2.h>
#include <stdio.h>
#include <stdlib.h>
#include "clock.h"
#include "dialogs.h"
#include "clkdata.h"
#include "alarmthd.h"
#include "res.h"


/*--------------------------------------------------------------*\
 *  Global variables  and definitions for this file
\*--------------------------------------------------------------*/

#define HOURS_24 ( (LONG) 1000L * 24L * 60L * 60L)


/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/

APIRET AlarmInit(VOID);
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:AlarmThread()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    1 - if sucessful execution completed
 *	    0 - if error
\****************************************************************/
VOID AlarmThread(PVOID pvMessage)

{
     ULONG ulTimerValue,ulPostCount;
     SHORT usi;


     /*
      *create a event semaphore
      *for this timer
      */
     if( DosCreateEventSem(NULL,
			   &TimerResources.hTimerDev,
			   DC_SEM_SHARED,
			   FALSE) )
     {
	  /*
	   *generate error
	   *message
	   *back to the console
	   */
     }

     /*
      *create our queue
      *and  semaphore
      */
      if(AlarmInit() )
      {
	  /*
	   *send a message to our
	   *main thread,unable to start
	   */

	  MessageBox(hwndFrame, IDMSG_CANNOTLOADSTRING,
		     MB_OK | MB_ERROR, FALSE);
	  _endthread();
      }
      ulTimerValue = TimerResources.ulTimerValue;

      /*
       *stay in our
       *loop until a abort message is received
       *from our main
       *thread
       */

      do
      {

	  /*
	   *sit here and
	   *wait for the semaphore to post,
	   *from one of two conditions
	   * 1)either the timer expired
	   * 2)or the pm thread cleared it for
	   * a exit or the timer value has changed
	   */
	   if( DosWaitEventSem((HEV)TimerResources.hTimerDev,
			       SEM_INDEFINITE_WAIT) )
	   {
	       /*
		*error occurred
		*notify the pm thread
		*/
		break;

	   }
	   if(fEndThread)
	   {
	       continue;
	   }

	   /*
	    *reset the post count
	    */
	   DosResetEventSem( (HEV) TimerResources.hTimerDev,
			       &ulPostCount);
	   /*
	    *did the timer value get
	    *changed
	    */
	    if(TimerResources.ulTimerValue != ulTimerValue)
	    {
		     ulTimerValue = TimerResources.ulTimerValue;
		     /*
		      *non async timer
		      *needs to be stopped
		      */
		     if(cp.sTimerType == TIMER_CONT )
		     {
			 DosStopTimer(TimerResources.hTimer);
		     }
		     /*
		      *set the alarm for the initial time
		      *delay till the first
		      *alarm goes
		      *off
		      */

		     if(AlarmInit() )
		     {
			 /*
			  *generate error message
			  */
			  MessageBox(hwndFrame, IDMSG_CANNOTLOADSTRING,
				     MB_OK | MB_ERROR, FALSE);
			  break;
		     }

	    }
	    /*
	     *the timer
	     *expired
	     */
	    else
	    {
		/*
		 *is the alarm set
		 */
		if(cp.alarm.usMode & AM_ACTIVE )
		{
		    /*
		     *send a message
		     *that a alarm has gone off
		     */
		     if(cp.alarm.usMode & AM_AUDIO)
		     {
			for (usi = 0; usi < 20; usi++)
			{
			     DosBeep(300 + usi * 100, 50);
			}
		     }
		     /*
		      *message box
		      */
		     if(cp.alarm.usMode & AM_MSGBOX)
		     {
			   WinPostMsg( hwndFrame,
				       WM_COMMAND,
				       MPFROM2SHORT(IDM_ALARM_EXPIRED,TRUE),
					   MPVOID );
		     }
		     /*
		      *the alarm has expired,check and make sure
		      *its on a 24 hour boundary
		      */
		     if(ulTimerValue != HOURS_24 )
		     {
			 ulTimerValue = TimerResources.ulTimerValue =
				   HOURS_24;
			 /*
			  *non async timer
			  *needs to be stopped
			  */
			 if(cp.sTimerType == TIMER_CONT )
			 {
			     DosStopTimer(TimerResources.hTimer);
			 }
			 if(AlarmInit() )
			 {
			     /*
			      *generate error message
			      */
			      break;
			 }
		     }
		 }
	    }
     }while(!fEndThread);


     _endthread();


}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:AlarmInit();
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    NO_ERROR   (0) No Error occurred
 *	    Non - Zero the api return value for the called function
\****************************************************************/
APIRET AlarmInit(VOID)
{
     APIRET ApiReturn = NO_ERROR;


     switch(cp.sTimerType)
     {
     case TIMER_CONT:
	  if( ApiReturn = DosStartTimer(TimerResources.ulTimerValue,
					(HSEM)TimerResources.hTimerDev,
					&TimerResources.hTimer) )
	  {
	       return(ApiReturn);
	  }
	  break;
     case TIMER_ASYNC:
	  if( ApiReturn = DosAsyncTimer(TimerResources.ulTimerValue,
					(HSEM)TimerResources.hTimerDev,
					&TimerResources.hTimer) )
	  {
	       return(ApiReturn);
	  }
	  break;
     }
     return(ApiReturn);
}
/*--------------------------------------------------------------*\
 *  End of file : alarmthd.c
\*--------------------------------------------------------------*/
#ifndef lint
static char *sccsid = "@(#)animal.c 1.3 2/3/92 20:39:51 [2/3/92] (c)IBM Corp. 1992";
#endif

/*
 * Copyright (c) International Business Machines Corporation
 *		 1991, 1992
 */

#define Animal_Class_Source
#include "animal.ih"
#include <string.h>

SOM_Scope char *SOMLINK getGenus(Animal * somSelf)
{
    AnimalData *somThis = AnimalGetData(somSelf);
    AnimalMethodDebug("Animal", "getGenus");
    return ("Unknown Genus");
}

SOM_Scope char *SOMLINK getSpecies(Animal * somSelf)
{
    AnimalData *somThis = AnimalGetData(somSelf);
    AnimalMethodDebug("Animal", "getSpecies");
    return ("Unknown Species");
}

SOM_Scope void SOMLINK setSound(Animal * somSelf,
				 char *mySound)
{
    AnimalData *somThis = AnimalGetData(somSelf);
    AnimalMethodDebug("Animal", "setSound");

    if (_sound)
	(*SOMFree) (_sound);
    _sound = (char *) (*SOMMalloc) (strlen(mySound) + 1);
    strcpy(_sound, mySound);
}

SOM_Scope void SOMLINK talk(Animal * somSelf)
{
    AnimalData *somThis = AnimalGetData(somSelf);
    AnimalMethodDebug("Animal", "talk");
    somPrintf("%s\n", _sound);
}

SOM_Scope void SOMLINK display(Animal * somSelf)
{
    AnimalData *somThis = AnimalGetData(somSelf);
    AnimalMethodDebug("Animal", "display");
    somPrintf("  Genus: %s\n", _getGenus(somSelf));
    somPrintf("Species: %s\n", _getSpecies(somSelf));
    somPrintf("This Animal says\n");
    _talk(somSelf);
}

SOM_Scope void SOMLINK somInit(Animal * somSelf)
{
    AnimalData *somThis = AnimalGetData(somSelf);
    AnimalMethodDebug("Animal", "somInit");
    parent_somInit(somSelf);
    _sound = (char *) NULL;
}

SOM_Scope void SOMLINK somUninit(Animal * somSelf)
{
    AnimalData *somThis = AnimalGetData(somSelf);
    AnimalMethodDebug("Animal", "somUninit");
    if (_sound)
	(*SOMFree) (_sound);
    parent_somUninit(somSelf);
}

SOM_Scope void SOMLINK somDumpSelfInt(Animal * somSelf,
				       int level)
{
    AnimalData *somThis = AnimalGetData(somSelf);
    AnimalMethodDebug("Animal", "somDumpSelfInt");
    _display(somSelf);
    parent_somDumpSelfInt(somSelf, level);
}
#ifndef lint
static char *sccsid = "@(#)animeta.c 1.3 2/3/92 20:39:56 [2/3/92] (c)IBM Corp. 1992";
#endif

/*
 * Copyright (c) International Business Machines Corporation
 *		 1991, 1992
 */

#define AnimalFactory_Class_Source
#include "animeta.ih"
#include "animal.h"

/*
 *  Create an instance of an Animal with a specific sound.
 */

SOM_Scope SOMAny *SOMLINK newAnimal(AnimalFactory * somSelf,
				     char *sound)
{
    /* AnimalFactoryData *somThis = AnimalFactoryGetData(somSelf); */
    Animal *newAnimal;
    AnimalFactoryMethodDebug("AnimalFactory", "newAnimal");

    newAnimal = _somNew(somSelf);
    _setSound(newAnimal, sound);
    return (newAnimal);
}
#ifndef lint
static char *sccsid = "@(#)bdog.c 1.3 2/3/92 20:40:00 [2/3/92] (c)IBM Corp. 1992";
#endif

/*
 * Copyright (c) International Business Machines Corporation
 *		 1991, 1992
 */

#define BigDog_Class_Source
#include "bdog.ih"

SOM_Scope void SOMLINK talk(BigDog * somSelf)
{
/*  BigDogData *somThis = BigDogGetData(somSelf); */
    BigDogMethodDebug("BigDog", "talk");
    somPrintf("WOOF WOOF\n");
    somPrintf("WOOF WOOF\n");
    somPrintf("WOOF WOOF\n");
    somPrintf("WOOF WOOF\n");
    somPrintf("WOOF WOOF\n");
    somSelf = somSelf;	       /* Avoid unreferenced parameter compiler
				* warning for OS/2 compiler */
}
#ifndef lint
static char *sccsid = "@(#)blep.c 1.3 1/22/92 16:08:17 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define bulletedList_Class_Source
#include "blep.ih"
#include "tpword.h"

#define PARAGRAPH_INDENTATION 0
#define LINE_INDENTATION 2
#define BULLET " - "

/* ************************************************************ */
SOM_Scope int SOMLINK epGetParagraphIndentation(bulletedList * somSelf)
{
    /* bulletedListData *somThis = bulletedListGetData(somSelf); */
    bulletedListMethodDebug("bulletedList", "epGetParagraphIndentation");

    somSelf;			       /* Avoid unreferenced parameter compiler
					* warning for OS/2 compiler */
    return PARAGRAPH_INDENTATION;

}

/* ************************************************************ */
SOM_Scope int SOMLINK epGetLineIndentation(bulletedList * somSelf)
{
    /* bulletedListData *somThis = bulletedListGetData(somSelf); */
    envProcessor *lastEnv = _epGetPreviousEnv(somSelf);
    bulletedListMethodDebug("bulletedList", "epGetLineIndentation");

    if (lastEnv)
	return _epGetLineIndentation(lastEnv) + LINE_INDENTATION;
    else
	return LINE_INDENTATION;
}

/* ************************************************************ */
SOM_Scope void SOMLINK epInitializeEnvironment(bulletedList * somSelf)
{
    /* bulletedListData *somThis = bulletedListGetData(somSelf); */
    textLine *thisLine;
    TPWord *bullet;
    bulletedListMethodDebug("bulletedList", "epInitializeEnvironment");

    parent_epInitializeEnvironment(somSelf);

    bullet = TPWordNew();
    _wordInit1(bullet, BULLET);
    thisLine = _tpGetLine(somSelf);
    _llAddTail(thisLine, (baseType *) bullet);
}

/* ************************************************************ */
SOM_Scope void SOMLINK tpProcessNewParagraph(bulletedList * somSelf)
{
/* bulletedListData *somThis = bulletedListGetData(somSelf); */
    textLine *thisLine;
    TPWord *bullet;
    bulletedListMethodDebug("bulletedList", "tpProcessNewParagraph");

    parent_tpProcessNewParagraph(somSelf);

    bullet = TPWordNew();
    _wordInit1(bullet, BULLET);
    thisLine = _tpGetLine(somSelf);
    _llAddTail(thisLine, (baseType *) bullet);
}
#ifndef lint
static char *sccsid = "@(#)bt.c 1.3 1/22/92 16:07:58 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define baseType_Class_Source
#include "bt.ih"
#include "helper.h"

SOM_Scope int SOMLINK match(baseType * somSelf,
			     void *target)
{
    /* baseTypeData *somThis = baseTypeGetData(somSelf); */
    baseTypeMethodDebug("baseType", "match");
    shouldHaveOverridden(somSelf, "match");
    target;			       /* Avoid unreferenced parameter compiler
					* warning for OS/2 compiler */
    return 0;
}

SOM_Scope void SOMLINK print(baseType * somSelf,
			      FILE * outputFile)
{
    /* baseTypeData *somThis = baseTypeGetData(somSelf); */
    baseTypeMethodDebug("baseType", "print");
    shouldHaveOverridden(somSelf, "print");
    outputFile; 		       /* Avoid unreferenced parameter compiler
					* warning for OS/2 compiler */
}
/******************************************************************************
*
*  Module Name: CAR.C
*
*  OS/2 Work Place Shell Sample Program
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.						      *
*
*  Entry Points:
*
*     Class Methods:
*
*	 carM_QueryModuleHandle
*
*     Overridden Class Methods:
*
*	 carM_wpclsInitData
*	 carM_wpclsQueryDefaultHelp
*	 carM_wpclsQueryDefaultView
*	 carM_wpclsQueryDetailsInfo
*	 carM_wpclsQueryIconData
*	 carM_wpclsQueryStyle
*	 carM_wpclsQueryTitle
*	 carM_wpclsUnInitData
*
*     Instance Methods:
*
*	 car_AddDashboardPage
*	 car_AddHornBeepPage
*	 car_BeepHorn
*	 car_QueryBrakes
*	 car_QueryDuration
*	 car_QueryHighTone
*	 car_QueryLowTone
*	 car_QuerySpeed
*	 car_SetBrakes
*	 car_SetDuration
*	 car_SetHighTone
*	 car_SetLowTone
*	 car_SetSpeed
*
*     Overridden Instance Methods:
*
*	 car_wpAddSettingsPages
*	 car_wpFilterPopupMenu
*	 car_wpInitData
*	 car_wpMenuItemHelpSelected
*	 car_wpMenuItemSelected
*	 car_wpModifyPopupMenu
*	 car_wpViewObject
*	 car_wpQueryDetailsData
*	 car_wpRestoreState
*	 car_wpSaveState
*	 car_wpUnInitData
*
*     Non-Method Functions:
*
*	 CarInit
*	 CarWndProc
*	 DashBoardDlgProc
*	 HornBeepDlgProc
*
******************************************************************************/

#define Car_Class_Source
#define M_Car_Class_Source

#include "car.ih"	       /* implementation header emitted from car.csc */
#include "car.ph"		      /* private header emitted from car.csc */

#include <string.h>
#include <stdio.h>
#ifdef __IBMCPP__
#include <memory.h>
#endif
#include <stdlib.h>
#include <setjmp.h>

/*
 *   Non-Method function prototypes
 */

HWND		 CarInit (Car*);
MRESULT EXPENTRY DashBoardDlgProc( HWND hwnd, ULONG msg,
				   MPARAM mp1, MPARAM mp2 );
MRESULT EXPENTRY HornBeepDlgProc( HWND hwnd, ULONG msg,
				   MPARAM mp1, MPARAM mp2 );
MRESULT EXPENTRY CarWndProc ( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 );

#pragma linkage(_Exception, system)
ULONG _Exception(EXCEPTIONREPORTRECORD	     *parg,
		 EXCEPTIONREGISTRATIONRECORD *pRegisRecord,
		 PCONTEXTRECORD		      pContextRecord,
		 PVOID			      pvSpare);



/***************** GLOBAL/STATIC (NON-INSTANCE) DATA SECTION ******************
*****									  *****
*****	 This data shouldn't be changed by instance methods or it will    *****
*****	 effect all instances!	Any variables that are specific (unique	  *****
*****	 values) for each instance of this object should be declared as	  *****
*****  instance data or dynamically allocated and stored as window data.  *****
*****									  *****
*****	   This global data should be declared as class instance data	  *****
*****	 if it will change after initialization.  In this case, it will	  *****
*****		       be accessed through class methods.		  *****
*****									  *****
******************************************************************************/


   CHAR	      szCarWindowClass[] =    "CARSAMPLE";
   CHAR	      szCarInstanceFilter[] = "*.CAR";
   CHAR	      szHelpLibrary[] =	      "car.hlp";
   UCHAR      szCarClassTitle[CCHMAXPATH] = "";
   HMODULE    hmod = NULLHANDLE;

   PSZ	      pszDefaultText ="\
			       \n\
     Bill of Sale	       \n\
   =========================   \n\
			       \n\
   Make........ Toyota	       \n\
			       \n\
   Model....... Camry	       \n\
			       \n\
   Color....... Blue	       \n\
			       \n\
   Sale Date... 3/31/92	       \n\
			       \n\
   Price....... 14,995	       \n";

   /*
    *	Globals required for Exception handling
    */

   jmp_buf jmpState;

   PSZ pszTrapMessage =			       "\
\
A Memory Access Violation occurred.  The Car \
sample's exception handler has transferred \
control back to the cleanup code in the method \
where the exception occurred.\n";

   /*
    *	Statics required for FIELDINFO structures needed for DETAILS view are
    *	handled in the three functions:
    *
    *	car_wpclsInitData, car_wpQueryDetailsData, car_wpQueryClassDetailsInfo
    */

   #define NUM_CAR_FIELDS    5

   CLASSFIELDINFO fieldinfo[NUM_CAR_FIELDS];	  /* structure in wpobject.h */

   PSZ apszCarColTitles[] =
   {
      "Make",		/* details column 1 */
      "Model",		/* details column 2 */
      "Color",		/* details column 3 */
      "Sale date",	/* details column 4 */
      "Price ($)"	/* details column 5 */
   };


/*************************  INSTANCE METHODS SECTION  *************************
*****									  *****
*****		   Do not put any code in this section unless		  *****
*****			it is an object INSTANCE method			  *****
*****									  *****
******************************************************************************/
#undef SOM_CurrentClass
#define SOM_CurrentClass SOMInstance


/*
 *
 *  METHOD: QueryBrakes					   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Query state of car's brakes
 *
 *  RETURN:
 *
 *    TRUE	     Brake is on
 *    FALSE	     Brake is off
 *
 */

SOM_Scope BOOL	 SOMLINK car_QueryBrakes(Car *somSelf)
{
   CarData *somThis = CarGetData(somSelf);
   CarMethodDebug("Car","car_QueryBrakes");

   return _BrakeFlag;
}

/*
 *
 *  METHOD: SetBrakes					   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Put on the brakes
 *
 *  RETURN:
 *
 *    TRUE	     state changed
 *    FALSE	     state didn't change
 *
 */

SOM_Scope VOID	 SOMLINK car_SetBrakes(Car *somSelf, BOOL fBrake)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_SetBrakes");

    _BrakeFlag = fBrake;
}

/*
 *
 *  METHOD: QueryDuration				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Query Duration of horn beep
 *
 *  RETURN:
 *
 *    ULONG	     Duration of beep
 *
 */

SOM_Scope ULONG	 SOMLINK car_QueryDuration(Car *somSelf)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_QueryDuration");

    return _duration;
}

/*
 *
 *  METHOD: SetDuration					   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Set Duration of horn beep
 *
 *  RETURN:
 *
 *    TRUE	     Duration changed
 *    FALSE	     Duration didn't change
 *
 */

SOM_Scope VOID	 SOMLINK car_SetDuration(Car *somSelf, ULONG ulDuration)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_SetDuration");

    _duration = ulDuration;
}

/*
 *
 *  METHOD: QueryHighTone				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Query HighTone of horn
 *
 *  RETURN:
 *
 *    ULONG	     High frequency of horn
 *
 */

SOM_Scope ULONG	 SOMLINK car_QueryHighTone(Car *somSelf)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_QueryHighTone");

    return _HighTone;
}

/*
 *
 *  METHOD: SetHighTone					   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Set HighTone of horn
 *
 *  RETURN:
 *
 *    TRUE	     Tone changed
 *    FALSE	     Tone didn't change
 *
 */

SOM_Scope VOID	 SOMLINK car_SetHighTone(Car *somSelf, ULONG ulTone)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_SetHighTone");

    _HighTone = ulTone;
}

/*
 *
 *  METHOD: QueryLowTone				  ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Query LowTone of horn
 *
 *  RETURN:
 *
 *    ULONG	     High frequency of horn
 *
 */

SOM_Scope ULONG	 SOMLINK car_QueryLowTone(Car *somSelf)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_QueryLowTone");

    return _LowTone;
}

/*
 *
 *  METHOD: SetLowTone					  ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Set LowTone of horn
 *
 *  RETURN:
 *
 *    TRUE	     Tone changed
 *    FALSE	     Tone didn't change
 *
 */

SOM_Scope VOID	 SOMLINK car_SetLowTone(Car *somSelf, ULONG ulTone)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_SetLowTone");

    _LowTone = ulTone;
}

/*
 *
 *  METHOD: QuerySpeed					   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Query Speed of car
 *
 *  RETURN:
 *
 *    ULONG	     car speed
 *
 */

SOM_Scope ULONG	 SOMLINK car_QuerySpeed(Car *somSelf)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_QuerySpeed");

    return _speed;
}

/*
 *
 *  METHOD: SetSpeed					   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Set Speed of car
 *
 *  RETURN:
 *
 *    TRUE	     speed changed
 *    FALSE	     speed didn't change
 *
 */

SOM_Scope VOID	 SOMLINK car_SetSpeed(Car *somSelf, ULONG ulSpeed)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_SetSpeed");

    _speed = ulSpeed;
}

/*
 *
 *  METHOD: BeepHorn					   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Beep the car's horn.
 *
 *  RETURN:
 *
 *    TRUE	     Successful
 *    FALSE	     Unsuccessful
 *
 */

SOM_Scope BOOL SOMLINK car_BeepHorn(Car *somSelf)
{
    USHORT i;

    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_BeepHorn");

    DosBeep(_QueryHighTone(somSelf), _QueryDuration(somSelf));
    DosSleep(100);
    DosBeep(_QueryLowTone(somSelf), _QueryDuration(somSelf));

    return TRUE;

}   /* end car_BeepHorn() */

/*
 *
 *  METHOD: AddDashboardPage				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    This method adds the dashboard page to the settings notebook.
 *
 *  RETURN:
 *
 *    0		     Unsuccessful
 *    ulPageId	     Identifier for the inserted page
 *
 *  HOW TO OVERRIDE:
 *
 *    Method should always be overridden in order to replace or remove
 *    the dashboard page from an object which is a descendent of Car.
 *    In most cases, an override of this method will not call the parent.
 *
 */

SOM_Scope ULONG SOMLINK car_AddDashboardPage(Car *somSelf, HWND hwndNotebook)
{
    PAGEINFO pageinfo;

    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_AddDashboardPage");

    memset((PCH)&pageinfo,0,sizeof(PAGEINFO));
    pageinfo.cb			= sizeof(PAGEINFO);
    pageinfo.hwndPage		= NULLHANDLE;
    pageinfo.usPageStyleFlags	= BKA_MAJOR;
    pageinfo.usPageInsertFlags	= BKA_FIRST;
    pageinfo.pfnwp		= DashBoardDlgProc;
    pageinfo.resid		= hmod;
    pageinfo.dlgid		= IDD_DASHBOARD;
    pageinfo.pszName		= "Dashboard";
    pageinfo.pCreateParams	= somSelf;
    pageinfo.idDefaultHelpPanel = ID_HELP_DASHBOARD;
    pageinfo.pszHelpLibraryName = szHelpLibrary;

    return _wpInsertSettingsPage( somSelf, hwndNotebook, &pageinfo );

}   /* end car_AddDashboardPage() */


/*
 *
 *  METHOD: AddHornBeepPage				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    This method adds the horn beep page to the settings
 *    notebook.
 *
 *  RETURN:
 *
 *    0		     Unsuccessful
 *    ulPageId	     Identifier for the inserted page
 *
 *  HOW TO OVERRIDE:
 *
 *    Method should always be overridden in order to replace or remove
 *    the horn beep page from an object which is a descendent of Car.
 *    In most cases, an override of this method will not call the parent.
 *
 *
 *    Methods from the WPObject class
 *
 */

SOM_Scope ULONG SOMLINK car_AddHornBeepPage(Car *somSelf, HWND hwndNotebook)
{
    PAGEINFO pageinfo;

    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_AddHornBeepPage");

    /* Insert the settings pages for a car
     */
    memset((PCH)&pageinfo,0,sizeof(PAGEINFO));
    pageinfo.cb			= sizeof(PAGEINFO);
    pageinfo.hwndPage		= NULLHANDLE;
    pageinfo.usPageStyleFlags	= BKA_MAJOR;
    pageinfo.usPageInsertFlags	= BKA_FIRST;
    pageinfo.pfnwp		= HornBeepDlgProc;
    pageinfo.resid		= hmod;
    pageinfo.dlgid		= IDD_HORNBEEP;
    pageinfo.pszName		= "Horn Beep";
    pageinfo.pCreateParams	= somSelf;
    pageinfo.idDefaultHelpPanel = ID_HELP_HORNBEEP;
    pageinfo.pszHelpLibraryName = szHelpLibrary;

    return _wpInsertSettingsPage( somSelf, hwndNotebook, &pageinfo );

}   /* end car_AddHornBeepPage() */

/*
 *
 *  OVERRIDE: wpInitData				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Initialize our state variables. Allocate any extra memory that
 *    we might need.
 *
 */

SOM_Scope void SOMLINK car_wpInitData(Car *somSelf)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_wpInitData");

    /*
     *	 We can initialize our instance data to 0's by using the somThis
     *	 pointer and the size of the CarData structure created by SOM.
     *
     *	 SOM stores instance data in a data structure named by prefixing
     *	 the name "Data" with the class name, in this case, "Car".
     */

    memset((PVOID)somThis, 0, sizeof(CarData));

    /*
     *	 And/or we can explicitly initialize our instance variables.
     */

    _HighTone  = DEFAULT_HITONE;
    _LowTone   = DEFAULT_LOTONE;
    _duration  = DEFAULT_DURATION;
    _speed     = DEFAULT_SPEED;
    _BrakeFlag = DEFAULT_BRAKEFLAG;

    parent_wpInitData(somSelf);

}   /* end car_wpInitData() */

/*
 *
 *  OVERRIDE: wpUnInitData				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Clear up memory that was allocated on wpInitData.
 *
 */

SOM_Scope void	 SOMLINK car_wpUnInitData(Car *somSelf)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_wpUnInitData");

    parent_wpUnInitData(somSelf);

}   /* end car_wpUnInitData() */


/*
 *
 *  METHOD: wpSaveState					   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Save our state variables (pitch and duration).
 *
 */

SOM_Scope BOOL SOMLINK car_wpSaveState(Car *somSelf)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_wpSaveState");

    _wpSaveLong( somSelf, szCarClassTitle, IDKEY_HITONE,	  _HighTone  );
    _wpSaveLong( somSelf, szCarClassTitle, IDKEY_LOTONE,	  _LowTone   );
    _wpSaveLong( somSelf, szCarClassTitle, IDKEY_DURATION,	  _duration  );
    _wpSaveLong( somSelf, szCarClassTitle, IDKEY_SPEED,		  _speed     );
    _wpSaveLong( somSelf, szCarClassTitle, IDKEY_BRAKEFLAG, (LONG)_BrakeFlag );

    return (parent_wpSaveState(somSelf));

}   /* end car_wpSaveState() */

/*
 *
 *  METHOD: wpRestoreState				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Retrieve our saved state variables (pitch and duration).
 *
 */

SOM_Scope BOOL SOMLINK car_wpRestoreState(Car *somSelf, ULONG ulReserved)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_wpRestoreState");

    _wpRestoreLong( somSelf, szCarClassTitle, IDKEY_HITONE,    &_HighTone  );
    _wpRestoreLong( somSelf, szCarClassTitle, IDKEY_LOTONE,    &_LowTone   );
    _wpRestoreLong( somSelf, szCarClassTitle, IDKEY_DURATION,  &_duration  );
    _wpRestoreLong( somSelf, szCarClassTitle, IDKEY_SPEED,     &_speed	   );
    _wpRestoreLong( somSelf, szCarClassTitle, IDKEY_BRAKEFLAG, &_BrakeFlag );

    return (parent_wpRestoreState(somSelf,ulReserved));

}   /* car_wpRestoreState() */

/*
 *
 *  METHOD: wpAddSettingsPages				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Add our own settings page to let the user alter the pitch
 *    and duration of the car's beep.
 *
 */

SOM_Scope BOOL SOMLINK car_wpAddSettingsPages(Car *somSelf, HWND hwndNotebook)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_wpAddSettingsPages");

    if (parent_wpAddSettingsPages(somSelf, hwndNotebook)
	     && _AddHornBeepPage( somSelf, hwndNotebook)
	     && _AddDashboardPage(somSelf, hwndNotebook))
    {
	return(TRUE);
    }
    else
    {
	DebugBox("car_wpAddSettingsPages", " Failed to add a settings page.");
	return( FALSE );
    }

}   /* car_wpAddSettingsPages() */

/*
 *
 *  METHOD: wpFilterPopupMenu				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Filter out any options from the context that don't apply.
 *
 *  HOW TO OVERRIDE:
 *
 *    No restrictions.
 *
 */

SOM_Scope ULONG SOMLINK car_wpFilterPopupMenu(Car *somSelf,
		ULONG ulFlags,
		HWND hwndCnr,
		BOOL fMultiSelect)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_wpFilterPopupMenu");

    /*
     *	 This method allows you to filter which menus to include in the
     *	 popup menu.  Note: wpclsQueryStyle is overridden to disallow
     *	 linking (creating shadow) as well.
     */
    return( parent_wpFilterPopupMenu(somSelf,ulFlags,hwndCnr,
		    fMultiSelect) & ~CTXT_LINK );

}   /* end car_wpFilterPopupMenu() */

/*
 *
 *  METHOD: wpModifyPopupMenu				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Add our extra option to the context menu to beep the horn
 *
 */

SOM_Scope BOOL SOMLINK car_wpModifyPopupMenu(Car *somSelf,
		HWND hwndMenu,
		HWND hwndCnr,
		ULONG iPosition)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_wpModifyPopupMenu");

    /*
     *	 Put in our special "open car" submenu item under the "open" menu
     */
    _wpInsertPopupMenuItems( somSelf, hwndMenu, 0,
			       hmod, ID_OPENMENU, WPMENUID_OPEN);
    /*
     *	 insert a "beep horn" menu item at the end of the list.
     */
    _wpInsertPopupMenuItems( somSelf, hwndMenu, iPosition,
			       hmod, ID_BEEPMENU, 0 );

    /*
     *	 insert a "TRAP-D" menu item at the end of the list.
     */
    _wpInsertPopupMenuItems( somSelf, hwndMenu, 0,
			       hmod, ID_TRAPMENU, 0 );

    return (parent_wpModifyPopupMenu(somSelf,hwndMenu,hwndCnr,iPosition));

}   /* end car_wpModifyPopupMenu() */

/*
 *
 *  METHOD: wpMenuItemSelected				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Process input from the extra menu option that we added.
 *
 */

SOM_Scope BOOL SOMLINK car_wpMenuItemSelected(Car *somSelf,
		HWND hwndFrame,
		ULONG MenuId)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_wpMenuItemSelected");

    /* Which of our menu items was selected ?
     */
    switch( MenuId )
    {
       case IDM_OPENCAR:
	  /*
	   *   We could call wpOpen here, but, if the object is already opened,
	   *   the following API determines whether the object should be
	   *   resurfaced, or if multiple views are desired.
	   */
	  _wpViewObject(somSelf, NULLHANDLE, OPEN_CAR, 0);
	  break;

       case IDM_BEEPHORN:
	  _BeepHorn(somSelf);
	  break;

       case IDM_TRAPCAR:
	  _TrapTest(somSelf);
	  break;

       default:
	  return parent_wpMenuItemSelected(somSelf, hwndFrame, MenuId);
	  break;
    }
    return TRUE;					  /* we processed it */

}   /* end car_wpMenuItemSelected() */

/*
 *
 *  METHOD: wpMenuItemHelpSelected			   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Process input from the extra menu option that we added.
 *
 */

SOM_Scope BOOL SOMLINK car_wpMenuItemHelpSelected(Car *somSelf,
		ULONG MenuId)
{
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_wpMenuItemHelpSelected");

    /* Which of our menu items was selected ?
     */
   switch( MenuId )
   {
      case IDM_BEEPHORN:

	 return(_wpDisplayHelp(somSelf,ID_HELP_BEEPHORN,szHelpLibrary));
	 break;

  /*  case IDM_OPENCAR:	   no help written at this time
   *
   *	 return(_wpDisplayHelp(somSelf,ID_HELP_OPENCAR,szHelpLibrary));
   *	 break;
   */
      default:
	 break;
   }

   return FALSE;

}   /* end car_wpMenuItemHelpSelected() */

/*
 *
 *  METHOD: wpQueryDetailsData				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Returns the car specific data for the details view of this object.
 *    Sets the pointer (*ppDetailsData) to the beginning of the buffer
 *    into which the data is written.
 *
 */

SOM_Scope ULONG SOMLINK car_wpQueryDetailsData(Car *somSelf,
		PVOID *ppDetailsData,
		PULONG pcp)
{
   PCARDETAILS pCarDetails;
   PBYTE       pSize;
    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_wpQueryDetailsData");

   parent_wpQueryDetailsData(somSelf,ppDetailsData, pcp);

   if (ppDetailsData)					       /* query data */
   {
      pCarDetails		   = (PCARDETAILS) *ppDetailsData;
      pCarDetails->pszMake	   = "Toyota";		     /* Manufacturer */
      pCarDetails->pszModel	   = "Camry";		       /* Model name */
      pCarDetails->pszColor	   = "BLUE";		 /* Color of the car */
      pCarDetails->cdateSale.day   = 24;		     /* Date of sale */
      pCarDetails->cdateSale.month = 12;
      pCarDetails->cdateSale.year  = 91;
      pCarDetails->ulPrice	   = 14000;		 /* Price in dollars */

      /* point to buffer location after our details data */
      *ppDetailsData = ((PBYTE) (*ppDetailsData)) + sizeof(*pCarDetails);

   }   /* end if (ppDetailsData) */
   else						       /* query size of data */
   {
      *pcp += sizeof(*pCarDetails);	/* caller is querying size of buffer */
   }

   return(TRUE);

}   /* end car_wpQueryDetailsData() */

/*
 *
 *   METHOD: wpOpen					    ( ) PRIVATE
 *							    (X) PUBLIC
 *   DESCRIPTION:
 *
 *     Opens the car window.
 *
 */

SOM_Scope HWND SOMLINK car_wpOpen(Car *somSelf,
		HWND hwndCnr,
		ULONG ulView,
		ULONG param)
{
 CarData *somThis = CarGetData(somSelf);
 CarMethodDebug("Car","car_wpOpen");

   switch (ulView)
   {
      case OPEN_CAR:

	 if (!_wpSwitchTo(somSelf, ulView))
	 {
	    /*
	     *	 Create a basic Frame and Client window for this instance.
	     */
	   return CarInit(somSelf);
	 }
	 break;

      default:
	 return parent_wpOpen(somSelf,hwndCnr,ulView,param);
	 break;

   }   /* end switch (ulView) */

}   /* end car_wpOpen() */


/*
 *
 *  METHOD: wpSetup					   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Specify Setup strings and do some initialization.	 This method is
 *    invoked once an object is completely created.
 *
 *  Note:  We're overriding this method to write some default data to the
 *	   object's real filename.  This will give us something to look at
 *	   if the user drag/drops us on an editor or selects the open/editor
 *	   view.
 */

SOM_Scope BOOL	 SOMLINK car_wpSetup(Car *somSelf,
		PSZ pszSetupString)
{
 ULONG cbBytesWritten;		 /* pointer to variable receiving byte count */
 APIRET rc;
 BOOL fSuccess;
 HFILE hf;			      /* pointer to variable for file handle */
 ULONG ulAction;		     /* pointer to variable for action taken */
 CHAR szObjectFilename[CCHMAXPATH];	     /* buffer for wpQueryRealName() */
 ULONG cb  = sizeof(szObjectFilename);


    CarData *somThis = CarGetData(somSelf);
    CarMethodDebug("Car","car_wpSetup");

   /*
    *	Write an initial bill-of-sale to the object data file
    */

   fSuccess =
   _wpQueryRealName(		     /* query full-pathname of object's file */
      somSelf,					   /* pointer to this object */
      szObjectFilename,					    /* return buffer */
      &cb,						    /* sizeof buffer */
      TRUE);				/* request fully qualified pathname? */

   if (fSuccess)
   {
      rc =
      DosOpen(szObjectFilename, &hf, &ulAction,
	 0,				/* file size if created or truncated */
	 FILE_NORMAL,					   /* file attribute */
	 FILE_OPEN	       /* action taken if file exists/does not exist */
	    | FILE_CREATE,
	 OPEN_ACCESS_READWRITE				/* open mode of file */
	    | OPEN_SHARE_DENYNONE,
	 NULL);		     /* pointer to structure for extended attributes */

      if (rc)
      {
       CHAR ach[10];

	 ltoa(rc, ach, 10);
	 DebugBox("car_wpSetup:DosOpen failed rc =", ach);
      }
      else
      {
	 DosWrite(hf, pszDefaultText, strlen(pszDefaultText), &cbBytesWritten);
	 DosClose(hf);
      }
   }   /* end if (fSuccess) */

   return (parent_wpSetup(somSelf,pszSetupString));

}   /* end car_wpSetup() */

/*
 *
 *  METHOD: TrapTest					    ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Specify Setup strings and do some initialization.	 This method is
 *    invoked once an object is completely created.
 *
 *  Note:  The variable used to communicate the current state to the
 *	   exception handler is global.	 If an exception occurs in more than
 *	   one instance of this object at the same time, the results will
 *	   be unpredictable.
 */

#pragma handler (car_TrapTest)

SOM_Scope VOID	 SOMLINK car_TrapTest(Car *somSelf)
{
  PSZ	   pszTrap = NULL;
  jmp_buf  saveState;
  CarData *somThis = CarGetData(somSelf);
  CarMethodDebug("Car","car_TrapTest");

   memcpy(saveState, jmpState, sizeof(jmpState));
   if (!setjmp(jmpState))   /* no exception?*/
   {
      /*
       *   Normal code for this method goes here
       */

      *pszTrap = 'a';
   }
   else	  /* we just returned from exception handler */
   {
      /*
       *   An exception just occurred in this method.  We should put any
       *   cleanup/recovery code in this code block and then return the
       *   error to the caller.
       */

      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, pszTrapMessage,
		      "Exception Handler Test",
		      999, MB_MOVEABLE | MB_OK | MB_ERROR);
   }

   memcpy(jmpState, saveState, sizeof(jmpState));

}   /* end car_TrapTest() */

/**************************  CLASS METHODS SECTION  ***************************
*****									  *****
*****		   Do not put any code in this section unless		  *****
*****			  it is an object CLASS method			  *****
*****									  *****
******************************************************************************/
#undef SOM_CurrentClass
#define SOM_CurrentClass SOMMeta


/*
 *
 *  METHOD: clsQueryModuleHandle			   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    This method returns the module handle of this class.  If this is the
 *    first invocation, DosQueryModuleHandle is called to save the handle
 *    for future invocations.
 *
 *  RETURN:
 *
 *    0		     Unsuccessful
 *    non-zero	     module handle
 *
 */

SOM_Scope HMODULE   SOMLINK carM_clsQueryModuleHandle(M_Car *somSelf)
{
 APIRET rc;

    /* M_CarData *somThis = M_CarGetData(somSelf); */
    M_CarMethodDebug("M_Car","carM_clsQueryModuleHandle");

   /*
    *	Make sure we already have module handle
    */

    if (hmod == NULLHANDLE)
    {
     zString zsPathName;
       /*
	*   Retrieve registered pathname of our module (DLL) and query the
	*   module handle.
	*/
       zsPathName =
       _somLocateClassFile( SOMClassMgrObject, SOM_IdFromString("Car"),
					      Car_MajorVersion, Car_MinorVersion);
       rc =
       DosQueryModuleHandle( zsPathName, &hmod);
       if (rc)
       {
	  DebugBox("carM_wpclsInitData", "Failed to load module");
	  return ( (HMODULE) 0);
       }

    }	/* end if (hmod == NULLHANDLE) */

    return (hmod);

}   /* end carM_clsQueryModuleHandle() */

/*
 *
 *  METHOD: wpclsQueryStyle				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *     The wpclsQueryStyle method is called to allow the class object
 *     to specify the default object class style for its instances.
 *
 *  REMARKS:
 *
 *     This method can be called at any time in order to determine the
 *     default style for instances of this class.
 *
 *     This method should be overridden in order to modify the default
 *     object style for instances of this class.
 *
 */

SOM_Scope ULONG	  SOMLINK carM_wpclsQueryStyle(M_Car *somSelf)
{
    /* M_CarData *somThis = M_CarGetData(somSelf); */
    M_CarMethodDebug("M_Car","carM_wpclsQueryStyle");

    /*
     *	 Modify style bits as described in programming reference.  This
     *	 particular style (link) is also disabled in wpFilterPopupMenu()
     */
    return (parent_wpclsQueryStyle(somSelf) | CLSSTYLE_NEVERLINK);
}

/*
 *
 *  METHOD: wpclsInitData				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Initalize the class data
 *
 */

SOM_Scope void SOMLINK carM_wpclsInitData(M_Car *somSelf)
{
 ULONG rc, i;
 PCLASSFIELDINFO pCFI;

    /* M_CarData *somThis  = M_CarGetData(somSelf); */
    M_CarMethodDebug("M_Car","carM_wpclsInitData");

    /*
     *	 Call the parent class method first
     */
    parent_wpclsInitData(somSelf);

    /*
     *	 Get class title
     */
    if (!WinLoadString(WinQueryAnchorBlock(HWND_DESKTOP), _clsQueryModuleHandle(somSelf), ID_TITLE,
			 sizeof(szCarClassTitle), szCarClassTitle))
			      /* Load string failed: use the parent's string */
       strcpy(szCarClassTitle, parent_wpclsQueryTitle(somSelf));

   /*
    *	Initialize everything needed for the CLASSFIELDINFO structures
    *	for the Car object class
    */

   for (i=0, pCFI=fieldinfo; i < NUM_CAR_FIELDS; i++, pCFI++)
   {
      memset((PCH) pCFI, 0, sizeof(CLASSFIELDINFO));		   /* zero's */

      pCFI->cb	      = sizeof(CLASSFIELDINFO);
      pCFI->flData    = CFA_RIGHT | CFA_SEPARATOR | CFA_FIREADONLY;
      pCFI->flTitle   = CFA_CENTER | CFA_SEPARATOR | CFA_HORZSEPARATOR |
			CFA_STRING | CFA_FITITLEREADONLY;
      pCFI->pNextFieldInfo = pCFI + 1;	     /* point to next CLASSFIELDINFO */
      pCFI->pTitleData = (PVOID) apszCarColTitles[i];
      pCFI->flCompare  = COMPARE_SUPPORTED | SORTBY_SUPPORTED;

      switch (i)
      {
	 case INDEX_MAKE:

	    pCFI->flData	   |= CFA_STRING;
	    pCFI->offFieldData	    = (ULONG)(FIELDOFFSET(CARDETAILS,pszMake));
	    pCFI->ulLenFieldData    = sizeof(PSZ);
	    pCFI->DefaultComparison = CMP_EQUAL;

	    break;

	 case INDEX_MODEL:

	    pCFI->flData	   |= CFA_STRING;
	    pCFI->offFieldData	    = (ULONG)(FIELDOFFSET(CARDETAILS,pszModel));
	    pCFI->ulLenFieldData    = sizeof(PSZ);
	    pCFI->DefaultComparison = CMP_EQUAL;

	    break;

	 case INDEX_COLOR:

	    pCFI->flData	   |= CFA_STRING;
	    pCFI->offFieldData	    = (ULONG)(FIELDOFFSET(CARDETAILS,pszColor));
	    pCFI->ulLenFieldData    = sizeof(PSZ);
	    pCFI->DefaultComparison = CMP_EQUAL;

	    break;

	 case INDEX_SALE_DATE:

	    pCFI->flData	   |= CFA_DATE;
	    pCFI->offFieldData	    = (ULONG)(FIELDOFFSET(CARDETAILS,cdateSale));
	    pCFI->ulLenFieldData    = sizeof(CDATE);
	    pCFI->ulLenCompareValue = sizeof(CDATE);
	    pCFI->DefaultComparison = CMP_GREATER;

	    break;

	 case INDEX_PRICE:

	    pCFI->flData	   |= CFA_ULONG;
	    pCFI->offFieldData	    = (ULONG)(FIELDOFFSET(CARDETAILS,ulPrice));
	    pCFI->ulLenFieldData    = sizeof(ULONG);
	    pCFI->ulLenCompareValue = sizeof(ULONG);
	    pCFI->DefaultComparison = CMP_GREATER;

	    break;

      }	  /* end switch(i) */

   }   /* end for (i=0, pCFI=fieldinfo; i < NUM_CAR_FIELDS; i++, pCFI++)  */

   fieldinfo[NUM_CAR_FIELDS-1].pNextFieldInfo = NULL;/* terminate linked list */

}   /* end carM_ wpclsInitData() */

/*
 *
 *  METHOD: wpclsUnInitData				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Free any class data
 *
 */

SOM_Scope void SOMLINK carM_wpclsUnInitData(M_Car *somSelf)
{
    M_CarMethodDebug("M_Car","carM_wpclsUnInitData");

    parent_wpclsUnInitData(somSelf);

}   /* end carM_wpclsUnInitData() */

/*
 *
 *  METHOD: wpclsQueryTitle				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Return the string "New car".
 *
 */

SOM_Scope PSZ SOMLINK carM_wpclsQueryTitle(M_Car *somSelf)
{
			      /* M_CarData *somThis = M_CarGetData(somSelf); */
    M_CarMethodDebug("M_Car","carM_wpclsQueryTitle");

    /*
     *	 Return the class title for a car
     */

    if (*szCarClassTitle )
       return( szCarClassTitle );
    else
       return( parent_wpclsQueryTitle(somSelf));

}   /* end carM_wpclsQueryTitle() */

/*
 *
 *  METHOD: wpclsQueryIconDdata				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Return the class icon
 *
 */

SOM_Scope ULONG SOMLINK carM_wpclsQueryIconData(M_Car *somSelf,
		  PICONINFO pIconInfo)
{
   APIRET rc;

   M_CarMethodDebug("M_Car","carM_wpclsQueryIconData");

   if (pIconInfo)
   {
      /*
       *   fill in icon information
       */
      pIconInfo->fFormat = ICON_RESOURCE;
      pIconInfo->hmod= _clsQueryModuleHandle(somSelf);
      pIconInfo->resid= ID_ICON;
   }

   return (sizeof(ICONINFO));

}   /* end carM_wpclsQueryIconData() */

/*
 *
 *  METHOD: wpclsQueryDefaultHelp			   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Process input from the extra menu option that we added.
 *
 */

SOM_Scope BOOL SOMLINK carM_wpclsQueryDefaultHelp(M_Car *somSelf,
		PULONG pHelpPanelId,
		PSZ pszHelpLibrary)
{
			      /* M_CarData *somThis = M_CarGetData(somSelf); */
    M_CarMethodDebug("M_Car","carM_wpclsQueryDefaultHelp");

    if (pHelpPanelId)				/* set default help panel id */
       *pHelpPanelId   = ID_HELP_DEFAULT;

    if (pszHelpLibrary)				       /* copy help filename */
       strcpy(pszHelpLibrary, szHelpLibrary);

    return (TRUE);

}   /* end carM_wpclsQueryDefaultHelp() */

/*
 *
 *  METHOD: wpclsQueryDefaultView			   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Returns the default view for a new instance of this object.
 *
 *  REMARKS:
 *
 *    Tell the system what our default open view is...
 *
 */

SOM_Scope ULONG SOMLINK carM_wpclsQueryDefaultView(M_Car *somSelf)
{
			      /* M_CarData *somThis = M_CarGetData(somSelf); */
    M_CarMethodDebug("M_Car","carM_wpclsQueryDefaultView");

    return OPEN_CAR;

}   /* end carM_wpclsQueryDefaultView() */

/*
 *
 *  METHOD: wpclsQueryDetailsInfo			   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *    Appends the car specific chain of FIELDINFO structures describing the
 *    details data of this object to *ppClassFieldInfo (if ppClassFieldInfo
 *    is NON-NULL).  In this case it also sets *ppClassFieldInfo to the
 *    head of the linked list.
 *
 *    Adds the number of bytes required by the details data for car to *pSize
 *    (if pSize is NON-NULL).
 *
 *  REMARKS:
 *
 *    Add details data for this object.
 *
 */

SOM_Scope ULONG SOMLINK carM_wpclsQueryDetailsInfo(M_Car *somSelf,
		PCLASSFIELDINFO *ppClassFieldInfo,
		PULONG pSize)
{
 ULONG		 cParentColumns;
 PCLASSFIELDINFO pCFI;
 ULONG		 i;

    /* M_CarData *somThis = M_CarGetData(somSelf); */
    M_CarMethodDebug("M_Car","carM_wpclsQueryDetailsInfo");

   /*
    *	Always call the parent method first to retrieve number of details
    *	columns and parent's data already defined in details buffer.
    */

   cParentColumns =
   parent_wpclsQueryDetailsInfo(somSelf, ppClassFieldInfo, pSize);

   /*
    *	If pSize is non-NULL, we must add the size of our deatils column
    *	data structure.
    */

   if (pSize)
      *pSize += sizeof(CARDETAILS);			      /* adjust size */

   /*
    *	If the request was for the chained fieldinfo structures
    *	(ppClassFieldInfo is non-NULL), link them in
    *
    *	eventually the chain will look like
    *
    *	Grandad - Dad - Me - Kid - Grandkid
    *
    *	I will be getting the pointer to the beginning of the chain
    *
    *	If the beginning of the chain is 0, I will assign the address
    *	of my first CLASSFIELDINFO structure to *ppClassFieldInfo.
    *	Otherwise *pp points to the first column description in the
    *	chain.	We need to walk the chain and link our CLASSFIELDINFO
    *	structures at the end.
    */

   if (ppClassFieldInfo)
   {
      /*
       *   Find the last link in the chain;  Then link our CLASSFIELDINFO
       *   structures to the chain.
       */

      if (*ppClassFieldInfo)
      {
	 pCFI = *ppClassFieldInfo;
	 for (i=0;i<cParentColumns;i++)
	    pCFI = (pCFI->pNextFieldInfo) ? pCFI->pNextFieldInfo : pCFI;

	 pCFI->pNextFieldInfo = fieldinfo;
      }
      else
	 *ppClassFieldInfo = fieldinfo;
   }
   return ((ULONG) (cParentColumns + NUM_CAR_FIELDS));

}   /* end carM_wpclsQueryDetailsInfo() */

/*
 *
 *  METHOD: wpclsQueryInstanceFilter			   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *     The wpclsQueryInstanceFilter method is called to allow the class
 *     object to specify the file title filters for instances of its
 *     class.
 *
 *  REMARKS:
 *
 *     A pointer to a string containing file title filter(s).  This
 *     string can contain several file title filters separated by a
 *     comma.  Example: "*.TXT, *.DOC"
 *
 *  Note:  Overriding this method will cause any data file with the extension
 *	   ".CAR" to become a data object of the class "Car."
 *
 */

SOM_Scope PSZ	SOMLINK carM_wpclsQueryInstanceFilter(M_Car *somSelf)
{
    /* M_CarData *somThis = M_CarGetData(somSelf); */
    M_CarMethodDebug("M_Car","carM_wpclsQueryInstanceFilter");

    return (szCarInstanceFilter);
}


/*
 *
 *  METHOD: wpclsQueryDetails				   ( ) PRIVATE
 *							   (X) PUBLIC
 *  DESCRIPTION:
 *
 *     Specify default details to display in details view
 *
 *  REMARKS:
 *
 *     A pointer details structure is modified and returned.
 *     Note: this is purely virtual at the moment (parent class doesn't
 *     do anything).
 */

SOM_Scope PCLASSDETAILS	  SOMLINK carM_wpclsQueryDetails(M_Car *somSelf)
{
    /* M_CarData *somThis = M_CarGetData(somSelf); */
    M_CarMethodDebug("M_Car","carM_wpclsQueryDetails");

    return (parent_wpclsQueryDetails(somSelf));
}


/**************************  ORDINARY CODE SECTION  ***************************
*****									  *****
*****		       Any non-method code should go here.		  *****
*****									  *****
******************************************************************************/
#undef SOM_CurrentClass


/***************************************************************************
*									   *
*	ROUTINE:    CarInit ( )						   *
*									   *
*	DESCRIPTION:	Car Initialization				   *
*									   *
*	RETURNS:    Handle of car frame window, NULL if error		   *
*									   *
***************************************************************************/
HWND CarInit (Car* somSelf)
{
   HAB	hab;					   /* PM anchor block handle */
   HWND hwndFrame = NULLHANDLE;			      /* Frame window handle */
   HWND hwndClient = NULLHANDLE;
   PWINDOWDATA pWindowData;
   BOOL fSuccess;
   SWCNTRL    swcEntry;					     /* Switch Entry */
   FRAMECDATA flFrameCtlData;				   /* Frame Ctl Data */

   hab = WinQueryAnchorBlock(HWND_DESKTOP);
   if (!WinRegisterClass( hab , szCarWindowClass, (PFNWP)CarWndProc ,
			    CS_SIZEREDRAW | CS_SYNCPAINT, sizeof(pWindowData)))
   {
      DebugBox("CarInit", "Failure in WinRegisterClass");
      return NULLHANDLE ;
   }

   /*
    *	Allocate some instance specific data in Window words of Frame window.
    *	This will ensure our window procedure can use this object's methods
    *	(our window proc isn't passed a * somSelf pointer).
    */
   pWindowData = (PWINDOWDATA) _wpAllocMem(somSelf, sizeof(*pWindowData), NULL);

   if (!pWindowData)
   {
      DebugBox("CarInit", "wpAllocMem failed to allocate pWindowData");
      return NULLHANDLE;
   }

   memset((PVOID) pWindowData, 0, sizeof(*pWindowData));
   pWindowData->cb = sizeof(*pWindowData);	       /* first field = size */
   pWindowData->somSelf = somSelf;

   /* Create a frame window
    */
   flFrameCtlData.cb		= sizeof( flFrameCtlData );
   flFrameCtlData.flCreateFlags = FCF_SIZEBORDER | FCF_TITLEBAR | FCF_SYSMENU |
				  FCF_MINMAX ;
   flFrameCtlData.hmodResources = hmod;
   flFrameCtlData.idResources	= ID_ICON;

   hwndFrame =					      /* create frame window */
   WinCreateWindow(
      HWND_DESKTOP,		  /* parent-window handle		     */
      WC_FRAME,			  /* pointer to registered class name	     */
      _wpQueryTitle(somSelf),	  /* pointer to window text		     */
      0,			  /* window style			     */
      0, 0, 0, 0,		  /* position of window			     */
      NULLHANDLE,		  /* owner-window handle		     */
      HWND_TOP,			  /* handle to sibling window		     */
      (USHORT) ID_FRAME,	  /* window identifier			     */
      (PVOID) &flFrameCtlData,	  /* pointer to buffer			     */
      NULL);	  ;		  /* pointer to structure with pres. params. */

   if (!hwndFrame)
   {
      DebugBox("CarInit", "Failure in WinCreateWindow");
      return NULLHANDLE;
   }
   hwndClient =		/* use WinCreateWindow so we can pass pres params */
   WinCreateWindow(
      hwndFrame,	       /* parent-window handle			  */
      szCarWindowClass,	       /* pointer to registered class name	  */
      NULL,		       /* pointer to window text		  */
      0,		       /* window style				  */
      0, 0, 0, 0,	       /* position of window			  */
      hwndFrame,	       /* owner-window handle			  */
      HWND_TOP,		       /* handle to sibling window		  */
      (USHORT)FID_CLIENT,      /* window identifier			  */
      pWindowData,	       /* pointer to buffer			  */
      NULL);		       /* pointer to structure with pres. params. */

   if (!hwndClient)
   {
      WinDestroyWindow(hwndFrame);
      return NULLHANDLE;
   }

   WinSendMsg(hwndFrame,WM_SETICON,MPFROMP(_wpQueryIcon(somSelf)),NULL);
   WinSetWindowText(WinWindowFromID(hwndFrame,(USHORT)FID_TITLEBAR),
							 _wpQueryTitle(somSelf));

   /*
    * Restore the Window Position
    */
   fSuccess =
   WinRestoreWindowPos(
      szCarClassTitle,					      /* class title */
      _wpQueryTitle(somSelf),				     /* object title */
      hwndFrame);

   if (!fSuccess)
   {
    SWP	       swp;

      /* Get the dimensions and the shell's suggested
       * location for the window
       */
      WinQueryTaskSizePos(hab,0,&swp);

      /* Set the frame window position
       */
      swp.fl		   = SWP_SIZE|SWP_MOVE|SWP_RESTORE|SWP_ZORDER;
      WinSetWindowPos(hwndFrame, HWND_TOP, swp.x, swp.y, swp.cx,
		     swp.cy, swp.fl);
   }

   WinShowWindow(hwndFrame,TRUE);
   WinStartTimer(hab, hwndClient, CAR_TIMER, (ULONG)100);

   return hwndFrame;						  /* success */

}   /* end CarInit() */


/******************************************************************************
*
*   CarWndProc()
*
*   DESCRIPTION: Car Window Procedure
*
******************************************************************************/
MRESULT EXPENTRY CarWndProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
  ULONG	   MenuId;
  PWINDOWDATA pWindowData;
  HWND	   hwndFrame;
  CHAR	   acBuffer[10];
  BOOL	   fSuccess;

   hwndFrame = WinQueryWindow(hwnd, QW_PARENT);

   switch( msg )
   {
      case WM_CREATE:

	pWindowData = (PWINDOWDATA) mp1;

	if (pWindowData == NULL)
	{
	   DebugBox("CarWndProc:WM_CREATE", "couldn't get window words");
	   return FALSE;
	}
	/*
	 *   Fill in the class view/usage details and window specific data
	 *   for this instance.
	 */
	pWindowData->UseItem.type    = USAGE_OPENVIEW;
	pWindowData->ViewItem.view   = OPEN_CAR;
	pWindowData->ViewItem.handle = hwndFrame;
	pWindowData->x		     = 10;
	pWindowData->y		     = 10;
	pWindowData->xDir	     = CAR_RIGHT;
	pWindowData->yDir	     = CAR_UP;

	/*
	 *   Set window pointer with object pointer and instance view info.
	 *   Then add view to the in-use list so wpSwitchTo works.
	 */
	WinSetWindowPtr(hwnd, QWL_USER, pWindowData);
	_wpAddToObjUseList(pWindowData->somSelf,&pWindowData->UseItem);
	_wpRegisterView(pWindowData->somSelf, hwndFrame,
					     _wpQueryTitle(pWindowData->somSelf));
	WinSetFocus( HWND_DESKTOP, hwndFrame);

	break;

      case WM_COMMAND:

	break;

      case WM_TIMER:

	 pWindowData = (PWINDOWDATA) WinQueryWindowPtr(hwnd, QWL_USER);

	 if (pWindowData == NULL)
	 {
	    DebugBox("CarWndProc:WM_TIMER", "couldn't get window words");
	    return FALSE;
	 }
	 else
	 {
	  RECTL	 rectl;
	    /*
	     *	 If the car's brakes are off, we move the car by modifying it's
	     *	 x,y position.	Direction (xDir, yDir) changes when the car's
	     *	 position reaches a border of the window.  The distance it
	     *	 moves is based on the speed contained in an instance variable.
	     */

	    if (_QueryBrakes(pWindowData->somSelf) == FALSE)
	    {
	       WinQueryWindowRect(hwnd,&rectl);

	       if (pWindowData->x <= 0)			  /* at left border? */
		  pWindowData->xDir = CAR_RIGHT;	      /* mult. by  1 */
	       else
		  if (pWindowData->x >= rectl.xRight - ICON_WIDTH)
		     pWindowData->xDir = CAR_LEFT;	      /* mult. by -1 */

	       if (pWindowData->y <= 0)			/* at bottom border? */
		  pWindowData->yDir = CAR_UP;		      /* mult. by  1 */
	       else
		  if (pWindowData->y >= rectl.yTop - ICON_HEIGHT)
		     pWindowData->yDir = CAR_DOWN;	      /* mult. by -1 */

	       pWindowData->x +=
		  pWindowData->xDir * _QuerySpeed(pWindowData->somSelf);

	       pWindowData->y +=
		  pWindowData->yDir * _QuerySpeed(pWindowData->somSelf);

	       WinInvalidateRect(hwnd, &rectl, TRUE);  /* invalidate car region */
	    }
	 }
	 break;

      case WM_PAINT:
	 pWindowData = (PWINDOWDATA) WinQueryWindowPtr(hwnd, QWL_USER);

	 if (pWindowData == NULL)
	 {
	    DebugBox("CarWndProc:WM_PAINT", "couldn't get window words");
	    return FALSE;
	 }
	 else
	 {
	  HPS	 hps;
	  RECTL	 rectl;

	   hps = WinBeginPaint( hwnd, (HPS)NULLHANDLE, &rectl);
	   WinFillRect( hps, &rectl, SYSCLR_WINDOW);
	   WinDrawPointer(hps, pWindowData->x, pWindowData->y,
			  _wpQueryIcon(pWindowData->somSelf), DP_NORMAL);
	   WinEndPaint( hps );
	 }
	 break;

      case WM_CLOSE:
	 {
	  HAB hab;

	    hab = WinQueryAnchorBlock(HWND_DESKTOP);
	    WinStopTimer(hab,hwnd,CAR_TIMER);

	    pWindowData = (PWINDOWDATA) WinQueryWindowPtr(hwnd, QWL_USER);

	    if (pWindowData == NULL)
	    {
	       DebugBox("CarWndProc:WM_CLOSE", "couldn't get window words");
	       return FALSE;
	    }
	    fSuccess =
	    WinStoreWindowPos(szCarClassTitle,_wpQueryTitle(pWindowData->somSelf),
									hwndFrame);
	    _wpDeleteFromObjUseList(pWindowData->somSelf,&pWindowData->UseItem);
	    _wpFreeMem(pWindowData->somSelf,(PBYTE)pWindowData);

	    WinPostMsg( hwnd, WM_QUIT, 0, 0 );
	    WinDestroyWindow ( hwndFrame ) ;
	 }
	 break;

      default:
	 return WinDefWindowProc( hwnd, msg, mp1, mp2 );
   }
   return FALSE;

}   /* end CarWndProc() */

/******************************************************************************
*
*   DashBoardDlgProc()
*
*   DESCRIPTION: Dialog Procedure for Dashboaard settings page
*
******************************************************************************/
MRESULT EXPENTRY DashBoardDlgProc(HWND hwndDlg, ULONG msg,
				  MPARAM mp1, MPARAM mp2)
{
 DASHDLGDATA * pDashDlgData;
 CHAR	       acBuffer[10];

   switch (msg)
   {
      case WM_INITDLG:
      {
	 USHORT	   usCount;
	 SLDCDATA  SliderData;
	 WNDPARAMS wprm;

	 /*
	  *   Store some instance specific data in Window words of this dialog.
	  *   This will ensure our dialog procedure can access this objects
	  *   data (our dialog proc isn't always passed a *somSelf pointer).
	  */
	 pDashDlgData =
	    (PDASHDLGDATA) _wpAllocMem((Car *)mp2, sizeof(*pDashDlgData), NULL);
	 if (pDashDlgData)
	 {
	    memset((PVOID) pDashDlgData, 0, sizeof(*pDashDlgData));
	    pDashDlgData->cb = sizeof(*pDashDlgData);
	    pDashDlgData->somSelf = (Car *) mp2;   /* pointer to this object */
	    pDashDlgData->PrevBrakes = _QueryBrakes(pDashDlgData->somSelf);
	    pDashDlgData->PrevSpeed  = _QuerySpeed(pDashDlgData->somSelf);
	 }
	 else
	 {
	    DebugBox("DashboardDlgProc:WM_INITDLG", "Couldn't allocate window words");
	    break;
	 }

	 WinSetWindowPtr(hwndDlg, QWL_USER, pDashDlgData);

	 SliderData.cbSize = sizeof(SLDCDATA);
	 SliderData.usScale1Increments = 10;
	 SliderData.usScale1Spacing = 20;
	 SliderData.usScale2Increments = 10;
	 SliderData.usScale2Spacing = 20;

	 wprm.fsStatus = WPM_CTLDATA;
	 wprm.cchText = 0;
	 wprm.cbPresParams = 0;
	 wprm.cbCtlData = 0;
	 wprm.pCtlData = &SliderData;
	 WinSendDlgItemMsg(hwndDlg,ID_SPEEDSLIDER,
			  WM_SETWINDOWPARAMS,(MPARAM)&wprm,(MPARAM)NULL ) ;

	 for (usCount = 0; usCount < 10; usCount++ )
	 {
	    WinSendDlgItemMsg(hwndDlg,ID_SPEEDSLIDER,
		SLM_SETTICKSIZE,MPFROM2SHORT(usCount,5),NULL);

	    itoa((usCount*10),acBuffer,10);
	    WinSendDlgItemMsg(hwndDlg, ID_SPEEDSLIDER, SLM_SETSCALETEXT,
	       MPFROMSHORT(usCount), MPFROMP(acBuffer));
	 }
	 WinSendDlgItemMsg(hwndDlg,ID_SPEEDSLIDER,SLM_SETSLIDERINFO,
	    MPFROM2SHORT(SMA_SLIDERARMDIMENSIONS,NULL),
	    MPFROM2SHORT(20,40));

	 WinSendDlgItemMsg(hwndDlg,ID_SPEEDSLIDER,SLM_SETSLIDERINFO,
	    MPFROM2SHORT(SMA_SLIDERARMPOSITION, SMA_INCREMENTVALUE),
	    MPFROMSHORT((SHORT)_QuerySpeed(pDashDlgData->somSelf)/10));

	 WinSetDlgItemText(hwndDlg,ID_SPEEDDATA,
	    ltoa(_QuerySpeed(pDashDlgData->somSelf),acBuffer,10));

	 if (_QueryBrakes(pDashDlgData->somSelf) == FALSE)
	 {
	    WinSendDlgItemMsg(hwndDlg,ID_GO,BM_SETCHECK,(MPARAM)1L, MPVOID);
	 }
	 else
	 {
	    WinSendDlgItemMsg(hwndDlg,ID_STOP,BM_SETCHECK,(MPARAM)1L, MPVOID);
	 }

	 return (MRESULT) TRUE;

      }	  /* end case WM_INITDLG: */

      case WM_CLOSE:

	 pDashDlgData = WinQueryWindowPtr(hwndDlg, QWL_USER);
	 if (pDashDlgData == NULL)
	 {
	    DebugBox("DashboardDlgProc:WM_COMMAND", "couldn't get window words");
	    break;
	 }
	 _wpFreeMem(pDashDlgData->somSelf,(PBYTE)pDashDlgData);
	 return (WinDefDlgProc(hwndDlg, msg, mp1, mp2) );

      case WM_COMMAND:

	 pDashDlgData = WinQueryWindowPtr(hwndDlg, QWL_USER);
	 if (pDashDlgData == NULL)
	 {
	    DebugBox("DashboardDlgProc:WM_COMMAND", "couldn't get window words");
	    break;
	 }

	 switch (SHORT1FROMMP(mp1))
	 {
	    case ID_UNDO:
	       _SetBrakes(pDashDlgData->somSelf, pDashDlgData->PrevBrakes);
	       _SetSpeed(pDashDlgData->somSelf, pDashDlgData->PrevSpeed);

	       WinSendDlgItemMsg(hwndDlg,ID_SPEEDSLIDER,SLM_SETSLIDERINFO,
		  MPFROM2SHORT(SMA_SLIDERARMPOSITION, SMA_INCREMENTVALUE),
		  MPFROMSHORT((SHORT)(_QuerySpeed(pDashDlgData->somSelf)/10)));

	       WinSetDlgItemText(hwndDlg,ID_SPEEDDATA,
		  ltoa(_QuerySpeed(pDashDlgData->somSelf),acBuffer,10));

	       if (_QueryBrakes(pDashDlgData->somSelf) == FALSE)
	       {
		  WinSendDlgItemMsg(hwndDlg,ID_GO,BM_SETCHECK,
		     (MPARAM)1L, MPVOID);
	       }
	       else
	       {
		  WinSendDlgItemMsg(hwndDlg,ID_STOP,BM_SETCHECK,
		     (MPARAM)1L, MPVOID);
	       }

	       break;

	    case ID_DEFAULT:
	       /*
		*   preserve previous values
		*/
	       pDashDlgData->PrevBrakes = _QueryBrakes(pDashDlgData->somSelf);
	       pDashDlgData->PrevSpeed	= _QuerySpeed(pDashDlgData->somSelf);

	       _SetBrakes(pDashDlgData->somSelf, DEFAULT_BRAKEFLAG);
	       _SetSpeed(pDashDlgData->somSelf, DEFAULT_SPEED);

	       WinSendDlgItemMsg(hwndDlg,ID_SPEEDSLIDER,SLM_SETSLIDERINFO,
		  MPFROM2SHORT(SMA_SLIDERARMPOSITION, SMA_INCREMENTVALUE),
		  MPFROMSHORT((SHORT)(_QuerySpeed(pDashDlgData->somSelf)/10)));

	       WinSetDlgItemText(hwndDlg,ID_SPEEDDATA,
		  ltoa(_QuerySpeed(pDashDlgData->somSelf), acBuffer,10));

	       WinSendDlgItemMsg(hwndDlg,ID_GO,BM_SETCHECK,
		  (MPARAM)1L, MPVOID);

	       break;

	    case ID_HELP:

	       break;

	 }   /* end switch (SHORT1FROMMP(mp1)) */

	 return (MRESULT) TRUE;

      case WM_CONTROL:
      {
	 ULONG temp;

	 pDashDlgData = WinQueryWindowPtr(hwndDlg, QWL_USER);
	 if (pDashDlgData == NULL)
	 {
	    DebugBox("DashboardDlgProc:WM_CONTROL", "couldn't get window words");
	    break;
	 }

	 switch (SHORT1FROMMP(mp1))
	 {
	    case ID_GO:
	       if ((USHORT) SHORT2FROMMP(mp1) == BN_CLICKED)
	       {
		  pDashDlgData->PrevBrakes = _QueryBrakes(pDashDlgData->somSelf);
		  _SetBrakes(pDashDlgData->somSelf, FALSE);
	       }
	       break;

	    case ID_STOP:
	       if ((USHORT) SHORT2FROMMP(mp1) == BN_CLICKED)
	       {
		  pDashDlgData->PrevBrakes = _QueryBrakes(pDashDlgData->somSelf);
		  _SetBrakes(pDashDlgData->somSelf, TRUE);
	       }
	       break;

	    case ID_SPEEDSLIDER:
	       if ((USHORT) SHORT2FROMMP(mp1) == SLN_CHANGE)
	       {
		  pDashDlgData->PrevSpeed  = _QuerySpeed(pDashDlgData->somSelf);
		  temp = (ULONG) WinSendDlgItemMsg(hwndDlg, ID_SPEEDSLIDER,
		     SLM_QUERYSLIDERINFO,
		     MPFROM2SHORT(SMA_SLIDERARMPOSITION,SMA_INCREMENTVALUE),
		     NULL);
		  temp = temp * 10;
		  WinSetDlgItemText(hwndDlg,ID_SPEEDDATA,
				   ltoa(temp,acBuffer,10));
		  _SetSpeed(pDashDlgData->somSelf, temp);
	       }
	       break;

	 }   /* end switch (SHORT1FROMMP(mp1)) */

	 return (MRESULT) TRUE;
	 break;

      }	  /* end case WM_CONTROL: */

   }   /* end switch (msg) */

   return (WinDefDlgProc(hwndDlg, msg, mp1, mp2) );

}   /* end DashBoardDlgProc() */

/******************************************************************************
*
*   HornBeepDlgProc()
*
*   DESCRIPTION:  Dialog Procedure for Horn Beep settings page
*
******************************************************************************/
MRESULT EXPENTRY HornBeepDlgProc(HWND hwndDlg, ULONG msg,
				  MPARAM mp1, MPARAM mp2)
{
 HORNDLGDATA * pHornDlgData;
 CHAR acBuffer[10];

   switch (msg)
   {
      case WM_INITDLG:
      {
	 /*
	  *   Store some instance specific data in Window words of this dialog.
	  *   This will ensure our dialog procedure can access this objects
	  *   data (our dialog proc isn't always passed a *somSelf pointer).
	  */
	 pHornDlgData =
	    (PHORNDLGDATA) _wpAllocMem((Car *) mp2, sizeof(*pHornDlgData), NULL);
	 if (pHornDlgData)
	 {
	    memset((PVOID) pHornDlgData, 0, sizeof(*pHornDlgData));
	    pHornDlgData->cb = sizeof(*pHornDlgData);
	    pHornDlgData->somSelf = (Car *) mp2;  /* pointer to this object */
	    pHornDlgData->PrevDuration = _QueryDuration(pHornDlgData->somSelf);
	    pHornDlgData->PrevHighTone = _QueryHighTone(pHornDlgData->somSelf);
	    pHornDlgData->PrevLowTone  = _QueryLowTone(pHornDlgData->somSelf);
	 }
	 else
	 {
	    DebugBox("HornBeepDlgProc", "Couldn't allocate window words");
	    break;
	 }

	 WinSetWindowPtr(hwndDlg, QWL_USER, pHornDlgData);

	 WinSendDlgItemMsg( hwndDlg, ID_HITONE, SPBM_SETLIMITS,
	    MPFROMLONG(1000), MPFROMLONG(0));

	 WinSendDlgItemMsg( hwndDlg, ID_HITONE, SPBM_SETCURRENTVALUE,
	    MPFROMLONG(_QueryHighTone(pHornDlgData->somSelf)), MPFROMLONG(0));

	 WinSendDlgItemMsg( hwndDlg, ID_LOTONE, SPBM_SETLIMITS,
	    MPFROMLONG(1000), MPFROMLONG(0));

	 WinSendDlgItemMsg( hwndDlg, ID_LOTONE, SPBM_SETCURRENTVALUE,
	    MPFROMLONG(_QueryLowTone(pHornDlgData->somSelf)), MPFROMLONG(0));

	 return (MRESULT) TRUE;
	 break;

      }	  /* end case WM_INITDLG: */

      case WM_CLOSE:

	 pHornDlgData = WinQueryWindowPtr(hwndDlg, QWL_USER);

	 if (pHornDlgData == NULL)
	 {
	    DebugBox("HornBeepDlgProc", "Couldn't get window words");
	    break;
	 }

	 _wpFreeMem(pHornDlgData->somSelf,(PBYTE)pHornDlgData);
	 return (WinDefDlgProc(hwndDlg, msg, mp1, mp2) );

      case WM_COMMAND:

	 pHornDlgData = WinQueryWindowPtr(hwndDlg, QWL_USER);
	 if (pHornDlgData == NULL)
	 {
	    DebugBox("HornBeepDlgProc", "Couldn't get window words");
	    break;
	 }

	 switch (SHORT1FROMMP(mp1))
	 {
	    case ID_UNDO:

	       WinSendDlgItemMsg( hwndDlg, ID_HITONE, SPBM_SETCURRENTVALUE,
		  MPFROMLONG(pHornDlgData->PrevHighTone),
		  MPFROMLONG(0));

	       WinSendDlgItemMsg( hwndDlg, ID_LOTONE, SPBM_SETCURRENTVALUE,
		  MPFROMLONG(pHornDlgData->PrevLowTone),
		  MPFROMLONG(0));

	       break;

	    case ID_DEFAULT:
	       /*
		*   preserve previous values
		*/
	       pHornDlgData->PrevHighTone =
		  _QueryHighTone(pHornDlgData->somSelf);
	       pHornDlgData->PrevLowTone =
		  _QueryLowTone(pHornDlgData->somSelf);

	       _SetHighTone(pHornDlgData->somSelf, DEFAULT_HITONE);
	       _SetLowTone(pHornDlgData->somSelf, DEFAULT_LOTONE);

	       WinSendDlgItemMsg( hwndDlg, ID_HITONE, SPBM_SETCURRENTVALUE,
		  MPFROMLONG(DEFAULT_HITONE), MPFROMLONG(0));

	       WinSendDlgItemMsg( hwndDlg, ID_LOTONE, SPBM_SETCURRENTVALUE,
		  MPFROMLONG(DEFAULT_LOTONE), MPFROMLONG(0));
	       break;

	    case ID_HELP:
	       break;

	 }   /* end switch (SHORT1FROMMP(mp1)) */

	 return (MRESULT) TRUE;
	 break;

      case WM_CONTROL:
      {
       ULONG temp;

	 pHornDlgData = WinQueryWindowPtr(hwndDlg, QWL_USER);

	 if (pHornDlgData == NULL)
	 {
	    DebugBox("HornBeepDlgProc", "Couldn't get window words");
	    break;
	 }

	 switch (SHORT2FROMMP(mp1))
	 {
	    case SPBN_ENDSPIN:

	       /*
		*   preserve previous values
		*/
	       pHornDlgData->PrevHighTone =
		  _QueryHighTone(pHornDlgData->somSelf);
	       pHornDlgData->PrevLowTone =
		  _QueryLowTone(pHornDlgData->somSelf);

	       WinSendDlgItemMsg( hwndDlg, ID_HITONE, SPBM_QUERYVALUE,
		  (MPARAM)&temp, MPFROM2SHORT(0,SPBQ_UPDATEIFVALID));
	       _SetHighTone(pHornDlgData->somSelf, temp);

	       WinSendDlgItemMsg( hwndDlg, ID_LOTONE, SPBM_QUERYVALUE,
		  (MPARAM)&temp, MPFROM2SHORT(0,SPBQ_UPDATEIFVALID));
	       _SetLowTone(pHornDlgData->somSelf, temp);

	       break;

	 }   /* end switch (SHORT2FROMMP(mp1)) */

      }	  /* end case WM_CONTROL: */

      return (MRESULT) TRUE;
      break;

   }   /* end switch(msg) */

   return (WinDefDlgProc(hwndDlg, msg, mp1, mp2) );

}   /* end HornBeepDlgProc() */

/******************************************************************************
*
*   _Exception()
*
*   DESCRIPTION:  Exception handler routine for this object.
*
*   PURPOSE: To notify user when an illegal memory access is made
*
*   METHOD:  Whenever a memory protection exception occurs, a message
*	     box is put on the screen to inform the user.
*
*   RETURNS: Returns HANDLED if memory exception,
*	     otherwise, returns NOT_HANDLED
*
******************************************************************************/
ULONG _Exception(EXCEPTIONREPORTRECORD	     *parg,
		 EXCEPTIONREGISTRATIONRECORD *pRegisRecord,
		 PCONTEXTRECORD		      pContextRecord,
		 PVOID			      pvSpare)
{
   LONG	 rc;
   CHAR	 szText[CCHMAXPATH];

   switch (parg->ExceptionNum)
   {
      case XCPT_ACCESS_VIOLATION:

	 /*
	  *   Notify the user when memory access violation occurs.
	  */
	 WinAlarm(HWND_DESKTOP, WA_ERROR);
	 longjmp(jmpState, ERROR_PROTECTION_VIOLATION);
	 break;

      case XCPT_PROCESS_TERMINATE:
      case XCPT_ASYNC_PROCESS_TERMINATE:
      case XCPT_SIGNAL:
      default:
	 /*
	  *   For more exceptions, see the header files or the programming
	  *   reference(s).
	  */
	 break;

   }   /* end switch (parg->ExceptionNum) */

   return(XCPT_CONTINUE_SEARCH);

}   /* end _Exception() */

/********************************  END car.c  ********************************/
/**************************************************************************
 *  File name  :  clipbrd.c
 *
 *  Description:  This program displays a standard window containing a
 *		  picture.  The action bar contains the choices Edit and
 *		  Help.	 The Edit pull-down contains choices that let the
 *		  user perform clipboard operations on the picture.
 *
 *		  This source file contains the following functions:
 *
 *		    main( VOID );
 *		    ClipbrdHelp ( HWND, USHORT );
 *		    ClearRoutine( VOID );
 *		    CopyRoutine( VOID );
 *		    CutRoutine( VOID );
 *		    DrawRect( VOID );
 *		    EraseRect( VOID );
 *		    ExitRoutine( HWND );
 *		    Finalize( VOID );
 *		    GetBitmap( VOID );
 *		    Initialize( VOID );
 *		    MenuInitialization( MPARAM, MPARAM);
 *		    MouseButtonDown( HWND, MPARAM);
 *		    PaintRoutine( HWND );
 *		    PasteRoutine( VOID );
 *		    RemoveRect( VOID );
 *		    Report_Error( HAB );
 *		    WindowDestroy( VOID );
 *		    WindowInitialization( HWND );
 *		    ReportAPIError( PSZ );
 *		    ProductInfoDlgProc( HWND, ULONG, MPARAM, MPARAM );
 *		    HelpProductInfo( HWND );
 *		    SetSysMenu( HWND );
 *
 *  Concepts   :  clipboard
 *
 *  API's      :  DevOpenDC
 *		  DevCloseDC
 *
 *		  DosExit
 *
 *		  GpiAssociate
 *		  GpiBox
 *		  GpiBitBlt
 *		  GpiCreateBitmap
 *		  GpiCreatePS
 *		  GpiDestroyPS
 *		  GpiDeleteBitmap
 *		  GpiLoadBitmap
 *		  GpiQueryBitmapParameters
 *		  GpiQueryColor
 *		  GpiQueryLineType
 *		  GpiSetCurrentPosition
 *		  GpiSetColor
 *		  GpiSetLineType
 *		  GpiSetBitmap
 *
 *		  WinCreateStdWindow
 *		  WinCreateMsgQueue
 *		  WinCloseClipbrd
 *		  WinDispatchMsg
 *		  WinDefDlgProc
 *		  WinDefWindowProc
 *		  WinDestroyWindow
 *		  WinDestroyMsgQueue
 *		  WinDlgBox
 *		  WinFillRect
 *		  WinFreeErrorInfo
 *		  WinGetMsg
 *		  WinGetErrorInfo
 *		  WinIsRectEmpty
 *		  WinInitialize
 *		  WinLoadString
 *		  WinMessageBox
 *		  WinOpenClipbrd
 *		  WinOpenWindowDC
 *		  WinPostMsg
 *		  WinQuerySysValue
 *		  WinQueryClipbrdData
 *		  WinQuerySysPointer
 *		  WinQueryWindowText
 *		  WinQueryWindowRect
 *		  WinQueryUpdateRect
 *		  WinRegisterClass
 *		  WinSendMsg
 *		  WinSetFocus
 *		  WinSetPointer
 *		  WinSetClipbrdData
 *		  WinSetRect
 *		  WinSetWindowText
 *		  WinTerminate
 *		  WinTrackRect
 *		  WinValidateRect
 *		  WinWindowFromID
 *
 *  Required
 *    Files    :  OS2.H, STRING.H, CLIPBRD.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/

#define INCL_DEV
#define INCL_WINWINDOWMGR
#define INCL_WINDIALOGS
#define INCL_WININPUT
#define INCL_WINRECTANGLES
#define INCL_WINACCELERATORS
#define INCL_WINPOINTERS
#define INCL_WINSETERRORINFO
#define INCL_WINMESSAGEMGR
#define INCL_WINBUTTONS
#define INCL_WINEDITCTLS
#define INCL_WINLISTBOXES
#define INCL_WINMENUS
#define INCL_WINSCROLLBARS
#define INCL_WINFRAMEMGR
#define INCL_WINFRAMECTLS
#define INCL_WINSYS
#define INCL_WINTRACKRECT
#define INCL_WINCLIPBOARD
#define INCL_GPICONTROL
#define INCL_GPITRANSFORMS
#define INCL_GPIPRIMITIVES
#define INCL_GPIREGIONS
#define INCL_GPICORRELATION
#define INCL_GPILCIDS
#define INCL_GPIBITMAPS
#define INCL_ERRORS
#define INCL_DOSPROCESS
#include <os2.h>
#include <string.h>
#include "clipbrd.h"

/*----------------- various window-dependent globals -------------------------*/

HAB	habMain;		       /* Anchor block handle		      */
HMQ	hmqMain;		       /* Application queue handle	      */
HWND	hwndFrame=0L;		     /* Frame control handle		    */
HWND	hwndClient;		       /* Client area handle		      */
HPS	hpsClient=0L;		     /* Client area gpi ps handle	    */
HDC	hdcClient;		       /* Window dc handle		      */
HACCEL haccelMain;		       /* Accelerator table handle	      */
HACCEL haccelTrack;		       /* Tracking rect accelerator table     */

/*-------------------------- memory bit map globals --------------------------*/

HDC	hdcMemory;
HBITMAP bmapMemory;
HPS	hpsMemory;

DRIVDATA    drvdata = {44L, 0L, "DISPLAY", 0L};

  struct {
    PSZ	  address;
    PSZ	  driver_name;
    PSZ	  driver_data;
    PSZ	  data_type;
    PSZ	  comment;
    PSZ	  proc_name;
    PSZ	  proc_params;
    PSZ	  spl_params;
    PSZ	  network_params;
	 }

    dcdatablk = {0L, "DISPLAY", 0L, 0L, 0L, 0L, 0L, 0L, 0L};

BITMAPINFOHEADER2 bmpMemory;	       /* bitmap information header for
					  create bitmap API		      */
POINTL	aptlCorners[4];		       /* rectangle corners for BitBlting     */


/*---------------------- tracking rectangle info structure -------------------*/

TRACKINFO tiStruct;

/*----------------- only process WM_PAINT when we are ready ------------------*/

BOOL fPaintable = FALSE;

/*----------------------- Line attribute bundle ------------------------------*/

LINEBUNDLE lbndLineAttr = {(LONG)0,	    /*	lColor;	      */
			   (LONG)0,	    /*	lBackColor;   */
			   FM_XOR,	    /*	usMixMode;    */
			   (USHORT)0,	    /*	usBackMixMode */
			   (FIXED)0,	    /*	fxWidth;      */
			   (LONG)0,	    /*	lGeomWidth;   */
			   (USHORT)0,	    /*	usType;	      */
			   (USHORT)0,	    /*	usEnd;	      */
			   (USHORT)0};	    /*	usJoin;	      */


/*---------------------------- loaded strings --------------------------------*/

char szTitleBar[CCHMAXSTRING];
char szTerminate[CCHMAXSTRING];
char szHelp[CCHMAXSTRING];
char szDefErrMesg[]  = "No further infomation";	 /* message when no other     */
char szApiErrTitle[] = "API Error Return";	 /* title for error message   */
LONG Status = SUCCESSX;
BOOL fErrMem=FALSE;

/*
 * Function prototypes
 */

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);

/**************************************************************************
 *
 *  Name       : main()
 *
 *  Description: Initializes the PM environment and processes
 *		 the application message queue until a WM_QUIT
 *		 message is received.  It then destroys all OS/2
 *		 PM services and terminates.
 *
 *  Concepts   : - obtains anchor block handle and creates message
 *		     queue
 *		 - calls the initialization routine
 *		 - creates the main frame window which creates the
 *		     main client window
 *		 - polls the message queue via Get/Dispatch Msg loop
 *		 - upon exiting the loop, exits
 *
 *  API's      :   WinInitialize
 *		   WinCreateMsgQueue
 *		   WinGetMsg
 *		   WinDispatchMsg
 *		   WinTerminate
 *
 *  Parameters :  [none]
 *
 *  Return     :  1 - if successful execution completed
 *		  0 - if error
 *
 *************************************************************************/
int main()
{
   QMSG qmsgMain;			      /* application queue structure */

   habMain = WinInitialize(0L);
   hmqMain = WinCreateMsgQueue(habMain,0);

  /*
   * Test to see if the queue handle is 0L. If it is, it probably
   * means that the program has been installed in Desktop Manager as
   * VIO or Full Screen. In this case, the WinInitialize works,
   * but creating the message queue will fail and if you continue
   * with anything else you will get invalid selectors.
   * You can't even put up a message box so the program will
   * not start and the user will not know why!
   */
   if (hmqMain != (HMQ)0L)
   {
      if (!Initialize())
      {
	 Report_Error(habMain);
	 Finalize();
      }

      while (WinGetMsg(habMain, &qmsgMain, 0L, 0,0))
	 WinDispatchMsg(habMain, &qmsgMain);

      Finalize();
   }
   else
   {
       WinTerminate(habMain);
   }
   return SUCCESSX;
}   /* end of main  */

/**************************************************************************
 *
 *  Name       : ClientWndProc
 *
 *  Description: This is the window procedure associated with the client
 *		 area in the standard frame window.  It processes all
 *		 messages either sent or posted to the client area,
 *		 depending on the message command and parameters.
 *
 *  Concepts   : messaging
 *
 *  API's      : WinMessageBox
 *		 WinDefWindowProc
 *
 *  Parameters :  hwnd = window handle
 *		  msg  = message i.d.
 *		  mp1  - first message parameter
 *		  mp2  - second message parameter
 *
 *  Return     :  depends on type of message processed
 *
 *************************************************************************/
MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   switch (msg)
   {
   case WM_CREATE:
      WindowInitialization(hwnd);
      break;

   case WM_DESTROY:
      WindowDestroy();
      break;

   case WM_HELP:
      WinMessageBox(HWND_DESKTOP,
		    hwnd,
		   (PSZ)szHelp,
		   (PSZ)szTitleBar,
		    0,
		    MB_MOVEABLE | MB_CUANOTIFICATION | MB_OK
		   );

      break;

   case WM_PAINT:
      PaintRoutine(hwnd);
      break;

   case WM_CLOSE:
      ExitRoutine(hwnd);
      break;

   case WM_INITMENU:
      MenuInitialization(mp1,mp2);
      break;

    /*
     * process menu item commands
     */
   case WM_COMMAND:
      switch (LOUSHORT(mp1))
      {
      case MENU_EXTHELP:
	 ClipbrdHelp( hwnd, EXTHELP );
	 break;
      case MENU_HELPINDEX:
	 ClipbrdHelp( hwnd, HELPINDEX );
	 break;
      case MENU_KEYSHELP:
	 ClipbrdHelp( hwnd, KEYSHELP );
	 break;
      case MENU_HELPUSING:
	 ClipbrdHelp( hwnd, GENHELP );
	 break;
      case MENU_PRODINFO:
	 HelpProductInfo( hwnd );
	 break;

      case MENU_COPY:
	 CopyRoutine();
	 break;
      case MENU_PASTE:
	 PasteRoutine();
	 break;
      case MENU_CUT:
	 CutRoutine();
	 break;
      case MENU_CLEAR:
	 ClearRoutine();
	 break;
	/*
	 * Unrecognized WM_COMMAND IDs are processed in a default manner.
	 */
      default:
	 return(WinDefWindowProc(hwnd, msg, mp1, mp2));
      }
      break;

    /*
     * Clear an existing rectangle from the screen, and set the process into
     * track rectangle mode loop, after setting up the required parameters
     */
   case WM_BUTTON1DOWN:
      MouseButtonDown(hwnd,mp1);
      break;


   default:
      return(WinDefWindowProc(hwnd, msg, mp1, mp2));
   }
   return (MRESULT)0;
}  /*  end of ClientWndProc  */

/**************************************************************************
 *
 *  Name       : ClearRoutine
 *
 *  Description: erases a bounding rectangle from the screen
 *
 *  Concepts   :
 *
 *  API's      : WinIsRectEmpty
 *		 WinSetRect
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID ClearRoutine()
{
    /*
     * If a bounding rectangle has been defined, erase that part of the
     * picture from the screen and the memory bit map.
     */
   if(!WinIsRectEmpty(habMain, &tiStruct.rclTrack))
   {
      EraseRect();
      WinSetRect(habMain, &tiStruct.rclTrack, 0, 0, 0, 0);
   } /* endif */
   return;
}  /*  end of ClearRoutine */

/**************************************************************************
 *
 *  Name       : ClipbrdHelp
 *
 *  Description: displays the appropriate help string
 *
 *  Concepts   : help
 *
 *  API's      : WinLoadString
 *		 WinMessageBox
 *
 *  Parameters : hwnd  = window handle
 *		 HelpId = help string i.d.
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID ClipbrdHelp(HWND hwnd, USHORT HelpId)
{
   CHAR szTemp[CCHMAXSTRING];

   /*
    * Get the appropriate help string.
    */
   if (!WinLoadString(habMain, (HMODULE)0L, HelpId, (SHORT)CCHMAXSTRING,
			  (PSZ)szTemp))
      ReportAPIError("Error loading Help String");

   /*
    * Display the help string.
    */
   WinMessageBox(HWND_DESKTOP,
		  hwnd,
		  (PSZ)szTemp,
		  (PSZ)szTitleBar,
		  0,
		  MB_MOVEABLE | MB_CUANOTIFICATION | MB_OK );
   return;
}  /*  end of ClipbrdHelp  */

/**************************************************************************
 *
 *  Name       : CopyRoutine
 *
 *  Description: copies a rectangle into a fresh bitmap
 *
 *  Concepts   :
 *
 *  API's      : WinOpenClipbrd
 *		 WinSetClipbrdData
 *		 WinCloseClipbrd
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID CopyRoutine()
{
   HBITMAP bmapTempMem;
    /*
     * If a bounding rectangle has been defined, copy that part of the
     * memory bit map into a newly-created bitmap.
     * Give the new bit map to the clipboard. Finally, clear the
     * bounding rectangle.
     */
   bmapTempMem = GetBitmap();
   if(bmapTempMem != (HBITMAP)0L)
   {
      WinOpenClipbrd(habMain);
      WinSetClipbrdData(habMain, (ULONG)bmapTempMem, CF_BITMAP, 0L);
      WinCloseClipbrd(habMain);
      RemoveRect();
   } /* endif */
   return;
}  /*  end of CopyRoutine  */

/**************************************************************************
 *
 *  Name       : CutRoutine
 *
 *  Description: cuts a rectangle to the clipboard and removes it from the
 *		 window
 *
 *  Concepts   : clipboard
 *
 *  API's      : WinOpenClipbrd
 *		 WinSetClipbrdData
 *		 WinCloseClipbrd
 *		 WinSetRect
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID CutRoutine()
{
  HBITMAP bmapTempMem;
    /*
     * If a bounding rectangle has been defined, copy that part of the
     * memory bit map into a newly created bitmap.
     * Give the new bitmap to the clipboard. Finally clear the
     * bounding rectangle and erase that part of the picture from the
     * screen and the memory bit map.
     */
   bmapTempMem = GetBitmap();
   if (bmapTempMem != (HBITMAP)0L)
   {
      WinOpenClipbrd(habMain);
      WinSetClipbrdData(habMain, (ULONG)bmapTempMem, CF_BITMAP, 0L);
      WinCloseClipbrd(habMain);
      EraseRect();
      WinSetRect(habMain, &tiStruct.rclTrack, 0, 0, 0, 0);
   } /* endif */
   return;
}  /*  end of CutRoutine  */

/**************************************************************************
 *
 *  Name       : DrawRect
 *
 *  Description: Draw a rectangle on the screen, using the last position
 *		 and size of the tracking rectangle.
 *
 *  Concepts   :
 *
 *  API's      : GpiQueryLineType
 *		 GpiSetLineType
 *		 GpiQueryColor
 *		 GpiSetColor
 *		 GpiSetCurrentPosition
 *		 GpiBox
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID DrawRect()
{
   POINTL ptlWork;
   LONG lSaveType;
   LONG lSaveColor;

   lSaveType = GpiQueryLineType(hpsClient);
   GpiSetLineType(hpsClient, LINETYPE_DOT);

   lSaveColor = GpiQueryColor(hpsClient);
   GpiSetColor(hpsClient,CLR_RED);

   ptlWork.x = tiStruct.rclTrack.xLeft;
   ptlWork.y = tiStruct.rclTrack.yBottom;
   GpiSetCurrentPosition(hpsClient, &ptlWork);

   ptlWork.x = tiStruct.rclTrack.xRight;
   ptlWork.y = tiStruct.rclTrack.yTop;
   GpiBox(hpsClient, DRO_OUTLINE, &ptlWork, 0L, 0L);

   GpiSetLineType(hpsClient, lSaveType);
   GpiSetColor(hpsClient,lSaveColor);
   return;
} /*  end of DrawRect  */

/**************************************************************************
 *
 *  Name       : EraseRect
 *
 *  Description: Erase a rectangle from the screen and from the memory
 *		 bit map
 *
 *  Concepts   :
 *
 *  API's      : WinFillRect
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID EraseRect()
{
   RECTL rclErase;

   rclErase = tiStruct.rclTrack;
   WinFillRect(hpsMemory, &rclErase, CLR_WHITE);
   RemoveRect();
   return;
}  /*  end of EraseRect	 */

/**************************************************************************
 *
 *  Name       : ExitRoutine
 *
 *  Description: called when PF3 is pushed, when Close is selected from
 *		 the System Menu, or when Exit is selected
 *
 *  Concepts   :
 *
 *  API's      : WinFillRect
 *
 *  Parameters : hwnd = window handle
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID ExitRoutine(HWND hwnd)
{
   WinPostMsg(hwnd, WM_QUIT, (MPARAM)0, (MPARAM)0);
   return;
}   /*	end of ExitRoutine  */

/**************************************************************************
 *
 *  Name       : Finalize
 *
 *  Description: destroy all Presentation Manager resources and end the
 *		 process
 *
 *  Concepts   : termination
 *
 *  API's      : WinDestroyWindow
 *		 WinDestroyMsgQueue
 *		 WinTerminate
 *		 DosExit
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID Finalize( VOID )
{
   WinDestroyWindow(hwndFrame);
   WinDestroyMsgQueue(hmqMain);
   WinTerminate(habMain);
   DosExit( Status, 0);
   return;
}   /*	end of Finalize	 */

/**************************************************************************
 *
 *  Name       : GetBitmap
 *
 *  Description: If a bounding rectangle has been defined, create a screen
 *		 compatible device context and a screen compatible bit map.
 *		 Select the bit map into the DC, create a
 *		 suitably sized GPI PS and associate it with the DC.
 *		 BitBlt that part of the
 *		 screen defined by the rectangle into the new bit map.
 *		 Destroy all other resources but return the bit map handle
 *		 (to be passed to the clipboard)
 *
 *  Concepts   :
 *
 *  API's      :  WinIsRectEmpty
 *		  WinQuerySysPointer
 *		  WinSetPointer
 *		  DevOpenDC
 *		  GpiCreatePS
 *		  GpiCreateBitmap
 *		  GpiSetBitmap
 *		  GpiBitBlt
 *		  GpiAssociate
 *		  GpiDestroyPS
 *		  DevCloseDC
 *
 *  Parameters : [none]
 *
 *  Return     : bitmap handle
 *
 *************************************************************************/
HBITMAP GetBitmap()
{
   HDC	 hdc;
   HPS	 hps;
   HBITMAP bmap;
   register HPOINTER tptr;

   SIZEL sizlWork;

   if(WinIsRectEmpty(habMain, &tiStruct.rclTrack))
   {
      return((HBITMAP)0L);
   } /* endif */

   if ( (tptr = WinQuerySysPointer(HWND_DESKTOP, SPTR_WAIT, FALSE)) == 0 )
      ReportAPIError("Failed to get System pointer handle");
   WinSetPointer(HWND_DESKTOP, tptr);
  /*
   * It is a bounding rectangle, so we only want what is inside.
   */
   sizlWork.cx = tiStruct.rclTrack.xRight - tiStruct.rclTrack.xLeft - 1;
   sizlWork.cy = tiStruct.rclTrack.yTop - tiStruct.rclTrack.yBottom - 1;

   hdc = DevOpenDC(habMain,
		  OD_MEMORY,
		 (PSZ)"*",
		  8L,
		 (PDEVOPENDATA)&dcdatablk,
		 (HDC)0L
		 );
   if (hdc == 0) ReportAPIError("DevOpenDC Failure");

   bmpMemory.cbFix	     = sizeof(bmpMemory);
   bmpMemory.cx		     = (USHORT)sizlWork.cx;
   bmpMemory.cy		     = (USHORT)sizlWork.cy;
   bmpMemory.cPlanes	     = 1L;
   bmpMemory.cBitCount	     = 24L;
   bmpMemory.ulCompression   = BCA_UNCOMP;
   bmpMemory.cxResolution    = 0;
   bmpMemory.cyResolution    = 0;
   bmpMemory.cclrUsed	     = 0;
   bmpMemory.cclrImportant   = 0;
   bmpMemory.usUnits	     = BRU_METRIC;
   bmpMemory.usRecording     = BRA_BOTTOMUP;
   bmpMemory.usRendering     = BRH_NOTHALFTONED;
   bmpMemory.cSize1	     = 0;
   bmpMemory.cSize2	     = 0;
   bmpMemory.ulColorEncoding = 0;
   bmpMemory.ulIdentifier    = 0;

   hps = GpiCreatePS(habMain, hdc, &sizlWork, GPIA_ASSOC | PU_PELS);
   if (hps == 0)
   {
     ReportAPIError("GpiCreatePS Failure");
   }

   bmap = GpiCreateBitmap(hps,
	   (PBITMAPINFOHEADER2)&bmpMemory,
	   0L,
	   (PBYTE)NULL,
	   (PBITMAPINFO2)NULL
	    );
   if (bmap ==0)
   {
      ReportAPIError("GpiCreateBitmap Failure");
   }

   GpiSetBitmap(hps, bmap);

  /*
   * No adjustments to the top and right top (using lengths) since the
   * rectangles used for the BitBlt are non-inclusive (the bottom and
   * left are included, but not the top and right)
   */
   aptlCorners[0].x = 0;
   aptlCorners[0].y = 0;
   aptlCorners[1].x = sizlWork.cx;
   aptlCorners[1].y = sizlWork.cy;
  /*
   * Want to copy from inside the bounding rect. Increase the left & bottom
   * by one but leave the top & right since the rectangles used for the BitBlt
   * are non-inclusive (the bottom and left are included, but not the
   * top and right).
   */
   aptlCorners[2].x = tiStruct.rclTrack.xLeft + 1;
   aptlCorners[2].y = tiStruct.rclTrack.yBottom + 1;
   aptlCorners[3].x = tiStruct.rclTrack.xRight;
   aptlCorners[3].y = tiStruct.rclTrack.yTop;
   GpiBitBlt(hps, hpsMemory, 4L, aptlCorners, ROP_SRCCOPY, BBO_IGNORE);

   GpiSetBitmap(hps, (HBITMAP)0L);
   GpiAssociate(hps, (HDC)0L);
   GpiDestroyPS(hps);
   DevCloseDC(hdc);
   WinSetPointer(HWND_DESKTOP, WinQuerySysPointer(HWND_DESKTOP,
						 SPTR_ARROW,
						 FALSE)
						 );
   return(bmap);
}  /*  end of GetBitmap	 */

/**************************************************************************
 *
 *  Name       : Initialize
 *
 *  Description: initialize the PM interface,
 *		 create an application message queue and a
 *		 standard frame window
 *
 *  Concepts   :
 *
 *  API's      : WinLoadString
 *		 WinRegisterClass
 *		 WinSetPointer
 *		 WinQuerySysPointer
 *		 WinCreateStdWindow
 *		 WinQueryWIndowText
 *		 WinSetWindowText
 *
 *  Parameters : [none]
 *
 *  Return     : TRUE = successful initialization
 *		 FALSE = error occurred
 *
 *************************************************************************/
BOOL Initialize()
{
   ULONG flCreate;
   BOOL	 fErrTmp=FALSE;

   fErrMem = (BOOL)!WinLoadString(habMain,
				(HMODULE)0L,
				(USHORT)TERMINATE,
				(SHORT)CCHMAXSTRING,
				(PSZ)szTerminate
				);
   fErrTmp = (BOOL)!WinLoadString(habMain,
				(HMODULE)0L,
				(USHORT)HELPPANEL,
				(SHORT)CCHMAXSTRING,
				(PSZ)szHelp
				);
   if (fErrMem || fErrTmp)
      return(FALSE);

   if (!WinRegisterClass(habMain,
			 (PSZ)"My Class",
			 (PFNWP)ClientWndProc,
			 CS_SIZEREDRAW,
			 0))

      return(FALSE);

   WinSetPointer(HWND_DESKTOP,
		WinQuerySysPointer(HWND_DESKTOP, SPTR_WAIT, FALSE));

   flCreate = FCF_STANDARD;
   hwndFrame = WinCreateStdWindow(HWND_DESKTOP,
				 WS_VISIBLE,
				 &flCreate,
				 (PSZ)"My Class",
				 (PSZ)NULL,
				 WS_VISIBLE,
				 (HMODULE)0L,
				 AMENU,
				 &hwndClient
				 );

   WinSetWindowText(hwndFrame, "CLIPBOARD SAMPLE");

   WinSetPointer(HWND_DESKTOP,
		WinQuerySysPointer(HWND_DESKTOP, SPTR_ARROW, FALSE));

   if (hwndFrame == (HWND)0L)
   {
      return(FALSE);
   } /* endif */

  /*
   * Get the window title given to the window by the system
   */
   WinQueryWindowText(hwndFrame, CCHMAXSTRING, (PSZ)szTitleBar);

   return(TRUE);
}  /*  end of Initialize  */

/**************************************************************************
 *
 *  Name       : MenuInitialization
 *
 *  Description: set beginning attributes (enabled or not) of menu items
 *
 *  Concepts   : menu
 *
 *  API's      : WinIsRectEmpty
 *		 WinSendMsg
 *		 WinOpenClipbrd
 *		 WinQueryClipbrdData
 *		 WinCloseClipbrd
 *
 *  Parameters : mp1 = first message parameter
 *		 mp2 = second message parameter
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID MenuInitialization(MPARAM mp1, MPARAM mp2)
{
   BOOL	   fEmptyRect;
    /*
     * Menu items in the Edit pull-down may need to be grayed, depending on
     * the presence of a rectangle and the contents of the clipboard.
     */
   if (LOUSHORT(mp1) == SM_CLIPBRD)
   {
      fEmptyRect = WinIsRectEmpty(habMain, &tiStruct.rclTrack);
      WinSendMsg((HWND)mp2,
		    MM_SETITEMATTR,
		    MPFROM2SHORT(MENU_COPY, TRUE),
		    MPFROM2SHORT(MIA_DISABLED,
				 fEmptyRect ? MIA_DISABLED : ~MIA_DISABLED)
				);
      WinSendMsg((HWND)mp2,
		    MM_SETITEMATTR,
		    MPFROM2SHORT(MENU_CUT, TRUE),
		    MPFROM2SHORT(MIA_DISABLED,
				 fEmptyRect ? MIA_DISABLED : ~MIA_DISABLED)
				);
      WinSendMsg((HWND)mp2,
		    MM_SETITEMATTR,
		    MPFROM2SHORT(MENU_CLEAR, TRUE),
		    MPFROM2SHORT(MIA_DISABLED,
				 fEmptyRect ? MIA_DISABLED : ~MIA_DISABLED)
				);

      WinOpenClipbrd(habMain);

      if ((HBITMAP)WinQueryClipbrdData(habMain, CF_BITMAP) != (HBITMAP)0L &&
	    !fEmptyRect)
      {
	 fEmptyRect = TRUE;
      }
      else
      {
	 fEmptyRect = FALSE;
      }
      WinSendMsg((HWND)mp2,
		 MM_SETITEMATTR,
		 MPFROM2SHORT(MENU_PASTE, TRUE),
		 MPFROM2SHORT(MIA_DISABLED,
		 fEmptyRect ? ~MIA_DISABLED : MIA_DISABLED)
			   );
      WinCloseClipbrd(habMain);
   }
}   /*	end of MenuInitialization  */

/**************************************************************************
 *
 *  Name       : MouseButtonDown
 *
 *  Description: process the mouse button interface
 *
 *  Concepts   : rectangle tracking
 *
 *  API's      : WinSetFocus
 *		 WinIsRectEmpty
 *		 WinSetRect
 *		 WinQueryWindowRect
 *		 WinTrackRect
 *
 *  Parameters : hwnd = window handle
 *		 mp1 = message parameter
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID MouseButtonDown(HWND hwnd, MPARAM mp1)
{
    /*
     * As the application is handling the button message, set the focus
     * to the frame window.
     */
   WinSetFocus(HWND_DESKTOP,hwndClient);

    /*
     * Clear an existing rectangle from the screen, and set the process into
     * track rectangle mode loop, after setting up the required parameters.
     */
   if(!WinIsRectEmpty(habMain, &tiStruct.rclTrack))
   {
      RemoveRect();
      WinSetRect(habMain, &tiStruct.rclTrack, 0, 0, 0, 0);
   } /* endif */

   tiStruct.cxBorder = 1;
   tiStruct.cyBorder = 1;
   tiStruct.cxGrid = 0;
   tiStruct.cyGrid = 0;
   WinSetRect(habMain, &tiStruct.rclTrack,
	     LOUSHORT(mp1),
	     HIUSHORT(mp1),
	     LOUSHORT(mp1),
	     HIUSHORT(mp1));
   WinQueryWindowRect(hwnd, &tiStruct.rclBoundary);
   tiStruct.ptlMinTrackSize.x = 1;
   tiStruct.ptlMinTrackSize.y = 1;
   tiStruct.ptlMaxTrackSize.x = ++tiStruct.rclBoundary.xRight;
   tiStruct.ptlMaxTrackSize.y = ++tiStruct.rclBoundary.yTop;
   tiStruct.fs	= TF_STANDARD | TF_ALLINBOUNDARY | TF_RIGHT | TF_BOTTOM;
   WinTrackRect(hwnd, (HPS)0L, &tiStruct);
   if((tiStruct.rclTrack.xRight - tiStruct.rclTrack.xLeft) > 2 &&
       (tiStruct.rclTrack.yTop - tiStruct.rclTrack.yBottom) > 2)
   {
      DrawRect();
   }
   else
   {
      WinSetRect(habMain, &tiStruct.rclTrack, 0, 0, 0, 0);
   } /* endif */
}    /*	 end of MouseButtonDown	 */

/**************************************************************************
 *
 *  Name       : PaintRoutine
 *
 *  Description: display bits in the window
 *
 *  Concepts   :
 *
 *  API's      : WinQueryUpdateRect
 *		 GpiBitBlt
 *		 WinInvalidateRect
 *		 WinIsRectEmpty
 *
 *
 *  Parameters : hwnd = window handle
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID PaintRoutine(HWND hwnd)
{
   RECTL   rclUpdt;
   BOOL	   RC;
     /*
      * If we are in a position to update the window, get the invalidated
      * rectangle and use this to copy from the memory bit map to the screen,
      * using a BitBlt. Finally, validate the updated rectangle.
      */
   if (fPaintable)
   {
       WinQueryUpdateRect(hwnd, &rclUpdt);
   /*
    * Want the top & right-hand side, so increase by one, since the
    * rectangles used for the BitBlt are non-inclusive (the bottom
    * and left are included, but not the top and right).
    */
       aptlCorners[0].x = rclUpdt.xLeft;
       aptlCorners[0].y = rclUpdt.yBottom;
       aptlCorners[1].x = rclUpdt.xRight+1;
       aptlCorners[1].y = rclUpdt.yTop+1;
   /*
    * Want the top & right-hand side as well, so increase by one, since the
    * rectangles used for the BitBlt are non-inclusive (the bottom
    * and left are included, but not the top and right).
    */
       aptlCorners[2].x = rclUpdt.xLeft;
       aptlCorners[2].y = rclUpdt.yBottom;
       aptlCorners[3].x = rclUpdt.xRight+1;
       aptlCorners[3].y = rclUpdt.yTop+1;
       GpiBitBlt(hpsClient,
		 hpsMemory,
		 4L,
		 aptlCorners,
		 ROP_SRCCOPY,
		 BBO_IGNORE
		);
       RC = WinValidateRect(hwnd, &rclUpdt, FALSE);
       if (!WinIsRectEmpty(habMain, &tiStruct.rclTrack))
	   DrawRect();
   }
}  /*  end of PaintRoutine  */

/**************************************************************************
 *
 *  Name       : PasteRoutine
 *
 *  Description: display a rectangle from the clipboard
 *
 *  Concepts   :
 *
 *  API's      : WinIsRectEmpty
 *		 WinOpenClipbrd
 *		 WinQueryClipbrdData
 *		 GpiQueryBitmapParameters
 *		 DevOpenDC
 *		 GpiCreatePS
 *		 GpiSetBitmap
 *		 WinSetPointer
 *		 GpiBitBlt
 *		 GpiAssociate
 *		 GpiDestroyPS
 *		 DevCloseDC
 *		 WinCloseClipbrd
 *		 WinSetRect
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID PasteRoutine()
{
   HDC	   hdcTempMem;
   HBITMAP bmapTempMem;
   HPS	   hpsTempMem;
   BITMAPINFOHEADER bmpTemp;
   SIZEL   sizlWork;
     /*
      * If a bounding rectangle has been defined, open the clipboard and
      * see if it contains a bit map. If one exists, create temporary DCs
      * and GPI PSs to enable the clipboard bit map to be BitBlted into
      * the memory bit map and from there onto the screen. Destroy all the
      * temporary resources, close the clipboard and clear the
      * bounding rectangle.
      */
   if (!WinIsRectEmpty(habMain, &tiStruct.rclTrack))
   {
      WinOpenClipbrd(habMain);
      bmapTempMem = (HBITMAP)WinQueryClipbrdData(habMain, CF_BITMAP);
      if(bmapTempMem != (HBITMAP)0L)
      {
	 GpiQueryBitmapParameters(bmapTempMem,
				  &bmpTemp
				  );
	  /*
	   * Want to paste inside the bounding rect. So increase the
	   * left & bottom by one but leave the top & right since the
	   * rectangles used for the BitBlt are non-inclusive (the
	   * bottom and left are included, but not the top and right).
	   */
	  aptlCorners[0].x = tiStruct.rclTrack.xLeft+1;
	  aptlCorners[0].y = tiStruct.rclTrack.yBottom+1;
	  aptlCorners[1].x = tiStruct.rclTrack.xRight;
	  aptlCorners[1].y = tiStruct.rclTrack.yTop;
	  /*
	   * No adjustments to the top & right top (using lengths)
	   * since the rectangles used for the BitBlt are
	   * non-inclusive (the bottom and left are included,
	   * but not the top and right).
	   */
	  aptlCorners[2].x = 0;
	  aptlCorners[2].y = 0;
	  aptlCorners[3].x = bmpTemp.cx;
	  aptlCorners[3].y = bmpTemp.cy;
	  hdcTempMem = DevOpenDC(habMain,
				 OD_MEMORY,
				(PSZ)"*",
				 8L,
				(PDEVOPENDATA)&dcdatablk,
				(HDC)0L
				);
	  sizlWork.cx = bmpTemp.cx;
	  sizlWork.cy = bmpTemp.cy;
	  hpsTempMem = GpiCreatePS(habMain,
				   hdcTempMem,
				   &sizlWork,
				   GPIA_ASSOC | PU_PELS
				  );
	  GpiSetBitmap(hpsTempMem, bmapTempMem);
	  WinSetPointer(HWND_DESKTOP,
			WinQuerySysPointer(HWND_DESKTOP,
					   SPTR_WAIT,
					   FALSE)
		       );
	  GpiBitBlt(hpsMemory,
		    hpsTempMem,
		    4L,
		    aptlCorners,
		    ROP_SRCCOPY,
		    BBO_IGNORE
		   );
	  /*
	   * Want a slightly bigger rectangle for the screen because
	   * we need to remove the bounding rectangle as well as do
	   * the paste.
	   */
	  aptlCorners[2].x =  (--aptlCorners[0].x);
	  aptlCorners[2].y =  (--aptlCorners[0].y);
	  aptlCorners[3].x =  (++aptlCorners[1].x);
	  aptlCorners[3].y =  (++aptlCorners[1].y);
	  GpiBitBlt(hpsClient,
		    hpsMemory,
		    4L,
		    aptlCorners,
		    ROP_SRCCOPY,
		    BBO_IGNORE
		   );
	  WinSetPointer(HWND_DESKTOP,
			WinQuerySysPointer(HWND_DESKTOP,
					   SPTR_ARROW,
					   FALSE)
		       );

	  GpiSetBitmap(hpsTempMem, (HBITMAP)0L);
	  GpiAssociate(hpsTempMem, (HDC)0L);
	  GpiDestroyPS(hpsTempMem);
	  DevCloseDC(hdcTempMem);
      } /* endif */
      WinCloseClipbrd(habMain);
      WinSetRect(habMain, &tiStruct.rclTrack, 0, 0, 0, 0);
   } /* endif */
}   /* end of PasteRoutine  */

/**************************************************************************
 *
 *  Name       : RemoveRect
 *
 *  Description: Update the screen from the memory bitmap, thus erasing
 *		 the rectangle
 *
 *  Concepts   :  bitblt
 *
 *  API's      : GpiBitBlt
 *		 WinSetRect
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID RemoveRect()
{
  /*
   * Want the top & right-hand side as well, so increase by one since the
   * rectangles used for the BitBlt are non-inclusive (the
   * bottom and left are included, but not the top and right).
   */
   aptlCorners[0].x = tiStruct.rclTrack.xLeft;
   aptlCorners[0].y = tiStruct.rclTrack.yBottom;
   aptlCorners[1].x = tiStruct.rclTrack.xRight+1;
   aptlCorners[1].y = tiStruct.rclTrack.yTop+1;

  /*
   * Want the top & right-hand side as well, so increase by one since the
   * rectangles used for the BitBlt are non-inclusive (the
   * bottom and left are included, but not the top and right).
   */
   aptlCorners[2].x = tiStruct.rclTrack.xLeft;
   aptlCorners[2].y = tiStruct.rclTrack.yBottom;
   aptlCorners[3].x = tiStruct.rclTrack.xRight+1;
   aptlCorners[3].y = tiStruct.rclTrack.yTop+1;
   GpiBitBlt(hpsClient,
	     hpsMemory,
	     4L,
	     aptlCorners,
	     ROP_SRCCOPY,
	     BBO_IGNORE
	    );


   WinSetRect(habMain, &tiStruct.rclTrack, 0, 0, 0, 0);
}  /* end of RemoveRect */

/**************************************************************************
 *
 *  Name       : Report_Error
 *
 *  Description: Display a particular system error message, the latest one
 *		 for the required thread.  No resources can be loaded in
 *		 case of memory error.
 *
 *  Concepts   :
 *
 *  API's      : WinGetErrorInfo
 *		 WinMessageBox
 *		 WinFreeErrorInfo
 *
 *  Parameters : hab = anchor block handle
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID Report_Error(HAB hab)
{
   PERRINFO  perriBlk;
   PSZ	     pszErrMsg;
   PSZ	     pszOffSet;

   if (!fErrMem)
   {
      if((perriBlk = WinGetErrorInfo(hab)) != (PERRINFO)NULL)
      {
	 pszOffSet = ((PSZ)perriBlk) + perriBlk->offaoffszMsg;
	 pszErrMsg = ((PSZ)perriBlk) + *((PUSHORT)pszOffSet);

	 WinMessageBox(HWND_DESKTOP,
			hwndFrame,
		       (PSZ)(pszErrMsg),
		       (PSZ)szTitleBar,
			0,
			MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL );
	  WinFreeErrorInfo(perriBlk);
	  return;
      }
   } /* endif */
   WinMessageBox(HWND_DESKTOP,
		 hwndFrame,
		 (PSZ)"ERROR - Out Of Memory",
		 (PSZ)szTitleBar,
		 0,
		 MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL);
}  /* end of Report_Error */

/**************************************************************************
 *
 *  Name       : WindowDestroy
 *
 *  Description: destroy particular window data
 *
 *  Concepts   :
 *
 *  API's      : GpiSetBitmap
 *		 GpiDeleteBitmap
 *		 GpiAssociate
 *		 GpiDestroyPS
 *		 DevCloseDC
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID WindowDestroy()
{
    /*
     * Deselect the bit map from the screen-compatible device context, and
     * delete the bit map. Disassociate the two GPI PSs from their respective
     * DCs and destroy the PSs. Finally destroy the memory DC.
     */

   GpiSetBitmap(hpsMemory, (HBITMAP)0L);
   GpiDeleteBitmap(bmapMemory);
   GpiAssociate(hpsClient, (HDC)0L);
   GpiDestroyPS(hpsClient);
   GpiAssociate(hpsMemory, (HDC)0L);
   GpiDestroyPS(hpsMemory);
   DevCloseDC(hdcMemory);
   return;
}   /*	end of WindowDestroy  */

/**************************************************************************
 *
 *  Name       : WindowInitialization
 *
 *  Description: create window information
 *
 *  Concepts   :
 *
 *  API's      : WinQuerySysValue
 *		 WinOpenWindowDC
 *		 GpiCreatePS
 *		 DevOpenDC
 *		 GpiSetBitmap
 *		 GpiLoadBitmap
 *		 GpiSetRect
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID WindowInitialization(HWND hwnd)
{
   SIZEL   sizlWork;

    /*
     * Get the maximum client area size. Create a window DC for the client
     * area and a normal GPI Presentation Space and associate the two. The
     * GPI PS will be the maximum client area size in pels. Create a
     * memory DC compatible with the screen, create a GPI PS and associate it
     * with the screen compatible DC. Load a bit map from the resource
     * file, and select the bit map into the screen-compatible DC.
     * Initialize the rectangle tracking and set a flag to enable window
     * painting.
     */
   sizlWork.cx = WinQuerySysValue(HWND_DESKTOP, SV_CXFULLSCREEN);
   sizlWork.cy = WinQuerySysValue(HWND_DESKTOP, SV_CYFULLSCREEN);

   hdcClient = WinOpenWindowDC(hwnd);
   hpsClient = GpiCreatePS(habMain,
			   hdcClient,
			   &sizlWork,
			   GPIA_ASSOC | PU_PELS
			  );

   dcdatablk.driver_data = (PSZ)&drvdata;
   hdcMemory = DevOpenDC(habMain,
			 OD_MEMORY,
			(PSZ)"*",
			 8L,
			(PDEVOPENDATA)&dcdatablk,
			(HDC)0L
			);

   hpsMemory = GpiCreatePS(habMain,
			   hdcMemory,
			   &sizlWork,
			   GPIA_ASSOC | PU_PELS
			  );

   bmapMemory = GpiLoadBitmap( hpsMemory
			     , (HMODULE)0L
			     , (USHORT)ID_BITMAP
			     , sizlWork.cx
			     , sizlWork.cy
			     );

   GpiSetBitmap(hpsMemory, bmapMemory);
   WinSetRect(habMain, &tiStruct.rclTrack, 0, 0, 0, 0);

   fPaintable = TRUE;
   return;
}   /*	end of WindowInitialization  */

/**************************************************************************
 *
 *  Name       : ReportAPIError
 *
 *  Description: display an error message returned from an API call
 *
 *  Concepts   :
 *
 *  API's      : WinGetErrorInfo
 *		 WinMessageBox
 *		 WinPostMsg
 *
 *  Parameters : what = message string
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID ReportAPIError(PSZ what)
{
   PERRINFO  pErrInfoBlk;
   PSZ	     pszErrMsg;
   PSZ	     pszOffSet;
   char	     ErrorMsg[CCHMAXSTRING];			      /* error text buffer */

   pszErrMsg = &szDefErrMesg[0];	       /* set default in case no err */
   strcpy(ErrorMsg, what);		       /* init message string	     */
   strcat(ErrorMsg, "\n\n");		       /* double space for neatness  */
   if ((pErrInfoBlk = WinGetErrorInfo(habMain)) != (PERRINFO)NULL)
   {
       pszOffSet = ((PSZ)pErrInfoBlk) + pErrInfoBlk->offaoffszMsg;
       pszErrMsg = ((PSZ)pErrInfoBlk) + *((PUSHORT)pszOffSet);

       WinFreeErrorInfo(pErrInfoBlk);
   } /*	 if ((pErrInfoBlk = WinGetErrorInfo(hab)) != (PCH)NULL) */
   strcat(ErrorMsg, pszErrMsg);			/* combine specific text     */
   WinMessageBox(HWND_DESKTOP,			/* parent window is desk top */
		 hwndFrame,			/* owner window is our frame */
		(PSZ)&ErrorMsg[0],		/* text for message	     */
		(PSZ)szApiErrTitle,		/* title is API error	     */
		 0,				/* null window id	     */
		 MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL ); /* flags	     */
   Status = ERRORX;
   WinPostMsg(hwndClient, WM_QUIT, (ULONG)0, (ULONG)0);
   return;
}  /* end of ReportAPIError  */

/**************************************************************************
 *
 *  Name       :  ProductInfoDlgProc(hwnd, msg, mp1, mp2)
 *
 *  Description:  Processes all messages sent to the Product
 *		  information dialog
 *
 *  Concepts   :  Called for each message sent to the Product information
 *		  dialog box.
 *
 *		  the Product information dialog has only a button control, so this
 *		  routine processes only WM_COMMAND messages.  Any
 *		  WM_COMMAND posted must have come from the OK
 *		  button, so we dismiss the dialog upon receiving it.
 *
 *  API's      :  WinDefDlgProc
 *
 *  Parameters :  [none]
 *
 *  Return     :  dependent on message sent
 *
 *************************************************************************/
MRESULT EXPENTRY ProductInfoDlgProc(HWND hwnd,ULONG msg, MPARAM mp1, MPARAM mp2)
{
   switch (msg)
   {
   case WM_INITDLG:
      SetSysMenu(hwnd);	      /* system menu for this dialog  */
	 return (MRESULT)NULL;

   default:
      return WinDefDlgProc(hwnd, msg, mp1, mp2);
   }
   return (MRESULT)NULL;
}   /*	End of ProductInfoDlgProc  */

/**************************************************************************
 *
 *  Name       :  HelpProductInfo(hwndMain)
 *
 *  Description: Processes the Product information choice from the Help
 *		 pulldown
 *
 *  Concepts   : Processes the WM_COMMAND message posted by the
 *		 Product information item of the Help menu
 *		 Called from MainCommand when the Product information
 *		 menu item is selected
 *		 Calls WinDlgBox to display the Product information
 *		 dialog.
 *
 *  API's      :  WinDlgBox
 *
 *  Parameters :  hwndMain = main window handle
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID  HelpProductInfo(HWND hwndMain)
{
    /* display the Product Information dialog. */
   if(DID_ERROR == WinDlgBox(HWND_DESKTOP,
			     hwndMain,
			     (PFNWP)ProductInfoDlgProc,
			     0,
			     IDD_PRODUCTINFO,
			     (PVOID)NULL))
      ReportAPIError("Can't start dialog");
   return;
}   /*	End of HelpProductInfo	 */

/**************************************************************************
 *
 *  Name       :  SetSysMenu(hDlg)
 *
 *  Description:  Enables only the Move and Close items in the
 *		  system menu pulldown for any dialog
 *
 *  Concepts   :
 *
 *  API's      :  WinWindowFromID
 *		  WinSendMsg
 *
 *  Parameters :  hDlg = dialog handle
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID SetSysMenu(HWND hDlg)
{
   HWND	    hSysMenu;
   MENUITEM Mi;
   SHORT    Pos;
   SHORT    Id;
   SHORT    cItems;

   /*
    *  We only want Move and Close in the system menu.
    */
   hSysMenu = WinWindowFromID(hDlg, FID_SYSMENU);
   WinSendMsg( hSysMenu, MM_QUERYITEM
	     , MPFROM2SHORT(SC_SYSMENU, FALSE), MPFROMP((PCH) & Mi));
   Pos = 0;
   cItems = (SHORT)WinSendMsg( Mi.hwndSubMenu, MM_QUERYITEMCOUNT,
			       (MPARAM)NULL, (MPARAM)NULL);
   while (cItems--)
   {
      Id = SHORT1FROMMR(WinSendMsg( Mi.hwndSubMenu, MM_ITEMIDFROMPOSITION
			 , MPFROM2SHORT(Pos, TRUE), (MPARAM)NULL));
      switch (Id)
      {
      case SC_MOVE:
      case SC_CLOSE:
	 Pos++;	 /* Don't delete that one. */
	 break;
      default:
	 WinSendMsg( Mi.hwndSubMenu, MM_DELETEITEM
		     , MPFROM2SHORT(Id, TRUE), (MPARAM)NULL);
      }
   }
} /*  End of SetSysMenu	 */
/***************************  End of clipbrd.c	**************************/
/*==============================================================*\
 *  cliqhelp.c - routines for the help manager interface
 *	Copyright 1992, IBM Corp.
 *--------------------------------------------------------------
 *
 *  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *  sample code created by IBM Corporation. This sample code is not
 *  part of any standard or IBM product and is provided to you solely
 *  for	 the purpose of assisting you in the development of your
 *  applications.  The code is provided "AS IS", without
 *  warranty of any kind.  IBM shall not be liable for any damages
 *  arising out of your use of the sample code, even if they have been
 *  advised of the possibility of   such damages.
 *
 *--------------------------------------------------------------
 *
 *  This module contains all the routines for interfacing with
 *  the IPF help manager.
 *
 *--------------------------------------------------------------
 *
 *  This source file contains the following functions:
 *
 *	    InitHelp()
 *	    HelpHelpForHelp(mp2)
 *	    HelpExtended(mp2)
 *	    HelpKeys(mp2)
 *	    HelpIndex(mp2)
 *	    HelpTutorial(mp2)
 *	    HelpAbout(mp2)
 *	    DisplayHelpPanel(idPanel)
 *	    DestroyHelpInstance()
 *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/




#define	 INCL_WINHELP

#include <os2.h>
#include <string.h>
#include "cliqmain.h"
#include "cliqhelp.h"
#include "cliqxtrn.h"
#include "cliqglbl.h"

#define HELPLIBRARYNAMELEN  20

/* If DEBUG is defined, then the help panels will display their
 *  id values on their title bar.  This is useful for determining
 *  which help panels are being shown for each dialog item.  When
 *  the DEBUG directive is not defined, then the panel ids are not
 *  displayed.
 */

/* #define  DEBUG */


/*--------------------------------------------------------------*\
 *  Global variables
\*--------------------------------------------------------------*/
static HWND hwndHelpInstance;
static CHAR szLibName[HELPLIBRARYNAMELEN];
static CHAR szWindowTitle[HELPLIBRARYNAMELEN];


/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/
MRESULT EXPENTRY AboutBoxDlgProc(HWND	hwnd,
				 ULONG	msg,
				 MPARAM mp1,
				 MPARAM mp2);



/****************************************************************\
 *  Routine for initializing the help manager
 *--------------------------------------------------------------
 *
 *  Name:   InitHelp()
 *
 *  Purpose: Initializes the IPF help facility
 *
 *  Usage:  Called once during initialization of the program
 *
 *  Method: Initializes the HELPINIT structure and creates the
 *	    help instance.  If successful, the help instance
 *	    is associated with the main window
 *
 *  Returns:
 *
\****************************************************************/
VOID InitHelp(VOID)
{
   HELPINIT hini;
   APIRET   apiRC;

   /* if we return because of an error, Help will be disabled */
   fHelpEnabled = FALSE;

   /* initialize help init structure */
   hini.cb = sizeof(HELPINIT);
   hini.ulReturnCode = 0L;

   hini.pszTutorialName = (PSZ)NULL;   /* if tutorial added, add name here */

   hini.phtHelpTable = (PHELPTABLE)MAKELONG(CLIQ_HELP_TABLE, 0xFFFF);
   hini.hmodHelpTableModule = 0L;
   hini.hmodAccelActionBarModule = 0L;
   hini.idAccelTable = 0;
   hini.idActionBar = 0;

   if(!(apiRC=WinLoadString(hab,
		     0,
		     IDS_HELPWINDOWTITLE,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szWindowTitle)))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, apiRC, MB_OK | MB_ERROR, FALSE);
      return;
   }

   hini.pszHelpWindowTitle = (PSZ)szWindowTitle;

   /* if debugging, show panel ids, else don't */
#ifdef DEBUG
   hini.fShowPanelId = CMIC_SHOW_PANEL_ID;
#else
   hini.fShowPanelId = CMIC_HIDE_PANEL_ID;
#endif

   if(!(apiRC=WinLoadString(hab,
		     0,
		     IDS_HELPLIBRARYNAME,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szLibName)))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, apiRC, MB_OK | MB_ERROR, FALSE);
      return;
   }

   hini.pszHelpLibraryName = (PSZ)szLibName;

   /* creating help instance */
   hwndHelpInstance = WinCreateHelpInstance(hab, &hini);

   if(hwndHelpInstance == NULLHANDLE || hini.ulReturnCode)
   {
      MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, hini.ulReturnCode, MB_OK | MB_ERROR, TRUE);
      return;
   }

   /* associate help instance with main frame */
   if(!(apiRC=WinAssociateHelpInstance(hwndHelpInstance, hwndMainFrame)))
   {
      MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, apiRC, MB_OK | MB_ERROR, TRUE);
      return;
   }

   /* help manager is successfully initialized so set flag to TRUE */
   fHelpEnabled = TRUE;

}   /* InitHelp() */


/****************************************************************\
 *  Processes the Help for Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpHelpForHelp(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Help for Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Help for Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_DISPLAY_HELP message to the help
 *	    instance so that the default Help For Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpHelpForHelp(MPARAM mp2)
{

   /* this just displays the system help for help panel */
   if(fHelpEnabled)
   {
      if(WinSendMsg(hwndHelpInstance, HM_DISPLAY_HELP, MPVOID, MPVOID))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    0,
		    MB_OK | MB_ERROR,
		    FALSE);
      }
   }
}   /* HelpHelpForHelp() */


/****************************************************************\
 *  Processes the Extended Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpExtended(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Extended Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Extended Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_EXT_HELP message to the help
 *	    instance so that the default Extended Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpExtended(MPARAM mp2)
{

   /* this just displays the system extended help panel */
   if(fHelpEnabled)
   {
      if((BOOL32)WinSendMsg(hwndHelpInstance, HM_EXT_HELP, MPVOID, MPVOID))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    0,
		    MB_OK | MB_ERROR,
		    FALSE);
      }
   }
}   /* HelpExtended() */


/****************************************************************\
 *  Processes the Keys Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpKeys(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Keys Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Keys Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_KEYS_HELP message to the help
 *	    instance so that the default Keys Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpKeys(MPARAM mp2)
{

   /* this just displays the system keys help panel */
   if(fHelpEnabled)
   {
      if(WinSendMsg(hwndHelpInstance, HM_KEYS_HELP, MPVOID, MPVOID))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    0,
		    MB_OK | MB_ERROR,
		    FALSE);
      }
   }
}   /* HelpKeys() */


/****************************************************************\
 *  Processes the Index Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpIndex(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Index Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Index Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_INDEX_HELP message to the help
 *	    instance so that the default Index Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpIndex(MPARAM mp2)
{

   /* this just displays the system help index panel */
   if(fHelpEnabled)
   {
      if(WinSendMsg(hwndHelpInstance, HM_HELP_INDEX, MPVOID, MPVOID))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    0,
		    MB_OK | MB_ERROR,
		    FALSE);
      }
   }
}   /* HelpIndex() */


/****************************************************************\
 *  Processes the Tutorial Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpTutorial(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Tutorial Help item of the Help menu.  While the
 *	      standard template application does not include a
 *	      Tutorial menu item, you can add one if your
 *	      application has a tutorial.
 *
 *  Usage:  Called from MainCommand when the Tutorial Help
 *	    menu item is selected
 *
 *  Method:
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpTutorial(MPARAM mp2)
{

  /*--------------------------------------------------------------*\
   *  Insert code for any tutorial here
  \*--------------------------------------------------------------*/

}   /* HelpTutorial() */


/****************************************************************\
 *  Processes the About command from the Help menu
 *--------------------------------------------------------------
 *
 *  Name:   HelpAbout(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      About item of the Help menu
 *
 *  Usage:  Called from MainCommand when the About
 *	    menu item is selected
 *
 *  Method: Calls WinDlgBox to display the about box dialog.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpAbout(MPARAM mp2)
{

   /* display the AboutBox dialog */
   WinDlgBox(HWND_DESKTOP,
	     hwndMain,
	     AboutBoxDlgProc,
	     0,
	     IDD_ABOUTBOX,
	     (PVOID)NULL);
}   /* HelpAbout() */


/****************************************************************\
 *  Displays the help panel indicated
 *--------------------------------------------------------------
 *
 *  Name:   DisplayHelpPanel(idPanel)
 *
 *  Purpose: Displays the help panel whose id is given
 *
 *  Usage:  Called whenever a help panel is desired to be
 *	    displayed, usually from the WM_HELP processing
 *	    of the dialog boxes
 *
 *  Method: Sends HM_DISPLAY_HELP message to the help instance
 *
 *  Returns:
 *
\****************************************************************/
VOID DisplayHelpPanel(SHORT idPanel)
{

   if(fHelpEnabled)
   {
      if(WinSendMsg(hwndHelpInstance,
	    HM_DISPLAY_HELP,
	    MPFROMLONG(MAKELONG(idPanel, NULL)),
	    MPFROMSHORT(HM_RESOURCEID)))
      {
	 MessageBox(hwndMainFrame,
		    IDMSG_HELPDISPLAYERROR,
		    0,
		    MB_OK | MB_ERROR,
		    TRUE);
      }
   }

}   /* DisplayHelpPanel() */



/****************************************************************\
 *  Destroys the help instance
 *--------------------------------------------------------------
 *
 *  Name:   DestroyHelpInstance(VOID)
 *
 *  Purpose: Destroys the help instance for the application
 *
 *  Usage:  Called after exit from message loop
 *
 *  Method: Calls WinDestroyHelpInstance() to destroy the
 *	    help instance
 *
 *  Returns:
 *
\****************************************************************/
VOID DestroyHelpInstance(VOID)
{

    if(hwndHelpInstance != NULLHANDLE)	{
	WinDestroyHelpInstance(hwndHelpInstance);
    }

}   /* DestroyHelpInstance() */


/****************************************************************\
 *  Dialog procedure for the About dialog box
 *--------------------------------------------------------------
 *
 *  Name:   AboutBoxDlgProc(hwnd, msg, mp1, mp2)
 *
 *  Purpose: Processes all messages sent to the About Box
 *
 *  Usage:  Called for each message sent to the About Box
 *	    dialog box.
 *
 *  Method: the about box only has a button control so this
 *	    routine only processes WM_COMMAND messages.	 Any
 *	    WM_COMMAND posted must have come from the Ok
 *	    button so we dismiss the dialog upon receiving it.
 *
 *  Returns: Dependent upon message sent
 *
\****************************************************************/
MRESULT EXPENTRY AboutBoxDlgProc(HWND	hwnd,	 /* handle of window */
				 ULONG	msg,	 /* id of message */
				 MPARAM mp1,	 /* first message parameter */
				 MPARAM mp2)	 /* second message parameter */
{
   switch(msg)
   {
      case WM_COMMAND:
	 /* no matter what the command, close the dialog */
	 WinDismissDlg(hwnd, TRUE);
	 break;

      default:
	 return(WinDefDlgProc(hwnd, msg, mp1, mp2));
	 break;
   }

   return (MRFROMLONG(0));

}   /* AboutBoxWndProc() */
/*==============================================================*\
 *
 *  cliqmain.c - sample queue application main source file
 *	Copyright 1992, IBM Corp.
 *
 *--------------------------------------------------------------
 *
 *  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *  sample code created by IBM Corporation. This sample code is not
 *  part of any standard or IBM product and is provided to you solely
 *  for	 the purpose of assisting you in the development of your
 *  applications.  The code is provided "AS IS", without
 *  warranty of any kind.  IBM shall not be liable for any damages
 *  arising out of your use of the sample code, even if they have been
 *  advised of the possibility of   such damages.
 *
 *--------------------------------------------------------------
 *
 *  This file contains the source for the main thread
 *  which services the PM message queue.
 *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/




#define INCL_WINHELP
#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#define INCL_DOSQUEUES
#define INCL_GPILCIDS
#define INCL_WIN

#include <os2.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "cliqmain.h"
#include "queue.h"
#include "cliqxtrn.h"
#include "cliqhelp.h"


#define	 ENTRY_STRING	  "Queue Message"
#define	 PRIORITY_STRING  "Message Priority"
#define	 DAY_STRING	  "Day"
#define	 MONTH_STRING	  "Month"
#define	 YEAR_STRING	  "Year"

#define	 ENTRY_LEN     14
#define	 PRIORITY_LEN  17
#define	 DAY_LEN	4
#define	 MONTH_LEN	6
#define	 YEAR_LEN	5


/*--------------------------------------------------------------*\
 *  Global variables
\*--------------------------------------------------------------*/

HWND   hwndMainFrame = NULLHANDLE;    /* handle to the main frame window */
HWND   hwndMain;		      /* handle to the main client window */
HAB    hab;			      /* anchor block for the process */
HMQ    hmq;			      /* handle to the process' message queue */
CHAR   szAppName[MAXNAMEL];	      /* buffer for application name string */
BOOL   fHelpEnabled;		      /* flag to determine if help is enabled */
HQUEUE hqQ;
LONG   cxChar, cyChar;
RECTL  rcl;
int    index;

BOOL	     fThrdsDead=FALSE;
HEV	     hevSend;
CHAR	     pszMessage[MESSAGE_LEN];
ULONG	     ulMsgSize, ulMsgType;
USHORT	     usPriority;
Q_DATE	     qdDate;
PVOID	     pvdQMsg;
THREADPARAM  tpThrdParm;


/****************************************************************\
 *  Main routine
 *--------------------------------------------------------------
 *
 *  Name:   main()
 *
 *  Purpose: Initializes the PM environment, calls the
 *		initialization routine, creates the main
 *		window,	 and polls the message queue
 *
 *  Usage:
 *
 *  Method:
 *	    - obtains anchor block handle and creates message
 *		queue
 *	    - calls the initialization routine
 *	    - creates the main frame window which creates the
 *		main client window
 *	    - polls the message queue via Get/Dispatch Msg loop
 *	    - upon exiting the loop, exits
 *
 *  Returns:
 *	    0 - if successful execution completed
 *	    1 - if error
\****************************************************************/
INT main()
{
   QMSG qmsg;	       /* message structure */
   int	iTimeout=1000; /* thread exit timeout */

   hab = WinInitialize(0);

   if(!hab)  {
      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      return(RETURN_ERROR);
   }

   hmq = WinCreateMsgQueue(hab, 0);

   if(!hmq)
   {
      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      WinTerminate(hab);
      return(RETURN_ERROR);
   }

   if(!Init())
   {
      if(hwndMainFrame == NULLHANDLE)
      {
	  MessageBox(HWND_DESKTOP,
		     IDMSG_MAINWINCREATEFAILED,
		     0,
		     MB_OK | MB_ERROR,
		     TRUE);
	  return(RETURN_ERROR);
      }

      else
      {
	 MessageBox(HWND_DESKTOP,
		 IDMSG_INITFAILED,
		 0,
		 MB_OK | MB_ERROR,
		 TRUE);
	 if (WinIsWindow(hab, hwndMainFrame))
	 {
	    WinDestroyWindow(hwndMainFrame);
	 }
      }

      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      WinDestroyMsgQueue(hmq);
      WinTerminate(hab);
      return(RETURN_ERROR);
   }

   /* Get-Dispatch Message loop */
   while(WinGetMsg(hab, (PQMSG)&qmsg, NULLHANDLE, 0, 0))
       WinDispatchMsg(hab, (PQMSG)&qmsg);

   /* destroy the help instance */
   DestroyHelpInstance();

   if (WinIsWindow(hab, hwndMainFrame))
   {
      WinDestroyWindow(hwndMainFrame);
   }

   WinDestroyMsgQueue(hmq);

   /* give other thread a chance to exit */
   while (!fThrdsDead && iTimeout--)
   {
      DosSleep(0);
   }

   DosCloseEventSem(hevSend);
   WinTerminate(hab);
   return(RETURN_SUCCESS);
}   /* main() */


/****************************************************************\
 *  Main client window procedure
 *--------------------------------------------------------------
 *
 *  Name:   MainWndProc(hwnd, msg, mp1, mp2)
 *
 *  Purpose: Processes the messages sent to the main client
 *		window.	 This routine processes the basic
 *		messages all client windows should process
 *		and passes all others onto WinDefWindowProc.
 *
 *  Usage:  Called for each message placed in the main
 *	    window's message queue
 *
 *  Method: a switch statement branches to the routines to be
 *	    performed for each message processed.
 *
 *  Returns:  Return values are determined by each message
 *
\****************************************************************/
MRESULT EXPENTRY MainWndProc(HWND   hwnd,    /* handle of window */
			     ULONG  msg,     /* id of message */
			     MPARAM mp1,     /* first message parameter */
			     MPARAM mp2)     /* second message parameter */
{
   HPS	  hps;
   FONTMETRICS	 fm;
   static POINTL ptl;

   switch(msg)
   {
      case WM_CREATE:
	 hps = WinGetPS(hwnd);
	 GpiQueryFontMetrics(hps, (LONG) sizeof fm, &fm);
	 WinReleasePS(hps);
	 cyChar = fm.lMaxBaselineExt;
	 cxChar = fm.lAveCharWidth;
	 rcl.yTop = 0;
	 break;

      case WM_PAINT:
	 if (0 == rcl.yTop)
	 {
	    WinQueryWindowRect(hwndMain, &rcl);
	 }
	 ptl.y = (4.0/5.0 * rcl.yTop + 1.0/2.0 * cxChar);
	 ptl.x = 4 * cxChar;
	 hps = WinBeginPaint(hwnd, NULLHANDLE, NULL);
	 GpiErase(hps);
	 GpiCharStringAt(hps, &ptl, ENTRY_LEN, ENTRY_STRING);

	 ptl.y = ((2.0/5.0) * rcl.yTop + cxChar);
	 GpiCharStringAt(hps, &ptl, PRIORITY_LEN, PRIORITY_STRING);

	 ptl.y = (3.0/5.0 * rcl.yTop + 1.0/2.0 * cxChar);
	 ptl.x = 1.0/4.0 * rcl.xRight - (DAY_LEN+1) * cxChar;
	 GpiCharStringAt(hps, &ptl, DAY_LEN, DAY_STRING);

	 ptl.y = (3.0/5.0 * rcl.yTop + 1.0/2.0 * cxChar);
	 ptl.x = 2.0/4.0 * rcl.xRight - (MONTH_LEN+1) * cxChar;
	 GpiCharStringAt(hps, &ptl, MONTH_LEN, MONTH_STRING);

	 ptl.y = (3.0/5.0 * rcl.yTop + 1.0/2.0 * cxChar);
	 ptl.x = 3.0/4.0 * rcl.xRight - (YEAR_LEN+1) * cxChar;
	 GpiCharStringAt(hps, &ptl, YEAR_LEN, YEAR_STRING);
	 WinEndPaint(hps);
	 break;

      case WM_COMMAND:
	  MainCommand(mp1, mp2);
	  break;

      case WM_MSG:
	 MessageBox(hwndMain,
		    (ULONG)SHORT1FROMMP(mp1),
		    LONGFROMMP(mp2),
		    MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL,
		    TRUE);
	 break;

      case HM_QUERY_KEYS_HELP:
	  return (MRESULT)PANEL_HELPKEYS;
	  break ;

      case WM_CLOSE:
	 /* send thread a closure message */
	 usPriority = 99;
	 DosPostEventSem(hevSend);

      default:
	 return(WinDefWindowProc(hwnd, msg, mp1, mp2));
	 break;
   }

   return (MRFROMLONG(0));	/* all window procedures should return 0 as a default */

}   /* MainWndProc() */


/****************************************************************\
 *  Message Box procedure
 *--------------------------------------------------------------
 *
 *  Name:   MessageBox(hwndOwner, nIdMsg, fsStyle, fBeep)
 *
 *  Purpose: Displays the message box with the message
 *		given in idMsg retrieved from the message table
 *		and using the style flags in fsStyle
 *
 *  Usage:  Called whenever a MessageBox is to be displayed
 *
 *  Method: - Message string is loaded from the process'
 *		message table
 *	    - Alarm beep is sounded if desired
 *	    - Message box with the message is displayed
 *	    - WinMessageBox return value is returned
 *
 *  Returns: return value from WinMessageBox()
 *
\****************************************************************/

ULONG MessageBox(HWND  hwndOwner,  /* handle of the message box's owner */
		 ULONG idMsg,	   /* id if the message in the message table */
		 LONG  lRC,	   /* return code of failing function */
		 ULONG fsStyle,	   /* style of the message box */
		 BOOL  fBeep)	   /* if TRUE, beep before message box is displayed */
{
   CHAR szText[TITLE_LEN];

   if(!WinLoadMessage(hab,
		    (HMODULE)NULL,
		    idMsg,
		    TITLE_LEN,
		    (PSZ)szText))
   {
      WinAlarm(HWND_DESKTOP, WA_ERROR);
      return MBID_ERROR;
   }

   if (lRC)
   {
      sprintf(szText, "%s\n rc = %lu", szText, lRC);
   }

   if(fBeep)  {
      WinAlarm(HWND_DESKTOP, WA_ERROR);
   }

   return(WinMessageBox(HWND_DESKTOP,
			hwndOwner,
			szText,
			(PSZ)NULL,
			MSGBOXID,
			fsStyle));

}   /* MessageBox() */


/****************************************************************\
 *  Main window WM_COMMAND processing procedure
 *--------------------------------------------------------------
 *
 *  Name:   MainCommand(mp1, mp2)
 *
 *  Purpose: Calls the appropriate procedures that deal with
 *		the selected menu item.
 *
 *  Usage:  Routine is called whenever a WM_COMMAND message
 *	    is posted to the main window.
 *
 *  Method: a switch statement branches on the id of the
 *	    menu item that posted the message and the
 *	    appropriate action for that item is taken.
 *
 *  Returns:
 *
\****************************************************************/
VOID MainCommand(MPARAM mp1, MPARAM mp2)
{
   ULONG  ulPosts;

   switch(SHORT1FROMMP(mp1))
   {
      case IDM_FILEEXIT:
	 usPriority = 99;
	 DosPostEventSem(hevSend);
	 FileExit();
	 break;

      case WID_SEND_DATE:
	 /* still waiting to send last message? */
	 DosQueryEventSem(hevSend, &ulPosts);

	 if (0 == ulPosts)
	 {
	    /* message type */
	    ulMsgType = Q_MSG_DATE;
	    pvdQMsg = (VOID *)&qdDate;

	    /* get date */
	    WinSendMsg(WinWindowFromID(hwndMain, WID_DAY),
		       SPBM_QUERYVALUE,
		       (MPARAM)&(qdDate.usDay),
		       MPFROM2SHORT(NULL, SPBQ_ALWAYSUPDATE));

	    WinSendMsg(WinWindowFromID(hwndMain, WID_MONTH),
		       SPBM_QUERYVALUE,
		       (MPARAM)&(qdDate.usMonth),
		       MPFROM2SHORT(NULL, SPBQ_ALWAYSUPDATE));

	    WinSendMsg(WinWindowFromID(hwndMain, WID_YEAR),
		       SPBM_QUERYVALUE,
		       (MPARAM)&(qdDate.usYear),
		       MPFROM2SHORT(NULL, SPBQ_ALWAYSUPDATE));

	    /* message size */
	    ulMsgSize = sizeof(Q_DATE);

	    /* get priority from spinbutton */
	    WinSendMsg(WinWindowFromID(hwndMain, WID_Q_PRIORITY),
		       SPBM_QUERYVALUE,
		       (MPARAM)&usPriority,
		       MPFROM2SHORT(NULL, SPBQ_ALWAYSUPDATE));

	    /* post message */
	    DosPostEventSem(hevSend);
	 }

	 else
	 {
	    /* didn't post message */
	    DosBeep(100,100);
	 }
	 break;

      case WID_SEND_MSG:
	 /* still waiting to send last message? */
	 DosQueryEventSem(hevSend, &ulPosts);

	 if (0 == ulPosts)
	 {
	    /* message type */
	    ulMsgType = Q_MSG_TEXT;
	    pvdQMsg = (VOID *)pszMessage;

	    /* get text */
	    WinQueryWindowText(WinWindowFromID(hwndMain, WID_Q_MSG), MESSAGE_LEN, pszMessage);

	    /* message size */
	    ulMsgSize = strlen(pszMessage) + 1;

	    /* get priority from spinbutton */
	    WinSendMsg(WinWindowFromID(hwndMain, WID_Q_PRIORITY),
		       SPBM_QUERYVALUE,
		       (MPARAM)&usPriority,
		       MPFROM2SHORT(NULL, SPBQ_ALWAYSUPDATE));

	    /* post message */
	    DosPostEventSem(hevSend);
	 }

	 else
	 {
	    /* didn't post message */
	    DosBeep(100,100);
	 }
	 break;

      case IDM_HELPHELPFORHELP:
	 HelpHelpForHelp(mp2);
	 break;

      case IDM_HELPEXTENDED:
	 HelpExtended(mp2);
	 break;

      case IDM_HELPKEYS:
	 HelpKeys(mp2);
	 break;

      case IDM_HELPINDEX:
	 HelpIndex(mp2);
	 break;

      case IDM_HELPTUTORIAL:
	 HelpTutorial(mp2);
	 break;

      case IDM_HELPABOUT:
	 HelpAbout(mp2);
	 break;

      default:
	 break;
   }
}   /* MainCommand() */


/****************************************************************\
 *  Initialization routine
 *--------------------------------------------------------------
 *
 *  Name:   Init()
 *
 *  Purpose: Performs initialization functions required
 *		before the application can be executed.
 *
 *  Usage:  Called once before the message queue is serviced.
 *
 *  Method:
 *	    - registers all window classes.
 *	    - initializes processing thread.
 *
 *  Returns:
 *	    TRUE - initialization is successful
 *	    FALSE - initialization failed
\****************************************************************/
BOOL Init()
{
   ULONG  flCtlData;	/* frame control data */
   LONG	  xLeft;
   HWND	  hwndSpin;
   static USHORT  ausPriority[] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15};

   /* load application name from resource file */
   if(!WinLoadString(hab, 0, IDS_APPNAME, MAXNAMEL, szAppName))
   {
      return FALSE;
   }

   /* register the main client window class */
   if(!WinRegisterClass(hab,
		       (PSZ)szAppName,
		       MainWndProc,
		       CS_SIZEREDRAW | CS_CLIPCHILDREN,
		       0))
   {
      return FALSE;
   }

   /* create the main window */
   flCtlData = FCF_TITLEBAR | FCF_SYSMENU | FCF_MENU |
	       FCF_MINMAX | FCF_ICON | FCF_BORDER | FCF_ACCELTABLE |
	       FCF_ICON | FCF_SHELLPOSITION | FCF_TASKLIST;

   if (NULLHANDLE == (hwndMainFrame = WinCreateStdWindow(HWND_DESKTOP,
							WS_VISIBLE,
							(PULONG)&flCtlData,
							(PSZ)szAppName,
							NULL,
							WS_VISIBLE,
							(HMODULE)NULL,
							IDR_MAIN,
							&hwndMain)))
   {
      return (FALSE);
   }

   WinSetWindowText(hwndMainFrame, szAppName);

   if (DosCreateEventSem(NULL, &hevSend, DC_SEM_SHARED, FALSE))
   {
      return (FALSE);
   }

   if (0 == rcl.yTop)
   {
      WinQueryWindowRect(hwndMain, &rcl);
   }
   xLeft = rcl.xRight/5;
   xLeft = max(xLeft, (cxChar * (ENTRY_LEN + 7)));
   xLeft = max(xLeft, (cxChar * (PRIORITY_LEN + 7)));

   if (!InitQThrd(hevSend, &pvdQMsg, &usPriority, &ulMsgSize, &ulMsgType))
   {
      DosCloseEventSem(hevSend);
      return(FALSE);
   }

   WinCreateWindow(hwndMain,
		   WC_ENTRYFIELD,
		   "Queue Message",
		   (WS_VISIBLE | ES_MARGIN | WS_TABSTOP),
		   xLeft,
		   ((4.0/5.0) * rcl.yTop),
		   ((rcl.xRight)-xLeft-(4)*cxChar),
		   (cyChar+ 2),
		   hwndMain,
		   HWND_BOTTOM,
		   WID_Q_MSG,
		   NULL,
		   NULL);

   hwndSpin = WinCreateWindow(hwndMain,
			      WC_SPINBUTTON,
			      "Priority",
			      (ULONG)(WS_VISIBLE | SPBS_MASTER | SPBS_NUMERICONLY | SPBS_JUSTRIGHT | WS_TABSTOP),
			      xLeft,
			      ((2.0/5.0) * rcl.yTop),
			      (cxChar*10),
			      (cyChar+2),
			      hwndMain,
			      HWND_BOTTOM,
			      WID_Q_PRIORITY,
			      NULL,
			      NULL);

   WinSendMsg(hwndSpin, SPBM_SETLIMITS, MPFROMLONG(15), MPFROMLONG(0));

   hwndSpin = WinCreateWindow(hwndMain,
			      WC_SPINBUTTON,
			      "Day",
			      (WS_VISIBLE | SPBS_MASTER | SPBS_NUMERICONLY | SPBS_JUSTRIGHT | WS_TABSTOP),
			      (1.0/4.0 * rcl.xRight),
			      ((3.0/5.0) * rcl.yTop),
			      (cxChar*10),
			      (cyChar+2),
			      hwndMain,
			      HWND_BOTTOM,
			      WID_DAY,
			      NULL,
			      NULL);

   WinSendMsg(hwndSpin, SPBM_SETLIMITS, MPFROMLONG(31), MPFROMLONG(1));

   hwndSpin = WinCreateWindow(hwndMain,
			      WC_SPINBUTTON,
			      "Month",
			      (ULONG)(WS_VISIBLE | SPBS_MASTER | SPBS_NUMERICONLY | SPBS_JUSTRIGHT | WS_TABSTOP),
			      (2.0/4.0 * rcl.xRight),
			      ((3.0/5.0) * rcl.yTop),
			      (cxChar*10),
			      (cyChar+2),
			      hwndMain,
			      HWND_BOTTOM,
			      WID_MONTH,
			      NULL,
			      NULL);

   WinSendMsg(hwndSpin, SPBM_SETLIMITS, MPFROMLONG(12), MPFROMLONG(1));

   hwndSpin = WinCreateWindow(hwndMain,
			      WC_SPINBUTTON,
			      "Year",
			      (WS_VISIBLE | SPBS_MASTER | SPBS_NUMERICONLY | SPBS_JUSTRIGHT | WS_TABSTOP),
			      (3.0/4.0 * rcl.xRight),
			      ((3.0/5.0) * rcl.yTop),
			      (cxChar*10),
			      (cyChar+2),
			      hwndMain,
			      HWND_BOTTOM,
			      WID_YEAR,
			      NULL,
			      NULL);

   WinSendMsg(hwndSpin, SPBM_SETLIMITS, MPFROMLONG(2000), MPFROMLONG(1900));

   WinCreateWindow(hwndMain,
		   WC_BUTTON,
		   "Send Msg",
		   (WS_VISIBLE | BS_PUSHBUTTON | WS_TABSTOP),
		   ((SHORT)(rcl.xRight/(LONG)3) - cxChar*(SHORT)8),
		   (rcl.yTop / 6),
		   (cxChar*16),
		   (2*cyChar),
		   hwndMain,
		   HWND_BOTTOM,
		   WID_SEND_MSG,
		   NULL, NULL);

   WinCreateWindow(hwndMain,
		   WC_BUTTON,
		   "Send Date",
		   (WS_VISIBLE | BS_PUSHBUTTON | WS_TABSTOP),
		   ((2*rcl.xRight/3) - cxChar*9),
		   (rcl.yTop / 6),
		   (cxChar*18),
		   (2*cyChar),
		   hwndMain,
		   HWND_BOTTOM,
		   WID_SEND_DATE,
		   NULL, NULL);

   InitHelp();

   return (TRUE);

}  /* Init() */


/****************************************************************\
 *  Exit routine
 *--------------------------------------------------------------
 *
 *  Name:   FileExit(mp2)
 *
 *  Purpose: Processes the File menu's Exit item.
 *
 *  Usage:  called whenever Exit from the file menu is
 *	    selected
 *
 *  Method:  Routine posts a WM_CLOSE message to the main
 *	     application window.
 *
 *  Returns:
 *
\****************************************************************/
VOID FileExit()
{

   WinPostMsg(hwndMain, WM_CLOSE, MPVOID, MPVOID);

}   /* FileExit() */

/*==============================================================*\
 *
 *  cliqthrd.c - thread source
 *	Copyright 1992, IBM Corp.
 *
 *--------------------------------------------------------------
 *
 *  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *  sample code created by IBM Corporation. This sample code is not
 *  part of any standard or IBM product and is provided to you solely
 *  for	 the purpose of assisting you in the development of your
 *  applications.  The code is provided "AS IS", without
 *  warranty of any kind.  IBM shall not be liable for any damages
 *  arising out of your use of the sample code, even if they have been
 *  advised of the possibility of   such damages.
 *
 *--------------------------------------------------------------
 *
 *
 *  This file contains the source for the thread initialization
 *  and the source for the thread that services the queue.
 *
\*==============================================================*/


#define INCL_DOSPROCESS
#define INCL_DOSQUEUES
#define INCL_DOSMEMMGR
#define INCL_WINMESSAGEMGR
#define INCL_DOSERRORS
#define INCL_DOSSEMAPHORES

#include <os2.h>


#include <stdlib.h>
#include <stddef.h>
#include <string.h>

#include "cliqmain.h"
#include "queue.h"
#include "cliqglbl.h"
#include "cliqxtrn.h"


#define	 STACKSIZE	8192
#define	 Q_BUFFER_SIZE	4000


PID	     pidServer;
HQUEUE	     hqQueue;
PVOID	     *pvdQMemory;


BOOL InitQThrd(HEV hevSend, PVOID *ppvdMessage, PUSHORT pusPriority, PULONG pulMsgSize, PULONG pulMsgType)
{
   APIRET	       apiRC;
   BOOL		       fSuccess = TRUE;
   static THREADPARAM  tpThrdParm;

   if (ERROR_QUE_NAME_NOT_EXIST == (apiRC=DosOpenQueue(&pidServer,
						       &hqQueue,
						       "\\queues\\" Q_NAME)))
   {
      MessageBox(HWND_DESKTOP,
		 IDMSG_SVR_DOWN,
		 apiRC,
		 MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL,
		 TRUE);
      fSuccess = FALSE;
   }

   else if (0 != apiRC)
   {
      MessageBox(hwndMain,
		 IDMSG_Q_ERR,
		 apiRC,
		 MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL,
		 TRUE);
      fSuccess = FALSE;
   }

   else
   {
      if (apiRC=DosAllocSharedMem((VOID **)&pvdQMemory,
			    NULL,
			    (ULONG)Q_BUFFER_SIZE,
			    fALLOCSHR))
   /* fALLOC is equivalent to PAG_READ | PAG_WRITE | PAG_COMMIT | PAG_EXECUTE | OBJ_TILE
    * OBJ_TILE is necessary when allocating named shared memory
    */
      {
	MessageBox(hwndMain,
		   IDMSG_MEM_ERR,
		   apiRC,
		   MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL,
		   TRUE);
	fSuccess = FALSE;
      }

      else if (apiRC=DosSubSetMem(pvdQMemory, DOSSUB_INIT, (ULONG)Q_BUFFER_SIZE))
      {
	MessageBox(hwndMain,
		   IDMSG_SUBALLOC_MEM_ERR,
		   apiRC,
		   MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL,
		   TRUE);
	fSuccess = FALSE;
      }

      /* give memory to server */
      else if (apiRC=DosGiveSharedMem(pvdQMemory, pidServer, PAG_READ | PAG_WRITE))
      {
	MessageBox(hwndMain,
		   IDMSG_GIVE_MEM_ERR,
		   apiRC,
		   MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL,
		   TRUE);
	fSuccess = FALSE;
      }

      else
      {
	 tpThrdParm.hevSend = hevSend;		/* posted when user elects to send message */
	 tpThrdParm.ppvdMessage = ppvdMessage;	/* message to be sent */
	 tpThrdParm.pusPriority = pusPriority;	/* priority of said message */
	 tpThrdParm.pulMsgSize = pulMsgSize;	/* size of message */
	 tpThrdParm.pulMsgType = pulMsgType;	/* size of message */


	 if (0 > _beginthread(PostQMessage,
			      NULL,
			      STACKSIZE,
			      (VOID *)&tpThrdParm))
	 {
	    fSuccess = FALSE;
	 }
      }

      if (!fSuccess)
      {
	 DosCloseQueue(hqQueue);
      }
   }

   return (fSuccess);
}


VOID PostQMessage(VOID *tpThrdParm)
{
   VOID	   *pqmsg;
   APIRET  apiRC;

   while (!DosWaitEventSem(((THREADPARAM *)tpThrdParm)->hevSend, SEM_INDEFINITE_WAIT))
   {
      if (15 < *(((THREADPARAM *)tpThrdParm)->pusPriority))  /* exit notification */
      {
	 break;
      }

      if (TRUE == fSetUpMessage(*(THREADPARAM *)tpThrdParm, &pqmsg))
      {
	 if (0 != (apiRC=DosWriteQueue(hqQueue,
				*(((THREADPARAM *)tpThrdParm)->pulMsgType),
				*(((THREADPARAM *)tpThrdParm)->pulMsgSize),
				(VOID *)pqmsg,
				*(((THREADPARAM *)tpThrdParm)->pusPriority))))
	 {
	    WinPostMsg(hwndMain, WM_MSG, MPFROMLONG(IDMSG_SVR_DOWN), MPFROMLONG(apiRC));
	 }
      }
   }

   DosCloseQueue(hqQueue);
   DosFreeMem(pvdQMemory);
   fThrdsDead = TRUE;
}


BOOL fSetUpMessage(THREADPARAM tpThrdParm, PVOID *pqmsg)
{
   BOOL	   fSuccess = FALSE;
   APIRET  apiRC;
   ULONG   ulPosts;

   if (apiRC=DosSubAllocMem(pvdQMemory, pqmsg, *tpThrdParm.pulMsgSize))
   {
      WinPostMsg(hwndMain, WM_MSG, MPFROMLONG(IDMSG_MEM_FULL), MPFROMLONG(apiRC));
   }

   else
   {
      if (memcpy(*pqmsg, *tpThrdParm.ppvdMessage, *tpThrdParm.pulMsgSize))
      {
	 fSuccess = TRUE;
      }
   }

   DosResetEventSem(tpThrdParm.hevSend, &ulPosts);
   return (fSuccess);
}
/*static char *SCCSID = "@(#)clkdata.c  6.5 92/02/18";*/
/*=========================================================================\
 *									   *
 *	 FILE:clkdata.c							   *
 *									   *
 *	 DESCRIPTION:	 Presentation Manager Alarm Clock Application	   *
 *									   *
 *									   *
 *									   *
 *	Copyright 1989, 1990, 1992 IBM Corp.				   *
 *									   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have been *
 *	advised of the possibility of	such damages.			   *
 *									   *
 *-------------------------------------------------------------------------*
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *--------------------------------------------------------------
 *
 *  This source file contains no functional code, but is used
 *  to include global data variable for various modules of the
 *  sample clock program
 *
 *
 *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/
#define INCL_PM
#define INCL_DOSSEMAPHORES
#define INCL_DOSDATETIME


#include <os2.h>
#include <string.h>
#include "clock.h"
#include "res.h"




/*--------------------------------------------------------------*\
 *  Global variables
\*--------------------------------------------------------------*/
HWND hwndFrame;
HWND hwndTitleBar;
HWND hwndSysMenu;
HWND hwndMinMax;
HWND hwndMenu;
HAB  hab;
HMQ  hmq;
HSWITCH hsw;
BOOL fStartAsIcon = FALSE;
BOOL fHelpEnabled = FALSE;

CLOCKPREF cp;
HWND hwndHelpInstance;


SHORT	   Selected = NOSELECT;	    /* currently hilited and selected field */
SHORT	   PreviousSelected;	    /* previously hilited and selected field */

UCHAR	   lastSecondDrawn = -1;


BOOL bLeadingZero;		    /* pad date/time with zero */
BOOL bIsIconic = FALSE;


WRECT rDateTime[6];		   /* placement of time and date matters */
WRECT rAlarmTime[3];		   /* placement of time and date matters */
WRECT rRepaintTime;		   /* repaint time region */
WRECT rDateAssign[3];		   /* holds date locs, so can quickly
				      reassign rDateTime[MONTH-YEAR]
				      to diff date formats */
SHORT sFirstTime;		   /* first field in time */
SHORT sFirstDate;		   /* first field in date */
SHORT asLeftOf[6];		   /* for inc/dec inclds wrapping */
SHORT asRightOf[6];		   /* for inc/dec inclds wrapping */
SHORT wDateTime[6];		   /* values for first 6 date/time items */
SHORT wModulos[3] =		   /* highest value for each; actually mod n+ 1 */
      { 23,59,59 };
SHORT wPrevDateTime[6];		   /* only repaint fields if nec */

HWND  hDate, hTime;		   /* handle to group boxes (for focus) */
HWND  hDateScroll;
HWND  hTimeScroll;
HWND  hCurrentFocus;		   /* control with current focus */
HWND  hDateTime;
HWND  hAlarmTime;

BOOL bTwelveHourFormat;		   /* 12 hr. versus military */
WRECT rTimeSep[3];		   /* posn of time separator strings and AM/PM */
CHAR  szTimeSep[TIME_SEP_LEN+1];     /* time separator string */
CHAR  szAnteMeridian[STRING_AM_LEN+1]; /* AM/PM */
CHAR  szPostMeridian[STRING_PM_LEN+1];
CHAR  szTitle [81];
CHAR  szErrClocks[PATHMAX+1];

WRECT rDateSep[2];		   /* posn of date separator strings */
CHAR  szDateSep[DATE_SEP_LEN+1];   /* date separator string */
BOOL fTimeFreez = FALSE;
BOOL fDateFreez = FALSE;
USHORT vusDateFormat;
MATRIXLF vmatlfDateTrans = {
     MAKEFIXED ( 1 , 0 ) ,	 MAKEFIXED ( 0 , 0 ) ,	     0L ,
     MAKEFIXED ( 0 , 0 ) ,	 MAKEFIXED ( 1 , 0 ) ,	     0L ,
     0L ,		       0L ,			 1L } ;
MATRIXLF vmatlfDateScale  = {
     MAKEFIXED ( 1 , 0 ) ,	 MAKEFIXED ( 0 , 0 ) ,	     0L ,
     MAKEFIXED ( 0 , 0 ) ,	 MAKEFIXED ( 1 , 0 ) ,	     0L ,
     0L ,		       0L ,			 1L } ;

SWP swp;
HPS hps;
HDC hdc;
RECTL rclPage;
DATETIME dt;
BOOL f;
BOOL fIconic, fShowSecondHand;
SIZEL sizl = { 200 , 200 };
ULONG cxRes , cyRes;
char achOldTime[9];
char achAmPm[3];
char achOldAmPm[3];
char achOldDate[9];
HPS hpsWnd;
LONG cxScreen , cyScreen;	   /* screen dimensions */
LONG vclrBG[3];
LONG vclrFace[3];
LONG vclrRing[3];
LONG vclrHands[3];
LONG vclrMajorTicks[3];
LONG vclrMinorTicks[3];
LONG vclrDate[4];
USHORT vusDatePos;
BOOL vbInAlarm;
PFNWP pfnwpEntryField;
HWND hwndEntryField;

HWND hwndClient;
HPS hpsBuffer;
HDC hdcBuffer;
BOOL fBufferDirty = FALSE;

ULONG cColorPlanes, cColorBitcount;
BOOL fEndThread = FALSE;
TIMER_RESOURCES TimerResources;

/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/



/*==============================================================*\
 *  Clnphelp.c - routines for the help manager interface
 *	Copyright 1992 IBM Corp.
 *--------------------------------------------------------------
 *
 *  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *  sample code created by IBM Corporation. This sample code is not
 *  part of any standard or IBM product and is provided to you solely
 *  for	 the purpose of assisting you in the development of your
 *  applications.  The code is provided "AS IS", without
 *  warranty of any kind.  IBM shall not be liable for any damages
 *  arising out of your use of the sample code, even if they have been
 *  advised of the possibility of   such damages.						      *
 *
 *--------------------------------------------------------------
 *
 *  This module contains all the routines for interfacing with
 *  the IPF help manager.
 *
 *--------------------------------------------------------------
 *
 *  This source file contains the following functions:
 *
 *	    InitHelp()
 *	    HelpHelpForHelp(mp2)
 *	    HelpExtended(mp2)
 *	    HelpKeys(mp2)
 *	    HelpIndex(mp2)
 *	    HelpTutorial(mp2)
 *	    HelpAbout(mp2)
 *	    DisplayHelpPanel(idPanel)
 *	    DestroyHelpInstance()
 *
\*==============================================================*/



/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/

#define	 INCL_WINHELP

#include <os2.h>
#include <string.h>
#include "clnpmain.h"
#include "clnphelp.h"
#include "clnpxtrn.h"
#include "clnpglbl.h"

#define HELPLIBRARYNAMELEN  20

/* If DEBUG is defined, then the help panels will display their
 *  id values on their title bar.  This is useful for determining
 *  which help panels are being shown for each dialog item.  When
 *  the DEBUG directive is not defined, then the panel ids are not
 *  displayed.
 */

/* #define  DEBUG */


/*--------------------------------------------------------------*\
 *  Global variables
\*--------------------------------------------------------------*/
static HWND hwndHelpInstance;
static CHAR szLibName[HELPLIBRARYNAMELEN];
static CHAR szWindowTitle[HELPLIBRARYNAMELEN];


/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/
MRESULT EXPENTRY AboutBoxDlgProc(HWND	hwnd,
				 ULONG	msg,
				 MPARAM mp1,
				 MPARAM mp2);



/****************************************************************\
 *  Routine for initializing the help manager
 *--------------------------------------------------------------
 *
 *  Name:   InitHelp()
 *
 *  Purpose: Initializes the IPF help facility
 *
 *  Usage:  Called once during initialization of the program
 *
 *  Method: Initializes the HELPINIT structure and creates the
 *	    help instance.  If successful, the help instance
 *	    is associated with the main window
 *
 *  Returns:
 *
\****************************************************************/
VOID InitHelp(VOID)
{
   HELPINIT hini;

   /* if we return because of an error, Help will be disabled */
   fHelpEnabled = FALSE;

   /* initialize help init structure */
   hini.cb = sizeof(HELPINIT);
   hini.ulReturnCode = 0L;

   hini.pszTutorialName = (PSZ)NULL;   /* if tutorial added, add name here */

   hini.phtHelpTable = (PHELPTABLE)MAKELONG(CLIP_HELP_TABLE, 0xFFFF);
   hini.hmodHelpTableModule = 0L;
   hini.hmodAccelActionBarModule = 0L;
   hini.idAccelTable = 0;
   hini.idActionBar = 0;

   if(!WinLoadString(hab,
		     0,
		     IDS_HELPWINDOWTITLE,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szWindowTitle))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, 0, MB_OK | MB_ERROR, NULL, FALSE);
      return;
   }

   hini.pszHelpWindowTitle = (PSZ)szWindowTitle;

   /* if debugging, show panel ids, else don't */
#ifdef DEBUG
    hini.fShowPanelId = CMIC_SHOW_PANEL_ID;
#else
    hini.fShowPanelId = CMIC_HIDE_PANEL_ID;
#endif

   if(!WinLoadString(hab,
		     0,
		     IDS_HELPLIBRARYNAME,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szLibName))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, 0, MB_OK | MB_ERROR, NULL, FALSE);
      return;
   }

   hini.pszHelpLibraryName = (PSZ)szLibName;

   /* creating help instance */
   hwndHelpInstance = WinCreateHelpInstance(hab, &hini);

   if(hwndHelpInstance == NULLHANDLE || hini.ulReturnCode)
   {
      MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, 0, MB_OK | MB_ERROR, NULL, TRUE);
      return;
   }

   /* associate help instance with main frame */
   if(!WinAssociateHelpInstance(hwndHelpInstance, hwndMainFrame))
   {
      MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, 0, MB_OK | MB_ERROR, NULL, TRUE);
      return;
   }

   /* help manager is successfully initialized so set flag to TRUE */
   fHelpEnabled = TRUE;

}  /* InitHelp() */


/****************************************************************\
 *  Processes the Help for Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpHelpForHelp(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Help for Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Help for Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_DISPLAY_HELP message to the help
 *	    instance so that the default Help For Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpHelpForHelp(MPARAM mp2)
{

   /* this just displays the system help for help panel */
   if(fHelpEnabled)
   {
      if(WinSendMsg(hwndHelpInstance, HM_DISPLAY_HELP, MPVOID, MPVOID))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    0,
		    MB_OK | MB_ERROR,
		    NULL,
		    FALSE);
      }
   }
}   /* HelpHelpForHelp() */


/****************************************************************\
 *  Processes the Extended Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpExtended(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Extended Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Extended Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_EXT_HELP message to the help
 *	    instance so that the default Extended Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpExtended(MPARAM mp2)
{

   /* this just displays the system extended help panel */
   if(fHelpEnabled)
   {
      if((BOOL32)WinSendMsg(hwndHelpInstance, HM_EXT_HELP, NULL, NULL))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    0,
		    MB_OK | MB_ERROR,
		    NULL,
		    FALSE);
      }
   }
}   /* HelpExtended() */


/****************************************************************\
 *  Processes the Keys Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpKeys(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Keys Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Keys Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_KEYS_HELP message to the help
 *	    instance so that the default Keys Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpKeys(MPARAM mp2)
{

   /* this just displays the system keys help panel */
   if(fHelpEnabled)
   {
      if(WinSendMsg(hwndHelpInstance, HM_KEYS_HELP, MPVOID, MPVOID))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    0,
		    MB_OK | MB_ERROR,
		    NULL,
		    FALSE);
      }
   }
}   /* HelpKeys() */


/****************************************************************\
 *  Processes the Index Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpIndex(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Index Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Index Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_INDEX_HELP message to the help
 *	    instance so that the default Index Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpIndex(MPARAM mp2)
{

   /* this just displays the system help index panel */
   if(fHelpEnabled)
   {
      if(WinSendMsg(hwndHelpInstance, HM_HELP_INDEX, MPVOID, MPVOID))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    0,
		    MB_OK | MB_ERROR,
		    NULL,
		    FALSE);
      }
   }
}   /* HelpIndex() */


/****************************************************************\
 *  Processes the Tutorial Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpTutorial(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Tutorial Help item of the Help menu.  While the
 *	      standard template application does not include a
 *	      Tutorial menu item, you can add one if your
 *	      application has a tutorial.
 *
 *  Usage:  Called from MainCommand when the Tutorial Help
 *	    menu item is selected
 *
 *  Method:
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpTutorial(MPARAM mp2)
{

   /*--------------------------------------------------------------*\
    *  Insert code for any tutorial here
   \*--------------------------------------------------------------*/

}   /* HelpTutorial() */


/****************************************************************\
 *  Processes the About command from the Help menu
 *--------------------------------------------------------------
 *
 *  Name:   HelpAbout(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      About item of the Help menu
 *
 *  Usage:  Called from MainCommand when the About
 *	    menu item is selected
 *
 *  Method: Calls WinDlgBox to display the about box dialog.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpAbout(MPARAM mp2)
{

   /* display the AboutBox dialog */
   WinDlgBox(HWND_DESKTOP,
	     hwndMainFrame,
	     AboutBoxDlgProc,
	     0,
	     IDD_ABOUTBOX,
	     (PVOID)NULL);
}   /* HelpAbout() */


/****************************************************************\
 *  Displays the help panel indicated
 *--------------------------------------------------------------
 *
 *  Name:   DisplayHelpPanel(idPanel)
 *
 *  Purpose: Displays the help panel whose id is given
 *
 *  Usage:  Called whenever a help panel is desired to be
 *	    displayed, usually from the WM_HELP processing
 *	    of the dialog boxes
 *
 *  Method: Sends HM_DISPLAY_HELP message to the help instance
 *
 *  Returns:
 *
\****************************************************************/
VOID DisplayHelpPanel(SHORT idPanel)  /* ID of the help panel to be displayed */
{

   if(fHelpEnabled)
   {
      if(WinSendMsg(hwndHelpInstance,
	    HM_DISPLAY_HELP,
	    MPFROMLONG(MAKELONG(idPanel, NULL)),
	    MPFROMSHORT(HM_RESOURCEID)))
      {
	 MessageBox(hwndMainFrame,
		    IDMSG_HELPDISPLAYERROR,
		    0,
		    MB_OK | MB_ERROR,
		    NULL,
		    TRUE);
      }
   }
}   /* DisplayHelpPanel() */



/****************************************************************\
 *  Destroys the help instance
 *--------------------------------------------------------------
 *
 *  Name:   DestroyHelpInstance(VOID)
 *
 *  Purpose: Destroys the help instance for the application
 *
 *  Usage:  Called after exit from message loop
 *
 *  Method: Calls WinDestroyHelpInstance() to destroy the
 *	    help instance
 *
 *  Returns:
 *
\****************************************************************/
VOID DestroyHelpInstance(VOID)
{

   if(hwndHelpInstance != NULLHANDLE)
   {
      WinDestroyHelpInstance(hwndHelpInstance);
   }
}   /* DestroyHelpInstance() */


/****************************************************************\
 *  Dialog procedure for the About dialog box
 *--------------------------------------------------------------
 *
 *  Name:   AboutBoxDlgProc(hwnd, msg, mp1, mp2)
 *
 *  Purpose: Processes all messages sent to the About Box
 *
 *  Usage:  Called for each message sent to the About Box
 *	    dialog box.
 *
 *  Method: the about box only has a button control so this
 *	    routine only processes WM_COMMAND messages.	 Any
 *	    WM_COMMAND posted must have come from the Ok
 *	    button so we dismiss the dialog upon receiving it.
 *
 *  Returns: Dependent upon message sent
 *
\****************************************************************/
MRESULT EXPENTRY AboutBoxDlgProc(HWND	hwnd,	 /* handle of window */
				 ULONG	msg,	 /* id of message */
				 MPARAM mp1,	 /* first message parameter */
				 MPARAM mp2)	 /* second message parameter */
{
   switch(msg)
   {
      case WM_COMMAND:
	 /* no matter what the command, close the dialog */
	 WinDismissDlg(hwnd, TRUE);
	 break;

      default:
	 return(WinDefDlgProc(hwnd, msg, mp1, mp2));
	 break;
   }

   return (MRFROMLONG(0));

}   /* AboutBoxWndProc() */
/*==============================================================*\
 *  clnpmain.c - Pipe Server end of Tic-Tac-Toe sample app
 *	Copyright 1992 IBM Corp.
 *--------------------------------------------------------------
 *
 *  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *  sample code created by IBM Corporation. This sample code is not
 *  part of any standard or IBM product and is provided to you solely
 *  for	 the purpose of assisting you in the development of your
 *  applications.  The code is provided "AS IS", without
 *  warranty of any kind.  IBM shall not be liable for any damages
 *  arising out of your use of the sample code, even if they have been
 *  advised of the possibility of   such damages.						      *
 *
 *--------------------------------------------------------------
 *
 *  This c file contains the window creation routines and
 *  manages the PM message queue.
 *
\*==============================================================*/



/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/
#define INCL_WINHELP
#define INCL_DOSPROCESS
#define INCL_WINMESSAGEMGR
#define INCL_WINWINDOWMGR
#define INCL_WININPUT
#define INCL_WINDIALOGS
#define INCL_DOSSEMAPHORES
#define INCL_WINFRAMEMGR
#define INCL_WINMENUS

#include <os2.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "clnpmain.h"
#include "clnphelp.h"
#include "clnpxtrn.h"
#include "namepipe.h"

#define	 THRD_EXIT_TIMEOUT  10

/*--------------------------------------------------------------*\
 *  Global variables
\*--------------------------------------------------------------*/

HWND   hwndMainFrame = NULLHANDLE;    /* handle to the main frame window */
HWND   hwndMain;		      /* handle to the main client window */
HWND   hwndMenu;
HAB    hab;			      /* anchor block for the process */
HMQ    hmq;			      /* handle to the process' message queue */
CHAR   szAppName[MAXNAMEL];	      /* buffer for application name string */
BOOL   fHelpEnabled=FALSE;	      /* flag to determine if help is enabled */
BOOL   fAppExit=FALSE;		      /* flag to signal application exit */
BOOL   fMyTurn=FALSE;		      /* flag allowing client to move */
USHORT usWhosX=CLIENT_NUM;	      /* flag denoting who is X piece */
ULONG  ulActiveSquare=0;	      /* window id of selected child */
HEV    hevWritePipe;		      /* event semaphore notifying pipe thread of message */
PIPE_MSG  pmsgPipeMsg;		      /* message to be written to pipe */
BOOL   fThrdsDead=FALSE;	      /* notification of thread exitting */


/****************************************************************\
 *  Main routine
 *--------------------------------------------------------------
 *
 *  Name:   main()
 *
 *  Purpose: Initializes the PM environment, calls the
 *		initialization routine, creates the main
 *		window,	 and polls the message queue
 *
 *  Usage:
 *
 *  Method:
 *	    - obtains anchor block handle and creates message
 *		queue
 *	    - calls the initialization routine
 *	    - creates the main frame window which creates the
 *		main client window
 *	    - polls the message queue via Get/Dispatch Msg loop
 *	    - upon exiting the loop, exits
 *
 *  Returns:
 *	    0 - if successful execution completed
 *	    1 - if error
\****************************************************************/
INT main()
{
   QMSG	  qmsg;		 /* message structure */
   ULONG  ulPosts;

   hab = WinInitialize(0);

   if(!hab)
   {
      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      return(RETURN_ERROR);
   }

   hmq = WinCreateMsgQueue(hab, 0);

   if(!hmq)
   {
      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      WinTerminate(hab);
      return(RETURN_ERROR);
   }

   if(!Init())
   {
      if(hwndMainFrame == NULLHANDLE)
      {
	  MessageBox(HWND_DESKTOP,
		     IDMSG_MAINWINCREATEFAILED,
		     0,
		     MB_OK | MB_ERROR,
		     NULL,
		     TRUE);
      }

      else
      {
	 MessageBox(HWND_DESKTOP,
		    IDMSG_INITFAILED,
		     0,
		    MB_OK | MB_ERROR,
		    NULL,
		    TRUE);

      }
      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      if (WinIsWindow(hab, hwndMainFrame))
      {
	 WinDestroyWindow(hwndMainFrame);
      }
      WinDestroyMsgQueue(hmq);
      WinTerminate(hab);
      return(RETURN_ERROR);
   }

   /* Get-Dispatch Message loop */
   while(WinGetMsg(hab, (PQMSG)&qmsg, NULLHANDLE, 0, 0))
      WinDispatchMsg(hab, (PQMSG)&qmsg);

   /* destroy the help instance */
   DestroyHelpInstance();

   if (WinIsWindow(hab, hwndMainFrame))
   {
      WinDestroyWindow(hwndMainFrame);
   }
   WinDestroyMsgQueue(hmq);

   WinTerminate(hab);
   return(RETURN_SUCCESS);

}   /* main() */


/****************************************************************\
 *  Main client window procedure
 *--------------------------------------------------------------
 *
 *  Name:   MainWndProc(hwnd, msg, mp1, mp2)
 *
 *  Purpose: Processes the messages sent to the main client
 *		window.	 This routine processes the basic
 *		messages all client windows should process
 *		and passes all others onto WinDefWindowProc.
 *
 *  Usage:  Called for each message placed in the main
 *	    window's message queue
 *
 *  Method: a switch statement branches to the routines to be
 *	    performed for each message processed.
 *
 *  Returns:  Return values are determined by each message
 *
\****************************************************************/
MRESULT EXPENTRY MainWndProc(HWND   hwnd,    /* handle of window */
			     ULONG  msg,     /* id of message */
			     MPARAM mp1,     /* first message parameter */
			     MPARAM mp2)     /* second message parameter */
{
   USHORT	usMsg=IDMSG_CLIENT_WIN;
   LONG		xBlock, yBlock;
   CHAR		*szChildClass = "TicTacToeSquare", *pszWinMsg="YOU WON ! !";
   int		i, j;
   HWND		hwndSquare;
   ULONG	ulOldSquare;
   static HWND	hwndChild[DIVISIONS][DIVISIONS];
   static int	iCloseCount=0;

   switch(msg)
   {
      case WM_CREATE:

	 WinRegisterClass (hab, szChildClass, ChildWndProc,
			   CS_SIZEREDRAW, sizeof(ULONG)*2) ;

	 for (i = 0 ; i < DIVISIONS ; i++)
	 {
	    for (j = 0 ; j < DIVISIONS ; j++)
	    {
	       hwndChild [i][j] = WinCreateWindow (
					       hwnd,	      /* Parent window	 */
					       szChildClass,  /* Window class	 */
					       NULL,	      /* Window text	 */
					       WS_VISIBLE |   /* Window style	 */
					       WS_SYNCPAINT,
					       0, 0, 0, 0,    /* Position & size */
					       hwnd,	      /* Owner window	 */
					       HWND_BOTTOM,   /* Placement	 */
					       (i*DIVISIONS+j), /* Child window ID */
				       (PVOID) NULL,	      /* Control data	 */
				       (PVOID) NULL) ;	      /* Pres. Params	 */
	       /* set window id in window data area */
	       if (NULLHANDLE == hwndChild[i][j] ||
		   FALSE == WinSetWindowULong(hwndChild[i][j],
					      sizeof(ULONG),
					      (i * DIVISIONS + j)))
	       {
		  return (MRFROMLONG(1));
	       }
	    }
	 }

	 break;

      case WM_BUTTON1DOWN:
      case WM_BUTTON1DBLCLK:
	   WinAlarm (HWND_DESKTOP, WA_WARNING) ;
	   break ;

      case WM_SIZE:
	 xBlock = SHORT1FROMMP (mp2) / DIVISIONS ;
	 yBlock = SHORT2FROMMP (mp2) / DIVISIONS ;

	 for (i = 0 ; i < DIVISIONS ; i++)
	 {
	    for (j = 0 ; j < DIVISIONS ; j++)
	    {
	       if (FALSE == WinSetWindowPos (hwndChild[j][i], NULLHANDLE,
					     (i * xBlock), (j * yBlock),
					     xBlock, yBlock,
					     (SWP_MOVE | SWP_SIZE)))
	       {
		  return (MRFROMLONG(1));
	       }
	    }
	 }
	 break;

      case WM_ERASEBACKGROUND:
	   return MRFROMLONG(1);

      case WM_CHAR:
	 if (SHORT1FROMMP(mp1) & KC_KEYUP)
	    break;

	 if (!(SHORT1FROMMP(mp1) & KC_VIRTUALKEY))
	    break;

	 ulOldSquare = ulActiveSquare;

	 switch (SHORT2FROMMP(mp2))
	 {
	    case VK_TAB:
	       /* make next client window active window */
	       ulActiveSquare = (((DIVISIONS*DIVISIONS-1) == ulActiveSquare) ? 0 : ulActiveSquare+1);
	       break;

	    case VK_BACKTAB:
	       /* make previous client window active window */
	       ulActiveSquare = ((0 == ulActiveSquare) ? (DIVISIONS*DIVISIONS-1) : ulActiveSquare-1);
	       break;

	    case VK_LEFT:
	       /* make client window to left active window */
	       ulActiveSquare = ((((ulActiveSquare-1)/DIVISIONS) == (ulActiveSquare/DIVISIONS)) ? ulActiveSquare-1 : ulActiveSquare+(DIVISIONS-1));
	       break;

	    case VK_RIGHT:
	       /* make client window to right active window */
	       ulActiveSquare = ((((ulActiveSquare+1)/DIVISIONS) == (ulActiveSquare/DIVISIONS)) ? ulActiveSquare+1 : ulActiveSquare+1-DIVISIONS);
	       break;

	    case VK_UP:
	       /* make client window above active window */
	       ulActiveSquare = ((ulActiveSquare+DIVISIONS < (DIVISIONS*DIVISIONS)) ? ulActiveSquare+DIVISIONS : ulActiveSquare-((DIVISIONS-1)*DIVISIONS));
	       break;

	    case VK_DOWN:
	       /* make client window below active window */
	       /* ulActiveSquares is unsigned, so instead of testing for */
	       /* less than zero, test for greater than it is allowed to be */
	       ulActiveSquare = (((ulActiveSquare-DIVISIONS) < (DIVISIONS*DIVISIONS)) ? ulActiveSquare-DIVISIONS : ulActiveSquare+((DIVISIONS-1)*DIVISIONS));
	       break;

	    case VK_NEWLINE:
	    case VK_ENTER:
	    case VK_SPACE:
	       WinPostMsg(WinWindowFromID(hwnd, ulActiveSquare), WM_BUTTON1DOWN, MPVOID, MPVOID);
	       break;
	 }

	 /* have squares repaint themselves */
	 WinInvalidateRect(WinWindowFromID(hwnd, ulOldSquare), NULL, FALSE);
	 WinInvalidateRect(WinWindowFromID(hwnd, ulActiveSquare), NULL, FALSE);
	 break ;

      case WM_COMMAND:
	 MainCommand(mp1, mp2);
	 break;

      case HM_QUERY_KEYS_HELP:
	 return (MRESULT)PANEL_HELPKEYS;   /* return id of key help panel */
	 break ;

      case WM_START:
	 WinEnableMenuItem(hwndMenu, IDM_FILESTART, TRUE);
	 break;

      case WM_SERVER_MOVE:
	 /* set window to server playing piece */
	 WinSetWindowULong((hwndSquare=WinWindowFromID(hwnd, SHORT1FROMMP(mp1))),
			   0,
			   SERVER_NUM);

	 /* repaint square */
	 WinInvalidateRect(hwndSquare, NULL, FALSE);
	 fMyTurn = TRUE;
	 break;

      case WM_DRAW:
	 usMsg = IDMSG_DRAW;
	 pszWinMsg = "Game is a Draw";
	 /* NO BREAK */

      case WM_WIN_SERVER:
	 if (SHORT1FROMMP(mp1) < DIVISIONS*DIVISIONS)
	 {
	    /* display winning move */
	    WinSetWindowULong((hwndSquare=WinWindowFromID(hwnd, SHORT1FROMMP(mp1))),
			      0,
			      SERVER_NUM);
	    WinInvalidateRect(hwndSquare, NULL, FALSE);
	    if (msg != WM_DRAW)
	    {
	       usMsg = IDMSG_SERVER_WIN;
	       pszWinMsg = "I WON ! !";
	    }
	 }
	 /* NO BREAK */

      case WM_WIN_CLIENT:
	 if (MBID_YES == MessageBox(hwndMain, usMsg, 0, MB_YESNO | MB_ICONQUESTION, pszWinMsg, TRUE))
	 {
	    InitBoard();
	 }

	 else
	 {
	    WinPostMsg(hwndMain, WM_COMMAND, MPFROMLONG(IDM_FILEEXIT), MPVOID);
	 }
	 break;

      case WM_MSG:
	 /* default message box */
	 if (MPVOID == mp2)
	 {
	    MessageBox(hwndMain, SHORT1FROMMP(mp1), LONGFROMMP(mp2), MB_OK | MB_ICONEXCLAMATION, NULL, TRUE);
	 }

	 /* custom message box */
	 else
	 {
	    MessageBox(hwndMain, SHORT1FROMMP(mp1), LONGFROMMP(mp2), SHORT2FROMMP(mp1), NULL, TRUE);
	 }
	 break;

      case WM_CLOSE:
	 fAppExit = TRUE;
	 PostPipeMsg(CLIENT_QUIT, 0);

	 /* give other thread a chance to exit */
	 /* but don't wait around forever for it */

	 for (iCloseCount = 0; FALSE == fThrdsDead && iCloseCount < THRD_EXIT_TIMEOUT; iCloseCount++)
	 {
	    DosSleep(0);
	 }

	 /* process the WM_CLOSE */

   /*--------------------------------------------------*\
    *	   Any messages not processed are passed on
    *	   to WinDefWindowProc.
   \*--------------------------------------------------*/

      default:
	 return(WinDefWindowProc(hwnd, msg, mp1, mp2));
	 break;
   }

   return (MRFROMLONG(0));	/* all window procedures should return 0 as a default */

}   /* MainWndProc() */


/****************************************************************\
 *  Message Box procedure
 *--------------------------------------------------------------
 *
 *  Name:   MessageBox(hwndOwner, nIdMsg, lRC, fsStyle, pszTitle, fBeep)
 *
 *  Purpose: Displays the message box with the message
 *		given in idMsg retrieved from the message table
 *		and using the style flags in fsStyle
 *
 *  Usage:  Called whenever a MessageBox is to be displayed
 *
 *  Method: - Message string is loaded from the process'
 *		message table
 *	    - Alarm beep is sounded if desired
 *	    - Message box with the message is displayed
 *	    - WinMessageBox return value is returned
 *
 *  Returns: return value from WinMessageBox()
 *
\****************************************************************/

ULONG MessageBox(HWND  hwndOwner, /* handle of the message box's owner */
		 ULONG idMsg,	  /* id if the message in the message table */
		 LONG  lRC,	  /* return code of failing function */
		 ULONG fsStyle,	  /* style of the message box */
		 PSZ   pszTitle,  /* title of message box */
		 BOOL  fBeep)	  /* if TRUE, beep before message box is displayed */
{
   CHAR szText[TITLE_LEN];

   if(!WinLoadMessage(hab,
		     (HMODULE)NULL,
		     idMsg,
		     TITLE_LEN,
		     (PSZ)szText))
   {
      WinAlarm(HWND_DESKTOP, WA_ERROR);
      return MBID_ERROR;
   }

   if (NULL == pszTitle)
   {
      pszTitle = "Client Error";
   }

   if (lRC)
   {
      sprintf(szText, "%s\n rc = %lu", szText, lRC);
   }

   if(fBeep)  {
      WinAlarm(HWND_DESKTOP, WA_ERROR);
   }

   return(WinMessageBox(HWND_DESKTOP,
			hwndOwner,
			szText,
			pszTitle,
			MSGBOXID,
			fsStyle));

}   /* MessageBox() */


/****************************************************************\
 *  Main window WM_COMMAND processing procedure
 *--------------------------------------------------------------
 *
 *  Name:   MainCommand(mp1, mp2)
 *
 *  Purpose: Calls the appropriate procedures that deal with
 *		the selected menu item.
 *
 *  Usage:  Routine is called whenever a WM_COMMAND message
 *	    is posted to the main window.
 *
 *  Method: a switch statement branches on the id of the
 *	    menu item that posted the message and the
 *	    appropriate action for that item is taken.
 *
 *  Returns:
 *
\****************************************************************/
VOID MainCommand(MPARAM mp1, MPARAM mp2)
{

   switch(SHORT1FROMMP(mp1))
   {
      case IDM_FILEEXIT:
	 FileExit();
	 break;

      case IDM_FILESTART:
	 /* ask player who should move first, perhaps with a message box */
	 WinEnableMenuItem(hwndMenu, IDM_FILESTART, FALSE);
	 if (MBID_YES == MessageBox(hwndMain, IDMSG_ME_FIRST, 0, MB_ICONQUESTION | MB_YESNO, "", FALSE))
	 {
	    fMyTurn = TRUE;
	 }

	 else
	 {
	    PostPipeMsg(YOU_FIRST, 0);
	 }
	 break;

      case IDM_OPTIONSWAPPIECES:
	 usWhosX = (USHORT)((SERVER_NUM == usWhosX) ? CLIENT_NUM : SERVER_NUM);
	 WinInvalidateRect(hwndMain, NULL, TRUE);
	 break;

      case IDM_HELPHELPFORHELP:
	 HelpHelpForHelp(mp2);
	 break;

      case IDM_HELPEXTENDED:
	 HelpExtended(mp2);
	 break;

      case IDM_HELPKEYS:
	 HelpKeys(mp2);
	 break;

      case IDM_HELPINDEX:
	 HelpIndex(mp2);
	 break;

      case IDM_HELPTUTORIAL:
	 HelpTutorial(mp2);
	 break;

      case IDM_HELPABOUT:
	 HelpAbout(mp2);
	 break;

      default:
	 break;
    }

}   /* MainCommand() */


/*
 *   Window procedure for each tic-tac-toe square.
 */
MRESULT EXPENTRY ChildWndProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   HPS	   hps ;
   RECTL   rcl ;
   USHORT  usWinState;
   ULONG   ulOldSquare;

   switch (msg)
   {
      case WM_CREATE:
	 /* initialize square as empty */
	 WinSetWindowULong (hwnd, 0, 0) ;
	 break;

      case WM_BUTTON1DOWN:
	 if (fMyTurn && 0 == (BOOL)WinQueryWindowULong (hwnd, 0))
	 {
	    fMyTurn = FALSE;
	    PostPipeMsg(CLIENT_MOVE, WinQueryWindowULong(hwnd, sizeof(ULONG)));
	    ulOldSquare = ulActiveSquare;
	    ulActiveSquare = WinQueryWindowULong(hwnd, sizeof(ULONG));
	    WinSetWindowULong (hwnd, 0, CLIENT_NUM);
	    WinInvalidateRect(WinWindowFromID(hwndMain, ulOldSquare), NULL, FALSE);
	    WinInvalidateRect(hwnd, NULL, FALSE);
	    WinSetActiveWindow (HWND_DESKTOP, hwnd);
	 }

	 else
	 {
	    WinAlarm(HWND_DESKTOP, WA_ERROR);
	 }
	 break;

      case WM_PAINT:
	 WinQueryWindowRect (hwnd, &rcl) ;

	 hps = WinBeginPaint (hwnd, NULLHANDLE, NULL) ;

	 if (WinQueryWindowULong(hwnd, sizeof(ULONG)) == ulActiveSquare)
	 {
	    WinDrawBorder (hps, &rcl, 2, 2, CLR_NEUTRAL, CLR_BACKGROUND,
			   DB_STANDARD | DB_INTERIOR) ;
	 }

	 else
	 {
	    WinDrawBorder (hps, &rcl, 1, 1, CLR_NEUTRAL, CLR_BACKGROUND,
			   DB_STANDARD | DB_INTERIOR) ;
	 }

	 if ((BOOL)(usWinState = (USHORT)WinQueryWindowULong (hwnd, 0)))
	 {
	    DrawPiece(hps, usWinState, rcl);
	 }

	 WinEndPaint (hps) ;
	 break;

      case WM_CHAR:
	 switch (SHORT2FROMMP(mp2))
	 {
	    case VK_NEWLINE:
	    case VK_ENTER:
	    case VK_SPACE:
	       if (fMyTurn && 0 == (BOOL)WinQueryWindowULong (hwnd, 0))
	       {
		  fMyTurn = FALSE;
		  PostPipeMsg(CLIENT_MOVE, WinQueryWindowULong(hwnd, sizeof(ULONG)));
		  WinSetWindowULong (hwnd, 0, CLIENT_NUM);
		  WinInvalidateRect (hwnd, NULL, FALSE);
	       }

	       else
	       {
		  WinAlarm(HWND_DESKTOP, WA_ERROR);
	       }

	       break;

	    default:
	       /* let the main window deal with it */
	       WinPostMsg(hwndMain, msg, mp1, mp2);
	 }
	 break;

      default:
	 return WinDefWindowProc (hwnd, msg, mp1, mp2) ;
   }
   return MRFROMLONG(0);
}


/****************************************************************\
 *  Initialization routine
 *--------------------------------------------------------------
 *
 *  Name:   Init()
 *
 *  Purpose: Performs initialization functions.
 *
 *  Usage:  Called once before the message queue is queried.
 *
 *  Method:
 *	    - starts processing thread
 *	    - registers all window classes
 *
 *  Returns:
 *	    TRUE - initialization is successful
 *	    FALSE - initialization failed
\****************************************************************/
BOOL Init()
{
   ULONG  flCtlData;	/* frame control data */


   /* load application name from resource file */
   if(!WinLoadString(hab, 0, IDS_APPNAME, MAXNAMEL, szAppName))
   {
      return FALSE;
   }

   /* register the main client window class */
   if(!WinRegisterClass(hab,
			szAppName,
			MainWndProc,
			CS_SIZEREDRAW | CS_CLIPCHILDREN,
			0))
   {
      return FALSE;
   }

   flCtlData = FCF_STANDARD;

   if (NULLHANDLE ==
       (hwndMainFrame = WinCreateStdWindow(HWND_DESKTOP,
					   WS_VISIBLE,
					   &flCtlData,
					   szAppName,
					   NULL,
					   WS_VISIBLE,
					   NULLHANDLE,
					   IDR_MAIN,
					   &hwndMain)))
   {
      return FALSE;
   }

   WinSetWindowText(hwndMainFrame, szAppName);

   InitHelp();

   if (!InitThread())
   {
      return FALSE;
   }

   hwndMenu = WinWindowFromID(hwndMainFrame, FID_MENU);

   return TRUE;
}  /* Init() */


/****************************************************************\
 *  Exit routine
 *--------------------------------------------------------------
 *
 *  Name:   FileExit(mp2)
 *
 *  Purpose: Processes the File menu's Exit item.
 *
 *  Usage:  called whenever Exit from the file menu is
 *	    selected
 *
 *  Method:  Routine posts a WM_CLOSE message to the main
 *	     application window.
 *
 *  Returns:
 *
\****************************************************************/
VOID FileExit()
{

   fAppExit = TRUE;
   WinPostMsg(hwndMain, WM_CLOSE, (MPARAM)NULL, (MPARAM)NULL);
}   /* FileExit() */


/*
 *   Draw X or O in square.
 */
VOID DrawPiece(HPS hps, USHORT usPiece, RECTL rcl)
{
   POINTL ptl;
   LONG	  xAxis, yAxis;

   if (usWhosX == usPiece)
   {
      /* Draw X */
      ptl.x = rcl.xLeft;
      ptl.y = rcl.yBottom;
      GpiMove (hps, &ptl);
      ptl.x = rcl.xRight;
      ptl.y = rcl.yTop;
      GpiLine (hps, &ptl);

      ptl.x = rcl.xLeft;
      ptl.y = rcl.yTop;
      GpiMove (hps, &ptl);
      ptl.x = rcl.xRight;
      ptl.y = rcl.yBottom;
      GpiLine (hps, &ptl);
   }

   else
   {
      /* Draw O */
      ptl.x = rcl.xLeft;
      ptl.y = rcl.yBottom;
      GpiMove (hps, &ptl);
      xAxis = rcl.xRight - rcl.xLeft;
      yAxis = rcl.yTop - rcl.yBottom;
      ptl.x = rcl.xRight;
      ptl.y = rcl.yTop;
      GpiBox(hps, DRO_OUTLINE, &ptl, xAxis, yAxis);
   }
}


/*
 *   Copy message to buffer and post event semaphore.
 */
VOID PostPipeMsg(USHORT usMsg, USHORT usData)
{

   pmsgPipeMsg.usMsgType = usMsg;
   pmsgPipeMsg.usMsgData = usData;
   DosPostEventSem(hevWritePipe);
}


/*
 *   Erase game board.
 */
VOID InitBoard()
{
   int i, j;

   fMyTurn = FALSE;
   for (i = 0 ; i < DIVISIONS ; i++)
   {
      for (j = 0 ; j < DIVISIONS ; j++)
      {
	 WinSetWindowULong(WinWindowFromID(hwndMain, (DIVISIONS*i+j)), 0, 0);
      }
   }

   WinInvalidateRect(hwndMain, NULL, TRUE);
   WinEnableMenuItem(hwndMenu, IDM_FILESTART, TRUE);
}
/*==============================================================*\
 *  clnpthrd.c - Pipe Server end of Tic-Tac-Toe sample app
 *	Copyright 1992 IBM Corp.
 *--------------------------------------------------------------
 *
 *  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *  sample code created by IBM Corporation. This sample code is not
 *  part of any standard or IBM product and is provided to you solely
 *  for	 the purpose of assisting you in the development of your
 *  applications.  The code is provided "AS IS", without
 *  warranty of any kind.  IBM shall not be liable for any damages
 *  arising out of your use of the sample code, even if they have been
 *  advised of the possibility of   such damages.						      *
 *
 *--------------------------------------------------------------
 *
 *  This c file contains the thread creation routines and
 *  manages the named pipe.
 *
\*==============================================================*/


/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/
#define INCL_WINHELP
#define INCL_DOSPROCESS
#define INCL_WINMESSAGEMGR
#define INCL_WINWINDOWMGR
#define INCL_DOSNMPIPES
#define INCL_DOSFILEMGR
#define INCL_DOSERRORS
#define INCL_DOSSEMAPHORES
#define INCL_WINDIALOGS

#include <os2.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stddef.h>
#include "namepipe.h"

static struct _THREADPARAM {
   CHAR	 StartPipe[MAXPIPENAME];
   CHAR	 GamePipe[MAXPIPENAME];
   BOOL	 fMeFirst;
   };

typedef struct _THREADPARAM THREADPARAM;

#include "clnpmain.h"
#include "clnpxtrn.h"
#include "clnpglbl.h"

#define	 STACKSIZE  8192

CHAR  pszServer[MAXSERVERNAME];

BOOL InitThread()
{
   static THREADPARAM  tpPipeNames;
   ULONG	       usErrorMsg=0;

   /* load and open dialog box to get server name from user */
   if (IDC_OK == WinDlgBox(HWND_DESKTOP, hwndMainFrame, ServerDlgProc, 0, IDD_SERVER, NULL))
   {
      strcpy(tpPipeNames.StartPipe, "\\\\");
      strcat(tpPipeNames.StartPipe, pszServer);
      strcat(tpPipeNames.StartPipe, START_PIPE_NAME);
      strcpy(tpPipeNames.GamePipe, "\\\\");
      strcat(tpPipeNames.GamePipe, pszServer);
      strcat(tpPipeNames.GamePipe, GAME_PIPE_NAME);
   }

   else
   {
      strcpy(tpPipeNames.StartPipe, START_PIPE_NAME);
      strcpy(tpPipeNames.GamePipe, GAME_PIPE_NAME);
   }

   /* create event semaphore to communicate with pipe thread */
   if ((BOOL)DosCreateEventSem(NULL, &hevWritePipe, DC_SEM_SHARED, FALSE))
   {
      usErrorMsg = IDMSG_CREATE_SEM_FAILED;
   }

   else if (0 > _beginthread(ManagePipe,
			     NULL,
			     STACKSIZE,
			     (VOID *)&tpPipeNames))
   {
      usErrorMsg = IDMSG_CREATE_THREAD_FAILED;
   }

   if (usErrorMsg != 0)
   {
      MessageBox(hwndMain, usErrorMsg, 0, MB_WARNING | MB_OK, NULL, TRUE);
   }

   return((BOOL)(!(BOOL)usErrorMsg));
}


MRESULT EXPENTRY ServerDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   ULONG       ulErrorReply=0, ulUserCommand;
   FILESTATUS  fs;
   APIRET      apiRC;

   switch (msg)
   {
      case WM_COMMAND:
	 switch ((ulUserCommand=SHORT1FROMMP(mp1)))
	 {
	    case ID_OK:
	       if (0 != WinQueryWindowText(WinWindowFromID(hwnd,
							   DID_PIPE_SVR),
					   MAXSERVERNAME,
					   pszServer))
	       {
		  while (ERROR_FILE_NOT_FOUND == (apiRC=DosQueryPathInfo(pszServer,
								  FIL_STANDARD,
								  &fs,
								  sizeof(FILESTATUS)))
			 || ERROR_PATH_NOT_FOUND == apiRC)
		  {
		     if (MBID_RETRY!=(ulErrorReply=MessageBox(hwnd,
					       IDMSG_INVALID_NAME,
					       0,
					       MB_CUAWARNING | MB_ABORTRETRYIGNORE,
					       NULL,
					       TRUE)))
		     {
			if (MBID_ABORT == ulErrorReply)
			{
			   ulUserCommand = ID_CANCEL;
			}

			break;
		     }
		  }
	       }

	       else
	       {
		  ulUserCommand = ID_CANCEL;
	       }

	    case ID_CANCEL:
	       WinDismissDlg(hwnd, ulUserCommand);
	       return (MRFROMLONG(0));
	 }
	 break;
   }
   return(WinDefDlgProc(hwnd, msg, mp1, mp2));
}


VOID ManagePipe(VOID *tpPipeNames)
{
   BOOL	   fSuccess=TRUE;
   USHORT  usMsg;
   ULONG   ulErrorMsg, ulIcon;
   HPIPE   hpPipe;
   PSZ	   pszServer;
   ULONG   ulAction;
   APIRET  apiRC;

/*
 *   Attempt to open named pipe.  If the pipe is busy, wait on it, and when
 *   it becomes free try to open it again.  Continue until success or error.
 */

   do
   {
      apiRC = DosOpen(((THREADPARAM *)tpPipeNames)->StartPipe,	/* pointer to filename	    */
		(PHFILE) &hpPipe,	     /* pointer to variable for file handle	     */
		&ulAction,		     /* pointer to variable for action taken	     */
		0L,			     /* file size if created or truncated	     */
		0L,			     /* file attribute				     */
		FILE_OPEN,		     /* action taken if file exists/does not exist   */
		FS_CLI_STARTPIPE_OPEN_MODE,  /* open mode of file			     */
		NULL);			     /* pointer to structure for extended attributes */
   }
   while (ERROR_PIPE_BUSY == apiRC &&
	  !(BOOL)(apiRC=DosWaitNPipe(pszServer, NP_INDEFINITE_WAIT)));

   if (apiRC != 0)
   {
      ulErrorMsg = IDMSG_CONNECT_FAILED;
      ulIcon = MB_CUAWARNING | MB_OK;
      fSuccess = FALSE;
   }

   if (TRUE == fSuccess)
   {
      /* connect to the game pipe */
      if ((BOOL)(hpPipe = ConnectGamePipe(hpPipe,
					  ((THREADPARAM *)tpPipeNames)->GamePipe)))
      {
	 /* enable the File-Start menu choice */
	 WinPostMsg(hwndMain, WM_START, MPVOID, MPVOID);

	 while (WritePipe(hpPipe, &usMsg) &&
		usMsg != CLIENT_QUIT &&
		usMsg != ERROR_MSG)
	 {
	    if (!(BOOL)ReadPipe(hpPipe, &usMsg))
	    {
	       break;
	    }
	 }
      }

      else
      {
	 ulErrorMsg = IDMSG_CONNECT_FAILED;
	 ulIcon = MB_CUAWARNING | MB_OK;
	 fSuccess = FALSE;
      }
   }

   if (FALSE == fSuccess)
   {
      WinPostMsg(hwndMain,
		 WM_MSG,
		 MPFROM2SHORT(ulErrorMsg, ulIcon),
		 MPFROMLONG(apiRC));
   }

   if (!fAppExit)
   {
      fAppExit = TRUE;
   }

   DosCloseEventSem(hevWritePipe);
   DosClose(hpPipe);
   fThrdsDead = TRUE;
}


/*
 *   open game pipe, notify server of success or failure, and close start pipe.
 */
HPIPE ConnectGamePipe(HPIPE hpPipe, PSZ pszGamePipe)
{
   HPIPE     hpGamePipe;
   USHORT    usMsg=ERROR_MSG;
   ULONG     ulCount, ulAction;
   PIPE_MSG  pmsgPipeMsg;
   APIRET    apiRC;

   /* block on read, and open game pipe if server sends START_MSG */
   if ((BOOL)ReadPipe(hpPipe, &usMsg) &&
       START_MSG == usMsg)
   {

      do
      {
	 apiRC = DosOpen(pszGamePipe,	      /* pointer to filename			      */
		  (PHFILE) &hpGamePipe,	      /* pointer to variable for file handle	      */
		  &ulAction,		      /* pointer to variable for action taken	      */
		  0L,			      /* file size if created or truncated	      */
		  0L,			      /* file attribute				      */
		  FILE_OPEN,		      /* action taken if file exists/does not exist   */
		  FS_CLI_GAMEPIPE_OPEN_MODE,  /* open mode of file			      */
		  NULL);		      /* pointer to structure for extended attributes */
      }
      while (ERROR_PIPE_BUSY == apiRC &&
	     !(BOOL)(apiRC=DosWaitNPipe(pszGamePipe, NP_INDEFINITE_WAIT)));
   }

   if (apiRC != 0)
   {
      usMsg = ERROR_MSG;
      hpGamePipe = 0;
   }

   if (START_MSG == usMsg)
   {
      pmsgPipeMsg.usMsgType = usMsg;
      pmsgPipeMsg.usMsgData = 0;

      /* notify server of success or failure */
      DosWrite(hpPipe, (VOID *)&pmsgPipeMsg, sizeof(PIPE_MSG), &ulCount);
   }

   /* if it is not a start message, return an error */
   else
   {
      hpGamePipe = 0;
   }

   /* close start pipe */
   DosClose(hpPipe);
   return(hpGamePipe);
}


/*
 *   wait for PM thread to post message, and write it to pipe.
 */
BOOL WritePipe(HPIPE hpPipe, USHORT *usMsg)
{
   ULONG   ulCount;
   BOOL	   fSuccess=TRUE;
   APIRET  apiRC;


   if (!(BOOL)DosWaitEventSem(hevWritePipe, SEM_INDEFINITE_WAIT))
   {
      DosResetEventSem(hevWritePipe, &ulCount);
      if ((BOOL)DosWrite(hpPipe, (VOID *)&pmsgPipeMsg, sizeof(PIPE_MSG), &ulCount))
      {
	 WinPostMsg(hwndMain, WM_MSG, MPFROM2SHORT(IDMSG_PIPE_WRITE_FAILED, MB_CUAWARNING | MB_OK), MPFROMLONG(apiRC));
	 fSuccess = FALSE;
      }

      *usMsg = pmsgPipeMsg.usMsgType;
   }

   else if (!fAppExit)
   {
      WinPostMsg(hwndMain, WM_MSG, MPFROM2SHORT(IDMSG_SEMAPHORE_ERROR, MB_CUAWARNING | MB_OK), MPVOID);
      fSuccess = FALSE;
   }

   return(fSuccess);
}


/*
 *   Read message from pipe, and post to PM thread.
 */
BOOL ReadPipe(HPIPE hpPipe, USHORT *usMsg)
{
   static PIPE_MSG  pmsgPipeMsg;
   BOOL		    fSuccess=TRUE;
   ULONG	    ulCount;
   APIRET	    apiRC;

   /* DosRead returns an error code of 0 and 0 bytes read with a broken pipe */
   if (!(BOOL)DosRead(hpPipe, (VOID *)&pmsgPipeMsg, sizeof(PIPE_MSG), &ulCount)
       && ulCount > 0)
   {
      if (START_MSG != (*usMsg = pmsgPipeMsg.usMsgType))
      {
	 WinPostMsg(hwndMain, (WM_USER+pmsgPipeMsg.usMsgType), MPFROMSHORT((SHORT)pmsgPipeMsg.usMsgData), MPVOID);
      }
   }

   else if (!fAppExit)
   {
      WinPostMsg(hwndMain, WM_MSG, MPFROM2SHORT(IDMSG_PIPE_READ_FAILED, MB_CUAWARNING | MB_OK), MPFROMLONG(apiRC));
      fSuccess = FALSE;
   }

   return(fSuccess);
}
/*static char *SCCSID = "@(#)clock.c    6.9 92/02/18";*/
/*=========================================================================\
 *									   *
 *	 FILE:clock.c							   *
 *									   *
 *	 DESCRIPTION:	 Presentation Manager Alarm Clock Application	   *
 *									   *
 *									   *
 *									   *
 *	Copyright 1989, 1990, 1992 IBM Corp.				   *
 *									   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have been *
 *	advised of the possibility of	such damages.			   *
 *									   *
 *-------------------------------------------------------------------------*
 *  This source file contains the following functions:
 *
 *  main()
 *  ClkInit()
 *  ClkFrameWndProc()
 *  MessageBox()
 *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/


#define INCL_PM
#define INCL_GPITRANSFORMS
#define INCL_WINHELP
#define INCL_WINWINDOWMGR
#define INCL_WINMESSAGEMGR
#define INCL_DOSSEMAPHORES
#define INCL_DOSDATETIME
#define INCL_DOSDEVIOCTL
#define INCL_DOSPROCESS


#include <\os2\os2.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>

#include "clock.h"
#include "res.h"
#include "clkdata.h"
#include "alarmthd.h"


/*--------------------------------------------------------------*\
 *Global definitions for this module
\*--------------------------------------------------------------*/

#define	 STACK_SIZE_SECTHRD 8192
#ifndef	 DEFAULT_QUEUE_SIZE
#define	 DEFAULT_QUEUE_SIZE  5
#endif

/*--------------------------------------------------------------*\
 *  Global  variables for this module
\*--------------------------------------------------------------*/


TID  tidAlarmThread;
PFNWP pfnwpFrameWndProc;

/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/

VOID	ClkShowFrameControls (HWND);
MRESULT EXPENTRY ClkWndProc (HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY ClkFrameWndProc (HWND, ULONG, MPARAM, MPARAM);
INT	main (SHORT sArgc , CHAR *ppArgv[]);
BOOL	ClkInit (VOID);
/****************************************************************\
 *  Routine Name:
 *--------------------------------------------------------------
 *
 *  Name: main()
 *
 *  Purpose:Main entry point for  the clock program
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
INT  main (SHORT sArgc,CHAR  *ppArgv[])
{
    QMSG qmsg ;

    /* have we been asked to start ourselves as an icon? */
    if (sArgc > 1)
    {
	if ( stricmp ( ppArgv [ 1 ] , "iconic" ) == 0 )
	    fStartAsIcon = TRUE ;


    }

    if ( ClkInit ( ) )
    {

	while ( WinGetMsg ( hab , & qmsg , NULLHANDLE , 0 , 0 ) )
	    WinDispatchMsg ( hab , & qmsg ) ;

	/* clean up and go home */
	#ifdef HELP
	if ( hwndHelpInstance != NULLHANDLE )
	{
	    WinDestroyHelpInstance(hwndHelpInstance);
	}
	#endif

	/*
	 *post the event semaphore
	 *for our alarm thread
	 */
	fEndThread = TRUE;
	DosStopTimer(TimerResources.hTimer);
	WinRemoveSwitchEntry ( hsw ) ;
	WinDestroyWindow ( hwndFrame ) ;
	WinDestroyMsgQueue ( hmq ) ;
	WinTerminate ( hab ) ;
    }

    return ( (INT) 0) ;
}/*main*/
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ClkInit()
 *
 *  Purpose:Clock Initialization.
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    1 - if sucessful execution completed
 *	    0 - if error
\****************************************************************/
BOOL ClkInit ( VOID )
{
    /* app name, switch list info, and frame creation flags */
    static PSZ pszClkName = "Clock";
    static SWCNTRL swctl = { NULLHANDLE , NULLHANDLE , NULLHANDLE , 0 , 0 ,
			     SWL_VISIBLE ,
			     SWL_JUMPABLE , "Clock" , 0 } ;
    static ULONG fcf = FCF_SIZEBORDER | FCF_TITLEBAR | FCF_MINMAX
		      | FCF_SYSMENU | FCF_ACCELTABLE;

    PID pid ;
    TID tid ;
    TimerResources.pszSemName	= SEM_TIMER_NAME;
    TimerResources.ulTimerValue = SEM_TIMER_VALUE;
    cp.sTimerType = TIMER_CONT;

    if ( ( hab = WinInitialize ( 0 ) ) == NULLHANDLE )
	return( FALSE );

    if ( ( hmq = WinCreateMsgQueue ( hab , DEFAULT_QUEUE_SIZE ) ) == NULLHANDLE )
    {
	WinTerminate ( hab ) ;
	return (FALSE );
    }

    if ( ! WinRegisterClass ( hab , pszClkName , ClkWndProc ,
			      CS_SIZEREDRAW , 0 ) )
    {
	WinDestroyMsgQueue ( hmq ) ;
	WinTerminate ( hab ) ;
	return (FALSE );
    }

    hwndFrame = WinCreateStdWindow ( HWND_DESKTOP , 0 , &fcf ,
				     pszClkName , pszClkName ,
				     0,
				     NULLHANDLE , IDR_MAIN ,
				     &hwndClient ) ;


    if (hwndFrame == NULLHANDLE)
    {
	WinDestroyMsgQueue (hmq);
	WinTerminate (hab);
	return (FALSE );
    }

    pfnwpFrameWndProc = WinSubclassWindow (hwndFrame, ClkFrameWndProc);

    /* add ourselves to the switch list */
    WinQueryWindowProcess (hwndFrame, &pid, &tid);
    swctl.hwnd = hwndFrame;
    swctl.idProcess = pid;
    hsw = WinAddSwitchEntry (&swctl);

    #ifdef HELP
    InitHelp();
    #endif
    /*
     *create our
     *second thread
     *to keep track of alarms
     *for us
     */
    if( tidAlarmThread = _beginthread(AlarmThread,
				      NULL,
				      STACK_SIZE_SECTHRD,
				      NULL) == -1 )
    {
	  return(FALSE);
    }

    return TRUE;
}/*ClkInit*/

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ClkFrameWndProc
 *
 *  Purpose: This routine handles our top level interface to the
 *	     desktop manager.
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    1 - if sucessful execution completed
 *	    0 - if error
\****************************************************************/
MRESULT EXPENTRY ClkFrameWndProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    register USHORT cmd;
    USHORT cmdSrc;
    HWND hwndT;
    SWP swp;

    switch (msg)
    {
    case WM_DESTROY:
	if (cp.fControlsHidden)
	    ClkShowFrameControls (hwnd);
	break;

    case WM_SYSCOMMAND:

	if (cp.fControlsHidden)
	{

	    cmd = LOUSHORT(mp1);
	    cmdSrc = LOUSHORT(mp2);

	    /*
	     * If the mouse has been captured, ignore the system command.
	     */
	    if(WinQueryCapture (HWND_DESKTOP) != NULLHANDLE)
	    {
		return(MPVOID);
	    }

	    switch (cmd)
	    {
	    case SC_RESTORE:
	    case SC_MAXIMIZE:
		/*
		 * Get the restore position that SetMultWindowPos will use.
		 */
		WinQueryWindowPos(hwnd, &swp);

		switch(cmd)
		{
		case SC_RESTORE:
		    swp.fl = SWP_RESTORE;
		    break;

		case SC_MAXIMIZE:
		    swp.fl = SWP_MAXIMIZE;
		    break;
		}

		/*
		 * If the control key is down, don't activate, or deactivate.
		 * Don't do this if this came from an accelerator.
		 */
		if (cmdSrc != CMDSRC_ACCELERATOR)
		{
		    if (WinGetKeyState(HWND_DESKTOP, VK_CTRL) & 0x8000)
			swp.fl &= ~(SWP_DEACTIVATE | SWP_ACTIVATE);
		}

		WinSetMultWindowPos(NULLHANDLE, (PSWP)&swp, 1);
		break;

	    case SC_MOVE:
	    case SC_SIZE:
	    case SC_CLOSE:
		switch (cmd)
		{
		case SC_SIZE:
		    /*
		     * Start keyboard sizing interface by sending a WM_TRACKFRAME
		     * message back to ourselves (the frame window).
		     */
		    WinSendMsg(hwnd, WM_TRACKFRAME,
			    MPFROMSHORT(TF_SETPOINTERPOS), MPVOID );
		    break;

		case SC_MOVE:
		    /*
		     * Start keyboard moving interface by sending a WM_TRACKFRAME
		     * message back to ourselves (the frame window).
		     */
		    WinSendMsg (hwnd, WM_TRACKFRAME,
			    MPFROMSHORT(TF_SETPOINTERPOS | TF_MOVE), MPVOID );
		    break;

		case SC_CLOSE:
		    if ((hwndT = WinWindowFromID (hwnd, FID_CLIENT)) == NULLHANDLE)
			hwndT = hwnd;
		    WinSetParent (hwndTitleBar, hwndFrame, FALSE);
		    WinSetParent (hwndSysMenu, hwndFrame, FALSE);
		    WinSetParent (hwndMinMax, hwndFrame, FALSE);
		    WinSetParent (hwndMenu, hwndFrame, FALSE);

		    WinPostMsg (hwndT, WM_CLOSE, MPVOID, MPVOID );
		    break;
		}
		break;

	    default:
		return (*pfnwpFrameWndProc)(hwnd, msg, mp1, mp2);
	    }

	    return (MPVOID);

	}
	else
	{
	    return (*pfnwpFrameWndProc)(hwnd, msg, mp1, mp2);
	}
    }

    return (*pfnwpFrameWndProc)(hwnd, msg, mp1, mp2);
}/*ClkFrameWindowProc*/

/****************************************************************\
 *  Message Box procedure
 *--------------------------------------------------------------
 *
 *  Name:   MessageBox(hwndOwner, nIdMsg, fsStyle, fBeep)
 *
 *  Purpose: Displays the message box with the message
 *		given in idMsg retrieved from the message table
 *		and using the style flags in fsStyle
 *
 *  Usage:  Called whenever a MessageBox is to be displayed
 *
 *  Method: - Message string is loaded from the process'
 *		message table
 *	    - Alarm beep is sounded if desired
 *	    - Message box with the message is displayed
 *	    - WinMessageBox return value is returned
 *
 *  Returns: return value from WinMessageBox()
 *
\****************************************************************/
APIRET MessageBox(HWND hwndOwner,SHORT idMsg,SHORT fsStyle, BOOL fBeep)
{
    CHAR szText[MESSAGELEN];
    APIRET ApiReturn = NO_ERROR;


    if(!WinLoadMessage(hab,
		      NULLHANDLE,
		      idMsg,
		      MESSAGELEN,
		      (PSZ)szText))
    {

	WinAlarm(HWND_DESKTOP, WA_ERROR);
	return MBID_ERROR;
    }

    if(fBeep)
    {
	WinAlarm(HWND_DESKTOP, WA_ERROR);
    }

   ApiReturn = WinMessageBox(HWND_DESKTOP,
			 hwndOwner,
			 szText,
			 (PSZ)NULL,
			 MSGBOXID,
			 fsStyle );

    return(ApiReturn);
}/* MessageBox() */
#ifndef lint
static char *sccsid = "@(#)colblk.c 1.3 1/22/92 16:09:11 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define columnBlock_Class_Source
#include "colblk.ih"
#include "textline.h"

#define SPACE_BETWEEN 3
#define HEADER_SPACE 3
#define FOOTER_SPACE 3

/* ************************************************************ */
SOM_Scope void SOMLINK cbInit(columnBlock * somSelf,
			       int newColumns,
			       int newHeight,
			       int newWidth)
{
    columnBlockData *somThis = columnBlockGetData(somSelf);
    int n;
    linkedList *newBlock;
    columnBlockMethodDebug("columnBlock", "cbInit");

    _columnWidth = newWidth - ((newColumns - 1) * SPACE_BETWEEN);
    _columnWidth = _columnWidth / newColumns;

    _llSetMax(somSelf, newColumns);
    for (n = 0; n < newColumns; n++) {
	newBlock = linkedListNew();
	_llSetMax(newBlock, newHeight - HEADER_SPACE - FOOTER_SPACE);
	parent_llAddTail(somSelf, (baseType *) newBlock);
    }
    _llHead(somSelf);
}

/* ************************************************************ */
SOM_Scope int SOMLINK cbGetColumnWidth(columnBlock * somSelf)
{
    columnBlockData *somThis = columnBlockGetData(somSelf);
    columnBlockMethodDebug("columnBlock", "cbGetColumnWidth");
    return _columnWidth;
}

/* ************************************************************ */
SOM_Scope int SOMLINK cbLinesLeft(columnBlock * somSelf)
{
    columnBlockData *somThis = columnBlockGetData(somSelf);
    linkedList *thisBlock;
    columnBlockMethodDebug("columnBlock", "cbLinesLeft");

    thisBlock = (linkedList *) _llRetrieve(somSelf);
    return (_llLeft(thisBlock) || !_llIsTail(somSelf)) ? 1 : 0;
}

/* ************************************************************ */
SOM_Scope baseType *SOMLINK llAddTail(columnBlock * somSelf,
				       baseType * newLine)
{
    columnBlockData *somThis = columnBlockGetData(somSelf);
    linkedList *thisBlock;
    columnBlockMethodDebug("columnBlock", "llAddTail");

    thisBlock = (linkedList *) _llRetrieve(somSelf);
    if (!thisBlock)
	return (baseType *) NULL;
    if (!_llLeft(thisBlock)) {
	if (!(thisBlock = (linkedList *) _llNext(somSelf))) {
	    return (baseType *) NULL;
	}
    }
    return _llAddTail(thisBlock, newLine);
}

/* ************************************************************ */
SOM_Scope void SOMLINK print(columnBlock * somSelf,
			      FILE * output)
{
/* Set up.
   ------- */
    columnBlockData *somThis = columnBlockGetData(somSelf);
    int n, blockLength, blankLines;
    linkedList *thisBlock;
    textLine *thisLine;
    columnBlockMethodDebug("columnBlock", "print");

/* Determine number of lines in typical block.
   ------------------------------------------- */
    thisBlock = (linkedList *) _llHead(somSelf);
    blockLength = _llLength(thisBlock);
    blankLines = _llLeft(thisBlock);

/* For each horizontal line...
   --------------------------- */
    for (n = 0; n < blockLength; n++) {

/*     For each text block...
       ---------------------- */
	thisBlock = (linkedList *) _llHead(somSelf);
	while (thisBlock) {

/*	  Print the column line.
	  ---------------------- */
	    thisLine = (textLine *) _llHead(thisBlock);
	    if (thisLine) {
		_print(thisLine, output);
		_llFreeContents(thisLine);
		_cbPrintBlanks(somSelf, output, _tlCharsLeft(thisLine));
	    }
	    else {
		_cbPrintBlanks(somSelf, output, _cbGetColumnWidth(somSelf));
	    }
	    _llRemoveHead(thisBlock);

/*	  Print space between columns.
	  ---------------------------- */
	    _cbPrintBlanks(somSelf, output, SPACE_BETWEEN);

/*	  Move to next block.
	  ------------------- */
	    thisBlock = (linkedList *) _llNext(somSelf);
	}
	fprintf(output, "\n");
    }
/* Print blank lines.
   ------------------ */
    for (n = 0; n < blankLines; n++) {
	fprintf(output, "\n");
    }

}

/* ************************************************************ */
SOM_Scope void SOMLINK somInit(columnBlock * somSelf)
{
    columnBlockData *somThis = columnBlockGetData(somSelf);
    columnBlockMethodDebug("columnBlock", "somInit");
    parent_somInit(somSelf);
}

/* ************************************************************ */
SOM_Scope void SOMLINK somUninit(columnBlock * somSelf)
{
    columnBlockData *somThis = columnBlockGetData(somSelf);
    columnBlockMethodDebug("columnBlock", "somUninit");
    parent_somUninit(somSelf);
}

/* ************************************************************ */
SOM_Scope void SOMLINK somDumpSelfInt(columnBlock * somSelf,
				       int level)
{
    columnBlockData *somThis = columnBlockGetData(somSelf);
    columnBlockMethodDebug("columnBlock", "somDumpSelfInt");
    parent_somDumpSelfInt(somSelf, level);
}

/* ************************************************************ */
SOM_Scope void SOMLINK cbPrintBlanks(columnBlock * somSelf,
				      FILE * output,
				      int nblanks)
{
    columnBlockData *somThis = columnBlockGetData(somSelf);
    int n;
    columnBlockMethodDebug("columnBlock", "cbPrintBlanks");

    for (n = 0; n < nblanks; n++) {
	putc(' ', output);
    }
}
/*static char *SCCSID = "@(#)constr.c   6.1 92/02/19";*/
/*************************************************************************
 * File Name	 : CONSTR.C
 *
 * Description	 : This sample program demonstrates how to use the API
 *		   NlsConvertBidiString. This Bidirectional (Bidi) API
 *		   is use to convert the bidi string from one set of
 *		   attributes (FromAttr, which describe the Bidi
 *		   attributes of the input buffer) to another set of
 *		   attributes (ToAttr, wich describes the Bidi attibutes
 *		   of the output buffer).
 *
 * Concepts	 : When there is a change between the FromAttr and ToAttr
 *		   the API does the necessary to convert the input buffer
 *		   to the ToAttr format, and put it in the output buffer.
 *		   If FromAttr equals to ToAttr, no Bidi conversion will
 *		   take place, and the input Buffer will be copied into
 *		   the output buffer.
 *
 * API's         : NlsSetBidiAtt
 *		   NlsQueryBidiAtt
 *		   NlsConvertBidiString
 *		   VioWrtCharStr
 *		   VioScrollUp
 *		   VioSetCurType
 *
 * Required files: To build and run this sample code the following files
 *		   are needed:
 *		   - constr.C
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 ************************************************************************/
#define INCL_BASE
/* To include the neccessary header files for Bidi */
#define INCL_DOSERRORS
#define INCL_BDCALLS

#include <string.h>
#include <os2.h>
#include <conio.h>

VOID Initialize(VOID);
VOID ConvertAndDisplay(VOID);
VOID SetCur(INT);

/* Define a variable to save the session Bidi Attributes in it */
ULONG ulOriginalBidiAttr;

/* Define the area where we will get the result
 * of what we want to query from the session   */
BDKVCB bdkvcbSetAttr;

/* Define the parameter to Hide and Restore the cursor */
#define HIDE   -1
#define RESTORE 0

/* Define the buffer for the string to be displayed */
CHAR cString[20];

/*************************************************************************
 * Name		 : Main
 *
 * Description	 : This is the main part of the program, it first clear
 *		   the screen and then hide the cursor. The string to be
 *		   converted will be displayed before and after the API
 *		   NlsConvertBidiString is called.
 *
 * API's         : NlsSetBidiAtt
 *		   VioScrollUp
 *
 * Parameters	 : This program does not take any command line parameters
 *
 * Returns	 : None
 *
 ************************************************************************/

INT main(SHORT sArgc,CHAR **ppArgv)
{
   APIRET RC;

   /* clear the screen	*/
   VioScrollUp(0, 0, 24, 79, -1," \x07", 0);

   /* hide the cursor */
   SetCur(HIDE);

   /* Write the static text to the screen and the string that
    * is needed to be shaped */
   Initialize();

   /* Call the API to shape the string and write it to the screen */
   ConvertAndDisplay();

   /* Wait for Enter key to end the program */

   VioWrtCharStr("Press Enter to end the program", 32, 23, 26, 0l);
   getchar();

   /* Restore the session Bidi attributes  */
   bdkvcbSetAttr.BDAtts = ulOriginalBidiAttr ;

   RC = NlsSetBidiAtt( 0L, (PSETINFO)&bdkvcbSetAttr);
   if( RC != 0)
   {
     printf("\n\nCannot set the session Bidi Attributes RC=%ld\n",RC);
     exit(1);
   }

   /* clear the screen before exit */
   VioScrollUp(0, 0, 24, 79, -1," \x07", 0);

   /* restore the cursor position */
   SetCur(RESTORE);

   return (0);
}
/*************************************************************************
 * Name		 : INITIALIZE
 *
 * Description	 : This function does save the current Bidi attributes of
 *		   the session in a global variable, and set session with
 *		   its own Bidi attributes to protect the displayed shaped
 *		   string from been processed again according to the session
 *		   Bidi attributes.
 *		   Then the function displays some static text and also the
 *		   String to be converted before calling the API.
 *
 * API's         : NlsQueryBidiAtt
 *		   NlsSetBidiAtt
 *		   VioWrtCharStr
 *
 * Parameters	 : This program does not take any command line parameters
 *
 * Returns	 : None
 *
 ************************************************************************/
VOID Initialize(VOID)
{
   INT iI, iRow, iCol;

   APIRET  RC;

   /* define structures to be array of strings to contain the static
    * text to be wirtten on the screen	*/
   struct {
	  CHAR cScreen[40];
	  }mssg1[3];

   struct {
	   CHAR cScreen[45];
	   }mssg2[3];

   /* First we need to set the session Bidi attributes to have the
    * shaping mode as Passthru. This will let the Bidi support
    * to display the characters on the screen as they are.
    * i.e without any additional shape processing.
    * This way, when the application does its own shaping processing
    * the output characters to the screen will not be corrupted. */

   /* The length here is 8 to query only on the Bidi attribute	 */

   bdkvcbSetAttr.BDLength = 8;

   RC = NlsQueryBidiAtt( 0L,(PRETINFO)&bdkvcbSetAttr);

   if(RC != 0)
   {
      printf("\n\nError in query the Bidi Attributes RC=%ld\n",RC);
      exit(1);
   }

   /* Now we save the initial value of the Bidi attributes so that
    * so that we set back the session with it before the program terminates*/

   ulOriginalBidiAttr = bdkvcbSetAttr.BDAtts;

  /* Here we set the shaping byte value to passthru */

   bdkvcbSetAttr.BDAtts = BD_LEVEL |
			  BD_SUPPORT |
			  BDORIENT_LTR |
			  BDNUM_PASSTHRU |
			  BDCSD_PASSTHRU;

  /* Now let's set the session Bidi attributes with the new value  */

   RC = NlsSetBidiAtt( 0L, (PSETINFO)&bdkvcbSetAttr);
   if( RC != 0)
   {
       printf("\n\nCannot set the session Bidi Attributes RC=%ld\n",RC);
       exit(1);
   }

   /* Initialize the structures with the characters to be displayed */
   strcpy(mssg1[0].cScreen, "Here we will display the Bidi string,");
   strcpy(mssg1[1].cScreen, " its Bidi attr are RTL, Arabic Num,");
   strcpy(mssg1[2].cScreen, "    and Base shapes characters.   ");

   /* In this for loop, we increment the iRow after the display of each
    * string in the structure to jump to another line, keeping the value
    * of the iCol value fixed to have the strings indented */
   for(iI = 0, iRow = 2, iCol = 23; iI < 3; iI++, iRow++)
     VioWrtCharStr(mssg1[iI].cScreen, strlen(mssg1[iI].cScreen),
		   iRow, iCol, 0l);

   /* Display the string before it is shaped.
    * Note that this is a Right To Left string, because the logical
    * order of the characters stored is from the begining of the Buffer
    * to the end, i.e from low to high memory.
    * Because the screen attributes is LTR, then this RTL string will
    * not be displayed in a readable form, however if we would have
    * set the screen bidi attibutes to RTL before displaying the
    * string, it would be readable.
    * In this example we will keep the screen Bidi attributes to be
    * LTR and we will use the API to convert the string to LTR, so
    * that it can be readable. */

   VioWrtCharStr("NOTE: If the current code page is not 864,   ",
		  47, 7, 21, 0L);
   VioWrtCharStr("the following strings will not be readable.  ",
		 47,  8, 21, 0l);

   strcpy(cString,"  : 1");
   VioWrtCharStr(cString, strlen(cString), 11, 31, 0l);

   /* Initialize the second structure with the characters to be displayed */
   strcpy(mssg2[0].cScreen, "Now lets call the  NlsConvertBdiString, to");
   strcpy(mssg2[1].cScreen, "convert the  above string to be  displayed");
   strcpy(mssg2[2].cScreen, "correctly on the current screen attributes");

   for(iI = 0, iRow = 14, iCol = 21; iI <= 2; iI++, iRow++)
     VioWrtCharStr(mssg2[iI].cScreen, strlen(mssg2[iI].cScreen),
		   iRow, iCol, 0l);

}
/*************************************************************************
 * Name		 : ConvertAndDisplay
 *
 * Description	 : This function will show how to use the Bidi API
 *		   NslConvertBidiString.
 *		   The function will also displays the string after
 *		   the conversion.
 *
 * API's         : NlsConvertBidiString
 *		   VioWrtCharStr
 *
 * Parameters	 : This program does not take any command line parameters
 *
 * Returns	 : None
 *
 ************************************************************************/
VOID ConvertAndDisplay(VOID)
{
   APIRET RC;
   INT	 iRow, iCol;
   ULONG ulFromAttr,ulToAttr;
   ULONG ulLength;
   ULONG ulIncrement ;
   ULONG ulReserved = 0L;

   ulLength = strlen(cString);

   /* The string contains successive characters, i.e the cell here is
    * only one character, i.e Increment =1 */
   ulIncrement = 1;

   iCol = 31;

   /* using the OR operator, we set the bits in FromAttr, to describe
    * the input string attributes, we know that it is a RTL, contains
    * Arabic numeral, and it is in Base shapes */

   ulFromAttr= BD_LEVEL |
	       BD_SUPPORT |
	       BDORIENT_RTL |
	       BDNUM_ARABIC |
	       BDCSD_BASE ;


   /* Now let's compose the ToAttr, we want the output string to be
    * LTR, Hindu numeral, and Shaped (Automatic Shape Determination) */

   ulToAttr= BD_LEVEL |
	     BD_SUPPORT |
	     BDORIENT_LTR |
	     BDNUM_HINDU |
	     BDCSD_AUTOMATIC ;


  /* calling the API.. to convert the string */
  RC = NlsConvertBidiString (cString,
			     cString,
			     ulLength,
			     ulIncrement,
			     ulFromAttr,
			     ulToAttr,
			     ulReserved);

  if (RC!=0)
     printf("RC=%ld\n",RC);

  /* NOTE: If the screen attributes were equal Hindi and Automatic, we
   * will obtain the same result on the screen if we called the API
   * NlsInverseString. In that case, the Bidi Screen Handler will
   * do the numeral and the shaping processing.
   * In addition, if the screen attributes (direction) was also RTL,
   * then we do not need to do any processing because the Bidi Screen
   *  Handler will do the string inversion.  */

  /* display the target buffer */
    VioWrtCharStr(cString, strlen(cString), 19, iCol, 0l);

}

/*************************************************************************
 * Name		 : SET_CUR
 *
 * Description	 : This function hides or restores the cursor position.
 *
 * API's         : VioSetCurType
 *
 * Parameters	 : (INT flag)
 *		   flag indicates whether we want ot hide or restore
 *		   the cursor.
 *
 * Returns	 : None
 *
 ************************************************************************/

VOID SetCur(INT iFlag)
{
   HVIO HVIOhandle = 0;
   VIOCURSORINFO cursor;

   cursor.yStart  = 3;
   cursor.cEnd	  = 5;
   cursor.cx	  = 0;
   cursor.attr	  = iFlag;

   VioSetCurType(&cursor, HVIOhandle);
}

/*************************************************************************
*
*  File Name   : Dialog.c
*
*  Description : This program demonstrates how to associate a pop-up
*		 window with a standard window.	 The pop-up window
*		 is defined as a dialog template in a resource file.
*
*  Concepts    : This program displays a standard window.  The action bar
*		 contains a single choice:  Options.  The Options
*		 pull-down contains a choice that displays a pop-up
*		 window which contains an entry field, and OK and Cancel
*		 pushbuttons.  When the user types a place name in the
*		 entry field and selects OK, the pop-up window
*		 disappears, and the place name is displayed at the end
*		 of the text "You live in".
*
*  API's       :
*  -------------
*  GpiCharStringAt	 WinDestroyWindow    WinInvalidateRegion
*  GpiSetColor		 WinDismissDlg	     WinLoadString
*  WinBeginPaint	 WinDispatchMsg	     WinPostMsg
*  WinCreateMsgQueue	 WinDlgBox	     WinQueryWindowText
*  WinCreateStdWindow	 WinEndPaint	     WinRegisterClass
*  WinDefDlgProc	 WinFillRect	     WinSendMsg
*  WinDefWindowProc	 WinGetMsg	     WinTerminate
*  WinDestroyMsgQueue	 WinInitialize	     WinWindowFromID
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.						      *
*
************************************************************************/

#define INCL_WINSYS			/* Selectively include		*/
#define INCL_WINFRAMEMGR		/* relevant parts of		*/
#define INCL_WINMENUS			/* the PM header file		*/
#define INCL_WINDIALOGS
#define INCL_GPI

#include <os2.h>
#include <string.h>
#include <stdlib.h>
#include "dialog.h"			/* Resource symbolic identifiers*/

#define LENGTH_STRING  33		/* Length of string		*/
#define RETURN_ERROR	1		/* return value for exit	*/
#define BEEP_WARN_FREQ	    60		/* frequency of warning beep	*/
#define BEEP_WARN_DUR	   100		/* duration of warning beep	*/

/* Function prototypes							*/
int main(VOID);
MRESULT EXPENTRY MyWindowProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 );
MRESULT EXPENTRY MyDlgProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 );
MRESULT EXPENTRY ProdInfoDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
VOID DisplayMessage( PCH str );
VOID SetSysMenu(HWND hwnd);
					/* Define parameters by type	*/
HAB   hab;				/* Anchor block handle		*/
HMQ   hmq;				/* Message queue handle		*/
HWND  hwndClient;			/* Client window handle		*/
ULONG flCreate = FCF_STANDARD;		/* Frame control flag		*/
BOOL  bComplete = FALSE;		/* Switch for first time through*/
HWND  hwndFrame;			/* Frame window handle		*/
CHAR  szLocation[LENGTH_STRING] = "";	/* To hold text entered by user */
CHAR  szResponse[LENGTH_STRING] = "";	/* To hold "You live in"	*/

/****************************************************************
 *  Name:   main()
 *
 *  Description: Entry point of program.
 *
 *  Concepts: Obtains anchor block handle and creates message
 *	      queue.  Calls the initialization routine.
 *	      Creates the main frame window which creates the
 *	      main client window.  Polls the message queue
 *	      via Get/Dispatch Msg loop.  Upon exiting the
 *	      loop, exits.
 *
 *  API's   :  WinInitilize
 *	       DosBeep
 *	       WinCreateMsgQueue
 *	       WinTerminate
 *	       WinRegisterClass
 *	       WinCreateStdWindow
 *	       WinSetWindowText
 *	       WinGetMsg
 *	       WinDispatchMsg
 *	       WinDestroyWindow
 *	       WinDestroyMsgQueue
 *
 *  Parameters: None
 *
 *  Returns:
 *	    1 - if sucessful execution completed
 *	    0 - if error
\****************************************************************/
int main(VOID)
{
  QMSG	qmsg;
  BOOL success;

  hab = WinInitialize( 0 );
  if(!hab)
  {
    DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
    exit(RETURN_ERROR);
  }

  hmq = WinCreateMsgQueue( hab, 0 );
  if(!hmq)
  {
    DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
    WinTerminate(hab);
    exit(RETURN_ERROR);
  }

  success = WinDlgBox( HWND_DESKTOP,	/* Place anywhere on desktop	*/
		       HWND_DESKTOP,	/* Owned by desk top		*/
		       (PFNWP)ProdInfoDlgProc,	 /* Addr. of procedure	*/
		       (HMODULE)0,	/* Module handle		*/
		       ID_PRODINFO,	/* Dialog identifier in resource*/
		       NULL);		/* Initialization data		*/
  if (!success)
  {
    DisplayMessage("Could Not Register Class");
    exit(RETURN_ERROR);
  }

  success = WinRegisterClass(		/* Register window class	*/
       hab,				/* Anchor block handle		*/
       "MyWindow",			/* Window class name		*/
       MyWindowProc,			/* Address of window procedure	*/
       CS_SIZEREDRAW,			/* Class style			*/
       0				/* No extra window words	*/
       );
  if (!success)
  {
    DisplayMessage("Could Not Register Class");
    exit(RETURN_ERROR);
  }

  hwndFrame = WinCreateStdWindow(
	HWND_DESKTOP,			/* Desktop window is parent	*/
	WS_VISIBLE,			/* Frame style			*/
	&flCreate,			/* Frame control flag		*/
	"MyWindow",			/* Window class name		*/
	"",				/* Window title			*/
	0L,				/* Client style of VISIBLE	*/
	(HMODULE)NULL,			/* Resource is in .EXE file	*/
	ID_MAINWND,			/* Frame window identifier	*/
	&hwndClient);			/* Client window handle		*/

  if (!hwndFrame)
  {
    DisplayMessage("Could Not Create Main Window");
    exit(RETURN_ERROR);
  }

  WinSetWindowText(hwndFrame, "Dialog - Sample Program");

/*
 * Get and dispatch messages from the application message queue
 * until WinGetMsg returns FALSE, indicating a WM_QUIT message.
 */
  while( WinGetMsg( hab, &qmsg, (HWND)NULL, 0, 0 ) )
    WinDispatchMsg( hab, &qmsg );

  WinDestroyWindow( hwndFrame );	/* Tidy up...			*/
  WinDestroyMsgQueue( hmq );		/* and				*/
  WinTerminate( hab );			/* terminate the application	*/
  return(0);
}
/***********************  End of main procedure	 ************************/

/****************************************************************
 *  Name:   MyWndProc
 *
 *  Description : Window procedure for the main clent window.
 *
 *  Concepts : Processes the messages sent to the main client
 *	       window.
 *
 *  API's : WinLoadString
 *	    WinDlgBox
 *	    WinInvalidateRegion
 *	    WinPostMsg
 *	    WinDefDlgProc
 *	    WinBeginPaint
 *	    WinFillRect
 *	    GpiCharStringAt
 *	    GpiSetColor
 *	    WinEndPaint
 *
 * Parameters	: hwnd - Window handle to which message is addressed
 *		  msg - Message type
 *		  mp1 - First message parameter
 *		  mp2 - Second message parameter
 *
 *  Returns:  Return values are determined by each message
 *
 ****************************************************************/
MRESULT EXPENTRY MyWindowProc ( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
  switch( msg )
  {
    case WM_CREATE:
      /*
       * Window initialization - load "You live in" string from resource
       */
      WinLoadString( hab,
		     (HMODULE)NULL,	   /* Resource is in .EXE file	*/
		     ID_RESPONSE,	   /* String identifier		*/
		     sizeof( szResponse ), /* Size of buffer		*/
		     (PSZ)szResponse);	   /* Buffer			*/
      break;
    case WM_COMMAND:
      /*
       * When the user chooses "Where..." from the Options pull-down,
       * the application displays a dialog box. WinDlgBox calls the
       * dialog procedure below. WinDlgBox does not return until the
       * dialog procedure returns.
       * WinInvalidateRegion sends a WM_PAINT message.
       */
      switch ( SHORT1FROMMP( mp1 ) )
      {
	case ID_WHERE:

	 WinDlgBox( HWND_DESKTOP,	/* Place anywhere on desktop	*/
		     hwndFrame,		/* Owned by frame		*/
		     MyDlgProc,		/* Address of dialog procedure	*/
		     (HMODULE)0,	/* Module handle		*/
		     ID_MYDIALOG,	/* Dialog identifier in resource*/
		     NULL);		/* Initialization data		*/

	  WinInvalidateRegion( hwnd, NULLHANDLE, FALSE ); /* Force a repaint */

	  break;
	case ID_EXITPROGRAM:

	  WinPostMsg( hwnd, WM_CLOSE, NULL, NULL);

	  break;
	default:
      return WinDefWindowProc( hwnd, msg, mp1, mp2 );
      }
      break;
    case WM_PAINT:
      /*
       * Window contents are drawn here. First time through, bComplete
       * is FALSE, so window is simply filled with SYSCLR_WINDOW.
       * On subsequent passes, if bComplete has been set to TRUE in the
       * dialog procedure, GpiCharStringAt draws the text.
       */
      {
       HPS    hps;			/* Presentation space handle	*/
       POINTL pt;			/* String screen coordinates	*/
       RECTL  rc;			/* Window rectangle		*/

	hps = WinBeginPaint( hwnd, (HPS)NULL, &rc );
	WinFillRect( hps, &rc, SYSCLR_WINDOW );
	if( bComplete)
	{
	  GpiSetColor( hps, CLR_NEUTRAL ); /* Text color same as PM	  */
	  pt.x = 50L; pt.y = 50L;	  /* Coordinates of "You live in" */
	  GpiCharStringAt( hps, &pt, (LONG)strlen( szResponse ), szResponse );
	  pt.x = 50L; pt.y = 30L;	  /* Coordinates of location	  */
	  GpiCharStringAt( hps, &pt, (LONG)strlen( szLocation ), szLocation );
	}
	WinEndPaint( hps );		  /* Drawing is complete	  */
      }
      break;
    case WM_CLOSE:
      WinPostMsg( hwnd, WM_QUIT, NULL, NULL);	  /* Cause termination	  */
      break;
    default:
      /*
       * Must have WinDefWindowProc in your window procedure
       */
      return WinDefWindowProc( hwnd, msg, mp1, mp2 );
  }
  return (MRESULT) FALSE;
}
/*********************** End of window procedure  ***********************/

/*********************************************************************
 *  Name : MyDlgProc
 *
 *  Description : Processes all messages sent to the dialog.
 *
 *  Concepts : Called for each message sent to the dialog box.
 *	       A switch statement branches to the routines to be
 *	       performed for each message processed.  Any messages
 *	       not specifically process are passed to the default
 *	       window procedure WinDefDlgProc().
 *
 *  API's : WinQueryWindowText
 *	    WinDismissDlg
 *
 * Parameters	: hwnd - Window handle to which message is addressed
 *		  msg - Message type
 *		  mp1 - First message parameter
 *		  mp2 - Second message parameter
 *
 *  Returns : Dependent upon message sent
 *
 ****************************************************************/
MRESULT EXPENTRY MyDlgProc( HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
  switch ( msg )
  {
    case WM_INITDLG:
       SetSysMenu(hwndDlg);		/* remove unused sys. menu items*/
       break;

    case WM_COMMAND:			/* Posted by pushbutton or key	*/
      /*
       * PM sends a WM_COMMAND message when the user presses either
       * the Enter or Escape pushbuttons.
       */
      switch( SHORT1FROMMP( mp1 ) )	/* Extract the command value	*/
      {
	case DID_OK:			/* The Enter pushbutton or key. */
					/* WinQueryWindowText copies the*/
					/* contents of the entry field	*/
					/* into szLocation.		*/
	  WinQueryWindowText( WinWindowFromID( hwndDlg, ID_ENTRYFIELD ),
			      LENGTH_STRING,
			      szLocation );
	  bComplete = TRUE;		/* Set switch so strings are	*/
					/* drawn in WM_PAINT processing.*/
	case DID_CANCEL:	 /* The Cancel pushbutton or Escape key */
	  WinDismissDlg( hwndDlg, TRUE );  /* Removes the dialog box	*/
	  return (MRESULT) FALSE;
	default:
	  break;
      }
      break;
    default:
      /*
       * Any event messages that the dialog procedure has not processed
       * come here and are processed by WinDefDlgProc.
       * This call MUST exist in your dialog procedure.
       */
      return WinDefDlgProc( hwndDlg, msg, mp1, mp2 );
  }
  return (MRESULT) FALSE;
}
/********************** End of dialog procedure	 ************************/

/*********************************************************************
 *  Name : ProdInfoDlgProc
 *
 *  Description : Processes all messages sent to the Product
 *		  Information dialog box.
 *
 *  Concepts : Called for each message sent to the Product
 *	       Information dialog box.	The Product
 *	       Information box only has a button control so
 *	       this routine only processes WM_COMMAND
 *	       messages.  Any WM_COMMAND posted must have come
 *	       from the Ok button so we dismiss the dialog
 *	       upon receiving it.
 *
 *  API's : WinDismissDlg
 *	    WinDefDlgProc
 *
 * Parameters	: hwnd - Window handle to which message is addressed
 *		  msg - Message type
 *		  mp1 - First message parameter
 *		  mp2 - Second message parameter
 *
 *  Returns : Dependent upon message sent
 *
 ****************************************************************/
MRESULT EXPENTRY ProdInfoDlgProc( HWND hwnd, ULONG msg, MPARAM mp1,
				  MPARAM mp2)
{
   switch(msg)
   {
      case WM_INITDLG:
	 SetSysMenu(hwnd);		/* remove unused sys. menu items*/
	 break;

      case WM_COMMAND:
	 /*
	  * No matter what the command, close the dialog
	  */
	 WinDismissDlg(hwnd, TRUE);
	 break;

      default:
	 return(WinDefDlgProc(hwnd, msg, mp1, mp2));
	 break;
   }
   return (MRESULT)0;
}
/********************** End ofProdinfo dialog procedure ****************/

/****************************************************************
 *  Name:   DisplayMessage
 *
 *  Description : Displays error messages.
 *
 *  Concepts : Displays a message box containing an error
 *	       message each time called.
 *
 *  API's : WinMessageBoxNon
 *
 * Parameters	: str - error message to display
 *
 *  Returns:  Void
 *
 ****************************************************************/
VOID DisplayMessage(PCH str)
{
  /*
   * This routine calls WinMessageBox to dsplay error messages to the
   * user.
   */

  WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, (PCH) str,
     (PCH) "Error Messages For The Dialog Sample", ID_MESSAGEBOX,
     MB_OK | MB_APPLMODAL | MB_MOVEABLE | MB_ERROR);
}
/******************* End of DisplayMessage procedure ********************/
/***********************************************************
 * Name		: SetSysMenu
 *
 * Description	: Procedure to remove unselectable items from
 *		  the window system menu.
 *
 * Concepts	: This routine determines the number of items
 *		  in the system menu, loops through those
 *		  items removing disabled menu items and menu
 *		  seperators.
 *
 * API's        : WinMessageBox
 *
 * Parameters	: None
 *
 * Return	: None
 *
 **************************************************************/
VOID SetSysMenu(HWND hwndDlg)
{
  SHORT sMenuItems;
  USHORT usItemid;
  MENUITEM menuItem;
  HWND	hwndSubMenu;

  /* Determine the definition of the system menu */
  WinSendDlgItemMsg(hwndDlg,(SHORT)FID_SYSMENU, MM_QUERYITEM,
		    MPFROM2SHORT((SHORT)SC_SYSMENU,FALSE),
		    MPFROMP(&menuItem));

  hwndSubMenu = menuItem.hwndSubMenu;

  /* Find the number of items in the in the submenu */
  sMenuItems = (SHORT)WinSendMsg(hwndSubMenu,
				 MM_QUERYITEMCOUNT,NULL,NULL);
  /*
   * Loop through the submenu items and remove disabled
   * menu items and menu separators.
   */
  for (; sMenuItems >= 0 ;sMenuItems-- )
  {
    /* Find the item ID for the current position. */
    usItemid = (USHORT)WinSendMsg(hwndSubMenu,MM_ITEMIDFROMPOSITION,
			 MPFROMSHORT(sMenuItems), NULL);

    /* Query the definition of the current item*/
    WinSendMsg(hwndSubMenu, MM_QUERYITEM,
	       MPFROM2SHORT(usItemid,FALSE), MPFROMP(&menuItem));

   /*
    * If the menu item is disabled or the item has a style
    * of MIS_SEPARATOR - delete it.
    */
    if ((BOOL)(WinSendMsg(hwndSubMenu, MM_QUERYITEMATTR,
	  MPFROM2SHORT(usItemid,FALSE), (MPARAM)MIA_DISABLED)) ||
	  (menuItem.afStyle & MIS_SEPARATOR))
    {
      WinSendMsg(hwndSubMenu, MM_DELETEITEM,
		MPFROM2SHORT(usItemid,FALSE),NULL);
    }
  } /* endfor */
}
/******************* End of SetSysMenu() procedure ********************/
/*static char *SCCSID = "@(#)dialogs.c  6.6 92/02/18";*/
/*=========================================================================\
 *									   *
 *	 FILE:dialogs.c							   *
 *									   *
 *	 DESCRIPTION:	 Dialog procedures for PM clock			   *
 *									   *
 *									   *
 *									   *
 *	Copyright 1989, 1990, 1992 IBM Corp.				   *
 *									   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have been *
 *	advised of the possibility of	such damages.			   *
 *									   *
 *-------------------------------------------------------------------------*
 *
 *--------------------------------------------------------------
 *
 *  This source file contains the following functions:
 *
 *  ClkTicksDlgProc()
 *  AlarmDialogsProc()
 *  AboutBoxDialogProc()
 *  SetAlarmField()
 *  GetAlarmTime()
 *  AlarmVScrolls()
 *  EntryFieldSubProc()
 *  AlarmSetTimer()
 *  ClkColorsDlgProc()
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/

#define INCL_WININPUT
#define INCL_WINFRAMEMGR
#define INCL_WINTRACKRECT
#define INCL_WINMENUS
#define INCL_WINSYS
#define INCL_WINTIMER
#define INCL_WINMESSAGEMGR
#define INCL_WINDIALOGS
#define INCL_WINBUTTONS
#define INCL_WINENTRYFIELDS
#define INCL_WINWINDOWMGR
#define INCL_WINSCROLLBARS
#define INCL_GPITRANSFORMS
#define INCL_GPIPRIMITIVES
#define INCL_GPILOGCOLORTABLE
#define INCL_DOSSEMAPHORES
#define INCL_DOSDATETIME

#include <os2.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "clock.h"
#include "res.h"
#include "clkdata.h"
/*--------------------------------------------------------------*\
 *  Global variables  and definitions for this file
\*--------------------------------------------------------------*/

/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/

VOID InitAlarm(HWND);
VOID AlarmSet(HWND);
VOID SetAlarmField(HWND, UCHAR, UCHAR);
VOID GetAlarmTime(HWND, UCHAR *, UCHAR *);
VOID AlarmVScrolls(HWND, USHORT, MPARAM);
VOID AlarmSetTimer(UCHAR uchHour,UCHAR uchMinutes );

MRESULT EXPENTRY AlarmDlgProc(HWND hwnd , ULONG usItem,
			       MPARAM mp1, MPARAM mp2 );
MRESULT EXPENTRY EntryFieldSubProc(HWND hwnd, ULONG usItem,
				     MPARAM mp1, MPARAM mp2 );
/**************************************************************************\
*									   *
*	ROUTINE:    ClkTicksDlgProc ( )					   *
*									   *
*	COMMENT:    "Ticks..." dialog					   *
*									   *
*	RETURNS:    MRESULT, 0 or return value from WinDefDlgProc	   *
*									   *
\**************************************************************************/

MRESULT EXPENTRY ClkTicksDlgProc ( HWND hwnd , ULONG usMsg ,
				   MPARAM mp1 , MPARAM mp2 )
{
    static USHORT usMajorTickSel ;
    static USHORT usMinorTickSel ;
    USHORT usButtonID ;

    switch ( usMsg ) {

	case WM_INITDLG :

	    /* show the current major tick preference */
	    WinSendMsg ( WinWindowFromID ( hwnd ,
					   ( CLKTM_MAJOR | cp.usMajorTickPref) ) ,
			 BM_SETCHECK , MPFROM2SHORT ( TRUE , NULL ) , MPVOID) ;

	    /* show the current minor tick preference */
	    WinSendMsg (  WinWindowFromID ( hwnd ,
					   (CLKTM_MINOR | cp.usMinorTickPref) ) ,
			  BM_SETCHECK ,
			  MPFROM2SHORT ( TRUE , 0 ) ,
			  MPVOID ) ;

	    /* load the selection values from the preferences */
	    usMajorTickSel = cp.usMajorTickPref ;
	    usMinorTickSel = cp.usMinorTickPref ;

	    /* let the default dialog procedure handle anything else */
	    break ;

	case WM_COMMAND :

	    switch ( LOUSHORT ( mp1 ) ) {

		case DID_OK :

		    /* store away selections as preferences */
		    cp.usMajorTickPref = usMajorTickSel ;
		    cp.usMinorTickPref = usMinorTickSel ;

		    /* repaint with the new preferences */
		    WinInvalidateRect ( hwndFrame , NULL, TRUE ) ;

		case DID_CANCEL :
		    WinDismissDlg ( hwnd , TRUE ) ;
	    }

	    return NULL ;

	case WM_CONTROL :

	    if ( SHORT2FROMMP ( mp1 ) == BN_CLICKED ) {

		usButtonID = SHORT1FROMMP ( mp1 ) ;

		switch ( usButtonID & 0xff00 ) {

		    case CLKTM_MAJOR :
			usMajorTickSel = LOBYTE ( usButtonID ) ;
			break ;

		    case CLKTM_MINOR :
			usMinorTickSel = LOBYTE ( usButtonID ) ;
			break ;
		}
	    }

	    /* fall through to the default control processing */
    }

    return WinDefDlgProc ( hwnd , usMsg , mp1 , mp2 ) ;
}
/**************************************************************************\
*									   *
*	ROUTINE:    AlarmDlgProc ( )					*
*									   *
*	COMMENT:    "Alarm..." dialog					   *
*									   *
*	RETURNS:    MRESULT, 0 or return value from WinDefDlgProc	   *
*									   *
\**************************************************************************/

MRESULT EXPENTRY AlarmDlgProc ( HWND hwnd , ULONG usMsg ,
				   MPARAM mp1 , MPARAM mp2 )
{

    switch ( usMsg ) {

	case WM_INITDLG :
	    hAlarmTime = hwnd; /*put in a global var, so everybody know we already
				have an opened dialog box*/
	    InitAlarm(hwnd);

	    break ;

	case WM_COMMAND :

	    switch ( LOUSHORT ( mp1 ) ) {

		case DID_OK :
		    AlarmSet(hwnd);


		case DID_CANCEL :
		    hAlarmTime = (HWND)NULL;
		    WinDismissDlg ( hwnd , TRUE ) ;
	    }

	    return NULL ;

	case WM_CONTROL :
	    break;

	case WM_VSCROLL:
	    AlarmVScrolls( hwnd,
			   HIUSHORT(mp2),
			   mp1	   );
	    break;

    }

    return WinDefDlgProc ( hwnd , usMsg , mp1 , mp2 ) ;
}
/**********************************************************************
* InitAlarm
*
************************************************************************/
void InitAlarm(HWND hwnd)
{

    USHORT usItem;
    MPARAM Message;

    WinSendMsg( WinWindowFromID(hwnd,SCROLL_HOURS),SBM_SETSCROLLBAR,
		MPFROMLONG(2),
		MPFROM2SHORT(1,3));
    WinSendMsg( WinWindowFromID(hwnd,SCROLL_MINUTES),SBM_SETSCROLLBAR,
		MPFROMLONG(2),
		MPFROM2SHORT(1,3));
    WinSendDlgItemMsg( hwnd,
		       IDC_HOURMINUTES,
		       EM_SETTEXTLIMIT,
		       MPFROMLONG(5),
		       MPVOID );
    SetAlarmField(hwnd,cp.alarm.uchHour,cp.alarm.uchMinutes);
    WinSendDlgItemMsg ( hwnd ,IDC_HOURMINUTES, EM_SETSEL , MPFROM2SHORT(0,0),
			MPVOID	) ;
    pfnwpEntryField = WinSubclassWindow( WinWindowFromID(hwnd,
							IDC_HOURMINUTES),
					  EntryFieldSubProc);
    usItem = (USHORT) (cp.alarm.usMode & AM_ACTIVE ?RB_ALARMON:RB_ALARMOFF );
    WinSendDlgItemMsg( hwnd,
		       usItem,
		       BM_SETCHECK,
		       MPFROMLONG(1),
		       MPVOID);
    Message = (cp.alarm.usMode & AM_AUDIO )? MPFROMLONG(1):MPFROMLONG(0);
    WinSendDlgItemMsg( hwnd,
		       IDC_BEEP,
		       BM_SETCHECK,
		       Message,
		       MPVOID);

    Message = (cp.alarm.usMode & AM_MSGBOX) ? MPFROMLONG(1):MPFROMLONG(0);
    WinSendDlgItemMsg( hwnd,
		       IDC_MSG,
		       BM_SETCHECK,
		       Message,
		       MPVOID);

}
/**************************************************************************
* AlarmSet
***************************************************************************/
VOID AlarmSet(HWND hwnd)
{



    GetAlarmTime(hwnd,&cp.alarm.uchHour,&cp.alarm.uchMinutes);
    cp.alarm.usMode = (AM_ACTIVE * ((ULONG)WinSendDlgItemMsg( hwnd,
						    RB_ALARMON,
						    BM_QUERYCHECK,
						    MPVOID,
						    MPVOID)))
		      |
		      (AM_AUDIO	 * ((ULONG)WinSendDlgItemMsg( hwnd,
						    IDC_BEEP  ,
						    BM_QUERYCHECK,
						    MPVOID,
						    MPVOID)))
		      |
		      (AM_MSGBOX * ((ULONG)WinSendDlgItemMsg( hwnd,
						    IDC_MSG   ,
						    BM_QUERYCHECK,
						    MPVOID,
						    MPVOID ) ) );
	  AlarmSetTimer(cp.alarm.uchHour,
			      cp.alarm.uchMinutes);

}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    1 - if sucessful execution completed
 *	    0 - if error
\****************************************************************/

VOID AlarmSetTimer(UCHAR uchHour,UCHAR uchMinutes )
{


    DATETIME DateTime;
    time_t  UTCCurrentTime,UTCAlarmTime;
    struct  tm	tmTime;

    memset(&DateTime,0,sizeof(DATETIME) );
    memset(&tmTime,0,sizeof(struct tm) );

    /*
     *get our current time
     *then use mktime to get the
     *UTC time
     */
     DosGetDateTime(&DateTime);
     tmTime.tm_min   = DateTime.minutes;
     tmTime.tm_hour  = DateTime.hours;
     tmTime.tm_mday  = DateTime.day;
     tmTime.tm_sec   = DateTime.seconds;
     tmTime.tm_mon   = --DateTime.month;
     tmTime.tm_year  = (DateTime.year - 1900);

     UTCCurrentTime =  mktime(&tmTime);

     /*
      *if the alarm time is less than the current  time
      *then the alarm must be for tomorrow
      */
     if( uchHour < DateTime.hours  ||
	       (DateTime.hours == cp.alarm.uchHour
	       && uchMinutes < DateTime.minutes ) )
     {
	  DateTime.day++;
     }
     /*
      *get the time
      *in UTC format for
      *the timer to expire
      */
     tmTime.tm_min   = uchMinutes;
     tmTime.tm_hour  = uchHour;
     tmTime.tm_mday  = DateTime.day;
     tmTime.tm_sec   = 0;
     tmTime.tm_isdst = 0;

     /*
      *set the timer value for the
      *difference between our  current time
      *and the alarm time ( in milliseconds)
      */
     UTCAlarmTime = mktime(&tmTime);
     TimerResources.ulTimerValue  = ( UTCAlarmTime  - UTCCurrentTime)
					  * 1000L ;
     /*
      *post the timer
      */
      DosPostEventSem(TimerResources.hTimerDev);

}


/**************************************************************************\
*									   *
*	ROUTINE:    ClkColorsDlgProc ( )				   *
*									   *
*	COMMENT:    "Clock Color Preferences" Dialog			   *
*									   *
*	RETURNS:    MRESULT, 0 or return value from WinDefDlgProc	   *
*									   *
\**************************************************************************/
MRESULT EXPENTRY ClkColorsDlgProc ( HWND hwnd , ULONG usMsg ,
				   MPARAM mp1 , MPARAM mp2 )
{
    USHORT usButtonID;
    static USHORT usCheckedPartID=0, usCheckedColorID=0;
    HWND hwndButton;
    HPS hpsT;
    RECTL rclButton , rclButtonInterior;
    static LONG clrBackgroundNew;
    static LONG clrFaceNew;
    static LONG clrHourHandNew;
    static LONG clrMinuteHandNew;
    static LONG *pclrNew;
    MRESULT rc;

    switch (usMsg)
    {

	case WM_INITDLG :
	    hpsT = WinGetPS(hwnd);

	    GpiCreateLogColorTable(hpsT, LCOL_RESET, LCOLF_RGB, 0L, 0L,(PLONG)NULL);

	    /* load the new values from the current ones */
	    clrBackgroundNew = GpiQueryColorIndex(hpsT, 0L, cp.clrBackground);

	    clrFaceNew = GpiQueryColorIndex(hpsT, 0L, cp.clrFace);
	    clrHourHandNew = GpiQueryColorIndex(hpsT, 0L, cp.clrHourHand);
	    clrMinuteHandNew = GpiQueryColorIndex(hpsT, 0L, cp.clrMinuteHand);

	    WinReleasePS(hpsT);

	    /* click the "Background" radio button */
	    WinPostMsg ( WinWindowFromID ( hwnd , CLKCLR_BACKGROUND ) ,
			 BM_CLICK , MPFROMSHORT ( TRUE ) , MPVOID) ;

	    /* let the default dialog procedure handle anything else */
	    break;

	case WM_COMMAND :

	    switch ( LOUSHORT ( mp1 ) ) {
		case DID_OK:
		    hpsT = WinGetPS(hwnd);

		    GpiCreateLogColorTable( hpsT,LCOLF_RGB,
					    0L, 0L, 0L,NULL );

		    /*
		     *update the one the user has
		     *selected
		     */
		    switch( usCheckedPartID )
		    {
		    case CLKCLR_BACKGROUND:
			 cp.clrBackground = GpiQueryRGBColor(hpsT, 0L,
						clrBackgroundNew);
			 break;
		    case CLKCLR_FACE:
			 cp.clrFace = GpiQueryRGBColor(hpsT, 0L,
					     clrFaceNew);
			 break;
		    case CLKCLR_HOURHAND:
			 cp.clrHourHand = GpiQueryRGBColor(hpsT, 0L,
					     clrHourHandNew);
			 break;
		    case CLKCLR_MINUTEHAND:
			 cp.clrMinuteHand = GpiQueryRGBColor(hpsT, 0L,
					     clrMinuteHandNew);
			 break;
		    }
		    WinReleasePS(hpsT);

		    /* repaint with the new colors */
		    WinInvalidateRect (hwndFrame, NULL, TRUE);

		case DID_CANCEL:
		    WinDismissDlg(hwnd, TRUE);
	    }
	    return NULL ;

	case WM_CONTROL :

	    usButtonID = SHORT1FROMMP ( mp1 ) ;

	    /* selecting a new object */
	    if ( usButtonID & CLKCLR_OBJECTS ) {

		switch ( usButtonID ) {
		    case CLKCLR_BACKGROUND :
			pclrNew = &clrBackgroundNew ;
			break ;
		    case CLKCLR_FACE :
			pclrNew = &clrFaceNew ;
			break ;
		    case CLKCLR_HOURHAND :
			pclrNew = &clrHourHandNew ;
			break ;
		    case CLKCLR_MINUTEHAND :
			pclrNew = &clrMinuteHandNew ;

		}
		usCheckedPartID = usButtonID ;

		/* click the button for the new object's current color */
		rc=WinSendMsg (WinWindowFromID(hwnd, (CLKCLR_BUTTONSHIFT + *pclrNew)),
			     BM_CLICK , MPFROMSHORT ( TRUE ) , MPVOID) ;
		break ;
	    }

	    switch ( SHORT2FROMMP ( mp1 ) ) {

		case BN_CLICKED :

		    *pclrNew = ( LONG ) usButtonID - CLKCLR_BUTTONSHIFT ;

		    /* turn off the check state of the previously checked
		     * button and turn on the check state of the button
		     * just clicked */

		    WinCheckButton(hwnd, usCheckedColorID, FALSE);
		    WinCheckButton(hwnd, usButtonID, TRUE);
		    usCheckedColorID = usButtonID;

		    break ;

		case BN_PAINT :

		    /* fill only the interior of the button, so we don't
		     * conflict with the focus indicator */

		    hwndButton = ( ( PUSERBUTTON ) mp2 ) -> hwnd ;
		    WinQueryWindowRect ( hwndButton , &rclButton ) ;
		    rclButton . xLeft ++ ;
		    rclButton . yBottom ++ ;
		    rclButton . xRight -- ;
		    rclButton . yTop -- ;
		    WinFillRect ( ( ( PUSERBUTTON ) mp2 ) -> hps ,
				  &rclButton ,
				  ( LONG ) usButtonID - CLKCLR_BUTTONSHIFT ) ;

		    /* hollow out those buttons which aren't checked */
		    if (!WinQueryButtonCheckstate(hwnd, usButtonID))
		    {
			rclButtonInterior . xLeft = rclButton . xLeft + 4 ;
			rclButtonInterior . yBottom = rclButton . yBottom + 4 ;
			rclButtonInterior . xRight = rclButton . xRight - 4 ;
			rclButtonInterior . yTop = rclButton . yTop - 4 ;
			WinFillRect ( ( ( PUSERBUTTON ) mp2 ) -> hps ,
				      &rclButtonInterior , SYSCLR_WINDOW ) ;
		    }

		    break ;
	    }

	    /* fall through to the default control processing */
    }

    return WinDefDlgProc ( hwnd , usMsg , mp1 , mp2 ) ;
}


/**************************************************************************\
*									   *
*	ROUTINE:    EntryFieldSubProc					   *
*									   *
*	COMMENT:    "Alarm..." dialog					   *
* This procedure filter messages for the entry field and make it a time	   *
* entry field. It doesn't allow for illigal characters according to the    *
* current selection. It doesn't allow modification of the time seperator.  *
* It works only for hours and minutes. The entry field has to be limited   *
* to 5 characters.							   *
*									   *
*									   *
*									   *
*	RETURNS:    MRESULT, 0 or return value from WinDefDlgProc	   *
*									   *
\**************************************************************************/

MRESULT EXPENTRY EntryFieldSubProc ( HWND hwnd , ULONG usMsg ,
				   MPARAM mp1 , MPARAM mp2 )
{
    USHORT usSelect,fsKeyFlags,usLast;
    UCHAR usChr1;
    UCHAR uchHourMinutes[6];
    BOOL bValid;
    MRESULT mresult;
    MRESULT mresultSel;

    if ((usMsg > WM_MOUSEFIRST) && (usMsg < WM_MOUSELAST)) {
	mresult = pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ) ;

	mresultSel = pfnwpEntryField(hwnd,EM_QUERYSEL,(PLONG)NULL,(PLONG) NULL);
	usSelect = LOUSHORT(mresultSel);
	usLast = HIUSHORT(mresultSel);
	if ((usSelect == 2) )
	       pfnwpEntryField ( hwnd , EM_SETSEL , MPFROM2SHORT(3,3) ,
				(PVOID)NULL ) ;
	if ((usSelect == 5) )
	       pfnwpEntryField ( hwnd , EM_SETSEL , MPFROM2SHORT(4,4) ,
				    (PVOID)NULL) ;
	return(mresult);
    }

    switch ( usMsg ) {

    case WM_SETFOCUS:
	pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ) ;
	if (SHORT1FROMMP(mp2))
	    pfnwpEntryField  ( hwnd,
			       EM_SETINSERTMODE,
			       MPFROMSHORT(FALSE),
			       (MPARAM)NULL   );
	return(MPVOID);
    case WM_CHAR:

    fsKeyFlags = (USHORT) SHORT1FROMMP(mp1);	/* key flags		 */
    if (!(fsKeyFlags & KC_KEYUP)){
	usSelect = (USHORT)WinSendMsg(hwnd,EM_QUERYSEL,MPVOID,MPVOID);
	if (fsKeyFlags & KC_VIRTUALKEY) {
	    switch(SHORT2FROMMP(mp2)) {

		case VK_INSERT:
		    return(MPVOID);
		case VK_UP:
		    break;
		case VK_DOWN:
		    break;
		case VK_LEFT:
		    if (usSelect == 3)
			 pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ) ;
		    return pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ) ;
		    break;
		case VK_RIGHT:
		    if (usSelect == 4)
		    {
			 return(MPVOID);
		    }
		    if (usSelect == 1)
			 pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ) ;
		    return pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ) ;
		    break;
		case VK_DELETE:
		case VK_BACKSPACE:
		    return(MPVOID);
		case VK_SPACE:
		switch (usSelect) {
		case 0:	  /*Hours most significant digit*/
		    if (bTwelveHourFormat) {
			  return(pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 )) ;
		    }

		default:
		    return(MPVOID);
		}

		default:
		    return pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ) ;
		    break;
	    }
	}
	else
	{
	    if (fsKeyFlags & KC_CHAR )
	    {
		bValid = FALSE;
		WinQueryWindowText(hwnd,sizeof(uchHourMinutes),uchHourMinutes);
		usChr1 = (UCHAR) CHAR1FROMMP(mp2);
		switch (usSelect) {
		case 0:	  /*Hours most significant digit*/
		    if (bTwelveHourFormat)
		    {
			if ((usChr1 > '1') || (usChr1 < '0'))
			{
			      return(MPVOID);
			}
			else
			{
			    pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ) ;
			    bValid = TRUE;
			}
		    }
		    else
		    {
			if ((usChr1 > '2') || (usChr1 < '0'))
			{
			      return(MPVOID);
			}
			else
			{
			    pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ) ;
			    bValid = TRUE;
			}

		    }
		    if (bValid)
		    {
			uchHourMinutes[0] = usChr1;
			uchHourMinutes[1] = '0';
			WinSetWindowText(hwnd,uchHourMinutes);
			pfnwpEntryField ( hwnd , EM_SETSEL , MPFROM2SHORT(1,1) ,
					    (PLONG)NULL ) ;
		    }
		    return(MPVOID);
		    break;
		case 1:
		    if (bTwelveHourFormat) {
			if ((uchHourMinutes[0] == '0') || (uchHourMinutes[0] == ' ') ) {
			    if ((usChr1 > '9') || (usChr1 < '0'))
			    {
				 return(MPVOID);
			    }

			    else
			    {
				pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ) ;
				bValid = TRUE;
			    }
			}
			else {/*prbably 1*/
			    if ((usChr1 > '2') || (usChr1 < '0') )
			    {
				return(MPVOID);
			    }
			    else
			    {
				pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ) ;
				bValid = TRUE;
			    }
			}
		    }
		    else {
			if (uchHourMinutes[0] < '2') {
			    if ((usChr1 > '9') || (usChr1 < '0'))
			    {
				   return(MPVOID);
			    }
			    else
			    {
				pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ) ;
				bValid = TRUE;
			    }
			}
			else
			{
			    if ((usChr1 > '4') || (usChr1 < '0'))
			    {
				   return(MPVOID);
			    }
			    else
			    {
				pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ) ;
				bValid = TRUE;
			    }
			}
		    }
		    /*Full the entryfield as if a time seperator is in also*/
		    if (bValid) {
			mp2 = (MPARAM)(((ULONG)mp2 & 0xffffff00) | szTimeSep[0]);
			return (pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ));
		    }
		    break;

		case 3:	  /*minutes left digit, 0-5*/
		    if ((usChr1 > '5') || (usChr1 < '0'))
		    {
			 return(MPVOID);
		    }
		    else return (pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 )) ;
		    break;
		case 4:	  /*minutes right digit, 0-9*/
		    if ((usChr1 > '9') || (usChr1 < '0'))
		    {
			 return(MPVOID);
		    }
		    else
		    {
			pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ) ;
			return (pfnwpEntryField (hwnd,EM_SETSEL,MPFROM2SHORT(4,4),MPVOID )) ;
		    }
		    break;

		}
	    }
	}
    }

    default:
	return pfnwpEntryField ( hwnd , usMsg , mp1 , mp2 ) ;
    }
}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:AlarmScrolls()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    1 - if sucessful execution completed
 *	    0 - if error
\****************************************************************/
VOID  AlarmVScrolls(HWND hwnd,USHORT ScrollMsg,MPARAM idScroll)
{
  UCHAR uchHours,uchMinutes;

    GetAlarmTime(hwnd,&uchHours,&uchMinutes);

    switch(ScrollMsg)
    {
    case SB_LINEUP:
    case SB_PAGEUP:
	if (idScroll == (MPARAM)SCROLL_HOURS)
	    if (uchHours == 23) uchHours = 0;
	    else uchHours++;
	else
	    if (uchMinutes == 59) uchMinutes = 0;
	    else uchMinutes++;
	break;


    case SB_LINEDOWN:
    case SB_PAGEDOWN:
	if (idScroll == (MPARAM)SCROLL_HOURS)
	    if (uchHours == 0) uchHours = 23;
	    else uchHours--;
	else
	    if (uchMinutes == 00) uchMinutes = 59;
	    else uchMinutes--;
	break;


    }
    SetAlarmField(hwnd,uchHours,uchMinutes);
    WinSendDlgItemMsg ( hwnd ,
			IDC_HOURMINUTES,
			EM_SETSEL ,
			(idScroll == (MPARAM)SCROLL_HOURS) ?MPFROM2SHORT(0,0):MPFROM2SHORT(3,3),
			 MPVOID ) ;
}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:GetAlarmTime()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *	    VOID
\****************************************************************/
VOID GetAlarmTime(HWND hwnd,UCHAR *npuchHours,UCHAR *npuchMinutes)
{
    UCHAR achHourMinutes[5];
    UCHAR uchHours;

    WinQueryDlgItemText(hwnd,IDC_HOURMINUTES,sizeof(achHourMinutes) + 1,achHourMinutes);
    uchHours = (UCHAR)atoi(achHourMinutes);

    if (bTwelveHourFormat)
    {
	if (WinSendDlgItemMsg( hwnd,
	     RB_PM     ,
	     BM_QUERYCHECK,
	     MPVOID,
	     MPVOID))
	{
	     if (uchHours != 12)
		  uchHours += 12;
	}
	else
	{
	    if (uchHours == 12) uchHours = 0;
	}
    }
    *npuchHours = uchHours;
    *npuchMinutes = (UCHAR)atoi(&achHourMinutes[3]);

}


/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:SetAlarmField
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    1 - if sucessful execution completed
 *	    0 - if error
\****************************************************************/
VOID SetAlarmField(HWND hwnd,UCHAR uchHours,UCHAR uchMinutes)
{
    UCHAR achHourMinutes[5];


    if (bTwelveHourFormat)
    {
	if (uchHours >= 12)
	{
	    uchHours -= 12;
	    WinSendDlgItemMsg( hwnd,
			       RB_PM,
			       BM_SETCHECK,
			       MPFROMLONG(1),
			       MPVOID);
	    if (uchHours == 0)
		    uchHours = 12;
	}
	else
	{
	    if (uchHours == 0) uchHours = 12;
	    WinSendDlgItemMsg( hwnd,
			       RB_AM,
			       BM_SETCHECK,
			       MPFROMLONG(1),
			       MPVOID);
	}

    }
    else
    {
	WinShowWindow(WinWindowFromID(hwnd,RB_PM),FALSE);
	WinShowWindow(WinWindowFromID(hwnd,RB_AM),FALSE);
    }
    itoa(uchHours,achHourMinutes,10);
    itoa(uchMinutes,&achHourMinutes[3],10);
    achHourMinutes[2] = szTimeSep[0];
    if (achHourMinutes[1] == 0)
    {
	achHourMinutes[1] = achHourMinutes[0];
	achHourMinutes[0] = ' ';
    }
    if (achHourMinutes[4] == 0) {
	achHourMinutes[4] = achHourMinutes[3];
	achHourMinutes[3] = '0';
    }
    WinSetDlgItemText(hwnd,IDC_HOURMINUTES,achHourMinutes);
}

/****************************************************************\
 *  Dialog procedure for the About dialog box
 *--------------------------------------------------------------
 *
 *  Name:   AboutBoxDlgProc(hwnd, msg, mp1, mp2)
 *
 *  Purpose: Processes all messages sent to the About Box
 *
 *  Usage:  Called for each message sent to the About Box
 *	    dialog box.
 *
 *  Method: the about box only has a button control so this
 *	    routine only processes WM_COMMAND messages.	 Any
 *	    WM_COMMAND posted must have come from the Ok
 *	    button so we dismiss the dialog upon receiving it.
 *
 *  Returns: Dependent upon message sent
 *
\****************************************************************/
MRESULT EXPENTRY AboutBoxDlgProc(HWND hwnd, ULONG msg, MPARAM mp1,
				     MPARAM mp2 )
{
    switch(msg)
    {
	case WM_COMMAND:
	    /* no matter what the command, close the dialog */
	    WinDismissDlg(hwnd, TRUE);
	    break;

	default:
	    return(WinDefDlgProc(hwnd, msg, mp1, mp2));
	    break;
    }

    return(MPVOID);

}   /* AboutBoxWndProc() */


/*--------------------------------------------------------------*\
 *  End of file :dialogs.c
\*--------------------------------------------------------------*/
/*static char *SCCSID = "@(#)digital.c  6.4 92/02/18";*/
/*=========================================================================\
 *									   *
 *	 FILE:digital.c							   *
 *									   *
 *	 DESCRIPTION: This file contains the routines necessary for	   *
 *		      updating the digital clock face			   *
 *									   *
 *									   *
 *	Copyright 1989, 1990, 1992 IBM Corp.				   *
 *									   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have been *
 *	advised of the possibility of	such damages.			   *
 *									   *
 *-------------------------------------------------------------------------*
 *--------------------------------------------------------------
 *
 *  This source file contains the following functions:
 *
 *  ClkDrawDigitalString()
 *
 *
 *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/

#define INCL_WIN
#define INCL_GPI
#define INCL_DOSSEMAPHORES
#define INCL_DOSDATETIME
#include <os2.h>
#include <string.h>
#include "clock.h"
#include "res.h"
#include "clkdata.h"




/*--------------------------------------------------------------*\
 *  Global variables  and definitions for this file
\*--------------------------------------------------------------*/
POINTL aptlSeg1[] =
{
    {  2, 40 },
    { 18, 40 },
    { 20, 42 },
    {  0, 42 },
};
/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/

/****************************************************************\
 *  Routine Name:
 *--------------------------------------------------------------
 *
 *  Name: ClkDrawDigitalString()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:VOID
 *
 *
\****************************************************************/
VOID ClkDrawDigitalString(HPS hps, char *psz, RECTL *prcl,
			  LONG clrFore, LONG clrBack)
{

    RECTL rclDevice;
    RECTL rclChar;
    USHORT cch, cxChar, cyChar, cxSegment, cySegment, i;
    LONG lPSid;
    USHORT xRemainder;

    /*
     * Do things in device coordinates to avoid problems with rounding.
     */
    rclDevice = *prcl;
    GpiConvert(hps, CVTC_WORLD, CVTC_DEVICE, 2L, (PPOINTL)&rclDevice);

    /*
     * Save and reset the PS to the default state.
     */
    lPSid = GpiSavePS(hps);
    GpiResetPS(hps, GRES_ATTRS);

    /*
     * Go into RGB mode
     */
    GpiCreateLogColorTable(hps, 0L, LCOLF_RGB, 0L, 0L, NULL);

    cch = (USHORT)strlen(psz);

    /*
     * How wide and how tall will each character be?
     */
    cxChar = (USHORT)(rclDevice.xRight - rclDevice.xLeft) / cch;
    cyChar = (USHORT)(rclDevice.yTop   - rclDevice.yBottom);

    cxSegment = cxChar / (USHORT)5;

    /*
     * Find out how much, if any we'll need to center the
     * digits by.
     */
    xRemainder = (USHORT)(rclDevice.xRight - rclDevice.xLeft) % cch;

    WinSetRect(NULLHANDLE, &rclChar,
	       (rclDevice.xLeft + (xRemainder / 2) ),
	       (rclDevice.yBottom),
	       ( (rclDevice.xLeft + (xRemainder / 2)) + cxChar - cxSegment),
	       (rclDevice.yBottom + cyChar) );

    for (i = 0; i < cch; i++)
    {
	WinDrawBorder(hps, &rclChar, cxSegment, cySegment, clrFore, clrBack,
		DB_INTERIOR);
	WinOffsetRect(NULLHANDLE, &rclChar, cxChar, 0);
    }

    /*
     * Put it back like we found it.
     */
    GpiRestorePS (hps, lPSid);
}


/*--------------------------------------------------------------*\
 *  End of file : digital.c
\*--------------------------------------------------------------*/
/*=========================================================================\
 *									   *
 *	 FILE:disp.c							   *
 *									   *
 *	 DESCRIPTION:							   *
 *									   *
 *									   *
 *									   *
 *-------------------------------------------------------------------------*
 *	Created 1991  IBM Corp.						   *
 *									   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *	*
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have been *
 *	advised of the possibility of	such damages.			   *				   *
 *-------------------------------------------------------------------------*
 *
 *  This source file contains the following functions:
 *
 *
 *  Disp()
 *
 *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/
#define	 INCL_VIO
#define	 INCL_KBD
#define	 INCL_MOU
#define	 INCL_DOSPROCESS
#include <os2.h>
#include <string.h>
#include "worms.h"
#include "wrmthrd.h"


/*--------------------------------------------------------------*\
 *  Global variables  and definitions for this file
\*--------------------------------------------------------------*/
/*
 *use a character cell
 *combo attribute for the
 *heading
 */

CHAR *pszMainWindow1=
" \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27W\27O\27R\27M\27S\27 \27 \27\
 \27 \27 \27 \27M\27I\27X\27E\27D\27 \27M\27O\27D\27E\27 \27 \27 \27 \27P\27R\27O\27G\27R\27A\27M\27 \27 \27 \27\
 \27 \27 \27 \27 \27 \27 \27 \27S\27A\27M\27P\27L\27E\27 \27 \27 \27 \27 \27 \27 \27 \27 \27";

CHAR *pszMainWindow2=
"\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\
\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\
\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27\27";


CHAR *pszMainWindow3=
" \27 \27 \27 \27 \27A\24d\27d\27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27D\24e\27l\27e\27t\27e\27\
 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27 \27E\24x\27i\27t\27 \27 \27 \27 \27 \27\
 \27 \27 \27 \24 \24 \27H\24e\27l\27p\27 \27 \27 \27 \27 \27 \27 \27 \27 \27";

USHORT usSize;
#define SIZ_WIND_BUFFER	     8192

/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/

/****************************************************************\
 *  Routine Name:DispMainWindow()
 *--------------------------------------------------------------
 *
 *  Name:WindMainDisp()
 *
 *  Purpose:
 *    Display the main window for the worms program.
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
VOID WindMainDisp( VOID )
{
     BYTE bCell[2];

     bCell[0] = 0x20;
     bCell[1] = ( WM_BLUE << 4 ) + WM_WHITE ;

     /*
      *clear the screen
      */
     VioScrollDn(TOP_ROW,LEFT_COL,0xFFFF,0xFFFF,0xFFFF,bCell,hvio);
     /*
      *display the main window
      */
     VioWrtCellStr(pszMainWindow1,strlen(pszMainWindow1),
		       TOP_ROW,LEFT_COL,hvio );

     VioWrtCellStr(pszMainWindow2,strlen(pszMainWindow2),
		       TOP_ROW + 1,LEFT_COL,hvio );

     VioWrtCellStr(pszMainWindow3,strlen(pszMainWindow3),
		       TOP_ROW + 2,LEFT_COL,hvio );
}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:SaveScreen()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    FALSE - if sucessful execution completed
 *	    TRUE  - if error
\****************************************************************/
BOOL
SaveScreen( PVOID *ppvWindow )
{


     usSize = SIZ_WIND_BUFFER;

     /*
      *allocate a buffer big enough to
      *save the full screen size plus the attribute
      */
     if(DosAllocMem(ppvWindow,(ULONG)usSize,fALLOC)  )
     {
	  return(TRUE);

     }
     VioReadCellStr(*ppvWindow,&usSize,TOP_ROW,LEFT_COL,
				   hvio );
     return(FALSE);

}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ReDisplayScreen()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	     VOID
 *
\****************************************************************/
VOID
ReDisplayScreen(PVOID pvWindBuf )
{


      VioWrtCellStr(pvWindBuf,usSize,TOP_ROW,LEFT_COL,
				   hvio );

      /*
       *free up the memory we allocated
       */
      DosFreeMem(pvWindBuf);

}
/*--------------------------------------------------------------*\
 *  End of file : disp.c
\*--------------------------------------------------------------*/
/*static char *SCCSID = "@(#)dlapi_dg.c 6.13 92/03/18";*/
/*==============================================================*\
 *  DLL_DLG.C - window procedures for the dialog boxes as well	*
 *		as utility procedures used by them		*
 *     (C) Copyright IBM Corporation 1992.			*
 *--------------------------------------------------------------*
 *								*
 *  This module contains the Dialog Procedures for the user	*
 *  defined dialogs as well as any support code they need	*
 *								*
 *--------------------------------------------------------------*
 *								*
 *  This source file contains the following functions:		*
 *								*
 *    GetPatternDlgProc(hwnd, msg, mp1, mp2)			*
 *    DispFileDlgProc  (hwnd, msg, mp1, mp2)			*
 *    DisplayFile      (hwnd, rect, pFile)			*
 *    OpenDlgProc      (hwnd, msg, mp1, mp2)			*
 *    DisplayDlgProc   (hwnd, msg, mp1, mp2)			*
 *    MathDlgProc      (hwnd, msg, mp1, mp2)			*
 *    ResultDlgProc    (hwnd, msg, mp1, mp2)			*
 *								*
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#include "dllapi.h"

/****************************************************************\
 *  Dialog procedure for the Path/Pattern dialog		*
 *--------------------------------------------------------------*
 *								*
 *  Name:    GetPatternDlgProc(hwnd, msg, mp1, mp2)		*
 *								*
 *  Purpose: Processes all messages sent to the Pattern dialog	*
 *								*
 *  Usage:   Called for each message sent to the dialog box.	*
 *								*
 *  Method:  a switch statement branches to the routines to be	*
 *	     performed for each message processed. Any messages *
 *	     not specifically processed are passed to the	*
 *	     default window procedure WinDefDlgProc()		*
 *								*
 *  Returns: Dependent upon message sent			*
 *								*
\****************************************************************/
MRESULT EXPENTRY GetPatternDlgProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
   static POBJSTRUCT pObj=NULL;
   static CHAR	 szBuffer[CCHMAXPATH];
   ULONG  ulDriveMap, ulDriveNum=0L, ulDirLen = CCHMAXPATH;
   SHORT  sIndex;
   MRESULT sRC;

   switch (msg)
   {
      case WM_INITDLG:

	  pObj = PVOIDFROMMP(mp2);
	  FixSysMenu(hwnd);
						  /* Get current drive */
	  DosQueryCurrentDisk(&ulDriveNum, &ulDriveMap);
	  memset(szBuffer, 0, sizeof(szBuffer));
	  szBuffer[0] = (CHAR)(ulDriveNum + '@');
	  strcpy(pObj->szCurDriver, szBuffer);
	  *(pObj->szCurDriver+1) = ':';
				 /* Get current dir & attach disk num. */
	  DosQueryCurrentDir(0L, pObj->szCurPath, &ulDirLen);
	  if(*(pObj->szCurPath+strlen(pObj->szCurPath)-1) != '\\')
	     strcat(pObj->szCurPath, "\\");	/* Add '\' at the tail */

	  memset(szBuffer, 0, sizeof(szBuffer));
	  strcpy(szBuffer, pObj->szCurDriver);
	  if(*(pObj->szCurPath) != '\\')
		  strcat(szBuffer,"\\");
	  strcat(szBuffer, pObj->szCurPath);/*Default path is current diver*/
	  WinSendDlgItemMsg(hwnd, IDD_PATH, EM_SETTEXTLIMIT,
			       MPFROM2SHORT(CCHMAXPATH, 0), NULL);
	  WinSetDlgItemText(hwnd, IDD_PATH, szBuffer);

	  if(*(pObj->szCurPattern) == '\000')
	     strcpy(pObj->szCurPattern, "*.*");	    /* Inition Pattern */
	  WinSetDlgItemText(hwnd, IDD_PATTERN, pObj->szCurPattern);

	  return((MRESULT)FALSE);
			/* Let the focus go to where the system puts it */
      case WM_COMMAND:
	  switch (SHORT1FROMMP(mp1)) {
	      case DID_OK:
						   /* Get new pattern */
		  memset(szBuffer,0,sizeof(szBuffer));
		  WinQueryDlgItemText(hwnd, IDD_PATTERN, MAX_EDIT_BUFF,
					szBuffer);
		  for (sIndex=0; szBuffer[sIndex]!='\000' &&
			 sIndex<MAX_EDIT_BUFF; sIndex++)
		  {
		     if (szBuffer[sIndex]>='a' && szBuffer[sIndex]<='z')
		     {
			szBuffer[sIndex] = szBuffer[sIndex] - (CHAR)' ';
		     }					     /* endif */
		  }					    /* endfor */
		  memset(pObj->szNewPattern,0,sizeof(pObj->szNewPattern));
		  if (*szBuffer == '\000')	 /* No input new path */
		     strcpy(pObj->szNewPattern,pObj->szCurPattern);
		  else				/* Store user pattern */
		     strcpy(pObj->szNewPattern,szBuffer);

						      /* Get new path */
		  memset(szBuffer,0,sizeof(szBuffer));
		  WinQueryDlgItemText(hwnd, IDD_PATH, CCHMAXPATH,
						 szBuffer);
		  for (sIndex=0; szBuffer[sIndex]!='\000' &&
			 sIndex<CCHMAXPATH; sIndex++)
		  {
		     if (szBuffer[sIndex]>='a' && szBuffer[sIndex]<='z')
		     {
			szBuffer[sIndex] = szBuffer[sIndex] - (CHAR)' ';
		     }					     /* endif */
		  }					    /* endfor */

		  memset(pObj->szNewDriver,0,sizeof(pObj->szNewDriver));
		  memset(pObj->szNewPath,0,sizeof(pObj->szNewPath));

		  if(*(szBuffer+strlen(szBuffer)-1) != '\\')
		     strcat(szBuffer, "\\");   /* Add '\' at the tail */
		  if (*szBuffer == '\000')	 /* No input new path */
		  {
		     strcpy(pObj->szNewDriver,pObj->szCurDriver);
		     strcpy(pObj->szNewPath,pObj->szCurPath);
		  }
		  else if(*(szBuffer+1) == ':') /* they specified a drive */
		  {
		     *(pObj->szNewDriver) = *szBuffer;/*Store disk number */
		     *((pObj->szNewDriver)+1) = *(szBuffer+1);
		     if(*(szBuffer+2) != '\\')		   /* If Path= c: */
		     {
			*(pObj->szNewPath) = '\\';	   /* Set path= \ */
		     }
							/*Store user path*/
		     strcat(pObj->szNewPath,(szBuffer+2));
		  }
		  else
		  {
		     strcpy(pObj->szNewDriver,pObj->szCurDriver);
		     strcpy(pObj->szNewPath,szBuffer);	 /* Store user path */
		  }
		  WinDismissDlg(hwnd, TRUE);
		  return((MRESULT)TRUE);

	      case DID_CANCEL:
		  WinDismissDlg(hwnd, FALSE);
		  return((MRESULT)TRUE);
	  }
	  break;

      case WM_CLOSE:
	  WinDismissDlg(hwnd, FALSE);
	  return((MRESULT)TRUE);

      default:
	  sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
	  return sRC;
   }
   return((MRESULT)TRUE);
}

/****************************************************************\
 *  Dialog procedure for the Display file dialog		*
 *--------------------------------------------------------------*
 *								*
 *  Name:    DispFileDlgProc(hwnd, msg, mp1, mp2)		*
 *								*
 *  Purpose: Processes all messages sent to the display dialog	*
 *								*
 *  Usage:   Called for each message sent to the dialog box.	*
 *								*
 *  Method:  a switch statement branches to the routines to be	*
 *	     performed for each message processed. Any messages *
 *	     not specifically processed are passed to the	*
 *	     default window procedure WinDefDlgProc()		*
 *								*
 *  Returns: Dependent upon message sent			*
 *								*
\****************************************************************/
MRESULT EXPENTRY DispFileDlgProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
   SHORT	    Ret=-1;
   PVOID	    pvAddress=0;
   PFILELIST	    pTail=NULL, pNext=NULL;    /* The last file of list */
   MRESULT sRC;

   switch (msg)
   {
      case WM_INITDLG:
	  FixSysMenu(hwnd);
	  pBackup=NULL;
				  /* Default click the buttom of backup */
	  WinSendDlgItemMsg(hwnd, IDD_ACCESSBACKUP,
			      BM_CLICK, (MPARAM)0L, (MPARAM)0L);
	  return((MRESULT)FALSE);
			/* Let the focus go to where the system puts it */
      case WM_COMMAND:
	  switch (SHORT1FROMMP(mp1)) {
	     case DID_OK:
		 pNext = pFindFile;
		 DosSetMem(pNext, sizeof(PFILELIST),
			   PAG_READ|PAG_WRITE|PAG_EXECUTE);
		 while (pNext != NULL)
		 {
		    if(!DosAllocMem(&pvAddress,sizeof(PFILELIST),fALLOC))
		    {	     /* Store file list to backup structure */
		       if (pBackup == NULL)
		       {		       /* Back up 1'st file */
			  pBackup = (PFILELIST)pvAddress;
			  strcpy(pBackup->szFileName,pNext->szFileName);
			  pBackup->pNextFile = NULL;
			  pTail = pBackup;
		       }
		       else
		       {
			  pTail->pNextFile = (PFILELIST)pvAddress;
			  pTail = pTail->pNextFile;
			  strcpy(pTail->szFileName, pNext->szFileName);
			  pTail->pNextFile = NULL;
		       }
		       pNext = pNext->pNextFile;
		    }
		 }				      /* while loop */
		 pNext = pFindFile; /* Protect the memory of file list */
		 if(pNext != NULL)
		 {
		    DosSetMem(pNext,sizeof(PFILELIST),
				      PAG_GUARD|PAG_READ|PAG_WRITE);
		 }
		 Ret = (SHORT)WinSendDlgItemMsg(hwnd, (ULONG)IDD_ACCESSBACKUP,
			    BM_QUERYCHECKINDEX, (MPARAM)0L, (MPARAM)0L);
		 if(Ret == 0)
		 {
		    pFlList = pBackup;
		 }
		 else
		 {
		    pFlList = pFindFile;
		 }
		 WinDismissDlg(hwnd, TRUE);
		 return((MRESULT)TRUE);

	     case DID_CANCEL:
		 WinDismissDlg(hwnd, FALSE);
		 return((MRESULT)TRUE);
	  }
	  break;

      case WM_CLOSE:
	  WinDismissDlg(hwnd, FALSE);
	  return((MRESULT)TRUE);

      default:
	  sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
	  return sRC;
   }
   return((MRESULT)TRUE);
}

/****************************************************************\
 *								*
 *  Name:    DisplayFile(hwnd, rect, pFile)			*
 *								*
 *  Purpose: This routine searches and display files which are	*
 *	     matching the pattern.				*
 *								*
 *  Usage:   After files searching, this module will create a	*
 *	     child window to display the matched files.		*
 *								*
 *  Returns: VOID						*
 *								*
\****************************************************************/
VOID DisplayFile (HWND hwnd, RECTL rect, PPFILELIST pFile)
{
   CHAR		szBuf[CCHMAXPATH];
   APIRET	sCount=0;
   PFILELIST	pTail=NULL;			    /* The last file of list */

   if(hwndChild)
     WinDestroyWindow(hwndChild);
   hwndChild = WinCreateWindow (hwnd,
				WC_LISTBOX,
				"File List...",
				WS_VISIBLE | FCF_MINMAX,
				rect.xLeft,
				rect.yBottom,
				rect.xRight-rect.xLeft,
				rect.yTop-rect.yBottom-5,
				hwnd,
				HWND_TOP,
				ID_CHILDWIN,
				NULL,
				(PVOID)NULL);
   pTail = *pFile;
   if(*pFile != NULL)
   {
      strcpy(szBuf, "The found file list ....");
      WinSendDlgItemMsg(hwnd, ID_CHILDWIN, LM_INSERTITEM,
			MPFROM2SHORT(LIT_END, 0),
			MPFROMP(szBuf));
   }
   while (pTail != NULL)
   {
      strcpy(szBuf, pTail->szFileName);
      WinSendDlgItemMsg(hwnd, ID_CHILDWIN, LM_INSERTITEM,
			MPFROM2SHORT(LIT_END, 0),
			MPFROMP(pTail->szFileName));
      sCount++;
      pTail = pTail->pNextFile;
   }							    /* endwhile */
   memset(szBuf, 0, sizeof(szBuf));
   sprintf(szBuf, "There are %d files found.", sCount);
   WinSendDlgItemMsg(hwnd, ID_CHILDWIN, LM_INSERTITEM,
		     MPFROM2SHORT(LIT_END, 0),
		     MPFROMP(szBuf));
   while(*pFile != NULL)		 /* Free the File list structure */
   {
      pTail = *pFile;
      *pFile = (*pFile)->pNextFile;
      DosFreeMem(pTail);
   }
   return;
}

/****************************************************************\
 *  Dialog procedure for the Open file dialog			*
 *--------------------------------------------------------------*
 *								*
 *  Name:    OpenDlgProc(hwnd, msg, mp1, mp2)			*
 *								*
 *  Purpose: Processes all messages sent to the Open file dialog*
 *								*
 *  Usage:   Called for each message sent to the dialog box.	*
 *								*
 *  Method:  a switch statement branches to the routines to be	*
 *	     performed for each message processed. Any messages *
 *	     not specifically processed are passed to the	*
 *	     default window procedure WinDefDlgProc()		*
 *								*
 *  Returns: Dependent upon message sent			*
 *								*
\****************************************************************/
MRESULT EXPENTRY OpenDlgProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
    static PFILEINFO pFile;
    static CHAR	  szBuffer[CCHMAXPATH];
    ULONG  ulDriveMap, ulDriveNum=0L, ulDirLen = CCHMAXPATH;
    SHORT  sIndex=0;
    MRESULT sRC;

    switch (msg)
    {
	case WM_INITDLG:

	    pFile = PVOIDFROMMP(mp2);
	    FixSysMenu(hwnd);
	    memset(pFile, 0, sizeof(pFile));
						    /* Get current drive */
	    DosQueryCurrentDisk(&ulDriveNum, &ulDriveMap);
	    *(pFile->szFileName) = (CHAR)(ulDriveNum + '@');
	    *(pFile->szFileName+1) = ':';
				   /* Get current dir & attach disk num. */
	    memset(szBuffer, 0, sizeof(szBuffer));
	    DosQueryCurrentDir(0L, szBuffer, &ulDirLen);

	    if(*(szBuffer+strlen(szBuffer)-1) != '\\')
	       strcat(szBuffer, "\\");		  /* Add '\' at the tail */
	    if(*(szBuffer) != '\\')	  /* Add '\' at begining of path */
	       strcat(pFile->szFileName,"\\");

	    strcat(pFile->szFileName,szBuffer);	 /* Display current path */
	    WinSendDlgItemMsg(hwnd, IDD_PATH, EM_SETTEXTLIMIT,
			       MPFROM2SHORT(CCHMAXPATH, 0), NULL);
	    WinSetDlgItemText(hwnd, IDD_PATH, pFile->szFileName );

	    return((MRESULT)FALSE);
			 /* Let the focus go to where the system puts it */
	case WM_COMMAND:
	    switch (SHORT1FROMMP(mp1)) {
	       case DID_OK:
		  memset(szBuffer,0,sizeof(szBuffer));
		  WinQueryDlgItemText(hwnd, IDD_PATH, CCHMAXPATH,
					szBuffer);
		  memset(pFile->szFileName,0,sizeof(pFile->szFileName));
		  for (sIndex=0; szBuffer[sIndex]!='\000' &&
			sIndex<CCHMAXPATH; sIndex++)
		  {
		     if (szBuffer[sIndex]>='a' && szBuffer[sIndex]<='z')
		     {
			szBuffer[sIndex] = szBuffer[sIndex] - (CHAR)' ';
		     }		      /* Changed lowercase to uppercase */
		  }
		  strcpy(pFile->szFileName, szBuffer);
		  WinDismissDlg(hwnd, TRUE);
		  break;

	       case DID_CANCEL:
		  WinDismissDlg(hwnd, FALSE);
		  break;
	       }
	    break;

	case WM_CLOSE:
	    WinDismissDlg(hwnd, FALSE);
	    return((MRESULT)TRUE);

	default:
	    sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
	    return sRC;
    }
    return (MRESULT)RETURN_SUCCESS;
}

/****************************************************************\
 *  Dialog procedure for the Display text dialog		*
 *--------------------------------------------------------------*
 *								*
 *  Name:    DisplayDlgProc(hwnd, msg, mp1, mp2)		*
 *								*
 *  Purpose: Processes all messages sent to the Display text	*
 *	     dialog window.					*
 *								*
 *  Usage:   Called for each message sent to the dialog box.	*
 *								*
 *  Method:  a switch statement branches to the routines to be	*
 *	     performed for each message processed. Any messages *
 *	     not specifically processed are passed to the	*
 *	     default window procedure WinDefDlgProc()		*
 *								*
 *  Returns: Dependent upon message sent			*
 *								*
\****************************************************************/
MRESULT EXPENTRY DisplayDlgProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
   CHAR	   szBuf[CCHMAXPATH];
   static PFILEINFO pFile;
   MRESULT sRC;

   switch (msg)
   {
      case WM_INITDLG:

	  pFile = PVOIDFROMMP(mp2);
	  FixSysMenu(hwnd);
	  strcpy(szBuf,"File: ");	   /* Display file path & name */
	  strcat(szBuf,pFile->szFileName);
	  WinSendDlgItemMsg(hwnd, IDD_PATH, EM_SETTEXTLIMIT,
			       MPFROM2SHORT(CCHMAXPATH, 0), NULL);
	  WinSetDlgItemText(hwnd, IDD_PATH, szBuf);
					       /* Display file content */
	  WinSendDlgItemMsg(hwnd, IDD_TEXT, EM_SETTEXTLIMIT,
			       MPFROM2SHORT(BUFF_SIZE, 0), NULL);
	  WinSetDlgItemText(hwnd, IDD_TEXT, pFile->szBuffer);

	  return((MRESULT)FALSE);
		       /* Let the focus go to where the system puts it */
      case WM_COMMAND:
	  switch (SHORT1FROMMP(mp1)) {
	      case DID_OK:
		 WinDismissDlg(hwnd, TRUE);
		 break;
	      }
	  break;

      default:
	  sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
	  return sRC;
   }
   return (MRESULT)RETURN_SUCCESS;
}

/****************************************************************\
 *  Dialog procedure for the Calculator Entry dialog		*
 *--------------------------------------------------------------*
 *								*
 *  Name:    MathDlgProc(hwnd, msg, mp1, mp2)			*
 *								*
 *  Purpose: Processes all messages sent to the Calculator input*
 *	     dialog window.					*
 *								*
 *  Usage:   Called for each message sent to the dialog box.	*
 *								*
 *  Method:  a switch statement branches to the routines to be	*
 *	     performed for each message processed. Any messages *
 *	     not specifically processed are passed to the	*
 *	     default window procedure WinDefDlgProc()		*
 *								*
 *  Returns: Dependent upon message sent			*
 *								*
\****************************************************************/
MRESULT EXPENTRY MathDlgProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
   static PMATHELEMENT pMath;
   static CHAR szBuffer[OP_SIZE];
   SHORT  sIndex;
   MRESULT sRC;

   switch (msg)
   {
       case WM_INITDLG:
	   pMath = PVOIDFROMMP(mp2);
	   FixSysMenu(hwnd);
	   pMath->fOperand1 = 0;
	   pMath->fOperand2 = 0;
	   *pMath->pszOperation = '\000';
	   memset(pMath->szResult, 0, sizeof(pMath->szResult) );
	   WinSendDlgItemMsg(hwnd, IDD_OPERAND1, EM_SETTEXTLIMIT,
			       MPFROM2SHORT(OP_SIZE, 0), NULL);
	   WinSendDlgItemMsg(hwnd, IDD_OPERAND2, EM_SETTEXTLIMIT,
			       MPFROM2SHORT(OP_SIZE, 0), NULL);
	   WinSendDlgItemMsg(hwnd, IDD_OPERATION, EM_SETTEXTLIMIT,
			       MPFROM2SHORT(1L, 0), NULL);
	   return((MRESULT)FALSE);
			 /* Let the focus go to where the system puts it */
       case WM_COMMAND:
	   switch (SHORT1FROMMP(mp1))
	   {
	      case DID_OK:
		 memset(szBuffer,0,sizeof(szBuffer));
		 WinQueryDlgItemText(hwnd, IDD_OPERAND1, OP_SIZE+1,
					szBuffer);
		 for (sIndex=0; sIndex<OP_SIZE && szBuffer[sIndex]!='\000';
			    sIndex++)
		 {
		    if( (szBuffer[sIndex]<'0' || szBuffer[sIndex]>'9')
			&& (szBuffer[sIndex] != '.') )
		    {
		       MessageBox(hwnd, IDMSG_ERROROPERAND, "Error !",
				MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
		       return((MRESULT)FALSE);		/* Illegal input */
		    }
		 }					       /* endfor */
		 pMath->fOperand1 = atol(szBuffer);

		 memset(szBuffer,0,sizeof(szBuffer));
		 WinQueryDlgItemText(hwnd, IDD_OPERAND2, OP_SIZE+1,
					szBuffer);
		 for (sIndex=0; sIndex<OP_SIZE && szBuffer[sIndex]!='\000';
			     sIndex++)
		 {
		    if( (szBuffer[sIndex]<'0' || szBuffer[sIndex]>'9')
			&& (szBuffer[sIndex] != '.') )
		    {
		       MessageBox(hwnd, IDMSG_ERROROPERAND, "Error !",
				MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);

		       *pMath->pszOperation = '\000';
		       return((MRESULT)FALSE);		/* Illegal input */
		    }
		 }					       /* endfor */
		 pMath->fOperand2 = atol(szBuffer);

		 memset(szBuffer,0,sizeof(szBuffer));
		 WinQueryDlgItemText(hwnd, IDD_OPERATION, OP_SIZE,
					pMath->pszOperation);
		 if(*pMath->pszOperation!='+' && *pMath->pszOperation!='-' &&
		    *pMath->pszOperation!='*' && *pMath->pszOperation!='/')
		 {
		     MessageBox(hwnd, IDMSG_ERROROPERAND, "Error !",
				MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);

		     *pMath->pszOperation = '\000';
		     return((MRESULT)FALSE);		/* Illegal input */
		 }
		 memset(pMath->szResult, 0, sizeof(pMath->szResult) );
		 WinDismissDlg(hwnd, TRUE);
		 break;

	      case DID_CANCEL:
		 WinDismissDlg(hwnd, FALSE);
		 break;
	   }
	   break;

       case WM_CLOSE:
	   WinDismissDlg(hwnd, FALSE);
	   return((MRESULT)TRUE);

       default:
	   sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
	   return sRC;
   }
   return (MRESULT)RETURN_SUCCESS;
}

/****************************************************************\
 *								*
 *  Name:    ResultDlgProc(hwnd, msg, mp1, mp2)			*
 *								*
 *  Purpose: Processes all messages sent to the result display	*
 *	     dialog window.					*
 *								*
 *  Usage:   Called for each message sent to the dialog box.	*
 *								*
 *  Method:  a switch statement branches to the routines to be	*
 *	     performed for each message processed. Any messages *
 *	     not specifically processed are passed to the	*
 *	     default window procedure WinDefDlgProc()		*
 *								*
 *  Returns: Dependent upon message sent			*
 *								*
\****************************************************************/
MRESULT EXPENTRY ResultDlgProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
   static  PMATHELEMENT pResult;
   CHAR	   szBuf[BUFF_SIZE];
   CHAR	   szTemp[BUFF_SIZE];
   SHORT   i;
   MRESULT sRC;

   switch (msg)
   {
       case WM_INITDLG:

	   pResult = PVOIDFROMMP(mp2);
	   FixSysMenu(hwnd);
	   memset(szBuf, 0, sizeof(szBuf));
	   sprintf(szBuf,"%ld", pResult->fOperand1); /* szBuf= 'OP1'	 */
	   memset(szTemp, 0, sizeof(szTemp));
	   sprintf(szTemp,"%ld", pResult->fOperand2);
	   strcat(szBuf," ");			 /* szBuf= 'OP1 '	 */
	   strcat(szBuf,pResult->pszOperation);	 /* szBuf= 'OP1 +'	 */
	   strcat(szBuf," ");			 /* szBuf= 'OP1 + '	 */
	   strcat(szBuf, szTemp);		 /* szBuf= 'OP1 + OP2'	 */
	   strcat(szBuf, " ");			 /* szBuf= 'OP1 + OP2 '	 */
	   strcat(szBuf, "=");			 /* szBuf= 'OP1 + OP2 =' */
						 /* Display the formula	 */
	   WinSetDlgItemText(hwnd, IDD_TEXT, szBuf);
	   for (i=BUFF_SIZE-1; i && pResult->szResult[i]!='.'; i--)
	   {
	      if (pResult->szResult[i] == '0')
		 pResult->szResult[i] = '\000';	 /* Erase tail's zero    */
	   }					 /* Display the result	 */
	   WinSetDlgItemText(hwnd, IDD_VALUE, pResult->szResult);

	   return((MRESULT)FALSE);
			 /* Let the focus go to where the system puts it */
       case WM_COMMAND:
	   switch (SHORT1FROMMP(mp1))
	   {
	      case DID_OK:
		 WinDismissDlg(hwnd, TRUE);
		 break;
	   }
	   break;

       default:
	   sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
	   return sRC;
   }
   return (MRESULT)RETURN_SUCCESS;
}
/*static char *SCCSID = "@(#)dlapi_hp.c 6.10 92/02/18";*/
/*==============================================================*\
 *  DLAPI_HP.C - routines for help information			*
 *	(C) Copyright IBM Corporation 1992.			*
 *--------------------------------------------------------------*
 *								*
 *  This module contains all the routines for interfacing with	*
 *  the IPF help manager.					*
 *								*
 *--------------------------------------------------------------*
 *								*
 *  This source file contains the following functions:		*
 *								*
 *	    InitHelp()						*
 *	    HelpHelpForHelp(mp2)				*
 *	    HelpExtended(mp2)					*
 *	    HelpKeys(mp2)					*
 *	    HelpIndex(mp2)					*
 *	    HelpAbout(mp2)					*
 *	    DisplayHelpPanel(idPanel)				*
 *	    DestroyHelpInstance(VOID)				*
 *	    AboutDlgProc(hwnd, msg, mp1, mp2)			*
 *	    FixSysMenu()					*
 *								*
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#include "dllapi.h"

/****************************************************************\
 *  Routine for initializing the help manager
 *--------------------------------------------------------------
 *
 *  Name:    InitHelp()
 *
 *  Purpose: Initializes the IPF help facility
 *
 *  Usage:   Called once during initialization of the program
 *
 *  Method:  Initializes the HELPINIT structure and creates the help
 *	     instance. If successful, the help instance is associated
 *	     with the main window
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID InitHelp(VOID)
{
   HELPINIT hini;

    /* If we return because of an error, Help will be disabled */
   fHelpEnabled = FALSE;
			     /* Initialize help init structure */
   hini.cb = sizeof(HELPINIT);
   hini.ulReturnCode = 0;
			   /* If tutorial added, add name here */
   hini.pszTutorialName = (PSZ)NULL;

   hini.phtHelpTable = (PHELPTABLE)MAKELONG(DLL_HELP_TABLE, 0xFFFF);
   hini.hmodHelpTableModule = 0;
   hini.hmodAccelActionBarModule = 0;
   hini.idAccelTable = 0;
   hini.idActionBar = 0;

   if(!WinLoadString(hab,
		     0,
		     IDS_HELPWINDOWTITLE,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szWindowTitle))
   {
       MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, "Error !",
			     MB_OK | MB_ERROR, TRUE);
       return;
   }
   hini.pszHelpWindowTitle = (PSZ)szWindowTitle;

		   /* If debugging, show panel ids, else don't */
#ifdef DEBUG
   hini.fShowPanelId = CMIC_SHOW_PANEL_ID;
#else
   hini.fShowPanelId = CMIC_HIDE_PANEL_ID;
#endif

   if(!WinLoadString(hab,
		     0,
		     IDS_HELPLIBRARYNAME,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szLibName))
   {
       MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, "Error !",
			     MB_OK | MB_ERROR, TRUE);
       return;
   }
   hini.pszHelpLibraryName = (PSZ)szLibName;
				     /* Creating help instance */
   hwndHelpInstance = WinCreateHelpInstance(hab, &hini);

   if(hwndHelpInstance == 0L || hini.ulReturnCode)
   {
       MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, "Error !",
				    MB_OK | MB_ERROR, TRUE);
       return;
   }
		    /* Associate help instance with main frame */
   if(!WinAssociateHelpInstance(hwndHelpInstance, hwndMainFrame))
   {
       MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, "Error !",
				 MB_OK | MB_ERROR, TRUE);
       return;
   }
       /* Help manager is successfully initialized so set flag to TRUE */
   fHelpEnabled = TRUE;
   return;
}						  /* InitHelp() */

/****************************************************************\
 *  Processes the Help for Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpHelpForHelp(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Help for
 *	     Help item of the Help menu
 *
 *  Usage:   Called from MainCommand when the Help for Help menu item
 *	     is selected
 *
 *  Method:  Sends an HM_DISPLAY_HELP message to the help instance so
 *	     that the default Help For Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpHelpForHelp(MPARAM mp2)
{
	  /* This just displays the system help for help panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_DISPLAY_HELP,(MPARAM)0,(MPARAM)0))
	   MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, "Error !",
		      MB_OK | MB_ERROR, TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.					   */
   return;
}					   /* HelpHelpForHelp() */

/****************************************************************\
 *  Processes the Extended Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpExtended(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Extended
 *	     Help item of the Help menu.
 *
 *  Usage:   Called from MainCommand when the Extended Help menu item
 *	     is selected.
 *
 *  Method:  Sends an HM_EXT_HELP message to the help instance so that
 *	     the default Extended Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpExtended(MPARAM mp2)
{
	  /* This just displays the system extended help panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_EXT_HELP,(MPARAM)0L,(MPARAM)0L))
	   MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, "Error !",
		      MB_OK | MB_ERROR, TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.					   */
   return;
}					      /* HelpExtended() */

/****************************************************************\
 *  Processes the Keys Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpKeys(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Keys Help
 *	     item of the Help menu.
 *
 *  Usage:   Called from MainCommand when the Keys Help menu item is
 *	     selected
 *
 *  Method:  Sends an HM_KEYS_HELP message to the help instance so that
 *	     the default Keys Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpKeys(MPARAM mp2)
{
	      /* This just displays the system keys help panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_KEYS_HELP,(MPARAM)0L,(MPARAM)0L))
	  MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, "Error !",
		      MB_OK | MB_ERROR, TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.					   */
   return;
}						  /* HelpKeys() */

/****************************************************************\
 *  Processes the Index Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpIndex(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Index Help
 *	     item of the Help menu
 *
 *  Usage:   Called from MainCommand when the Index Help menu item
 *	     is selected
 *
 *  Method:  Sends an HM_INDEX_HELP message to the help instance so
 *	     that the default Index Help is displayed.
 *
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpIndex(MPARAM mp2)
{
	      /* This just displays the system help index panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_HELP_INDEX,(MPARAM)0L,(MPARAM)0L))
	   MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, "Error !",
		      MB_OK | MB_ERROR, TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.					   */
   return;
}						 /* HelpIndex() */

/****************************************************************\
 *  Processes the About command from the Help menu
 *--------------------------------------------------------------
 *
 *  Name:    HelpAbout(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the About item
 *	     of the Help menu
 *
 *  Usage:   Called from MainCommand when the About menu item is selected
 *
 *  Method:  Calls WinDlgBox to display the about box dialog.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpAbout(MPARAM mp2)
{
				/* Display the AboutBox dialog */
   WinDlgBox(HWND_DESKTOP,
		hwndMain,
		AboutDlgProc,
		(HMODULE)0,
		IDD_PRODUCTINFO,
		NULL);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.					   */
   return;
}						 /* HelpAbout() */

/****************************************************************\
 *  Displays the help panel indicated
 *--------------------------------------------------------------
 *
 *  Name:    DisplayHelpPanel(idPanel)
 *
 *  Purpose: Displays the help panel whose id is given
 *
 *  Usage:   Called whenever a help panel is desired to be displayed,
 *	     usually from the WM_HELP processing of the dialog boxes
 *
 *  Method:  Sends HM_DISPLAY_HELP message to the help instance
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID DisplayHelpPanel(LONG idPanel)
{
   if(fHelpEnabled)
       if((LONG)WinSendMsg(hwndHelpInstance,
		     HM_DISPLAY_HELP,
		     MPFROMLONG(MAKELONG(idPanel, NULL)),
		     MPFROMSHORT(HM_RESOURCEID)))

	   MessageBox(hwndMainFrame, IDMSG_HELPDISPLAYERROR, "Error !",
		      MB_OK | MB_ERROR, TRUE);
   return;
}					  /* DisplayHelpPanel() */

/****************************************************************\
 *  Destroys the help instance
 *--------------------------------------------------------------
 *
 *  Name:    DestroyHelpInstance(VOID)
 *
 *  Purpose: Destroys the help instance for the application
 *
 *  Usage:   Called after exit from message loop
 *
 *  Method:  Calls WinDestroyHelpInstance() to destroy the help instance
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID DestroyHelpInstance(VOID)
{
   if(hwndHelpInstance != 0L)
   {
       WinDestroyHelpInstance(hwndHelpInstance);
   }
   return;
}				       /* DestroyHelpInstance() */

/****************************************************************\
 *
 * Name:    AboutDlgProc(hwnd, msg, mp1, mp2)
 *
 * Purpose: Handles all the messages associated with the About dialog.
 *
 * Usage:   Called from HelpAbout() when about menu be selected.
 *
 * Returns:
 *
\****************************************************************/
MRESULT EXPENTRY AboutDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   MRESULT sRC;

   switch(msg)
   {
      case WM_INITDLG:
	 FixSysMenu(hwnd);
	 return (MRESULT)0L;

      case WM_COMMAND:
	 WinDismissDlg(hwnd, TRUE);
	 return (MRESULT)0L;

      default:
	 sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
	 return sRC;
   }
   return (MRESULT)0L;
}

/****************************************************************\
 * Name:    FixSysMenu()					 *
 *								 *
 * Purpose: This routine removes the Restore, Size, Minimize, and*
 *	    Maximize options from the system menu of a dialog.	 *
 *								 *
 * Usage  : Called during the WM_INITDLG of a dialog procedure.	 *
 *								 *
 * Returns: VOID						 *
 *								 *
\****************************************************************/
VOID FixSysMenu(HWND hwndDlg)
{
   HWND hwndMenu;				    /* handle to system menu */

   hwndMenu = WinWindowFromID(hwndDlg, FID_SYSMENU);

   WinSendMsg(hwndMenu,		      /* delete Restore from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_RESTORE, TRUE),
	      MPFROMP(NULL));

   WinSendMsg(hwndMenu,			 /* delete Size from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_SIZE, TRUE),
	      MPFROMP(NULL));

   WinSendMsg(hwndMenu,		     /* delete Minimize from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_MINIMIZE, TRUE),
	      MPFROMP(NULL));

   WinSendMsg(hwndMenu,		     /* delete Maximize from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_MAXIMIZE, TRUE),
	      MPFROMP(NULL));
   return;
}
/*static char *SCCSID = "@(#)dlapi_in.c 6.8 92/02/18";*/
/*==============================================================*\
 *  DLAPI_IN.C - routines for initialization and exit processing*
 *	(C) Copyright IBM Corporation 1992.			*
 *--------------------------------------------------------------*
 *								*
 *  This module contains the code for application initialization*
 *  as well as the code for exit list processing		*
 *								*
 *--------------------------------------------------------------*
 *								*
 *  This source file contains the following functions:		*
 *								*
 *	Init() - initialization routines			*
 *	ExitProc(usTermCode) - exit list processing procedure	*
 *	GPFHandler(parg) - GPFault and guard page excep handler *
 *								*
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#include "dllapi.h"

/****************************************************************\
 *  Initialization routine					*
 *--------------------------------------------------------------*
 *								*
 *  Name:    Init()						*
 *								*
 *  Purpose: Performs initialization functions required before	*
 *	     the main window can be created.			*
 *								*
 *  Usage:   Called once before the main window is created.	*
 *								*
 *  Method:  - installs the routine ExitProc into the		*
 *		DosExitList chain				*
 *	     - registers all window classes			*
 *	     - performs any command line processing		*
 *								*
 *  Returns: TRUE - initialization is successful		*
 *	     FALSE - initialization failed			*
 *								*
\****************************************************************/
BOOL Init(VOID)
{
    /* Add ExitProc to the exit list to handle the exit processing */
    if(DosExitList(EXLST_ADD, ExitProc))
    {
	return FALSE;
    }
		       /* load application name from resource file */
    if(!WinLoadString(hab, (HMODULE)0, IDS_APPNAME, MAXAPPNAMELEN, szAppName))
	return FALSE;
    if(!WinLoadString(hab, 0, IDS_UNTITLED, MESSAGELEN, szUntitled))
	return FALSE;
			  /* register the main client window class */
    if(WinRegisterClass(hab,
			(PSZ)szAppName,
			(PFNWP)MainWndProc,
			CS_SIZEREDRAW | CS_SYNCPAINT | CS_CLIPCHILDREN,
			0) == 0)
	return FALSE;

    /* Turn off hard-error popup after GP-FAULT. No return codes
       checked as it is cosmetic and if it doesn't work the only side
       effect will be to have the default hard-error popup show up. */

    DosError(FERR_DISABLEEXCEPTION | FERR_DISABLEHARDERR);

    return TRUE;
}							  /* Init() */

/****************************************************************\
 *  Exit list processing procedure				*
 *--------------------------------------------------------------*
 *								*
 *  Name:    ExitProc(usTermCode)				*
 *								*
 *  Purpose: Cleans up certain resources when the application	*
 *	     terminates						*
 *								*
 *  Usage:   Routine is called by DosExitList when the		*
 *	     application exits					*
 *								*
 *  Method:  global resources, such as the main window and	*
 *	     message queue, are destroyed and any system	*
 *	     resources used are freed				*
 *								*
 *  Returns: Returns EXLST_EXIT to the DosExitList handler	*
 *								*
\****************************************************************/
VOID APIENTRY ExitProc(ULONG usTermCode)
				  /* code for the reason for termination */
{
   WinDestroyWindow(hwndMainFrame);
   /*--------------------------------------------------*\
    *	   Any other system resources used	       *
    *	   (e.g. memory or files) should be freed here *
   \*--------------------------------------------------*/
   WinDestroyMsgQueue(hmq);

   WinTerminate(hab);

   DosExitList(EXLST_EXIT, (PFNEXITLIST)0L);	/* termination complete */

   /* This routine currently doesn't use the usTermCode parameter so *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'  *
   \*  warning at compile time					     */

   return;
}							   /* ExitProc() */

/****************************************************************\
 *  Do nothing Guard Page Exception Handler			*
 *--------------------------------------------------------------*
 *								*
 *  Name:    GPFHandler(PXCPT)					*
 *								*
 *  Purpose: To notify user when a guard page entered exception *
 *	     occurs						*
 *								*
 *  Usage:   Routine is called when a guard page is accessed	*
 *								*
 *  Method:  Whenever a guard page is accessed, a message	*
 *	     box is put on the screen indicating this.		*
 *								*
 *  Returns: Returns HANDLED if guard page exception,		*
 *	     otherwise, returns NOT_HANDLED			*
\****************************************************************/
ULONG GPFHandler(EXCEPTIONREPORTRECORD *parg,
		 EXCEPTIONREGISTRATIONRECORD *pRegisRecord,
		 PCONTEXTRECORD	 pContextRecord,
		 PVOID pvSpare)
{
    LONG  sRet;
    CHAR  szText[MESSAGELEN];

    if(parg->ExceptionNum == XCPT_FLOAT_DIVIDE_BY_ZERO ||
       parg->ExceptionNum == XCPT_INTEGER_DIVIDE_BY_ZERO)
    {
       MessageBox(hwndMain, IDMSG_DIVIDEZERO, "Error !",
		MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
       DosExit(EXIT_PROCESS, RETURN_ERROR);
       return(XCPT_CONTINUE_SEARCH);
    }
    /* Notify the user when they have accessed a guard page, and let
       the system default guard page handler handle the exception. */
    if(parg->ExceptionNum == XCPT_GUARD_PAGE_VIOLATION)
    {
       WinLoadMessage(hab, (HMODULE)NULL, IDMSG_ACCESSGUARDPAGE, MESSAGELEN,
		      (PSZ)szText);
       WinAlarm(HWND_DESKTOP, WA_ERROR);

       sRet = WinMessageBox(HWND_DESKTOP, hwndMain, szText, "Note !",
			    IDM_MSGBOX, MB_MOVEABLE | MB_YESNO | MB_ERROR);
       switch (sRet)
       {
	  case MBID_YES:
	     pFlList = pBackup;
	     break;

	  case MBID_NO:
	     DosExit(EXIT_PROCESS, RETURN_ERROR);
	     break;
       }
       WinInvalidateRect(hwndMain,NULL,TRUE);
       return(XCPT_CONTINUE_EXECUTION);
    }
    return(XCPT_CONTINUE_SEARCH);
}
/**************************************************************************
 *  File name  :  dlg.c
 *
 *  Description:  This module contains the Dialog Procedures for the user
 *		  defined dialogs as well as any support code they need.
 *
 *		  This source file contains the following functions:
 *
 *		  ProductInfoDlgProc(hwnd, msg, mp1, mp2)
 *		  SetSysMenu(hDlg)
 *
 *  Concepts   :  dialog box
 *
 *  API's      :  WinDismissDlg
 *		  WinDefDlgProc
 *		  WinWindowFromID
 *		  WinSendMsg
 *
 *  Required
 *    Files    :  OS2.H, STRING.H, MAIN.H, DLG.H, XTRN.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *  Include files, macros, defined constants, and externs
 */

#define	 INCL_WINMENUS
#define	 INCL_WINFRAMEMGR
#include <os2.h>
#include <string.h>
#include "main.h"
#include "dlg.h"
#include "xtrn.h"

/*
 *  Global variables
 */

/*
 *  Entry point declarations
 */

MRESULT EXPENTRY ProductInfoDlgProc(HWND hwnd, USHORT msg,
				  MPARAM mp1, MPARAM mp2);
VOID SetSysMenu( HWND hDlg );

/**************************************************************************
 *
 *  Name       : ProductInfoDlgProc(hwnd, msg, mp1, mp2)
 *
 *  Description: Processes all messages sent to the Product information
 *		 dialog
 *
 *  Concepts:  The Product information dialog has only a button control,
 *	       so this routine processes only WM_COMMAND messages.  Any
 *	       WM_COMMAND posted must have come from the OK
 *	       button, so we dismiss the dialog upon receiving it.
 *
 *  API's      :  WinDismissDlg
 *		  WinDefDlgProc
 *
 *  Parameters :  hwnd	   = window handle
 *		  msg	   = message i.d.
 *		  mp1	   = first message parameter
 *		  mp2	   = second message parameter
 *
 *  Return     :  dependent on message sent
 *
 *************************************************************************/
MRESULT EXPENTRY ProductInfoDlgProc(
			 HWND hwnd,	 /* handle of window */
			 USHORT msg,	 /* id of message */
			 MPARAM mp1,	 /* first message parameter */
			 MPARAM mp2)	 /* second message parameter */
{
   switch(msg)
   {
      case WM_INITDLG:
	 SetSysMenu(hwnd);	 /* system menu for this dialog	 */
	 return MRFROMSHORT(FALSE);

      case WM_COMMAND:
	   /* no matter what the command, close the dialog */
	 WinDismissDlg(hwnd, TRUE);
	 break;

      default:
	 return(WinDefDlgProc(hwnd, msg, mp1, mp2));
	 break;
   }
   return (MRESULT)NULL;
}   /*	End of ProductInfoDlgProc   */


/**************************************************************************
 *
 *  Name       : SetSysMenu(hDlg)
 *
 *  Description: Sets only the Move and Close items of the system menu
 *
 *  Concepts:  Any dialog box is free to call this routine, to edit
 *	       which menu items will appear on its System Menu pulldown.
 *
 *  API's      :  WinWindowFromID
 *		  WinSendMsg
 *
 *  Parameters :  hDlg	   = window handle of the dialog
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID SetSysMenu(HWND hDlg)
{
    HWND     hSysMenu;
    MENUITEM Mi;
    ULONG    Pos;
    MRESULT  Id;
    SHORT    cItems;

    /******************************************************************/
    /*	We only want Move and Close in the system menu.		      */
    /******************************************************************/

    hSysMenu = WinWindowFromID(hDlg, FID_SYSMENU);
    WinSendMsg( hSysMenu, MM_QUERYITEM
	      , MPFROM2SHORT(SC_SYSMENU, FALSE), MPFROMP((PCH) & Mi));
    Pos = 0L;
    cItems = (SHORT)WinSendMsg( Mi.hwndSubMenu, MM_QUERYITEMCOUNT,
				(MPARAM)NULL, (MPARAM)NULL);
    while (cItems--)
    {
	Id = WinSendMsg( Mi.hwndSubMenu, MM_ITEMIDFROMPOSITION
			  , MPFROMLONG(Pos), (MPARAM)NULL);
	switch (SHORT1FROMMR(Id))
	{
	case SC_MOVE:
	case SC_CLOSE:
	    Pos++;  /* Don't delete that one. */
	    break;
	default:
	    WinSendMsg( Mi.hwndSubMenu, MM_DELETEITEM
		      , MPFROM2SHORT((USHORT)Id, TRUE), (MPARAM)NULL);
	}
    }
}   /*	End of SetSysMenu  */
/***************************  End of dlg.c  ****************************/
/*static char *SCCSID = "@(#)dllapi.c   6.13 92/02/18";*/
/*==============================================================*\
 *  DLLAPI.C - Sample PM application				*
 *								*
 *	(C) Copyright IBM Corporation 1992.			*
 *								*
 *--------------------------------------------------------------*
 *								*
 *  This DLL application program consists of a DLL file that	*
 *  provides a 32-bit DOS called functions, and an API's EXE    *
 *  file that uses the dynamic linking library to handle some	*
 *  operations. The DLL uses protected memory to protect its	*
 *  shared data, and exception management to validate the API's *
 *  pointer parameters, handle the errors returned.		*
 *  This application also serves as a template that can be	*
 *  easily modified by an application developer.  The source	*
 *  files are organized so that the overhead code that should	*
 *  be in all applications is located in the same files so	*
 *  that these files do not need to be modified.  The routines	*
 *  that deal with application specific code are also located	*
 *  in their own modules.  An application developer need only	*
 *  change these files in order to modify this template for	*
 *  his application.						*
 *								*
 *--------------------------------------------------------------*
 *								*
 *  This source file contains the following functions:		*
 *								*
 *	main() - main routine					*
 *	MainWndProc(hwnd, msg, mp1, mp2) - main window procedure*
 *	MainCommand(hwnd, mp1, mp2) - WM_COMMAND processing	*
 *	MessageBox(hwnd nId, pszMsg, fsStyle, bBeep)		*
 *								*
\*==============================================================*/
/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/

#include "dllapi.h"

/****************************************************************\
 *  Main routine						*
 *--------------------------------------------------------------*
 *								*
 *  Name:    main()						*
 *								*
 *  Purpose: Initializes the PM environment, calls the		*
 *	     initialization routine, creates the main window,	*
 *	     and polls the message queue.			*
 *								*
 *  Usage:							*
 *								*
 *  Method:  -obtains anchor block handle and creates message	*
 *		queue						*
 *	     -calls the initialization routine			*
 *	     -creates the main frame window which creates the	*
 *		main client window				*
 *	     -polls the message queue via Get/Dispatch Msg loop *
 *	     -upon exiting the loop, exits			*
 *								*
 *  Returns: 1 - if sucessful execution completed		*
 *	     0 - if error					*
 *								*
\****************************************************************/
INT main(VOID)
{
   QMSG qmsg;					   /* message structure */
   ULONG ctlData=FCF_STANDARD;		     /* main frame control data */
   EXCEPTIONREGISTRATIONRECORD ExceptionStruct;

   strcpy(szWindowText,"DLLAPI Sample");
   hwndChild = (HWND)0;
   hab = WinInitialize(0);
   if(!hab)
   {
       DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
       DosExit(EXIT_PROCESS, RETURN_ERROR);
   }
   hmq = WinCreateMsgQueue(hab, 0);
   if(!hmq)
   {
       DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
       WinTerminate(hab);
       DosExit(EXIT_PROCESS, RETURN_ERROR);
   }
   if(!Init())
   {
       MessageBox(HWND_DESKTOP, IDMSG_INITFAILED, "Error !",
			   MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
       DosExit(EXIT_PROCESS, RETURN_ERROR);
   }
					      /* create the main window */
   hwndMainFrame = WinCreateStdWindow(HWND_DESKTOP,
				      WS_VISIBLE,
				      (PVOID)&ctlData,
				      (PSZ)szAppName,
				      (PSZ)NULL,
				      WS_VISIBLE,
				      (HMODULE)NULL,
				      ID_RESOURCE,
				      (PHWND)&hwndMain);
   if(!hwndMainFrame)
   {
       MessageBox(HWND_DESKTOP, IDMSG_MAINWINCREATEFAILED, "Error !",
			   MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
       DosExit(EXIT_PROCESS, RETURN_ERROR);
   }
   InitHelp();
   ExceptionStruct.ExceptionHandler = (_ERR *)&GPFHandler;
   DosSetExceptionHandler(&ExceptionStruct) ;

   while(WinGetMsg(hmq, (PQMSG)&qmsg, 0L, 0L, 0L))
	   WinDispatchMsg(hmq, (PQMSG)&qmsg);

   DosUnsetExceptionHandler(&ExceptionStruct) ;
					   /* destroy the help instance */
   DestroyHelpInstance();
				    /* will normally be put in ExitProc */
   DosExit(EXIT_PROCESS, RETURN_SUCCESS);
   return 0;
}							       /* main() */

/****************************************************************\
 *  Main client window procedure				*
 *--------------------------------------------------------------*
 *								*
 *  Name:    MainWndProc(hwnd, msg, mp1, mp2)			*
 *								*
 *  Purpose: Processes the messages sent to the main client	*
 *	     window. This routine processes the basic messages	*
 *	     all client windows should process and passes all	*
 *	     others onto UserWndProc where the developer can	*
 *	     process any others.				*
 *								*
 *  Usage:   Called for each message placed in the main		*
 *	     window's message queue                             *
 *								*
 *  Method:  a switch statement branches to the routines to be	*
 *	     performed for each message processed. Any messages *
 *	     not specifically process are passed to the user's  *
 *	     message processing procedure UserWndProc().	*
 *								*
 *  Returns: Return values are determined by each message	*
 *								*
\****************************************************************/
MRESULT EXPENTRY MainWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   MRESULT sRC;

   switch(msg) {
       case WM_PAINT:
	   MainPaint(hwnd);
	   break;

       case WM_COMMAND:
	   MainCommand(hwnd, mp1, mp2);
	   break;

   /*--------------------------------------------------*\
    *	   Any messages not processed are passed on    *
    *	   to the user's window proc.  It is           *
    *	   responsible for passing any messages it     *
    *	   doesn't handle onto WinDefWindowProc()      *
   \*--------------------------------------------------*/
       case HM_QUERY_KEYS_HELP:
	   return ((MRESULT)PANEL_KEYSHELP);

       default:
	   sRC = WinDefWindowProc(hwnd, msg, mp1, mp2);
	   return sRC;
   }
   return (MRESULT)0L; /*all window procedures should return 0 as a default*/
}							 /* MainWndProc() */

/****************************************************************\
 *  Main client painting routine				*
 *--------------------------------------------------------------*
 *								*
 *  Name:    MainPaint(hwnd)					*
 *								*
 *  Purpose: Paints the main client window.			*
 *								*
 *  Usage:   Routine is called whenver the client window	*
 *	     procedure receives a WM_PAINT message		*
 *								*
 *  Method:  -begins painting by calling WinBeginPaint		*
 *		and retriving the HPS for the window		*
 *	     -paint page info boxes				*
 *								*
 *	     -ends painting by calling WinEndPaint		*
 *								*
 *  Returns: VOID						*
 *								*
\****************************************************************/
VOID MainPaint(HWND hwnd)
{
   HPS	  hps;				/* Handle for painting		 */
   RECTL  rect;				/* Rectangle struct for painting */
   CHAR	  szBuffer[BUFF_SIZE];
   POINTL ptl;

   hps = WinBeginPaint(hwnd, 0L, (PRECTL)&rect);
   WinFillRect(hps, (PRECTL)&rect, CLR_BACKGROUND);
			      /* Fill update rectangle with window color */
   WinQueryWindowRect(hwndMain, (PRECTL)&rect);
   switch (sStatus) {
   case IDM_SEARCH:
      ptl.x = HORZ_INDENT;
      ptl.y = rect.yTop - VERT_TEXT_POS;
      memset(szBuffer, 0, sizeof(szBuffer));
      strcpy(szBuffer, "Searching Path: [");
      strcat(szBuffer, ObjInfo.szCurDriver);
      strcat(szBuffer, ObjInfo.szCurPath);
      strcat(szBuffer, "]");

      GpiCharStringAt(hps, &ptl, strlen(szBuffer), szBuffer);

      ptl.x = HORZ_INDENT;
      ptl.y = rect.yTop - VERT_TEXT_POS * 2;
      memset(szBuffer, 0, sizeof(szBuffer));
      strcpy(szBuffer, "Searching Pattern: [");
      strcat(szBuffer, ObjInfo.szCurPattern);
      strcat(szBuffer, "]");

      GpiCharStringAt(hps, &ptl, strlen(szBuffer), szBuffer);

      break;
   default:
      break;
   }							   /* endswitch */
   WinEndPaint(hps);
   return;
}							 /* MainPaint() */

/****************************************************************\
 *  Main window WM_COMMAND processing procedure			*
 *--------------------------------------------------------------*
 *								*
 *  Name:   MainCommand(hwnd, mp1, mp2)				*
 *								*
 *  Purpose:Calls the appropriate procedures that deal with	*
 *	     the selected menu item.				*
 *								*
 *  Usage:  Routine is called whenever a WM_COMMAND message	*
 *	    is posted to the main window.			*
 *								*
 *  Method: a switch statement branches on the id of the	*
 *	    menu item that posted the message and the		*
 *	    appropriate action for that item is taken.	Any	*
 *	    menu ids that are not part of the standard menu	*
 *	    set are passed onto the user defined WM_COMMAND	*
 *	    processing procedure.				*
 *								*
 *  Returns: VOID						*
 *								*
\****************************************************************/
VOID MainCommand(HWND hwnd, MPARAM mp1, MPARAM mp2)
{
    switch(SHORT1FROMMP(mp1))
    {
	case IDM_GENERALHELP:
	   HelpExtended(mp2);
	   return;

	case IDM_USINGHELP:
	   HelpHelpForHelp(mp2);
	   return;

	case IDM_TUTORIAL:
	   HelpKeys(mp2);
	   return;

	case IDM_HELPINDEX:
	   HelpIndex(mp2);
	   return;

	case IDM_HELPPRODUCTINFO:
	   HelpAbout(mp2);
	   return;

    /*--------------------------------------------------*\
     *	    User command processing routine is called	*
     *	    here so any ids not procecessed here can be *
     *	    processed					*
    \*--------------------------------------------------*/
	default:
	    UserCommand(hwnd, mp1, mp2);
	    break;
    }
    return;
}						 /* MainCommand() */


/****************************************************************\
 *  Non-standard menu item command processing procedure		*
 *--------------------------------------------------------------*
 *								*
 *  Name:    UserCommand(hwnd, mp1, mp2)			*
 *								*
 *  Purpose: Process any WM_COMMAND messages send to hwndMain	*
 *		that are not processed by MainCommand		*
 *								*
 *  Usage:   Routine is called for each WM_COMMAND that is	*
 *	     not posted by a standard menu item			*
 *								*
 *  Method:  A switch statement branches control based upon	*
 *	     the id of the control which posted the message	*
 *								*
 *  Returns: VOID						*
 *								*
\****************************************************************/
VOID UserCommand(HWND hwnd, MPARAM mp1, MPARAM mp2)
{
   HPS	       hps;
   RECTL       rect;
   CHAR	       szBuffer[BUFF_SIZE];
   APIRET      Ret;
   POINTL      ptl;

   switch (SHORT1FROMMP(mp1))
   {
       case IDM_SEARCH:
	   if (WinDlgBox(HWND_DESKTOP,
			 hwnd,
			 (PFNWP)GetPatternDlgProc,
			 (HMODULE)0,
			 (ULONG)IDD_GETPATTERN,
			 (PVOID)&ObjInfo) )
	   {
	      sStatus = IDM_SEARCH;
	      hps = WinGetPS(hwnd);
	      WinQueryWindowRect(hwnd, &rect);
	      WinFillRect(hps, (PRECTL)&rect, CLR_BACKGROUND);
	      ptl.x = HORZ_INDENT;
	      ptl.y = rect.yTop - VERT_TEXT_POS;
	      memset(szBuffer, 0, sizeof(szBuffer));
	      strcpy(szBuffer, "Searching Path: [");
	      strcat(szBuffer, ObjInfo.szNewDriver);
	      strcat(szBuffer, ObjInfo.szNewPath);
	      strcat(szBuffer, "]");

	      GpiCharStringAt(hps, &ptl, strlen(szBuffer), szBuffer);

	      ptl.x = HORZ_INDENT;
	      ptl.y = rect.yTop - VERT_TEXT_POS * 2;
	      memset(szBuffer, 0, sizeof(szBuffer));
	      strcpy(szBuffer, "Searching Pattern: [");
	      strcat(szBuffer, ObjInfo.szNewPattern);
	      strcat(szBuffer, "]");

	      GpiCharStringAt(hps, &ptl, strlen(szBuffer), szBuffer);
	      WinReleasePS(hps);

	      Ret=SearchFile(&ObjInfo, &pFindFile);
	      if (Ret)
	      {
		  switch(Ret) {
		  case ERROR_FILE_NOT_FOUND:
		       MessageBox(hwnd, IDMSG_FILENOTFOUND, "Warning !",
				MB_OK | MB_INFORMATION | MB_MOVEABLE, TRUE);
		       break;
		  case ERROR_DRIVE_LOCKED:
		       MessageBox(hwnd, IDMSG_DRIVELOCKED, "Error !",
				MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
		       break;
		  case ERROR_PATH_NOT_FOUND:
		       MessageBox(hwnd, IDMSG_PATHNOTFOUND, "Error !",
				MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
		       break;
		  case RETURN_ERROR:
		       MessageBox(hwnd, IDMSG_ERRORSETPATH, "Error !",
				MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
		       break;
		  case ERROR_BUFFER_OVERFLOW:
		       MessageBox(hwnd, IDMSG_BUFFEROVERFLOW, "Error !",
				MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
		       break;
		  case ERROR_INVALID_DRIVE:
		       MessageBox(hwnd, IDMSG_ERRORINVALIDDRIVE, "Error !",
				MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
		       break;
		  }			  /* End of switch(Ret)	  */
	      }				  /* Endif of DisplayFile */
	      else
	      {
		 memset(ObjInfo.szCurDriver,0,sizeof(ObjInfo.szCurDriver));
		 memset(ObjInfo.szCurPath,0,sizeof(ObjInfo.szCurPath));
		 memset(ObjInfo.szCurPattern,0,sizeof(ObjInfo.szCurPattern));
		 strcpy(ObjInfo.szCurDriver,ObjInfo.szNewDriver);
		 strcpy(ObjInfo.szCurPath,ObjInfo.szNewPath);
		 strcpy(ObjInfo.szCurPattern,ObjInfo.szNewPattern);
		 rect.yTop = rect.yTop-VERT_TEXT_POS*2-5;

		 if(WinDlgBox(HWND_DESKTOP,
			   hwnd,
			   (PFNWP)DispFileDlgProc,
			   (HMODULE)0,
			   (ULONG)IDD_DSPFILESTRUCT,
			   (PVOID)NULL) )

		     DisplayFile(hwnd, rect, &pFlList);
	      }
	   }			       /* End of case(IDM_SEARCH) */
	   break;

       case IDM_OPEN:
	   if (WinDlgBox(HWND_DESKTOP,
			 hwnd,
			 (PFNWP)OpenDlgProc,
			 (HMODULE)0,
			 (ULONG)IDD_OPENFILE,
			 (PVOID)&FileInfo) )
	   {
	      Ret=ReadFileProc(&FileInfo);
	      if(Ret)
	      {
		 switch(Ret) {
		 case ERROR_PATH_NOT_FOUND:
		      MessageBox(hwnd, IDMSG_PATHNOTFOUND, "Error !",
			       MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
		      break;
		 case ERROR_OPEN_FAILED:
		      MessageBox(hwnd, IDMSG_OPENFAILED, "Error !",
			       MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
		      break;
		 case ERROR_FILE_NOT_FOUND:
		      MessageBox(hwnd, IDMSG_FILENOTFOUND, "Error !",
			       MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
		      break;
		 case ERROR_ACCESS_DENIED:
		      MessageBox(hwnd, IDMSG_ACCESSDENIED, "Error !",
			       MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
		      break;
		 default:
		      MessageBox(hwnd, IDMSG_RETURNERROR, "Error !",
			       MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
		      break;
		 }
	      }
	      else
	      {
		 if(!WinDlgBox(HWND_DESKTOP,
			      hwnd,
			      (PFNWP)DisplayDlgProc,
			      (HMODULE)0,
			      (ULONG)IDD_DISPLAYTEXT,
			      (PVOID)&FileInfo) )
		 MessageBox(hwnd, IDMSG_DSPTEXTERROR, "Error !",
			  MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
	      }
	   }
	   break;
       case IDM_CALCUL:
	   if (WinDlgBox(HWND_DESKTOP,
			 hwnd,
			 (PFNWP)MathDlgProc,
			 (HMODULE)0,
			 (ULONG)IDD_GETMATHINFO,
			 (PVOID)&MathInfo) )
	   {
	      if(*(MathInfo.pszOperation) != '\000')
	      {
		 CalCulProc(&MathInfo);

		 if(!WinDlgBox(HWND_DESKTOP,
			      hwnd,
			      (PFNWP)ResultDlgProc,
			      (HMODULE)0,
			      (ULONG)IDD_DISPLAYVALUE,
			      (PVOID)&MathInfo) )
		 MessageBox(hwnd, IDMSG_DSPTEXTERROR, "Error !",
			  MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
	      }
	   }
	   break;

       default:
	 break;
   }
    /* This routine currently doesn't use the mp2 parameter but       *\
     *	it is referenced here to prevent an 'Unreferenced Parameter'  *
    \*	warning at compile time.				      */
   return;
}

/****************************************************************\
 *  Message Box procedure					*
 *--------------------------------------------------------------*
 *								*
 *  Name:    MessageBox(hwndOwner,IdMsg,pszMsg,fsStyle,bBeep)	*
 *								*
 *  Purpose: Displays the warning message box with the message	*
 *		given in nIdMsg retrived from the message table *
 *								*
 *  Usage:   Called whever an error occurs and a message wishes *
 *	     to be displayed to the user			*
 *								*
 *  Method:  - Message string is loaded from the process'       *
 *		message table					*
 *	     - Alarm beep is sounded if desired			*
 *	     - Message box with the message is displayed	*
 *								*
 *  Returns: VOID						*
 *								*
\****************************************************************/
VOID MessageBox(HWND hwndOwner, LONG IdMsg, PSZ pszMsg, LONG fsStyle,
		     BOOL bBeep)
{
   CHAR szText[MESSAGELEN];

   if(!WinLoadMessage(hab, (HMODULE)NULL, IdMsg, MESSAGELEN, (PSZ)szText))
   {
       WinAlarm(HWND_DESKTOP, WA_ERROR);
       return;
   }
   if(bBeep)
       WinAlarm(HWND_DESKTOP, WA_ERROR);

   WinMessageBox(HWND_DESKTOP,
		 hwndOwner,
		 szText,
		 (PSZ)pszMsg,
		 IDM_MSGBOX,
		 fsStyle);
   return;
}						   /* MessageBox() */
/*static char *SCCSID = "@(#)dllib.c    6.9 92/02/18";*/
/*==============================================================*\
 *  DLLIB.C - dynamic linking library procedures for the window *
 *	(C) Copyright IBM Corporation 1992.			*
 *--------------------------------------------------------------*
 *								*
 *  This module contains the Display file Procedures for the	*
 *  user defined DOS called as well as any code they need	*
 *								*
 *--------------------------------------------------------------*
 *								*
 *  This source file contains the following functions:		*
 *								*
 *    SearchFile  (pObj, pFile)					*
 *    ReadFileProc(pFileText)					*
 *    CalCulProc  (pMathEl)					*
 *								*
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#include "dllib.h"

/****************************************************************\
 *								*
 * Name:    SearchFile(pObj, pFile)				*
 *								*
 * Purpose: This routine searches files which are matching the	*
 *	    pattern.						*
 *								*
 * Usage:   After files searching, this module will create a	*
 *	    linking structure to store the matched files.	*
 *								*
 * Returns: Dependent upon API return code.			*
 *								*
\****************************************************************/
APIRET APIENTRY SearchFile (POBJSTRUCT pObj, PPFILELIST pFile)
{
   FILEFINDBUF3 findbuf;
   HDIR		hDir = HDIR_CREATE;
   ULONG	ulSearchCount = 1;
   CHAR		szBuf[CCHMAXPATH];
   APIRET	Ret=0;
   PVOID	pvAddress=0;
   PFILELIST	pTail=NULL, pNext=NULL;		/* The last file of list */
					     /* Change to selected drive */
   Ret = DosSetDefaultDisk((ULONG)(*(pObj->szNewDriver) - '@'));
   if(Ret)
	return (Ret);
					 /* Change to selected directory */
   memset(szBuf, 0, sizeof(szBuf));
   strcpy(szBuf, pObj->szNewPath);
   if(strlen(szBuf)!= 1 && *(szBuf+strlen(szBuf)-1) == '\\')
       *(szBuf+strlen(szBuf)-1) = '\000';	       /* Erase last '\' */
   Ret = DosSetCurrentDir((PSZ)szBuf);
   if(Ret)
	 return (Ret);

   DosSetMem(*pFile, sizeof(PFILELIST), PAG_READ|PAG_WRITE|PAG_EXECUTE);

   while(*pFile != NULL)		 /* Free the File list structure */
   {
      pTail = *pFile;
      *pFile = (*pFile)->pNextFile;
      DosFreeMem(pTail);
   }
   Ret = DosFindFirst((PSZ)pObj->szNewPattern, &hDir, FILE_NORMAL,
		&findbuf, sizeof(findbuf), &ulSearchCount, FIL_STANDARD);

   if(Ret)
   {
      if(Ret == ERROR_NO_MORE_FILES)			/* No file found */
	  WinAlarm(HWND_DESKTOP, WA_ERROR);

	  WinMessageBox(HWND_DESKTOP,
		   HWND_DESKTOP,
		   "No file is matched this pattern,\ncheck pattern or path.",
		   (PSZ)"Warning !",
		   IDM_MSGBOX,
		   MB_OK | MB_INFORMATION | MB_MOVEABLE);
      return (Ret);
   }
   else
   {
      if(!DosAllocMem(&pvAddress,sizeof(PFILELIST),
		     PAG_READ|PAG_WRITE|PAG_COMMIT))
      {					     /* Store 1'st file into list */
	 memset(szBuf, 0, sizeof(szBuf));
	 strcat(szBuf, pObj->szNewDriver);
	 strcat(szBuf, pObj->szNewPath);
	 strcat(szBuf, findbuf.achName);
	 *pFile = (PFILELIST)pvAddress;
	 strcpy((*pFile)->szFileName, szBuf);
	 (*pFile)->pNextFile = NULL;
      }
   }
   pTail = *pFile;
   while(ulSearchCount)
   {
      Ret=DosFindNext(hDir, &findbuf, sizeof(findbuf), &ulSearchCount);
      if(Ret)				/* Ret != 0, DosFindNext is fail */
      {
	pNext = *pFile;		      /* Protect the memory of file list */
	if(pNext != NULL)
	{
	  DosSetMem(pNext,sizeof(PFILELIST), PAG_GUARD|PAG_READ|PAG_WRITE);
	}
	if (Ret != ERROR_NO_MORE_FILES)
	   return Ret;				   /* Have error occured */
	else
	   return 0;
      }
      memset(szBuf, 0, sizeof(szBuf));	      /* More files are searched */
      strcat(szBuf, pObj->szNewDriver);
      strcat(szBuf, pObj->szNewPath);
      strcat(szBuf, findbuf.achName);
			    /* Store all found files to structure pFiles */
      if(!DosAllocMem(&pvAddress,sizeof(PFILELIST),
		     PAG_READ|PAG_WRITE|PAG_COMMIT))
      {						 /* Store file into list */
	 pTail->pNextFile = (PFILELIST)pvAddress;
	 pTail = pTail->pNextFile;
	 strcpy(pTail->szFileName, szBuf);
	 pTail->pNextFile = NULL;
      }
   }
   pNext = *pFile;		      /* Protect the memory of file list */
   if(pNext != NULL)
   {
      DosSetMem(pNext,sizeof(PFILELIST), PAG_GUARD|PAG_READ|PAG_WRITE);
   }
   return 0;					       /* RETURN_SUCCESS */
}

/****************************************************************\
 *								*
 * Name:    ReadFileProc(pFileText)				*
 *								*
 * Purpose: This routine open and read file which are selected. *
 *								*
 * Usage:   After files read, this module will store data into	*
 *	    a buffer.						*
 *								*
 * Returns: Dependent upon API return code.			*
 *								*
\****************************************************************/
APIRET APIENTRY ReadFileProc(PFILEINFO pFileText)
{
   HFILE    FileHandle=0;				/* Opened file handle */
   ULONG    ulAct=0L;
   APIRET   Ret;
   ULONG    ulRdByte=0L;				   /* Bytes be read */

   Ret = DosOpen((PSZ)pFileText->szFileName,
		 (PHFILE)&FileHandle,
		 &ulAct,
		 0L,		       /* Specify file new size for created */
		 FILE_NORMAL,	     /* File attributes for create new file */
		 FILE_OPEN,			   /* Open an existing file */
	   OPEN_SHARE_DENYWRITE,/* Open modes: others can open to read only */
		 NULL);			   /* Extended attributes structure */
   if (Ret)
      return (Ret);				       /* RETURN_ERROR code */
   else
   {
      DosRead(FileHandle, (PVOID)&(pFileText->szBuffer), BUFF_SIZE, &ulRdByte);
      if (ulRdByte == 0L)
	 return (APIRET)1;				    /* RETURN_ERROR */
   }
   if(DosClose(FileHandle))
     return (APIRET)1;					    /* RETURN_ERROR */
   return (APIRET)0;					  /* RETURN_SUCCESS */
}

/****************************************************************\
 *								*
 * Name:    CalCulProc(pMathEl)					*
 *								*
 * Purpose: This routine calculates the result from given	*
 *	      operands which are input by user.			*
 *								*
 * Usage:   After calculated, store the result to Math structure*
 *								*
 * Returns: Dependent upon API return code.			*
 *								*
\****************************************************************/
APIRET APIENTRY CalCulProc(PMATHELEMENT pMathEl)
{
   double fResultVal=0.0;

   switch (*pMathEl->pszOperation) {
   case '+':
      fResultVal = pMathEl->fOperand1 + pMathEl->fOperand2;
      break;
   case '-':
      fResultVal = pMathEl->fOperand1 - pMathEl->fOperand2;
      break;
   case '*':
      fResultVal = pMathEl->fOperand1 * pMathEl->fOperand2;
      break;
   case '/':
      fResultVal = (double)pMathEl->fOperand1 / (double)pMathEl->fOperand2;
      break;
   }							       /* endswitch */
   sprintf(pMathEl->szResult, "%f", fResultVal);
   return (APIRET)0;					  /* RETURN_SUCCESS */
}
#ifndef lint
static char *sccsid = "@(#)dog.c 1.3 2/3/92 20:39:45 [2/3/92] (c)IBM Corp. 1992";
#endif

/*
 * Copyright (c) International Business Machines Corporation
 *		 1991, 1992
 */

#define Dog_Class_Source
#include "dog.ih"
#include <string.h>

SOM_Scope char *SOMLINK getBreed(Dog * somSelf)
{
    DogData *somThis = DogGetData(somSelf);
    DogMethodDebug("Dog", "getBreed");

    return _breed;
}

SOM_Scope char *SOMLINK getColor(Dog * somSelf)
{
    DogData *somThis = DogGetData(somSelf);
    DogMethodDebug("Dog", "getColor");

    return _color;
}

SOM_Scope void SOMLINK setBreed(Dog * somSelf, char *myBreed)
{
    DogData *somThis = DogGetData(somSelf);
    DogMethodDebug("Dog", "setBreed");

    if (_breed)
	(*SOMFree) (_breed);
    _breed = (char *) (*SOMMalloc) (strlen(myBreed) + 1);
    strcpy(_breed, myBreed);
}

SOM_Scope void SOMLINK setColor(Dog * somSelf, char *myColor)
{
    DogData *somThis = DogGetData(somSelf);
    DogMethodDebug("Dog", "setColor");

    if (_color)
	(*SOMFree) (_color);
    _color = (char *) (*SOMMalloc) (strlen(myColor) + 1);
    strcpy(_color, myColor);
}

SOM_Scope void SOMLINK somInit(Dog * somSelf)
{
    DogData *somThis = DogGetData(somSelf);
    DogMethodDebug("Dog", "somInit");
    parent_somInit(somSelf);

    _color = 0;
    _breed = 0;
}

SOM_Scope void SOMLINK somUninit(Dog * somSelf)
{
    DogData *somThis = DogGetData(somSelf);
    DogMethodDebug("Dog", "somUninit");

    if (_color)
	(*SOMFree) (_color);
    if (_breed)
	(*SOMFree) (_breed);
    parent_somUninit(somSelf);
}

SOM_Scope void SOMLINK somDumpSelfInt(Dog * somSelf,
				       int level)
{
    DogData *somThis = DogGetData(somSelf);
    DogMethodDebug("Dog", "somDumpSelfInt");
    parent_somDumpSelfInt(somSelf, level);
}

SOM_Scope char *SOMLINK getGenus(Dog * somSelf)
{
    DogData *somThis = DogGetData(somSelf);
    DogMethodDebug("Dog", "getGenus");
    return ("Canis");
}

SOM_Scope char *SOMLINK getSpecies(Dog * somSelf)
{
    DogData *somThis = DogGetData(somSelf);
    DogMethodDebug("Dog", "getSpecies");
    return ("Familiaris");
}

SOM_Scope void SOMLINK display(Dog * somSelf)
{
    DogData *somThis = DogGetData(somSelf);
    DogMethodDebug("Dog", "display");
    somPrintf("  Breed: %s\n", _getBreed(somSelf));
    somPrintf("  Color: %s\n", _getColor(somSelf));
    parent_display(somSelf);
}
#ifndef lint
static char *sccsid = "@(#)dogmeta.c 1.3 2/3/92 20:40:05 [2/3/92] (c)IBM Corp. 1992";
#endif

/*
 * Copyright (c) International Business Machines Corporation
 *		 1991, 1992
 */

#define DogFactory_Class_Source
#include "dogmeta.ih"
#include "dog.h"

/*
 *  Create an instance of a Dog with a specific sound, breed, & color.
 */

SOM_Scope SOMAny *SOMLINK newDog(DogFactory * somSelf,
				  char *sound,
				  char *breed,
				  char *color)
{
    /* DogFactoryData *somThis = DogFactoryGetData(somSelf); */
    Dog *newDog;
    DogFactoryMethodDebug("DogFactory", "newDog");

    newDog = _newAnimal(somSelf, sound);
    _setBreed(newDog, breed);
    _setColor(newDog, color);

    return (newDog);

}
/**************************************************************************
 *  File name  :  dragdrag.c
 *
 *  Description:  This source file contains the direct manipulation routines
 *		  of the Drag/drop sample.
 *
 *		  This source file contains the following functions:
 *
 *		  FreeSourceResources (hab, pDraginfo)
 *		  PreventClose (hwndClient, cDrag)
 *		  RemoveFinalBackslash (p)
 *		  InitDrag(hwndClient, hList, hptrFile, hptrFolder, hptrMulti,
 *			   pContainerName)
 *		  EndConversation (hwndClient, mp1)
 *		  DragLeave (void)
 *		  DropHelp (hwndClient, pDraginfo)
 *		  DragOver (pDraginfo, pCurrentDir)
 *		  Drop (hab, hwndClient, pDraginfo, pCurrentDir)
 *		  EndTarget (hwnd, pParm)
 *		  CheckBusy (void)
 *		  CheckClose (hwnd)
 *		  TargetThread (void)
 *
 *  Concepts   :  direct manipulation
 *
 *  API's      :  DrgAccessDraginfo
 *		  DrgDeleteDraginfoStrHandles
 *		  DrgQueryDragitemCount
 *		  DrgQueryDragitemPtr
 *		  DrgFreeDraginfo
 *		  WinWindowFromID
 *		  WinSendMsg
 *		  DrgAllocDraginfo
 *		  DrgAddStrHandle
 *		  WinQueryLboxItemText
 *		  DrgSetDragitem
 *		  DrgDrag
 *		  WinDeleteLboxItem
 *		  DrgQueryStrName
 *		  DrgVerifyRMF
 *		  DrgAllocDragtransfer
 *		  DrgSendTransferMsg
 *		  WinStartTimer
 *		  WinGetMsg
 *		  WinStopTimer
 *		  WinDispatchMsg
 *		  DrgFreeDragtransfer
 *		  DosGetNamedSharedMem
 *		  DosSubAllocMem
 *		  DosCreateThread
 *		  DrgQueryDragitem
 *		  WinPostMsg
 *		  DosCopy
 *		  DosDelete
 *		  DosEnterCritSec
 *		  WinGetLastError
 *
 *  Required
 *    Files    :  OS2.H, STRING.H, DRAGDROP.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *	  Include the required sections from the PM header file.
 */
#define INCL_DOSFILEMGR
#define INCL_DOSPROCESS
#define INCL_DOSERRORS
#define INCL_SHLERRORS
#define INCL_WIN
#define INCL_WINSTDDRAG

/*
 *		       Include the PM header file.
 */
#include <os2.h>

/*
 *		    Include the C library header files.
 */
#include <string.h>

/*
 *		   Include the application header files.
 */
#include "dragdrop.h"

static PDRAGTARGETTHREAD vpThreadParms = NULL;

/*
 * Variables global to this file
 */
static char   szRendMechFmtFILE []  = "<DRM_OS2FILE,DRF_UNKNOWN>";

/*
 * Because the following items used by the target, are used only
 * during the drag operation, and drag is a system modal operation,
 * a target can always accept a drop.
 *
 * In any case, the target cannot allow the application to
 * close when a drag is in progress, either as a target or a source.
 * This is because the thread performing the operation would also be
 * ended.  A target could allow a close, but only if it prompted
 * the user to request permission.
 */

static USHORT	 usOperation;
      /* usOperation is used to remember the user selected
       * (or application selected default * operation) between
       * a DM_DRAGOVER
       * and a DM_DROP message, to avoid re-figuring the operation.
       * Because this is used during drag, which is a system modal
       * operation, a target can always be dropped on.
       * Used by target only.
       */

/*
 * The following is used by both the source and target to keep the total
 * number of drag operations that the application is currently involved
 * in. If the count is non-zero, the application will not allow the user
 * to close it.
 */
static ULONG	ulDragCount = 0L;

/**************************************************************************
 *
 *  Name       : FreeSourceResources (hab, pDraginfo)
 *
 *  Description: Frees the resources allocated by the source for a drag
 *		 operation
 *
 *  Concepts   :  accesses and deletes an instance of drag information
 *
 *  API's      :  DrgAccessDraginfo
 *		  DrgDeleteDraginfoStrHandles
 *		  DrgQueryDragitemCount
 *		  DrgQueryDragitemPtr
 *		  DrgFreeDraginfo
 *
 *  Parameters :  pDraginfo = pointer to the drag information structure
 *
 *  Return     :  TRUE	= if resources freed successfully
 *		  FALSE = unable to free all resources
 *
 *************************************************************************/
BOOL FreeSourceResources (HAB hab, PDRAGINFO pDraginfo)
{
   PDRAGITEM	   pDragitem;
   ULONG	   ulItemsDragged, i;
   ERRORID	   errorid;

   if(DrgAccessDraginfo(pDraginfo) && DrgDeleteDraginfoStrHandles(pDraginfo))
      ;		  /* drag access OK */
   else
   {
      MessageBox(HWND_DESKTOP, IDMSG_DRAGACCESSERROR, MB_OK | MB_ERROR, TRUE);
      return FALSE;
   }

   ulItemsDragged = DrgQueryDragitemCount(pDraginfo);

   for (i = 0L; i < ulItemsDragged; ++i)
   {
      pDragitem = DrgQueryDragitemPtr(pDraginfo, i);
      if(!FreeAppDragitem((PAPPDRAGITEM)pDragitem->ulItemID))
      {
	 MessageBox(HWND_DESKTOP, IDMSG_MEMFREEERROR, MB_OK | MB_ERROR, TRUE);
	 return FALSE;
      }
   }

   if(!FreeAppDraginfo(FindAppDraginfo(pDraginfo)))
   {
      MessageBox(HWND_DESKTOP, IDMSG_MEMFREEERROR, MB_OK | MB_ERROR, TRUE);
      return FALSE;
   }
   if(DrgFreeDraginfo(pDraginfo)
	       || PMERR_SOURCE_SAME_AS_TARGET == WinGetLastError(hab))
      return TRUE;
   else
   {
      MessageBox(HWND_DESKTOP, IDMSG_DRAGFREEERROR, MB_OK | MB_ERROR, TRUE);
      return FALSE;
   }
}  /* End of FreeSourceResources  */


/**************************************************************************
 *
 *  Name       : PreventClose (hwndClient, cDrag)
 *
 *  Description: Disables the close option on the system menu when
 *		 a drag is in progress, or enables it when all drag
 *		 operations have completed.
 *
 *  Concepts   :  system menu, enablement
 *
 *  API's      :  WinWindowFromID
 *		  WinSendMsg
 *
 *  Parameters :  hwndClient = client window handlenformation structure
 *		  cDrag	     = the enabled state of the close menu item
 *
 *  Return     :  TRUE	= if the close menu item is disabled
 *		  FALSE = if the close menu item has been enabled
 *
 *************************************************************************/
VOID PreventClose(HWND hwndClient, ULONG cDrag)
{
   HWND hwndSysMenu = WinWindowFromID(ParentOf(hwndClient), FID_SYSMENU);

   WinSendMsg(hwndSysMenu, MM_SETITEMATTR, MPFROM2SHORT(SC_CLOSE, (SHORT)TRUE),
	     MPFROM2SHORT(MIA_DISABLED, (SHORT)(cDrag ? MIA_DISABLED : FALSE)));

   return;
}  /*  End of PreventClose  */


/**************************************************************************
 *
 *  Name       : RemoveFinalBackslash (p)
 *
 *  Description: Checks the final character in a string and,
 *		 if it is a backslash, removes it.
 *
 *  Concepts   :  pathnames
 *
 *  API's      :  [none]
 *
 *  Parameters :  p = a pointer to the string
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID RemoveFinalBackslash (PSZ p)
{
   for (; *p; ++p)
      ;			 /*  go to the end of the string  */

   if (*--p == '\\')
   {
      *p = '\0';
   }
}  /*  End of RemoveFinalBackslash  */


/**************************************************************************
 *
 *  Name       : InitDrag(hwndClient, hList, hptrFile, hptrFolder,
 *			  hptrMulti, pContainerName)
 *
 *  Description: Builds a DRAGINFO structure for the selected items,
 *		 then calls DrgDrag to perform the drag operation.
 *
 *  Concepts   :  direct manipulation
 *
 *  API's      :  DrgAllocDraginfo
 *		  DrgAddStrHandle
 *		  WinQueryLboxItemText
 *		  DrgSetDragitem
 *
 *  Parameters :  hwndClient = client window handle
 *		  hList	     = handle of the list of file names
 *		  hptrFile   = file handle
 *		  hptrFolder = folder handle
 *		  hptrMulti  = multiple list handle
 *		  pContainerName - pointer to name of container
 *
 *  Return     :  TRUE	= the drag operation was performed
 *		  FALSE = unable to perform the drag operation
 *
 *************************************************************************/
BOOL InitDrag (HAB hab, HWND hwndClient, HWND hList, HPOINTER hptrFile,
	       HPOINTER hptrFolder, HPOINTER hptrMulti, PSZ pContainerName)
{
   CHAR		    chDrive;
   SHORT	    item;
   ULONG	    i, ulItemsDragged;
   HWND		    hwndTarget;
   LHANDLE	    hImage;
   DRAGITEM	    Dragitem;
   HSTR		    hstrType, hstrRMF, hstrContainerName;
   USHORT	    fsControl;
   USHORT	    fsSupportedOps;
   PPUBFILEFINDBUF  pFile;
   CHAR		    szItemName [64];
   CHAR		    szFullContainerName [CCHMAXPATH];
   PAPPDRAGINFO	    pAppDraginfo;
   PDRAGINFO	    pSourceDraginfo;
   DRAGIMAGE	    dimg;

   /*
    * Determine number of items selected prior to allocating the
    * DRAGINFO structure. Note that this sample program requires at
    * least one item to be selected in order to do a drag operation.
    */

   ulItemsDragged = 0L;
   item = WinQueryLboxSelItemFirst (hList);

   while (item != LIT_NONE)
   {
      ++ulItemsDragged;
      item = WinQueryLboxSelItemNext (hList, item);
   }

   if (ulItemsDragged == 0L)
   {
      MessageBox(HWND_DESKTOP, IDMSG_ATLEASTONE, MB_OK | MB_ERROR, TRUE);
      return FALSE;
   }

   /*
    * Allocate the DRAGINFO structure and the APPDRAGINFO structure.
    */
   pSourceDraginfo = DrgAllocDraginfo(ulItemsDragged);
   pAppDraginfo = AllocAppDraginfo (hwndClient, pSourceDraginfo);

   /*
    * Initialize variable used to initialize the internal DRAGITEM
    * structure.
    */
   hstrType  = DrgAddStrHandle (DRT_UNKNOWN);	    /* file type is unknown  */
   hstrRMF   = DrgAddStrHandle (szRendMechFmtFILE); /* os2file, unknown	     */
   strcpy (szFullContainerName, pContainerName);    /* container name	     */

   RemoveFinalBackslash (szFullContainerName);
   strcat (szFullContainerName, "\\");
   hstrContainerName = DrgAddStrHandle(szFullContainerName);

   fsControl = 0;
   chDrive = (CHAR) pContainerName[0];

   if((chDrive=='A') || (chDrive=='B') || (chDrive=='a') || (chDrive=='b'))
   {	   /* is source container removable media?   */
      fsControl = fsControl | (SHORT)DC_REMOVEABLEMEDIA;
   }

   fsSupportedOps = DO_COPYABLE | DO_MOVEABLE;	  /* can only move or copy */

   /*
    * Initialize common portions of the internal Dragitem buffer.
    */
   Dragitem.hwndItem	      = hwndClient;
   Dragitem.hstrType	      = hstrType;
   Dragitem.hstrRMF	      = hstrRMF;
   Dragitem.hstrContainerName = hstrContainerName;
   Dragitem.fsControl	      = fsControl;
   Dragitem.fsSupportedOps    = fsSupportedOps;

   /*
    * Initialize unique portions of the internal Dragitem buffer for each
    * item that was selected.
    */
   item = LIT_FIRST;

   for (i = 0L; i < ulItemsDragged; ++i)
   {
      item = WinQueryLboxSelItemNext (hList, item);
      WinQueryLboxItemText (hList, item, szItemName, sizeof(szItemName));
      pFile = FindFileName (szItemName);

      if (pFile == NULL)
      {
	 MessageBox(HWND_DESKTOP, IDMSG_CANTLOCATE, MB_OK | MB_ERROR, TRUE);
      }
      else
      {
	 Dragitem.hstrSourceName = DrgAddStrHandle (pFile->achName);
	 Dragitem.hstrTargetName = Dragitem.hstrSourceName;
	 Dragitem.ulItemID = (ULONG)AllocAppDragitem(pSourceDraginfo, pFile);
	 if(Dragitem.ulItemID == 0L)
	    return FALSE;
	 if (pFile->attrFile & FILE_DIRECTORY)
	    Dragitem.fsControl = Dragitem.fsControl | (SHORT)DC_CONTAINER;

	 if(!DrgSetDragitem(pSourceDraginfo, &Dragitem, sizeof(DRAGITEM), i))
	 {
	    MessageBox(HWND_DESKTOP, IDMSG_DRAGSETITEMERROR,
		       MB_OK | MB_ERROR, TRUE);
	    return FALSE;
	 }
      }
   }
   /*
    *  Drag the items.
    */
   if (ulItemsDragged == 1L)
      hImage = (Dragitem.fsControl & DC_CONTAINER) ? hptrFolder : hptrFile;
   else
      hImage = hptrMulti;

   ++ulDragCount;		      /* remember drag is in progress	  */
   PreventClose(hwndClient, ulDragCount);

   dimg.cb	 = sizeof (DRAGIMAGE);
   dimg.hImage	 = hImage;
   dimg.fl	 = DRG_ICON | DRG_TRANSPARENT;
   dimg.cxOffset = 0;
   dimg.cyOffset = 0;

   pSourceDraginfo->hwndSource = hwndClient;
   hwndTarget=DrgDrag(hwndClient, pSourceDraginfo, &dimg, 1L, VK_BUTTON2, NULL);

   if (hwndTarget == NULLHANDLE)
   {
     /*
      * User cancelled the drag or asked for help, so we can release
      * the resources allocated to the drag operation.
      */
      FreeSourceResources (hab, pSourceDraginfo);
      --ulDragCount;
      PreventClose (hwndClient, ulDragCount);
   }
   return TRUE;
}     /*  End of InitDrag  */


/**************************************************************************
 *
 *  Name       : EndConversation(hwndClient, mp1)
 *
 *  Description: Decrements ulItemsDragged by one for each
 *		 DM_ENDCONVERSATION received.  When ulItemsDragged
 *		 becomes 0, the DRAGINFO structure is freed.
 *
 *  Concepts   :  direct manipulation
 *
 *  API's      :  WinWindowFromID
 *		  WinDeleteLboxItem
 *		  DrgFreeDraginfo
 *		  WinGetLastError
 *
 *  Parameters :  hwndClient = client window handle
 *		  mp1	     = drag item ID
 *		  mp2	     = render success flag
 *
 *  Return     :  NULL = successful end to the conversation
 *
 *************************************************************************/
MRESULT EndConversation(HAB hab, HWND hwndClient, MPARAM mp1, MPARAM mp2)
{
   PAPPDRAGITEM pAppDragitem = (PAPPDRAGITEM)mp1;
   PAPPDRAGINFO pAppDraginfo;
   USHORT	i;
   HWND		hwndLbox = WinWindowFromID (hwndClient, LIST_ID);

  /*
   *   Did the target properly render the item?
   */
   if(mp2 == (MPARAM)DMFL_TARGETFAIL)
      MessageBox(HWND_DESKTOP, IDMSG_TARGETRENDER, MB_OK | MB_ERROR, TRUE);
  /*
   * delete the item from the listbox if the operation was a move
   */
   if (pAppDragitem->pDraginfo->usOperation == (USHORT)DO_MOVE)
   {
      i = WinFindLboxItem (hwndLbox, pAppDragitem->pFile->achName);
      WinDeleteLboxItem (hwndLbox, i);
   }

   pAppDraginfo = FindAppDraginfo(FindDraginfo(pAppDragitem));
   if(!pAppDraginfo)
      MessageBox(HWND_DESKTOP, IDMSG_FINDAPPDRAGINFO, MB_OK | MB_ERROR, TRUE);
   FreeAppDragitem(pAppDragitem);

   if (--pAppDraginfo->usItemsDragged == 0)
   {
      if(DrgFreeDraginfo(pAppDraginfo->pDraginfo)
	       || PMERR_SOURCE_SAME_AS_TARGET == WinGetLastError(hab))
      {
	 if(!FreeAppDraginfo(pAppDraginfo))
	    MessageBox(HWND_DESKTOP, IDMSG_MEMFREEERROR, MB_OK | MB_ERROR,TRUE);
	 else
	 {
	    --ulDragCount;		     /* indicate drag completed */
	    PreventClose(hwndClient, ulDragCount);
	 }
      }
      else
	 MessageBox(HWND_DESKTOP, IDMSG_DRAGFREEERROR, MB_OK | MB_ERROR, TRUE);
   }
   return (MRESULT)NULL;
}  /*  End of EndConversation  */


/**************************************************************************
 *
 *  Name       : DragLeave()
 *
 *  Description: Called when a LN_DRAGLEAVE message is received.
 *		 As this application does not do target emphasis,
 *		 this function simply returns NULL.
 *
 *  Concepts   :  target emphasis
 *
 *  API's      :  [none]
 *
 *  Parameters :  [none]
 *
 *  Return     :  NULL = successful end
 *
 *************************************************************************/
MRESULT DragLeave (void)
{
   return (MRESULT)NULL;
}  /*  End of DragLeave	 */

/**************************************************************************
 *
 *  Name       : DropHelp(hwndClient, pDraginfo)
 *
 *  Description: Issues a message to notify the user what would happen
 *		 if mouse button 2 were released, based on the current
 *		 operation.
 *
 *  Concepts   :  direct manipulation
 *
 *  API's      :  DrgAccessDraginfo
 *		  DrgDeleteDraginfoStrHandles
 *		  DrgFreeDraginfo
 *
 *  Parameters :  hwndClient = client window handle
 *		  pDraginfo  = pointer to drag information structure
 *
 *  Return     :  NULL = successful
 *
 *************************************************************************/
MRESULT DropHelp (HWND hwndClient, PDRAGINFO pDraginfo)
{
   char message[81];

   if(!DrgAccessDraginfo (pDraginfo))
   {
      MessageBox(HWND_DESKTOP, IDMSG_DRAGACCESSERROR, MB_OK | MB_ERROR, TRUE);
   }
   strcpy (message, "Dropping here would perform ");

   switch (pDraginfo->usOperation)
   {
   case DO_DEFAULT:
      strcat (message, "the default ");
      break;
   case DO_COPY:
      strcat (message, "a copy ");
      break;
   case DO_MOVE:
      strcat (message, "a move ");
      break;
   case DO_UNKNOWN:
      strcat (message, "an unknown (private) ");
      break;
   }

   strcat (message, "operation.");
   Message (message);

   if(DrgDeleteDraginfoStrHandles(pDraginfo) && DrgFreeDraginfo(pDraginfo))
      ;	       /*  free OK  */
   else
   {
      MessageBox(HWND_DESKTOP, IDMSG_DRAGERROR, MB_OK | MB_ERROR, TRUE);
   }
   hwndClient = hwndClient;	   /* unreferenced formal parameter */
   return (MRESULT)NULL;
}  /*  End of DropHelp	*/


/**************************************************************************
 *
 *  Name       : DragOver(pDraginfo, pCurrentDir)
 *
 *  Description: Provides visual feedback to the user as to whether it
 *		 can support the drag operation
 *
 *  Concepts   :  direct manipulation
 *
 *  API's      :  DrgAccessDraginfo
 *		  DrgFreeDraginfo
 *		  DrgQueryDragitemPtr
 *		  DrgQueryStrName
 *		  DrgQueryDragitemCount
 *		  DrgVerifyRMF
 *		  WinGetLastError
 *
 *  Parameters :  pDraginfo  = pointer to drag information structure
 *		  pCurrentDir= the name of the current directory
 *
 *  Return     :  DOR_DROP, DO_MOVE for a default operation
 *
 *************************************************************************/
MRESULT DragOver(HAB hab, PDRAGINFO pDraginfo, PSZ pCurrentDir)
{
   USHORT	 usIndicator, cItems, i;
   ULONG	 ulBytesWritten;
   PDRAGITEM	 pditem;
   CHAR		 SourceDir [CCHMAXPATH], chDrive;

  /*
   * Get access to the DRAGINFO structure.
   */
   if(!DrgAccessDraginfo(pDraginfo))
   {
      MessageBox(HWND_DESKTOP, IDMSG_DRAGACCESSERROR, MB_OK | MB_ERROR, TRUE);
      return (MRFROM2SHORT (DOR_NODROPOP, 0));
   }
   usOperation = (USHORT)DO_MOVE;	   /* the default operation is move */

  /*
   * Determine if a drop can be accepted.
   */
   switch (pDraginfo->usOperation)
   {
    /*
     * return DOR_NODROPOP if current operation is link or unknown.
     */
   case DO_UNKNOWN:
      if(!DrgFreeDraginfo (pDraginfo))
	 MessageBox(HWND_DESKTOP, IDMSG_DRAGFREEERROR, MB_OK | MB_ERROR, TRUE);
      return (MRFROM2SHORT (DOR_NODROPOP, 0));

    /*
     * Determine default operation if current operation is default.
     * The default is move unless either the source or the target is
     * on different removable media.
     */
   case DO_DEFAULT:
      pditem = DrgQueryDragitemPtr (pDraginfo, 0);
      ulBytesWritten = DrgQueryStrName(pditem->hstrContainerName,
				       sizeof(SourceDir),
				       SourceDir);
      if(ulBytesWritten == 0L)
      {
	 MessageBox(HWND_DESKTOP, IDMSG_DRAGQUERYSTRINGERROR,
			  MB_OK | MB_ERROR, TRUE);
	 return (MRFROM2SHORT (DOR_NODROPOP, 0));
      }

	 /*
	  * if the source and target are on the
	  * same drive, the operation is a move
	  */
      if (*pCurrentDir == SourceDir[0])
	 usOperation = (USHORT)DO_MOVE;
	 /*
	  * otherwise, different drives
	  */
      else
      {
	 chDrive = (CHAR)pCurrentDir[0];
	   /*
	    * if the target is A: or B:, or the source
	    * is removeable media, the operation is a copy
	    */
	 if((chDrive == 'A') || (chDrive == 'B') || (chDrive == 'a') ||
	    (chDrive=='b') || pditem->fsControl & DC_REMOVEABLEMEDIA)
	 {
	    usOperation = (USHORT)DO_COPY;
	 }
	   /*
	    * otherwise, the default operation is a move
	    */
	 else
	 {
	    usOperation = (USHORT)DO_MOVE;
	 }
      }
      break;

   case DO_MOVE:
   case DO_COPY:
      usOperation = pDraginfo->usOperation;
      break;
   }

  /*
   * In order to support the operation, the source must support the
   * operation this target has decided upon.  The source must also
   * support a rendering mechanism of <DRM_OS2FILE,DRF_UNKNOWN>.
   * This target doesn't care about the file type.
   */

   usIndicator = DOR_DROP;
   cItems = DrgQueryDragitemCount (pDraginfo);

   /*
    * inspect each item to see if it is acceptable
    */
   for (i = 0; i < cItems; ++i)
   {
      pditem = DrgQueryDragitemPtr (pDraginfo, i);

     /*
      * the item is acceptable only if it is copyable and the
      * operation is a copy, or it is moveable and the operation
      * is a move, and it can render <DRM_OS2FILE,DRF_UNKNOWN>
      */
      if (((pditem->fsSupportedOps & DO_COPYABLE) &&
			(usOperation == (USHORT)DO_COPY)) ||
	  ((pditem->fsSupportedOps & DO_MOVEABLE) &&
			  (usOperation == (USHORT)DO_MOVE)))
      {
	 if (DrgVerifyRMF(pditem, "DRM_OS2FILE", "DRF_UNKNOWN"))
	 {
	    usIndicator = DOR_DROP;
	 }
	 else
	 {
	    usIndicator = DOR_NEVERDROP;
	    break;
	 }			      /* endif DrgVerifyRendMechFmt */
      }
      else
      {
	 usIndicator = DOR_NODROPOP;
	 break;
      }					    /* endif supported ops	  */
   }					   /* end for all items dragged	 */

   if(!DrgFreeDraginfo(pDraginfo))
      if(PMERR_SOURCE_SAME_AS_TARGET != WinGetLastError(hab))
      {
	 MessageBox(HWND_DESKTOP, IDMSG_DRAGFREEERROR, MB_OK | MB_ERROR, TRUE);
	 return (MRFROM2SHORT (DOR_NODROPOP, 0));
      }
   return (MRFROM2SHORT(usIndicator, usOperation));
}  /*  End of DragOver	*/


/**************************************************************************
 *
 *  Name       :  Drop (hwndClient, pDraginfo, pCurrentDir)
 *
 *  Description:  This function handles the drop operation
 *
 *		  Since we would not receive a DM_DROP message unless a
 *		  DOR_DROP reply had been given for a DM_DRAGOVER, we
 *		  can assume we have successfully validated that we can
 *		  accept the drop. Note that drag would havesent another
 *		  DM_DRAGOVER if the operation had changed.
 *
 *		  Therefore we don't have to re-validate the operation.
 *		  We can go ahead and perform the operation. We will
 *		  perform each copy in sequence, but will not capture
 *		  the mouse. This should allow the user to perform
 *		  other operations, but not require this application
 *		  to start another thread and coordinate the ending of
 *		  the conversation and freeing up of resources. The user
 *		  will not be able to perform any other operations with
 *		  this application while the operations are in progress.
 *
 *  Concepts   :  direct manipulation
 *
 *  API's      :  DrgAccessDraginfo
 *		  DrgQueryDragitemPtr
 *		  DrgQueryStrName
 *		  DrgAddStrHandle
 *		  DrgSendTransferMsg
 *		  WinStartTimer
 *		  WinGetMsg
 *		  WinStopTimer
 *		  WinDispatchMsg
 *		  DrgFreeDragtransfer
 *		  DosGetNamedSharedMem
 *		  DrgDeleteDraginfoStrHandles
 *		  DrgFreeDraginfo
 *		  DosSubAllocMem
 *		  DosCreateThread
 *
 *  Parameters :  hwndClient = client window handle
 *		  pDraginfo  = ointer to a drag information structure
 *		  pCurrentDir= the name of the current directory
 *
 *  Return     :  NULL = successful
 *
 *************************************************************************/
MRESULT Drop(HAB hab, HWND hwndClient, PDRAGINFO pDraginfo, PSZ pCurrentDir)
{
   PDRAGTARGETTHREAD	 pParm;
   PBYTE	  aStack;
   TID		 tid;
   USHORT	 i;
   PDRAGTRANSFER pdxfer;
   PDRAGITEM	 pditem;
   HSTR		 hstrRMF;
   char		 szFullTargetName  [CCHMAXPATH];
   char		 szTargetFile [CCHMAXPATHCOMP];
   QMSG		 qmsg;
   USHORT	 cRetry, idTimer;
   ULONG	 mr, ulBytesWritten;

   /*
    * Get access to the Draginfo structure.
    */
   if(!DrgAccessDraginfo (pDraginfo))
      MessageBox(HWND_DESKTOP, IDMSG_DRAGACCESSERROR, MB_OK | MB_ERROR, TRUE);
   if (pDraginfo->hwndSource == hwndClient)
   {
     /*
      * Source window and target window are the same, so don't do the
      * operation... just release the resources allocated for the drag.
      */
      FreeSourceResources (hab, pDraginfo);
      --ulDragCount;
      PreventClose (hwndClient, ulDragCount);
      return (MRESULT)NULL;
   }

   pditem = DrgQueryDragitemPtr (pDraginfo, 0);

   /*
    * if the source name wasn't provided, let the source render
    */
   if (!pditem->hstrSourceName)
   {
      pdxfer   = DrgAllocDragtransfer (pDraginfo->cditem);
      hstrRMF  = DrgAddStrHandle ("<DRM_OS2FILE, DRF_UNKNOWN>");

      for (i=0; i<pDraginfo->cditem; i++)
      {
	 pditem = DrgQueryDragitemPtr (pDraginfo, i);

       /*
	* Build the fully qualified target file name.
	*/
	 strcpy (szFullTargetName, pCurrentDir);
	 RemoveFinalBackslash (szFullTargetName);
	 ulBytesWritten =DrgQueryStrName(pditem->hstrTargetName,
					 sizeof(szTargetFile),
					 szTargetFile);
	 if(ulBytesWritten == 0L)
	    MessageBox(HWND_DESKTOP, IDMSG_DRAGQUERYSTRINGERROR,
			   MB_OK | MB_ERROR, TRUE);

	 if (szTargetFile[0] != '\\')
	    strcat(szFullTargetName, "\\");
	 strcat(szFullTargetName, szTargetFile);

       /*
	* initialize the DRAGTRANSFER
	*/
	 pdxfer[i].cb		    = sizeof (DRAGTRANSFER);
	 pdxfer[i].hwndClient	    = hwndClient;
	 pdxfer[i].pditem	    = pditem;
	 pdxfer[i].hstrSelectedRMF  = hstrRMF;
	 pdxfer[i].hstrRenderToName = DrgAddStrHandle (szFullTargetName);
	 pdxfer[i].ulTargetInfo	    = 0L;
	 pdxfer[i].usOperation	    = pDraginfo->usOperation;
	 pdxfer[i].fsReply	    = 0;

	 /*
	  * send the DM_RENDER to the source, retrying as necessary
	  */
	 for (cRetry=0, mr=0; cRetry<MAX_RETRIES && !mr; cRetry++)
	 {
	    mr = (ULONG)DrgSendTransferMsg(pDraginfo->hwndSource,
					   DM_RENDER,
					   (MPARAM)(pdxfer + i),
					   (MPARAM)NULL);

	   /*
	    * if the source didn't render, retry if we can
	    */
	    if (!mr)
	    {
	       if (pdxfer[i].fsReply & DMFL_RENDERRETRY)
	       {
		  idTimer = WinStartTimer (0L, 0L, 0L, 1000L);

	       /*
		* start a timer to wait, but process
		* messages so we don't hang the queue
		*/
		  while (WinGetMsg (0L, &qmsg, 0L, 0, 0))
		  {
		     if ((qmsg.msg == WM_TIMER) &&
			       ((USHORT) qmsg.mp1 == idTimer))
		     {
			WinStopTimer (0L, 0L, idTimer);
			break;
		     }
		     else
			WinDispatchMsg (0L, &qmsg);
		  }
	       }
	       else
		  DrgFreeDragtransfer(pdxfer + i);
	    }
	 }
      }
   }

   /*
    * Allocate the stack segment for the target thread.
    */
   else if (DosGetNamedSharedMem((PPVOID)&aStack, (PSZ)"\\sharemem\\dragmem",
				 PAG_READ | PAG_WRITE) != 0LU)
   {
      MessageBox(HWND_DESKTOP, IDMSG_CANTCREATESTACK, MB_OK | MB_ERROR, TRUE);
      DrgDeleteDraginfoStrHandles(pDraginfo);
      DrgFreeDraginfo(pDraginfo);
   }
   else
   {
     /*
      * Build the parameter list structure for the target thread.
      */
      DosSubAllocMem(aStack, (PPVOID)&pParm, sizeof(DRAGTARGETTHREAD));

      pParm->pDraginfo	 = pDraginfo;
      pParm->hwndClient	 = hwndClient;
      pParm->usOperation = usOperation;
      strcpy(pParm->szTargetDir, pCurrentDir);

     /*
      * Remember that a drag is in progress and start the target thread.
      */
      ++ulDragCount;
      PreventClose (hwndClient, ulDragCount);

      vpThreadParms = pParm;

      DosCreateThread(&tid, (PFNTHREAD)TargetThread,
		      (ULONG)vpThreadParms, 0U, STACKSIZE);
   }

   return (MRESULT)NULL;
}    /*	 End of Drop  */


/**************************************************************************
 *
 *  Name       :  EndTarget(hwnd, pParm)
 *
 *  Description: This function is called whenever a WM_TARGETCOMPLETE
 *		 message is received. It releases all resources used
 *		 during the drag operation and remembers that the drag
 *		 operation has completed.
 *
 *  Concepts   :  direct manipulation
 *
 *  API's      :  DrgQueryDragitemCount
 *		  DrgQueryDragitem
 *		  DrgSendTransferMsg
 *		  DrgDeleteDraginfoStrHandles
 *		  DrgFreeDraginfo
 *		  WinPostMsg
 *
 *  Parameters :  hwnd	     = window handle
 *		  pParm	     = points to drag information
 *
 *  Return     :  NULL = successful
 *
 *************************************************************************/
MRESULT EndTarget (HWND hwnd, PDRAGTARGETTHREAD pParm)
{
   USHORT		 cItems, i;
   DRAGITEM		 Dragitem;

  /*
   * Decrement the count of drag operations in progress and prepare to
   * release the resources allocated for the drag operation.
   */
   --ulDragCount;
   PreventClose (hwnd, ulDragCount);
   cItems = DrgQueryDragitemCount (pParm->pDraginfo);

  /*
   * End the conversation for each item in the DRAGINFO structure and
   * let source know we have completed the drag operation for each item.
   */
   for (i = 0; i < cItems; ++i)
   {
      if(!DrgQueryDragitem (pParm->pDraginfo, sizeof(Dragitem), &Dragitem, i))
	 MessageBox(HWND_DESKTOP, IDMSG_DRAGQUERYITEMERROR,
		    MB_OK | MB_ERROR, TRUE);
      DrgSendTransferMsg(Dragitem.hwndItem, DM_ENDCONVERSATION,
			 MPFROMLONG(Dragitem.ulItemID),
			 MPFROMLONG(DMFL_TARGETSUCCESSFUL));
   }
  /*
   * Free the draginfo structure.
   */
   if(DrgDeleteDraginfoStrHandles(pParm->pDraginfo)
		 && DrgFreeDraginfo(pParm->pDraginfo))
      ;
   else
      MessageBox(HWND_DESKTOP, IDMSG_DRAGERROR, MB_OK | MB_ERROR, TRUE);
   WinPostMsg(hwnd, WM_REFRESH, NULL, NULL);
   return (MRESULT)NULL;
}  /*  End of EndTarget	 */


/**************************************************************************
 *
 *  Name       :  CheckBusy()
 *
 *  Description:  This call determines if a drag is in progress.
 *
 *  Concepts   :  direct manipulation
 *
 *  API's      :  [none]
 *
 *  Parameters :  [none]
 *
 *  Return     :  TRUE = a drag is in progress
 *		  FALSE = no drag in progress
 *
 *************************************************************************/
BOOL CheckBusy (void)
{
   return ((BOOL) ulDragCount);
}  /*  End of CheckBusy	 */


/**************************************************************************
 *
 *  Name       :  CheckClose(hwnd)
 *
 *  Description:  This call determines if a drag is in progress by
 *		  checking ulDragCount.	 If a drag is in progress,
 *		  close is not allowed.
 *
 *  Concepts   :  direct manipulation
 *
 *  API's      :  WinPostMsg
 *
 *  Parameters :  hwnd = window handle
 *
 *  Return     :  TRUE = a drag is in progress
 *		  FALSE = no drag in progress
 *
 *************************************************************************/
MRESULT CheckClose (HWND hwnd)
{
   if (!ulDragCount)
      WinPostMsg (hwnd, WM_QUIT, (MPARAM)0L, (MPARAM)0L);

   return ((MPARAM)NULL);
}  /*  End of CheckClose  */

/**************************************************************************
 *
 *  Name       :  TargetThread()
 *
 *  Description:  This is the main function of this thread.
 *
 *  Concepts   :  direct manipulation
 *
 *  API's      :  DrgQueryDragitemCount
 *		  DrgQueryDragitem
 *		  DrgQueryStrName
 *		  DosCopy
 *		  DosDelete
 *		  DosEnterCritSec
 *
 *  Parameters :  [none]
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID FAR TargetThread (void)
{
   PDRAGTARGETTHREAD pParm;
   USHORT	 cItems, i;
   ULONG	 ulBytesWritten;
   DRAGITEM	 Dragitem;
   char		 szFullSourceName  [CCHMAXPATH];
   char		 szFullTargetName  [CCHMAXPATH];
   char		 szSourceFile [CCHMAXPATHCOMP];
   char		 szTargetFile [CCHMAXPATHCOMP];

   pParm = vpThreadParms;

  /*
   * Get the number of items being dragged.
   */

   cItems = DrgQueryDragitemCount (pParm->pDraginfo);

  /*
   * If the source has provided the file name in the DRAGITEM
   * structures, we can go ahead and do a target copy without getting
   * the source involved in the operation.  We will always copy the file
   * using the suggested target name.  In this application the names
   * are always the same.
   */

   for (i = 0; i < cItems; ++i)
   {
      if(!DrgQueryDragitem (pParm->pDraginfo, sizeof(Dragitem), &Dragitem, i))
	 MessageBox(HWND_DESKTOP, IDMSG_DRAGQUERYITEMERROR,
		      MB_OK | MB_ERROR, TRUE);
      if(Dragitem.hstrSourceName    != 0L &&
	 Dragitem.hstrTargetName    != 0L &&
	 Dragitem.hstrContainerName != 0L)
      {
      /*
       * Build the fully qualified source file name.
       */
	 ulBytesWritten = DrgQueryStrName(Dragitem.hstrContainerName,
					  sizeof(szFullSourceName),
					  szFullSourceName);
	 if(ulBytesWritten == 0)
	    MessageBox(HWND_DESKTOP, IDMSG_DRAGQUERYSTRINGERROR,
		       MB_OK | MB_ERROR, TRUE);
	 ulBytesWritten = DrgQueryStrName(Dragitem.hstrSourceName,
					  sizeof(szSourceFile),
					  szSourceFile);
	 if(ulBytesWritten == 0)
	    MessageBox(HWND_DESKTOP, IDMSG_DRAGQUERYSTRINGERROR,
			MB_OK | MB_ERROR, TRUE);

	 if (szSourceFile[0] == '\\')
	    strcpy (szSourceFile, szSourceFile+1);

	 strcat (szFullSourceName, szSourceFile);

      /*
       * Build the fully qualified target file name.
       */
	 strcpy (szFullTargetName, pParm->szTargetDir);
	 RemoveFinalBackslash (szFullTargetName);
	 ulBytesWritten = DrgQueryStrName(Dragitem.hstrTargetName,
					  sizeof(szTargetFile),
					  szTargetFile);
	 if(ulBytesWritten == 0)
	    MessageBox(HWND_DESKTOP, IDMSG_DRAGQUERYSTRINGERROR,
			   MB_OK | MB_ERROR, TRUE);

	 if (szTargetFile[0] != '\\')
	    strcat (szFullTargetName, "\\");

	 strcat (szFullTargetName, szTargetFile);

      /*
       * Do the operation.  DosCopy works with different drives;
       * DosMove does not, so we will use DosCopy and DosDelete.
       */
	 switch (pParm->usOperation)
	 {
	 case DO_MOVE:	   /*  Mimic DosMove with DosCopy and DosDelete.  */
	     if(DosCopy(szFullSourceName, szFullTargetName, DCPY_EXISTING)
			  == NO_ERROR)
		DosDelete(szFullSourceName);
	     break;
	 case DO_COPY:
	     DosCopy (szFullSourceName, szFullTargetName, DCPY_EXISTING);
	     break;
	 }			      /* end switch usOperation */
      }				      /* end of target copy	*/
   }				      /* end of dragitem loop	*/

  /*
   * Post ourselves a target complete message so the client window
   * knows we are done and can free the stack segment and the draginfo
   * structure.
   */
   DosEnterCritSec();			/* make sure we finish before the   */
					/* main thread frees our stack	    */

   WinPostMsg (pParm->hwndClient, WM_TARGETCOMPLETE, pParm, NULL);
}  /*  End of TargetThread  */
/***************************  End of dragdrag.c	 *************************/

/**************************************************************************
 *  File name  :  dragheap.c
 *
 *  Description:  This file contains all file and memory management
 *		  functions for the Drag/Drop sample.
 *
 *		  This source file contains the following functions:
 *
 *		  FindFilePurge()
 *		  FindFileFirst(pszFilename, ulAttributes)
 *		  FindFileNext(pInput)
 *		  FindFileName(pszName)
 *		  AllocAppDraginfo(hwndClient, pDraginfo)
 *		  FreeAppDraginfo(pAppDraginfo)
 *		  FindAppDraginfo(pDraginfo)
 *		  AllocAppDragitem(pDraginfo, pFile)
 *		  FreeAppDragitem(pAppDragitem)
 *		  FindDraginfo(pAppDragitem)
 *		  FindDragitemFile(pAppDragitem)
 *
 *  Concepts   :  memory management
 *
 *  API's      :  DosSubFreeMem
 *		  DosGetNamedSharedMem
 *		  DosAllocSharedMem
 *		  DosSubSetMem
 *		  DosFindFirst
 *		  DosSubAllocMem
 *		  DosFindNext
 *		  DosFindClose
 *		  DrgQueryDragitemCount
 *
 *  Required
 *    Files    :  OS2.H, STRING.H, DRAGDROP.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/

/*
 *	  Include the required sections from the PM header file
 */
#define INCL_DOSERRORS
#define INCL_DOSFILEMGR
#define INCL_WIN
#define INCL_WINSTDDRAG

/*
 *		       Include the PM header file
 */
#include <os2.h>

/*
 *		    Include the C library header files
 */
#include <string.h>

/*
 *		   Include the application header files
 */
#include "dragdrop.h"

/*
 * Variables global to file
 */

static PBYTE		hHeap	  = NULL;   /* heap from which elements are */
					    /* allocated		    */
static PPUBFILEFINDBUF	pFirst	  = NULL;   /* anchor to list of elements   */
static PAPPDRAGINFO	pFirstAppDraginfo = NULL;
					    /* pointer to chain of source   */
					    /* that contain information	    */
					    /* for each drag in progress    */

/**************************************************************************
 *
 *  Name       : FindFilePurge
 *
 *  Description: Removes all entries in the list.  The function is
 *		 invoked from FileFindFirst to remove the old list if
 *		 one is present.
 *
 *  Concepts   :
 *
 *  API's      :  DosSubFreeMem
 *
 *  Parameters :  [none]
 *
 *  Return     :  TRUE	= list was purged
 *		  FALSE = purge of list was unsuccessful
 *************************************************************************/
BOOL FindFilePurge(VOID)
{
   PPUBFILEFINDBUF pList, pListNext;

   for (pList = pFirst; pList != NULL; pList = pListNext)
   {
      pListNext = pList->pNext;
      if(NO_ERROR !=
	    DosSubFreeMem(hHeap, (NPBYTE)pList, sizeof(PUBFILEFINDBUF)))
	 return FALSE;
   }
   pFirst = NULL;				   /* indicate list is empty */
   return TRUE;
}


/**************************************************************************
 *
 *  Name       : FindFileFirst
 *
 *  Description: Finds all files in the input subdirectory, creating
 *		 a list of these files in the heap.  It then returns
 *		 the first file found onthe queue that matches the
 *		 input attributes.
 *
 *  Concepts   :
 *
 *  API's      :  DosGetNamedSharedMem
 *		  DosAllocSharedMem
 *		  DosSubSetMem
 *		  DosFindFirst
 *		  DosSubAllocMem
 *		  DosFindNext
 *		  DosFindClose
 *
 *  Parameters :  pszFilename = the name of the file
 *		  ulAttributes = attribute flags
 *
 *  Return     :  address of the first list element that matches the
 *		  input attributes, or
 *		  NULL = no file matched the input attributes
 *************************************************************************/
PPUBFILEFINDBUF FindFileFirst (PSZ pszFilename, ULONG ulAttributes)
{
   FILEFINDBUF3	   ffbFile;
   ULONG	   rc;
   ULONG	   cFile;
   PPUBFILEFINDBUF pAlloc, pTail;
   NPBYTE	   npBuffer;
   HDIR		   hDir;
   PVOID	   phHeap;

   if (!hHeap)
   {
     /*
      * Initialize the heap that will be used to contain the queue elements
      * for the files in the subdirectory
      */
     rc = DosGetNamedSharedMem((PPVOID)&hHeap, (PSZ)"\\sharemem\\dragmem",
			       PAG_READ | PAG_WRITE);
     if (rc != 0L)
     {
	rc = DosAllocSharedMem((PPVOID)&hHeap, (PSZ)"\\sharemem\\dragmem",
			     65535LU,  PAG_COMMIT | PAG_READ | PAG_WRITE);

	if(rc != 0L ||	  /* Initialize the heap.		  */
	   (NO_ERROR != DosSubSetMem((PVOID)hHeap, 1, 65535)))
	{
	  /*
	   * Heap initialization failed.
	   */
	  MessageBox(HWND_DESKTOP,
		    IDMSG_HEAPERROR,
		    MB_OK | MB_ERROR,
		    TRUE);
	  return NULL;
	}
	 /*
	  * Heap is initialized - set anchor to NULL.
	  */
	pFirst = NULL;
     }
   }

   /*
    * heap now initialized
    *
    * free the entries currently on the list and create the new list
    */
   if(!FindFilePurge())			       /* empty the current list   */
   {
      MessageBox(HWND_DESKTOP,
		    IDMSG_MEMFREEERROR,
		    MB_OK | MB_ERROR,
		    TRUE);
      return NULL;
   }

   cFile = 1;				       /* buffer is large enough   */
					       /* to contain info for 1	   */
					       /* file			   */
   hDir = HDIR_CREATE;			       /* allocate DosFind handle  */
   rc = DosFindFirst(pszFilename, &hDir, ulAttributes, &ffbFile,
		     sizeof(ffbFile), &cFile, 1);
   while (!rc)
   {
    /*
     * if we couldn't allocate a buffer from the heap, display an
     * error message and set the flag that will terminate the loop
     */
      if((NO_ERROR !=
	DosSubAllocMem((PVOID)hHeap, (PPVOID)&npBuffer, sizeof(PUBFILEFINDBUF)))
	       ||     !npBuffer)
      {
	 MessageBox(HWND_DESKTOP,
		    IDMSG_HEAPALLOCERROR,
		    MB_OK | MB_ERROR,
		    TRUE);
	 rc = 1;
      }

    /*
     * otherwise, add the found entry to the list
     */
      else
      {
	 phHeap = hHeap;
	 pAlloc = (PPUBFILEFINDBUF) npBuffer;
	 pAlloc->pNext = NULL;

      /*
       * if this is the first one in the list, update the head pointer
       */
	 if (pFirst == NULL)
	    pFirst = pAlloc;

      /*
       * otherwise, add it to the end of the list
       */
	 else
	   pTail ->pNext = pAlloc;

	 pTail = pAlloc;		    /* update the tail pointer	    */

      /*
       * copy portions of file find buffer that will be kept to the
       * buffer that we allocated.
       */
	 if (ffbFile.attrFile & FILE_DIRECTORY)
	    strcpy (pAlloc->achName, "\\");	/* add '\\' before directory  */
	 else
	    pAlloc->achName[0] = '\0';		/* just a file		      */

	 strcat (pAlloc->achName, ffbFile.achName);
	 pAlloc->fdateLastWrite = ffbFile.fdateLastWrite;
	 pAlloc->ftimeLastWrite = ffbFile.ftimeLastWrite;
	 pAlloc->cbFileAlloc	= ffbFile.cbFileAlloc;
	 pAlloc->attrFile	= ffbFile.attrFile;

      /*
       * get next file
       */
	 rc = DosFindNext (hDir, &ffbFile, (LONG)(sizeof(ffbFile)), &cFile);
      }
   }

  /*
   * All files have been found. Free the file find handle and send the
   * appropriate return code.
   */
   DosFindClose (hDir);
   return (pFirst);
}


/**************************************************************************
 *
 *  Name       : FindFileNext
 *
 *  Description: Finds the next file int eh input subdirectory
 *
 *  Concepts   :
 *
 *  API's      :  [none]
 *
 *  Parameters :  pInput = a pointer to the input file-find buffer
 *
 *  Return     :  address of the next file that matches the
 *		  input attributes, or
 *		  NULL = no file matched the input attributes before
 *			 reaching the end of the list
 *************************************************************************/
PPUBFILEFINDBUF FindFileNext(PPUBFILEFINDBUF pInput)
{
   return ((pInput != NULL) ? pInput->pNext : (PPUBFILEFINDBUF)NULL);
}

/**************************************************************************
 *
 *  Name       : FindFileName
 *
 *  Description: Finds the next file in the input subdirectory
 *
 *  Concepts   :
 *
 *  API's      :  [none]
 *
 *  Parameters :  pszName = a pointer to the file name string
 *
 *  Return     :  address of the next file that matches the
 *		  input file name, or
 *		  NULL = no file matched the input name
 *************************************************************************/
PPUBFILEFINDBUF FindFileName (PSZ pszName)
{
   PPUBFILEFINDBUF	 pList;

   pList = pFirst;

   while (pList != NULL)
   {
      if (strcmp (pList->achName, pszName) == 0)
	 break;

      pList = pList -> pNext;
   }

   return pList;
}

/**************************************************************************
 *
 *  Name       : AllocAppDraginfo
 *
 *  Description: Allocates an APPDRAGINFO control block and places
 *		 it on a queue to be found by the application later.
 *		 The APPDRAGINFO is initialized.
 *
 *  Concepts   : drag information
 *
 *  API's      :  DosSubAllocMem
 *		  DrgQueryDragitemCount
 *
 *  Parameters :  pszName = a pointer to the file name string
 *
 *  Return     :  address of the APPDRAGINFO, or
 *		  NULL = the allocation failed
 *************************************************************************/
PAPPDRAGINFO AllocAppDraginfo (HWND hwndClient, PDRAGINFO pDraginfo)
{
   NPBYTE	   npBuffer;
   PAPPDRAGINFO	   pAlloc;
   PVOID	   phHeap;

  /*
   * if we couldn't allocate a buffer from
   * the heap, display a message and abort
   */
   if(NO_ERROR != DosSubAllocMem(hHeap, (PPVOID)&npBuffer, sizeof(APPDRAGINFO)))
   {
      MessageBox(HWND_DESKTOP,
		 IDMSG_ALLOCDRAGINFO,
		 MB_OK | MB_ERROR,
		 TRUE);
      return NULL;
   }
   else
   {
    /*
     * Add entry to list.
     */
      phHeap = hHeap;
      pAlloc = (PAPPDRAGINFO) npBuffer;
      pAlloc->pNextAppDraginfo = pFirstAppDraginfo;
      pFirstAppDraginfo = pAlloc;

    /*
     * Initialize the new entry.
     */
      pAlloc->pDraginfo	     = pDraginfo;
      pAlloc->hwndClient     = hwndClient;
      pAlloc->usItemsDragged = DrgQueryDragitemCount(pDraginfo);
      return pAlloc;
   }
}

/**************************************************************************
 *
 *  Name       : FreeAppDraginfo
 *
 *  Description: Removes an APPDRAGINFO from the queue and
 *		 deallocates the memory it was using.
 *
 *  Concepts   : drag information
 *
 *  API's      :  DosSubFreeMem
 *
 *  Parameters :  pAppDraginfo = pointer to the drag information
 *
 *  Return     :  TRUE = memory was successfullly deallocated
 *		  FALSE = the deallocation failed
 *************************************************************************/
BOOL FreeAppDraginfo(PAPPDRAGINFO pAppDraginfo)
{
   PAPPDRAGINFO	   pPrevious, pCurrent;

   pPrevious = NULL;
   pCurrent = pFirstAppDraginfo;

   while (pCurrent != NULL)
   {
      if (pCurrent == pAppDraginfo)
	 break;
      else
      {
	 pPrevious = pCurrent;
	 pCurrent = pCurrent->pNextAppDraginfo;
      }
   }

   if (pCurrent != NULL)
   {
      if (pPrevious == NULL)
	 pFirstAppDraginfo = pCurrent->pNextAppDraginfo;
      else
	 pPrevious->pNextAppDraginfo = pCurrent->pNextAppDraginfo;

      if (NO_ERROR ==
	     DosSubFreeMem(hHeap, (NPBYTE)pAppDraginfo, sizeof(APPDRAGINFO)))
	 return TRUE;
      else
	 return FALSE;
   }
   else
   {
      return FALSE;
   }
}

/**************************************************************************
 *
 *  Name       : FindAppDraginfo
 *
 *  Description: Finds an APPDRAGINFO, given the address of a DRAGINFO
 *
 *  Concepts   : drag information
 *
 *  API's      :  [none]
 *
 *  Parameters :  pDraginfo = pointer to the drag information
 *
 *  Return     :  NULL = unable to find the APPDRAGINFO
 *		  otherwise, the address of the APPDRAGINFO
 *************************************************************************/
PAPPDRAGINFO FindAppDraginfo(PDRAGINFO pDraginfo)
{
   PAPPDRAGINFO	   pCurrent;

   pCurrent = pFirstAppDraginfo;

   while (pCurrent != NULL)
   {
     if (pCurrent->pDraginfo == pDraginfo)
	break;
     else
	pCurrent = pCurrent->pNextAppDraginfo;
   }

   return pCurrent;
}


/**************************************************************************
 *
 *  Name       : AllocAppDragitem
 *
 *  Description: Allocates an APPDRAGITEM control block and initializes it
 *
 *  Concepts   : drag information
 *
 *  API's      :  DosSubAllocMem
 *
 *  Parameters :  pDraginfo = pointer to the drag information
 *		  pFile = file pointer
 *
 *  Return     :  NULL = allocation failed
 *		  otherwise, the address of the APPDRAGINFO
 *************************************************************************/
PAPPDRAGITEM AllocAppDragitem(PDRAGINFO pDraginfo, PPUBFILEFINDBUF pFile)
{
   NPBYTE	   npBuffer;
   PAPPDRAGITEM	   pAlloc;
   PVOID	   phHeap;

   if(NO_ERROR != DosSubAllocMem(hHeap, (PPVOID)&npBuffer, sizeof(APPDRAGITEM)))
   {
       MessageBox(HWND_DESKTOP,
		    IDMSG_HEAPALLOCERROR,
		    MB_OK | MB_ERROR,
		    TRUE);
       return NULL;
   }
   else
   {
     /*
      * initialize the new entry
      */
      phHeap = &hHeap;
      pAlloc = (PAPPDRAGITEM)npBuffer;
      pAlloc->pDraginfo = pDraginfo;
      pAlloc->pFile	= pFile;
      return pAlloc;
   }
}

/**************************************************************************
 *
 *  Name       : FreeAppDragitem
 *
 *  Description: Frees an APPDRAGITEM
 *
 *  Concepts   : drag information
 *
 *  API's      :  DosSubFreeMem
 *
 *  Parameters :  pAppDragitem = pointer to the drag item
 *
 *  Return     :  TRUE = memory was successfully deallocated
 *		  FALSE = an error occurred
 *************************************************************************/
BOOL FreeAppDragitem(PAPPDRAGITEM pAppDragitem)
{
   return (NO_ERROR ==
	 DosSubFreeMem(hHeap, (NPBYTE)pAppDragitem, sizeof(APPDRAGITEM)));
}


/**************************************************************************
 *
 *  Name       : FindDragInfo
 *
 *  Description: Finds the PDRAGINFO for a drag operation, given the
 *		 address of an APPDRAGITEM
 *
 *  Concepts   : drag information
 *
 *  API's      :  [none]
 *
 *  Parameters :  pAppDragitem = pointer to the application drag item
 *
 *  Return     :  NULL = unable to find the drag information
 *		  otherwise, the address of the drag information used
 *		  to drag this item
 *************************************************************************/
PDRAGINFO FindDraginfo(PAPPDRAGITEM pAppDragitem)
{
   return pAppDragitem->pDraginfo;
}

/**************************************************************************
 *
 *  Name       : FindDragItemFile
 *
 *  Description: Finds the PPUBFILEFINDBUF for a drag operation, given the
 *		 address of an APPDRAGITEM
 *
 *  Concepts   : drag information
 *
 *  API's      :  [none]
 *
 *  Parameters :  pAppDragitem = pointer to the drag item
 *
 *  Return     :  NULL = unable to find the PPUBFILEFINDBUF
 *		  otherwise, the address of the PPUBFILEFINDBUF for the
 *		  item being dragged
 *************************************************************************/
PPUBFILEFINDBUF FindDragitemFile (PAPPDRAGITEM pAppDragitem)
{
   return pAppDragitem->pFile;
}
/***************************  End of dragheap.c	 *************************/
/**************************************************************************
 *  File name  :  draghelp.c
 *
 *  Description:  This file contains all the routines for interfacing
 *		  with the IPF help manager.
 *
 *		  This source file contains the following functions:
 *
 *		  InitHelp(hab, hwnd)
 *		  HelpUsingHelp(hwnd)
 *		  HelpGeneral(hwnd)
 *		  HelpIndex(hwnd)
 *		  HelpProductInfo(hwnd)
 *		  DestroyHelpInstance(hwnd)
 *		  ProductInfoDlgProc(hwnd, msg, mp1, mp2)
 *		  SetSysMenu(hwnd)
 *
 *  Concepts   :  IPF Help Manager
 *
 *  API's      :  WinLoadString
 *		  WinCreateHelpInstance
 *		  WinAssociateHelpInstance
 *		  WinSendMsg
 *		  WinDlgBox
 *		  WinDestroyHelpInstance
 *		  WinDefDlgProc
 *		  WinWindowFromID
 *
 *  Required
 *    Files    :  OS2.H, STRING.H, STDIO.H, DRAGDROP.H, DRAGHELP.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *  Include files, macros, defined constants, and externs
 */

#define	 INCL_WINHELP
#define	 INCL_WINSTDDRAG
#define	 INCL_WINMENUS
#define	 INCL_WINFRAMEMGR

#include <os2.h>
#include <string.h>
#include <stdio.h>
#include "dragdrop.h"
#include "draghelp.h"

#define HELPLIBRARYNAMELEN  20

/*
 *  Global variables
 */
static HWND hwndHelpInstance;
static CHAR szLibName[HELPLIBRARYNAMELEN];
static CHAR szWindowTitle[HELPLIBRARYNAMELEN];
static BOOL fHelpEnabled;

/*
 *  Entry point declarations
 */
MRESULT EXPENTRY ProductInfoDlgProc(HWND hwnd,
				    USHORT msg,
				    MPARAM mp1,
				    MPARAM mp2);

/**************************************************************************
 *
 *  Name       :  InitHelp(hab, hwnd)
 *
 *  Description: Initializes the IPF help facility
 *		 Called once during initialization of the program
 *
 *  Concepts   : Initializes the HELPINIT structure and creates the
 *		 help instance.	 If successful, the help instance
 *		 is associated with the main window queue
 *
 *  API's      :   WinLoadString
 *		   WinCreateHelpInstance
 *		   WinAssociateHelpInstance
 *
 *  Parameters :  hab	   = anchor block handle
 *		  hwndMain = main window handle
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID InitHelp(HAB hab, HWND hwndMain)
{
   HELPINIT hini;

   /* If we return because of an error, Help will be disabled. */
   fHelpEnabled = FALSE;

   /* initialize help init structure */
   hini.cb = sizeof(HELPINIT);
   hini.ulReturnCode = 0L;
   hini.pszTutorialName = (PSZ)NULL;
   hini.phtHelpTable = (PHELPTABLE)MAKELONG(DRAGDROP_HELP_TABLE, 0xFFFF);
   hini.hmodHelpTableModule = 0;
   hini.hmodAccelActionBarModule = 0;
   hini.idAccelTable = 0;
   hini.idActionBar = 0;

   if(!WinLoadString(hab,
		     0,
		     IDS_CLIENTCLASS,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szWindowTitle))
   {
       MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
       return;
   }

   hini.pszHelpWindowTitle = (PSZ)szWindowTitle;
   hini.fShowPanelId = CMIC_HIDE_PANEL_ID;

   if(!WinLoadString(hab,
		     0,
		     IDS_HELPLIBRARYNAME,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szLibName))
   {
       MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
       return;
   }

   hini.pszHelpLibraryName = (PSZ)szLibName;

		   /* creating help instance */
   hwndHelpInstance = WinCreateHelpInstance(hab, &hini);

   if(!hwndHelpInstance)
   {
       MessageBox(hwndMain, IDMSG_HELPNOTAVAILABLE, MB_OK | MB_ERROR, TRUE);
       return;
   }

   if(hini.ulReturnCode)
   {
       MessageBox(hwndMain, IDMSG_HELPCREATEERROR, MB_OK | MB_ERROR, TRUE);
       return;
   }

		/* associate help instance with main frame */
   if(!WinAssociateHelpInstance(hwndHelpInstance, hwndMain))
   {
       MessageBox(hwndMain, IDMSG_HELPASSOCIATEERROR, MB_OK | MB_ERROR, TRUE);
       return;
   }

   /* help manager is successfully initialized so set flag to TRUE */
   fHelpEnabled = TRUE;
}   /*	End of InitHelp	 */

/**************************************************************************
 *
 *  Name       :  HelpUsingHelp(hwnd)
 *
 *  Description: Processes the Using help choice from the Help pulldown
 *
 *  Concepts   : Processes the WM_COMMAND message posted by the
 *		 Using Help item of the Help menu
 *		 Called from MainCommand when the Using Help
 *		 menu item is selected
 *		 Sends an HM_DISPLAY_HELP message to the help
 *		 instance so that the default Using Help is
 *		 displayed.
 *
 *  API's      :   WinSendMsg
 *
 *  Parameters :  hwndMain = main window handle
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID  HelpUsingHelp(HWND hwndMain)
{
    /* this just displays the system using help panel */
    if(fHelpEnabled)
       if (NULL != WinSendMsg(hwndHelpInstance, HM_DISPLAY_HELP,
			  (MPARAM)NULL, (MPARAM)NULL))
	{
	    MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, MB_OK | MB_ERROR,
		       FALSE);
	}
}   /* End of HelpUsingHelp   */


/**************************************************************************
 *
 *  Name       :  HelpGeneral(hwnd)
 *
 *  Description: Processes the General help choice from the Help pulldown
 *
 *  Concepts   : Processes the WM_COMMAND message posted by the
 *		 General Help item of the Help menu
 *		 Called from MainCommand when the General Help
 *		 menu item is selected
 *		 Sends an HM_EXT_HELP message to the help
 *		 instance so that the default Extended Help is
 *		 displayed.
 *
 *  API's      :   WinSendMsg
 *
 *  Parameters :  hwndMain = main window handle
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID  HelpGeneral(HWND hwndMain)
{
    /* this just displays the system general help panel */
    if(fHelpEnabled)
	if(NULL != WinSendMsg(hwndHelpInstance, HM_EXT_HELP,
		      (MPARAM)NULL, (MPARAM)NULL))
	    MessageBox(hwndMain,
		       IDMSG_HELPDISPLAYERROR,
		       MB_OK | MB_ERROR,
		       FALSE);
}   /* End of HelpGeneral   */


/**************************************************************************
 *
 *  Name       :  HelpIndex(hwnd)
 *
 *  Description: Processes the Help index choice from the Help pulldown
 *
 *  Concepts   : Processes the WM_COMMAND message posted by the
 *		 Help index item of the Help menu
 *		 Called from MainCommand when the Help index
 *		 menu item is selected
 *		 Sends an HM_INDEX_HELP message to the help
 *		 instance so that the Help index is displayed.
 *
 *  API's      :  WinSendMsg
 *
 *  Parameters :  hwndMain = main window handle
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID  HelpIndex(HWND hwndMain)
{
    /* this just displays the system help index panel */
    if(fHelpEnabled)
	if(NULL != WinSendMsg(hwndHelpInstance, HM_HELP_INDEX,
		      (MPARAM)NULL, (MPARAM)NULL))
	    MessageBox(hwndMain,
		       IDMSG_HELPDISPLAYERROR,
		       MB_OK | MB_ERROR,
		       FALSE);
}   /* End of HelpIndex	  */


/**************************************************************************
 *
 *  Name       :  HelpProductInfo(hwndMain)
 *
 *  Description: Processes the Product information choice from the Help
 *		 pulldown
 *
 *  Concepts   : Processes the WM_COMMAND message posted by the
 *		 Product information item of the Help menu
 *		 Called from MainCommand when the Product information
 *		 menu item is selected
 *		 Calls WinDlgBox to display the Product information
 *		 dialog.
 *
 *  API's      :  WinSendMsg
 *
 *  Parameters :  hwndMain = main window handle
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID  HelpProductInfo(HWND hwndMain)
{
    /* display the Product Information dialog. */
    if(DID_ERROR == WinDlgBox(HWND_DESKTOP,
			      hwndMain,
			      (PFNWP)ProductInfoDlgProc,
			      0,
			      IDD_PRODUCTINFO,
			      (PVOID)NULL))

	MessageBox(HWND_DESKTOP,
		   IDMSG_CANTSTARTDIALOG ,
		   MB_OK | MB_ERROR,
		   TRUE);
}   /*	End of HelpProductInfo	 */

/**************************************************************************
 *
 *  Name       :  DestroyHelpInstance()
 *
 *  Description:  Deletes the application's help instance
 *
 *  Concepts   : Calls WinDestroyHelp Instance to delete the instance
 *
 *  API's      :  WinDestroyHelpInstance
 *
 *  Parameters :  [none]
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID DestroyHelpInstance(VOID)
{
    if(hwndHelpInstance != 0L)
    {
	WinDestroyHelpInstance(hwndHelpInstance);
    }
}   /* End of DestroyHelpInstance    */


/**************************************************************************
 *
 *  Name       :  ProductInfoDlgProc(hwnd, msg, mp1, mp2)
 *
 *  Description:  Processes all messages sent to the Product
 *		  information dialog
 *
 *  Concepts   :  Called for each message sent to the Product information
 *		  dialog box.
 *
 *		  the Product information dialog has only a button control, so this
 *		  routine processes only WM_COMMAND messages.  Any
 *		  WM_COMMAND posted must have come from the OK
 *		  button, so we dismiss the dialog upon receiving it.
 *
 *  API's      :  WinDefDlgProc
 *
 *  Parameters :  [none]
 *
 *  Return     :  dependent on message sent
 *
 *************************************************************************/
MRESULT EXPENTRY ProductInfoDlgProc(HWND hwnd,
				    USHORT msg,
				    MPARAM mp1,
				    MPARAM mp2)
{
    switch (msg)
    {
    case WM_INITDLG:
       SetSysMenu(hwnd);       /* system menu for this dialog  */
	  return (MRESULT)NULL;

    default:
       return WinDefDlgProc(hwnd, msg, mp1, mp2);
    }
    return (MRESULT)NULL;
}   /*	End of ProductInfoDlgProc  */

/**************************************************************************
 *
 *  Name       :  SetSysMenu(hDlg)
 *
 *  Description:  Enables only the Move and Close items in the
 *		  system menu pulldown for any dialog
 *
 *  Concepts   :
 *
 *  API's      :  WinWindowFromID
 *		  WinSendMsg
 *
 *  Parameters :  hDlg = dialog handle
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID SetSysMenu( HWND hDlg )
{
    HWND     hSysMenu;
    MENUITEM Mi;
    SHORT    Pos;
    ULONG    Id;
    SHORT    cItems;

    /*
     *	We only want Move and Close in the system menu.
     */
    hSysMenu = WinWindowFromID(hDlg, FID_SYSMENU);
    WinSendMsg( hSysMenu, MM_QUERYITEM
	      , MPFROM2SHORT(SC_SYSMENU, FALSE), MPFROMP((PCH) & Mi));
    Pos = 0;
    cItems = (SHORT)WinSendMsg( Mi.hwndSubMenu, MM_QUERYITEMCOUNT,
				(MPARAM)NULL, (MPARAM)NULL);
    while (cItems--)
    {
	Id = (ULONG) WinSendMsg( Mi.hwndSubMenu, MM_ITEMIDFROMPOSITION
			  , MPFROM2SHORT(Pos, TRUE), (MPARAM)NULL);
	switch (SHORT1FROMMP(Id))
	{
	case SC_MOVE:
	case SC_CLOSE:
	    Pos++;  /* Don't delete that one. */
	    break;
	default:
	    WinSendMsg( Mi.hwndSubMenu, MM_DELETEITEM
		      , MPFROM2SHORT(Id, TRUE), (MPARAM)NULL);
	}
    }
} /*  End of SetSysMenu	 */
/***************************  End of draghelp.c	 *************************/
/*static char *SCCSID = "@(#)eas.c      6.14 92/03/18";*/
/*==============================================================*\
 *  EAS.C -New Extended Attribute Display sample PM application *
 *								*
 *  (C) Copyright IBM Corporation 1992.				*
 *--------------------------------------------------------------*
 *								*
 *  This program implements an extended attributes editor.	*
 *  Included in this file are all of the PM interface procedures*
 *  All of these procs represent procedures for dialog boxes.	*
 *  This code is implemented as it was written to show how to	*
 *  show how to use EA editor.					*
 *								*
 *  The EA code revolves around the HoldFEA structure.	This	*
 *  structure is a linked list which contains one EA per	*
 *  structure.	Each HoldFEA structure is dynamically allocated *
 *  as are the two string pointer members of the structure,	*
 *  szName and aValue.	This is done to make handling the EAs	*
 *  easier and more flexable.					*
 *								*
 *  This application also serves as a template that can be	*
 *  easily modified by an application developer.  The source	*
 *  files are organized so that the overhead code that should	*
 *  be in all applications is located in the same files so	*
 *  that these files do not need to be modified.  The routines	*
 *  that deal with application specific code are also located	*
 *  in their own modules.  An application developer need only	*
 *  change these files in order to modify this template for	*
 *  his application.						*
 *								*
 *--------------------------------------------------------------*
 *  Procedures in this file:					*
 *   main()	    Sets up the PM environment and heap and	*
 *			 calls the MainWndProc			*
 *   MainWndProc()  Handles the main window messages		*
 *   MainPaint()    Handles the main paint window messages	*
 *   MainCommand()  Handles the main command window messages	*
 *   ProcExit()	    Handles the WinClose window messages	*
 *   UserCommand()  Handles the user command window messages	*
 *   MainControl()  Handles the main control window messages	*
 *   MessageBox	    Handles all error messages			*
 *   AddEAProc()    Handles new EA name entry and type selection*
 *   AsciiEditProc()Handles editing of EA name/value		*
 *   IconDlgProc()  Unimplemented icon procedure handler	*
 *   MultiTypeProc()Handles the Multi-type dialog box		*
 *   ShowEAType()   Shows Selected EA Type for MainDlgProc	*
 *   EditEA()	    Handles selection of an EA in the listbox	*
 *   GetCurFEA()    Gets a ptr to the hi-lited EA in the listbox*
 *   GetMem()							*
\*==============================================================*/
/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#define	EXTERN
#include "eas.h"

       /* Setup the table, the order is related to DLGTEMPLATE of IDD_ADDEA */
EADATA ConvTable[EATABLESIZE] = {
   { EA_LPASCII	  ,"Length preceeded ascii\0             ",IDD_LPDATA},
   { EA_LPBINARY  ,"Length preceeded hex binary\0        ",IDD_LPDATA},
   { EA_ASCIIZ	  ,"Asciiz\0                             ",IDD_ASCIIZ},
   { EA_LPMETAFILE,"Metafile\0                           ",IDD_LPDATA},
   { EA_ASCIIZFN  ,"Asciiz file name of associated data\0",IDD_ASCIIZ},
   { EA_ASCIIZEA  ,"Asciiz EA of associated data\0       ",IDD_ASCIIZ},
   { EA_MVMT	  ,"Multi value multi type field\0       ",IDD_MULTILIST},
   { EA_ASN1	  ,"ASN.1 field\0                        ",IDD_ASCIIZ},
   { EA_LPBITMAP  ,"Length preceeded bitmap\0            ",IDD_LPDATA},
   { EA_LPICON	  ,"Length preceeded icon\0              ",IDD_LPDATA},
   { EA_MVST	  ,"Multi value single type field\0      ",IDD_MULTILIST},
   { 0		  ,"Non conventional format\0            ",IDD_ASCIIZ}
   };

/****************************************************************\
 *  Main routine						*
 *--------------------------------------------------------------*
 *								*
 *  Name:    main(int argc, char *argv[])			*
 *								*
 *  Purpose: Initializes the PM environment, calls the		*
 *	     initialization routine, creates the main window,	*
 *	     and polls the message queue.			*
 *								*
 *  Usage:							*
 *								*
 *  Method:  -obtains anchor block handle and creates message	*
 *		queue						*
 *	     -calls the initialization routine			*
 *	     -creates the main frame window which creates the	*
 *		main client window				*
 *	     -polls the message queue via Get/Dispatch Msg loop *
 *	     -upon exiting the loop, exits			*
 *								*
 *  Returns: 1 - if sucessful execution completed		*
 *	     0 - if error					*
 *								*
\****************************************************************/
INT main(int argc, char *argv[])
{
   QMSG qmsg;					      /* message structure */
   ULONG ctlData=FCF_SYSMENU | FCF_MENU | FCF_ICON | /* frame control data */
		 FCF_TASKLIST | FCF_TITLEBAR |
		 FCF_SIZEBORDER | FCF_ACCELTABLE |
		 FCF_MINMAX | FCF_SHELLPOSITION;

   FILE_ISOPEN = FALSE;
   FILE_CHANGED = FALSE;
   COMMAND_LINE_FILE = FALSE;
   if(argc > 1)			 /* If a command line file, get EAs from it */
      if(ParseFileName(szFileName,argv[1]) != FILE_VALID)  /* Bad file name */
	 *szFileName=0;
      else
	 COMMAND_LINE_FILE = TRUE;

   /* Note: The following 3 setup calls aren't currently checked for errors */
   hab = WinInitialize(0);
   if(!hab)  {
       DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
       return(RETURN_ERROR);
   }
   hmq = WinCreateMsgQueue(hab, 0);
   if(!hmq)  {
       DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
       WinTerminate(hab);
       return(RETURN_ERROR);
   }
   if(!Init())
   {
       MessageBox(HWND_DESKTOP, IDMSG_INITFAILED, "Error !",
			   MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
       DosExit(EXIT_PROCESS, RETURN_ERROR);
   }
					      /* create the main window */
   hwndMainFrame = WinCreateStdWindow(HWND_DESKTOP,
				      WS_VISIBLE,
				      (PVOID)&ctlData,
				      (PSZ)szAppName,
				      (PSZ)NULL,
				      WS_VISIBLE,
				      (HMODULE)NULL,
				      ID_RESOURCE,
				      (PHWND)&hwndMain);
   if(!hwndMainFrame)
   {
       MessageBox(HWND_DESKTOP, IDMSG_MAINWINCREATEFAILED, "Error !",
			   MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
       DosExit(EXIT_PROCESS, RETURN_ERROR);
   }
   InitHelp();

   while(WinGetMsg(hmq, (PQMSG)&qmsg, 0L, 0L, 0L))
	   WinDispatchMsg(hmq, (PQMSG)&qmsg);

					   /* destroy the help instance */
   DestroyHelpInstance();
				    /* will normally be put in ExitProc */
   DosExit(EXIT_PROCESS, RETURN_SUCCESS);
   return 0;
}							       /* main() */

/****************************************************************\
 *  Main client window procedure				*
 *--------------------------------------------------------------*
 *								*
 *  Name:    MainWndProc(hwnd, msg, mp1, mp2)			*
 *								*
 *  Purpose: Processes the messages sent to the main client	*
 *	     window. This routine processes the basic messages	*
 *	     all client windows should process and passes all	*
 *	     others onto UserWndProc where the developer can	*
 *	     process any others.				*
 *								*
 *  Usage:   Called for each message placed in the main		*
 *	     window's message queue                             *
 *								*
 *  Method:  a switch statement branches to the routines to be	*
 *	     performed for each message processed. Any messages *
 *	     not specifically process are passed to the user's  *
 *	     message processing procedure UserWndProc().	*
 *								*
 *  Returns: Return values are determined by each message	*
 *								*
\****************************************************************/
MRESULT EXPENTRY MainWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   MRESULT sRC;

   switch(msg)
   {
      case WM_CREATE:
	  WinPostMsg(hwnd,WM_USER,(MPARAM)0,(MPARAM)0);
	  break;

      case WM_USER:  /* Posted by WM_INITDLG allows main window to open 1st */
	  if(COMMAND_LINE_FILE)
	  {
	     OpenFile(hwnd, ARGFILE);
	  }
	  break;
      case WM_PAINT:
	  MainPaint(hwnd);
	  break;

      case WM_COMMAND:
	  MainCommand(hwnd, mp1, mp2);
	  break;

      case WM_CONTROL:
	  MainControl(hwnd, mp1, mp2);
	  break;

   /*--------------------------------------------------*\
    *	   Any messages not processed are passed on    *
    *	   to the user's window proc.  It is           *
    *	   responsible for passing any messages it     *
    *	   doesn't handle onto WinDefWindowProc()      *
   \*--------------------------------------------------*/
      case HM_QUERY_KEYS_HELP:
	  return ((MRESULT)PANEL_KEYSHELP);

      default:
	  sRC = WinDefWindowProc(hwnd, msg, mp1, mp2);
	  return sRC;
   }
   return (MRESULT)0L;
		    /* all window procedures should return 0 as a default */
}							 /* MainWndProc() */

/****************************************************************\
 *  Main client painting routine				*
 *--------------------------------------------------------------*
 *								*
 *  Name:    MainPaint(hwnd)					*
 *								*
 *  Purpose: Paints the main client window.			*
 *								*
 *  Usage:   Routine is called whenver the client window	*
 *	     procedure receives a WM_PAINT message		*
 *								*
 *  Method:  -begins painting by calling WinBeginPaint		*
 *		and retriving the HPS for the window		*
 *	     -paint page info boxes				*
 *								*
 *	     -ends painting by calling WinEndPaint		*
 *								*
 *  Returns: VOID						*
 *								*
\****************************************************************/
VOID MainPaint(HWND hwnd)
{
   HPS	  hps;				/* Handle for painting		 */
   RECTL  rect;				/* Rectangle struct for painting */
   CHAR	  szBuffer[BUFF_SIZE];
   POINTL ptl;

   hps = WinBeginPaint(hwnd, 0L, (PRECTL)&rect);
   WinFillRect(hps, (PRECTL)&rect, CLR_BACKGROUND);
			      /* Fill update rectangle with window color */
   WinQueryWindowRect(hwndMain, (PRECTL)&rect);

      ptl.x = HORZ_INDENT;
      ptl.y = rect.yTop - VERT_TEXT_POS;
      memset(szBuffer, 0, sizeof(szBuffer));
      strcpy(szBuffer, "File Name:");
      GpiCharStringAt(hps, &ptl, strlen(szBuffer), szBuffer);

      ptl.x = HORZ_INDENT;
      ptl.y = rect.yTop - VERT_TEXT_POS*3;
      memset(szBuffer, 0, sizeof(szBuffer));
      strcpy(szBuffer, "EA Type:");
      GpiCharStringAt(hps, &ptl, strlen(szBuffer), szBuffer);

      ptl.x = HORZ_INDENT;
      ptl.y = rect.yTop - VERT_TEXT_POS*5;
      memset(szBuffer, 0, sizeof(szBuffer));
      strcpy(szBuffer, "EA Names:");
      GpiCharStringAt(hps, &ptl, strlen(szBuffer), szBuffer);

   if(FILE_ISOPEN)
   {
      ptl.x = HORZ_INDENT + 10;
      ptl.y = rect.yTop - VERT_TEXT_POS*2;
      GpiCharStringAt(hps, &ptl, strlen(szFileName), szFileName);

      ptl.x = HORZ_INDENT + 10;
      ptl.y = rect.yTop - VERT_TEXT_POS*4;
      GpiCharStringAt(hps, &ptl, strlen(szEAType), szEAType);
   }
   else
   {
      ptl.x = HORZ_INDENT + 10;
      ptl.y = rect.yTop - VERT_TEXT_POS*2;
      strcpy(szBuffer, "File name will appear here!");
      GpiCharStringAt(hps, &ptl, strlen(szBuffer), szBuffer);

      ptl.x = HORZ_INDENT + 10;
      ptl.y = rect.yTop - VERT_TEXT_POS*4;
      strcpy(szBuffer, "EA types will appear here!");
      GpiCharStringAt(hps, &ptl, strlen(szBuffer), szBuffer);
   }
   WinEndPaint(hps);
   return ;
}							 /* MainPaint() */

/****************************************************************\
 *  Main window WM_COMMAND processing procedure			*
 *--------------------------------------------------------------*
 *								*
 *  Name:   MainCommand(hwnd, mp1, mp2)				*
 *								*
 *  Purpose:Calls the appropriate procedures that deal with	*
 *	     the selected menu item.				*
 *								*
 *  Usage:  Routine is called whenever a WM_COMMAND message	*
 *	    is posted to the main window.			*
 *								*
 *  Method: a switch statement branches on the id of the	*
 *	    menu item that posted the message and the		*
 *	    appropriate action for that item is taken.	Any	*
 *	    menu ids that are not part of the standard menu	*
 *	    set are passed onto the user defined WM_COMMAND	*
 *	    processing procedure.				*
 *								*
 *  Returns: VOID						*
 *								*
\****************************************************************/
VOID MainCommand(HWND hwnd, MPARAM mp1, MPARAM mp2)
{
    switch(SHORT1FROMMP(mp1))
    {
	case IDM_GENERALHELP:
	   HelpExtended(mp2);
	   break;

	case IDM_USINGHELP:
	   HelpHelpForHelp(mp2);
	   break;

	case IDM_TUTORIAL:
	   HelpKeys(mp2);
	   break;

	case IDM_HELPINDEX:
	   HelpIndex(mp2);
	   break;

	case IDM_HELPPRODUCTINFO:
	   HelpAbout(mp2);
	   break;

    /*--------------------------------------------------*\
     *	    User command processing routine is called	*
     *	    here so any ids not procecessed here can be *
     *	    processed					*
    \*--------------------------------------------------*/
	default:
	    UserCommand(hwnd, mp1, mp2);
	    break;
    }
    return;
}						 /* MainCommand() */

/****************************************************************\
 *  Main window WM_CONTROL processing procedure			*
 *--------------------------------------------------------------*
 *								*
 *  Name:   MainControl(hwnd, mp1, mp2)				*
 *								*
 *  Purpose:Calls the appropriate procedures that deal with	*
 *	     the selected menu item.				*
 *								*
 *  Usage:  Routine is called whenever a WM_CONTROL message	*
 *	    is posted to the main window.			*
 *								*
 *  Method: a switch statement branches on the id of the	*
 *	    menu item that posted the message and the		*
 *	    appropriate action for that item is taken.	Any	*
 *	    menu ids that are not part of the standard menu	*
 *	    set are passed onto the user defined WM_CONTROL	*
 *	    processing procedure.				*
 *								*
 *  Returns: VOID						*
 *								*
\****************************************************************/
VOID MainControl(HWND hwnd, MPARAM mp1, MPARAM mp2)
{
   switch(SHORT1FROMMP(mp1))
   {
      case IDD_WINLBOX:
	 switch(SHORT2FROMMP(mp1))
	 {
	    case LN_SELECT:	      /* A new item has been hi-lited */
	       ShowEAType(hwnd);      /* Display appropriate EA Type  */
	       break;

	    case LN_ENTER:	      /* Edit the selected EA	      */
	       EditEA(hwnd);
	       break;
	 }
   }
    /* This routine currently doesn't use the msg & mp2 parameter but *\
     *	it is referenced here to prevent an 'Unreferenced Parameter'  *
    \*	warning at compile time.				      */
   return;
}

/****************************************************************\
 *  Exit routine						*
 *--------------------------------------------------------------*
 *								*
 *  Name:    ProcExit(hwnd, mp2)				*
 *								*
 *  Purpose: Processes the menu's Exit item.                    *
 *								*
 *  Usage:   called whenever Exit from the menu is selected	*
 *								*
 *  Method:  Routine posts a WM_CLOSE message to the main	*
 *	     application window.				*
 *								*
 *  Returns: VOID						*
 *								*
\****************************************************************/
VOID ProcExit(HWND hwnd, MPARAM mp2)
{
   USHORT   usRet;

   if(FILE_CHANGED)	/* Give user a chance to save changes	*/
   {
      usRet= MessageBox(hwnd, IDMSG_FILECHANGED, "Warning !",
			MB_YESNOCANCEL | MB_ICONEXCLAMATION, TRUE);
      switch(usRet)
      {
	 case MBID_YES:		   /* They want to save the EAs */
	    WriteEAs();
	    break;
	 case MBID_CANCEL:    /* They don't really want to quit */
	    break;
      }
   }
   WinPostMsg(hwndMain, WM_CLOSE, (MPARAM)NULL, (MPARAM)NULL);

    /* This routine currently doesn't use the mp2 parameter but       *\
     *	it is referenced here to prevent an 'Unreferenced Parameter'  *
    \*	warning at compile time.				      */
   return;
}							 /* ProcExit() */

/****************************************************************\
 *  Non-standard menu item command processing procedure		*
 *--------------------------------------------------------------*
 *								*
 *  Name:    UserCommand(hwnd, mp1, mp2)			*
 *								*
 *  Purpose: Process any WM_COMMAND messages send to hwndMain	*
 *		that are not processed by MainCommand		*
 *								*
 *  Usage:   Routine is called for each WM_COMMAND that is	*
 *	     not posted by a standard menu item			*
 *								*
 *  Method:  A switch statement branches control based upon	*
 *	     the id of the control which posted the message	*
 *								*
 *  Returns: VOID						*
 *								*
\****************************************************************/
VOID UserCommand(HWND hwnd, MPARAM mp1, MPARAM mp2)
{
   RECTL  rect;			      /* Rectangle struct for painting */
   LONG usRet;

   switch (SHORT1FROMMP(mp1))
   {
       case IDM_OPEN:	       /* Select another file to view/edit EAs */
	  if(FILE_CHANGED)	  /* Give them a chance to save modifications */
	  {
	     usRet = MessageBox(hwnd, IDMSG_FILECHANGED, "Warning !",
				  MB_YESNOCANCEL | MB_ICONEXCLAMATION, TRUE);
	     switch(usRet)
	     {
		case MBID_YES:
		     WriteEAs();
		     break;

		case MBID_NO:
		     break;

		case MBID_CANCEL:
		     return;
	     }
	  }
	  WinQueryWindowRect(hwnd, &rect);
	  if(hwndChild1)
	     WinDestroyWindow(hwndChild1);

	  hwndChild1 = WinCreateWindow(hwnd,
			  WC_LISTBOX,
			  NULL,
			  WS_VISIBLE,
			  rect.xLeft,
			  rect.yBottom,
			  rect.xRight-rect.xLeft,
			  rect.yTop -rect.yBottom -VERT_TEXT_POS*5,
			  hwnd,
			  HWND_TOP,
			  IDD_WINLBOX,
			  NULL,
			  (PVOID)NULL);
	  if(OpenFile(hwnd,0))			       /* File open ok */
		       break;
	  break;

       case IDM_SAVE:	       /* Write EA's out to disk               */
	  WriteEAs();
	  break;

       case IDM_ADD:	       /* Add an EA to current list in memory  */
	  AddEA(hwnd);
	  break;

       case IDM_DELETE:	       /* Delete an EA from memory	       */
	  DeleteCurEA(hwnd);
	  break;

       case IDM_EDIT:	       /* Edit the hilited EA		       */
	  EditEA(hwnd);
	  break;

       default:
	 break;
   }
    /* This routine currently doesn't use the mp2 parameter but       *\
     *	it is referenced here to prevent an 'Unreferenced Parameter'  *
    \*	warning at compile time.				      */
   return;
}

/****************************************************************\
 *  Message Box procedure					*
 *--------------------------------------------------------------*
 *								*
 *  Name:    MessageBox(hwndOwner,IdMsg,pszMsg,fsStyle,bBeep)	*
 *								*
 *  Purpose: Displays the warning message box with the message	*
 *		given in nIdMsg retrived from the message table *
 *								*
 *  Usage:   Called whever an error occurs and a message wishes *
 *	     to be displayed to the user			*
 *								*
 *  Method:  - Message string is loaded from the process'       *
 *		message table					*
 *	     - Alarm beep is sounded if desired			*
 *	     - Message box with the message is displayed	*
 *								*
 *  Returns:							*
 *								*
\****************************************************************/
LONG MessageBox(HWND hwndOwner, LONG IdMsg, PSZ pszMsg, LONG fsStyle,
		     BOOL bBeep)
{
    CHAR szText[MESSAGELEN];
    LONG usRet;

    if(!WinLoadMessage(hab, (HMODULE)NULL, IdMsg, MESSAGELEN, (PSZ)szText))
    {
	WinAlarm(HWND_DESKTOP, WA_ERROR);
	return RETURN_ERROR;
    }
    if(bBeep)
	WinAlarm(HWND_DESKTOP, WA_ERROR);

    usRet = WinMessageBox(HWND_DESKTOP,
			 hwndOwner,
			 szText,
			 (PSZ)pszMsg,
			 IDM_MSGBOX,
			 fsStyle);
    return usRet;
}						    /* MessageBox() */

/****************************************************************\
 *								*
 *  Name:    AddEAProc(hwnd, msg, mp1, mp2)			*
 *								*
 *  Purpose: Handles the screen that allows the user to enter a *
 *	     new EA Name and select the EA type.  It checks to	*
 *	     make sure the name is unique and is not NULL before*
 *	     returning. The user pointer is used to determine	*
 *	     whether the name is allowed to change or not.	*
 *	     If it points to a PassData structure, the Point	*
 *	     member gives the static EA Name.			*
 *								*
 *  Usage:   Called by MainDlgProc when user select the ADD.	*
 *								*
 *  Method:  Called by both the add EA routine and the m-m EA	*
 *	     add routine.  This routine places the user typed	*
 *	     name in global szEAName, and the EA type in global *
 *	      usRetEAType.					*
 *								*
 *  Returns: Exits with WinDismissDlg set to TRUE if the user	*
 *	     selects OK, FALSE if the user selects CANCEL.	*
 *								*
\****************************************************************/
MRESULT EXPENTRY AddEAProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   static CHAR bPDat = 0;   /* flag indicating if the pPDat struct is valid */
   PASSDATA FAR *pPDat;	    /* struct used to pass in default EA name	    */
   USHORT   i;
   MRESULT  sRC;

   switch(msg)
   {
      case WM_INITDLG:
	 FixSysMenu(hwnd);
	 bPDat = 0;
	 WinSendDlgItemMsg(hwnd, IDD_EANAME,EM_SETTEXTLIMIT,
				 MPFROM2SHORT(MAXEANAME,0),NULL);
	 WinSendDlgItemMsg(hwnd, EA_LPASCII, BM_CLICK,(MPARAM)0L,(MPARAM)0L);

	 pPDat=PVOIDFROMMP(mp2);
	 if(pPDat)
	 {
	    bPDat = 1;
	    WinSetDlgItemText(hwnd, IDD_EANAME, pPDat->Point);
	    WinEnableWindow(WinWindowFromID(hwnd,IDD_EANAME),
			    FALSE);		   /* Disable EA Name field */
	    WinSetFocus(HWND_DESKTOP,WinWindowFromID(hwnd,DID_OK));

	    return (MRESULT)TRUE;    /* We don't want default focus setting */
	 }
	 return (MRESULT)0L;

      case WM_COMMAND:
	 switch(LOUSHORT(mp1))
	 {
	    case DID_OK:
	       if(bPDat == 0)	       /* It is a new EA (not multi-type)   */
	       {
		  WinQueryDlgItemText(hwnd, IDD_EANAME, MAXEANAME+1, szEAName);

		  if(!strlen(szEAName))	   /* Don't allow a Null EA Name    */
		  {
		     MessageBox(hwnd, IDMSG_ERROREANAME, "Error !",
					 MB_OK | MB_ERROR, TRUE);
		     return (MRESULT)0L;
		  }

		  if(EAExists(szEAName))   /* Don't allow duplicate EA Name */
		  {
		     MessageBox(hwnd, IDMSG_DUPLICATENAME, "Error !",
					     MB_OK | MB_ERROR, TRUE);
		     return (MRESULT)0L;
		  }
		  usRetEAType = (USHORT) WinSendDlgItemMsg(hwnd, EA_ASCIIZ,
			    BM_QUERYCHECKINDEX,(MPARAM)0L,(MPARAM)0L);
							 /* New MVST EAname */
		  if (ConvTable[usRetEAType].usPrefix == EA_MVST)
		  {
		     for (i=0; i<MAXEANAME+1 && szEAName[i] != '\000'; i++)
		     {			 /* Transfer lowercase to uppercase */
			if(szEAName[i]>='a' && szEAName[i]<='z')
			   szEAName[i] = szEAName[i] - (CHAR)' ';
		     }
						  /* Store MVST name & type */
		     for(i=0; i<MSNUM && MSdata[i].szName != NULL;)
			      i++;
		     GetMem((PPVOID)&MSdata[i].szName, sizeof(MVSTDATA));
		     strcpy(MSdata[i].szName,szEAName);
		     MSdata[i].usType  = usRetEAType;
		  }
	       }
	       else				       /* It is multi value */
	       {
		  usRetEAType = (USHORT) WinSendDlgItemMsg(hwnd,
					      EA_ASCIIZ,
					      BM_QUERYCHECKINDEX,
					      (MPARAM)0L,(MPARAM)0L);

			   /* Check Type Name is in the list of MVST or not */
		  for (i=0; i<MSNUM && MSdata[i].szName!=NULL &&
				  strcmp(szEAName,MSdata[i].szName)!=0;)
			    i++;
					 /* 2'nd value of existed MVST type */
		  if(i<MSNUM && MSdata[i].szName!=NULL)
		  {
		     if (ConvTable[usRetEAType].usPrefix == EA_MVST)
		     {
			MessageBox(hwnd, IDMSG_ERRORMULTIVALUE, "Error !",
					     MB_OK | MB_ERROR, TRUE);
			return (MRESULT)0L;
		     }
		     if (ConvTable[usRetEAType].usPrefix == EA_MVMT)
		     {
			MessageBox(hwnd, IDMSG_ERRORMULTITYPE, "Error !",
					     MB_OK | MB_ERROR, TRUE);
			return (MRESULT)0L;
		     }
		     MSdata[i].usType = usRetEAType;
		  }
	       }
	       WinDismissDlg(hwnd, TRUE);
	       return (MRESULT)0L;

	    case DID_CANCEL:
	       WinDismissDlg(hwnd, FALSE);
	       return (MRESULT)0L;
	 }
	 break;

      case WM_CLOSE:
	 WinDismissDlg(hwnd, FALSE);
	 return (MRESULT)0L;
   }
   sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
   return sRC;
}

/****************************************************************\
 *								*
 *  Name:    AsciiEditProc(hwnd, msg, mp1, mp2)			*
 *								*
 *  Purpose: This proc handles the editing of EA Names and their*
 *	     associated ASCII strings.				*
 *								*
 *  Method:  A PassData struct must be passed in when called.	*
 *	     Note that the Value buffer is dynamically allocated*
 *	     and it is the responsibility of the calling	*
 *	     procedure to deallocate the buffer (szScratch) when*
 *	     finished with it. Note also that memory allocations*
 *	     are NOT fully error trapped.			*
 *								*
 *  Returns: Exits with WinDismissDlg set to TRUE if the user	*
 *	     selects OK, FALSE if the user selects CANCEL. Global
 *	     szEAName contains the modified EA Value.  the fFlag*
 *	     member of the passed in data will be updated to	*
 *	     reflect the currentstate of the Need bit.		*		    *
 *								*
\****************************************************************/
MRESULT EXPENTRY AsciiEditProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   static PASSDATA FAR *pPDat;
   MRESULT sRC;

   switch(msg)
   {
      case WM_INITDLG:
	 FixSysMenu(hwnd);
	 WinSendDlgItemMsg(hwnd, IDD_EANAME,EM_SETTEXTLIMIT,
				 MPFROM2SHORT(MAXEANAME,0),NULL);
	 WinSendDlgItemMsg(hwnd, IDD_EAVALUE,EM_SETTEXTLIMIT,
				 MPFROM2SHORT(MAXEAVALUE,0),NULL);
	 pPDat=PVOIDFROMMP(mp2);

	 WinSetDlgItemText(hwnd, IDD_EANAME,pPDat->Point);
	 WinSetDlgItemText(hwnd, IDD_EATYPE,ConvTable[usRetEAType].szFormat);
	 WinSendDlgItemMsg(hwnd, IDD_NEEDBIT, BM_SETCHECK,
			   MPFROM2SHORT(pPDat->fFlag,0),NULL);

	 if(szAscii)   /* Set default EA Value if global var is != NULL */
	    WinSetDlgItemText(hwnd, IDD_EAVALUE,szAscii);

	 if(pPDat->usIndex) /* Disable EANAME if passed in a non-zero value */
	 {
	    WinEnableWindow(WinWindowFromID(hwnd,IDD_EANAME),FALSE);
	    WinEnableWindow(WinWindowFromID(hwnd,IDD_NEEDBIT),FALSE);
	    WinSetFocus(HWND_DESKTOP,WinWindowFromID(hwnd,IDD_EAVALUE));
	    return (MRESULT)TRUE;    /* We don't want default focus setting */
	 }
	 return (MRESULT)0L;

      case WM_COMMAND:
	 switch(LOUSHORT(mp1))
	 {
	    case DID_OK:
	       pPDat->fFlag = (BYTE) WinSendDlgItemMsg(hwnd, IDD_NEEDBIT,
						       BM_QUERYCHECK, 0L, 0L);
	       WinQueryDlgItemText(hwnd, IDD_EANAME, MAXEANAME+1, szEAName);

	       if(!strlen(szEAName))		/* They nulled out the name */
	       {
		  MessageBox(hwnd, IDMSG_ERROREANAME, "Error !",
				     MB_OK | MB_ERROR, TRUE);
		  return (MRESULT)0L;
	       }

	       GetMem( &szScratch, (ULONG)MAXEAVALUE+1L); /* Allocate buffer for value */
	       WinQueryDlgItemText(hwnd, IDD_EAVALUE, MAXEAVALUE+1, szScratch);

	       if(!strlen(szScratch))	       /* They nulled out the value */
	       {
		  FreeMem(szScratch);		   /* Free the value buffer */
		  MessageBox(hwnd, IDMSG_ERRORVALUE, "Error !",
					 MB_OK | MB_ERROR, TRUE);
		  return (MRESULT)0L;
	       }
	       if(stricmp(szEAName,pPDat->Point))    /* changed the EA name */
	       {
		  if(EAExists(szEAName))   /* Can't have duplicate EA names */
		  {
		     MessageBox(hwnd, IDMSG_DUPLICATENAME, "Error !",
					   MB_OK | MB_ERROR, TRUE);
		     FreeMem(szScratch);	       /* Free value buffer */
		     return (MRESULT)0L;
		  }
	       }

	       DosSetMem(szScratch, strlen(szScratch)+1, fPERM|PAG_COMMIT);

	       WinDismissDlg(hwnd, TRUE);
	       return (MRESULT)0L;

	    case DID_CANCEL:
	       WinDismissDlg(hwnd, FALSE);
	       return (MRESULT)0L;
	 }
	 break;

      case WM_CLOSE:
	 WinDismissDlg(hwnd, FALSE);
	 return (MRESULT)0L;
   }
   sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
   return sRC;
}

/****************************************************************\
 *  Name:    IconDlgProc(hwnd, msg, mp1, mp2)			*
 *								*
 *  Purpose: This proc is intedned to handle displaying and	*
 *	      editing icons/bitmaps.				*
 *								*
 *  Usage  :							*
 *								*
 *  Method :							*
 *								*
 *  Returns:							*
 *								*
\****************************************************************/
MRESULT EXPENTRY IconDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   MRESULT sRC;

   switch(msg)
   {
      case WM_INITDLG:
	 FixSysMenu(hwnd);
	 return 0L;

      case WM_COMMAND:
	 WinDismissDlg(hwnd, TRUE);
	 return 0L;
      case WM_PAINT:
      {
	 SWP	  swpTxt, swpDlg;
	 HPS	  hps;
	 POINTL	  ptl;
	 HBITMAP  hbm;

	 WinDefDlgProc(hwnd, WM_PAINT, mp1, mp2);  /* normal dialog painting */

	 hps = WinGetPS(hwnd);			       /* now, add our stuff */
						    /* load and draw Example */
	 hbm = GpiLoadBitmap(hps, 0, ID_BMP, 0L, 0L);

	 WinQueryWindowPos(WinWindowFromID(hwnd, ID_LOGOTEXT), &swpTxt);
	 WinQueryWindowPos(hwnd, &swpDlg);
	 ptl.x = (LONG)((swpDlg.cx - 95) / 2);
	 ptl.y = (LONG)((((swpDlg.cy - swpTxt.y) - 53) / 2) + swpTxt.y);
	 WinDrawBitmap(hps,
		       hbm,
		       NULL,
		       &ptl,
		       0L,
		       0L,
		       DBM_IMAGEATTRS);
	 WinReleasePS(hps);
	 return (MRESULT)0L;
      }
   }
   sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
   return sRC;
}
/****************************************************************\
 *								*
 *  Name:    MultiValueProc(hwnd, msg, mp1, mp2)		*
 *								*
 *  Purpose: This proc handles the multi-valuee EA stuff. Allows*
 *	     the fields in a given m-m to be edited.		*
 *  Usage :							*
 *								*
 *  Method : NOTE that this procedure is fully reentrant/	*
 *	     recursive in that it calls EditEAValue() which can *
 *	     call MultiValueProc. Since PassData information is *
 *	     placed in static variables,the ReEnter structure is*
 *	     used to hold a dynamic linked  list of values	*
 *	     passed intothe proc and thus keeps the  static data*
 *	     set to the proper values.				*
 *								*
 *  Returns: Always returns TRUE thru WinDismissDlg when DONE is*
 *	     clicked.						*
 *								*
\****************************************************************/
MRESULT EXPENTRY MultiValueProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   static HOLDFEA *pFEA;		/* Points to the current EA	    */
   static PASSDATA FAR *pPDat;		/* Points to the passed Data struct */
   static REENTER *CurEntry;		/* Points to most recent data frame */
   REENTER *ReEntHold=NULL;		/* Temp used to setup the frame	    */
   PASSDATA PDat;			/* Used for call to EditEAValue	    */
   USHORT *pusPtr,cnt;			/* Utility vars			    */
   SHORT  sOffset;
   CHAR	  *pInsert,*pValue,*pDelete;
   CHAR	  szCodePage[LENUSHORTBUF];
   BYTE	  fNeed;			/* Holds state of need checkbox	    */
   MRESULT sRC;

   switch(msg)
   {
      case WM_INITDLG:
	 FixSysMenu(hwnd);
	 pPDat = PVOIDFROMMP(mp2);		      /* Set up static vars */
	 pFEA  = (HOLDFEA *) pPDat->Point;

	 GetMem((PPVOID)&ReEntHold, (LONG)sizeof(REENTER));  /* Allows for recusive calls */
	 ReEntHold->pPDat = pPDat;
	 ReEntHold->pFEA  = pFEA;
	 ReEntHold->next  = CurEntry;
	 CurEntry = ReEntHold;

	 WinSendDlgItemMsg(hwnd, IDD_NEEDBIT, BM_SETCHECK,/* Need bit setup */
			   MPFROM2SHORT((pFEA->fEA&0x80)? TRUE : FALSE,0),
			   NULL);

	 WinSetDlgItemText(hwnd, IDD_EATYPE,"");      /* Setup the codepage */
	 WinSetDlgItemText(hwnd, IDD_EANAME,pFEA->szName);
	 WinSendDlgItemMsg(hwnd, IDD_CODEPAGE,EM_SETTEXTLIMIT,
				 MPFROM2SHORT(LENUSHORTBUF-1,0),NULL);

	 pusPtr= (USHORT *) ((CHAR *) pFEA->aValue+pPDat->usMultiOffset);
	 pusPtr++;	    /* Skip the EA_Type field and point to codepage */
	 sprintf(szCodePage,"%u",*pusPtr);
	 WinSetDlgItemText(hwnd, IDD_CODEPAGE,szCodePage);

	 pusPtr++;	      /* Skip codepage and point to the field count */

	 for(cnt=0;cnt< *pusPtr;cnt++)	     /* Add each field to the L-Box */
	 {
	    pInsert = MultiTypeIndex(pFEA->aValue+pPDat->usMultiOffset,cnt);
	    pValue = EAValueString(pInsert);	    /* Ptr to asciiz string */

	    WinSendDlgItemMsg(hwnd, IDD_LBOX, LM_INSERTITEM,
			      MPFROM2SHORT(LIT_END,0),
			      MPFROMP(pValue));
	    FreeMem(pValue);			      /* Free asciiz string */
	 }
	 return (MRESULT)0L;

      case WM_CONTROL:
	 switch(SHORT1FROMMP(mp1))
	 {
	    case IDD_LBOX:
	       switch(SHORT2FROMMP(mp1))
	       {
		  case LN_SELECT:   /* Display proper EA type for selection */
		     sOffset = (SHORT) WinSendDlgItemMsg(hwnd, IDD_LBOX,
						  LM_QUERYSELECTION,0,0);
		     if(sOffset<0)
			break;

		     pValue = MultiTypeIndex(pFEA->aValue+pPDat->usMultiOffset,
					     sOffset);
		     pusPtr = (USHORT *) pValue;

		     WinSetDlgItemText(hwnd,IDD_EATYPE,
				ConvTable[LookupEAType(*pusPtr)].szFormat);
		     break;

		  case LN_ENTER:  /* Setup and edit a m-m field */
		     sOffset = (SHORT) WinSendDlgItemMsg(hwnd, IDD_LBOX,
						       LM_QUERYSELECTION,0,0);
		     if(sOffset<0)
			return 0L;

		     PDat.Point		= (CHAR *) pFEA; /* Pass curr data */
		     PDat.cbMulti	= pPDat->cbMulti;
		     PDat.usMultiOffset = pPDat->usMultiOffset;
		     PDat.usIndex	= sOffset;

		     if(EditEAValue(hwnd,&PDat))     /* They didn't cancel */
		     {
			pInsert=MultiTypeIndex(pFEA->aValue
						+ pPDat->usMultiOffset,
					       sOffset);
			pValue =EAValueString(pInsert);

			WinSendDlgItemMsg(hwnd, IDD_LBOX, LM_SETITEMTEXT,
					  MPFROMSHORT(sOffset),
					  MPFROMP(pValue));
			FreeMem(pValue);	       /* Free asciiz str */
		     }
		     return (MRESULT)0L;
	       }
	 }
	 break;

      case WM_COMMAND:
	 switch(LOUSHORT(mp1))
	 {
	    case IDD_ADD:			 /* Add an item for a m-m */
	       if(!WinDlgBox(HWND_DESKTOP,	 /* Do an ascii text edit */
			     hwnd,
			     AsciiEditProc,
			     '\0',
			     IDD_ASCIIEDIT,
			     &PDat))
		     return (MRESULT)0L;	      /* They said cancel */
	       break;

	    case IDD_EDIT:		    /* Setup and edit a m-m field */
	       sOffset = (SHORT) WinSendDlgItemMsg(hwnd, IDD_LBOX,
						   LM_QUERYSELECTION,0,0);
	       if(sOffset<0)
	       {
		  MessageBox(hwnd, IDMSG_ERRORSELECT, "Error !",
				       MB_OK | MB_ERROR, TRUE);
		  return (MRESULT)0L;
	       }
	       PDat.Point	  = (CHAR *) pFEA;	 /* Pass curr data */
	       PDat.cbMulti	  = pPDat->cbMulti;
	       PDat.usMultiOffset = pPDat->usMultiOffset;
	       PDat.usIndex	  = sOffset;

	       if(EditEAValue(hwnd,&PDat))	     /* They didn't cancel */
	       {
		  pInsert=MultiTypeIndex(pFEA->aValue + pPDat->usMultiOffset,
					 sOffset);
		  pValue =EAValueString(pInsert);

		  WinSendDlgItemMsg(hwnd, IDD_LBOX, LM_SETITEMTEXT,
				    MPFROMSHORT(sOffset),
				    MPFROMP(pValue));
		  FreeMem(pValue);			/* Free asciiz str */
	       }
	       return (MRESULT)0L;

	    case IDD_DELETE:			  /* Delete hi-lited item  */
	       sOffset = (USHORT) WinSendDlgItemMsg(hwnd, IDD_LBOX,
						    LM_QUERYSELECTION,0,0);
	       if(sOffset<0)		  /* No item is currently selected */
	       {
		  MessageBox(hwnd, IDMSG_ERRORSELECT, "Error !",
				       MB_OK | MB_ERROR, TRUE);
		  return (MRESULT)0L;
	       }
	       WinSendDlgItemMsg(hwnd, IDD_LBOX, LM_DELETEITEM,
				 MPFROMSHORT(sOffset),0L);

	       /* Get pointers to start of selected field and the following
		  field, then move the rest of the EA back, resize the
		  buffer, and change the EA Value counter		   */

	       pDelete = MultiTypeIndex(pFEA->aValue+pPDat->usMultiOffset,
					sOffset);
	       pValue  = MultiTypeIndex(pFEA->aValue+pPDat->usMultiOffset,
					(sOffset+1) );
	       memmove(pDelete,pValue,pFEA->cbValue-(pValue-pFEA->aValue));
	       DosSetMem(pFEA->aValue, pFEA->cbValue-(pValue-pDelete), fPERM|PAG_COMMIT);
	       pFEA->cbValue -= pValue-pDelete;

				    /* Decrement the field count in the m-m */
	       pusPtr  = (USHORT *) ((CHAR *) pFEA->aValue +
					      pPDat->usMultiOffset);
	       pusPtr+=2;			/* Point to the field count */
	       *pusPtr -= 1;			/* Decrement the field cnt  */

	       FILE_CHANGED = TRUE;
	       return (MRESULT)0L;

	    case DID_DONE:
			 /* Handle the possible change of the need checkbox */
	       fNeed = (BYTE) WinSendDlgItemMsg(hwnd, IDD_NEEDBIT,
						BM_QUERYCHECK,
						0L, 0L);
	       if(fNeed)
		  fNeed = 0x80;
	       if(fNeed != (BYTE) (pFEA->fEA & 0x80))	    /* Need changed */
	       {
		  pFEA->fEA = (BYTE)((pFEA->fEA & 0x7F) | fNeed);
		  FILE_CHANGED = TRUE;
	       }

			      /* Handle the possible change of the codepage */
	       WinQueryDlgItemText(hwnd, IDD_CODEPAGE,
				   LENUSHORTBUF, szCodePage);
	       sscanf(szCodePage,"%u",&cnt);
	       pusPtr= (USHORT *) ((CHAR *) pFEA->aValue+pPDat->usMultiOffset);
	       pusPtr++;    /* Skip the EA_Type field and point to codepage */
	       if(*pusPtr != cnt)	 /* They changed the codepage value */
	       {
		  *pusPtr = cnt;
		  FILE_CHANGED = TRUE;
	       }
	       ReEntHold = CurEntry->next;	 /* Finish recursion safety */
	       FreeMem(CurEntry);
	       CurEntry = ReEntHold;
	       if(CurEntry)
	       {
		  pPDat = CurEntry->pPDat;
		  pFEA	= CurEntry->pFEA;
	       }
	       WinDismissDlg(hwnd, TRUE);
	       return (MRESULT)0L;
	 }

      case WM_CLOSE:
	 WinDismissDlg(hwnd, FALSE);
	 return (MRESULT)0L;
   }
   sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
   return sRC;
}

/****************************************************************\
 *								*
 *  Name:    MultiTypeProc(hwnd, msg, mp1, mp2)			*
 *								*
 *  Purpose: This proc handles the multi-type EA stuff. Allows	*
 *	     the fields in a given m-m to be edited.		*
 *  Usage :							*
 *								*
 *  Method : NOTE that this procedure is fully reentrant/	*
 *	     recursive in that it calls EditEAValue() which can *
 *	     call MultiTypeProc. Since PassData information is	*
 *	     placed in static variables, the ReEnter structure	*
 *	     is used to hold a dynamic linked list of values	*
 *	     passed into the proc and thus keeps the static data*
 *	     set to the proper values.				*
 *								*
 *  Returns: Always returns TRUE thru WinDismissDlg when DONE is*
 *	     clicked.						*
 *								*
\****************************************************************/
MRESULT EXPENTRY MultiTypeProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   static HOLDFEA *pFEA;		/* Points to the current EA	    */
   static PASSDATA FAR *pPDat;		/* Points to the passed Data struct */
   static REENTER *CurEntry;		/* Points to most recent data frame */
   REENTER *ReEntHold=NULL;		/* Temp used to setup the frame	    */
   PASSDATA PDat;			/* Used for call to EditEAValue	    */
   USHORT *pusPtr,cnt;			/* Utility vars			    */
   SHORT  sOffset;
   CHAR	  *pInsert,*pValue,*pDelete;
   CHAR	  szCodePage[LENUSHORTBUF];
   BYTE	  fNeed;			/* Holds state of need checkbox	    */
   MRESULT sRC;

   switch(msg)
   {
      case WM_INITDLG:
	 FixSysMenu(hwnd);
	 pPDat = PVOIDFROMMP(mp2);		      /* Set up static vars */
	 pFEA  = (HOLDFEA *) pPDat->Point;

	 GetMem((PPVOID)&ReEntHold, (ULONG)sizeof(REENTER));  /* Allows for recusive calls */
	 ReEntHold->pPDat = pPDat;
	 ReEntHold->pFEA  = pFEA;
	 ReEntHold->next  = CurEntry;
	 CurEntry = ReEntHold;

	 WinSendDlgItemMsg(hwnd, IDD_NEEDBIT, BM_SETCHECK,/* Need bit setup */
			   MPFROM2SHORT((pFEA->fEA&0x80)? TRUE : FALSE,0),
			   NULL);

	 WinSetDlgItemText(hwnd, IDD_EATYPE,"");      /* Setup the codepage */
	 WinSetDlgItemText(hwnd, IDD_EANAME,pFEA->szName);
	 WinSendDlgItemMsg(hwnd, IDD_CODEPAGE,EM_SETTEXTLIMIT,
				 MPFROM2SHORT(LENUSHORTBUF-1,0),NULL);

	 pusPtr= (USHORT *) ((CHAR *) pFEA->aValue+pPDat->usMultiOffset);
	 pusPtr++;	    /* Skip the EA_Type field and point to codepage */
	 sprintf(szCodePage,"%u",*pusPtr);
	 WinSetDlgItemText(hwnd, IDD_CODEPAGE,szCodePage);

	 pusPtr++;	      /* Skip codepage and point to the field count */

	 for(cnt=0;cnt< *pusPtr;cnt++)	     /* Add each field to the L-Box */
	 {
	    pInsert = MultiTypeIndex(pFEA->aValue+pPDat->usMultiOffset,cnt);
	    pValue = EAValueString(pInsert);	    /* Ptr to asciiz string */

	    WinSendDlgItemMsg(hwnd, IDD_LBOX, LM_INSERTITEM,
			      MPFROM2SHORT(LIT_END,0),
			      MPFROMP(pValue));
	    FreeMem(pValue);			      /* Free asciiz string */
	 }
	 return (MRESULT)0L;

      case WM_CONTROL:
	 switch(SHORT1FROMMP(mp1))
	 {
	    case IDD_LBOX:
	       switch(SHORT2FROMMP(mp1))
	       {
		  case LN_SELECT:   /* Display proper EA type for selection */
		     sOffset = (SHORT) WinSendDlgItemMsg(hwnd, IDD_LBOX,
						       LM_QUERYSELECTION,0,0);
		     if(sOffset<0)
			break;

		     pValue = MultiTypeIndex(pFEA->aValue+pPDat->usMultiOffset,
					     sOffset);
		     pusPtr = (USHORT *) pValue;

		     WinSetDlgItemText(hwnd,IDD_EATYPE,
				ConvTable[LookupEAType(*pusPtr)].szFormat);
		     break;

		  case LN_ENTER:  /* Setup and edit a m-m field */
		     sOffset = (SHORT) WinSendDlgItemMsg(hwnd, IDD_LBOX,
						       LM_QUERYSELECTION,0,0);
		     if(sOffset<0)
			return (MRESULT)0L;

		     PDat.Point		= (CHAR *) pFEA; /* Pass curr data */
		     PDat.cbMulti	= pPDat->cbMulti;
		     PDat.usMultiOffset = pPDat->usMultiOffset;
		     PDat.usIndex	= sOffset;

		     if(EditEAValue(hwnd,&PDat))     /* They didn't cancel */
		     {
			pInsert=MultiTypeIndex(pFEA->aValue
						+ pPDat->usMultiOffset,
					       sOffset);
			pValue =EAValueString(pInsert);

			WinSendDlgItemMsg(hwnd, IDD_LBOX, LM_SETITEMTEXT,
					  MPFROMSHORT(sOffset),
					  MPFROMP(pValue));
			FreeMem(pValue);	       /* Free asciiz str */
		     }
		     return (MRESULT)0L;
	       }
	 }
	 break;

      case WM_COMMAND:
	 switch(LOUSHORT(mp1))
	 {
	    case IDD_ADD:			 /* Add an item for a m-m */
	       MultiAdd(hwnd, pFEA,pPDat);
	       return (MRESULT)0L;

	    case IDD_EDIT:		    /* Setup and edit a m-m field */
	       if(ConvTable[usRetEAType].usPrefix != EA_MVST)
	       {
		  sOffset = (SHORT) WinSendDlgItemMsg(hwnd, IDD_LBOX,
						   LM_QUERYSELECTION,0,0);
		  if(sOffset<0)
		  {
		     MessageBox(hwnd, IDMSG_ERRORSELECT, "Error !",
				       MB_OK | MB_ERROR, TRUE);
		     return (MRESULT)0L;
		  }
	       } else	    sOffset=0;

	       PDat.Point	  = (CHAR *) pFEA;	 /* Pass curr data */
	       PDat.cbMulti	  = pPDat->cbMulti;
	       PDat.usMultiOffset = pPDat->usMultiOffset;
	       PDat.usIndex	  = sOffset;

	       if(EditEAValue(hwnd,&PDat))	     /* They didn't cancel */
	       {
		  pInsert=MultiTypeIndex(pFEA->aValue + pPDat->usMultiOffset,
					 sOffset);
		  pValue =EAValueString(pInsert);

		  WinSendDlgItemMsg(hwnd, IDD_LBOX, LM_SETITEMTEXT,
				    MPFROMSHORT(sOffset),
				    MPFROMP(pValue));
		  FreeMem(pValue);			/* Free asciiz str */
	       }
	       return (MRESULT)0L;

	    case IDD_DELETE:			  /* Delete hi-lited item  */
	       sOffset = (USHORT) WinSendDlgItemMsg(hwnd, IDD_LBOX,
						    LM_QUERYSELECTION,0,0);
	       if(sOffset<0)		  /* No item is currently selected */
	       {
		  MessageBox(hwnd, IDMSG_ERRORSELECT, "Error !",
				       MB_OK | MB_ERROR, TRUE);
		  return (MRESULT)0L;
	       }
	       WinSendDlgItemMsg(hwnd, IDD_LBOX, LM_DELETEITEM,
				 MPFROMSHORT(sOffset),0L);

	       /* Get pointers to start of selected field and the following
		  field, then move the rest of the EA back, resize the
		  buffer, and change the EA Value counter		   */

	       pDelete = MultiTypeIndex(pFEA->aValue+pPDat->usMultiOffset,
					sOffset);
	       pValue  = MultiTypeIndex(pFEA->aValue+pPDat->usMultiOffset,
					(sOffset+1) );
	       memmove(pDelete,pValue,pFEA->cbValue-(pValue-pFEA->aValue));
	       DosSetMem(pFEA->aValue, pFEA->cbValue-(pValue-pDelete), fPERM|PAG_COMMIT);
	       pFEA->cbValue -= pValue-pDelete;

				    /* Decrement the field count in the m-m */
	       pusPtr  = (USHORT *) ((CHAR *) pFEA->aValue +
					      pPDat->usMultiOffset);
	       pusPtr+=2;			/* Point to the field count */
	       *pusPtr -= 1;			/* Decrement the field cnt  */

	       FILE_CHANGED = TRUE;
	       return (MRESULT)0L;

	    case DID_DONE:
			 /* Handle the possible change of the need checkbox */
	       fNeed = (BYTE) WinSendDlgItemMsg(hwnd, IDD_NEEDBIT,
						BM_QUERYCHECK,
						0L, 0L);
	       if(fNeed)
		  fNeed = 0x80;
	       if(fNeed != (BYTE) (pFEA->fEA & 0x80))	    /* Need changed */
	       {
		  pFEA->fEA = (BYTE)((pFEA->fEA & 0x7F) | fNeed);
		  FILE_CHANGED = TRUE;
	       }

			      /* Handle the possible change of the codepage */
	       WinQueryDlgItemText(hwnd, IDD_CODEPAGE,
				   LENUSHORTBUF, szCodePage);
	       sscanf(szCodePage,"%u",&cnt);
	       pusPtr= (USHORT *) ((CHAR *) pFEA->aValue+pPDat->usMultiOffset);
	       pusPtr++;    /* Skip the EA_Type field and point to codepage */
	       if(*pusPtr != cnt)	 /* They changed the codepage value */
	       {
		  *pusPtr = cnt;
		  FILE_CHANGED = TRUE;
	       }
	       ReEntHold = CurEntry->next;	 /* Finish recursion safety */
	       FreeMem(CurEntry);
	       CurEntry = ReEntHold;
	       if(CurEntry)
	       {
		  pPDat = CurEntry->pPDat;
		  pFEA	= CurEntry->pFEA;
	       }
	       WinDismissDlg(hwnd, TRUE);
	       return (MRESULT)0L;
	 }

      case WM_CLOSE:
	 WinDismissDlg(hwnd, FALSE);
	 return (MRESULT)0L;
   }
   sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
   return sRC;
}

/****************************************************************\
 *								*
 *  Name:    ShowEAType(hwnd)					*
 *								*
 *  Purpose: This routine handles the display of the current EA *
 *	     type by setting the text in the appropriate dialog *
 *	     field.						*
 *  Usage  :							*
 *  Method : Routine should be bullet proof as it does its own	*
 *	     error checking. It assumes that hwnd points to the *
 *	     correct window with the name listbox in it.	*
 *								*
 *  Returns: VOID						*
 *								*
\****************************************************************/
VOID ShowEAType(HWND hwnd)
{
   HOLDFEA *pFEA;

   pFEA = GetCurFEA(hwnd, pHoldFEA);	       /* Points to the selected EA */
   if(!pFEA)				/* Kill line if nothing is selected */
   {
      memset(szEAType, 0, sizeof(szEAType) );
      WinInvalidateRect(hwndMain, NULL, FALSE);
      return;
   }
   strcpy(szEAType, ConvTable[usRetEAType].szFormat);
   WinInvalidateRect(hwndMain, NULL, FALSE);
   return;
}

/****************************************************************\
 *								*
 *  Name:    EditEA(hwnd)					*
 *								*
 *  Purpose: This routine handles the editing of an EA when it	*
 *	     is selected from the listbox.  It get the item	*
 *	     selected, sets up the PassData structure then calls*
 *	     EditEAValue to do the actual edi			*
 *  Usage  :							*
 *  Method : Routine should be bullet proof as it does its own	*
 *	     error checking. It assumes that hwnd points to the *
 *	     correct window with the name listbox in it.	*		 *
 *								*
 *  Returns: TRUE if the edit was successful.			*
 *								*
\****************************************************************/
BOOL EditEA(HWND hwnd)
{
   HOLDFEA  *pFEA=pHoldFEA;			 /* Pointer for selected EA */
   SHORT    soffset,sCnt;    /* Both used to reference offset of selected EA */
   PASSDATA PData;

   if(!FILE_ISOPEN)
   {
      MessageBox(hwnd, IDMSG_ERRORSELECT, "Error !",
			       MB_OK | MB_ERROR, TRUE);
      return(FALSE);
   }
   soffset = sCnt = (SHORT) WinSendDlgItemMsg(hwnd, IDD_WINLBOX,
					    LM_QUERYSELECTION,0,0);
   if(soffset< 0)			       /* Nothing is selected */
   {
      MessageBox(hwnd, IDMSG_ERRORSELECT, "Error !",
			       MB_OK | MB_ERROR, TRUE);
      return(FALSE);
   }
   while(sCnt--)				     /* Get to the right EA */
      pFEA = pFEA->next;

   PData.Point	       = (CHAR *)pFEA;		/* Set the pass data struct */
   PData.usMultiOffset = 0;
   PData.cbMulti       = 0;

   if(EditEAValue(hwnd,&PData))				       /* It worked */
   {
      WinSendDlgItemMsg(hwnd, IDD_WINLBOX, LM_SETITEMTEXT,
			MPFROMSHORT(soffset),MPFROMP(pFEA->szName));
      return(TRUE);
   }
   return(FALSE);
}

/****************************************************************\
 *								*
 * Name:    GetCurFEA(hwnd, pFEA)				*
 *								*
 * Purpose: This routine returns a pointer to the EA currently	*
 *	    highlighted in the list box.			*
 * Usage  :							*
 * Method : Routine should be bullet proof as it does its own	*
 *	    error checking. It assumes that hwnd points to the	*
 *	    correct window with the name listbox in it.		*
 *								*
 * Returns: The current EA as determined by querying the l-box	*
 *	    selector, returns NULL if there is an error or	*
 *	    nothing is selected.				*
 *								*
\****************************************************************/
HOLDFEA *GetCurFEA(HWND hwnd, HOLDFEA *pFEA)
{
   LONG	 lOffset;

   lOffset = (LONG) WinSendDlgItemMsg(hwnd, IDD_WINLBOX,
				      LM_QUERYSELECTION,0,0);

   if(lOffset == 0xffff)			  /* Nothing is highlighted */
   {
      MessageBox(hwnd, IDMSG_ERRORSELECT, "Error !",
			       MB_OK | MB_ERROR, TRUE);
      return(NULL);
   }
   while(lOffset--)
   {
      pFEA = pFEA->next;
   }
   return(pFEA);
}

/****************************************************************\
 *								*
 *  Name:    GetMem (ppv, cb)					*
 *								*
 *  Purpose: This routine returns a pointer to a available*	*
 *	     memory space.					*
 *								*
 *  Usage  :							*
 *  Method : Routine should be bullet proof as it does its own	*
 *	     error checking. It assumes that hwnd points to the *
 *	     correct window with the name listbox in it.	*
 *								*
 *  Returns: The current EA as determined by querying the l-box *
 *	     selector.						*
 *								*
\****************************************************************/
VOID GetMem (PVOID *ppv, ULONG cb)
{
    BOOL	f;

    f =(BOOL) DosAllocMem(ppv, cb, fPERM|PAG_COMMIT);
    if (f)
    {
	MessageBox(HWND_DESKTOP, IDMSG_MEMORYFULL, "Error !",
			       MB_OK | MB_ERROR, TRUE);
	*ppv = NULL;
	return;
    }
    return;
}

/****************************************************************\
 *								*
 *  Name:    ResizeMem(ppv, cbOld, cbNew)			*
 *								*
 *  Purpose: This routine returns a pointer to a available	*
 *	     memory space.					*
 *								*
 *  Usage  :							*
 *  Method :							*
 *								*
 *  Returns: VOID						*
 *								*
\****************************************************************/
VOID ResizeMem (PVOID *ppv, ULONG cbOld, ULONG cbNew)
{
    BOOL	f;
    PVOID	pvNew=NULL;

    f = (BOOL) DosAllocMem(&pvNew, cbNew, fPERM|PAG_COMMIT);
    if (f) {
	MessageBox(HWND_DESKTOP, IDMSG_MEMORYFULL, "Error !",
				 MB_OK | MB_ERROR, TRUE);
	*ppv = NULL;
	return;
    }
    memcpy(pvNew, *ppv, cbOld);
    f = (BOOL) DosFreeMem(*ppv);
    *ppv = pvNew;
    return ;
}
/*static char *SCCSID = "@(#)easea.c    6.7 92/02/18";*/
/*==============================================================*\
 *								*
 *  EASEA.C - sample PM application				*
 *    (C) Copyright IBM Corporation 1992.			*
 *--------------------------------------------------------------*
 *    This module contains subroutines for eas.c that		*
 *    specifically deal with the manipulation of EAs.		*
 *								*
 *--------------------------------------------------------------*
 *  Procedures in this file:					*
 *   AddEA()	       Handles the Add button press		*
 *   QueryEAs()	       Reads in all the EAs associated with a file
 *   CheckEAIntegrity()Checks an EA buffer to see if it is valid*
 *   Free_FEAList()    Deallocates memory associated with EA list
 *   LookupEAType()    Gets an offset into table for an EA type *
 *   DeleteCurEA()     Deletes the highlighted EA		*
 *   CurEAType()       Returns EA Type given a HoldFEA ptr	*
 *   GetUSHORT()       Returns nth USHORT in ->aValue		*
 *   WriteEAs()	       Updates EAs state on the disk		*
 *   EditEAValue()     Handles editing a given EA ( m-m EAs)	*
 *   EAExists()	       Determines if the given EA Name exists	*
 *   ChangeName()      Handles the change of an EA's name       *
 *   MultiTypeIndex()  Gets a specific field in a m-m structure *
 *   EAValueString()   Returns a representational string for  EA*
 *   MultiAdd()	       Handles addition of a field for m-m	*
\*==============================================================*/
/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#include "eas.h"

extern EADATA ConvTable[EATABLESIZE];

/****************************************************************\
 *								*
 *  Name:    AddEA(hwnd)					*
 *								*
 *  Purpose: This routine handles the addition of a new EA to	*
 *	     the linked list.					*
 *								*
 *  Usage  :							*
 *								*
 *  Method : Routine does NOT do full memory error trapping and *
 *	     the insert message to l-box is not error checked.	*
 *								*
 *  Returns: TRUE if the EA is successfully added.		*
 *								*
\****************************************************************/
BOOL AddEA(HWND hwnd)
{
   HOLDFEA  *pFEA=pHoldFEA;	  /* Points to the beginning of the EA list */
   HOLDFEA  *pNewFEA=NULL;	  /* Used to temporarily hold the new EA    */
   PASSDATA PData;

   if(!FILE_ISOPEN)
   {
      MessageBox(hwnd, IDMSG_NOFILEOPEN, "Error !",
				MB_OK | MB_ERROR, TRUE);
      return(FALSE);
   }
   if(!WinDlgBox(HWND_DESKTOP,			/* get new EA name and type */
		 hwnd,
		 AddEAProc,
		 '\0',
		 IDD_ADDEA,
		 '\0'))
      return(FALSE);					/* they said cancel */

   GetMem((PPVOID)&pNewFEA, sizeof(HOLDFEA));/* Allocate space for new EA struct */

   pNewFEA->cbName = (CHAR) strlen(szEAName);	   /* Fill in new structure */
   pNewFEA->cbValue= 0;
   pNewFEA->fEA	   = 0;					/* Need bit NOT set */
					       /* Name returned in szEAName */
   GetMem((PPVOID)&pNewFEA->szName, pNewFEA->cbName+1);
   strcpy(pNewFEA->szName,strupr(szEAName));
   pNewFEA->aValue = '\0';
   pNewFEA->next   = '\0';

   if(pHoldFEA == '\0')			  /* It's the first EA for the file */
      pHoldFEA = pNewFEA;
   else				    /* Add EA to the end of the linked list */
   {
      while(pFEA->next)
	 pFEA = pFEA->next;
      pFEA->next = pNewFEA;
   }
   PData.Point	       = (CHAR *) pNewFEA;	/* Setup user data for call */
   PData.cbMulti       = 0;			/* to edit of the name and  */
   PData.usMultiOffset = 0;			/* EA Value		    */

   if(!EditEAValue(hwnd,&PData))		  /* They canceled the edit */
   {
      if(pFEA)					    /* It's not the only EA */
	 pFEA->next = '\0';		   /* Disconnect the partial new EA */
      else
	 pHoldFEA = '\0';		   /* The new EA was the first one  */

      FreeMem(pNewFEA->szName);
      FreeMem(pNewFEA);

      return(FALSE);
   }
   WinSendDlgItemMsg(hwnd, IDD_WINLBOX, LM_INSERTITEM,/* Insert name in L-Box */
		     MPFROM2SHORT(LIT_END,0),
		     MPFROMP(pNewFEA->szName));
   return(TRUE);
}

/****************************************************************\
 *								*
 *  Name:    QueryEAs(pszPath)					*
 *								*
 *  Purpose: Call DOS to Query a file's EA names and values.    *
 *								*
 *  Usage:							*
 *								*
 *  Method : Routine does NOT do full memory error trapping.	*
 *	     NOTE:  This routine does NOT prevent other		*
 *	     processes from accessing the file's EAs while it is*
 *	     reading them in, or while the program is editing	*
 *	     them.						*
 *								*
 *  Returns: TRUE if it successfully reads in the EAs. Upon exit*
 *	     , globalp HoldFEA points to a linked list of the	*
 *	     EAs for the current file.				*
 *								*
\****************************************************************/
BOOL QueryEAs(CHAR *pszPath)
{
   CHAR *pAllocc=NULL; /* Holds the FEA struct returned by DosEnumAttribute */
		       /*  used to create the GEA2LIST for DosQueryPathInfo */
   CHAR *pBigAlloc=NULL; /* Temp buffer to hold each EA as it is read in    */
   USHORT cbBigAlloc=0;	 /* Size of buffer				    */

   ULONG ulEntryNum = 1; /* count of current EA to read (1-relative)	    */
   ULONG ulEnumCnt;	 /* Number of EAs for Enum to return, always 1	    */

   HOLDFEA *pLastIn=0;	  /* Points to last EA added, so new EA can link    */
   HOLDFEA *pNewFEA=NULL; /* Struct to build the new EA in		    */

   FEA2 *pFEA;		 /* Used to read from Enum's return buffer          */
   GEA2LIST *pGEAList;/*Ptr used to set up buffer for DosQueryPathInfo call */
   EAOP2  eaopGet;	 /* Used to call DosQueryPathInfo		    */
				   /* Allocate enough room for any GEA List */
   GetMem((PPVOID)&pAllocc, MAX_GEA);
   pFEA = (FEA2 *) pAllocc;		  /* pFEA always uses pAlloc buffer */

   pHoldFEA = '\0';	       /* Reset the pointer for the EA linked list  */

   while(TRUE)		      /* Loop continues until there are no more EAs */
   {
      ulEnumCnt = 1;		       /* Only want to get one EA at a time */
      if(DosEnumAttribute(Ref_ASCIIZ,		 /* Read into pAlloc Buffer */
			  pszPath,		 /* Note that this does not */
			  ulEntryNum,		 /* get the aValue field,   */
			  pAllocc,		 /* so DosQueryPathInfo must*/
			  MAX_GEA,		 /* be called to get it.    */
			  &ulEnumCnt,
			  (LONG) GetInfoLevel1))
	break;				    /* There was some sort of error */

      if(ulEnumCnt != 1)		      /* All the EAs have been read */
	 break;

      ulEntryNum++;

      GetMem((PPVOID)&pNewFEA, sizeof(HOLDFEA));

      if (pNewFEA == '\0')				   /* Out of memory */
      {
	 FreeMem(pAllocc);
	 Free_FEAList(pHoldFEA,pDelList);
	 return (FALSE);
      }

      pNewFEA->cbName = pFEA->cbName;	   /* Fill in the HoldFEA structure */
      pNewFEA->cbValue= pFEA->cbValue;
      pNewFEA->fEA    = pFEA->fEA;
      pNewFEA->next = '\0';

      GetMem((PPVOID)&pNewFEA->szName, pFEA->cbName +1); /* Allocate for 2 arrays */
      GetMem((PPVOID)&pNewFEA->aValue, pFEA->cbValue);

      if (!pNewFEA->szName || !pNewFEA->aValue)		   /* Out of memory */
      {
	 if(pNewFEA->szName)
	    FreeMem(pNewFEA->szName);
	 if(pNewFEA->aValue)
	    FreeMem(pNewFEA->aValue);

	 FreeMem(pAllocc);
	 FreeMem(pNewFEA);

	 Free_FEAList(pHoldFEA,pDelList);
	 return (FALSE);
      }
      strcpy(pNewFEA->szName,pFEA->szName);		 /* Copy in EA Name */

      cbBigAlloc = sizeof(FEA2LIST) + pNewFEA->cbName+1 +
			      pNewFEA->cbValue;
      GetMem((PPVOID)&pBigAlloc, cbBigAlloc);
      if (pBigAlloc == '\0')
      {
	 FreeMem(pNewFEA->szName);
	 FreeMem(pNewFEA->aValue);
	 FreeMem(pAllocc);
	 FreeMem(pNewFEA);
	 Free_FEAList(pHoldFEA,pDelList);
	 return (FALSE);
      }

      pGEAList = (GEA2LIST *) pAllocc;		/* Set up GEAList structure */

      pGEAList->cbList = sizeof(GEA2LIST) + pNewFEA->cbName; /* +1 for NULL */
      pGEAList->list[0].oNextEntryOffset = 0L;
      pGEAList->list[0].cbName = pNewFEA->cbName;
      strcpy(pGEAList->list[0].szName,pNewFEA->szName);

      eaopGet.fpGEA2List = (GEA2LIST FAR *) pAllocc;
      eaopGet.fpFEA2List = (FEA2LIST FAR *) pBigAlloc;

      eaopGet.fpFEA2List->cbList = cbBigAlloc;

      DosQueryPathInfo(pszPath,			    /* Get the complete EA info */
		       FIL_QUERYEASFROMLIST,
		      (PVOID) &eaopGet,
		       sizeof(EAOP2));
      memcpy(pNewFEA->aValue,		       /* Copy the value to HoldFEA */
	     pBigAlloc+sizeof(FEA2LIST)+pNewFEA->cbName,
	     pNewFEA->cbValue);

      FreeMem(pBigAlloc);		    /* Release the temp Enum buffer */

      if(!CheckEAIntegrity(pNewFEA->aValue,pNewFEA->cbValue))	  /* Bad EA */
      {
	 FreeMem(pNewFEA->szName);
	 FreeMem(pNewFEA->aValue);
	 FreeMem(pNewFEA);
	 continue;			/* Don't add this EA to linked list */
      }

      if(pHoldFEA == '\0')		       /* If first EA, set pHoldFEA */
	 pHoldFEA = pNewFEA;
      else				   /* Otherwise, add to end of list */
	 pLastIn->next = pNewFEA;

      pLastIn = pNewFEA;		      /* Update the end of the list */
   }
   FreeMem(pAllocc);			  /* Free up the GEA buf for DosEnum */
   return (TRUE);
}


/****************************************************************\
 *								*
 *  Function name: CheckEAIntegrity(aBuf, cbBuf)		*
 *								*
 *  Returns: TRUE if the buffer is a valid EA structure.	*
 *								*
 *  Purpose: This routine checks the integrity of the passed EA *
 *	     buffer by seeing if there are any non-standard EA	*
 *	     types, or bad data that isn't sized correctly.     *
 *  Usage  :							*
 *  Method : Routine uses MultiTypeIndex() to check m-m type EAs*
 *	     since they are potentially recursive. However, this*
 *	     may not be a good idea if the m-m EA is severly	*
 *	     corrupted because it may cause MTI() to attempt a	*
 *	     read from protected memory. Routine does NOT modify*
 *	     the buffer under any circumstance.			*
 *								*
 *  Returns: TRUE if the buffer is a valid EA structure.	*
 *								*
\****************************************************************/
BOOL CheckEAIntegrity(CHAR *aBuf, ULONG cbBuf)
{
   USHORT *pusPtr = (USHORT *) aBuf;
   USHORT usOffset;
   CHAR	  *aEndPtr;

   usOffset = LookupEAType(*pusPtr);		     /* Get the EA type */

   switch(ConvTable[usOffset].usFldType)
   {
      case IDD_LPDATA:
	 pusPtr++;
	 if(*pusPtr + 2*sizeof(USHORT) == cbBuf)
	    return TRUE;
	 else
	    return FALSE;

      case IDD_MULTILIST:
	 if(*pusPtr == EA_MVMT)
	 {
	    pusPtr += 2;

		/* This checks where the end of the m-m list ends to determine
		   the size of the EA.	This is probably not good if the EA is
		   badly corrupted and it points to protected memory	    */

	    aEndPtr = MultiTypeIndex(aBuf,*pusPtr);
	    if(aEndPtr - aBuf == (CHAR) cbBuf)
	       return TRUE;
	    else
	       return FALSE;
	 }
	 else		 /* Single type, multi-value is not yet implemented */
	 {
	    return TRUE;
	 }
      default:
	 return FALSE;
   }
   return TRUE;
}

/****************************************************************\
 *								*
 *  Name:    Free_FEAList(pFEA, pDList)				*
 *								*
 *  Purpose: This routine frees up the current list of EAs by	*
 *	     deallocating the space used by the szName and	*
 *	     aValue fields, then deallocating the HoldFEA struct*
 *	     Next, it deletes the EAName space, then the	*
 *	     DeleteList structure.				*
 *  Usage :							*
 *  Method:  Note that EAS always passes in pHoldFEA and	*
 *	     pDelList which is unnecessary since they are global*
 *	     pointers;however, this is done to make the routine *
 *	     more flexible by allowing multiple linked lists to *
 *	     exist.						*
 *								*
 *  Returns: VOID.  The two linked lists passed in are cleaned	*
 *	     out though.					*
 *								*
\****************************************************************/
VOID Free_FEAList(HOLDFEA *pFEA, DELETELIST *pDList)
{
   HOLDFEA *next;	/* Holds the next field since we free the structure */
			/* before reading the current next field	    */
   DELETELIST *Dnext;				   /* Same purpose as *next */

   while(pFEA)
   {
      next = pFEA->next;
      if(pFEA->szName)				  /* Free if non-NULL name  */
	 FreeMem(pFEA->szName);
      if(pFEA->aValue)				  /* Free if non-NULL value */
	 FreeMem(pFEA->aValue);

      FreeMem(pFEA);				     /* Free HoldFEA struct */
      pFEA = next;
   }
   while(pDList)
   {
      Dnext = pDList->next;
      if(pDList->EAName)
	 FreeMem(pDList->EAName);
      FreeMem(pDList);
      pDList = Dnext;
   }
   return;
}

/****************************************************************\
 *								*
 *  Name:    LookupEAType(usType)				*
 *								*
 *  Purpose: This routine takes EA type and returns an offset	*
 *	     into ConvTable which points to an entry that	*
 *	     describes the type passed in.			*
 *								*
 *  Usage:							*
 *  Method:							*
 *								*
 *  Returns: An offset into the ConvTable to the appropriate	*
 *	     entry. If no match is found, the return value	*
 *	     points to the last entry, non-conventional format. *
 *								*
\****************************************************************/
ULONG LookupEAType(ULONG usType)
{
   USHORT cnt;

   for(cnt=0;cnt<EATABLESIZE-1;cnt++)
      if(ConvTable[cnt].usPrefix == usType)
	 return(cnt);
   return(cnt);
}

/****************************************************************\
 *								*
 *  Name:    DeleteCurEA(hwnd)					*
 *								*
 *  Purpose: This routine removes in memory the currently	*
 *	     highlighted EA from the EA list.  It places the	*
 *	     deleted EA in the global pDelList linked list.	*
 *								*
 *  Usage:   This routine is called by MainDlgProc when DELETE	*
 *	     button selected.					*
 *								*
 *  Method:  The memory allocation routines are NOT fully error *
 *	     trapped.						*
 *								*
 *  Returns: VOID.  Removes one item from global pHoldFEA list	*
 *	     and adds one to global pDelList.			*
 *								*
\****************************************************************/
VOID DeleteCurEA(HWND hwnd)
{
   HOLDFEA    *pFEA,*pFEAPrev;
   DELETELIST *pDL=NULL, *pDLcnt;/*Utility ptrs for manipulating the Del list*/
   SHORT      sOffset;
   SHORT      i;

   if(!FILE_ISOPEN)
   {
      MessageBox(hwnd, IDMSG_ERRORSELECT, "Error !",
			       MB_OK | MB_ERROR, TRUE);
      return;
   }
   sOffset = (SHORT) WinSendDlgItemMsg(hwnd, IDD_WINLBOX,
					 LM_QUERYSELECTION,0,0);
   if(sOffset<0)			   /* No item is currently selected */
   {
      MessageBox(hwnd, IDMSG_ERRORSELECT, "Error !",
				     MB_OK | MB_ERROR, TRUE);
      return;
   }
   pFEA = GetCurFEA(hwnd,pHoldFEA);	/* Gets a pointer to item to delete */
   if (pFEA == '\0')
      return;
	       /* These two allocations should be checked for out of memory */
   GetMem((PPVOID)&pDL, sizeof(DELETELIST));	 /* Add Name to Delete List */
   GetMem((PPVOID)&pDL->EAName, pFEA->cbName+1);
   strcpy(pDL->EAName,pFEA->szName);
   pDL->next = '\0';

   if(pDelList == '\0')		      /* The del list was previously empty  */
      pDelList = pDL;
   else				      /* tack name onto the end of the list */
   {
      pDLcnt = pDelList;
      while(pDLcnt->next)
	 pDLcnt = pDLcnt->next;
      pDLcnt->next = pDL;
   }
   WinSendDlgItemMsg(hwnd, IDD_WINLBOX,
		     LM_DELETEITEM,MPFROMSHORT(sOffset),0L);

   if(sOffset<1)			/* Remove pFEA from the linked list */
   {
      pHoldFEA = pFEA->next;
   }
   else
   {
      pFEAPrev = pHoldFEA;

      --sOffset;
      while(sOffset)					/* Find previous EA */
      {
	 pFEAPrev = pFEAPrev->next;
	 --sOffset;
      }
      pFEAPrev->next = pFEA->next;
   }
			   /* Check Type Name is in the list of MVST or not */
   for (i=0; i<MSNUM && MSdata[i].szName!=NULL &&
			strcmp(pFEA->szName,MSdata[i].szName)!=0;)
	  i++;

   if(i<MSNUM && MSdata[i].szName!=NULL)	 /* Found the EA type in MVST list */
   {
      FreeMem(MSdata[i].szName);
      for (; i<MSNUM && MSdata[i+1].szName!=NULL; i++)
      {
	 MSdata[i].szName = MSdata[i+1].szName;
	 MSdata[i].usType = MSdata[i+1].usType;
      }
   }
   FreeMem(pFEA->szName);			      /* Release the memory */
   FreeMem(pFEA->aValue);
   FreeMem(pFEA);

   FILE_CHANGED = TRUE;
   return;
}

/****************************************************************\
 *								*
 *  Name:    CurEAType(pFEA)					*
 *								*
 *  Purpose: Given an EA structure, this routine returns the	*
 *	     Type of the EA which resides in the first USHORT of*
 *	     the aValue member. This function is the same as	*
 *	     GetUSHORT(pFEA,0).					*
 *  Usage  :							*
 *  Method : Assumes a valid HoldFEA struct.			*
 *								*
 *  Returns: The EA type.					*
 *								*
\****************************************************************/
ULONG CurEAType(HOLDFEA *pFEA)			 /* Same as GetUSHORT(,0); */
{
   USHORT *pusType;    /* EA Type is stored in first USHORT of aValue field */

   pusType = (USHORT *) pFEA->aValue;
   return(*pusType);
}

/****************************************************************\
 *								*
 *  Name:    GetUSHORT(pFEA, index)				*
 *								*
 *  Purpose: This routine returns the nth USHORT value in the	*
 *	     aValue member of pFEA using index as the offset.	*
 *  Usage  :							*
 *  Method : Assumes a valid HoldFEA struct and that index	*
 *	     doesn't point outside the aValue buffer.           *
 *								*
 *  Returns: The appropriate USHORT from the aValue field	*
 *								*
\****************************************************************/
USHORT GetUSHORT(HOLDFEA *pFEA, ULONG index)
{
   USHORT *pusType;

   pusType = (USHORT *) pFEA->aValue;
   while(index-- > 0)
      pusType++;
   return(*pusType);
}

/****************************************************************\
 *								*
 *  Name:    WriteEAs()						*
 *								*
 *  Purpose: This routine updates the EAs on disk to reflect	*
 *	     their current condition in memory.	 First, all EAs *
 *	     in the delete list are removed from the disk, then *
 *	     all EAs in the pHoldFEA list are written to disk.	*
 *  Usage  :							*
 *  Method : This routine is not bulletproof as it does not get *
 *	     exclusive access to the file EAs, nor does it	*
 *	     handle out of disk space sort of errors. Also,	*
 *	     memory fetches are not fully error trapped.	*
 *								*
 *  Returns: VOID.  But cleans out the pDelList linked list.	*
 *								*
\****************************************************************/
VOID WriteEAs()
{
   DELETELIST *pDL = pDelList,*pDLnext;
   HOLDFEA    *pHFEA= pHoldFEA;
   EAOP2       eaopWrite;
   CHAR	      aBuf[MAX_GEA],*aPtr=NULL;
   FEA2	       *pFEA = (FEA2 *) &aBuf[sizeof(ULONG)];
   USHORT     usMemNeeded, usRet;
   ULONG      *pulPtr=(ULONG *) aBuf;  /* Initally points to top of FEALIST */

   if(!FILE_ISOPEN)
   {
      MessageBox(HWND_DESKTOP, IDMSG_NOFILEOPEN, "Error !",
				MB_OK | MB_ERROR, TRUE);
      return;
   }
   if (!FILE_CHANGED)		       /* Don't write unless it's necessary */
      return;
   eaopWrite.fpFEA2List = (FEA2LIST FAR *) aBuf; /* Setup fields that won't */
   pFEA->fEA	 = 0;				 /* change for the delete   */
   pFEA->cbValue = 0;				 /* calls to DosSetPathInfo */

   while(pDL)			      /* Clean out all the deleted EA names */
   {
      pFEA->cbName = (UCHAR) strlen(pDL->EAName);
      *pulPtr	   = sizeof(FEA2LIST) + pFEA->cbName;
      strcpy(pFEA->szName,pDL->EAName);
      pFEA->oNextEntryOffset = 0L;
					 /* Delete EA's by saying cbValue=0 */
      DosSetPathInfo(szFileName,
		     SetInfoLevel2,
		     (PVOID) &eaopWrite,
		     sizeof(EAOP2),
		     DSPI_WRTTHRU);
      pDLnext = pDL->next;			      /* Temp hold next pDL */
      FreeMem(pDL->EAName);		      /* Free up current Del struct */
      FreeMem(pDL);
      pDL = pDLnext;				  /* Set pDL to saved value */
   }
   pDelList = '\0';				    /* DelList is now empty */

   while(pHFEA)					 /* Go through each HoldFEA */
   {
      usMemNeeded = sizeof(FEA2LIST) + pHFEA->cbName+1 +
				pHFEA->cbValue;
      GetMem((PPVOID)&aPtr, usMemNeeded);

      eaopWrite.fpFEA2List = (FEA2LIST FAR *) aPtr;  /* Fill in eaop struct */
      eaopWrite.fpFEA2List->cbList = usMemNeeded;

      eaopWrite.fpFEA2List->list[0].fEA	    = pHFEA->fEA;
      eaopWrite.fpFEA2List->list[0].cbName  = pHFEA->cbName;
      eaopWrite.fpFEA2List->list[0].cbValue = pHFEA->cbValue;

      strcpy(eaopWrite.fpFEA2List->list[0].szName, pHFEA->szName);
      memcpy(eaopWrite.fpFEA2List->list[0].szName + pHFEA->cbName+1,
	     pHFEA->aValue, pHFEA->cbValue);

      usRet = DosSetPathInfo(szFileName,	 /* Write out the EA */
			     FIL_QUERYEASIZE,
			     (PVOID) &eaopWrite,
			     sizeof(EAOP2),
			     DSPI_WRTTHRU);
      if (usRet)
      {
	  MessageBox(HWND_DESKTOP, IDMSG_WRITEERROR, "Error !",
				  MB_OK | MB_ERROR, TRUE);
	  FreeMem(aPtr);		      /* Free up the FEALIST struct */
	  FILE_CHANGED = FALSE;
	  return;
      }
      FreeMem(aPtr);			      /* Free up the FEALIST struct */

      pHFEA = pHFEA->next;
   }
   FILE_CHANGED = FALSE;
   MessageBox(HWND_DESKTOP, IDMSG_WRITEOK, "Note !", MB_OK, FALSE);
   return;
}

/****************************************************************\
 *								*
 *  Function name: EditEAValue(hwnd, pPDat)			*
 *								*
 *  Purpose: This routine allows the entry/edit of an EA value	*
 *	     condition in memory.  First, all EAs in the delete *
 *	     list are removed from the disk, then all EAs in the*
 *	     pHoldFEA list are written out to disk.		*
 *  Usage  :							*
 *  Method : Expects the PassData structure to tell it the	*
 *	     HoldFEA to edit, and if it is a subfield of a multi*
 *	     -multi EA, the rest of the PassData structure will *
 *	     be filled into indicated which m-m is being edited.*
 *	     Note that if this is a new edit, usRetEAType is	*
 *	     expected to be set to the proper EA type upon entry*
 *    NOTE:  memory sizing  requests are not fully error trapped*
 *								*
 *  Returns: TRUE if the edit was successful.			*
 *								*
\****************************************************************/
BOOL EditEAValue(HWND hwnd, PPASSDATA pPDat)
{
   USHORT usEAType;		       /* Holds the field type to be edited */
   USHORT *pusPtr;
   USHORT usSize;  /* Holds the delta difference of the old and new buffers */
   CHAR	  *szNew=NULL,*szTrash;				   /* Temporary pointers */
   PASSDATA PDat;
   HOLDFEA *pFEA = (HOLDFEA *) pPDat->Point;	     /* The EA to be edited */

			    /* Determine the type of EA that will be edited */
   if(pPDat->cbMulti)				  /* It's a multi-type job  */
   {
      pusPtr = (USHORT *) MultiTypeIndex(pFEA->aValue+pPDat->usMultiOffset,
					 pPDat->usIndex);
      usEAType = *pusPtr;
   }
   else if(pFEA->cbValue)			  /* It isn't a new EA name */
   {
      pusPtr   = (USHORT *)pFEA->aValue;
      usEAType = *pusPtr;
   }
   else							   /* It's a new EA */
      usEAType = ConvTable[usRetEAType].usPrefix;

   PDat.Point	= pFEA->szName;		 /* General setup for AsciiEditProc */
						  /* =1 if there is a multi */
   PDat.usIndex =(USHORT)( pPDat->cbMulti ? 1 : 0);
   PDat.fFlag	= (BYTE) ((pFEA->fEA & 0x80) ? TRUE : FALSE);

   switch(usEAType)
   {
      case EA_ASCIIZ:
      case EA_ASCIIZFN:
      case EA_ASCIIZEA:
      case EA_ASN1:
	 if(pPDat->cbMulti)			/* It is a multi-type field */
	    szAscii=MultiTypeIndex(pFEA->aValue + pPDat->usMultiOffset,
				   pPDat->usIndex)
		    +sizeof(USHORT);
	 else if(pFEA->cbValue)			/* There is a current value */
	    szAscii=pFEA->aValue+sizeof(USHORT);
	 else						   /* It's a new EA */
	    szAscii='\0';

	 if(!WinDlgBox(HWND_DESKTOP,		   /* Do an ascii text edit */
		       hwnd,
		       AsciiEditProc,
		       '\0',
		       IDD_ASCIIEDIT,
		       &PDat))
	    return(FALSE);				/* They said cancel */

	 if(PDat.fFlag)				/* Handle the need/nice bit */
	    PDat.fFlag = 0x80;
	 if(PDat.fFlag != (BYTE)(PDat.fFlag & 0x80))
	    FILE_CHANGED = TRUE;
	 pFEA->fEA =(BYTE)( (pFEA->fEA & 0x7f) | PDat.fFlag );

	 if(stricmp(strupr(szEAName),pFEA->szName))	/* The name changed */
	    ChangeName(pFEA,szEAName);

	 if(pFEA->cbValue)			/* There is a current value */
	 {
	    if(!strcmp(szAscii,szScratch))	       /* It hasn't changed */
	       return(TRUE);

	    if(pPDat->cbMulti)		  /* Do the whole thing here if m-m */
	    {						  /* Change in size */
	       usSize = (strlen(szScratch)-strlen(szAscii));

	       if(usSize > 0)			/* The new string is longer */
	       {
		  ResizeMem((PPVOID)&pFEA->aValue,	     /* Enlarge the EA size */
			    pFEA->cbValue,
			    pFEA->cbValue+usSize);
		  szTrash=MultiTypeIndex(pFEA->aValue + pPDat->usMultiOffset,
					       (pPDat->usIndex+1));
		  memmove(szTrash+usSize,    /* Move end of EA to make room */
			  szTrash,
			  pFEA->cbValue-(szTrash-pFEA->aValue));
	       }
	       else
	       {
		  szTrash= MultiTypeIndex(pFEA->aValue + pPDat->usMultiOffset,
					       (pPDat->usIndex+1));
		  memmove(szTrash+usSize,    /* Move back the end of the EA */
			  szTrash,
			  pFEA->cbValue-(szTrash-pFEA->aValue));
		  DosSetMem(pFEA->aValue, pFEA->cbValue+usSize, fPERM|PAG_COMMIT);
	       }
	       szTrash=MultiTypeIndex(pFEA->aValue + pPDat->usMultiOffset,
				      pPDat->usIndex);
	       strcpy(szTrash+sizeof(USHORT),szScratch); /* Copy in new val */
	       pFEA->cbValue+=usSize;		   /* Change buffer count   */

	       FILE_CHANGED = TRUE;
	       return(FILE_CHANGED);		      /* Done with m-m edit */
	    }
	    else
	    {
	       FreeMem(pFEA->aValue);		   /* Release old Value mem */
	    }
	 }
	 GetMem((PPVOID)&szNew, strlen(szScratch)+3); /* +3 for Type & NULL */
	 pusPtr = (USHORT *) szNew;
	 *pusPtr= usEAType;			  /* Set type in new buffer */
	 strcpy(szNew+2,szScratch);		   /* Copy in the new value */
	 pFEA->aValue = szNew;			    /* Fix up the structure */
	 pFEA->cbValue= (USHORT)(strlen(szScratch)+3);

	 FILE_CHANGED = TRUE;
	 return(FILE_CHANGED);

      case EA_LPBITMAP:
      case EA_LPICON:
      case EA_LPBINARY:
      case EA_LPASCII:
      case EA_LPMETAFILE:
	 if (usEAType==EA_LPBITMAP || usEAType==EA_LPICON)
	 {
	    WinDlgBox(HWND_DESKTOP,
		      hwnd,
		      IconDlgProc,
		      '\0',
		      IDD_ABOUTBOX,
		      NULL);
	 }
	 if(pPDat->cbMulti)			/* It is a multi-type field */
	 {   /* szTrash points to field to edit, pusPtr to the field length */
	    szTrash=MultiTypeIndex(pFEA->aValue + pPDat->usMultiOffset,
				   pPDat->usIndex);
	    pusPtr = (USHORT *) ((CHAR *) szTrash + sizeof(USHORT));
	    usSize = *pusPtr;
	    if(usSize)				       /* It isn't a new EA */
	    {				    /* Set up inital value for edit */
	       GetMem((PPVOID)&szAscii, usSize+1);
	       memcpy(szAscii,szTrash+2*sizeof(USHORT),usSize);
	       *( ( CHAR *)szAscii + usSize ) ='\0';
	    }
	    else					 /* No inital value */
	       szAscii = '\0';
	 }
	 else if(pFEA->cbValue)	   /* Single type && there is current value */
	 {
	    usSize=GetUSHORT(pFEA,1);	   /* Get size and set inital value */
	    if(usSize)
	    {
	       GetMem((PPVOID)&szTrash, usSize+1);	     /* +1 for null */
	       memcpy(szTrash,pFEA->aValue+4,usSize);
	       szTrash[usSize]='\0';
	       szAscii=szTrash;
	    }
	    else
	       szAscii = '\0';
	 }
	 else
	    szAscii = '\0';

	 if(!WinDlgBox(HWND_DESKTOP,		   /* Do an ascii text edit */
		       hwnd,
		       AsciiEditProc,
		       '\0',
		       IDD_ASCIIEDIT,
		       &PDat))
	 {     /* Cancel, but check if memory needs to be freed before exit */
	    if(pPDat->cbMulti || pFEA->cbValue)
	       if(szAscii)				   /* It's not NULL */
		  FreeMem(szAscii);			     /* +1 for NULL */
	    return(FALSE);
	 }
	 if(PDat.fFlag)				/* Handle the need/nice bit */
	    PDat.fFlag = 0x80;
	 if(PDat.fFlag != (BYTE)(PDat.fFlag & 0x80))
	    FILE_CHANGED = TRUE;
	 pFEA->fEA = (BYTE)((pFEA->fEA & 0x7f) | PDat.fFlag);

	 if(stricmp(strupr(szEAName),pFEA->szName))	/* The name changed */
	    ChangeName(pFEA,szEAName);

	 if(pFEA->cbValue)			/* There is a current value */
	 {
	    if(szAscii && !strcmp(szAscii,szScratch))  /* It hasn't changed */
	    {
	       if(szAscii)
		  FreeMem(szAscii);
	       return(TRUE);
	    }
	    if(szAscii)			       /* Free default value buffer */
	       FreeMem(szAscii);

	    if(pPDat->cbMulti)	   /* Do the whole thing here is multi-type */
	    {						   /* Change in len */
	       USHORT usDelta = (USHORT)(strlen(szScratch) - usSize);
	       if(usDelta > 0)	  /* The new string is longer, resize first */
	       {
		  ResizeMem((PPVOID)&pFEA->aValue, pFEA->cbValue, pFEA->cbValue+usDelta);
		  szTrash= MultiTypeIndex(pFEA->aValue + pPDat->usMultiOffset,
					 (pPDat->usIndex+1));
		  memmove(szTrash+usDelta,szTrash,
			  pFEA->cbValue-(szTrash-pFEA->aValue));
	       }
	       else
	       {
		  szTrash= MultiTypeIndex(pFEA->aValue + pPDat->usMultiOffset,
					 (pPDat->usIndex+1));
		  memmove(szTrash+usDelta,szTrash,
			  pFEA->cbValue-(szTrash-pFEA->aValue));
		  ResizeMem((PPVOID)&pFEA->aValue, pFEA->cbValue+usDelta, fPERM|PAG_COMMIT);
	       }
	       szTrash=MultiTypeIndex(pFEA->aValue + pPDat->usMultiOffset,
				      pPDat->usIndex);
	       memmove(szTrash+2*sizeof(USHORT),szScratch,strlen(szScratch));
	       pusPtr = (USHORT *) ((CHAR *)szTrash + sizeof(USHORT));
	       *pusPtr= strlen(szScratch); /* Set the length field */

	       pFEA->cbValue += usDelta;	 /* Adjust struct len field */

	       FILE_CHANGED = TRUE;
	       return(FILE_CHANGED);
	    }
	    FreeMem(pFEA->aValue);		       /* Free up old value */
	 }
	 GetMem((PPVOID)&szNew, strlen(szScratch)+4); /* Get space for new value */
	 pusPtr = (USHORT *) szNew;
	 *pusPtr= usEAType;				  /* Set type field */
	 pusPtr++;
	 *pusPtr= strlen(szScratch);		/* Set length field */
	 memcpy(szNew+4,szScratch,*pusPtr);	       /* Copy in new value */
	 pFEA->aValue = szNew;				 /* Adjust pointers */
	 pFEA->cbValue= strlen(szScratch)+4;/* +4 for type and LP cnt */

	 FILE_CHANGED = TRUE;
	 return(FILE_CHANGED);

      case EA_MVST:
      case EA_MVMT:			     /* It's multi-value multi-type */
	 if(pFEA->cbValue == 0)				   /* It's a new EA */
	 {					   /* Allocate empty m-m EA */
	    GetMem((PPVOID)&pFEA->aValue, 3*sizeof(USHORT));
	    pFEA->cbValue = 3*sizeof(USHORT);
	    pusPtr	= (USHORT *) pFEA->aValue;
	    if(usEAType == EA_MVMT)
	       *pusPtr = 0xffdf;		 /* Multi-value, multi-type */
	    else
	       *pusPtr = 0xffde;		/* Multi-value, single-type */
	    pusPtr+=2;				     /* Skip type, codepage */
	    *pusPtr = 0;		 /* No fields initially	    */
	    FILE_CHANGED = TRUE;
	 }
						   /* Set up passed in data */
	 if(pPDat->cbMulti)			  /* It's a multi-type job  */
	 {
	    szNew   = MultiTypeIndex(pFEA->aValue + pPDat->usMultiOffset,
				     pPDat->usIndex);
	    szTrash = MultiTypeIndex(pFEA->aValue + pPDat->usMultiOffset,
					   (pPDat->usIndex+1));
	    PDat.usMultiOffset = (USHORT)(szNew - pFEA->aValue);
	    PDat.cbMulti       = (USHORT)(szTrash - szNew);
	 }
	 else
	 {
	    PDat.usMultiOffset = 0;
	    PDat.cbMulti       = pFEA->cbValue;
	 }
	 PDat.Point = (CHAR *) pFEA;

	 WinDlgBox(HWND_DESKTOP,		  /* Do the Multi-type edit */
		   hwnd,
		   MultiTypeProc,
		   '\0',
		   IDD_MULTIBOX,
		   &PDat);
	 return(TRUE);

      default:
	 return(FALSE);
   }
   return(FALSE);
}

/****************************************************************\
 *								*
 *  Name:    EAExists(szEAName)					*
 *								*
 *  Purpose: This routine goes through the linked list pointed	*
 *	     to by global pHoldFEA and determines whether or not*
 *	     an EA othe passed name already exists.		*
 *  Usage:							*
 *  Method : The comparison is NOT case sensitive.		*
 *								*
 *  Returns: TRUE if an EA with a name matching szEAName exists.*
 *								*
\****************************************************************/
BOOL EAExists(CHAR *szEAName)
{
   HOLDFEA *phFEA=pHoldFEA;

   while(phFEA)
   {
      if(!stricmp(szEAName,phFEA->szName))
	 return(TRUE);
      phFEA=phFEA->next;
   }
   return(FALSE);
}

/****************************************************************\
 *								*
 *  Name:    ChangeName(pFEA, szName)				*
 *								*
 *  Purpose: This routine copies the current EA Name to the	*
 *	     delete list, then allocates a new space, copies the*
 *	     new name into it, and sets the FEA pointer to it.	*
 *  Usage :							*
 *  Method : Not all the memory allocations are fully error	*
 *	     trapped.						*
 *								*
 *  Returns: VOID.  Fixes up the pFEA structure and global	*
 *	     pDelList.						*
 *								*
\****************************************************************/
VOID ChangeName(HOLDFEA *pFEA, CHAR *szName)
{
   CHAR *szTemp=NULL;
   DELETELIST *pDL=NULL;

   GetMem((PPVOID)&szTemp, strlen(szName+1));/* Allocate space for new name */
   if(!szTemp)
      return;
					    /* Allocate a new delete struct */
   GetMem((PPVOID)&pDL,	 sizeof(DELETELIST));
   pDL->EAName = pFEA->szName;		       /* Fill in DeleteList struct */
   pDL->next   = pDelList;
   pDelList    = pDL;

   strcpy(szTemp,szName);		   /* Copy name to permanent buffer */
   pFEA->szName = szTemp;		   /* Fix up struct		    */
   pFEA->cbName = (CHAR) strlen(szName);

   FILE_CHANGED = TRUE;
   return;
}

/****************************************************************\
 *								*
 *  Name:    MultiTypeIndex(pMulti, usIndex)			*
 *								*
 *  Purpose: This routine takes a pointer to a Multi-Multi data *
 *	     field and returns a pointer to the nth data field	*
 *	     in this buffer.					*
 *  Usage:							*
 *  Method:  Memory bounds are not checked and a corrupt EA field
 *	     could cause unspecified results. Recursively calls *
 *	     itself to handle nesting. Does not support multi-	*
 *	     value single type fields.				*
 *								*
 *  Returns: a pointer to the field specified by the usIndex	*
 *	     parameters.					*
 *								*
 *  Calls: LookupEAType, MultiTypeIndex()			*
 *								*
\****************************************************************/
CHAR *MultiTypeIndex(CHAR *pMulti, ULONG usIndex)
{
   USHORT *pusPtr;
   USHORT usOffset;
			       /* skip over 0xffdf, codepage, and field cnt */
   pMulti += 3*sizeof(USHORT);

   while(usIndex--)		    /* loop to skip over correct # of flds  */
   {
      pusPtr   = (USHORT *) pMulti;   /* The address of EA data type stored */
      usOffset = LookupEAType(*pusPtr);		/* Get offset of field type */

      pMulti += sizeof(USHORT);	  /* Skip over the type field to first data */

      switch(ConvTable[usOffset].usFldType)
      {
	 case IDD_ASCIIZ:
	    while(*pMulti)		   /* Increment to point after NULL */
		pMulti++;
	    pMulti++;
	    break;

	 case IDD_LPDATA:
	    pusPtr = (USHORT *) pMulti;		/* Get the length of a data */
	    pMulti += *pusPtr + sizeof(USHORT);		     /* skip to end */
	    break;

	 case IDD_MULTILIST:
	    if(*pusPtr == EA_MVMT)  /* m-m, do a recursive call to skip fld */
	    {
	       pusPtr = (USHORT *) pMulti;	     /* points to field cnt */
	       pMulti = MultiTypeIndex(pMulti-sizeof(USHORT),*pusPtr);
	       break;
	    }
	       /* implemented for Multi-valued single-type stuff... */
	    pusPtr = (USHORT *) pMulti;		/* Get the length of a data */
	    pMulti += *pusPtr + sizeof(USHORT);		     /* skip to end */
	    break;
      }
   }
   return(pMulti);
}

/****************************************************************\
 *								*
 *  Name:    EAValueString(aEAVal)				*
 *								*
 *  Purpose: This routine takes a pointer to an EA Value (i.e.	*
 *	     starting with $ffxx) and returns a pointer to a	*
 *	     string representing the value of the EA. This string
 *	     must be Freed by the user when finished with it.	*			   *
 *  Usage:							*
 *  Method : Not all GetMem's are totally error trapped. The    *
 *	     string returned is allocated in this procedure, but*
 *	     it is the caller's responsibility to free the buffer
 *								*
 *  Returns: a pointer to an ASCII description of the field value
 *								*
\****************************************************************/
CHAR *EAValueString(CHAR *aEAVal)
{
   USHORT *pusPtr= (USHORT *) aEAVal;		   /* Points to EA Type	    */
   CHAR *szRet=NULL, *szTemp;			 /* szRet points to return string */

   switch(*pusPtr)
   {
      case EA_ASCIIZ:	  /* For asciiz strings, return MAXSHOWSIZE-1 chars */
      case EA_ASCIIZFN:
      case EA_ASCIIZEA:
      case EA_ASN1:
	 aEAVal += sizeof(USHORT);
	 if(strlen(aEAVal)<MAXSHOWSIZE)
	 {
	    GetMem((PPVOID)&szRet, strlen(aEAVal)+1);
	    strcpy(szRet,aEAVal);
	 }
	 else
	 {
	    GetMem((PPVOID)&szRet, MAXSHOWSIZE);
	    strncpy(szRet,aEAVal,MAXSHOWSIZE-4);
	    strcpy (szRet+MAXSHOWSIZE-4,"...");
	    szRet[MAXSHOWSIZE-1]='\0';
	 }
	 return(szRet);

      case EA_LPASCII:		 /* Display up to first MAXSHOWSIZE-1 chars */
      case EA_LPMETAFILE:
	 pusPtr++;
	 aEAVal += 2*sizeof(USHORT);
	 if(*pusPtr < MAXSHOWSIZE)
	 {
	    GetMem((PPVOID)&szRet, *pusPtr +1);
	    strncpy(szRet,aEAVal,*pusPtr);
	    szRet[*pusPtr]='\0';
	 }
	 else
	 {
	    GetMem((PPVOID)&szRet, MAXSHOWSIZE);
	    strncpy(szRet,aEAVal,MAXSHOWSIZE-4);
	    strcpy (szRet+MAXSHOWSIZE-4,"...");
	    szRet[MAXSHOWSIZE-1]='\0';
	 }
	 return(szRet);
		 /* For the rest of the types, just display the field type */
      case EA_LPBINARY:
	 szTemp = "*** LP Binary ***";
	 break;

      case EA_LPBITMAP:
	 szTemp = "*** LP Bitmap ***";
	 break;

      case EA_LPICON:
	 szTemp = "*** LP Icon ***";
	 break;

      case EA_MVMT:
	 szTemp = "*** Multi-value Multi-type ***";
	 break;

      case EA_MVST:
	 szTemp = "*** Multi-value Single-type ***";
	 break;

      default:
	 szTemp = "*** Unknown EA type ***";
	 break;

   }
   GetMem((PPVOID)&szRet, strlen(szTemp)+1); /* Copy string from static to dynamic */
   strcpy(szRet,szTemp);
   return(szRet);
}

/****************************************************************\
 *								*
 *  Function name: MultiAdd(hwnd, pFEA, pPDat)			*
 *								*
 *  Purpose: This routine is called by MultiTypeProc and handles*
 *	     the addition of a subvalue to a multi-value, multi-*
 *	     type EA.						*
 *  Usage :							*
 *  Method : Not all GetMem's are totally error trapped.  It is *
 *	     possible that the add to the listbox could fail.	*
 *								*
 *  Returns: VOID.  Modifies the current pFEA.			*
 *								*
\****************************************************************/
VOID MultiAdd(HWND hwnd, HOLDFEA *pFEA, PPASSDATA pPDat)
{
   USHORT   usSize, i;
   USHORT   *pusPtr;
   CHAR	    aUtility[6];	/* Used to hold the header for all EA types */
   CHAR	    *pInsert,*pValue;
   PASSDATA PDat;

   PDat.Point = pFEA->szName;
			   /* Check Type Name is in the list of MVST or not */
   for (i=0; i<MSNUM && MSdata[i].szName!=NULL &&
			     strcmp(PDat.Point,MSdata[i].szName)!=0;)
	 i++;

   if(ConvTable[usRetEAType].usPrefix != EA_MVST && i==MSNUM)
   {
     if(!WinDlgBox(HWND_DESKTOP,		   /* Get the name and type */
		   hwnd,
		   AddEAProc,
		   '\0',
		   IDD_ADDEA,
		   &PDat))
	return;						/* They said cancel */
   }
   else			   /* MVST */
   {
     if (i < MSNUM && MSdata[i].szName!=NULL && MSdata[i].usType<10)
	 usRetEAType = MSdata[i].usType;	     /* EAname & type exist */
     else
	if(!WinDlgBox(HWND_DESKTOP,	 /* EAname is new, get the new type */
		      hwnd,
		      AddEAProc,
		      '\0',
		      IDD_ADDEA,
		      &PDat))
	   return;					/* They said cancel */
   }
   pusPtr = (USHORT *) aUtility;
   *pusPtr= ConvTable[usRetEAType].usPrefix;  /* Set the type in header buf */

   switch(ConvTable[usRetEAType].usFldType)
   {
      case IDD_ASCIIZ:		 /* make buffer look like: xx FF 00, size 3 */
	 usSize = 3;
	 aUtility[2]=0;
	 break;

      case IDD_LPDATA:	  /* make the buffer look like: xx FF 00 00, size 4 */
	 usSize = 4;
	 pusPtr = (USHORT *) &aUtility[2];
	 *pusPtr= 0;
	 break;

      case IDD_MULTILIST:
	 usSize = 6;
	 pusPtr = (USHORT *) &aUtility[2];
	 *pusPtr= 0;				       /* Zero out codepage */
	 pusPtr++;
	 *pusPtr= 0;					/* Zero out fld cnt */
	 break;
   }
			       /* Increase EA size to accomodate the header */
   ResizeMem((PPVOID)&pFEA->aValue, pFEA->cbValue, pFEA->cbValue+usSize);

   pusPtr  = (USHORT *) ((CHAR *) pFEA->aValue + pPDat->usMultiOffset);
   pusPtr+=2;		       /* Point to the current number of m-m fields */

	/* Get ptr to beginning of current EA, scoot the rest down and insert
	 the 3-4 byte header at the end of the list.			    */
   pInsert = MultiTypeIndex(pFEA->aValue+pPDat->usMultiOffset, *pusPtr);
   memmove(pInsert+usSize,pInsert, pFEA->cbValue-(pInsert-pFEA->aValue));
   memcpy(pInsert,aUtility,usSize);

   pFEA->cbValue += usSize;			       /* Fix up the counts */
   pPDat->cbMulti+= usSize;
						   /* Set the PDat for call */
   PDat.Point	      = (CHAR *) pFEA;
   PDat.cbMulti	      = pPDat->cbMulti;
   PDat.usMultiOffset = pPDat->usMultiOffset;
   PDat.usIndex	      = *pusPtr;

   if(!EditEAValue(hwnd,&PDat))			  /* They canceled the edit */
   {	      /* Move the EA's back to effectively kill the inserted header */
      memmove(pInsert,pInsert+usSize,pFEA->cbValue-(pInsert-pFEA->aValue));
      DosSetMem(pFEA->aValue, pFEA->cbValue-usSize, fPERM|PAG_COMMIT);
      pFEA->cbValue -= usSize;				 /* Adjust counters */
      pPDat->cbMulti-= usSize;

      return;
   }
	/* Reset pusPtr since EditEAValue could have moved the base address */
   pusPtr  = (USHORT *) ((CHAR *) pFEA->aValue + pPDat->usMultiOffset);
   pusPtr+=2;

   pInsert = MultiTypeIndex(pFEA->aValue+pPDat->usMultiOffset, *pusPtr);

   *pusPtr += 1;		/* Field cnt incremented AFTER call to Edit */

   pValue = EAValueString(pInsert);	   /* Add new field to the list box */

   WinSendDlgItemMsg(hwnd, IDD_LBOX, LM_INSERTITEM,
		     MPFROM2SHORT(LIT_END,0),
		     MPFROMP(pValue));
   FreeMem(pValue);

   FILE_CHANGED = TRUE;
   return;
}
/*static char *SCCSID = "@(#)easfile.c  6.13 92/03/18";*/
/*==============================================================*\
 *								*
 * EASFILE.C							*
 *    (C) Copyright IBM Corporation 1992.			*
 *--------------------------------------------------------------*
 *  This module contains subroutines for eas.c that specifically*
 *  deal with the Open file interface. Most of the routines were*
 *  taken from Charles Petzold's book "Programming the OS/2     *
 *  Presentation Manager" and were slightly modified.           *
 *								*
 *--------------------------------------------------------------*
 *  Procedures in this file:					*
 *   OpenFile()	       Asks user for new file name and opens it *
 *   OpenFileProc()    Dialog proc that prompts user file name	*
 *   FillDirListBox()  Fills the directory list box		*
 *   FillFileListBox() Fills the file list box			*
 *								*
\*==============================================================*/
/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#include "eas.h"

extern EADATA ConvTable[EATABLESIZE];

/****************************************************************\
 *								*
 *  Name:    OpenFile(hwnd, usMode)				*
 *								*
 *  Purpose: This routine handles opening a new file.  It will	*
 *	     also query the user for the disposition of the	*
 *	     current file if it has been modified before loading*
 *	     the new file.					*
 *								*
 *  Usage  : This routine is called by MainDlgProc to deal with *
 *	     the Open file interface.				*
 *								*
 *  Method : Routine should be bullet proof as it does its own	*
 *	     error checking.  It assumes that hwnd points to the*
 *	     correct window with the name listbox in it.	*
 *								*
 *  Returns: TRUE if a file is open upon exit.			*
 *								*
\****************************************************************/
BOOL OpenFile(HWND hwnd, ULONG usMode)
{
   CHAR szOldFile[CCHMAXPATH];
   HFILE  FileHandle=0;
   ULONG  ulAct=0L;

   strcpy(szOldFile,szFileName);  /* Save name of the currently open file */

   if(usMode != ARGFILE)		/* It isn't the command line file */
   {
      if(!WinDlgBox(HWND_DESKTOP,      /* Get the file name from the user */
		    hwnd,
		    OpenFileProc,
		    '\0',
		    IDD_OPENBOX,
		    NULL))
      {
	 strcpy(szFileName,szOldFile); /* They canceled, restore old file */
	 return(FILE_ISOPEN);
      }
   }
			     /* Check filename availble or not */
   if( DosOpen(szFileName, &FileHandle, &ulAct, 0L, FILE_NORMAL,
			FILE_OPEN, OPEN_SHARE_DENYWRITE, NULL) )
   {
      MessageBox(hwnd, IDMSG_ERRORFILEOPEN, "Error !",
		       MB_OK | MB_ERROR, TRUE);
      return(FILE_ISOPEN);
   }
   else			/* File is existed and availble to use */
      DosClose(FileHandle);

   if(FILE_ISOPEN) /* Free up everything associated with the current file */
   {
      Free_FEAList(pHoldFEA,pDelList);
      FILE_ISOPEN = FALSE;
   }

   if(QueryEAs(szFileName))			    /* We were successful */
   {
      HOLDFEA *pFEA=pHoldFEA;

      FILE_ISOPEN = TRUE;
      FILE_CHANGED = FALSE;

      WinSendDlgItemMsg(hwnd, IDD_WINLBOX, LM_DELETEALL,0L,0L); /* Fill L-box */

      while(pFEA)
      {
	 WinSendDlgItemMsg(hwnd, IDD_WINLBOX, LM_INSERTITEM,
			   MPFROM2SHORT(LIT_END,0),
			   MPFROMP(pFEA->szName));
	 pFEA = pFEA->next;
      }
   }
   else					     /* We couldn't query the EAs */
   {
      *szFileName = '\000';
      memset(szEAType, 0, sizeof(szEAType) );
      WinInvalidateRect(hwndMain, NULL, FALSE);
      FILE_ISOPEN = FALSE;
      return (FILE_ISOPEN);
   }
   memset(szEAType, 0, sizeof(szEAType) );
   WinInvalidateRect(hwndMain, NULL, FALSE);
   pDelList = NULL;
   return(TRUE);
}

/****************************************************************\
 *								*
 *  Name:    OpenFileProc(hwnd, msg, mp1, mp2)			*
 *								*
 *  Purpose: This proc handles the user interface to select a	*
 *	     file name. Some elementary checks are done to make *
 *	     sure the filename is valid.			*
 *								*
 *  Usage  : This routine is called by OpenFile to open the file*
 *								*
 *  Method : The interface is NOT foolproof as it is possible to*
 *	     continue with a non-existant file name.  Also,	*
 *	     users are not currently allowed to view/edit the	*
 *	     EAs attached to a directory.			*
 *								*
 *  Returns: TRUE if selects OK, FALSE if Cancel is selected.	*
 *								*
\****************************************************************/
MRESULT EXPENTRY OpenFileProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   static CHAR szCurrentPath[CCHMAXPATH]={'.', '\\', '*', '\000'},
		szBuffer[CCHMAXPATH];
   CHAR	       szParsedPath[CCHMAXPATH];
   SHORT       sSelect;
   MRESULT sRC;

   switch(msg)
   {
      case WM_INITDLG:
	 FixSysMenu(hwnd);
	 FillDirListBox(hwnd,szCurrentPath);
	 FillFileListBox(hwnd);
	 WinSendDlgItemMsg(hwnd, IDD_FILEEDIT,EM_SETTEXTLIMIT,
				 MPFROM2SHORT(CCHMAXPATH,0),NULL);
	 return (MRESULT)0L;

      case WM_CONTROL:			    /* An lbox item is selected */
	 if(SHORT1FROMMP(mp1) == IDD_DIRLIST ||
	    SHORT1FROMMP(mp1) == IDD_FILELIST)
	 {					  /* Get item->szBuffer */
	    sSelect = (USHORT) WinSendDlgItemMsg(hwnd,
			       SHORT1FROMMP(mp1),
			       LM_QUERYSELECTION, 0L, 0L);

	    WinSendDlgItemMsg(hwnd, SHORT1FROMMP(mp1),
			      LM_QUERYITEMTEXT,
			      MPFROM2SHORT(sSelect, sizeof(szBuffer)),
			      MPFROMP(szBuffer));
	 }

	 switch(SHORT1FROMMP(mp1))
	 {
	    case IDD_DIRLIST:	       /* Item was in the directory lbox */
	       switch(SHORT2FROMMP(mp1))
	       {
		  case LN_ENTER:	   /* Go to the select drive/dir */
		     if(*szBuffer == ' ')
			DosSelectDisk(*(szBuffer+1) - '@');
		     else
			DosSetCurrentDir(szBuffer);

		     FillDirListBox(hwnd, szCurrentPath);
		     FillFileListBox(hwnd);

		     WinSetDlgItemText(hwnd, IDD_FILEEDIT, "");
		     return (MRESULT)0L;
	       }
	       break;

	    case IDD_FILELIST:		   /* Item was in the file lbox */
	       switch(SHORT2FROMMP(mp1))
	       {
		  case LN_SELECT:	   /* Copy name to entry field	*/
		     WinSetDlgItemText(hwnd, IDD_FILEEDIT, szBuffer);
		     return (MRESULT)0L;

		  case LN_ENTER:	      /* Try to query the file */
		     if(ParseFileName(szFileName, szBuffer) != FILE_VALID)
			return 0;	   /* Some error, don't finish */
		     WinDismissDlg(hwnd, TRUE);
		     return (MRESULT)0L;
	       }
	       break;
	 }
	 break;

      case WM_COMMAND:
	 switch(LOUSHORT(mp1))
	 {
	    case DID_OK:       /* Try to query file in the entry field */
	       memset(szBuffer, 0, sizeof(szBuffer) );
	       WinQueryDlgItemText(hwnd, IDD_FILEEDIT,
				   sizeof(szBuffer), szBuffer);
					 /* Check filename availble or not */
	       if(*szBuffer == '\000')
	       {
		  MessageBox(hwnd, IDMSG_NOFILEOPEN, "Error !",
				   MB_OK | MB_ERROR, TRUE);
		  return FALSE;
	       }
	       switch(ParseFileName(szParsedPath, szBuffer))
	       {
		  case FILE_INVALID:		/* Can't open the file */
		     WinAlarm(HWND_DESKTOP, WA_ERROR);
		     FillDirListBox(hwnd, szCurrentPath);
		     FillFileListBox(hwnd);
		     return (MRESULT)0L;

		  case FILE_PATH:    /* It was an incomplete path name */
		     strcpy(szCurrentPath,szBuffer);
		     FillDirListBox(hwnd, szCurrentPath);
		     FillFileListBox(hwnd);
		     WinSetDlgItemText(hwnd, IDD_FILEEDIT, "");
		     return (MRESULT)0L;

		  case FILE_VALID:		       /* It was valid */
		     strcpy(szFileName, szParsedPath);
		     WinDismissDlg(hwnd, TRUE);
		     return (MRESULT)0L;
	       }
	       break;

	    case DID_CANCEL:
	       WinDismissDlg(hwnd, FALSE);
	       return (MRESULT)0L;
	 }
	 break;

      case WM_CLOSE:
	 WinDismissDlg(hwnd, FALSE);
	 return (MRESULT)0L;

   }
   sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
   return sRC;
}

/****************************************************************\
 *								*
 *  Name:    FillDirListBox(hwnd, pcCurrentPath)		*
 *								*
 *  Purpose: This routine is called by OpenFileProc to fill in	*
 *	     the directory list box				*
 *								*
 *  Usage  : This routine is called by OpenFileProc to fill the *
 *	     file list box.					*
 *								*
 *  Method : Adequete error checking is NOT done on the return	*
 *	     values of the system calls.  Also, it is remotely	*
 *	     possible that the calls to add to the list box	*
 *	     could fail.					*
 *								*
 *  Returns: VOID						*
 *								*
\* **************************************************************/
VOID FillDirListBox(HWND hwnd, CHAR *pcCurrentPath)
{
   static CHAR szDrive [] = "  :";
   FILEFINDBUF3 findbuf;
   HDIR	       hDir = HDIR_CREATE;
   SHORT       sDrive;
   ULONG       ulCurPathLen, ulDriveMap=0L, ulSearchCount = 1, ulDriveNum=0L;

   memset(&findbuf,0,sizeof(FILEFINDBUF) );

   DosQueryCurrentDisk(&ulDriveNum, &ulDriveMap);
   *pcCurrentPath     = (CHAR) (ulDriveNum + '@');
   *(pcCurrentPath+1) = ':';
   *(pcCurrentPath+2) = '\\';
   ulCurPathLen = CCHMAXPATH;
   DosQueryCurrentDir(0L, pcCurrentPath + 3, &ulCurPathLen);

   WinSetDlgItemText(hwnd, IDD_PATH, pcCurrentPath);
   WinSendDlgItemMsg(hwnd, IDD_DIRLIST, LM_DELETEALL, NULL, NULL);

   for(sDrive = ('A'-'A'); sDrive <= ('Z'-'A'); sDrive++)
   {
      if(ulDriveMap & (1L << sDrive))
      {
	 *(szDrive+1) = (CHAR) (sDrive + 'A');

	 WinSendDlgItemMsg(hwnd, IDD_DIRLIST, LM_INSERTITEM,
			   MPFROM2SHORT(LIT_END, 0),
			   MPFROMP(szDrive));
      }
   }
   if (DosFindFirst("*", &hDir, FILE_DIRECTORY, &findbuf,
		sizeof(findbuf), &ulSearchCount, FIL_STANDARD))
   {
      DosBeep(500,110);
      return;
   }
   while(ulSearchCount)
   {
      if(findbuf.attrFile & 0x0010 &&
	 (findbuf.achName[0] != '.' || findbuf.achName[1]))

	 WinSendDlgItemMsg(hwnd, IDD_DIRLIST, LM_INSERTITEM,
			   MPFROM2SHORT(LIT_SORTASCENDING, 0),
			   MPFROMP(findbuf.achName));

      if(DosFindNext(hDir, &findbuf, sizeof(findbuf), &ulSearchCount))
	 break;
   }
   return;
}

/****************************************************************\
 *								*
 *  Name:    FillFileListBox(hwnd)				*
 *								*
 *  Purpose: This routine is called by OpenFileProc to fill in	*
 *	     the file list box with files in the current	*
 *	     directory.						*
 *								*
 *  Usage  : This routine is called by OpenFileProc to fill the *
 *	     file list box.					*
 *								*
 *  Method : Adequete error checking is NOT done on the return	*
 *	     values of the system calls.  Also, it is remotely	*
 *	     possible that the calls to add to the list box	*
 *	     could fail.					*
 *								*
 *  Returns: VOID						*
 *								*
\****************************************************************/
VOID FillFileListBox(HWND hwnd)
{
   FILEFINDBUF3 findbuf;
   HDIR	       hDir = HDIR_CREATE;
   ULONG       ulSearchCount = 1; /* Read 1 entry at a time */

   memset(&findbuf,0,sizeof(FILEFINDBUF) );
   WinSendDlgItemMsg(hwnd, IDD_FILELIST, LM_DELETEALL, NULL, NULL);

   if (DosFindFirst("*", &hDir, FILE_NORMAL, &findbuf, sizeof(findbuf),
		       &ulSearchCount,FIL_STANDARD))
   {
      DosBeep(700,110);
      return;
   }
   while(ulSearchCount)
   {
      WinSendDlgItemMsg(hwnd, IDD_FILELIST, LM_INSERTITEM,
			MPFROM2SHORT(LIT_SORTASCENDING, 0),
			MPFROMP(findbuf.achName));

      if(DosFindNext(hDir, &findbuf, sizeof(findbuf), &ulSearchCount))
	 break;
   }
   return;
}

/****************************************************************\
 *								*
 *  Name:    ParseFileName(pcOut, pcIn)				*
 *								*
 *  Purpose: This routine changes drive and directory as per	*
 *	     pcIn string.					*
 *								*
 *  Usage:   Note that pcOut is only valid if FILE_VALID is	*
 *	     returned. In place of strupr(), a codepage should	*
 *	     be fetched and DosCaseMap() should be used to allow*
 *	     for extended chars. This routine could use some	*
 *	     cleanup work.					*
 *								*
 *  Returns: FILE_INVALID if pcIn had invalid drive or no	*
 *			     directory				*
 *	     FILE_PATH	  if pcIn was empty or had just a path/ *
 *			     no file name.			*
 *	     FILE_VALID	  if pcIn point to good file.		*
 *								*
\****************************************************************/
LONG ParseFileName(CHAR *pcOut, CHAR *pcIn)
{
   CHAR	  *pcLastSlash, *pcFileOnly ;
   ULONG  ulDriveMap, ulDirLen = CCHMAXPATH, ulDriveNum=0L;

   strupr(pcIn);   /* Does NOT handle extended chars, should use DosCaseMap */

   if(*pcIn == '\000')		    /* If string is empty, return FILE_PATH */

      return FILE_PATH;

			/* Get drive from input string or use current drive */
   if(*(pcIn+1) == ':')			     /* Yup, they specified a drive */
   {
      if(DosSelectDisk(*pcIn - '@'))		/* Change to selected drive */
	 return FILE_INVALID;
      pcIn += 2;
   }
   DosQueryCurrentDisk(&ulDriveNum, &ulDriveMap);      /* Get current drive */
   *pcOut++ = (CHAR) (ulDriveNum + '@');	      /* Build drive letter */
   *pcOut++ = ':';
   *pcOut++ = '\\';

   if(*pcIn == '\000')	/* If rest of the string is empty, return FILE_PATH */
      return FILE_PATH;

       /* Search for the last backslash.  If none, it could be a directory. */
   if(!(pcLastSlash = strrchr(pcIn, '\\')))		     /* No slashes? */
   {
      if(!DosSetCurrentDir(pcIn))
	 return FILE_PATH;			      /* It was a directory */
				       /* Get current dir & attach input fn */
      DosQueryCurrentDir(0L, pcOut, &ulDirLen);

      if(*(pcOut+strlen(pcOut)-1) != '\\')
	 strcat(pcOut++, "\\");

      strcat(pcOut, pcIn);
      return FILE_VALID;
   }
	       /* If the only backslash is at the beginning, change to root */
   if(pcIn == pcLastSlash)
   {
      DosSetCurrentDir("\\");

      if(*(pcIn+1) == '\000')
	 return FILE_PATH;

      strcpy(pcOut, pcIn+1);
      return FILE_VALID;
   }
		   /* Attempt to change directory -- Get current dir if OK */
  *pcLastSlash = '\0';

   if(DosSetCurrentDir(pcIn))
      return FILE_INVALID;

   DosQueryCurrentDir(0L, pcOut, &ulDirLen);
					    /* Append input filename if any */
   pcFileOnly = pcLastSlash+1;

   if(*pcFileOnly == '\000')
      return FILE_PATH;

   if(*(pcOut+strlen(pcOut)-1) != '\\')
      strcat(pcOut++, "\\");

   strcat(pcOut, pcFileOnly);
   return FILE_VALID;
}
/*static char *SCCSID = "@(#)eashelp.c  6.10 92/02/18";*/
/*==============================================================*\
 *  EASHELP.C - routines for help information			*
 *	(C) Copyright IBM Corporation 1992.			*
 *--------------------------------------------------------------*
 *								*
 *  This module contains all the routines for interfacing with	*
 *  the IPF help manager.					*
 *								*
 *--------------------------------------------------------------*
 *								*
 *  This source file contains the following functions:		*
 *								*
 *	    InitHelp()						*
 *	    HelpHelpForHelp(mp2)				*
 *	    HelpExtended(mp2)					*
 *	    HelpKeys(mp2)					*
 *	    HelpIndex(mp2)					*
 *	    HelpAbout(mp2)					*
 *	    DisplayHelpPanel(idPanel)				*
 *	    DestroyHelpInstance(VOID)				*
 *	    AboutDlgProc(hwnd, msg, mp1, mp2)			*
 *	    FixSysMenu()					*
 *								*
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#include "eas.h"

static HWND hwndHelpInstance;
static CHAR szLibName[HELPLIBRARYNAMELEN];
static CHAR szWindowTitle[HELPLIBRARYNAMELEN];
BOOL   fHelpEnabled;		    /* flag to determine if help is enabled */
/****************************************************************\
 *  Routine for initializing the help manager
 *--------------------------------------------------------------
 *
 *  Name:    InitHelp()
 *
 *  Purpose: Initializes the IPF help facility
 *
 *  Usage:   Called once during initialization of the program
 *
 *  Method:  Initializes the HELPINIT structure and creates the help
 *	     instance. If successful, the help instance is associated
 *	     with the main window
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID InitHelp(VOID)
{
   HELPINIT hini;

    /* If we return because of an error, Help will be disabled */
   fHelpEnabled = FALSE;
			     /* Initialize help init structure */
   hini.cb = sizeof(HELPINIT);
   hini.ulReturnCode = 0;
			   /* If tutorial added, add name here */
   hini.pszTutorialName = (PSZ)NULL;

   hini.phtHelpTable = (PHELPTABLE)MAKELONG(EAS_HELP_TABLE, 0xFFFF);
   hini.hmodHelpTableModule = 0;
   hini.hmodAccelActionBarModule = 0;
   hini.idAccelTable = 0;
   hini.idActionBar = 0;

   if(!WinLoadString(hab,
		     0,
		     IDS_HELPWINDOWTITLE,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szWindowTitle))
   {
       MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, "Error !",
			     MB_OK | MB_ERROR, TRUE);
       return;
   }
   hini.pszHelpWindowTitle = (PSZ)szWindowTitle;

		   /* If debugging, show panel ids, else don't */
#ifdef DEBUG
   hini.fShowPanelId = CMIC_SHOW_PANEL_ID;
#else
   hini.fShowPanelId = CMIC_HIDE_PANEL_ID;
#endif

   if(!WinLoadString(hab,
		     0,
		     IDS_HELPLIBRARYNAME,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szLibName))
   {
       MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, "Error !",
			     MB_OK | MB_ERROR, TRUE);
       return;
   }
   hini.pszHelpLibraryName = (PSZ)szLibName;
				     /* Creating help instance */
   hwndHelpInstance = WinCreateHelpInstance(hab, &hini);

   if(hwndHelpInstance == 0L || hini.ulReturnCode)
   {
       MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, "Error !",
				    MB_OK | MB_ERROR, TRUE);
       return;
   }
		    /* Associate help instance with main frame */
   if(!WinAssociateHelpInstance(hwndHelpInstance, hwndMainFrame))
   {
       MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, "Error !",
				 MB_OK | MB_ERROR, TRUE);
       return;
   }
   /* Help manager is successfully initialized so set flag to TRUE */
   fHelpEnabled = TRUE;
   return;
}						  /* InitHelp() */

/****************************************************************\
 *  Processes the Help for Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpHelpForHelp(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Help for
 *	     Help item of the Help menu
 *
 *  Usage:   Called from MainCommand when the Help for Help menu item
 *	     is selected
 *
 *  Method:  Sends an HM_DISPLAY_HELP message to the help instance so
 *	     that the default Help For Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpHelpForHelp(MPARAM mp2)
{
	  /* This just displays the system help for help panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_DISPLAY_HELP,(MPARAM)0,(MPARAM)0))
	   MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, "Error !",
		      MB_OK | MB_ERROR, TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.					   */
   return;
}					  /* HelpHelpForHelp() */

/****************************************************************\
 *  Processes the Extended Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpExtended(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Extended
 *	     Help item of the Help menu.
 *
 *  Usage:   Called from MainCommand when the Extended Help menu item
 *	     is selected.
 *
 *  Method:  Sends an HM_EXT_HELP message to the help instance so that
 *	     the default Extended Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpExtended(MPARAM mp2)
{
	  /* This just displays the system extended help panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_EXT_HELP,(MPARAM)0L,(MPARAM)0L))
	   MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, "Error !",
		      MB_OK | MB_ERROR, TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.					   */
   return;
}					      /* HelpExtended() */

/****************************************************************\
 *  Processes the Keys Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpKeys(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Keys Help
 *	     item of the Help menu.
 *
 *  Usage:   Called from MainCommand when the Keys Help menu item is
 *	     selected
 *
 *  Method:  Sends an HM_KEYS_HELP message to the help instance so that
 *	     the default Keys Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpKeys(MPARAM mp2)
{
	      /* This just displays the system keys help panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_KEYS_HELP,(MPARAM)0L,(MPARAM)0L))
	  MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, "Error !",
		      MB_OK | MB_ERROR, TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.					   */
   return;
}						  /* HelpKeys() */

/****************************************************************\
 *  Processes the Index Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpIndex(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Index Help
 *	     item of the Help menu
 *
 *  Usage:   Called from MainCommand when the Index Help menu item
 *	     is selected
 *
 *  Method:  Sends an HM_INDEX_HELP message to the help instance so
 *	     that the default Index Help is displayed.
 *
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpIndex(MPARAM mp2)
{
	     /* This just displays the system help index panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_HELP_INDEX,(MPARAM)0L,(MPARAM)0L))
	   MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, "Error !",
		      MB_OK | MB_ERROR, TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.					   */
   return;
}						 /* HelpIndex() */

/****************************************************************\
 *  Processes the About command from the Help menu
 *--------------------------------------------------------------
 *
 *  Name:    HelpAbout(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the About item
 *	     of the Help menu
 *
 *  Usage:   Called from MainCommand when the About menu item is selected
 *
 *  Method:  Calls WinDlgBox to display the about box dialog.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpAbout(MPARAM mp2)
{
				 /* Display the AboutBox dialog */
   WinDlgBox(HWND_DESKTOP,
		hwndMain,
		AboutDlgProc,
		(HMODULE)0,
		IDD_PRODUCTINFO,
		NULL);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.					   */
   return;
}						 /* HelpAbout() */

/****************************************************************\
 *  Displays the help panel indicated
 *--------------------------------------------------------------
 *
 *  Name:    DisplayHelpPanel(idPanel)
 *
 *  Purpose: Displays the help panel whose id is given
 *
 *  Usage:   Called whenever a help panel is desired to be displayed,
 *	     usually from the WM_HELP processing of the dialog boxes
 *
 *  Method:  Sends HM_DISPLAY_HELP message to the help instance
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID DisplayHelpPanel(LONG idPanel)
{
   if(fHelpEnabled)
       if((LONG)WinSendMsg(hwndHelpInstance,
		     HM_DISPLAY_HELP,
		     MPFROMLONG(MAKELONG(idPanel, NULL)),
		     MPFROMSHORT(HM_RESOURCEID)))

	   MessageBox(hwndMainFrame, IDMSG_HELPDISPLAYERROR, "Error !",
		      MB_OK | MB_ERROR, TRUE);
   return;
}					  /* DisplayHelpPanel() */

/****************************************************************\
 *  Destroys the help instance
 *--------------------------------------------------------------
 *
 *  Name:    DestroyHelpInstance(VOID)
 *
 *  Purpose: Destroys the help instance for the application
 *
 *  Usage:   Called after exit from message loop
 *
 *  Method:  Calls WinDestroyHelpInstance() to destroy the help instance
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID DestroyHelpInstance(VOID)
{
   if(hwndHelpInstance != 0L)
   {
      WinDestroyHelpInstance(hwndHelpInstance);
   }
   return;
}				       /* DestroyHelpInstance() */

/****************************************************************\
 *
 * Name:    AboutDlgProc(hwnd, msg, mp1, mp2)
 *
 * Purpose: Handles all the messages associated with the About dialog.
 *
 * Usage:   Called from HelpAbout() when about menu be selected.
 *
 * Returns:
 *
\****************************************************************/
MRESULT EXPENTRY AboutDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   MRESULT sRC;

   switch(msg)
   {
      case WM_INITDLG:
	 FixSysMenu(hwnd);
	 return (MRESULT)0L;

      case WM_COMMAND:
	 WinDismissDlg(hwnd, TRUE);
	 return (MRESULT)0L;

      default:
	 sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
	 return sRC;
   }
   return (MRESULT)0L;
}

/****************************************************************\
 * Name:    FixSysMenu()					 *
 *								 *
 * Purpose: This routine removes the Restore, Size, Minimize, and*
 *	    Maximize options from the system menu of a dialog.	 *
 *								 *
 * Usage  : Called during the WM_INITDLG of a dialog procedure.	 *
 *								 *
 * Returns: VOID						 *
 *								 *
\****************************************************************/
VOID FixSysMenu(HWND hwndDlg)
{
   HWND hwndMenu;				    /* handle to system menu */

   hwndMenu = WinWindowFromID(hwndDlg, FID_SYSMENU);

   WinSendMsg(hwndMenu,		      /* delete Restore from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_RESTORE, TRUE),
	      MPFROMP(NULL));

   WinSendMsg(hwndMenu,			 /* delete Size from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_SIZE, TRUE),
	      MPFROMP(NULL));

   WinSendMsg(hwndMenu,		     /* delete Minimize from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_MINIMIZE, TRUE),
	      MPFROMP(NULL));

   WinSendMsg(hwndMenu,		     /* delete Maximize from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_MAXIMIZE, TRUE),
	      MPFROMP(NULL));
   return;
}
/*static char *SCCSID = "@(#)easinit.c  6.5 92/02/18";*/
/*==============================================================*\
 *  EASINIT.C - routines for initialization and exit processing *
 *	(C) Copyright IBM Corporation 1992.			*
 *--------------------------------------------------------------*
 *								*
 *  This module contains the code for application initialization*
 *  as well as the code for exit list processing		*
 *								*
 *--------------------------------------------------------------*
 *								*
 *  This source file contains the following functions:		*
 *								*
 *	Init() - initialization routines			*
 *	ExitProc(usTermCode) - exit list processing procedure	*
 *								*
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#include "eas.h"

/****************************************************************\
 *  Initialization routine					*
 *--------------------------------------------------------------*
 *								*
 *  Name:    Init()						*
 *								*
 *  Purpose: Performs initialization functions required before	*
 *	     the main window can be created.			*
 *								*
 *  Usage:   Called once before the main window is created.	*
 *								*
 *  Method:  - installs the routine ExitProc into the		*
 *		DosExitList chain				*
 *	     - registers all window classes			*
 *	     - performs any command line processing		*
 *								*
 *  Returns: TRUE - initialization is successful		*
 *	     FALSE - initialization failed			*
 *								*
\****************************************************************/
BOOL Init(VOID)
{
    /* Add ExitProc to the exit list to handle the exit processing */
    if(DosExitList(EXLST_ADD, ExitProc))
    {
	return FALSE;
    }
		       /* load application name from resource file */
    if(!WinLoadString(hab, (HMODULE)0, IDS_APPNAME, MAXAPPNAMELEN, szAppName))
	return FALSE;
    if(!WinLoadString(hab, 0, IDS_UNTITLED, MESSAGELEN, szUntitled))
	return FALSE;
			  /* register the main client window class */
    if(WinRegisterClass(hab,
			(PSZ)szAppName,
			(PFNWP)MainWndProc,
			CS_SIZEREDRAW | CS_SYNCPAINT | CS_CLIPCHILDREN,
			0) == 0)
	return FALSE;

    /* Turn off hard-error popup after GP-FAULT. No return codes
       checked as it is cosmetic and if it doesn't work the only side
       effect will be to have the default hard-error popup show up. */

    return TRUE;
}							  /* Init() */

/****************************************************************\
 *  Exit list processing procedure				*
 *--------------------------------------------------------------*
 *								*
 *  Name:    ExitProc(usTermCode)				*
 *								*
 *  Purpose: Cleans up certain resources when the application	*
 *	     terminates						*
 *								*
 *  Usage:   Routine is called by DosExitList when the		*
 *	     application exits					*
 *								*
 *  Method:  global resources, such as the main window and	*
 *	     message queue, are destroyed and any system	*
 *	     resources used are freed				*
 *								*
 *  Returns: Returns EXLST_EXIT to the DosExitList handler	*
 *								*
\****************************************************************/
VOID APIENTRY ExitProc(ULONG usTermCode)
				  /* code for the reason for termination */
{
   WinDestroyWindow(hwndMainFrame);
   /*--------------------------------------------------*\
    *	   Any other system resources used	       *
    *	   (e.g. memory or files) should be freed here *
   \*--------------------------------------------------*/
   WinDestroyMsgQueue(hmq);

   WinTerminate(hab);

   DosExitList(EXLST_EXIT, (PFNEXITLIST)0L);	/* termination complete */

   /* This routine currently doesn't use the usTermCode parameter so *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'  *
   \*  warning at compile time					     */

   return;
}							   /* ExitProc() */
/**************************************************************************
 *  File name  :  edit.c
 *
 *  Description:  This module reserves paths for code for the WM_COMMAND
 *		  messages posted by the standard edit menu.
 *
 *		  This source file contains the following functions:
 *
 *		  EditUndo(mp2)
 *		  EditCut(mp2)
 *		  EditCopy(mp2)
 *		  EditPaste(mp2)
 *		  EditClear(mp2)
 *
 *  Concepts   :  clipboard
 *
 *  API's      :  [none]
 *
 *  Required
 *    Files    :  OS2.H, MAIN.H, XTRN.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *  Include files, macros, defined constants, and externs
 */

#include <os2.h>
#include "main.h"
#include "xtrn.h"

/*
 *  Global variables
 */

/*
 *  Entry point declarations
 */

/**************************************************************************
 *
 *  Name       : EditUndo(mp2)
 *
 *  Description: Processes selection of the Undo choice of the Edit
 *		 pulldown
 *
 *  Concepts:  called whenever Undo from the Edit menu is selected
 *
 *  API's      :  [none]
 *
 *  Parameters :  mp2	   = second message parameter
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID EditUndo(MPARAM mp2)
{
    /* This routine currently doesn't use the mp2 parameter but
     *	it is referenced here to prevent an 'Unreferenced Parameter'
     *	warning at compile time.
     */
    mp2;
}   /* End of EditUndo	 */

/**************************************************************************
 *
 *  Name       : EditCut(mp2)
 *
 *  Description: Processes selection of the Cut choice of the Edit
 *		 pulldown
 *
 *  Concepts:  called whenever Cut from the Edit menu is selected
 *
 *  API's      :  [none]
 *
 *  Parameters :  mp2	   = second message parameter
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID EditCut(MPARAM mp2)
{
    /* This routine currently doesn't use the mp2 parameter but
     *	it is referenced here to prevent an 'Unreferenced Parameter'
     *	warning at compile time.
     */
    mp2;
}   /* End of EditCut	*/

/**************************************************************************
 *
 *  Name       : EditCopy(mp2)
 *
 *  Description: Processes selection of the Copy choice of the Edit
 *		 pulldown
 *
 *  Concepts:  called whenever Copy from the Edit menu is selected
 *
 *  API's      :  [none]
 *
 *  Parameters :  mp2	   = second message parameter
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID EditCopy(MPARAM mp2)
{
    /* This routine currently doesn't use the mp2 parameter but
     *	it is referenced here to prevent an 'Unreferenced Parameter'
     *	warning at compile time.
     */
    mp2;
}   /* End of EditCopy	 */

/**************************************************************************
 *
 *  Name       : EditPaste(mp2)
 *
 *  Description: Processes selection of the Paste choice of the Edit
 *		 pulldown
 *
 *  Concepts:  called whenever Paste from the Edit menu is selected
 *
 *  API's      :  [none]
 *
 *  Parameters :  mp2	   = second message parameter
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID EditPaste(MPARAM mp2)
{
    /* This routine currently doesn't use the mp2 parameter but
     *	it is referenced here to prevent an 'Unreferenced Parameter'
     *	warning at compile time.
     */
    mp2;
}   /* End of EditPaste	   */

/**************************************************************************
 *
 *  Name       : EditClear(mp2)
 *
 *  Description: Processes selection of the Clear choice of the Edit
 *		 pulldown
 *
 *  Concepts:  called whenever Clear from the Edit menu is selected
 *
 *  API's      :  [none]
 *
 *  Parameters :  mp2	   = second message parameter
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID EditClear(MPARAM mp2)
{
    /* This routine currently doesn't use the mp2 parameter but
     *	it is referenced here to prevent an 'Unreferenced Parameter'
     *	warning at compile time.
     */
    mp2;
}   /* End of EditClear	  */
/***************************  End of edit.c  ****************************/
#ifndef lint
static char *sccsid = "@(#)ep.c 1.3 1/22/92 16:08:42 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define envProcessor_Class_Source

#include <stdlib.h>

#include "helper.h"
#include "tpword.h"
#include "page.h"

#include "txtep.h"
#include "header.h"
#include "footer.h"
#include "ipep.h"
#include "blep.h"

#include "ep.ih"

/* ************************************************************ */
SOM_Scope void SOMLINK epInit1(envProcessor * somSelf,
				envProcessor * lastEnv)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessorMethodDebug("envProcessor", "epInit1");

    _previousEnv = lastEnv;
    _thisFile = _epGetFileMgr(_previousEnv);
    _thisPage = _epGetPage(_previousEnv);

}

/* ************************************************************ */
SOM_Scope void SOMLINK epProcessEnvironment(envProcessor * somSelf)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessorMethodDebug("envProcessor", "epProcessEnvironment");
    shouldHaveOverridden(somSelf, "epProcessEnvironment");
}

/* ************************************************************ */
SOM_Scope void SOMLINK epStartUpNewEnvironment(envProcessor * somSelf,
						TPWord * envName)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessor *nextEnv;
    envProcessorMethodDebug("envProcessor", "epStartUpNewEnvironment");

    if (_match(envName, "[[standard_text]]")) {
	nextEnv = txtEnvProcessorNew();
	_epInit1(nextEnv, somSelf);
    }
    else if (_match(envName, "[[header]]")) {
	nextEnv = headerNew();
	_epInit1(nextEnv, somSelf);
    }
    else if (_match(envName, "[[footer]]")) {
	nextEnv = footerNew();
	_epInit1(nextEnv, somSelf);
    }
    else if (_match(envName, "[[standard_text]]")) {
	nextEnv = txtEnvProcessorNew();
	_epInit1(nextEnv, somSelf);
    }
    else if (_match(envName, "[[indent_paragraphs]]")) {
	nextEnv = indentedParagraphsNew();
	_epInit1(nextEnv, somSelf);
    }
    else if (_match(envName, "[[bulleted_list]]")) {
	nextEnv = bulletedListNew();
	_epInit1(nextEnv, somSelf);
    }
    else {
	printf("Unknown environment: ");
	_print(envName, stdout);
	exit(2);
    }

    _epPrepareForNewEnvironment(somSelf);
    _epProcessEnvironment(nextEnv);
    _somFree(nextEnv);
}

/* ************************************************************ */
SOM_Scope void SOMLINK epInitializeEnvironment(envProcessor * somSelf)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessorMethodDebug("envProcessor", "epInitializeEnvironment");
}

/* ************************************************************ */
SOM_Scope void SOMLINK epShutdownEnvironment(envProcessor * somSelf)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessorMethodDebug("envProcessor", "epShutdownEnvironment");
}

/* ************************************************************ */
SOM_Scope void SOMLINK epPrepareForNewEnvironment(envProcessor * somSelf)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessorMethodDebug("envProcessor", "epPrepareForNewEnvironment");
}

/* ************************************************************ */
SOM_Scope int SOMLINK epGetParagraphIndentation(envProcessor * somSelf)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessorMethodDebug("envProcessor", "epGetParagraphIndentation");
    return (0);
}

/* ************************************************************ */
SOM_Scope int SOMLINK epGetLineIndentation(envProcessor * somSelf)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessorMethodDebug("envProcessor", "epGetLineIndentation");
    return (0);
}

/* ************************************************************ */
SOM_Scope page *SOMLINK epGetPage(envProcessor * somSelf)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessorMethodDebug("envProcessor", "epGetPage");
    return _thisPage;
}

/* ************************************************************ */
SOM_Scope fileMgr *SOMLINK epGetFileMgr(envProcessor * somSelf)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessorMethodDebug("envProcessor", "epGetFileMgr");
    return _thisFile;
}

/* ************************************************************ */
SOM_Scope envProcessor *SOMLINK epGetPreviousEnv(envProcessor * somSelf)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessorMethodDebug("envProcessor", "epGetPreviousEnv");
    return _previousEnv;
}

/* ************************************************************ */
SOM_Scope char *SOMLINK epGetClassName(envProcessor * somSelf)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    static char *myClass = "envProcessor";
    envProcessorMethodDebug("envProcessor", "epGetClassName");
    return myClass;
}

/* ************************************************************ */
SOM_Scope void SOMLINK epSetPage(envProcessor * somSelf,
				  page * newPage)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessorMethodDebug("envProcessor", "epSetPage");
    _thisPage = newPage;
}

/* ************************************************************ */
SOM_Scope void SOMLINK epSetFileMgr(envProcessor * somSelf,
				     fileMgr * newFileMgr)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessorMethodDebug("envProcessor", "epSetFileMgr");
    _thisFile = newFileMgr;
}

/* ************************************************************ */
SOM_Scope void SOMLINK somInit(envProcessor * somSelf)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessorMethodDebug("envProcessor", "somInit");

    parent_somInit(somSelf);
    _previousEnv = 0;
    _thisFile = 0;
    _thisPage = 0;
}

/* ************************************************************ */
SOM_Scope void SOMLINK somUninit(envProcessor * somSelf)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessorMethodDebug("envProcessor", "somUninit");

    if (!_previousEnv) {
	_somFree(_thisFile);
	_somFree(_thisPage);
	printf("\n");                  /* Last line feed for document. */
    }
    parent_somUninit(somSelf);
}

/* ************************************************************ */
SOM_Scope void SOMLINK somDumpSelfInt(envProcessor * somSelf,
				       int level)
{
    envProcessorData *somThis = envProcessorGetData(somSelf);
    envProcessorMethodDebug("envProcessor", "somDumpSelfInt");

    parent_somDumpSelfInt(somSelf, level);
}
/**************************************************************************
 *  File name  :  file.c
 *
 *  Description:  This module contains the code for the WM_COMMAND messages
 *		  posted by the standard File menu.
 *
 *		  This source file contains the following functions:
 *
 *		  FileNew(mp2);
 *		  FileOpen(mp2);
 *		  FileSave(mp2);
 *		  FileSaveAs(mp2);
 *		  WriteFileToDisk(hf);
 *		  GetFileName();
 *		  UpdateTitleText(hwnd);
 *		  TemplateOpenFilterProc(hwnd, msg, mp1, mp2)
 *		  TemplateSaveFilterProc(hwnd, msg, mp1, mp2)
 *
 *  Concepts   :  file management
 *
 *  API's      :  WinLoadString
 *		  WinFileDlg
 *		  DosOpen
 *		  DosClose
 *		  WinSetWindowText
 *		  WinWindowFromID
 *		  WinDefFileDlgProc
 *
 *  Required
 *    Files    :  OS2.H, STRING.H, MAIN.H, HELP.H, XTRN.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *  Include files, macros, defined constants, and externs
 */

#define INCL_WINFRAMEMGR
#define INCL_WINSWITCHLIST
#define INCL_WINSTDFILE

#include <os2.h>
#include <string.h>
#include "main.h"
#include "xtrn.h"
#include "help.h"

/*
 *  Global variables
 */

CHAR szFullPath[CCHMAXPATH] = "";

/*
 *  Entry point declarations
 */


/**************************************************************************
 *
 *  Name       : FileNew(mp2)
 *
 *  Description: Processes the File menu's New item
 *
 *  Concepts:  called whenever NEW from the FILE menu is selected
 *
 *  API's      : [none]
 *
 *  Parameters :  mp2	   = second message parameter
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID FileNew(MPARAM mp2)
{
    /*
     *	Enter routines for creating a new file and window
     */

    /* clear file name and reset the titlebar text */
   szFullPath[0] = '\0';
   UpdateTitleText(hwndMainFrame);

    /*	This routine currently doesn't use the mp2 parameter but
     *	it is referenced here to prevent an 'Unreferenced Parameter'
     *	warning at compile time.
     */
    mp2;
}   /* End of FileNew	*/


/**************************************************************************
 *
 *  Name       : FileOpen(mp2)
 *
 *  Description: Processes the File menu's Open item
 *
 *  Concepts:  Called whenever OPEN from the FILE menu is selected
 *
 *	       Calls the standard file open dialog to get the
 *	       file name.  The file name is passed onto DosOpen
 *	       which returns the handle to the file.  The file
 *	       input procedure is called and then the file handle
 *	       is closed.
 *
 *  API's      : WinLoadString
 *		 WinFileDlg
 *		 DosOpen
 *		 DosClose
 *
 *  Parameters :  mp2	   = second message parameter
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID FileOpen(MPARAM mp2)
{
   FILEDLG fdg;
   HFILE hfIn;
   ULONG ulAction;
   CHAR szTitle[MESSAGELEN], szButton[MESSAGELEN];

   fdg.cbSize = sizeof(FILEDLG);

   if(!WinLoadString(hab, (HMODULE)0, IDS_OPEN, MESSAGELEN, szTitle))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, TRUE);
      return;
   }

   if(!WinLoadString(hab, (HMODULE)0, IDS_OPEN, MESSAGELEN, szButton))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, TRUE);
      return;
   }

   fdg.pszTitle = szTitle;
   fdg.pszOKButton = szButton;
   fdg.ulUser = 0L;
   fdg.fl = FDS_HELPBUTTON | FDS_CENTER | FDS_OPEN_DIALOG;
   fdg.pfnDlgProc = (PFNWP)TemplateOpenFilterProc;
   fdg.lReturn = 0L;
   fdg.lSRC = 0L;
   fdg.hMod = 0;
   fdg.usDlgId = FILEOPEN;
   fdg.x = 0;
   fdg.y = 0;

   if(!WinLoadString(hab, (HMODULE)0, IDS_FILEOPENEXT, CCHMAXPATH,
		     fdg.szFullFile))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, TRUE);
      return;
   }

   fdg.pszIType	      = (PSZ)NULL;
   fdg.papszITypeList = (PAPSZ)NULL;
   fdg.pszIDrive      = (PSZ)NULL;
   fdg.papszIDriveList= (PAPSZ)NULL;
   fdg.sEAType	      = (SHORT)0;
   fdg.papszFQFilename= (PAPSZ)NULL;
   fdg.ulFQFCount     = 0L;

   /* get the file */
   if(!WinFileDlg(HWND_DESKTOP, hwndMain, &fdg))
      return;

   /*
    *  Upon sucessful return of a file, open it for reading
    */

   if(fdg.lReturn == ID_OK)
   {
      if( DosOpen(fdg.szFullFile,     /* file name from Open dialog */
		  &hfIn,	      /* file handle returned */
		  &ulAction,
		  0L,
		  FILE_NORMAL,
		  FILE_OPEN,
		  OPEN_ACCESS_READONLY | OPEN_SHARE_DENYNONE,
		  (PEAOP2)NULL))
      {
	 MessageBox(hwndMain,
		      IDMSG_CANNOTOPENINPUTFILE,
		      MB_OK | MB_ERROR,
		      FALSE);

	   /*
	    *  NOTE:  You now have several options on how to proceed
	    *	   from this point:
	    *	       - You can abort the File Open by returning from
	    *		 this procedure.
	    *	       - You can bring up the File Open dialog again
	    *		 and have the user pick another file.
	    *	       - You can check the error code from the DosOpen,
	    *		 determine why the open failed, and take an
	    *		 action appropriate to the specific failure.
	    */

	 return;
      }

       /* copy file name into file name buffer */
      strcpy(szFullPath, fdg.szFullFile);

       /*
	*  Place routine for reading the file here.
	*/

      DosClose(hfIn);

      UpdateTitleText(hwndMainFrame);
   }

   /* This routine currently doesn't use the mp2 parameter but       *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'
   \*  warning at compile time.					     */
   mp2;
}   /* End of FileOpen	 */

/**************************************************************************
 *
 *  Name       : FileSave(mp2)
 *
 *  Description: Processes the File menu's Save item
 *
 *  Concepts:  Called whenever SAVE from the FILE menu is selected
 *
 *	       Routine opens the file for output, calls the
 *	       application's save routine, and closes the file.
 *
 *  API's      : DosOpen
 *		 DosClose
 *
 *  Parameters :  mp2	   = second message parameter
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID FileSave(MPARAM mp2)
{
   HFILE hf;
   ULONG ulAction;
   /*
    * If the file currently is untitled, we will need to get a file
    * name from the user before we can open the file.  Getting a
    * file name is normally done during the FileSaveAs operation
    * so we will treat this save as a SaveAs and call FileSaveAs().
    * If the file is titled, then we save the file.
    *
    * NOTE:  This routine will be called by FileSaveAs(), but only
    *  after a valid file name has been obtained.  So, FileSaveAs()
    *  will not be called again from this routine.
    */
   if(szFullPath[0] == '\0')
   {
      FileSaveAs(mp2);
      return;
   }

   /* open the file */
   if( DosOpen(szFullPath,	   /* file name of current document */
	       &hf,		   /* file handle of output file */
	       &ulAction,
	       0L,
	       FILE_NORMAL,
	       FILE_OPEN | FILE_CREATE,
	       OPEN_ACCESS_WRITEONLY | OPEN_SHARE_DENYNONE,
	       (PEAOP2)NULL))
   {
       MessageBox(hwndMain,
		  IDMSG_CANNOTOPENOUTPUTFILE,
		  MB_OK | MB_ERROR,
		  FALSE);
       return;
   }

   WriteFileToDisk(hf);

   DosClose(hf);

   /* This routine currently doesn't use the mp2 parameter but       *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'
   \*  warning at compile time.					     */
   mp2;
}   /* End of FileSave	 */

/**************************************************************************
 *
 *  Name       : FileSaveAs(mp2)
 *
 *  Description: Processes the File menu's Save as item
 *
 *  Concepts:  Called whenever SAVE AS from the FILE menu is selected
 *
 *	       Routine prompts the user for the name of the file,
 *	       then saves the file.
 *
 *  API's      : DosOpen
 *		 DosClose
 *
 *  Parameters :  mp2	   = second message parameter
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID FileSaveAs(MPARAM mp2)
{
   HFILE hf;
   ULONG ulAction;
   ULONG sT;

   while(TRUE)	   /* infinite loop until we break out of it */
   {
      /* Get a name for the file */
      if(!GetFileName())
	 return;

      /* See if the file exists.  If it does, then confirm that the
       * user wants to overwrite it.  If he doesn't, then get a new
       * file name
       */
      if( DosOpen(szFullPath,	  /* file name from, GetFileName() */
		  &hf,		  /* handle of opened file */
		  &ulAction,
		  0L,
		  FILE_NORMAL,
		  FILE_CREATE,
		  OPEN_ACCESS_WRITEONLY | OPEN_SHARE_DENYNONE,
		  (PEAOP2)NULL))
      {
	 MessageBox(hwndMain,
		    IDMSG_CANNOTOPENOUTPUTFILE,
		    MB_OK | MB_ERROR,
		    FALSE);
	 return;
      }
      else
	 DosClose(hf);

      /* if file exists, ask if we want to overwrite it */
      if(ulAction == FILE_EXISTED)
      {
	 sT = MessageBox(hwndMain,
			 IDMSG_OVERWRITEFILE,
			 MB_QUERY | MB_YESNOCANCEL,
			 FALSE);

	 if(sT == MBID_CANCEL)
	    return;

	 if(sT == MBID_YES)
	    break;

	  /* if user selected no, repeat the sequence */
      }

   }   /* while(TRUE) */

   UpdateTitleText(hwndMainFrame);

   /*
    * Now that we have a valid file name, save the file.  This is
    * normally done under the File Save function so we can just
    * call the FileSave() function here.  Note that FileSave() will
    * not call FileSaveAs() back since there is a valid file name
    */
    FileSave(mp2);

   /*  This routine currently doesn't use the mp2 parameter but
    *  it is referenced here to prevent an 'Unreferenced Parameter'
    *  warning at compile time.
    */
   mp2;
}   /* End of FileSaveAs   */


/**************************************************************************
 *
 *  Name       : WriteFileToDisk(hfile)
 *
 *  Description: writes the current file to the file in hf
 *
 *  Concepts:  called from FileSave and FileSaveAs when a fileelected
 *	       is to be saved to disk
 *
 *	       NOTE:  This routine must not close the file.
 *
 *  API's      : [none]
 *
 *  Parameters :  hfile	   = file handle
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID WriteFileToDisk(HFILE hf)						\
{
    /*
     *	Place routine to write a disk file here.
     */

    hf;
}   /* End of WriteFileToDisk	*/


/**************************************************************************
 *
 *  Name       : GetFileName()
 *
 *  Description: gets the name of the save file
 *
 *  Concepts:	 called when the user needs to supply a name for
 *		 the file to be saved
 *
 *		  calls the standard file open dialog to get the
 *		 file name.
 *
 *  API's      : WinLoadString
 *		 WinFileDlg
 *
 *  Parameters : [none]
 *
 *  Return     :  TRUE if successful in getting a file name
 *		  FALSE if not successful in getting a file name
 *
 *************************************************************************/
BOOL GetFileName(VOID)
{
   FILEDLG fdg;
   CHAR szTitle[MESSAGELEN], szButton[MESSAGELEN];

   fdg.cbSize = sizeof(FILEDLG);

   if(!WinLoadString(hab, 0, IDS_SAVE, MESSAGELEN, szTitle))
   {
       MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, TRUE);
       return FALSE;
   }

   if(!WinLoadString(hab, 0, IDS_SAVE, MESSAGELEN, szButton))
   {
       MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, TRUE);
       return FALSE;
   }

   fdg.pszTitle = szTitle;
   fdg.pszOKButton = szButton;

   fdg.ulUser = 0L;
   fdg.fl = FDS_HELPBUTTON | FDS_CENTER | FDS_SAVEAS_DIALOG;
   fdg.pfnDlgProc = (PFNWP)TemplateSaveFilterProc;
   fdg.lReturn = 0L;
   fdg.lSRC = 0L;
   fdg.hMod = (HMODULE)NULL;
   fdg.usDlgId = FILESAVE;
   fdg.x = 0;
   fdg.y = 0;
   fdg.pszIType = (PSZ)NULL;
   fdg.papszITypeList = (PAPSZ)NULL;
   fdg.pszIDrive = (PSZ)NULL;
   fdg.papszIDriveList = (PAPSZ)NULL;
   fdg.sEAType = (SHORT)0;
   fdg.papszFQFilename = (PAPSZ)NULL;
   fdg.ulFQFCount = 0L;

   strcpy(fdg.szFullFile, szFullPath);

   /* get the file */
   if(!WinFileDlg(HWND_DESKTOP, hwndMain, &fdg))
       return FALSE;

   if(fdg.lReturn != ID_OK)
       return FALSE;

   /* copy file name and path returned into buffers */
   strcpy(szFullPath, fdg.szFullFile);

   return TRUE;
}   /* End of GetFileName   */

/**************************************************************************
 *
 *  Name       : UpdateTitleText
 *
 *  Description: Updates the text in the main window's title bar to
 *		 display the app name, followed by the separator,
 *		 followed by the file name.
 *
 *  Concepts :	 Called at init time and when the text file is changed.
 *		 Gets the program name, appends the separator, and
 *		 appends the file name.
 *
 *  API's      : WinLoadString
 *		 WinSetWindowText
 *		 WinWindowFromID
 *
 *  Parameters : hwnd = window handle
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID UpdateTitleText(HWND hwnd)
{
   CHAR szBuf[MAXNAMEL+TITLESEPARATORLEN+CCHMAXPATH];
   CHAR szSeparator[TITLESEPARATORLEN+1];
   PSZ pszT;

   WinLoadString(hab, (HMODULE)0, IDS_APPNAME, MAXNAMEL, szBuf);
   WinLoadString(hab,
		 (HMODULE)0,
		 IDS_TITLEBARSEPARATOR,
		 TITLESEPARATORLEN,
		 szSeparator);

   strcat(szBuf, szSeparator);

   if(szFullPath[0] == '\0')
      pszT = szUntitled;
   else
      pszT = szFullPath;

   strcat(szBuf, pszT);

   WinSetWindowText(WinWindowFromID(hwnd, FID_TITLEBAR), szBuf);
}   /* End of UpdateTitleText	*/

/**************************************************************************
 *
 *  Name       : TemplateOpenFilterProc(hwnd, msg, mp1, mp2)
 *
 *  Description: Filters the help messages to the open dialog
 *
 *  Concepts :	 If help is requested during the standard OPEN
 *		 dialog, this routine will display an appropriate
 *		 panel.
 *
 *  API's      : WinDefFileDlgProc
 *
 *  Parameters : hwnd = window handle
 *		 message = message i.d.
 *		 mp1	 = first message parameter
 *		 mp2	 = second message parameter
 *
 *  Return     :  the result of the message
 *
 *************************************************************************/
MRESULT EXPENTRY TemplateOpenFilterProc(HWND hwnd, ULONG message,
					MPARAM mp1, MPARAM mp2 )
{
   if(message == WM_HELP)
   {
      DisplayHelpPanel(HID_FS_OPEN_DLG_HELP_PANEL);
      return (MRESULT)FALSE ;
   }

   return WinDefFileDlgProc( hwnd, message, mp1, mp2 ) ;
}  /*  End of TemplateSaveFilterProc  */


/**************************************************************************
 *
 *  Name       : TemplateSaveFilterProc(hwnd, msg, mp1, mp2)
 *
 *  Description: Filters the help messages to the save dialog
 *
 *  Concepts :	 If help is requested during the standard SAVEAS
 *		 dialog, this routine will display an appropriate
 *		 panel.
 *
 *  API's      : WinDefFileDlgProc
 *
 *  Parameters : hwnd = window handle
 *		 message = message i.d.
 *		 mp1	 = first message parameter
 *		 mp2	 = second message parameter
 *
 *  Return     :  the result of the message
 *
 *************************************************************************/
MRESULT EXPENTRY TemplateSaveFilterProc(HWND hwnd,
					ULONG message,
					MPARAM mp1,
					MPARAM mp2 )
{
   if(message == WM_HELP)
   {
      DisplayHelpPanel(HID_FS_SAVE_DLG_HELP_PANEL);
      return (MRESULT)FALSE ;
   }

   return WinDefFileDlgProc( hwnd, message, mp1, mp2 );
}  /*  End of TemplateSaveFilterProc  */
/***************************  End of file.c  ***************************/
#ifndef lint
static char *sccsid = "@(#)fm.c 1.3 1/22/92 16:09:18 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define fileMgr_Class_Source

#define BUFF_SIZE 20

#include <stdio.h>
#include <stdlib.h>
#include "fm.ih"

/* ************************************************************ */
SOM_Scope void SOMLINK fmInit(fileMgr * somSelf,
			       char *newFile)
{
    fileMgrData *somThis = fileMgrGetData(somSelf);
    fileMgrMethodDebug("fileMgr", "fileMgrInit");
    if (!(_funit = fopen(newFile, "r"))) {
	printf("Error: unable to open input file \"%s\".\n", newFile);
	exit(3);
    }
}

/* ************************************************************ */
SOM_Scope int SOMLINK fmGetChar(fileMgr * somSelf)
{
    fileMgrData *somThis = fileMgrGetData(somSelf);
    int newChar;
    fileMgrMethodDebug("fileMgr", "fmGetChar");

    if (_fmSize(somSelf)) {
	newChar = _buffer[_getSide];
	_getSide = _fmIncr(somSelf, _getSide);
    }
    else {
	newChar = getc(_funit);
    }
    return newChar;
}

/* ************************************************************ */
SOM_Scope int SOMLINK fmPeekChar(fileMgr * somSelf,
				  int offset)
{
    fileMgrData *somThis = fileMgrGetData(somSelf);
    int newChar;
    char cChar;
    int n;
    fileMgrMethodDebug("fileMgr", "fmPeekChar");

    for (;;) {
	n = _fmSize(somSelf);
	if (n > offset)
	    break;
	newChar = getc(_funit);
	cChar = (char) newChar;
	_buffer[_putSide] = newChar;
	_putSide = _fmIncr(somSelf, _putSide);
    }
    offset = _fmAdd(somSelf, _getSide, offset);
    newChar = _buffer[offset];
    return newChar;
}

/* ************************************************************ */
SOM_Scope void SOMLINK somInit(fileMgr * somSelf)
{
    fileMgrData *somThis = fileMgrGetData(somSelf);
    fileMgrMethodDebug("fileMgr", "somInit");
    parent_somInit(somSelf);

    _funit = 0;
    _putSide = 0;
    _getSide = 0;
}

/* ************************************************************ */
SOM_Scope void SOMLINK somUninit(fileMgr * somSelf)
{
    fileMgrData *somThis = fileMgrGetData(somSelf);
    fileMgrMethodDebug("fileMgr", "somUninit");

    if (_funit)
	fclose(_funit);

    parent_somUninit(somSelf);
}

/* ************************************************************ */
SOM_Scope void SOMLINK somDumpSelfInt(fileMgr * somSelf,
				       int level)
{
    fileMgrData *somThis = fileMgrGetData(somSelf);
    fileMgrMethodDebug("fileMgr", "somDumpSelfInt");
    parent_somDumpSelfInt(somSelf, level);
}

/* ************************************************************ */
SOM_Scope int SOMLINK fmSize(fileMgr * somSelf)
{
    fileMgrData *somThis = fileMgrGetData(somSelf);
    int result;
    fileMgrMethodDebug("fileMgr", "size");

    if (_getSide == _putSide)
	result = 0;
    else if (_getSide < _putSide)
	result = _putSide - _getSide;
    else
	result = (BUFF_SIZE - _getSide - 1) + (_putSide + 1);
    return result;
}

/* ************************************************************ */
SOM_Scope int SOMLINK fmIncr(fileMgr * somSelf,
			      int oldNum)
{
    fileMgrData *somThis = fileMgrGetData(somSelf);
    fileMgrMethodDebug("fileMgr", "incr");

    if (oldNum == (BUFF_SIZE - 1))
	return 0;
    else
	return (oldNum + 1);
}

/* ************************************************************ */
SOM_Scope int SOMLINK fmAdd(fileMgr * somSelf,
			     int oldNum,
			     int addNum)
{
    fileMgrData *somThis = fileMgrGetData(somSelf);
    fileMgrMethodDebug("fileMgr", "add");
    return ((oldNum + addNum) % BUFF_SIZE);
}
#ifndef lint
static char *sccsid = "@(#)footer.c 1.3 1/22/92 16:09:39 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define footer_Class_Source
#include "footer.ih"

#include "page.h"
#include "tpword.h"

/* ************************************************************ */
SOM_Scope void SOMLINK epProcessEnvironment(footer * somSelf)
{
/* footerData *somThis = footerGetData(somSelf); */
    page *thisPage;
    textLine *thisFt;
    TPWord *thisWord;

    footerMethodDebug("footer", "epProcessEnvironment");

    thisPage = _epGetPage(somSelf);
    thisFt = _pgGetFooterBlock(thisPage);

    for (;;) {
	thisWord = readToken(_epGetFileMgr(somSelf));
	if (_match(thisWord, "[[end_environment]]")) {
	    _somFree(thisWord);
	    return;
	}
	if (_tpwType(thisWord) == TP_LINE_BREAK) {
	    _somFree(thisWord);
	    continue;
	}
	_llAddTail(thisFt, thisWord);
	if (_match(thisWord, "[[page_number]]"))
	    _pgSetPageNumber(thisPage, thisWord);
    }
}
/**************************************************************************
 *
 *  Name       :
 *
 *  Description:
 *
 *  Concepts:
 *
 *  API's      :
 *
 *  Parameters :
 *
 *  Return     :
 *
 *************************************************************************/
/***************************  End of funchead.c	 *************************/
/******************************************************************************
*
*  File Name   : GLOBALS.C
*
*  Description : global data for Jigsaw
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.						      *
*
******************************************************************************/

#include "jigsaw.h"

/*-------------------------- general definitions -----------------------------*/

HAB	  habMain	   = NULLHANDLE;  /* main thread anchor block handle  */
HMQ	  hmqMain	   = NULLHANDLE;  /* main thread queue handle	      */
HWND	  hwndFrame	   = NULLHANDLE;  /* frame control handle	      */
HWND	  hwndClient	   = NULLHANDLE;  /* client area handle		      */
HWND	  hwndMenu	   = NULLHANDLE;  /* Menu handle		      */
HDC	  hdcClient	   = NULLHANDLE;  /* window dc handle		      */
HPS	  hpsClient	   = NULLHANDLE;  /* client area Gpi ps handle	      */
SIZEL	  sizlMaxClient;		  /* max client area size	      */
HPS	  hpsPaint	   = NULLHANDLE;  /* ps for use in Main Thread	      */
HRGN	  hrgnInvalid	   = NULLHANDLE;  /* handle to the invalid region     */

HAB	  habAsync	   = NULLHANDLE;  /* async thread anchor block handle */
HMQ	  hmqAsync	   = NULLHANDLE;  /* async thread queue handle	      */
TID	  tidAsync;			  /* async thread id		      */
SEL	  selStack;			  /* async thread stack selector      */
SHORT	  sPrty		   = -1;	  /* async thread priority	      */

HWND	  hwndHorzScroll   = NULLHANDLE;  /* horizontal scroll bar window     */
HWND	  hwndVertScroll   = NULLHANDLE;  /* vertical scroll bar window	      */

POINTS	  ptsScrollPos,
	  ptsOldScrollPos;
POINTS	  ptsScrollMax,
	  ptsHalfScrollMax;
POINTS	  ptsScrollLine;
POINTS	  ptsScrollPage;

MATRIXLF  matlfIdentity	   = { UNITY, 0, 0, 0, UNITY, 0, 0, 0, 1 };
LONG	  lScale;			  /* current zoom level		      */
POINTL	  ptlScaleRef;			  /* scalefactor, detects size change */

POINTL	  ptlOffset;
POINTL	  ptlBotLeft	   = { 0, 0};
POINTL	  ptlTopRight	   = { 3000, 3000};
POINTL	  ptlMoveStart;		       /* model space point at start of move  */
LONG	  lLastSegId;		       /* last segment id assigned to a piece */
LONG	  lPickedSeg	   = 0L;       /* seg id of piece selected for drag   */
POINTL	  ptlOffStart;		       /* segment xform xlate at move start   */
RECTL	  rclBounds;		       /* pict bounding box in model coords.  */
POINTL	  ptlOldMouse	   = {0L, 0L}; /* current mouse posn		      */
POINTL	  ptlMouse	   = {0L, 0L}; /* current mouse posn		      */
BOOL	  fButtonDownMain  = FALSE;    /* only drag if mouse down	      */
BOOL	  fButtonDownAsync = FALSE;    /* only drag if mouse down	      */

POINTL	  ptlUpdtRef;
POINTL	  aptlUpdt[3];
BOOL	  fUpdtFirst;
BOOL	  fFirstLoad	   = TRUE;
BOOL	fPictureAssembled = TRUE;

/*-------------------------- segment list ------------------------------------*/

PSEGLIST pslHead	   = NULL;	      /* head of the list	      */
PSEGLIST pslTail	   = NULL;	      /* tail of the list	      */
PSEGLIST pslPicked	   = NULL;	      /* picked segment's list member */

/*-------------------------- bitmap-related data -----------------------------*/

LOADINFO li;
PLOADINFO pli = &li;

HPS	   hpsBitmapFile      = NULLHANDLE; /* bitmap straight from the file */

HDC	   hdcBitmapFile      = NULLHANDLE;
HBITMAP	   hbmBitmapFile      = NULLHANDLE;

BITMAPINFOHEADER2  bmp2BitmapFile;
PBITMAPINFOHEADER2 pbmp2BitmapFile    = &bmp2BitmapFile;
BITMAPINFOHEADER2  bmp2BitmapFileRef;
PBITMAPINFOHEADER2 pbmp2BitmapFileRef = &bmp2BitmapFileRef;

HPS	   hpsBitmapSize  = NULLHANDLE;	 /* bitmap sized to the current size */
HDC	   hdcBitmapSize  = NULLHANDLE;
HBITMAP	   hbmBitmapSize  = NULLHANDLE;

HPS	   hpsBitmapBuff  = NULLHANDLE;/* image composed here, copied to scrn */
HDC	   hdcBitmapBuff  = NULLHANDLE;
HBITMAP	   hbmBitmapBuff  = NULLHANDLE;

HPS	   hpsBitmapSave  = NULLHANDLE;/* save part of screen during dragging */
HDC	   hdcBitmapSave  = NULLHANDLE;
HBITMAP	   hbmBitmapSave  = NULLHANDLE;

BITMAPINFOHEADER2  bmp2BitmapSave;
PBITMAPINFOHEADER2 pbmp2BitmapSave    = &bmp2BitmapSave;

DEVOPENSTRUC dop = { NULL
		     , "DISPLAY"
		     , NULL
		     , NULL
		     , NULL
		     , NULL
		     , NULL
		     , NULL
		     , NULL };


/*--------------------------- Miscellaneous ----------------------------------*/

/*
 *   These event semaphores are loosely used to signal events between Jigsaw's
 *   two threads.  No DosWaitEventSem() calls are made at this time, since,
 *   without reworking the code, this could block out a thread that should
 *   continually process the message queue.  Semaphores are "Reset" while
 *   being used (to signal event) and "Posted" when the event is over.
 */

HEV	hevTerminate;	 /* event semaphore - terminating Jigsaw...	      */
HEV	hevDrawOn;	 /* event semaphore - enable/disable drawing	      */
HEV	hevMouse;	 /* event semaphore - enable/disable mouse tracking   */
HEV	hevLoadingBitmap;/* event semaphore - loading a bitmap file from disk */
HEV	hevKillDraw;	 /* event semaphore - stop drawing		      */

PSZ	pszBlankMsg    = "";

SWCNTRL swctl	    = { 0, 0, 0, 0, 0, SWL_VISIBLE, SWL_JUMPABLE, 0, 0 };
HSWITCH hsw;			       /* handle to a switch list entry	      */
char	szTitle[MESSAGELEN];	       /* Title bar text		      */
char	szErrorTitle[MESSAGELEN];      /* error Title bar text		      */
LONG	lByteAlignX, lByteAlignY;      /* memory alignment constants	      */

BOOL fErrMem	  = FALSE;	       /* set if alloc async stack fails      */
BOOL BmpLoaded	  = FALSE;

USHORT	       Currentchecked = IDM_SIZE_FULL;

/******************************* end GLOBALS.C *******************************/
/* *********** GRAPHIC C Sample Program Source Code File (.C) *****************
 *
 * PROGRAM NAME: GRAPHIC
 * -------------
 *  Presentation Manager Non-Retained Graphics C Sample Program
 *
 * WHAT THIS PROGRAM DOES:
 * -----------------------
 *  This program displays a selected metafile.
 *  The current contents of the client area can also be printed.
 *  All drawing is performed by a lower-priority asynchronous
 *  thread, thus allowing the program to monitor its message queue
 *  at regular intervals. The program does not test every call for
 *  an error return code.
 *
 * WHAT THIS PROGRAM DEMONSTRATES:
 * -------------------------------
 *  This program demonstrates the use of the default viewing
 *  transformation, metafile loading and playing, the use of
 *  dialog boxes, and file manipulation through Standard Open dialog.
 *  It also demonstrates the use of an asynchronous drawing thread and
 *  print thread.
 *
 * API CALLS FEATURED:
 * -------------------
 *
 *  WinAddSwitchEntry			  DosReleaseMutexSem
 *  WinAssociateHelpInstance		  DosCloseMutexSem
 *  WinBeginPaint			  DosCloseEventSem
 *  WinCreateStdWindow			  DosWaitThread
 *  WinCreationFlags
 *  WinCreateHelpInstance		  DosResetEventSem
 *  WinCreateMsgQueue
 *  WinCreateWindow			  DosCreateThread
 *  WinDlgBox				  DosGetInfoBlocks
 *  WinDefFileDlgProc			  DosCreateMutexSem
 *  WinDestroyHelpInstance		  DosCreateEventSem
 *  WinDestroyMsgQueue
 *  WinDestroyWindow			  GpiCharStringAt
 *  WinDispatchMsg			  GpiSetColor
 *  WinDefDlgProc			  GpiQueryFontMetrics
 *  WinDefWindowProc			  GpiCreateRegion
 *  WinDismissDlg			  GpiCreatePS
 *  WinEndPaint				  GpiQueryCharBox
 *  WinFillRect				  GpiAssociate
 *  WinGetPS				  GpiDestroyPS
 *  WinGetMsg				  GpiDestroyRegion
 *  WinInitialize			  GpiLoadMetaFile
 *  WinInvalidateRegion			  GpiResetPS
 *  WinInvalidateRect			  GpiSetStopDraw
 *  WinLoadString
 *  WinMessageBox
 *  WinOpenWindowDC
 *  WinPostMsg
 *  WinPostQueueMsg
 *  WinQuerySysValue
 *  WinQuerySysPointer
 *  WinQueryWindowDC
 *  WinQueryWindowPos
 *  WinQueryWindowProcess
 *  WinQueryWindowPtr
 *  WinQueryWindowRect
 *  WinRegisterClass
 *  WinReleasePS
 *  WinRequestMutexSem
 *  WinSendDlgItemMsg
 *  WinSendMsg
 *  WinSetWindowPos
 *  WinSetWindowPtr
 *  WinSetWindowText
 *  WinTerminate
 *  WinWaitEventSem
 *  WinWindowFromID
 *
 * WHAT YOU NEED TO COMPILE THIS PROGRAM:
 * --------------------------------------
 *
 *  REQUIRED FILES:
 *  ---------------
 *
 *    GRAPHIC.C	    - Source code
 *    FILE.C	    - Source code (File Handling)
 *    GRAPHIC.MAK   - Make file for this program
 *    GRAPHIC.DEF   - Module definition file
 *    GRAPHIC.H	    - Application header file
 *    GRAPHIC.ICO   - Icon file
 *    GRAPHIC.LNK   - Linker automatic response file
 *    GRAPHIC.RC    - Resource file
 *
 *    OS2.H	     - Presentation Manager include file
 *    STDLIB.H	     - Miscellaneous function declarations
 *    STRING.H	     - String function declarations
 *
 * EXPECTED INPUT:
 * ---------------
 *  User activity with the mouse or the keyboard, the standard
 *  frame controls, menus, and dialog boxes.
 *
 * EXPECTED OUTPUT:
 * ----------------
 *  Display of the center part of a metafile picture in a standard
 *  window. This has a frame with title bar, system and application
 *  menus, and maximize and minimize icons.
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 ******************************************************************************/

/* Include the required sections of the PM header file */

#include <stdlib.h>
#include <string.h>

#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#define INCL_GPICONTROL
#define INCL_GPIMETAFILES
#define INCL_GPIREGIONS
#define INCL_GPIPRIMITIVES
#define INCL_GPILCIDS
#define INCL_WINSTDFILE
#define INCL_WINSTDDLGS
#define INCL_WINHELP
#define INCL_WINPOINTERS
#define INCL_WINFRAMEMGR
#define INCL_WINWINDOWMGR
#define INCL_WINMESSAGEMGR
#define INCL_WINDIALOGS
#define INCL_WINSYS
#define INCL_WINMENUS
#define INCL_WINMLE
#define INCL_WINERRORS

#include <os2.h>
#include <pmstddlg.h>
#include <ctype.h>
#include <process.h>
#include "graphic.h"

/*
 * Presentation Manager Program Main Body
 *
 * The following routine is the Presentation Manager program Main Body.
 * The Main Body of a PM program is concerned with associating the
 * application with the Presentation Manager system, creating its
 * message queue, registering and displaying its main window, servicing
 * its message queue during the time that the application is active,
 * and disassociating the application from PM when the user is finished
 * with the application. The remaining parts of this source module that
 * are concerned with the Presentation Manager are the application's
 * window procedures (main window procedure, child window procedures,
 * and dialog window procedures) that process the messages associated
 * with the application's various windows.
 */

/* static function definitions */
static	 VOID	    InvalidateTextRect(HWND hWnd);
static	 MAIN_PARM  Parm;
static	 PAPPL_DEFAULTS ApplDefaults;

/**************************************************************************
 * Function: main
 *
 * Initializes the structures and handle the messages for the main window
 *
 * Parameters: none
 *
 * Result: none
 *
 ***************************************************************************/
VOID main(VOID)
{
	 QMSG	    qmsg;	    /* MSG structure to store the messages */
	 BOOL	    fRc;
	 BOOL	    FastQuit = FALSE;

/* Do the Initialization */
   if (!Initialize())
   {
      FastQuit = TRUE;
      ReportError();
      EndProgram();
   }


/* The following is the message loop for the application. */

   do
   {
      fRc = WinGetMsg(Parm.hAB, (PQMSG)&qmsg, 0, 0, 0);
      if (fRc)			 /* if not WM_QUIT, pass the message to the   */
	 WinDispatchMsg(Parm.hAB, (PQMSG)&qmsg);     /* window procedure     */
   } while (fRc);

/* if printing is in process, cancel print job */
   if (Parm.PrintStatus)
   {
      if (GpiSetStopDraw(Parm.hpsPrint, (LONG)TRUE) == GPI_ERROR)
	 DispError(Parm.hAB,Parm.hWndClient);
   }

   EndProgram();
   exit(0);
} /* End of main */

/**************************************************************************
 * Function: Initialize
 *
 * Initializing the structures and handle the messages for the main window
 *
 * Parameters: none
 *
 * Result:  BOOL	      TRUE	Initialization ok
 *			      FALSE	Error in Initialization
 *
 ***************************************************************************/
BOOL Initialize(VOID)
{
	 CHAR	    szAppName[20];	      /* class name of application */
static	 CHAR	    InfoWindow[] = "GRAPHIC"; /* class name of info window */
	 INT	    rc;
	 HELPINIT   hiGRAPHICHelp;     /* Help initialization structure	   */
	 ULONG	    WinCreationFlags;  /* window creation flags		   */
	 PID	    pid;	 /* Process identifier for adding name to  */
				       /* switch list			   */
	 TID	    tid;	       /* Thread identifier		   */
	 SWCNTRL    Swctl;
	 ULONG	   WindowPosOption;


/* Init Structure */
   memset((PVOID)&Parm, '\0', sizeof(MAIN_PARM));
   Parm.PrintEnabled = Parm.PrintPropertiesEnabled = Parm.fNotReady = TRUE;
   Parm.DrawThreadID = (TID)-1;
   Parm.CheckedItem = -1;
   Parm.DrawParm.rclBounds.xLeft = Parm.DrawParm.rclBounds.yBottom =
				   Parm.DrawParm.rclBounds.xRight =
				   Parm.DrawParm.rclBounds.yTop = 0xFFFF;
   Parm.DrawParm.fAllValid = Parm.fStoppable = Parm.DrawParm.fDrawing = TRUE;

   /* Create semaphores */
   DosCreateMutexSem(NULL, &Parm.hmtxsemStoppable, DC_SEM_SHARED, FALSE);
   DosCreateEventSem(NULL, &Parm.hevsemTerminate, DC_SEM_SHARED, TRUE);
   DosCreateEventSem(NULL, &Parm.hevsemPrintEnds, DC_SEM_SHARED, TRUE);
   DosCreateEventSem(NULL, &Parm.hevsemStop, DC_SEM_SHARED, TRUE);
   /*
    * The WinInitialize routine initializes the Presentation Manager
    * facilities for use by this application and returns a handle to the
    * anchor block assigned to the application by PM.
    */
   if ((Parm.hAB = WinInitialize(0)) == (HAB)0)
      return(FALSE);

   Parm.ProgramTitle = GetString(Parm.hAB, APPLICATION_NAME, ALLOC_STRING);

   /* The WinCreateMsgQueue call creates a message queue for this application */
   if ((Parm.hMQ = WinCreateMsgQueue(Parm.hAB, 16384)) == (HMQ)0)
      return(FALSE);

   /* Query System Pointer */
   Parm.hptrGlass = WinQuerySysPointer(HWND_DESKTOP, SPTR_WAIT, FALSE);
   Parm.hptrArrow = WinQuerySysPointer(HWND_DESKTOP, SPTR_ARROW, FALSE);


/* The following function registers the classes of all application windows */
   strcpy(szAppName, GetString(Parm.hAB, APPLICATION_NAME, STATIC_STRING));
   rc = WinRegisterClass(Parm.hAB,	   /* Anchor block handle	      */
			 (PCH)szAppName,   /* Name of class being registered  */
			 (PFNWP)WndProc,   /* Window procedure for class      */
			 CS_CLIPCHILDREN | CS_SIZEREDRAW | CS_SYNCPAINT,
			 0);

   if (rc == FALSE)
      return(FALSE);

   /* register a class for the information window */
   rc = WinRegisterClass(Parm.hAB,	   /* Anchor block handle	      */
			 (PCH)InfoWindow,  /* Name of class being registered  */
			 (PFNWP)WndProcI,  /* Window procedure for class      */
			 /* CS_SIZEREDRAW | CS_SYNCPAINT | CS_SAVEBITS, */
			 0L,
			 sizeof(PMAIN_PARM));

   if (rc == FALSE)
      {
      strcpy(Parm.ErrorMsg,
	     GetString(Parm.hAB, ERRMSG_REGISTER_FAILED, STATIC_STRING));
      return(FALSE);
      }

   /* IPF Initialization Structure */

   hiGRAPHICHelp.cb = sizeof(HELPINIT);		   /* size of init structure */
   hiGRAPHICHelp.ulReturnCode = 0;
   hiGRAPHICHelp.pszTutorialName = 0;		   /* no tutorial	     */
   hiGRAPHICHelp.phtHelpTable = (PVOID)(0xffff0000 | ID_GRAPHIC);
   hiGRAPHICHelp.hmodAccelActionBarModule = 0;
   hiGRAPHICHelp.idAccelTable = 0;
   hiGRAPHICHelp.idActionBar = 0;
   hiGRAPHICHelp.pszHelpWindowTitle = szAppName;
   hiGRAPHICHelp.hmodHelpTableModule = 0;
   hiGRAPHICHelp.fShowPanelId = 0;
   hiGRAPHICHelp.pszHelpLibraryName = HELP_FILE;

   /* Create Instance of IPF */

   Parm.hWndGRAPHICHelp = WinCreateHelpInstance(Parm.hAB, &hiGRAPHICHelp);

   if (!Parm.hWndGRAPHICHelp || hiGRAPHICHelp.ulReturnCode)
      {
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
		    GetString(Parm.hAB, ERRMSG_NO_HELP, STATIC_STRING),
		    (PSZ)Parm.ProgramTitle,
		    1,
		    MB_OK | MB_APPLMODAL | MB_MOVEABLE);
      WinDestroyHelpInstance(Parm.hWndGRAPHICHelp);
      }
    /*
     * The CreateWindow function creates a frame window for this application's
     * top window, and sets the window's size and location as appropriate.
     */
   WinCreationFlags = FCF_TITLEBAR     |
		      FCF_SYSMENU      |
		      FCF_MINBUTTON    |
		      FCF_MAXBUTTON    |
		      FCF_SIZEBORDER   |
		      FCF_MENU	       |
		      FCF_ACCELTABLE   |
		      FCF_ICON;

   WinCreationFlags |= FCF_SHELLPOSITION;

   /* Create the frame window */
   Parm.hWndFrame = WinCreateStdWindow(HWND_DESKTOP, /* parent of window      */
				WS_VISIBLE,	     /* frame window style    */
				&WinCreationFlags,   /* frame flags	      */
				szAppName,	     /* class name	      */
				Parm.ProgramTitle,   /* window title	      */
				WS_VISIBLE |	     /* client window style   */
				WS_CLIPCHILDREN,
				(HMODULE)NULL,	     /* module for resources  */
				ID_GRAPHIC,	     /* resource id	      */
				(HWND FAR *)&Parm.hWndClient); /* client handle*/
      /*
       * if hWndFrame is NULL, an error occured when opening the window,
       *     notify the user and exit this function
       */
   if (Parm.hWndFrame == (HWND)0)
      {
      strcpy(Parm.ErrorMsg, GetString(Parm.hAB, ERRMSG_CREATE_WINDOW,
				       STATIC_STRING));
      return(FALSE);
      }

   /* Associate Instance of IPF */

   if (Parm.hWndGRAPHICHelp)
      WinAssociateHelpInstance(Parm.hWndGRAPHICHelp,
			       Parm.hWndFrame);
   /*
    * The following inline routine fills out the application's switch control
    * structure with the appropriate information to add the application's
    * name to the OS/2 Task Manager List, a list of the jobs currently
    * running on the computer.
    */
   WinQueryWindowProcess(Parm.hWndFrame, &pid, &tid);
   Swctl.hwnd = Parm.hWndFrame;			    /* Frame window handle    */
   Swctl.idProcess = pid;			    /* Process identifier     */
   Swctl.uchVisibility = SWL_VISIBLE;		    /* visibility	      */
   Swctl.fbJump = SWL_JUMPABLE;			    /* Jump indicator	      */
   strcpy(Swctl.szSwtitle, Parm.ProgramTitle);	    /* Frame window title     */
   WinAddSwitchEntry(&Swctl);

   /* Copy Application Defaults */
   if (ApplDefaults)
      {
      strcpy(Parm.DriverName, ApplDefaults->DriverName);
      }

   /* Query Default Printer and set print items (Print & Printer Properties) */
   SetPrintItems(&Parm);

   /* create information window */
     Parm.InfoWnd.hWnd = WinCreateWindow(Parm.hWndClient,
					 InfoWindow,
					 (PSZ)InfoWindow,
					 WS_SAVEBITS | WS_CLIPCHILDREN,
					 0,
					 0,
					 1,
					 1,
					 Parm.hWndClient,
					 HWND_TOP,
					 ID_GRAPHIC,
					 (PVOID)&Parm,
					 NULL);

   if (Parm.InfoWnd.hWnd == (HWND)0)
   {
      strcpy(Parm.ErrorMsg, GetString(Parm.hAB, ERRMSG_INFO_WINDOW, STATIC_STRING));
      return(FALSE);
   }

/*
 * Query current process ID, thread ID and the process ID of the parent
 * process
 */
   DosGetInfoBlocks(&Parm.ptibMain, &Parm.ppibMain);

/* create draw thread */
   if (DosCreateThread(&Parm.DrawThreadID,
		    (PFNTHREAD)DrawThread,
		    (ULONG)(PMAIN_PARM)&Parm,
		    (ULONG)0,
		    (ULONG)STACK_SIZE))
   {
      strcpy(Parm.ErrorMsg, GetString(Parm.hAB, ERRMSG_DRAW_THREAD, STATIC_STRING));
      return(FALSE);
   }

/* create print thread */
   if (DosCreateThread(&Parm.PrintThreadID,
		    (PFNTHREAD)PrintThread,
		    (ULONG)(PMAIN_PARM)&Parm,
		    (ULONG)0,
		    (ULONG)STACK_SIZE))
   {
      strcpy(Parm.ErrorMsg, GetString(Parm.hAB, ERRMSG_PRINT_THREAD,
	     STATIC_STRING));
      return(FALSE);
   }

/* invalidate text rectangle */
   InvalidateTextRect(Parm.hWndClient);
   return(TRUE);

} /* End of Initialize */

/**************************************************************************
 * Function: Report Error
 *
 * Display a message box with the error returned from the function
 * Initialize.
 *
 * Parameters: none
 *
 * Result:  none
 *
 ***************************************************************************/
VOID ReportError(VOID)

{
   if (Parm.ErrorMsg)
      WinMessageBox(HWND_DESKTOP,
		 (Parm.hWndFrame) ? Parm.hWndFrame : HWND_DESKTOP,
		 (PSZ)Parm.ErrorMsg,
		 (PSZ)NULL,
		 0,
		 MB_MOVEABLE | MB_CUACRITICAL | MB_OK);
} /* End of ReportError */

/*************************************************************************
 * Function: EndProgram
 *
 * End the threads and discard all windows
 *
 * Parameters: none
 *
 * Result:  none
 *
 ***************************************************************************/
VOID EndProgram(VOID)
{
   ULONG      ResetCount;
/*
 * Perform clean up before exiting application.
 * Destroy Instance of IPF
 */
   if (Parm.hWndGRAPHICHelp)
      WinDestroyHelpInstance(Parm.hWndGRAPHICHelp);

/* end the draw thread */
   if (Parm.DrawThreadID != -1)
   {
      WinRequestMutexSem(Parm.hmtxsemStoppable, (ULONG)-1);
      Parm.fStoppable = TRUE;
      DosReleaseMutexSem(Parm.hmtxsemStoppable);
      SendCommand(&Parm, (ULONG)FLUSH_COMMAND, (ULONG)NULL);
      DosResetEventSem(Parm.hevsemTerminate, &ResetCount);
      if (SendCommand(&Parm, (ULONG)STOP_THREAD, (ULONG)NULL))
	 WinWaitEventSem(Parm.hevsemTerminate, (ULONG)-1);
   }

/* end the print thread */
   if (Parm.PrintThreadID != -1)
   {
      DosResetEventSem(Parm.hevsemPrintEnds, &ResetCount);
      WinPostQueueMsg(Parm.hMQPrint, STOP_THREAD, MPFROMSHORT(0), MPFROMSHORT(0));
      WinWaitEventSem(Parm.hevsemPrintEnds, (ULONG)-1);
   }

/* wait until Draw Thread has ended */
   DosWaitThread(&Parm.DrawThreadID, DCWW_WAIT);

/* wait until print thread has ended */
   DosWaitThread(&Parm.PrintThreadID, DCWW_WAIT);

   if (Parm.InfoWnd.hWnd)
      WinDestroyWindow(Parm.InfoWnd.hWnd);  /* Destroy the Infowindow		 */
   if (Parm.hWndFrame)
      WinDestroyWindow(Parm.hWndFrame);	    /* Destroy the frame window		 */
   if (Parm.hMQ)
      WinDestroyMsgQueue(Parm.hMQ);  /* Destroy the application message queue */
   if (Parm.hAB)
      WinTerminate(Parm.hAB);	     /* Terminate the application's use of   */
				     /* Presentation Manager resources	     */

   /* Close the semaphores */
   DosCloseMutexSem(Parm.hmtxsemStoppable);	   /* new with 2.0 */
   DosCloseEventSem(Parm.hevsemTerminate);
   DosCloseEventSem(Parm.hevsemPrintEnds);
   DosCloseEventSem(Parm.hevsemStop);
} /* End of EndProgram */

/**************************************************************************
 * Function: WndProc
 *
 * Main Window Procedure
 *
 * This procedure provides service routines for the general PM events
 * (messages) that PM sends to the window, as well as the user
 * initiated events (messages) that are generated when the user selects
 * the action bar and pulldown menu controls or the corresponding
 * keyboard accelerators.
 *
 * The SWITCH statement shown below distributes the window messages to
 * the respective message service routines, which are set apart by the
 * CASE statements. The window procedures must provide an appropriate
 * service routine for its end user initiated messages, as well as the
 * general PM messages (like the WM_CLOSE message). If a message is
 * sent to this procedure for which there is no programmed CASE clause
 * (i.e., no service routine), the message is defaulted to the
 * WinDefWindowProc function, where it is disposed of by PM.
 *
 * Parameters: HWND	    window handle
 *	       USHORT	    message
 *	       MPARAM	    message parameter 1
 *	       MPARAM	    message parameter 2
 *
 * Result:  MRESULT	    message result
 *
 ***************************************************************************/
MRESULT EXPENTRY WndProc(HWND hWnd, ULONG message, MPARAM mp1, MPARAM mp2)
{
	 HPS	    hPS;      /* Handle for the Presentation Space	   */
	 RECTL	    rClient;  /* Handle to rectangle formed by client area */
	 PSWP	    WindowPos;
static	 BOOL	    WindowMinimized = FALSE;
	 HMF	    hmfPicture;
static	 CHAR	    Filename[260];
static	 CHAR	    Filemask[260];
static	 MENUITEM   mi =
		    {
		    1, MIS_TEXT, 0, IDM_F_TEXT_PREVIOUS, (HWND)0, (ULONG)0
		    };
static	 BOOL	    MenuUpdated = FALSE;
	 PSZ	    FileName;
	 PSZ	    DialogHeader;

   switch(message)
   {
   case SET_PRINT_STATUS:	       /* set print status		*/
	Parm.PrintStatus = (BOOL)SHORT1FROMMP(mp1);
	Parm.hpsPrint = (HPS)LONGFROMMP(mp2);
	WinSendMsg(Parm.InfoWnd.hWnd,  /* hide/show information window */
		   ENABLE_INFO_WND,
		   mp1,
		   MPFROMSHORT(0));
	SetPrintItems(&Parm);		   /* set item "Print" in the menu */
	break;

   case WM_CREATE:
	return(WndProcCreate(hWnd, &Parm));
	break;

   case WM_ERASEBACKGROUND:
	/*
	 * If the flag fNotReady is set, the default processing for this
	 * message occurs.
	 */
	if (Parm.fNotReady)
	   return(MRESULT)(TRUE);
	else
	   return(MRESULT)(FALSE);
	break;

   case WM_USER_END_ON_ERROR:	       /* Display error and end program */
	WinMessageBox(HWND_DESKTOP,
		      hWnd,
		      (PSZ)PVOIDFROMMP(mp2),
		      (PSZ)PVOIDFROMMP(mp1),
		      (USHORT)0,
		      MB_OK | MB_MOVEABLE | MB_CUACRITICAL | MB_APPLMODAL);
	WinPostMsg(hWnd,
		   WM_QUIT,
		   MPFROMSHORT(0),
		   MPFROMSHORT(0));
	break;
   case WM_USER_DEFINED_CODE:	       /* own messages			*/
	switch (SHORT1FROMMP(mp1))
	   {
	   case CHECK_ITEM:	       /* check item in file menu	*/
		break;
	   }

   case WM_COMMAND:
	/*
	 * The PM messages for action bar and pulldown menu items are
	 * processed in this routine.
	 */
	switch(SHORT1FROMMP(mp1))
	   {
	   case IDM_F_GPI:	       /* menu item "GPI"		*/
	       *Parm.Message = '\0';
		if (Parm.CheckedItem != 1)
		{
		   StopDrawing(&Parm);
		   if (GpiResetPS(Parm.hpsClient, GRES_ALL) == GPI_ERROR)
		       DispError(Parm.hAB,Parm.hWndClient);
		   SendCommand(&Parm, (ULONG)SET_TRANSFORM, (ULONG)NULL);
		   SendCommand(&Parm, (ULONG)DRAW_ORDERS, (ULONG)NULL);
		   Parm.DrawThreadActivated = TRUE;
		   CheckPulldown(&Parm, 1);
		   SetTitleBarText(&Parm, "GPI");
		}
		break;

	   case IDM_F_METAFILE_LOAD:/* load metafile from menu item "METAFILE"*/
		*Parm.Message = '\0';
		strcpy(Filemask, Parm.MetafilePath);
		FileName = strrchr(Filemask, (int)'\\');
		if (FileName == NULL)
		   FileName = Filemask;
		else
		   FileName++;
		strcpy(FileName, "*.MET");

		/* Display File Dialog */
		DialogHeader = GetString(Parm.hAB, FILEDLG_META_HEADER,
					 ALLOC_STRING);
		if (OpenFileDialog(Parm.hWndFrame, DialogHeader,
				   Filemask, Filename))
		   {
		      strcpy(Parm.MetafilePath, Filename);
		      WinSendMsg(hWnd,
				 IDM_F_METAFILE,
				 MPFROMSHORT(0),
				 MPFROMSHORT(0));
		   }
		free(DialogHeader);
		break;

	   case IDM_F_PRINT:		  /* menu item "Print"		*/
		switch (Parm.CheckedItem)
		   {
		   case 1:	       /* print GPI */
			PrintGpiMeta(&Parm, DRAW_GPI);
			break;
		   case 2:	       /* print Metafile */
			PrintGpiMeta(&Parm, DRAW_META);
			break;
		   }
		break;

	   case IDM_O_PRINTPROPERTIES:	 /*  menu item "Job properties" */
		QueryJobProperties(Parm.hAB,
				   &Parm.DriverData,
				   &Parm.DriverDataLength,
				   Parm.DriverName,
				   Parm.QueueName,
				   NULL, TRUE);

		break;

	   case IDM_H_HELPINDEX:	/* menu item "Help for Index"  */
		if (Parm.hWndGRAPHICHelp)
		   WinSendMsg(Parm.hWndGRAPHICHelp, HM_DISPLAY_HELP,
			     MPFROMSHORT(HELP_INDEX), 0L);
		break;

	   case IDM_H_HELPGEN:		/* menu item "Help for General"*/
		if (Parm.hWndGRAPHICHelp)
		   WinSendMsg(Parm.hWndGRAPHICHelp, HM_DISPLAY_HELP,
			     MPFROMSHORT(HELP_GEN), 0L);
		break;

	   case IDM_H_HELPUSING:	/* menu item "Help for Using"  */
		if (Parm.hWndGRAPHICHelp)
		   WinSendMsg(Parm.hWndGRAPHICHelp, HM_DISPLAY_HELP,
			     MPFROMSHORT(HELP_USING), 0L);
		break;

	   case IDM_H_HELPKEYS:		/* menu item "Help for Keys"   */
		if (Parm.hWndGRAPHICHelp)
		   WinSendMsg(Parm.hWndGRAPHICHelp, HM_DISPLAY_HELP,
			      MPFROMSHORT(HELP_KEYS), 0L);
		break;

	   case IDM_H_ABOUT:		/* menu item "About"	       */
		WinDlgBox(HWND_DESKTOP, hWnd, (PFNWP)AboutDlg,
			  0, ID_ABOUT, (PBYTE)NULL);
		break;

	   default:
		break; /* End of default case for switch(mp1) */
	   }
	 break; /* End of WM_COMMAND */

    case IDM_F_METAFILE:
	 StopDrawing(&Parm);
	 if (GpiResetPS(Parm.hpsClient, GRES_ALL) == GPI_ERROR)
	     DispError(Parm.hAB,Parm.hWndClient);
	 if (LONGFROMMP(mp1) == 0L)
	    hmfPicture = GpiLoadMetaFile(Parm.hAB, Parm.MetafilePath);
	 else
	    hmfPicture = (HMF)LONGFROMMP(mp1);
	 if (hmfPicture == (HMF)NULL)
	    {
	    StringWithVarText(Parm.hAB, ERRMSG_METAFILE_FAILED,
			      Parm.MetafilePath, Parm.Message),
	    Parm.fNotReady = FALSE;
	    DisplayMessage(Parm.hWndClient, Parm.Message);
	    }
	 else
	    {
	    SendCommand(&Parm, (ULONG)SET_TRANSFORM,
			(ULONG)hmfPicture);
	    SendCommand(&Parm, (ULONG)DRAW_ORDERS, (ULONG)NULL);
	    Parm.DrawThreadActivated = TRUE;
	    CheckPulldown(&Parm, 2);
	    if (LONGFROMMP(mp1) == 0L)
	       SetTitleBarText(&Parm, Parm.MetafilePath);
	    else
	       SetTitleBarText(&Parm, "!Clipboard Metafile");
	    }
	 break;

    case WM_INITMENU:	   /* message appears on selecting a pulldown menu */
	 switch(SHORT1FROMMP(mp1))
	    {
	    case IDM_FILE:	       /* set items "Print" and "Print      */
	    case IDM_OPTIONS:	       /* properties" when menu is selected */
		 SetPrintItems(&Parm);
		 break;
	    case IDM_F_METAFILE:
		 /* test, if metafile data in the clipboard */
		 /* test, if a metafile was selected */
		   if (*Parm.MetafilePath != '\0')
		    {
		    FileName = strrchr(Parm.MetafilePath, (int)'\\');
		    if (FileName == NULL)
		       FileName = Parm.MetafilePath;
		    else
		       FileName++;
		    WinSendMsg(HWNDFROMMP(mp2),
			       MM_INSERTITEM,
			       MPFROMP(&mi),
			       MPFROMP(FileName));
		    MenuUpdated = TRUE;
		    }
		 break;
	    }
	 break;

   case WM_DESTROY:
      /*
       * The application has asked for the window to be destroyed.
       * Where appropriate, the region and the graphics presentation
       * spaces are destroyed.
       */
      if (Parm.DrawParm.hrgnInvalid != (HRGN)NULL)
	 if (GpiDestroyRegion(Parm.hpsClient,
			      Parm.DrawParm.hrgnInvalid) == GPI_ERROR)
	     DispError(Parm.hAB,Parm.hWndClient);
      if (Parm.hpsClient !=(HPS)NULL)
	 {
	  if (GpiAssociate(Parm.hpsClient, (HDC)NULL) == GPI_ERROR)
	      DispError(Parm.hAB,Parm.hWndClient);
	  if (GpiDestroyPS(Parm.hpsClient) == GPI_ERROR)
	      DispError(Parm.hAB,Parm.hWndClient);
	 }
      if (Parm.hpsPaint !=(HPS)NULL)
	 if (GpiDestroyPS(Parm.hpsPaint) == GPI_ERROR)
	     DispError(Parm.hAB,Parm.hWndClient);
      break;

   case WM_MINMAXFRAME:		  /* minimize/maximize window */
	WindowPos = PVOIDFROMMP(mp1);
	if (WindowPos->fl & SWP_MINIMIZE)
	   {
	   WindowMinimized = TRUE;
	   if (Parm.DrawThreadActivated)
	      SendCommand(&Parm, (ULONG)FLUSH_COMMAND, (ULONG)NULL);
	   }
	else
	   {
	   WindowMinimized = FALSE;
	   }
	break;


   case HM_QUERY_KEYS_HELP:
	/*
	 * If the user requests Keys Help from the help pulldown,
	 * IPF sends the HM_QUERY_KEYS_HELP message to the application,
	 * which should return the panel id of the Keys Help panel
	 */
	return (MRESULT)PANEL_HELPKEYS;	 /* return id of key help panel */
	break;

   case HM_ERROR:
	/*
	 * If an IPF error occurs, an HM_ERROR message will be sent to
	 * the application.
	 */
	if (Parm.hWndGRAPHICHelp && ((ULONG)mp1) == HMERR_NO_MEMORY)
	   {
	   WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
			 GetString(Parm.hAB, ERRMSG_HELP_TERMINATED,
				   STATIC_STRING),
			 Parm.ProgramTitle,
			 1,
			 MB_OK | MB_APPLMODAL | MB_MOVEABLE);
	   WinDestroyHelpInstance(Parm.hWndGRAPHICHelp);
	   }
	 else
	   {
	   strcpy(Parm.ErrorMsg,
		  GetString(Parm.hAB, ERRMSG_HELP_ERROR, STATIC_STRING));
	   ltoa(LONGFROMMP(mp1), &Parm.ErrorMsg[strlen(Parm.ErrorMsg)], 16);

	   WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
			 (PSZ)Parm.ErrorMsg,
			 (PSZ)Parm.ProgramTitle,
			 1,
			 MB_OK | MB_APPLMODAL | MB_MOVEABLE);
	   }
	break;

   case WM_SIZE:     /* code for sizing client area */
	if (WindowMinimized)
	   break;
	if (Parm.ResizeWindow)
	   AdjustWindowSize(&Parm);
	else
	   Parm.ResizeWindow = TRUE;
	if (Parm.DrawThreadActivated)  /* cancel any pending draw requests */
	{
	   SendCommand(&Parm, (ULONG)FLUSH_COMMAND, (ULONG)NULL);
	   SendCommand(&Parm, (ULONG)SIZING, (ULONG)NULL);
	}
	WinPostMsg(Parm.InfoWnd.hWnd,	  /* reposition information window */
		   POS_INFO_WND,
		   MPFROMSHORT(0),
		   MPFROMSHORT(0));
	break;	     /* End of WM_SIZE */

   case WM_PAINT:    /* code for the window's client area */
	if (Parm.DrawThreadActivated)
	   return(WndProcPaint(&Parm));
	/* Obtain a handle to a cache presentation space */
	hPS = WinBeginPaint(hWnd, 0, 0);

	/* Determine the size of the client area */
	WinQueryWindowRect(hWnd, &rClient);

	/* Fill the background with the default background color */
	WinFillRect(hPS, &rClient, CLR_BACKGROUND);

	/* return presentation space to state before WinBeginPaint */
	WinEndPaint(hPS);

	break; /* End of WM_PAINT */

   default:
	/*
	 * For any message which you don't specifically provide a
	 * service routine, you should return the message to PM using
	 * the WinDefWindowProc function.
	 */
	return(WinDefWindowProc(hWnd, message, mp1, mp2));
	break;	/* End of default */
   }
return(0L);
} /* End of WndProc */

/*************************************************************************
 * Function: CheckPulldown
 *
 * Check one of the pulldown items "GPI", "METAFILE"
 *
 * Parameters: PMAIN_PARM   main parameter structure
 *	       ULONG	   number of item to check
 *
 * Result:  none
 *
 ***************************************************************************/
VOID CheckPulldown(PMAIN_PARM Parm, LONG index)
{
static	 ULONG	   Items[] =
		    {
		    IDM_F_GPI,
		    IDM_F_METAFILE,
		    };

/* if item already checked, do nothing */
   if (Parm->CheckedItem != index)
   {
      if (index == 0)		       /* If text is selected */
      {
	 WinSendMsg(Parm->hWndFrame,
		 WM_USER_DEFINED_CODE,
		 MPFROMSHORT(INIT_MLE),
		 MPFROMSHORT(TRUE));
      }
      if (Parm->CheckedItem == 0)      /* If text is deselected */
      {
	 WinSendMsg(Parm->hWndFrame,
		 WM_USER_DEFINED_CODE,
		 MPFROMSHORT(INIT_MLE),
		 MPFROMSHORT(FALSE));
      }
      Parm->CheckedItem = index;
      if (!index)
	 InvalidateTextRect(Parm->hWndClient);
   }
} /* End of CheckPullDown */

/*************************************************************************
 * Function: AdjustWindowSize
 *
 * resize frame window
 *
 * Parameters: PMAIN_PARM   main parameter structure
 *
 * Result:  none
 *
 ***************************************************************************/
VOID AdjustWindowSize(PMAIN_PARM Parm)
{
   SWP	      SizeFrame;
   SWP	      SizeClient;
   HPS	      hPS;
   SIZEF      CharSizeClient;

   hPS = WinGetPS(Parm->hWndClient);	     /* get PS of client area	   */

   /* get size of character box */
   if (GpiQueryCharBox(hPS, (PSIZEF)&CharSizeClient) == GPI_ERROR)
       DispError(Parm->hAB,Parm->hWndClient);

   WinReleasePS(hPS);			     /* release presentation space */

   WinReleasePS(hPS);			     /* release presentation space */
   /*
    * resize window, so that at least the information line and one line of
    * the multiline edit field can be displayed
    */
   WinQueryWindowPos(Parm->hWndFrame,
		     &SizeFrame);

   WinQueryWindowPos(Parm->hWndClient,
		     &SizeClient);
} /* End of AdjustWindowSize */

/*************************************************************************
 * Function: WndProcCreate
 *
 * The WndProcCreate function obtains a device context for the client
 * area of the window, creates a normal graphics presentation space,
 * and associates the two. The presentation page is defined in pels,
 * and is the same size as the maximum client area.
 * A second graphics presentation space is defined for use by the main
 * thread. This is the same size and format as the first presentation
 * space.  WndProcCreate also defines an empty region for hpsClient.
 * This is used by the asynchronous thread to accumulate invalid
 * regions in the client area.
 *
 * Parameters: HWND	    window handle of the frame window
 *	       PMAIN_PARM   main parameter structure
 *
 * Result:  MRESULT	    TRUE if an error appeared, otherwise false
 *
 ***************************************************************************/
MRESULT WndProcCreate(HWND hwnd, PMAIN_PARM Parm)
{
   SIZEL      sizlClient;

/* query size of Desktop */
   sizlClient.cx = WinQuerySysValue(HWND_DESKTOP, SV_CXFULLSCREEN);
   sizlClient.cy = WinQuerySysValue(HWND_DESKTOP, SV_CYFULLSCREEN);

   /* open device context for client area */
   Parm->hdcClient = WinOpenWindowDC(hwnd);
   /* create presentation space for client area	 and associate it with DC */
   Parm->hpsClient = GpiCreatePS(Parm->hAB,
				 Parm->hdcClient,
				 &sizlClient,
				 GPIA_ASSOC | PU_PELS);
   if (Parm->hpsClient == (HPS)NULL)
      return((MRESULT)TRUE);

   /* create presentation space for painting */
   Parm->hpsPaint = GpiCreatePS(Parm->hAB,
				(HDC)NULL,
				&sizlClient,
				PU_PELS);

   /* create region for client area */
   Parm->DrawParm.hrgnInvalid = GpiCreateRegion(Parm->hpsClient,
						(ULONG)0, (PRECTL)NULL);

   return(FALSE);
} /* End of WndProcCreate */

/*************************************************************************
 * Function: SetPrintItems
 *
 * Test (default) printer queue and enable/disable menu items "Print" and
 * "Print properties".
 *
 * Parameters: PMAIN_PARM   main parameter structure
 *
 * Result:  none
 *
 ***************************************************************************/
VOID SetPrintItems(PMAIN_PARM Parm)
{
BOOL	   QueuePredefined;

					/* test, if queue preselected */
   if (Parm->QueueName[0] == '\0')
      QueuePredefined = FALSE;
   else
      QueuePredefined = TRUE;
/*
 * if queue preselected, test if queue is already valid, otherwise query
 * default queue
 */
   if (QueryDefaultQueue(Parm->QueueName, Parm->DriverName))
   {
   /*
    * if item "Print" is disabled and no print request is running, enable
    * menu item "Print"
    */
      if (!Parm->PrintEnabled)
      {
	 if (!Parm->PrintStatus)
	 {
	    WinSendMsg(WinWindowFromID(Parm->hWndFrame, (USHORT)FID_MENU),
		    MM_SETITEMATTR,
		    MPFROM2SHORT(IDM_F_PRINT, TRUE),
		    MPFROM2SHORT(MIA_DISABLED, ~MIA_DISABLED));
	    Parm->PrintEnabled = TRUE;
	 }
      }
      else
   /*
    * if item "Print" is enabled and a print request is running, disable
    * menu item "Print"
    */
	 if (Parm->PrintStatus)
	 {
	    WinSendMsg(WinWindowFromID(Parm->hWndFrame, (USHORT)FID_MENU),
		    MM_SETITEMATTR,
		    MPFROM2SHORT(IDM_F_PRINT, TRUE),
		    MPFROM2SHORT(MIA_DISABLED, MIA_DISABLED));
	    Parm->PrintEnabled = FALSE;
	 }
   /* if menu item "Print properties" is disabled, enable item */
      if (!Parm->PrintPropertiesEnabled)
      {
	 WinSendMsg(WinWindowFromID(Parm->hWndFrame, (USHORT)FID_MENU),
		 MM_SETITEMATTR,
		 MPFROM2SHORT(IDM_O_PRINTPROPERTIES, TRUE),
		 MPFROM2SHORT(MIA_DISABLED, ~MIA_DISABLED));
	 Parm->PrintPropertiesEnabled = TRUE;
      }
   }
   else
   {
   /*
    * if printer queue is not valid, disable menu items "Print" and
    * "Print properties
    */
      if (Parm->PrintEnabled)
      {
	 WinSendMsg(WinWindowFromID(Parm->hWndFrame, (USHORT)FID_MENU),
		 MM_SETITEMATTR,
		 MPFROM2SHORT(IDM_F_PRINT, TRUE),
		 MPFROM2SHORT(MIA_DISABLED, MIA_DISABLED));
	 Parm->PrintEnabled = FALSE;
      }
      if (Parm->PrintPropertiesEnabled)
      {
	 WinSendMsg(WinWindowFromID(Parm->hWndFrame, (USHORT)FID_MENU),
		 MM_SETITEMATTR,
		 MPFROM2SHORT(IDM_O_PRINTPROPERTIES, TRUE),
		 MPFROM2SHORT(MIA_DISABLED, MIA_DISABLED));
	 Parm->PrintPropertiesEnabled = FALSE;
      }
      if (!QueuePredefined)
	 *Parm->QueueName = '\0';
   }
} /* End of SetPrintItems */

/*************************************************************************
 * Function: StopDrawing
 *
 * Stop drawing "GPI or "METAFILE"  on request.
 *
 * Parameters: PMAIN_PARM   main parameter structure
 *
 * Result:  none
 *
 ***************************************************************************/
VOID StopDrawing(PMAIN_PARM Parm)
{
ULONG	   ResetCount;
    /*
     * if not "GPI" or "METAFILE"  do nothing
     * if ((Parm->CheckedItem < 1) || (Parm->CheckedItem > 3))
     */
   if (Parm->CheckedItem < 1)
      return;

   if (Parm->DrawThreadID != -1)
   {
      if (Parm->hpsClient != (HPS)NULL)
	 if (GpiSetStopDraw(Parm->hpsClient, (LONG)TRUE) == GPI_ERROR)
	    DispError(Parm->hAB,Parm->hWndClient);
      WinRequestMutexSem(Parm->hmtxsemStoppable, (ULONG)-1);
      Parm->fStoppable = TRUE;
      DosReleaseMutexSem(Parm->hmtxsemStoppable);
      SendCommand(Parm, FLUSH_COMMAND, 0L);
      DosResetEventSem(Parm->hevsemStop, &ResetCount);
      if (SendCommand(Parm, STOP_DRAWING, 0L))
	 WinWaitEventSem(Parm->hevsemStop, (ULONG)-1);
   }
} /* End of StopDrawing */

/*************************************************************************
 * Function: AboutDlg
 *
 * Dialog procedure for About dialog box.
 *
 * Parameters: HWND	    window handle of dialog box
 *	       USHORT	    message
 *	       MPARAM	    message parameter 1
 *	       MPARAM	    message parameter 2
 *
 * Result:  MRESULT	    message result
 *
 ***************************************************************************/
MRESULT EXPENTRY AboutDlg(HWND hWnd, USHORT msg, MPARAM mp1, MPARAM mp2)
{

   switch (msg)
   {
   case DLG_OK:
	WinDismissDlg(hWnd, FALSE);
	break;
   default:
	return(WinDefDlgProc(hWnd, msg, mp1, mp2));
   }
   return (MRESULT)FALSE;
} /* End of AboutDlg */

/**************************************************************************
 * Function: InvalidateTextRect
 *
 * Query size of information line and invalidate that rectangle.
 *
 * Parameters: HWND	    window handle of client area
 *
 * Result:  none
 *
 ***************************************************************************/
static VOID InvalidateTextRect(HWND hWnd)
{
   HPS	       hPS;
   FONTMETRICS ActFont;
   RECTL       Rectl;

   WinQueryWindowRect(hWnd, &Rectl);
   hPS = WinGetPS(hWnd);
   if (GpiQueryFontMetrics(hPS, (LONG)sizeof(FONTMETRICS), &ActFont) == GPI_ERROR)
       DispError(Parm.hAB,Parm.hWndClient);
   WinReleasePS(hPS);

   Rectl.yBottom = Rectl.yTop - ActFont.lMaxBaselineExt;
   WinInvalidateRect(hWnd, &Rectl, FALSE);
} /* End of InvalidateTextRect */

/*************************************************************************
 * Function: WndProcI
 *
 * Window procedure for information window.
 *
 * Parameters: HWND	    window handle of information window
 *	       USHORT	    message
 *	       MPARAM	    message parameter 1
 *	       MPARAM	    message parameter 2
 *
 * Result:  MRESULT	    message result
 *
 ***************************************************************************/
MRESULT EXPENTRY WndProcI(HWND hWndI, ULONG Msg, MPARAM mp1, MPARAM mp2)
{
	 PMAIN_PARM Parm;
	 FONTMETRICS ActFont;
	 HPS	    hPS;
	 SWP	    WinPos;
	 RECTL	    rInfo;
	 POINTL	    DrawPos;
static	 PSZ	    Message;

   if (Msg != WM_CREATE)
      Parm = WinQueryWindowPtr(hWndI, 0);

   switch (Msg)
   {
   case WM_CREATE:	/* Set window pointer to main parameter stucture   */
	Parm = (PMAIN_PARM)PVOIDFROMMP(mp1);
	Message = GetString(Parm->hAB, TEXT_SPOOLING_MESSAGE, ALLOC_STRING);
	WinSetWindowPtr(hWndI, 0, (PVOID)Parm);
	break;
   case ENABLE_INFO_WND:	       /* show/hide information window	   */
	if (Parm->InfoWnd.SizeX == 0)  /* if first call, calculate size of */
	   {			       /* information window		   */
	   hPS = WinGetPS(hWndI);
	   if (GpiQueryFontMetrics(hPS, (LONG)sizeof(FONTMETRICS), &ActFont) == GPI_ERROR)
	       DispError(Parm->hAB,Parm->hWndClient);
	   Parm->InfoWnd.SizeY = (LONG)ActFont.lMaxBaselineExt;
	   Parm->InfoWnd.DrawLine = (LONG)ActFont.lMaxDescender;
	   Parm->InfoWnd.SizeX = (LONG)12 * (LONG)ActFont.lAveCharWidth;
	   WinReleasePS(hPS);
	   WinSetWindowPos(hWndI,
			   (HWND)NULLHANDLE,
			   0L, 0L, Parm->InfoWnd.SizeX,
			   Parm->InfoWnd.SizeY,
			   SWP_SIZE | SWP_HIDE);
	   }
	/* show/hide information window */
	Parm->InfoWnd.EnableWindow = SHORT1FROMMP(mp1);
	if (!Parm->InfoWnd.EnableWindow)
	   {
	   WinSetWindowPos(hWndI, (HWND)NULLHANDLE,
			   0L, 0L, 0L, 0L,
			   SWP_HIDE);
	   }
	else
	   {
	   WinSendMsg(hWndI,
		      POS_INFO_WND,
		      MPFROMSHORT(0),
		      MPFROMSHORT(0));
	   WinInvalidateRect(hWndI, (PRECTL)NULL, TRUE);
	   }
	break;
   case POS_INFO_WND:		       /* reposition info window if frame */
	if (Parm->InfoWnd.EnableWindow)
	{
	WinQueryWindowPos(Parm->hWndClient, &WinPos); /* window is resized */
	WinSetWindowPos(hWndI, (HWND)HWND_TOP,
			WinPos.cx - Parm->InfoWnd.SizeX,
			WinPos.cy - Parm->InfoWnd.SizeY,
			0L, 0L,
			SWP_MOVE | SWP_SHOW);
	}
	break;
   case WM_PAINT:			     /* paint information window if*/
	if (Parm->InfoWnd.EnableWindow)	     /* window is shown		   */
	   {
	   hPS = WinBeginPaint(hWndI, 0, 0);
	   WinQueryWindowRect(hWndI, &rInfo);
	   WinFillRect(hPS, &rInfo, CLR_RED);
	   GpiSetColor(hPS, CLR_WHITE);
	   DrawPos.x = 4L;
	   DrawPos.y = (LONG)Parm->InfoWnd.DrawLine;
	   GpiCharStringAt(hPS, &DrawPos, strlen(Message) - 1L,
			   Message);
	   WinEndPaint(hPS);
	   }
	else
	   return(WinDefWindowProc(hWndI, Msg, mp1, mp2));
	break;
   default:
	return(WinDefWindowProc(hWndI, Msg, mp1, mp2));
   }
   return (MRESULT)FALSE;
} /* End of WndProcI */

/*************************************************************************
 * Function: SetTitleBarText
 *
 * Change Text of Titlebar
 *
 * Parameters: PMAIN_PARM   Pointer to main parameter structure
 *	       PSZ	    filename to display
 *
 * Result:  none
 *
 ***************************************************************************/
VOID SetTitleBarText(PMAIN_PARM Parm, PSZ Filename)
{
static	 CHAR	    TitleBarText[80];
	 PSZ	    Ptr;

   strcpy(TitleBarText, Parm->ProgramTitle);
   if (Filename != (PSZ)NULL)
      if (*Filename == '!')
      {
	 strcat(TitleBarText, " - ");
	 strcat(TitleBarText, &Filename[1]);
      }
      else
	 if (*Filename != '\0')
	 {
	    strcat(TitleBarText, " - \"");

	 /* Set Ptr to first character after the path if possible */
	    if ((Ptr = strrchr(Filename, '\\')) == NULL)
	       Ptr = Filename;
	    else
	       Ptr++;

	    strcat(TitleBarText, Ptr);
	    strcat(TitleBarText, "\"");
	 }

/* Set Title Bar Text */
   WinSetWindowText(WinWindowFromID(Parm->hWndFrame, FID_TITLEBAR),
		 TitleBarText);
} /* End of SetTitleBarText */

/**************************************************************************
 * Function: GetString
 *
 * Get String from resource file
 *
 * Parameters: HAB	    Anchor block handle
 *	       ULONG	    ID of string
 *	       BOOL	    FALSE - Use static field
 *			    TRUE  - allocate space for the string
 *
 * Result:  PSZ	       Pointer to the loaded string or NULL if error
 *
 ***************************************************************************/
PSZ GetString(HAB hAB, ULONG ID, BOOL Alloc)
{
   LONG	      sLength;
   static PSZ Field[256];
   PSZ	      Ptr;

   if ((sLength = WinLoadString(hAB,
				(HMODULE)NULLHANDLE,
				ID,
				sizeof(Field),
				(PSZ)Field)) == 0)
      return(NULL);

   if (Alloc)
   {
      Ptr = malloc(sLength + 1);
      memcpy(Ptr, Field, sLength + 1);
      return(Ptr);
   }

   return  (PSZ)Field ;
} /* End of GetString */

/**************************************************************************
 * Function: StringWithVarText
 *
 * Get String from resource file
 *
 * Parameters: HAB	    Anchor block handle
 *	       ULONG	    ID of string
 *	       PSZ	    Pointer to variable text
 *	       PSZ	    Pointer to output buffer
 *
 * Result:  PSZ	       Pointer to output buffer
 *
 ***************************************************************************/
PSZ StringWithVarText(HAB hAB, ULONG ID, PSZ VarText, PSZ Result)
{
   PSZ	      Field;
   PSZ	      Ptr;

   Field = GetString(hAB, ID, STATIC_STRING);

   if ((Ptr = strstr(Field, "<t>")) == NULL)
      Ptr = strstr(Field, "<T>");

   strcpy(Result, Field);

   if (Ptr != NULL)
   {
      strcpy(&Result[Ptr - Field], VarText);
      strcat(Result, &Ptr[3]);
   }

   return(Result);
} /* End of StringWithVarText */

/**************************************************************************
 * Function: TemplateOpenFilterProc
 *
 * TemplateOpenFilterProc - This is a procedure that will filter the help
 *			     messages to the open dialog.
 *
 * Parameters: HWND	   window handle of information window
 *	       USHORT	   message
 *	       MPARAM	   message parameter 1
 *	       MPARAM	   message parameter 2
 *
 ***************************************************************************/
MRESULT EXPENTRY TemplateOpenFilterProc(HWND hwnd, ULONG message,
					MPARAM mp1, MPARAM mp2)
{

  if(message == WM_HELP)
  {
      DisplayHelpPanel(HID_FS_OPEN_DLG_HELP_PANEL);
       return FALSE ;
  }

   return WinDefFileDlgProc( hwnd, message, mp1, mp2 ) ;
} /* End of TemplateOpenFilterProc */

/**************************************************************************
 * Function: DisplayHelpPanel(idPanel)
 *
 * DisplayHelpPanel - Displays the help panel whose id is given
 *
 *  Usage:  Called whenever a help panel is desired to be
 *	    displayed, usually from the WM_HELP processing
 *	    of the dialog boxes
 *
 *  Method: Sends HM_DISPLAY_HELP message to the help instance
 *
 ***************************************************************************/
VOID DisplayHelpPanel(SHORT idPanel)
{
   if(WinSendMsg(Parm.hWndGRAPHICHelp,
		 HM_DISPLAY_HELP,
		 MPFROMLONG(MAKELONG(idPanel, NULL)),
		 MPFROMSHORT(HM_RESOURCEID)))
   {
      strcpy(Parm.ErrorMsg,
	  GetString(Parm.hAB, ERRMSG_HELPDISPLAYERROR, STATIC_STRING));
   }

} /* End of DisplayHelpPanel */

/**************************************************************************
 * Function: DispError
 *
 *  DispError -- report an error returned from an API service.
 *
 *  Usage:  The error message is displayed using a message box
 *
 ***************************************************************************/
VOID DispErrorMsg(HAB hab, HWND hwndFrame, PCH FileName, LONG LineNum)
{
   PERRINFO  pErrInfoBlk;
   PSZ	     pszOffSet, pszErrMsg;
   ERRORID   ErrorId;
   PCH	     ErrorStr;
   CHAR	     szbuff[125];

   DosBeep(800,10);

   if (!hab)
   {					 /* Non-PM Error */
      WinLoadString(Parm.hAB, 0L, IDS_UNKNOWNMSG, sizeof(szbuff), (PSZ)szbuff);
      ErrorStr = malloc(strlen(szbuff)+strlen(FileName)+10);
      sprintf(ErrorStr, szbuff, FileName, LineNum);
      WinMessageBox(HWND_DESKTOP,	  /* Parent window is desk top */
		   hwndFrame,		 /* Owner window is our frame */
		   (PSZ)ErrorStr,	 /* PMWIN Error message	      */
		   "Error Message",	 /* Title bar message	      */
		   MSGBOXID,		 /* Message identifier	      */
		   MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL ); /* Flags */
      free(ErrorStr);
      return;
   }

   ErrorId = WinGetLastError(Parm.hAB);

   if ((pErrInfoBlk = WinGetErrorInfo(Parm.hAB)) != (PERRINFO)NULL)
   {
      pszOffSet = ((PSZ)pErrInfoBlk) + pErrInfoBlk->offaoffszMsg;
      pszErrMsg = ((PSZ)pErrInfoBlk) + *((PSHORT)pszOffSet);

      WinLoadString(Parm.hAB, 0L, IDS_ERRORMSG, sizeof(szbuff), (PSZ)szbuff);
      ErrorStr = malloc(strlen(szbuff)+strlen(pszErrMsg)+strlen(FileName)+10);
      sprintf(ErrorStr, szbuff, pszErrMsg, FileName, LineNum);

      WinMessageBox(HWND_DESKTOP,	  /* Parent window is desktop */
		   hwndFrame,		 /* Owner window is our frame */
		   (PSZ)ErrorStr,	 /* PMWIN Error message	      */
		   "Error Message",	 /* Title bar message	      */
		   MSGBOXID,		 /* Message identifier	      */
		   MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL ); /* Flags */

      free(ErrorStr);

      WinFreeErrorInfo(pErrInfoBlk);
   }
} /* End of DispErrorMsg */
/****************************** End of Graphic.c **************************/
//*static char *SCCSID = "@(#)hanoi.c   6.22 92/03/18";*/
/*==============================================================*\
 *  HANOI.C - Sample PM application
 *
 *
 *	Copyright  1991	 IBM Corp.					   *
 *									   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *	*
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have been *
 *	advised of the possibility of	such damages.			   *				   *
 *--------------------------------------------------------------
 *
 *  This program implements a tower of hanoi program.  This
 *  sample app was written to demonstrate the use of a multi-
 *  threaded program.  The main thread handles the PM interface,
 *  the second thread is started to do the recursive execution
 *  of the hanoi algorithm.
 *
 *--------------------------------------------------------------
 *
 *  This source file contains the following functions:
 *	main(argc, *argv[]) - main routine
 *	MainWndProc(hwnd, msg, mp1, mp2) - main window procedure
 *	MainPaint(hwnd) - WM_PAINT processing of main
 *	MainCommand(mp1, mp2) - WM_COMMAND processing of main
 *	CalcThread() - Sets up and terminates the secondary thread
 *	DrawDisk(hps, cPole, bLevel, fDraw) - Draws or erases a disk
 *					      from poles
 *	MoveDisk(hps, bFrom, bTo) - Moves a disk from one pole to another
 *	Hanoi(bHeight, bFrom, bTo, bTemp) - Recursive routine for tower
 *					    of hanoi
 *	EnableMenuItem(hwnd, sMenuItem, fEnable) - Activates/deactivates
 *						   a menu choice
 *	EntryFldDlgProc(hwnd, msg, mp1, mp2) - Handles the set number of
 *					       disks dialog box
 *	SetupTowers() - Sets up the global tower data
 *	FixSysMenu(hwndDlg) - Remove Restore, Size, Min, & Max from
 *			      system menu
 *	AboutDlgProc(hwnd, msg, mp1, mp2) - processing about dlg box
 *	ObjectWndProc(hwnd, msg, mp1, mp2)
 *	MessageBox(hwndOwner, IdMsg, fsStyle, fBeep) - processing all
 *						   message calling
 *	Init(VOID) - iniitializing the process
 *	ExitProc(usTermCode) - terminating the process
 *	CreateBackgroundThread(VOID) - process the background thread creating
 *	BackgroundThread(ulThreadParam) - handle the background thread process
 *	DestroyBackgroundThread(VOID) - destroy background thread process
 *	InitHelp(VOID) - initialize the help process
 *	HelpHelpForHelp(mp2) - processing the help for help message
 *	HelpExtended(mp2) - processing the help for extended message
 *	HelpKeys(mp2) - processing the help menu of keys
 *	HelpIndex(mp2) - processing the help index message
 *	HelpAbout(mp2) - processing the about dlg box message
 *	DisplayHelpPanel(idPanel) - processing the help pannel display
 *	DestroyHelpInstance(VOID) - destroy the help instance
 *	PostBkThreadMsg(msg, mp1, mp2) - handle the background thread meg.
 *
\*==============================================================*/
/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/
#define INCL_WIN
#define INCL_HELP
#define INCL_WINHEAP
#define INCL_WINDIALOGS
#define INCL_WINWINDOWMGR
#define INCL_GPI
#define INCL_GPIPRIMITIVES
#define INCL_GPIBITMAPS
#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES

#include <os2.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "hanoi.h"

/*--------------------------------------------------------------*\
 *  Global variables
\*--------------------------------------------------------------*/
CHAR   szClientClass[] = "Hanoi";
BYTE   abTowers[3][MAXDISKCNT];	   /* Used to hold disk numbers on each post */
BYTE   abTowersNdx[3];		   /* Current number of disks on each post */
BYTE   cTowerSize = DEFAULTSIZE;   /* Holds the total number of disks */
USHORT ausPolePos[3]= {POSTOFFSET, /* Holds offset drawing information */
		       POSTOFFSET + POSTSPACE,
		       POSTOFFSET + 2*POSTSPACE };
ULONG  ulIterations;
TID    tidCalcThread;
BOOL   fContinueCalc;
HWND   hwndMainFrame=0L,	      /* Handle to the main frame window */
       hwndMain;		     /* Handle to the main client window */
CHAR   szAppName[MAXNAMEL];	   /* Buffer for application name string */
HAB    hab;				 /* Anchor block for the process */
HMQ    hmq;			 /* Handle to the process' message queue */
CHAR   szUntitled[MESSAGELEN];		 /* buffer for "Untitled" string */
static BOOL fThreadCreated = FALSE;
static HEV hevThreadInit;	  /* semaphore for thread initialization */
static HAB habBkThread;
static HMQ hmqBkThread;
static TID tidBkThread;
static HWND hwndObject;
static CHAR szObjectClass[MAXNAMEL];
static HEV hevThreadInit;	  /* semaphore for thread initialization */
BOOL   fHelpEnabled;		 /* flag to determine if help is enabled */
static CHAR szLibName[HELPLIBRARYNAMELEN];
static CHAR szWindowTitle[HELPLIBRARYNAMELEN];
static HWND hwndHelpInstance;
BOOL   fViewOn=TRUE;			       /* flag to view on or off */
CHAR   *pszDisk	      ="Disk Information";
CHAR   *pszDisksMoved ="Disks Moved:";

/*--------------------------------------------------------------*\
 *  Entry point declarations					*
\*--------------------------------------------------------------*/
MRESULT EXPENTRY MainWndProc(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY EntryFldDlgProc(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY AboutDlgProc(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY ObjectWndProc(HWND, ULONG, MPARAM, MPARAM);
LONG	MessageBox(HWND, LONG, LONG, BOOL);
VOID APIENTRY ExitProc(ULONG);
BOOL Init(VOID);
VOID MainPaint(HWND);
LONG MainCommand(HWND, MPARAM, MPARAM);
VOID CalcThread(VOID);
VOID DrawDisk(HPS,BYTE,BYTE,BYTE);
VOID MoveDisk(HPS,BYTE,BYTE);
VOID Hanoi(BYTE, BYTE, BYTE, BYTE);
VOID EnableMenuItem(HWND, LONG, BOOL);
VOID SetupTowers(VOID);
VOID FixSysMenu(HWND);

BOOL CreateBackgroundThread(VOID);
VOID BackgroundThread(ULONG);
BOOL PostBkThreadMsg(ULONG, MPARAM, MPARAM);
VOID DestroyBackgroundThread(VOID);

VOID InitHelp(VOID);
VOID HelpHelpForHelp(MPARAM);
VOID HelpExtended(MPARAM);
VOID HelpKeys(MPARAM);
VOID HelpIndex(MPARAM);
VOID HelpAbout(MPARAM);
VOID DisplayHelpPanel(LONG);
VOID DestroyHelpInstance(VOID);

/****************************************************************\
 *  Main routine
 *--------------------------------------------------------------
 *
 *  Name:    main(argc, *argv[])
 *
 *  Purpose: Initializes the PM environment, calls the initialization
 *	     routine, creates main window, and polls the message queue
 *
 *  Usage:
 *
 *  Method:  - obtains anchor block handle and creates message
 *	       queue
 *	     - calls the initialization routine
 *	     - creates the main frame window which creates the
 *	       main client window
 *	     - polls the message queue via Get/Dispatch Msg loop
 *	     - upon exiting the loop, exits
 *
 *  Returns: 0 - if successful execution completed
 *	     1 - if error
 *
\****************************************************************/
INT main(LONG argc, CHAR *argv[])
{
   QMSG	    qmsg;			       /* Message structure */
   ULONG    flCtlData;			      /* Frame control data */
   LONG	    sHold;

   if(argc > 1)	 /* If command line arg, use as the initial number of disks */
   {
      sHold = (LONG)atoi(argv[1]);
      if(sHold>0 && sHold<=MAXDISKCNT)
      cTowerSize = (BYTE) sHold;
   }

   SetupTowers();

   hab = WinInitialize(0L);

   if(!hab)
   {
       DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
       return(RETURN_ERROR);
   }

   hmq = WinCreateMsgQueue(hab, 0L);

   if(!hmq)
   {
       DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
       WinTerminate(hab);
       return(RETURN_ERROR);
   }

   if(!Init())
   {
	MessageBox(HWND_DESKTOP,
		   IDMSG_INITFAILED,
		   MB_OK | MB_ERROR,
		   TRUE);

	return(RETURN_ERROR);
   }
   /* Create the main window */
   flCtlData = FCF_STANDARD;

   hwndMainFrame = WinCreateStdWindow(HWND_DESKTOP,
				      WS_VISIBLE,
				      &flCtlData,
				      szAppName,
				      NULL,
				      WS_VISIBLE,
				      (HMODULE)NULL,
				      ID_RESOURCE,
				      (PHWND)&hwndMain);
   if(hwndMainFrame == NULLHANDLE)
   {
       MessageBox(HWND_DESKTOP,
		  IDMSG_MAINWINCREATEFAILED,
		  MB_OK | MB_ERROR,
		  TRUE);

       return(RETURN_ERROR);
   }
   InitHelp();
   /* Get/Dispatch Message loop */
   while(WinGetMsg(hab, (PQMSG)&qmsg, 0L, 0L, 0L))
       WinDispatchMsg(hab, (PQMSG)&qmsg);

    /* destroy the help instance */
    DestroyHelpInstance();

#ifdef BACKGROUND_THREAD
   DestroyBackgroundThread();
#endif

   return(RETURN_SUCCESS);

}   /* main() */

/****************************************************************\
 *  Initialization routine
 *--------------------------------------------------------------
 *
 *  Name:    Init(VOID)
 *
 *  Purpose: Performs initialization functions required before the main
 *	     window can be created.
 *
 *  Usage:   Called once before the main window is created.
 *
 *  Method:  - installs the routine ExitProc into the DosExitList chain
 *	     - registers all window classes
 *	     - performs any command line processing
 *
 *
 *  Returns: TRUE - initialization is successful
 *	     FALSE - initialization failed
\****************************************************************/
BOOL Init(VOID)
{

    /* Add ExitProc to the exit list to handle the exit processing. If
     * there is an error, then terminate the process since there have
     * not been any resources allocated yet			     */

    if(DosExitList(EXLST_ADD, ExitProc))
    {
	MessageBox(HWND_DESKTOP,
		   IDMSG_CANNOTLOADEXITLIST,
		   MB_OK | MB_ERROR,
		   TRUE);
	DosExit(EXIT_PROCESS, RETURN_ERROR);
    }

     /* load application name from resource file */
    if(!WinLoadString(hab, 0L, IDS_APPNAME, MAXNAMEL, szAppName))
	return FALSE;

	    /* load "untitled" string */
    if(!WinLoadString(hab, 0L, IDS_UNTITLED, MESSAGELEN, szUntitled))
	return FALSE;

	/* register the main client window class */
    if(!WinRegisterClass(hab,
			(PSZ)szAppName,
			(PFNWP)MainWndProc,
			CS_SIZEREDRAW | CS_CLIPCHILDREN,
			0L))
    {
	return FALSE;
    }

    /* If you wish to create a thread for background processing, define
     *	the BACKGROUND_THREAD constant the routine commented out here.
     * The routines for the background thread are in the thrd.c file.
     */

#ifdef BACKGROUND_THREAD
    if(!CreateBackgroundThread())
	return FALSE;
#endif
    return TRUE;
} /* Init() */

/****************************************************************\
 *  Exit list processing procedure
 *--------------------------------------------------------------
 *
 *  Name:    ExitProc(ULONG usTermCode)
 *
 *  Purpose: Cleans up certain resources when the application terminates
 *
 *  Usage:   Routine is called by DosExitList when the application exits
 *
 *  Method:  Global resources, such as the main window and message queue,
 *	     are destroyed and any system resources used are freed.
 *
 *  Returns: Returns EXLST_EXIT to the DosExitList handler
 *
\****************************************************************/
VOID APIENTRY ExitProc(ULONG usTermCode)
			  /* code for the reason for termination */
{

    /* destroy the main window if it exists */
    if(WinIsWindow(hab, hwndMainFrame))	 {
	WinDestroyWindow(hwndMainFrame);
    }
    /*--------------------------------------------------*\
     *	    Any other system resources used
     *	    (e.g. memory or files) should be freed here
    \*--------------------------------------------------*/
    WinDestroyMsgQueue(hmq);

    WinTerminate(hab);

    DosExitList(EXLST_EXIT, (PFNEXITLIST)0L);/* termination complete */
    return;
}					    /* ExitProc() */

/****************************************************************\
 *  Main client window procedure
 *--------------------------------------------------------------
 *
 *  Name:    MainWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
 *
 *  Purpose: Handles all the messages associated with the main window
 *	     and calls the appropriate handling procedures.
 *
 *  Usage:   Called for each message placed in the window's message queue
 *
 *  Method:  Called only by main().  Note that when WM_PAINT executes,
 *	     the secondary thread may change data during the update
 *	     which may cause a problem.	 However, this is NOT a write
 *	     conflict, as only 1 thread does the writing.
 *
 *  Returns: Return values are determined by each message
 *
\****************************************************************/
MRESULT EXPENTRY MainWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   CHAR	  szMsg[MSGBUFSIZE];		/* Sprintf buffer */
   MRESULT sRC;
   SHORT  cxNew,cyNew;


   switch(msg)
   {
      case WM_PAINT:
	 MainPaint(hwnd);
	 break;

      case WM_COMMAND:
	 MainCommand(hwnd, mp1, mp2);
	 break;

      case IDM_DONE:
	 EnableMenuItem(hwnd,IDM_START,TRUE);  /* Reenable Start & set */
	 EnableMenuItem(hwnd,IDM_SET,TRUE);
	 EnableMenuItem(hwnd,IDM_STOP,FALSE);	       /* Disable stop */

	 sprintf(szMsg,"%lu disks were moved.",ulIterations);  /* Print msg */
	 WinMessageBox(HWND_DESKTOP, hwnd, szMsg, "Done!", 0L,
		       MB_OK | MB_MOVEABLE | MB_INFORMATION);
	 SetupTowers();					/* Reset towers */
	 WinInvalidateRect(hwnd,NULL,FALSE);   /* Force a screen redraw */
	 break;

      case HM_QUERY_KEYS_HELP:
	 return ( (MRESULT)PANEL_KEYSHELP);

      default:
	 sRC = WinDefWindowProc(hwnd, msg, mp1, mp2);
	 return sRC;
   }
   return (MRESULT)0L;/* all window procedures should return 0 as a default */
}			  /* MainWndProc() */

/****************************************************************\
 *  Main client painting routine
 *--------------------------------------------------------------
 *
 *  Name:    MainPaint(HWND hwnd)
 *
 *  Purpose: Paints the main client window.
 *
 *  Usage:   Routine is called whenver the client window
 *	     procedure receives a WM_PAINT message
 *
 *
 *  Method:  -begins painting by calling WinBeginPaint and retrieving
 *	      the HPS for the window
 *	     -performs any painting desired
 *	     -ends painting by calling WinEndPaint
 *
 *  Returns: 0 - if successful execution completed
 *	     1 - if error
 *
\****************************************************************/
VOID MainPaint(HWND hwnd)
{
   HPS	  hps;			       /* Handle for painting		*/
   RECTL  rclUpdate, rect;	       /* Rectangle struct for painting */
   POINTL ptl;			       /* Point struct for painting	*/
   BYTE	  cPole,bCnt,cnt;      /* Utility variables		*/
   CHAR	  szBuffer[BUFF_SIZE];
   LONG	  lVert,bHeight;
   FONTMETRICS FontMetrics;

   hps = WinBeginPaint(hwnd, 0L, (PRECTL)&rclUpdate);

   /* Fill update rectangle with window color */
   WinFillRect(hps, (PRECTL)&rclUpdate, SYSCLR_WINDOW);
   WinQueryWindowRect(hwndMain, (PRECTL)&rect);
   /*
    *get the character set size
    */
   GpiQueryFontMetrics(hps,sizeof(FontMetrics),&FontMetrics);
   ptl.x = (rect.xRight - ( strlen(pszDisk) * FontMetrics.lAveCharWidth)) / 2;
   ptl.y = rect.yTop   -  ( (VERT_POS - 2)  * FontMetrics.lEmHeight);
   if(fViewOn) /*view disk information*/
   {
      memset(szBuffer, 0L, sizeof(szBuffer));
      strcpy(szBuffer,pszDisk);
      GpiCharStringAt(hps, &ptl, strlen(szBuffer), szBuffer);
   }
   /*
    *center the base in the middle
    *of our screen
    */
   DrawRect( (rect.xRight - BASELEN) /2,
	     (rect.yTop - BASETHICK)  /2,
	     (rect.xRight + BASELEN) /2,
	     (rect.yTop + BASETHICK)  /2,
	      CLR_DARKGREEN );

   /* Draw the 3 posts */
   lVert   = (rect.yTop - BASETHICK)/2 +BASETHICK ;
   bHeight  = lVert + (cTowerSize *DISKSPACE + POSTEXTRAHT) ;
   for(cnt=0;cnt<3;cnt++)
   {
      ausPolePos[cnt] =
	 ((rect.xRight - BASELEN) /2)+ ((BASELEN -(POSTHALF+POSTWIDTH))/2   * cnt);
      DrawRect(ausPolePos[cnt],
	       bHeight,
	       ausPolePos[cnt]+(POSTHALF+POSTWIDTH),
	       lVert,
	       CLR_DARKGREEN);
   }

   /* Place the appropriate disks on each pole */
   for(cPole=0;cPole<3;cPole++)
   {
      for(bCnt=0;bCnt<abTowersNdx[cPole];bCnt++)
      {
	 DrawDisk(hps,cPole,bCnt,fDRAW);
      }
   }
   WinEndPaint(hps);
   return;
}				      /* MainPaint() */

/****************************************************************\
 *  Main window WM_COMMAND processing procedure
 *--------------------------------------------------------------
 *
 *  Name:    MainCommand(HWND hwnd, MPARAM mp1, MPARAM mp2)
 *
 *  Purpose: Calls the appropriate procedures that deal with the
 *	     selected menu item.
 *
 *  Usage:   Routine is called whenever a WM_COMMAND message is posted
 *	     to the main window.
 *
 *  Method:  a switch statement branches on the id of the menu item
 *	     that posted the message and the appropriate action for
 *	     that item is taken.  Any menu ids that are not part of
 *	     the standard menu set are passed onto the user defined
 *	     WM_COMMAND processing procedure.
 *
 *  Returns: Return values are determined by each message
 *
\****************************************************************/
LONG MainCommand(HWND hwnd, MPARAM mp1, MPARAM mp2)
{
   switch(SHORT1FROMMP(mp1))
   {
      case IDM_START:
			      /* Set continuation fContinueCalc */
	 fContinueCalc = TRUE;
	 ulIterations = 0L;	       /* Zero iteration counter */
	 if (DosCreateThread (&tidCalcThread, (PFNTHREAD)CalcThread,
				   0L, 0L, STACK))
	    DosBeep (440, 175);
	 else		    /* Disallow menu items that could change data */
	 {			    /* while the second thread is running */
	    EnableMenuItem(hwnd, IDM_START, FALSE); /* Disable Start item */
	    EnableMenuItem(hwnd, IDM_SET, FALSE);   /* Disable Set item */
	    EnableMenuItem(hwnd, IDM_STOP, TRUE);   /* Enable Stop item */
	 }
	 break;

      case IDM_STOP:
	 fContinueCalc = FALSE;	      /* Notify thread to quit */
	 break;

      case IDM_SET:		   /* Pop up the query/set box */
	 if(WinDlgBox(HWND_DESKTOP, hwnd,
		   (PFNWP)EntryFldDlgProc, (HMODULE)0L,IDD_SETCOUNT,0L))
	 {
	    SetupTowers();		       /* Reset towers */
	    WinInvalidateRect(hwnd,NULL,FALSE);
	 }
	 break;

      case IDM_ON:
	 fViewOn = TRUE;
	 WinInvalidateRect(hwnd,NULL,FALSE);
	 break;

      case IDM_OFF:
	 fViewOn = FALSE;
	 WinInvalidateRect(hwnd,NULL,FALSE);
	 break;


      case IDM_HELPHELPFORHELP:
	 HelpHelpForHelp(mp2);
	 break;

      case IDM_HELPEXTENDED:
	 HelpExtended(mp2);
	 break;

      case IDM_HELPKEYS:
	 HelpKeys(mp2);
	 break;

      case HM_QUERY_KEYS_HELP:
	 return (PANEL_KEYSHELP);

      case IDM_HELPINDEX:
	 HelpIndex(mp2);
	 break;

      case IDM_HELPPRODUCTINFO:
	 HelpAbout(mp2);
	 break;
   }
   return 0;
}

/****************************************************************\
 *  Creates the Background thread
 *--------------------------------------------------------------
 *
 *  Name:    CreateBackgroundThread(VOID)
 *
 *  Purpose: Routine creates the background thread
 *
 *  Usage:   Routine is called at initialization time to create a
 *	     background processing thread.
 *
 *  Method:  The routine calls DosCreateThread with the Background
 *	     thread routine.
 *
 *  Returns: TRUE if thread is created successfully.
 *	     FALSE if not or if the thread was already created
 *
\****************************************************************/
BOOL CreateBackgroundThread(VOID)
{
    LONG sRet;

    /*------------------------------------------------------------------*
     *	Note: C-runtime considerations:
     *	If you use non-reentrant C runtime functions in the second thread,
     *	then you will need to use _beginthread and _endthread instead of
     *	DosCreateThread and DosExit.
     *------------------------------------------------------------------*/
    if(!fThreadCreated)
    {
	DosCreateEventSem((PSZ)NULL, &hevThreadInit, 0L, FALSE);
	sRet = DosCreateThread(&tidBkThread,
				      (PFNTHREAD)BackgroundThread,
				      0L,
				      0L,
				      THREADSTACKSIZE);
    }
    else
    {
	return FALSE;
    }

		  /* wait until the thread has finished initialization */
    if(DosWaitEventSem(hevThreadInit, SEM_TIMEOUT))
	return FALSE;

    return((BOOL)(sRet == 0));

}   /* CreateBackgroundThread() */

/****************************************************************\
 *  Destroys the Background thread
 *--------------------------------------------------------------
 *
 *  Name:    DestroyBackgroundThread(VOID)
 *
 *  Purpose: Routine destroys the background thread
 *
 *  Usage:   Routine is called at exit time to destroy the background
 *	     processing thread.
 *
 *  Method:  The routine posts a WM_CLOSE message to the object window
 *	     to end its message loop.  It then waits to make sure that
 *	     the thread has been terminated before it returns.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID DestroyBackgroundThread(VOID)
{
   PostBkThreadMsg(WM_CLOSE, NULL, NULL);

   DosWaitThread(&tidBkThread, 0L);
   return;
}				   /* DestroyBackgroundThread() */

/****************************************************************\
 *  DrawDisk procedure
 *--------------------------------------------------------------
 *
 *  Name:    DrawDisk(HPS hps, BYTE cPole, BYTE bLevel, BYTE fDraw)
 *
 *  Purpose: This routine takes a PS handle, the hanoi spindle and
 *	     disk level and draws an appropriately sized disk.
 *
 *  Usage:   Routine is called whenever the disk need to display.
 *
 *  Method:  Does not grab exclusive access to the screen before
 *	     drawing which may cause a problem.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID DrawDisk(HPS hps, BYTE cPole, BYTE bLevel, BYTE fDraw)
{
   USHORT usXstart,usYstart,usWidth;
   POINTL ptl;
   RECTL  rect;		    /* Rectangle struct for painting */
   /* Calculate Bottom of disk */
   WinQueryWindowRect(hwndMain,&rect);
   usYstart = (rect.yTop + BASETHICK) /2 + (DISKSPACE * bLevel);


   /* Calculate the disk's width */
   usWidth = (MAXDISKWIDTH-MINDISKWIDTH) * abTowers[cPole][bLevel]
	      /cTowerSize + MINDISKWIDTH;
   /* Center disk on pole */
   usXstart = (ausPolePos[cPole] - usWidth/2 ) + DISKTHICK;

   if(fDraw == fDRAW)		  /* If we are to draw the disk */
   {
      DrawRect(usXstart,usYstart,usXstart+usWidth,
	       usYstart+DISKTHICK-1,CLR_RED);
   }
   else	      /* We are to erase the disk, then redraw the pole */
   {
      DrawRect(usXstart,usYstart,usXstart+usWidth,
	       usYstart+DISKTHICK-1,CLR_WHITE);
#if 0
      DrawRect(ausPolePos[cPole]-POSTHALF,
	       usYstart,
	       ausPolePos[cPole]-POSTHALF+POSTWIDTH,
	       usYstart+DISKTHICK-1,
	       CLR_DARKGREEN);
#endif
      DrawRect(ausPolePos[cPole],
	       usYstart,
	       ausPolePos[cPole]+POSTHALF+POSTWIDTH,
	       usYstart+DISKTHICK-1,
	       CLR_DARKGREEN);
   }
   return;
}

/****************************************************************\
 *  CalcThread procedure
 *--------------------------------------------------------------
 *
 * Name:    CalcThread(VOID)
 *
 * Purpose: Calls the recursive Hanoi with initial setting of 0,2,1
 *	    meaning from pole 0, to pole 2, using pole 1 as a temporary.
 *	    Hanoi returns when finished, or the user says stop.
 *	    This proc then sets a critical section so the posted
 *	    message won't be handled until the thread is terminated.
 *
 * Usage:   Routine is called whenever a IDM_START message is posted to
 *	    the main window.
 *
 * Method:  No DosExitCritSec() is called since _endthread() supposedly
 *	    clears the critical section when the thread is terminated.
 *
 * Returns: VOID
 *
\****************************************************************/
VOID CalcThread(VOID)
{
   HAB	  habb;			 /* Anchor block for the process */

   habb = WinInitialize(0L);	 /* Called to increase Ring 2 stack size */
   Hanoi(cTowerSize,0,2,1);    /* Execute the recursive routine */
   WinTerminate(habb);

   DosEnterCritSec(); /* Set Crit so the IDM_DONE isn't processed */
		      /* until this thread has completely terminated  */
   WinPostMsg(hwndMain,IDM_DONE,NULL,NULL);

   DosExit (EXIT_THREAD, 0L);		     /* Terminate thread */
   return;
}

/****************************************************************\
 *  EnableMenuItem procedure
 *--------------------------------------------------------------
 *
 * Name:    EnableMenuItem(HWND hwnd, LONG sMenuItem, BOOL fEnable)
 *
 * Purpose: This routine handles enabling/disabling of menu items.  This
 *	    is done by getting Parent and Menu hwnd handles then sending
 *	    the appropriate message.
 *
 * Usage:   Routine is called when enable or disable one item from menu.
 *
 * Method:
 *
 * Returns: VOID
 *
\****************************************************************/
VOID EnableMenuItem(HWND hwnd, LONG sMenuItem, BOOL fEnable)
{
   HWND hwndParent = WinQueryWindow(hwnd, QW_PARENT);
   HWND hwndMenu   = WinWindowFromID(hwndParent, FID_MENU);

   WinSendMsg(hwndMenu, MM_SETITEMATTR,
	      MPFROM2SHORT(sMenuItem, TRUE),
	      MPFROM2SHORT(MIA_DISABLED, fEnable ? 0 : MIA_DISABLED));
   return;
}

/****************************************************************\
 *  Hanoi recursion procedure
 *--------------------------------------------------------------
 *
 *  Name:    Hanoi(BYTE bHeight, BYTE bFrom, BYTE bTo, BYTE bTemp)
 *
 *  Purpose: This routine implements a recursive hanoi program that
 *	     works as follows:	By recursion, move all the disks,
 *	     except for the bottom disk to the temporary stack.
 *	     Then move the bottom disk to the target spindle.
 *	     Now recursively move the stack on the temporary spindle
 *	     to the target spindle.  The limiting case is when Hanoi()
 *	     is called with a bHeight of 0 in which case the depth
 *	     recursion is terminated.
 *
 *  Usage:
 *
 *  Method:  This routine checks the ->fContClac fContinueCalcFlag,
 *	     which is set by the main thread when the user selects
 *	     stop, to see if the user wishes to abort the algorithm.
 *	     If so, it backs out and exits.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID Hanoi(BYTE bHeight, BYTE bFrom, BYTE bTo, BYTE bTemp)
	     /* bHeight - The number of disks in the from stack to move */
	     /* bFrom	- The from spindle number, 0-2 */
	     /* bTo	- The to spindle number, 0-2 */
	     /* bTemp	- The temporary spindle number */
{
   HPS	  hps;				 /* Handle for painting */
   RECTL  rect;		       /* Rectangle struct for painting */
   CHAR	  szBuffer[BUFF_SIZE];
   LONG	  lIncrement = 1;
   POINTL ptl;
   USHORT usCenter;
   FONTMETRICS FontMetrics;

   if(bHeight<=0 || !fContinueCalc)	  /* Exit up if no more */
      return;			 /* disks or the user said Stop */

   Hanoi((BYTE)(bHeight-1),	    /* Move all but bottom disk */
	 (BYTE)bFrom,
	 (BYTE)bTemp,
	 (BYTE)bTo);

   if(!fContinueCalc)			/* If user said to stop */
      return;
   /* Display bFrom -> bTo */
   hps = WinGetPS(hwndMain);
   MoveDisk(hps,bFrom,bTo);		/* Move the bottom disk */
   if (fViewOn)
   {
      WinQueryWindowRect(hwndMain, (PRECTL)&rect);
      GpiQueryFontMetrics(hps,sizeof(FontMetrics),&FontMetrics);
      /*
       *set  center
       */
      usCenter =  (rect.xRight/2);
      /*
       *left hand side of text to blank out
       */
      rect.xLeft = ptl.x =( usCenter +( ( strlen(pszDisksMoved) ) / 2) * FontMetrics.lAveCharWidth);

      /*
       *bottom
       */
      rect.yBottom = ptl.y = rect.yTop - (VERT_POS * FontMetrics.lEmHeight);
      /*
       *top
       */
      rect.yTop	   = rect.yTop -   ((VERT_POS - 1)  * FontMetrics.lEmHeight);


      rect.yBottom = ptl.y;
      /*
       *clear off the previous	numbers
       *by drawing a  opaque rectangle
       */
      memset(szBuffer,' ', sizeof(szBuffer) );

      GpiCharStringPosAt(hps,
			 &ptl,
			 &rect,
			 (ULONG)CHS_OPAQUE,
			 DELETE_WIDTH,
			 szBuffer,
			 &lIncrement);

      GpiCharStringAt(hps, &ptl, strlen(szBuffer), szBuffer);
      strcpy(szBuffer,pszDisksMoved);
      /*
       *display the number of disks moved
       */
      /*
       *left hand side of text to draw
       */
      ptl.x = usCenter - (( (strlen(pszDisksMoved) + MAX_DIGITS)/ 2)* FontMetrics.lAveCharWidth);
      GpiCharStringAt(hps, &ptl, strlen(szBuffer), szBuffer);
      sprintf(szBuffer,"%05lu",
		       ulIterations+ 1 );

      ptl.x = usCenter + ( ((strlen(pszDisksMoved ) /2) + 1) * FontMetrics.lAveCharWidth);
      GpiCharStringAt(hps, &ptl, strlen(szBuffer), szBuffer);
   }
   WinReleasePS(hps);
   ulIterations++;
   /* Move disks over */
   Hanoi((BYTE)(bHeight-1),(BYTE)bTemp,(BYTE)bTo,(BYTE)bFrom);
   return;
}

/****************************************************************\
 *  SetupTowers procedure
 *--------------------------------------------------------------
 *
 *  Name:    SetupTowers(VOID)
 *
 *  Purpose: This routine initializes the global arrays that represent
 *	     the hanoi stacks.	This involves placing all the disks on
 *	     the first peg, emptying the other 2 pegs and setting the
 *	     associated counts.
 *
 *  Usage:   Routine is called when program started or restarted.
 *
 *  Method:  Calling uses the global variable cTowerSize to determine
 *	     how many disks there are.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID SetupTowers(VOID)
{
   USHORT cnt;

   for(cnt=0; cnt<cTowerSize; cnt++)	 /* Setup the intial post with disks */
      abTowers[0][cnt] = cTowerSize - (BYTE)cnt - (BYTE)1;

   abTowersNdx[0] = (BYTE)cTowerSize;	  /* Set disk count for initial post */
   abTowersNdx[1] = abTowersNdx[2] = (BYTE)0;	   /* Zero other post counts */
   return;
}

/****************************************************************\
 *  MoveDisk procedure
 *--------------------------------------------------------------
 *
 *  Name:    MoveDisk(HPS hps, BYTE bFrom, BYTE bTo)
 *
 *  Purpose: This routine moves the top disk from the bFrom spindle
 *	     to the top of the bTo spindle.
 *
 *  Usage:
 *
 *  Method:  Does error checking for trying to move a disk from a
 *	     spindle that does not have any disks on it.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID MoveDisk(HPS hps, BYTE bFrom, BYTE bTo)
			/* hps - Handle for painting */
			/* bFrom - The from spindle number, 0-2 */
			/* bTo - The to spindle number, 0-2 */
{
   CHAR bTOSndx;			  /* Top of stack index */
   BYTE bDiskNum;			 /* Disk number to move */

   bTOSndx = abTowersNdx[bFrom]-(CHAR) 1;

   DrawDisk(hps,bFrom,bTOSndx,fERASE);	 /* Remove disk off from stack */

   bDiskNum = abTowers[bFrom][bTOSndx]; /* Get move disk number */
   abTowersNdx[bFrom]--;      /* Decrease count on from spindle */

	/* Offset to place the disk at Place on stack in memory */
   bTOSndx = abTowersNdx[bTo]++;
   abTowers[bTo][bTOSndx] = bDiskNum;
				   /* Draw disk on the to stack */
   DrawDisk(hps,bTo,bTOSndx,fDRAW);
   return;
}

/****************************************************************\
 *  EntryFldDlgProc procedure
 *--------------------------------------------------------------
 *
 *  Name:   EntryFldDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
 *
 *
 * Purpose: Handles all the messages associated with the set entry field
 *	    and calls the appropriate handling procedures.  The purpose
 *	    of this dialog box is to get a new number of disks for the
 *	    hanoi routine.
 *
 * Usage:
 *
 * Method:  If the value entered is valid, global cTowerSize is changed
 *	    to the new value, and TRUE is returned.
 *
 * Returns: Terminates with a TRUE if a new valid Tower Size has been entered.
 *
\****************************************************************/
MRESULT EXPENTRY EntryFldDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   SHORT sNewSize=0;			    /* Holds new number of disks */
   MRESULT sRC;

   switch(msg)
   {
      case WM_INITDLG:
	 FixSysMenu(hwnd);

	 WinSendDlgItemMsg(hwnd, IDD_ENTRYFLD, EM_SETTEXTLIMIT,
			   MPFROM2SHORT(2,0),NULL);  /* Limit len */
	 WinSetDlgItemShort(hwnd, IDD_ENTRYFLD, cTowerSize,TRUE);
	 return (MRESULT)0L;		   /* Allow normal focus setting */

      case WM_COMMAND:
	 switch(SHORT1FROMMP(mp1))
	 {
	    case DID_OK:
	       WinQueryDlgItemShort(hwnd, IDD_ENTRYFLD, &sNewSize, TRUE);
	       if(sNewSize>0 && sNewSize<=MAXDISKCNT) /* Set new Tower size */
	       {
		  cTowerSize = (BYTE) sNewSize;
		  WinDismissDlg(hwnd,TRUE);
	       }
	       else			       /* Invalid value */
		  MessageBox(hwndMainFrame,
			     IDMSG_DISKNUMBERERROR,
			     MB_OK | MB_ICONEXCLAMATION,
			     TRUE);
	       return (MRESULT)0L;

	    case DID_CANCEL:
	       WinDismissDlg(hwnd,FALSE);
	       return (MRESULT)0L;

	    default:
	       sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
	       return sRC;
	 }
	 break;

      default:
	 sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
	 return sRC;
   }
   return (MRESULT)0L;
}

/****************************************************************\
 *  Dialog procedure for the About dialog box
 *--------------------------------------------------------------
 *
 *  Name:    AboutDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
 *
 *  Purpose: Handles all the messages associated with the About Box
 *
 *  Usage:   Called for each message sent to the About Box dialog box.
 *
 *  Method:  The about box only has a button control so this routine
 *	     only processes WM_COMMAND messages. Any WM_COMMAND
 *	     posted must have come from the Ok button so we dismiss
 *	     the dialog upon receiving it.
 *
 *  Returns: Dependent upon message sent
 *
\****************************************************************/
MRESULT EXPENTRY AboutDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   MRESULT sRC;

   switch(msg)
   {
      case WM_INITDLG:
	 FixSysMenu(hwnd);
	 return (MRESULT)0L;

      case WM_COMMAND:
	 WinDismissDlg(hwnd, TRUE);
	 return (MRESULT)0L;

      default:
	 sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
	 return sRC;
   }
   return (MRESULT)0L;
}

/****************************************************************\
 *  FixSysMenu procedure
 *--------------------------------------------------------------
 *
 *  Name:    FixSysMenu(HWND hwndDlg)
 *
 *  Purpose: This routine removes the Restore, Size, Minimize, and
 *	     Maximize options from the system menu of a dialog.
 *
 *  Usage
 *
 *  Method:  Called during the WM_INITDLG of a dialog procedure.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID FixSysMenu(HWND hwndDlg)
{
   HWND hwndMenu;		       /* Handle to system menu */

   hwndMenu = WinWindowFromID(hwndDlg, FID_SYSMENU);

   WinSendMsg(hwndMenu,	 /* Delete Restore from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_RESTORE, TRUE),
	      MPFROMP(NULL));

   WinSendMsg(hwndMenu,	    /* Delete Size from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_SIZE, TRUE),
	      MPFROMP(NULL));

   WinSendMsg(hwndMenu, /* Delete Minimize from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_MINIMIZE, TRUE),
	      MPFROMP(NULL));

   WinSendMsg(hwndMenu, /* Delete Maximize from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_MAXIMIZE, TRUE),
	      MPFROMP(NULL));
   return;
}

/****************************************************************\
 *  Message Box procedure
 *--------------------------------------------------------------
 *
 *  Name:    MessageBox(HWND hwndOwner, LONG IdMsg, LONG fsStyle, BOOL fBeep)
 *
 *  Purpose: Displays the message box with the message given in idMsg
 *	     retrieved from the message table and using the style
 *	     flags in fsStyle
 *
 *  Usage:   Called whenever a MessageBox is to be displayed
 *
 *  Method:  - Message string is loaded from the process' message table
 *	     - Alarm beep is sounded if desired
 *	     - Message box with the message is displayed
 *	     - WinMessageBox return value is returned
 *
 *  Returns: Return value from WinMessageBox()
 *
\****************************************************************/
LONG MessageBox(HWND hwndOwner, LONG IdMsg, LONG fsStyle, BOOL fBeep)
	   /* hwndOwner - Handle of the message box's owner */
	   /* idMsg - ID if the message in the message table */
	   /* fsStyle - Style of the message box */
	   /* fBeep - If TRUE, beep before message box is displayed */
{
    CHAR szText[MESSAGELEN];
    LONG sRC;

    if(!WinLoadMessage(hab,
		      (HMODULE)NULL,
		      IdMsg,
		      MESSAGELEN,
		      (PSZ)szText))
    {
	WinAlarm(HWND_DESKTOP, WA_ERROR);
	return RETURN_ERROR;
    }

    if(fBeep)
	WinAlarm(HWND_DESKTOP, WA_ERROR);

    sRC = WinMessageBox(HWND_DESKTOP,
			hwndOwner,
			szText,
			(PSZ)NULL,
			IDD_MSGBOX,
			fsStyle);
    return sRC;
}				       /* MessageBox() */

/****************************************************************\
 *  Routine for initializing the help manager
 *--------------------------------------------------------------
 *
 *  Name:    InitHelp(VOID)
 *
 *  Purpose: Initializes the IPF help facility
 *
 *  Usage:   Called once during initialization of the program
 *
 *  Method:  Initializes the HELPINIT structure and creates the help
 *	     instance. If successful, the help instance is associated
 *	     with the main window
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID InitHelp(VOID)
{
    HELPINIT hini;

     /* If we return because of an error, Help will be disabled */
    fHelpEnabled = FALSE;
			      /* Initialize help init structure */
    hini.cb = sizeof(HELPINIT);
    hini.ulReturnCode = 0;
			    /* If tutorial added, add name here */
    hini.pszTutorialName = (PSZ)NULL;

    hini.phtHelpTable = (PHELPTABLE)MAKELONG(HANOI_HELP_TABLE, 0xFFFF);
    hini.hmodHelpTableModule = 0;
    hini.hmodAccelActionBarModule = 0;
    hini.idAccelTable = 0;
    hini.idActionBar = 0;

    if(!WinLoadString(hab,
		      0,
		      IDS_HELPWINDOWTITLE,
		      HELPLIBRARYNAMELEN,
		      (PSZ)szWindowTitle))
    {
	MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING,
			      MB_OK | MB_ERROR, FALSE);
	return;
    }
    hini.pszHelpWindowTitle = (PSZ)szWindowTitle;

		    /* If debugging, show panel ids, else don't */
#ifdef DEBUG
    hini.fShowPanelId = CMIC_SHOW_PANEL_ID;
#else
    hini.fShowPanelId = CMIC_HIDE_PANEL_ID;
#endif

    if(!WinLoadString(hab,
		      0,
		      IDS_HELPLIBRARYNAME,
		      HELPLIBRARYNAMELEN,
		      (PSZ)szLibName))
    {
	MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING,
			      MB_OK | MB_ERROR, FALSE);
	return;
    }
    hini.pszHelpLibraryName = (PSZ)szLibName;
				      /* Creating help instance */
    hwndHelpInstance = WinCreateHelpInstance(hab, &hini);

    if(hwndHelpInstance == 0L || hini.ulReturnCode)
    {
	MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, MB_OK | MB_ERROR, TRUE);
	return;
    }
		     /* Associate help instance with main frame */
    if(!WinAssociateHelpInstance(hwndHelpInstance, hwndMainFrame))
    {
	MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR,
				  MB_OK | MB_ERROR, TRUE);
	return;
    }
/* Help manager is successfully initialized so set flag to TRUE */
    fHelpEnabled = TRUE;
   return;
}						  /* InitHelp() */

/****************************************************************\
 *  Processes the Help for Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpHelpForHelp(MPARAM mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Help for
 *	     Help item of the Help menu
 *
 *  Usage:   Called from MainCommand when the Help for Help menu item
 *	     is selected
 *
 *  Method:  Sends an HM_DISPLAY_HELP message to the help instance so
 *	     that the default Help For Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpHelpForHelp(MPARAM mp2)
{
	   /* This just displays the system help for help panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance, HM_DISPLAY_HELP,
					(MPARAM)0L, (MPARAM)0L))
	   MessageBox(hwndMain,
		      IDMSG_HELPDISPLAYERROR,
		      MB_OK | MB_ERROR,
		      FALSE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'
   \*  warning at compile time.					   */
   return;
}					   /* HelpHelpForHelp() */

/****************************************************************\
 *  Processes the Extended Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpExtended(MPARAM mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Extended
 *	     Help item of the Help menu.
 *
 *  Usage:   Called from MainCommand when the Extended Help menu item
 *	     is selected.
 *
 *  Method:  Sends an HM_EXT_HELP message to the help instance so that
 *	     the default Extended Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpExtended(MPARAM mp2)
{
	   /* This just displays the system extended help panel */
   if(fHelpEnabled)
	if((LONG)WinSendMsg(hwndHelpInstance, HM_EXT_HELP,
					       (MPARAM)0L,(MPARAM)0L))
	    MessageBox(hwndMain,
		       IDMSG_HELPDISPLAYERROR,
		       MB_OK | MB_ERROR,
		       FALSE);

    /* This routine currently doesn't use the mp2 parameter but     *\
     *	it is referenced here to prevent an 'Unreferenced Parameter'
    \*	warning at compile time.				    */
   return;
}					      /* HelpExtended() */

/****************************************************************\
 *  Processes the Keys Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpKeys(MPARAM mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Keys Help
 *	     item of the Help menu.
 *
 *  Usage:   Called from MainCommand when the Keys Help menu item is
 *	     selected
 *
 *  Method:  Sends an HM_KEYS_HELP message to the help instance so that
 *	     the default Keys Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpKeys(MPARAM mp2)
{
	       /* This just displays the system keys help panel */
    if(fHelpEnabled)
	if((LONG)WinSendMsg(hwndHelpInstance, HM_KEYS_HELP,
					     (MPARAM)0L,(MPARAM)0L))
	    MessageBox(hwndMain,
		       IDMSG_HELPDISPLAYERROR,
		       MB_OK | MB_ERROR,
		       FALSE);

    /* This routine currently doesn't use the mp2 parameter but     *\
     *	it is referenced here to prevent an 'Unreferenced Parameter'
    \*	warning at compile time.				    */
    return;
}						  /* HelpKeys() */

/****************************************************************\
 *  Processes the Index Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpIndex(MPARAM mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Index Help
 *	     item of the Help menu
 *
 *  Usage:   Called from MainCommand when the Index Help menu item
 *	     is selected
 *
 *  Method:  Sends an HM_INDEX_HELP message to the help instance so
 *	     that the default Index Help is displayed.
 *
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpIndex(MPARAM mp2)
{
	      /* This just displays the system help index panel */
    if(fHelpEnabled)
	if((LONG)WinSendMsg(hwndHelpInstance, HM_HELP_INDEX,
					     (MPARAM)0L,(MPARAM)0L))
	    MessageBox(hwndMain,
		       IDMSG_HELPDISPLAYERROR,
		       MB_OK | MB_ERROR,
		       FALSE);

    /* This routine currently doesn't use the mp2 parameter but     *\
     *	it is referenced here to prevent an 'Unreferenced Parameter'
    \*	warning at compile time.				    */
    return;
}						 /* HelpIndex() */

/****************************************************************\
 *  Processes the About command from the Help menu
 *--------------------------------------------------------------
 *
 *  Name:    HelpAbout(MPARAM mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the About item
 *	     of the Help menu
 *
 *  Usage:   Called from MainCommand when the About menu item is selected
 *
 *  Method:  Calls WinDlgBox to display the about box dialog.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpAbout(MPARAM mp2)
{
				 /* Display the AboutBox dialog */
    WinDlgBox(HWND_DESKTOP,
	      hwndMain,
	      (PFNWP)AboutDlgProc,
	      0,
	      IDD_PRODUCTINFO,
	      (PVOID)NULL);

    /* This routine currently doesn't use the mp2 parameter but     *\
     *	it is referenced here to prevent an 'Unreferenced Parameter
    \*	warning at compile time.				    */
    return;
}						 /* HelpAbout() */

/****************************************************************\
 *  Displays the help panel indicated
 *--------------------------------------------------------------
 *
 *  Name:    DisplayHelpPanel(LONG idPanel)
 *
 *  Purpose: Displays the help panel whose id is given
 *
 *  Usage:   Called whenever a help panel is desired to be displayed,
 *	     usually from the WM_HELP processing of the dialog boxes
 *
 *  Method:  Sends HM_DISPLAY_HELP message to the help instance
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID DisplayHelpPanel(LONG idPanel)
			/* ID of the help panel to be displayed */
{
    if(fHelpEnabled)
	if((LONG)WinSendMsg(hwndHelpInstance,
		      HM_DISPLAY_HELP,
		      MPFROMLONG(MAKELONG(idPanel, NULL)),
		      MPFROMSHORT(HM_RESOURCEID)))

	    MessageBox(hwndMainFrame,
		       IDMSG_HELPDISPLAYERROR,
		       MB_OK | MB_ERROR,
		       TRUE);
    return;
}					  /* DisplayHelpPanel() */

/****************************************************************\
 *  Destroys the help instance
 *--------------------------------------------------------------
 *
 *  Name:    DestroyHelpInstance(VOID)
 *
 *  Purpose: Destroys the help instance for the application
 *
 *  Usage:   Called after exit from message loop
 *
 *  Method:  Calls WinDestroyHelpInstance() to destroy the help instance
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID DestroyHelpInstance(VOID)
{
    if(hwndHelpInstance != 0L)
    {
	WinDestroyHelpInstance(hwndHelpInstance);
    }
    return;
}				       /* DestroyHelpInstance() */

/****************************************************************\
 *  Posts a message to the Background thread
 *--------------------------------------------------------------
 *
 *  Name:    PostBkThreadMsg(ULONG msg, MPARAM mp1, MPARAM mp2)
 *
 *  Purpose: Routine posts a message to the object window of the
 *	     background thread.
 *
 *  Usage:   Routine is called whenever a message is to be posted to
 *	     the background processing thread.
 *
 *  Method:  The routine posts the message to the object window of the
 *	     thread.
 *
 *  Returns:  the return value from WinPostMsg().
 *
\****************************************************************/
BOOL PostBkThreadMsg(ULONG msg, MPARAM mp1, MPARAM mp2)
{
   BOOL sRC;

   sRC = WinPostMsg(hwndObject, msg, mp1, mp2);
   return sRC;
}					   /* PostBkThreadMsg() */

/****************************************************************\
 *  Background thread routine
 *--------------------------------------------------------------
 *
 *  Name:    BackgroundThread(ULONG ulThreadParam)
 *
 *  Purpose: Routine is a background thread used for tasks to be
 *	     completed in the background.
 *
 *  Usage:   Routine is called at initialization time to create a
 *	     background processing thread.
 *
 *  Method:  The routine initializes itself as a PM thread and creates
 *	     a message queue.  It then creates an object window through
 *	     which it will receive and send messages.  It then polls
 *	     through a message loop, processing any messages it receives
 *	     in the object window's window procedure. When the loop
 *	     ends, it terminates.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID BackgroundThread(ULONG ulThreadParam)
		     /* Parameter passed into DosCreateThread() */
{
    QMSG qmsg;
			     /* Create message queue for thread */
    habBkThread = WinInitialize(0L);

    do
    {

	 if(habBkThread == 0L)
	 {
	     WinPostMsg(hwndMain, TM_THREADINITFAILED, NULL, NULL);
	     DosExit(EXIT_THREAD,(ULONG)NULL);
	 }
	 hmqBkThread = WinCreateMsgQueue(habBkThread, 0L);
	 if(hmqBkThread == 0L)
	 {
	     WinPostMsg(hwndMain, TM_THREADINITFAILED, NULL, NULL);
	     WinTerminate(habBkThread);
	     DosExit(EXIT_THREAD, (ULONG)NULL);
	 }
	 /* Load the string for the object
	  *window class and register the class
	  */
	 if(!WinLoadString(habBkThread,
			   0,
			   IDS_OBJECTCLASS,
			   MAXNAMEL,
			   (PSZ)szObjectClass))
	 {
	     WinPostMsg(hwndMain, TM_THREADINITFAILED, NULL, NULL);
	     break;
	 }
	  /* Register the main client window class */
	 if(!WinRegisterClass(habBkThread,
			     (PSZ)szObjectClass,
			     (PFNWP)ObjectWndProc,
			     0L,
			     0L))
	 {
	     WinPostMsg(hwndMain, TM_THREADINITFAILED, NULL, NULL);
	     break;
	 }
	  /* Create the object window */
	 hwndObject = WinCreateWindow(HWND_OBJECT,
				      szObjectClass,
				      NULL,
				      0L,
				      0,
				      0,
				      0,
				      0,
				      0L,
				      HWND_TOP,
				      OBJECTID,
				      NULL,
				      NULL);

	 if(hwndObject == 0L)
	 {
	     WinPostMsg(hwndMain, TM_THREADINITFAILED, NULL, NULL);
	     break;
	 }
	 /* Set thread created flag so another
	  *thread of this type cannot be created
	  */

	 fThreadCreated = TRUE;

				   /* Clear initialization semaphore */
	 DosPostEventSem(hevThreadInit);


						     /* Message loop */
	 while(WinGetMsg(hmqBkThread, (PQMSG)&qmsg, 0L, 0L, 0L))
	     WinDispatchMsg(hmqBkThread, (PQMSG)&qmsg);

    }ONCE;

    /* Destroy object window, clean up message queue and terminate */
    if(WinIsWindow(habBkThread, hwndObject))
	WinDestroyWindow(hwndObject);

    WinDestroyMsgQueue(hmqBkThread);
    WinTerminate(habBkThread);

 /* If termination is due to an error initializing the thread, then clear the
    initialization semaphore so that the main thread can continue. */

    if(!fThreadCreated)
	DosPostEventSem(hevThreadInit);
    DosExit(EXIT_THREAD, 0L);
		 /* The thread parameter is not currently used */
    return;
}					 /* BackgroundThread() */

/****************************************************************\
 *  Dialog procedure for the Object window
 *--------------------------------------------------------------
 *
 *  Name:    ObjectWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
 *
 *  Purpose: Processes all messages sent to the Object window
 *
 *  Usage:   Called for each message sent to the Object window.
 *
 *  Method:  The Object window processes the messages that tell the
 *	     background thread what action to take. Since the object
 *	     window is not visible, it will not process any of the
 *	     standard window messages.
 *
 *  Returns: Dependent upon message sent
 *
\****************************************************************/
MRESULT EXPENTRY ObjectWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   MRESULT  sRC;

   switch(msg)	{
      /*-------------------------------------------------------*\
       *  Include any user defined messages to determine which
       *  action the background thread should take
      \*-------------------------------------------------------*/
   default:
      sRC = WinDefWindowProc(hwnd, msg, mp1, mp2);
      return sRC;
    }
    /* This routine currently doesn't use the hwnd, mp1, mp2 parameter  *\
     *	but it is referenced here to prevent an 'Unreferenced Parameter'*
    \*	warning at compile time.					*/
    return (MRESULT)0L;
}					     /* ObjectWndProc() */
/**************************************************************************
 *  File name  :
 *
 *  Description:
 *
 *  Concepts   :
 *
 *  API's      :
 *
 *  Required
 *    Files    :
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/***************************  End of head.c  *****************************/
#ifndef lint
static char *sccsid = "@(#)header.c 1.3 1/22/92 16:09:53 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define header_Class_Source
#include "header.ih"

/* ************************************************************ */
SOM_Scope void SOMLINK epProcessEnvironment(header * somSelf)
{
/* headerData *somThis = headerGetData(somSelf); */
    page *thisPage;
    textLine *thisHd;
    TPWord *thisWord;

    headerMethodDebug("header", "epProcessEnvironment");

    thisPage = _epGetPage(somSelf);
    thisHd = _pgGetHeaderBlock(thisPage);

    for (;;) {
	thisWord = readToken(_epGetFileMgr(somSelf));
	if (_match(thisWord, "[[end_environment]]")) {
	    _somFree(thisWord);
	    return;
	}
	if (_tpwType(thisWord) == TP_LINE_BREAK) {
	    _somFree(thisWord);
	    continue;
	}
	_llAddTail(thisHd, thisWord);
	if (_match(thisWord, "[[page_number]]"))
	    _pgSetPageNumber(thisPage, thisWord);
    }

}
/*************** Hello C Sample Program Source Code File (.C) **************
 *
 * PROGRAM NAME: HELLO
 * -------------
 *  Presentation Manager Standard Window C Sample Program
 *
 * REVISION LEVEL: 2.0
 * ---------------
 *
 * WHAT THIS PROGRAM DOES:
 * -----------------------
 *  This program displays a standard window containing the text "Hello".
 *  The action bar contains a single choice, Options.
 *  The Options pull-down contains three choices that each
 *  paint a different string in the window.
 *
 * WHAT THIS PROGRAM DEMONSTRATES:
 * -------------------------------
 *  This program demonstrates how to create and display a standard window,
 *  and how to use resources defined in a resource script file.
 *
 * WHAT YOU NEED TO COMPILE THIS PROGRAM:
 * --------------------------------------
 *
 *  REQUIRED FILES:
 *  ---------------
 *
 *    HELLO.C	    - Source code
 *    HELLO.MAK	    - Make file for this program
 *    HELLO.H	    - Application header file
 *    HELLO.ICO	    - Icon file
 *    HELLO.LNK	    - Linker automatic response file
 *    HELLO.RC	    - Resource file
 *
 *    OS2.H	     - Presentation Manager include file
 *    STRING.H	     - String handling function declarations
 *
 *  REQUIRED LIBRARIES:
 *  -------------------
 *
 *    OS2386.LIB     - Presentation Manager/OS2 library
 *    CLIB3R.LIB     - C library (Register conventions)
 *
 *  REQUIRED PROGRAMS:
 *  ------------------
 *    WATCOM C Compiler
 *    WATCOM Linker
 *    Resource Compiler
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 ******************************************************************************/
#define INCL_WIN
#define INCL_GPI

#include <os2.h>			/* PM header file		*/
#include <string.h>			/* ANSI string header file	*/
#include "hello.h"			/* Resource symbolic identifiers*/

#define STRINGLENGTH 20			/* Length of string		*/

/*
 * Function prototypes
 */
MRESULT EXPENTRY MyWindowProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 );

					/* Define parameters by type	*/
HAB  hab;				/* PM anchor block handle	*/
CHAR szHello[STRINGLENGTH];		/* String parameters, set in	*/
CHAR sz1[STRINGLENGTH];			/* the processing of WM_CREATE, */
CHAR sz2[STRINGLENGTH];			/* and used in the processing	*/
CHAR sz3[STRINGLENGTH];			/* of WM_COMMAND, in window	*/
CHAR szString[STRINGLENGTH];		/* procedure.			*/
PSZ  pszErrMsg;

/**************************************************************************
 *
 *  Name       : main()
 *
 *  Description: Initializes the process for OS/2 PM services and
 *		 process the application message queue until a
 *		 WM_QUIT message is received.  It then destroys all
 *		 OS/2 PM resources and terminates.
 *
 *  Concepts   : - obtains anchor block handle and creates message queue
 *		 - creates the main frame window which creates the
 *		     main client window
 *		 - polls the message queue via Get/Dispatch Msg loop
 *		 - upon exiting the loop, exits
 *
 *  API's      :   WinInitialize
 *		   WinCreateMsgQueue
 *		   WinTerminate
 *		   WinSetWindowPos
 *		   WinSetWindowText
 *		   WinRegisterClass
 *		   WinCreateStdWindow
 *		   WinGetMsg
 *		   WinDispatchMsg
 *		   WinDestroyWindow
 *		   WinDestroyMsgQueue
 *
 *  Parameters :  [none]
 *
 *  Return     :  1 - if successful execution completed
 *		  0 - if error
 *
 *************************************************************************/
INT main (VOID)
{
  HMQ  hmq;				/* Message queue handle		*/
  HWND hwndClient = NULLHANDLE;		/* Client area window handle	*/
  HWND hwndFrame = NULLHANDLE;		/* Frame window handle		*/
  QMSG qmsg;				/* Message from message queue	*/
  ULONG flCreate;			/* Window creation control flags*/

  if ((hab = WinInitialize(0)) == 0L) /* Initialize PM	   */
     AbortHello(hwndFrame, hwndClient); /* Terminate the application	*/

  if ((hmq = WinCreateMsgQueue( hab, 0 )) == 0L)/* Create a msg queue */
     AbortHello(hwndFrame, hwndClient); /* Terminate the application	*/

  if (!WinRegisterClass(		/* Register window class	*/
     hab,				/* Anchor block handle		*/
     (PSZ)"MyWindow",			/* Window class name		*/
     (PFNWP)MyWindowProc,		/* Address of window procedure	*/
     CS_SIZEREDRAW,			/* Class style			*/
     0					/* No extra window words	*/
     ))
     AbortHello(hwndFrame, hwndClient); /* Terminate the application	*/

   flCreate = FCF_STANDARD &		/* Set frame control flags to	*/
	     ~FCF_SHELLPOSITION;	/* standard except for shell	*/
					/* positioning.			*/

  if ((hwndFrame = WinCreateStdWindow(
	       HWND_DESKTOP,		/* Desktop window is parent	*/
	       0,			/* STD. window styles		*/
	       &flCreate,		/* Frame control flag		*/
	       "MyWindow",		/* Client window class name	*/
	       "",			/* No window text		*/
	       0,			/* No special class style	*/
	       (HMODULE)0L,	      /* Resource is in .EXE file     */
	       ID_WINDOW,		/* Frame window identifier	*/
	       &hwndClient		/* Client window handle		*/
	       )) == 0L)
     AbortHello(hwndFrame, hwndClient); /* Terminate the application	*/

    WinSetWindowText(hwndFrame, "HELLO SAMPLE");

  if (!WinSetWindowPos( hwndFrame,	/* Shows and activates frame	*/
		   HWND_TOP,		/* window at position 100, 100, */
		   100, 100, 200, 200,	/* and size 200, 200.		*/
		   SWP_SIZE | SWP_MOVE | SWP_ACTIVATE | SWP_SHOW
		 ))
     AbortHello(hwndFrame, hwndClient); /* Terminate the application	*/

/*
 * Get and dispatch messages from the application message queue
 * until WinGetMsg returns FALSE, indicating a WM_QUIT message.
 */

  while( WinGetMsg( hab, &qmsg, 0L, 0, 0 ) )
    WinDispatchMsg( hab, &qmsg );
  WinDestroyWindow(hwndFrame);		 /* Tidy up...			 */
  WinDestroyMsgQueue( hmq );		 /* Tidy up...			 */
  WinTerminate( hab );			 /* Terminate the application	 */
  return( 1 );
} /* End of main */

/**************************************************************************
 *
 *  Name       : MyWindowProc
 *
 *  Description: The window procedure associated with the client area in
 *		 the standard frame window. It processes all messages
 *		 either sent or posted to the client area, depending on
 *		 the message command and parameters.
 *
 *  Concepts   :
 *
 *  API's      :   WinLoadString
 *		   WinInvalidateRegion
 *		   WinPostMsg
 *		   WinDefWindowProc
 *		   WinBeginPaint
 *		   GpiSetColor
 *		   GpiSetBackColor
 *		   GpiSetBackMix
 *		   GpiCharStringAt
 *		   WinEndPaint
 *
 *  Parameters :  hwnd = window handle
 *		  msg = message code
 *		  mp1 = first message parameter
 *		  mp2 = second message parameter
 *
 *  Return     :  depends on message sent
 *
 *************************************************************************/
MRESULT EXPENTRY MyWindowProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
  switch( msg )
  {
    case WM_CREATE:
      /*
       * Window initialization is performed here in WM_CREATE processing
       * WinLoadString loads strings from the resource file.
       */
      WinLoadString( hab, (HMODULE)0L, IDS_HELLO, STRINGLENGTH, szHello );
      WinLoadString( hab, (HMODULE)0L, IDS_1,	  STRINGLENGTH, sz1	);
      WinLoadString( hab, (HMODULE)0L, IDS_2,	  STRINGLENGTH, sz2	);
      WinLoadString( hab, (HMODULE)0L, IDS_3,	  STRINGLENGTH, sz3	);
      strcpy( szString, szHello );	/* Copy text Hello into szString*/
      break;

    case WM_COMMAND:
      /*
       * When the user chooses option 1, 2, or 3 from the Options pull-
       * down, the text string is set to 1, 2, or 3, and
       * WinInvalidateRegion sends a WM_PAINT message.
       * When Exit is chosen, the application posts itself a WM_CLOSE
       * message.
       */
      {
      USHORT command;			/* WM_COMMAND command value	*/
      command = SHORT1FROMMP(mp1);	/* Extract the command value	*/
      switch (command)
      {
	case ID_OPTION1:
	  strcpy( szString, sz1 );
	  WinInvalidateRegion( hwnd, 0L, FALSE );
	  break;
	case ID_OPTION2:
	  strcpy( szString, sz2 );
	  WinInvalidateRegion( hwnd, 0L, FALSE );
	  break;
	case ID_OPTION3:
	  strcpy( szString, sz3 );
	  WinInvalidateRegion( hwnd, 0L, FALSE );
	  break;
	case ID_EXITPROG:
	  WinPostMsg( hwnd, WM_CLOSE, (MPARAM)0, (MPARAM)0 );
	  break;
	default:
	  return WinDefWindowProc( hwnd, msg, mp1, mp2 );
      }

      break;
      }
    case WM_ERASEBACKGROUND:
      /*
       * Return TRUE to request PM to paint the window background
       * in SYSCLR_WINDOW.
       */
      return (MRESULT)( TRUE );
    case WM_PAINT:
      /*
       * Window contents are drawn here in WM_PAINT processing.
       */
      {
      HPS    hps;			/* Presentation Space handle	*/
      RECTL  rc;			/* Rectangle coordinates	*/
      POINTL pt;			/* String screen coordinates	*/
					/* Create a presentation space	*/
      hps = WinBeginPaint( hwnd, 0L, &rc );
      pt.x = 50; pt.y = 50;		/* Set the text coordinates,	*/
      GpiSetColor( hps, CLR_NEUTRAL );	       /* colour of the text,	*/
      GpiSetBackColor( hps, CLR_BACKGROUND );  /* its background and	*/
      GpiSetBackMix( hps, BM_OVERPAINT );      /* how it mixes,		*/
					       /* and draw the string...*/
      GpiCharStringAt( hps, &pt, (LONG)strlen( szString ), szString );
      WinEndPaint( hps );		       /* Drawing is complete	*/
      break;
      }
    case WM_CLOSE:
      /*
       * This is the place to put your termination routines
       */
      WinPostMsg( hwnd, WM_QUIT, (MPARAM)0,(MPARAM)0 );/* Cause termination*/
      break;
    default:
      /*
       * Everything else comes here.  This call MUST exist
       * in your window procedure.
       */

      return WinDefWindowProc( hwnd, msg, mp1, mp2 );
  }
  return (MRESULT)FALSE;
} /* End of MyWindowProc */

/**************************************************************************
 *
 *  Name       : AbortHello
 *
 *  Description: Report an error returned from an API service
 *
 *  Concepts   :  use of message box to display information
 *
 *  API's      :  DosBeep
 *		  WinGetErrorInfo
 *		  WinMessageBox
 *		  WinFreeErrorInfo
 *		  WinPostMsg
 *
 *  Parameters :  hwndFrame = frame window handle
 *		  hwndClient = client window handle
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID AbortHello(HWND hwndFrame, HWND hwndClient)
{
   PERRINFO  pErrInfoBlk;
   PSZ	     pszOffSet;
   void	     stdprint(void);

   DosBeep(100,10);
   if ((pErrInfoBlk = WinGetErrorInfo(hab)) != (PERRINFO)NULL)
   {
      pszOffSet = ((PSZ)pErrInfoBlk) + pErrInfoBlk->offaoffszMsg;
      pszErrMsg = ((PSZ)pErrInfoBlk) + *((PSHORT)pszOffSet);
      if((INT)hwndFrame && (INT)hwndClient)
	 WinMessageBox(HWND_DESKTOP,	     /* Parent window is desk top */
		       hwndFrame,	     /* Owner window is our frame */
		       (PSZ)pszErrMsg,	     /* PMWIN Error message	  */
		       "Error Msg",	     /* Title bar message	  */
		       MSGBOXID,	     /* Message identifier	  */
		       MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL ); /* Flags */
      WinFreeErrorInfo(pErrInfoBlk);
   }
   WinPostMsg(hwndClient, WM_QUIT, (MPARAM)NULL, (MPARAM)NULL);
} /* End of AbortHello */

/*********************** End of the hello.c *******************************/
/**************************************************************************
 *  File name  :  help.c
 *
 *  Description:  This module contains all the routines for interfacing
 *		  the IPF Help Manager.
 *
 *		  This source file contains the following functions:
 *
 *		  InitHelp()
 *		  HelpIndex()
 *		  HelpGeneral()
 *		  HelpUsingHelp()
 *		  HelpKeys()
 *		  HelpTutorial()
 *		  HelpProductInfo()
 *		  DisplayHelpPanel(idPanel)
 *		  DestroyHelpInstance()
 *
 *  Concepts   :  help manager
 *
 *  API's      :  WinLoadString
 *		  WinCreateHelpInstance
 *		  WinAssociateHelpInstance
 *		  WinSendMsg
 *		  WinDlgBox
 *		  WinDestroyHelpInstance
 *		  WinMessageBox
 *		  WinAlarm
 *
 *    Files    :  OS2.H, STRING.H, MAIN.H, DLG.H, HELP.H, XTRN.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/

/*
 *  Include files, macros, defined constants, and externs
 */

#define	 INCL_WINHELP

#include <os2.h>
#include <string.h>
#include "main.h"
#include "dlg.h"
#include "help.h"
#include "xtrn.h"

#define HELPLIBRARYNAMELEN  20

/* If DEBUG is defined, then the help panels will display their
 *  id values on their title bar.  This is useful for determining
 *  which help panels are being shown for each dialog item.  When
 *  the DEBUG directive is not defined, then the panel ids are not
 *  displayed.
 */

/* #define  DEBUG */

/*
 *  Global variables
 */
static HWND hwndHelpInstance;
static CHAR szLibName[HELPLIBRARYNAMELEN];
static CHAR szWindowTitle[HELPLIBRARYNAMELEN];


/*
 *  Entry point declarations
 */
MRESULT EXPENTRY ProductInfoDlgProc(HWND hwnd,
				    ULONG msg,
				    MPARAM mp1,
				    MPARAM mp2);


/**************************************************************************
 *
 *  Name       : InitHelp()
 *
 *  Description:  Initializes the IPF help facility
 *
 *  Concepts:	  Called once during initialization of the program
 *
 *		  Initializes the HELPINIT structure and creates the
 *		  help instance.  If successful, the help instance
 *		  is associated with the main window.
 *
 *  API's      :  WinLoadString
 *		  WinCreateHelpInstance
 *		  WinAssociateHelpInstance
 *
 *  Parameters :  [none]
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID InitHelp(VOID)
{
   HELPINIT hini;

   /* if we return because of an error, Help will be disabled */
   fHelpEnabled = FALSE;

   /* initialize help init structure */
   hini.cb = sizeof(HELPINIT);
   hini.ulReturnCode = 0;

   hini.pszTutorialName = (PSZ)NULL;   /* if tutorial added, add name here */

   hini.phtHelpTable = (PHELPTABLE)MAKELONG(TEMPLATE_HELP_TABLE, 0xFFFF);
   hini.hmodHelpTableModule = 0;
   hini.hmodAccelActionBarModule = 0;
   hini.idAccelTable = 0;
   hini.idActionBar = 0;

   if(!WinLoadString(hab,
		     (HMODULE)0,
		     IDS_HELPWINDOWTITLE,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szWindowTitle))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
      return;
   }

   hini.pszHelpWindowTitle = (PSZ)szWindowTitle;

   /* if debugging, show panel ids, else don't */
#ifdef DEBUG
   hini.fShowPanelId = CMIC_SHOW_PANEL_ID;
#else
   hini.fShowPanelId = CMIC_HIDE_PANEL_ID;
#endif

   if(!WinLoadString(hab,
		     (HMODULE)0,
		     IDS_HELPLIBRARYNAME,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szLibName))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
      return;
   }

   hini.pszHelpLibraryName = (PSZ)szLibName;

   /* creating help instance */
   hwndHelpInstance = WinCreateHelpInstance(hab, &hini);

   if(hwndHelpInstance == NULLHANDLE || hini.ulReturnCode)
   {
      MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, MB_OK | MB_ERROR, TRUE);
      return;
   }

   /* associate help instance with main frame */
   if(!WinAssociateHelpInstance(hwndHelpInstance, hwndMainFrame))
   {
      MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, MB_OK | MB_ERROR, TRUE);
      return;
   }

   /* help manager is successfully initialized so set flag to TRUE */
   fHelpEnabled = TRUE;
}   /* End of InitHelp	 */


/**************************************************************************
 *
 *  Name       : HelpGeneral()
 *
 *  Description: Processes the WM_COMMAND message posted by the
 *		 General Help item of the Help menu.
 *
 *  Concepts:	 Called from MainCommand when the General Help
 *		 menu item is selected.
 *
 *		 Sends an HM_EXT_HELP message to the help
 *		 instance so that the default Extended Help is
 *		 displayed.
 *
 *  API's      : WinSendMsg
 *
 *  Parameters :  [none]
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID  HelpGeneral(VOID)
{
    /* this just displays the system extended help panel */
   if(fHelpEnabled)
      if(NULL != WinSendMsg(hwndHelpInstance, HM_EXT_HELP,
			    (MPARAM)NULL, (MPARAM)NULL))
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    MB_OK | MB_ERROR,
		    FALSE);
}   /* End of HelpGeneral  */

/**************************************************************************
 *
 *  Name       : HelpUsingHelp()
 *
 *  Description: Processes the WM_COMMAND message posted by the
 *		 Using Help item of the Help menu.
 *
 *  Concepts:	 Called from MainCommand when the Using Help
 *		 menu item is selected.
 *
 *		 Sends an HM_DISPLAY_HELP message to the help
 *		 instance so that the default Using Help is
 *		 displayed.
 *
 *  API's      : WinSendMsg
 *
 *  Parameters :  [none]
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID  HelpUsingHelp(VOID)
{
   /* this just displays the system help for help panel */
   if(fHelpEnabled)
      if(NULL != WinSendMsg(hwndHelpInstance, HM_DISPLAY_HELP,
			    (MPARAM)NULL, (MPARAM)NULL))
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    MB_OK | MB_ERROR,
		    FALSE);
}   /* End of HelpUsingHelp   */


/**************************************************************************
 *
 *  Name       : HelpKeys()
 *
 *  Description: Processes the WM_COMMAND message posted by the
 *		 Keys Help item of the Help menu.
 *
 *  Concepts:	 Called from MainCommand when the Keys Help
 *		 menu item is selected.
 *
 *		 Sends an HM_KEYS_HELP message to the help
 *		 instance so that the default Keys Help is
 *		 displayed.
 *
 *  API's      : WinSendMsg
 *
 *  Parameters :  [none]
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID  HelpKeys(VOID)
{
   /* this just displays the system keys help panel */
   if(fHelpEnabled)
      if(NULL != WinSendMsg(hwndHelpInstance, HM_KEYS_HELP,
			    (MPARAM)NULL, (MPARAM)NULL))
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    MB_OK | MB_ERROR,
		    FALSE);
}   /* End of HelpKeys	 */


/**************************************************************************
 *
 *  Name       : HelpIndex()
 *
 *  Description: Processes the WM_COMMAND message posted by the
 *		 Help Index item of the Help menu.
 *
 *  Concepts:	 Called from MainCommand when the Help Index
 *		 menu item is selected.
 *
 *		 Sends an HM_INDEX_HELP message to the help
 *		 instance so that the default Help Index is
 *		 displayed.
 *
 *  API's      : WinSendMsg
 *
 *  Parameters :  [none]
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID  HelpIndex(VOID)
{
   /* this just displays the system help index panel */
   if(fHelpEnabled)
      if(NULL != WinSendMsg(hwndHelpInstance, HM_HELP_INDEX,
			     (MPARAM)NULL, (MPARAM)NULL))
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    MB_OK | MB_ERROR,
		    FALSE);
}   /* End of HelpIndex() */


/**************************************************************************
 *
 *  Name       : HelpTutorial()
 *
 *  Description: Processes the WM_COMMAND message posted by the
 *		  Tutorial Help item of the Help menu.	While the
 *		  standard template application does not include a
 *		  Tutorial menu item, you can add one if your
 *		  application has a tutorial.
 *
 *  Concepts:	 Called from MainCommand when the Tutorial Help
 *		 menu item is selected.
 *
 *  API's      :  WinLoadMessage
 *		  WinMessageBox
 *		  WinAlarm
 *
 *  Parameters :  [none]
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID  HelpTutorial(VOID)
{
   CHAR szText[MESSAGELEN];

   /*
    *  Insert code for any tutorial below in place of the message box.
    */
   if(!WinLoadMessage(hab,
		     (HMODULE)NULLHANDLE,
		     IDMSG_YOURTUTORIAL,
		     MESSAGELEN,
		     (PSZ)szText))
   {
      WinAlarm(HWND_DESKTOP, WA_ERROR);
      return;
   }
   WinMessageBox(HWND_DESKTOP,
		 hwndMain,
		 szText,
		 "Tutorial",
		 MB_OK | MB_INFORMATION,
		 FALSE);

}   /* End of HelpTutorial   */


/**************************************************************************
 *
 *  Name       : HelpProductInfo()
 *
 *  Description: Processes the WM_COMMAND message posted by the
 *		 Product information item of the Help Menu.
 *
 *  Concepts:	 Called from MainCommand when the Product information
 *		 menu item is selected
 *
 *		 Calls WinDlgBox to display the Product information dialog.
 *
 *  API's      : WinDlgBox
 *
 *  Parameters :  [none]
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID  HelpProductInfo(VOID)
{
   /* display the Product Information dialog. */
   WinDlgBox(HWND_DESKTOP,
	     hwndMain,
	     (PFNWP)ProductInfoDlgProc,
	     0,
	     IDD_PRODUCTINFO,
	     (PVOID)NULL);
}   /* End of HelpProductInfo() */


/**************************************************************************
 *
 *  Name       : DisplayHelpPanel(idPanel)
 *
 *  Description: Displays the help panel whose id is given
 *
 *  Concepts:	 Called whenever a help panel is desired to be
 *		 displayed, usually from the WM_HELP processing
 *		 of the dialog boxes.
 *
 *		 Sends HM_DISPLAY_HELP message to the help instance.
 *
 *  API's      : WinSendMsg
 *
 *  Parameters :  idPanel = panel i.d.
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID DisplayHelpPanel(ULONG idPanel)
{
   if(fHelpEnabled)
      if(NULL != WinSendMsg(hwndHelpInstance,
			    HM_DISPLAY_HELP,
			    MPFROMLONG(idPanel),
			    MPFROMSHORT(HM_RESOURCEID)))
	 MessageBox(hwndMainFrame,
		    IDMSG_HELPDISPLAYERROR,
		    MB_OK | MB_ERROR,
		    TRUE);
}   /* End of DisplayHelpPanel	 */


/**************************************************************************
 *
 *  Name       : DestroyHelpInstance()
 *
 *  Description: Destroys the help instance for the application
 *
 *  Concepts:	 Called after exit from message loop.
 *
 *		 Calls WinDestroyHelpInstance() to destroy the
 *		 help instance.
 *
 *  API's      : WinDestroyHelpInstance
 *
 *  Parameters :  [none]
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID DestroyHelpInstance(VOID)
{
   if(hwndHelpInstance != NULLHANDLE)
      WinDestroyHelpInstance(hwndHelpInstance);
}   /* End of DestroyHelpInstance   */
/***************************  End of help.c  ****************************/
#ifndef lint
static char *sccsid = "@(#)helper.c 1.3 1/22/92 16:10:13 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

/* File: helper.c */

#include "helper.h"
#include <stdio.h>
#include <stdlib.h>

/* ************************************************************ */
void shouldHaveOverridden(SOMObject * thisObject, char *methodName)
{
    char *class = _somGetClassName(thisObject);

    printf("RUN TIME ERROR\n");
    printf("method: %s invoked on object of class: %s\n", methodName, class);
    printf("%s MUST override %s, and has not.\n", class, methodName);
    exit(1);
}
/**************************************************************************
 *  File name  :  img_data.c
 *
 *  Description:  This module contains global data declarations for the
 *		  PM Porting Sample.
 *
 *  Concepts   :  global data
 *
 *  API's      :  [none]
 *
 *  Required
 *    Files    :  OS2.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/

#define INCL_WINPOINTERS
#define INCL_WINSTDFILE
#include <os2.h>

/*
 * Global data declarations
 */

HAB	 vhab;				    /* anchor block handle */
HDC	 vhdcMem;		   /* memory device context handle */
HDC	 vhdc;			   /* window device context handle */
HPS	 vhps	    = (HPS)NULL;		/* image PS handle */
HPS	 vhpsMem    = (HPS)NULL;	       /* memory PS handle */
BOOL	 vfImgLoaded  = FALSE;	     /* initially image not loaded */
BOOL	 vfDetail     = FALSE;	    /* view non-detailed initially */
BOOL	 vfMaximized  = FALSE;	 /* initially window not maximized */
BOOL	 vfHelpEnabled = FALSE;	     /* set when help installed ok */
HWND	 vhwndFrame = (HWND)NULL;     /* image window frame handle */
HWND	 vhwndClient;		      /* main window client handle */
HWND	 vhwndVScroll;		      /* vertical scrollbar handle */
HWND	 vhwndHScroll;		    /* horizontal scrollbar handle */
HWND	 vhwndViewForeClr = (HWND)NULL; /* foreground color handle */
HWND	 vhwndViewBackClr = (HWND)NULL; /* background color handle */
HWND	 vhwndMenu;				/* menu bar handle */
LONG	 vlXScreen;				   /* screen width */
LONG	 vlYScreen;				  /* screen height */
LONG	 vlcxVScroll;			/* vertical scrollbar size */
LONG	 vlcyHScroll;		      /* horizontal scrollbar size */
LONG	 vlcyTitle;				/* titlebar height */
LONG	 vlcyMenu;				 /* menubar height */
LONG	 vlcxBorder;			      /* size border width */
LONG	 vlcyBorder;			     /* size border height */
LONG	 vlForeClr = CLR_WHITE;	       /* initial foreground color */
LONG	 vlBackClr = CLR_BLACK;	       /* initial background color */
#if (defined(PORT_16) || defined(PORT_32))
PBYTE vpbImgBuf;			   /* image storage buffer */
#else
BYTE _far16 *vpbImgBuf;			   /* image storage buffer */
#endif
PFNWP	 vpfnwpFrame;		    /* main frame-window procedure */
SIZEL	 vsizlImg;		  /* width and height of the image */
ULONG	 vulScrollYMax;			 /* maximum Y scroll range */
ULONG	 vulScrollXMax;			 /* maximum X scroll range */
POINTL	 vptlSave = {0L, 0L};		  /* save/restore position */
HBITMAP	 vhbm;					 /* bit-map handle */
HPOINTER vhptrWait;		       /* system hourglass pointer */
HPOINTER vhptrArrow;			   /* system arrow pointer */
#ifndef PORT_16
FILEDLG	 vfdg;				  /* file dialog structure */
#endif
/***************************  End of img_data.c	 *************************/
/*static char *SCCSID = "@(#)img_dlg.c  6.6 92/02/10";*/
/**************************************************************************
 *  File name  :  img_dlg.c
 *
 *  Description:  This module contains the code for handling the
 *		  Product information dialog box.
 *		  This source file contains the following functions:
 *
 *		  ProductInfoDlgProc(hwnd, msg, mp1, mp2)
 *		  SetSysMenu(hwnd)
 *
 *  Concepts   :  This is used only to allow deletion of certain
 *		  System Menu items when the dialog is started.
 *
 *  API's      :  WinDefDlgProc
 *		  WinSendMsg
 *		  WinWindowFromID
 *
 *  Required
 *    Files    :  OS2.H, STRING.H, IMG_MAIN.H, IMG_XTRN.H, IMG_DLG.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *  Include files, macros, defined constants, and externs
 */
#define INCL_WINMENUS
#define INCL_WINFRAMEMGR
#define INCL_WINSTDFILE
#include <os2.h>
#include <string.h>

#include "img_main.h"
#include "img_xtrn.h"
#include "img_dlg.h"

/**************************************************************************
 *
 *  Name       : ProductInfoDlgProc(hwnd, msg, mp1, mp2)
 *
 *  Description: Processes messages sent to the Product information dialog
 *
 *  Concepts   : the Product information dialog has only a button control,
 *		 so this routine processes only WM_COMMAND messages.  Any
 *		 WM_COMMAND posted must have come from the OK
 *		 button, so we dismiss the dialog upon receiving it.
 *
 *  API's      : WinDefDlgProc
 *
 *  Parameters : hwnd = the dialog box handle
 *		 msg = the message sent to the Product information dialog
 *		 mp1 = the first message parameter
 *		 mp2 = the second message parameter
 *
 *  Return     : Dependent upon message sent;  NULL = successful
 *
\*************************************************************************/
#ifdef PORT_16
MRESULT EXPENTRY ProductInfoDlgProc(HWND hwnd, USHORT msg, MPARAM mp1,MPARAM mp2)
#endif
#ifdef PORT_32
MRESULT EXPENTRY ProductInfoDlgProc(HWND hwnd, ULONG msg, MPARAM mp1,MPARAM mp2)
#endif
{
    switch (msg)
    {
	case WM_INITDLG:
	    SetSysMenu(hwnd);	    /* system menu for this dialog  */
	    return MRFROMSHORT(FALSE);

	default:
	    return WinDefDlgProc(hwnd, msg, mp1, mp2);
    }
    return MRFROMSHORT(0);
} /* End of ProductInfoDlgProc	*/

/**************************************************************************
 *
 *  Name       : SetSysMenu(HWND hDlg)
 *
 *  Description: This sets only Move and Close menu items for any dialog.
 *
 *  Concepts   : Unless particular menu items are deleted, the System Menu
 *		 will show disabled items.
 *
 *  API's      : WinSendMsg
 *		 WinWindowFromID
 *
 *  Parameters : hDlg = the dialog box handle
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID SetSysMenu(HWND hDlg)
{
    HWND     hSysMenu;
    MENUITEM Mi;
    SHORT    Pos;
    ULONG    Id;
    SHORT    cItems;

    /*
     *	We only want Move and Close in the system menu.
     */

    hSysMenu = WinWindowFromID(hDlg, FID_SYSMENU);
    WinSendMsg( hSysMenu, MM_QUERYITEM
	      , MPFROM2SHORT(SC_SYSMENU, FALSE), MPFROMP((PCH) & Mi));
    Pos = 0;
    cItems = SHORT1FROMMR(WinSendMsg(Mi.hwndSubMenu, MM_QUERYITEMCOUNT,
				(MPARAM)NULL, (MPARAM)NULL));
    while (cItems--)
    {
	Id = (ULONG) WinSendMsg( Mi.hwndSubMenu, MM_ITEMIDFROMPOSITION
			  , MPFROM2SHORT(Pos, TRUE), (MPARAM)NULL);
	switch (SHORT1FROMMP(Id))
	{
	case SC_MOVE:
	case SC_CLOSE:
	    Pos++;		/* Don't delete that one. */
	    break;
	default:
	    WinSendMsg( Mi.hwndSubMenu, MM_DELETEITEM
		      , MPFROM2SHORT(Id, TRUE), (MPARAM)NULL);
	}
    }
} /* End of SetSysMenu	*/
/***************************  End of img_dlg.c	 *************************/

/**************************************************************************
 *  File name  :  img_file.c
 *
 *  Description:  This module contains the code for handling the functions
 *		  offered on the File submenu. These functions are called
 *		  from the MainCommand() routine.
 *
 *		  FileOpen(mp2)
 *		  FileLoadImage()
 *
 *  Concepts   :  file input and output
 *
 *  API's      :  WinLoadString
 *		  WinFileDlg
 *		  WinSetPointer
 *		  WinSendMsg
 *		  WinInvalidateRect
 *		  DosRead
 *		  DosClose
 *		  WinIsChild
 *		  WinSetParent
 *		  WinDefFileDlgProc
 *
 *  Required
 *    Files    :  OS2.H, STRING.H, STDLIB.H, IMG_MAIN.H, IMG_XTRN.H,
 *		  IMG_HELP.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *  Include files, macros, defined constants, and externs
 */
#define INCL_WINSCROLLBARS
#define INCL_WINFRAMEMGR
#define INCL_WINPOINTERS
#define INCL_WINSTDFILE
#include <os2.h>
#include <string.h>
#include <stdlib.h>

#include "img_main.h"
#include "img_help.h"
#include "img_xtrn.h"

/*
 *  Static Variables & local defines
 */
#define CCHEXTENSION 6
#define MAX_IMAGE_SIZE 0xFFFF

/* fully-qualified filename from open dialog */
CHAR szFullFile[CCHMAXPATH] = {0};

/*
 *  Entry point declarations
 */
BOOL		 FileLoadImage(VOID);
MRESULT EXPENTRY ImageOpenFilterProc(HWND hwnd, ULONG message,
		  MPARAM mp1, MPARAM mp2 );
#ifdef PORT_32
/**************************************************************************
 *
 *  Name       : FileOpen(mp2)
 *
 *  Description: Processes the File menu's Open item.
 *
 *  Concepts   : Called whenever New from the File menu is selected.
 *		 Calls the standard file open dialog to get the
 *		 file name.  The file name is passed onto DosOpen
 *		 which returns the handle to the file.	The file
 *		 input procedure is called and then the file handle
 *		 is closed.
 *
 *  API's      : WinLoadString
 *		 WinFileDlg
 *		 WinSetPointer
 *		 WinSendMsg
 *		 WinInvalidateRect
 *
 *  Parameters : mp2  = message parameter 2
 *
 *  Return     : TRUE  - if file successfully loaded
 *		 FALSE - if it failed to load the file
 *
 *************************************************************************/
BOOL FileOpen(MPARAM mp2)
{
    BOOL fSuccess = FALSE;
    PCH	 pch;
    CHAR szTitle[MESSAGELEN], szButton[MESSAGELEN];
    CHAR szExtension[CCHEXTENSION];			  /* e.g.: *.IMG */

   /*
    * set up structure to pass to standard file dialog
    */
    vfdg.cbSize = sizeof(FILEDLG);
    vfdg.fl = FDS_CENTER | FDS_HELPBUTTON | FDS_OPEN_DIALOG;

    if (!WinLoadString(vhab,
		       0,
		       IDS_OPEN,
		       MESSAGELEN,
		       szTitle))
    {
       MessageBox(vhwndFrame, IDMSG_CANNOTLOADSTRING, 0, MB_OK | MB_ERROR,
		  TRUE);
       return FALSE;
    }
    vfdg.pszTitle = szTitle;				/* dialog title */

    if (!WinLoadString(vhab,
		       (HMODULE)0,
		       IDS_OPEN,
		       MESSAGELEN,
		       szButton))
    {
	MessageBox(vhwndFrame, IDMSG_CANNOTLOADSTRING, 0, MB_OK | MB_ERROR,
		   TRUE);
	return FALSE;
    }
    vfdg.pszOKButton = szButton;		 /* <Enter> button text */

    vfdg.ulUser = 0L;
    vfdg.pfnDlgProc = ImageOpenFilterProc;
    vfdg.lReturn = 0L;
    vfdg.lSRC = 0L;
    vfdg.hMod = (HMODULE)NULL;
    vfdg.usDlgId = FILEOPEN;
    vfdg.x = (SHORT)0;
    vfdg.y = (SHORT)0;

    /* set up EA type list & initial type */
    vfdg.pszIType = (PSZ)NULL;
    vfdg.papszITypeList = (PAPSZ)NULL;

    /* set up drive list & initial drive */
    vfdg.pszIDrive = (PSZ)NULL;
    vfdg.papszIDriveList = (PAPSZ)NULL;
    vfdg.sEAType = 0;
    vfdg.papszFQFilename = (PAPSZ)NULL;
    vfdg.ulFQFCount = 0L;

   /*
    * get the default file extension (i.e. *.IMG)
    */
    if (!WinLoadString(vhab, 0, IDS_FILEOPENEXTENSION,
		       CCHEXTENSION, szExtension))
    {
	MessageBox(vhwndFrame, IDMSG_CANNOTLOADSTRING, 0,
		   MB_OK | MB_ERROR, TRUE);
	return FALSE;
    }

   /*
    * if dialog has been previously invoked, then ensure the
    * dialog is brought with the last user-selected directory
    */
    if (*szFullFile)
    {
	pch = strrchr(szFullFile, '\\');
	strcpy(++pch, szExtension);
	strcpy(vfdg.szFullFile, szFullFile);
    }
    else
	strcpy(vfdg.szFullFile, szExtension);

   /*
    * Invoke the standard file dialog and get a file.
    */
    if (!WinFileDlg(HWND_DESKTOP, vhwndFrame, (PFILEDLG)&vfdg))
    {
	MessageBox(vhwndFrame, IDMSG_CANNOTRUNFILEOPEN, 0,
			    MB_OK | MB_ERROR, TRUE);
	return FALSE;
    }
    WinInvalidateRect(vhwndClient, (PRECTL)NULL, FALSE);

   /*
    *  Upon successful return of a file, open it for reading.
    */
    if (vfdg.lReturn == DID_OK)
    {
	strcpy(szFullFile, vfdg.szFullFile);

       /*
	* attempt to load selected image
	*/
	WinSetPointer(HWND_DESKTOP, vhptrWait);
	fSuccess = FileLoadImage();
	WinSetPointer(HWND_DESKTOP, vhptrArrow);

       /*
	* Report error if image cannot be loaded.
	*/
	if (!fSuccess)
	{
	    MessageBox(vhwndFrame, IDMSG_CANNOTOPENINPUTFILE, 0,
		       MB_OK | MB_ERROR, FALSE);
	    return FALSE;
	}

	/* Update title with new filename.     */
	UtilUpdateTitleText(vhab, vhwndFrame, szFullFile);

	/* reset scrollbars */
	WinSendMsg(vhwndVScroll, SBM_SETPOS, (MPARAM)NULL, (MPARAM)NULL);
	WinSendMsg(vhwndHScroll, SBM_SETPOS, (MPARAM)NULL, (MPARAM)NULL);

	WinInvalidateRect(vhwndClient, (PRECTL)NULL, FALSE);

       /* This routine currently doesn't use the mp2 parameter but       *\
	*  it is referenced here to prevent an 'Unreferenced Parameter'
       \*  warning at compile time.					 */
	mp2;
    }
}   /*	End of FileOpen */

/**************************************************************************
 *
 *  Name       : FileLoadImage()
 *
 *  Description: Loads an image into storage
 *
 *  Concepts   : Routine is called whenever a WM_COMMAND message
 *		 is posted to the main window as a result of
 *		 selecting the 'Open...' item on the 'File'
 *		 pulldown.  It calls SizeCalculateMaxWindow() and
 *		 DrawImage().
 *
 *		  - determine the size of the image to be loaded
 *		  - allocate allocation storage to contain the
 *		    image
 *		  - load image into allocated storage
 *
 *  API's      : WinSendMsg
 *		 DosRead
 *		 DosClose
 *		 WinIsChild
 *		 WinSetParent
 *
 *  Parameters : [none]
 *
 *  Return     : TRUE  - if image successfully loaded
 *		 FALSE - if it failed to load the image
 *
 *************************************************************************/
BOOL FileLoadImage(void)
{
   ULONG  ulBufSiz;   /* size of buffer required for the image */
   HFILE  hfile;
#if (defined(PORT_S132) || defined(PORT_32))
   ULONG cByte;
#else
   USHORT cByte;
#endif
   BOOL fFailed = FALSE;
   CHAR szTmp[10];	  /* to hold image file header	       */

   /*
    * Locate the selected file and determine its size, so that enough
    * storage can be allocated.
    */
   if (!(ulBufSiz = UtilFindFileSize(szFullFile)))
      return FALSE;

   /*
    * free any image storage buffer already in use
    */
   if (vfImgLoaded)
#if (defined(PORT_16) || defined(PORT_S132))
      UtilMemoryFree(SELECTOROF(vpbImgBuf));
#else
      UtilMemoryFree(vpbImgBuf);
#endif
    /* allocate memory for image */
   if (!UtilMemoryAllocate((USHORT)ulBufSiz, &vpbImgBuf))
      return FALSE;

   /*
    * open the image-data file
    */
   if (!UtilGetFileHandle(szFullFile, &hfile))
   {
      vfDetail = FALSE;
      vfImgLoaded = FALSE;
#if (defined(PORT_16) || defined(PORT_S132))
      UtilMemoryFree(SELECTOROF(vpbImgBuf));
#else
      UtilMemoryFree(vpbImgBuf);
#endif
      return FALSE;
   }
   /*
    * read the image width and height values from the image-file header
    * note: the image width is in bytes & the image height is in pels
    */
   DosRead(hfile, (PVOID)szTmp, 4L, &cByte);
   szTmp[4] = '\0';
   vsizlImg.cx = atol(szTmp);

   /* check for comma in header */
   DosRead(hfile, (PVOID)szTmp, 1L, &cByte);
   szTmp[1] = '\0';

   if (strcmp(szTmp, ","))
       fFailed = TRUE;
   else
   {
       /* read the image height field */
       DosRead(hfile, (PVOID)szTmp, 4L, &cByte);
       szTmp[4] = '\0';
       vsizlImg.cy = atol(szTmp);
   }

   /*
    * if header not correct format, fail the load
    */
   if (fFailed || vsizlImg.cx == 0L || vsizlImg.cy == 0L)
   {
       DosClose(hfile);
       vfDetail = FALSE;
       vfImgLoaded = FALSE;
#if (defined(PORT_16) || defined(PORT_S132))
       UtilMemoryFree(SELECTOROF(vpbImgBuf));
#else
       UtilMemoryFree(vpbImgBuf);
#endif
       return FALSE;
   }

   /*
    * adjust the image height (if necessary) to keep within 64KB limit
    */
   if (ulBufSiz >= MAX_IMAGE_SIZE)
      vsizlImg.cy = MAX_IMAGE_SIZE / (vsizlImg.cx + 3);

   /*
    * convert the image-width value to pels
    */
   vsizlImg.cx *= 8;

   /*
    * transfer the image data to application storage
    */
   DosRead(hfile, (PVOID)vpbImgBuf, ulBufSiz, &cByte);

   DosClose(hfile);

   /*
    * Invoke the DrawImage function to define a bitmap containing the
    * image.
    */
   PaintDrawImage();
   vfDetail = FALSE;
   vfImgLoaded = TRUE;

   /*
    * As 'Non-Detail' mode is set, scrolling should be disabled. The scroll
    * bars are made invisible by ensuring that they are no longer
    * object windows.
    */
   if (WinIsChild(vhwndVScroll, vhwndFrame))
   {
       WinSetParent(vhwndVScroll, HWND_OBJECT, FALSE);
       WinSetParent(vhwndHScroll, HWND_OBJECT, FALSE);
       WinSendMsg(vhwndFrame,
		  WM_UPDATEFRAME,
		  MPFROMLONG(FCF_VERTSCROLL | FCF_HORZSCROLL),
		  (MPARAM)NULL);
   }
   return TRUE;

}  /* End of FileLoadImage */

/**************************************************************************
 *
 *  Name       : ImageOpenFilterProc
 *
 *  Description: Filters all help messages to the open dialog
 *
 *  Concepts   : Needed to display help from the Open dialog
 *
 *  API's      : WinDefFileDlgProc
 *
 *  Parameters : hwnd	= window handle
 *		 msg	= message code
 *		 mp1	= first message parameter
 *		 mp2	= second message parameter
 *
 *  Return     : same return as WinDefFileDlgProc()
 *
 *************************************************************************/
MRESULT EXPENTRY ImageOpenFilterProc(HWND hwnd,
				     ULONG message,
				     MPARAM mp1,
				     MPARAM mp2 )
{
   if(message == WM_HELP)
   {
       DisplayHelpPanel(HID_FS_OPEN_DLG_HELP_PANEL);
       return (MRESULT)FALSE ;
   }
   return WinDefFileDlgProc( hwnd, message, mp1, mp2 ) ;
} /* End of ImageOpenFilterProc	 */
#endif	/*  PORT_32  */
#ifdef PORT_16	/*  This is a dummy function for the 16-bit compile.  */
BOOL FileOpen(MPARAM mp2)
{
   return FALSE;
   mp2;
}  /* End of dummy FileOpen  */
#endif
/***************************  End of img_file.c	 *************************/
/**************************************************************************
 *  File name  :  img_help.c
 *
 *  Description:  This module contains all the routines for interfacing with
 *		  the IPF help manager.
 *
 *		  HelpInit()
 *		  HelpUsingHelp()
 *		  HelpGeneral()
 *		  HelpIndex()
 *		  HelpProductInfo()
 *		  HelpDestroyInstance()
 *
 *  Concepts   :  online help
 *
 *  API's      :  WinLoadString
 *		  WinCreateHelpInstance
 *		  WinAssociateHelpInstance
 *		  WinSendMsg
 *		  WinDestroyHelpInstance
 *		  WinDlgBox
 *
 *  Required
 *    Files    :  OS2.H, STRING.H, IMG_MAIN.H, IMG_XTRN.H, IMG_DLG.H,
 *		     IMG_HELP.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *  Include files, macros, defined constants, and externs
 */
#define INCL_WINHELP
#define INCL_WINDIALOGS
#define INCL_WINSTDFILE

#include <os2.h>
#include <string.h>

#include "img_main.h"
#include "img_xtrn.h"
#include "img_dlg.h"
#include "img_help.h"

#define HELPLIBRARYNAMELEN  20

/*
 *  Global variables
 */
static HWND hwndHelpInstance;

#ifdef HELP_MANAGER_ENABLED

/**************************************************************************
 *
 *  Name       : HelpInit()
 *
 *  Description: Initializes the IPF help facility
 *
 *  Concepts   : Called once during initialization of the program
 *
 *		 Initializes the HELPINIT structure and creates the
 *		 help instance.	 If successful, the help instance
 *		 is associated with the main window.
 *
 *  API's      : WinLoadString
 *		 WinCreateHelpInstance
 *		 WinAssociateHelpInstance
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID HelpInit(VOID)
{
   HELPINIT hini;
   CHAR szLibName[HELPLIBRARYNAMELEN];
   CHAR szWindowTitle[HELPLIBRARYNAMELEN];

   /* inititalize help init structure */
   hini.cb = sizeof(HELPINIT);
   hini.ulReturnCode = 0;

   hini.pszTutorialName = (PSZ)NULL;   /* if tutorial added, add name here */

   hini.phtHelpTable = (PHELPTABLE)(0xFFFF0000 | IMAGE_HELP_TABLE);
   hini.hmodHelpTableModule = 0;
   hini.hmodAccelActionBarModule = 0;
   hini.idAccelTable = 0;
   hini.idActionBar = 0;

#if (defined(PORT_16) || defined(PORT_S116))
#ifdef DEBUG
   hini.usShowPanelId = CMIC_SHOW_PANEL_ID;
#else
   hini.usShowPanelId = CMIC_HIDE_PANEL_ID;
#endif	/* DEBUG       */
#else	/* NOT PORT_16 */
#ifdef DEBUG
   hini.fShowPanelId = CMIC_SHOW_PANEL_ID;
#else
   hini.fShowPanelId = CMIC_HIDE_PANEL_ID;
#endif	/* DEBUG       */
#endif	/* NOT PORT_16 */

   if (!WinLoadString(vhab,
		      (HMODULE)0,
		      IDS_HELPWINDOWTITLE,
		      HELPLIBRARYNAMELEN,
		      (PSZ)szWindowTitle))
   {
       MessageBox(vhwndFrame, IDMSG_CANNOTLOADSTRING, 0,
		  MB_OK | MB_ERROR, FALSE);
       return;
   }
   hini.pszHelpWindowTitle = (PSZ)szWindowTitle;

   if (!WinLoadString(vhab,
		      (HMODULE)0,
		      IDS_HELPLIBRARYNAME,
		      HELPLIBRARYNAMELEN,
		      (PSZ)szLibName))
   {
       MessageBox(vhwndFrame, IDMSG_CANNOTLOADSTRING, 0,
		  MB_OK | MB_ERROR, FALSE);
       return;
   }
   hini.pszHelpLibraryName = (PSZ)szLibName;


   /* creating help instance */
   hwndHelpInstance = WinCreateHelpInstance(vhab, &hini);

   if (!hwndHelpInstance || hini.ulReturnCode)
   {
       MessageBox(vhwndFrame, IDMSG_HELPLOADERROR, 0,
		  MB_OK | MB_ERROR, FALSE);
       return;
   }

   /* associate help instance with main frame */
   if (!WinAssociateHelpInstance(hwndHelpInstance, vhwndFrame))
   {
       MessageBox(vhwndFrame, IDMSG_HELPLOADERROR, 0,
		  MB_OK | MB_ERROR, FALSE);
       return;
   }

   /* set flag to enable Help menu items */
   vfHelpEnabled = TRUE;
}   /* End of HelpInit */

/**************************************************************************
 *
 *  Name       : HelpUsingHelp()
 *
 *  Description: Processes the WM_COMMAND message posted by the
 *		 Using help item of the Help menu
 *
 *  Concepts   : Called from MainCommand when the Using help
 *		 menu item is selected
 *
 *		 Sends an HM_DISPLAY_HELP message to the help
 *		 instance so that the default Using help is
 *		 displayed.
 *
 *  API's      : WinSendMsg
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID  HelpUsingHelp(VOID)
{
   /* this just displays the system help for help panel */
   if (NULL != WinSendMsg(hwndHelpInstance, HM_DISPLAY_HELP,
			  (MPARAM)NULL, (MPARAM)NULL))
       MessageBox(vhwndFrame, IDMSG_HELPDISPLAYERROR, 0, MB_OK | MB_ERROR,
		  FALSE);
}   /* End of HelpUsingHelp   */

/**************************************************************************
 *
 *  Name       : HelpGeneral()
 *
 *  Description: Processes the WM_COMMAND message posted by the
 *		 General help item of the Help menu
 *
 *  Concepts   : Called from MainCommand when the General help
 *		 menu item is selected
 *
 *		 Sends an HM_EXT_HELP message to the help
 *		 instance so that the default General help is
 *		 displayed.
 *
 *  API's      : WinSendMsg
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID HelpGeneral(VOID)
{
   /* this just displays the system general help panel */
   if (NULL != WinSendMsg(hwndHelpInstance, HM_EXT_HELP,
			  (MPARAM)NULL, (MPARAM)NULL))
	 MessageBox(vhwndFrame, IDMSG_HELPDISPLAYERROR, 0, MB_OK | MB_ERROR,
		    FALSE);
}   /* End of HelpGeneral() */

/**************************************************************************
 *
 *  Name       : HelpIndex()
 *
 *  Description: Processes the WM_COMMAND message posted by the
 *		 Help index item of the Help menu
 *
 *  Concepts   : Called from MainCommand when the Help index
 *		 menu item is selected
 *
 *		 Sends an HM_INDEX_HELP message to the help
 *		 instance so that the Help Index is displayed.
 *
 *  API's      : WinSendMsg
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID HelpIndex(VOID)
{
    /* this just displays the system help index panel */
   if (NULL != WinSendMsg(hwndHelpInstance, HM_HELP_INDEX,
			  (MPARAM)NULL, (MPARAM)NULL))
       MessageBox(vhwndFrame, IDMSG_HELPDISPLAYERROR, 0, MB_OK | MB_ERROR,
		  FALSE);
}   /* End of HelpIndex() */

/**************************************************************************
 *
 *  Name       : HelpDestroyInstance()
 *
 *  Description: Destroys the help instance for the application
 *
 *  Concepts   : Called during Exit list processing
 *
 *		 Calls WinDestroyHelpInstance() to destroy the
 *		 help instance
 *
 *  API's      : WinDestroyHelpInstance
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID HelpDestroyInstance(VOID)
{
   if(hwndHelpInstance != 0L)
   {
      WinDestroyHelpInstance(hwndHelpInstance);
   }
   vfHelpEnabled = FALSE;
}   /* End of HelpDestroyInstance */

#endif

/**************************************************************************
 *
 *  Name       : HelpProductInfo()
 *
 *  Description:  Processes the WM_COMMAND message posted by the
 *		  Product information item of the Help menu
 *
 *  Concepts   : Called from MainCommand when the Product information
 *		 menu item is selected
 *
 *		 Calls WinDlgBox to display the Product information
 *
 *  API's      : WinDlgBox
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID  HelpProductInfo(void)
{
    WinDlgBox(HWND_DESKTOP, vhwndClient, ProductInfoDlgProc, (HMODULE)0,
	      IDD_PRODUCTINFO, (PVOID)NULL);
}   /* End of HelpProductInfo */

/**************************************************************************
 *
 *  Name       : DisplayHelpPanel(idPanel)
 *
 *  Description:  Displays the help panel whose id is given
 *
 *  Concepts   : Called whenever a help panel is desired to be
 *		 displayed, usually from the WM_HELP processing
 *		 of the dialog boxes
 *
 *		 Sends HM_DISPLAY_HELP message to the help instance
 *
 *  API's      : WinSendMsg
 *
 *  Parameters : idPanel = code number of the help panel to be displayed
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID DisplayHelpPanel(ULONG idPanel)
{
   if(vfHelpEnabled)
       if(NULL != WinSendMsg(hwndHelpInstance,
			     HM_DISPLAY_HELP,
			     MPFROMLONG(idPanel),
			     MPFROMSHORT(HM_RESOURCEID)))
   {
	   MessageBox(vhwndFrame,
		      IDMSG_HELPDISPLAYERROR,
		      0,
		      MB_OK | MB_ERROR,
		      TRUE);
    }
}   /* End of DisplayHelpPanel() */
/***************************  End of img_help.c	 *************************/
/**************************************************************************
 *  File name  :  img_init.c
 *
 *  Description:  This module contains the code for application
 *		  initialization as well as the code for exit list
 *		  processing.
 *		  Functions contained here:
 *
 *		  Init()
 *		  InitMainWindow()
 *		  InitClientArea(hwnd)
 *		  InitGlobalVars()
 *
 *  Concepts   :  initialization, subclassing
 *
 *  API's      :  DosExitList
 *		  DosExit
 *		  WinRegisterClass
 *		  WinLoadString
 *		  WinCreateStdWindow
 *		  WinWindowFromID
 *		  WinSetParent
 *		  WinSendMsg
 *		  WinSubclassWindow
 *		  WinOpenWindowDC
 *		  GpiCreatePS
 *		  GpiSetColor
 *		  GpiSetBackColor
 *		  GpiSetBackMix
 *		  WinQuerySysValue
 *		  WinQuerySysPointer
 *
 *  Required
 *    Files    :  OS2.H, IMG_MAIN.H, IMG_XTRN.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *  Include files, macros, defined constants, and externs
 */
#define INCL_DOSPROCESS
#define INCL_DOSERRORS
#define INCL_WINWINDOWMGR
#define INCL_WINFRAMEMGR
#define INCL_WINSYS
#define INCL_WINPOINTERS
#define INCL_WINSTDFILE
#define INCL_GPIPRIMITIVES

#include <os2.h>

#include "img_main.h"
#include "img_xtrn.h"

/*
 *  Entry point declarations
 */
BOOL InitMainWindow(VOID);
BOOL InitGlobalVars(VOID);
BOOL InitClientArea(HWND hwnd);

/*
 *  static variables
 */
CHAR szAppName[CCHAPPNAME];		   /* application title */
#define RETURN_ERROR	    1	     /* error return in DosExit */

/**************************************************************************
 *
 *  Name       : Init()
 *
 *  Description: Performs initialization functions.
 *
 *  Concepts   : Called once before the main window is created.
 *		 - register all window classes
 *		 - setup main application window
 *		 - set global variables
 *
 *  API's      :  DosExitList
 *		  DosExit
 *		  WinRegisterClass
 *		  WinLoadString
 *
 *  Parameters :  [none]
 *
 *  Return     :  NO_ERROR  - initiaization is successful
 *		  String_ID - initialization failed
 *
 *************************************************************************/
#ifdef PORT_16
USHORT Init(VOID)
#endif
#ifdef PORT_32
ULONG Init(VOID)
#endif
{
    /* Add ExitProc to the exit list to handle the exit processing.  If
     * there is an error, then terminate the process since there have
     * not been any resources allocated yet
     */
   if (DosExitList(EXLST_ADD, (PFNEXITLIST)ExitProc))
   {
       MessageBox(HWND_DESKTOP,
		  IDMSG_CANNOTLOADEXITLIST, 0,
		  MB_OK | MB_ERROR,
		  TRUE);
       DosExit(EXIT_PROCESS, RETURN_ERROR);
   }

   /* load application name from resource file */
   if(0==WinLoadString(vhab, (HMODULE)NULL, IDS_APPNAME, CCHAPPNAME, szAppName))
       return IDMSG_CANNOTLOADSTRING;

   /* register the main client window class */
   if (!WinRegisterClass(vhab,
		szAppName,
		(PFNWP)MainWndProc,
		0L,
		0))
       return IDMSG_INITFAILED;

   /*
    * create main application window & detach scrollbars
    */
   if (!InitMainWindow())
       return IDMSG_MAINWINCREATEFAILED;

   /*
    * set up globals used for sizing & system pointers
    */
   if (!InitGlobalVars())
      return IDMSG_INITFAILED;

   /*
    * this function prepares the application for loading images
    */
   InitClientArea(vhwndClient);

   /*
    * initialize help mechanism
    */
#ifdef HELP_MANAGER_ENABLED
   HelpInit();
#endif

   return NO_ERROR;
}  /* End of Init */

/**************************************************************************
 *
 *  Name       : InitMainWindow()
 *
 *  Description: Creates the application window and puts it into
 *		 its initial state.
 *
 *  Concepts   : Called once by the Init() routine
 *		 - create main application window
 *		 - detach scrollbars from window
 *		 - subclass frame window procedure
 *
 *  API's      :  WinCreateStdWindow
 *		  WinWindowFromID
 *		  WinSetParent
 *		  WinSendMsg
 *		  WinRegisterClass
 *		  WinSubclassWindow
 *
 *  Parameters :  [none]
 *
 *  Return     :  TRUE - window successfully created
 *		  FALSE - window creation failed
 *
 *************************************************************************/
BOOL InitMainWindow(VOID)
{
   ULONG ctlData = FCF_STANDARD | FCF_VERTSCROLL | FCF_HORZSCROLL;

   /*
    * Create a window with standard controls.
    */
   vhwndFrame = WinCreateStdWindow(
			 HWND_DESKTOP,
			 WS_VISIBLE,
			 (PULONG)&ctlData,
			 (PSZ)szAppName,
			 (PSZ)NULL,
			 WS_VISIBLE,
			 (HMODULE)NULL,
			 IDR_MAIN,
			 (PHWND)&vhwndClient);
   if (!vhwndFrame)
      return FALSE;

   /*
    * for the time being detach the scrollbars from the main
    * window - but remember their handles for later
    */
   vhwndVScroll = WinWindowFromID(vhwndFrame, FID_VERTSCROLL);
   vhwndHScroll = WinWindowFromID(vhwndFrame, FID_HORZSCROLL);
   WinSetParent(vhwndVScroll, HWND_OBJECT, FALSE);
   WinSetParent(vhwndHScroll, HWND_OBJECT, FALSE);
   WinSendMsg(vhwndFrame, WM_UPDATEFRAME,
	      MPFROMLONG(FCF_VERTSCROLL | FCF_HORZSCROLL), (MPARAM)NULL);

   /* save menubar handle */
   vhwndMenu = WinWindowFromID(vhwndFrame, FID_MENU);

   /*
    * the frame window procedure is subclassed, so that frame-sizing
    * restrictions can be implemented.
    */
   if (!WinRegisterClass(vhab, "SUBFRAME", (PFNWP)FrameWndProc, 0L, 0))
      return FALSE;

   vpfnwpFrame = WinSubclassWindow(vhwndFrame, (PFNWP)FrameWndProc);

   return TRUE;
} /* End of InitMainWindow() */

/**************************************************************************
 *
 *  Name       : InitClientArea()
 *
 *  Description: Prepares the client area to accept the images
 *
 *  Concepts   : Called once by the Init() routine
 *		 - obtain a window device context
 *		 - define the image presentation space
 *		 - associate the two
 *		 - set foreground/background colours &
 *		   background mix for the presentation space
 *
 *  API's      :  WinOpenWindowDC
 *		  GpiCreatePS
 *		  GpiSetColor
 *		  GpiSetBackColor
 *		  GpiSetBackMix
 *
 *  Parameters :  hwnd = client window handle
 *
 *  Return     :  TRUE - client area successfully set up
 *		  FALSE - client area setup failed
 *
 *************************************************************************/
BOOL InitClientArea(HWND hwnd)
{
   SIZEL  sizl;

   sizl.cx = 0L;		/* set size to default for device    */
   sizl.cy = 0L;		/*  (full screen)		     */

   vhdc = WinOpenWindowDC(hwnd);
   if (!vhdc)
       return FALSE;

   vhps = GpiCreatePS(vhab,
		      vhdc,
		      &sizl,
		      (ULONG)PU_PELS | GPIT_NORMAL | GPIA_ASSOC
		      );
   if (!vhps)
       return FALSE;

   GpiSetColor(vhps, vlForeClr);
   GpiSetBackColor(vhps, vlBackClr);
   GpiSetBackMix(vhps, BM_OVERPAINT);

   return TRUE;
}   /* End of InitClientArea */

/**************************************************************************
 *
 *  Name       : InitGlobalVars()
 *
 *  Description: Performs initialization of the application  s
 *		 global variables
 *
 *  Concepts   : Called once by the Init() routine
 *
 *  API's      :  WinQuerySysValue
 *		  WinQuerySysPointer
 *
 *  Parameters :  [none]
 *
 *  Return     :  TRUE - initialization is successful
 *		  FALSE - initialization failed
 *
 *************************************************************************/
BOOL InitGlobalVars(VOID)
{
   /* load system sizes */
   vlXScreen = WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN);
   vlYScreen = WinQuerySysValue(HWND_DESKTOP, SV_CYSCREEN);
   vlcxVScroll = WinQuerySysValue(HWND_DESKTOP, SV_CXVSCROLL);
   vlcyHScroll = WinQuerySysValue(HWND_DESKTOP, SV_CYHSCROLL);
   vlcyTitle = WinQuerySysValue(HWND_DESKTOP, SV_CYTITLEBAR);
   vlcyMenu = WinQuerySysValue(HWND_DESKTOP, SV_CYMENU);
   vlcxBorder = WinQuerySysValue(HWND_DESKTOP, SV_CXSIZEBORDER);
   vlcyBorder = WinQuerySysValue(HWND_DESKTOP, SV_CYSIZEBORDER);

   /* load system pointers */
   vhptrArrow = WinQuerySysPointer(HWND_DESKTOP, SPTR_ARROW, FALSE);
   vhptrWait = WinQuerySysPointer(HWND_DESKTOP, SPTR_WAIT, FALSE);
   return TRUE;
} /* End of InitGlobalVars  */
/***************************  End of img_init.c	 *************************/
/**************************************************************************
 *  File name  :  img_main.c
 *
 *  Description:  This application serves as an example of porting a 16-bit
 *		  application to 32-bit.  It modifies a 16-bit application
 *		  which was built using the headers/libraries/tools
 *		  from the OS/2 1.3 toolkit and produces a pure 32-bit
 *		  application.
 *
 *		  This source file contains the following functions:
 *
 *		  main()
 *		  MainWndProc(hwnd, msg, mp1, mp2)
 *		  FrameWndProc(hwnd, msg, mp1, mp2)
 *		  MessageBox(hwnd idMsg, fsStyle, fBeep)
 *		  MainCommand(mp1, mp2)
 *		  ExitProc(usTermCode)
 *
 *  Concepts   :  porting
 *
 *  API's      :  WinInitialize
 *		  DosBeep
 *		  WinCreateMsgQueue
 *		  WinGetMsg
 *		  WinTerminate
 *		  WinDispatchMsg
 *		  WinBeginPaint
 *		  WinFillRect
 *		  WinEndPaint
 *		  WinInvalidateRect
 *		  GpiAssociate
 *		  GpiDestroyPS
 *		  GpiSetBitmap
 *		  GpiDeleteBitmap
 *		  GpiDestroyPS
 *		  DevCloseDC
 *		  WinIsChild
 *		  WinSetParent
 *		  WinPostMsg
 *		  WinQueryWindowRect
 *		  GpiQueryCurrentPosition
 *		  WinMapWindowPoints
 *		  WinCalcFrameRect
 *		  WinLoadMessage
 *		  WinAlarm
 *		  WinIsWindow
 *		  WinDestroyWindow
 *		  WinDestroyMsgQueue
 *		  DosExitList
 *
 *  Required
 *    Files    :  OS2.H, STRING.H, STDIO.H, IMG_MAIN.H, IMG_XTRN.H,
 *		  IMG_HELP.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *  Include files, macros, defined constants, and externs
 */
#define INCL_DOSPROCESS
#define INCL_WINWINDOWMGR
#define INCL_WINFRAMEMGR
#define INCL_WINSYS
#define INCL_WINTRACKRECT
#define INCL_WINHELP
#define INCL_WINSTDFILE
#define INCL_GPIPRIMITIVES
#define INCL_GPIBITMAPS

/*
 *  Include files, macros, defined constants, and externs
 */
#include <os2.h>
#include <string.h>
#include <stdio.h>

#include "img_main.h"
#include "img_xtrn.h"
#include "img_help.h"

/*
 *  error defines
 */
#define RETURN_SUCCESS	     0	/* successful return in DosExit */
#define RETURN_ERROR	     1	/* error return in DosExit	*/
#define BEEP_WARN_FREQ	    60	/* frequency of warning beep	*/
#define BEEP_WARN_DUR	   100	/* duration of warning beep	*/

/*
 *  Entry point declarations
 */
VOID MainCommand(MPARAM mp1, MPARAM mp2);

/*
 *  Static variables
 */
HMQ    hmq;	      /* application queue handle */

/**************************************************************************
 *
 *  Name       : main()
 *
 *  Description: Initializes the PM environment, calls the
 *		 initialization routine, creates the main
 *		 window,  and polls the message queue
 *
 *  Concepts   : - obtains anchor block handle and creates message
 *		     queue
 *		 - calls the initialization routine
 *		 - creates the main frame window which creates the
 *		     main client window
 *		 - polls the message queue via Get/Dispatch Msg loop
 *		 - upon exiting the loop, exits
 *
 *  API's      :  WinInitialize
 *		  DosBeep
 *		  WinCreateMsgQueue
 *		  WinGetMsg
 *		  WinTerminate
 *		  WinDispatchMsg
 *
 *  Parameters :  [none]
 *
 *  Return     :  1 - if successful execution completed
 *		  0 - if error
 *
 *************************************************************************/
int main(void)
{
   QMSG	  qmsg;		 /* message structure */
#ifdef PORT_16
   USHORT rc;
#endif
#ifdef PORT_32
   ULONG  rc;
#endif

   vhab = WinInitialize(0);
   if(!vhab)
   {
       DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
       return RETURN_ERROR;
   }

   /* find a define for this v */
   hmq = WinCreateMsgQueue(vhab, 0);
   if(!hmq)
   {
       DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
       WinTerminate(vhab);
       return RETURN_ERROR;
   }

   if(rc = Init())
   {
       MessageBox(HWND_DESKTOP, rc, 0, MB_OK | MB_ERROR, TRUE);
   }
   else
   {
       /* get/dispatch message loop */
       while (WinGetMsg(vhab, &qmsg, (HWND)NULL, 0, 0))
	  WinDispatchMsg(vhab, &qmsg);
   }

  /*
   * release any allocated resource - no need to check return codes
   */
#ifdef HELP_MANAGER_ENABLED
    /* destroy the help instance */
   HelpDestroyInstance();
#endif
   return RETURN_SUCCESS;
}   /* End of main */

/**************************************************************************
 *
 *  Name       : MainWndProc(hwnd, msg, mp1, mp2)
 *
 *  Description: Processes the messages sent to the main client
 *		 window.  This routine processes the basic
 *		 messages all client windows should process
 *		 and passes all others onto UserWndProc where
 *		 the developer can process any others.
 *
 *  Concepts   : Called for each message placed in the main
 *		 window's message queue
 *
 *		 A switch statement branches to the routines to be
 *		 performed for each message processed.	Any messages
 *		 not specifically process are passed to the user's
 *		 message processing procedure UserWndProc().
 *
 *  API's      :  WinBeginPaint
 *		  WinFillRect
 *		  WinEndPaint
 *		  WinInvalidateRect
 *		  GpiQueryCurrentPosition
 *		  WinQueryWindowRect
 *		  GpiAssociate
 *		  GpiDestroyPS
 *		  GpiSetBitmap
 *		  GpiDeleteBitmap
 *		  GpiAssociate
 *		  GpiDestroyPS
 *		  DevCloseDC
 *		  WinIsChild
 *		  WinSetParent
 *		  WinPostMsg
 *
 *  Parameters :  hwnd = window handle
 *		  msg  = message code
 *		  mp1  = first message parameter
 *		  mp2  = second message parameter
 *
 *  Return     :  values are determined by each message
 *
 *************************************************************************/
MRESULT EXPENTRY MainWndProc(
	     HWND hwnd,	     /* handle of window */
#ifdef PORT_16
	     USHORT  msg,     /* id of message */
#endif
#ifdef PORT_32
	     ULONG  msg,     /* id of message */
#endif
	     MPARAM mp1,     /* first message parameter */
	     MPARAM mp2)     /* second message parameter */
{
   PSWP	   pswp;
   BOOL	   fHScroll;
   RECTL   rcl;
   POINTL  ptl;

   switch (msg)
   {
       case WM_CREATE:
	  /*
	   * set application title to 'Untitled'
	   */
	   UtilUpdateTitleText(vhab,
			       ((PCREATESTRUCT)PVOIDFROMMP(mp2))->hwndParent,
			       "");

	   /* return FALSE to continue window creation, TRUE to abort it */
	   return (MRESULT)FALSE;
	   break;

       case WM_INITMENU:

	  /*
	   * disable/enable menu items as appropriate
	   */
	   MenuInit(mp1, mp2);
	   break;

       case WM_ERASEBACKGROUND:

	  /*
	   * The client window is cleared to SYSCLR_WINDOW
	   */
	   return (MRESULT)TRUE;
	   break;

       case WM_MINMAXFRAME:

	  /*
	   * the window can be maximized by double clicking on the
	   * title bar, clicking on the maximize icon, or by
	   * selecting the maximize option in the System Menu.
	   * The SizeCalculateMaxWindow() function is invoked to set the
	   * window to a size that is no larger than the loaded image.
	   */
	   pswp = (PSWP)mp1;
#if (defined(PORT_S132) || defined(PORT_32))
	   if (pswp->fl & SWP_MAXIMIZE) {
#else
	   if (pswp->fs & SWP_MAXIMIZE) {
#endif

	      /*
	       * disable options which aren't valid when
	       * the window is maximized
	       */
	       vfMaximized = TRUE;

	       if (vfDetail)
	       {
		   SizeCalculateMaxWindow(&rcl);
		   pswp->cy = (SHORT)(rcl.yTop - rcl.yBottom);
		   pswp->cx = (SHORT)(rcl.xRight - rcl.xLeft);
		   pswp->y  = (SHORT)rcl.yBottom;
		   pswp->x  = (SHORT)rcl.xLeft;
	       }
	   }
	   else

	      /*
	       * re-enable options which were invalid when
	       * the window was maximized
	       */
	       vfMaximized = FALSE;
	   break;

       case WM_PAINT:

	   WinBeginPaint(hwnd, vhps, (PRECTL)&rcl);
	   if (vfImgLoaded && vfDetail)

	      /*
	       * If an image has been loaded and the user has selected
	       * the 'Detail' view, the PaintUnSizedImage() function is
	       * invoked to draw the image data in the client window.
	       * The image is drawn unscaled, and clipped if necessary.
	       */
	       PaintUnSizedImage();

	   else if (vfImgLoaded && !vfDetail)

	      /*
	       * If an image has been loaded and the user has selected
	       * the 'Non-detailed' view, the PaintSizedImage() function is
	       * invoked to size the image and draw it.
	       * The image is drawn scaled to fit the window.
	       */
	       PaintSizedImage();

	   else
	      /*
	       * If no image data has been loaded, clear the window to
	       * the default system color.
	       */
	       WinFillRect(vhps, &rcl, SYSCLR_WINDOW);

	   WinEndPaint(vhps);
	   break;

       case WM_SIZE:

	  /*
	   * If the window size is altered and the image is being
	   * viewed in detail, the WndSize function is invoked to restrict
	   * the new window size and scroll-bar range to image limits.
	   * If the 'Non-detailed' view has been selected and the window
	   * size is altered, the image has to be redrawn to fit the window.
	   */
	   if (vfImgLoaded && vfDetail)
	       SizePositionImage(mp2);

	   WinInvalidateRect(hwnd, (PRECTL)NULL, FALSE);
	   break;

       case WM_HSCROLL:
       case WM_VSCROLL:

	  /*
	   * scrolling is implemented only if an image has been
	   * loaded, the 'Detail' view has been selected, and there is
	   * image data still lying outside window limits.
	   */
	   fHScroll = (BOOL)(msg == WM_HSCROLL);
	   if (vfImgLoaded && vfDetail &&
	       (fHScroll ? vulScrollXMax > 0 : vulScrollYMax > 0))
	   {
	      GpiQueryCurrentPosition(vhps, &ptl);
	      WinQueryWindowRect(hwnd, &rcl);

	       /* call the appropriate scroll routine */
	      (fHScroll ? SizeHScroll(mp2, rcl, ptl) :
			  SizeVScroll(mp2, rcl, ptl));
	   }
	   break;

       case WM_DESTROY:

	  /*
	   * delete the image graphics presentation space
	   */
	   GpiAssociate(vhps, (HDC)NULL);
	   GpiDestroyPS(vhps);

	   if (vfImgLoaded)
	   {
	      /*
	       * Free any allocated memory
	       */
#if (defined(PORT_16) || defined(PORT_S132))
	       UtilMemoryFree(SELECTOROF(vpbImgBuf));
#else
	       UtilMemoryFree(vpbImgBuf);
#endif

	      /*
	       * Release all bit-map resources and close the memory
	       * device context
	       */
	       GpiSetBitmap(vhpsMem, (HBITMAP)NULL);
	       GpiDeleteBitmap(vhbm);
	       GpiAssociate(vhpsMem, (HDC)NULL);
	       GpiDestroyPS(vhpsMem);
	       DevCloseDC(vhdcMem);
	   }

	  /*
	   * ensure that the scroll bars are child windows of the
	   * frame, so that they will be destroyed automatically.
	   */
	   if (!WinIsChild(vhwndHScroll, vhwndFrame))
	   {
	       WinSetParent(vhwndVScroll, vhwndFrame, FALSE);
	       WinSetParent(vhwndHScroll, vhwndFrame, FALSE);
	   }
	   break;

       case WM_CLOSE:
	   WinPostMsg(hwnd, WM_QUIT, (MPARAM)NULL, (MPARAM)NULL);
	   break;

       case WM_COMMAND:

	  /*
	   * processing of menu options is required
	   */
	   MainCommand(mp1, mp2);
	   break;

#ifdef HELP_MANAGER_ENABLED

       case HM_ERROR:
	  /*
	   * an error has occurred while using IPF help - report
	   * the error and destroy the help instance
	   */
	   MessageBox(vhwndFrame, IDMSG_HELPMANAGERERROR, 0,
		      MB_OK | MB_ERROR, TRUE);
	   vfHelpEnabled = FALSE;
	   break;
#endif
       default:

	   /*
	    * default must call WinDefWindowProc()
	    */
	  return WinDefWindowProc(hwnd, msg, mp1, mp2);
	  break;
   }
   return (MRESULT)NULL; /* window procedures should return 0 as a default */
}   /* End of MainWndProc */

/**************************************************************************
 *
 *  Name       : FrameWndProc(hwnd, msg, mp1, mp2)
 *
 *  Description: The purpose of the frame-window subclass procedure
 *		 is to restrict frame-window sizing so that it is
 *		 in step with the size of the client-window
 *		 presentation space.  The size of the image
 *		 determines the size of the maximized window.
 *		 Messages intended for the frame-window procedure
 *		 are sent here first.
 *
 *  Concepts   :  Called for each message placed in the main
 *		  window's message queue
 *
 *		 A switch statement branches to the routines to be
 *		 performed for each message processed.	Any messages
 *		 not specifically processed are passed to the user's
 *		 message processing procedure MainWndProc(). The
 *		 message trapped by this wndproc() are
 *		 WM_QUERYTRACKINFO & WM_ADJUSTWINDOWPOS which are
 *		 both posted to the frame procedure initially to
 *		 set up the default values.
 *
 *  API's      :  WinQueryWindowRect(vhwn
 *		  GpiQueryCurrentPosition
 *		  WinMapWindowPoints
 *		  WinCalcFrameRect
 *
 *  Parameters :  hwnd = window handle
 *		  msg  = message code
 *		  mp1  = first message parameter
 *		  mp2  = second message parameter
 *
 *  Return     :  values are determined by each message
 *
 *************************************************************************/
MRESULT EXPENTRY FrameWndProc(
	     HWND hwnd,	     /* handle of window */
#ifdef PORT_16
	     USHORT msg,     /* id of message (16-bit)	*/
#endif
#ifdef PORT_32
	     ULONG  msg,     /* id of message (32-bit)	 */
#endif
	     MPARAM mp1,     /* first message parameter */
	     MPARAM mp2)     /* second message parameter */
{
   SWP	      swp;
   PSWP	      pswp;
   RECTL      rcl;
   ULONG      rc;
   POINTL     ptl;
   PTRACKINFO ptrack;

   switch(msg)
   {
       case WM_ADJUSTWINDOWPOS:

	  /*
	   * restrict the size of the window so that it never exceeds
	   * the maximum size of the image - only handle explicitly
	   * for the 'Detail' mode
	   */
	   if (vfImgLoaded && vfDetail)
	   {
	       rc = (ULONG)(*vpfnwpFrame)(hwnd, msg, mp1, mp2);
	       pswp = (PSWP)mp1;
	       swp = *pswp;

	      /*
	       * Find the maximum allowed size, and ensure that
	       * the window size never exceeds this.
	       */
	       SizeCalculateMaxWindow(&rcl);
	       if (swp.cx > (SHORT)rcl.xRight)
		   swp.cx = (SHORT)rcl.xRight;
	       if (swp.cy > (SHORT)rcl.yTop)
		   swp.cy = (SHORT)rcl.yTop;
	       *pswp = swp;
	       return (MRESULT)rc;
	   }
	   else

	       /* let the system handle the message */
	       return (*vpfnwpFrame)(hwnd, msg, mp1, mp2);

	   break;

       case WM_QUERYTRACKINFO:

	  /*
	   * Invoke the normal frame-window procedure first in order
	   * to update the tracking rectangle to the new position.
	   */
	   (*vpfnwpFrame)(hwnd, msg, mp1, mp2);
	   ptrack = (PTRACKINFO)mp2;

	   if (vfImgLoaded && vfDetail)
	   {
	      /*
	       * Limit the size of the bounding rectangle only if the
	       * window is being sized.
	       * fs and rclBoundary are tracking information structure
	       * elements.
	       */
	       if (((ptrack->fs & TF_MOVE) != TF_MOVE) &&
		   ((ptrack->fs & TF_MOVE)	       ||
		    (ptrack->fs & TF_SETPOINTERPOS  )))
	       {
		   WinQueryWindowRect(vhwndClient, &rcl);
		   GpiQueryCurrentPosition(vhps, &ptl);

		   ptrack->rclBoundary.yTop    = rcl.yBottom + ptl.y;
		   ptrack->rclBoundary.yBottom = rcl.yBottom + ptl.y -
						 vsizlImg.cy;
		   ptrack->rclBoundary.xLeft   = rcl.xLeft + ptl.x;
		   ptrack->rclBoundary.xRight  = rcl.xLeft + ptl.x +
						 vsizlImg.cx;

		  /*
		   * Convert client boundary coordinates to screen
		   * coordinates.
		   */
		   WinMapWindowPoints(vhwndClient,
				      HWND_DESKTOP,
				      (PPOINTL)&ptrack->rclBoundary,
				      sizeof(RECTL)/sizeof(POINTL));

		  /*
		   * Calculate equivalent frame boundary from client
		   * boundary data.
		   */
		   WinCalcFrameRect(vhwndFrame,
				    (PRECTL)&ptrack->rclBoundary,
				    FALSE);

		   ptrack->fs |= TF_ALLINBOUNDARY;
	       }
	   }
	   return (MRESULT)TRUE;
       break;

   default:

      /*
       * return using the normal frame window procedure
       */
       return (*vpfnwpFrame)(hwnd, msg, mp1, mp2);
       break;

   }
   return (MRESULT)NULL; /* window procedures should return 0 as a default */
}   /* End of FrameWndProc */

/**************************************************************************
 *
 *  Name       : MessageBox(hwndOwner, idMsg, idCaption, fsStyle, fBeep)
 *
 *  Description: Displays the message box with the message
 *		 given in idMsg retrived from the message table
 *		 and using the style flags in fsStyle
 *
 *  Concepts   : Called whenever a MessageBox is to be displayed
 *		 - Message string is loaded from the process'
 *		     message table
 *		 - Alarm beep is sounded if desired
 *		 - Message box with the message is displayed
 *		 - WinMessageBox return value is returned
 *
 *  API's      :  WinLoadMessage
 *		  WinAlarm
 *		  WinMessageBox
 *
 *  Parameters :  hwnd	    =  handle of the owner of the message box
 *		  idMsg	    =  i.d. of the message in the message table
 *		  idCaption =  i.d. of the caption in the message table
 *		  fsStyle   =  style of the message box
 *		  fBeep	    =  whether to beep before displaying the box
 *
 *  Return     :  the values from WinMessageBox()
 *
 *************************************************************************/
ULONG MessageBox(
	 HWND hwndOwner,     /* handle of the message box's owner */
#ifdef PORT_16
	 USHORT idMsg,	      /* id of the message in the message table */
	 USHORT idCaption,    /* id of the caption in the message table */
	 USHORT fsStyle,      /* style of the message box */
#endif
#ifdef PORT_32
	 ULONG idMsg,	     /* id of the message in the message table */
	 ULONG idCaption,    /* id of the caption in the message table */
	 ULONG fsStyle,	     /* style of the message box */
#endif
	 BOOL fBeep)	     /* if TRUE, beep before message box is displayed */
{
   CHAR szText[MESSAGELEN];
   CHAR szCaption[MESSAGELEN];

   if (!WinLoadMessage(vhab,
		       (HMODULE)NULL,
		       idMsg,
		       MESSAGELEN,
		       (PSZ)szText))
   {
       WinAlarm(HWND_DESKTOP, WA_ERROR);
       return MBID_ERROR;
   }

  /*
   * if idCaption specified load string else use default
   * caption 'Error!'
   */
   if (idCaption)
   {
       if (!WinLoadMessage(vhab,
			   (HMODULE)NULL,
			   idCaption,
			   MESSAGELEN,
			  (PSZ)szCaption))
       {
	   WinAlarm(HWND_DESKTOP, WA_ERROR);
	   return MBID_ERROR;
       }
   }

   if (fBeep)
       WinAlarm(HWND_DESKTOP, WA_ERROR);

   return WinMessageBox(HWND_DESKTOP,
			hwndOwner,
			szText,
			(idCaption ? szCaption : (PSZ)NULL),
			MSGBOXID,
			fsStyle);
}   /* End of MessageBox */

/**************************************************************************
 *
 *  Name       : MainCommand(mp1, mp2)
 *
 *  Description: Calls the appropriate procedures that deal with
 *		 the selected menu item.
 *
 *  Concepts   : Routine is called whenever a WM_COMMAND message
 *		 is posted to the main window.
 *
 *		 A switch statement branches on the id of the
 *		 menu item that posted the message and the
 *		 appropriate action for that item is taken.  Any
 *		 menu ids that are not part of the standard menu
 *		 set are passed onto the user defined WM_COMMAND
 *		 processing procedure.
 *
 *  API's      :  [none]
 *
 *  Parameters :  mp1	    =  first message parameter
 *		  mp2	    =  second message parameter
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID MainCommand(MPARAM mp1, MPARAM mp2)
{
   switch (SHORT1FROMMP(mp1))
   {
       case IDM_FILEOPEN:

	  /*
	   * Open file and load/draw the selected image
	   */
	   FileOpen(mp2);
	   break;

       case IDM_VIEWDETAIL:

	  /*
	   * toggle between Detail and Non-Detail mode
	   */
	   ViewSwitchMode();
	   break;

       case IDM_VIEWSAVEPOSITION:

	  /*
	   * save the current image position
	   */
	   ViewSavePosition();
	   break;

       case IDM_VIEWRESTOREPOSITION:

	  /*
	   * save the current image position
	   */
	   ViewRestorePosition();
	   break;

       case IDM_VIEWFORECOLORBLACK:
       case IDM_VIEWFORECOLORWHITE:
       case IDM_VIEWFORECOLORBLUE:
       case IDM_VIEWFORECOLORGREEN:
       case IDM_VIEWFORECOLORYELLOW:
       case IDM_VIEWFORECOLORRED:
       case IDM_VIEWBACKCOLORBLACK:
       case IDM_VIEWBACKCOLORWHITE:
       case IDM_VIEWBACKCOLORBLUE:
       case IDM_VIEWBACKCOLORGREEN:
       case IDM_VIEWBACKCOLORYELLOW:
       case IDM_VIEWBACKCOLORRED:
	   ViewChangeColor(SHORT1FROMMP(mp1));
	   break;

#ifdef HELP_MANAGER_ENABLED
       case IDM_HELPUSINGHELP:
	   HelpUsingHelp();
	   break;

       case IDM_HELPGENERAL:
	   HelpGeneral();
	   break;

       case IDM_HELPINDEX:
	   HelpIndex();
	   break;
#endif
       case IDM_HELPPRODUCTINFO:
	   HelpProductInfo();
	   break;
    }
}   /* End of MainCommand */

/**************************************************************************
 *
 *  Name       : ExitProc(usTermCode)
 *
 *  Description: Cleans up certain resources when the application ends
 *
 *  Concepts   : Routine is called by DosExitList when the
 *		 application exits
 *
 *		 Global resources, such as the main window and
 *		 message queue, are destroyed and any system
 *		 resources used are freed.
 *
 *  API's      : WinIsWindow
 *		 WinDestroyWindow
 *		 WinDestroyMsgQueue
 *		 WinTerminate
 *		 DosExitList
 *
 *  Parameters : usTermCode = the termination code
 *
 *  Return     : EXLST_EXIT to the DosExitList handler
 *
 *************************************************************************/
VOID  ExitProc(USHORT usTermCode)
{
   /* destroy the main window if it exists */
   if (WinIsWindow(vhab, vhwndFrame))
       WinDestroyWindow(vhwndFrame);

   WinDestroyMsgQueue(hmq);
   WinTerminate(vhab);

   DosExitList(EXLST_EXIT, (PFNEXITLIST)NULL);	 /* termination complete */

   /* This routine currently doesn't use the usTermCode parameter so
    *  it is referenced here to prevent an 'Unreferenced Parameter'
    *  warning at compile time
    */
   usTermCode;

}   /* End of ExitProc */
/***************************  End of img_main.c	 *************************/
/**************************************************************************
 *  File name  :  img_menu.c
 *
 *  Description:  This module contains the code for initializing menus as a
 *		  result of a WM_INITMENU message, and also code for
 *		  disabling/enabling single menu items.	 Functions in this
 *		  file:
 *
 *		  MenuInit(mp1, mp2)
 *		  MenuGetColorItemId(idBase)
 *		  MenuEnableItem(hwndMenu, idItem, fEnabled)
 *		  MenuCheckItem(hwndMenu, idItem)
 *
 *  Concepts   :  menu management
 *
 *  API's      :  WinSendMsg
 *
 *  Required
 *    Files    :  OS2.H, IMG_MAIN.H, IMG_XTRN.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *  Include files, macros, defined constants, and externs
 */
#define INCL_WINMENUS
#define INCL_WINFRAMEMGR
#define INCL_WINSTDFILE
#include <os2.h>

#include "img_main.h"
#include "img_xtrn.h"

/*
 *  Entry point declarations
 */

/**************************************************************************
 *
 *  Name       : MenuInit(mp1, mp2)
 *
 *  Description: Processes the WM_INITMENU message for the main window,
 *		 disabling any menus that are not active
 *
 *  Concepts   : Routine is called each time a menu is dropped.
 *
 *		 A switch statement branches control based upon
 *		 the id of the menu which is being displayed.
 *
 *  API's      :  [none]
 *
 *  Parameters :  mp1 = first message parameter
 *		  mp2 = second message parameter
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID MenuInit(MPARAM mp1, MPARAM mp2)
{
   switch(SHORT1FROMMP(mp1))
   {
      case IDM_FILE:

	  /*
	   * set the items on the File sub-menu appropriately
	   */
	   MenuEnableItem(HWNDFROMMP(mp2), IDM_FILEOPEN, (BOOL)!vfMaximized);
	   break;

      case IDM_VIEW:

	  /*
	   * set the items on the View sub-menu appropriately
	   */
	 if (!vfImgLoaded)
	     MenuEnableItem(HWNDFROMMP(mp2), IDM_VIEWDETAIL, FALSE);
	 else
	 {
	     MenuEnableItem(HWNDFROMMP(mp2), IDM_VIEWDETAIL, TRUE);
	     MenuCheckItem(HWNDFROMMP(mp2), IDM_VIEWDETAIL, vfDetail);
	 }

	 MenuEnableItem(HWNDFROMMP(mp2), IDM_VIEWFOREGROUNDCOLOR,
			vfImgLoaded);

	 MenuEnableItem(HWNDFROMMP(mp2), IDM_VIEWBACKGROUNDCOLOR,
			vfImgLoaded);

	 MenuEnableItem(HWNDFROMMP(mp2), IDM_VIEWSAVEPOSITION,
			(BOOL)(vfImgLoaded && vfDetail));

	 MenuEnableItem(HWNDFROMMP(mp2), IDM_VIEWRESTOREPOSITION,
			(BOOL)(vfImgLoaded && vfDetail));

	 break;

      /*
       * check the currently selected foreground color &
       * set global variable if previously not set
       */
      case IDM_VIEWFOREGROUNDCOLOR:
	 MenuEnableItem(HWNDFROMMP(mp2),
			 MenuGetColorItemId(IDM_VIEWFORECOLORBLACK), FALSE);

	 if (!vhwndViewForeClr)
	    vhwndViewForeClr = HWNDFROMMP(mp2);
	 break;

      /*
       * check the currently selected background color &
       * set global variable if previously not set
       */
      case IDM_VIEWBACKGROUNDCOLOR:
	 MenuEnableItem(HWNDFROMMP(mp2),
			 MenuGetColorItemId(IDM_VIEWBACKCOLORBLACK), FALSE);

	 if (!vhwndViewBackClr)
	    vhwndViewBackClr = HWNDFROMMP(mp2);
	 break;

      case IDM_HELP:
	   /*
	    * Enable or disable the Help menu depending upon whether the
	    * help manager has been enabled
	    */
	  MenuEnableItem(HWNDFROMMP(mp2),
			 IDM_HELPUSINGHELP, vfHelpEnabled);

	  MenuEnableItem(HWNDFROMMP(mp2),
			 IDM_HELPGENERAL, vfHelpEnabled);

	  MenuEnableItem(HWNDFROMMP(mp2),
			 IDM_HELPKEYS, vfHelpEnabled);

	  MenuEnableItem(HWNDFROMMP(mp2),
			 IDM_HELPINDEX, vfHelpEnabled);

	   /** REMEMBER: add a case for IDM_HELPTUTORIAL if you include
	       the menu item   **/

	  break;
   }
}   /* End of MenuInit */

/**************************************************************************
 *
 *  Name       : MenuGetColorItemId(idBase)
 *
 *  Description: Returns ID for the currently selected foreground/
 *		 background color value
 *
 *  Concepts   : Called whenever either the foreground/background
 *		 floating color menu is to be displayed.
 *
 *  API's      : [none]
 *
 *  Parameters : idBase = identifier of base color, foreground/background
 *
 *  Return     : id of menu item
 *
 *************************************************************************/
SHORT MenuGetColorItemId(SHORT idBase) /* Id of base color, foregrnd/backgrnd */
{
   LONG lColor;

   if (idBase == IDM_VIEWFORECOLORBLACK)
       lColor = vlForeClr;
   else
       lColor = vlBackClr;

   /*
    * calculate menu item id based on current color value
    */
   switch ((SHORT)lColor)
   {
       case CLR_BLACK:
	   return idBase;
	   break;
       case CLR_WHITE:
	   return (SHORT)(idBase + 1);
	   break;
       case CLR_BLUE:
	   return (SHORT)(idBase + 2);
	   break;
       case CLR_GREEN:
	   return (SHORT)(idBase + 3);
	   break;
       case CLR_YELLOW:
	   return (SHORT)(idBase + 4);
	   break;
       case CLR_RED:
	   return (SHORT)(idBase + 5);
	   break;
   }
}   /* End of MenuGetColorItemId */

/**************************************************************************
 *
 *  Name       : MenuEnableItem(hwndMenu, idItem, fEnable)
 *
 *  Description: Enables or disables the menu item
 *
 *  Concepts   : Called whenever a menu item is to be enabled or disabled
 *		 Sends a MM_SETITEMATTR to the menu with the
 *		 given item id.	 Sets the MIA_DISABLED attribute
 *		 flag if the item is to be disabled, clears the flag
 *		 if enabling.
 *
 *  API's      : WinSendMsg
 *
 *  Parameters : hwndMenu = menu handle
 *		 idItem	  = menu item identifier
 *		 fEnable  = flag to enable (TRUE) or disable (FALSE)
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID MenuEnableItem(
	    HWND hwndMenu,	/* Handle to the menu */
	    SHORT idItem,	/* Id of the menu item to be enabled/disabled */
	    BOOL fEnable)	/* flag to set enable or disable bit */
{
   WinSendMsg(hwndMenu,
	      MM_SETITEMATTR,
	      MPFROM2SHORT(idItem, TRUE),
	      MPFROM2SHORT(MIA_DISABLED,
			   (fEnable ? 0 : MIA_DISABLED)));
}   /* End of MenuEnableItem */

/**************************************************************************
 *
 *  Name       : MenuCheckItem(hwndMenu, idItem)
 *
 *  Description: Checks a menu item
 *
 *  Concepts   : Called whenever a menu item is to be checked
 *		 Sends a MM_SETITEMATTR to the menu with the
 *		 given item id.	 Sets the MIA_CHECKED attribute
 *		 flag if the item is to be checked.
 *
 *  API's      : WinSendMsg
 *
 *  Parameters : hwndMenu = menu handle
 *		 idItem	  = menu item identifier
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID MenuCheckItem(
	    HWND hwndMenu,	/* Handle to the menu */
	    SHORT idItem,	/* Id of the menu item to be enabled/disabled */
	    BOOL fCheck)	/* Check/uncheck item */
{
   WinSendMsg(hwndMenu,
	      MM_SETITEMATTR,
	      MPFROM2SHORT(idItem, TRUE),
	      MPFROM2SHORT(MIA_CHECKED,
			   (fCheck ? MIA_CHECKED : ~MIA_CHECKED)));

}   /* End of MenuCheckItem() */
/***************************  End of img_menu.c	 *************************/
/**************************************************************************
 *  File name  :  img_pnt.c
 *
 *  Description:  This module contains the code for the main client window
 *		  painting.  It contains these functions:
 *
 *		  PaintUnSizedImage()
 *		  PaintSizedImage()
 *		  PaintDrawImage()
 *
 *  Concepts   :  bitmaps
 *
 *  API's      :  GpiDeleteBitmap
 *		  GpiAssociate
 *		  GpiDestroyPS
 *		  DevCloseDC
 *		  DevOpenDC
 *		  GpiCreatePS
 *		  GpiCreateBitmap
 *		  GpiSetBitmap
 *		  GpiErase
 *		  GpiSetBackMix
 *		  GpiSetCurrentPosition
 *		  WinMessageBox
 *		  GpiImage
 *		  WinInvalidateRect
 *		  WinSetPointer
 *		  WinQueryWindowRect
 *		  WinDrawBitmap
 *
 *  Required
 *    Files    :  OS2.H, STRING.H, STDIO.H, IMG_MAIN.H, IMG_XTRN.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *  Include files, macros, defined constants, and externs
 */
#define INCL_DOSMEMMGR
#define INCL_DOSPROCESS
#define INCL_WINMENUS
#define INCL_WINFRAMEMGR
#define INCL_WINPOINTERS
#define INCL_WINSTDFILE
#define INCL_GPIPRIMITIVES
#define INCL_GPIBITMAPS

#include <os2.h>
#include <string.h>
#include <stdio.h>

#include "img_main.h"
#include "img_xtrn.h"

/**************************************************************************
 *
 *  Name       : PaintDrawImage()
 *
 *  Description: Draws the image data into the bitmap
 *
 *  Concepts   : Routine is called from LoadImage()
 *		 - creates a memory device context
 *		 - defines a memory presentation space
 *		 - associates the memory DC with the memory PS
 *		 - creates a bitmap
 *		 - Selects bitmap into memory DC
 *		 - draws the image data into the bitmap
 *
 *  API's      :  GpiDeleteBitmap
 *		  GpiAssociate
 *		  GpiDestroyPS
 *		  DevCloseDC
 *		  DevOpenDC
 *		  GpiCreatePS
 *		  GpiCreateBitmap
 *		  GpiSetBitmap
 *		  GpiErase
 *		  GpiSetBackMix
 *		  GpiSetCurrentPosition
 *		  WinMessageBox
 *		  GpiImage
 *		  WinInvalidateRect
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID PaintDrawImage(void)
{
   POINTL ptl;
   DEVOPENSTRUC dop;
#ifdef PORT_16
   BITMAPINFOHEADER  BmapInfo;
#endif
#ifdef PORT_32
   BITMAPINFOHEADER2 BmapInfo;
#endif

   if (vfImgLoaded)
   {
       /*
	* The memory presentation space is defined to accommodate a
	* particular file of image data. If an image has already been
	* loaded, its resources must be deleted before a new set can be
	* defined.
	*/
	GpiDeleteBitmap(vhbm);
	GpiAssociate(vhpsMem, (HDC)NULL);
	GpiDestroyPS(vhpsMem);
	DevCloseDC(vhdcMem);
   }

   /*
    * define the memory device context
    */
   dop.pszLogAddress = (PSZ)NULL;
   dop.pszDriverName = "DISPLAY";
   vhdcMem = DevOpenDC(vhab,
		       OD_MEMORY,
		       "*",
		       2L, /* number of valid elements */
		       (PDEVOPENDATA)&dop,
		       (HDC)NULL);

   /*
    * The memory presentation space is defined and associated with the
    * memory device context. The presentation page is the same size in
    * pels as the image.
    */
   vhpsMem = GpiCreatePS(vhab,
			 vhdcMem,
			 &vsizlImg,
			 (LONG)PU_PELS | GPIT_NORMAL | GPIA_ASSOC);

   /*
    * Create a bit map in a format compatible with the memory device
    * context.
    */

   /*
    * Define the bitmap information header.
    */
   BmapInfo.cbFix     = 16;		   /* bit-map header length   */
   BmapInfo.cx	      = vsizlImg.cx;
   BmapInfo.cy	      = vsizlImg.cy;
   BmapInfo.cPlanes   = 1L;		   /* number of bit planes    */
   BmapInfo.cBitCount = 1L;		   /* number of bits per pel  */


   /*
    * The bit map is defined and selected into the memory device
    * context. The output display is cleared.
    */
   vhbm = GpiCreateBitmap(vhpsMem,
			  &BmapInfo,
			  0L,			  /* no options	     */
			  (PBYTE)NULL,		  /* no initial data */
			  NULL);

   GpiSetBitmap(vhpsMem, vhbm);
   GpiErase(vhpsMem);
   GpiSetBackMix(vhpsMem, BM_OVERPAINT);

   /*
    * The current position is set to the top-left corner of the memory
    * presentation page before GpiImage is issued to draw the image
    * into it.
    */
   ptl.x = 0L;
   ptl.y = vsizlImg.cy;
   GpiSetCurrentPosition(vhpsMem, &ptl);
#ifdef PORT_32
   {
      BYTE     acInform[50];
      PBYTE    pbFileName;

      WinInvalidateRect(vhwndClient, (PRECTL)NULL, FALSE);
      sprintf (acInform, "Press OK to display this image.");
      pbFileName = strrchr(vfdg.szFullFile, '\\');  /* the last backslash */
      if(pbFileName)
	 pbFileName++;
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, (PSZ)acInform, (PSZ)pbFileName,
	      0L, MB_OK | MB_INFORMATION | MB_APPLMODAL | MB_MOVEABLE);
   }
#endif
   WinEnableWindowUpdate(vhwndClient, TRUE);

   GpiImage(vhpsMem,
	    0L,
	    &vsizlImg,				   /* image size	   */
	    (LONG)((vsizlImg.cx * vsizlImg.cy)/8), /* data length in bytes */
	    vpbImgBuf);				   /* image data	   */

   GpiSetBitmap(vhpsMem, (HBITMAP)NULL); /* free bit map in memory DC */
   WinInvalidateRect(vhwndClient, (PRECTL)NULL, FALSE);
}   /* End of PaintDrawImage */


/**************************************************************************
 *
 *  Name       : PaintUnSizedImage()
 *
 *  Description: Paints the image in the client window
 *
 *  Concepts   : Routine is called from MainWndProc()
 *
 *  API's      :  WinSetPointer
 *		  GpiImage
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID PaintUnSizedImage(void)
{
   WinSetPointer(HWND_DESKTOP, vhptrWait);

   GpiImage(vhps,
	    0L,
	    &vsizlImg,				 /* size in pels	 */
	    (LONG)(vsizlImg.cx * vsizlImg.cy/8), /* data length in bytes */
	    vpbImgBuf);				 /* image data		 */

   WinSetPointer(HWND_DESKTOP, vhptrArrow);
}   /* End of PaintUnSizedImage */

/**************************************************************************
 *
 *  Name       : PaintSizedImage()
 *
 *  Description: Paints the image in the client window, sizes
 *		 it so that the whole of the image is visible
 *		 (i.e. scaled as necessary)

 *  Concepts   : Routine is called from MainWndProc()
 *
 *  API's      :  WinQueryWindowRect
 *		  WinSetPointer
 *		  WinDrawBitmap
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID PaintSizedImage(void)
{
   RECTL  rcl;			 /* client window rectangle    */
   POINTL aptl[5];		 /* array of x,y pairs	       */

   /*
    * The dimensions of the target rectangle are obtained using the
    * WinQueryWindowRect() call.
    */
   WinQueryWindowRect(vhwndClient, &rcl); /* query client window size */
   aptl[0].x = 0;			  /* bottom left, in	      */
   aptl[0].y = 0;			  /*  device coordinates      */
   aptl[1].x = rcl.xRight - rcl.xLeft;	  /* top right, in	      */
   aptl[1].y = rcl.yTop - rcl.yBottom;	  /*  device coordinates      */

   /*
    * The dimensions of the source rectangle are those of the source
    * image.
    */
   aptl[2].x = 0;			  /* bottom left, in	      */
   aptl[2].y = 0;			  /*  window coordinates      */
   aptl[3].x = vsizlImg.cx;		  /* top right, in	      */
   aptl[3].y = vsizlImg.cy;		  /*  device coordinates      */

   WinSetPointer(HWND_DESKTOP, vhptrWait);

   /*
    * Draw the image.
    */
   WinDrawBitmap(vhps,
		 vhbm,
		 (PRECTL)NULL,		      /* draw whole bit map   */
		 (PPOINTL)&rcl,		      /* bit-map destination  */
					      /*  is client window    */
					      /*  rectangle.	      */
		 0L,
		 0L,
		 DBM_STRETCH | DBM_IMAGEATTRS);
					      /* stretch or compress  */
					      /*  to suit, and use    */
					      /*  image attributes    */
					      /*  for color.	      */

   WinSetPointer(HWND_DESKTOP, vhptrArrow);
}   /* End of PaintSizedImage */
/***************************  End of img_pnt.c	 *************************/
/**************************************************************************
 *  File name  :  img_size.c
 *
 *  Description:  This module contains the code for sizing the main window,
 *		  and scrolling the image inside the window.
 *		  Functions contained here:
 *
 *		  SizeMainWindow()
 *		  SizeCalculateMaxWindow(prclBound)
 *		  SizePositionImage(mp2)
 *		  SizeVScroll(mp2, rcl, ptl)
 *		  SizeHScroll(mp2, rcl, ptl)
 *		  ScrollBars(usWidth, usHeight)
 *		  Scroll(lThmbpos, lDeltaSc, sScrollType, prclInvalid)
 *
 *  Concepts   :  sizable windows
 *
 *  API's      :  WinSetWindowPos
 *		  WinQueryWindowRect
 *		  GpiSetCurrentPosition
 *		  WinSendMsg
 *		  WinWindowFromID
 *		  WinScrollWindow
 *		  WinInvalidateRect
 *		  GpiQueryCurrentPosition
 *
 *  Required
 *    Files    :  OS2.H, STRING.H, STDLIB.H, IMG_MAIN.H, IMG_XTRN.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *  Include files, macros, defined constants, and externs
 */
#define INCL_WINSCROLLBARS
#define INCL_WINFRAMEMGR
#define INCL_WINSTDFILE
#define INCL_GPIPRIMITIVES

#include <os2.h>
#include <string.h>
#include <stdlib.h>

#include "img_main.h"
#include "img_xtrn.h"

/*
 *  Static variables
 */
ULONG ulScrollXPage;
ULONG ulScrollYPage;
ULONG ulScrollYLine  = LINESCROLL;
ULONG ulScrollXLine  = LINESCROLL;

/*
 *  Entry point declarations
 */
VOID ScrollBars(USHORT usWidth, USHORT usHeight);
VOID Scroll(LONG lThmbpos, LONG lDeltaSc, SHORT sScrollType,
	    PRECTL prclInvalid);

/**************************************************************************
 *
 *  Name       : SizeMainWindow()
 *
 *  Description: Maximizes the amount of the image that is
 *		 visible . This can only be done after the image
 *		 has been loaded, as the size of the window is
 *		 directly related to the size of the image.
 *
 *  Concepts   : Routine is called whenever a WM_COMMAND message
 *		 is posted to the main window as a result of
 *		 selecting the 'Detail' item on the 'View'
 *		 pulldown.
 *
 *		  Sets the size and position of the main window
 *		  whenever 'Detail' mode is selected.
 *
 *  API's      :  WinSetWindowPos
 *		  WinQueryWindowRect
 *		  GpiSetCurrentPosition
 *
 *  Parameters :  [none]
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID SizeMainWindow(void)
{
    RECTL  rcl, rclCWM;

    /* limit the window size */
    SizeCalculateMaxWindow(&rclCWM);
    WinSetWindowPos(vhwndFrame, (HWND)NULL,
		    (SHORT)rclCWM.xLeft,
		    (SHORT)rclCWM.yBottom,
		    (SHORT)(rclCWM.xRight - rclCWM.xLeft),
		    (SHORT)(rclCWM.yTop - rclCWM.yBottom),
		    SWP_MOVE | SWP_SIZE);

   /*
    * The position of the top-left corner of the window rectangle is
    * recorded and selected as the current position before the image is
    * drawn.
    */

    WinQueryWindowRect(vhwndClient, &rcl);
    vptlSave.x = rcl.xLeft;
    vptlSave.y = rcl.yTop;
    GpiSetCurrentPosition(vhps, &vptlSave);

   /*
    * set the scroll-bar range and slider position and size
    */
    ScrollBars((USHORT)(rcl.xRight - rcl.xLeft),
	       (USHORT)(rcl.yTop - rcl.yBottom));

}   /* End of SizeMainWindow */

/**************************************************************************
 *
 *  Name       : Scroll()
 *
 *  Description: Scrolls the window contents horizontally or
 *		 vertically.
 *
 *  Concepts   : Routine is called from SizeVScroll() and
 *		 SizeHScroll()
 *		 - reposition slider
 *		 - scroll the window contents in the required
 *		   direction by the required amount.
 *
 *  API's      :  WinSendMsg
 *		  WinWindowFromID
 *		  WinScrollWindow
 *
 *  Parameters :  lThmbPos =  new thumb position
 *		  lDeltaSc =  scrolled amount
 *		  sScrollType =	 horizontal/vertical scroll ?
 *		  prclInvalid) = invalidated area
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID Scroll(
	    LONG   lThmbPos,	    /* new thumb position */
	    LONG   lDeltaSc,	    /* scrolled amount */
	    SHORT  sScrollType,	    /* horizontal/vertical scroll ? */
	    PRECTL prclInvalid)	    /* invalidated area */
{
   unsigned Fid;

   /* determine type of scroll operation */
   Fid = sScrollType == VERTSCROLL ? FID_VERTSCROLL : FID_HORZSCROLL;

  /*
   * reposition the slider
   */
   WinSendMsg(WinWindowFromID(vhwndFrame, Fid),
	      SBM_SETPOS,
	      MPFROMLONG(lThmbPos),
	      (MPARAM)NULL);

  /*
   * scroll the window contents
   */

   if (sScrollType == VERTSCROLL)

       /* vertical scroll */
       WinScrollWindow(vhwndClient,
		       0,
		       (SHORT)lDeltaSc,
		       (PRECTL)NULL,
		       (PRECTL)NULL,
		       (HRGN)NULL,
		       (PRECTL)prclInvalid,
		       0);
   else

       /* horizontal scroll */
       WinScrollWindow(vhwndClient,
		       (SHORT)lDeltaSc,
		       0,
		       (PRECTL)NULL,
		       (PRECTL)NULL,
		       (HRGN)NULL,
		       (PRECTL)prclInvalid,
		       0);

}   /* End of Scroll */


/**************************************************************************
 *
 *  Name       : ScrollBars()
 *
 *  Description: Prepares the main window for scrolling (i.e.
 *		 set up the scrollbars appropriately)
 *
 *  Concepts   : Routine is called from WndSize() and SizeMain()
 *		 - set scrollbar ranges
 *		 - set slider size relative to the current window
 *		   size
 *
 *  API's      :  WinSendMsg
 *		  GpiQueryCurrentPosition
 *
 *  Parameters :  usWidth  =  width
 *		  usHeight =  height
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID ScrollBars(USHORT usWidth, USHORT usHeight)
{
   POINTL ptlCur;

  /*
   * calculate the full scrolling range
   */
   vulScrollXMax = vsizlImg.cx - usWidth;
   vulScrollYMax = vsizlImg.cy - usHeight;

  /*
   * The page-scrolling action scrolls the image by half of the window
   * extent in both axes.
   */
   ulScrollXPage = usWidth  / 2;
   ulScrollYPage = usHeight / 2;

  /*
   * get current position, which is at the top-left of the image
   */
   GpiQueryCurrentPosition(vhps, &ptlCur);

  /*
   * The scroll-bar slider is positioned according to the position
   * of the image in the newly-sized window.
   */
   WinSendMsg(vhwndHScroll,
	      SBM_SETSCROLLBAR,
	      MPFROMLONG(-ptlCur.x),		      /* slider position */
	      MPFROM2SHORT(0, (SHORT)vulScrollXMax));	/* range	 */

   WinSendMsg(vhwndVScroll,
	      SBM_SETSCROLLBAR,
	      MPFROMLONG(ptlCur.y - usHeight),	      /* slider position */
	      MPFROM2SHORT(0, (SHORT)vulScrollYMax));	/* range	 */

   WinSendMsg(vhwndHScroll,
	      SBM_SETTHUMBSIZE,
	      MPFROM2SHORT(usWidth, (SHORT)(vsizlImg.cx)),
	      (MPARAM)0L);

   WinSendMsg(vhwndVScroll,
	      SBM_SETTHUMBSIZE,
	      MPFROM2SHORT(usHeight, (SHORT)(vsizlImg.cy)),
	      (MPARAM)0L);

}  /* End of ScrollBars */

/**************************************************************************
 *
 *  Name       : SizeCalculateMaxWindow()
 *
 *  Description: Calculates the maximized window size, which
 *		 must not exceed the size of the loaded image.
 *
 *  Concepts   : Routine is called from SizeMain(), LoadImage(),
 *		 MainWndProc() and FrameWndProc()
 *
 *		 max_window_size = min(screen_size, image_size)
 *
 *  API's      :  [none]
 *
 *  Parameters :  prclBound = points to the bounding rectangle
 *
 *  Return     :   TRUE	 - if image loaded and in 'Detail' mode
 *		   FALSE - if either the image isn't loaded or
 *			 the application is not in 'Detail' mode
 *
 *************************************************************************/
BOOL SizeCalculateMaxWindow(prclBound)
PRECTL prclBound;
{
  /*
   * Calculate the maximized window size. If an image has been loaded
   * in 'Detail' mode, the maximized window is the smaller of the
   * screen and the image.
   */

   if (vfImgLoaded && vfDetail)
   {
       if (vsizlImg.cx > (vlYScreen - vlcxVScroll))
       {
	   prclBound->xLeft  = -vlcxBorder;
	   prclBound->xRight = prclBound->xLeft + vlYScreen +
			       (2*vlcxBorder);
       }
       else
       {
	   prclBound->xLeft  = 0;
	   prclBound->xRight = prclBound->xLeft +
			       vsizlImg.cx + vlcxVScroll +
			       (2*vlcxBorder);
       }

       if (vsizlImg.cy >
	   (vlYScreen - vlcyHScroll - vlcyMenu - vlcyTitle))
       {
	   prclBound->yBottom = -vlcyBorder;
	   prclBound->yTop = prclBound->yBottom + vlYScreen +
			     (2*vlcyBorder);
       }
       else
       {
	   prclBound->yTop = vlYScreen;
	   prclBound->yBottom = prclBound->yTop -
				(vsizlImg.cy + vlcyTitle + vlcyMenu +
				 vlcyHScroll + (2*vlcyBorder));
       }
       return  TRUE;
   }
   else
       /* error if not in 'Detail' mode */
       return FALSE;
}   /* End of SizeCalculateMaxWindow */

/**************************************************************************
 *
 *  Name       : SizeVScroll(mp2, rcl, ptl)
 *
 *  Description: Implements vertical scrolling in 'Detail' mode
 *
 *  Concepts   : Routine is called MainWndProc() and it invokes
 *		 Scroll().
 *
 *		 -adjust current position
 *		 -redraw image at new position
 *
 *  API's      : GpiSetCurrentPosition
 *		 WinInvalidateRect
 *
 *  Parameters :  mp2 = second message parameter
 *		  rcl = rectangle
 *		  ptl = new position
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID SizeVScroll(MPARAM mp2, RECTL rcl, POINTL ptl)
{
   LONG	  lDeltaScr;

   /* act on the type of vertical scroll message */
   switch (SHORT2FROMMP(mp2))
   {
       case SB_LINEDOWN:

	  /*
	   * line-down processing
	   */
	   if ((ULONG)(ptl.y - rcl.yTop) < vulScrollYMax)
	   {
	       lDeltaScr = ptl.y;
	       ptl.y +=
		   ((ULONG)(ptl.y - rcl.yTop) + ulScrollYLine < vulScrollYMax) ?
		   ulScrollYLine : vulScrollYMax - (ptl.y - rcl.yTop);
	       lDeltaScr = ptl.y - lDeltaScr;
	       GpiSetCurrentPosition(vhps, &ptl);
	       Scroll((ptl.y-rcl.yTop), lDeltaScr, VERTSCROLL, &rcl);
	       WinInvalidateRect(vhwndClient, &rcl, FALSE);
	   }
	   break;

       case SB_LINEUP:

	  /*
	   * line-up processing
	   */
	   if (ptl.y > rcl.yTop)
	   {
	       lDeltaScr = ptl.y;
	       ptl.y -= (ptl.y > rcl.yTop + ulScrollYLine) ?
			 ulScrollYLine : ptl.y - rcl.yTop;
	       lDeltaScr = ptl.y - lDeltaScr;
	       GpiSetCurrentPosition(vhps, &ptl);
	       Scroll((ptl.y-rcl.yTop), lDeltaScr, VERTSCROLL, &rcl);
	       WinInvalidateRect(vhwndClient, &rcl, FALSE);
	   }
	   break;

       case SB_PAGEDOWN:

	  /*
	   * page-down processing
	   */
	   if ((ULONG)(ptl.y - rcl.yTop) < vulScrollYMax)
	   {
	       lDeltaScr =
		   ((ULONG)(ptl.y - rcl.yTop) + ulScrollYPage < vulScrollYMax) ?
		    ulScrollYPage : vulScrollYMax -
		    (SHORT)(ptl.y - rcl.yTop);
	       ptl.y += lDeltaScr;
	       GpiSetCurrentPosition(vhps, &ptl);
	       Scroll((ptl.y-rcl.yTop), lDeltaScr, VERTSCROLL, &rcl);
	       WinInvalidateRect(vhwndClient, &rcl, FALSE);
	   }
	   break;

       case SB_PAGEUP:

	  /*
	   * page-up processing
	   */
	   if (ptl.y > rcl.yTop)
	   {
	       lDeltaScr = (ptl.y > rcl.yTop + ulScrollYPage) ?
			    ulScrollYPage : (SHORT)(ptl.y - rcl.yTop);
	       ptl.y -= lDeltaScr;
	       GpiSetCurrentPosition(vhps, &ptl);
	       Scroll((ptl.y-rcl.yTop), -lDeltaScr, VERTSCROLL, &rcl);
	       WinInvalidateRect(vhwndClient, &rcl, FALSE);
	   }
	   break;

       case SB_SLIDERPOSITION:

	  /*
	   * adjust the slider position
	   */
	   lDeltaScr = ptl.y;
	   ptl.y = rcl.yTop + SHORT1FROMMP(mp2);
	   lDeltaScr = ptl.y - lDeltaScr;
	   GpiSetCurrentPosition(vhps, &ptl);
	   Scroll((LONG)(SHORT1FROMMP(mp2)), lDeltaScr, VERTSCROLL, &rcl);
	   WinInvalidateRect(vhwndClient, &rcl, FALSE);
	   break;

   }
}   /* End of SizeVScroll() */

/**************************************************************************
 *
 *  Name       : SizeHScroll(mp2, rcl, ptl)
 *
 *  Description: Implements horizontal scrolling in 'Detail' mode
 *
 *  Concepts   : Routine is called MainWndProc() and it invokes
 *		 Scroll().
 *
 *		 -adjust current position
 *		 -redraw image at new position
 *
 *  API's      : GpiSetCurrentPosition
 *		 WinInvalidateRect
 *
 *  Parameters :  mp2 = second message parameter
 *		  rcl = rectangle
 *		  ptl = new position
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID SizeHScroll(MPARAM mp2, RECTL rcl, POINTL ptl)
{
   LONG	  lDeltaScr;

   /* act on the type of horizontal scroll message */
   switch(SHORT2FROMMP(mp2))
   {
       case SB_LINERIGHT:

	  /*
	   * line-right processing
	   */
	   if ((vsizlImg.cx + ptl.x) > rcl.xRight)
	   {
	       lDeltaScr = ptl.x;
	       ptl.x -=
		   ((vsizlImg.cx + ptl.x) > rcl.xRight+ulScrollXLine) ?
		   ulScrollXLine : ptl.x + vsizlImg.cx - rcl.xRight;
	       lDeltaScr = ptl.x - lDeltaScr;
	       GpiSetCurrentPosition(vhps, &ptl);
	       Scroll(-ptl.x, lDeltaScr, HORZSCROLL, &rcl);
	       WinInvalidateRect(vhwndClient, &rcl, FALSE);
	   }
	   break;

       case SB_LINELEFT:

	  /*
	   * line-left processing
	   */
	   if (ptl.x < rcl.xLeft)
	   {
	       lDeltaScr = ptl.x;
	       ptl.x += ((ULONG)(rcl.xLeft - ptl.x) > ulScrollXLine) ?
			 ulScrollXLine : rcl.xLeft - ptl.x;
	       lDeltaScr = ptl.x - lDeltaScr;
	       GpiSetCurrentPosition(vhps, &ptl);
	       Scroll(-ptl.x, lDeltaScr, HORZSCROLL, &rcl);
	       WinInvalidateRect(vhwndClient, &rcl, FALSE);
	   }
	   break;

       case SB_PAGERIGHT:

	  /*
	   * page-right processing
	   */
	   if ((vsizlImg.cx + ptl.x) > rcl.xRight)
	   {
	       lDeltaScr =
		  ((vsizlImg.cx+(LONG)ptl.x) > rcl.xRight+ulScrollXPage) ?
		  ulScrollXPage : (vsizlImg.cx + ptl.x - rcl.xRight);
	       ptl.x -= (LONG)lDeltaScr;
	       GpiSetCurrentPosition(vhps, &ptl);
	       Scroll(-ptl.x, -lDeltaScr, HORZSCROLL, &rcl);
	       WinInvalidateRect(vhwndClient, &rcl, FALSE);
	   }
	   break;

       case SB_PAGELEFT:

	  /*
	   * page-left processing
	   */
	   if (ptl.x < rcl.xLeft)
	   {
	       lDeltaScr = ((ULONG)(rcl.xLeft - ptl.x) > ulScrollXPage) ?
			    ulScrollXPage : (SHORT)(rcl.xLeft - ptl.x);
	       ptl.x += lDeltaScr;
	       GpiSetCurrentPosition(vhps, &ptl);
	       Scroll(-ptl.x, lDeltaScr, HORZSCROLL, &rcl);
	       WinInvalidateRect(vhwndClient, &rcl, FALSE);
	   }
	   break;

       case SB_SLIDERPOSITION:

	  /*
	   * adjust the slider position
	   */
	   lDeltaScr = ptl.x;
	   ptl.x = (LONG)rcl.xLeft - (LONG)SHORT1FROMMP(mp2);
	   lDeltaScr = ptl.x - lDeltaScr;
	   GpiSetCurrentPosition(vhps, &ptl);
	   Scroll((LONG)(SHORT1FROMMP(mp2)), lDeltaScr, HORZSCROLL, &rcl);
	   WinInvalidateRect(vhwndClient, &rcl, FALSE);
	   break;

       default:
	   break;
   }
}   /* End of SizeHScroll */

/**************************************************************************
 *
 *  Name       : SizePositionImage(mp2)
 *
 *  Description: Positions the image correctly within a sized window.

 *  Concepts   : Routine is called MainWndProc() and it invokes
 *		 ScrollBars().
 *
 *		 - adjust current position of image
 *		 - adjust range & position of scrollbars
 *
 *  API's      : GpiSetCurrentPosition
 *		 WinQueryWindowRect
 *		 GpiQueryCurrentPosition
 *
 *  Parameters :  mp2 = second message parameter
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID SizePositionImage(MPARAM mp2)
{
   RECTL  rcl;		  /* new window rectangle	       */
   POINTL ptl;		  /* new current position	       */

   WinQueryWindowRect(vhwndClient, &rcl);
   GpiQueryCurrentPosition(vhps, &ptl);

  /*
   * The WM_QUERYTRACKINFO processing ensures that window size never
   * exceeds image size. Here, however, image position in relation to
   * window limits is checked.
   *
   * Set current position such that the image top and right edges are
   * at least at the window limits.
   */

   ptl.y = (ptl.y < rcl.yTop) ? rcl.yTop : ptl.y;
   ptl.x = ((ptl.x + vsizlImg.cx) < rcl.xRight) ?
	    (rcl.xRight - rcl.xLeft) - vsizlImg.cx : ptl.x;
   GpiSetCurrentPosition(vhps, &ptl);

  /*
   * adjust scroll-bar positioning and range to new window size
   */
   ScrollBars(SHORT1FROMMP(mp2), SHORT2FROMMP(mp2));
}  /* End of SizePositionImage() */
/***************************  End of img_size.c	 *************************/
/**************************************************************************
 *  File name  :  img_util.c
 *
 *  Description:  This module contains the code for allocating/freeing
 *		  memory for the image data, and for image file-related
 *		  options.  It contains these functions:
 *
 *		  UtilMemoryAllocate(usBufSiz, ppByte)
 *		  UtilMemoryFree(pByte)
 *		  UtilFindFileSize(pszFilename)
 *		  UtilGetFileHandle(pszFilename, phfile)
 *		  UtilUpdateTitleText(hab, hwnd, pszFullFile)
 *
 *  Concepts   :  32-bit memory allocation
 *
 *  API's      :  DosAllocSeg  [in 16 bit]  or DosAllocMem  [in 32 bit]
 *		  DosFreeSeg   [in 16 bit]  or DosFreeMem   [in 32 bit]
 *		  DosFindFirst
 *		  DosOpen
 *		  WinLoadString
 *		  WinSetWindowText
 *		  WinWindowFromID
 *
 *  Required
 *    Files    :  OS2.H, STRING.H, IMG_MAIN.H, IMG_XTRN.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/

/*
 *  Include files, macros, defined constants, and externs
 */

#define INCL_DOSERRORS
#define INCL_WINFRAMEMGR
#define INCL_WINSWITCHLIST
#define INCL_WINSTDFILE
#include <os2.h>
#include <string.h>

#include "img_main.h"
#include "img_xtrn.h"

#ifdef PORT_S116
LONG FAR pascal UtilFindFileSize(PSZ pszFilename);
BOOL FAR pascal UtilMemoryAllocate(USHORT cbSize, PBYTE FAR *ppByte);
BOOL FAR pascal UtilGetFileHandle(PSZ pszFilename, PHFILE phfile);
VOID FAR pascal UtilUpdateTitleText(HAB hab, HWND hwnd, PSZ pszFullFile);
VOID FAR pascal UtilMemoryFree(SEL sel);
#endif
/**************************************************************************
 *
 *  Name       : UtilMemoryAllocate(usBufSiz, ppByte)
 *
 *  Description: Allocates memory for the image
 *
 *  Concepts   : Routine is called whenever memory needs to be
 *		 allocated to store a new image.
 *
 *  API's      :  DosAllocSeg  [in 16 bit]  or DosAllocMem  [in 32 bit]
 *
 *  Parameters : usBufSiz = how many bytes to allocate
 *		 ppByte	  = pointer to the first byte of the memory block
 *
 *  Return     : TRUE  - if memory successfully allocated
 *		 FALSE - if it failed to allocate memory
 *
 *************************************************************************/
#if (defined(PORT_16) || defined(PORT_32))
BOOL UtilMemoryAllocate(USHORT usBufSiz, PBYTE FAR *ppByte)
#else
BOOL FAR pascal UtilMemoryAllocate(USHORT usBufSiz, PBYTE FAR *ppByte)
#endif
{
#if (defined(PORT_16) || defined(PORT_S116))
    SEL sel;

    if (DosAllocSeg(usBufSiz, &sel, SEG_NONSHARED) == NO_ERROR)
    {
	*ppByte = (BYTE *)MAKEP(sel, 0);
	return TRUE;
    }
    else
	return FALSE;
#else

    return (BOOL)(!DosAllocMem((PPVOID)ppByte,
		    (ULONG)usBufSiz, PAG_READ | PAG_WRITE | PAG_COMMIT));
#endif

}  /* End of UtilMemoryAllocate	 */

/**************************************************************************
 *
 *  Name       : UtilMemoryFree(pByte)
 *
 *  Description: Frees memory of the image
 *
 *  Concepts   : Routine is called at cleanup time during the processing
 *		 of a WM_DESTROY message, and before loading a new image
 *
 *  API's      :  DosFreeSeg  [in 16 bit]  or DosFreeMem  [in 32 bit]
 *
 *  Parameters : pByte	 = pointer to the first byte of the memory block
 *
 *  Return     : [none]
 *
 *************************************************************************/
#ifdef PORT_32
VOID UtilMemoryFree(pByte)
PBYTE pByte;
{
   DosFreeMem(pByte);
}   /* End of UtilMemoryFree */
#else
#ifdef PORT_16
VOID UtilMemoryFree(SEL sel)
#else
VOID FAR pascal UtilMemoryFree(SEL sel)
#endif
{
   DosFreeSeg(sel);
}   /* End of UtilMemoryFree */
#endif

/**************************************************************************
 *
 *  Name       : UtilFindFileSize(pszFilename)
 *
 *  Description: Finds the size of a loaded image
 *
 *  Concepts   : Called to determine the size of the image in order
 *		 to allocate sufficient storage for it
 *
 *  API's      : DosFindFirst
 *
 *  Parameters : pszFilename = a pointer to a string, the file name
 *
 *  Return     : filesize = max(0xFFFF, filesize)
 *
 *************************************************************************/
#if (defined(PORT_16) || defined(PORT_32))
LONG UtilFindFileSize(pszFilename)
#else
LONG FAR pascal UtilFindFileSize(pszFilename)
#endif
PSZ pszFilename;
{
    FILEFINDBUF ffb;	   /* DOS file-search results buffer	*/
    HDIR hdir = 0xffff;	   /* allocate a handle to caller	*/
#if (defined(PORT_16) || defined(PORT_S116))
    USHORT usAttrib  = 0;
    USHORT cSearch   = 1;
    if (DosFindFirst(pszFilename,  /* filename from Open Dialog */
		     &hdir,
		     usAttrib,
		     &ffb,
		     (USHORT)(sizeof(ffb) * cSearch),
		     &cSearch,
		     0L) == NO_ERROR)  /* reserved must be NULL */
#else
    ULONG ulAttrib  = 0;
    ULONG cSearch   = 1;
    if (DosFindFirst(pszFilename,  /* filename from Open Dialog */
		     &hdir,
		     ulAttrib,
		     &ffb,
		     sizeof(ffb) * cSearch,
		     &cSearch,
		     1L) == NO_ERROR)  /* number of files to locate */
#endif
       /*
	* Obtain the size of the image. The amount of storage
	* required depends on the size of the image, which is
	* recorded in the image-file header.
	* If the image is greater than 64KB, then only the first 64KB of
	* image data is loaded.
	*/
	return (ffb.cbFileAlloc > 0xFFFFL) ? 0xFFFFL : ffb.cbFileAlloc;
    else
	return 0L;

}   /* End of UtilFindFileSize */

/**************************************************************************
 *
 *  Name       : UtilGetFileHandle(pszFilename, phfile)
 *
 *  Description: Opens the file passed in and returns its file handle
 *
 *  Concepts   : Called in order the read in the image data from a file
 *		 so that it can be displayed
 *
 *  API's      : DosOpen
 *
 *  Parameters : pszFilename = a pointer to a string, the file name
 *		 phfile	     = a pointer to the file handle
 *
 *  Return     : the value of the DosOpen return
 *
 *************************************************************************/
#if (defined(PORT_16) || defined(PORT_32))
BOOL UtilGetFileHandle(pszFilename, phfile)
#else
BOOL FAR pascal UtilGetFileHandle(pszFilename, phfile)
#endif
PSZ pszFilename;
PHFILE phfile;
{
#if (defined(PORT_16) || defined(PORT_S116))
    USHORT usAction;

    return DosOpen(pszFilename,		  /* filename from open dialog */
		   phfile,		       /* file handle returned */
		   (PUSHORT)&usAction,
		   0L,
		   FILE_NORMAL,
		   FILE_OPEN,
		   OPEN_ACCESS_READONLY | OPEN_SHARE_DENYNONE,
		   0L) == NO_ERROR;		       /* must be zero */
#else
    ULONG ulAction;

    return (BOOL)(!DosOpen(pszFilename,	      /* filename from open dialog */
		   phfile,		      /* file handle returned */
		   &ulAction,
		   0L,
		   FILE_NORMAL,
		   FILE_OPEN,
		   OPEN_ACCESS_READONLY | OPEN_SHARE_DENYNONE,
		   (PEAOP2)NULL)) ;		       /* must be zero */
#endif

}   /* End of UtilGetFileHandle	 */

/**************************************************************************
 *
 *  Name       : UtilUpdateTitleText(hab, hwnd, pszFullFile)
 *
 *  Description: Updates the text in the main window's title bar to
 *		 display the app name, followed by the separator,
 *		 followed by the file name
 *
 *  Concepts   : Called at init time and when the text file is changed
 *
 *  API's      : WinLoadString
 *		 WinSetWindowText
 *		 WinWindowFromID
 *
 *  Parameters : hab	     = anchor block handle
 *		 hwnd	     = window handle
 *		 pszFullFile = a string:  the path and filename
 *
 *  Return     : [none]
 *
 *************************************************************************/
#if (defined(PORT_16) || defined(PORT_32))
VOID UtilUpdateTitleText(hab, hwnd, pszFullFile)
#else
VOID FAR pascal UtilUpdateTitleText(hab, hwnd, pszFullFile)
#endif
HAB  hab;
HWND hwnd;
PSZ  pszFullFile;
{
    CHAR szBuf[MAXNAMEL];
    CHAR szSeparator[TITLESEPARATORLEN+1];
    CHAR szUntitled[MESSAGELEN];
    PSZ pszFileName;
#ifdef PORT_S116
    PCHAR pch;
    USHORT cch;
#endif

    WinLoadString(hab, (HMODULE)NULL, IDS_APPNAME, MAXNAMEL, szBuf);
    WinLoadString(hab, (HMODULE)NULL, IDS_TITLEBARSEPARATOR,
		  TITLESEPARATORLEN, szSeparator);

    strcat(szBuf, szSeparator);

#if (defined(PORT_16) || defined(PORT_32))
   /*
    * if filename is valid it will be F.Q so search for
    * final backslash, otherwise use the Untitled string.
    */
    if (NULL != (pszFileName = strrchr(pszFullFile, (int)'\\')))
	pszFileName++;
#else
    /* set pointer to end of string and count characters in string */
    pch = pszFullFile;
    cch = 0;
    while (*pch++)
	cch++;

    /* must cater to the null string in this test */
    if (cch > 0)
	pch--;

    /* search for final backslash in F.Q name if it exists */
    while (*--pch && *pch != '\\' && cch-- >= 0)  ;

   /*
    * if filename is valid (ie '\' is found in F.Q name,
    * then use filename, otherwise use the Untitled string.
    */
    if (*pch == '\\')
	pszFileName = ++pch;
#endif
    else
    {
	/* load "untitled" string */
	WinLoadString(hab, 0, IDS_UNTITLED, MESSAGELEN, szUntitled);
	pszFileName = (PSZ)szUntitled;
    }
    strcat(szBuf, pszFileName);	 /* szBuf = Image Sample Program - IMAGE.IMG */
    WinSetWindowText(WinWindowFromID(hwnd, FID_TITLEBAR), szBuf);
}   /* End of UtilUpdateTitleText  */
/***************************  End of img_util.c	 *************************/
/**************************************************************************
 *  File name  :  img_view.c
 *
 *  Description:  This module contains the code for handling the functions
 *		  offered on the View submenu. These functions are called
 *		  from the MainCommand() routine:
 *
 *		  ViewSwitchMode()
 *		  ViewChangeColor()
 *		  ViewSavePosition()
 *		  ViewRestorePosition()
 *
 *  Concepts   :  display modes, image processing
 *
 *  API's      :  WinSetParent
 *		  WinSendMsg
 *		  WinInvalidateRect
 *		  GpiSetBackCol
 *		  GpiSetColor
 *		  GpiSetBackMix
 *		  WinQueryWindowRect
 *		  GpiSetCurrentPosition
 *
 *  Required
 *    Files    :  OS2.H, STDLIB.H, IMG_MAIN.H, IMG_XTRN.H, IMG_DLG.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *  Include files, macros, defined constants, and externs
 */
#define INCL_WINSCROLLBARS
#define INCL_WINFRAMEMGR
#define INCL_WINSTDFILE
#define INCL_GPIPRIMITIVES

/*
 *  Include files, macros, defined constants, and externs
 */
#include <os2.h>
#include <stdlib.h>

#include "img_main.h"
#include "img_xtrn.h"
#include "img_dlg.h"

/*
 *  Static variables
 */
/* foreground/background color choices */
LONG  lColorArray[COLOR_COUNT] = {CLR_BLACK,
				  CLR_WHITE,
				  CLR_BLUE,
				  CLR_GREEN,
				  CLR_YELLOW,
				  CLR_RED};

/**************************************************************************
 *
 *  Name       : ViewSwitchMode()
 *
 *  Description: Toggles the mode of the application from Non-Detail
 *		 to Detail mode and visa versa
 *
 *  Concepts   : Routine is called whenever a WM_COMMAND message
 *		 is posted to the main window in response to
 *		 the user (de)selecting the Detail item
 *		 from the View submenu.
 *
 *		 Since Non-Detail mode is the opposite to Detail mode,
 *		 toggle the menu settings, and ownership of the
 *		 scrollbars, and redraw. If entering Detail mode
 *		 it is necessary to size the main window as well.
 *
 *  API's      :  WinSetParent
 *		  WinSendMsg
 *		  WinInvalidateRect
 *
 *  Parameters :  [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID ViewSwitchMode()
{
   vfDetail = (BOOL)(!vfDetail);

   /*
    * detach/attach scrollbars to main window accordingly
    */
   WinSetParent(vhwndVScroll,
		 vfDetail ? vhwndFrame : HWND_OBJECT,
		 FALSE);
   WinSetParent(vhwndHScroll,
		 vfDetail ? vhwndFrame : HWND_OBJECT,
		 FALSE);

   WinSendMsg(vhwndFrame,
	       WM_UPDATEFRAME,
	       MPFROMLONG(FCF_VERTSCROLL | FCF_HORZSCROLL),
	       (MPARAM)NULL);

    /* resize main window if in 'Detail' mode */
   if (vfDetail)
	SizeMainWindow();

   WinInvalidateRect(vhwndClient, (PRECTL)NULL, FALSE);

}   /* End of ViewSwitchMode  */

/**************************************************************************
 *
 *  Name       : ViewChangeColor(idColor)
 *
 *  Description: Changes the foreground/background colors of the
 *		 selected image.
 *
 *  Concepts   : Routine is called whenever a WM_COMMAND message
 *		 is posted to the main window in response to
 *		 the user selecting a Color item from either the
 *		 'Foreground'/'Background' Color items on the View submenu
 *
 *  API's      :  GpiSetBackColor
 *		  GpiSetColor
 *		  GpiSetBackMix
 *		  WinInvalidateRect
 *
 *  Parameters :  idColor = identifier of the selected color
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID ViewChangeColor(USHORT idColor)
{
   LONG lForeClr, lBackClr;
   BOOL fSameClr;
   USHORT idItem;

   /*
    * change either the foreground/background color and save
    * previous settings so that the appropriate menuitem can
    * be reset
    */
   if (idColor < IDM_VIEWBACKCOLORBLACK)
   {
       lForeClr = lColorArray[idColor - COLOR_BASE];
       fSameClr = (BOOL)(lForeClr == vlBackClr);
       idItem = MenuGetColorItemId(IDM_VIEWFORECOLORBLACK);
   }
   else
   {
       lBackClr = lColorArray[idColor - COLOR_BASE - COLOR_COUNT];
       fSameClr = (BOOL)(lBackClr == vlForeClr);
       idItem = MenuGetColorItemId(IDM_VIEWBACKCOLORBLACK);
   }
   /*
    * if background color is the same as the foreground color
    * - ensure this is correct and get out if not
    */
   if (fSameClr)
   {
       if (MessageBox(vhwndFrame,
		      IDMSG_BACKEQFORE, IDMSG_WARNING,
		      MB_APPLMODAL | MB_YESNO | MB_CUAWARNING,
		      TRUE) == MBID_NO)
	   return;
   }

    /* cancel previously checked item  & save new values */
   if (idColor < IDM_VIEWBACKCOLORBLACK)
   {
       MenuEnableItem(vhwndViewForeClr, idItem, TRUE);
       vlForeClr = lForeClr;
   }
   else
   {
       MenuEnableItem(vhwndViewBackClr, idItem, TRUE);
       vlBackClr = lBackClr;
   }

   /*
    * set colors appropriately and force redraw
    */
   GpiSetBackColor(vhps, vlBackClr);
   GpiSetColor(vhps, vlForeClr);
   GpiSetBackMix(vhps, BM_OVERPAINT);
   WinInvalidateRect(vhwndClient, (PRECTL)NULL, FALSE);

}   /* End of ViewChangeColor() */

/**************************************************************************
 *
 *  Name       : ViewRestorePosition()
 *
 *  Description: Restores the saved position of the image
 *
 *  Concepts   : Routine is called whenever a WM_COMMAND message
 *		 is posted to the main window in response to
 *		 the user selecting the Restore Position item
 *
 *  API's      : WinQueryWindowRect
 *		 GpiSetCurrentPosition
 *		 WinSendMsg
 *		 WinInvalidateRect
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID ViewRestorePosition(void)
{
   RECTL rcl;

    /* only valid if image is loaded & in Detail mode */
   if (vfImgLoaded && vfDetail)
   {
       WinQueryWindowRect(vhwndClient, &rcl);
       GpiSetCurrentPosition(vhps, &vptlSave);
       WinSendMsg(vhwndVScroll,
		  SBM_SETPOS,
		  MPFROMLONG(vptlSave.y - rcl.yTop),
		  (MPARAM)NULL);
       WinSendMsg(vhwndHScroll,
		  SBM_SETPOS,
		  MPFROMLONG(labs(vptlSave.x)),
		  (MPARAM)NULL);
       WinInvalidateRect(vhwndClient, (PRECTL)NULL, FALSE);
   }
}   /* End of ViewRestorePosition */

/**************************************************************************
 *
 *  Name       : ViewSavePosition()
 *
 *  Description: Saves the saved position of the image
 *
 *  Concepts   : Routine is called whenever a WM_COMMAND message
 *		 is posted to the main window in response to
 *		 the user selecting the Save Position item
 *
 *  API's      : GpiQueryCurrentPosition
 *
 *  Parameters : [none]
 *
 *  Return     : [none]
 *
 *************************************************************************/
VOID ViewSavePosition(void)
{
   if (vfImgLoaded && vfDetail)
       GpiQueryCurrentPosition(vhps, &vptlSave);
}   /* ViewSavePosition() */
/***************************  End of img_view.c	 *************************/
/*=========================================================================\
 *									   *
 *	 FILE:init.c							   *
 *									   *
 *	 DESCRIPTION: This file handles all initialization necessary	   *
 *		      for the worms program				   *
 *									   *
 *	Copyright 1992 IBM Corp.					   *
 *									   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *	*
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have been *
 *	advised of the possibility of	such damages.			   *				   *
 *-------------------------------------------------------------------------*
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *--------------------------------------------------------------
 *
 *  This source file contains the following functions:
 *
 *
 *  Init()
 *
 *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/
#define	 INCL_VIO
#define	 INCL_DOSPROCESS
#define	 INCL_MOU
#define	 INCL_DOSSEMAPHORES

#include <os2.h>
#include <stdlib.h>
#include "worms.h"
#include "disp.h"
#include "init.h"
#include "wmouse.h"




/*--------------------------------------------------------------*\
 *  Global variables  and definitions for this file
\*--------------------------------------------------------------*/

#define CREATE_MOUSE  1
#define STACK_SIZE_MOUTHRD  32768
#define WORM_SEM_NAME  NULL
#define WORM_DRAW_NAME NULL
HEV   hevWormSem;
HEV   hevDrawSem;
HEV   hevDrawOk;





/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/

BOOL
create_wmThread(VOID );

BOOL bStartWorms(VOID );
/****************************************************************\
 *  Routine Name:Init()
 *--------------------------------------------------------------
 *
 *  Name:
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	 TRUE  - Error Occurred
 *	 FALSE - No error occurred
\****************************************************************/
BOOL
Init(PSHORT psErrorMessage)
{
     BOOL fError = FALSE;
     VIOCURSORINFO viociTemp;

     /*
      *get the current configuration
      */
     VioModeInfo.cb = sizeof(VioModeInfo);
     VioGetMode(&VioModeInfo,hvio );

     /*
      *save the cursor type
      */
     VioGetCurType(&viociCursor,hvio);
     VioGetCurType(&viociTemp,hvio);

     /*
      *turn off the cursor
      */
      viociTemp.attr = 0xFFFF;
      VioSetCurType(&viociTemp,hvio);



     /*
      *display the main default window
      */
     WindMainDisp();

     if(create_wmThread() )
     {
	  ErrorMessage(ERROR_CREATING_WREADTHRD,TRUE);
     }

     /*
      *create a general purpose
      *semaphore
      */
     if(DosCreateEventSem(WORM_SEM_NAME,
			   &hevWormSem,
			   0,
			   FALSE ) )
     {
	  fError = TRUE;
     }
     /*
      *create a sem
      *to contro the threads that
      *draw to the screen
      */
     if(DosCreateEventSem(WORM_DRAW_NAME,
			   &hevDrawSem,
			   0,
			   TRUE) )
     {
	  fError = TRUE;
     }

     if(DosCreateEventSem(NULL,
			   &hevDrawOk,
			   DC_SEM_SHARED,
			   FALSE ) )
     {
	  fError = TRUE;
     }

     /*
      *start up
      *the number of worms
      *specified on the command
      *line
      */
     bStartWorms();

     return(fError);

}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:create_wmThread()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    FALSE - if sucessful execution completed
 *	    TRUE  - if error
\****************************************************************/
BOOL
create_wmThread(VOID )
{
    SHORT sValue;

    if( _beginthread( WReadMouse,
		      NULL,
		      STACK_SIZE_MOUTHRD,
		      &sValue) == -1 )
    {
	  return(TRUE);
    }

    return(FALSE);


}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:bStartWorms()
 *
 *  Purpose:Kick off the number off worms that was specified on the command
 *	    line
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    TRUE  - An error occurred
 *	    FALSE - No error  occurred
\****************************************************************/
BOOL bStartWorms(VOID )
{

     USHORT usWorms;


     for(usWorms = 0; usWorms < sStartWorms;usWorms ++ )
     {
	  if( WormCreate() )
	  {
	       return(TRUE);

	  }
     }
     return(FALSE);
}







/*--------------------------------------------------------------*\
 *  End of file : init.c
\*--------------------------------------------------------------*/
/*static char *SCCSID = "@(#)invstr.c   6.1 92/02/19";*/
/*************************************************************************
 * File Name	 : INVSTR.C
 *
 * Description	 : This sample program demonstrates how to use the API
 *		   NlsInverseString. This Bidirectional (Bidi) API is used
 *		   to invert a string from Right To Left, to Left To Right
 *		   and vice versa.
 *
 * Concepts	 : Inversion of strings is usually required when converting
 *		   logically ordered characters to visual ordering,
 *		   depending on the orientation of the presentation device
 *		   (screen, printer..)
 *		   Example:
 *		      static CHAR [] ={'f','i','l','e'};
 *		   This string will be in a readable format if it is
 *		   displayed on a LTR screen, however in order to display
 *		   and read it on a RTL screen we should invert it.
 *
 * API's         : NlsInverseString
 *		   VioWrtCharStr
 *		   VioScrollUp
 *		   VioWrtCellStr
 *		   VioSetCurType
 *
 * Required files: To build and run this sample code the following files
 *		   are needed:
 *		   - INVSTR.C
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 ************************************************************************/

#define INCL_BASE
#define INCL_DOSERRORS
#define INCL_BDCALLS	/* This is to include the Bidi headers */

#include <os2.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

#define HIDE -1			       /* PARAMATER TO HIDE THE SCREEN*/
#define RESTORE 0		       /* paramater to restore the screen */

VOID SetCur(INT);


char string[35] = {'S', 0x78, 't', 0x1e, 'r', 0x49, 'i' ,0x71, 'n',0x4f, 'g',
		  0x2a, ' ',0x0f, 't',0x5f, 'o',0x78, ' ', 0x0f, 'I', 0x5d, 'n',
		  0x70, 'v', 0x5e, 'e', 0x06, 'r', 0x6e, 't', 0x78, '\0'
		   };
		/* this is the string to reverse, each character is followed */
		/* by its attributes.					     */
		/* In fact this simulates the case of reversing a screen     */
		/* buffer.						     */

/*************************************************************************
 * Name		 : Main
 *
 * Description	 : This is the main part of the program, it first clear
 *		   the screen and then hide the cursor. The string to be
 *		   inverted will be displayed before and after the
 *		   NlsinvsrseString is called.
 *		   Here we will show how to use the API, and what are
 *		   the parameters needed.
 *
 * API's         : NlsInverseString
 *		   VioWrtCharStr
 *		   VioScrollUp
 *		   VioWrtCellStr
 *
 *
 * Parameters	 : This program does not take any command line parameters
 *
 * Returns	 : None
 *
 ************************************************************************/

INT main(SHORT sArgc,CHAR **ppArgv)
{
   APIRET RC;

   /* Use the VioScrollUp API to clear the screen */
   VioScrollUp(0, 0, 24, 79, -1," \x07", 0);

   /* Call the SetCur() procedure to hide the Cursor */
   SetCur(HIDE);

   RC = VioWrtCharStr("Here is the string we want to invert:",38, 4, 10, 0l);

   /* Write to the Screen the String needed to be inverted */
   RC = VioWrtCellStr(string, strlen(string),7, 10, 0);

   /* Call the NlsInverseString to invert cells of lenght 2 in the string,
    * here the source can equal to target but they should not overlap  */
   RC = NlsInverseString( string, string, strlen(string), 2);

   if (RC != 0)
   {
      printf("\nError in calling the API, RC=%ld\n",RC);
      return(1);
   }

   RC = VioWrtCharStr("Now after calling the API NlsInveseString,",
		       44, 10, 10, 0l);
   RC = VioWrtCharStr("we will get the following inverted string:",
		       43, 11, 10, 0l);

   /* Write the string after inversion on the screen */
   RC = VioWrtCellStr(string, strlen(string),14, 10, 0);

   RC=VioWrtCharStr("Note that each character is still keeping its attribute !",
		     60, 17, 10, 0l);

   RC = VioWrtCharStr("Press Enter to exit the program",32, 23, 20, 0l);

   /* Wait for the Enter Key to end the program */
   getchar();

   /* Clear the screnn */
   RC = VioScrollUp(0, 0, 24, 79, -1," \x07", 0);

   /* Restor the cursor position */
   SetCur(RESTORE);

   return(0);

} /* End of Main */

/*************************************************************************
 * Name		 : SETCUR
 *
 * Description	 : This function hides or restores the cursor position.
 *
 * API's         : VioSetCurType
 *
 * Parameters	 : (INT flag)
 *		   flag indicates whether we want ot hide or restore
 *		   the cursor.
 *
 * Returns	 : None
 *
 ************************************************************************/
VOID SetCur(INT flag)
{
   HVIO HVIOhandle = 0;
   VIOCURSORINFO cursor;

   cursor.yStart  = 3;
   cursor.cEnd	  = 5;
   cursor.cx	  = 0;
   cursor.attr	  = flag;

   VioSetCurType(&cursor, HVIOhandle);

} /* End of SetCurr */

#ifndef lint
static char *sccsid = "@(#)ipep.c 1.3 1/22/92 16:10:26 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define indentedParagraphs_Class_Source
#include "ipep.ih"

#define PARAGRAPH_INDENTATION 3
#define LINE_INDENTATION 0


/* ************************************************************ */
SOM_Scope int SOMLINK epGetParagraphIndentation(indentedParagraphs * somSelf)
{
/* indentedParagraphsData *somThis = indentedParagraphsGetData(somSelf); */
     indentedParagraphsMethodDebug("indentedParagraphs",
				    "epGetParagraphIndentation");

    somSelf;
    return PARAGRAPH_INDENTATION;

}

/* ************************************************************ */
SOM_Scope int SOMLINK epGetLineIndentation(indentedParagraphs * somSelf)
{
/* indentedParagraphsData *somThis = indentedParagraphsGetData(somSelf); */
    envProcessor *lastEnv;
    indentedParagraphsMethodDebug("indentedParagraphs",
				  "epGetLineIndentation");
    lastEnv = _epGetPreviousEnv(somSelf);
    if (lastEnv)
	return _epGetLineIndentation(lastEnv) +
	    LINE_INDENTATION;
    else
	return LINE_INDENTATION;

}
/******************************************************************************
*
*  File Name   : JIGHELP.C
*
*  Description : This module contains all the routines for interfacing with
*		 the IPF help manager.
*
*  Concepts    : Using the Information Presentation Facility for help
*
*  Entry Points:
*		 AboutBoxDlgProc()
*		 DestroyHelpInstance()
*		 DisplayHelpPanel()
*		 HelpAbout()
*		 HelpExtended()
*		 HelpHelpForHelp()
*		 HelpIndex()
*		 HelpInit()
*		 HelpTutorial()
*		 ShowDlgHelp()
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.						      *
*
******************************************************************************/

/*--------------------------------------------------------------
 *  Include files, macros, defined constants, and externs
  --------------------------------------------------------------*/

/*
 * If DEBUG is defined, then the help panels will display their
 *  id values on their title bar.  This is useful for determining
 *  which help panels are being shown for each dialog item.  When
 *  the DEBUG directive is not defined, then the panel ids are not
 *  displayed.
 */

/*
   A better method of defining this directive is in a parameter to the
   compiler (-DDEBUG).

#define	 DEBUG
*/

#include "jigsaw.h"
#include "globals.h"
#include "jighelp.h"
#include <string.h>

/*--------------------------------------------------------------*\
 *  Local Static Variables
\*--------------------------------------------------------------*/
static HWND hwndHelpInstance;
static CHAR szLibName[HELPLIBRARYNAMELEN];
static CHAR szWindowTitle[HELPLIBRARYNAMELEN];
static BOOL fHelpEnabled = FALSE;


/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/
MRESULT EXPENTRY AboutBoxDlgProc(HWND hwnd, ULONG msg,
	     MPARAM mp1, MPARAM mp2);
VOID ShowDlgHelp(HWND hwnd);


/****************************************************************\
 *  Routine for initializing the help manager
 *--------------------------------------------------------------
 *
 *  Name:   HelpInit()
 *
 *  Purpose: Initializes the IPF help facility
 *
 *  Usage:  Called once during initialization of the program
 *
 *  Method: Initializes the HELPINIT structure and creates the
 *	 help instance.	 If successful, the help instance
 *	 is associated with the main window
 *
 *  Returns:
 *
\****************************************************************/
VOID HelpInit(VOID)
{
    HELPINIT hini;

    /* if we return because of an error, Help will be disabled */
    fHelpEnabled = FALSE;

    /* inititalize help init structure */
    hini.cb = sizeof(HELPINIT);
    hini.ulReturnCode = 0L;

    hini.pszTutorialName = (PSZ)NULL;	/* if tutorial added, add name here */

    hini.phtHelpTable = (PHELPTABLE)MAKELONG(JIGSAW_HELP_TABLE, 0xFFFF);
    hini.hmodHelpTableModule = (HMODULE)0;
    hini.hmodAccelActionBarModule = (HMODULE)0;
    hini.idAccelTable = 0;
    hini.idActionBar = 0;

    if(!WinLoadString(habMain,
	    (HMODULE)0,
	    IDS_HELPWINDOWTITLE,
	    HELPLIBRARYNAMELEN,
	    (PSZ)szWindowTitle))  {

   MessageBox(hwndFrame, IDS_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
   return;
    }

    hini.pszHelpWindowTitle = (PSZ)szWindowTitle;

    /* if debugging, show panel ids, else don't */
#ifdef DEBUG
    hini.fShowPanelId = CMIC_SHOW_PANEL_ID;
#else
    hini.fShowPanelId = CMIC_HIDE_PANEL_ID;
#endif

    if(!WinLoadString(habMain,
	    (HMODULE)0,
	    IDS_HELPLIBRARYNAME,
	    HELPLIBRARYNAMELEN,
	    (PSZ)szLibName))   {

   MessageBox(hwndFrame, IDS_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
   return;
    }

    hini.pszHelpLibraryName = (PSZ)szLibName;

    /* creating help instance */
    hwndHelpInstance = WinCreateHelpInstance(habMain, &hini);

    if(!hwndHelpInstance || hini.ulReturnCode)	 {
   MessageBox(hwndFrame,
	 IDS_HELPLOADERROR,
	 MB_OK | MB_ERROR,
	 TRUE);
   return;
    }

    /* associate help instance with main frame */
    if(!WinAssociateHelpInstance(hwndHelpInstance, hwndFrame)) {
   MessageBox(hwndFrame,
	 IDS_HELPLOADERROR,
	 MB_OK | MB_ERROR,
	 TRUE);
   return;
    }

    /* help manager is successfully initialized so set flag to TRUE */
    fHelpEnabled = TRUE;

}   /* HelpInit() */


/****************************************************************\
 *  Processes the Help for Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpHelpForHelp(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	   Help for Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Help for Help
 *	 menu item is selected
 *
 *  Method: Sends an HM_DISPLAY_HELP message to the help
 *	 instance so that the default Help For Help is
 *	 displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpHelpForHelp(mp2)
MPARAM mp2;   /* second parameter of WM_COMMAND message */
{

    /* this just displays the system help for help panel */
    if(fHelpEnabled)
   if(WinSendMsg(hwndHelpInstance, HM_DISPLAY_HELP, NULL, NULL))
       MessageBox(hwndFrame,
	     IDS_HELPDISPLAYERROR,
	     MB_OK | MB_ERROR,
	     FALSE);

    /* This routine currently doesn't use the mp2 parameter but       *\
     *	it is referenced here to prevent an 'Unreferenced Parameter'
    \*	 warning at compile time.		   */
    mp2 = mp2;

}   /* HelpHelpForHelp() */


/****************************************************************\
 *  Processes the Extended Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpExtended( VOID )
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	   Extended Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Extended Help
 *	 menu item is selected
 *
 *  Method: Sends an HM_EXT_HELP message to the help
 *	 instance so that the default Extended Help is
 *	 displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpExtended( VOID )
{

    /* this just displays the system extended help panel */
    if(fHelpEnabled)

/*
    if (WinSendMsg(hwndHelpInstance,PANEL_EXTENDED_CONTENTS,
		 MPFROMSHORT(PANEL_EXTENDED_CONTENTS), NULL))
       MessageBox(hwndFrame,
	     IDS_HELPDISPLAYERROR,
	     MB_OK | MB_ERROR,
	     FALSE);
*/
    if(WinSendMsg(hwndHelpInstance, HM_EXT_HELP, NULL, NULL))
       MessageBox(hwndFrame,
	     IDS_HELPDISPLAYERROR,
	     MB_OK | MB_ERROR,
	     FALSE);
}   /* HelpExtended() */



/****************************************************************\
 *  Processes the Keys Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpKeys(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	   Keys Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Keys Help
 *	 menu item is selected
 *
 *  Method: Sends an HM_KEYS_HELP message to the help
 *	 instance so that the default Keys Help is
 *	 displayed.
 *
 *  Returns:
 *
\****************************************************************/
/*VOID	HelpKeys(mp2)
MPARAM mp2;    second parameter of WM_COMMAND message
{						       */

    /* this just displays the system keys help panel
    if(fHelpEnabled)
   if(WinSendMsg(hwndHelpInstance, PANEL_KEYS_CONTENTS, MPFROMSHORT(PANEL_KEYS_CONTENTS), NULL))
       MessageBox(hwndFrame,
	     IDS_HELPDISPLAYERROR,
	     MB_OK | MB_ERROR,
	     FALSE);
						      */

    /* This routine currently doesn't use the mp2 parameter but       *\
     *	it is referenced here to prevent an 'Unreferenced Parameter'
    \*	 warning at compile time.		   */
 /*   mp2;

}    HelpKeys() */


/****************************************************************\
 *  Processes the Index Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpIndex(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	   Index Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Index Help
 *	 menu item is selected
 *
 *  Method: Sends an HM_INDEX_HELP message to the help
 *	 instance so that the default Index Help is
 *	 displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpIndex(mp2)
MPARAM mp2;   /* second parameter of WM_COMMAND message */
{

    /* this just displays the system help index panel */
    if(fHelpEnabled)
   if(WinSendMsg(hwndHelpInstance, HM_HELP_INDEX, NULL, NULL))
       MessageBox(hwndFrame,
	     IDS_HELPDISPLAYERROR,
	     MB_OK | MB_ERROR,
	     FALSE);


    /* This routine currently doesn't use the mp2 parameter but       *\
     *	it is referenced here to prevent an 'Unreferenced Parameter'
    \*	 warning at compile time.		   */
    mp2 = mp2;

}   /* HelpIndex() */


/****************************************************************\
 *  Processes the Tutorial Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpTutorial(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	   Tutorial Help item of the Help menu.	 While the
 *	   standard template application does not include a
 *	   Tutorial menu item, you can add one if your
 *	   application has a tutorial.
 *
 *  Usage:  Called from MainCommand when the Tutorial Help
 *	 menu item is selected
 *
 *  Method:
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpTutorial(mp2)
MPARAM mp2;   /* second parameter of WM_COMMAND message */
{

   /*--------------------------------------------------------------*\
    *  Insert code for any tutorial here
   \*--------------------------------------------------------------*/


    /* This routine currently doesn't use the mp2 parameter but       *\
     *	it is referenced here to prevent an 'Unreferenced Parameter'
    \*	 warning at compile time.		   */
    mp2 = mp2;

}   /* HelpTutorial() */

/****************************************************************\
 *  Processes the About command from the Help menu
 *--------------------------------------------------------------
 *
 *  Name:   HelpAbout(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	   About item of the Help menu
 *
 *  Usage:  Called from MainCommand when the About
 *	 menu item is selected
 *
 *  Method: Calls WinDlgBox to display the about box dialog.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpAbout(mp2)
MPARAM mp2;   /* second parameter of WM_COMMAND message */
{
    /* display the AboutBox dialog */
    WinDlgBox(HWND_DESKTOP,
	 hwndFrame,
	 (PFNWP)AboutBoxDlgProc,
	 (HMODULE)0,
	 IDD_ABOUTBOX,
	 (PVOID)NULL);

    /* This routine currently doesn't use the mp2 parameter but       *\
     *	it is referenced here to prevent an 'Unreferenced Parameter'
    \*	 warning at compile time.		   */
    mp2 = mp2;

}   /* HelpAbout() */


/****************************************************************\
 *  Displays the help panel indicated
 *--------------------------------------------------------------
 *
 *  Name:   DisplayHelpPanel(idPanel)
 *
 *  Purpose: Displays the help panel whose id is given
 *
 *  Usage:  Called whenever a help panel is desired to be
 *	 displayed, usually from the WM_HELP processing
 *	 of the dialog boxes
 *
 *  Method: Sends HM_DISPLAY_HELP message to the help instance
 *
 *  Returns:
 *
\****************************************************************/
VOID DisplayHelpPanel(SHORT idPanel) /* ID of help panel to display */
{
    if (fHelpEnabled)
      if (WinSendMsg(hwndHelpInstance, HM_DISPLAY_HELP,
		     MPFROM2SHORT(idPanel, NULL), MPFROMSHORT(HM_RESOURCEID)))

	 MessageBox(hwndFrame, IDS_HELPDISPLAYERROR, MB_OK | MB_ERROR, TRUE);

}   /* DisplayHelpPanel() */



/****************************************************************\
 *  Destroys the help instance
 *--------------------------------------------------------------
 *
 *  Name:   DestroyHelpInstance(VOID)
 *
 *  Purpose: Destroys the help instance for the application
 *
 *  Usage:  Called after exit from message loop
 *
 *  Method: Calls WinDestroyHelpInstance() to destroy the
 *	 help instance
 *
 *  Returns:
 *
\****************************************************************/
VOID DestroyHelpInstance(VOID)
{
    if(hwndHelpInstance)  {
   WinDestroyHelpInstance(hwndHelpInstance);
    }

}   /* DestroyHelpInstance() */
/****************************************************************\
 *  Dialog procedure for the About dialog box
 *--------------------------------------------------------------
 *
 *  Name:   AboutBoxDlgProc(hwnd, msg, mp1, mp2)
 *
 *  Purpose: Processes all messages sent to the About Box
 *
 *  Usage:  Called for each message sent to the About Box
 *	 dialog box.
 *
 *  Method: the about box only has a button control so this
 *	 routine only processes WM_COMMAND messages.  Any
 *	 WM_COMMAND posted must have come from the Ok
 *	 button so we dismiss the dialog upon receiving it.
 *
 *  Returns: Dependent upon message sent
 *
\****************************************************************/
MRESULT EXPENTRY AboutBoxDlgProc(HWND hwnd, ULONG msg,MPARAM mp1,MPARAM mp2)
{
    switch(msg)	 {
   case WM_COMMAND:
       /* no matter what the command, close the dialog */
       WinDismissDlg(hwnd, TRUE);
       break;
/**********  Remove this code for now
   case WM_HELP:
       ShowDlgHelp(hwnd);
       break;		  ************/

   default:
       return(WinDefDlgProc(hwnd, msg, mp1, mp2));
       break;
    }

    return 0L;

}   /* AboutBoxDlgProc() */
/****************************************************************\
 *  Shows the help panel for the given dialog window
 *--------------------------------------------------------------
 *
 *  Name:   ShowDlgHelp(hwnd)
 *
 *  Purpose: Displays the help panel for the current selected
 *	  item in the dialog window
 *
 *  Usage:  Called each time a WM_HELP message is posted to
 *	 a dialog
 *
 *  Method: gets the id value of the window and determine which
 *	 help panel to display.	 Then sends a message to
 *	 the help instance to display the panel.  If the dialog
 *	 or item is not included here, then the unknown dialog
 *	 or unknown item panel is displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID ShowDlgHelp(hwnd)
HWND hwnd;   /* handle of list box window */
{
    SHORT idDlg, idItem;
    HWND  hwndFocus;

    /* get the id of the dialog box */
    idDlg = WinQueryWindowUShort(hwnd, QWS_ID);

    /* finds which window has the focus and gets its id */
    hwndFocus = WinQueryFocus(HWND_DESKTOP);
    idItem = WinQueryWindowUShort(hwndFocus, QWS_ID);


}   /* ShowDlgHelp() */

/******************************	 END JIGHELP.C	******************************/
/******************************************************************************
*
*  File Name   : JIGSAW.C
*
*  Description : main function and code for the Jigsaw application
*
*     This program provides a jigsaw puzzle, based on a decomposition of an
*     arbitrary bitmap loaded from a file.  The user can jumble the pieces,
*     then drag them individually by means of the mouse.  The image can be
*     zoomed in and out and scrolled up/down and left/right.
*
*     JIGSAW uses GpiBitBlt with clip paths to create a collection of picture
*     fragments which are the puzzle pieces.  In earlier versions of the
*     program, each of these pieces was associated with a single retain-mode
*     graphics segment.	 The retain-mode technique, however, proved to be
*     too slow, so subsequent versions of the program used retain-mode APIs
*     for fewer and fewer operations.  The current version eliminates
*     retain-mode graphics altogether.	Instead, the drawing data for each
*     piece is stored in _SEGLIST data structure defined in JIGSAW.H.
*     This structure contains all the data needed to draw a piece, including
*     pointers to the previous and next pieces.	 The _SEGLIST nodes are
*     arranged in drawing priority order, so the picture can be reconstructed
*     by traversing the list in sequence, drawing each piece as its
*     corresponding structure is encountered.  Where the comments in the
*     rest of the program refer to a "segment," they are simply referring to
*     a piece of the puzzle as defined by a record in this data structure.
*
*     To retain responsiveness to user requests, the real work is done in a
*     second thread, with work requests transmitted from the main thread in
*     the form of messages.  This arrangement makes it possible for the user
*     to override lengthy drawing operations with a higher-priority request
*     (eg. program termination, magnification change, etc.).
*
*     Individual pieces are made to "move" by changing their model transforms.
*     Scrolling and zooming of the whole picture is done by changing the
*     default viewing transform.  The points in model space associated with
*     each piece (control points for the bounding curve, corners of the
*     bounding box, etc.) are converted via GpiConvert into points in device
*     space prior to use with GpiBitBlt, etc.
*
*  Concepts    : Illustrates the use of GPI
*		 Illustrates the use of off-screen bitmaps
*
*  Entry Points:
*		 CalcSize()
*		 CheckMenu()
*		 CheckPsl()
*		 CreatePicture()
*		 DispErrorMsg()
*		 DoHorzScroll()
*		 DosGetThreadInfo()
*		 DoVertScroll()
*		 DumpPicture()
*		 EnableMenu()
*		 NewThread()
*		 Finalize()
*		 Initialize()
*		 Jumble()
*		 LeftDown()
*		 LeftUp()
*		 Load()
*		 main()
*		 MouseMove()
*		 PrepareBitmap()
*		 ReadBitmap()
*		 ReportError()
*		 ResetScrollBars()
*		 SegListCheck()
*		 ToBottom()
*		 Zoom()
*
*  API's       : GpiBeginPath
*		 GpiEndPath
*		 GpiFillPath
*		 GpiSetClipPath
*		 GpiSetClipRegion
*
*		 GpiCreateBitmap
*		 GpiDeleteBitmap
*		 GpiSetBitmap
*		 GpiSetBitmapBits
*		 GpiBitBlt
*
*		 GpiConvert
*
*		 GpiCreateRegion
*		 GpiCombineRegion
*		 GpiSetRegion
*		 GpiDestroyRegion
*		 GpiQueryRegionBox
*
*		 GpiSetAttrMode
*		 GpiSetColor
*
*		 GpiQueryDefaultViewMatrix
*		 GpiSetDefaultViewMatrix
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.						      *
*
******************************************************************************/

#include "jigsaw.h"
#include "globals.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/******************************************************************************
*
*  Name	       : main
*
*  Description : Main thread will initialize the process for PM services and
*		 process the application message queue until a WM_QUIT message
*		 is received.  It will then destroy all PM resources and
*		 terminate.  Any error during initialization will be reported
*		 and the process terminated.
*
*  Concepts    :
*
*  API's       :
*
*  Parameters  : VOID
*
*  Return      :
*
******************************************************************************/

VOID main(VOID)
{
  QMSG	qmsg;

  if( Initialize())
      while( WinGetMsg( habMain, &qmsg, NULLHANDLE, 0, 0))
	  WinDispatchMsg( habMain, &qmsg);
  else
      ReportError( habMain);
  Finalize();

}   /* end main() */

/******************************************************************************
*
*  Name	       : Initialize
*
*  Description :
*
*  The Initialize function will initialize the PM interface,
*  create an application message queue, a standard frame window and a new
*  thread to control drawing operations.  It will also initialize static
*  strings.
*
*  Concepts    :
*
*  API's       :
*
*  Parameters  : VOID
*
*  Return      : BOOL
*
******************************************************************************/

BOOL Initialize(VOID)
{
  ULONG	   flCreate;
  PID	   pid;
  TID	   tid;

   /*
    * create all semaphores for mutual exclusion and event timing
    */
		   /* (anonomous,	     ,	  private,  reset) */

   if (DosCreateEventSem( NULL,	 &hevDrawOn,	      0,    FALSE) ||
       DosCreateEventSem( NULL,	 &hevMouse,	      0,    FALSE) ||
       DosCreateEventSem( NULL,	 &hevLoadingBitmap,   0,    FALSE) ||
       DosCreateEventSem( NULL,	 &hevTerminate,	      0,    FALSE) ||
       DosCreateEventSem( NULL,	 &hevKillDraw,	      0,    FALSE))
   {
       return (FALSE);			     /* failed to create a semaphore */
   }

   WinShowPointer( HWND_DESKTOP, TRUE);
   habMain = WinInitialize( 0);
   if( !habMain)
       return( FALSE);

   hmqMain = WinCreateMsgQueue( habMain,0);
   if( !hmqMain)
       return( FALSE);

   WinLoadString( habMain, 0, IDS_TITLEBAR, sizeof(szTitle), szTitle);
   WinLoadString( habMain, 0, IDS_ERROR_TITLE, sizeof(szErrorTitle), szErrorTitle);
   if( !WinRegisterClass( habMain
			, (PCH)szTitle
			, ClientWndProc
			, CS_SIZEREDRAW
			, 0 ))
       return( FALSE);

   flCreate =	(FCF_STANDARD | FCF_VERTSCROLL | FCF_HORZSCROLL)
	      & ~(ULONG)FCF_TASKLIST;
   hwndFrame =
   WinCreateStdWindow(
      HWND_DESKTOP,			  /* handle of the parent window     */
      WS_VISIBLE,			  /* frame-window style		     */
      &flCreate,			  /* creation flags		     */
      szTitle,				  /* client-window class name	     */
      szTitle,				  /* address of title-bar text	     */
      WS_VISIBLE,			  /* client-window style	     */
      0,				  /* handle of the resource module   */
      IDR_MAIN,				  /* frame-window identifier	     */
      &hwndClient);			  /* address of client-window handle */

   if( !hwndFrame)
       return( FALSE);

   sizlMaxClient.cx = WinQuerySysValue( HWND_DESKTOP, SV_CXFULLSCREEN);
   sizlMaxClient.cy = WinQuerySysValue( HWND_DESKTOP, SV_CYFULLSCREEN);

   lByteAlignX = WinQuerySysValue( HWND_DESKTOP, SV_CXBYTEALIGN);
   lByteAlignY = WinQuerySysValue( HWND_DESKTOP, SV_CYBYTEALIGN);

   hdcClient = WinOpenWindowDC( hwndClient);
   hpsClient = GpiCreatePS( habMain
			  , hdcClient
			  , &sizlMaxClient
			  , GPIA_ASSOC | PU_PELS );
   if( !hpsClient)
   {
    DispError(habMain,hwndClient);
    return( TRUE);
   }
   if (GpiSetAttrMode( hpsClient, AM_PRESERVE) == GPI_ERROR)
       DispError(habMain,hwndClient);

   hwndHorzScroll = WinWindowFromID( hwndFrame, FID_HORZSCROLL);

   hwndVertScroll = WinWindowFromID( hwndFrame, FID_VERTSCROLL);

   if ((hpsPaint = GpiCreatePS( habMain, NULLHANDLE, &sizlMaxClient, PU_PELS)) == GPI_ERROR)
		  DispError(habMain,hwndClient);

   hrgnInvalid = GpiCreateRegion( hpsClient, 0L, NULL);

   WinQueryWindowProcess( hwndFrame, &pid, &tid);
   swctl.hwnd	   = hwndFrame;
   swctl.idProcess = pid;
   strcpy( swctl.szSwtitle, szTitle);
   hsw = WinAddSwitchEntry( &swctl);

   hwndMenu = WinWindowFromID( hwndFrame, FID_MENU);

   if(DosCreateThread(&tidAsync,
		      (PFNTHREAD) NewThread,
		      0,
		      0,
		      STACKSIZE )) {
       return( FALSE);
       }			       /* create async thread		      */
   if( !CreateBitmapHdcHps( &hdcBitmapFile, &hpsBitmapFile))
       return( FALSE);
   if( !CreateBitmapHdcHps( &hdcBitmapSize, &hpsBitmapSize))
       return( FALSE);
   if( !CreateBitmapHdcHps( &hdcBitmapBuff, &hpsBitmapBuff))
       return( FALSE);
   if( !CreateBitmapHdcHps( &hdcBitmapSave, &hpsBitmapSave))
       return( FALSE);

   ResetScrollBars();
   /*
    * initialise help mechanism
    */

   HelpInit();
   return( TRUE);

}   /* end Initialize() */

/******************************************************************************
*
*  Name	       : Finalize
*
*  Description :
*
* Finalize will destroy the asynchronous drawing thread, all Presentation
* Manager resources, and terminate the process.
*
*  Concepts    :
*
*  API's       :
*
*  Parameters  : VOID
*
*  Return      : VOID
*
******************************************************************************/

VOID Finalize(VOID)
{
  ULONG ulPostCt;

  if( tidAsync)
  {
      DosResetEventSem( hevDrawOn, &ulPostCt);
      DosPostEventSem( hevKillDraw);
      DosPostEventSem( hevTerminate);
      SendCommand( UM_DIE, (MPARAM)NULL, (MPARAM)NULL);
  }

  while( pslHead != NULL )
  {
    if (GpiSetBitmap( pslHead->hpsFill, NULLHANDLE) == (HBITMAP)BMB_ERROR)
      DispError(habMain,hwndClient);
    if (GpiDeleteBitmap( pslHead->hbmFill) == GPI_ERROR)
      DispError(habMain,hwndClient);
    if (GpiDestroyPS( pslHead->hpsFill) == GPI_ERROR)
      DispError(habMain,hwndClient);
    DevCloseDC( pslHead->hdcFill);

    if (GpiSetBitmap( pslHead->hpsHole, NULLHANDLE)== (HBITMAP)BMB_ERROR)
      DispError(habMain,hwndClient);
    if (GpiDeleteBitmap( pslHead->hbmHole) == GPI_ERROR)
      DispError(habMain,hwndClient);
    if (GpiDestroyPS( pslHead->hpsHole) == GPI_ERROR)
      DispError(habMain,hwndClient);
    DevCloseDC( pslHead->hdcHole);

    SegListUpdate( DEL_SEG, pslHead);
  }

  if( hrgnInvalid)
      GpiDestroyRegion( hpsClient, hrgnInvalid);
  if( hpsClient)
  {
      GpiAssociate( hpsClient, NULLHANDLE);
      GpiDestroyPS( hpsClient);
  }
  if( hpsPaint)
      GpiDestroyPS( hpsPaint);

  if( hpsBitmapFile)
  {
      GpiSetBitmap( hpsBitmapFile, NULLHANDLE);
      GpiDeleteBitmap( hbmBitmapFile);
      GpiDestroyPS( hpsBitmapFile);
      DevCloseDC( hdcBitmapFile);
  }
  if( hpsBitmapSize)
  {
      GpiSetBitmap( hpsBitmapSize, NULLHANDLE);
      GpiDeleteBitmap( hbmBitmapSize);
      GpiDestroyPS( hpsBitmapSize);
      DevCloseDC( hdcBitmapSize);
  }
  if( hpsBitmapBuff)
  {
      GpiSetBitmap( hpsBitmapBuff, NULLHANDLE);
      GpiDeleteBitmap( hbmBitmapBuff);
      GpiDestroyPS( hpsBitmapBuff);
      DevCloseDC( hdcBitmapBuff);
  }
  if( hpsBitmapSave)
  {
      GpiSetBitmap( hpsBitmapSave, NULLHANDLE);
      GpiDeleteBitmap( hbmBitmapSave);
      GpiDestroyPS( hpsBitmapSave);
      DevCloseDC( hdcBitmapSave);
  }

  DestroyHelpInstance();

  if( hwndFrame)
      WinDestroyWindow( hwndFrame);
  if( hmqMain)
      WinDestroyMsgQueue( hmqMain);
  if( habMain)
      WinTerminate( habMain);

  DosExit( EXIT_PROCESS, 0);

}   /* end Finalize() */

/******************************************************************************
*
*  Name	       : ReportError
*
*  Description :
*
* ReportError  will display the latest error information for the required
* thread. No resources to be loaded if out of memory error.
*
*  Concepts    :
*
*  API's       :
*
*  Parameters  : HAB hab
*
*  Return      : VOID
*
******************************************************************************/

VOID ReportError(HAB hab)
{
PERRINFO  perriBlk;
PSZ	  pszErrMsg;
PSZ	  pszOffSet;

  if (!fErrMem){
      if ((perriBlk = WinGetErrorInfo(hab)) != (PERRINFO)NULL){
	  pszOffSet = ((PSZ)perriBlk) + perriBlk->offaoffszMsg;
	  pszErrMsg = ((PSZ)perriBlk) + *((PULONG)pszOffSet);
	  WinMessageBox(HWND_DESKTOP,
			hwndFrame,
		       (PSZ)(pszErrMsg),
		       (PSZ)szTitle,
			0,
			MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL );
	  WinFreeErrorInfo(perriBlk);
	  return;
      }
  } /* endif */

  MessageBox(							    /* ERROR */
     hwndFrame,
     IDS_ERROR_OUTOFMEMORY,
     MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL,
     TRUE);

}   /* end ReportError() */

/******************************************************************************
*
*  Name	       : ResetScrollBars
*
*  Description :
*
* Reset the scroll bars to be in the middle of their range
*
*  Concepts    :
*
*  API's       :
*
*  Parameters  : VOID
*
*  Return      : VOID
*
******************************************************************************/

VOID ResetScrollBars(VOID)
{
    RECTL     rclClient;

    WinQueryWindowRect( hwndClient, &rclClient);
    ptsScrollMax.x = (SHORT)(rclClient.xRight - rclClient.xLeft);
    ptsHalfScrollMax.x = ptsScrollMax.x >> 1;
    ptsScrollPage.x = ptsScrollMax.x >> 3;
    ROUND_DOWN_MOD( ptsScrollPage.x, (SHORT)lByteAlignX);
    ptsScrollLine.x = ptsScrollMax.x >> 5;
    ROUND_DOWN_MOD( ptsScrollLine.x, (SHORT)lByteAlignX);
    ptsScrollPos.x = ptsHalfScrollMax.x;
    ptsOldScrollPos.x = ptsHalfScrollMax.x;
    WinSendMsg( hwndHorzScroll
	      , SBM_SETSCROLLBAR
	      , MPFROMSHORT( ptsScrollPos.x)
	      , MPFROM2SHORT( 1, ptsScrollMax.x) );

    ptsScrollMax.y = (SHORT)(rclClient.yTop - rclClient.yBottom);
    ptsHalfScrollMax.y = ptsScrollMax.y >> 1;
    ptsScrollPage.y = ptsScrollMax.y >> 3;
    ROUND_DOWN_MOD( ptsScrollPage.y, (SHORT)lByteAlignY);
    ptsScrollLine.y = ptsScrollMax.y >> 5;
    ROUND_DOWN_MOD( ptsScrollLine.y, (SHORT)lByteAlignY);
    ptsScrollPos.y = ptsHalfScrollMax.y;
    ptsOldScrollPos.y = ptsHalfScrollMax.y;
    WinSendMsg( hwndVertScroll
	      , SBM_SETSCROLLBAR
	      , MPFROMSHORT( ptsScrollPos.y)
	      , MPFROM2SHORT( 1, ptsScrollMax.y) );

    WinSendMsg( hwndHorzScroll
	      , SBM_SETTHUMBSIZE
	      , MPFROM2SHORT(ptsScrollPage.x, ptsScrollMax.x)
	      , 0				 );

    WinSendMsg( hwndVertScroll
	      , SBM_SETTHUMBSIZE
	      , MPFROM2SHORT(ptsScrollPage.y, ptsScrollMax.y)
	      , NULL				 );

}   /* end ResetScrollBars() */

/******************************************************************************
*
*  Name	       : Load
*
*  Description : Load a bitmap
*
*  Parameters  : PLOADINFO pli - pointer to file information (name, handle...)
*
*  Return      : VOID
*
******************************************************************************/

VOID Load(PLOADINFO pli)
{
 ULONG	   ulPostCt;
 PUCHAR	   pFilename;
 UCHAR	   szWindowText[CCHMAXPATH];

   DosResetEventSem( hevLoadingBitmap, &ulPostCt);  /* begin loading bitmap */

   /*
    *	Disable bitmap manipulation submenus
    */

   EnableMenu(IDM_SIZE_MENU,   FALSE);
   EnableMenu(IDM_SIZE_SMALL,  FALSE);
   EnableMenu(IDM_SIZE_MEDIUM, FALSE);
   EnableMenu(IDM_SIZE_LARGE,  FALSE);
   EnableMenu(IDM_SIZE_FULL,   FALSE);
   EnableMenu(IDM_JUMBLE,      FALSE);

   CheckMenu(Currentchecked, FALSE);			/* uncheck old menu */

   if( hbmBitmapFile)
   {
      if (GpiSetBitmap( hpsBitmapFile, NULLHANDLE) == (HBITMAP)BMB_ERROR)
	  DispError(habMain,hwndClient);
      if (GpiDeleteBitmap( hbmBitmapFile) == GPI_ERROR)
	  DispError(habMain,hwndClient);
   }

   if (!ReadBitmap( pli->hf))
   {
      MessageBox(hwndClient, IDS_ERROR_READ, MB_OK | MB_ERROR, TRUE);
      DosPostEventSem( hevLoadingBitmap);	      /* end loading bitmap */
      if (!fFirstLoad)
      {
	 /*
	  *   Re-Enable bitmap manipulation submenus
	  */

	 EnableMenu(IDM_SIZE_MENU,   TRUE);
	 EnableMenu(IDM_SIZE_SMALL,  TRUE);
	 EnableMenu(IDM_SIZE_MEDIUM, TRUE);
	 EnableMenu(IDM_SIZE_LARGE,  TRUE);
	 EnableMenu(IDM_SIZE_FULL,   TRUE);
	 EnableMenu(IDM_JUMBLE,	     TRUE);

	 CheckMenu(Currentchecked, TRUE);		 /* recheck old menu */

      }	  /* end if (!fFirstLoad) */

      return;
   }

   /*
    *	Change Title Bar text and Window List text to include filename.
    */

   strcpy(swctl.szSwtitle, szTitle);
   strcat(swctl.szSwtitle, " - ");
   strcpy(szWindowText, swctl.szSwtitle);	     /* save duplicate part */
   pFilename = strrchr(pli->szFileName, '\\');	       /* contain pathname? */

   if (pFilename == NULL)
      pFilename = pli->szFileName;	   /* filename doesn't contain path */
   else
      ++pFilename;			      /* point past last back-slash */
   strcat( swctl.szSwtitle, pFilename);
   WinChangeSwitchEntry( hsw, &swctl);

   strcat(szWindowText, pli->szFileName);    /* use full filename in window */
   WinSetWindowText( hwndFrame, szWindowText);
   ResetScrollBars();

   if (fFirstLoad ||
       (PBMP1(pbmp2BitmapFile)->cx	  >  PBMP1(pbmp2BitmapFileRef)->cx ||
	PBMP1(pbmp2BitmapFile)->cy	  >  PBMP1(pbmp2BitmapFileRef)->cy ||
	PBMP1(pbmp2BitmapFile)->cPlanes	  != PBMP1(pbmp2BitmapFileRef)->cPlanes ||
	PBMP1(pbmp2BitmapFile)->cBitCount != PBMP1(pbmp2BitmapFileRef)->cBitCount))
   {
     if( !fFirstLoad)
	      DumpPicture();
     if( !PrepareBitmap() )
     {
	MessageBox(hwndClient, IDS_ERROR_READ, MB_OK | MB_ERROR, TRUE);
	DosPostEventSem( hevLoadingBitmap);	 /* end loading bitmap */
	if (!fFirstLoad)
	{
	   /*
	    *	Re-Enable bitmap manipulation submenus
	    */

	   EnableMenu(IDM_SIZE_MENU,   TRUE);
	   EnableMenu(IDM_SIZE_SMALL,  TRUE);
	   EnableMenu(IDM_SIZE_MEDIUM, TRUE);
	   EnableMenu(IDM_SIZE_LARGE,  TRUE);
	   EnableMenu(IDM_SIZE_FULL,   TRUE);
	   EnableMenu(IDM_JUMBLE,      TRUE);

	   CheckMenu(Currentchecked, TRUE);		/* recheck old menu */

	}   /* end if (!fFirstLoad) */

	return;
     }
     CreatePicture( PICTURE_CREATE);
     bmp2BitmapFileRef = bmp2BitmapFile;
   } else
   {
     CreatePicture( PICTURE_UPDATE);
   }

   lScale = 0;

   CalcBounds();
   ptlScaleRef.x = ptlScaleRef.y = 0L;
   CalcTransform( hwndClient);

   DosPostEventSem( hevLoadingBitmap);		      /* end loading bitmap */

   fFirstLoad = FALSE;
   fPictureAssembled = TRUE;
   BmpLoaded = TRUE;

   /*
    *	Enable bitmap manipulation submenus
    */
   EnableMenu(IDM_SIZE_MENU,   TRUE);
   EnableMenu(IDM_SIZE_SMALL,  TRUE);
   EnableMenu(IDM_SIZE_MEDIUM, TRUE);
   EnableMenu(IDM_SIZE_LARGE,  TRUE);
   EnableMenu(IDM_SIZE_FULL,   TRUE);
   EnableMenu(IDM_JUMBLE,      TRUE);

   CheckMenu(IDM_SIZE_FULL, TRUE);			  /* check full size */
   Currentchecked = IDM_SIZE_FULL;

}   /* end Load() */

/******************************************************************************/
/* Throw the pieces around the screen.					      */
/******************************************************************************/
VOID Jumble(VOID)
{
  LONG	    lWidth, lHeight;
  DATETIME  date;
  POINTL    ptl;
  RECTL	    rclClient;
  PSEGLIST  psl;

  if( WinQueryWindowRect( hwndClient, &rclClient) )
  {
    lWidth  = rclClient.xRight - rclClient.xLeft;
    lHeight = rclClient.yTop   - rclClient.yBottom;
    if( (lWidth > 0) && (lHeight > 0) )
    {
       DosGetDateTime( &date);
       srand( (USHORT)date.hundredths);
       for( psl = pslHead; psl != NULL; psl = psl->pslNext)
       {
	       psl->pslNextIsland = psl;    /* reset island pointer		      */
	       psl->fIslandMark = FALSE;    /* clear island mark		      */
	       ptl.x = rclClient.xLeft	 + (rand() % lWidth);
	       ptl.y = rclClient.yBottom + (rand() % lHeight);
	       if (GpiConvert( hpsClient, CVTC_DEVICE, CVTC_MODEL, 1L, &ptl) == GPI_ERROR)
		 DispError(habMain,hwndClient);
	       ptl.x = 50 * (ptl.x / 50) - 250;
	       ptl.y = 50 * (ptl.y / 50) - 250;
	       psl->ptlModelXlate.x = ptl.x - psl->ptlLocation.x;
	       psl->ptlModelXlate.y = ptl.y - psl->ptlLocation.y;
	       SetRect( psl);
      }
    }
    fPictureAssembled = FALSE;
  }
}

/******************************************************************************/
/*																		    */
/*																		    */
/*																		    */
/******************************************************************************/
VOID ToBottom( pslDown)
PSEGLIST pslDown;
{
  BOOL	    fFirst;
  PSEGLIST  psl;

  for( psl = pslDown, fFirst = TRUE
     ; (psl != pslDown) || fFirst
     ; psl = psl->pslNextIsland, fFirst = FALSE )
    SegListUpdate( MAKE_HEAD_SEG, psl);	      /* at head => lowest priority   */
}


/******************************************************************************/
/*																		    */
/* NewThread is the asynchronous drawing thread. It is responsible for all    */
/* drawing.  It will initialize its PM interface and create an application    */
/* message queue.  It will then monitor its message queue and process any     */
/* commands received.														*/
/*																		    */
/******************************************************************************/
VOID NewThread(VOID)
{
  QMSG	    qmsgAsync, qmsgPeek;
  BOOL	    fDone;
  POINTL    aptlDraw[3];
  USHORT    usChar, fsKeyFlags;
  PSEGLIST  psl;
  ULONG	    ulPostCt;

  /****************************************************************************/
  /* Initialize the PM interface.  If it fails, terminate both threads.	      */
  /****************************************************************************/
  habAsync = WinInitialize( 0);
  if( !habAsync)
  {
      WinPostMsg( hwndClient, WM_QUIT, NULL, NULL);
      DosExit( EXIT_THREAD, 0);
  }

  /****************************************************************************/
  /* Create a message queue.  If it fails, terminate both threads.		 */
  /****************************************************************************/
  hmqAsync = WinCreateMsgQueue( habAsync, 150);
  if( !hmqAsync)
  {
      WinPostMsg( hwndClient, WM_QUIT, NULL, NULL);
      WinTerminate( habAsync);
      DosExit( EXIT_THREAD, 0);
  }
  else
  {
     WinCancelShutdown( hmqAsync, TRUE);   /* don't wait around for shutdown */
  }

  DosSetPriority( PRTYS_THREAD, PRTYC_NOCHANGE, sPrty, (TID)NULL);


  while( TRUE)
  {
    WinGetMsg( habAsync, &qmsgAsync, NULLHANDLE, 0, 0);

    /*
     *	 If we're exiting, give that message highest priority.
     */

    if( WinPeekMsg(habAsync, &qmsgPeek, NULLHANDLE, UM_DIE, UM_DIE, PM_NOREMOVE))
	    qmsgAsync = qmsgPeek;
    /*
     *	 Disallow drawing and mouse tracking as needed
     */

    if( (qmsgAsync.msg < UM_SIZING) || (qmsgAsync.msg > UM_LOAD))
	    DosPostEventSem( hevMouse);		    /* enable mouse tracking */
    else
	    DosResetEventSem( hevMouse, &ulPostCt); /* disable mouse tracking */

    if( WinPeekMsg( habAsync, &qmsgPeek, NULLHANDLE, UM_SIZING, UM_LOAD, PM_NOREMOVE))
    {
       DosResetEventSem( hevDrawOn, &ulPostCt);		  /* disable drawing */
       DosResetEventSem( hevMouse, &ulPostCt);	   /* disable mouse tracking */
    }
    else
    {
       DosPostEventSem( hevDrawOn);			   /* enable drawing */
       DosPostEventSem( hevMouse);		    /* enable mouse tracking */
    }

    /**************************************************************************/
    /* process the commands						      */
    /**************************************************************************/

    switch( qmsgAsync.msg)
    {
      /************************************************************************/
      case UM_CHAR:
	    fsKeyFlags = (USHORT)SHORT1FROMMP(qmsgAsync.mp1);
	    usChar	   = (USHORT)SHORT1FROMMP(qmsgAsync.mp2);
	    if(	  (fsKeyFlags & KC_CHAR)
	       && ((usChar == 'b') || (usChar == 'B')))
	    {
	      if( psl = Correlate( &ptlMouse))
	      {
		ToBottom( psl);
		Redraw();
	      }
	    }
	    break;

      /************************************************************************/
      case UM_LOAD:
	      Load( (PLOADINFO)qmsgAsync.mp1);
	      Redraw();
	break;

      /************************************************************************/
      case UM_JUMBLE:
	Jumble();
	Redraw();
	break;

      /************************************************************************/
      case UM_REDRAW:
	Redraw();
	break;

      /************************************************************************/
      /* DRAW will use the passed region containing the invalidated area of   */
      /* the screen, repaint it and then destroy the region.		      */
      /************************************************************************/
      case UM_DRAW:

	if (!BmpLoaded)
	     break;
	if( qmsgAsync.mp1)
	{
	  DoDraw( hpsBitmapBuff, (HRGN)qmsgAsync.mp1, TRUE);
	  if (GpiQueryRegionBox( hpsClient, (HRGN)qmsgAsync.mp1, (PRECTL)aptlDraw) == RGN_ERROR)
		 DispError(habMain,hwndClient);
	  if (GpiDestroyRegion( hpsClient, (HRGN)qmsgAsync.mp1) == GPI_ERROR)
		 DispError(habMain,hwndClient);
	  WinMapWindowPoints( hwndClient, HWND_DESKTOP, aptlDraw, 3);
	  ROUND_DOWN_MOD( aptlDraw[0].x, lByteAlignX);	  /* round down	      */
	  ROUND_DOWN_MOD( aptlDraw[0].y, lByteAlignY);	  /* round down	      */
	  ROUND_UP_MOD(	  aptlDraw[1].x, lByteAlignX);	  /* round up	      */
	  ROUND_UP_MOD(	  aptlDraw[1].y, lByteAlignY);	  /* round up	      */
	  WinMapWindowPoints( HWND_DESKTOP, hwndClient, aptlDraw, 3);
	  aptlDraw[2] = aptlDraw[0];
	  if (GpiBitBlt( hpsClient
		       , hpsBitmapBuff
		       , 3L
		       , aptlDraw
		       , ROP_SRCCOPY
		       , BBO_IGNORE ) == GPI_ERROR)
	      DispError(habMain,hwndClient);
	}
	break;


      /************************************************************************/
      /* Get new scroll posn from command ( i.e. +/-1 +/-page) or new	      */
      /* absolute position from parameter, update scroll posn, change the     */
      /* transform and update the thumb posn.  Finally update the window.     */
      /************************************************************************/
      case UM_HSCROLL:
	switch( SHORT2FROMMP( qmsgAsync.mp1) )
	{
	    case SB_LINEUP:
		ptsScrollPos.x -= ptsScrollLine.x;
		break;
	    case SB_LINEDOWN:
		ptsScrollPos.x += ptsScrollLine.x;
		break;
	    case SB_SLIDERTRACK:
	    case SB_SLIDERPOSITION:
		for( fDone = FALSE; !fDone ;)
		{
		  if( WinPeekMsg( habAsync
				, &qmsgPeek
				, NULLHANDLE
				, UM_HSCROLL
				, UM_HSCROLL
				, PM_NOREMOVE))
		      if(   (SHORT2FROMMP( qmsgPeek.mp1) == SB_SLIDERTRACK)
			  ||(SHORT2FROMMP( qmsgPeek.mp1) == SB_SLIDERPOSITION))
			  WinPeekMsg( habAsync
				    , &qmsgAsync
				    , NULLHANDLE
				    , UM_HSCROLL
				    , UM_HSCROLL
				    , PM_REMOVE);
		      else
			  fDone = TRUE;
		  else
		      fDone = TRUE;
		}
		ptsScrollPos.x = SHORT1FROMMP( qmsgAsync.mp1);
		ROUND_DOWN_MOD( ptsScrollPos.x, (SHORT)lByteAlignX);
		break;
	    case SB_PAGEUP:
		ptsScrollPos.x -= ptsScrollPage.x;
		break;
	    case SB_PAGEDOWN:
		ptsScrollPos.x += ptsScrollPage.x;
		break;
	    case SB_ENDSCROLL:
		break;
	    default:
		break;
	}
	DoHorzScroll();
	break;

      case UM_VSCROLL:
	switch( SHORT2FROMMP( qmsgAsync.mp1) )
	{
	    case SB_LINEUP:
		ptsScrollPos.y -= ptsScrollLine.y;
		break;
	    case SB_LINEDOWN:
		ptsScrollPos.y += ptsScrollLine.y;
		break;
	    case SB_SLIDERTRACK:
	    case SB_SLIDERPOSITION:
		for( fDone = FALSE; !fDone ;)
		{
		  if( WinPeekMsg( habAsync
				, &qmsgPeek
				, NULLHANDLE
				, UM_VSCROLL
				, UM_VSCROLL
				, PM_NOREMOVE))
		      if(   (SHORT2FROMMP( qmsgPeek.mp1) == SB_SLIDERTRACK)
			  ||(SHORT2FROMMP( qmsgPeek.mp1) == SB_SLIDERPOSITION))
			  WinPeekMsg( habAsync
				    , &qmsgAsync
				    , NULLHANDLE
				    , UM_VSCROLL
				    , UM_VSCROLL
				    , PM_REMOVE);
		      else
			  fDone = TRUE;
		  else
		      fDone = TRUE;
		}
		ptsScrollPos.y = SHORT1FROMMP( qmsgAsync.mp1);
		ROUND_DOWN_MOD( ptsScrollPos.y, (SHORT)lByteAlignY);
		break;
	    case SB_PAGEUP:
		ptsScrollPos.y -= ptsScrollPage.y;
		break;
	    case SB_PAGEDOWN:
		ptsScrollPos.y += ptsScrollPage.y;
		break;
	    case SB_ENDSCROLL:
		break;
	    default:
		break;
	}
	DoVertScroll();
	break;

      /************************************************************************/
      /* the window is being resized					      */
      /************************************************************************/
      case UM_SIZING:
	CalcBounds();
	CalcTransform( hwndClient);
	break;

      /************************************************************************/
      /* adjust zoom factor						      */
      /************************************************************************/
      case UM_ZOOM:
	if( WinPeekMsg( habAsync
		      , &qmsgPeek
		      , NULLHANDLE
		      , UM_SIZING
		      , UM_LOAD
		      , PM_NOREMOVE))
	    DosResetEventSem( hevDrawOn, &ulPostCt);
	else {
	    DosPostEventSem( hevDrawOn);
	    }

	Zoom();
	break;

      /************************************************************************/
      /* Button down will cause a correlate on the picture to test for a hit. */
      /* Any selected segment will be highlighted and redrawn as dynamic.     */
      /************************************************************************/
      case UM_LEFTDOWN:
	if( !fButtonDownAsync)
	{
	    fButtonDownAsync = TRUE;
       if(!fPictureAssembled)
	       LeftDown( qmsgAsync.mp1);
	}
	break;

      /************************************************************************/
      /* if a segment is being dragged it will be redrawn in a new posn	      */
      /************************************************************************/
      case UM_MOUSEMOVE:
#ifdef fred
	if( !fButtonDownAsync)
	    break;
#endif
	for( fDone = FALSE; !fDone ;)
	{
	  if( WinPeekMsg( habAsync	      /* look through first button-up */
			, &qmsgPeek
			, NULLHANDLE
			, UM_MOUSEMOVE
			, UM_LEFTUP
			, PM_NOREMOVE))
	      if( qmsgPeek.msg == UM_MOUSEMOVE) /* only collapse move msgs    */
		  WinPeekMsg( habAsync
			    , &qmsgAsync
			    , NULLHANDLE
			    , UM_MOUSEMOVE
			    , UM_MOUSEMOVE
			    , PM_REMOVE);
	      else
		  fDone = TRUE;
	  else
	      fDone = TRUE;
	}
	MouseMove( qmsgAsync.mp1);	/* process last move before button-up */
	break;

      /************************************************************************/
      /* if a segment is being dragged it will be redrawn as normal	      */
      /************************************************************************/
      case UM_LEFTUP:
	if( fButtonDownAsync)
	{
	    LeftUp();
	    fButtonDownAsync = FALSE;
	}
	break;

      /************************************************************************/
      /* destroy resources and terminate							   */
      /************************************************************************/
      case UM_DIE:
	      WinDestroyMsgQueue( hmqAsync);
	      WinTerminate( habAsync);
	      DosExit( EXIT_THREAD, 0);
	      break;

      /************************************************************************/
      default:
	break;
    }
  }
}

/******************************************************************************/
/*									      */
/******************************************************************************/
VOID CalcSize( mp1, mp2)
MPARAM mp1;
MPARAM mp2;
{
  ptsScrollMax.y = SHORT2FROMMP( mp2);
  ptsHalfScrollMax.y = ptsScrollMax.y >> 1;
  ptsScrollPage.x = ptsScrollMax.x >> 3;
  ROUND_DOWN_MOD( ptsScrollPage.x, (SHORT)lByteAlignX);
  ptsScrollLine.x = ptsScrollMax.x >> 5;
  ROUND_DOWN_MOD( ptsScrollLine.x, (SHORT)lByteAlignX);
  ptsScrollPos.y = (SHORT)(
			   (  (LONG)ptsScrollPos.y
			    * (LONG)SHORT2FROMMP(mp2)
			   )/ (LONG)SHORT2FROMMP(mp1)
			  );
  ptsOldScrollPos.y = (SHORT)(
			      (	 (LONG)ptsOldScrollPos.y
			       * (LONG)SHORT2FROMMP(mp2)
			      )/ (LONG)SHORT2FROMMP(mp1)
			     );
  WinSendMsg( hwndVertScroll
	    , SBM_SETSCROLLBAR
	    , MPFROMSHORT( ptsScrollPos.y)
	    , MPFROM2SHORT( 1, ptsScrollMax.y) );

  ptsScrollMax.x = SHORT1FROMMP( mp2);
  ptsHalfScrollMax.x = ptsScrollMax.x >> 1;
  ptsScrollPage.y = ptsScrollMax.y >> 3;
  ROUND_DOWN_MOD( ptsScrollPage.y, (SHORT)lByteAlignY);
  ptsScrollLine.y = ptsScrollMax.y >> 5;
  ROUND_DOWN_MOD( ptsScrollLine.y, (SHORT)lByteAlignY);
  ptsScrollPos.x = (SHORT)(
			   (  (LONG)ptsScrollPos.x
			    * (LONG)SHORT1FROMMP(mp2)
			   )/(LONG)SHORT1FROMMP(mp1)
			  );
  ptsOldScrollPos.x = (SHORT)(
			      (	 (LONG)ptsOldScrollPos.x
			       * (LONG)SHORT1FROMMP(mp2)
			      )/ (LONG)SHORT1FROMMP(mp1)
			     );
  WinSendMsg( hwndHorzScroll
	    , SBM_SETSCROLLBAR
	    , MPFROMSHORT( ptsScrollPos.x)
	    , MPFROM2SHORT( 1, ptsScrollMax.x) );
    WinSendMsg( hwndHorzScroll
	      , SBM_SETTHUMBSIZE
	      , MPFROM2SHORT(ptsScrollPage.x, ptsScrollMax.x)
	      , NULL				 );

    WinSendMsg( hwndVertScroll
	      , SBM_SETTHUMBSIZE
	      , MPFROM2SHORT(ptsScrollPage.y, ptsScrollMax.y)
	      , NULL				 );

}

/******************************************************************************/
/* button down will cause one segment to be indicated and made dynamic	      */
/******************************************************************************/
VOID LeftDown(MPARAM mp)
{
  POINTL    ptl;
  HRGN	    hrgn, hrgnUpdt, hrgnUpdtDrag;
  RECTL	    rcl;
  BOOL	    fFirst;
  PSEGLIST  psl;

  ptl.x = (LONG)(SHORT)SHORT1FROMMP( mp);
  ptl.y = (LONG)(SHORT)SHORT2FROMMP( mp);

  /****************************************************************************/
  pslPicked = Correlate( &ptl);
  if( pslPicked)
    lPickedSeg	 = pslPicked->lSegId;
  else
  {
    fButtonDownAsync = FALSE;
    return;
  }
  if( (lPickedSeg < 1) || (lPickedSeg > lLastSegId) )
  {
     #if defined(DEBUG)
     {
       CHAR	 szMsg[40];

	sprintf( szMsg, "Segment id out of range: %x", lPickedSeg);
	WinMessageBox(HWND_DESKTOP, hwndFrame, szMsg, szErrorTitle, 0,
		       MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL);
     }
     #endif

     fButtonDownAsync = FALSE;
     return;
  }

  /****************************************************************************/
  ptlOffStart = pslPicked->ptlModelXlate;
  ptlMoveStart = ptl;
  if (GpiConvert( hpsClient, CVTC_DEVICE, CVTC_MODEL, 1L, &ptlMoveStart) == GPI_ERROR)
      DispError(habMain,hwndClient);
  ptlMoveStart.x = (ptlMoveStart.x / 50) * 50;
  ptlMoveStart.y = (ptlMoveStart.y / 50) * 50;
  ptlUpdtRef = ptlMoveStart;
  if (GpiConvert( hpsClient, CVTC_MODEL, CVTC_DEVICE, 1L, &ptlUpdtRef) == GPI_ERROR)
      DispError(habMain,hwndClient);

  /****************************************************************************/
  hrgnUpdt = GpiCreateRegion( hpsClient, 0L, NULL);
  for( psl = pslPicked, fFirst = TRUE
     ; (psl != pslPicked) || fFirst
     ; psl = psl->pslNextIsland, fFirst = FALSE )
  {
    rcl = psl->rclCurrent;   /* get model space bounding box of piece	      */
    if (GpiConvert( hpsClient, CVTC_MODEL, CVTC_DEVICE, 2L, (PPOINTL)&rcl) == GPI_ERROR)
	DispError(habMain,hwndClient);
    rcl.xRight++;	     /* adjust rectangle for conversion to dev space  */
    rcl.yTop++;
    rcl.xRight	+= 2;				 /* should not need	      */
    rcl.yTop	+= 2;				 /* should not need	      */
    rcl.xLeft	-= 4;				 /* should not need	      */
    rcl.yBottom -= 4;				 /* should not need	      */
    hrgn = GpiCreateRegion( hpsClient, 1L, &rcl);
    if (GpiCombineRegion( hpsClient, hrgnUpdt, hrgnUpdt, hrgn, CRGN_OR) == RGN_ERROR)
	DispError(habMain,hwndClient);
    if (GpiDestroyRegion( hpsClient, hrgn) == GPI_ERROR)
	DispError(habMain,hwndClient);
    psl->fVisible = FALSE;
  }

  if (GpiQueryRegionBox( hpsClient, hrgnUpdt, (PRECTL)aptlUpdt) == GPI_ERROR)
      DispError(habMain,hwndClient);
  WinMapWindowPoints( hwndClient, HWND_DESKTOP, aptlUpdt, 3);
  ROUND_DOWN_MOD( aptlUpdt[0].x, lByteAlignX);		  /* round down	      */
  ROUND_DOWN_MOD( aptlUpdt[0].y, lByteAlignY);		  /* round down	      */
  ROUND_UP_MOD(	  aptlUpdt[1].x, lByteAlignX);		  /* round up	      */
  ROUND_UP_MOD(	  aptlUpdt[1].y, lByteAlignY);		  /* round up	      */
  WinMapWindowPoints( HWND_DESKTOP, hwndClient, aptlUpdt, 3);
  hrgnUpdtDrag = GpiCreateRegion( hpsBitmapBuff, 1L, (PRECTL)aptlUpdt);

  aptlUpdt[2] = aptlUpdt[0];
  DoDraw( hpsBitmapBuff, hrgnUpdtDrag, TRUE);
  if (GpiDestroyRegion( hpsClient, hrgnUpdt) == GPI_ERROR)
      DispError(habMain,hwndClient);
  if (GpiDestroyRegion( hpsBitmapBuff, hrgnUpdtDrag) == GPI_ERROR)
      DispError(habMain,hwndClient);
  if (GpiBitBlt( hpsBitmapSave
	       , hpsBitmapBuff
	       , 3L
	       , aptlUpdt
	       , ROP_SRCCOPY
	       , BBO_IGNORE ) == GPI_ERROR)
      DispError(habMain,hwndClient);

  /****************************************************************************/
  for( psl = pslPicked, fFirst = TRUE
     ; (psl != pslPicked) || fFirst
     ; psl = psl->pslNextIsland, fFirst = FALSE )
  {
    psl->fVisible = TRUE;
    DrawPiece( hpsBitmapBuff, psl, TRUE);
  }
  if (GpiBitBlt( hpsClient
	   , hpsBitmapBuff
	   , 3L
	   , aptlUpdt
	   , ROP_SRCCOPY
	   , BBO_IGNORE ) ==  GPI_ERROR)
      DispError(habMain,hwndClient);
  WinSetCapture( HWND_DESKTOP, hwndClient);
}




/******************************************************************************/
/*									      */
/* move the segment							      */
/*									      */
/******************************************************************************/
VOID MouseMove( mp)
MPARAM mp;
{
  RECTL	    rcl;
  POINTL    ptl, ptlModel, ptlDevice;
  POINTL    aptlUpdtRef[3], aptlUpdtNew[3];
  PSEGLIST  psl;
  BOOL	    fFirst;

  ptl.x = (LONG)(SHORT)SHORT1FROMMP( mp);
  ptl.y = (LONG)(SHORT)SHORT2FROMMP( mp);

  /****************************************************************************/
  /* clip mouse coords to client window					      */
  /****************************************************************************/
  WinQueryWindowRect( hwndClient, &rcl);
  if (rcl.xLeft > ptl.x)
    ptl.x = rcl.xLeft;
  if (rcl.xRight <= ptl.x)
    ptl.x = rcl.xRight;
  if (rcl.yBottom > ptl.y)
    ptl.y = rcl.yBottom;
  if (rcl.yTop <= ptl.y)
    ptl.y = rcl.yTop;
  ptlMouse = ptl;

  if( !lPickedSeg || !pslPicked || !fButtonDownAsync)
    return;

  ptlModel = ptl;
  if (GpiConvert( hpsClient, CVTC_DEVICE, CVTC_MODEL, 1L, &ptlModel) == GPI_ERROR)
      DispError(habMain,hwndClient);
  ptlModel.x = 50 * (ptlModel.x / 50);
  ptlModel.y = 50 * (ptlModel.y / 50);
  if( (ptlModel.x == ptlOldMouse.x) && (ptlModel.y == ptlOldMouse.y))
    return;
  ptlOldMouse.x = ptlModel.x;
  ptlOldMouse.y = ptlModel.y;
  ptlDevice = ptlModel;
  if (GpiConvert( hpsClient, CVTC_MODEL, CVTC_DEVICE, 1L, &ptlDevice) == GPI_ERROR)
      DispError(habMain,hwndClient);

  if (GpiBitBlt( hpsBitmapBuff
	   , hpsBitmapSave
	   , 3L
	   , aptlUpdt
	   , ROP_SRCCOPY
	   , BBO_IGNORE ) == GPI_ERROR)
      DispError(habMain,hwndClient);
  aptlUpdtRef[0] = aptlUpdt[0];
  aptlUpdtRef[1] = aptlUpdt[1];

  aptlUpdt[0].x += ptlDevice.x - ptlUpdtRef.x;
  aptlUpdt[0].y += ptlDevice.y - ptlUpdtRef.y;
  aptlUpdt[1].x += ptlDevice.x - ptlUpdtRef.x;
  aptlUpdt[1].y += ptlDevice.y - ptlUpdtRef.y;
  WinMapWindowPoints( hwndClient, HWND_DESKTOP, aptlUpdt, 3);
  ROUND_DOWN_MOD( aptlUpdt[0].x, lByteAlignX);		  /* round down	      */
  ROUND_DOWN_MOD( aptlUpdt[0].y, lByteAlignY);		  /* round down	      */
  ROUND_UP_MOD(	  aptlUpdt[1].x, lByteAlignX);		  /* round up	      */
  ROUND_UP_MOD(	  aptlUpdt[1].y, lByteAlignY);		  /* round up	      */
  WinMapWindowPoints( HWND_DESKTOP, hwndClient, aptlUpdt, 3);
  aptlUpdt[2] = aptlUpdt[0];
  ptlUpdtRef = ptlDevice;
  if (GpiBitBlt( hpsBitmapSave
	       , hpsBitmapBuff
	       , 3L
	       , aptlUpdt
	       , ROP_SRCCOPY
	       , BBO_IGNORE ) == GPI_ERROR)
      DispError(habMain,hwndClient);


  pslPicked->ptlModelXlate.x = ptlOffStart.x + ptlModel.x - ptlMoveStart.x;
  pslPicked->ptlModelXlate.y = ptlOffStart.y + ptlModel.y - ptlMoveStart.y;

  for( psl = pslPicked, fFirst = TRUE
     ; (psl != pslPicked) || fFirst
     ; psl = psl->pslNextIsland, fFirst = FALSE )
  {
    psl->ptlModelXlate = pslPicked->ptlModelXlate;
    DrawPiece( hpsBitmapBuff, psl, TRUE);
  }

  WinUnionRect( habMain
	      , (PRECTL)aptlUpdtNew
	      , (PRECTL)aptlUpdt
	      , (PRECTL)aptlUpdtRef);
  WinMapWindowPoints( hwndClient, HWND_DESKTOP, aptlUpdtNew, 2);
  ROUND_DOWN_MOD( aptlUpdtNew[0].x, lByteAlignX);	  /* round down	      */
  ROUND_DOWN_MOD( aptlUpdtNew[0].y, lByteAlignY);	  /* round down	      */
  ROUND_UP_MOD(	  aptlUpdtNew[1].x, lByteAlignX);	  /* round up	      */
  ROUND_UP_MOD(	  aptlUpdtNew[1].y, lByteAlignY);	  /* round up	      */
  WinMapWindowPoints( HWND_DESKTOP, hwndClient, aptlUpdtNew, 2);
  aptlUpdtNew[2] = aptlUpdtNew[0];
  if (GpiBitBlt( hpsClient
	       , hpsBitmapBuff
	       , 3L
	       , aptlUpdtNew
	       , ROP_SRCCOPY
	       , BBO_IGNORE ) == GPI_ERROR)
      DispError(habMain,hwndClient);
}


/******************************************************************************/
/*															   */
/* The dragged segment is being unselected.  Return it to its normal state.   */
/*															   */
/******************************************************************************/
VOID LeftUp(VOID)
{
  PSEGLIST   psl, pslTemp;
  POINTL     ptlShift;
  BOOL	     fFirst;
  LONG	     l;

  if (!BmpLoaded)
    {
	   MessageBox(hwndFrame, IDS_LOADBITMAP, MB_OK | MB_INFORMATION, TRUE);
      return;
    }
  else if(fPictureAssembled)
    {
	   MessageBox(hwndFrame, IDS_OPTIONJUMBLE, MB_OK | MB_INFORMATION, TRUE);
      return;
    }

  if( !lPickedSeg || !pslPicked)
    return;

  for( psl = pslPicked, fFirst = TRUE
     ; (psl != pslPicked) || fFirst
     ; psl = psl->pslNextIsland, fFirst = FALSE )
  {

    SetRect( psl);
    SegListUpdate( MAKE_TAIL_SEG, psl);	      /* at tail => highest priority  */
    psl->fIslandMark = TRUE;		      /* mark as island member	      */
  }
  ptlShift = pslPicked->ptlModelXlate;

  for( psl = pslHead; psl != NULL; psl = psl->pslNext)
    if( !psl->fIslandMark)
      for( l = 0; l < 8; l++)
	if( pslPicked->lAdjacent[l] == psl->lSegId)
	  if(	(ptlShift.x == psl->ptlModelXlate.x)
	     && (ptlShift.y == psl->ptlModelXlate.y))
	  {
	    DosBeep( 600, 100);
	    DosBeep( 1200, 50);
	    MarkIsland( psl, TRUE);	      /* mark the whole new island    */
	    pslTemp = psl->pslNextIsland;     /* swap island ptrs	      */
	    psl->pslNextIsland = pslPicked->pslNextIsland;
	    pslPicked->pslNextIsland = pslTemp;
	  }
  MarkIsland( pslPicked, FALSE);	      /* unmark the island	      */

  pslPicked = NULL;
  lPickedSeg = 0;

  WinSetCapture( HWND_DESKTOP, (HWND)NULL);
}


/******************************************************************************/
/*														      */
/* DoHorzScroll will horizontally scroll the current contents of		    */
/* the client area and redraw the invalidated area					     */
/*															   */
/******************************************************************************/
VOID DoHorzScroll(VOID)
{
  POINTL    aptlClient[3];
  HRGN	    hrgn;
  MATRIXLF  matlf;

  if( ptsScrollPos.x > ptsScrollMax.x)	   /* clip to range of scroll param   */
      ptsScrollPos.x = ptsScrollMax.x;
  if( ptsScrollPos.x < 0)
      ptsScrollPos.x = 0;

  if( ptsOldScrollPos.x != ptsScrollPos.x) /* only process change in position */
      WinSendMsg( hwndHorzScroll
		, SBM_SETPOS
		, MPFROM2SHORT( ptsScrollPos.x, 0)
		, MPFROMLONG( NULL));

  /****************************************************************************/
  /* Scroll the window the reqd amount, using bitblt'ing (ScrollWindow)       */
  /* if any of the screen still in view, and paint into uncovered region;     */
  /* else repaint the whole client area.				      */
  /****************************************************************************/
  hrgn = GpiCreateRegion( hpsClient, 0L, NULL);
  WinQueryWindowRect( hwndClient, (PRECTL)aptlClient);
  if( abs( ptsScrollPos.x - ptsOldScrollPos.x) <= ptsScrollMax.x)
  {
      WinScrollWindow( hwndClient
		     , (SHORT) (ptsOldScrollPos.x - ptsScrollPos.x)
		     , (SHORT) 0
		     , (PRECTL) NULL
		     , (PRECTL) NULL
		     , (HRGN) hrgn
		     , (PRECTL) NULL
		     , 0);
  } else
  {
      if (GpiSetRegion( hpsClient, hrgn, 1L, (PRECTL)aptlClient) == GPI_ERROR)
	  DispError(habMain,hwndClient);
  }
  /****************************************************************************/
  /* adjust the default view matrix					      */
  /****************************************************************************/
  if (GpiQueryDefaultViewMatrix( hpsClient, 9L, &matlf ) == GPI_ERROR)
      DispError(habMain,hwndClient);
  matlf.lM31 -= ptsScrollPos.x - ptsOldScrollPos.x;
  if (GpiSetDefaultViewMatrix( hpsClient, 9L, &matlf, TRANSFORM_REPLACE) == GPI_ERROR)
      DispError(habMain,hwndClient);

  DoDraw( hpsClient, hrgn, TRUE);     /* paint into the client area	      */
  ptsOldScrollPos.x = ptsScrollPos.x;
  if (GpiDestroyRegion( hpsClient, hrgn) == GPI_ERROR)
      DispError(habMain,hwndClient);

  aptlClient[2] = aptlClient[0];
  if (!fFirstLoad)		    /* don't bother if no bitmap was read in */
  {
     if (GpiBitBlt( hpsBitmapBuff      /* update the off-screen client image */
		  , hpsClient
		  , 3L
		  , aptlClient
		  , ROP_SRCCOPY
		  , BBO_IGNORE ) == GPI_ERROR)
	 DispError(habMain,hwndClient);
  }   /* end if () */
}

/******************************************************************************/
/*									      */
/* DoVertScroll will vertically scroll the current contents of		      */
/* the client area and redraw the invalidated area			      */
/*									      */
/******************************************************************************/
VOID DoVertScroll(VOID)
{
  POINTL    aptlClient[3];
  HRGN	    hrgn;
  MATRIXLF  matlf;

  if( ptsScrollPos.y > ptsScrollMax.y)
      ptsScrollPos.y = ptsScrollMax.y;
  if( ptsScrollPos.y < 0)
      ptsScrollPos.y = 0;

  if( ptsOldScrollPos.y != ptsScrollPos.y)
      WinSendMsg( hwndVertScroll
		, SBM_SETPOS
		, MPFROM2SHORT( ptsScrollPos.y, 0)
		, MPFROMLONG( NULL));

  /****************************************************************************/
  /* Scroll the window the reqd amount, using bitblt'ing (ScrollWindow)       */
  /* if any of the screen still in view, and paint into uncovered region;     */
  /* else repaint the whole client area.				      */
  /****************************************************************************/
  hrgn = GpiCreateRegion( hpsClient, 0L, NULL);
  WinQueryWindowRect( hwndClient, (PRECTL)aptlClient);
  if( abs( ptsScrollPos.y - ptsOldScrollPos.y) <= ptsScrollMax.y)
  {
      WinScrollWindow( hwndClient
		     , 0
		     , (SHORT) (ptsScrollPos.y - ptsOldScrollPos.y)
		     , (PRECTL) NULL
		     , (PRECTL) NULL
		     , (HRGN) hrgn
		     , (PRECTL) NULL
		     , 0);
  } else
  {
      if (GpiSetRegion( hpsClient, hrgn, 1L, (PRECTL)aptlClient) == GPI_ERROR)
	  DispError(habMain,hwndClient);
  }
  if (GpiQueryDefaultViewMatrix( hpsClient, 9L, &matlf ) == GPI_ERROR)
      DispError(habMain,hwndClient);
  matlf.lM32 += ptsScrollPos.y - ptsOldScrollPos.y;
  if (GpiSetDefaultViewMatrix( hpsClient, 9L, &matlf, TRANSFORM_REPLACE) == GPI_ERROR)
      DispError(habMain,hwndClient);

  DoDraw( hpsClient, hrgn, TRUE);
  ptsOldScrollPos.y = ptsScrollPos.y;
  if (GpiDestroyRegion( hpsClient, hrgn) == GPI_ERROR)
      DispError(habMain,hwndClient);

  aptlClient[2] = aptlClient[0];
  if (!fFirstLoad)		    /* don't bother if no bitmap was read in */
  {
     if (GpiBitBlt( hpsBitmapBuff
		  , hpsClient
		  , 3L
		  , aptlClient
		  , ROP_SRCCOPY
		  , BBO_IGNORE ) == GPI_ERROR)
	 DispError(habMain,hwndClient);
  }
}

/******************************************************************************
*
*  Name	       : EnableMenu
*
*  Description : Enable/Disable bitmap size submenus
*
*  Parameters  : ULONG id	 - menu id (ASSUME: id = submenu of FID_MAIN
*		 BOOL  fEnable	 - enable/disable?
*
*  Return      : VOID
*
******************************************************************************/

VOID EnableMenu(ULONG id, BOOL fEnable)
{
    WinSendMsg(hwndMenu,			  /* global main menu handle */
       MM_SETITEMATTR,				       /* set menu attribute */
       MPFROM2SHORT(id, TRUE),					  /* menu id */
       MPFROM2SHORT(MIA_DISABLED,		       /* mask = disable bit */
		    fEnable ? ~MIA_DISABLED : MIA_DISABLED)); /* turn off/on */

}   /* end EnableMenu() */

/******************************************************************************
*
*  Name	       : CheckMenu
*
*  Description : Check/Uncheck bitmap size submenus
*
*  Parameters  : ULONG id	- menu id  (ASSUME: id = submenu of FID_MAIN
*		 BOOL  fCheck	- check/unckeck?
*
*  Return      : VOID
*
******************************************************************************/

VOID CheckMenu(ULONG id, BOOL fCheck)
{
    WinSendMsg(hwndMenu,			  /* global main menu handle */
       MM_SETITEMATTR,				       /* set menu attribute */
       MPFROM2SHORT(id, TRUE),					  /* menu id */
       MPFROM2SHORT(MIA_CHECKED,			 /* mask = check bit */
		    fCheck ? MIA_CHECKED : ~MIA_CHECKED));    /* turn on/off */

}   /* end CheckMenu() */


/******************************************************************************/
/*															   */
/* adjust zoom factor and recalc the picture transform, then do a redraw of   */
/* whole screen													  */
/*														 */
/******************************************************************************/
VOID Zoom( VOID )
{
  ULONG	 ulPostKillDraw, ulPostCt;

  DosQueryEventSem(hevKillDraw, &ulPostKillDraw);

  CalcBounds();
  DosQueryEventSem(hevKillDraw, &ulPostCt);
  if (ulPostKillDraw != ulPostCt)
  {
     DosResetEventSem(hevKillDraw, &ulPostCt);
     return;
  }
  CalcTransform( hwndClient);
  DosQueryEventSem(hevKillDraw, &ulPostCt);
  if (ulPostKillDraw != ulPostCt)
  {
     DosResetEventSem(hevKillDraw, &ulPostCt);
     return;
  }
  Redraw();
}

/******************************************************************************/
/*									      */
/* Check the segment list for obvious errors.				      */
/*									      */
/******************************************************************************/
BOOL SegListCheck(INT iLoc)
{
  PSEGLIST   psl;
  CHAR	     szMsg[50];

  szMsg[0] = '\0';
  for( psl = pslHead; psl != NULL; psl = psl->pslNext)
    if( (psl->lSegId < 1) || (psl->lSegId > lLastSegId) )
    {
      #if defined(DEBUG)

	 sprintf( szMsg, "Bad head segment list, location %d", iLoc);
	 WinMessageBox(HWND_DESKTOP, hwndFrame, szMsg, szErrorTitle, 0,
			MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL);
      #endif

      return( FALSE);
    }
  for( psl = pslTail; psl != NULL; psl = psl->pslPrev)
    if( (psl->lSegId < 1) || (psl->lSegId > lLastSegId) )
    {
      #if defined(DEBUG)

	 sprintf( szMsg, "Bad head segment list, location %d", iLoc);
	 WinMessageBox(HWND_DESKTOP, hwndFrame, szMsg, szErrorTitle, 0,
			MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL);
      #endif

      return( FALSE);
    }
  return( TRUE);
}

/******************************************************************************/
/*									      */
/* DumpPicture will free the list and segment store for the picture	      */
/*									      */
/******************************************************************************/
BOOL DumpPicture(VOID)
{
  while( pslHead != NULL )
  {
    if (GpiSetBitmap( pslHead->hpsFill, NULLHANDLE) == (HBITMAP)BMB_ERROR)
	DispError(habMain,hwndClient);
    if (GpiDeleteBitmap( pslHead->hbmFill) == GPI_ERROR)
	DispError(habMain,hwndClient);
    if (GpiDestroyPS( pslHead->hpsFill) == GPI_ERROR)
	DispError(habMain,hwndClient);
    DevCloseDC( pslHead->hdcFill);

    if (GpiSetBitmap( pslHead->hpsHole, NULLHANDLE) == (HBITMAP)BMB_ERROR)
	DispError(habMain,hwndClient);
    if (GpiDeleteBitmap( pslHead->hbmHole) == GPI_ERROR)
	DispError(habMain,hwndClient);
    if (GpiDestroyPS( pslHead->hpsHole) == GPI_ERROR)
	DispError(habMain,hwndClient);
    DevCloseDC( pslHead->hdcHole);

    SegListUpdate( DEL_SEG, pslHead);
  }

  if( hbmBitmapSize)
  {
      if (GpiSetBitmap( hpsBitmapSize, NULLHANDLE) == (HBITMAP)BMB_ERROR)
	  DispError(habMain,hwndClient);
      if (GpiDeleteBitmap( hbmBitmapSize) == GPI_ERROR)
	  DispError(habMain,hwndClient);
  }
  if( hbmBitmapBuff)
  {
      if (GpiSetBitmap( hpsBitmapBuff, NULLHANDLE) == (HBITMAP)BMB_ERROR)
	  DispError(habMain,hwndClient);
      if (GpiDeleteBitmap( hbmBitmapBuff) == GPI_ERROR)
	  DispError(habMain,hwndClient);
  }
  if( hbmBitmapSave)
  {
      if (GpiSetBitmap( hpsBitmapSave, NULLHANDLE) == (HBITMAP)BMB_ERROR)
	  DispError(habMain,hwndClient);
      if (GpiDeleteBitmap( hbmBitmapSave) == GPI_ERROR)
	  DispError(habMain,hwndClient);
  }

  return( TRUE);
}

/******************************************************************************/
/*									      */
/* Draw the picture into segment store.					      */
/*									      */
/******************************************************************************/
BOOL CreatePicture(SHORT sUpdate)
{
  POINTL	     ptl, aptlSides[12], aptlControl[12];
  SEGLIST	     sl;
  PSEGLIST	     psl;
  LONG		     l, lMinor, lNeighbor, alFuzz[36][4];
  SIZEL		     sizl;
  BITMAPINFOHEADER2  bmp2;
  PBITMAPINFOHEADER2 pbmp2 = &bmp2;
  DATETIME	     date;
  ULONG		     ulPostCt;

  /****************************************************************************/
  /* compute some fuzz for the control points				      */
  /****************************************************************************/
  DosGetDateTime( &date);
  srand( (USHORT)date.hundredths);
  for( l = 0; l < 36; l++)
    for( lMinor = 0; lMinor < 4; lMinor++)
      alFuzz[l][lMinor] = 50 * (rand() % 10);

  /****************************************************************************/
  /* reset the default viewing transform to identity			      */
  /****************************************************************************/
  SetDVTransform( (FIXED)UNITY
		, (FIXED)0
		, (FIXED)0
		, (FIXED)UNITY
		, 0L
		, 0L
		, TRANSFORM_REPLACE);

  /****************************************************************************/
  /* draw the pieces							      */
  /****************************************************************************/
  lLastSegId = 0;
  for( ptl.x = ptlBotLeft.x; ptl.x < ptlTopRight.x; ptl.x += 500)
  {
    DosQueryEventSem( hevTerminate, &ulPostCt);
    if( ulPostCt)
      break;
    for( ptl.y = ptlBotLeft.y; ptl.y < ptlTopRight.y; ptl.y += 500)
    {
      DosQueryEventSem( hevTerminate, &ulPostCt);
      if( ulPostCt)
	      break;
      lLastSegId++;

      /************************************************************************/
      /* compute the piece outline control points			      */
      /************************************************************************/
      aptlControl[0].x = 250L;
      aptlControl[0].y = 500L;
      aptlControl[1].x = 250;
      aptlControl[1].y = -500L;
      aptlControl[2].x = 500L;
      aptlControl[2].y = 0L;

      aptlControl[3].x = 0L;
      aptlControl[3].y = 250L;
      aptlControl[4].x = 1000L;
      aptlControl[4].y = 250L;
      aptlControl[5].x = 500L;
      aptlControl[5].y = 500L;

      aptlControl[6].x = 250L;
      aptlControl[6].y = 0L;
      aptlControl[7].x = 250L;
      aptlControl[7].y = 1000L;
      aptlControl[8].x = 0L;
      aptlControl[8].y = 500L;

      aptlControl[9].x	= 500L;
      aptlControl[9].y	= 250L;
      aptlControl[10].x = -500L;
      aptlControl[10].y = 250L;
      aptlControl[11].x = 0L;
      aptlControl[11].y = 0L;

      if( ptl.y == ptlBotLeft.y)
      {
	      aptlControl[0].y = 0L;
	      aptlControl[1].y = 0L;
      }

      if( (ptl.x + 500) == ptlTopRight.x)
      {
	aptlControl[3].x = 500L;
	      aptlControl[4].x = 500L;
      }

      if( (ptl.y + 500) == ptlTopRight.y)
      {
	      aptlControl[6].y = 500L;
	aptlControl[7].y = 500L;
      }

      if( ptl.x == ptlBotLeft.x)
      {
	      aptlControl[ 9].x = 0L;
	      aptlControl[10].x = 0L;
      }

      /************************************************************************/
      /* compute the adjacent segments					      */
      /************************************************************************/
      sl.lAdjacent[0] = lLastSegId - 7;
      sl.lAdjacent[1] = lLastSegId - 6;
      sl.lAdjacent[2] = lLastSegId - 5;
      sl.lAdjacent[3] = lLastSegId - 1;
      sl.lAdjacent[4] = lLastSegId + 1;
      sl.lAdjacent[5] = lLastSegId + 5;
      sl.lAdjacent[6] = lLastSegId + 6;
      sl.lAdjacent[7] = lLastSegId + 7;
      if( ptl.x == ptlBotLeft.x)
      {
	      sl.lAdjacent[0] = 0;
	      sl.lAdjacent[1] = 0;
	      sl.lAdjacent[2] = 0;
      }
      if( ptl.y == ptlBotLeft.y)
      {
	      sl.lAdjacent[0] = 0;
	      sl.lAdjacent[3] = 0;
	      sl.lAdjacent[5] = 0;
      }
      if( (ptl.x + 500) == ptlTopRight.x)
      {
	      sl.lAdjacent[5] = 0;
	      sl.lAdjacent[6] = 0;
	      sl.lAdjacent[7] = 0;
      }
      if( (ptl.y + 500) == ptlTopRight.y)
      {
	      sl.lAdjacent[2] = 0;
	      sl.lAdjacent[4] = 0;
	      sl.lAdjacent[7] = 0;
      }

      /************************************************************************/
      /* throw in some fuzz						      */
      /************************************************************************/
      if( sl.lAdjacent[3])
      {
	      aptlControl[0].y	-= alFuzz[lLastSegId - 1][0];
	      aptlControl[1].y	+= alFuzz[lLastSegId - 1][1];
      }

      if( sl.lAdjacent[1])
      {
	aptlControl[9].x  -= alFuzz[lLastSegId - 1][2];
	      aptlControl[10].x += alFuzz[lLastSegId - 1][3];
      }

      if( lNeighbor = sl.lAdjacent[4])
      {
	aptlControl[7].y  -= alFuzz[lNeighbor - 1][0];
	      aptlControl[6].y	+= alFuzz[lNeighbor - 1][1];
      }

      if( lNeighbor = sl.lAdjacent[6])
      {
	      aptlControl[4].x	-= alFuzz[lNeighbor - 1][2];
	      aptlControl[3].x	+= alFuzz[lNeighbor - 1][3];
      }

      /************************************************************************/
      /* compute the piece control points in world coordinates		      */
      /************************************************************************/
      for( l=0; l<12; l++)
      {
	      aptlSides[l].x = ptl.x + aptlControl[l].x;
	      aptlSides[l].y = ptl.y + aptlControl[l].y;
	      sl.aptlSides[l] = aptlSides[l];
      }

      /************************************************************************/
      /* compute the dimensions of the matching rects for BitBlt	      */
      /************************************************************************/
      sl.rclBitBlt.xLeft   = ptl.x - 250;
      sl.rclBitBlt.yBottom = ptl.y - 250;
      sl.rclBitBlt.xRight  = ptl.x + 750;
      sl.rclBitBlt.yTop	   = ptl.y + 750;
      if( ptl.x == ptlBotLeft.x)
	      sl.rclBitBlt.xLeft += 250;
      if( ptl.y == ptlBotLeft.y)
	      sl.rclBitBlt.yBottom += 250;
      if( (ptl.x + 500) == ptlTopRight.x)
	sl.rclBitBlt.xRight -= 250;
      if( (ptl.y + 500) == ptlTopRight.y)
	      sl.rclBitBlt.yTop -= 250;

      /************************************************************************/
      /* store the piece location					      */
      /************************************************************************/
      sl.ptlLocation = ptl;

      /************************************************************************/
      /* create the masks						      */
      /************************************************************************/
      if( sUpdate == PICTURE_CREATE)
      {
	      bmp2	= bmp2BitmapFile;
      if (bmp2.cbFix  == sizeof(BITMAPINFOHEADER))
	 {
	      sizl.cx = 2 +  ((PBITMAPINFOHEADER)pbmp2BitmapFile)->cx
		       * (sl.rclBitBlt.xRight - sl.rclBitBlt.xLeft)
		       / (ptlTopRight.x - ptlBotLeft.x);
	      sizl.cy = 2 +  ((PBITMAPINFOHEADER)pbmp2BitmapFile)->cy
		       * (sl.rclBitBlt.yTop - sl.rclBitBlt.yBottom)
		       / (ptlTopRight.y - ptlBotLeft.y);
	    ((PBITMAPINFOHEADER)pbmp2)->cx = LOUSHORT( sizl.cx);
	    ((PBITMAPINFOHEADER)pbmp2)->cy = LOUSHORT( sizl.cy);
	 }
      else
	 {
	      sizl.cx = 2 + ((pbmp2BitmapFile->cx
		       * (sl.rclBitBlt.xRight - sl.rclBitBlt.xLeft))
		       / (ptlTopRight.x - ptlBotLeft.x));
	      sizl.cy = 2 + ((pbmp2BitmapFile->cy
		       * (sl.rclBitBlt.yTop - sl.rclBitBlt.yBottom))
		       / (ptlTopRight.y - ptlBotLeft.y));
	     (pbmp2)->cx = LOUSHORT( sizl.cx);
	     (pbmp2)->cy = LOUSHORT( sizl.cy);
	}

	      if ((sl.hdcHole = DevOpenDC( habMain
			      , OD_MEMORY
			      , "*"
			      , 3L
			      , (PDEVOPENDATA)&dop
			      , NULLHANDLE)) == DEV_ERROR)
		 DispError(habMain,hwndClient);
	      if ((sl.hpsHole = GpiCreatePS( habMain
				, sl.hdcHole
				, &sizl
				, PU_PELS | GPIA_ASSOC | GPIT_MICRO )) == GPI_ERROR)
		 DispError(habMain,hwndClient);

	      if ((sl.hbmHole = GpiCreateBitmap( sl.hpsHole
				    , pbmp2
				    , 0L
				    , NULL
				    , NULL)) == (HBITMAP)GPI_ERROR)
		 DispError(habMain,hwndClient);


	      if ((GpiSetBitmap( sl.hpsHole, sl.hbmHole)) == (HBITMAP)BMB_ERROR)
		 DispError(habMain,hwndClient);


	      if ((sl.hdcFill = DevOpenDC( habMain
			      , OD_MEMORY
			      , "*"
			      , 3L
			      , (PDEVOPENDATA)&dop
			      , NULLHANDLE)) == DEV_ERROR)
		 DispError(habMain,hwndClient);
	      if ((sl.hpsFill = GpiCreatePS( habMain
				, sl.hdcFill
				, &sizl
				, PU_PELS | GPIA_ASSOC | GPIT_MICRO )) == GPI_ERROR)
		 DispError(habMain,hwndClient);
	      if ((sl.hbmFill = GpiCreateBitmap( sl.hpsFill
				    , pbmp2
				    , 0L
				    , NULL
				    , NULL)) == (HBITMAP)GPI_ERROR)
		 DispError(habMain,hwndClient);

	      if ((GpiSetBitmap( sl.hpsFill, sl.hbmFill)) == (HBITMAP)BMB_ERROR)
		 DispError(habMain,hwndClient);
      }


      sl.fVisible	 = TRUE;
      sl.lSegId		 = lLastSegId;
      sl.fIslandMark	 = FALSE;
      sl.ptlModelXlate.x = sl.ptlModelXlate.y = 0L;
      if( sUpdate == PICTURE_CREATE)
      {
	      sl.pslNext	   = NULL;
	      sl.pslPrev	   = NULL;
	      SetRect( &sl);
	      psl = SegListUpdate( ADD_TAIL_SEG, &sl);
       } else
       {
	      psl = SegListGet( lLastSegId);
	      psl->fIslandMark = FALSE;
	      for( l=0; l<12; l++)
		psl->aptlSides[l] = aptlSides[l];
	      psl->ptlModelXlate = sl.ptlModelXlate;
	      SetRect( psl);
       }
       psl->pslNextIsland = psl;	/* point to self ==> island of one    */
    }
  }
  if( ulPostCt)
      SendCommand( UM_DIE, (MPARAM)NULL, (MPARAM)NULL);

  return( TRUE);
}

/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
VOID CheckPsl( psl)
PSEGLIST  psl;
{
  SHORT	  s;

  for( s=2; s<12; s+=3)
    if( !WinPtInRect( habAsync, &psl->rclBitBlt, &psl->aptlSides[s]))
      break;
}

/******************************************************************************/
/*									      */
/* Create the Size, Save and Buff bitmaps.				      */
/*									      */
/******************************************************************************/
BOOL PrepareBitmap(VOID)
{
  hbmBitmapSize	   = GpiCreateBitmap( hpsBitmapSize
				    , pbmp2BitmapFile
				    , 0L
				    , NULL
				    , NULL);
  if( !hbmBitmapSize)
    {
    DispError(habMain,hwndClient);
    return( FALSE);
    }
  if (GpiSetBitmap( hpsBitmapSize, hbmBitmapSize) == (HBITMAP)BMB_ERROR)
     DispError(habMain,hwndClient);

  bmp2BitmapSave    = bmp2BitmapFile;
  if (pbmp2BitmapSave->cbFix  == sizeof(BITMAPINFOHEADER))
      {
      ((PBITMAPINFOHEADER)pbmp2BitmapSave)->cx = LOUSHORT( sizlMaxClient.cx);
      ((PBITMAPINFOHEADER)pbmp2BitmapSave)->cy = LOUSHORT( sizlMaxClient.cy);
      }
  else
      {
      (pbmp2BitmapSave)->cx = LOUSHORT(sizlMaxClient.cx);
      (pbmp2BitmapSave)->cy = LOUSHORT(sizlMaxClient.cy);
      }
  hbmBitmapSave	    = GpiCreateBitmap( hpsBitmapSave
				    , pbmp2BitmapSave
				    , 0L
				    , NULL
				    , NULL);
  if( !hbmBitmapSave)
    {
     DispError(habMain,hwndClient);
     return( FALSE);
    }
  if (GpiSetBitmap( hpsBitmapSave, hbmBitmapSave) == (HBITMAP)BMB_ERROR)
     DispError(habMain,hwndClient);


  hbmBitmapBuff	    = GpiCreateBitmap( hpsBitmapBuff
				    , pbmp2BitmapSave
				    , 0L
				    , NULL
				    , NULL);
  if( !hbmBitmapBuff)
    {
    DispError(habMain,hwndClient);
    return( FALSE);
    }
  if (GpiSetBitmap( hpsBitmapBuff, hbmBitmapBuff) == (HBITMAP)BMB_ERROR)
    DispError(habMain,hwndClient);

  return( TRUE);
}

/******************************************************************************
*
*  Name	       : ReadBitmap
*
*  Description :
*
* Get the bitmap from disk.
* Note that there are 2 formats for bitmap files, one of which is archaic.
* Both formats are supported here.  All new bitmaps should follow the format
* in BITMAPFILEHEADER.
*
*  Concepts    :
*
*  API's       :
*
*  Parameters  : HFILE hfile
*
*  Return      : BOOL
*
*  Notes:
*
*   File Layout - size and layout of following map are dependent on the
*   type of bitmap.  The cbFix field of the structures is used to determine
*   the size of the structures which in turn identifies them.
*
*
*	    SINGLE BITMAP FILE FORMAT
*
*   Ŀ offset 0
*     Bitmap File Header	      (bfh2)   pbfh2->offBits contains data Ŀ
*   					       offset (from begin of file)   
*   Ĵ				      
*     Bitmap Information Header      (bmp2)  				      
*   Ĵ				      
*     Color Table of RGB Structures  (argb2) 				      
*   Ĵ <
*     Bitmap Data (scan lines)		      
*   		  .			      
*   		  .			      
*   		  .			      
*   
*
*
*	  BITMAP-ARRAY FILE FORMAT
*
*   Ŀ offset 0
*     Bitmap Array File Header	      (baf2)  
*     (only for bitmap arrays)		      
*   Ĵ
*     Bitmap File Header	      (bfh2)   pbfh2->offBits contains data Ŀ
*   					       offset (from begin of file)   
*   Ĵ				      
*     Bitmap Information Header      (bmp2)  				      
*   Ĵ				      
*     Color Table of RGB Structures  (argb2) 				      
*   Ĵ				      
*   	  next Bitmap Array File Header	      				      
*   		  .			      				      
*   		  .			      				      
*   		  .			      				      
*   Ĵ <
*     1st Bitmap Data (scan lines)	      
*   					      
*   					      
*   Ĵ
*   	  next Bitmap Data (scan lines)	      
*   		  .			      
*   		  .			      
*   		  .			      
*   
*
******************************************************************************/

BOOL ReadBitmap(HFILE hfile)
{
   APIRET     rc;					  /* API return code */
   BOOL	      fRet = FALSE;			    /* Function return code. */
   FILESTATUS fsts;
   PBITMAPFILEHEADER2 pbfh2;		       /* can address any file types */
   PBITMAPINFOHEADER2 pbmp2;			 /* address any info headers */
   PBYTE  pFileBegin = NULL;		    /* beginning of bitmap file data */
   ULONG  cbRead;			 /* Number of bytes read by DosRead. */
   ULONG  cScans, cScansRet;	      /* number of scan lines in bitmap (cy) */

   /*
    *	Use Loop to avoid duplicate cleanup code.  If any errors, a break
    *	statement will jump directly to error cleanup code.
    */

   do
   {
      /*
       *   Find out how big the file is, allocate that much memory, and read
       *   in the entire bitmap.
       */

      rc =
      DosQueryFileInfo(hfile, 1, &fsts, sizeof(fsts));
      if (rc)
	 break;			       /* jump to error code outside of loop */

      rc =
      DosAllocMem(
	 (PPVOID) &pFileBegin,
	 (ULONG)  fsts.cbFile,
	 (ULONG)  PAG_READ | PAG_WRITE | PAG_COMMIT);

      if (rc)
	 break;			       /* jump to error code outside of loop */

      if (DosRead( hfile, (PVOID)pFileBegin, fsts.cbFile, &cbRead))
	 break;			       /* jump to error code outside of loop */

      /*
       *   If it's a bitmap-array, point to common file header.  Otherwise,
       *   point to beginning of file.
       */

      pbfh2 = (PBITMAPFILEHEADER2) pFileBegin;
      pbmp2 = NULL;		      /* only set this when we validate type */

      switch (pbfh2->usType)
      {
	 case BFT_BITMAPARRAY:

	    /*
	     *	 If this is a Bitmap-Array, adjust pointer to the normal
	     *	 file header.  We'll just use the first bitmap in the
	     *	 array and ignore other device forms.
	     */

	    pbfh2 = &(((PBITMAPARRAYFILEHEADER2) pFileBegin)->bfh2);
	    pbmp2 = &pbfh2->bmp2;    /* pointer to info header (readability) */
	    break;

	 case BFT_BMAP:

	    pbmp2 = &pbfh2->bmp2;    /* pointer to info header (readability) */
	    break;

	 default:      /* these formats aren't supported; don't set any ptrs */
	 case BFT_ICON:
	 case BFT_POINTER:
	 case BFT_COLORICON:
	 case BFT_COLORPOINTER:

	    break;

      }	  /* end switch (pbfh2->usType) */

      if (pbmp2 == NULL)
	 break;	       /* File format NOT SUPPORTED: break out to error code */

      /*
       *   Check to see if BMP file has an old structure, a new structure, or
       *   Windows structure.  Capture the common data and treat all bitmaps
       *   generically with pointer to new format.  API's will determine format
       *   using cbFixed field.
       *
       *   Windows bitmaps have the new format, but with less data fields
       *   than PM.  The old strucuture has some different size fields,
       *   though the field names are the same.
       *
       *
       *   NOTE: bitmap data is located by offsetting the beginning of the file
       *	 by the offset contained in pbfh2->offBits.  This value is in
       *	 the same relatie location for different format bitmap files.
       */

      if (pbmp2->cbFix == sizeof(BITMAPINFOHEADER))	      /* old format? */
      {
	 cScans = (ULONG) ((PBITMAPINFOHEADER)pbmp2)->cy;
      }
      else				 /* new PM format, Windows, or other */
      {
	 cScans = pbmp2->cy;
      }

      memcpy(			   /* copy bitmap info into global structure */
	 (PVOID) pbmp2BitmapFile,
	 (PVOID) pbmp2,
	 pbmp2->cbFix);	     /* only copy specified size (varies per format) */

      hbmBitmapFile =
      GpiCreateBitmap(
	 hpsBitmapFile,				/* presentation-space handle */
	 pbmp2BitmapFile,	     /* address of structure for format data */
	 0L,							  /* options */
	 NULL,				  /* address of buffer of image data */
	 NULL);			/* address of structure for color and format */

      if (!hbmBitmapFile)
      {
	 DispError(habMain,hwndClient);
	 break;			       /* jump to error code outside of loop */
      }

      if (GpiSetBitmap( hpsBitmapFile, hbmBitmapFile) == (HBITMAP)BMB_ERROR)
      {
	 DispError(habMain,hwndClient);
	 break;			       /* jump to error code outside of loop */
      }

      /*
       *   Tell GPI to put the bits into the thread's PS. The function returns
       *   the number of scan lines of the bitmap that were copied.  We want
       *   all of them at once.
       */

      cScansRet =
      GpiSetBitmapBits(
	 hpsBitmapFile,				/* presentation-space handle */
	 0L,					 /* index of first scan line */
	 cScans,				     /* number of scan lines */
	 pFileBegin + pbfh2->offBits,		   /* address of bitmap data */
	 (PBITMAPINFO2) pbmp2);		   /* address of bitmap header table */

      if (cScansRet != cScans)			     /* original # of scans? */
      {
	 DispError(habMain,hwndClient);
	 break;			       /* jump to error code outside of loop */
      }

      DosFreeMem( pFileBegin);
      DosClose( hfile);
      return TRUE;				      /* function successful */

   } while (FALSE); /* fall through loop first time */

    /*
     *	 Close the file, free the buffer space and leave.  This is an error exit
     *	 point from the function.  Cleanup code is here to avoid duplicate code
     *	 after each operation.
     */

    if (pFileBegin != NULL)
       DosFreeMem( pFileBegin);
    DosClose( hfile);

    return FALSE;					  /* function failed */

}   /* end ReadBitmap() */


/**************************************************************************/
/* DispError -- report an error returned from an API service.		  */
/*									  */
/* The error message is displayed using a message box			  */
/*									  */
/**************************************************************************/
VOID DispErrorMsg(HAB hab, HWND hwndFrame, PCH FileName, LONG LineNum)
{
 PERRINFO  pErrInfoBlk;
 PSZ	   pszOffSet, pszErrMsg;
 ERRORID   ErrorId;
 PCH	   ErrorStr;
 CHAR	   szbuff[125];

   DosBeep(800,10);
   #if defined(DEBUG)
      DosBeep(800,10);
      DosBeep(800,10);
      DosBeep(800,10);
      DosBeep(800,10);
      DosBeep(800,10);
   #endif   /* defined(DEBUG) */

   if (!hab)
   {					 /* Non-PM Error */
      WinLoadString( habMain,0, IDS_UNKNOWNMSG, sizeof(szbuff), (PSZ)szbuff);
      ErrorStr = malloc(strlen(szbuff)+strlen(FileName)+10);
      sprintf(ErrorStr, szbuff, FileName, LineNum);
      WinMessageBox(HWND_DESKTOP,	  /* Parent window is desk top */
		    hwndFrame,		  /* Owner window is our frame */
		    (PSZ)ErrorStr,	  /* PMWIN Error message       */
		    szErrorTitle,	  /* Title bar message	       */
		    MSGBOXID,		  /* Message identifier	       */
		    MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL ); /* Flags */
      free(ErrorStr);
      return;
   }

   ErrorId = WinGetLastError(hab);

   if ((pErrInfoBlk = WinGetErrorInfo(hab)) != (PERRINFO)NULL)
   {
      pszOffSet = ((PSZ)pErrInfoBlk) + pErrInfoBlk->offaoffszMsg;
      pszErrMsg = ((PSZ)pErrInfoBlk) + *((PULONG)pszOffSet);

      WinLoadString( habMain,0, IDS_ERRORMSG, sizeof(szbuff), (PSZ)szbuff);
      ErrorStr = malloc(strlen(szbuff)+strlen(pszErrMsg)+strlen(FileName)+10);
      sprintf(ErrorStr, szbuff, pszErrMsg, FileName, LineNum);

      WinMessageBox(HWND_DESKTOP,	  /* Parent window is desk top */
		    hwndFrame,		  /* Owner window is our frame */
		    (PSZ)ErrorStr,	  /* PMWIN Error message       */
		    szErrorTitle,	  /* Title bar message	       */
		    MSGBOXID,		  /* Message identifier	       */
		    MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL ); /* Flags */

      free(ErrorStr);

      WinFreeErrorInfo(pErrInfoBlk);
   }
}


/********************************************************************/

/* DosGetThreadInfo Call Only Temp Call for the LX Toronto Compiler */

/********************************************************************/

APIRET DosGetThreadInfo(PTIB *pptib,PPIB *pppib)
{

      return( DosGetInfoBlocks(pptib,pppib) );
}

/*******************************  END JIGSAW.C	******************************/
#ifndef lint
static char *sccsid = "@(#)ldog.c 1.3 2/3/92 20:40:07 [2/3/92] (c)IBM Corp. 1992";
#endif

/*
 * Copyright (c) International Business Machines Corporation
 *		 1991, 1992
 */

#define LittleDog_Class_Source
#include "ldog.ih"

SOM_Scope void SOMLINK talk(LittleDog * somSelf)
{
/*  LittleDogData *somThis = LittleDogGetData(somSelf); */
    LittleDogMethodDebug("LittleDog", "talk");
    somPrintf("woof woof\n");
    somPrintf("woof woof\n");
    somSelf = somSelf;	       /* Avoid unreferenced parameter compiler
				* warning for OS/2 compiler */
}
#ifndef lint
static char *sccsid = "@(#)link.c 1.3 1/22/92 16:09:29 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define link_Class_Source
#include "link.ih"

/* ************************************************************ */
SOM_Scope void SOMLINK somInit(link * somSelf)
{
    linkData *somThis = linkGetData(somSelf);
    linkMethodDebug("link", "somInit");
    parent_somInit(somSelf);

    _next = 0;
    _previous = 0;
    _contents = 0;
}

/* ************************************************************ */
SOM_Scope void SOMLINK somDumpSelfInt(link * somSelf,
				       int level)
{
    linkData *somThis = linkGetData(somSelf);
    linkMethodDebug("link", "somDumpSelfInt");
    parent_somDumpSelfInt(somSelf, level);
}

/* ************************************************************ */
SOM_Scope void SOMLINK linkSetNext(link * somSelf,
				    link * nextLink)
{
    linkData *somThis = linkGetData(somSelf);
    linkMethodDebug("link", "linkSetNext");
    _next = nextLink;
}

/* ************************************************************ */
SOM_Scope void SOMLINK linkSetPrevious(link * somSelf,
					link * nextLink)
{
    linkData *somThis = linkGetData(somSelf);
    linkMethodDebug("link", "linkSetPrevious");
    _previous = nextLink;
}

/* ************************************************************ */
SOM_Scope void SOMLINK linkSetContents(link * somSelf,
					baseType * newContents)
{
    linkData *somThis = linkGetData(somSelf);
    linkMethodDebug("link", "linkSetContents");
    _contents = newContents;
}

/* ************************************************************ */
SOM_Scope link *SOMLINK linkGetNext(link * somSelf)
{
    linkData *somThis = linkGetData(somSelf);
    linkMethodDebug("link", "linkGetNext");
    return (_next);
}

/* ************************************************************ */
SOM_Scope link *SOMLINK linkGetPrevious(link * somSelf)
{
    linkData *somThis = linkGetData(somSelf);
    linkMethodDebug("link", "linkGetPrevious");
    return (_previous);
}

/* ************************************************************ */
SOM_Scope baseType *SOMLINK linkGetContents(link * somSelf)
{
    linkData *somThis = linkGetData(somSelf);
    linkMethodDebug("link", "linkGetContents");
    return (_contents);
}

/* ************************************************************ */
SOM_Scope void SOMLINK print(link * somSelf,
			      FILE * outputFile)
{
    linkData *somThis = linkGetData(somSelf);
    linkMethodDebug("link", "print");
    fprintf(outputFile, "\n");
    fprintf(outputFile, "    Link\n");
    fprintf(outputFile, "    self: %x \n", somSelf);
    fprintf(outputFile, "    next: %x \n", _next);
    fprintf(outputFile, "previous: %x\n", _previous);
    fprintf(outputFile, "contents: %x\n", _contents);
}
#ifndef lint
static char *sccsid = "@(#)ll.c 1.3 1/22/92 16:10:02 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define linkedList_Class_Source
#include "link.h"
#include "ll.ih"
#define MAX_INT 30000

/* ************************************************************ */
SOM_Scope baseType *SOMLINK llHead(linkedList * somSelf)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    linkedListMethodDebug("linkedList", "llHead");

    if (!_nlinks)
	return (baseType *) NULL;
    _currentLink = _headLink;
    return (_linkGetContents(_currentLink));
}

/* ************************************************************ */
SOM_Scope baseType *SOMLINK llTail(linkedList * somSelf)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    linkedListMethodDebug("linkedList", "llTail");

    if (!_nlinks)
	return (baseType *) NULL;
    _currentLink = _tailLink;
    return (_linkGetContents(_currentLink));
}

/* ************************************************************ */
SOM_Scope int SOMLINK llLength(linkedList * somSelf)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    linkedListMethodDebug("linkedList", "llLength");
    return _nlinks;
}

/* ************************************************************ */
SOM_Scope void SOMLINK llSetMax(linkedList * somSelf,
				 int newMax)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    linkedListMethodDebug("linkedList", "llSetMax");
    _max = newMax;
}

/* ************************************************************ */
SOM_Scope int SOMLINK llLeft(linkedList * somSelf)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    linkedListMethodDebug("linkedList", "llLeft");
    return (_max - _llLength(somSelf));
}

/* ************************************************************ */
SOM_Scope baseType *SOMLINK llNext(linkedList * somSelf)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    linkedListMethodDebug("linkedList", "llNext");

    if (!_nlinks)
	return (baseType *) NULL;
    if (_linkGetNext(_currentLink)) {
	_currentLink = _linkGetNext(_currentLink);
	return (_linkGetContents(_currentLink));
    }
    else {
	return (baseType *) NULL;
    }
}

/* ************************************************************ */
SOM_Scope baseType *SOMLINK llPrevious(linkedList * somSelf)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    linkedListMethodDebug("linkedList", "llPrevious");

    if (!_nlinks)
	return (baseType *) NULL;
    if (_linkGetPrevious(_currentLink)) {
	_currentLink = _linkGetPrevious(_currentLink);
	return (_linkGetContents(_currentLink));
    }
    else {
	return (baseType *) NULL;
    }
}

/* ************************************************************ */
SOM_Scope baseType *SOMLINK llRetrieve(linkedList * somSelf)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    linkedListMethodDebug("linkedList", "llRetrieve");

    if (!_nlinks)
	return (baseType *) NULL;
    return (_linkGetContents(_currentLink));
}

/* ************************************************************ */
SOM_Scope baseType *SOMLINK llReplace(linkedList * somSelf,
				       baseType * newElement)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    linkedListMethodDebug("linkedList", "llReplace");

    if (!_nlinks)
	return (baseType *) NULL;
    _linkSetContents(_currentLink, newElement);
    return (_linkGetContents(_currentLink));
}

/* ************************************************************ */
SOM_Scope baseType *SOMLINK llPromoteTail(linkedList * somSelf)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    link *oldTail;
    linkedListMethodDebug("linkedList", "llPromoteTail");
    if (!_nlinks)
	return (baseType *) NULL;
    if (_nlinks == 1)
	return (_linkGetContents(_headLink));
    oldTail = _tailLink;
    _tailLink = _linkGetPrevious(_tailLink);
    _linkSetNext(_linkGetPrevious(oldTail), 0);
    _linkSetPrevious(oldTail, 0);
    _linkSetNext(oldTail, _headLink);
    _linkSetPrevious(_headLink, oldTail);
    _headLink = oldTail;
    _currentLink = _headLink;
}

/* ************************************************************ */
SOM_Scope baseType *SOMLINK llAddHead(linkedList * somSelf,
				       baseType * newElement)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    link *newLink = linkNew();
    linkedListMethodDebug("linkedList", "llAddHead");

    _linkSetContents(newLink, newElement);
    if (!_llLeft(somSelf)) {
	_llHead(somSelf);
	return (_llReplace(somSelf, newElement));
    }
    if (_llHead(somSelf)) {
	_linkSetPrevious(_currentLink, newLink);
    }
    else
	_tailLink = newLink;
    _linkSetNext(newLink, _currentLink);
    _headLink = _currentLink = newLink;
    _nlinks++;
    return (_linkGetContents(_currentLink));
}

/* ************************************************************ */
SOM_Scope baseType *SOMLINK llAddTail(linkedList * somSelf,
				       baseType * newElement)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    link *newLink = linkNew();
    linkedListMethodDebug("linkedList", "llAddTail");

    _linkSetContents(newLink, newElement);
    if (!_llLeft(somSelf)) {
	_llTail(somSelf);
	return (_llReplace(somSelf, newElement));
    }
    if (_llTail(somSelf)) {
	_linkSetNext(_currentLink, newLink);
    }
    else
	_headLink = newLink;
    _linkSetPrevious(newLink, _currentLink);
    _tailLink = _currentLink = newLink;
    _nlinks++;
    return (_linkGetContents(_currentLink));
}

/* ************************************************************ */
SOM_Scope baseType *SOMLINK llRemoveHead(linkedList * somSelf)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    baseType *thisItem;
    linkedListMethodDebug("linkedList", "llRemoveHead");

    if (!_nlinks)
	return (baseType *) NULL;
    thisItem = _llHead(somSelf);
    if (_nlinks == 1) {
	_somFree(_headLink);
	_headLink = _tailLink = _currentLink = 0;
    }
    if (_nlinks > 1) {
	_llNext(somSelf);
	_somFree(_headLink);
	_headLink = _currentLink;
	_linkSetPrevious(_headLink, 0);
    }
    _nlinks--;
    return thisItem;
}

/* ************************************************************ */
SOM_Scope int SOMLINK llIsTail(linkedList * somSelf)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    linkedListMethodDebug("linkedList", "llIsTail");
    return (_currentLink == _tailLink);

}

/* ************************************************************ */
SOM_Scope void SOMLINK llFreeContents(linkedList * somSelf)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    baseType *thisItem;

    linkedListMethodDebug("linkedList", "llFreeContents");

    while (thisItem = _llRemoveHead(somSelf))
	_somFree(thisItem);
}

/* ************************************************************ */
SOM_Scope void SOMLINK print(linkedList * somSelf,
			      FILE * outputFile)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    baseType *thisItem;

    linkedListMethodDebug("linkedList", "print");
    thisItem = _llHead(somSelf);
    if (thisItem) {
	while (thisItem) {
	    _print(thisItem, outputFile);
	    thisItem = _llNext(somSelf);
	}
    }
}

/* ************************************************************ */
SOM_Scope void SOMLINK somInit(linkedList * somSelf)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    linkedListMethodDebug("linkedList", "somInit");
    parent_somInit(somSelf);

    _currentLink = 0;
    _headLink = 0;
    _tailLink = 0;
    _nlinks = 0;
    _max = MAX_INT;
}

/* ************************************************************ */
SOM_Scope void SOMLINK somUninit(linkedList * somSelf)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    linkedListMethodDebug("linkedList", "somUninit");

    while (_llRemoveHead(somSelf))
	;
    parent_somUninit(somSelf);
}

/* ************************************************************ */
SOM_Scope void SOMLINK somDumpSelfInt(linkedList * somSelf,
				       int level)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    linkedListMethodDebug("linkedList", "somDumpSelfInt");
    parent_somDumpSelfInt(somSelf, level);
}

/* ************************************************************ */
SOM_Scope void SOMLINK llTrace(linkedList * somSelf, FILE * output)
{
    linkedListData *somThis = linkedListGetData(somSelf);
    linkedListMethodDebug("linkedList", "llTrace");
    fprintf(output, "\n");
    fprintf(output, " Linked List\n");
    fprintf(output, "        max: %d\n", _max);
    fprintf(output, "     nlinks: %d\n", _nlinks);
    fprintf(output, "currentLink: %x\n", _currentLink);
    fprintf(output, "   headLink: %x\n", _headLink);
    fprintf(output, "   tailLink: %x\n", _tailLink);

    _print(_headLink, output);
    _print(_currentLink, output);
    _print(_tailLink, output);
}
#ifndef lint
static char *sccsid = "@(#)main.c 1.3 1/22/92 16:10:45 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * Adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#include <stdlib.h>
#include "suep.h"

void main(int argc, char *argv[])
{
    setUpEnvProcessor *nextEnv;
    fileMgr *myFile;
    page *myPage;
    char *inputFile;

    somEnvironmentNew();
    SOM_TraceLevel = (argc > 2 ? 1 : 0);
    inputFile = (argc > 1 ? argv[1] : "test.dat");

    nextEnv = setUpEnvProcessorNew();
    myFile = fileMgrNew();
    myPage = pageNew();
    _fmInit(myFile, inputFile);

    _epSetPage(nextEnv, myPage);
    _epSetFileMgr(nextEnv, myFile);
    _suProcessOptions(nextEnv);

    _somFree(nextEnv);
    exit(0);
}
/******************************************************************************
*
*  File Name   : MISC.C
*
*  Description : miscellaneous Jigsaw functions
*
*  Entry Points:
*		 CreateBitmapHdcHps()
*		 SegListUpdate()
*		 SetDVTransform()
*		 SetRect()
*		 SegListGet()
*		 DrawPiece()
*		 DoDraw()
*		 CalcBounds()
*		 CalcTransform()
*		 Redraw()
*		 Correlate()
*		 MarkIsland()
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.						      *
*
******************************************************************************/

#include "jigsaw.h"
#include "globals.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/******************************************************************************/
/*									      */
/* Create a memory DC and an associated PS.				      */
/*									      */
/******************************************************************************/
BOOL CreateBitmapHdcHps( phdc, phps)
PHDC phdc;
PHPS phps;
{
  SIZEL	   sizl;
  HDC	   hdc;
  HPS	   hps;

  hdc = DevOpenDC( habMain, OD_MEMORY, "*", 3L, (PDEVOPENDATA)&dop, NULLHANDLE);
  if( !hdc)
    return( FALSE);

  sizl.cx = sizl.cy = 1L;
  if ((hps = GpiCreatePS( habMain
			, hdc
			, &sizl
			, PU_PELS | GPIA_ASSOC | GPIT_MICRO )) == GPI_ERROR)
	     DispError(habMain,hwndClient);
  if( !hps)
    return( FALSE);

  *phdc = hdc;
  *phps = hps;
  return( TRUE);
}

/*****************************************************************************/
/*									      */
/* Add (at head or tail) or delete a specified segment list member.	      */
/*									      */
/******************************************************************************/
PSEGLIST SegListUpdate(USHORT usOperation,PSEGLIST pslUpdate)
{
  PSEGLIST psl;

  switch( usOperation)
  {
    case ADD_HEAD_SEG:
      if( pslHead == NULL)
      {
	DosAllocMem((PPVOID)&pslHead,(ULONG)sizeof(SEGLIST),(ULONG)PAG_READ | PAG_WRITE | PAG_COMMIT);
	if( pslHead == NULL)
	  return( NULL);
	*pslHead = *pslUpdate;
	pslHead->pslPrev = NULL;
	pslHead->pslNext = NULL;
	pslTail = pslHead;
      } else
      {
	DosAllocMem((PPVOID)&psl,(ULONG)sizeof(SEGLIST),(ULONG)PAG_READ | PAG_WRITE | PAG_COMMIT);
	if( psl == NULL)
	  return( NULL);
	*psl = *pslUpdate;
	pslHead->pslPrev = psl;
	psl->pslNext = pslHead;
	psl->pslPrev = NULL;
	pslHead = psl;
      }
      return( pslHead);
      break;

    case ADD_TAIL_SEG:
      if( pslTail == NULL)
      {
	DosAllocMem((PPVOID)&pslHead,(ULONG)sizeof(SEGLIST),(ULONG)PAG_READ | PAG_WRITE |
		PAG_COMMIT);
	if( pslHead == NULL)
	  return( NULL);
	*pslHead = *pslUpdate;
	pslHead->pslPrev = NULL;
	pslHead->pslNext = NULL;
	pslTail = pslHead;
      } else
      {
	DosAllocMem((PPVOID)&psl,(ULONG)sizeof(SEGLIST),(ULONG)PAG_READ | PAG_WRITE |
		PAG_COMMIT);
	if( psl == NULL)
	  return( NULL);
	*psl = *pslUpdate;
	pslTail->pslNext = psl;
	psl->pslPrev = pslTail;
	psl->pslNext = NULL;
	pslTail = psl;
      }
      return( pslTail);
      break;

    case MAKE_TAIL_SEG:
      if( pslUpdate == pslTail)
	return( pslTail);
      if( pslUpdate == pslHead)
      {
	pslHead = pslHead->pslNext;
	pslHead->pslPrev = NULL;
      } else
      {
	pslUpdate->pslPrev->pslNext = pslUpdate->pslNext;
	pslUpdate->pslNext->pslPrev = pslUpdate->pslPrev;
      }
      pslTail->pslNext = pslUpdate;
      pslUpdate->pslPrev = pslTail;
      pslTail = pslUpdate;
      pslTail->pslNext = NULL;
      return( pslTail);
      break;

    case MAKE_HEAD_SEG:
      if( pslUpdate == pslHead)
	return( pslHead);
      if( pslUpdate == pslTail)
      {
	pslTail = pslTail->pslPrev;
	pslTail->pslNext = NULL;
      } else
      {
	pslUpdate->pslPrev->pslNext = pslUpdate->pslNext;
	pslUpdate->pslNext->pslPrev = pslUpdate->pslPrev;
      }
      pslHead->pslPrev = pslUpdate;
      pslUpdate->pslNext = pslHead;
      pslHead = pslUpdate;
      pslHead->pslPrev = NULL;
      return( pslHead);
      break;

    case DEL_SEG:
      for( psl = pslHead; psl != NULL; psl = psl->pslNext)
      {
	if( psl->lSegId == pslUpdate->lSegId)
	{
	  if( psl == pslHead)
	  {
	    pslHead = psl->pslNext;
	    if( pslHead == NULL)
	      pslTail = NULL;
	    else
	      pslHead->pslPrev = NULL;
	  }else if( psl == pslTail)
	  {
	    pslTail = psl->pslPrev;
	    pslTail->pslNext = NULL;
	  } else
	  {
	    (psl->pslPrev)->pslNext = psl->pslNext;
	    (psl->pslNext)->pslPrev = psl->pslPrev;
	  }
	  DosFreeMem( psl);
	  return( psl);
	  break;
	}
      }
      return( NULL);
      break;

    default:
      return( NULL);
  }
}

/******************************************************************************/
/*									      */
/* set the default viewing transform					      */
/*									      */
/******************************************************************************/
VOID SetDVTransform( fx11, fx12, fx21, fx22, l31, l32, lType)
FIXED fx11;
FIXED fx12;
FIXED fx21;
FIXED fx22;
FIXED l31;
FIXED l32;
FIXED lType;
{
  MATRIXLF  matlf;

  matlf.fxM11 = fx11;
  matlf.fxM12 = fx12;
  matlf.lM13  = 0L;
  matlf.fxM21 = fx21;
  matlf.fxM22 = fx22;
  matlf.lM23  = 0L;
  matlf.lM31  = l31;
  matlf.lM32  = l32;
  matlf.lM33  = 1L;
  if (GpiSetDefaultViewMatrix( hpsClient, 9L, &matlf, lType) == GPI_ERROR)
      DispError(habMain,hwndClient);
}

/******************************************************************************/
/*									      */
/* Determine the bounding rect of a segment.				      */
/*									      */
/* Use special knowledge that the only non-identity part of the segment	      */
/* transform is the translation part.					      */
/******************************************************************************/
VOID SetRect( psl)
PSEGLIST psl;
{
  psl->rclCurrent	  = psl->rclBitBlt;	 /* world space bounding rect */
  psl->rclCurrent.xLeft	  += psl->ptlModelXlate.x;
  psl->rclCurrent.yBottom += psl->ptlModelXlate.y;
  psl->rclCurrent.xRight  += psl->ptlModelXlate.x;
  psl->rclCurrent.yTop	  += psl->ptlModelXlate.y;
}

/******************************************************************************/
/*									      */
/* Return a pointer to a segment list member, based on segment id.	      */
/*									      */
/******************************************************************************/
PSEGLIST SegListGet( lSeg)
LONG lSeg;
{
  PSEGLIST  psl;

  for( psl = pslHead; psl != NULL; psl = psl->pslNext)
    if( psl->lSegId == lSeg)
      return( psl);
  return( NULL);
}


/******************************************************************************
*
*  Name	       : DrawPiece
*
*  Description : Draw one piece.
*
*  Concepts    :
*
*  API's       :
*
*  Parameters  : HPS	  hps
*		 PSEGLIST psl
*		 BOOL	  fFill
*
*  Return      : VOID
*
******************************************************************************/

VOID DrawPiece(HPS hps, PSEGLIST psl, BOOL fFill)
{
   POINTL  aptl[4];
   APIRET  rc;

   if(psl->fVisible)			      /* don't bother if not visible */
   {
      /*
       *  Setup source and target points based on model transform of this peice
       */

      aptl[2].x = aptl[2].y = 0L;		       /* source: lower left */
      aptl[3] = psl->aptlBitBlt[3];		      /* source: upper right */

							       /* target:    */
      aptl[0].x = psl->rclBitBlt.xLeft + psl->ptlModelXlate.x; /* lower left */
      aptl[0].y = psl->rclBitBlt.yBottom + psl->ptlModelXlate.y;

      rc =
      GpiConvert(hpsClient, CVTC_MODEL, CVTC_DEVICE, 1L, aptl);

      if (rc == GPI_ERROR)
	 DispError(habMain,hwndClient);

      aptl[1].x = aptl[0].x + aptl[3].x;	      /* target: upper right */
      aptl[1].y = aptl[0].y + aptl[3].y;	   /* (equal to source size) */

      /*
       *  Punch a hole
       */

      rc =
      GpiBitBlt(
	 hps,				 /* target presentation-space handle */
	 psl->hpsHole,			 /* source presentation-space handle */
	 4L,				 /* number of points in array	     */
	 aptl,				 /* address of array		     */
	 ROP_SRCAND,			 /* mixing method		     */
	 BBO_IGNORE);			 /* line/column-compression flag     */

      if (rc == GPI_ERROR)
	 DispError(habMain,hwndClient);

      if (fFill)
      {
	 /*
	  *  Fill the hole
	  */
	 rc =
	 GpiBitBlt(
	    hps,			 /* target presentation-space handle */
	    psl->hpsFill,		 /* source presentation-space handle */
	    4L,				 /* number of points in array	     */
	    aptl,			 /* address of array		     */
	    ROP_SRCPAINT,		 /* mixing method		     */
	    BBO_IGNORE);		 /* line/column-compression flag     */

	 if (rc == GPI_ERROR)
	    DispError(habMain,hwndClient);

      }	  /* end if (fFill) */

   }   /* end if(psl->fVisible) */

}   /* end DrawPiece() */

/******************************************************************************/
/*									      */
/* Draw the picture, using the passed region for clipping.		      */
/* Intersect the bounding box used for the clip region with the client rect.  */
/* Test each segment to see if its bounding box intersects the bounding box   */
/* of the clipping region.  Draw only if there is an intersection.	      */
/*									      */
/******************************************************************************/
BOOL DoDraw(HPS hps,HRGN hrgn,BOOL fPaint)
{
  HRGN	    hrgnOld;
  RECTL	    rcl, rclRegion, rclDst, rclClient;
  PSEGLIST  psl;
  ULONG	    ulPostCt;

  if( fPaint && !fFirstLoad)
  {
    if (GpiSetColor( hps, CLR_BACKGROUND) == GPI_ERROR)
	DispError(habMain,hwndClient);
    if (GpiPaintRegion( hps, hrgn) == GPI_ERROR)	     /* erase region */
	DispError(habMain,hwndClient);
  }

  if (GpiQueryRegionBox( hps, hrgn, &rclRegion) == RGN_ERROR)
      DispError(habMain,hwndClient);

  WinQueryWindowRect( hwndClient, &rclClient);

  if( !WinIntersectRect( habAsync, &rclRegion, &rclRegion, &rclClient))
    return( FALSE);				     /* not in client window */

  if (GpiSetClipRegion( hps, hrgn, &hrgnOld) == RGN_ERROR) /* make the clip region */
      DispError(habMain,hwndClient);

  for( psl = pslHead; psl != NULL; psl = psl->pslNext)	  /* scan all pieces */
  {
    /**************************************************************************/
    /* get the piece bounding box in device coordinates			      */
    /**************************************************************************/
    rcl = psl->rclCurrent;
    if (GpiConvert( hpsClient, CVTC_MODEL, CVTC_DEVICE, 2L, (PPOINTL)&rcl) == GPI_ERROR)
	DispError(habMain,hwndClient);
    rcl.xRight++;
    rcl.yTop++;

    /**************************************************************************/
    /* if the piece might be visible, and drawing allowed, draw the piece     */
    /**************************************************************************/

    if( WinIntersectRect( habAsync, &rclDst, &rcl, &rclRegion))
       {
       DosQueryEventSem( hevDrawOn, &ulPostCt);		 /* drawing enabled? */
	 if( ulPostCt)						      /* yes */
	   DrawPiece( hps, psl, TRUE);
	 else
	   break;		    /* drawing is disabled; don't draw piece */
       }
  }

  if (GpiSetClipRegion( hps, NULLHANDLE, &hrgnOld) == RGN_ERROR)
      DispError(habMain,hwndClient);

  DosQueryEventSem( hevDrawOn, &ulPostCt);
  if( ulPostCt)					       /* drawing is enabled */
    if (GpiSetRegion( hpsClient, hrgnInvalid, 0L, NULL) == RGN_ERROR)
	DispError(habMain,hwndClient);

  return( TRUE);

}   /* end DoDraw() */

/******************************************************************************/
/*									      */
/* get bounding rect of whole picture in model coordinates		      */
/*									      */
/******************************************************************************/
VOID CalcBounds(VOID)
{
  PSEGLIST  psl;
  RECTL	    rclOld;
  ULONG	    ulPostKillDraw, ulPostCt;

  if( !pslHead)
    return;
  rclBounds = rclOld = pslHead->rclCurrent;

  /*
   * get start killdraw post count
   */
  DosQueryEventSem(hevKillDraw, &ulPostKillDraw);

  for( psl = pslHead->pslNext; psl != NULL; psl = psl->pslNext) {
    DosQueryEventSem(hevKillDraw, &ulPostCt);
    if (ulPostKillDraw != ulPostCt) {
	rclBounds = rclOld;
	return;
	}
    WinUnionRect(habAsync, &rclBounds, &rclBounds, &(psl->rclCurrent));
    }
}

/******************************************************************************/
/*									      */
/* Calculate and set the default viewing transform based on zoom and scroll   */
/*									      */
/******************************************************************************/
VOID CalcTransform( hwnd)
HWND hwnd;
{
  RECTL	    rclClient;
  POINTL    ptlCenter, ptlTrans, ptlScale, aptl[4], ptlOrg, aptlSides[12];
  PSEGLIST  psl;
  LONG	    l;
  MATRIXLF  matlf;
  ULONG	    ulPostCt, ulPostKillDraw;


  /*
   * get start killdraw post count
   */
  DosQueryEventSem(hevKillDraw, &ulPostKillDraw);


  /****************************************************************************/
  /* from bounding rect of picture get center of picture		      */
  /****************************************************************************/
  ptlCenter.x = (rclBounds.xLeft   + rclBounds.xRight) / 2;
  ptlCenter.y = (rclBounds.yBottom + rclBounds.yTop  ) / 2;

  /****************************************************************************/
  /* translate center of picture to origin				      */
  /****************************************************************************/
  SetDVTransform( (FIXED)UNITY
		, (FIXED)0
		, (FIXED)0
		, (FIXED)UNITY
		, -ptlCenter.x
		, -ptlCenter.y
		, TRANSFORM_REPLACE);

  /****************************************************************************/
  /* scale down to 1:1 of bitmap in file				      */
  /****************************************************************************/
  if (pbmp2BitmapFile->cbFix  == sizeof(BITMAPINFOHEADER))
      {
      ptlScale.x = UNITY * ((PBITMAPINFOHEADER)pbmp2BitmapFile)->cx
	      / (ptlTopRight.x - ptlBotLeft.x);
      ptlScale.y = UNITY * ((PBITMAPINFOHEADER)pbmp2BitmapFile)->cy
	      / (ptlTopRight.y - ptlBotLeft.y);
      }
  else
      {
      ptlScale.x = UNITY * pbmp2BitmapFile->cx
	      / (ptlTopRight.x - ptlBotLeft.x);
      ptlScale.y = UNITY * pbmp2BitmapFile->cy
	      / (ptlTopRight.y - ptlBotLeft.y);
      }

  /****************************************************************************/
  /* add in zoom scale							      */
  /****************************************************************************/
  ptlScale.x += ptlScale.x * lScale / (ZOOM_MAX + 1);
  ptlScale.y += ptlScale.y * lScale / (ZOOM_MAX + 1);

  SetDVTransform( (FIXED)ptlScale.x
		, (FIXED)0
		, (FIXED)0
		, (FIXED)ptlScale.y
		, 0L
		, 0L
		, TRANSFORM_ADD);

  /****************************************************************************/
  /* translate center of picture to center of client window		      */
  /****************************************************************************/
  WinQueryWindowRect( hwnd, &rclClient);
  ptlTrans.x = (rclClient.xRight - rclClient.xLeft)   / 2;
  ptlTrans.y = (rclClient.yTop	 - rclClient.yBottom) / 2;

  /****************************************************************************/
  /* add in horizontal and vertical scrolling factors			      */
  /****************************************************************************/
  ptlTrans.x -= ptsScrollPos.x - ptsHalfScrollMax.x;
  ptlTrans.y += ptsScrollPos.y - ptsHalfScrollMax.y;
  SetDVTransform( (FIXED)UNITY
		, (FIXED)0
		, (FIXED)0
		, (FIXED)UNITY
		, ptlTrans.x
		, ptlTrans.y
		, TRANSFORM_ADD);

  if (GpiQueryDefaultViewMatrix( hpsClient, 9L, &matlf) == GPI_ERROR)
      DispError(habMain,hwndClient);
  if (GpiSetDefaultViewMatrix( hpsClient, 9L, &matlf, TRANSFORM_REPLACE) == GPI_ERROR)
      DispError(habMain,hwndClient);

  /****************************************************************************/
  /* create bitmaps for pieces						      */
  /****************************************************************************/

  ptlOffset = ptlBotLeft;		   /* BottomLeft corner in dev coord  */
  if (GpiConvert( hpsClient, CVTC_WORLD, CVTC_DEVICE, 1L, &ptlOffset) == GPI_ERROR)
      DispError(habMain,hwndClient);
  if( (ptlScale.x != ptlScaleRef.x) || (ptlScale.y != ptlScaleRef.y))
  {
    ptlScaleRef = ptlScale;

    /**************************************************************************/
    /* create a shadow bitmap of the original, sized to current output size   */
    /**************************************************************************/
    aptl[0] = ptlBotLeft;		   /* current output rect, dev coord  */
    aptl[1] = ptlTopRight;
    if (GpiConvert( hpsClient, CVTC_WORLD, CVTC_DEVICE, 2L, aptl) == GPI_ERROR)
	DispError(habMain,hwndClient);
    aptl[0].x -= ptlOffset.x;		   /* put bottom left at (0,0)	      */
    aptl[0].y -= ptlOffset.y;
    aptl[1].x -= ptlOffset.x;
    aptl[1].y -= ptlOffset.y;
#ifdef fred
    aptl[1].x -= ptlOffset.x - 1;	   /* correct for coordinate convert  */
    aptl[1].y -= ptlOffset.y - 1;
#endif
    aptl[2].x = 0L;
    aptl[2].y = 0L;
  if (pbmp2BitmapFile->cbFix  == sizeof(BITMAPINFOHEADER))
     {
    aptl[3].x = ((PBITMAPINFOHEADER)pbmp2BitmapFile)->cx;  /*bitmap dimensions	 */
    aptl[3].y = ((PBITMAPINFOHEADER)pbmp2BitmapFile)->cy;
     }
  else
     {
    aptl[3].x = pbmp2BitmapFile->cx;	    /* bitmap dimensions	       */
    aptl[3].y = pbmp2BitmapFile->cy;
     }
    if (GpiSetBitmap( hpsBitmapSize, hbmBitmapSize) == (HBITMAP)BMB_ERROR)
	DispError(habMain,hwndClient);
    if (GpiBitBlt( hpsBitmapSize	       /* copy the bitmap		  */
		 , hpsBitmapFile
		 , 4L
		 , aptl
		 , ROP_SRCCOPY
		 , BBO_IGNORE) == GPI_ERROR)
	DispError(habMain,hwndClient);

    for( psl = pslHead; psl != NULL; psl = psl->pslNext)
    {
      DosQueryEventSem( hevTerminate, &ulPostCt);
      if( ulPostCt) /* exit if quit   */
	break;

      DosQueryEventSem( hevKillDraw, &ulPostCt);
      if( ulPostCt != ulPostKillDraw) {
	break;
	}

      aptl[0].x = psl->rclBitBlt.xLeft;	    /* bounding rect in world space   */
      aptl[0].y = psl->rclBitBlt.yBottom;
      aptl[1].x = psl->rclBitBlt.xRight;
      aptl[1].y = psl->rclBitBlt.yTop;
      aptl[2] = aptl[0];
      aptl[3] = aptl[1];
      if (GpiConvert( hpsClient, CVTC_WORLD, CVTC_DEVICE, 2L, &aptl[2]) == GPI_ERROR)
	  DispError(habMain,hwndClient);
      ptlOrg = aptl[2];
      aptl[3].x -= ptlOrg.x - 1;	    /* bitmap rect of piece	      */
      aptl[3].y -= ptlOrg.y - 1;
      aptl[2].x = 0L;
      aptl[2].y = 0L;
      psl->aptlBitBlt[0] = aptl[0];
      psl->aptlBitBlt[1] = aptl[1];
      psl->aptlBitBlt[2] = aptl[2];
      psl->aptlBitBlt[3] = aptl[3];

      /************************************************************************/
      /* compute the piece control points				      */
      /************************************************************************/
      for ( l = 0; l < 12; l++)
	aptlSides[l] = psl->aptlSides[l];
      if (GpiConvert( hpsClient, CVTC_WORLD, CVTC_DEVICE, 12L, aptlSides) == GPI_ERROR)
	  DispError(habMain,hwndClient);
      for ( l = 0; l < 12; l++)
      {
	aptlSides[l].x -= ptlOrg.x;
	aptlSides[l].y -= ptlOrg.y;
      }

      /************************************************************************/
      /* prepare the mask to punch a hole in the output bitmap		      */
      /************************************************************************/
      if (GpiSetClipPath( psl->hpsHole, 0L, SCP_RESET)== GPI_ERROR)/* no clip path	    */
	  DispError(habMain,hwndClient);
      if (GpiBitBlt( psl->hpsHole			 /* fill with 1's         */
		   , NULLHANDLE
		   , 2L
		   , &psl->aptlBitBlt[2]
		   , ROP_ONE
		   , BBO_IGNORE) == GPI_ERROR)
	  DispError(habMain,hwndClient);

      if (GpiBeginPath( psl->hpsHole, 1L) == GPI_ERROR)	 /* define a clip path	  */
	  DispError(habMain,hwndClient);
      if (GpiMove( psl->hpsHole, &aptlSides[11]) == GPI_ERROR)
	  DispError(habMain,hwndClient);
      if (GpiPolySpline( psl->hpsHole, 12L, aptlSides) == GPI_ERROR)
	  DispError(habMain,hwndClient);
      if (GpiEndPath( psl->hpsHole) == GPI_ERROR)
	  DispError(habMain,hwndClient);
      if (GpiSetClipPath( psl->hpsHole, 1L, SCP_AND) == GPI_ERROR)
	  DispError(habMain,hwndClient);
      if (GpiBitBlt( psl->hpsHole			 /* fill with 0's         */
		   , NULLHANDLE
		   , 2L
		   , &psl->aptlBitBlt[2]
		   , ROP_ZERO
		   , BBO_IGNORE) == GPI_ERROR)
	  DispError(habMain,hwndClient);
      if (GpiSetClipPath( psl->hpsHole, 0L, SCP_RESET) == GPI_ERROR)  /* clear the clip path   */
	  DispError(habMain,hwndClient);

      /************************************************************************/
      /* prepare the mask to fill the hole in the output bitmap		      */
      /************************************************************************/
      aptl[0] = psl->aptlBitBlt[2];
      aptl[1] = psl->aptlBitBlt[3];
      aptl[2] = aptl[0];
      if (GpiBitBlt( psl->hpsFill			 /* make inverse of hole  */
		   , psl->hpsHole
		   , 3L
		   , aptl
		   , ROP_NOTSRCCOPY
		   , BBO_IGNORE) == GPI_ERROR)
	  DispError(habMain,hwndClient);

      aptl[0] = psl->aptlBitBlt[2];
      aptl[1] = psl->aptlBitBlt[3];
      aptl[2].x = ptlOrg.x - ptlOffset.x;	     /* pick the right part   */
      aptl[2].y = ptlOrg.y - ptlOffset.y;	     /* of the sized bitmap   */
      if (GpiBitBlt( psl->hpsFill			 /* fill with data	  */
		   , hpsBitmapSize
		   , 3L
		   , aptl
		   , ROP_SRCAND
		   , BBO_IGNORE) == GPI_ERROR)
	  DispError(habMain,hwndClient);
      if (GpiSetClipPath( psl->hpsFill, 0L, SCP_RESET) == GPI_ERROR)  /* clear the clip path   */
	  DispError(habMain,hwndClient);
      if (GpiSetColor( psl->hpsFill, CLR_RED) == GPI_ERROR)/* draw the outline	    */
	  DispError(habMain,hwndClient);
      if (GpiMove( psl->hpsFill, &aptlSides[11]) == GPI_ERROR)
	  DispError(habMain,hwndClient);
      if (GpiPolySpline( psl->hpsFill, 12L, aptlSides) == GPI_ERROR)
	  DispError(habMain,hwndClient);
      DrawPiece( hpsClient, psl, TRUE);
    }
  }
}

/******************************************************************************/
/*									      */
/* Redraw the entire client window.					      */
/*									      */
/******************************************************************************/
VOID Redraw(VOID)
{
  RECTL	  rclInvalid;
  HRGN	  hrgnUpdt;
  POINTL  aptlUpdtNew[3];

  WinQueryWindowRect( hwndClient, &rclInvalid);
  hrgnUpdt = GpiCreateRegion( hpsBitmapBuff, 1L, &rclInvalid);
  DoDraw( hpsBitmapBuff, hrgnUpdt, TRUE);
  if (GpiDestroyRegion( hpsBitmapBuff, hrgnUpdt) == GPI_ERROR)
     DispError(habMain,hwndClient);
  aptlUpdtNew[0].x = rclInvalid.xLeft;
  aptlUpdtNew[0].y = rclInvalid.yBottom;
  aptlUpdtNew[1].x = rclInvalid.xRight;
  aptlUpdtNew[1].y = rclInvalid.yTop;
  ROUND_DOWN_MOD( aptlUpdtNew[0].x, lByteAlignX);	  /* round down	      */
  ROUND_DOWN_MOD( aptlUpdtNew[0].y, lByteAlignY);	  /* round down	      */
  ROUND_UP_MOD(	  aptlUpdtNew[1].x, lByteAlignX);	  /* round up	      */
  ROUND_UP_MOD(	  aptlUpdtNew[1].y, lByteAlignY);	  /* round up	      */
  aptlUpdtNew[2] = aptlUpdtNew[0];

  if (!fFirstLoad)
  {
     if (GpiBitBlt( hpsClient
		  , hpsBitmapBuff
		  , 3L
		  , aptlUpdtNew
		  , ROP_SRCCOPY
		  , BBO_IGNORE ) == GPI_ERROR)
	 DispError(habMain,hwndClient);
  }   /* end if (!fFirstLoad) */
}

/******************************************************************************
*
*  Name	       : CorrelatePPOINTL
*
*  Description : perform bitmap-based correlation
*
*  Concepts    :
*
*  API's       :
*
*  Parameters  : PPOINTL pptl
*
*  Return      : PSEGLIST
*
******************************************************************************/

PSEGLIST Correlate(PPOINTL pptl)
{
   PSEGLIST  psl;
   POINTL    aptl[2];
   LONG	     lColor;
   RECTL     rcl;
   APIRET    rc;				    /* return code from APIs */


   aptl[0] = aptl[1] = *pptl;			  /* target lower-left point */

   aptl[1].x++;				  /* target bitmap upper-right point */
   aptl[1].y++;

   /*
    *  Set all hpsBitmapSave pels to 1.	 We're doing this so we can draw
    *  the correlated segment (if any) overtop of it.  Then, if the color
    *  didn't change, we know that we hit a clipped part of the segment
    *  (piece).
    */
   rc =
   GpiBitBlt(
      hpsBitmapSave,			 /* target presentation-space handle */
      NULLHANDLE,			 /* source presentation-space handle */
      2L,				 /* number of points in array	     */
      aptl,				 /* address of array		     */
      ROP_ONE,				 /* mixing method		     */
      BBO_IGNORE);			 /* line/column-compression flag     */

   if (rc  == GPI_ERROR)
      DispError(habMain,hwndClient);

   /*
    *  Retrieve color attribute for correlation point
    */

   lColor =						  /* should return 0 */
   GpiQueryPel(hpsBitmapSave, pptl);

   if (lColor == GPI_ALTERROR)
      DispError(habMain,hwndClient);

   /*
    *  Do a manual correlation by determining if the correlation point
    *  intersects the region occupied be each segment (piece).
    */

   for( psl = pslTail; psl != NULL; psl = psl->pslPrev)
   {
      /*
       *  get device coordinates for current segment (peice) bounding box
       */

      rcl = psl->rclCurrent;
      rc =
      GpiConvert(
	 hpsClient,		/* presentation-space handle		     */
	 CVTC_MODEL,		/* source coordinate space		     */
	 CVTC_DEVICE,		/* target coordinate space		     */
	 2L,			/* number of coordinate pairs in structure   */
	 (PPOINTL)&rcl);	/* address of structure for coordinate pairs */

      if (rc == GPI_ERROR)
	 DispError(habMain,hwndClient);

      rcl.xRight++;
      rcl.yTop++;

      /*
       *  Does the point fall inside this segment's (peice's) bounding box?
       *  If so, did the color of the pel change when we drew the piece?  If
       *  so, we selected a point inside this piece (segment) which isn't
       *  clipped.  Return it.
       */

      if (WinPtInRect(habAsync, &rcl, pptl))
      {
	  DrawPiece( hpsBitmapSave, psl, FALSE);      /* draw clipped bitmap */
	  if(GpiQueryPel( hpsBitmapSave, pptl) != lColor)   /* color change? */
	     break;						/* got a hit */
      }
   }   /* end for(all segments in our linked list) */

   return( psl);

}   /* end Correlate() */

/******************************************************************************/
/*									      */
/* mark a whole island							      */
/*									      */
/******************************************************************************/
VOID MarkIsland(PSEGLIST pslMark,BOOL fMark)
{
  PSEGLIST  psl;
  BOOL	    fFirst;

  for( psl = pslMark, fFirst = TRUE
     ; (psl != pslMark) || fFirst
     ; psl = psl->pslNextIsland, fFirst = FALSE )
      psl->fIslandMark = fMark;		      /* mark as island member	      */
}

/********************************  END MISC.C  *******************************/
/*static char *SCCSID = "@(#)numerics.c 6.1 92/02/19";*/
/*************************************************************************
 * File Name	 : NUMERICS
 *
 * Description	 : This sample program demonstrates how to use the
 *		   Bidirectional (Bidi) API NlsConvertBidiNumerics.
 *		   This is an Arabic specific API and it is used to
 *		   to convert the Arabic numerals to Hindu shapes
 *		   for presentation purposes, or vice versa for
 *		   storage purposes.
 *
 * Concepts	 : It is advisable that the Numeral should be left as true
 *		   ones (0x30-0x39), for storage and processing.
 *
 * API's         : NlsConvertBidiNumerics
 *
 * Required files: To build and run this sample code the following files
 *		   are needed:
 *		   - NUMERICS.c
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 ************************************************************************/
#define INCL_DOSERRORS
#define INCL_BDCALLS	/* This is to include the Bidi headers */

#include <os2.h>
#include <stdio.h>

/*************************************************************************
 * Name		 : Main
 *
 * Description	 : This is the main part of the program, it calls the
 *		   Bidi API to convert all the Arabic numerals in a
 *		   String to Hindu numerals, according to the value
 *		   of the numerics byte in the Bidi attributes passed.
 *
 * API's         : NlsConvertBidiNumerics
 *
 * Parameters	 : This program does not take any command line parameters
 *
 * Returns	 : None
 *
 ************************************************************************/
INT main(SHORT sArgc,CHAR **ppArgv)
{
  static CHAR cNumSourceArray[]={'1','2','3','4','5','\0'};
  char cNumTargetArray [6];

  /* using the OR operator,we construct the value of the Bidi attributes,
   * the value of the numerics byte indicates conversion to Hindi */
  /* Note that the numeral conversion is not dependant on the
   * value of the orientation byte or on the value of the shaping byte
   * in the Bidi attributes */

  ULONG ulBidiAtt = BD_LEVEL
		   | BD_SUPPORT
		   | BDORIENT_RTL
		   | BDNUM_HINDU
		   | BDCSD_AUTOMATIC ;

  APIRET RC=0;
  ULONG ulEffect = 0l;
  ULONG ulIncrement = 1l;
  ULONG ulLength = 5l;
  cNumTargetArray[5]='\0';

  /* Print the string before it is converted */
  printf ("%s\n", cNumSourceArray);

  /* this API will convert all the arabic numerics in a string to hindi	 */
  RC = NlsConvertBidiNumerics (ulBidiAtt,
			       ulEffect,
			       cNumSourceArray,
			       cNumTargetArray,
			       ulLength,
			       ulIncrement);
  if (RC!=0)
  {
    printf ("RC=%d\n", RC);
  }

  /* Print the string after the conversion */
  printf ("%s\n", cNumTargetArray);


  printf ("\n\n\n\n Press Enter to end the program \n");


  /* Wait for Enter to End the program */
  getchar();

  return (0);
} /* end of main */
#ifndef lint
static char *sccsid = "@(#)page.c 1.3 1/22/92 16:10:49 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define page_Class_Source
#include <stdio.h>
#include "page.ih"

#define MAX_WORDS_IN_HEADER 100
#define MAX_WORDS_IN_FOOTER 100

/* ************************************************************ */
SOM_Scope void SOMLINK pgPrint(page * somSelf,
				FILE * output)
{
    pageData *somThis = pageGetData(somSelf);
    char buffer[10];
    pageMethodDebug("page", "pgPrint");

/* Print header.
   ------------- */
    _pageNumber++;
    if (_pageWord) {
	sprintf(buffer, "%d", _pageNumber);
	_wrdReplace(_pageWord, buffer);
    }
    fprintf(output, "\n\f");
    if (_header)
	_print(_header, output);
    fprintf(output, "\n\n");

/* Print text.
   ----------- */
    if (_columns)
	_print(_columns, output);
    fprintf(output, "\n\n");

/* Print footer.
   ------------- */
    if (_footer)
	_print(_footer, output);

/* Clear out text from somThis column block.
   -------------------------------------- */
    _somFree(_columns);
    _columns = 0;
}

/* ************************************************************ */
SOM_Scope void SOMLINK pgSetHeight(page * somSelf,
				    int newHeight)
{
    pageData *somThis = pageGetData(somSelf);
    pageMethodDebug("page", "pgSetHeight");
    _height = newHeight;
}

/* ************************************************************ */
SOM_Scope void SOMLINK pgSetWidth(page * somSelf,
				   int newWidth)
{
    pageData *somThis = pageGetData(somSelf);
    pageMethodDebug("page", "pgSetWidth");
    _width = newWidth;

}

/* ************************************************************ */
SOM_Scope void SOMLINK pgSetNumberOfColumns(page * somSelf,
					     int newColumns)
{
    pageData *somThis = pageGetData(somSelf);
    pageMethodDebug("page", "pgSetNumberOfColumns");
    _ncolumns = newColumns;
}

/* ************************************************************ */
SOM_Scope void SOMLINK pgSetPageNumber(page * somSelf,
					TPWord * newPageWord)
{
    pageData *somThis = pageGetData(somSelf);
    pageMethodDebug("page", "pgSetPageNumber");
    _pageWord = newPageWord;
}

/* ************************************************************ */
SOM_Scope columnBlock *SOMLINK pgGetColumnBlock(page * somSelf)
{
    pageData *somThis = pageGetData(somSelf);
    pageMethodDebug("page", "pgGetColumnBlock");

    if (!_columns) {
	_columns = columnBlockNew();
	_cbInit(_columns, _ncolumns, _height, _width);
    }
    return _columns;
}

/* ************************************************************ */
SOM_Scope textLine *SOMLINK pgGetHeaderBlock(page * somSelf)
{
    pageData *somThis = pageGetData(somSelf);
    pageMethodDebug("page", "pgGetHeaderBlock");

    if (!_header) {
	_header = textLineNew();
	_tlInit(_header, MAX_WORDS_IN_HEADER);
    }
    return _header;
}

/* ************************************************************ */
SOM_Scope textLine *SOMLINK pgGetFooterBlock(page * somSelf)
{
    pageData *somThis = pageGetData(somSelf);
    pageMethodDebug("page", "pgGetFooterBlock");
    if (!_footer) {
	_footer = textLineNew();
	_tlInit(_footer, MAX_WORDS_IN_FOOTER);
    }
    return _footer;
}

/* ************************************************************ */
SOM_Scope void SOMLINK somInit(page * somSelf)
{
    pageData *somThis = pageGetData(somSelf);
    pageMethodDebug("page", "somInit");

    parent_somInit(somSelf);
}

/* ************************************************************ */
SOM_Scope void SOMLINK somUninit(page * somSelf)
{
    pageData *somThis = pageGetData(somSelf);
    pageMethodDebug("page", "somUninit");

    parent_somUninit(somSelf);
}

/* ************************************************************ */
SOM_Scope void SOMLINK somDumpSelfInt(page * somSelf,
				       int level)
{
    pageData *somThis = pageGetData(somSelf);
    pageMethodDebug("page", "somDumpSelfInt");

    parent_somDumpSelfInt(somSelf, level);
}
/*static char *SCCSID = "@(#)paint.c    6.6 92/02/18";*/
/*=========================================================================\
 *									   *
 *	 FILE:paint.c							   *
 *									   *
 *	 DESCRIPTION:	routines used in painting the clock face	   *
 *									   *
 *									   *
 *									   *
 *	Copyright 1989, 1990, 1992 IBM Corp.				   *
 *									   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have been *
 *	advised of the possibility of	such damages.			   *
 *									   *
 *-------------------------------------------------------------------------*
 *

#define DISABLE 1

 *--------------------------------------------------------------
 *
 *  This source file contains the following functions:
 *
 *   ClkPaint
 *   ClkDrawHand
 *   ClkDrawFace
 *   ClkDrawRing
 *   ClkDrawDate
 *   ClkDrawTicks
 *   DrawDigitalTime
 *   GetArrangedDate
 *   DrawTrapez
 *   DrawFullRing
 *
 *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/
#define INCL_WIN
#define INCL_GPI
#define INCL_DOSSEMAPHORES
#define INCL_DOSDATETIME

#include <os2.h>
#include <string.h>
#include <stdlib.h>
#include "clock.h"
#include "res.h"
#include "clkdata.h"

/*--------------------------------------------------------------*\
 *  Global variables  and definitions for this file
\*--------------------------------------------------------------*/


#define MATLF_SIZE ( sizeof ( MATRIXLF ) / sizeof ( LONG ) )

#define CLK_MAJORTICKS	0x0001
#define CLK_MINORTICKS	0x0002

#define XDATE 52L
#define YDATE 14L
#define ZDATE 1L

POINTL aptlFillet1[]= {{53L ,63L },{ 70L ,50L },{68L,47L}} ;
POINTL aptlFillet2[]= {{68L,47L},{ 70L, 50L },{56L ,67L }} ;
POINTL aptlFillet3[]= {{53L ,64L },{ 56L ,62L },{60L,58L}} ;
POINTL aptlFillet4[]= {{60L,58L},{ 60L, 63L },{56L ,67L }} ;
POINTL ptlLight= { -1L , 1L } ;
POINTL ptlShade= {  2L, -2L } ;
POINTL ptlFace = { 0L, 0L};

static FIXED fxSin [60] =
{
    0x00000000, 0x00001ac2, 0x00003539, 0x00004f1b, 0x0000681f, 0x00007fff,
    0x00009679, 0x0000ab4c, 0x0000be3e, 0x0000cf1b, 0x0000ddb3, 0x0000e9de,
    0x0000f378, 0x0000fa67, 0x0000fe98, 0x0000ffff, 0x0000fe98, 0x0000fa67,
    0x0000f378, 0x0000e9de, 0x0000ddb3, 0x0000cf1b, 0x0000be3e, 0x0000ab4c,
    0x00009679, 0x00008000, 0x00006820, 0x00004f1b, 0x00003539, 0x00001ac2,
    0x00000000, 0xffffe53e, 0xffffcac7, 0xffffb0e5, 0xffff97e1, 0xffff8001,
    0xffff6988, 0xffff54b5, 0xffff41c2, 0xffff30e5, 0xffff224d, 0xffff1622,
    0xffff0c88, 0xffff0599, 0xffff0168, 0xffff0001, 0xffff0167, 0xffff0599,
    0xffff0c88, 0xffff1622, 0xffff224d, 0xffff30e5, 0xffff41c2, 0xffff54b4,
    0xffff6987, 0xffff8000, 0xffff97e0, 0xffffb0e4, 0xffffcac6, 0xffffe53e
} ;


/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/

VOID ClkPaint	     (HWND hWind);
VOID ClkDrawHand     (HPS hpsSpace, SHORT sHand, SHORT sMany);
VOID ClkDrawFace     (HPS hpsSpace);
VOID ClkDrawRing     (HPS hpsSpace);
VOID ClkDrawDate     (HPS hpsSpace, USHORT usDate);
VOID ClkDrawTicks    (HPS hpsSpace, USHORT usMany);
VOID DrawDigitalTime (HWND hWind);
VOID GetArrangedDate (CHAR pszDate[]);
VOID DrawTrapez	     (HPS ,POINTL *, LONG );
VOID DrawFullRing    (HPS hpsSpace, PPOINTL ppPoint, FIXED fixed1,
		       FIXED fixed2, LONG lSize);


/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name: DrawClock()
 *
 *  Purpose:Draw the clock face ,hand and minute hand,
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns: VOID
 *
 *
\****************************************************************/
VOID DrawClock (HPS hpsDraw)
{
    RECTL rcl;

    WinQueryWindowRect (hwndClient, &rcl);
    WinFillRect (hpsBuffer, &rcl, cp.clrBackground);

    /* draw the face, the hour hand, and the minute hand */

    ClkDrawRing (hpsDraw);
    ClkDrawFace (hpsDraw);
    ClkDrawDate (hpsDraw, DM_REDRAW);
    ClkDrawHand (hpsDraw, HT_HOUR_SHADE, dt.hours);
    ClkDrawHand (hpsDraw, HT_MINUTE_SHADE, dt.minutes);
    ClkDrawHand (hpsDraw, HT_HOUR, dt.hours);
    ClkDrawHand (hpsDraw, HT_MINUTE, dt.minutes);

    /* draw the tick marks */
    if ((cp.usMajorTickPref == CLKTM_ALWAYS) ||
	    ((cp.usMajorTickPref == CLKTM_NOTICONIC) && ! fIconic))
	ClkDrawTicks (hpsDraw, CLK_MAJORTICKS);

    if ((cp.usMinorTickPref == CLKTM_ALWAYS) ||
	    ((cp.usMinorTickPref == CLKTM_NOTICONIC) && !fIconic))
	ClkDrawTicks (hpsDraw, CLK_MINORTICKS);
}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:UpdateScreen()
 *
 *  Purpose: Update the screen area.
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
VOID UpdateScreen (HPS hps, RECTL *prclUpdate)
{
    POINTL aptl[3];

    if (prclUpdate != NULL)
    {
	aptl[0].x = prclUpdate->xLeft;
	aptl[0].y = prclUpdate->yBottom;
	aptl[1].x = prclUpdate->xRight;
	aptl[1].y = prclUpdate->yTop;
	aptl[2].x = prclUpdate->xLeft;
	aptl[2].y = prclUpdate->yBottom;
    }
    else
    {
	WinQueryWindowRect (hwndClient, (PRECTL)aptl);
	aptl[2].x =
	aptl[2].y = 0;
    }

    GpiBitBlt (hps, hpsBuffer, 3L, aptl, ROP_SRCCOPY, 0L);
}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ClkPaint
 *
 *  Purpose: Paint the clock client window.
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:  VOID
 *
 *
\****************************************************************/
VOID ClkPaint (HWND hwnd)
{
    RECTL rclUpdate;
    HPS hpsWnd;

    if (cp.usDispMode & DM_ANALOG)
    {

	WinBeginPaint (hwnd, hps, &rclUpdate);

	GpiCreateLogColorTable (hps, 0L, LCOLF_RGB, 0L, 0L, (PLONG)NULL);

	WinFillRect (hps, &rclUpdate, cp.clrBackground);

	if (fBufferDirty)
	{
	    DrawClock (hpsBuffer);
	    fBufferDirty = FALSE;
	}

	UpdateScreen (hps, &rclUpdate);

	/*
	 * Draw the second hand last, so xor will work.
	 */
	if (fShowSecondHand && (cp.usDispMode & DM_SECONDHAND))
	    ClkDrawHand(hps, HT_SECOND, dt.seconds);

	WinEndPaint (hps);

    }
    else
    { /*For now, if it is not Analog, it must be digital*/

	hpsWnd = WinBeginPaint (hwnd, NULLHANDLE, &rclUpdate);

	GpiCreateLogColorTable(hpsWnd, 0L, LCOLF_RGB, 0L, 0L, (PLONG) NULL);

	WinFillRect (hpsWnd, &rclUpdate, cp.clrBackground);

	memset (achOldTime, 0, sizeof(achOldTime));
	memset (achOldAmPm, '0', sizeof(achOldAmPm));
	memset (achOldDate, '0', sizeof(achOldDate));

	DrawDigitalTime (hwnd);

	WinEndPaint (hpsWnd);
    }
}


/**************************************************************************\
*									   *
*	ROUTINE:    ClkDrawHand						   *
*									   *
*	COMMENT:    Draws specified hand at specified hour in given PS	   *
*									   *
\**************************************************************************/

VOID ClkDrawHand ( HPS hps , SHORT sHandType , SHORT sAngle )
{
    static POINTL aptlHour [ ] = { { 6 , 0 } , { 0 , 62 } , { -6 , 0 } ,
				   { 0 , -14 } , { 6 , 0 } } ;
    static POINTL aptlHourLine1 [] = {{0L,-10L},{0L,56}};

    static POINTL aptlMinute [ ] = { { 5 , 0 } , { 0 , 77 } , { -5 , 0 } ,
				     { 0 , -14 } , { 5 , 0 } } ;
    static POINTL aptlMinuteLine1 [] = {{0L,-15L},{0L,72}};

    static POINTL aptlSecond [ ] = { { 0 , -15 } , { 0 , 74 } } ;
    static POINTL ptlOrigin = {0L,0L};

    static LONG cptlHour = sizeof ( aptlHour ) / sizeof ( POINTL ) ;
    static LONG cptlMinute = sizeof ( aptlMinute ) / sizeof ( POINTL ) ;
    static LONG cptlSecond = sizeof ( aptlSecond ) / sizeof ( POINTL ) ;
    BOOL f ;

    static MATRIXLF matlfModel =
    {
	MAKEFIXED ( 1 , 0 ) ,	    MAKEFIXED ( 0 , 0 ) ,	0L ,
	MAKEFIXED ( 0 , 0 ) ,	    MAKEFIXED ( 1 , 0 ) ,	0L ,
	100L ,			    100L ,			1L } ;

    static MATRIXLF matlfShade =
    {
	MAKEFIXED ( 1 , 0 ) ,	    MAKEFIXED ( 0 , 0 ) ,	0L ,
	MAKEFIXED ( 0 , 0 ) ,	    MAKEFIXED ( 1 , 0 ) ,	0L ,
	3L ,			 -3L ,			    1L } ;

    /* prepare a rotation transform and set it into the ps */
    /*	    cos x    - sin x	0     *\
    |	    sin x      cos x	0      |
    \*	    100	       100	1     */

    matlfModel.fxM11 =
    matlfModel.fxM22 = fxSin[(sAngle + 15) % 60];
    matlfModel.fxM12 = fxSin[(sAngle + 30) % 60];
    matlfModel.fxM21 = fxSin[sAngle];

    f = GpiSetModelTransformMatrix(hps, (LONG)MATLF_SIZE, &matlfModel,
	    TRANSFORM_REPLACE);

    /* draw the specified hand */

    switch ( sHandType )
    {

	case HT_HOUR:
	    GpiSetColor ( hps , vclrHands[SURFACE] ) ;
	    GpiBeginPath ( hps , 1L ) ;
	    GpiSetCurrentPosition ( hps , aptlHour ) ;
	    GpiPolyLine ( hps , cptlHour , aptlHour ) ;
	    GpiEndPath ( hps ) ;
	    GpiFillPath ( hps , 1L , FPATH_ALTERNATE ) ;
	    GpiSetColor ( hps , vclrHands[SHADE]   ) ;
	    GpiSetCurrentPosition ( hps , aptlHour ) ;
	    GpiPolyLine ( hps , cptlHour , aptlHour ) ;
	    GpiSetColor ( hps , vclrHands[SHADE]   ) ;
	    GpiSetCurrentPosition ( hps , aptlHourLine1 ) ;
	    GpiPolyLine ( hps , 1L , &(aptlHourLine1[1]) ) ;
	    break;
	case HT_HOUR_SHADE:
	    GpiSetModelTransformMatrix ( hps , ( LONG ) MATLF_SIZE ,
					      & matlfShade , TRANSFORM_ADD     ) ;
	    GpiSetColor ( hps , vclrFace [SHADE]   ) ;
	    GpiBeginPath ( hps , 1L ) ;
	    GpiSetCurrentPosition ( hps , aptlHour ) ;
	    GpiPolyLine ( hps , cptlHour , aptlHour ) ;
	    GpiEndPath ( hps ) ;
	    GpiFillPath ( hps , 1L , FPATH_ALTERNATE ) ;
	    break;

	case HT_MINUTE:
	    GpiSetColor ( hps , vclrHands[SURFACE] ) ;
	    GpiBeginPath ( hps , 1L ) ;
	    GpiSetCurrentPosition ( hps , aptlMinute ) ;
	    GpiPolyLine ( hps , cptlMinute , aptlMinute ) ;
	    GpiEndPath ( hps ) ;
	    GpiFillPath ( hps , 1L , FPATH_ALTERNATE ) ;

	    GpiSetColor ( hps , vclrHands[SHADE]   ) ;
	    GpiSetCurrentPosition ( hps , aptlMinute ) ;
	    GpiPolyLine ( hps , cptlMinute , aptlMinute ) ;
	    GpiSetColor ( hps , vclrHands[SHADE]   ) ;
	    GpiSetCurrentPosition ( hps , aptlMinuteLine1 ) ;
	    GpiPolyLine ( hps , 1L , &(aptlMinuteLine1[1]) ) ;
	    GpiSetCurrentPosition ( hps , & ptlOrigin) ;
	    GpiFullArc ( hps , DRO_OUTLINEFILL , MAKEFIXED ( 2 , 0 ) ) ;
	    break;
	case HT_MINUTE_SHADE:
	    GpiSetModelTransformMatrix ( hps , ( LONG ) MATLF_SIZE ,
					      & matlfShade , TRANSFORM_ADD     ) ;
	    GpiSetColor ( hps , vclrFace [SHADE]   ) ;
	    GpiBeginPath ( hps , 1L ) ;
	    GpiSetCurrentPosition ( hps , aptlMinute ) ;
	    GpiPolyLine ( hps , cptlMinute , aptlMinute ) ;
	    GpiEndPath ( hps ) ;
	    GpiFillPath ( hps , 1L , FPATH_ALTERNATE ) ;
	    break;

	case HT_SECOND:
	    /* draw in XOR mixmode, so we can undraw later */
	    GpiSetMix ( hps , FM_INVERT ) ;
	    GpiSetCurrentPosition ( hps , aptlSecond ) ;
	    GpiPolyLine ( hps , cptlSecond , aptlSecond ) ;
	    GpiSetMix ( hps , FM_OVERPAINT ) ;
	    break;
    }
}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ClkDrawFace()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns: VOID
 *
 *
\****************************************************************/
VOID ClkDrawFace ( HPS hps )
{
    BOOL f ;
    static POINTL ptlLight= { -2L , 2L } ;
    static POINTL ptlShade= {  2L, -2L } ;
    static POINTL ptlFace = { 0L, 0L};
    /*	      1		0      0     *\
    *	      0		1      0      *
    \*	    100	      100      1     */

    static MATRIXLF matlfModel = {
	MAKEFIXED ( 1 , 0 ) ,	    MAKEFIXED ( 0 , 0 ) ,	0L ,
	MAKEFIXED ( 0 , 0 ) ,	    MAKEFIXED ( 1 , 0 ) ,	0L ,
	100L ,			    100L ,			1L } ;

    /* center at (100, 100) and draw the clock face */
    f = GpiSetModelTransformMatrix ( hps , ( LONG ) MATLF_SIZE ,
				     & matlfModel , TRANSFORM_REPLACE ) ;


    GpiSetColor ( hps , vclrFace[SURFACE]);
    GpiSetCurrentPosition ( hps , & ptlFace ) ;
    GpiFullArc ( hps , DRO_OUTLINEFILL , MAKEFIXED ( 80, 0 ) ) ;
}


VOID ClkDrawRing ( HPS hps )
{
    BOOL f ;
    static POINTL ptlLight= { -2L , 2L } ;
    static POINTL ptlShade= {  1L, -1L } ;
    static POINTL ptlFace = { 0L, 0L};
    static POINTL ptlShadeIn= { -3L , 3L } ;
    static POINTL ptlLightIn= {	 1L, -1L } ;
    /*	      1		0      0     *\
    *	      0		1      0      *
    \*	    100	      100      1     */

    static MATRIXLF matlfModel = {
	MAKEFIXED ( 1 , 0 ) ,	    MAKEFIXED ( 0 , 0 ) ,	0L ,
	MAKEFIXED ( 0 , 0 ) ,	    MAKEFIXED ( 1 , 0 ) ,	0L ,
	100L ,			    100L ,			1L } ;

    /* center at (100, 100) and draw the clock face */
    f = GpiSetModelTransformMatrix ( hps , ( LONG ) MATLF_SIZE ,
				     & matlfModel , TRANSFORM_REPLACE ) ;

    DrawFullRing(hps,
		    &ptlShade,
		    MAKEFIXED(95,0),
		    MAKEFIXED(99 ,0),
		    vclrRing[SHADE]);

    DrawFullRing(hps,
		    &ptlLight,
		    MAKEFIXED(95,0),
		    MAKEFIXED(98 ,0),
		    vclrRing[LIGHT]   );

    DrawFullRing(hps,
		    &ptlLightIn,
		    MAKEFIXED(88,0),
		    MAKEFIXED(94,0),
		    vclrRing[LIGHT]   );


    DrawFullRing(hps,
		    &ptlShadeIn,
		    MAKEFIXED(86,0),
		    MAKEFIXED(93,0),
		    vclrRing[SHADE]);

    DrawFullRing(hps,
		    &ptlFace ,
		    MAKEFIXED(94,0),
		    MAKEFIXED(98 ,0),
		    vclrRing[SURFACE]);

    GpiSetColor ( hps , vclrFace[SURFACE]);
    GpiSetCurrentPosition ( hps , & ptlFace ) ;
    GpiFullArc ( hps , DRO_OUTLINEFILL , MAKEFIXED ( 91, 0 ) ) ;
}


/**************************************************************************\
*									   *
*	ROUTINE:    ClkDrawDate ( )					   *
*									   *
*	COMMENT:    Draws Date when analog time is displayed		   *
*									   *
\**************************************************************************/
VOID ClkDrawDate (HPS hps, USHORT usDrawMode)
{
    char achFinalDate[9];
    SIZEF sizef;

    static POINTL ptl = { 2 * ZDATE, 3 * ZDATE };
    static POINTL aptlDateShade[ ] = { { 0L , 0L },
				       { 0L , YDATE },
				       { XDATE , YDATE },
				       { XDATE - ZDATE , YDATE - ZDATE },
				       { ZDATE , YDATE - ZDATE },
				       { ZDATE, ZDATE }
				     };
    static POINTL aptlDateLight[ ] = { { 0L , 0L },
				       { XDATE , 0L },
				       { XDATE , YDATE },
				       { XDATE - ZDATE , YDATE - ZDATE },
				       { XDATE - ZDATE, ZDATE },
				       { ZDATE, ZDATE }
				     };
    static POINTL aptlDateBG[] = { {0L ,0L},
				   {XDATE,YDATE} };

    if ((cp.usDispMode & DM_DATE) && (!fIconic)) {

	GetArrangedDate (achFinalDate);

	GpiSetModelTransformMatrix (hps, (LONG)MATLF_SIZE, &vmatlfDateTrans,
		TRANSFORM_REPLACE);
	GpiSetModelTransformMatrix (hps, (LONG)MATLF_SIZE, &vmatlfDateScale,
		TRANSFORM_ADD);

	if (strncmp(achFinalDate, achOldDate, sizeof(achFinalDate) - 1)) {

	    GpiSetColor (hps, vclrDate[BACKGROUND]);
	    GpiSetCurrentPosition (hps, &aptlDateBG[0]);
	    GpiBox (hps, DRO_FILL, &aptlDateBG[1], 0L, 0L);
	    usDrawMode = DM_REDRAW;
	}

	if ((usDrawMode == DM_REDRAW) || (vusDatePos == DP_INSIDE)) {

#ifdef DISABLE
	    WinSetRect(NULL, &rclDateString, 2, 2, XDATE - 2,
		       YDATE - 2);
	    ClkDrawDigitalString(hps, "88888888", &rclDateString,
		    0x00101010, 0x00808080);

#else

	    GpiSetColor (hps, CLR_BLACK);
#ifdef DISABLE
	    GpiSetColor (hps, vclrDate[SURFACE]);
#endif
	    GetArrangedDate (achFinalDate);
	    GpiSetCharMode (hps,CM_MODE3);
	    GpiSetCurrentPosition (hps, &ptl);
	    sizef.cx = MAKEFIXED (10, 0);
	    sizef.cy = MAKEFIXED (YDATE, 0);
	    GpiSetCharBox(hps, &sizef);
	    GpiCharString (hps, (ULONG)sizeof(achFinalDate), (PSZ)achFinalDate);
#endif

	    GpiSetColor (hps, vclrDate[SHADE]);
	    GpiSetCurrentPosition (hps, aptlDateShade);
	    GpiBeginPath (hps, 1L);
	    GpiPolyLine (hps, 5L, &(aptlDateShade[1]));
	    GpiCloseFigure (hps);
	    GpiEndPath (hps);
	    GpiFillPath (hps, 1L, FPATH_ALTERNATE);

	    GpiSetColor (hps, vclrDate[LIGHT]);
	    GpiSetCurrentPosition (hps, aptlDateLight);
	    GpiBeginPath (hps, 1L);
	    GpiPolyLine (hps, 5L, &(aptlDateLight[1]));
	    GpiCloseFigure (hps);
	    GpiEndPath (hps);
	    GpiFillPath (hps, 1L, FPATH_ALTERNATE);
	}
    } else {
	/*
	 * If we're minimized then we need to update the
	 * icontext with the date.
	 */
	if (((cp.usDispMode & (DM_TIME | DM_DATE)) == (DM_TIME | DM_DATE)) &&
		(fIconic)) {
	    GetArrangedDate (achFinalDate);
	    WinSetWindowText (hwndFrame, achFinalDate);
	}
    }
}


/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ClkDrawTicks()
 *
 *  Purpose:Draws Clock Ticks()
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns: VOID
 *
 *
\****************************************************************/
VOID ClkDrawTicks ( HPS hps , USHORT usTicks )
{
    BOOL f ;
    USHORT usAngle,usTrapez ;


    /* prepare a transform to use when rotating the ticks */
    /*	    cos x    - sin x	0     *\
    |	    sin x      cos x	0      |
    \*	    100	       100	1     */

    static MATRIXLF matlfModel = {
	MAKEFIXED ( 1 , 0 ) ,	    MAKEFIXED ( 0 , 0 ) ,	0L ,
	MAKEFIXED ( 0 , 0 ) ,	    MAKEFIXED ( 1 , 0 ) ,	0L ,
	100L ,			    100L ,			1L } ;

    /* define what the tick marks look like */
    static POINTL aptlMajorTick [ ] = { { -3 , 94 } , { 3 , 100 } } ;
    static BYTE	  aclr [12][4] = {
	    /*12*/	  {SHADE,LIGHT,LIGHT,SHADE},
	    /*1*/	  {LIGHT,LIGHT,LIGHT,SHADE},
	    /*2*/	  {LIGHT,LIGHT,SHADE,SHADE},
	    /*3*/	  {LIGHT,LIGHT,SHADE,SHADE},
	    /*4*/	  {LIGHT,LIGHT,SHADE,LIGHT},
	    /*5*/	  {LIGHT,SHADE,SHADE,LIGHT},
	    /*6*/	  {LIGHT,SHADE,SHADE,LIGHT},
	    /*7*/	  {LIGHT,SHADE,SHADE,LIGHT},
	    /*8*/	  {LIGHT,SHADE,LIGHT,LIGHT},
	    /*9*/	  {SHADE,SHADE,LIGHT,LIGHT},
	    /*9*/	  {SHADE,SHADE,LIGHT,LIGHT},
	    /*11*/	  {SHADE,LIGHT,LIGHT,SHADE}
				 };
    static  POINTL aptlMT  [4][4] = {
				  { {-3,81},{-1,83},{1,83},{3,81  }} ,
				  { {-3,81},{-1,83},{-1,87},{-3,89 }} ,
				  { {-3,89},{-1,87},{1,87},{3,89 }} ,
				  { {3,89},{1,87},{1,83},{3,81	}}
				 };
    static POINTL aptlMajorTickShadow [ ] = { { -1 , 83 } , { 1 , 87  } } ;
    static POINTL aptlMinorTick [ ] = { { 0 , 83 } , { 0 , 85 } } ;


    /* have we been asked to draw the major ticks? */
    if ( usTicks & CLK_MAJORTICKS )
	for ( usAngle = 0 ; usAngle < 60 ; usAngle += 5 ) {

	    /* set the rotation transform */
	    matlfModel . fxM11 =
	    matlfModel . fxM22 = fxSin [ ( usAngle + 15 ) % 60 ] ;
	    matlfModel . fxM12 = fxSin [ ( usAngle + 30 ) % 60 ] ;
	    matlfModel . fxM21 = fxSin [ usAngle ] ;
	    f = GpiSetModelTransformMatrix ( hps , ( LONG ) MATLF_SIZE ,
					     & matlfModel ,
					     TRANSFORM_REPLACE ) ;

	    /* draw a major tick mark */
	    for (usTrapez = 0; usTrapez < 4; usTrapez++) {
		DrawTrapez(hps,aptlMT[usTrapez],vclrMajorTicks[aclr[usAngle/5][usTrapez]]);
	    }
	    GpiSetColor ( hps , vclrMajorTicks[SURFACE]) ;
	    GpiSetCurrentPosition ( hps , & aptlMajorTickShadow [ 0 ] ) ;
	    GpiBox ( hps , DRO_FILL , & aptlMajorTickShadow [ 1 ] , 0L , 0L ) ;
    }

    /* have we been asked to draw the minor ticks? */
    /* draw in the default color */
    GpiSetColor ( hps ,vclrMinorTicks[SHADE]  ) ;
    if ( usTicks & CLK_MINORTICKS )
	for ( usAngle = 0 ; usAngle < 60 ; usAngle ++ ) {
	    if ((usAngle % 5) != 0) {

		matlfModel . fxM11 =
		matlfModel . fxM22 = fxSin [ ( usAngle + 15 ) % 60 ] ;
		matlfModel . fxM12 = fxSin [ ( usAngle + 30 ) % 60 ] ;
		matlfModel . fxM21 = fxSin [ usAngle ] ;

		/* set the transform */
		f = GpiSetModelTransformMatrix ( hps , ( LONG ) MATLF_SIZE ,
						 & matlfModel ,
						 TRANSFORM_REPLACE ) ;

		/* draw a minor tick mark */
		GpiSetCurrentPosition ( hps , & aptlMinorTick [ 0 ] ) ;
		GpiBox ( hps , DRO_OUTLINEFILL , & aptlMinorTick [ 1 ] , 0L , 0L ) ;
	    }
    }
}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:DrawTrapez()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
VOID DrawTrapez(HPS hps,POINTL *aptl,LONG color)
{
    GpiSetColor ( hps,color) ;
    GpiBeginPath(hps, 1L);		    /* start the path bracket */
    GpiSetCurrentPosition ( hps ,  aptl	 ) ;
    GpiPolyLine(hps, 3L,&(aptl[1]) );	   /* draw the three sides   */
    GpiCloseFigure(hps);		    /* close the triangle     */
    GpiEndPath(hps);			    /* end the path bracket   */
    GpiFillPath(hps, 1L, FPATH_ALTERNATE);  /* draw and fill the path */
}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    1 - if sucessful execution completed
 *	    0 - if error
\****************************************************************/
#ifdef orchik
VOID ClkDrawTicks ( HPS hps , USHORT usTicks )
{
    BOOL f ;
    USHORT usAngle ;

    /* prepare a transform to use when rotating the ticks */
    /*	    cos x    - sin x	0     *\
    |	    sin x      cos x	0      |
    \*	    100	       100	1     */

    static MATRIXLF matlfModel = {
	MAKEFIXED ( 1 , 0 ) ,	    MAKEFIXED ( 0 , 0 ) ,	0L ,
	MAKEFIXED ( 0 , 0 ) ,	    MAKEFIXED ( 1 , 0 ) ,	0L ,
	100L ,			    100L ,			1L } ;
    static MATRIXLF matlfLight = {
	MAKEFIXED ( 1 , 0 ) ,	    MAKEFIXED ( 0 , 0 ) ,	0L ,
	MAKEFIXED ( 0 , 0 ) ,	    MAKEFIXED ( 1 , 0 ) ,	0L ,
	-1L ,			    1L ,		      1L } ;
    static MATRIXLF matlfShade = {
	MAKEFIXED ( 1 , 0 ) ,	    MAKEFIXED ( 0 , 0 ) ,	0L ,
	MAKEFIXED ( 0 , 0 ) ,	    MAKEFIXED ( 1 , 0 ) ,	0L ,
	 1L ,			   -1L ,		      1L } ;

    /* define what the tick marks look like */
    static POINTL aptlMajorTick [ ] = { { -2 , 91 } , { 2 , 97	} } ;
    static POINTL aptlMajorTickShade [ ] = { { -2 , 91 } , { 2 , 97  } } ;
    static POINTL aptlMajorTickLight [ ] = { { -2 , 91 } , { 2 , 970 } } ;
    static POINTL aptlMinorTick [ ] = { { 0 , 91 } , { 0 , 92 } } ;

    /* draw in the default color */
    GpiSetColor ( hps , CLR_DEFAULT ) ;

    /* have we been asked to draw the major ticks? */
    if ( usTicks & CLK_MAJORTICKS )
	for ( usAngle = 0 ; usAngle < 60 ; usAngle += 5 ) {

	    /* set the rotation transform */
	    matlfModel . fxM11 =
	    matlfModel . fxM22 = fxSin [ ( usAngle + 15 ) % 60 ] ;
	    matlfModel . fxM12 = fxSin [ ( usAngle + 30 ) % 60 ] ;
	    matlfModel . fxM21 = fxSin [ usAngle ] ;
	    /* draw a major tick mark shade*/
	    f = GpiSetModelTransformMatrix ( hps , ( LONG ) MATLF_SIZE ,
					     & matlfModel ,
					     TRANSFORM_REPLACE ) ;
	    f = GpiSetModelTransformMatrix ( hps , ( LONG ) MATLF_SIZE ,
					     & matlfShade ,
					     TRANSFORM_ADD     ) ;
	    GpiSetColor (hps, 0x00C0C0C0);
	    GpiSetCurrentPosition ( hps , & aptlMajorTickShade [ 0 ] ) ;
	    GpiBox ( hps , DRO_FILL , & aptlMajorTick [ 1 ] , 2L , 2L ) ;

	    /*Draw light*/

	    f = GpiSetModelTransformMatrix ( hps , ( LONG ) MATLF_SIZE ,
					     & matlfModel ,
					     TRANSFORM_REPLACE ) ;
	    f = GpiSetModelTransformMatrix ( hps , ( LONG ) MATLF_SIZE ,
					     & matlfLight ,
					     TRANSFORM_ADD     ) ;
	    GpiSetColor(hps, RGB_WHITE);
	    GpiSetCurrentPosition ( hps , & aptlMajorTickLight [ 0 ] ) ;
	    GpiBox ( hps , DRO_FILL , & aptlMajorTick [ 1 ] , 2L , 2L ) ;

	    /*Draw tick mark surface */

	    f = GpiSetModelTransformMatrix ( hps , ( LONG ) MATLF_SIZE ,
					     & matlfModel ,
					     TRANSFORM_REPLACE ) ;
	    GpiSetColor(hps, 0x00808080);
	    GpiSetCurrentPosition ( hps , & aptlMajorTick [ 0 ] ) ;
	    GpiBox ( hps , DRO_FILL , & aptlMajorTick [ 1 ] , 2L , 2L ) ;
    }

    /* have we been asked to draw the minor ticks? */
    if ( usTicks & CLK_MINORTICKS )
	for ( usAngle = 0 ; usAngle < 60 ; usAngle ++ ) {
	    if ((usAngle % 5) != 0) {
		matlfModel . fxM11 =
		matlfModel . fxM22 = fxSin [ ( usAngle + 15 ) % 60 ] ;
		matlfModel . fxM12 = fxSin [ ( usAngle + 30 ) % 60 ] ;
		matlfModel . fxM21 = fxSin [ usAngle ] ;

		/* set the transform */
		f = GpiSetModelTransformMatrix ( hps , ( LONG ) MATLF_SIZE ,
						 & matlfModel ,
						 TRANSFORM_REPLACE ) ;

		/* draw a minor tick mark */
		GpiSetCurrentPosition ( hps , & aptlMinorTick [ 0 ] ) ;
		GpiLine ( hps , & aptlMinorTick [ 1 ] ) ;
	    }
    }
}

#endif
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:DrawFullRing()
 *
 *  Purpose: This routine draws the ring for the clock face.
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
VOID DrawFullRing(HPS hps,PPOINTL pptlCenter,FIXED fxRadIn, FIXED fxRadOut,
		     LONG lColor)
{
    GpiSetColor(hps,lColor);
    GpiSetCurrentPosition ( hps , pptlCenter );
    GpiBeginPath(hps,1L);
    GpiFullArc ( hps , DRO_OUTLINE ,  fxRadIn  ) ;
    GpiFullArc ( hps , DRO_OUTLINE ,  fxRadOut	) ;
    GpiCloseFigure(hps);
    GpiEndPath(hps);
    GpiFillPath ( hps , 1L , FPATH_ALTERNATE ) ;
}


/*--------------------------------------------------------------*\
 *  End of file :paint.c
\*--------------------------------------------------------------*/
/*+--------------------------------------------------------------------------+*/
/*|									     |*/
/*| PROGRAM NAME: PALETTE						     |*/
/*| -------------							     |*/
/*|  A PM program demonstrating vector fonts, palette manager APIs, and IPF  |*/
/*|  help.								     |*/
/*|									     |*/
/*| COPYRIGHT:								     |*/
/*| ----------								     |*/
/*|  Copyright (C) International Business Machines Corp., 1992		     |*/
/*|									     |*/
/*| DISCLAIMER OF WARRANTIES:						     |*/
/*| -------------------------						     |*/
/*|  The following [enclosed] code is sample code created by IBM Corporation.|*/
/*|  This sample code is not part of any standard IBM product and is provided|*/
/*|  to you solely for the purpose of assisting you in the development of    |*/
/*|  your applications.	 The code is provided "AS IS", without warranty of   |*/
/*|  any kind.	IBM shall not be liable for any damages arising out of your  |*/
/*|  use of the sample code, even if they have been advised of the	     |*/
/*|  possibility of such damages.					     |*/
/*|									     |*/
/*| REVISION LEVEL: 1.0							     |*/
/*| ---------------							     |*/
/*|									     |*/
/*| WHAT THIS PROGRAM DOES:						     |*/
/*| -----------------------						     |*/
/*|  This program displays a standard window and then draws the IBM logo     |*/
/*|  in the window.  The logo is done using a vector font.  Then a palette   |*/
/*|  is created and rotated in another thread.				     |*/
/*|									     |*/
/*| WHAT THIS PROGRAM DEMONSTRATES:					     |*/
/*| -------------------------------					     |*/
/*|  This program demonstrates how to create and display a standard window,  |*/
/*|  use switched menus, use a second thread for drawing, modify a palette   |*/
/*|  using some basic GPI calls, and display vectored fonts.		     |*/
/*|									     |*/
/*| APIs CALLED:							     |*/
/*| ------------							     |*/
/*|    WinInitialize							     |*/
/*|    WinCreateMsgQueue						     |*/
/*|    WinRegisterClass							     |*/
/*|    WinCreateHelpInstance						     |*/
/*|    WinDestroyHelpInstance						     |*/
/*|    WinCreateStdWindow						     |*/
/*|    WinGetLastError							     |*/
/*|    WinShowWindow							     |*/
/*|    WinAssociateHelpInstance						     |*/
/*|    WinGetMsg							     |*/
/*|    WinDispatchMsg							     |*/
/*|    WinReleasePS							     |*/
/*|    WinDestroyHelpInstance						     |*/
/*|    WinDestroyWindow							     |*/
/*|    WinDestroyMsgQueue						     |*/
/*|    WinTerminate							     |*/
/*|    WinRequestMutexSem						     |*/
/*|    WinRealizePalette						     |*/
/*|    DosReleaseMutexSem						     |*/
/*|    DosCreateMutexSem						     |*/
/*|    WinOpenWindowDC							     |*/
/*|    GpiCreatePS							     |*/
/*|    DevQueryCaps							     |*/
/*|    DosCreateThread							     |*/
/*|    WinQueryWindowRect						     |*/
/*|    WinPostMsg							     |*/
/*|    WinWindowFromID							     |*/
/*|    WinSetMenuItemText						     |*/
/*|    WinInvalidateRect						     |*/
/*|    WinDlgBox							     |*/
/*|    WinSendMsg							     |*/
/*|    WinBeginPaint							     |*/
/*|    WinFillRect							     |*/
/*|    GpiQueryFonts							     |*/
/*|    GpiCreateLogFont							     |*/
/*|    GpiSetCharSet							     |*/
/*|    GpiSetCharBox							     |*/
/*|    GpiQueryTextBox							     |*/
/*|    GpiBeginPath							     |*/
/*|    GpiMove								     |*/
/*|    GpiCharString							     |*/
/*|    GpiEndPath							     |*/
/*|    GpiSetClipPath							     |*/
/*|    WinEndPaint							     |*/
/*|    WinDefWindowProc							     |*/
/*|    WinDismissDlg							     |*/
/*|    WinDefDlgProc							     |*/
/*|    GpiCreatePalette							     |*/
/*|    GpiSelectPalette							     |*/
/*|    GpiSetColor							     |*/
/*|    GpiLine								     |*/
/*|    DosSleep								     |*/
/*|    GpiAnimatePalette						     |*/
/*|    GpiDeletePalette							     |*/
/*|    DosExit								     |*/
/*|    WinAlarm								     |*/
/*|    WinMessageBox							     |*/
/*|									     |*/
/*|									     |*/
/*| WHAT YOU NEED TO COMPILE THIS PROGRAM:				     |*/
/*| --------------------------------------				     |*/
/*|									     |*/
/*|  REQUIRED FILES:							     |*/
/*|  ---------------							     |*/
/*|									     |*/
/*|    PALETTE.C      - Source code					     |*/
/*|    PALETTE.MAK    - Make file for this program			     |*/
/*|    PALETTE.DEP    - Dependency file for this program		     |*/
/*|    PALETTE.DEF    - Module definition file				     |*/
/*|    PALETTE.H      - Application header file				     |*/
/*|    PALETTE.ICO    - Icon file					     |*/
/*|    PALETTE.RC     - Resource file					     |*/
/*|    PALETTE.IPF    - Documentation file for this program		     |*/
/*|    PALETTE.DLG    - Dialog file					     |*/
/*|									     |*/
/*|    OS2.H	      - Presentation Manager include file		     |*/
/*|    STDLIB.H	      - Standard library function declarations		     |*/
/*|    ...								     |*/
/*|									     |*/
/*|  REQUIRED LIBRARIES:						     |*/
/*|  -------------------						     |*/
/*|									     |*/
/*|    OS2386.LIB     - OS/2 API Library				     |*/
/*|									     |*/
/*|  REQUIRED PROGRAMS:							     |*/
/*|  ------------------							     |*/
/*|									     |*/
/*|    IBM C Set/2 Compiler (icc.exe	)				     |*/
/*|    IBM Linker	    (link386.exe)				     |*/
/*|    Resource Compiler    (rc.exe	)				     |*/
/*|    Help Compiler	    (ipfc.exe	)				     |*/
/*|									     |*/
/*+--------------------------------------------------------------------------+*/

/*+--------------------------------------------------------------------------+*/
/*| System and library header files.					     |*/
/*+--------------------------------------------------------------------------+*/

#define INCL_WINWINDOWMGR
#define INCL_WINMESSAGEMGR
#define INCL_WINHELP
#define INCL_WINFRAMEMGR
#define INCL_WINERRORS
#define INCL_WINPALETTE
#define INCL_GPICONTROL
#define INCL_WINMENUS
#define INCL_WINDIALOGS
#define INCL_GPILCIDS
#define INCL_GPIPRIMITIVES
#define INCL_GPIPATHS
#define INCL_GPILOGCOLORTABLE
#define INCL_DOSSEMAPHORES
#define INCL_DOSPROCESS
#define INCL_DEV
#include <os2.h>

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include "palette.h"

/*
 * Globals
 */

HAB	hab;
HPAL	hPal = NULLHANDLE;
HRGN	hrgn = NULLHANDLE;
HDC	hdc =  NULLHANDLE;
HMQ	hmqPalette;
HWND	hwndPalette;
HWND	hwndPaletteFrame;
CHAR	szClassName[]	= "Palette";
CHAR	szMessage[]	= "Palette Manager Sample";


/*
 * Status Flags For the options menu
 */

#define SLOW_VALUE    100LU
#define MEDIUM_VALUE  10LU		    /* Set speed constants	      */
#define FAST_VALUE     0LU

BOOL  speedSlow	     = FALSE;
BOOL  speedMedium    = TRUE;		    /* Initial Speed		      */
BOOL  speedFast	     = FALSE;
ULONG animationSpeed = MEDIUM_VALUE;

BOOL  logoIBM	     = FALSE;		    /* Initial Text		      */
BOOL  logoOS2	     = TRUE;

/*
 * Palette Drawing Thread Globals
 */

static LONG    lMessageCount = 0L;
static BOOL    fPaletteCaps = TRUE;    /* Palette Manager capabilities?	 */
static SHORT   cxClient, cyClient;     /* client window X and Y size	 */
static USHORT  threadRun = FALSE;      /* non-zero means draw lines	 */
static HMTX    hmtxPS	 = NULLHANDLE; /* PS access semaphore		 */
static HPS     hpsBuffer = NULLHANDLE; /* Pres. space for memory buffer	 */

#define PAL_COUNT 128L	     /* For the purposes of this example we will be   */
ULONG alTable[PAL_COUNT];    /*	       using 128 palette entries.	      */

#define MSG_BOX_ID     256		    /* error message box id	      */


/*
 * Required IPF Structure Declarations
 */

HELPINIT hmiHelpData;			    /* Help initialization structure  */
HWND	 hwndHelpInstance;		    /* Handle to Help window	      */


/*
 * Main routine...initializes window and message queue
 */
int main( )
{
   QMSG qmsg;
   ULONG ctldata;

   /*
    * Create your hab, hmq, and register a class.
    */

   hab = WinInitialize(0LU);

   hmqPalette = WinCreateMsgQueue(hab, 0L);

   WinRegisterClass( hab,
		     (PSZ)szClassName,
		     (PFNWP)PaletteWndProc,
		     CS_SIZEREDRAW,
		     0LU);

   /*+-----------------------------------------+*/
   /*| IPF Initialization Structure	       |*/
   /*+-----------------------------------------+*/

   hmiHelpData.cb			= sizeof(HELPINIT);
   hmiHelpData.ulReturnCode		= 0LU;
   hmiHelpData.pszTutorialName		= (PSZ)NULL;
   hmiHelpData.phtHelpTable	 = (PHELPTABLE)MAKELONG(MAIN_HELPTABLE, 0xFFFF);
   hmiHelpData.hmodAccelActionBarModule = NULLHANDLE;
   hmiHelpData.idAccelTable		= 0;
   hmiHelpData.idActionBar		= 0;
   hmiHelpData.pszHelpWindowTitle	= "Palette Help";
   hmiHelpData.hmodHelpTableModule	= NULLHANDLE;
   hmiHelpData.fShowPanelId		= CMIC_HIDE_PANEL_ID;
   hmiHelpData.pszHelpLibraryName	= "PALETTE.HLP";


   /*+------------------------------------------+*/
   /*| Create Instance of IPF			|*/
   /*|						|*/
   /*| pass Anchor Block handle and address of	|*/
   /*| IPF initialization structure, and check	|*/
   /*| that creation was successful.		|*/
   /*+------------------------------------------+*/

   if((hwndHelpInstance = WinCreateHelpInstance(hab, &hmiHelpData))==NULLHANDLE)
      mprintf("Help Creation Error");

   else if (hmiHelpData.ulReturnCode)
   {
      mprintf("Help Terminated Due to Error %ld",
	       hmiHelpData.ulReturnCode);

      WinDestroyHelpInstance(hwndHelpInstance);
   }


   /*
    * Create a standard pm window and check
    * that creation was successful.
    */

   ctldata = FCF_STANDARD;

   hwndPaletteFrame = WinCreateStdWindow( HWND_DESKTOP,
					  WS_VISIBLE,
					  &ctldata,
					  szClassName,
					  szMessage,
					  0LU,
					  NULLHANDLE,
					  ID_WINDOW,
					  &hwndPalette );
   if (hwndPaletteFrame == NULLHANDLE)
   {
      mprintf("WinCreateStdWindow error: 0x%04x", WinGetLastError(hab));
      return 0;
   }
   WinShowWindow( hwndPaletteFrame, TRUE );


   /*+-----------------------------------------+*/
   /*| Associate Instance of IPF	       |*/
   /*|					       |*/
   /*| pass handle to Help Window and handle   |*/
   /*| to frame window with which Help is      |*/
   /*| to be associated.		       |*/
   /*+-----------------------------------------+*/

   if (hwndHelpInstance)
      WinAssociateHelpInstance(hwndHelpInstance, hwndPaletteFrame);


   /*
    * Poll messages from event queue
    */

   while( WinGetMsg( hab, (PQMSG)&qmsg, (HWND)NULLHANDLE, 0LU, 0LU ) )
      WinDispatchMsg( hab, (PQMSG)&qmsg );


   /*
    * Clean up
    */

   if(hpsBuffer)
      WinReleasePS( hpsBuffer );
   if(hwndHelpInstance)
      WinDestroyHelpInstance( hwndHelpInstance );
   if(hwndPaletteFrame)
      WinDestroyWindow( hwndPaletteFrame );
   if(hmqPalette)
      WinDestroyMsgQueue( hmqPalette );
   WinTerminate( hab );
   return 0;
} /*  end of main()  */


/*
 * This routine processes WM_COMMAND, WM_PAINT.	 It passes
 * everything else to the Default Window Procedure.
 */
MRESULT EXPENTRY PaletteWndProc(
   HWND	  hwnd,
   ULONG  msg,
   MPARAM mp1,
   MPARAM mp2 )
{
   static  RECTL  rctlClient, rctlSize;	      /* client rectl's               */
   TID	   tidDrawing;			      /* drawing thread identifier    */
   ULONG   cclr;
   HPS	   hps;
   HWND	   hwndMenu;			      /* Handle for the Menu bar      */


   switch (msg)
   {

      /*+-----------------------------------------------------------------+*/
      /*| In this example, the WinRealizePalette call is issued in	  |*/
      /*| response to a WM_REALIZEPALETTE. This ensures that the palette  |*/
      /*| is appropriately realized for all drawing operations.		  |*/
      /*+-----------------------------------------------------------------+*/

   case WM_REALIZEPALETTE:
	 WinRequestMutexSem( hmtxPS, SEM_INDEFINITE_WAIT );
	 WinRealizePalette(hwnd, hpsBuffer, &cclr);
	 DosReleaseMutexSem( hmtxPS );
      break;


   case WM_CREATE:

   {
      SIZEL sizl = { 0L, 0L };
      LONG  alCaps[CAPS_PHYS_COLORS];
      LONG lCount = CAPS_PHYS_COLORS;
      LONG lStart = CAPS_FAMILY;

      /*+-----------------------------------------------------------------+*/
      /*| The client window is being created.  Create the semaphore to	  |*/
      /*| control access to the presentation space.  Then create the	  |*/
      /*| thread that will draw the lines.				  |*/
      /*+-----------------------------------------------------------------+*/

      DosCreateMutexSem( (PSZ)NULL, &hmtxPS, 0UL, FALSE );

      hdc = WinOpenWindowDC(hwnd);

      /*+-----------------------------------------------------------------+*/
      /*| Create a non-cached presentation space.  We will not release	  |*/
      /*| this PS, as we will be Selecting a Palette to this PS and then  |*/
      /*| animating the palette.  Upon releasing a PS the palette is no	  |*/
      /*| longer selected for obvious reasons.				  |*/
      /*+-----------------------------------------------------------------+*/

      hpsBuffer = GpiCreatePS( hab,
			       hdc,
			       &sizl,
			       PU_PELS | GPIF_DEFAULT |
			       GPIT_MICRO | GPIA_ASSOC );

      DevQueryCaps( hdc, lStart, lCount, alCaps );
      fPaletteCaps = alCaps[CAPS_ADDITIONAL_GRAPHICS] & CAPS_PALETTE_MANAGER;

      if ( PaletteInit() )
	 break;

      threadRun = TRUE;

      DosCreateThread( &tidDrawing,
		       (PFNTHREAD) DrawingThread,
		       0UL,
		       0UL,
		       8192UL );

      break;
   }

   case WM_SIZE:
      /*+-----------------------------------------------------------------+*/
      /*| Window is being resized so get new client window size and	  |*/
      /*| recompute the end points for the lines.			  |*/
      /*+-----------------------------------------------------------------+*/

      WinQueryWindowRect(hwnd,&rctlSize);

      cxClient = SHORT1FROMMP( mp2 );	    /* Get new client window size     */
      cyClient = SHORT2FROMMP( mp2 );
      break;

   case WM_SHOW:
      if ( (lMessageCount == 0L) && !fPaletteCaps )
      {
	 lMessageCount +=
	 mprintf("Palette animation is not supported on this display.");
      }
      break;

   case WM_INITMENU:
      switch (LOUSHORT(mp1))
      {
	 case IDM_OPTIONS:
	    hwndMenu = WinWindowFromID( hwndPaletteFrame, /* Get Menu Handle  */
					FID_MENU );
	    WinEnableMenuItem(hwndMenu, IDM_SPEED,     fPaletteCaps);
	    WinEnableMenuItem(hwndMenu, IDM_STARTSTOP, fPaletteCaps);
	    break;

	 case IDM_SPEED:
	    SetPulldownState(hwndPaletteFrame, IDM_SPEEDSLOW  , speedSlow);
	    SetPulldownState(hwndPaletteFrame, IDM_SPEEDMEDIUM, speedMedium);
	    SetPulldownState(hwndPaletteFrame, IDM_SPEEDFAST  , speedFast);
	    break;

	 case IDM_LOGO:
	    SetPulldownState(hwndPaletteFrame, IDM_LOGOIBM    , logoIBM);
	    SetPulldownState(hwndPaletteFrame, IDM_LOGOOS2    , logoOS2);
	    break;
      }
      break;


   case WM_COMMAND:
      switch (LOUSHORT(mp1))
      {
	 case IDM_EXIT:
	    WinPostMsg(hwnd, WM_CLOSE, MPVOID, MPVOID);
	    break;

	 case IDM_STARTSTOP:
	    hwndMenu = WinWindowFromID( hwndPaletteFrame, /* Get Menu Handle  */
					FID_MENU );

	    if ( speedSlow || speedMedium || speedFast	) /* If running->stop */
	    {
	       speedSlow   = FALSE;
	       speedMedium = FALSE;			  /* Set no speed     */
	       speedFast   = FALSE;

	       WinSetMenuItemText( hwndMenu,		  /* Change Menu Text */
				   IDM_STARTSTOP,	  /* ID# for old text */
				   "Start" );		  /* 'Change To' text */
	    }
	    else				     /* If stopped then start */
	    {
	       if ( animationSpeed == SLOW_VALUE )
		    speedSlow	= TRUE;
	       if ( animationSpeed == MEDIUM_VALUE )	  /* Reset proper flag */
		    speedMedium = TRUE;
	       if ( animationSpeed == FAST_VALUE )
		    speedFast	= TRUE;

	       WinSetMenuItemText( hwndMenu,		  /* Change Menu Text */
				   IDM_STARTSTOP,	  /* ID# for old text */
				   "Stop" );		  /* 'Change To' text */
	    }
	    break;


	 case IDM_SPEEDSLOW:
	    speedSlow	= TRUE;
	    speedMedium = FALSE;
	    speedFast	= FALSE;
	    animationSpeed = SLOW_VALUE;
	    break;

	 case IDM_SPEEDMEDIUM:
	    speedSlow	= FALSE;
	    speedMedium = TRUE;
	    speedFast	= FALSE;
	    animationSpeed = MEDIUM_VALUE;
	    break;

	 case IDM_SPEEDFAST:
	    speedSlow	= FALSE;
	    speedMedium = FALSE;
	    speedFast	= TRUE;
	    animationSpeed = FAST_VALUE;
	    break;

	 case IDM_LOGOIBM:
	    logoIBM = TRUE;
	    logoOS2 = FALSE;
	    WinInvalidateRect(hwnd, &rctlSize, FALSE);
	    break;

	 case IDM_LOGOOS2:
	    logoIBM = FALSE;
	    logoOS2 = TRUE;
	    WinInvalidateRect(hwnd, &rctlSize, FALSE);
	    break;

	 case IDM_HELPABOUT:		   /* DISPLAY HELP ABOUT DIALOG	      */
	    WinDlgBox(HWND_DESKTOP,	   /* MAKE THE DESKTOP THE PARENT     */
		      hwnd,		   /* OWNED BY THE CLIENT WINDOW      */
		      (PFNWP) AboutDlgProc,/* ADDRESS OF THE DIALOG PROCEDURE */
		      NULLHANDLE,	   /* MODULE HANDLE		      */
		      IDD_PRODUCTINFO,	   /* DIALOG IDENTIFIER IN RESOURCE   */
		      (PVOID)NULL);	   /* INITIALIZATION DATA	      */

	    WinInvalidateRect(hwnd, &rctlSize, FALSE);	    /* Refresh Window */
	    break;

	 case IDM_HELPFORHELP:
	    if (hwndHelpInstance)
	    {
	       WinSendMsg( hwndHelpInstance, HM_DISPLAY_HELP, MPVOID, MPVOID);
	    }
	   break;

	 case IDM_HELP_INDEX:
	    if (hwndHelpInstance)
	    {
	       WinSendMsg(hwndHelpInstance, HM_HELP_CONTENTS, MPVOID, MPVOID);
	    }
	    break;

	 case IDM_EXTENDED_HELP:
	    if (hwndHelpInstance)
	    {
	       WinSendMsg(hwndHelpInstance, HM_DISPLAY_HELP,
	       MPFROMSHORT(IDM_EXTENDED_HELP), HM_RESOURCEID);
	    }
	    break;

	 case IDM_KEYS_HELP:
	    if (hwndHelpInstance)
	    {
	       WinSendMsg( hwndHelpInstance,
			   HM_DISPLAY_HELP,
			   MPFROM2SHORT(IDM_KEYS_HELP, 0),
			   MPFROMSHORT(HM_RESOURCEID));
	    }
	    break;

	 default:
	    break;

      } /* end of switch within case WM_COMMAND */
      break;

   case WM_PAINT:

      /*+------------------------------------------------------+*/
      /*| Since there will be two threads painting on the same |*/
      /*| frame we will use a semaphore to resolve contention. |*/
      /*+------------------------------------------------------+*/

      WinRequestMutexSem( hmtxPS, SEM_INDEFINITE_WAIT );

      /*
       * Get a cached micro presentation space.
       */
      hps = WinBeginPaint( hwnd, NULLHANDLE, &rctlClient );

      /*
       * Fill the rectangle with the backgound color.
       */
      WinFillRect( hps, &rctlClient, CLR_BLACK );

      /*+-------------------------------------------------+*/
      /*| The following code segment loads a vector font  |*/
      /*| scales it to fit in the window and draws it	  |*/
      /*| vertically and horizontally centered.		  |*/
      /*+-------------------------------------------------+*/
      {
	 POINTL	      ptl;
	 SIZEF	      sizfx;
	 FATTRS	      fattrs;
	 ULONG	      min;
	 LONG	      cFonts, lTemp = 0L;
	 PFONTMETRICS pfm;
	 LONG	      lcid = 1L;
	 CHAR	      fontName[25],outText[25];
	 USHORT	      codePage;


	 min = (cxClient<cyClient) ? cxClient : cyClient;
	 min /= 3;

	 if(logoIBM)
	 {
	    strcpy(fontName,"Symbol Set");
	    codePage = 65400;
	    strcpy(outText,"");
	 }
	 else
	 {
	    /*+-------------------------------------------+*/
	    /*| Define "Helvetica Bold" vector font,	  |*/
	    /*| "Courier Bold" and "Times New Roman Bold" |*/
	    /*| are examples of other vector fonts.	  |*/
	    /*+-------------------------------------------+*/
	    strcpy(fontName,"Helvetica Bold");
	    codePage = 850;
	    strcpy(outText,"OS/2");
	 }

	 cFonts = GpiQueryFonts(hpsBuffer, QF_PUBLIC, fontName, &lTemp,
	     (LONG) sizeof(FONTMETRICS), (PFONTMETRICS)NULL);

	 if(cFonts > 0L)
	 {
	    pfm = malloc(sizeof(FONTMETRICS) * cFonts);
	    GpiQueryFonts(hpsBuffer, QF_PUBLIC, fontName, &cFonts,
			  (LONG) sizeof(FONTMETRICS), pfm);
	    fattrs.lMatch	   = pfm[0].lMatch;
	    strcpy(fattrs.szFacename, pfm[0].szFacename);
	 }
	 else
	 {
	    fattrs.lMatch = 0L;
	    strcpy(fattrs.szFacename, "");
	 }

	 fattrs.usRecordLength	= sizeof(FATTRS);
	 fattrs.fsSelection	= FATTR_SEL_OUTLINE;
	 fattrs.idRegistry	= 0;
	 fattrs.usCodePage	= codePage;
	 fattrs.lMaxBaselineExt = 0L;
	 fattrs.lAveCharWidth	= 0L;
	 fattrs.fsType		= 0;
	 fattrs.fsFontUse	= FATTR_FONTUSE_OUTLINE;

	 GpiCreateLogFont(hpsBuffer, (PSTR8)NULL, lcid, &fattrs);
	 GpiSetCharSet(hpsBuffer, lcid);

	 sizfx.cx = MAKEFIXED(min, 0);
	 sizfx.cy = MAKEFIXED(min, 0);
	 GpiSetCharBox(hpsBuffer, &sizfx);

	 /*+------------------------------------------------+*/
	 /*| CALCULATE THE POINT TO START THE CENTERED TEXT |*/
	 /*+------------------------------------------------+*/
	 {
	    POINTL aptl[TXTBOX_COUNT];

	    GpiQueryTextBox(hpsBuffer,
			    strlen(outText),
			    outText,
			    TXTBOX_COUNT,      /* return maximum information  */
			    aptl);	       /* array of coordinates points */
					       /* in world coordinates.	      */


	    ptl.x = (cxClient - aptl[TXTBOX_TOPRIGHT].x) / 2;
	    ptl.y = (cyClient - aptl[TXTBOX_TOPRIGHT].y) / 2;

	 }


	 /*+-------------------------------------------+*/
	 /*| Now that we have our vector font and      |*/
	 /*| location to place on the screen, let's    |*/
	 /*| create a Path using the outline font.     |*/
	 /*+-------------------------------------------+*/

	 GpiBeginPath(hpsBuffer,1L);

	 GpiMove(hpsBuffer,&ptl);
	 GpiCharString(hpsBuffer, strlen(outText), outText);

	 GpiEndPath(hpsBuffer);

	 /*+-----------------------------------------+*/
	 /*| Next let's erase the current clip path  |*/
	 /*| and assign the above outline font path  |*/
	 /*| as a clip path to the current hps.	     |*/
	 /*+-----------------------------------------+*/

	 GpiSetClipPath(hpsBuffer,
		0L,
		FPATH_ALTERNATE);

	 GpiSetClipPath(hpsBuffer,
		1L,
		FPATH_ALTERNATE | SCP_AND);


	 /*+-------------------------------------------+*/
	 /*| Lastly draw a series of lines which will  |*/
	 /*| be clipped to attached clip path.	       |*/
	 /*| *Draw on the Char Box		       |*/
	 /*+-------------------------------------------+*/

	 DrawPaletteLines(rctlSize,
			  PAL_COUNT,
			  hpsBuffer);

	 if(pfm)
	    free(pfm);
      }


      /*
       * Release the cached micro presentation space.
       */
      WinEndPaint( hps );

      /*+------------------------------------------------------+*/
      /*| Release the semaphore, thereby allowing the other    |*/
      /*| thread to paint.				       |*/
      /*+------------------------------------------------------+*/

      DosReleaseMutexSem( hmtxPS );
      break;

   default:
      return WinDefWindowProc(hwnd, msg, mp1, mp2);

   }
   return MRFROMLONG(0L);
}   /*	end of PaletteWndProc()	 */



/*+--------------------------------------------------------------------------+*/
/*| AboutDlgProc - Help About Dialog Procedure				     |*/
/*+--------------------------------------------------------------------------+*/

MRESULT EXPENTRY AboutDlgProc( HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   switch( msg )
   {
   case WM_COMMAND:	     /* DISMISS DIALOG */
      WinDismissDlg( hwndDlg, TRUE );
      break;

   default:
      return (WinDefDlgProc( hwndDlg, msg, mp1, mp2 ));
   }
   return MRFROMLONG(0L);
}  /*  end of AboutDlgProc()  */



/*+--------------------------------------------------------------------------+*/
/*| PaletteInit - Initializes the palette in the client window.		     |*/
/*+--------------------------------------------------------------------------+*/
LONG PaletteInit()
{
   LONG	   i;
   LONG	   ret = 0L;
   ULONG   cclr;

   WinRequestMutexSem( hmtxPS, SEM_INDEFINITE_WAIT );

   /*+--------------------------------------------------------------+*/
   /*| Create entry with shades of blue if animation is supported,  |*/
   /*| solid blue otherwise.					    |*/
   /*+--------------------------------------------------------------+*/

   for (i=0L; (ULONG)i < PAL_COUNT; i++)
   {
      LONG index = 222L;    /*	use if no animation  */

      /*+----------------------------------------------------+*/
      /*| INDEX = 128 POINTS EVENLY SPACED BETWEEN 1 AND 255 |*/
      /*+----------------------------------------------------+*/
      if(fPaletteCaps)
	 index = ((float) (i + 1L) * 255.0) / (float) PAL_COUNT;

      alTable[i] = PC_RESERVED * 16777216 + LONGFromRGB(0, 0, index); /* BLUE */

   }

   hPal = GpiCreatePalette( hab,
			    (ULONG) LCOL_PURECOLOR,
			    (ULONG) LCOLF_CONSECRGB,
			    PAL_COUNT,
			    alTable );

   if( hPal == NULLHANDLE || hPal == GPI_ERROR)
   {
      DosReleaseMutexSem( hmtxPS );
      mprintf("GpiCreatePalette Error 0x%04x",ret = WinGetLastError(hab));
   }

   else if(GpiSelectPalette(hpsBuffer, hPal ) == PAL_ERROR)
   {
      DosReleaseMutexSem( hmtxPS );
      mprintf("GpiSelectPalette Error 0x%04x", ret = WinGetLastError(hab));
   }

   else if( WinRealizePalette(hwndPalette,hpsBuffer,&cclr) == PAL_ERROR)
   {
      DosReleaseMutexSem( hmtxPS );
      mprintf("WinRealizePalette Error 0x%04x", ret = WinGetLastError(hab));
   }

   else
   {
      DosReleaseMutexSem( hmtxPS );
   }

   return ret;
}  /*  end of PaletteInit()  */


/*+--------------------------------------------------------------------------+*/
/*| DrawPaletteLines - Procedure that draws the lines in the passed box.     |*/
/*+--------------------------------------------------------------------------+*/
VOID DrawPaletteLines(RECTL  rctl,
		      ULONG ulPalCount,
		      HPS hps)
{
   LONG	 color = 0L;		     /* foreground (line) color	     */
   POINTL ptl1,ptl2;

   ptl1.x = rctl.xLeft;
   ptl1.y = rctl.yTop;
   ptl2.x = rctl.xLeft;
   ptl2.y = rctl.yBottom;

   while(ptl1.x <= rctl.xRight)
   {
      if ( (ULONG) color >= ulPalCount )
	  color = 0L;
      else
	  color++;		     /* Increment foreground color   */

      ptl1.x ++;
      ptl2.x ++;

      GpiSetColor( hps, color );
      GpiMove( hps, &ptl1 );	     /* Move to start point	     */
      GpiLine( hps, &ptl2 );	     /* Draw new line		     */
    }
}  /*  end of DrawPaletteLines()  */



/*+--------------------------------------------------------------------------+*/
/*| DrawingThread - Procedure that animates the palette in the client window.|*/
/*+--------------------------------------------------------------------------+*/
static void _System DrawingThread( ULONG ulThreadArg )
{
   HAB	 habThread2;		   /* Anchor block handle for thread */
   HMQ	 hmqThread2;		   /* Queue handle for thread	     */
   int	 i;

   habThread2 = WinInitialize( 0LU );
   hmqThread2 = WinCreateMsgQueue( habThread2, 0L );

   while ( threadRun )
   {
      LONG temp;


/*+--------------------------------------------------------------------------+*/
/*|	The following if clause puts this thread to sleep as long as there   |*/
/*| is no speed flag set, i.e. the animation is 'Stop'ed.		     |*/
/*|	The else clause continues rotating the palette.			     |*/
/*+--------------------------------------------------------------------------+*/
      if (!speedSlow && !speedMedium && !speedFast )
      {
	 DosSleep(500LU);
      }
      else
      {
	 /*+-----------------------------------------------------------+*/
	 /*| Request PS semaphore so that main thread does NOT use it. |*/
	 /*+-----------------------------------------------------------+*/

	 WinRequestMutexSem( hmtxPS, SEM_INDEFINITE_WAIT );

	 temp = alTable[ 0 ];
	 for(i = 0; (ULONG) i < PAL_COUNT - 1; i++)
	 {
	    alTable[ i ] = alTable[ i + 1 ];
	 }
	 alTable[ PAL_COUNT - 1 ] = temp;

	 GpiAnimatePalette( hPal,
			    LCOLF_CONSECRGB,
			    0LU,
			    PAL_COUNT,
			    alTable);

	 /*+-----------------------+*/
	 /*| Release PS semaphore. |*/
	 /*+-----------------------+*/

	 DosReleaseMutexSem( hmtxPS );

	 /*+---------------------------------------------+*/
	 /* Surrender rest of timeslice to other threads. */
	 /* Never do a DosSleep(0) as this will not give  */
	 /* lower priority threads a time slice		  */
	 /*+---------------------------------------------+*/

	 if(animationSpeed) DosSleep( animationSpeed );
      }
   }


   /*+----------------------------------------+*/
   /*| Clean up and terminate drawing thread. |*/
   /*+----------------------------------------+*/

   if(hPal)
      GpiDeletePalette( hPal );
   if(hmqThread2)
      WinDestroyMsgQueue( hmqThread2 );
   WinTerminate( habThread2 );
   DosExit( EXIT_THREAD, 0LU );
}     /*  end of DrawingThread()  */



/*+--------------------------------------------------------------------------+*/
/*|									     |*/
/*| FUNCTION NAME: mprintf						     |*/
/*| --------------							     |*/
/*|  A PM function for displaying a message box with a printf type format.   |*/
/*|									     |*/
/*| EXPECTED INPUT:							     |*/
/*| ---------------							     |*/
/*|  See the definition of printf.					     |*/
/*|									     |*/
/*| EXPECTED OUTPUT:							     |*/
/*| ----------------							     |*/
/*|  Message Box							     |*/
/*|									     |*/
/*| NOTES								     |*/
/*| ----------------							     |*/
/*|  One must be careful not to call this within a paint routine, because    |*/
/*|  the closing of the message box will generate another paint message.     |*/
/*|									     |*/
/*+--------------------------------------------------------------------------+*/
LONG mprintf(PSZ format, ...)
{
   va_list pArg;
   PSZ	   buffer;
   LONG	   lCount;

   WinAlarm( HWND_DESKTOP, WA_ERROR );

   if(!(buffer = malloc(513)))
      return 0L;

   va_start(pArg, format);

   lCount = vsprintf(buffer, format, pArg);

   WinMessageBox( HWND_DESKTOP,	      /* parent window handle	 */
		  HWND_DESKTOP,	      /* owner window handle	 */
		  buffer,	      /* pointer to message text */
		  szClassName,	      /* pointer to title text	 */
		  MSG_BOX_ID,	      /* message box identifier	 */
		  MB_OK | MB_ERROR ); /* message box style	 */

   return lCount;
}   /*	end of mprintf()  */



/*+--------------------------------------------------------------------------+*/
/*|									     |*/
/*| FUNCTION NAME: SetPulldownState					     |*/
/*| --------------							     |*/
/*|  A PM function for setting the check mark status of a menu item.	     |*/
/*|									     |*/
/*| EXPECTED INPUT:							     |*/
/*| ---------------							     |*/
/*|  Handle to the window containing the menu.				     |*/
/*|  Item id within the menu to check.					     |*/
/*|  BOOL indicating state to set:  TRUE=CHECKED FALSE=UNCHECKED	     |*/
/*|									     |*/
/*| EXPECTED OUTPUT:							     |*/
/*| ----------------							     |*/
/*|  None								     |*/
/*+--------------------------------------------------------------------------+*/
void SetPulldownState( HWND hwnd, USHORT item, BOOL state)
{
   WinCheckMenuItem(WinWindowFromID(hwnd, FID_MENU), item, state);
} /*  end of SetPulldownState()	 */
/**************************  end of palette.c	*******************************/


/**************************************************************************
 *  File name  :  pnt.c
 *
 *  Description:  This module contains the code for the main client
 *		  window painting.
 *
 *		  This source file contains the following functions:
 *
 *		  MainPaint(hwnd)
 *
 *  Concepts   :  window painting
 *
 *  API's      :  WinBeginPaint
 *		  WinFillRect
 *		  WinEndPaint
 *
 *  Required
 *    Files    :  OS2.H, MAIN.H, XTRN.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *  Include files, macros, defined constants, and externs
 */

#define	 INCL_WINSYS

#include <os2.h>
#include "main.h"
#include "xtrn.h"

/*
 *  Global variables
 */

/*
 *  Entry point declarations
 */


/**************************************************************************
 *
 *  Name       : MainPaint(hwnd)
 *
 *  Description: Paints the main client window.
 *
 *  Concepts:  Routine is called whenver the client window
 *	       procedure receives a WM_PAINT message
 *
 *	       - begins painting by calling WinBeginPaint
 *		   and retrieving the HPS for the window
 *	       - performs any painting desired
 *	       - ends painting by calling WinEndPaint
 *
 *  API's      :  WinBeginPaint
 *		  WinFillRect
 *		  WinEndPaint
 *
 *  Parameters :  hwnd	   = window handle
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID MainPaint(HWND hwnd)
{
   RECTL rclUpdate;
   HPS hps;

   hps = WinBeginPaint(hwnd, NULLHANDLE, &rclUpdate);

   /* fill update rectangle with window color */
   WinFillRect(hps, &rclUpdate, SYSCLR_WINDOW);

   /*
    *	   Add painting routines here.	Hps is now
    *	   the HPS for the window and rclUpdate
    *	   contains the update rectangle.
    */

   WinEndPaint(hps);
}   /* End of MainPaint	  */
/***************************  End of pnt.c  ****************************/
/******************************************************************************
*
*  File Name   : PROCS.C
*
*  Description : miscellaneous Jigsaw functions
*
*  Entry Points:
*		 SendCommand()
*		 ClientWndProc()
*		 WndProcPaint()
*		 WndProcCommand()
*		 FileOpen()
*		 SizeBitmap()
*		 MessageBox()
*		 JigsawOpenFilterProc()
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.						      *
*
******************************************************************************/

#include "jigsaw.h"
#include "jighelp.h"
#include "globals.h"
#include <stdio.h>
#include <string.h>

#define PB_STAT_CANCEL 1
#define PB_STAT_HELP   2
#define DEFAULT_DIR    "\\OS2\\BITMAP"

/******************************************************************************/
/*															   */
/*  Define forward procedure references							 */
/*														      */
/******************************************************************************/

/* list of EA type strings */
PSZ apszITL[]={"Jigsaw", (PSZ)NULL};


/******************************************************************************
*
*  Name	       : SendCommand
*
*  Description :
*		 SendCommand will attempt to post the required command and
*		 parameters to the asynchronous drawing thread's message
*		 queue.	 The command will only be posted if the queue exists.
*
*  Parameters  : ULONG ulCommand, MPARAM mp1, MPARAM mp2
*
*  Return      : BOOL
*
******************************************************************************/

BOOL SendCommand(ULONG ulCommand, MPARAM mp1, MPARAM mp2)
{
   if (!hmqAsync)			   /* no message queue; don't bother */
      return( FALSE);

   switch (ulCommand)
   {
      case UM_DIE:
      case UM_LEFTDOWN:
      case UM_LEFTUP:
      case UM_MOUSEMOVE:
      case UM_DRAW:
      case UM_HSCROLL:
      case UM_VSCROLL:
      case UM_ZOOM:
      case UM_REDRAW:
      case UM_SIZING:
      case UM_JUMBLE:
      case UM_LOAD:
      case UM_CHAR:

	 return( WinPostQueueMsg( hmqAsync    /* let worker thread handle it */
				, ulCommand
				, mp1
				, mp2 ) );
	 break;

      default:
	 return( TRUE);

   }   /* end switch (ulCommand)  */

}   /* end SendCommand() */

/******************************************************************************
*
*  Name	       : ClientWndProc
*
*  Description : ClientWndProc is the window procedure associated with the
*		 client window.
*
*  Parameters  : HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2
*
*  Return      : MRESULT
*
******************************************************************************/


MRESULT EXPENTRY ClientWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
  CHAR	 szTemp[128];
  ULONG	 ulSemPostCount;

  switch (msg)
  {
    case WM_CHAR:

      SendCommand( UM_CHAR, mp1, mp2);
      break;

    case WM_CLOSE:
      WinLoadString( habMain, 0, IDS_TERMINATE, sizeof(szTemp), (PSZ)szTemp );
      if( WinMessageBox( HWND_DESKTOP
		       , hwndFrame
		       , szTemp
		       , szTitle
		       , 0
		       , MB_CUAWARNING | MB_YESNO | MB_CUANOTIFICATION | MB_DEFBUTTON1)
	       == MBID_YES)
	  WinPostMsg( hwnd, WM_QUIT, NULL, NULL);
      break;

    case WM_PAINT:
      return( WndProcPaint());
      break;

    /**************************************************************************/
    /* Keys Help Message													      */
    /**************************************************************************/
    case HM_QUERY_KEYS_HELP:
      return (MRESULT)PANEL_HELPKEYS;	/* return id of key help panel */
      break;

    /**************************************************************************/
    /*														      */
    /**************************************************************************/
    case WM_ERASEBACKGROUND:
      return( ( MRESULT)TRUE);
      break;

    /**************************************************************************/
    /* Process menu item commands, and commands generated from the keyboard   */
    /* via the accelerator table. Most are handled by the async thread	      */
    /**************************************************************************/
    case WM_COMMAND:
      return( WndProcCommand( hwnd, msg, mp1, mp2));
      break;

    /**************************************************************************/
    /* Scrolling is handled by the async drawing thread. Simply pass on the   */
    /* command and parameters										 */
    /**************************************************************************/
    case WM_HSCROLL:
      SendCommand( UM_HSCROLL, mp2, 0);
      break;

    case WM_VSCROLL:
      SendCommand( UM_VSCROLL, mp2, 0);
      break;

    /************************************************************************/
    /* The client area is being resized.							 */
    /************************************************************************/
    case WM_SIZE:
      DosResetEventSem( hevDrawOn, &ulSemPostCount);	 /* disallow drawing */
      SendCommand( UM_SIZING, mp1, mp2);
      break;

    /**************************************************************************/
    /* Mouse commands are handled by the async thread. Simply send on the     */
    /* command and parameters.									      */
    /**************************************************************************/
    case WM_BUTTON2DBLCLK:
    case WM_BUTTON2DOWN:
      if( hwnd != WinQueryFocus( HWND_DESKTOP))
	      WinSetFocus( HWND_DESKTOP, hwnd);
      if( !fButtonDownMain)
      {
	      fButtonDownMain = TRUE;
	      SendCommand( UM_LEFTDOWN, mp1, 0);
      }
      return( ( MRESULT)TRUE);
      break;

    case WM_BUTTON2UP:
      if( !fButtonDownMain)
	      return( ( MRESULT)TRUE);
      if( SendCommand( UM_LEFTUP, mp1, 0))
	      fButtonDownMain = FALSE;
      else
	      WinAlarm( HWND_DESKTOP, WA_WARNING);
      return( ( MRESULT)TRUE);
      break;

    case WM_MOUSEMOVE:
      DosQueryEventSem( hevMouse, &ulSemPostCount);
      if( ulSemPostCount)			  /* mouse tracking enabled? */
	      SendCommand( UM_MOUSEMOVE, mp1, 0);
      return( WinDefWindowProc( hwnd, msg, mp1, mp2));
      break;
    /**************************************************************************/
    /* Default for the rest						      */
    /**************************************************************************/
    default:
      return( WinDefWindowProc( hwnd, msg, mp1, mp2));

  }   /* end switch (msg)  */

  return( FALSE);

}   /* end ClientWndProc() */

/******************************************************************************/
/*															   */
/* WM_PAINT message											       */
/*														 */
/******************************************************************************/
MRESULT WndProcPaint(VOID)
{
  HRGN	 hrgnUpdt;
  SHORT	 sRgnType;

  hrgnUpdt = GpiCreateRegion( hpsPaint, 0L, NULL);
  sRgnType = WinQueryUpdateRegion( hwndClient, hrgnUpdt);
  SendCommand( UM_DRAW, (MPARAM)hrgnUpdt, 0);
  WinValidateRegion( hwndClient, hrgnUpdt, FALSE);
  return( FALSE);
}

/******************************************************************************
*
*  Name	       : WndProcCommand
*
*  Description : Process menu item commands, and commands generated from the
*		 keyboard via the accelerator table.  Most are handled by
*		 the async thread
*
*  Parameters  : HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2
*
*  Return      : MRESULT
*
******************************************************************************/

MRESULT WndProcCommand(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  ULONG	    ulSemPostCount;
  ULONG	    ulLoadPostCount;

   DosQueryEventSem( hevLoadingBitmap, &ulLoadPostCount); /* drawing enabled? */

   switch( SHORT1FROMMP(mp1))
   {
      case IDM_SIZE_SMALL:

	 if (ulLoadPostCount == 0)    /* is a bitmap currently being loaded? */
	    break;		      /* ignore message while loading bitmap */
	 CheckMenu(Currentchecked, FALSE);	 /* remove check on old menu */
	 SizeBitmap(-8);			    /* change transform size */
	 CheckMenu(IDM_SIZE_SMALL, TRUE);		/* add check to menu */
	 Currentchecked = IDM_SIZE_SMALL;		/* save cur. menu id */

	 break;

      case IDM_SIZE_MEDIUM:

	 if (ulLoadPostCount == 0)    /* is a bitmap currently being loaded? */
	    break;		      /* ignore message while loading bitmap */
	 CheckMenu(Currentchecked, FALSE);	 /* remove check on old menu */
	 SizeBitmap(-4);			    /* change transform size */
	 CheckMenu(IDM_SIZE_MEDIUM, TRUE);		/* add check to menu */
	 Currentchecked = IDM_SIZE_MEDIUM;		/* save cur. menu id */

	 break;

      case IDM_SIZE_LARGE:

	 if (ulLoadPostCount == 0)    /* is a bitmap currently being loaded? */
	    break;		      /* ignore message while loading bitmap */
	 CheckMenu(Currentchecked, FALSE);	 /* remove check on old menu */
	 SizeBitmap(-2);			    /* change transform size */
	 CheckMenu(IDM_SIZE_LARGE, TRUE);		/* add check to menu */
	 Currentchecked = IDM_SIZE_LARGE;		/* save cur. menu id */

	 break;

      case IDM_SIZE_FULL:

	 if (ulLoadPostCount == 0)    /* is a bitmap currently being loaded? */
	    break;		      /* ignore message while loading bitmap */
	 CheckMenu(Currentchecked, FALSE);	 /* remove check on old menu */
	 SizeBitmap(0);				    /* change transform size */
	 CheckMenu(IDM_SIZE_FULL, TRUE);		/* add check to menu */
	 Currentchecked = IDM_SIZE_FULL;		/* save cur. menu id */

	 break;

      case IDM_JUMBLE:

	 DosResetEventSem( hevDrawOn, &ulSemPostCount);	 /* disallow drawing */
	 SendCommand( UM_JUMBLE, 0, 0);

	 break;

      case IDM_LOAD:

	 FileOpen();	       /* Open file and load/draw the selected image */

	 break;

      /**********************************************************************/
      /* Pass on the rest to the async thread.				    */
      /**********************************************************************/

      case IDM_HELPHELPFORHELP:

	 HelpHelpForHelp(mp2);

	 break;

      case IDM_HELPEXTENDED:

	 DisplayHelpPanel(PANEL_EXTENDED_CONTENTS);

	 break;

      case IDM_HELPINDEX:

	 HelpIndex(mp2);

	 break;

      case IDM_HELPTUTORIAL:

	 HelpTutorial(mp2);

	 break;

      case IDM_HELPABOUT:

	 HelpAbout(mp2);

	 break;


      /**********************************************************************/
      /* Unrecognized => default					    */
      /**********************************************************************/

      default:
	 return( WinDefWindowProc(hwnd, msg, mp1, mp2));
   }

   return( FALSE);

}   /* end WndProcCommand() */


/****************************************************************\
 *  Open file routine
 *--------------------------------------------------------------
 *
 *  Name:   FileOpen()
 *
 *  Purpose: Processes the File menu's Open item.
 *
 *  Usage:  called whenever New from the File menu is selected
 *
 *  Method:  calls the standard file open dialog to get the
 *	    file name.	The file name is passed onto DosOpen
 *	    which returns the handle to the file.  The file
 *	    input procedure is called and then the file handle
 *	    is closed.
 *
 *  Returns:
 *
\****************************************************************/
BOOL FileOpen( VOID )
{
 BOOL	     fSuccess = FALSE;
 PCH	     pch;
 FILEDLG     fdg;
 CHAR	     szHeader[MESSAGELEN], szButton[MESSAGELEN];
 CHAR	     szExtension[FILEPROTOSIZE];
 ULONG	     ulDummy;			    /* local temporary variable	 */
 ULONG	     ulSemPostCount;
 FILEFINDBUF FileBuff;	   /*  used to locate default directory */
 HDIR	     hdir  = HDIR_SYSTEM;
 ULONG	     Count = 1;

   /*
    * set up structure to pass to standard file dialog
    */
 fdg.cbSize = sizeof(FILEDLG);
 fdg.fl = FDS_CENTER | FDS_HELPBUTTON | FDS_OPEN_DIALOG;

 if (!WinLoadString(habMain, 0, IDS_OPENDLGHEADER, MESSAGELEN, szHeader))
   {
   MessageBox(hwndFrame, IDS_CANNOTLOADSTRING, MB_OK | MB_ERROR, TRUE);
   return FALSE;
   }
 fdg.pszTitle = szHeader;			     /* dialog title */

 if (!WinLoadString(habMain, 0, IDS_OPENDLGBUTTON, MESSAGELEN, szButton))
   {
   MessageBox(hwndFrame, IDS_CANNOTLOADSTRING, MB_OK | MB_ERROR, TRUE);
   return FALSE;
   }
 fdg.pszOKButton = szButton;		     /* <ENTER> button text */

 fdg.ulUser = 0L;
 fdg.pfnDlgProc = (PFNWP)JigsawOpenFilterProc;
 fdg.lReturn = 0L;
 fdg.lSRC = 0;
 fdg.hMod = 0;
 fdg.usDlgId = 0;
 fdg.x = 0;
 fdg.y = 0;

    /* setup EA type list & initial type */
 fdg.pszIType = (PSZ)NULL;
 fdg.papszITypeList = (PAPSZ)apszITL;

    /* setup drive list & initial drive */
 fdg.pszIDrive = (PSZ)NULL;
 fdg.papszIDriveList = (PAPSZ)NULL;

   /*
    * get the default file extension (i.e. *.BMP)
    */
 if (!WinLoadString(habMain,  0, IDS_FILEOPENEXTENSION, FILEPROTOSIZE,
							       szExtension))
   {
   MessageBox(hwndFrame, IDS_CANNOTLOADSTRING, MB_OK | MB_ERROR, TRUE);
   return FALSE;
   }

   /*
    * if dialog has been previously invoked, then ensure the
    * dialog is brought with the last user-selected directory
    */
 if (*pli->szFileName)
   {
   pch = strrchr(pli->szFileName, '\\');
   strcpy(++pch, szExtension);
   strcpy(fdg.szFullFile, pli->szFileName);
   }
 else	    /* search for \os2\bitmap directory */
   {
   if (!DosFindFirst(DEFAULT_DIR, &hdir, FILE_DIRECTORY, &FileBuff,
			      sizeof(FILEFINDBUF), &Count, FIL_STANDARD))
     sprintf(fdg.szFullFile, "%s\\%s", DEFAULT_DIR, szExtension);
   else
     strcpy(fdg.szFullFile, szExtension);
   }


 fdg.sEAType = -1;
 fdg.papszFQFilename = 0;
 fdg.ulFQFCount = 0;

   /*
    * invoke the standard file dialog and get a file
    */
 if (!WinFileDlg(HWND_DESKTOP, hwndFrame, (PFILEDLG)&fdg))
   {
   MessageBox(hwndFrame, IDS_CANNOTRUNFILEDLG,MB_OK | MB_ERROR, TRUE);
   return FALSE;
   }

   /*
    *  Upon sucessful return of a file, open it for reading
    */
 if (fdg.lReturn == DID_OK)
 {
   strcpy(pli->szFileName, fdg.szFullFile);
   DosOpen(
      pli->szFileName,	     /* pointer to filename			     */
      &(pli->hf),	     /* pointer to variable for file handle	     */
      &ulDummy,		     /* pointer to variable for action taken	     */
      0,		     /* file size if created or truncated	     */
      FILE_NORMAL,	     /* file attribute				     */
      FILE_OPEN,	     /* action taken if file exists/does not exist   */
      OPEN_ACCESS_READONLY | /* open mode of file			     */
       OPEN_SHARE_DENYWRITE,
      NULL);		     /* pointer to structure for extended attributes */

   DosResetEventSem( hevDrawOn, &ulSemPostCount);	 /* disallow drawing */
   SendCommand( UM_LOAD, (MPARAM)pli, 0);
 }
 return TRUE;
}   /* end FileOpen() */


VOID SizeBitmap(LONG lTempScale )
{
   ULONG  ulSemPostCount;

	lScale = lTempScale;
	DosResetEventSem( hevDrawOn, &ulSemPostCount);	 /* disallow drawing */
	DosPostEventSem( hevKillDraw);
	SendCommand( UM_ZOOM, MPVOID, MPVOID);
} /* SizeBitmap */



/****************************************************************\
 *  Message Box procedure
 *--------------------------------------------------------------
 *
 *  Name:   MessageBox(hwndOwner, idMsg, fsStyle, fBeep)
 *
 *  Purpose: Displays the message box with the message
 *		given in idMsg retrived from the message table
 *		and using the style flags in fsStyle
 *
 *  Usage:  Called whenever a MessageBox is to be displayed
 *
 *  Method: - Message string is loaded from the process'
 *		message table
 *	    - Alarm beep is sounded if desired
 *	    - Message box with the message is displayed
 *	    - WinMessageBox return value is returned
 *
 *  Returns: return value from WinMessageBox()
 *
\****************************************************************/
ULONG MessageBox(HWND hwndOwner, ULONG idMsg, ULONG fsStyle, BOOL fBeep)
{
   CHAR szText[MESSAGELEN];
   PSZ	pszTitle;

   if (fsStyle & MB_ERROR)
      pszTitle = NULL;				       /* default is "Error" */
   else
      pszTitle = szTitle;		      /* use "Jigsaw" for non-errors */

   if (!WinLoadString(habMain,
	   (HMODULE)NULLHANDLE,
	   idMsg,
	   MESSAGELEN,
	   (PSZ)szText))
   {
      if (idMsg == IDS_CANNOTLOADSTRING)
      {
	 strcpy(szText, "Failed to load resource string");
      }
      else
      {
	 WinAlarm(HWND_DESKTOP, WA_ERROR);
	 return MBID_ERROR;
      }
   }

   if (fBeep)
      WinAlarm(HWND_DESKTOP, WA_ERROR);

   return WinMessageBox(HWND_DESKTOP,	  /* handle of the parent window     */
	     hwndOwner,			  /* handle of the owner window	     */
	     szText,			  /* address of text in message box  */
	     pszTitle,			  /* address of title of message box */
	     MSGBOXID,			  /* message-box identifier	     */
	     fsStyle);			  /* type of message box	     */

}   /* end MessageBox() */

/***************************************************************************
 *** JigsawOpenFilterProc - This is a procedure that will filter the help
 *			     messages to the open dialog.
***************************************************************************/
MRESULT EXPENTRY JigsawOpenFilterProc(HWND hwnd,ULONG message,MPARAM mp1,MPARAM mp2 )
{
  if(message == WM_HELP)
  {
       DisplayHelpPanel(HID_FS_OPEN_DLG_HELP_PANEL);
       return FALSE ;
   }

   return WinDefFileDlgProc( hwnd, message, mp1, mp2 ) ;
}

/*******************************  END PROCS.C  *******************************/
/****************************************************************************
 * OS/2 Sample Print Application PRTSAMP
 *
 * File name: prtcreat.c
 *
 * Description: Contains code that the application does once at startup.
 *		These functions are called when client window procedure
 *		is called with the WM_CREATE messsage.
 *
 *		  This source file contains the following functions:
 *
 *		  Create(hwnd)
 *
 * Concepts:   initialization
 *
 * API's:      WinQueryAnchorBlock
 *	       WinSetWindowULong
 *	       WinQueryWindow
 *	       WinWindowFromID
 *	       WinSendMsg
 *	       WinLoadString
 *	       WinSetWindowText
 *	       WinEnableMenuItem
 *	       WinEnableControl
 *	       WinOpenWindowDC
 *	       GpiCreatePS
 *	       GpiQueryDefaultViewMatrix
 *	       WinCheckMenuItem
 *	       GpiSetDefaultViewMatrix
 *
 *    Files    :  OS2.H, PRTSAMP.H, PRTSDLG.H, PMASSERT.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 ****************************************************************************/

/* os2 includes */
#define INCL_WINSTDFILE
#define INCL_WINSTDFONT
#define INCL_WINWINDOWMGR
#define INCL_WINMENUS
#define INCL_WINERRORS
#define INCL_WINFRAMEMGR
#define INCL_GPITRANSFORMS
#define INCL_SPL
#define INCL_SPLDOSPRINT
#include <os2.h>

/* c language includes */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stddef.h>
#include <process.h>
#include <sys\types.h>
#include <sys\stat.h>

/* application includes */
#include "prtsamp.h"
#include "prtsdlg.h"
#include "pmassert.h"


/**************************************************************************
*
* Name:	  Create
*
* Description:	Does the WM_CREATE processing for the client window;
*		allocates memory for the block of main parameters and
*		starts to initialize it; creates thread 2 which operates
*		the object window.
*
* Concepts:	second thread
*
 * API's:      WinQueryAnchorBlock
 *	       WinSetWindowULong
 *	       WinQueryWindow
 *	       WinWindowFromID
 *	       WinSendMsg
 *	       WinLoadString
 *	       WinSetWindowText
 *	       WinEnableMenuItem
 *	       WinEnableControl
 *	       WinOpenWindowDC
 *	       GpiCreatePS
 *	       GpiQueryDefaultViewMatrix
 *	       WinCheckMenuItem
 *	       GpiSetDefaultViewMatrix
 *
 * Parameters:	 hwnd = client window handle
 *
 * Return:	 a pointer to the main block of parameters
 *
 **************************************************************************/
PMAIN_PARM Create( HWND hwnd )
{
   BOOL		   bOK;
   CHAR		   szWork[ LEN_WORKSTRING ];
   HAB		   hab;
   PMAIN_PARM	   pmp;
   SEL		   sel;
   SIZEL	   sizel;
   USHORT	   rc;
   int		   idThread;

   /* query hab */
   hab = WinQueryAnchorBlock( hwnd );

   /* allocate main block of parameters. see prtsamp.h */
   pmp = (PMAIN_PARM)calloc( 1, sizeof( MAIN_PARM ));
   pmassert( hab, pmp );

   /* set main parmaters pointer into client window words */
   bOK = WinSetWindowULong( hwnd, QWL_USER, (ULONG) pmp );
   pmassert( hab, bOK  );


   /* store hab and important window handles in the pmp */
   pmp->hab	     = hab;
   pmp->hwndClient   = hwnd;
   pmp->hwndFrame    = WinQueryWindow( hwnd, QW_PARENT );
   pmp->hwndTitlebar = WinWindowFromID( pmp->hwndFrame, FID_TITLEBAR );
   pmp->hwndMenubar  = WinWindowFromID( pmp->hwndFrame, FID_MENU );
   pmp->hwndVScroll  = WinWindowFromID( pmp->hwndFrame, FID_VERTSCROLL);

   pmassert( hab, pmp->hwndTitlebar );
   pmassert( hab, pmp->hwndMenubar  );
   pmassert( hab, pmp->hwndVScroll  );


   /* disable client and menubar until application completely initializes. */
   WinSendMsg( hwnd, WM_USER_DISABLE_CLIENT, (MPARAM)0, (MPARAM)0 );

   /* set initial mode of operation to be unknown; shall know after file open */
   pmp->ulMode = pmp->ulNextMode = MODE_UNKNOWN;

   /* printing options */
   pmp->usCopies = 1;

   /* get program title; put in pmp and title bar */
   bOK = WinLoadString( pmp->hab, (HMODULE)NULLHANDLE,
			PROGRAM_TITLE, LEN_WORKSTRING, szWork );
   pmassert( hab, bOK );
   pmp->pszTitle = strdup( szWork );
   pmassert( hab, pmp->pszTitle );
   bOK = WinSetWindowText( pmp->hwndTitlebar, pmp->pszTitle );
   pmassert( hab, bOK );

   /* gray certain menu items (this is a pmwin.h macro) */
   WinEnableMenuItem( pmp->hwndMenubar, IDM_PRINT,    FALSE );
   WinEnableMenuItem( pmp->hwndMenubar, IDM_VIEWFULL, FALSE );
   WinEnableMenuItem( pmp->hwndMenubar, IDM_VIEWHALF, FALSE );
   WinEnableMenuItem( pmp->hwndMenubar, IDM_PAGEDOWN, FALSE );
   WinEnableMenuItem( pmp->hwndMenubar, IDM_SETFONT,  FALSE );

   /* disable vertical scroll bar control; enable in text mode */
   WinEnableControl( pmp->hwndFrame, FID_VERTSCROLL, FALSE );

   /* store window dc for hwnd */
   pmp->hdcClient = WinOpenWindowDC( hwnd );
   pmassert( hab, pmp->hdcClient );

   /* create a normal screen ps for the screen dc in twips */
   /* 1440 twips == 1 inch; 20 twips == 1 point; 72 points per inch */
   sizel.cx = 0;
   sizel.cy = 0;
   pmp->hpsClient = GpiCreatePS(
			hab,
			pmp->hdcClient,
			&sizel,
			PU_TWIPS | GPIF_LONG | GPIT_NORMAL | GPIA_ASSOC	 );
   pmassert( hab, pmp->hpsClient );

   /* query default view matrix */
   bOK = GpiQueryDefaultViewMatrix( pmp->hpsClient, 9, &pmp->matlfDefView );
   pmassert( pmp->hab, bOK );

   /* the scale of the matrix should be 1-to-1 */
   pmassert( hab, pmp->matlfDefView.fxM11 == MAKEFIXED( 1, 0 ));
   pmassert( hab, pmp->matlfDefView.fxM22 == MAKEFIXED( 1, 0 ));

   /* keep a floating point version of current scale in main parameters */
   pmp->floatScale = 1.0;

   /* set check on menu item that viewing is 1-to-1 scale */
   WinCheckMenuItem( pmp->hwndMenubar, IDM_VIEWFULL,  TRUE );

   /* modify default view matrix to add translation in the x direction */
   pmp->matlfDefView.lM31 = OFFSET_XY_TWIPS;
   bOK = GpiSetDefaultViewMatrix( pmp->hpsClient, 9,
				  &pmp->matlfDefView, TRANSFORM_REPLACE );
   pmassert( pmp->hab, bOK );

   /* set up default sizelPage for letter form 8.5 x 11 portrait in twips */
   /* these values will be overwritten later in initialization if the	  */
   /* program can load the printer last used from the profile		  */
   pmp->sizelPage.cx  = 11520;	   /*  8.0 inches */
   pmp->sizelPage.cy  = 15120;	   /* 10.5 inches */

   /* prepare the file dialog structure */
   pmp->filedlg.cbSize	   = sizeof( FILEDLG );
   pmp->filedlg.fl	   = FDS_OPEN_DIALOG | FDS_CENTER | FDS_HELPBUTTON;
   pmp->filedlg.pfnDlgProc = MyFileDlgProc;
   pmp->filedlg.ulUser	   = (ULONG)pmp;

   /* and the font dialog structure */
   pmp->fontdlg.cbSize		  = sizeof( FONTDLG );
   pmp->fontdlg.fl	      =
	  FNTS_CENTER | FNTS_HELPBUTTON | FNTS_VECTORONLY | FNTS_INITFROMFATTRS;
   pmp->fontdlg.usFamilyBufLen	  = sizeof( pmp->szFamilyname );
   pmp->fontdlg.pszFamilyname	  = pmp->szFamilyname;
   pmp->fontdlg.pfnDlgProc	  = MyFontDlgProc;
   pmp->fontdlg.clrFore		  = CLR_BLACK;
   pmp->fontdlg.clrBack		  = CLR_WHITE;
   pmp->fontdlg.ulUser		  = (ULONG)pmp;
   pmp->fontdlg.hpsScreen     = pmp->hpsClient;
   pmp->fontdlg.usWeight	  = 5;		      /* normal style */

   /* do more initialization on thread 2. See WM_CREATE case in prtobj.c */
   /* create object window which operates on thread 2 */
   /* see prtobj.c for thread 2 code and object window procedure */
   idThread = _beginthread( threadmain, NULL, LEN_STACK, pmp );
   pmassert( hab, idThread != 0 );

   return pmp;
}  /* end of Create()  */
/***************************  End of prtcreat.c ****************************/
/**************************************************************************
 * OS/2 Sample Print Application PRTSAMP
 *
 *  File name  :  prtmenu.c
 *
 *  Description:  This file contains functions which respond to selections
 *		  the user makes at the menu bar or the pulldown menus on it.
 *
 *		  This source file contains the following functions:
 *
 *		  Menu(hwnd, msg, mp1, mp2)
 *		  GetEAFileType(hfile)
 *		  FileTypeDlgProc(hwnd, msg, mp1, mp2)
 *		  MyFileDlgProc(hwnd, msg, mp1, mp2)
 *		  MyFontDlgProc(hwnd, msg, mp1, mp2)
 *		  ProdInfoDlgProc(hwnd, msg, mp1, mp2)
 *		  SetSysMenu(hdlg)
 *
 *  Concepts   :  standard dialogs
 *
 *  API's      :  WinQueryWindowULong
 *		  WinFileDlg
 *		  WinFontDlg
 *		  WinDlgBox
 *		  WinSendMsg
 *		  WinPostMsg
 *		  WinCheckMenuItem
 *		  GpiSetDefaultViewMatrix
 *		  WinAlarm
 *		  DosQueryFileInfo
 *		  WinCheckButton
 *		  WinSetFocus
 *		  WinQueryButtonCheckstate
 *		  WinDismissDlg
 *		  DosOpen
 *		  DosRead
 *		  DosClose
 *		  WinLoadString
 *		  WinMessageBox
 *		  WinDefFileDlgProc
 *		  WinDefFontDlgProc
 *		  WinDefDlgProc
 *		  WinEnableMenuItem
 *		  WinWindowFromID
 *
 *    Files    :  OS2.H, PRTSAMP.H, PRTSDLG.H, PRTSHLP.H, PMASSERT.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.
 *************************************************************************/

/* os2 includes */
#define INCL_DOSFILEMGR
#define INCL_WINSTDFILE
#define INCL_WINSTDFONT
#define INCL_WININPUT
#define INCL_WINFRAMEMGR
#define INCL_WINWINDOWMGR
#define INCL_WINMENUS
#define INCL_WINHELP
#define INCL_WINBUTTONS
#define INCL_WINDIALOGS
#define INCL_WINERRORS
#define INCL_GPITRANSFORMS
#define INCL_SPL
#define INCL_SPLDOSPRINT
#include <os2.h>

/* c language includes */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stddef.h>
#include <process.h>
#include <sys\types.h>
#include <sys\stat.h>

/* application includes */
#include "prtsamp.h"
#include "prtsdlg.h"
#include "prtshlp.h"
#include "pmassert.h"

/**************************************************************************
 *
 *  Name       : Menu()
 *
 *  Description: Processes commands initiated from the menu bar.
 *
 *  Concepts:	 pull-down menus
 *
 *  API's      :  WinQueryWindowULong
 *		  WinFileDlg
 *		  WinFontDlg
 *		  WinDlgBox
 *		  WinSendMsg
 *		  WinPostMsg
 *		  WinCheckMenuItem
 *		  GpiSetDefaultViewMatrix
 *		  WinAlarm
 *
 *  Parameters :  hwnd = window handle
 *		  msg  = message code
 *		  mp1  = first message parameter
 *		  mp2  = second message parameter
 *
 *  Return     :  depends on message sent
 *************************************************************************/
MRESULT Menu( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   PMAIN_PARM pmp;
   ULONG      rc;
   BOOL	      bOK;
   POINTL     pointl;
   FIXED      aFixed[ 2 ];
   FIXED      fxWork;
   LONG	      lRC;

   /* obtain the main parameter pointer from window words */
   pmp = (PMAIN_PARM)WinQueryWindowULong( hwnd, QWL_USER );

   switch( msg )
   {
   case WM_COMMAND:
      switch(SHORT1FROMMP(mp1))
      {
      case IDM_OPEN:
	/* filedlg structure initialized in create.c.
	 * See function MyFileDlgProc() which operates while file dialog is up.
	 */
	 WinFileDlg( HWND_DESKTOP, hwnd, &pmp->filedlg );
	 return (MRESULT)NULL;

      case IDM_PAGEDOWN:
	/* preview the next page of text */
	 WinSendMsg( hwnd, WM_USER_DISABLE_CLIENT, (MPARAM)0L, (MPARAM)0L );
	 WinPostMsg( pmp->hwndObject, WM_USER_PAGINATE,
			       (MPARAM)hwnd, (MPARAM)FLAGS_PAGINATE_SCREEN );
	 return (MRESULT)NULL;

      case IDM_PRINT:
	 Print(hwnd, pmp);
	 return (MRESULT)NULL;

      case IDM_HELPINDEX:
	 rc = (ULONG)WinSendMsg(pmp->hwndHelp, HM_HELP_INDEX,
			     (MPARAM)NULL, (MPARAM)NULL);
	 pmassert( pmp->hab, rc == 0L );
	 break;

      case IDM_HELPEXTENDED:
	 rc = (ULONG)WinSendMsg(pmp->hwndHelp, HM_EXT_HELP,
			     (MPARAM)NULL, (MPARAM)NULL);
	 pmassert( pmp->hab, rc == 0L );
	 break;

      case IDM_USINGHELP:
	 rc = (ULONG)WinSendMsg(pmp->hwndHelp, HM_DISPLAY_HELP,
			      (MPARAM)NULL, (MPARAM)NULL);
	 pmassert( pmp->hab, rc == 0L );
	 break;

      case IDM_PRODINFO:
	 rc = WinDlgBox( HWND_DESKTOP,
			hwnd,
			(PFNWP)ProdInfoDlgProc,
			(HMODULE)NULLHANDLE,
			IDD_PRODINFO,
			(PVOID)pmp );
	 pmassert( pmp->hab, rc != DID_ERROR );
	 return (MRESULT)NULL;

      case IDM_SETFONT:
	/* let user pick a font */
	pmassert( pmp->hab, pmp->ulMode == MODE_TEXT );

	/* reassign hpsPrinter because it could have changed */
	pmp->fontdlg.hpsPrinter	  = pmp->hpsPrinterInfo;


	WinFontDlg( HWND_DESKTOP, hwnd, &pmp->fontdlg );
	if( pmp->fontdlg.lReturn == DID_OK )
	{
	   /*
	    * Store an indicator that the font dialog was recently visited.
	    * This indicator is referenced in PRTSAMP.C under the
	    * WM_NACK_DEFAULT_FONT case where the user is warned that
	    * the pagination routine is using a default font.
	    */
	   pmp->fVisitedFontDialog = TRUE;

	   /* requested vector (outline) fonts only */
	   pmassert( pmp->hab, pmp->fontdlg.fAttrs.fsFontUse & FATTR_FONTUSE_OUTLINE )

	   if( pmp->f )
	   {
	      /* seek top of file to display document in new font */
	      fseek( pmp->f, 0, SEEK_SET );
	      /* re-paginate for the screen */
	      WinSendMsg( hwnd, WM_USER_DISABLE_CLIENT, 0, 0 );
	      WinPostMsg( pmp->hwndObject, WM_USER_PAGINATE,
				   (MPARAM)hwnd, (MPARAM)FLAGS_PAGINATE_SCREEN );
	   }
	}

	 return (MRESULT)NULL;


      case IDM_SETUP:
	/*
	 * Present queue selection dialog to user (parm 3 == TRUE);
	 * Returns TRUE if queue/printer/form options changed.
	 * If changed, then reset the program with NEW_MODE processing. See
	 * prtsamp.c for the WM_USER_NEW_MODE case.
	 */
	if( QueryPrintQueue( pmp, TRUE ))
	{
	    WinPostMsg(pmp->hwndClient, WM_USER_NEW_MODE, 0, 0);
	}
	 return (MRESULT)NULL;


      case IDM_VIEWHALF:
      case IDM_VIEWFULL:
	 switch ( SHORT1FROMMP (mp1) )
	 {
	 case IDM_VIEWHALF:
	    WinCheckMenuItem( pmp->hwndMenubar, IDM_VIEWFULL, FALSE );
	    WinCheckMenuItem( pmp->hwndMenubar, IDM_VIEWHALF, TRUE  );
	    fxWork = MAKEFIXED( 0, 32768 );
	    pmp->floatScale = 0.50;
	    break;

	case IDM_VIEWFULL:
	    WinCheckMenuItem( pmp->hwndMenubar, IDM_VIEWFULL, TRUE  );
	    WinCheckMenuItem( pmp->hwndMenubar, IDM_VIEWHALF, FALSE );
	    fxWork = MAKEFIXED( 1, 0 );
	    pmp->floatScale = 1.00;
	    break;
	}

	if( pmp->matlfDefView.fxM11 != fxWork )
	{
	   /* apply the new scaling with no Y translation for now */
	    pmp->matlfDefView.fxM11 = fxWork;
	    pmp->matlfDefView.fxM22 = fxWork;
	    pmp->matlfDefView.lM31  = OFFSET_XY_TWIPS;
	    pmp->matlfDefView.lM32  = 0;
	    bOK = GpiSetDefaultViewMatrix( pmp->hpsClient, 9,
				   &pmp->matlfDefView, TRANSFORM_REPLACE );
	    pmassert( pmp->hab, bOK );

	   /*
	    * Still need Y translation to "home" the document in the client
	    * window. "Home" means to position the document such that the
	    * top-left corner of the document appears in the top-left corner
	    * of the client window.
	    *
	    * The WM_SIZE case in prtsamp.c sets a proper Y translation so it
	    * homes the document
	    *
	    */
	    WinSendMsg( hwnd, WM_SIZE, (MPARAM)0L, (MPARAM)0L );
	 }
	 else
	 {
	   /* viewmatrix ok already */
	    WinAlarm( HWND_DESKTOP, WA_NOTE );
	 }
	 return (MRESULT)NULL;
      }
      break;
   }
   return (MRESULT)NULL;
}   /*	end of Menu()  */


/**************************************************************************
 *
 *  Name       : GetEAFileType
 *
 *  Description: Gets the value for the extended attribute called ".TYPE".
 *		 For more information, see the EA Sample Program and
 *		 BSEDOS.H.
 *
 *  Concepts:	 extended attributes
 *
 *  API's      : DosQueryFileInfo
 *
 *  Parameters :  hfile = file handle to query
 *
 *  Return     :  the extended attribute file type MODE_* as a ULONG
 *************************************************************************/
ULONG GetEAFileType( HFILE hfile )
{
   ULONG       ulMode;
   ULONG       rc;
   EAOP2       eaop2;
   PGEA2LIST   pgea2list;
   PFEA2LIST   pfea2list;
   PGEA2       pgea2;
   PFEA2       pfea2;
   PUSHORT     pus;

   /* default to unknown */
   ulMode = MODE_UNKNOWN;

   /* create one list item in GEA list */
   pgea2 = (PGEA2) calloc ( 1, 10 );
   pgea2->oNextEntryOffset = 0;
   pgea2->cbName	   = 5;
   memcpy( pgea2->szName, ".TYPE", 5 );

   /* create the list with one GEA item */
   pgea2list = (PGEA2LIST) calloc ( 1, 14 );
   pgea2list->cbList = 10;
   memcpy( &pgea2list->list, pgea2, 10 );

   /* create the list where DosQueryFileInfo places result */
   pfea2list = (PFEA2LIST) calloc ( 1, 64 );
   pfea2list->cbList = 64;

   /* put both lists in a eaop2 structure */
   eaop2.fpGEA2List = pgea2list;
   eaop2.fpFEA2List = pfea2list;

   /* get info */
   if( 0 == DosQueryFileInfo( hfile, FIL_QUERYEASFROMLIST, &eaop2, 64 ) )
   {
     /* is there a ".TYPE" EA? */
      pfea2 = pfea2list->list;
      if( pfea2->cbValue > 0 )
      {
       /* Point to the EAT_* value. See bsedos.h or the EA sample program. */
	 pus = (PUSHORT) (PCHAR)(((PCHAR)pfea2)+20);
	 switch( *pus )
	 {
	 case EAT_ASCII:
	    ulMode = MODE_TEXT;
	    break;
	 case EAT_BITMAP:
	    ulMode = MODE_BITMAP;
	    break;
	 case EAT_METAFILE:
	    ulMode = MODE_METAFILE;
	    break;
	 }
      }
   }
   free( pfea2list );
   free( pgea2list );
   free( pgea2 );
   return ulMode;
}     /*  end of GetEAFileType()  */


/**************************************************************************
 *
 *  Name       : FileTypeDlgProc
 *
 *  Description: Window procedure for the dialog that lets the user
 *		 indicate the file type, presented as a child dialog
 *		 of the standard file dialog.
 *
 *  Concepts:	 window words
 *
 *  API's      : WinSetWindowULong
 *		 WinCheckButton
 *		 WinSetFocus
 *		 WinQueryButtonCheckstate
 *		 WinDismissDlg
 *		 WinDefDlgProc
 *
 *  Parameters : sets check according to pmp->ulNextMode, defaults to
 *		 text type
 *		 pmp is passed to this dialog at WM_INITDLG time and stored
 *		 in dialog window words.
 *
 *  Return     : sets pmp->ulNextMode according to user's selection
 *************************************************************************/
ULONG APIENTRY FileTypeDlgProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   PMAIN_PARM  pmp;
   ULONG       id;

   switch( msg )
   {
   case WM_INITDLG:
      pmp = (PMAIN_PARM) mp2;
      WinSetWindowULong( hwnd, QWL_USER, (ULONG)mp2 );

    /* set check according to pmp->ulNextMode */
      switch( pmp->ulNextMode )
      {
      case MODE_BITMAP:
	 id = IDC_CK_BITMAP;
	 break;
      case MODE_METAFILE:
	 id = IDC_CK_METAFILE;
	 break;
      default:
	 id = IDC_CK_TEXT;
	 break;
      }

    /* pmwin.h macro */
   WinCheckButton( hwnd, id, TRUE );

   WinSetFocus( HWND_DESKTOP, hwnd );

   return 1L;

   case WM_COMMAND:
      pmp = (PMAIN_PARM) WinQueryWindowULong( hwnd, QWL_USER );
      switch( SHORT1FROMMP( mp1 ))
      {
      case DID_OK:
      /* get checked button */
	 if( WinQueryButtonCheckstate( hwnd, IDC_CK_TEXT ))
	 {
	    pmp->ulNextMode = MODE_TEXT;
	 }
	 if( WinQueryButtonCheckstate( hwnd, IDC_CK_BITMAP ))
	 {
	    pmp->ulNextMode = MODE_BITMAP;
	 }
	 if( WinQueryButtonCheckstate( hwnd, IDC_CK_METAFILE ))
	 {
	    pmp->ulNextMode = MODE_METAFILE;
	 }
	 WinDismissDlg( hwnd, DID_OK );
	 break;

    case DID_CANCEL:
      /* return */
	WinDismissDlg( hwnd, DID_CANCEL );
	break;
      }
      return 0L;

   }
   return (ULONG)WinDefDlgProc( hwnd, msg, mp1, mp2 );
}  /*  end of FileTypeDlgProc()	 */


/************************************************************************
 *
 * Name:     MyFileDlgProc
 *
 * Description: Window procedure that subclasses the WinFileDlg window
 *		procedure, processes/validates filenames the user picked
 *		from the WinFileDlg.
 *		The address of this function has been specified in the
 *		pmp->FILEDLG structure before invoking WinFileDlg().
 *		Handle WM_HELP from font dialog.
 *
 *  Concepts:	 open/saveas file dialog
 *
 *  API's      : WinQueryWindowULong
 *		 WinDlgBox
 *		 WinPostMsg
 *		 DosOpen
 *		 DosRead
 *		 DosClose
 *		 WinLoadString
 *		 WinMessageBox
 *		 WinSendMsg
 *		 WinDefFileDlgProc
 *
 * Parameters:	Regular window procedure arguments.
 *		Can get pmp from filedlg.ulUser.
 *		Can get to filedlg structure by getting its pointer
 *		from dialog window words.
 *
 * Result:	presents the filetype dialog as a child of the filedlg
**************************************************************************/
MRESULT APIENTRY MyFileDlgProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   BOOL	       bOK;
   HFILE       hfile;
   ULONG       ulAction, rc, ulMode, ulPanel, ulBytes;
   PCHAR       pch;
   MRESULT     mr;
   char	       szWork[ LEN_WORKSTRING ];
   PMAIN_PARM  pmp;
   PFILEDLG    pfiledlg;

   switch( msg )
   {
   case FDM_VALIDATE:
      /* get pointer to fontdlg structure from window words of this dialog */
      pfiledlg = (PFILEDLG)WinQueryWindowULong( hwnd, QWL_USER );
      /* filedlg structure has a pmp pointer stored in the user dword */
      pmp = (PMAIN_PARM)pfiledlg->ulUser;


      /* file dialog asking me to validate the filename pointed to by mp1 */
      rc = DosOpen(  (PSZ)mp1,
		     &hfile,
		     &ulAction,
		     0,
		     FILE_NORMAL,
		     FILE_OPEN,
		     OPEN_ACCESS_READONLY | OPEN_SHARE_DENYNONE,
		     NULL );
      if( rc == 0 )
      {
	/* file exists; what kind of file is this according to the EAs? */
	ulMode = GetEAFileType( hfile );

	if( ulMode == MODE_UNKNOWN )
	{
	  /* not sure. Look at file extension to determine file type. */
	  pch = (PSZ)mp1 + strlen( (PSZ)mp1 );
	  pch = max( (PSZ)mp1, pch-4 );
	  if( 0 == stricmp( pch, ".BMP" )) ulMode = MODE_BITMAP;
	  if( 0 == stricmp( pch, ".TXT" )) ulMode = MODE_TEXT;
	  if( 0 == stricmp( pch, ".MET" )) ulMode = MODE_METAFILE;
	  if( 0 == stricmp( pch, ".SPL" )) ulMode = MODE_METAFILE;
	}

	if( ulMode == MODE_UNKNOWN )
	{
	  /* still not sure; peek at data in the file */
	  if( 0 == DosRead( hfile, szWork, 16, &ulBytes ))
	  {
	    if( 0==strncmp(szWork,"BM",2 ) || 0==strncmp(szWork,"BA", 2 ))
	    {
	       ulMode = MODE_BITMAP;
	    }
	    else if( szWork[3] == 0xA8	&&  szWork[4] == 0xA8  )
	    {
	       ulMode = MODE_METAFILE;
	    }
	  }
	}

	/* set "best-guess" mode into main params for FileTypeDlgProc() */
	pmp->ulNextMode = ulMode;

	/* confirm file type with user via the file type dialog */
	rc = WinDlgBox( HWND_DESKTOP,
			hwnd,
			(PFNWP)FileTypeDlgProc,
			(HMODULE)NULLHANDLE,
			IDD_FILETYPE,
			(PVOID)pmp );
	pmassert( pmp->hab, rc != DID_ERROR );
	if( rc == DID_OK )
	{
	   /* set up for new operating mode on new file */
	   strcpy( pmp->szNextFilename, pmp->filedlg.szFullFile );
	   WinPostMsg( pmp->hwndClient, WM_USER_NEW_MODE,
		      (MPARAM)NULL, (MPARAM)NULL);
	   mr = (MRESULT) 1L;
	}
	else
	{
	   mr = (MRESULT)NULL;
	}
	DosClose( hfile );
      }
      else
      {
	/* file not found */
	bOK = WinLoadString( pmp->hab, (HMODULE)NULLHANDLE,
			     ERRMSG_FILE_NOT_FOUND, LEN_WORKSTRING, szWork );
	pmassert( pmp->hab, bOK );
	WinMessageBox( HWND_DESKTOP, hwnd, szWork,
					      pmp->pszTitle, 0, MB_CANCEL );
	mr = (MRESULT)NULL;
      }
      return mr;


   case WM_HELP:
     /* get pointer to fontdlg structure from window words of this dialog */
      pfiledlg = (PFILEDLG) WinQueryWindowULong( hwnd, QWL_USER );
     /* filedlg structure has a pmp pointer stored in the user dword */
      pmp = (PMAIN_PARM) pfiledlg->ulUser;

      if( pmp->hwndHelp )
      {
	 ulPanel = PANEL_FILEDIALOG;
	 WinSendMsg( pmp->hwndHelp, HM_DISPLAY_HELP,
		   (MPARAM)&ulPanel, (MPARAM)HM_RESOURCEID );
	 return (MRESULT)NULL;
      }
      break;

   default:
      break;
   }
   return WinDefFileDlgProc( hwnd, msg, mp1, mp2 );
}   /*	end of MyFileDlgProc()	*/



/************************************************************************
*
* Name: MyFontDlgProc
*
* Description:	Window procedure that subclasses the WinFontDlg window
*		procedure.  Exists to handle WM_HELP message from the
*		standard font dialog.
*
* Parameters:	Regular window procedure arguments.
*		Can get pmp from fontdlg.ulUser.  Can get to fontdlg
*		structure by getting its pointer from dialog window words.
*
* returns: depends on message sent
*
**************************************************************************/
MRESULT APIENTRY MyFontDlgProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   PMAIN_PARM  pmp;
   PFONTDLG    pfontdlg;
   ULONG       ulPanel;

   switch( msg )
   {
   case WM_HELP:
     /* get pointer to filedlg structure from window words of this dialog */
      pfontdlg = (PFONTDLG) WinQueryWindowULong( hwnd, QWL_USER );
     /* fontdlg structure has a pmp pointer stored in the user dword */
      pmp = (PMAIN_PARM) pfontdlg->ulUser;

      if( pmp->hwndHelp )
      {
	 ulPanel = PANEL_FONTDIALOG;
	 WinSendMsg( pmp->hwndHelp, HM_DISPLAY_HELP,
		   (MPARAM)&ulPanel, (MPARAM)HM_RESOURCEID );
	 return (MRESULT)NULL;
      }
      break;
   }
   return WinDefFontDlgProc( hwnd, msg, mp1, mp2 );
}   /*	end of MyFontDlgProc()	*/


/*********************************************************************
*  Name : ProdInfoDlgProc
*
*  Description : Processes all messages sent to the Product
*		 Information dialog box.
*
*  Concepts : Called for each message sent to the Product
*	      Information dialog box.  The Product
*	      Information box only has a button control so
*	      this routine only processes WM_COMMAND
*	      messages.	 Any WM_COMMAND posted must have come
*	      from the Ok button so we dismiss the dialog
*	      upon receiving it.
*
*  API's : WinDismissDlg
*	   WinDefDlgProc
*
* Parameters   : hwnd - Window handle to which message is addressed
*		 msg - Message type
*		 mp1 - First message parameter
*		 mp2 - Second message parameter
*
*  Returns : Dependent upon message sent
****************************************************************/
MRESULT EXPENTRY ProdInfoDlgProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   switch(msg)
   {
      case WM_INITDLG:
	 SetSysMenu(hwnd);	 /* system menu for this dialog	 */
	 return MRFROMSHORT(FALSE);

      case WM_COMMAND:
	 /*
	  * No matter what the command, close the dialog
	  */
	 WinDismissDlg(hwnd, TRUE);
	 break;

      default:
	 return(WinDefDlgProc(hwnd, msg, mp1, mp2));
	 break;
   }
   return (MRESULT)NULL;
}   /*	end of ProdInfoDlgProc()  */


/**************************************************************************
 *
 *  Name       : SetSysMenu(hDlg)
 *
 *  Description: Sets only the Move and Close items of the system menu
 *
 *  Concepts:  Any dialog box is free to call this routine, to edit
 *	       which menu items will appear on its System Menu pulldown.
 *
 *  API's      :  WinWindowFromID
 *		  WinSendMsg
 *
 *  Parameters :  hDlg	   = window handle of the dialog
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID SetSysMenu(HWND hDlg)
{
    HWND     hSysMenu;
    MENUITEM Mi;
    ULONG    Pos;
    MRESULT  Id;
    SHORT    cItems;

    /******************************************************************/
    /*	We only want Move and Close in the system menu.		      */
    /******************************************************************/

    hSysMenu = WinWindowFromID(hDlg, FID_SYSMENU);
    WinSendMsg( hSysMenu, MM_QUERYITEM
	      , MPFROM2SHORT(SC_SYSMENU, FALSE), MPFROMP((PCH) & Mi));
    Pos = 0L;
    cItems = (SHORT)WinSendMsg( Mi.hwndSubMenu, MM_QUERYITEMCOUNT,
				(MPARAM)NULL, (MPARAM)NULL);
    while (cItems--)
    {
	Id = WinSendMsg( Mi.hwndSubMenu, MM_ITEMIDFROMPOSITION
			  , MPFROMLONG(Pos), (MPARAM)NULL);
	switch (SHORT1FROMMR(Id))
	{
	case SC_MOVE:
	case SC_CLOSE:
	    Pos++;  /* Don't delete that one. */
	    break;
	default:
	    WinSendMsg( Mi.hwndSubMenu, MM_DELETEITEM
		      , MPFROM2SHORT((USHORT)Id, TRUE), (MPARAM)NULL);
	}
    }
}   /*	End of SetSysMenu  */

/***************************  End of prtmenu.c	****************************/
/****************************************************************************
 * OS/2 Sample Print Application PRTSAMP
 *
 * Name: prtobj.c
 *
 * Description:	  The object window procedure on thread 2.
 *
 *	       Tasks asked of the object window are not bound by 1/10
 *	       second rule.  Tasks are given to the object window to
 *	       perform via WM_USER_* messages.
 *
 *	       When tasks are completed, the object window posts a
 *	       WM_USER_ACK message to the window that requested the task.
 *
 *	       This source file contains the following functions:
 *
 *	       threadmain(pv)
 *	       ObjectWinProc(hwnd, msg, mp1, mp2)
 *	       trim(s)
 *	       FixedPointsToTwips(fxPointSize)
 *
 * Concepts:   second thread, object window
 *
 * API's:       WinInitialize
 *		WinCreateMsgQueu
 *		WinRegisterClass
 *		WinCreateWindow
 *		WinPostMsg
 *		WinGetMsg
 *		WinDispatchMsg
 *		WinDestroyWindow
 *		WinDestroyMsgQueue
 *		WinTerminate
 *		DosExit
 *		WinQueryAnchorBlock
 *		WinQueryWindowULong
 *		WinSetWindowULong
 *		DosOpen
 *		DosQueryFileInfo
 *		DosRead
 *		DosClose
 *		DevOpenDC
 *		GpiCreatePS
 *		GpiCreateBitmap
 *		GpiSetBitmap
 *		GpiSetBitmapBits
 *		WinInvalidateRect
 *		GpiLoadMetaFile
 *		WinSendMsg
 *		GpiSetDrawingMode
 *		WinGetLastError
 *		DosSleep
 *		GpiErase
 *		GpiDeleteSegment
 *		GpiOpenSegment
 *		GpiSetCurrentPosition
 *		GpiBox
 *		GpiSetColor
 *		GpiCharString
 *		GpiCloseSegment
 *		WinQueryWindowRect
 *		GpiQueryBitmapParameters
 *		GpiBitBlt
 *		GpiQueryPS
 *		GpiPlayMetaFile
 *		GpiSetPS
 *		WinDefWindowProc
 *		GpiSetCharSet
 *		GpiDeleteSetId
 *		GpiCreateLogFont
 *		GpiQueryFontMetrics
 *		GpiSetCharBox
 *
 *   Files    :	 OS2.H, PRTSAMP.H, PRTSDLG.H, PMASSERT.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *
 ****************************************************************************/

/* os2 includes */
#define INCL_DOSFILEMGR
#define INCL_DOSPROCESS
#define INCL_WINSTDFILE
#define INCL_WINSTDFONT
#define INCL_WINWINDOWMGR
#define INCL_WINDIALOGS
#define INCL_WINMLE
#define INCL_WINERRORS
#define INCL_GPIPRIMITIVES
#define INCL_GPIMETAFILES
#define INCL_GPILCIDS
#define INCL_GPIBITMAPS
#define INCL_GPISEGMENTS
#define INCL_GPITRANSFORMS
#define INCL_GPIERRORS
#define INCL_GPICONTROL
#define INCL_SPL
#define INCL_SPLDOSPRINT
#include <os2.h>

/* c language includes */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stddef.h>
#include <process.h>
#include <sys\types.h>
#include <sys\stat.h>

/* application includes */
#include "prtsamp.h"
#include "prtsdlg.h"
#include "prtshlp.h"
#include "pmassert.h"

/* local function prototypes */


FIXED FixedPointsToTwips(FIXED fxPointSize);



/*************************************************************************
 *
 * Name: threadmain
 *
 * Description: Similar in nature to main(), except this occurs on thread 2.
 *		Called by _beginthread() in prtcreat.c
 *
 * API's:       WinInitialize
 *		WinCreateMsgQueu
 *		WinRegisterClass
 *		WinCreateWindow
 *		WinPostMsg
 *		WinGetMsg
 *		WinDispatchMsg
 *		WinDestroyWindow
 *		WinDestroyMsgQueue
 *		WinTerminate
 *		DosExit
 *
 * Parameters: pv, a pointer to the main block of program parameters
 *
 * Return:  [none]
 *
 **************************************************************************/
void _Optlink threadmain( void *pv )
{

   PMAIN_PARM pmp;
   BOOL	      bOK;
   HAB	      hab;
   HMQ	      hmq;
   QMSG	      qmsg;

   /* copy and convert pvoid parmeter to a pointer to the main parameter block */
   pmp = (PMAIN_PARM) pv;

   /* thread initialization */
   hab = WinInitialize( 0 );
   hmq = WinCreateMsgQueue( hab, 0 );

   bOK = WinRegisterClass( hab,
				OBJECTCLASSNAME,
				ObjectWinProc,
				0L,
				sizeof( PMAIN_PARM ) );
   pmassert( hab, bOK );

   /*
    * create a worker window where the parent is the PM object window,
    * it operates on thread 2,
    * has no visible windows on the desktop,
    * and is not bound by the 1/10 second message processing rule.
    */
   pmp->hwndObject = WinCreateWindow(
		       HWND_OBJECT,	  /* parent */
		       OBJECTCLASSNAME,	  /* class name */
		       "",		  /* no caption needed */
		       0L,		  /* style */
		       0L,		  /* x */
		       0L,		  /* y */
		       0L,		  /* cx */
		       0L,		  /* cy */
		       HWND_OBJECT,	  /* owner */
		       HWND_BOTTOM,	  /* position (nop) */
		       0L,		  /* id (nop) */
		       (PVOID)pmp,	  /* parms passed to wm_create case */
		       (PVOID)NULL);	  /* presparams */

   pmassert( hab, pmp->hwndObject );

   /*
    * at this point, application has completely initialized
    * wm_create processing in the object window procedure has completed.
    * let client window know about it
    */
   bOK = WinPostMsg( pmp->hwndClient, WM_USER_ACK, (MPARAM)0L, (MPARAM)0L );
   pmassert( pmp->hab, bOK );


    /* The create processing put values in for next mode and next filename.
       Post this message to activate those new settings */
    bOK = WinPostMsg( pmp->hwndClient, WM_USER_NEW_MODE, 0, 0 );
    pmassert( pmp->hab, bOK );


   /*
    * dispatch messages; these messages will be mostly user-defined messages
    * processed on thread 2
    */
   while( WinGetMsg ( hab, &qmsg, (HWND)NULLHANDLE, 0L, 0L ))
   {
      WinDispatchMsg ( hab, &qmsg );
   }


   /* Use the new-mode processing to close current file before exiting */
   pmp->ulNextMode = MODE_UNKNOWN;
   WinPostMsg( pmp->hwndClient, WM_USER_NEW_MODE, 0, 0 );


   /* make thread one terminate */
   WinPostMsg( pmp->hwndClient, WM_QUIT, (MPARAM)0L, (MPARAM)0L );

   /* clean up */
   WinDestroyWindow( pmp->hwndObject );
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   /* exit this thread */
   DosExit(EXIT_THREAD, 0L);
}  /*  end of threadmain()  */


/**************************************************************************
 *
 * Name: ObjectWinProc
 *
 * Description: a window procedure like most others, except it is not
 *		responsible for any visible windows or presentation. It
 *		exists to perform lengthy tasks on thread2 of the
 *		application.  WM_* messages appear here in alphabetical order.
 *
 * API's:       WinQueryAnchorBlock
 *		WinQueryWindowULong
 *		WinPostMsg
 *		WinSetWindowULong
 *		DosOpen
 *		DosQueryFileInfo
 *		DosRead
 *		DosClose
 *		DevOpenDC
 *		GpiCreateBitmap
 *		GpiSetBitmap
 *		GpiSetBitmapBits
 *		WinInvalidateRect
 *		GpiLoadMetaFile
 *		WinSendMsg
 *		GpiSetDrawingMode
 *		WinGetLastError
 *		DosSleep
 *		GpiErase
 *		GpiDeleteSegment
 *		GpiOpenSegment
 *		GpiSetCurrentPosition
 *		GpiBox
 *		GpiSetColor
 *		GpiCharString
 *		GpiCloseSegment
 *		WinQueryWindowRect
 *		GpiSetCharSet
 *		GpiDeleteSetId
 *		GpiCreateLogFont
 *		GpiQueryFontMetrics
 *		GpiQueryBitmapParameters
 *		GpiBitBlt
 *		GpiQueryPS
 *		GpiPlayMetaFile
 *		GpiSetPS
 *		WinDefWindowProc
 *
 * Parameters: mp1 = window handle to acknowledge upon completion of the task
 *	       (hwndToAck)
 *	       mp2 is an extra parameter and depends on the task
 *
 * returns: an acknowlegement of completion of the task using WinPostMsg
 *   if success: WinPostMsg( hwndToAck, WM_USER_ACK,  msg, rc );
 *		 return rc;
 *
 *   if not:	 WinPostMsg( hwndToAck, WM_NACK_*   , msg, rc );
 *		 return rc;
 *
 *   where msg was the WM_USER_* message that was posted to the object window
 *   and rc is a return code. Depending on the hwndToAck, returning
 *   the result code can be as important as posting it; in particular,
 *   the object window may send synchronous messages to itself and may
 *   check the result code via the return code of WinSendMsg()
 *
 ***************************************************************************/
MRESULT EXPENTRY ObjectWinProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   BITMAPINFOHEADER   bmpinfo;
   BOOL		      bOK;
   BYTE		      abDesc[ LEN_PLAYMETAFILEDESCS ];
   CHAR		      szWork[ LEN_WORKSTRING ];
   FILESTATUS3	      filestatus3;
   FONTMETRICS	      fm;
   HAB		      hab;
   HBITMAP	      hbm;
   HDC		      hdcCompatible;
   HFILE	      hfile;
   HPS		      hps;
   HWND		      hwndToAck;
   IPT		      ipt;
   LONG		      alOptions[ LEN_PLAYMETAFILEOPTS ];
   LONG		      l, lRC, lCount;
   LONG		      lLeftMarginTwips, lLeading, cLinesOnPage;
   PBITMAPFILEHEADER2 pbmpfileheader2;
   PBITMAPFILEHEADER2 pbmpfileheader2Work;
   PBITMAPINFOHEADER2 pbmp2;
   PBYTE	      pBits;
   PBYTE	      pBitsAligned;
   PCHAR	      pch;
   PHBITMAP	      phbm;
   PHDC		      phdc;
   PHPS		      phps;
   PLONG	      pdxIncrement;
   PMAIN_PARM	      pmp;
   POINTL	      apointl[ 4 ];
   POINTL	      pointl;
   PPOINTL	      pptlPosition;
   RECTL	      rectl;
   SIZEF	      sizef;
   SIZEL	      sizel;
   ULONG	      rc, ulAction, ulPtr, cBytes, cScans, ulOptions, ulWork;
   ULONG	      cbImageData;
   ULONG	      ulPointSize;


   /* store the handle of the window to ack upon task completion; */
   hwndToAck = (HWND)mp1;
   hab = WinQueryAnchorBlock( hwnd );
   pmp = (PMAIN_PARM) WinQueryWindowULong( hwnd, QWL_USER );


   switch( msg )
   {

   case WM_CREATE:
     /* mp1 is pointer to main paramters; save it in object window words */
     pmp = (PMAIN_PARM)mp1;
     WinSetWindowULong( hwnd, QWL_USER, (ULONG) pmp );

     /* do more startup processing whilst on thread 2 */

     /* Read .ini for filename, mode, printer, and driver data */
     GetProfile( pmp );

     /*
      * Try to set the print destination to that which was stored in INI.
      * Parm 3 == FALSE means do not display a dialog
      */
     QueryPrintQueue( pmp, FALSE );
     return (MRESULT)NULL;


   case WM_USER_CLOSE:
     /* write settings to ini */
     SaveProfile(pmp);

     /*
      * post a quit to object window;
      * when msg loop falls out in threadmain, then post wm_quit to client
      */
     WinPostMsg( hwnd, WM_QUIT, 0, 0 );
     break;


   case WM_USER_LOAD_BITMAP:
     /*
      * THIS MESSAGE HAS A PARAMETER:
      * mp2 is a flag that indicates whether the memory ps for the bitmap
      * is to be compatible with the screen or the current printer setup
      * see HDCMEM_COMPATIBILITY_*  in prtsamp.h
      */

     /* open bitmap file */
     rc = DosOpen(  pmp->szFilename,
		    &hfile,
		    &ulAction,
		    0L,
		    FILE_NORMAL,
		    FILE_OPEN,
		    OPEN_ACCESS_READONLY | OPEN_SHARE_DENYNONE,
		    NULL );
     if( rc != 0 )
     {
       WinPostMsg( hwndToAck, WM_NACK_FILE_READING_ERROR, (MPARAM)msg, (MPARAM)0L );
       return (MRESULT)NULL;
     }

     /* query file size; returned in filestatus3.cbFile */
     rc = DosQueryFileInfo( hfile, FIL_STANDARD,
				   (PVOID)&filestatus3, sizeof( filestatus3 ));
     pmassert( hab, rc == 0 );

     /* alloc memory for bitmap file read */
     pbmpfileheader2 = (PBITMAPFILEHEADER2) malloc( filestatus3.cbFile );
     pmassert( hab, pbmpfileheader2 );

     /* read bitmap file into memory */
     rc = DosRead( hfile, (PVOID)pbmpfileheader2, filestatus3.cbFile, &cBytes );
     if( rc != 0  ||  cBytes == 0 )
     {
       free( pbmpfileheader2 );
       DosClose( hfile );
       WinPostMsg( hwndToAck, WM_NACK_FILE_READING_ERROR,
			  (MPARAM)msg, (MPARAM)0L );
       return (MRESULT)NULL;
     }

     DosClose( hfile );

     switch( pbmpfileheader2->usType )
     {
     case BFT_BITMAPARRAY:
       /* default to the first bitmap in the array */
       pbmpfileheader2Work = &((PBITMAPARRAYFILEHEADER2)pbmpfileheader2)->bfh2;
       pmassert( hab, pbmpfileheader2Work );
       pbmp2 = &pbmpfileheader2Work->bmp2;
       cbImageData = filestatus3.cbFile - pbmpfileheader2Work->offBits;
       pBits = (PBYTE)pbmpfileheader2 + pbmpfileheader2Work->offBits;
       break;

     case BFT_BMAP:
       /* set pbmp2 to point to the BITMAPINFO2 structure within the file */
       pbmp2 = &pbmpfileheader2->bmp2;
       cbImageData = filestatus3.cbFile - pbmpfileheader2->offBits;
       pBits = (PBYTE)pbmpfileheader2 + pbmpfileheader2->offBits;
       break;

     case BFT_ICON:
     case BFT_POINTER:
     case BFT_COLORICON:
     case BFT_COLORPOINTER:
       /* not supported by print sample */
       free( pbmpfileheader2 );
       WinPostMsg( hwndToAck, WM_NACK_BITMAP_NOT_SUPPORTED,
			 (MPARAM)msg, (MPARAM)0L );
       return (MRESULT)NULL;
     }

     /* pBits should be sensible */
     pmassert( hab, pbmp2 );
     pmassert( hab, pBits );

     /* open a new memory dc with compatibility as required per mp2 argument */
     switch( (ULONG)mp2 )
     {
     case HDCMEM_COMPATIBILITY_SCREEN:
       hdcCompatible = pmp->hdcClient;
       phdc	     = &pmp->hdcMemory;
       phps	     = &pmp->hpsMemory;
       phbm	     = &pmp->hbm;
       break;

     case HDCMEM_COMPATIBILITY_PRINTER:
       hdcCompatible = pmp->hdcPrinter;
       phdc	     = &pmp->hdcMem4Printer;
       phps	     = &pmp->hpsMem4Printer;
       phbm	     = &pmp->hbm4Printer;
       break;

     default:
       /* this assert will fail and remind the programmer of a problem */
       pmassert( hab, NULL == "expected HDCMEM_COMPATIBILITY_*" );
     }


     /* previous uses of hbm, hps, and hdc are properly closed and tidy */
     pmassert( hab, *phps == (HPS)NULLHANDLE );
     pmassert( hab, *phdc == (HDC)NULLHANDLE );
     pmassert( hab, *phbm == (HBITMAP)NULLHANDLE );


     *phdc = DevOpenDC(pmp->hab, OD_MEMORY, "*",0, NULL, hdcCompatible);
     pmassert( hab, *phdc );

     /* create the ps in memory to hold the bitmap */
     sizel.cx = 0;
     sizel.cy = 0;
     *phps = GpiCreatePS( pmp->hab, *phdc, &sizel,
			  PU_PELS | GPIA_ASSOC | GPIT_NORMAL );
     pmassert( hab, *phps );

     /* create a bitmap */
     *phbm = GpiCreateBitmap( *phps,
			      pbmp2,
			      0,		  /* options */
			      (PBYTE)NULL,	  /* init table */
			      (PBITMAPINFO2)NULL );  /* bitmap info */
     pmassert( hab, *phbm );

     /* set bitmap into the memory ps */
     hbm = GpiSetBitmap( *phps, *phbm );
     pmassert( hab, hbm != HBM_ERROR );

     /*
      * determine if this is a 1.x or 2.x bitmap
      * by looking at the length of the BITMAPINFOHEADER structure
      */
     if( pbmp2->cbFix == sizeof(BITMAPINFOHEADER))
     {
	/* this is an OS2 PM 1.x bitmap */
	cScans = (ULONG) ((PBITMAPINFOHEADER)pbmp2)->cy;
	pmp->cyBitmap = ((PBITMAPINFOHEADER)pbmp2)->cy;
	pmp->cxBitmap = ((PBITMAPINFOHEADER)pbmp2)->cx;
	pmp->cxBitmapRes = pmp->cyBitmapRes = 0;
     }
     else
     {
	/* default to Windows and OS2 2.0 PM bitmap */
	cScans = pbmp2->cy;
	pmp->cyBitmap = pbmp2->cy;
	pmp->cxBitmap = pbmp2->cx;
	pmp->cxBitmapRes = pbmp2->cxResolution;
	pmp->cyBitmapRes = pbmp2->cyResolution;
     }


     /*
      * Some print drivers expect the bit image data to be dword
      * aligned.  Allocate a new memory object and copy bit data
      * to it.
      */
     pBitsAligned = (PBYTE) malloc( cbImageData );
     pmassert( hab, pBitsAligned );
     pmassert( hab, ((ULONG)pBitsAligned & 3 ) == 0 );
     memcpy( pBitsAligned, pBits, cbImageData );


     /* take bitmap bits from file buffer and place into memory ps for bitmap */
     lRC = GpiSetBitmapBits( *phps,
		    0,
		    (LONG)cScans,
		    pBitsAligned,
		    (PBITMAPINFO2)pbmp2	 );
     pmassert( hab, lRC != GPI_ERROR );

     /* clean up */
     free( pBitsAligned );
     free( pbmpfileheader2 );

     /* invalidate client area to force a paint */
     WinInvalidateRect( pmp->hwndClient, NULL, FALSE );

     /* done loading bitmap */
     WinPostMsg( hwndToAck, WM_USER_ACK, (MPARAM)msg, (MPARAM)0L );
     return (MRESULT)NULL;


   case WM_USER_LOAD_METAFILE:
     /* load new metafile */
     pmp->hmf = GpiLoadMetaFile( hab, pmp->szFilename );
     if( GPI_ERROR  == pmp->hmf )
     {
       /* load error */
       pmp->hmf	 = (HMF)NULLHANDLE;
       WinPostMsg( hwndToAck, WM_NACK_FILE_READING_ERROR,
		       (MPARAM)msg, (MPARAM)0L );
       return (MRESULT)NULL;
     }

     /* invalidate client area to force a paint */
     WinInvalidateRect( pmp->hwndClient, NULL, FALSE );

     /* done loading bitmap */
     WinPostMsg( hwndToAck, WM_USER_ACK, (MPARAM)msg, (MPARAM)0L );
     return (MRESULT)NULL;


   case WM_USER_LOAD_TEXT:
     pmp->f = fopen( pmp->szFilename, "r" );
     if( !pmp->f )
     {
       WinPostMsg( hwndToAck, WM_NACK_FILE_READING_ERROR,
				 (MPARAM)msg, (MPARAM)0L );
       return (MRESULT)NULL;
     }

     /* has user visited the font dialog? */
     if( pmp->fontdlg.fAttrs.usRecordLength == (USHORT)0 )
     {
       /* no font selected yet; chain to font selection dialog now
	* after user selects a font (prtmenu.c), the program invokes
	* the pagination routine				     */
       WinPostMsg( pmp->hwndClient, WM_COMMAND, (MPARAM)IDM_SETFONT, (MPARAM)0L);
     }
     else
     {
       /* a font is already selected; invoke the pagination routine  */
       WinSendMsg( hwnd, WM_USER_PAGINATE,
		   (MPARAM)hwnd, (MPARAM)FLAGS_PAGINATE_SCREEN );
     }

     /* done loading text */
     WinPostMsg( hwndToAck, WM_USER_ACK, (MPARAM)msg, (MPARAM)0L );
     return (MRESULT)NULL;


   case WM_USER_PAGINATE:
     /*
      * mp2 is a set of flags to govern pagination behavior
      * can return one of three result codes:
      * PAGINATE_EOF		 end of file, no text drawn
      * PAGINATE_NOT_EOF	 not end of file, text drawn
      * PAGINATE_EOF_PART_PAGE	 end of file, text drawn
      */
     pmassert( hab, pmp->f );
     pmassert( hab, pmp->ulMode == MODE_TEXT );

     /* check for end of file */
     if( feof( pmp->f ))
     {
       /* ack and return with indication of end-of-file */
       WinPostMsg( hwndToAck, WM_USER_ACK, (MPARAM)msg, (MPARAM)PAGINATE_EOF );
       return (MRESULT) PAGINATE_EOF;
     }

     /* prepare to draw on screen or printer */
     switch( (ULONG)mp2 )
     {
     case FLAGS_PAGINATE_SCREEN:
	hps = pmp->hpsClient;

	/*
	 * Paginate the text into a retained segment. The text drawing
	 * orders can then be played back at WM_PAINT time with a call
	 * to GpiDrawChain.
	 */
	bOK = GpiSetDrawingMode( hps, DM_RETAIN );
	pmassert( hab, bOK );

	GpiErase( hps );

	/* delete any previous segment; segment 1 is all we use */
	GpiDeleteSegment( hps, 1 );

	/* open a new segment for the text using segment ID 1 */
	bOK = GpiOpenSegment( hps, 1 );
	pmassert( hab, bOK );

	/*
	 * Draw a box the same size as the current printer page.
	 * If user picks a font too big, he'll know this visually.
	 */
	pointl.x = pointl.y = 0;
	bOK = GpiSetCurrentPosition( hps,  &pointl );
	pmassert( hab, bOK );

	pointl.x = pmp->sizelPage.cx;
	pointl.y = pmp->sizelPage.cy;
	lRC = GpiBox( hps, DRO_OUTLINE, &pointl, 0L, 0L );
	pmassert( hab, lRC != GPI_ERROR );

	break;

     case FLAGS_PAGINATE_PRINTER:
	pmassert( hab,	pmp->hpsPrinter );
	hps = pmp->hpsPrinter;
	break;

     default:
	pmassert( hab, NULL == "bad flag in WM_USER_PAGINATE" );
     }

     /* use black color */
     bOK = GpiSetColor( hps, CLR_BLACK );
     pmassert( hab, bOK );



     /* Discard LCID (logical character identifier) 1 if it exists. */
     if( GpiSetCharSet( hps, 1 ))
     {
	 /* select font 0 and delete font 1   */
	 GpiSetCharSet(hps, 0 );
	 GpiDeleteSetId(hps, 1 );
     }

     /* select default font 0 */
     GpiSetCharSet(hps, 0 );



    /*
     *	Create the logical font with fAttrs from the font dialog.
     *
     *	This version of the print sample only requests vector (outline)
     *	fonts of the font dialog. (Reference: PRTCREAT.C, the
     *	initialization of the pmp->fontdlg structure.)
     *
     *	Later versions of the print sample will allow the selection of printer
     *	device fonts and then emulate their appearance on the display using
     *	outline fonts.
     *
     *	Create and select the requested font into the PS and query its
     *	font metrics.
     */

    lRC = GpiCreateLogFont( hps, NULL, 1, &pmp->fontdlg.fAttrs );
    pmassert(hab, lRC != GPI_ERROR );

    if( lRC == FONT_DEFAULT )
    {
      /*
       * This can happen on Postscript device fonts which are outline fonts,
       * and also LaserJet PCL 5 scalable printer device fonts. These
       * have to be emulated on the screen. Give a warning to user that
       * some default font is in use, and carry on.
       *
       * A future release of the print sample is to demonstrate the
       * emulation of printer device fonts on the screen using outline fonts.
       */
       WinPostMsg( hwndToAck, WM_NACK_DEFAULT_FONT, 0, 0 );
    }

    bOK = GpiSetCharSet( hps, 1 );
    pmassert( hab, bOK );

    bOK = GpiQueryFontMetrics(hps, sizeof(FONTMETRICS), &fm );
    pmassert(hab, bOK);



    /*
     *	 GpiSetCharBox
     *
     *	 "Char box" the font to the point size desired by the user.
     *	 When sizef.cx == sizef.cy, the result is a normally-proportioned font.
     *	 Setting sizef.cx to one-half of sizef.cy yields a compressed font,
     *	 and setting sizef.cx to twice sizef.cy yields an expanded font.
     *	 Experiment with these settings; this is one of the most flexible
     *	 aspects of the Adobe font rasterizing technology in the OS2 graphics
     *	 engine. It is true WYSIWYG and very device independent.
     *
     *	 Although not demonstrated in this version of the print sample,
     *	 GpiSetCharBox will play an important role in emulating printer device
     *	 fonts on the screen device for WYSIWYG output.
     */

    sizef.cy = sizef.cx = FixedPointsToTwips( pmp->fontdlg.fxPointSize );
    bOK = GpiSetCharBox(hps, &sizef);
    pmassert(hab, bOK);


    /*
     *	Set Line Space
     *
     *	Here are three methods for determining the vertical
     *	line spacing (also known as line increment or leading)
     *	between lines of text.
     *
     *	1) Add two values from the fontmetrics structure:
     *	lMaxBaselineExt + lExternalLeading.
     *
     *	2) Use fontmetrics values lEmHeight * 1.20 + lExternalLeading
     *	lExternalLeading is zero for PM fonts.
     *
     *	3) The typesetters' rule of thumb: lead is pointsize plus two points.
     *
     * Method 1 and 2 require A) a re-read of the font metrics after the call
     * to GpiSetCharBox because those metrics will change as a result of
     * GpiSetCharBox, or B) some computation given the current font metrics.
     * Method 3 is simplest because the only variable is point size, and that
     * was specified by the user.
     *
     * 1 point = 20 twips.
     */

    lLeading =	20 * FIXEDINT( pmp->fontdlg.fxPointSize )
	    +	20 * FIXEDFRAC( pmp->fontdlg.fxPointSize ) / 0x10000
	    +	40;

    /* compute lines on page */
    cLinesOnPage = (pmp->sizelPage.cy / lLeading) - 1;

    /* left margin is zero */
    lLeftMarginTwips = 0;

    /* start a upper left corner of page */
    pointl.x = lLeftMarginTwips;
    pointl.y = pmp->sizelPage.cy  - lLeading;

    /*
     * Read from text file at current file position and draw as much of it
     * as will fit on the page.
     */
    while( fgets( szWork, LEN_WORKSTRING, pmp->f ))
    {
	/* remove trailing white space */
	trim( szWork );

	/* move to the spot on the page */
	bOK = GpiSetCurrentPosition( hps,  &pointl   );
	pmassert( hab, bOK );

	lRC = GpiCharString( hps, strlen( szWork ), szWork );
	pmassert( hab, lRC != GPI_ERROR );

	/* move down the page */
	pointl.y -= lLeading;

	/* have reached bottom of page? */
	if( --cLinesOnPage == 0	 )
	{
	    /* yes, bottom of page; break out of this while loop */
	    break;
	}
    }

    if( (ULONG)mp2 == FLAGS_PAGINATE_SCREEN )
    {
      /* close the drawing segment; only the screen uses retained segments */
      bOK = GpiCloseSegment( hps );
      pmassert( hab, bOK );
      bOK = GpiSetDrawingMode( hps, DM_DRAW );
      pmassert( hab, bOK );
    }

    /* something WAS drawn on the page, yet could be at end of file now */
    lRC = feof( pmp->f ) ? PAGINATE_EOF_PART_PAGE : PAGINATE_NOT_EOF;

    /* ack and return with result code */
    WinPostMsg( hwndToAck, WM_USER_ACK,(MPARAM)msg,(MPARAM)lRC );
    return (MRESULT) lRC;


   case WM_USER_PAINT_BITMAP:
     pmassert( hab, pmp->hbm );

     /*
      * bitblt the bitmap into the client ps
      * set the target coordinates of the screen ps
      */
     WinQueryWindowRect( pmp->hwndClient, &rectl );
     apointl[0].x  = rectl.xLeft;
     apointl[0].y  = rectl.yBottom;
     apointl[1].x  = rectl.xRight;
     apointl[1].y  = rectl.yTop;

     /* set the source coordinates of the loaded bitmap */
     bOK = GpiQueryBitmapParameters( pmp->hbm, &bmpinfo );
     pmassert( hab, bOK );
     apointl[2].x  = 0;
     apointl[2].y  = 0;
     apointl[3].x  = bmpinfo.cx;
     apointl[3].y  = bmpinfo.cy;

     /* bit block transfer */
     lRC = GpiBitBlt( pmp->hpsClient, pmp->hpsMemory, 4L, apointl,
		      ROP_SRCCOPY, BBO_AND );
     pmassert( hab, lRC != GPI_ERROR );

     WinPostMsg( hwndToAck, WM_USER_ACK, (MPARAM)msg, 0 );
     return (MRESULT)NULL;


   case WM_USER_PAINT_METAFILE:
     /*
      * Reference: Graham C.E. Winn, "OS/2 PM GPI", VNR Computer Library
      * play metafile into client area
      */
     pmassert( hab, pmp->hmf );

     /* save state of hps */
     ulOptions = GpiQueryPS( pmp->hpsClient, &sizel );

     memset( alOptions, 0, sizeof( alOptions ));
     alOptions[ PMF_SEGBASE		] = 0;
     alOptions[ PMF_LOADTYPE		] = LT_ORIGINALVIEW;
     alOptions[ PMF_RESOLVE		] = 0;
     alOptions[ PMF_LCIDS		] = LC_LOADDISC;
     alOptions[ PMF_RESET		] = RES_RESET;
     alOptions[ PMF_SUPPRESS		] = SUP_NOSUPPRESS;
     alOptions[ PMF_COLORTABLES		] = CTAB_REPLACE;
     alOptions[ PMF_COLORREALIZABLE	] = CREA_NOREALIZE;
     alOptions[ PMF_DEFAULTS		] = DDEF_LOADDISC;
     lRC = GpiPlayMetaFile( pmp->hpsClient,
			    pmp->hmf,
			    LEN_PLAYMETAFILEOPTS,
			    alOptions,
			    &lCount,		/* segment count */
			    LEN_PLAYMETAFILEDESCS,
			    abDesc );
     pmassert( hab, lRC != GPI_ERROR );

     /* restore state of ps */
     bOK = GpiSetPS( pmp->hpsClient, &sizel, ulOptions );
     pmassert( hab, bOK );

     WinPostMsg( hwndToAck, WM_USER_ACK, (MPARAM)msg, (MPARAM)0L );
     return (MRESULT)NULL;


   case WM_USER_PRINT:
     ProcessUserPrint(hwnd, pmp);
     WinPostMsg( hwndToAck, WM_USER_ACK, (MPARAM)msg, (MPARAM)0L );
     return (MRESULT)NULL;
   }

   /* default: */
   return WinDefWindowProc( hwnd, msg, mp1, mp2 );
}  /* end of ObjectWinProc() */


/*************************************************************************
*
* Name: trim
*
* Description: removes trailing whitespace characters from a string
*
* Parameters: psz = a string
*
* Returns: a pointer to the same string passed in
*
**************************************************************************/

PSZ trim( PSZ s )
{
  PCH p;

  /* point p to null-terminator byte of string s */
  p =  s + strlen( s );

  /* work backward and remove white space characters at end of string */
  p--;
  while( s <= p && ( *p == '\r' || *p == ' ' || *p == '\n' || *p == '\t' ))
  {
    *p = 0;
    p--;
  }

  return s;
}  /*  end of trim()  */


/*************************************************************************
 *
 * name: FixedPointsToTwips
 *
 * Description:	 converts a point size
 *
 * API's:  [none]
 *
 * Parameters:	fxPointSize = the point size as a fixed number
 *
 * Return:  Twips as a fixed number
 *
 **************************************************************************/
FIXED FixedPointsToTwips(FIXED fxPointSize)
{
    USHORT	integer;
    USHORT	fraction;

    integer = FIXEDINT(fxPointSize);
    integer *= 20;
    fraction = FIXEDFRAC(fxPointSize);
    fraction = (USHORT)(((LONG)fraction) * 20L / 0x10000);
    integer += fraction;

    return MAKEFIXED(integer, 0);
} /*  end of FixedPointsToTwips()  */

/***************************  End of prtobj.c ****************************/

/**************************************************************************
 *  File name  :  prtprint.c
 *
 *  Description:  This module contains all the functions needed to display
 *		  a listbox with the valid printer queues and to select a
 *		  printer and the print properties.
 *
 *		  This source file contains the following functions:
 *
 *		  Print( hwnd, pmp )
 *		  PrintingDlgProc( hwnd, msg, mp1, mp2 )
 *		  PrintDlgProc( hwnd, msg, mp1, mp2 )
 *		  QueryPrintQueue( hwnd, pmp, fShowDialog)
 *		  QueryPrintDlgProc( hwnd, msg, mp1, mp2 )
 *		  QueryJobProperties( hab, pQueueInfo )
 *		  ProcessUserPrint( hwnd, pmp )
 *		  PrinterBitblt( hwnd, pmp )
 *		  PrinterPaginate( hwnd, pmp )
 *		  PrinterPlayMetaFile( hwnd, pmp )
 *		  PrinterResetMetaFile( hwnd, pmp )
 *		  FindQueue( pszQueueName, pQueueInfo, sCount )
 *		  SortQueues( pQueue1, pQueue2 )
 *
 *  Concepts   :  Listbox, printer queue display and printer property dislpay
 *		  and modification.
 *
 *  API's      :  DevCloseDC
 *		  DevEscape
 *		  DevOpenDC
 *		  DevPostDeviceModes
 *		  DevQueryCaps
 *
 *		  GpiAssociate
 *		  GpiBitblt
 *		  GpiConvert
 *		  GpiCreateLogFont
 *		  GpiCreatePS
 *		  GpiDeleteBitmap
 *		  GpiDeleteSetID
 *		  GpiDestroyPS
 *		  GpiPlayMetaFile
 *		  GpiQueryPS
 *		  GpiSetBitmap
 *		  GpiSetCharSet
 *
 *		  PrfQueryProfileString
 *
 *		  SplEnumQueue
 *
 *		  WinDefDlgProc
 *		  WinDismissDlg
 *		  WinDlgBox
 *		  WinEnableControl
 *		  WinLoadDlg
 *		  WinLoadString
 *		  WinMessageBox
 *		  WinPostMsg
 *		  WinQueryDlgItemShort
 *		  WinQueryDlgItemText
 *		  WinQueryWindowULong
 *		  WinSendMsg
 *		  WinSetDlgItemShort
 *		  WinSetDlgItemText
 *		  WinSetWindowULong
 *		  WinSendDlgItemMsg
 *		  WinShowWindow
 *
 *  Files      :  OS2.H, MAIN.H, HELP.H, XTRN.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/

/* Include the required sections from the PM header file.  */
#define INCL_WINSTDFILE
#define INCL_WINSTDFONT
#define INCL_WINHELP
#define INCL_WINENTRYFIELDS
#define INCL_WINLISTBOXES
#define INCL_WINDIALOGS
#define INCL_WINERRORS
#define INCL_WINWINDOWMGR
#define INCL_WINSHELLDATA
#define INCL_GPIPRIMITIVES
#define INCL_GPITRANSFORMS
#define INCL_GPIBITMAPS
#define INCL_GPICONTROL
#define INCL_GPIMETAFILES
#define INCL_GPILCIDS
#define INCL_DEV
#define INCL_SPL
#define INCL_SPLDOSPRINT
#include <os2.h>

/* c language includes */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stddef.h>
#include <process.h>
#include <sys\types.h>
#include <sys\stat.h>

/* application includes */
#include "prtsamp.h"
#include "prtsdlg.h"
#include "pmassert.h"
#include "prtshlp.h"


/* static function prototypes */

static int _Optlink SortQueues(const void *pQueue1, const void *pQueue2);
MRESULT EXPENTRY PrintDlgProc(HWND, USHORT, MPARAM, MPARAM);
MRESULT EXPENTRY PrintingDlgProc(HWND, USHORT, MPARAM, MPARAM);
MRESULT EXPENTRY QueryPrintDlgProc(HWND, USHORT, MPARAM, MPARAM);
BOOL QueryJobProperties(HAB hab, PPRQINFO3 pPrQ);
LONG FindQueue(PSZ pszQueueName, PPRQINFO3 pQueueInfo, LONG lCount);
VOID PrinterPaginate(HWND hwnd, PMAIN_PARM pmp);
VOID PrinterBitblt(HWND hwnd, PMAIN_PARM pmp);
VOID PrinterPlayMetaFile(HWND hwnd, PMAIN_PARM pmp);
VOID PrinterResetMetaFile(HWND hwnd, PMAIN_PARM pmp);

/*************************************************************************
 *  Function   :  Print
 *
 *  Description:  This function displays the print dialog.
 *
 *  API's      :  WinDlgBox
 *		  WinSendMsg
 *		  WinLoadDlg
 *
 *  Parameters :  HWND	       window handle of frame window
 *		  PMAIN_PARM   global application data
 *
 *  Return     :  TRUE if print successful, otherwise FALSE
 *
 *************************************************************************/
BOOL Print(HWND hwnd, PMAIN_PARM pmp)
{
   /*
    * Query user print options.	 Of the standard print dialog, we've only
    * made use of the number of copies the user wants. See the PrintDlgProc
    * for details.
    */
   if (WinDlgBox( HWND_DESKTOP,
		  hwnd,
		  (PFNWP)PrintDlgProc,
		  (HMODULE)NULLHANDLE,
		  IDD_PRINT,
		  (PVOID)pmp) )
   {
      /*
       * User wants to print, so start print job and display text
       * showing job printing status.
       */
      WinSendMsg( hwnd, WM_USER_DISABLE_CLIENT, (MPARAM)0L, (MPARAM)0L );

      WinLoadDlg( HWND_DESKTOP,
		  hwnd,
		  (PFNWP)PrintingDlgProc,
		  (HMODULE)NULLHANDLE,
		  IDD_PRINTING,
		  (PVOID)pmp);
   }
   return FALSE;
}

/*************************************************************************
 *  Function   : PrintingDlgProc
 *
 *  Description:  This function displays the print dialog.
 *
 *  API's      :  WinPostMsg
 *		  WinDismissDlg
 *		  WinEnableControl
 *		  WinSetDlgItemText
 *		  WinDefDlgProc
 *
 *  Parameters :  HWND	       window handle of printer selection dialog
 *		  USHORT       message
 *		  MPARAM       message parameter 1
 *		  MPARAM       message parameter 2
 *
 *  Return     :  message result
 *
 *************************************************************************/
MRESULT EXPENTRY PrintingDlgProc(HWND hwnd,
				 USHORT msg,
				 MPARAM mp1,
				 MPARAM mp2)
{
   static PMAIN_PARM   pmp;

   switch (msg)
   {
   case WM_INITDLG:
      /* Get pointer to application specific data */
      pmp = (PMAIN_PARM) PVOIDFROMMP(mp2);

      /*
       * send WM_USER_PRINT message
       * disable client -- object window enables client
       *   when complete
       */
      pmp->fCancel = FALSE;
      WinPostMsg(pmp->hwndObject, WM_USER_PRINT, (MPARAM)hwnd, (MPARAM)0L);
      return 0L;

   case WM_USER_ACK:
      /*
       *  The job has either completed or aborted, so tell the client
       *  window and get out.
       */

      WinPostMsg(pmp->hwndClient, WM_USER_ACK, 0L, 0L);

      WinDismissDlg(hwnd, FALSE);
      return 0L;

   case WM_COMMAND:
      switch(SHORT1FROMMP(mp1))
      {
      case DID_CANCEL:
	 pmp->fCancel = TRUE;
	 WinEnableControl( hwnd, DID_CANCEL, FALSE );
	 WinSetDlgItemText( hwnd, IDD_PRINTINGTEXT, (PSZ)"Aborting..." );
	 return 0;
      }
      break;
   }
   return( WinDefDlgProc( hwnd, msg, mp1, mp2 ) );
}  /* End of PrintingDlgProc */

/*************************************************************************
 *  Function   :  PrintDlgProc
 *
 *  Description:
 *
 *  API's      :  WinSetDlgItemText
 *		  WinSetDlgItemShort
 *		  WinShowWindow
 *		  WinSendMsg
 *		  WinQueryDlgItemShort
 *		  WinQueryDlgItemText
 *		  WinDismissDlg
 *		  WinDefDlgProc
 *
 *  Parameters :  HWND	       window handle of printer selection dialog
 *		  USHORT       message
 *		  MPARAM       message parameter 1
 *		  MPARAM       message parameter 2
 *
 *  Return     :  MRESULT	  message result
 *
 *************************************************************************/
MRESULT EXPENTRY PrintDlgProc(HWND hwnd,
			      USHORT msg,
			      MPARAM mp1,
			      MPARAM mp2)
{
   static PMAIN_PARM pmp;
   PSZ	       psz;
   USHORT      us;
   ULONG       ulPanel;

   switch (msg)
   {
   case WM_INITDLG:
      /* Get pointer to application specific data */
      pmp = (PMAIN_PARM) PVOIDFROMMP(mp2);

      /* Show the printer name */
      WinSetDlgItemText(hwnd, IDD_PRTPRINTER, (PSZ)pmp->achQueueDesc);

      /* Show the document name */
      psz = strrchr( pmp->szFilename, '\\' );
      if (psz && *psz)
      {
	  ++psz;
	  WinSetDlgItemText(hwnd, IDD_PRTDOCUMENT, psz);
      }

      /* Initialize the number of copies */
      WinSetDlgItemShort(hwnd, IDD_PRTCOPIES,
			 pmp->usCopies, FALSE);

	/*
	 * Hide the page and preview controls.	The reason they are
	 * included in the print sample DLG file is for the benefit
	 * of programmers who want their dialogs to look exactly like
	 * those presented in the Programming Guide for printing.
	 */
	for (us = IDD_PRTALL; us <= IDD_PRTPREVIEW; ++us)
	    WinShowWindow(WinWindowFromID(hwnd, us), FALSE);

      /* Make entry fields read only */
      WinSendMsg(WinWindowFromID(hwnd, IDD_PRTPRINTER),
		 EM_SETREADONLY, (MPARAM)TRUE, (MPARAM)0L);
      WinSendMsg(WinWindowFromID(hwnd, IDD_PRTDOCUMENT),
		 EM_SETREADONLY, (MPARAM)TRUE, (MPARAM)0L);

      return 0;

   case WM_HELP:
      if( pmp->hwndHelp )
      {
	 ulPanel = PANEL_PRINTDLG;
	 WinSendMsg( pmp->hwndHelp, HM_DISPLAY_HELP,
		   (MPARAM)&ulPanel, (MPARAM)HM_RESOURCEID );
	 return (MRESULT)NULL;
      }
      break;

   case WM_CONTROL:
      switch(SHORT1FROMMP(mp1))
      {
      case IDD_PRTCOPIES:
	 if (SHORT2FROMMP(mp1) == EN_CHANGE)
	 {
	    /*
	     * Verify that a non-zero number was typed in the entry field.
	     * If not, beep and set it back to 1.
	     */
	    if (!WinQueryDlgItemShort( hwnd, IDD_PRTCOPIES,
				       (PSHORT)&pmp->usCopies, FALSE) ||
				       !pmp->usCopies )
	    {
	       CHAR    szCopies[4];	   /* text contents of entry field */

	       /*
		* If the field has length (no length means user backspaced
		* over the current value), the clear the invalid value and
		* beep to warn the user.
		*/
	       if (WinQueryDlgItemText( hwnd, IDD_PRTCOPIES,
					sizeof(szCopies), (PSZ)szCopies ))
	       {
		  WinSetDlgItemText(hwnd, IDD_PRTCOPIES, "");
		  DosBeep(600, 5);
	       }
	       pmp->usCopies = 1;
	    }
	 }
	 return 0;

	/* Not using these controls; see comment under WM_INITDLG */
      case IDD_PRTALL:
      case IDD_PRTSELECT:
      case IDD_PRTFIRSTPAGE:
      case IDD_PRTLASTPAGE:
      case IDD_PRTPREVIEW:
      case IDD_PRTDOCUMENT:
      case IDD_PRTPRINTER:
	 return 0;
      }
      break;

   case WM_COMMAND:
      switch(SHORT1FROMMP(mp1))
      {
      case DID_OK:
	 WinDismissDlg(hwnd, TRUE);
	 return 0;

      case DID_CANCEL:
	 WinDismissDlg(hwnd, FALSE);
	 return 0;

      case DID_HELP_BUTTON:
	 /* don't do anything yet */
	 return 0;
      }
      break;

   }
   return(WinDefDlgProc(hwnd, msg, mp1, mp2));

} /* End of PrintDlgProc */

/*************************************************************************
 *  Function   :  QueryPrintQueue
 *
 *  Description:  Query all printer queues, display them in a listbox
 *		  and do a selection.
 *
 *  Parameters:	  PMAIN_PARM  pmp has global application data
 *		  fShowDialog	  a flag:  should the dialog be displayed?
 *
 *  API's      :  WinLoadString
 *		  WinMessageBox
 *		  WinDlgBox
 *		  SplEnumQueue
 *
 *  Return     :  TRUE if printer changed, otherwise FALSE
 *
 *************************************************************************/
BOOL QueryPrintQueue(PMAIN_PARM pmp, BOOL fShowDialog)
{
    ULONG	    ul, cReturned, cTotal, cbNeeded;
    PPRQINFO3	    pQueueInfo, pqi;
    LONG	    i;
    BOOL	    fResult, fSameQueue, bOK;
    CHAR	    szWork[LEN_WORKSTRING];
    PSZ		    pszWork;
    SIZEL	    sizel;
    DEVOPENSTRUC    dos;
    CHAR	    achDriverName[DRIVERNAME_LENGTH];
    PCHAR	    pch;

   /*
    * Get count of total number of print queues and the size of the
    * buffer needed (cbNeeded) to hold them.
    */
   ul = SplEnumQueue( NULL,	     /* pszComputerName - local machine */
		      3,	     /* information level 3 requested	*/
		      NULL,	     /* pBuf - NULL for first call	*/
		      0L,	     /* cbBuf - 0 to get size needed	*/
		      &cReturned,    /* number of queues returned	*/
		      &cTotal,	     /* total number of queues		*/
		      &cbNeeded,     /* number bytes needed to store	*/
				     /* all requested information	*/
		      NULL );	     /* reserved			*/

   /* If there are no print queues display Message Box */
   if (cTotal == 0L)
   {	       /* this system has no printers defined */
      bOK = WinLoadString( pmp->hab,
			   (HMODULE)NULLHANDLE,
			   ERRMSG_NO_QUEUES_DEFINED,
			   LEN_WORKSTRING,
			   szWork );
      pmassert( pmp->hab, bOK );

      WinMessageBox( HWND_DESKTOP,
		     pmp->hwndFrame,
		     szWork,
		     pmp->pszTitle,
		     (USHORT)0,
		     MB_OK | MB_MOVEABLE | MB_CUAWARNING | MB_APPLMODAL);
	/* nothing changed */
      return FALSE;
   }

   /*
    * allocate memory to store the enumerated queue information
    */
   pQueueInfo = malloc( cbNeeded ) ;
    pmassert( pmp->hab, pQueueInfo );

    /* Call again to get print queue data. */
   ul = SplEnumQueue( NULL,		/* pszComputerName - local machine */
		      3,		/* information level 3 requested   */
		      pQueueInfo,	/* pBuf - gets enumerated queues   */
		      cbNeeded,		/* cbBuf - size of pBuf		   */
		      &cReturned,	/* number of queues returned	   */
		      &cTotal,		/* total number of queues	   */
		      &cbNeeded,	/* number bytes needed to store	   */
					/*   all requested information	   */
		      NULL );		/* reserved			   */

    pmassert( pmp->hab, ul == 0 );

    /*
     * Validate that the user-preferred queue has been initialized OK.
     * If not, initialize it now. User's preference of queues is
     * named by the variable pmp->achQueueName.
     */

    if( *pmp->achQueueName == 0 )
    {
       /*
	* There is no preferred queue name because there was none
	* in the INI file (perhaps this is the first time the
	* program has run on this system?) or the profile reading
	* failed somehow. Give the user the application default
	* queue.
	*
	* get default queue's name
	*/
       ul = PrfQueryProfileString( HINI_PROFILE,
				   "PM_SPOOLER",
				   "QUEUE",
				   NULL,
				   szWork,
				   LEN_WORKSTRING );

       if( ul )
       {
	  /* truncate queuename at terminating semicolon */
	  pch = strchr( szWork, ';' );
	  pmassert( pmp->hab, pch );
	  *pch = 0;
	  strcpy( pmp->achQueueName, szWork );
       }
       else
       {  /*
	   * no application default queue? odd. Give him the first queue
	   * from the SplEnumQueue calls
	   */
	  pmassert( pmp->hab, *pQueueInfo->pszName );
	  strcpy( pmp->achQueueName, pQueueInfo->pszName );
       }
    }

    pmassert( pmp->hab, 0 < strlen( pmp->achQueueName ));

    /*
     * store current driver data info into SplEnumQueue info
     * so that when user wants to change a print property
     * but not necessarily a printer, his previous settings
     * will be shown in the print properties dialog
     */
    i = FindQueue( pmp->achQueueName, pQueueInfo, cReturned );
    pmassert( pmp->hab, i != -1 );
    pqi = &pQueueInfo[i];
    if( pqi->pDriverData->cb == pmp->cbDriverDataLen )
    {
      memcpy( pqi->pDriverData, pmp->pDriverData, pmp->cbDriverDataLen );
    }


    /*
     * Display dialog box to select a printer
     */


    if (fShowDialog)
    {
	/* sort the data returned from SplEnumQueue by queue name  */
	qsort((void *)pQueueInfo,
	  (size_t)cReturned,
	  (size_t)sizeof(PRQINFO3),
	  SortQueues);

	/*
	 * Dialog procedure requires the data from SplEnumQueue.
	 * Use the pmp to pass this data to the dialog.
	 */
	pmp->pQueueInfo	 = pQueueInfo;
	pmp->lQueueCount = cReturned;

	/* present the dialog  */
	ul = WinDlgBox( HWND_DESKTOP,
			pmp->hwndFrame,
			(PFNWP)QueryPrintDlgProc,
			(HMODULE)0,
			IDD_QUERYPRINT,
			(PVOID)pmp);

	pmassert( pmp->hab, ul != DID_ERROR );

	/* done with these vars for now	 */
	pmp->pQueueInfo	 = NULL;
	pmp->lQueueCount = 0;


	if( ul == DID_CANCEL )
	{
	     /* free queueinfo buffer for SplEnumQueue	 */
	     free( pQueueInfo );
	     /* indicate to caller that no change occurred  */
	     return FALSE;
	}
    }




    /*
     * At this point, something changed about the printer destination:
     * form, printer, queue, resolution, something.
     *
     * Prepare a printer info DC and associate a printer info PS with it
     * for the print queue named by pmp->achQueueName.
     */



    /* set pqi to point to the PRQINFO3 structure for pmp->achQueueName	 */

    i = FindQueue( pmp->achQueueName, pQueueInfo, cReturned );
    pmassert( pmp->hab, i  != -1 );
    pqi = &pQueueInfo[i];

    /*
     * destroy previous printer info PS's and DC's and
     * allocations for their driver data
     */
    if( pmp->pDriverData )
    {
	free( pmp->pDriverData );
	pmp->pDriverData      = NULL;
	pmp->cbDriverDataLen  = 0;
    }

    if( pmp->hpsPrinterInfo )
    {
	GpiAssociate(pmp->hpsPrinterInfo, (HDC)NULL);
	GpiDestroyPS(pmp->hpsPrinterInfo);
	pmp->hpsPrinterInfo = (HPS)0;
    }

    if( pmp->hdcPrinterInfo )
    {
	DevCloseDC(pmp->hdcPrinterInfo);
	pmp->hdcPrinterInfo = (HDC)0;
    }

    /* store new driver name in pmp  */
    strcpy( pmp->achDriverName, pqi->pszDriverName );

    /* store new driver data length in pmp  */
    pmp->cbDriverDataLen  = pqi->pDriverData->cb;

    /* store new driver data in pmp  */
    pmp->pDriverData = (PDRIVDATA) malloc( pmp->cbDriverDataLen );
    pmassert( pmp->hab, pmp->pDriverData );
    memcpy( pmp->pDriverData, pqi->pDriverData, pmp->cbDriverDataLen );

    /* store new queue description in pmp  */
    strncpy(pmp->achQueueDesc, pqi->pszComment, QUEUEDESC_LENGTH);
    pmp->achQueueDesc[QUEUEDESC_LENGTH-1] = 0;

    /* initialize local variables to zeros */
    memset( &dos,   0, sizeof(dos));
    memset( &sizel, 0, sizeof(sizel));

    /* build a devopenstruct for the call to DevOpenDC */
    strcpy( achDriverName, pqi->pszDriverName );
    achDriverName[strcspn(achDriverName, ".")] = '\0';
    dos.pszLogAddress = pmp->achQueueName;
    dos.pszDriverName = (PSZ)achDriverName;
    dos.pdriv = pmp->pDriverData;

    /* Create an OD_INFO device context */
    pmp->hdcPrinterInfo = DevOpenDC(
			    pmp->hab,
			    OD_INFO,
			    "*",
			    3L,
			    (PVOID)&dos,
			    (HDC)NULL);
    pmassert(pmp->hab, pmp->hdcPrinterInfo != DEV_ERROR);


    /* create PS for printer info -- not a full-blown PS */
    pmp->hpsPrinterInfo = GpiCreatePS(
			pmp->hab,
			pmp->hdcPrinterInfo,
			(PSIZEL)&sizel,
			PU_TWIPS | GPIA_ASSOC);
    pmassert(pmp->hab, pmp->hpsPrinterInfo != GPI_ERROR);

    /* Store the page size of the device (PU_TWIPS) */
    ul = GpiQueryPS(pmp->hpsPrinterInfo, (PSIZEL)&pmp->sizelPage);
    pmassert(pmp->hab, ul != GPI_ERROR);


    /* free the buffer allocated for SplEnumQueue call	*/
    free( pQueueInfo );

    /* return indication that something changed	 */
    return TRUE;
}   /*	end of QueryPrintQueue */

/*************************************************************************
 *  Function   :  QueryPrintDlgProc
 *
 *  Description:  This function is the dialog window procedure for printer
 *		  selection.
 *		  This dialog presents to the user a list of printer
 *		  destinations, or queues.  Typically, the user would
 *		  hilight a queue, then press the Job Properties... button
 *		  to set items like orientation, form, resolution, etc.
 *		  The printer driver presents the job properties dialog
 *		  when the application calls DevPostDeviceModes.
 *
 *		  Today, there is no standard, uniform way to tell whether
 *		  the user pressed OK or Cancel at the Job Properties dialog;
 *		  therefore, the dialog processing assumes that
 *		  job properties were changed no matter if the
 *		  user pressed OK or cancel. See the use of the
 *		  fVisitedJobProperties Boolean variable.
 *
 *		  This function is associated with the dialog box that is
 *		  included in the function name of the procedure. It
 *		  provides the service routines for the events (messages)
 *		  that occur because the end user operates one of the dialog
 *		  box's buttons, entry fields, or controls.
 *
 *		  The SWITCH statement in the function distributes the dialog
 *		  box messages to the respective service routines, which are
 *		  set apart by the CASE clauses. Like any other PM window,
 *		  the Dialog Window procedures must provide an appropriate
 *		  service routine for their end user initiated messages as
 *		  well as for the general PM messages (like the WM_CLOSE
 *		  message). If a message is sent to this procedure for which
 *		  there is no programmed CASE condition (no service routine),
 *		  the message is defaulted to the WinDefDlgProc function,
 *		  where it is disposed of by PM.
 *
 *  Parameters :  HWND	       window handle of printer selection dialog
 *		  USHORT       message
 *		  MPARAM       message parameter 1
 *		  MPARAM       message parameter 2
 *
 *  API's      :  WinSetWindowULong
 *		  WinSendDlgItemMsg
 *		  WinEnableControl
 *		  WinSendDlgItemMsg
 *		  WinQueryWindowULong
 *		  WinDismissDlg
 *		  WinDefDlgProc
 *
 * Return      :  message result
 *
 *************************************************************************/
MRESULT EXPENTRY QueryPrintDlgProc( HWND hwnd,
				    USHORT msg,
				    MPARAM mp1,
				    MPARAM mp2 )
{
   static BOOL	       fVisitedJobProperties;
   PMAIN_PARM	       pmp;
   INT		       i, index;
   PSZ		       psz;
   HWND		       hwndListbox;
   ULONG	       ulPanel;

   switch (msg)
   {
   case WM_INITDLG:
      /* Get pointer to application specific data */
      pmp = (PMAIN_PARM) mp2;
      WinSetWindowULong( hwnd, QWL_USER, (ULONG) mp2 );


      /*
       *  Assume user will not select job properties.
       *  This affects how to dismiss this dialog.
       */
      fVisitedJobProperties = FALSE;

      /* Fill listbox with print objects */

	hwndListbox = WinWindowFromID( hwnd, IDD_QPLISTBOX );
	pmassert( pmp->hab, hwndListbox );

      for (i = 0; i < pmp->lQueueCount; ++i)
      {
       /* use printer comment if possible, else use queue name for display */
	 psz = *pmp->pQueueInfo[i].pszComment ?
		pmp->pQueueInfo[i].pszComment :
		pmp->pQueueInfo[i].pszName;
	    /* pmwin.h macro for inserting list box items   */
	    index = WinInsertLboxItem( hwndListbox, LIT_END, psz );

	    /* pre-select this one?  */
	    if( 0 == strcmp( pmp->pQueueInfo[i].pszName, pmp->achQueueName ))
	    {
	       WinSendMsg( hwndListbox, LM_SELECTITEM,
					    (MPARAM)index, (MPARAM)TRUE );
	    }
      }

	/* one must be selected */
	index = WinQueryLboxSelectedItem( hwndListbox );
	pmassert( pmp->hab, index != LIT_NONE );

      return FALSE;

   case WM_HELP:
      /* get pointer to structure from window words of this dialog */
      pmp = (PMAIN_PARM)WinQueryWindowULong( hwnd, QWL_USER );

      if( pmp->hwndHelp )
      {
	 ulPanel = PANEL_QUERYPRINT;
	 WinSendMsg( pmp->hwndHelp, HM_DISPLAY_HELP,
		   (MPARAM)&ulPanel, (MPARAM)HM_RESOURCEID );
	 return (MRESULT)NULL;
      }
      break;


   case WM_COMMAND:
      pmp = (PMAIN_PARM) WinQueryWindowULong( hwnd, QWL_USER );
      switch(SHORT1FROMMP(mp1))
      {
      case IDD_QPJOBPROP:
	  /*
	   * Flag that we visited the job properties dialog. Since
	   * DevPostDeviceModes (OS2_PM_DRV_DEVMODES) option
	   * DPDM_POSTJOBPROP has no return code or standard way to
	   * indicate user cancel, we have to assume something might
	   * have changed.
	   */
	  fVisitedJobProperties = TRUE;
	  hwndListbox = WinWindowFromID( hwnd, IDD_QPLISTBOX );
	  pmassert( pmp->hab, hwndListbox );
	  index = WinQueryLboxSelectedItem( hwndListbox );
	  pmassert( pmp->hab, index != LIT_NONE );
	  QueryJobProperties( pmp->hab, &pmp->pQueueInfo[ index ] );
	  return 0;

      case DID_OK:
	    hwndListbox = WinWindowFromID( hwnd, IDD_QPLISTBOX );
	    pmassert( pmp->hab, hwndListbox );
	    index = WinQueryLboxSelectedItem( hwndListbox );
	    pmassert( pmp->hab, index != LIT_NONE );

	 /* modify pmp->achQueueName; it is now the user's preferred queue */
	    strcpy( pmp->achQueueName,	pmp->pQueueInfo[ index ].pszName );
	    WinDismissDlg( hwnd, DID_OK );
	    return 0;


      case DID_CANCEL:
	 WinDismissDlg(hwnd, fVisitedJobProperties ? DID_OK : DID_CANCEL );
	 return (MRESULT)NULL;
      }
      break;

   }
   return( WinDefDlgProc(hwnd, msg, mp1, mp2) );
} /* End of QueryPrintDlgProc */


/*************************************************************************
 *  Function   :  QueryJobProperties
 *
 *  Description:  Query job properties (print properties) of the printer
 *		  driver.
 *
 *  Parameters :  HAB		  anchor block handle of the process
 *		  PPRQINFO3	  pointer to queue information structure
 *
 *  API's      :  DevPostDeviceModes
 *
 *  Return     :  TRUE if ok, otherwise FALSE
 *
 *************************************************************************/
BOOL QueryJobProperties(HAB hab, PPRQINFO3 pQueueInfo)
{
   CHAR	       achDriverName[DRIVERNAME_LENGTH];
   CHAR	       achDeviceName[DEVICENAME_LENGTH];
   INT	       i;
   LONG	       l;
   PSZ	       pszTemp;

   /*
    * The pszDriverName is of the form DRIVER.DEVICE (e.g.,
    * LASERJET.HP LaserJet IID) so we need to separate it
    * at the dot
    */
   i = strcspn(pQueueInfo->pszDriverName, ".");
   if (i)
   {
      strncpy(achDriverName, pQueueInfo->pszDriverName, i);
      achDriverName[i] = '\0';
      strcpy(achDeviceName, &pQueueInfo->pszDriverName[i + 1]);
   }
   else
   {
      strcpy(achDriverName, pQueueInfo->pszDriverName);
      *achDeviceName = '\0';
   }

   /*
    * There may be more than one printer assigned to this print queue
    * We will use the first in the comma separated list.  We would
    * need an expanded dialog for the user to be more specific.
    */
   pszTemp = strchr(pQueueInfo->pszPrinters, ',');
   if ( pszTemp )
   {
      /* Strip off comma and trailing printer names */
      *pszTemp = '\0' ;
   }

   /*
    * Post the job properties dialog for the printer to allow the
    * user to modify the options
    */
   l = DevPostDeviceModes( hab,
			   pQueueInfo->pDriverData,
			   achDriverName,
			   achDeviceName,
			   pQueueInfo->pszPrinters,
			   DPDM_POSTJOBPROP );

   return l == DEV_OK;
}  /* End of QueryJobProperties */

/*************************************************************************
 *
 *  Name:	  ProcessUserPrint
 *
 *  Description:  This routine handles the user print (WM_USER_PRINT)
 *		  message. We're running thread 2 here because it can be
 *		  a long operation. The device context and presentation
 *		  space are created here, then one of three functions
 *		  is called to print depending on whether we have a
 *		  bitmap, metafile or text document.
 *
 *  Parameters :  HWND		 window handle
 *		  PMAIN_PARM	 global application data
 *
 *  API's      :  DevOpenDC
 *		  GpiCreatePS
 *		  DevEscape
 *		  GpiAssociate
 *		  GpiDestroyPS
 *		  DevCloseDC
 *
 *  Return     :  VOID
 *
 *
 *************************************************************************/

VOID ProcessUserPrint( HWND hwnd, PMAIN_PARM pmp)
{
   DEVOPENSTRUC	   dos;
   USHORT	   us;
   VOID		   (*pfnPrintDocument)(HWND, PMAIN_PARM);
   CHAR		   achDriverName[DRIVERNAME_LENGTH];
   CHAR		   achQueueProcParams[8];
   BOOL		   fResult;

   /* Build the device context data for DevOpenDC */
   memset((PVOID)&dos, 0, sizeof(dos));

   strcpy(achDriverName, pmp->achDriverName);
   achDriverName[strcspn(achDriverName, ".")] = '\0';
   sprintf(achQueueProcParams, "COP=%d", pmp->usCopies);

   dos.pszLogAddress = pmp->achQueueName;
   dos.pszDriverName = (PSZ)achDriverName;
   dos.pdriv = pmp->pDriverData;
   dos.pszDataType = (PSZ)"PM_Q_STD";
   dos.pszComment = pmp->pszTitle;
   dos.pszQueueProcParams = (PSZ)achQueueProcParams;

   /*
    * Switch on whether we are writing text, a bitmap
    * or a metafile into the PS, and process
    */
   switch (pmp->ulMode)
   {
   case MODE_TEXT:
	/* Seek to beginning of user-specified file */
      fseek(pmp->f, 0, SEEK_SET);
      pfnPrintDocument = PrinterPaginate;
      break;

   case MODE_BITMAP:
      pfnPrintDocument = PrinterBitblt;

      /*
       * Don't create PM_Q_STD bitmaps because of color conversion
       * problems if printing color bitmaps on a monochrome device.
       */
      dos.pszDataType = (PSZ)"PM_Q_RAW";
      break;

   case MODE_METAFILE:
      pfnPrintDocument = PrinterPlayMetaFile;
      break;

   default:
      pmassert(pmp->hab, FALSE);
      return;
   }

   /* Create DC for the printer */
   pmp->hdcPrinter = DevOpenDC( pmp->hab,
				OD_QUEUED,
				"*",
				9L,
				(PVOID)&dos,
				(HDC)NULLHANDLE );

   /* Create PS for the printer */
   pmp->hpsPrinter = GPI_ERROR;
   if (pmp->hdcPrinter != DEV_ERROR)
   {
      pmp->hpsPrinter = GpiCreatePS( pmp->hab,
				     pmp->hdcPrinter,
				     (PSIZEL)&pmp->sizelPage,
				     PU_TWIPS | GPIA_NOASSOC );
      pmassert( pmp->hab, pmp->hpsPrinter != GPI_ERROR );

      if (pmp->hpsPrinter != GPI_ERROR)
      {
	 /*
	  * Didn't use GPI_ASSOC to create the PS so that in the case
	  * of a metafile, we can first play the metafile to reset the
	  * PS before it is associated to the DC.
	  */
	 if (pmp->ulMode == MODE_METAFILE)
	 {
	    PrinterResetMetaFile(hwnd, pmp);
	 }

	 /* Now associate the presentation space */
	 fResult = GpiAssociate(pmp->hpsPrinter, pmp->hdcPrinter);
	 pmassert(pmp->hab, fResult);

	 /* Issue STARTDOC to begin printing */
	 DevEscape( pmp->hdcPrinter,
		    DEVESC_STARTDOC,
		    (LONG)strlen(pmp->szFilename),
		    (PBYTE)pmp->szFilename,
		    (PLONG)NULL, (PBYTE)NULL );

	 /* Print the document */
	 (*pfnPrintDocument)(hwnd, pmp);

	 /*
	  * Issue ABORTDOC if user cancelled print job, or ENDDOC
	  * to for normal job termination.
	  */
	 DevEscape( pmp->hdcPrinter,
		    pmp->fCancel ? DEVESC_ABORTDOC : DEVESC_ENDDOC,
		    0L, (PBYTE)NULL, (PLONG)NULL, (PBYTE)NULL );

	 /* Release and destroy the PS */
	 GpiAssociate( pmp->hpsPrinter, (HDC)NULLHANDLE );
	 GpiDestroyPS( pmp->hpsPrinter );
      }
   }

   /* Clean up the DC */
   if (pmp->hdcPrinter != DEV_ERROR)
   {
      DevCloseDC(pmp->hdcPrinter);
      pmp->hdcPrinter = DEV_ERROR;
   }

   return;
}

/*************************************************************************
 *
 *  Name       :  PrinterBitblt
 *
 *  Description:  Load a bitmap into a memory DC using the WM_USER_LOAD_BITMAP
 *		  processing. Calculate what size to print the bitmap in order
 *		  to preserve the bitmap aspect ratio and still have it fit on
 *		  the page. Then bit blit into the printer PS, allowing the
 *		  device presentation driver to do the stretch blit.
 *
 *  Parameters :  HWND		 window handle
 *		  PMAIN_PARM	 global application data
 *
 *  API's      :  WinSendMsg
 *		  GpiQueryPS
 *		  GpiConvert
 *		  GpiBitblt
 *		  GpiSetBitmap
 *		  GpiDeleteBitmap
 *		  GpiAssociate
 *		  GpiDestroyPS
 *		  DevCloseDC
 *
 *  Return     :  VOID
 *
 *************************************************************************/

VOID PrinterBitblt(HWND hwnd, PMAIN_PARM pmp)
{
    BITMAPINFOHEADER bmi;
    POINTL  aptl[4];
    LONG    lResult;
    double  xRatio, yRatio;

    /* Clear our variables to ensure USER_LOAD_BITMAP starts fresh */
    pmp->hdcMem4Printer = (HDC)NULLHANDLE;
    pmp->hpsMem4Printer = (HPS)NULLHANDLE;
    pmp->hbm4Printer = (HBITMAP)NULLHANDLE;

    /* Send message to create a printer PS with our bitmap set into it */
    WinSendMsg(hwnd, WM_USER_LOAD_BITMAP, (MPARAM)hwnd,
	       (MPARAM)HDCMEM_COMPATIBILITY_PRINTER);

    /* Set up source and target blt rectangles */
    aptl[0].x = aptl[0].y = 0L;
    aptl[2].x = aptl[2].y = 0L;

    aptl[3].x = pmp->cxBitmap;
    aptl[3].y = pmp->cyBitmap;

    if (pmp->cxBitmapRes && pmp->cyBitmapRes)
    {
	/*
	 * Since the intended resolution for the bitmap is known,
	 * the actual size of the bitmap can be calculated, in
	 * twips (1440 twips/inch).
	 */
	aptl[1].x = ((double)pmp->cxBitmap)/((double)pmp->cxBitmapRes)
		    * 1440.0;
	aptl[1].y = ((double)pmp->cyBitmap)/((double)pmp->cyBitmapRes)
		    * 1440.0;
    }
    else
    {
       /*
	* Assume the bitmap aspect ratio is 1.0 and fit this to
	* the size of the presentation space
	*/
       GpiQueryPS(pmp->hpsPrinter, (PSIZEL)&aptl[1]);
       xRatio = ((double)aptl[1].x) / ((double)aptl[3].x);
       yRatio = ((double)aptl[1].y) / ((double)aptl[3].y);
       if (yRatio > xRatio)
	  aptl[1].y = xRatio * (double)aptl[3].y;
       else
	  aptl[1].x = yRatio * (double)aptl[3].x;
    }

    /* Convert twips to device pels */
    GpiConvert( pmp->hpsPrinter, CVTC_WORLD, CVTC_DEVICE, 1L,
		(PPOINTL)&aptl[1] );

    /* Translate the position of the bitmap on the page here */

    /* Bitblt the source bitmap onto the printer presentation space */
    lResult = GpiBitBlt( pmp->hpsPrinter,
			 pmp->hpsMem4Printer,
			 4L,
			 (PPOINTL)aptl,
			 ROP_SRCCOPY,
			 BBO_IGNORE );
    pmassert( pmp->hab, lResult == GPI_OK );

    /* Clean up bitmap, memory PS and memory DC */
    GpiSetBitmap( pmp->hpsMem4Printer, (HBITMAP)NULLHANDLE );
    GpiDeleteBitmap( pmp->hbm4Printer );
    GpiAssociate( pmp->hpsMem4Printer, (HDC)NULLHANDLE );
    GpiDestroyPS( pmp->hpsMem4Printer );
    DevCloseDC( pmp->hdcMem4Printer );

    return;
}  /* End of PrinterBitblt */

/*************************************************************************
 *
 *  Name:      :  PrinterPaginate
 *
 *  Description:  This function uses WM_USER_PAGINATE processing to
 *		  print text to printer There is a check of the fCancel
 *		  Boolean in the main parameters after paginating each
 *		  page. If this Boolean becomes true, then printing the
 *		  text is aborted.
 *
 *  API's      :  GpiCreateLogFont
 *		  GpiSetCharSet
 *		  WinSendMsg
 *		  DevEscape
 *		  GpiSetCharSet
 *		  GpiDeleteSetID
 *
 *  Return     :  VOID
 *
 *************************************************************************/
VOID PrinterPaginate(HWND hwnd, PMAIN_PARM pmp)
{
   ULONG   ul;
   BOOL	   fResult;

   /*
    * Create a logical font for the printer and set it
    * into the PS
    */
   ul = (ULONG)GpiCreateLogFont( pmp->hpsPrinter,
				 (PSTR8)NULL,
				 1L,
				 (PFATTRS)&pmp->fontdlg.fAttrs );
   pmassert(pmp->hab, ul == FONT_MATCH);

   fResult = GpiSetCharSet( pmp->hpsPrinter, 1L );
   pmassert( pmp->hab, fResult );

   do
   {
      ul = (ULONG)WinSendMsg( hwnd,
			      WM_USER_PAGINATE,
			      (MPARAM)hwnd,
			      (MPARAM)FLAGS_PAGINATE_PRINTER );
      if ( ul == PAGINATE_NOT_EOF )
      {
	 DevEscape( pmp->hdcPrinter,
		    DEVESC_NEWFRAME,
		    0L,
		    (PBYTE)NULL,
		    (PLONG)NULL,
		    (PBYTE)NULL );
      }
      else
      {
	   /* End of file; Break out of this loop and return to do enddoc */
	  break;
      }
    } while (  !pmp->fCancel );

   /* Clean up logical font id */
   GpiSetCharSet(pmp->hpsPrinter, 0L);
   GpiDeleteSetId(pmp->hpsPrinter, 1L);

   return;
}  /* End of PrinterPaginate */

/*************************************************************************
 *
 *  Name       :  PrinterPlayMetafile
 *
 *  Description:  Play metafile into printer PS without the reset and
 *		  suppress options.
 *
 *  Parameters :  HWND		 window handle
 *		  PMAIN_PARM	 global application data
 *
 *  API's      :  GpiPlayMetaFile
 *
 *  Return     :  VOID
 *
 *  reference  :  Graham C.E. Winn, "OS/2 PM GPI", VNR Computer Library
 *
 *************************************************************************/
VOID PrinterPlayMetaFile(HWND hwnd, PMAIN_PARM pmp)
{
   LONG	   alOptions[ LEN_PLAYMETAFILEOPTS ];
   BYTE	   abDesc[ LEN_PLAYMETAFILEDESCS ];
   LONG	   lSegments;
   BOOL	   fResult;

   lSegments = 0;

   memset(alOptions, 0, sizeof(alOptions));
   alOptions[ PMF_SEGBASE	  ] = 0L;
   alOptions[ PMF_LOADTYPE	  ] = LT_NOMODIFY;
   alOptions[ PMF_RESOLVE	  ] = RS_DEFAULT;
   alOptions[ PMF_LCIDS		  ] = LC_LOADDISC;
   alOptions[ PMF_RESET		  ] = RES_NORESET;
   alOptions[ PMF_SUPPRESS	  ] = SUP_NOSUPPRESS;
   alOptions[ PMF_COLORTABLES	  ] = CTAB_REPLACE;
   alOptions[ PMF_COLORREALIZABLE ] = CREA_NOREALIZE;
   alOptions[ PMF_DEFAULTS	  ] = DDEF_LOADDISC;

   fResult = (BOOL)GpiPlayMetaFile( pmp->hpsPrinter,
				    pmp->hmf,
				    LEN_PLAYMETAFILEOPTS,
				    alOptions,
				    (PLONG)&lSegments,
				    LEN_PLAYMETAFILEDESCS,
				    (PSZ)abDesc );
   pmassert( pmp->hab, fResult );

   return;
}  /* End of PrinterPlayMetafile */

/*************************************************************************
 *
 *  Function   :  PrinterResetMetafile
 *
 *  Description:  Reset the printer PS with page units, size and default viewing
 *		  transform specified in the metafile.	Note that the PS must
 *		  not be associated with the DC if this is an PM_Q_STD print job.
 *
 *  Parameters :  HWND		 window handle
 *		  PMAIN_PARM	 global application data
 *
 *  API's      :  GpiPlayMetaFile
 *
 *  Return     :  VOID
 *
 *  reference  :  Graham C.E. Winn, "OS/2 PM GPI", VNR Computer Library
 *
 *************************************************************************/
VOID PrinterResetMetaFile(HWND hwnd, PMAIN_PARM pmp)
{
   LONG	       alOptions[ LEN_PLAYMETAFILEOPTS ];
   BYTE	       abDesc[ LEN_PLAYMETAFILEDESCS ];
   LONG	       lSegments;
   BOOL	       fResult;

   lSegments = 0L;

   memset(alOptions, 0, sizeof(alOptions));
   alOptions[ PMF_SEGBASE	  ] = 0L;
   alOptions[ PMF_LOADTYPE	  ] = LT_NOMODIFY;
   alOptions[ PMF_RESOLVE	  ] = RS_DEFAULT;
   alOptions[ PMF_LCIDS		  ] = LC_LOADDISC;
   alOptions[ PMF_RESET		  ] = RES_RESET;
   alOptions[ PMF_SUPPRESS	  ] = SUP_SUPPRESS;
   alOptions[ PMF_COLORTABLES	  ] = CTAB_DEFAULT;
   alOptions[ PMF_COLORREALIZABLE ] = CREA_DEFAULT;
   alOptions[ PMF_DEFAULTS	  ] = DDEF_DEFAULT;

   fResult = (BOOL)GpiPlayMetaFile( pmp->hpsPrinter,
				    pmp->hmf,
				    LEN_PLAYMETAFILEOPTS,
				    alOptions,
				    (PLONG)&lSegments,
				    LEN_PLAYMETAFILEDESCS,
				    (PSZ)abDesc );
   pmassert( pmp->hab, fResult );

   return;
}  /* End of PrinterResetMetaFile */

/*************************************************************************
 *
 *   Function	:  FindQueue
 *
 *   Description:  Finds the queue name in the PRQINFO3 structure.
 *
 *   Parameters :  PSZ		pointer to the name of the queue
 *		   PPRQINFO3	pointer to queue selection structure 1
 *		   SHORT	number of queue names to compare
 *
 *   API's      :  [none]
 *
 *************************************************************************/
LONG FindQueue(PSZ pszQueueName, PPRQINFO3 pQueueInfo, LONG lCount)
{
   LONG i;

   for (i = 0L; i < lCount; ++i)
   {
      if ( !strcmp( pszQueueName, pQueueInfo[i].pszName ) )
	 return i;
   }

   return -1L;		       /*  if not found	 */
}  /* End of FindQueue */

/*************************************************************************
 *  Function   :  SortQueues
 *
 *  Description:  Compare routine for sorting the queue names table.
 *
 *  Parameters :  PPRQINFO3    pointer to queue selection structure 1
 *		  PPRQINFO3    pointer to queue selection structure 2
 *
 *  API's      :  [none]
 *
 *  Return     :  result of comparison
 *
 *************************************************************************/
static int _Optlink SortQueues(const void *pQueue1, const void *pQueue2)
{
return(strcmp(((PPRQINFO3)pQueue1)->pszComment,
	      ((PPRQINFO3)pQueue2)->pszComment));
} /* end of SortQueues() */
/***************************  End of prtprint.c ****************************/
/****************************************************************************
 * OS/2 Sample Print Application PRTSAMP
 *
 * File name: prtprof.c
 *
 * Description:	 In this module are all the functions needed to save and
 *		 restore the application defaults to/from the PRTSAMP.INI.
 *
 *		 This source file contains the following functions:
 *
 *		 GetProfile(pmp)
 *		 SaveProfile(pmp)
 *		 SaveVersion(pmp)
 *		 SaveProfileOnly(pmp)
 *		 SaveDriverData(pmp)
 *		 PutProfileInfo(pmp)
 *		 GetProfileInfo(pmp)
 *
 * Concepts:   profile file
 *
 * API's:      PrfQueryProfileData
 *	       PrfWriteProfileData
 *	       PrfQueryProfileSize
 *	       WinQueryWindowPos
 *	       WinQueryWindowUShort
 *
 *    Files    :  OS2.H, PRTSAMP.H, PRTSDLG.H, PMASSERT.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 ****************************************************************************/

/* os2 includes */
#define INCL_WINSTDFILE
#define INCL_WINSTDFONT
#define INCL_WINWINDOWMGR
#define INCL_WINSHELLDATA
#define INCL_GPITRANSFORMS
#define INCL_SPL
#define INCL_SPLDOSPRINT
#include <os2.h>

/* c language includes */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stddef.h>
#include <process.h>
#include <sys\types.h>
#include <sys\stat.h>

/* application includes */
#include "prtsamp.h"
#include "prtsdlg.h"
#include "pmassert.h"

static const LONG lProgramVersion = 2000L;

static const PSZ pszApplication = "PRTSAMP";
static const PSZ pszProfileKey = "Profile";
static const PSZ pszVersionKey = "Version";
static const PSZ pszDriverDataKey = "DriverData";

VOID GetProfileInfo(PMAIN_PARM pmp);
VOID PutProfileInfo(PMAIN_PARM pmp);
BOOL SaveDriverData(PMAIN_PARM pmp);
BOOL SaveProfileOnly(PMAIN_PARM pmp);
BOOL SaveVersion(PMAIN_PARM pmp);

/***************************************************************************
 * Name	   : GetDefaults
 *
 * Description:	 Get the application defaults from OS2.INI (HINI_USERPROFILE)
 *
 * Concepts:  profile file
 *
 * API's:      PrfQueryProfileData
 *	       PrfWriteProfileData
 *	       PrfQueryProfileSize
 *
 * Parameters:	pmp = a pointer to the application main data structure
 *
 * Return:   [none]
 *
 ***************************************************************************/
VOID GetProfile(PMAIN_PARM pmp)
{
   LONG	   lCount, lVersion;
   BOOL	   fNeedDefaults;

   fNeedDefaults = TRUE;
   lVersion = 0;
   pmp->pDriverData = (PDRIVDATA)NULL;
   pmp->cbDriverDataLen = 0;

   /*
    * First determine if the profile information in OS2.INI matches
    * the version number of this program.  If so, we will understand
    * the format of the data.  Otherwise, just use default values.
    */
   lCount = sizeof(LONG);

   if (!PrfQueryProfileData(
	   HINI_USERPROFILE,
	   pszApplication,
	   pszVersionKey,
	   (PVOID)&lVersion,
	   (PULONG)&lCount) ||
       lCount != sizeof(LONG))
   {
       ;
   }
   else if (lVersion != lProgramVersion)
   {
       /*
	* The profile data is the wrong version, so we need to clean
	* it up. This deletes all keys under the application name.
	*/
       PrfWriteProfileData(
	   HINI_USERPROFILE,
	   pszApplication,
	   (PSZ)NULL,
	   (PVOID)NULL,
	   0L);
   }
   else
   {
       /*
	* We have a matching version number, so we can proceed to
	* read the rest of the profile information.
	*/

       /*
	* Look for the "Profile" information. We know the size of this
	* data so we're going to read as many bytes as we need. If for
	* some reason there's more info than we need that's all right
	* because we're relying on the lVersion to tell us we understand
	* the data.
	*/
       lCount = sizeof(PRTSAMP_PROFILE);

       if (PrfQueryProfileData(
	       HINI_USERPROFILE,
	       pszApplication,
	       pszProfileKey,
	       (PVOID)&pmp->Profile,
	       (PULONG)&lCount) &&
	   lCount == sizeof(PRTSAMP_PROFILE))
       {
	   fNeedDefaults = FALSE;

	   /*
	    * We found our profile data, which includes what
	    * print object we want to use. Now look for the
	    * "DriverData" data we want to use for this
	    * print object.
	    */
	   if (PrfQueryProfileSize(
		   HINI_USERPROFILE,
		   pszApplication,
		   pszDriverDataKey,
		   (PULONG)&lCount) &&
	       lCount >= sizeof(DRIVDATA))
	   {
	       /*
		* Found the size of the driver data. It can
		* only make sense if it is at least as big
		* as the DRIVDATA structure. Allocate some
		* space for it, and read it in.
		*/
	       pmp->pDriverData = (PDRIVDATA)malloc(lCount);
	       if (pmp->pDriverData)
	       {
		   pmp->cbDriverDataLen = lCount;

		   if (!PrfQueryProfileData(
			   HINI_USERPROFILE,
			   pszApplication,
			   pszDriverDataKey,
			   (PVOID)pmp->pDriverData,
			   (PULONG)&lCount) ||
		       lCount != pmp->cbDriverDataLen)
		   {
		       /*
			* Didn't find any driver data or the size
			* was wrong. Back out of our allocation.
			*/
		       free(pmp->pDriverData);
		       pmp->pDriverData = (PDRIVDATA)NULL;
		       pmp->cbDriverDataLen = 0;
		   }
	       }
	   }
       }

   } /* end handle correct profile version info */

   if (fNeedDefaults)
   {
       memset((PVOID)&pmp->Profile, 0, sizeof(PRTSAMP_PROFILE));
   }
   else
   {
       GetProfileInfo(pmp);
   }
}  /*  end of GetProfile() */

/**************************************************************************
 * Name:     SaveProfile
 *
 * Description: saves profile data PRTSAMP_PROFILE Application defaults
 *
 * API's:  [none]
 *
 * Parameters:	pmp = a pointer to the application main data structure
 *
 * Return:  [none]
 *
 ***************************************************************************/
VOID SaveProfile(PMAIN_PARM pmp)
{
    PutProfileInfo(pmp);
    SaveVersion(pmp);
    if (SaveProfileOnly(pmp))
	SaveDriverData(pmp);

    return;
} /* end of SaveProfile() */

/**************************************************************************
 * Name:     SaveVersion
 *
 * Description: saves program version to user profile
 *
 * API's:  PrfWriteProfileData
 *
 * Parameters:	pmp = a pointer to the application main data structure
 *
 * Return:  value from call to PrfWriteProfileData
 *
 ***************************************************************************/
BOOL SaveVersion(PMAIN_PARM pmp)
{
    return PrfWriteProfileData(
	HINI_USERPROFILE,
	pszApplication,
	pszVersionKey,
	(PVOID)&lProgramVersion,
	(ULONG)sizeof(lProgramVersion));
} /*  end of SaveVersion()  */

/**************************************************************************
 * Name :    SaveProfileOnly
 *
 * Description: saves program profile to user profile
 *
 * API's:  PrfWriteProfileData
 *
 * Parameters:	pmp = a pointer to the application main data structure
 *
 * Return:  value from call to PrfWriteProfileData
 *
 ***************************************************************************/
BOOL SaveProfileOnly(PMAIN_PARM pmp)
{
    return PrfWriteProfileData(
	HINI_USERPROFILE,
	pszApplication,
	pszProfileKey,
	(PVOID)&pmp->Profile,
	(ULONG)sizeof(pmp->Profile));
} /* end of SaveProfileOnly()  */

/**************************************************************************
 * Name :    SaveDriverData
 *
 * Description: saves driver data to user profile
 *
 * API's:  PrfWriteProfileData
 *
 * Parameters:	pmp = a pointer to the application main data structure
 *
 * Return:  value from call to PrfWriteProfileData
 *
 ***************************************************************************/
BOOL SaveDriverData(PMAIN_PARM pmp)
{
   return pmp->pDriverData == (PDRIVDATA)NULL ? FALSE :
	PrfWriteProfileData(
	    HINI_USERPROFILE,
	    pszApplication,
	    pszDriverDataKey,
	    (PVOID)pmp->pDriverData,
	    (ULONG)pmp->cbDriverDataLen);
}  /*  end of SaveDriverData()	*/

/**************************************************************************
 * Name :    PutProfileInfo
 *
 * Description:	 writes data to the profile file
 *
 * API's:  WinQueryWindowPos
 *	   WinQueryWindowUShort
 *
 * Parameters:	pmp = a pointer to the application main data structure
 *
 * Return:  [none]
 *
 ***************************************************************************/
VOID PutProfileInfo(PMAIN_PARM pmp)
{
   SWP	   swpPos;

   memset((PVOID)&pmp->Profile, 0, sizeof(PRTSAMP_PROFILE));

   /*
    * Query window position and size.
    */
   WinQueryWindowPos(pmp->hwndFrame, &swpPos);

   if ((swpPos.fl & SWP_MAXIMIZE) != 0)
   {
       pmp->Profile.fMaximized = TRUE;
       pmp->Profile.cy = WinQueryWindowUShort(pmp->hwndFrame, QWS_CYRESTORE);
       pmp->Profile.cx = WinQueryWindowUShort(pmp->hwndFrame, QWS_CXRESTORE);
       pmp->Profile.y = WinQueryWindowUShort(pmp->hwndFrame, QWS_YRESTORE);
       pmp->Profile.x = WinQueryWindowUShort(pmp->hwndFrame, QWS_XRESTORE);
   }
   else
   {
       pmp->Profile.fMaximized = FALSE;
       pmp->Profile.cy = swpPos.cy;
       pmp->Profile.cx = swpPos.cx;
       pmp->Profile.y = swpPos.y;
       pmp->Profile.x = swpPos.x;
   }

   pmp->Profile.fxPointSize = pmp->fontdlg.fxPointSize;
   memcpy((PVOID)&pmp->Profile.fAttrs,
	  (PVOID)&pmp->fontdlg.fAttrs,
	  sizeof(pmp->Profile.fAttrs));

   pmp->Profile.ulNextMode = pmp->ulMode;
   strcpy(pmp->Profile.szNextFilename, pmp->szFilename);

   strcpy(pmp->Profile.achQueueName, pmp->achQueueName);
   strcpy(pmp->Profile.achDriverName, pmp->achDriverName);

   return;
}  /*  end of PutProfileInfo()	*/

/**************************************************************************
 * Function: GetProfileInfo
 *
 * Description:	 reads data which had been saved in the profile
 *
 * API's:  [none]
 *
 * Parameters:	pmp = a pointer to the application main data structure
 *
 * Result: [none]
 *
 ***************************************************************************/
VOID GetProfileInfo(PMAIN_PARM pmp)
{
   pmp->fontdlg.fxPointSize = pmp->Profile.fxPointSize;
   memcpy((PVOID)&pmp->fontdlg.fAttrs,
	  (PVOID)&pmp->Profile.fAttrs,
	  sizeof(pmp->Profile.fAttrs));

   pmp->ulNextMode = pmp->Profile.ulNextMode;
   strcpy(pmp->szNextFilename, pmp->Profile.szNextFilename);
   strcpy(pmp->achQueueName, pmp->Profile.achQueueName);
   strcpy(pmp->achDriverName, pmp->Profile.achDriverName);

   return;
}  /*  end of GetProfileInfo()	*/
/***************************  End of prtprof.c ****************************/
/***************************************************************************
 *
 * File name   :  prtsamp.c
 *
 * Description :  This program demonstrates how to display and print ascii
 *		  text, meta files and bitmaps.	 It also shows how to use
 *		  the standard file dialog and the standard font dialog,
 *		  how to display and change printer properties and how to
 *		  display and select printer queues.
 *
 *		  This source file contains the following functions:
 *
 *		  main()
 *		  WinProc(hwnd, msg, mp1, mp2)
 *		  CalibrateScrollBar(pmp)
 *
 * Required
 *    files    :
 *		  PRTSAMP.C	   - Source code
 *		  PRTCREAT.C	   - Source code
 *		  PRTMENU.C	   - Source code
 *		  PRTOBJ.C	   - Source code
 *		  PRTPRINT.C	   - Source code
 *		  PRTPROF.C	   - Source code
 *		  PRTSAMP.H	   - Application header file
 *		  PMASSERT.H	   - Application header file
 *		  PRTSDLG.H	   - Application header file
 *		  PRTSHLP.H	   - Application header file
 *		  PRTSAMP.RC	   - Resource file
 *		  PRTSAMP.DLG	   - Dialog file
 *		  PRTSAMP.IPF	   - Help file
 *		  PRTSAMP.MAK	   - Make file for this program
 *		  PRTSAMP.BMP	   - Bitmap file
 *		  PRTSAMP.TXT	   - Text file
 *		  PRTSAMP.MET	   - Meta file
 *		  PRTSAMP.ICO	   - Print sample icon
 *
 *		  OS2.H		   - Presentation Manager include file
 *		  STDIO.H	   - Standard input/output c include file
 *		  STDLIB.H	   - Standard c include file
 *		  STRING.H	   - String handling function declarations
 *		  CTYPE.H
 *		  STDDEF.H
 *		  PROCESS.H
 *		  SYS\TYPES.H
 *		  SYS\STAT.H
 *
 *  Concepts   :  listboxes, directory search
 *
 *  API's      :  GpiAssociate
 *		  GpiConvert
 *		  GpiDeleteBitmap
 *		  GpiDeleteMetaFile
 *		  GpiDestroyPS
 *		  GpiDrawChain
 *		  GpiSetDefaultViewMatrix
 *
 *		  WinAddSwitchEntry
 *		  WinAssociateHelpInstance
 *		  WinBeginPaint
 *		  WinCreateHelpInstance
 *		  WinCreateMsgQueue
 *		  WinCreateStdWindow
 *		  WinDestroyHelpInstance
 *		  WinDestroyMsgQueue
 *		  WinDestroyWindow
 *		  WinDispatchMsg
 *		  WinEndPaint
 *		  WinFillRect
 *		  WinGetMsg
 *		  WinInitialize
 *		  WinInvalidateRect
 *		  WinIsWindowEnabled
 *		  WinLoadString
 *		  WinMessageBox
 *		  WinPostMsg
 *		  WinQuerySysPointer
 *		  WinQueryWindowRect
 *		  WinQueryWindowULong
 *		  WinRegisterClass
 *		  WinRemoveSwitchEntry
 *		  WinSendMsg
 *		  WinSetPointer
 *		  WinSetWindowText
 *		  WinTerminate
 *
 * Required
 *   libraries :  OS2386.LIB	 - Presentation Manager/OS2 library
 *		  C library
 *
 * Required
 *   programs  :  C Compiler
 *		  Linker
 *		  Resource Compiler
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *
 ******************************************************************************/

/* Include the required sections from the PM header files.  */
#define INCL_DOSFILEMGR
#define INCL_WINSTDFILE
#define INCL_WINSTDFONT
#define INCL_WINWINDOWMGR
#define INCL_WINSCROLLBARS
#define INCL_WINDIALOGS
#define INCL_WINERRORS
#define INCL_WINPOINTERS
#define INCL_WININPUT
#define INCL_WINMENUS
#define INCL_WINHELP
#define INCL_WINTIMER
#define INCL_WINSYS
#define INCL_WINFRAMEMGR
#define INCL_GPITRANSFORMS
#define INCL_GPISEGMENTS
#define INCL_GPIMETAFILES
#define INCL_SPL
#define INCL_SPLDOSPRINT
#include <os2.h>

/* c language includes */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stddef.h>
#include <process.h>
#include <sys\types.h>
#include <sys\stat.h>

/* application includes */
#include "prtsamp.h"
#include "prtsdlg.h"
#include "prtshlp.h"
#include "pmassert.h"

/**************************************************************************
 *
 *  Name       : main()
 *
 *  Description: Initializes the application, gets and dispatches messages
 *		 for the client window on thread 1 and terminates the
 *		 application when a WM_QUIT message is received.  It then
 *		 saves the configuration in os2.ini, destroys all OS/2
 *		 PM resources, and terminates.
 *
 *		 The following routine is the Presentation Manager program
 *		 main body. The main body of a PM program is concerned with
 *		 associating the application with the Presentation Manager
 *		 system, creating its message queue, registering and displaying
 *		 its main window, servicing its message queue during the time
 *		 that the application is active, and disassociating the
 *		 application from PM when the user is finished with the
 *		 it. The remaining parts of this source module that are
 *		 concerned with the Presentation Manager are the application's
 *		 window procedures (main window procedure, child window
 *		 procedures, and dialog window procedures) that process the
 *		 messages associated with the application's various windows.
 *
 *  Concepts   : - obtains anchor block handle and creates message
 *		     queue
 *		 - creates the main frame window which creates the
 *		     main client window
 *		 - polls the message queue via Get/Dispatch Msg loop
 *		 - upon exiting the loop, exits
 *
 *  API's      :  WinInitialize
 *		  WinCreateMsgQueue
 *		  WinRegisterClass
 *		  WinLoadString
 *		  WinCreateHelpInstance
 *		  WinMessageBox
 *		  WinCreateStdWindow
 *		  WinQueryWindowULong
 *		  WinAssociateHelpInstance
 *		  WinAddSwitchEntry
 *		  WinGetMsg
 *		  WinDispatchMsg
 *		  WinRemoveSwitchEntry
 *		  WinDestroyHelpInstance
 *		  WinDestroyWindow
 *		  WinDestroyMsgQueue
 *		  WinTerminate
 *
 *  Parameters :  [none]
 *
 *  Return     :  Always returns zero.	The ANSI standard requires that
 *		  main be declared as an INT.
 *
 *************************************************************************/
INT main(VOID)
{
					/* Define variables by type	*/
   BOOL	      bOK;			/* Boolean used for return code */
   HAB	      hab;			/* PM anchor block handle	*/
   HMQ	      hmq;			/* Message queue handle		*/
   QMSG	      qmsg;			/* Message from message queue	*/
   ULONG      ulCtlData;		/* Standard window create flags */
   HWND	      hwndFrame;		/* Frame window handle		*/
   HWND	      hwndClient;		/* Client area window handle	*/
   HWND	      hwndHelp;			/* Help window handle		*/
   PMAIN_PARM pmp;			/* Main parameters structure	*/
   SWCNTRL    swctl;			/* Struct to add to window list */
   HSWITCH    hsw;			/* Window list handle ret'd     */
   HELPINIT   hmi;			/* Struct for help creation	*/
   CHAR	      szWork[ LEN_WORKSTRING ]; /* General use string work area */
   PSZ	      pszTitle;			/* Pointer to program title	*/


   /* normal PM application startup */
   hab = WinInitialize( 0 );
   hmq = WinCreateMsgQueue( hab, 0 );

   /*
    * Register a class for my client window's behavior.
    * This class has enough extra window words to hold a pointer.
    */
   bOK = WinRegisterClass(
		     hab,
		     CLASSNAME,
		     WinProc,
		     CS_SIZEREDRAW,
		     sizeof( PMAIN_PARM ));
   /*
    * Ensure WinRegisterClass worked ok; if not, present a message box.
    * ( See pmassert.h. )
    */
   pmassert( hab, bOK );


   /* Load program title and allocate a local copy. Use it in help creation. */
   WinLoadString( hab, (HMODULE)NULLHANDLE,
		  PROGRAM_TITLE, LEN_WORKSTRING, szWork );
   pszTitle = strdup( szWork );

   /* Create help. */
   memset( &hmi, 0, sizeof( hmi ));
   hmi.cb		  = sizeof( HELPINIT );
   hmi.phtHelpTable	  = (PVOID)(0xffff0000 | ID_PRTSAMP);
   hmi.pszHelpWindowTitle = pszTitle;
   hmi.pszHelpLibraryName = HELP_FILE;
   hwndHelp = WinCreateHelpInstance( hab, &hmi );
   if( ! hwndHelp )
   {
      WinLoadString(hab, (HMODULE)NULLHANDLE,
		    ERRMSG_NO_HELP, LEN_WORKSTRING, szWork);
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, szWork, pszTitle, 0, MB_CANCEL);
   }

   /* done with local copy of title text */
   free( pszTitle );


   /* flags to control creation of window; use on call to WinCreateStdWindow */
   ulCtlData = FCF_SYSMENU | FCF_TITLEBAR | FCF_SIZEBORDER
			   | FCF_MINMAX | FCF_MENU | FCF_ACCELTABLE
			   | FCF_VERTSCROLL;

   hwndFrame = WinCreateStdWindow( HWND_DESKTOP,
				   WS_VISIBLE | FS_ICON | FS_SHELLPOSITION,
				   &ulCtlData,
				   CLASSNAME,
				   NULL,    /* title text set in prtcreat.c */
				   0,	    /* client style		    */
				   (HMODULE)NULLHANDLE,	 /* resources in exe */
				   ID_PRTSAMP,
				   &hwndClient	);

   pmassert( hab, hwndFrame );
   pmassert( hab, hwndClient );

   /* create.c placed pointer to main params in client's window words; get it */
   pmp = (PMAIN_PARM) WinQueryWindowULong( hwndClient, QWL_USER );
   /* store help instance handle in main parameter block */
   pmp->hwndHelp  = hwndHelp;

   bOK = WinAssociateHelpInstance( hwndHelp, hwndFrame );
   pmassert( hab, bOK );

   /* Add program to task list. */
   memset( &swctl, 0, sizeof( SWCNTRL ));
   strcpy( swctl.szSwtitle, pmp->pszTitle );
   swctl.hwnd	       = hwndFrame;
   swctl.uchVisibility = SWL_VISIBLE;
   swctl.fbJump	       = SWL_JUMPABLE;
   hsw = WinAddSwitchEntry( &swctl );

   /* message loop */
   while( WinGetMsg( hab, &qmsg, (HWND)NULLHANDLE, 0, 0 ))
   {
     WinDispatchMsg( hab, &qmsg );
   }

   /* clean up */
   WinRemoveSwitchEntry( hsw );
   WinDestroyHelpInstance( hwndHelp );
   WinDestroyWindow( hwndFrame );
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );

   DosExit( EXIT_PROCESS, 0 );
   return 0;
}  /* End of main() */

/*************************************************************************
 *
 * Name	      : WinProc(hwnd, msg, mp1, mp2)
 *
 * Description: Processes the messages sent to the main client
 *		window.	 This routine processes the basic
 *		messages all client windows should process.
 *
 * Concepts   : This procedure provides service routines for the general
 *		PM events (messages) that PM sends to the window, as well
 *		as the user initiated events (messages) that are generated
 *		when the user selects the action bar and pulldown menu
 *		controls or the corresponding keyboard accelerators.
 *
 *		The switch statement shown below distributes the window
 *		messages to the respective message service routines, which
 *		are set apart by the case statements.  The window
 *		procedures must provide an appropriate service routine for
 *		its end user initiated messages, as well as the general PM
 *		messages (like the WM_CLOSE message). If a message is sent
 *		to this procedure for which there is no programmed case
 *		clause (i.e., no service routine), the message is defaulted
 *		function WinDefWindowProc, where it is disposed of by PM.
 *
 *		Time-consuming tasks are posted to the object window where
 *		they can be performed without the 1/10 second turnaround
 *		time imposed on the client window. When the object window
 *		is busy, the client window is usually disabled. The object
 *		window then posts an acknowledgement
 *		back to the client when the lengthy task is completed.
 *
 *		Cases under the big switch appear in alphabetical order.
 *
 *  API's     :   WinLoadString
 *		  WinMessageBox
 *		  WinQueryWindowULong
 *		  WinSendMsg
 *		  WinPostMsg
 *		  WinIsWindowEnabled
 *		  WinSetPointer
 *		  WinQuerySysPointer
 *		  WinBeginPaint
 *		  WinQueryWindowRect
 *		  WinFillRect
 *		  WinEndPaint
 *		  WinInvalidateRect
 *		  WinSetWindowText
 *		  GpiDrawChain
 *		  GpiConvert
 *		  GpiSetDefaultViewMatrix
 *		  GpiAssociate
 *		  GpiDestroyPS
 *		  GpiDeleteBitmap
 *		  GpiDeleteMetaFile
 *
 * Parameters : HWND	     window handle
 *		ULONG	     message
 *		MPARAM	     message parameter 1
 *		MPARAM	     message parameter 2
 *
 * Result     : MRESULT	     message result
 *
 *************************************************************************/
MRESULT EXPENTRY WinProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   BOOL		       bOK;
   PMAIN_PARM	       pmp;
   HPS		       hps;
   RECTL	       rectl;
   PCHAR	       pch;
   CHAR		       szWork[ LEN_WORKSTRING ];
   SHORT	       cx, cy;
   POINTL	       pointl;
   SHORT	       sStep;
   float	       floatWork;
   ULONG	       ulWork;

   switch(msg)
   {
   case WM_CLOSE:
      /* obtain the main parameter pointer from window words */
      pmp = (PMAIN_PARM) WinQueryWindowULong( hwnd, QWL_USER );

      if( pmp->fBusy )
      {
	 /* OK to close when object window is busy?  */
	 WinLoadString( pmp->hab, (HMODULE)NULLHANDLE,
		   ERRMSG_CLOSE_QUESTION, LEN_WORKSTRING, szWork );
	 ulWork = WinMessageBox( HWND_DESKTOP, pmp->hwndFrame,
		      szWork, pmp->pszTitle, 0, MB_YESNOCANCEL );

	 if( ulWork == MBID_YES )
	 {
	    /* close down the application in spite of being busy */
	    pmp->fCancel = TRUE;
	    /* disable client during exit */
	    WinSendMsg( hwnd, WM_USER_DISABLE_CLIENT, (MPARAM)0 , (MPARAM)0  );
	    /* start a watchdog timer to ensure a timely death */
	    WinStartTimer( pmp->hab, hwnd, ID_DEATH_TIMER, LEN_DEATH_TIMER );
	    /* Tell object window to close, quit, and post me a WM_QUIT */
	    WinPostMsg( pmp->hwndObject, WM_USER_CLOSE, (MPARAM)hwnd, (MPARAM)0 );
	 }
      }
      else
      {
	 /* not busy, so initiate closure by telling object window to close */
	 WinPostMsg( pmp->hwndObject, WM_USER_CLOSE, (MPARAM)hwnd, (MPARAM)0 );
      }
      return (MRESULT)NULL;


   case WM_COMMAND:
      /* do menu activities; see menu.c */
      return Menu( hwnd, msg, mp1, mp2 );


   case WM_CREATE:
      /*
       * Do one-time, startup processing in PRTCREAT.C.
       * This function allocates the pmp, a pointer to the program's
       * main parameters. See the declaration of this block of
       * parameters in PRTSAMP.H, the MAIN_PARM structure.
       *
       * The Create() function allocates this structure and
       * begins to initialize it. Throughout all the code, the pmp->
       * pointer is usually obtainable with a call to WinQueryWindowULong.
       * Window word space for this pointer was reserved on the call
       * to WinRegisterClass.
       *
       * Create() allocates, initializes, and stores the pmp pointer
       * in the client window words. It then starts thread 2 of the
       * application on which the object window operates. The pmp
       * pointer is passed to thread 2 with _beginthread in PRTCREAT.C.
       * The pmp is passed to the object window on the call to
       * WinCreateWindow in PRTOBJ.C. Finally, the object window stores
       * the pmp in its window words under the WM_CREATE case of the
       * ObjectWinProc in PRTOBJ.C.
       *
       */
      Create( hwnd );
      return (MRESULT)NULL;


   case WM_MOUSEMOVE:
      /* display which pointer? -- could query pmp->fBusy or... */
      if( WinIsWindowEnabled( hwnd ))
      {
	 /* not disabled; display regular pointer */
	 WinSetPointer( HWND_DESKTOP,
			WinQuerySysPointer( HWND_DESKTOP, SPTR_ARROW, FALSE ));
      }
      else
      {
	 /* disabled; display hourglass because I'm busy */
	 WinSetPointer( HWND_DESKTOP,
			WinQuerySysPointer( HWND_DESKTOP, SPTR_WAIT, FALSE ));
      }
     return (MRESULT) 1;



   case WM_NACK_BITMAP_NOT_SUPPORTED:
      /*
       * Object window does not support this format of bitmap -
       * show a message box.
       */
      pmp = (PMAIN_PARM) WinQueryWindowULong( hwnd, QWL_USER );
      WinSendMsg( hwnd, WM_USER_ENABLE_CLIENT, (MPARAM)0, (MPARAM)0 );
      bOK = WinLoadString( pmp->hab, (HMODULE)0,
		   ERRMSG_BITMAP_NOT_SUPPORTED, LEN_WORKSTRING, szWork );
      pmassert( pmp->hab, bOK );
      WinMessageBox( HWND_DESKTOP, pmp->hwndFrame,
		     szWork, pmp->pszTitle, 0, MB_CANCEL );

      pmp->ulNextMode	     = MODE_UNKNOWN;
      pmp->szNextFilename[0] = 0;
      WinPostMsg( hwnd, WM_USER_NEW_MODE, (MPARAM)0, (MPARAM)0 );
      return (MRESULT) 0;


   case WM_NACK_DEFAULT_FONT:
      /*
       * On the call to GpiCreateLogFont in PRTOBJ.C, the GPI returned
       * some font other than a perfect match. Warn user that a default
       * face is in use. This can happen for Postscript and PCL 5 printer
       * users.
       *
       * Only warn the user once after each visit to the font dialog.
       *
       * Don't re-enable the client yet. That message is still to come.
       */
      pmp = (PMAIN_PARM) WinQueryWindowULong( hwnd, QWL_USER );
      if( pmp->fVisitedFontDialog )
      {
	 /* only one warning per font dialog visit */
	 pmp->fVisitedFontDialog  = FALSE;

	 bOK = WinLoadString( pmp->hab, (HMODULE)0,
		      ERRMSG_DEFAULT_FONT, LEN_WORKSTRING, szWork );
	 pmassert( pmp->hab, bOK );
	 WinMessageBox( HWND_DESKTOP, pmp->hwndFrame,
			szWork, pmp->pszTitle, 0, MB_CANCEL );
      }
      return (MRESULT) 0;



   case WM_NACK_FILE_READING_ERROR:
      /*
       * Object window had a problem with reading the disk -
       * show a message box.
       */
      pmp = (PMAIN_PARM) WinQueryWindowULong( hwnd, QWL_USER );
      WinSendMsg( hwnd, WM_USER_ENABLE_CLIENT, (MPARAM)0, (MPARAM)0 );
      bOK = WinLoadString( pmp->hab, (HMODULE)NULLHANDLE,
			   ERRMSG_READ_ERROR, LEN_WORKSTRING, szWork );
      pmassert( pmp->hab, bOK );
      WinMessageBox( HWND_DESKTOP, pmp->hwndFrame,
		     szWork, pmp->pszTitle, 0, MB_CANCEL );
      pmp->ulNextMode	     = MODE_UNKNOWN;
      pmp->szNextFilename[0] = 0;
      WinPostMsg( hwnd, WM_USER_NEW_MODE, (MPARAM)0, (MPARAM)0 );
      return (MRESULT) 0;


   case WM_PAINT:
      pmp = (PMAIN_PARM) WinQueryWindowULong( hwnd, QWL_USER );

      /* current mode of the program affects window painting */
      switch( pmp->ulMode )
      {
      case MODE_UNKNOWN:
	 /* blank the client window with background color; use a cache ps */
	 hps = WinBeginPaint( hwnd, (HPS) 0, &rectl );
	 pmassert( pmp->hab, hps );
	 bOK = WinFillRect( pmp->hpsClient, &rectl, SYSCLR_WINDOW );
	 pmassert( pmp->hab, bOK );
	 WinEndPaint( hps );
	 return (MRESULT) 0;

      case MODE_TEXT:
	 if( pmp->fBusy )
	 {
	    /*
	     * Object window is busy with the client PS drawing into
	     * retained segments. Use a cached micro PS to merely
	     * fill the client window with a background wash.
	     *
	     * Proper painting of the text will occur in due time
	     * because the WM_USER_ACK case below will
	     * invalidate the client window and force a paint.
	     * The object window won't be busy then.
	     */
	    hps = WinBeginPaint( hwnd, (HPS) 0, &rectl );
	    pmassert( pmp->hab, hps );
	    bOK = WinFillRect( hps, &rectl, SYSCLR_WINDOW );
	    pmassert( pmp->hab, bOK );
	    WinEndPaint( hps );
	 }
	 else
	 {
	    /* PS not busy. Use GpiDrawChain to repaint the text */
	    hps = WinBeginPaint( hwnd, (HPS)pmp->hpsClient, &rectl );
	    pmassert( pmp->hab, hps );
	    bOK = WinFillRect( pmp->hpsClient, &rectl, SYSCLR_WINDOW );
	    pmassert( pmp->hab, bOK );
	    /*
	     * GpiDrawChain re-plays the GpiCharString orders that were
	     * retain in the WM_USER_PAGINATE case in prtobj.c
	     */
	    bOK = GpiDrawChain( pmp->hpsClient );
	    pmassert( pmp->hab, bOK );
	    bOK = WinEndPaint( pmp->hpsClient );
	    pmassert( pmp->hab, bOK );
	 }
	 return (MRESULT) 0;

      case MODE_BITMAP:
	 if( pmp->hbm )
	 {
	    WinSendMsg( hwnd, WM_USER_DISABLE_CLIENT, (MPARAM)0, (MPARAM)0 );
	    WinPostMsg( pmp->hwndObject, WM_USER_PAINT_BITMAP,
			(MPARAM)hwnd, (MPARAM)0 );
	 }
	 /* must call default window proc for window validation */
	 break;

      case MODE_METAFILE:
	 hps = WinBeginPaint( hwnd, (HPS) 0, &rectl );
	 pmassert( pmp->hab, hps );
	 WinFillRect( hps, &rectl, SYSCLR_WINDOW );
	 if( pmp->hmf )
	 {
	    WinSendMsg( hwnd, WM_USER_DISABLE_CLIENT, (MPARAM)0, (MPARAM)0 );
	    WinPostMsg( pmp->hwndObject, WM_USER_PAINT_METAFILE,
			(MPARAM)hwnd, (MPARAM)0 );
	 }
	 WinEndPaint( hps );
	 return (MRESULT) 0;

      default:
	 pmassert( pmp->hab, NULL == "bad case in WM_PAINT" );
      }
      break;


   case WM_SIZE:
      /* Do size process if frame is not minimized and mode is text. */
      pmp = (PMAIN_PARM) WinQueryWindowULong( hwnd, QWL_USER );

      /*
       * If the object window is busy drawing, the GPI calls here can fail
       * because the PS is busy. Check for this situation and delay
       * the sizing operation by a few milliseconds.
       */
      if( pmp->fBusy )
      {
	  WinStartTimer( pmp->hab, hwnd, ID_SIZE_TIMER, LEN_SIZE_TIMER );
	  return (MRESULT) 0;
      }

      switch( pmp->ulMode )
      {
      case MODE_TEXT:
	 ulWork = WinQueryWindowULong( pmp->hwndFrame, QWL_STYLE );

	 if( !( ulWork & WS_MINIMIZED ))
	 {
	    /* Frame is not minimized. Get window size in pels. */
	    WinQueryWindowRect( hwnd, &rectl );

	    /* how many twips will fit into the client window now? */
	    bOK = GpiConvert( pmp->hpsClient, CVTC_DEVICE,
			      CVTC_WORLD, 2L, (PPOINTL)&rectl );
	    pmassert( pmp->hab, bOK );

	    /* compute client size in twips, store in pmp */
	    pmp->sizelClient.cx = rectl.xRight - rectl.xLeft;
	    pmp->sizelClient.cy = rectl.yTop   - rectl.yBottom;

	    /* reset scroll bar values; set thumbbutton position at zero */
	    pmp->sVScrollPos = 0;
	    CalibrateScrollBar( pmp );

	    /*
	     * Modify def-view matrix Y translation to home the displayed page.
	     * This depends on the current scaling value.
	     */
	    pmp->matlfDefView.lM32 = (LONG)(pmp->floatScale *
		(float) ( OFFSET_XY_TWIPS - pmp->sVScrollRange ));
	    bOK = GpiSetDefaultViewMatrix( pmp->hpsClient, 9,
			     &pmp->matlfDefView, TRANSFORM_REPLACE );
	    pmassert( pmp->hab, bOK );

	    /* force a paint */
	    WinInvalidateRect( hwnd, NULL, FALSE );
	 }
	 break;
      }
      return (MRESULT) 0;




   case WM_TIMER:
      pmp = (PMAIN_PARM) WinQueryWindowULong( hwnd, QWL_USER );
      switch( (ULONG) mp1 )
      {
      case ID_DEATH_TIMER:
	 /* object window never posted a quit in allotted time.
	 WinPostMsg( hwnd, WM_QUIT, 0, 0 );
	 break;
      case ID_SIZE_TIMER:
	 /* object window was busy with the PS before; try sizing now */
	 bOK = WinStopTimer( pmp->hab, hwnd, ID_SIZE_TIMER );
	 pmassert( pmp->hab, bOK );
	 WinSendMsg( hwnd, WM_SIZE, 0, 0 );
	 break;
      }
      return (MRESULT) 0;





   case WM_USER_ACK:
      /*
       * Object window is done processing lengthy task.
       * mp1 contains the WM_USER msg originally posted to the object window
       * mp2 may contain a result code, depending on mp1
       */
      pmp = (PMAIN_PARM) WinQueryWindowULong( hwnd, QWL_USER );

      /* reenable the client window */
      WinSendMsg( hwnd, WM_USER_ENABLE_CLIENT, (MPARAM)0, (MPARAM)0 );

      switch( (ULONG)mp1 )
      {
      case WM_USER_LOAD_TEXT:
	 /*
	  * Do size processing so that document will
	  * "home" in the client window.
	  */
	 WinSendMsg( hwnd, WM_SIZE, (MPARAM)0, (MPARAM)0 );
	 break;
      case WM_USER_PAGINATE:
	 switch( (ULONG)mp2  )
	 {
	 case PAGINATE_EOF:
	 case PAGINATE_EOF_PART_PAGE:
	    /* seek top of file */
	    fseek( pmp->f, 0, SEEK_SET );
	 }
	 WinInvalidateRect( hwnd, NULL, FALSE );
	 break;
      }

      return (MRESULT) 0;


   case WM_USER_DISABLE_CLIENT:
      /*
       * usually disable before posting a task to the object window
       * this message may be sent; disable menu action bar as well
       */
      pmp = (PMAIN_PARM) WinQueryWindowULong( hwnd, QWL_USER );
      pmp->fBusy = TRUE;
      WinEnableWindow( pmp->hwndClient,	 FALSE );
      WinEnableWindow( pmp->hwndMenubar, FALSE );
      WinEnableControl( pmp->hwndFrame, FID_VERTSCROLL,	 FALSE );
      WinEnableMenuItem( pmp->hwndMenubar, IDM_PAGEDOWN, FALSE );
      WinEnableMenuItem( pmp->hwndMenubar, IDM_VIEWFULL, FALSE );
      WinEnableMenuItem( pmp->hwndMenubar, IDM_VIEWHALF, FALSE );
      return (MRESULT)0;


   case WM_USER_ENABLE_CLIENT:
      /*
       * usually enable upon receipt of object window ack/nack
       * this message may be sent; enable menu actions if text mode
       */
      pmp = (PMAIN_PARM) WinQueryWindowULong( hwnd, QWL_USER );
      pmp->fBusy = FALSE;
      WinEnableWindow( pmp->hwndClient,	 TRUE );
      WinEnableWindow( pmp->hwndMenubar, TRUE );
      if( pmp->ulMode == MODE_TEXT )
      {
	 WinEnableControl( pmp->hwndFrame, FID_VERTSCROLL,  TRUE );
	 WinEnableMenuItem( pmp->hwndMenubar, IDM_PAGEDOWN, TRUE );
	 WinEnableMenuItem( pmp->hwndMenubar, IDM_VIEWFULL, TRUE );
	 WinEnableMenuItem( pmp->hwndMenubar, IDM_VIEWHALF, TRUE );
      }
      return (MRESULT) 0;



   case WM_USER_NEW_MODE:
      /*
       * The program now has a new file, file type, or printer, or
       * printer form, orientation, resolution, etc. The receipt
       * and processing of this message works to reset the program:
       * Old file, bitmap, or metafile handles are closed, and
       * new ones get opened. The titlebar shows the new filename.
       * This case works very much like a program reset.
       */
      pmp = (PMAIN_PARM) WinQueryWindowULong( hwnd, QWL_USER );

      /* close processing on current file */

      switch( pmp->ulMode )
      {
      case MODE_BITMAP:
	/* destroy previous memory dc, ps, and hbm */
	if( pmp->hpsMemory )
	{
	  GpiAssociate( pmp->hpsMemory, (HDC)0 );
	  GpiDestroyPS( pmp->hpsMemory );
	  pmp->hpsMemory = (HPS) 0;
	}
	if( pmp->hdcMemory )
	{
	  DevCloseDC( pmp->hdcMemory );
	  pmp->hdcMemory = (HDC) 0;
	}
	if( pmp->hbm )
	{
	  GpiDeleteBitmap( pmp->hbm );
	  pmp->hbm = (HBITMAP) 0;
	}
	break;

      case MODE_METAFILE:
	/* destroy old metafile handle */
	if( pmp->hmf )
	{
	  GpiDeleteMetaFile( pmp->hmf );
	  pmp->hmf = (HMF) 0;
	}
	break;

      case MODE_TEXT:
	fclose( pmp->f );
	pmp->f = (FILE *) 0;
	/* turn off options for text mode */
	WinEnableMenuItem( pmp->hwndMenubar, IDM_VIEWHALF, FALSE );
	WinEnableMenuItem( pmp->hwndMenubar, IDM_VIEWFULL, FALSE );
	WinEnableMenuItem( pmp->hwndMenubar, IDM_PAGEDOWN, FALSE );
	WinEnableMenuItem( pmp->hwndMenubar, IDM_SETFONT,  FALSE );
	WinEnableControl( pmp->hwndFrame, FID_VERTSCROLL,  FALSE );
	break;
      }


      /* copy over current values with the next values */
      pmp->ulMode = pmp->ulNextMode;
      strcpy( pmp->szFilename, pmp->szNextFilename );

      /* enable the print menu option if mode is known and there
	 is a printer set up. */
      WinEnableMenuItem( pmp->hwndMenubar, IDM_PRINT,
       (pmp->ulMode != MODE_UNKNOWN && pmp->hpsPrinterInfo ) );


      /* update title bar text and show filename in use */
      if( *pmp->szFilename )
      {
	pch = strrchr( pmp->szFilename, '\\' );
	pmassert( pmp->hab, pch );
	pch++;
	pmassert( pmp->hab, *pch );
	sprintf( szWork, "%s - %s", pmp->pszTitle, pch );
      }
      else
      {
	strcpy( szWork, pmp->pszTitle );
      }
      WinSetWindowText( pmp->hwndTitlebar, szWork );

      /* process this new mode */
      switch( pmp->ulMode )
      {
      case MODE_BITMAP:
	/* load the bitmap into memory so it is compatible with the screen */
	WinSendMsg( hwnd, WM_USER_DISABLE_CLIENT, 0, 0 );
	WinPostMsg( pmp->hwndObject, WM_USER_LOAD_BITMAP,
		    (MPARAM)hwnd, (MPARAM)HDCMEM_COMPATIBILITY_SCREEN );
	break;

      case MODE_METAFILE:
	/* make object window read metafile */
	WinSendMsg( hwnd, WM_USER_DISABLE_CLIENT, 0, 0 );
	WinPostMsg( pmp->hwndObject, WM_USER_LOAD_METAFILE, (MPARAM)hwnd, 0 );
	break;

      case MODE_TEXT:
	/* turn on options for text mode */
	WinEnableMenuItem( pmp->hwndMenubar, IDM_VIEWHALF, TRUE	 );
	WinEnableMenuItem( pmp->hwndMenubar, IDM_VIEWFULL, TRUE	 );
	WinEnableMenuItem( pmp->hwndMenubar, IDM_PAGEDOWN, TRUE	 );
	WinEnableMenuItem( pmp->hwndMenubar, IDM_SETFONT,  TRUE	 );
	WinEnableControl( pmp->hwndFrame, FID_VERTSCROLL,  TRUE	 );
	/* reset view matrix that was last in effect for viewing text pages; */
	/* this gets lost after viewing a metafile */
	bOK = GpiSetDefaultViewMatrix( pmp->hpsClient, 9,
				       &pmp->matlfDefView, TRANSFORM_REPLACE );
	pmassert( pmp->hab, bOK );
	/* disable until text loaded */
	WinSendMsg( hwnd, WM_USER_DISABLE_CLIENT, 0, 0 );
	/* tell object window to load the text file */
	bOK = WinPostMsg( pmp->hwndObject, WM_USER_LOAD_TEXT, (MPARAM)hwnd, 0 );
	pmassert( pmp->hab, bOK );
	break;


      case MODE_UNKNOWN:
	/* clear the client window */
	WinInvalidateRect( hwnd, NULL, FALSE );
	break;

      }
      return (MRESULT) 0;

   case WM_VSCROLL:
      pmp = (PMAIN_PARM) WinQueryWindowULong( hwnd, QWL_USER );
      pmassert( pmp->hab, pmp->ulMode == MODE_TEXT );

      /* Compute some fraction of scroll bar range for a unit of scrolling. */
      sStep  = pmp->sVScrollRange / 50;

      switch( SHORT2FROMMP( mp2 ))
      {
      case SB_LINEUP:
	 pmp->sVScrollPos	-= sStep;
	 break;
      case SB_PAGEUP:
	 pmp->sVScrollPos	-= pmp->sizelClient.cy;
	 break;
      case SB_LINEDOWN:
	 pmp->sVScrollPos	+= sStep;
	 break;
      case SB_PAGEDOWN:
	 pmp->sVScrollPos += pmp->sizelClient.cy;
	 break;
      case SB_SLIDERPOSITION:
      case SB_SLIDERTRACK:
	 pmp->sVScrollPos = SHORT1FROMMP( mp2 );
	 break;
      }

      /* Don't allow step assignments to exceed limits of zero to range. */
      pmp->sVScrollPos = max( (SHORT)0,
			      min( pmp->sVScrollPos, pmp->sVScrollRange ));

      if( pmp->sVScrollPos != SHORT1FROMMR(WinSendMsg( pmp->hwndVScroll,
	  SBM_QUERYPOS, (MPARAM)0, (MPARAM)0 )))
      {
	 /*
	  * New scroll bar thumbbutton position is different than current.
	  * Set a new Y translation value to effect the scroll.
	  * Current scale setting affects the Y element of the matrix.
	  */
	 pmp->matlfDefView.lM32 =  (LONG)(pmp->floatScale *
	     (float)( OFFSET_XY_TWIPS +
		      pmp->sVScrollPos -
		      pmp->sVScrollRange ));
	 bOK = GpiSetDefaultViewMatrix( pmp->hpsClient,
					9,
					&pmp->matlfDefView,
					TRANSFORM_REPLACE );
	 pmassert( pmp->hab, bOK );
	 CalibrateScrollBar( pmp );
	 WinInvalidateRect( hwnd, NULL, FALSE );
      }
      return (MRESULT) 0;


   }

   return WinDefWindowProc( hwnd, msg, mp1, mp2 );
}  /* End of WinProc() */


 /************************************************************************
 *
 * Name	       : CalibrateScrollBar( pmp )
 *
 * Description : This function computes the scroll bar range to be that
 *		 portion of the text document that is clipped from the
 *		 client window, then sends this range to the scroll bar.
 *		 The thumb position used is that which is already in the pmp.
 *
 *		 Thumbsize is then computed by the scroll bar to be a ratio
 *		 of the visible part of the document / the entire document.
 *
 * Concepts    : Manipulation of thum position and scroll bar.
 *
 * API's       : WinSendMsg
 *
 * Parameters  : PMAIN_PARM	 structure containing important data such
 *				  as window handles, device context handles,
 *				  and other bitmap, printing and program
 *				  information
 *
 * Returns     : [nothing]
 *
 **************************************************************************/
VOID CalibrateScrollBar( PMAIN_PARM pmp )
{
   BOOL bOK;

   /*
    * The range of the scroll bar is the length of the
    * printed page that is clipped by the client window.
    */
   pmp->sVScrollRange = ( pmp->sizelPage.cy + 2*OFFSET_XY_TWIPS ) -
				   pmp->sizelClient.cy;

   /* Position the thumbbutton according to pmp->sVScrollPos. */
   bOK = (BOOL)WinSendMsg( pmp->hwndVScroll,
		     SBM_SETSCROLLBAR,
		     (MPARAM) pmp->sVScrollPos,
		     MPFROM2SHORT( (USHORT)0,  pmp->sVScrollRange ));
   pmassert( pmp->hab, bOK );

   /* Set thumbsize of the scroll bar. */

   bOK = (BOOL)WinSendMsg( pmp->hwndVScroll,
		     SBM_SETTHUMBSIZE,
		     MPFROM2SHORT( pmp->sizelClient.cy, pmp->sizelPage.cy ),
		     (MPARAM)0 );

   pmassert( pmp->hab, bOK );

}  /* End of CalibrateScrollBar(). */
/***************************  End of prtsamp.c ****************************/
/*static char *SCCSID = "@(#)revscr.c   6.1 92/02/19";*/
/*************************************************************************
 * File Name	 : REVSCR.C
 *
 * Description	 : This sample program demonstrates how to use the
 *		   Bidirectional (Bidi) API NlsQueryBidiAttr and
 *		   NlsSetBidiAttr to change the screen and keyboard
 *		   attributes of a session.
 *
 * API's         : NlsSetBidiAttr
 *		   NlsQuerytBidiAttr
 *		   VioWrtCharStr
 *		   VioScrollUp
 *		   VioSetCurPos
 *
 * Required files: To build and run this sample code the following files
 *		   are needed:
 *		   - REVSCR.C
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 ************************************************************************/
#define INCL_BASE
/* Including the system return codes, will include
 *the bidi return error codes as well */
#define INCL_DOSERRORS
/* This to include the Bidi header file */
#define INCL_BDCALLS

#include <os2.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>

/* declairation of the functions used */
VOID GetAttr(VOID);
VOID SetAttr(VOID);
VOID Toggle(VOID);
VOID Initialize(VOID);

#define ROW 15
#define COL 5

/* define the structures that are going to be used to Set and Query
 * the screen and keyboard attributes	*/
BDKVCB bdkvcbRetAttr, bdkvcbSaveAttr;


/*************************************************************************
 * Name		 : Main
 *
 * Description	 : This is the main part of the program, it first clear
 *		   the screen and then queries the screen and keyboard
 *		   attributes, change it, and set it, so that the screen
 *		   orientation becomes RLT.
 *
 * API's         : NlsSetBidiAttr
 *		   VioScrollUp
 *		   VioSetCurPos
 *
 * Parameters	 : This program does not take any command line parameters
 *
 * Returns	 : None
 *
 ************************************************************************/
INT main(SHORT sArgc,CHAR **ppArgv)
{
   INT iCh,
       iRow ;

   iRow = ROW;

   /* clear the screen */
   VioScrollUp(0, 0, 24, 79, -1," \x07", 0);

   /* Query the screen Bidi attributes */
   GetAttr();

   /* Toggle the orientation and the language layer */
   Toggle();

   /* Set the new screen and keyboard attributes */
   SetAttr();

   /* Set the cursor position
    * Note: When running the program, watch where the cursor got set,
    * and remember that the cursor setting was done after we changed
    * the screen orientation */

   VioSetCurPos(iRow, COL, 0);

   /* Display some text to the screen */
   Initialize();

   /* Wait for Enter to end the program */
   getchar ();

   /* Clear the screen */
   VioScrollUp(0, 0, 24, 79, -1," \x07", 0);

   /* Reset the screen orientation and the language layer */
   NlsSetBidiAtt( 0L, (PSETINFO)&bdkvcbSaveAttr);

   return (1);
} /* end of main */

/*************************************************************************
 * Name		 : GetAttr
 *
 * Description	 : This function issues the NlsQueryBidiAttr to query the
 *		   the screen and keyboard attributes
 *
 * API's         : NlsQueryBidiAttr
 *
 * Parameters	 : (VOID)
 *
 * Returns	 : None
 *
 ************************************************************************/
VOID GetAttr(VOID)
{
   APIRET RC;			      /* used for error checking */

   /* The length here is 16 to query the Bidi attributes
    *  and the Bidi flags */
   bdkvcbRetAttr.BDLength = 16;

   RC = NlsQueryBidiAtt( 0L,(PRETINFO)&bdkvcbRetAttr);
   if(RC != 0)
   {
      printf("\n\nError in query bidi attr num %d\n",RC);
      exit(1);
   }
}
/*************************************************************************
 * Name		 : SetAttr
 *
 * Description	 : This function issues the NlsSetBidiAttr to set the
 *		   the screen and keyboard attributes
 *
 * API's         : NlsQueryBidiAttr
 *
 * Parameters	 : (VOID)
 *
 * Returns	 : None
 *
 ************************************************************************/
VOID SetAttr(VOID)
{
  APIRET RC;

   /* The length here is 16 to set the Bidi attributes
    *  and the Bidi flags */
   bdkvcbRetAttr.BDLength= 16;

   RC = NlsSetBidiAtt( 0L, (PSETINFO)&bdkvcbRetAttr);
   if( RC != 0)
   {
       printf("\n\nError in set Bidi attributes: %d\n",RC);
       exit(1);
   }
}
/*************************************************************************
 * Name		 : Toggle
 *
 * Description	 : This function uses the Bidi defined values in the
 *		   header file BDCALLS.H to change the attributes, by
 *		   the mean of the operator OR.
 *		   It also saves the original settings before it does
 *		   change it.
 *
 * API's         : None
 *
 * Parameters	 : (VOID)
 *
 * Returns	 : None
 *
 ************************************************************************/
VOID Toggle(VOID)
{
   /* save the original Bidi attributes settings */
   bdkvcbSaveAttr = bdkvcbRetAttr;

   bdkvcbRetAttr.BDAtts = bdkvcbRetAttr.BDAtts | BDORIENT_RTL;
			      /* here we toggle the orientation,	     */
			      /* if left to right, make it right to left     */
			      /* and vise versa				     */

   bdkvcbRetAttr.BDFlags = bdkvcbRetAttr.BDAtts | BDFLAG_LAYER;

}
/*************************************************************************
 * Name		 : Initialize
 *
 * Description	 : This function is used to display some messages on the
 *		   screen
 *
 * API's         : VioWrtCharStr
 *
 * Parameters	 : (VOID)
 *
 * Returns	 : None
 *
 ************************************************************************/
VOID Initialize(VOID)
{
   int iI, iCol, iRow, iLength;
   struct {
	 char cScreen[45];
	 }mssg[5];
   strcpy(mssg[0].cScreen, "neercs eht ,ttAidiBteSslN gnillac retfA");
   strcpy(mssg[1].cScreen, "   reyal egaugnal eht dna ,LTR won si  ");
   strcpy(mssg[2].cScreen, "           lanoitaN won si             ");
   strcpy(mssg[3].cScreen, "  ... sretcarahc emos epyt ot yrT      ");
   strcpy(mssg[4].cScreen, "    margorp eht dne ot retnE sserP     ");
   iLength = strlen(mssg[0].cScreen);
   iCol = 23;
   iRow = 2;
   for( iI = 0; iI < 3; iI++, iRow++)
       VioWrtCharStr(mssg[iI].cScreen, iLength, iRow, iCol, 0l);

       VioWrtCharStr(mssg[3].cScreen, iLength, 8, iCol, 0l);
       VioWrtCharStr(mssg[4].cScreen, iLength, 23, iCol, 0l);
}
/*static char *SCCSID = "@(#)semaph.c   6.12 92/02/19";*/
/*==============================================================*\
 *  SEMAPH.C - routines for demonstrating semaphore API.	*
 *	  (C) Copyright IBM Corporation 1992.			*
 *--------------------------------------------------------------*
 *  This module contains code to demonstrate the use of		*
 *  semaphores to control access to a resource shared by	*
 *  multiple threads. Event semaphores are used to signal a	*
 *  thread is to give up a resource. A Mutex semaphore is used	*
 *  to provide exclusive access to the resource. A mux		*
 *  semaphore provides a method to check multiple event		*
 *  semaphores.							*
 *								*
 *								*
 *--------------------------------------------------------------*
 *								*
 *  This source file contains the following functions:		*
 *								*
 *	  VOID	 SemError(PSZ,ULONG);				*
 *	  ULONG	 CreateAllSems(VOID);				*
 *	  VOID	 StartSemExample(VOID);				*
 *	  VOID	 ThreadConsumer(ULONG);				*
 *	  VOID	 SignalUserEvent(PULONG pfAutoMode);		*
 *	  ULONG	 SetAutoMode(VOID);				*
 *	  VOID	 RunAuto(VOID);					*
 *	  VOID	 StopSemaphore(VOID);				*
 *								*
 *								*
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#include "semaph.h"

/*--------------------------------------------------------------*\
 *  Global variables						*
\*--------------------------------------------------------------*/
extern LONG colors[MAXUSERS];
extern LONG clrText[MAXUSERS];
static VOID MyMove (ULONG usMyID, ULONG ulUser);

/****************************************************************\
 * Procedure to print error messages to screen in a Message Box.*
 *--------------------------------------------------------------*
 *								*
 *  Name:    SemError(pszAPIName,usErrorCode)			*
 *								*
 *  Purpose: Used to print name of API and error number when	*
 *	     a return code other than 0 is returned from an	*
 *	     API call.						*
 *								*
 *  Usage:   Called by all procedures in this file whenever	*
 *	     an API call fails.					*
 *								*
 *  Method:  The error number is converted to a string.	 String *
 *	     functions are used to build the error message.	*
 *	     The message is printed in a Message Box.		*
 *								*
 *  NOTE:    This function is called by multiple threads,	*
 *	     therefore, only re-entrant functions can be used.	*
 *	     Note that string is build according to American	*
 *	     English conventions using hard-coded strings, and	*
 *	     so portability to other languages would require a	*
 *	     more flexible approach.				*
 *								*
 *  Returns: none.						*
 *								*
\****************************************************************/
VOID SemError(PSZ pszAPIName,ULONG usErrorCode)
{
   char acMessage[100],acErrorNumber[10];

   itoa(usErrorCode,acErrorNumber,BASETEN);
   strcpy(acMessage,pszAPIName);
   strcat(acMessage,": error # ");
   strcat(acMessage,acErrorNumber);

   WinMessageBox(HWND_DESKTOP,
		 hwndMain,
		 acMessage,
		 szAppName,
		 1,
		 MB_OK);
   return;
}

/****************************************************************\
 * Routine to create  semaphores used in this file.		*
 *--------------------------------------------------------------*
 *								*
 *  Name:    CreateAllSems(VOID)				*
 *								*
 *  Purpose: Create semaphores needed by the consumer threads.	*
 *	     Checks return codes from semaphore creation.	*
 *								*
 *  Usage:   Called by StartSemExample.				*
 *								*
 *  Method:  Semaphores are all anonymous private semaphores	*
 *	     since the semaphores are used by threads in the	*
 *	     same process.					*
 *								*
 *  Returns: 0 if all semaphores are created successfully.	*
 *	     Otherwise returns error code for first create	*
 *	     semaphore API to fail.				*
 *								*
\****************************************************************/
ULONG CreateAllSems(VOID)
{
   ULONG      rc;
   SEMRECORD   asr[MAXRESOURCES];
   INT	       i;

   rc = DosCreateMutexSem((PSZ)NULL,&hmtxOwnResource, 0L,FALSE);
   if (rc)
   {
       SemError("DosCreateMutexSem",rc);
       return(rc);
   }

   for (i = 0; i < MAXRESOURCES; i++)
   {
      rc = DosCreateEventSem( (PSZ)NULL, &aSquares[i].hev,
				      0L, FALSE);
      if (rc)
      {
	  SemError("DosCreateEventSem",rc);
	  return(rc);
      }
      else
      {
	  asr[i].ulUser = i;
	  asr[i].hsemCur = (PVOID) aSquares[i].hev;
      }
   }
			  /* this muxwait semaphore contains all of the
			  event semaphores created in the loop above. */
   rc = DosCreateMuxWaitSem((PSZ)NULL,&hmuxResource,
	   MAXRESOURCES,asr, DCMW_WAIT_ANY);
   if (rc)
   {
      SemError("DosCreateMuxWaitSem",rc);
      return(rc);
   }
   rc = DosCreateEventSem((PSZ)NULL,&hevStop,0L,FALSE);
   if (rc)
   {
       SemError("DosCreateEventSem",rc);
       return(rc);
   }
   return(rc);
}

/****************************************************************\
 * Routine to start semaphore example				*
 *--------------------------------------------------------------*
 *								*
 *  Name:     StartSemExample(VOID)				*
 *								*
 *  Purpose:  Calls routines to create semaphores and draw	*
 *	      resources.  Creates consumer threads.		*
 *								*
 *  Usage:    Called in file usercmd.c when the user selects	*
 *	      start from the semaphore menu.			*
 *								*
 *  Method:   Uses routines in paint.c to draw consumers and	*
 *	      resources.  This is done by creating a paint	*
 *	      message, not calling the draw routines directly.	*
 *								*
 *  Returns:  TRUE if start succeeds, FALSE if start fails	*
 *								*
\****************************************************************/
INT   StartSemExample(VOID)
{
    TID		tid=0;
    ULONG	rc;
    INT		i;
    FONTMETRICS fntmet;
    HPS		hps;
    SWP		swp;

    InitSemaphExample();

    rc = CreateAllSems();

    if (rc)
	return FALSE;
    /****************************************************************\
     * Create consumer threads. Note that values can be passed to   *
     * threads in OS/2 2.0. We pass the ordinal number of the child *
     * to each child.						    *
    \****************************************************************/

    for (usConsumerThreadsCreated = 0;
     usConsumerThreadsCreated < cNumUsers; usConsumerThreadsCreated++)
    {
	rc = DosCreateThread((PTID) &tid, (PFNTHREAD)ThreadConsumer,
	     (ULONG) usConsumerThreadsCreated, (ULONG)1,(ULONG) STACKSIZE);
	if (rc)
	{
	    SemError("DosCreateThread",rc);
	    return FALSE;
	}
	else
	{
	    thrConsumers[usConsumerThreadsCreated].tid = tid;
	    thrConsumers[usConsumerThreadsCreated].lHits = 0L;
	}
    }
    for (i = 0; i < (INT) cNumUsers; i++)
    {
	DosResumeThread (thrConsumers[i].tid);
    }
    hps = WinGetPS (hwndMain);
    if (hps)
    {
	GpiQueryFontMetrics (hps, (LONG) sizeof fntmet, &fntmet);
	WinQueryWindowPos (hwndMain, &swp);
	SetRectPositions((SHORT)swp.cx, (SHORT)swp.cy,
			 (SHORT) fntmet.lMaxBaselineExt,
			 (SHORT) fntmet.lMaxDescender);
	DrawRects (hps);
	WinReleasePS (hps);
    }
    return TRUE;
}

/****************************************************************\
 * Routine to signal consumer to release resource.		*
 *--------------------------------------------------------------*
 *								*
 *  Name:     SignalUserEvent(pfAutoMode)			*
 *								*
 *  Purpose:  Posts user event semaphore to signal thread to	*
 *	      release resource.	 Also posts event to stop	*
 *	      Auto mode if *pfAutoMode is true.			*
 *								*
 *  Usage:    Called in file usercmd.c when the user selects	*
 *	      Event from the semaphore menu.			*
 *								*
 *  Method:   Turns off Auto mode, if present by posting auto	*
 *	      semaphore.  User event is then posted.		*
 *								*
 *  Returns:							*
 *								*
\****************************************************************/
VOID SignalUserEvent(PULONG pfAutoMode)
{
  ULONG rc;

			  /* If sample is in auto mode turn auto mode off. */
  if (*pfAutoMode)
  {
      rc = DosPostEventSem(hevStopAuto);
      if (rc)
      {
	 SemError("DosPostEventSem Stop Auto",rc);
      }
		       /* Wait for auto mode thread to die, so we don't
			  end up with multiple copies of it later.    */

      rc = DosWaitThread(&tidAutoThread,0L);
      if (rc)
      {
	 SemError("DosWaitThread",rc);
      }
      *pfAutoMode = FALSE;
      DosCloseEventSem (hevStopAuto);
  }

  /* If Auto mode haas already posted the event this is OK
     so we will not check error codes here. */

  DosPostEventSem(aSquares[rand() % MAXRESOURCES].hev);
  return;
}

/****************************************************************\
 * Routine to start Auto mode.					*
 *--------------------------------------------------------------*
 *								*
 *  Name:     SetAutoMode(VOID)					*
 *								*
 *  Purpose:  Creates thread and semaphore needed to run auto	*
 *	      mode.						*
 *								*
 *  Usage:    Called in file usercmd.c when the user selects	*
 *	      Auto from the semaphore menu.			*
 *								*
 *  Returns:  NO_ERROR on success, else error from api call.	*
 *								*
\****************************************************************/
ULONG SetAutoMode()
{
    ULONG rc;

    rc = DosCreateEventSem((PSZ)NULL,&hevStopAuto,0L,FALSE);
    if (rc)
    {
	SemError("DosCreateEventSem",rc);
	return(rc);
    }

    rc = DosCreateThread((PTID)&tidAutoThread,(PFNTHREAD)RunAuto,0L,0L,STACKSIZE);
    if (rc)
    {
	DosCloseEventSem (hevStopAuto); /* close semaphore created above */
	SemError("DosCreateThread", rc);
	return(rc);
    }

    return(NO_ERROR);
}

/****************************************************************\
 * Routine to run Auto mode.					*
 *--------------------------------------------------------------*
 *								*
 *  Name:     RunAuto(ULONG ulArg)				*
 *								*
 *  Purpose:  Posts user event at fixed time interval to signal *
 *	      consumers to release resource.			*
 *								*
 *  Usage:    Thread created by SetAutoMode.			*
 *								*
 *  Method:   Kills itself when StopAutoMode semaphore is	*
 *	      posted.						*
 *								*
 *  Returns:							*
 *								*
\****************************************************************/
VOID __syscall RunAuto( ULONG ulArg )
{
   ULONG rcWait;
   HAB habLocal;
   HMQ hmqLocal;
   INT i;

   /* Need a message queue for any thread that wants to print messages. */

   habLocal = WinInitialize(0);
   hmqLocal = WinCreateMsgQueue(habLocal,0);

   /* while stop auto semaphore not posted, post user event semaphore. */

      /***************************************************************
       * Don't check return code from DosPostEventSem(hevUserEvent)  *
       * since we just want the resource to change hands.  We don't  *
       * care if it changes hands exactly every time it goes through *
       * the loop.						     *
       *							     *
       * The event may already be posted if the system is busy and   *
       * the resource threads don't finish with it fast enough.      *
       * This is not a problem in this case.			     *
       ***************************************************************/

   do {			     /* if ulTimeout is zero, still waitevent
				 for 1 msec to force yielding of CPU. */
       rcWait = DosWaitEventSem(hevStopAuto, max (ulTimeout, 1));
       if (rcWait == ERROR_TIMEOUT)
       {
	   i = rand () % MAXRESOURCES;	    /* generate it */
	   DosPostEventSem (aSquares[i].hev);
       }
   } while (rcWait == ERROR_TIMEOUT);

   /* If there was an error, print a message */

   if (rcWait)
   {
      SemError("DosWaitEventSem",rcWait);
   }

   WinDestroyMsgQueue (hmqLocal);
   WinTerminate (habLocal);
   DosExit(EXIT_THREAD,0);

		/* Since ulArg is not referenced anywhere we must use this
		   use this dummy reference to stop a compiler warning.	   */
   ++ulArg;
   return;
}

/****************************************************************\
 * Routine to stop semaphore example.				*
 *--------------------------------------------------------------*
 *								*
 *  Name:     BeginStop(pfAutoMode)				*
 *								*
 *  Purpose:  Posts stop event semaphore to signal threads to	*
 *	      die.  Also posts event to stop Auto mode if	*
 *	      necessary. Then waits for threads to complete,	*
 *	      Creates thread StopSemaphore which posts stop	*
 *	      event and waits for child threads.		*
 *								*
 *  Usage:    Called in file usercmd.c when the user selects	*
 *	      Stop from the semaphore menu.			*
 *								*
 *  Method:   Execs thread to do waits so that message thread	*
 *	      doesn't hang.                                     *
 *  Returns:							*
 *								*
\****************************************************************/
VOID BeginStop (PULONG pfAutoMode)
{
   ULONG rc;
   TID tidLocal;

   rc = DosPostEventSem(hevStop);
   if (rc)
   {
       SemError("DosPostEventSem",rc);
       return;
   }
   if (*pfAutoMode)
   {
       rc = DosPostEventSem(hevStopAuto);
       if (rc)
       {
	  SemError("DosPostEventSem",rc);
       }
   }
   rc = DosCreateThread((PTID)&tidLocal, (PFNTHREAD)StopSemaphore,
			  (ULONG)pfAutoMode,(ULONG)0,(ULONG) STACKSIZE);
   if (rc)
   {
       SemError("DosCreateThread",rc);
   }
   return;
}

/****************************************************************\
 * Routine to really stop semaphore example.			*
 *--------------------------------------------------------------*
 *								*
 *  Name:     StopSemaphore( ULONG ulArg )			*
 *								*
 *  Purpose:  Waits for threads to complete,			*
 *	      Sends message to message thread to indicate this	*
 *	      has occurred, and exits.				*
 *								*
 *  Usage:    Exec'd from BeginStop when user selects Stop from *
 *	      Semaphore menu.					*
 *								*
 *  Method:   Turns off Auto mode, if present by posting auto	*
 *	      semaphore.  Then stop event is posted.  Waits	*
 *	      for threads to die.				*
 *  Returns:							*
 *								*
\****************************************************************/
VOID __syscall StopSemaphore( ULONG ulArg )
{
   ULONG rc,usCount, i;
   PULONG pfAutoMode = (PULONG)ulArg;

   if (*pfAutoMode)
   {
      rc = DosWaitThread(&tidAutoThread,0L);
      if (rc && (rc != ERROR_INVALID_THREADID))
      {
	 SemError("DosWaitThread",rc);
      }
      *pfAutoMode = FALSE;
   }
   /* Wait for usConsumer threads to die.  Order of death not important. */

   for (usCount = 0; usCount < usConsumerThreadsCreated; usCount++)
   {
      rc = DosWaitThread(&thrConsumers[usCount].tid,0L);

      /* rc is ERROR_INVALID_THREADID the thread is already dead.*\
      \* This is OK and not a error.				 */

      if (rc && (rc != ERROR_INVALID_THREADID))
      {
	 SemError("DosWaitThread",rc);
      }
   }
		/* Threads dead so we don't need semaphores any more.  */
   DosCloseEventSem(hevStopAuto);
   DosCloseEventSem(hevStop);
   DosCloseMutexSem(hmtxOwnResource);
   for (i = 0; i < MAXRESOURCES; i++)
   {
      DosCloseEventSem(aSquares[i].hev);
   }
   DosCloseMuxWaitSem (hmuxResource);
   WinPostMsg (hwndMain, WM_COMMAND, (MPARAM)IDM_STOPFINISHED, (MPARAM)NULL);
   DosExit (EXIT_THREAD, 0);
   return;
}

/****************************************************************\
 * Routine for consumer threads.				*
 *--------------------------------------------------------------*
 *								*
 *  Name:     ThreadConsumer(ULONG)				*
 *								*
 *  Purpose:  There are NUMUSERS copies of this thread to act	*
 *	      as consumers of the resource. The thread waits for*
 *	      exclusive access to the resource and colors it.	*
 *								*
 *  Usage:    Threads created by StartSemExample.		*
 *								*
 *  Method:   Waits for mutex to gain ownership of resource.	*
 *	      Releases resource when user event. Dies when	*
 *	      Stop event.					*
 *  Returns:							*
 *								*
\****************************************************************/
VOID __syscall ThreadConsumer( ULONG ulMyID )
{
   ULONG  ulPostCnt;
   ULONG  ulUser=0L;
   ULONG  rc;
   HAB	  habb;
   HMQ	  hmqq;

   /* Need a message queue for any thread that wants to print messages. */
   habb = WinInitialize(0);
   hmqq = WinCreateMsgQueue(habb,0);

   /* while the user has not selected stop ... */
   while ((DosWaitEventSem(hevStop,SEM_IMMEDIATE_RETURN)) == ERROR_TIMEOUT)
   {
      /* Wait for exclusive ownership of resource */

      DosRequestMutexSem(hmtxOwnResource,SEM_INDEFINITE_WAIT);

      /* the following check is necessary because the stop semaphore
       * may have been posted  while we were waiting on the mutex
       */
      if (DosWaitEventSem(hevStop, SEM_IMMEDIATE_RETURN) == ERROR_TIMEOUT)
      {
      /*********************************************************************\
       * an item is ready, which one?  don't wait forever because there is *
       * a possibility that the stop semaphore was posted and that no more *
       * resource is forthcoming. we wait twice as long as we think is	   *
       * necessary.							   *
      \*********************************************************************/
	 if (!DosWaitMuxWaitSem (hmuxResource, max (ulTimeout << 1,
	    TIMEOUTPERIOD) , &ulUser))
	 {
	    MyMove (ulMyID, ulUser);
	    DosResetEventSem(aSquares[ulUser].hev, &ulPostCnt);
	 }
      }
			       /* Let some other thread have resource. */
      rc = DosReleaseMutexSem(hmtxOwnResource);
      if (rc)
      {
	 SemError("DosReleaseMutexSem",rc);
      }
   }
   /* hevStop was posted, kill this thread */
   WinDestroyMsgQueue (hmqq);
   WinTerminate (habb);
   DosExit(EXIT_THREAD, 0);
   return;
}

/****************************************************************\
 *  called from ThreadConsumer to make and register move	*
 *--------------------------------------------------------------*
 *								*
 *  Name: MyMove (usMyID, ulUser)				*
 *	  ULONG	    usMyID;	id of caller			*
 *	  ULONG	    ulUser;	number of the square to "hit"	*
 *								*
 *  Purpose: color a square on the game board 'my' color.	*
 *	     update display of number of hits for 'my' thread.	*
 *								*
 *  Usage: called only from ThreadConsumer			*
 *								*
 *  Method:							*
 *								*
 *  Returns: none						*
 *								*
\****************************************************************/
static VOID MyMove (ULONG usMyID, ULONG ulUser)
{
   if (aSquares [ulUser].usOwner != usMyID)
   {
      aSquares[ulUser].usOwner = usMyID;
      thrConsumers[usMyID].lHits++;
      DrawResource (&aSquares[ulUser].rcl, colors [usMyID]);
      DrawStats (usMyID);
   }
   return;
}

/****************************************************************\
 * Routine to init game board					*
 *--------------------------------------------------------------*
 *								*
 *  Name:     InitSemaphExample(VOID)				*
 *								*
 *  Purpose:  Initializes game board unowned, sets semaphores	*
 *	      to 0.						*
 *  Usage:    Called from StartSemExample in semaph.c when	*
 *	      user selects start from the semaphore menu.	*
 *  Method:							*
 *								*
 *  Returns:  none						*
 *								*
\****************************************************************/
VOID InitSemaphExample(VOID)
{
   int i;

   for (i = 0; i < MAXRESOURCES; i++)
   {
      aSquares[i].hev = 0;
      aSquares[i].usOwner = UNOWNED;
   }
   hevStopAuto = 0L;
   hevStop = 0L;
   hmtxOwnResource = 0L;
   hmuxResource	 = 0L;
   return;
}
/*static char *SCCSID = "@(#)sem_dlg.c  6.13 92/03/18";*/
/*==============================================================*\
 *  SEM_DLG.C - window procedures for the dialog boxes as well	*
 *		as utility procedures used by them		*
 *	(C) Copyright IBM Corporation 1992.			*
 *--------------------------------------------------------------*
 *								*
 *  This module contains the Dialog Procedures for the user	*
 *  defined dialogs as well as any support code they need	*
 *								*
 *--------------------------------------------------------------*
 *								*
 *  This source file contains the following functions:		*
 *								*
 *	     TimeDlgProc(hwnd, msg, mp1, mp2)			*
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#include "semaph.h"

/****************************************************************\
 *  Dialog procedure for the Timeout entry dlg box		*
 *--------------------------------------------------------------*
 *								*
 *  Name:   TimeDlg(hwnd, msg, mp1, mp2)			*
 *								*
 *  Purpose: Processes all messages sent to the Timer Box	*
 *								*
 *  Usage:  Called for each message sent to the Timer Box	*
 *	    dialog box.						*
 *								*
 *  Method: display box on init, and reset global ulTimeout on	*
 *	    successful entry					*
 *								*
 *								*
 *								*
 *  Returns: Dependent upon message sent			*
 *								*
\****************************************************************/
MRESULT EXPENTRY TimeDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    CHAR    szBuffer [MAXTEXTLEN];
    SHORT   sTimeout = 0;	 /* local copy of timeout for dlg */
    static  HWND    hwndWork;
    MRESULT sRC;

    switch(msg)	 {
	    case WM_INITDLG:
		/* init the entry field w/current value */
		hwndWork = WinWindowFromID ( hwnd, IDD_ENTRY);
		WinSetWindowText (hwndWork, itoa(ulTimeout, szBuffer, 10));
		WinSendMsg( hwndWork, EM_SETSEL,
			MPFROM2SHORT(0, strlen(szBuffer)), (MPARAM)0 );
		FixSysMenu(hwnd);
		return (MRESULT)0L;

	    case WM_COMMAND:
		/* no matter what the command, close the dialog */
		switch(SHORT1FROMMP(mp1))  {
		    case DID_OK:
			if (WinQueryDlgItemShort(hwnd, IDD_ENTRY,
				 &sTimeout, FALSE) == FALSE) {
			    WinSetDlgItemText (hwnd, IDD_ENTRY,
					  itoa(ulTimeout, szBuffer, 10));
			}
			else
			    ulTimeout = (ULONG)sTimeout;

			WinDismissDlg(hwnd, TRUE);
			return (MRESULT)0L;
						    /* fall thru to... */
		    case DID_CANCEL:
			WinDismissDlg(hwnd, FALSE);
			return (MRESULT)0L;

		    default:
			sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
			return sRC;
		}
		break;

	    case WM_CLOSE:
		WinDismissDlg(hwnd, FALSE);
		return (MRESULT)0L;

	    default:
		sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
		return sRC;
    }
    return (MRESULT)0L;
}						       /* TimeDlgProc() */
/*static char *SCCSID = "@(#)sem_help.c 6.17 92/02/19";*/
/*==============================================================*\
 *  SEM_HELP.C - routines for help information			*
 *	(C) Copyright IBM Corporation 1992.			*
 *--------------------------------------------------------------*
 *								*
 *  This module contains all the routines for interfacing with	*
 *  the IPF help manager.					*
 *								*
 *--------------------------------------------------------------*
 *								*
 *  This source file contains the following functions:		*
 *								*
 *	    InitHelp()						*
 *	    HelpHelpForHelp(mp2)				*
 *	    HelpExtended(mp2)					*
 *	    HelpKeys(mp2)					*
 *	    HelpIndex(mp2)					*
 *	    HelpAbout(mp2)					*
 *	    DisplayHelpPanel(idPanel)				*
 *	    DestroyHelpInstance(VOID)				*
 *	    AboutDlgProc(hwnd, msg, mp1, mp2)			*
 *	    FixSysMenu(hwndDlg)					*
 *								*
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#include "semaph.h"

/****************************************************************\
 *  Routine for initializing the help manager
 *--------------------------------------------------------------
 *
 *  Name:    InitHelp()
 *
 *  Purpose: Initializes the IPF help facility
 *
 *  Usage:   Called once during initialization of the program
 *
 *  Method:  Initializes the HELPINIT structure and creates the help
 *	     instance. If successful, the help instance is associated
 *	     with the main window
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID InitHelp(VOID)
{
   HELPINIT hini;

    /* If we return because of an error, Help will be disabled */
   fHelpEnabled = FALSE;
			     /* Initialize help init structure */
   hini.cb = sizeof(HELPINIT);
   hini.ulReturnCode = 0;
			   /* If tutorial added, add name here */
   hini.pszTutorialName = (PSZ)NULL;

   hini.phtHelpTable = (PHELPTABLE)MAKELONG(SEMAPH_HELP_TABLE, 0xFFFF);
   hini.hmodHelpTableModule = 0;
   hini.hmodAccelActionBarModule = 0;
   hini.idAccelTable = 0;
   hini.idActionBar = 0;

   if(!WinLoadString(hab,
		     0,
		     IDS_HELPWINDOWTITLE,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szWindowTitle))
   {
       MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING,TRUE);
       return;
   }
   hini.pszHelpWindowTitle = (PSZ)szWindowTitle;

		   /* If debugging, show panel ids, else don't */
#ifdef DEBUG
   hini.fShowPanelId = CMIC_SHOW_PANEL_ID;
#else
   hini.fShowPanelId = CMIC_HIDE_PANEL_ID;
#endif

   if(!WinLoadString(hab,
		     0,
		     IDS_HELPLIBRARYNAME,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szLibName))
   {
       MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING,TRUE);
       return;
   }
   hini.pszHelpLibraryName = (PSZ)szLibName;
				     /* Creating help instance */
   hwndHelpInstance = WinCreateHelpInstance(hab, &hini);

   if(hwndHelpInstance == 0 || hini.ulReturnCode)
   {
       MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR,TRUE);
       return;
   }
		    /* Associate help instance with main frame */
   if(!WinAssociateHelpInstance(hwndHelpInstance, hwndMainFrame))
   {
       MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR,TRUE);
       return;
   }
/* Help manager is successfully initialized so set flag to TRUE */
   fHelpEnabled = TRUE;
   return;
}						  /* InitHelp() */

/****************************************************************\
 *  Processes the Help for Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpHelpForHelp(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Help for
 *	     Help item of the Help menu
 *
 *  Usage:   Called from MainCommand when the Help for Help menu item
 *	     is selected
 *
 *  Method:  Sends an HM_DISPLAY_HELP message to the help instance so
 *	     that the default Help For Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpHelpForHelp(MPARAM mp2)
{
	  /* This just displays the system help for help panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_DISPLAY_HELP,
				 (MPARAM)0,(MPARAM)0))
	   MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR,TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.					   */
   return;
}					   /* HelpHelpForHelp() */

/****************************************************************\
 *  Processes the Extended Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpExtended(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Extended
 *	     Help item of the Help menu.
 *
 *  Usage:   Called from MainCommand when the Extended Help menu item
 *	     is selected.
 *
 *  Method:  Sends an HM_EXT_HELP message to the help instance so that
 *	     the default Extended Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpExtended(MPARAM mp2)
{
	  /* This just displays the system extended help panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_EXT_HELP,(MPARAM)0L,(MPARAM)0L))
	   MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR,TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.					   */
   return;
}					      /* HelpExtended() */

/****************************************************************\
 *  Processes the Keys Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpKeys(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Keys Help
 *	     item of the Help menu.
 *
 *  Usage:   Called from MainCommand when the Keys Help menu item is
 *	     selected
 *
 *  Method:  Sends an HM_KEYS_HELP message to the help instance so that
 *	     the default Keys Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpKeys(MPARAM mp2)
{
	      /* This just displays the system keys help panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_KEYS_HELP,(MPARAM)0L,(MPARAM)0L))
	  MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR,TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.					   */
   return;
}						  /* HelpKeys() */

/****************************************************************\
 *  Processes the Index Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpIndex(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Index Help
 *	     item of the Help menu
 *
 *  Usage:   Called from MainCommand when the Index Help menu item
 *	     is selected
 *
 *  Method:  Sends an HM_INDEX_HELP message to the help instance so
 *	     that the default Index Help is displayed.
 *
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpIndex(MPARAM mp2)
{
	     /* This just displays the system help index panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_HELP_INDEX,(MPARAM)0L,(MPARAM)0L))
	   MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR,TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.					   */
   return;
}						 /* HelpIndex() */

/****************************************************************\
 *  Processes the About command from the Help menu
 *--------------------------------------------------------------
 *
 *  Name:    HelpAbout(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the About item
 *	     of the Help menu
 *
 *  Usage:   Called from MainCommand when the About menu item is selected
 *
 *  Method:  Calls WinDlgBox to display the about box dialog.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpAbout(MPARAM mp2)
{
				/* Display the AboutBox dialog */
   WinDlgBox(HWND_DESKTOP,
	     hwndMain,
	     AboutDlgProc,
	     (HMODULE)0,
	     IDD_PRODUCTINFO,
	     NULL);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.					   */
   return;
}						 /* HelpAbout() */

/****************************************************************\
 *  Displays the help panel indicated
 *--------------------------------------------------------------
 *
 *  Name:    DisplayHelpPanel(idPanel)
 *
 *  Purpose: Displays the help panel whose id is given
 *
 *  Usage:   Called whenever a help panel is desired to be displayed,
 *	     usually from the WM_HELP processing of the dialog boxes
 *
 *  Method:  Sends HM_DISPLAY_HELP message to the help instance
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID DisplayHelpPanel(LONG idPanel)
{
   if(fHelpEnabled)
       if((LONG)WinSendMsg(hwndHelpInstance,
		     HM_DISPLAY_HELP,
		     MPFROMLONG(MAKELONG(idPanel, NULL)),
		     MPFROMSHORT(HM_RESOURCEID)))

	   MessageBox(hwndMainFrame, IDMSG_HELPDISPLAYERROR, TRUE);
   return;
}					  /* DisplayHelpPanel() */

/****************************************************************\
 *  Destroys the help instance
 *--------------------------------------------------------------
 *
 *  Name:    DestroyHelpInstance(VOID)
 *
 *  Purpose: Destroys the help instance for the application
 *
 *  Usage:   Called after exit from message loop
 *
 *  Method:  Calls WinDestroyHelpInstance() to destroy the help instance
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID DestroyHelpInstance(VOID)
{
   if(hwndHelpInstance != 0)
   {
      WinDestroyHelpInstance(hwndHelpInstance);
   }
   return;
}				       /* DestroyHelpInstance() */

/****************************************************************\
 *
 * Name:    AboutDlgProc(hwnd, msg, mp1, mp2)
 *
 * Purpose: Handles all the messages associated with the About dialog.
 *
 * Usage:   Called from HelpAbout() when about menu be selected.
 *
 * Returns:
 *
\****************************************************************/
MRESULT EXPENTRY AboutDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   MRESULT sRC;

   switch(msg)
   {
      case WM_INITDLG:
	 FixSysMenu(hwnd);
	 return (MRESULT)0L;

      case WM_COMMAND:
	 WinDismissDlg(hwnd, TRUE);
	 return (MRESULT)0L;

      default:
	 sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
	 return sRC;
   }
   return 0L;
}

/****************************************************************\
 * Name:    FixSysMenu()					 *
 *								 *
 * Purpose: This routine removes the Restore, Size, Minimize, and*
 *	    Maximize options from the system menu of a dialog.	 *
 *								 *
 * Usage  : Called during the WM_INITDLG of a dialog procedure.	 *
 *								 *
 * Returns: VOID						 *
 *								 *
\****************************************************************/
VOID FixSysMenu(HWND hwndDlg)
{
   HWND hwndMenu;				    /* handle to system menu */

   hwndMenu = WinWindowFromID(hwndDlg, FID_SYSMENU);

   WinSendMsg(hwndMenu,		      /* delete Restore from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_RESTORE, TRUE),
	      MPFROMP(NULL));

   WinSendMsg(hwndMenu,			 /* delete Size from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_SIZE, TRUE),
	      MPFROMP(NULL));

   WinSendMsg(hwndMenu,		     /* delete Minimize from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_MINIMIZE, TRUE),
	      MPFROMP(NULL));

   WinSendMsg(hwndMenu,		     /* delete Maximize from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_MAXIMIZE, TRUE),
	      MPFROMP(NULL));
   return;
}
/*static char *SCCSID = "@(#)sem_init.c 6.10 92/02/19";*/
/*==============================================================*\
 *  SEM_INIT.C - routines for initialization and exit processing*
 *	(C) Copyright IBM Corporation 1992.			*
 *--------------------------------------------------------------*
 *								*
 *  This module contains the code for application initialization*
 *  as well as the code for exit list processing		*
 *								*
 *--------------------------------------------------------------*
 *								*
 *  This source file contains the following functions:		*
 *								*
 *   Init() - initialization routines				*
 *   ExitProc(usTermCode) - exit list processing procedure	*
 *								*
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#include "semaph.h"

/****************************************************************\
 *  Initialization routine					*
 *--------------------------------------------------------------*
 *								*
 *  Name:    Init()						*
 *								*
 *  Purpose: Performs initialization functions required before	*
 *	     the main window can be created.			*
 *								*
 *  Usage:   Called once before the main window is created.	*
 *								*
 *  Method:  - installs the routine ExitProc into the		*
 *		DosExitList chain				*
 *	     - registers all window classes			*
 *	     - performs any command line processing		*
 *								*
 *  Returns: TRUE - initialization is successful		*
 *	     FALSE - initialization failed			*
 *								*
\****************************************************************/
BOOL Init(VOID)
{
    /* Add ExitProc to the exit list to handle the exit processing */
    if(DosExitList(EXLST_ADD, ExitProc))
    {
	return FALSE;
    }
		       /* load application name from resource file */
    if(!WinLoadString(hab, (HMODULE)0, IDS_APPNAME, MAXAPPNAMELEN, szAppName))
	return FALSE;
    if(!WinLoadString(hab, 0, IDS_UNTITLED, MESSAGELEN, szUntitled))
	return FALSE;
			  /* register the main client window class */
    if(WinRegisterClass(hab,
			(PSZ)szAppName,
			(PFNWP)MainWndProc,
			CS_SIZEREDRAW | CS_SYNCPAINT | CS_CLIPCHILDREN,
			0) == 0)
	return FALSE;

    return TRUE;
}							  /* Init() */

/****************************************************************\
 *  Exit list processing procedure				*
 *--------------------------------------------------------------*
 *								*
 *  Name:    ExitProc(usTermCode)				*
 *								*
 *  Purpose: Cleans up certain resources when the application	*
 *	     terminates						*
 *								*
 *  Usage:   Routine is called by DosExitList when the		*
 *	     application exits					*
 *								*
 *  Method:  global resources, such as the main window and	*
 *	     message queue, are destroyed and any system	*
 *	     resources used are freed				*
 *								*
 *  Returns: Returns EXLST_EXIT to the DosExitList handler	*
 *								*
\****************************************************************/
VOID APIENTRY ExitProc(ULONG usTermCode)
				  /* code for the reason for termination */
{
   WinDestroyWindow(hwndMainFrame);
   /*--------------------------------------------------*\
    *	   Any other system resources used	       *
    *	   (e.g. memory or files) should be freed here *
   \*--------------------------------------------------*/
   WinDestroyMsgQueue(hmq);

   WinTerminate(hab);

   DosExitList(EXLST_EXIT, (PFNEXITLIST)0L);	/* termination complete */

   /* This routine currently doesn't use the usTermCode parameter so *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'  *
   \*  warning at compile time					     */

   return;
}							   /* ExitProc() */
/*static char *SCCSID = "@(#)sem_main.c 6.16 92/02/19";*/
/*==============================================================*\
 *  SEM_MAIN.C - Sample PM application				*
 *     (C) Copyright IBM Corporation 1992.			*
 *--------------------------------------------------------------*
 *								*
 *  This application serves two distinct purposes.  First, it	*
 *  demonstrates the standard menus and dialogs that most PM	*
 *  applications will contain.	The Demo menu calls dialog	*
 *  boxes that demonstrate all of the controls available for	*
 *  use in a dialog box.  There is also a dialog box which	*
 *  demonstrates the setting and removing of control		*
 *  Presentation Parameters.  Finally, the demo menu also has	*
 *  menu items that demonstrate the various types of message	*
 *  boxes that the system supports.				*
 *								*
 *  This application also serves as a template than can be	*
 *  easily modified by an application developer.  The source	*
 *  files are organized so that the overhead code that should	*
 *  be in all applications is located in the same files so	*
 *  that these files do not need to be modified.  The routines	*
 *  that deal with application specific code are also located	*
 *  in their own modules.  An application developer need only	*
 *  change these files in order to modify this template for	*
 *  his application.						*
 *								*
 *--------------------------------------------------------------*
 *								*
 *  This source file contains the following functions:		*
 *								*
 *   main() - main routine					*
 *   MainWndProc(hwnd, msg, mp1, mp2) - main window procedure	*
 *   MessageBox(hwnd nId, bBeep) - Warning box routine		*
 *   MainCommand(mp1, mp2) - WM_COMMAND processing of Main	*
 *								*
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#include "semaph.h"

/****************************************************************\
 *  Main routine						*
 *--------------------------------------------------------------*
 *								*
 *  Name:   main()						*
 *								*
 *  Purpose: Initializes the PM environment, calls the		*
 *		initialization routine, creates the main	*
 *		window,	 and polls the message queue		*
 *								*
 *  Usage:							*
 *								*
 *  Method:							*
 *	    - obtains anchor block handle and creates message	*
 *		queue						*
 *	    - calls the initialization routine			*
 *	    - creates the main frame window which creates the	*
 *		main client window				*
 *	    - polls the message queue via Get/Dispatch Msg loop *
 *	    - upon exiting the loop, exits			*
 *								*
 *  Returns: (via DosExit)					*
 *	    1 - if sucessful execution completed		*
 *	    0 - if error					*
\****************************************************************/
INT main(VOID)
{
   QMSG qmsg;	       /* message structure */
   ULONG ctlData;      /* frame control data */

   strcpy(szWindowText,"Sample");
   cNumUsers=NUMUSERS;
   fSemaphoreStarted=FALSE;
   fSemaphoreWasStarted=FALSE;
   fAutoMode=FALSE;
   ulTimeout = TIMEOUTPERIOD;

   hab = WinInitialize(0);
   if(!hab) {
      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      return(RETURN_ERROR);
   }
   hmq = WinCreateMsgQueue(hab, 0);
   if(!hmq) {
      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      WinTerminate(hab);
      return(RETURN_ERROR);
   }
   if(!Init()) {
      MessageBox(HWND_DESKTOP, IDMSG_INITFAILED, TRUE);
      DosExit(EXIT_PROCESS, RETURN_ERROR);
   }
					 /* create the main window */
   ctlData = FCF_STANDARD;
   hwndMainFrame = WinCreateStdWindow(HWND_DESKTOP,
				      WS_VISIBLE,
				      (PVOID)&ctlData,
				      (PSZ)szAppName,
				      (PSZ)NULL,
				      WS_VISIBLE,
				      (HMODULE)NULL,
				      IDR_RESOURCE,
				      (PHWND)&hwndMain);

   if(!hwndMainFrame)
   {
       MessageBox(HWND_DESKTOP, IDMSG_MAINWINCREATEFAILED, TRUE);
       DosExit(EXIT_PROCESS, RETURN_ERROR);
   }
   InitHelp();

   while(WinGetMsg(hmq, (PQMSG)&qmsg, (HWND)0, 0, 0))
       WinDispatchMsg(hmq, (PQMSG)&qmsg);
					  /* destroy the help instance */
   DestroyHelpInstance();
				    /* will normally be put in ExitProc */
   DosExit(EXIT_PROCESS, RETURN_SUCCESS);
   return 0L;
}

/****************************************************************\
 *  Main client window procedure				*
 *--------------------------------------------------------------*
 *								*
 *  Name:   MainWndProc(hwnd, msg, mp1, mp2)			*
 *								*
 *  Purpose: Processes the messages sent to the main client	*
 *		window.	 This routine processes the basic	*
 *		messages all client windows should process	*
 *		and passes all others onto UserWndProc where	*
 *		the developer can process any others.		*
 *								*
 *  Usage:  Called for each message placed in the main		*
 *	    window's message queue                              *
 *								*
 *  Method: a switch statement branches to the routines to be	*
 *	    performed for each message processed.  Any messages *
 *	    not specifically process are passed to the user's   *
 *	    message processing procedure UserWndProc().		*
 *								*
 *  Returns:  Return values are determined by each message	*
 *								*
\****************************************************************/
MRESULT EXPENTRY MainWndProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
    FONTMETRICS	 fntmet;
    HPS		 hPS;
    static SHORT xClient, yClient;
    static SHORT yChar, yDesc;
    MRESULT sRC;

    switch(msg)
    {
       case WM_CREATE:
	   hPS = WinGetPS (hwnd);
	   GpiQueryFontMetrics (hPS, (LONG) sizeof fntmet, &fntmet);

	   yChar = fntmet.lMaxBaselineExt;
	   yDesc = fntmet.lMaxDescender;

	   WinReleasePS (hPS);
	   break;

       case WM_PAINT:
	   MainPaint(hwnd);
	   break;

       case WM_SIZE:
	   xClient = LOUSHORT (mp2);   /* width of window  */
	   yClient = HIUSHORT (mp2);   /* height of window */
	   WinPostMsg (hwndMain, WM_USERCHANGED, (MPARAM)0, (MPARAM)0);
	   break;
				       /* fall thru to ... */
       case WM_USERCHANGED:	       /* number of threads changed */
				       /* so x and y are already known */
	   SetRectPositions(xClient, yClient, yChar, yDesc);
	   WinInvalidateRect (hwnd, NULL, TRUE);
	   break;

       case WM_COMMAND:
	   MainCommand(hwnd, mp1, mp2);
	   break;

	/*-----------------------------------------------*\
	 *   Any messages not processed are passed on	 *
	 *   to the user's window proc.  It is           *
	 *   responsible for passing any messages it	 *
	 *   doesn't handle onto WinDefWindowProc()      *
	\*-----------------------------------------------*/
       case HM_QUERY_KEYS_HELP:
	   return ((MRESULT)PANEL_KEYSHELP);

       default:
	   sRC = WinDefWindowProc(hwnd, msg, mp1, mp2);
	   return sRC;

    }
    return (MRESULT)0L;
		  /* all window procedures should return 0 as a default */
}						       /* MainWndProc() */

/****************************************************************\
 *  Main window WM_COMMAND processing procedure			*
 *--------------------------------------------------------------*
 *								*
 *  Name:   MainCommand(hwnd, mp1, mp2)				*
 *								*
 *  Purpose: Calls the appropriate procedures that deal with	*
 *		the selected menu item.				*
 *								*
 *  Usage:  Routine is called whenever a WM_COMMAND message	*
 *	    is posted to the main window.			*
 *								*
 *  Method: a switch statement branches on the id of the	*
 *	    menu item that posted the message and the		*
 *	    appropriate action for that item is taken.	Any	*
 *	    menu ids that are not part of the standard menu	*
 *	    set are passed onto the user defined WM_COMMAND	*
 *	    processing procedure.				*
 *								*
 *  Returns:							*
 *								*
\****************************************************************/
VOID MainCommand(HWND hwnd, MPARAM mp1, MPARAM mp2 )
{
    switch(SHORT1FROMMP(mp1))
    {
	case IDM_GENERALHELP:
	   HelpExtended(mp2);
	   break;

	case IDM_USINGHELP:
	   HelpHelpForHelp(mp2);
	   break;

	case IDM_TUTORIAL:
	   HelpKeys(mp2);
	   break;

	case IDM_HELPINDEX:
	   HelpIndex(mp2);
	   break;

	case IDM_HELPPRODUCTINFO:
	   HelpAbout(mp2);
	   break;

    /*--------------------------------------------------*\
     *	    User command processing routine is called	*
     *	    here so any ids not procecessed here can be *
     *	    processed					*
    \*--------------------------------------------------*/
	default:
	    UserCommand(mp1, mp2);
	    break;
    }
    return;
}					      /* MainCommand() */

/****************************************************************\
 *  Message Box procedure					*
 *--------------------------------------------------------------*
 *								*
 *  Name:   MessageBox(hwndOwner, nIdMsg, bBeep)		*
 *								*
 *  Purpose: Displays the warning message box with the message	*
 *		given in nIdMsg retrived from the message table *
 *								*
 *  Usage:  Called whever an error occurs and a message wishes	*
 *	    to be displayed to the user				*
 *								*
 *  Method: - Message string is loaded from the process'        *
 *		message table					*
 *	    - Alarm beep is sounded if desired			*
 *	    - Message box with the message is displayed		*
 *								*
 *  Returns:							*
 *								*
\****************************************************************/
VOID MessageBox( HWND hwndOwner, /* handle of the message box's owner      */
		 LONG nIdMsg,	/* id if the message in the message table */
		 BOOL bBeep ) /* TRUE, beep before message box is displayed*/
{
   CHAR szText[MESSAGELEN];

   if(!WinLoadMessage(hab, (HMODULE)NULL, nIdMsg, MESSAGELEN, (PSZ)szText))
   {
       WinAlarm(HWND_DESKTOP, WA_ERROR);
       return;
   }

   if(bBeep)
       WinAlarm(HWND_DESKTOP, WA_ERROR);

   WinMessageBox(HWND_DESKTOP,
		 hwndOwner,
		 szText,
		 (PSZ)NULL,
		 IDM_MSGBOX,
		 MB_OK | MB_ERROR);
   return;
}							 /* MessageBox() */
/*static char *SCCSID = "@(#)sem_pnt.c  6.12 92/02/19";*/
/*==============================================================*\
 *  SEM_PNT.C - routines for the painting of the main window	*
 *	(C) Copyright IBM Corporation 1992.			*
 *--------------------------------------------------------------*
 *								*
 *  This module contains the code for the main client window	*
 *  painting							*
 *								*
 *--------------------------------------------------------------*
 *								*
 *  This source file contains the following functions:		*
 *								*
 *	DrawResource(PRECTL, COLOR) - Draws colored square	*
 *	DrawStats(ULONG)  update the statistics for a thread	*
 *	ChangeResource(COLOR) - Changes resource color		*
 *	InitSemaphExample(VOID) - Sets initial colors		*
 *	SetRectPositions(HWND) - Calculate rectangle locations	*
 *	MyOffsetRect(PRECTL, LONG, LONG) - Offsets consumer	*
 *					   rectangles from	*
 *					   resource		*
 *	MainPaint(hwnd) - main WM_PAINT processing routine	*
 *								*
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#include "semaph.h"

/*--------------------------------------------------------------*\
 *  Global variables						*
\*--------------------------------------------------------------*/
/* static variables - only visible within this file */
static LONG  yStatsTop, yStatsBtm, xStatsRight, yBoardTop, yDescGlobal;
SHORT  xWidth;

LONG colors[MAXUSERS]= {
    CLR_WHITE, CLR_BLACK, CLR_BLUE, CLR_RED, CLR_PINK, CLR_GREEN,
    CLR_CYAN, CLR_YELLOW, CLR_DARKGRAY, CLR_DARKBLUE, CLR_DARKRED,
    CLR_DARKPINK, CLR_DARKGREEN, CLR_DARKCYAN, CLR_BROWN, CLR_PALEGRAY};

LONG clrText[MAXUSERS]= {
    CLR_BLACK, CLR_WHITE, CLR_YELLOW, CLR_GREEN, CLR_BLACK, CLR_YELLOW,
    CLR_WHITE, CLR_RED, CLR_WHITE, CLR_BLUE, CLR_RED,
    CLR_PINK, CLR_GREEN, CLR_CYAN, CLR_WHITE, CLR_DARKGRAY};

/****************************************************************\
 * Routine to draw the resource rectangle.			*
 *--------------------------------------------------------------*
 *								*
 *  Name:     DrawResource(PRECTL, COLOR)			*
 *								*
 *  Purpose:  Color 1 of the 64 rectangles on the playing board.*
 *								*
 *  Usage:    Called from ThreadConsumer in semaph.c when	*
 *	      resource becomes owned by a thread.		*
 *								*
 *  Method:   Get the PS from global hwndMain and  WinFillRect. *
 *	      This rountine is included so that no access	*
 *	      to the resouce is made outside of paint.c.	*
 *	      This is to produce code which is more		*
 *	      object orientated.				*
 *								*
 *  Returns:  none						*
 *								*
\****************************************************************/
VOID DrawResource(PRECTL prcl, COLOR color)
{
   HPS hps;

   hps = WinGetPS(hwndMain);
   /* this code is related to the WinFillRect in DrawRects.
    * they should stay in synch with each other.
    */
   WinFillRect(hps,prcl,color);
   WinReleasePS(hps);
   return;
}

/****************************************************************\
 * update the statistics (number of hits) for a thread		*
 *--------------------------------------------------------------*
 *								*
 *  Name:     DrawStats(ULONG)					*
 *								*
 *  Purpose:  update statistics display for for a thread	*
 *								*
 *  Usage:    Called from ThreadConsumer in semaph.c when	*
 *	      resource becomes owned by a thread.		*
 *								*
 *								*
 *  Method:   Get the PS, set colors, print number of hits for	*
 *	      the thread identified by usMyID.			*
 *	      This rountine is included so that no access	*
 *	      to the resouce is made outside of paint.c.	*
 *								*
 *  Returns:							*
 *								*
\****************************************************************/
VOID DrawStats(ULONG usMyID)
{
   HPS hps;
   POINTL  ptl;
   THRDATA *pThr = &thrConsumers[usMyID];
   CHAR	   szBuf [CNT_SZHITS];

   ptl.x = pThr->rcl.xLeft;
   ptl.y = pThr->rcl.yBottom;
   /* sprintf is non-reentrant, so it is used only when
    * have the mutex.
    */
   sprintf (szBuf, "%lu", pThr->lHits);
   hps = WinGetPS(hwndMain);
   GpiSetBackColor (hps, colors [usMyID]);
   GpiSetColor (hps, clrText [usMyID]);
   GpiCharStringPosAt (hps, &ptl, &pThr->rcl, CHS_CLIP | CHS_OPAQUE,
    strlen (szBuf), szBuf, NULL);
   WinReleasePS(hps);
   return;
}

/****************************************************************\
 *  Routine to paint rectangles in main window.			*
 *--------------------------------------------------------------*
 *								*
 *  Name:     DrawRects(HPS)					*
 *								*
 *  Purpose:  Does painting of rectangles.			*
 *								*
 *  Usage:    Called from MainPaint when a paint message	*
 *	      is received after the semaphore sample has	*
 *	      been started.					*
 *								*
 *  Method:   Uses WinFillRect API to color all owned squares on*
 *	      the square "playing board". Updates stats for	*
 *	      every active consumer thread. Prints the static	*
 *	      informational text.				*
 *								*
 *  Returns:  none.						*
 *								*
\****************************************************************/
VOID DrawRects(HPS hps)
{
   INT i;
   POINTL  ptl;
			    /* Fill all rectangles in consumer array....
				as well as rectangle for resource.	 */
   if (fSemaphoreWasStarted)
      {
       for ( i = 0; i < MAXRESOURCES; i++ )
       {
	   if (aSquares[i].usOwner < MAXUSERS &&
	    aSquares[i].usOwner != (USHORT)UNOWNED) {
	       /* this line is identical to that in DrawResource.
	       * they should stay in synch with each other.
	       */
	       WinFillRect (hps, &aSquares[i].rcl, colors[aSquares[i].usOwner]);
	   }
       }
   }
			/* print dividing line at bottom of stat display */
   ptl.x = 0;
   ptl.y = yStatsBtm - 2;
   GpiMove (hps, &ptl);
   ptl.x = xWidth;
   GpiLine (hps, &ptl);

   /* print statistics for each user */
   for (i = 0; i < (INT) cNumUsers; i++)
   {
       DrawStats ((USHORT) i);
   }
   return;
}

/****************************************************************\
 * Routine to size and set the positions of rectangle.		*
 *--------------------------------------------------------------*
 *								*
 * Name:    SetRectPositions (xClient, yClient, yChar, yDesc)	*
 *	    SHORT   xClient;	width of client window		*
 *	    SHORT   yClient;	height of client window		*
 *	    SHORT   yChar;	maximum baseline extender	*
 *	    SHORT   yDesc;	maximum char descender		*
 *								*
 * Purpose: Given above information about the window, calculate *
 *	    the area need for the square game board, the	*
 *	    statistics display, and informative text.		*
 *								*
 * Usage:   Called from MainWndProc whenever a size message	*
 *	    is received.					*
 *								*
 * Method:  Determines space needed for statistics display from *
 *	    the font information given as parameters to this	*
 *	    procedure.	Then calculates the 18 values which	*
 *	    describe a chess by distances from a corner along 2 *
 *	    adjacent sides. These are stored in arrays aX and aY*
 *	    Given these values, rectangles are calculated for	*
 *	    each square on the grid, and stored as part of the	*
 *	    information about those squares. Then the size of	*
 *	    the rectangles used for the stat display at the top *
 *	    of the window are calculated, and stored in the	*
 *	    struct describing the thread. Finally, the position *
 *	    of the line of informative text which divides the	*
 *	    two regions of colored squares is derived.		*
 *								*
 * Returns: none						*
 *								*
\****************************************************************/
VOID SetRectPositions(SHORT xClient, SHORT yClient, SHORT yChar, SHORT yDesc)
{
   INT	   i;
   INT	   dx;
   LONG aX [CNT_POINTS_EDGE];
   LONG aY [CNT_POINTS_EDGE];
   SHORT xScale, yScale;
						 /* top of stat display */
   yStatsTop = yClient;
					      /* bottom of stat display */
   yStatsBtm = yClient - yChar;
					       /* width of stat display */
   xStatsRight = xClient;

	       /* dx is the "scaling factor" for the statistics display */
   dx = (INT) ( (double)xStatsRight / (double)cNumUsers );

				     /* rectangles for the stat display */
   for (i = 0; i < (INT) cNumUsers; i++)
   {
      thrConsumers[i].rcl.yBottom = yStatsBtm;
      thrConsumers[i].rcl.yTop = yStatsTop;
      thrConsumers[i].rcl.xLeft = i * dx;
      thrConsumers[i].rcl.xRight = (i+1) * dx;
   }
					      /* consume any unused edge */
   thrConsumers [cNumUsers - 1].rcl.xRight = xClient;
   yClient = yStatsBtm - 2;
	  /* the scaling factors determine how large each square will be */
   xScale =  xClient / CNT_SQUARES_EDGE;
   yScale =  yClient / CNT_SQUARES_EDGE;

				/* the entire game board is described by
				   the points that are calculated here.	 */
   for (i = 0; i < CNT_POINTS_EDGE; i++)
   {
       aX[i] = i * xScale;
       aY[i] = i * yScale;
   }
					   /* consume any unused portion */
   aX[CNT_SQUARES_EDGE] = aX[CNT_SQUARES_EDGE] + xClient % CNT_SQUARES_EDGE;
   aY[CNT_SQUARES_EDGE] = aY[CNT_SQUARES_EDGE] + yClient % CNT_SQUARES_EDGE - 1;

				/* now plug the points just calculated into
				   the rectangles that make up the board */
   for (i = 0; i < MAXRESOURCES; i++)
   {
       aSquares[i].rcl.xLeft = aX [i % CNT_SQUARES_EDGE];
       aSquares[i].rcl.xRight = aX [(i % CNT_SQUARES_EDGE) + 1];
       aSquares[i].rcl.yBottom = aY [i / CNT_SQUARES_EDGE];
       aSquares[i].rcl.yTop = aY [(i / CNT_SQUARES_EDGE) + 1];
   }
					   /* store the descender for later */
   yDescGlobal = yDesc;
				  /* store top of board for later reference */
   yBoardTop = aY[CNT_SQUARES_EDGE];
       /* finally, store the width of the client window for later reference */
   xWidth = xClient;
   return;
}

/****************************************************************\
 *   client painting routine					*
 *--------------------------------------------------------------*
 *								*
 *  Name:   MainPaint(hwnd)					*
 *								*
 *  Purpose: Paints the main client window.			*
 *								*
 *  Usage:  Routine is called whenver the client window		*
 *	    procedure receives a WM_PAINT message		*
 *								*
 *  Method:							*
 *	    - begins painting by calling WinBeginPaint		*
 *	      and retriving the HPS for the window		*
 *	    - performs any painting desired.  Currently the	*
 *	      only painting it does is to draw rectangles on	*
 *	      the screen if semaphore is started.		*
 *	    - ends painting by calling WinEndPaint		*
 *								*
 *  Returns:							*
 *								*
\****************************************************************/
VOID MainPaint( HWND hwnd )
{
   HPS hps=0L;

   hps = WinBeginPaint(hwnd, 0L, 0L);
   GpiErase (hps);
   DrawRects (hps);
   WinEndPaint(hps);
   return;
}						/* MainPaint() */
/*static char *SCCSID = "@(#)sem_user.c 6.10 92/03/25";*/
/*==============================================================*\
 *  SEM_USER.C - routines for handling messages not processed	*
 *		by the standard message processing routine	*
 *	(C) Copyright IBM Corporation 1992.			*
 *--------------------------------------------------------------*
 *								*
 *  This module contains the code for processing messages sent	*
 *  to the standard window that the standard window does not	*
 *  process.  The application developer need only modify this	*
 *  file in order to implement new menu items or process	*
 *  messages not handled by the standard message routine.	*
 *								*
 *  This module also contains some routines that demonstate the *
 *  various dialog box controls and message box types that can	*
 *  be used.  The sample code should be deleted when this	*
 *  module is modified for an application.  The demonstration	*
 *  code is identified by comments.				*
 *								*
 *--------------------------------------------------------------*
 *								*
 *  This source file contains the following functions:		*
 *								*
 *	UserCommand(mp1, mp2) - user WM_COMMAND processor	*
 *								*
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#include "semaph.h"

/****************************************************************\
 *  Non-standard menu item command processing procedure		*
 *--------------------------------------------------------------*
 *								*
 *  Name:   UserCommand(mp1, mp2)				*
 *								*
 *  Purpose: Process any WM_COMMAND messages send to hwndMain	*
 *		that are not processed by MainCommand		*
 *								*
 *  Usage:  Routine is called for each WM_COMMAND that is	*
 *	    not posted by a standard menu item			*
 *								*
 *  Method: A switch statement branches control based upon	*
 *	    the id of the control which posted the message	*
 *								*
 *  Returns:							*
\****************************************************************/
VOID UserCommand( MPARAM mp1, MPARAM mp2 )
{
    USHORT rc;
    HWND hwndSemMenu;

    hwndSemMenu = WinWindowFromID(hwndMainFrame, FID_MENU);

    switch(SHORT1FROMMP(mp1))
    {
       case IDM_SEMSTART_MANUAL:
	   if (!fSemaphoreStarted)
	   {   /* should never get this message unless sample started*/

	       fSemaphoreStarted = TRUE;
	       fSemaphoreWasStarted = TRUE;

	       /* Turn on other menu items */
	       WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		   MPFROM2SHORT(IDM_SEMSTOP,TRUE),
		   MPFROM2SHORT(MIA_DISABLED,FALSE));

	       WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		   MPFROM2SHORT(IDM_POST,TRUE),
		   MPFROM2SHORT(MIA_DISABLED,FALSE));

	       WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		   MPFROM2SHORT(IDM_SEM_RESUMEAUTO,TRUE),
		   MPFROM2SHORT(MIA_DISABLED,FALSE));

	       /* turn off menu items to configure demo */
	       WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		   MPFROM2SHORT(IDM_OPTIONS_NTHRDS,TRUE),
		   MPFROM2SHORT(MIA_DISABLED,MIA_DISABLED));

	       WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		   MPFROM2SHORT(IDM_OPTIONS_TIMEOUT ,TRUE),
		   MPFROM2SHORT(MIA_DISABLED,MIA_DISABLED));

	       WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		   MPFROM2SHORT(IDM_SEMSTART,TRUE),
		   MPFROM2SHORT(MIA_DISABLED,MIA_DISABLED));

	       if (StartSemExample() == FALSE) {
		   MessageBox (HWND_DESKTOP, IDMSG_CANNOTSTART, TRUE);
		   WinSendMsg (hwndMain, WM_CLOSE, 0L, 0L);
	       }
	   }
	   break;

       case IDM_POST:
	   if (fSemaphoreStarted)
	   {   /* should never get this message unless sample started*/
	       if (fAutoMode)
	       {
		    WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		     MPFROM2SHORT(IDM_SEM_RESUMEAUTO,TRUE),
		     MPFROM2SHORT(MIA_DISABLED,FALSE));
	       }
	       SignalUserEvent(&fAutoMode);
	   }
	   break;

       case IDM_SEM_RESUMEAUTO:
       case IDM_SEMSTART_AUTO:
	   if (!fSemaphoreStarted)
	   {	/* should never get this message unless sample started*/
		fSemaphoreStarted = TRUE;
		fSemaphoreWasStarted = TRUE;

		/* Turn on other menu items */
		WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		    MPFROM2SHORT(IDM_SEMSTOP,TRUE),
		    MPFROM2SHORT(MIA_DISABLED,FALSE));

		WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		    MPFROM2SHORT(IDM_POST,TRUE),
		    MPFROM2SHORT(MIA_DISABLED,FALSE));

		/* turn off menu items to configure demo */
		WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		    MPFROM2SHORT(IDM_OPTIONS_NTHRDS,TRUE),
		    MPFROM2SHORT(MIA_DISABLED,MIA_DISABLED));

	       WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		   MPFROM2SHORT(IDM_OPTIONS_TIMEOUT ,TRUE),
		   MPFROM2SHORT(MIA_DISABLED,MIA_DISABLED));

		StartSemExample();

	   }

	   if (fSemaphoreStarted && !fAutoMode)
	   {
	      rc = SetAutoMode();
	      if (!rc)
	      {
		 fAutoMode = TRUE;
		 /* disable menus */

		 WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		     MPFROM2SHORT(IDM_SEM_RESUMEAUTO,TRUE),
		     MPFROM2SHORT(MIA_DISABLED,MIA_DISABLED));

		 WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		    MPFROM2SHORT(IDM_SEMSTART,TRUE),
		    MPFROM2SHORT(MIA_DISABLED,MIA_DISABLED));
	      }
	   }
	   break;

       case  IDM_SEMSTOP:
	   if (fSemaphoreStarted)
	   {
	      BeginStop (&fAutoMode);

	       /* don't allow them to select stop again */
	      WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		  MPFROM2SHORT(IDM_SEMSTOP,TRUE),
		  MPFROM2SHORT(MIA_DISABLED,MIA_DISABLED));

	      WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		  MPFROM2SHORT(IDM_SEM_RESUMEAUTO,TRUE),
		  MPFROM2SHORT(MIA_DISABLED,MIA_DISABLED));

	      WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		  MPFROM2SHORT(IDM_POST,TRUE),
		  MPFROM2SHORT(MIA_DISABLED,MIA_DISABLED));
	   }
	   break;
       case  IDM_STOPFINISHED:
	   if (fSemaphoreStarted)
	   {
	      fSemaphoreStarted = FALSE;

	      /* Reset option and semaphore/start menu items ... */
	      WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		  MPFROM2SHORT(IDM_SEMSTART,TRUE),
		  MPFROM2SHORT(MIA_DISABLED,FALSE));

	      WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		  MPFROM2SHORT(IDM_OPTIONS_NTHRDS,TRUE),
		  MPFROM2SHORT(MIA_DISABLED,FALSE));

	      WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		  MPFROM2SHORT(IDM_OPTIONS_TIMEOUT ,TRUE),
		  MPFROM2SHORT(MIA_DISABLED,FALSE));
	   }
	   break;

       case IDM_OPTIONS_NTHRDS_2:
       case IDM_OPTIONS_NTHRDS_4:
       case IDM_OPTIONS_NTHRDS_8:
       case IDM_OPTIONS_NTHRDS_16:
	   if (!fSemaphoreStarted) {
	       INT oldNumUsers = cNumUsers;
	       WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		   MPFROM2SHORT(IDM_OPTIONS_NTHRDS+cNumUsers,TRUE),
		   MPFROM2SHORT(MIA_CHECKED,FALSE));
	       cNumUsers = SHORT1FROMMP(mp1) - IDM_OPTIONS_NTHRDS;
	       /* if we changed the number of threads to display */
	       if (cNumUsers != oldNumUsers)
		   WinPostMsg (hwndMain, WM_USERCHANGED, (MPARAM)0, (MPARAM)0);

	       WinSendMsg(hwndSemMenu,MM_SETITEMATTR,
		   MPFROM2SHORT(IDM_OPTIONS_NTHRDS+cNumUsers,TRUE),
		   MPFROM2SHORT(MIA_CHECKED,MIA_CHECKED));
	   }
	   break;

       case IDM_OPTIONS_TIMEOUT:
	   if (!fSemaphoreStarted)
	   {
	       WinDlgBox (HWND_DESKTOP,
			  hwndMain,
			  TimeDlgProc,
			  0,
			  TIMERBOX,
			  NULL);
	   }
	   break;

       default:
	       break;
    }

    /* This routine currently doesn't use the mp2 parameter but       *\
     *	it is referenced here to prevent an 'Unreferenced Parameter'  *
    \*	warning at compile time.				      */
    return;

}						     /* UserCommand() */
/*static char *SCCSID = "@(#)setprint.c 6.2 92/02/24";*/
/*************************************************************************
 * File Name	 : SETPRINT.C
 *
 * Description	 : This sample program demonstrates how to use the
 *		   Bidirectional (Bidi) API NlsSetBidiPrint.
 *		   This Bidi API is use to send the Bidi attriubtes
 *		   of the string we want to print, to the Bidi
 *		   printer support. Accordingly, the string will be
 *		   printed following this attributes. This is independant
 *		   from the current printer Bidi attriubes.
 *
 * Considerations: Before using this program, make sure that the Bidi
 *		   printer support is active (RUN= statement in the
 *		   CONFIG.SYS exists) and it is loading the correct CFG
 *		   that match the type of printer connected.
 *		   Also make sure that proper font is been dowloaded to
 *		   the printer.
 *
 * API's         : NlsSetBidiPrint
 *		   VioWrtCharStr
 *		   VioScrollUp
 *		   VioSetCurType
 *
 * Required files: To build and run this sample code the following files
 *		   are needed:
 *		   - SETPRINT.C
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 ************************************************************************/
#define INCL_BASE
/* To include the neccessary header files for Bidi */
#define INCL_DOSERRORS
#define INCL_BDCALLS
#define INCL_DOSFILEMGR
#define PRINTER	 "PRN"

#include <string.h>
#include <os2.h>
#include <conio.h>
#include <stdio.h>

VOID Initialize(VOID);
VOID SendAttThenJob(VOID);
VOID SetCur(INT);

/* Define the parameter to Hide and Restore the cursor */
#define HIDE   -1
#define RESTORE 0

/* Define the buffer for the string to be printed */
CHAR cString[30];

/*************************************************************************
 * Name		 : Main
 *
 * Description	 : This is the main part of the program, it first clears
 *		   the screen and then hides the cursor. The string to be
 *		   printed will be displayed on the screen, and after
 *		   Hitting Enter, it will go to the printer associated
 *		   with its own attributes.
 *
 * API's         : VioScrollUp
 *
 * Parameters	 : This program does not take any command line parameters
 *
 * Returns	 : None
 *
 ************************************************************************/

INT main(SHORT sArgc,CHAR **ppArgv)
{
   APIRET RC;

   /* clear the screen	*/
   VioScrollUp(0, 0, 24, 79, -1," \x07", 0);

   /* hide the cursor */
   SetCur(HIDE);

   /* Write the static text to the screen and the string that
    * is needed to be shaped */
   Initialize();

   VioWrtCharStr("Press Enter to continue or Ctrl-c to Exit", 43, 15, 23, 0l);
   getchar();

   /* Call the API to shape the string and wirte it to the screen */
   SendAttThenJob();

   VioWrtCharStr("Press Enter to end the program", 32, 23, 23, 0l);
   getchar();

   /* clear the screen before exit */
   VioScrollUp(0, 0, 24, 79, -1," \x07", 0);

   /* restore the cursor position */
   SetCur(RESTORE);

   return (0);
}
/*************************************************************************
 * Name		 : INITIALIZE
 *
 * Description	 : This function displays some static text  on the screen
		   and also the String to print before it is printed.
 *
 * API's         : VioWrtCharStr
 *
 * Parameters	 : This program does not take any command line parameters
 *
 * Returns	 : None
 *
 ************************************************************************/
VOID Initialize(VOID)
{
   INT iI, iRow, iCol;

   APIRET  RC;

   /* define structures to be array of strings to contain the static
    * text to be wirtten on the screen	*/
   struct {
	  CHAR cScreen[45];
	  }mssg1[2];

   /* Initialize the structures with the characters to be displayed */
   strcpy(mssg1[0].cScreen, " First, make sure that the Bidi Printer");
   strcpy(mssg1[1].cScreen, "Support is running with the correct CFG..");

   /* In this for loop, we increment the iRow after the display of each
    * string in the structure to jump to another line, keeping the value
    * of the iCol value fixed to have the strings indented */
   for(iI = 0, iRow = 3, iCol = 23; iI < 2; iI++, iRow++)
     VioWrtCharStr(mssg1[iI].cScreen, strlen(mssg1[iI].cScreen),
		   iRow, iCol, 0l);


   strcpy(cString,"This is a text sample");
   VioWrtCharStr(cString, strlen(cString), 8, 23, 0l);

}
/*************************************************************************
 * Name		 : SendAttThenJob
 *
 * Description	 : This function will show how to use the Bidi API
 *		   NslSetBidiPrint.
 *		   The function will also display the status of the
 *		   string to print.
 *
 * API's         : NlsSetBidiPrint
 *		   VioWrtCharStr
 *
 * Parameters	 : This program does not take any command line parameters
 *
 * Returns	 : None
 *
 ************************************************************************/
VOID SendAttThenJob(VOID)
{

   APIRET   RC=0;
   HFILE    hfileFileHandle;
   ULONG    ulBidiAttr;
   ULONG    ulLength=8L;
   ULONG    ulAction = 0;
   ULONG    ulBytesWritten;


   ulBidiAttr =	 BD_LEVEL
	       | BD_SUPPORT
	       | BDORIENT_RTL
	       | BDNUM_PASSTHRU
	       | BDCSD_PASSTHRU;

   RC = DosOpen(PRINTER,
		&hfileFileHandle,
		&ulAction,
		0L,
		FILE_SYSTEM,
		OPEN_ACTION_OPEN_IF_EXISTS,
		OPEN_ACCESS_WRITEONLY |	 OPEN_SHARE_DENYREAD,
		(PEAOP2)NULL);
   if (RC)
   {
     printf ("Cannot open the Printet to write RC=%ld\n",RC);
     exit (1);
   }

   RC = NlsSetBidiPrint( ulBidiAttr, ulLength, (HFILE)hfileFileHandle);

   if (RC)
   {
     printf ("Error in sending string's attributes to the printer RC=%ld\n",RC);
     exit (1);
   }
   else
   {
     RC = DosWrite(hfileFileHandle,
		   cString,
		   strlen(cString),
		   &ulBytesWritten);

     if (RC)
     {
       printf ("Error in writting the string to the printer RC=%ld\n",RC);
       exit(1);
     }
     else
     {
       VioWrtCharStr("The string is been sent to the printer", 40, 18, 23, 0l);
     }
   }

   RC = DosClose(hfileFileHandle);
   if (RC)
   {
     printf ("Error in closing the printer device RC=%ld\n",RC);
     exit (1);
   }
}
/*************************************************************************
 * Name		 : SET_CUR
 *
 * Description	 : This function hides or restores the cursor position.
 *
 * API's         : VioSetCurType
 *
 * Parameters	 : (INT flag)
 *		   flag indicates whether we want ot hide or restore
 *		   the cursor.
 *
 * Returns	 : None
 *
 ************************************************************************/

VOID SetCur(INT iFlag)
{
   HVIO HVIOhandle = 0;
   VIOCURSORINFO cursor;

   cursor.yStart  = 3;
   cursor.cEnd	  = 5;
   cursor.cx	  = 0;
   cursor.attr	  = iFlag;

   VioSetCurType(&cursor, HVIOhandle);
}

/*static char *SCCSID = "@(#)shape.c    6.1 92/02/19";*/
/*************************************************************************
 * File Name	 : SHAPE.C
 *
 * Description	 : This sample program demonstrates how to use the
 *		   Bidirectional (Bidi) API NlsShapeBidiString.
 *		   This an Arabic specific API and is used to Shape a
 *		   string according to the value of the CSD byte in
 *		   the Bidi attributes given to the API.
 *
 * Concepts	 : The orientation byte in the Bidi attributes should
 *		   describe the way the input string was logically sotred,
 *		   i.e RTL or LTR. This is mandatory because the Character
 *		   Shape Determination is dependant on the string
 *		   orientation. If a wrong orientation was specified, a
 *		   wrong output is expected
 *
 * API's         : NlsSetBidiAtt
 *		   NlsQueryBidiAtt
 *		   NlsShapeBidiString
 *		   VioWrtCharStr
 *		   VioScrollUp
 *		   VioSetCurType
 *
 * Required files: To build and run this sample code the following files
 *		   are needed:
 *		   - SHAPE.C
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 ************************************************************************/
#define INCL_BASE
/* To include the neccessary header files for Bidi */
#define INCL_DOSERRORS
#define INCL_BDCALLS

#include <string.h>
#include <os2.h>
#include <conio.h>

VOID Initialize(VOID);
VOID ShapeAndDisplay(VOID);
VOID SetCur(INT);

/* Define a variable to save the session Bidi Attributes in it */
ULONG ulOriginalBidiAttr;

/* Define the area where we will get the result
 * of what we want to query from the session   */
BDKVCB bdkvcbSetAttr;

/* Define the parameter to Hide and Restore the cursor */
#define HIDE   -1
#define RESTORE 0

/* Define the buffer for the string to be displayed */
CHAR cString[50];

/*************************************************************************
 * Name		 : Main
 *
 * Description	 : This is the main part of the program, it first clear
 *		   the screen and then hide the cursor. The string to be
 *		   shaped will be displayed before and after the API
 *		   NlsShapeBidiString is called, with different modes of
 *		   shaping.
 *
 * API's         : NlsSetBidiAtt
 *		   VioScrollUp
 *
 * Parameters	 : This program does not take any command line parameters
 *
 * Returns	 : None
 *
 ************************************************************************/

INT main(SHORT sArgc,CHAR **ppArgv)
{
   APIRET RC;

   /* clear the screen	*/
   VioScrollUp(0, 0, 24, 79, -1," \x07", 0);

   /* hide the cursor */
   SetCur(HIDE);

   /* Write the static text to the screen and the string that
    * is needed to be shaped */
   Initialize();

   /* Call the API to shape the string and wirte it to the screen */
   ShapeAndDisplay();

   /* Wait for Enter key to end the program */

   VioWrtCharStr("Press Enter to end the program", 32, 23, 28, 0l);
   getchar();

   /* Restore the session Bidi attributes  */
   bdkvcbSetAttr.BDAtts = ulOriginalBidiAttr ;

   RC = NlsSetBidiAtt( 0L, (PSETINFO)&bdkvcbSetAttr);
   if( RC != 0)
   {
     printf("\n\nCannot set the session Bidi Attributes RC=%ld\n",RC);
     exit(1);
   }

   /* clear the screen before exit */
   VioScrollUp(0, 0, 24, 79, -1," \x07", 0);

   /* restore the cursor position */
   SetCur(RESTORE);

   return (0);
}
/*************************************************************************
 * Name		 : INITIALIZE
 *
 * Description	 : This function does save the current Bidi attributes of
 *		   the session in a global variable, and set session with
 *		   its own Bidi attributes to protect the displayed shaped
 *		   string from been processed again according to the session
 *		   Bidi attributes.
 *		   Then the function displays some static text and also the
 *		   String to be shaped before any shaping processing.
 *
 * API's         : NlsQueryBidiAtt
 *		   NlsSetBidiAtt
 *		   VioWrtCharStr
 *
 * Parameters	 : This program does not take any command line parameters
 *
 * Returns	 : None
 *
 ************************************************************************/
VOID Initialize(VOID)
{
   INT iI, iRow, iCol;

   APIRET  RC;

   /* define structures to be array of strings to contain the static
    * text to be wirtten on the screen	*/
   struct {
	  CHAR cScreen[40];
	  }mssg1[4];

   struct {
	   CHAR cScreen[12];
	   }mssg2[8];

   /* First we need to set the session Bidi attributes to have the
    * shaping mode as Passthru. This will let the Bidi support
    * to display the characters on the screen as they are.
    * i.e without any additional shape processing.
    * This way, when the application does its own shaping processing
    * the output characters to the screen will not be corrupted. */

   /* The length here is 8 to query only on the Bidi attribute	 */

   bdkvcbSetAttr.BDLength = 8;

   RC = NlsQueryBidiAtt( 0L,(PRETINFO)&bdkvcbSetAttr);

   if(RC != 0)
   {
      printf("\n\nError in query the Bidi Attributes RC=%ld\n",RC);
      exit(1);
   }

   /* Now we save the initial value of the Bidi attributes so that
    * so that we set back the session with it before the program terminates*/

   ulOriginalBidiAttr = bdkvcbSetAttr.BDAtts;

  /* Here we set the shaping byte value to passthru */

   bdkvcbSetAttr.BDAtts = BD_LEVEL |
			  BD_SUPPORT |
			  BDORIENT_LTR |
			  BDNUM_PASSTHRU |
			  BDCSD_PASSTHRU;

  /* Now let's set the session Bidi attributes with the new value  */

   RC = NlsSetBidiAtt( 0L, (PSETINFO)&bdkvcbSetAttr);
   if( RC != 0)
   {
       printf("\n\nCannot set the session Bidi Attributes RC=%ld\n",RC);
       exit(1);
   }

   /* Initialize the structures with the characters to be displayed */
   strcpy(mssg1[0].cScreen, "Calling NlsShapeBidiString you can");
   strcpy(mssg1[1].cScreen, "  Change the following String to  ");
   strcpy(mssg1[2].cScreen, "    any of the different Arabic   ");
   strcpy(mssg1[3].cScreen, "             Shapes               ");

   /* In this for loop, we increment the iRow after the display of each
    * string in the structure to jump to another line, keeping the value
    * of the iCol value fixed to have the strings indented */
   for(iI = 0, iRow = 2, iCol = 23; iI < 4; iI++, iRow++)

   VioWrtCharStr(mssg1[iI].cScreen, strlen(mssg1[iI].cScreen), iRow, iCol, 0l);


   /* Initialize the second structure with the characters to be displayed */
   strcpy(mssg2[0].cScreen, "String    :");
   strcpy(mssg2[1].cScreen, "Base      :");
   strcpy(mssg2[2].cScreen, "Initial   :");
   strcpy(mssg2[3].cScreen, "Middle    :");
   strcpy(mssg2[4].cScreen, "Final     :");
   strcpy(mssg2[5].cScreen, "Isolated  :");
   strcpy(mssg2[6].cScreen, "Shaped LTR:");
   strcpy(mssg2[7].cScreen, "Shaped RTL:");


   VioWrtCharStr(mssg2[0].cScreen, strlen(mssg2[0].cScreen), 8, 5, 0l);

   for(iI = 1, iRow = 11, iCol = 5; iI <= 7; iI++, iRow++)

   VioWrtCharStr(mssg2[iI].cScreen, strlen(mssg2[iI].cScreen), iRow, iCol, 0l);

   /* Display the string before it is shaped.
    * Note that this is a Left To Right string, because the logical
    * order of the characters stored is from the end of the buffer
    * to the begining, i.e from high to low memory */

   strcpy(cString,"  Ѯ  ʼ  ");
   VioWrtCharStr(cString, strlen(cString), 8, 18, 0l);
}
/*************************************************************************
 * Name		 : SHAPEANDDISPLAY
 *
 * Description	 : This function will show how to use the Bidi API
 *		   NslShapeBidiString, and what are the different shaping
 *		   modes available and how to pass them to the API.
 *		   The function will display the string after each call to
 *		   NslShapeBidiString, according to different shaping
 *		   attributes.
 *
 * API's         : NlsShapeBidiString
 *		   VioWrtCharStr
 *
 * Parameters	 : This program does not take any command line parameters
 *
 * Returns	 : None
 *
 ************************************************************************/
VOID ShapeAndDisplay(VOID)
{
   APIRET RC;
   INT	 iRow, iCol;
   ULONG ulBidiAttr,ulBidiAttrIso;
   ULONG ulEffect ;
   CHAR	 cTarget[50];
   ULONG ulLength;
   ULONG ulIncrement ;

   /* The Effect paramter is reserved to be zero */
   ulEffect = 0;

   ulLength = strlen(cString);

   /* The string contains successive characters, i.e the cell here is
    * only one character, i.e Increment =1 */
   ulIncrement = 1;

   iCol = 18;

   /* using the OR operator, we set the bits in the Bidi attributes
    * to describe the orientation of the buffer and the shaping mode
    * that we want as output */

   ulBidiAttr= BD_LEVEL |
	       BD_SUPPORT |
	       BDORIENT_LTR |
	       BDNUM_PASSTHRU |
	       BDCSD_BASE ;

    /* In this for loop, we depend on the fact that if we increment
     * the Bidi attributes by 1, starting from the value of the
     * BASE shapes, we get another shaping attribute, until we reach
     * the ISOLATED shapes mode, which is the value in ulBidiAttrIso.
     * We also increment the iRow value by one, to get a new line to
     * display each mode  */

   ulBidiAttrIso = ulBidiAttr | BDCSD_ISOLATED;

   for(iRow=11; ulBidiAttr <= ulBidiAttrIso ; ulBidiAttr++, iRow++)

   {
       RC=NlsShapeBidiString(ulBidiAttr,ulEffect, cString,
			     cTarget, ulLength, ulIncrement);

       /* If there is an error returned */
       if(RC != 0)
       {
       printf ("RC1 =%ld\n",RC);
	   exit(1);
       }

       /* terminate the string with a NULL */
       cTarget[strlen(cString)] = '\0';

       /* display it on the screen */
       VioWrtCharStr(cTarget, strlen(cTarget), iRow, iCol, 0l);
    }

   /* Now let's put the shaping mode to be Automatic character determination
    * (shaping) ON, keeping the orientation to be Left To Right. */

   ulBidiAttr= BD_LEVEL |
	       BD_SUPPORT |
	       BDORIENT_LTR |
	       BDNUM_PASSTHRU |
	       BDCSD_AUTOMATIC;

    RC=NlsShapeBidiString(ulBidiAttr ,ulEffect,cString,
			  cTarget, ulLength, ulIncrement);

    if(RC != 0)
    {
       printf ("RC2 =%ld\n",RC);
       exit(1);
    }

    cTarget[strlen(cTarget)] = '\0';
    VioWrtCharStr(cTarget, strlen(cTarget), iRow, iCol, 0l);

   /* Just for the sake of demonstration, let's intentionally set the
    * the orientation bit to Right To Left, which is the wrong orientation
    * of the original string, keeping the shaping mode unchanged */

   ulBidiAttr= ulBidiAttr | BDORIENT_RTL;

    RC=NlsShapeBidiString(ulBidiAttr ,ulEffect,cString,
			  cTarget, ulLength, ulIncrement);

    if(RC != 0)
    {
       printf ("RC3 =%ld\n",RC);
       exit(1);
    }
    cTarget[strlen(cTarget)] = '\0';

    VioWrtCharStr(cTarget, strlen(cTarget), iRow+1, iCol, 0l);
}

/*************************************************************************
 * Name		 : SET_CUR
 *
 * Description	 : This function hides or restores the cursor position.
 *
 * API's         : VioSetCurType
 *
 * Parameters	 : (INT flag)
 *		   flag indicates whether we want ot hide or restore
 *		   the cursor.
 *
 * Returns	 : None
 *
 ************************************************************************/

VOID SetCur(INT iFlag)
{
   HVIO HVIOhandle = 0;
   VIOCURSORINFO cursor;

   cursor.yStart  = 3;
   cursor.cEnd	  = 5;
   cursor.cx	  = 0;
   cursor.attr	  = iFlag;

   VioSetCurType(&cursor, HVIOhandle);
}

/*=========================================================================*\
 *									   *
 * SORT.C - Multi-threaded PM sample.					   *
 *									   *
 *									   *
 *	(C) Copyright IBM Corporation 1992.				   *
 *									   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have	   *
 *	been advised of the possibility of   such damages.		   *
 *-------------------------------------------------------------------------*
 *
 *   This program demonstrates the use of many threads by doing
 *   LISTCNT simultaneous sorts.  Each sorting algorithm runs
 *   from a separate thread, the routine which updates the display
 *   is run from another thread, and the main thread is used to
 *   handle the main window's messages.  The display thread is
 *   started when the program begins and is not terminated (allows
 *   default cleanup to terminate thread) as the display routine
 *   is used throughout the program's life.
 *   This code was written to allow easy modification.	To change
 *   the number of simultaneous sorts, change the LISTCNT #define
 *   and modify the global arrays which control the screen
 *   drawing color, the sort each thread is to use, and the sort name.
 *   Note:  This program was not intended to infer the relative
 *	    speeds of the various sorting algorithms.
 *
 *---------------------------------------------------------------
 *
 *   Procedures in this file:
 *     main()		  Sets up the PM environment and calls
 *			  the main dialog procedure ClientWndProc
 *     ClientWndProc()	  Handles the main window messages
 *     CalcThread()	  Generic stub that sets up, executes, and
 *			  terminates each sort in an aux. thread
 *     DispThread()	  Updates the display during the sorts
 *     BubbleSort()	  Implements a bubble sort
 *     InsertionSort()	  Implements an insertion sort
 *     BatcherSort()	  Stub that calls recursive Batcher sort
 *     BatcherSortR()	  Implements a Batcher sort
 *     QuickSort()	  Stub that calls recursive Quick sort
 *     QuickSortR()	  Implements a Quick sort
 *     EnableMenuItem()	  Activates/deactivates a menu choice
 *     EntryFldDlgProc()  Handles the set number of disks dialog box
 *     RandomizeData()	  Randomizes the data arrays for the sorts
 *     FixSysMenu()	  Remove Restore, Size, Min, & Max from system menu
 *
\*==============================================================*/
/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs	*
\*--------------------------------------------------------------*/
#define INCL_WIN
#define INCL_WINHEAP
#define INCL_HELP
#define INCL_WINDIALOGS
#define INCL_GPIPRIMITIVES
#define INCL_GPIBITMAPS
#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#include <os2.h>
#include <stdio.h>
#include <string.h>
#include <process.h>
#include <stdlib.h>
#include "sort.h"

/*--------------------------------------------------------------*\
 *  Entry point declarations					*
\*--------------------------------------------------------------*/

MRESULT EXPENTRY ClientWndProc	(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY EntryFldDlgProc(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY AboutDlgProc(HWND, ULONG, MPARAM, MPARAM);
LONG	MessageBox(HWND, LONG, LONG, BOOL);
VOID APIENTRY ExitProc(ULONG);
BOOL Init(VOID);

INT main(LONG ,CHAR **);
VOID APIENTRY CalcThread(ULONG);
VOID APIENTRY DispThread(ULONG);

VOID EnableMenuItem(HWND, LONG, BOOL);
VOID RandomizeData(ULONG);
VOID BubbleSort(PCALCPARAM);
VOID BatcherSort(PCALCPARAM);
VOID BatcherSortR(PCALCPARAM, ULONG, ULONG, ULONG, BOOL);
VOID QuickSort(PCALCPARAM);
VOID QuickSortR(PCALCPARAM, LONG, LONG);
VOID InsertionSort(PCALCPARAM);
VOID FixSysMenu(HWND);
VOID InitHelp(VOID);
VOID HelpHelpForHelp(MPARAM);
VOID HelpExtended(MPARAM);
VOID HelpKeys(MPARAM);
VOID HelpIndex(MPARAM);
VOID HelpAbout(MPARAM);
VOID DisplayHelpPanel(LONG);
VOID DestroyHelpInstance(VOID);
HEV  hev;
RECTL  rcl;		 /* Rectangle struct for painting  */

/*--------------------------------------------------------------*\
 *  Global variables						*
\*--------------------------------------------------------------*/
CHAR szClientClass[40];
USHORT Data[LISTCNT][MAX_ELEMS];     /* Array that contains the data to sort  */

/* Global data that defines each of the sort routines */

			      /* Color of each of the LISTCNT data lists.  */
ULONG  ulColors[LISTCNT] = { CLR_RED,CLR_BLUE,CLR_DARKGREEN,CLR_CYAN };

	  /* List of sorts to be executed for each of the LISTCNT threads. */
VOID (*pExecSub[LISTCNT])(PCALCPARAM)={BubbleSort,BatcherSort,QuickSort,
			   InsertionSort};
						   /* Ascii names of sorts */
CHAR *szSubNames[LISTCNT]={"Bubble Sort",
			   "Batcher Sort",
			   "Quick Sort",
			   "Insertion Sort"};

HAB    hab;				 /* Anchor block for the process */
HMQ    hmq;
BOOL   fHelpEnabled;		 /* flag to determine if help is enabled */
CHAR   szUntitled[MESSAGELEN];		 /* buffer for "Untitled" string */
HWND   hwndFrame, hwndClient;
static CHAR szLibName[HELPLIBRARYNAMELEN];
static CHAR szWindowTitle[HELPLIBRARYNAMELEN];
static HWND hwndHelpInstance;
RECTL  rectl;

/****************************************************************\
 * Function name: main(LONG sArgc,CHAR **ppArgv)
 *
 * Parameters:	NONE
 *
 * Returns: Always returns 0
 *
 * Purpose: Sets up the PM environment, calls the main window proc,
 *	    handles the window's messages then cleans up and exits.
 *
 * Usage:
\****************************************************************/
INT main(LONG sArgc,CHAR **ppArgv)
{
   QMSG		qmsg;
   CHAR *pszName = "SORT";

   ULONG flFrameFlags = FCF_STANDARD;

   strncpy(szClientClass,pszName,strlen(pszName) );

   /* These PM calls should be error checked */
   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue(hab, 0);

   if(!Init())
   {
       MessageBox(HWND_DESKTOP,
		  IDMSG_INITFAILED,
		  MB_OK | MB_ERROR,
		  TRUE);
       DosExit(EXIT_PROCESS,RETURN_ERROR);
   }


   hwndFrame = WinCreateStdWindow(HWND_DESKTOP,
				  WS_VISIBLE,
				  &flFrameFlags,
				  szClientClass,
				  NULL,
				  0L,
				  (HMODULE)0,
				  ID_RESOURCE,
				  &hwndClient);
   if(hwndFrame == NULLHANDLE)
   {
       MessageBox(HWND_DESKTOP,
		  IDMSG_MAINWINCREATEFAILED,
		  MB_OK | MB_ERROR,
		  TRUE);
       DosExit(EXIT_PROCESS,RETURN_ERROR);
   }
   InitHelp();

   while(WinGetMsg(hab,&qmsg,0,0,0))	    /* Message loop */
      WinDispatchMsg(hab,&qmsg);

   /* destroy the help instance */
   DestroyHelpInstance();

   DosExit(EXIT_PROCESS,RETURN_SUCCESS);
   return 0L;
}

/****************************************************************\
 *  Initialization routine
 *---------------------------------------------------------------
 *
 *  Name:    Init()
 *
 *  Purpose: Performs initialization functions required before the main
 *	     window can be created.
 *
 *  Usage:   Called once before the main window is created.
 *
 *  Method:  - installs the routine ExitProc into the DosExitList chain
 *	     - registers all window classes
 *	     - performs any command line processing
 *
 *
 *  Returns: TRUE - initialization is successful
 *	     FALSE - initialization failed
\****************************************************************/
BOOL Init(VOID)
{

    /* Add ExitProc to the exit list to handle the exit processing. If
     * there is an error, then terminate the process since there have
     * not been any resources allocated yet			     */

    if(DosExitList(EXLST_ADD, ExitProc))
    {
	MessageBox(HWND_DESKTOP,
		   IDMSG_CANNOTLOADEXITLIST,
		   MB_OK | MB_ERROR,
		   TRUE);
	DosExit(EXIT_PROCESS, RETURN_ERROR);
    }

    if(DosCreateEventSem(NULL,&hev,DC_SEM_SHARED,FALSE ) )
    {
	return(FALSE);
    }

     /* load application name from resource file */
    if(!WinLoadString(hab, 0, IDS_APPNAME, MAXNAMEL, szClientClass))
	return FALSE;

    /* load "untitled" string */
    if(!WinLoadString(hab, 0, IDS_UNTITLED, MESSAGELEN, szUntitled))
	return FALSE;
    /* register the main client window class */
    if(!WinRegisterClass(hab,
			(PSZ)szClientClass,
			(PFNWP)ClientWndProc,
			CS_SIZEREDRAW | CS_CLIPCHILDREN,
			0))
    {
	 return FALSE;
    }
    return( TRUE);
}						    /* Init() */

/****************************************************************\
 *  Exit list processing procedure
 *--------------------------------------------------------------
 *
 *  Name:    ExitProc(usTermCode)
 *
 *  Purpose: Cleans up certain resources when the application terminates
 *
 *  Usage:   Routine is called by DosExitList when the application exits
 *
 *  Method:  Global resources, such as the main window and message queue,
 *	     are destroyed and any system resources used are freed.
 *
 *  Returns: Returns EXLST_EXIT to the DosExitList handler
 *
\****************************************************************/
VOID APIENTRY ExitProc(ULONG usTermCode)
{
   /* destroy the main window if it exists */
   if(WinIsWindow(hab, hwndFrame))  {
       WinDestroyWindow(hwndFrame);
   }

   /*--------------------------------------------------*\
    *	   Any other system resources used	       *
    *	   (e.g. memory or files) should be freed here *
   \*--------------------------------------------------*/

   WinDestroyMsgQueue(hmq);

   WinTerminate(hab);

   DosExitList(EXLST_EXIT, 0L);		/* termination complete */
   return;
}					    /* ExitProc() */

/****************************************************************\
 * Function name: ClientWndProc()
 *
 * Parameters:	hwnd, msg, mp1, mp2.  Standard PM Dialog Proc params.
 *		No user data is expected in the WM_CREATE.
 *
 * Returns: Returns with WM_QUIT message
 *
 * Purpose: Handles all the messages associated with the main window
 *	    and calls the appropriate handling procedures.
 *
 * Usage  : Called only by main()
\****************************************************************/
MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   HPS	  hps=0;			 /* Handle for painting		   */
   POINTL ptl;				 /* Point struct for painting	   */
   static CALCPARAM cp[LISTCNT];	 /* Struct passed to sort threads  */
   static TID	 tidCalc[LISTCNT];	 /* Sort threads IDs		   */
   static CALCPARAM cpDisp;		 /* Struct passed to disp thread   */
   static TID	 tidDisplay;		 /* Secondary display thread ID	   */
   static USHORT usWindowYCoord=1;	 /* Holds current client window ht */
   static BYTE	 cThreadCnt = 0;	 /* Count of sort threads running  */
   static USHORT cSetSize=MAX_ELEMS;	 /* User sort set size		   */
   USHORT cnt,cnt2,usID;		 /* Utility counters		   */
   ULONG  ulBlip;			 /* Holds the marker pos for Paint */
   MRESULT sRC;

   switch(msg)
   {
      case WM_CREATE:
	 RandomizeData(cSetSize);	 /* Initially randomize data set   */
	 /* Start display thread */
	 cpDisp.hwnd	    = hwnd;
	 cpDisp.Array	    = &usWindowYCoord;
	 cpDisp.pcThreadCnt = &cThreadCnt;
	 cpDisp.pcSetSize   = &cSetSize;
	 DosCreateThread( &tidDisplay,
	  		DispThread,
			(ULONG) ((PVOID) &cpDisp),
			0,
			STACKSIZE);
	if( tidDisplay == (USHORT)-1)
	 {
	    WinAlarm(HWND_DESKTOP, WA_ERROR);  /* can't start display thread */
	    DosExit(EXIT_PROCESS,1);
	 }
	 /* Up the display priority an arbitrary amount to cause it to
	    update more rapidly and to give it a higher priority than
	    the sort threads.*/
	 DosSetPriority(PRTYS_THREAD, PRTYC_REGULAR, 5, tidDisplay);

	 return (MRESULT)0L;

      case WM_SIZE:
	 WinInvalidateRect(hwnd,NULL,FALSE);	 /* Force a redraw */
	 sRC = WinDefWindowProc(hwnd, msg, mp1, mp2);
	 return sRC;

      case WM_PAINT:
	 hps = WinBeginPaint(hwnd,0,0);	  /* Get paint handle	   */
	 WinQueryWindowRect(hwnd,&rcl);
	 if(NELEMS < MAX_ELEMS )
	 {
	       cSetSize = NELEMS;
	 }
	 else
	 {
	       cSetSize = MAX_ELEMS;
	 }
	 RandomizeData(cSetSize);	 /* Initially randomize data set   */
	 usWindowYCoord = rcl.yTop;
	  /* Draw if screen */
	  /* is big enough  */
	 if( (XOFFSET + (2 * COLUMNOFFSET))< (rcl.xRight-rcl.xLeft) &&
	    (YOFFSET * ROWCNT) < (rcl.yTop-rcl.yBottom ) )
	 {
	    DrawRect(rcl.xLeft,rcl.yBottom,	    /* White out the screen  */
		     rcl.xRight,rcl.yTop,CLR_WHITE);

	    DrawLine(XOFFSET, YOFFSET,		    /* Draw baseline	     */
		     rcl.xRight,YOFFSET,CLR_BLACK);

	    DrawLine(XOFFSET, YOFFSET,		    /* Draw vertical line    */
		     XOFFSET,rcl.yTop,CLR_BLACK);

	    for(cnt=0;cnt<LISTCNT;cnt++)	    /* Draw data points	     */
	    {
	       for(cnt2=0;cnt2<cSetSize;cnt2++)
	       {
		  ulBlip = (rcl.yTop-YOFFSET-5) * Data[cnt][cnt2] / RAND_MAX
			   + YOFFSET+1;

		  Draw2Pel(XOFFSET+1 + cnt2, ulBlip, ulColors[cnt]);
	       }
	    }
	    for(cnt=0,cnt2= 0;cnt<COLUMNCNT;cnt++)	    /* Do bottom legend	     */
	    {
	       if(cnt2 >= ROWCNT )
	       {
		    cnt2 = 0;
	       }
	       ptl.x = XOFFSET + cnt2++ *COLUMNOFFSET;
	       /*
		*next row after the last column
		*/
	       if(cnt >=  (COLUMNCNT / ROWCNT ) )
	       {
		    ptl.y = YOFFSET - ( 2 * ROWOFFSET);
	       }
	       else
	       {
		    ptl.y = YOFFSET - ROWOFFSET;
	       }
	       GpiSetColor(hps,ulColors[cnt]);
	       GpiCharStringAt(hps,&ptl,
			       (LONG) strlen(szSubNames[cnt]),
			       szSubNames[cnt]);
	    }
	 }

	 WinEndPaint(hps);
	 return (MRESULT)0L;

      case WM_COMMAND:
	 switch(SHORT1FROMMP(mp1))
	 {
	    case IDM_START:

	       /*
		*clear the drawing semaphore
		*/
	       DosPostEventSem(hev);
	       /* Try to get stack space */
	       for(cnt=0;cnt<LISTCNT;cnt++)
	       {
		  cp[cnt].hwnd		= hwnd;	 /* Set the static struct  */
		  cp[cnt].fContinueCalc = TRUE;
		  cp[cnt].pFunc		= pExecSub[cnt];
		  cp[cnt].usID		= cnt;
		  cp[cnt].Array		= Data[cnt];
		  cp[cnt].cArray	= cSetSize;

		  /* Try to start the thread */
		  DosCreateThread( &tidCalc[cnt],
		  		CalcThread,
				(ULONG) (PVOID) &cp[cnt],
				0,
				STACKSIZE);
		  if( tidCalc[cnt] == (USHORT)-1)
		  {
		     WinAlarm(HWND_DESKTOP, WA_ERROR);
		     return (MRESULT)0L;
		  }
		  if(cThreadCnt++ == 0)	 /* When the first thread starts */
		  {
		     /* Disable Start, Set, and Randomize, enable Stop */
		     EnableMenuItem(hwnd,IDM_START,FALSE);
		     EnableMenuItem(hwnd,IDM_SET,FALSE);
		     EnableMenuItem(hwnd,IDM_RANDOM,FALSE);
		     EnableMenuItem(hwnd,IDM_STOP,TRUE);
		  }
	       }
	       return (MRESULT)0L;

	    case IDM_STOP:
	       for(cnt=0;cnt<LISTCNT;cnt++)
		  cp[cnt].fContinueCalc = FALSE;  /* Notify thread to quit  */
	       return (MRESULT)0L;

	    case IDM_RANDOM:
	       RandomizeData(cSetSize);		       /* Randomize data */
	       WinInvalidateRect(hwnd,NULL,FALSE);     /* Force a redraw */
	       return (MRESULT)0L;

	    case IDM_SET:
	       if(WinDlgBox(HWND_DESKTOP, hwnd, /* Pop up the query/set box */
			    EntryFldDlgProc,(HMODULE)0,IDD_SETCOUNT,
			    (VOID FAR *) &cSetSize))
	       {
		  WinInvalidateRect(hwnd,NULL,FALSE);	  /* Force a redraw */
	       }
	       return (MRESULT)0L;

	    case IDM_GENERALHELP:
	       HelpExtended(mp2);
	       return (MRESULT)0L;

	    case IDM_USINGHELP:
	       HelpHelpForHelp(mp2);
	       return (MRESULT)0L;

	    case IDM_TUTORIAL:
	       HelpKeys(mp2);
	       return (MRESULT)0L;

	    case IDM_HELPINDEX:
	       HelpIndex(mp2);
	       return (MRESULT)0L;

	    case IDM_HELPPRODUCTINFO:
	       HelpAbout(mp2);
	       return (MRESULT)0L;

	    default:
	       sRC = WinDefWindowProc(hwnd, msg, mp1, mp2);
	       return sRC;
	 }
	 break;

      case IDM_DONE:
	 usID = SHORT1FROMMP(mp1);  /* Get ID of quit thread	 */

	 if(--cThreadCnt == 0)		    /* If all quit, enable menus */
	 {
	    EnableMenuItem(hwnd,IDM_START,TRUE);
	    EnableMenuItem(hwnd,IDM_SET,TRUE);
	    EnableMenuItem(hwnd,IDM_RANDOM,TRUE);
	    EnableMenuItem(hwnd,IDM_STOP,FALSE);
	 }
	 return (MRESULT)0L;

      case HM_QUERY_KEYS_HELP:
	 return ((MRESULT)PANEL_KEYSHELP);

      case WM_CLOSE:

	 DosCloseEventSem(hev);
	 for(cnt=0;cnt<LISTCNT;cnt++)
	 {
	    DosKillThread(tidCalc[cnt]);
	 }
	 DosKillThread(tidDisplay);
	 WinPostMsg(hwnd, WM_QUIT, 0L, 0L);
	 return 0L;

      default:
	 sRC = WinDefWindowProc(hwnd, msg, mp1, mp2);
	 return sRC;
   }

   return (MRESULT)0L;
}

/****************************************************************\
 * Function name: CalcThread()
 *
 * Parameters:	pcp is a struct which contains the hwnd handle, the
 *		continue flag which is initially set to TRUE, the ID
 *		which is the
 *
 * Returns: VOID
 *
 * Purpose: This generic stub calls the passed "sort" function with a pointer
 *	    to the data and an item count, then when the sort terminates, it
 *	    cleans up by Posting a done message, then terminating the thread.
 *
 * Usage  : No DosExitCritSec() is called since _endthread()
 *		   clears the critical section when the thread is
 *		   terminated.
 *
\****************************************************************/
VOID APIENTRY CalcThread(ULONG param)
{
   PVOID pcp;
   pcp = (PVOID) param;
   (*((PCALCPARAM)pcp)->pFunc)(pcp);	     /* Execute recurs routine */
			   /* Set Crit so the IDM_DONE isn't processed */
			/* until this thread has completely terminated */
   DosEnterCritSec();

   WinPostMsg(((PCALCPARAM)pcp)->hwnd,IDM_DONE,
	      MPFROMSHORT(((PCALCPARAM)pcp)->usID),NULL);/* Post done */

   /*
    *set the post count for each thread
    *that goes through
    */
   DosPostEventSem(hev);

   return;
}

/****************************************************************\
 * Function name: DispThread()
 *
 * Parameters:	pcp is a struct which contains the hwnd handle, the
 *		count of active threads, the ->Array element points to
 *		the current height of the window which can be dynamically
 *		resized by the user, the pcSetSize points to the current
 *		set size which can be changed by the user only when the
 *		sort is stopped.
 *		None of the other pcp members are used.
 *
 * Returns: VOID
 *
 * Purpose: This routine is run as a secondary thread to update the screen
 *	    when the sort threads are running.	It works by making passes
 *	    through the data lists and redrawing them.	A DosSleep(0) is
 *	    called at the end of each pass to help sychronize things a bit.
 *
 * Usage  : Note that this thread is started when the program is
 *		   initialized, and is never terminated.  Note that
 *		   fDoUpdate is used in such a way that the screen is
 *		   ALWAYS updated once after all threads have terminated.
 *		   This avoids the possibility of the display not being
 *		   fully accurate when the sorts terminate.
 *
\****************************************************************/
VOID APIENTRY DispThread(ULONG param )
{
   PVOID pvData;
   USHORT cnt,cnt2;	 /* Utility counters				*/
   HPS hps;		 /* Presentation space handle			*/
   POINTL ptl;		 /* Used for various drawing macros		*/
   ULONG  ulBlip;	 /* Holds the Y offset for a given data point	*/
   PCALCPARAM pcp;	 /* after all sort threads terminate		*/
   USHORT *pusYCoord;
   ULONG  ulPostCount;

   pvData=(PVOID)param;
   pcp = (PCALCPARAM) pvData;
   pusYCoord = pcp->Array;
   /* Points to location that always	*/
   /* contains current client wind hgt	*/

   hps = WinGetPS( pcp->hwnd);

   while(TRUE)
   {
      /*
       *sit and wait on the clearing of the semaphore
       */
      DosWaitEventSem(hev,SEM_INDEFINITE_WAIT);
      DosQueryEventSem(hev,&ulPostCount);
      /*
       *wait on all 4 threads + the post used to start
       *to post
       */
      if(ulPostCount == 5)
      {
	  ulPostCount = 0;
	  DosResetEventSem(hev,&ulPostCount);
      }
      for(cnt=0;cnt<*((PCALCPARAM)pcp)->pcSetSize;cnt++)/* Update data set */
      {
	 DrawLine(XOFFSET+1 + cnt,YOFFSET+1,	  /* Erase vertical column */
		  XOFFSET+1 + cnt,*pusYCoord, CLR_WHITE);

	 for(cnt2=0;cnt2<LISTCNT;cnt2++)	  /* Draw each point	   */
	 {
	    ulBlip = (ULONG) (*pusYCoord-YOFFSET-5)*Data[cnt2][cnt] / RAND_MAX
		      + YOFFSET+1;
	    Draw2Pel(XOFFSET+1 + cnt, ulBlip, ulColors[cnt2]);
	 }
      }
   }

   /* Note that these 3 lines NEVER get executed, but should the program be
      modified to end the thread, this is the appropriate termination code. */
   WinReleasePS(hps);
//   WinTerminate(habb);
   return;
}

/****************************************************************\
 * Function name: BubbleSort()
 *
 * Parameters:	pcp is a struct which contains the hwnd handle, a
 *		pointer to the data array, and a count of the items in
 *		the data array.
 *		None of the other pcp members are used.
 *
 * Returns: VOID
 *
 * Purpose:  Implements a bubble sort which is an O(n^2) algorithm.  It
 *	     works by repeatedly going through the data and comparing
 *	     consecutive elements and swapping them if they aren't in
 *	     the correct order.	 This guarantees that each pass will
 *	     place at least one additional item in its appropriate
 *	     place.
 *
 * Usage:
\****************************************************************/
VOID BubbleSort(PCALCPARAM pcp)
{
   BOOL fModified = FALSE; /* Set whenever a swap is done, if an entire */
			   /* pass doesn't set the flag, the we're done */
   INT	  cnt;
   INT	  cnt2;		   /* Counters used for the 2-level loops	*/
   USHORT usTemp;	   /* Used to hold a data item during a swap	*/

   for(cnt=(ULONG)(pcp->cArray-1);cnt>=0;cnt--) /*Set the max no. of passes*/
   {
      for(cnt2=0;cnt2<cnt;cnt2++) /* Only sort thru current cnt pass	*/
      {
	 if(!pcp->fContinueCalc)  /* User wishes to terminate the sort	*/
	    return;

	 if(pcp->Array[cnt2]>pcp->Array[cnt2+1]) /* Items need to swap	*/
	 {
	    fModified = TRUE;

	    usTemp = pcp->Array[cnt2];
	    pcp->Array[cnt2] = pcp->Array[cnt2+1];
	    pcp->Array[cnt2+1]= usTemp;
	 }
      }
      if(!fModified)	      /* Nothing changed during the entire pass */
	 break;
      fModified = FALSE;		       /* Reset the modify flag */
   }
   return;
}

/****************************************************************\
 * Function name: InsertionSort()
 *
 * Parameters:	pcp is a struct which contains the hwnd handle, a
 *		pointer to the data array, and a count of the items in
 *		the data array.
 *		None of the other pcp members are used.
 *
 * Returns: VOID
 *
 * Purpose:  Implements an insertion sort which is an O(n^2) algorithm.
 *	     This sort works much faster and does not require that much
 *	     additional code to implement.  It works by setting a sorted
 *	     list to be just the first element, the working each
 *	     successive item into the already sorted list.
 *
 * Usage:
\****************************************************************/
VOID InsertionSort(PCALCPARAM pcp)
{
   SHORT cnt,cnt2;	      /* Counters used for the 2-level loops	*/
   USHORT usTemp;	      /* Used to hold a data item during a swap */

   for(cnt=1;cnt<(LONG)pcp->cArray;cnt++)  /* Insert each item in turn */
   {
      if(!pcp->fContinueCalc)	   /* User wishes to terminate the sort */
	 return;
      usTemp=pcp->Array[cnt];			/* Hold value to insert */
      cnt2=(LONG)(cnt-1);
      while(pcp->Array[cnt2]>usTemp)	/* Move items down to make room */
      {
	 pcp->Array[cnt2+1]=pcp->Array[cnt2];
	 cnt2--;
	 if(cnt2<0)
	    break;
      }
      pcp->Array[cnt2+1] = usTemp;		     /* Insert the item */
   }
   return;
}

/****************************************************************\
 * Function name: BatcherSort()
 *
 * Parameters:	pcp is a struct which contains the continue flag,
 *		a pointer to the data array, and a count of the items in
 *		the data array.
 *		None of the other pcp members are used.
 *
 * Returns: VOID
 *
 * Purpose:  This routine is a stub that calls the recursive Batcher sort
 *	     with the proper initial arguments.
 *
 * Usage:  It passes the pcp, the size of the array to be sorted,
 *		    the offset to start sorting at(0), the number number
 *		    of elements each item is from neighboring elements (1),
 *		    and Half flag to sort the halves (1=YES).
\****************************************************************/
VOID BatcherSort(PCALCPARAM pcp)
{
   BatcherSortR(pcp,pcp->cArray,0,1,1);
   return;
}

/****************************************************************\
 * Function name: BatcherSortR()
 *
 * Parameters:	pcp is a struct which contains the continue flag,
 *		a pointer to the data array.
 *		None of the other pcp members are used.
 *		usArrSize is the number of elements in the current sort set.
 *		usStart is the offset to the 1st element in the set.
 *		usSkip is the spacing between consecutive elements.
 *		fHalves sorts the 2 halves when set, otherwise skips the
 *			1st 2 of the 4 sub-sorts.
 *
 * Returns: VOID
 *
 * Purpose:  Implements Batcher sort which is O(n lg n).  The advantage
 *	     of the batcher sort is that the comparisons made do NOT
 *	     depend upon the outcome of previous comparisons.  This makes
 *	     it a good algorithm for parallelism.  The algorithm works as
 *	     follows:  Sort the first half, sort the second half, sort the
 *	     odd elements, sort the even elements, then compare swap
 *	     elements 2/3, 4/5, ...
 *
 * Usage  :  There are several adaptations to the algorithm to
 *		    allow it to work with arbitrary sized data sets
 *		    (the original required a power of 2 sized data
 *		    set):  if the set size is less than 2, the routine
 *		    returns, the first "half" is always the largest
 *		    possible power of two, and the top value for the
 *		    final compare/swap is adjusted to round up in
 *		    case of an odd data set.
 *		    Another optimization is that involving the fHalves
 *		    flag.  This stems from the observation that when
 *		    the odd/even sort recurses, the first and second
 *		    halves are already sorted, thus the first 2
 *		    recursive calls are unnecessary in this case.
 *
\****************************************************************/
VOID BatcherSortR(PCALCPARAM pcp, ULONG usArrSize, ULONG usStart,
		  ULONG usSkip, BOOL fHalves)
{
   USHORT cnt,usUpper,usTemp; /* Utility variables */

   if(!pcp->fContinueCalc) /* User wishes to terminate the sort */
      return;

   if(usArrSize<2) /* No sorting needed if <2 items in the set */
      return;

   if(usArrSize==2) /* Do simple compare/swap if there are 2 elements */
   {
      if(pcp->Array[usStart]>pcp->Array[usStart+usSkip])
      {
	 usTemp = pcp->Array[usStart];
	 pcp->Array[usStart] = pcp->Array[usStart+usSkip];
	 pcp->Array[usStart+usSkip]= usTemp;
      }
      return;
   }

   usTemp=1;		      /* usTemp ends up holding the smallest power */
   while(usTemp < usArrSize)  /* of 2 that is at least as big as usArrSize */
      usTemp *= 2;

   if(fHalves)	/* If the sort was NOT called by the odd/even recurses */
   {
      BatcherSortR(pcp,(ULONG)(usTemp/2),usStart,usSkip,(BOOL)1);    /* Sort 1st half */
      BatcherSortR(pcp,(ULONG)(usArrSize-usTemp/2),	  /* Sort 2nd half */
		   (ULONG)(usStart+usTemp/2*usSkip),usSkip,(BOOL)1);
   }
   BatcherSortR(pcp,(ULONG)(usArrSize-usArrSize/2),usStart,(ULONG)(usSkip*2),(BOOL)0); /* Sort evens */
   BatcherSortR(pcp,(ULONG)(usArrSize/2),(ULONG)(usStart+usSkip),(ULONG)(usSkip*2),(BOOL)0);	/* Sort odds  */

   if(!pcp->fContinueCalc) /* User wishes to terminate the sort */
      return;

   usUpper=(ULONG)(usStart+usSkip+(usArrSize-usArrSize/2-1)*2*usSkip);
   for(cnt=usStart+usSkip;cnt<usUpper;cnt+=usSkip*2) /* Do final compares */
   {
      if(pcp->Array[cnt]>pcp->Array[cnt+usSkip])
      {
	 usTemp = pcp->Array[cnt];
	 pcp->Array[cnt] = pcp->Array[cnt+usSkip];
	 pcp->Array[cnt+usSkip]= usTemp;
      }
      if(!pcp->fContinueCalc) /* User wishes to terminate the sort */
	 return;
   }
   return;
}


/****************************************************************\
 * Function name: QuickSort()
 *
 * Parameters:	pcp is a struct which contains the continue flag,
 *		a pointer to the data array, and a count of the items in
 *		the data array.
 *		None of the other pcp members are used.
 *
 * Returns: VOID
 *
 * Purpose:  This routine is a stub that calls the recursive Quick sort
 *	     with the proper initial arguments.
 *
 * Usage  :  It passes the pcp (Which contains the array ptr),
 *		    the offset to start sorting at(0), and the offset to
 *		    finish sorting at (Array size-1).
 *
\****************************************************************/
VOID QuickSort(PCALCPARAM pcp)
{
   QuickSortR(pcp,0,(pcp->cArray-1));
   return;
}


/****************************************************************\
 * Function name: QuickSortR()
 *
 * Parameters:	pcp is a struct which contains the continue flag,
 *		a pointer to the data array.
 *		None of the other pcp members are used.
 *		sLeft is the offset of the leftmost sort element (smallest).
 *		sRight is the offset of rightmost sort element (largest).
 *
 * Returns: VOID
 *
 * Purpose:  Implements Quick sort which is O(n lg n).	Quick sort is a
 *	     good all-purpose sorting algorithm and is widely used.  This
 *	     implementation works by placing the first element in the list
 *	     into its correct place, by moving all elements smaller to its
 *	     left, and all numbers larger to its right.	 The Quick sort
 *	     recurses on the smaller side of the properly placed element,
 *	     and loops back through the same routine for the larger side.
 *
 *	     NOTE: This routine does not recurse on both sides of the
 *		   partition element.  It only recurses on the smaller
 *		   of the two sides.  This was done in order to eliminate
 *		   the stack overrun when it tries to sort an already
 *		   sorted list.
 *
 * Usage:
 *
\****************************************************************/
VOID QuickSortR(PCALCPARAM pcp, LONG sLeft, LONG sRight)
{
   SHORT sTempLeft  = sLeft;	/* Holds lower bound on split position	    */
   SHORT sTempRight = sRight;	/* Holds upper bound on split position	    */
   SHORT sSplit;		/* Used to hold offset of positioned elem   */
   USHORT usTemp;		/* Holds temp element during positioning    */

   while(TRUE)
   {
      if(sLeft >= sRight)	   /* If there is <=1 element, return */
	 return;

      if(!pcp->fContinueCalc)	   /* User wishes to terminate the sort */
	 return;

      /* Split list, sSplit will contain the split element */
      usTemp = pcp->Array[sTempLeft];

      while(TRUE)    /* Loop thru 2 cases until the split position is found */
      {
	 while(pcp->Array[sTempRight] > usTemp && /* Skip elems on right side  */
			   sTempRight > sLeft)	  /* that are > the split elem */
	    sTempRight--;

	 if(sTempRight<=sTempLeft)  /* Left and Right have met, split is found */
	 {
	    pcp->Array[sTempLeft]=usTemp;  /* Place split elem at proper place */
	    sSplit = sTempLeft;
	    break;
	 }
	 pcp->Array[sTempLeft++] =
		       pcp->Array[sTempRight];	  /* Move small element to LHS */

	 while(pcp->Array[sTempLeft] < usTemp &&  /* Skip elems on left side   */
			   sTempLeft < sRight)	  /* that are < the split elem */
	    sTempLeft++;

	 if(sTempRight<=sTempLeft)  /* Left and Right have met, split is found */
	 {
	    pcp->Array[sTempRight]=usTemp; /* Place split elem at proper place */
	    sSplit = sTempRight;
	    break;
	 }
	 pcp->Array[sTempRight--] =
		       pcp->Array[sTempLeft];	  /* Move large element to RHS */
      }

      if ((sSplit - sLeft) > (sRight - sSplit)) {
	 /* left half is larger than right half */
	 QuickSortR(pcp, sSplit+1, sRight);   /* Sort the 2nd half of the list */
	 if(!pcp->fContinueCalc)	    /* User wishes to terminate sort */
	   return;
	 sTempLeft = sLeft;		    /* Set up to sort the 1st half */
	 sTempRight = sRight = sSplit - 1;
      }
      else {
	 /* right half is larger than left half */
	 QuickSortR(pcp, sLeft, sSplit-1);    /* Sort the 1st half of the list */
	 if(!pcp->fContinueCalc)	    /* User wishes to terminate sort */
	   return;
	 sTempRight = sRight;		    /* Set up to sort the 2nd half */
	 sTempLeft = sLeft = sSplit + 1;
      }
   }
   return;
}

/****************************************************************\
 * Function name: EnableMenuItem()
 *
 * Parameters:	hwnd is a handle of the current window.
 *		sMenuItem is the ID of the item to Enable/Disable.
 *		fEnable will enable item if TRUE, otherwise disables it.
 *
 * Returns: VOID
 *
 * Purpose: This routine handles enabling/disabling of menu items.  This
 *	    is done by getting Parent and Menu hwnd handles then sending
 *	    the appropriate message.
 *
 * Usage:
 *
\****************************************************************/
VOID EnableMenuItem(HWND hwnd, LONG sMenuItem, BOOL fEnable)
{
   HWND hwndParent = WinQueryWindow(hwnd, QW_PARENT);
   HWND hwndMenu   = WinWindowFromID(hwndParent, FID_MENU);

   WinSendMsg(hwndMenu, MM_SETITEMATTR,
	      MPFROM2SHORT(sMenuItem, TRUE),
	      MPFROM2SHORT(MIA_DISABLED, fEnable ? 0 : MIA_DISABLED));
   return;
}

/****************************************************************\
 * Function name: EntryFldDlgProc()
 *
 * Parameters:	hwnd, msg, mp1, mp2.  Standard PM Dialog Proc params.
 *		A pointer to the current set size is passed in WM_INITDLG.
 *
 * Returns: Terminates with a TRUE iff a new valid data set size is entered.
 *
 * Purpose: Handles all the messages associated with the set entry field
 *	    and calls the appropriate handling procedures.  The purpose
 *	    of this dialog box is to get a new data set size for the
 *	    sort routines.
 *
 *
 * Usage  : If the value entered is valid, the proc will set the
 *		   variable passed in through the WM_INITDLG to the value.
\****************************************************************/
MRESULT EXPENTRY EntryFldDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   SHORT   sNewSize=0;				      /* Holds new set set */
   static  SHORT *pcSetSize;  /* Set to point to user-passed set size */
   MRESULT sRC;

   switch(msg)
   {
      case WM_INITDLG:
	 FixSysMenu(hwnd);
	 pcSetSize=PVOIDFROMMP(mp2);
	 WinSendDlgItemMsg(hwnd, IDD_ENTRYFLD,EM_SETTEXTLIMIT,	/* Limit len */
				 MPFROM2SHORT(4,0),NULL);
	 WinSetDlgItemShort(hwnd, IDD_ENTRYFLD,
			      *pcSetSize,TRUE);
	 return (MRESULT)0L;			       /* Allow normal focus setting */

      case WM_COMMAND:
	 switch(SHORT1FROMMP(mp1))
	 {
	    case DID_OK:
	       WinQueryDlgItemShort(hwnd, IDD_ENTRYFLD,
				    &sNewSize, TRUE); /* Get the short	    */
	       if(sNewSize>0 && sNewSize<=MAX_ELEMS)  /* Set new data set size */
	       {
		  *pcSetSize =	sNewSize;
		  WinDismissDlg(hwnd,TRUE);
	       }
	       else				      /* Invalid value	    */
	       {
		  MessageBox(hwnd, IDMSG_ERRORSIZE,
				     MB_OK | MB_ERROR, TRUE);
		  return (MRESULT)FALSE;
	       }
	       return (MRESULT)0L;

	    case DID_CANCEL:
	       WinDismissDlg(hwnd,FALSE);
	       return (MRESULT)0L;

	    default:
	       sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
	       return sRC;
	 }
	 break;

      default:
	 sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
	 return sRC;
   }
   return (MRESULT)0L;
}

/****************************************************************\
 * Function name: AboutDlgProc()
 *
 * Parameters:	hwnd, msg, mp1, mp2.  Standard PM Dialog Proc params.
 *
 * Returns:
 *
 * Purpose: Handles all the messages associated with the About dialog.
 *
 * Usage:
 *
\****************************************************************/
MRESULT EXPENTRY AboutDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   MRESULT sRC;

   switch(msg)
   {
      case WM_INITDLG:
	 FixSysMenu(hwnd);
	 return (MRESULT)0L;

      case WM_COMMAND:
	 WinDismissDlg(hwnd, TRUE);
	 return (MRESULT)0L;

      default:
	 sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
	 return sRC;
   }
   return (MRESULT)0L;
}

/****************************************************************\
 * Function name: RandomizeData()
 *
 * Parameters:	cSetSize is the current size of the data set
 *
 * Returns: VOID
 *
 * Purpose: This routine randomizes the data arrays.
 *
 * Usage  : This routine assumes that LISTCNT and NELEMS define
 *		   the dimensions of the global Data array which is
 *		   randomized.
\****************************************************************/
VOID RandomizeData(ULONG cSetSize)
{
   USHORT cnt,cnt2;
   for(cnt=0;cnt<LISTCNT;cnt++)
   {
      for(cnt2=0;cnt2<cSetSize;cnt2++)
	 Data[cnt][cnt2] = rand();
   }
   return;
}

/****************************************************************\
 * Function name: FixSysMenu()
 *
 * Parameters:	hwndDlg - handle to calling dialog
 *
 * Returns: VOID
 *
 * Purpose: This routine removes the Restore, Size, Minimize, and
 *	    Maximize options from the system menu of a dialog.
 *
 * Usage  : Called during the WM_INITDLG of a dialog procedure.
 *
\****************************************************************/
VOID FixSysMenu(HWND hwndDlg)
{
   HWND hwndMenu;				    /* handle to system menu */

   hwndMenu = WinWindowFromID(hwndDlg, FID_SYSMENU);

   WinSendMsg(hwndMenu,		      /* delete Restore from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_RESTORE, TRUE),
	      MPFROMP(NULL));

   WinSendMsg(hwndMenu,			 /* delete Size from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_SIZE, TRUE),
	      MPFROMP(NULL));

   WinSendMsg(hwndMenu,		     /* delete Minimize from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_MINIMIZE, TRUE),
	      MPFROMP(NULL));

   WinSendMsg(hwndMenu,		     /* delete Maximize from the system menu */
	      MM_DELETEITEM,
	      MPFROM2SHORT(SC_MAXIMIZE, TRUE),
	      MPFROMP(NULL));
   return;
}

/****************************************************************\
 *  Routine for initializing the help manager
 *--------------------------------------------------------------
 *
 *  Name:    InitHelp()
 *
 *  Purpose: Initializes the IPF help facility
 *
 *  Usage:   Called once during initialization of the program
 *
 *  Method:  Initializes the HELPINIT structure and creates the help
 *	     instance. If successful, the help instance is associated
 *	     with the main window
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID InitHelp(VOID)
{
   HELPINIT hini;

    /* If we return because of an error, Help will be disabled */
   fHelpEnabled = FALSE;
			     /* Initialize help init structure */
   hini.cb = sizeof(HELPINIT);
   hini.ulReturnCode = 0;
			   /* If tutorial added, add name here */
   hini.pszTutorialName = (PSZ)NULL;

   hini.phtHelpTable = (PHELPTABLE)MAKELONG(SORT_HELP_TABLE, 0xFFFF);
   hini.hmodHelpTableModule = 0;
   hini.hmodAccelActionBarModule = 0;
   hini.idAccelTable = 0;
   hini.idActionBar = 0;

   if(!WinLoadString(hab,
		     0,
		     IDS_HELPWINDOWTITLE,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szWindowTitle))
   {
       MessageBox(hwndClient, IDMSG_CANNOTLOADSTRING,
			     MB_OK | MB_ERROR, FALSE);
       return;
   }
   hini.pszHelpWindowTitle = (PSZ)szWindowTitle;

		    /* If debugging, show panel ids, else don't */
#ifdef DEBUG
   hini.fShowPanelId = CMIC_SHOW_PANEL_ID;
#else
   hini.fShowPanelId = CMIC_HIDE_PANEL_ID;
#endif

   if(!WinLoadString(hab,
		     0,
		     IDS_HELPLIBRARYNAME,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szLibName))
   {
       MessageBox(hwndClient, IDMSG_CANNOTLOADSTRING,
			     MB_OK | MB_ERROR, FALSE);
       return;
   }
   hini.pszHelpLibraryName = (PSZ)szLibName;
				     /* Creating help instance */
   hwndHelpInstance = WinCreateHelpInstance(hab, &hini);

   if(hwndHelpInstance == 0 || hini.ulReturnCode)
   {
       MessageBox(hwndFrame, IDMSG_HELPLOADERROR, MB_OK | MB_ERROR, TRUE);
       return;
   }
		    /* Associate help instance with main frame */
   if(!WinAssociateHelpInstance(hwndHelpInstance, hwndFrame))
   {
       MessageBox(hwndFrame, IDMSG_HELPLOADERROR,
				 MB_OK | MB_ERROR, TRUE);
       return;
   }
/* Help manager is successfully initialized so set flag to TRUE */
   fHelpEnabled = TRUE;
   return;
}						  /* InitHelp() */

/****************************************************************\
 *  Processes the Help for Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpHelpForHelp(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Help for
 *	     Help item of the Help menu
 *
 *  Usage:   Called from MainCommand when the Help for Help menu item
 *	     is selected
 *
 *  Method:  Sends an HM_DISPLAY_HELP message to the help instance so
 *	     that the default Help For Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpHelpForHelp(MPARAM mp2)
{
	   /* This just displays the system help for help panel */
   if(fHelpEnabled)
       if(WinSendMsg(hwndHelpInstance, HM_DISPLAY_HELP, NULL, NULL))
	   MessageBox(hwndClient,
		      IDMSG_HELPDISPLAYERROR,
		      MB_OK | MB_ERROR,
		      FALSE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'
   \*  warning at compile time.					   */
   return;
}					   /* HelpHelpForHelp() */

/****************************************************************\
 *  Processes the Extended Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpExtended(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Extended
 *	     Help item of the Help menu.
 *
 *  Usage:   Called from MainCommand when the Extended Help menu item
 *	     is selected.
 *
 *  Method:  Sends an HM_EXT_HELP message to the help instance so that
 *	     the default Extended Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpExtended(MPARAM mp2)
{
	   /* This just displays the system extended help panel */
   if(fHelpEnabled)
       if(WinSendMsg(hwndHelpInstance, HM_EXT_HELP, NULL, NULL))
	   MessageBox(hwndClient,
		      IDMSG_HELPDISPLAYERROR,
		      MB_OK | MB_ERROR,
		      FALSE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'
   \*  warning at compile time.					   */
   return;
}					      /* HelpExtended() */

/****************************************************************\
 *  Processes the Keys Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpKeys(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Keys Help
 *	     item of the Help menu.
 *
 *  Usage:   Called from MainCommand when the Keys Help menu item is
 *	     selected
 *
 *  Method:  Sends an HM_KEYS_HELP message to the help instance so that
 *	     the default Keys Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpKeys(MPARAM mp2)
{
	       /* This just displays the system keys help panel */
   if(fHelpEnabled)
       if(WinSendMsg(hwndHelpInstance, HM_KEYS_HELP, NULL, NULL))
	   MessageBox(hwndClient,
		      IDMSG_HELPDISPLAYERROR,
		      MB_OK | MB_ERROR,
		      FALSE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'
   \*  warning at compile time.					   */
   return;
}						  /* HelpKeys() */

/****************************************************************\
 *  Processes the Index Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpIndex(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Index Help
 *	     item of the Help menu
 *
 *  Usage:   Called from MainCommand when the Index Help menu item
 *	     is selected
 *
 *  Method:  Sends an HM_INDEX_HELP message to the help instance so
 *	     that the default Index Help is displayed.
 *
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpIndex(MPARAM mp2)
{
	      /* This just displays the system help index panel */
   if(fHelpEnabled)
       if(WinSendMsg(hwndHelpInstance, HM_HELP_INDEX, NULL, NULL))
	   MessageBox(hwndClient,
		      IDMSG_HELPDISPLAYERROR,
		      MB_OK | MB_ERROR,
		      FALSE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'
   \*  warning at compile time.					   */
   return;
}						 /* HelpIndex() */

/****************************************************************\
 *  Processes the About command from the Help menu
 *--------------------------------------------------------------
 *
 *  Name:    HelpAbout(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the About item
 *	     of the Help menu
 *
 *  Usage:   Called from MainCommand when the About menu item is selected
 *
 *  Method:  Calls WinDlgBox to display the about box dialog.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpAbout(MPARAM mp2)
{
				 /* Display the AboutBox dialog */
   WinDlgBox(HWND_DESKTOP,
		hwndClient,
		AboutDlgProc,
		(HMODULE)0,
		IDD_PRODUCTINFO,
		NULL);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'
   \*  warning at compile time.					   */
   return;
}						 /* HelpAbout() */

/****************************************************************\
 *  Displays the help panel indicated
 *--------------------------------------------------------------
 *
 *  Name:    DisplayHelpPanel(idPanel)
 *
 *  Purpose: Displays the help panel whose id is given
 *
 *  Usage:   Called whenever a help panel is desired to be displayed,
 *	     usually from the WM_HELP processing of the dialog boxes
 *
 *  Method:  Sends HM_DISPLAY_HELP message to the help instance
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID DisplayHelpPanel(LONG idPanel)
{
   if(fHelpEnabled)
       if(WinSendMsg(hwndHelpInstance,
		     HM_DISPLAY_HELP,
		     MPFROMLONG(MAKELONG(idPanel, NULL)),
		     MPFROMSHORT(HM_RESOURCEID)))

	   MessageBox(hwndFrame,
		      IDMSG_HELPDISPLAYERROR,
		      MB_OK | MB_ERROR,
		      TRUE);
   return;
}					  /* DisplayHelpPanel() */

/****************************************************************\
 *  Destroys the help instance
 *--------------------------------------------------------------
 *
 *  Name:    DestroyHelpInstance(VOID)
 *
 *  Purpose: Destroys the help instance for the application
 *
 *  Usage:   Called after exit from message loop
 *
 *  Method:  Calls WinDestroyHelpInstance() to destroy the help instance
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID DestroyHelpInstance(VOID)
{
   if(hwndHelpInstance != 0)
   {
       WinDestroyHelpInstance(hwndHelpInstance);
   }
   return;
}				       /* DestroyHelpInstance() */

/****************************************************************\
 *  Message Box procedure
 *--------------------------------------------------------------
 *
 *  Name:    MessageBox(hwndOwner, nIdMsg, fsStyle, fBeep)
 *
 *  Purpose: Displays the message box with the message given in idMsg
 *	     retrieved from the message table and using the style
 *	     flags in fsStyle
 *
 *  Usage:   Called whenever a MessageBox is to be displayed
 *
 *  Method:  - Message string is loaded from the process' message table
 *	     - Alarm beep is sounded if desired
 *	     - Message box with the message is displayed
 *	     - WinMessageBox return value is returned
 *
 *  Returns: Return value from WinMessageBox()
 *
\****************************************************************/
LONG MessageBox(HWND hwndOwner, LONG idMsg, LONG fsStyle, BOOL fBeep)
{
    CHAR szText[MESSAGELEN];
    LONG sRC;

    if(!WinLoadMessage(hab,
		      (HMODULE)NULL,
		      idMsg,
		      MESSAGELEN,
		      (PSZ)szText))
    {
	WinAlarm(HWND_DESKTOP, WA_ERROR);
	return RETURN_ERROR;
    }

    if(fBeep)
	WinAlarm(HWND_DESKTOP, WA_ERROR);

    sRC = WinMessageBox(HWND_DESKTOP,
			hwndOwner,
			szText,
			(PSZ)NULL,
			IDD_MSGBOX,
			fsStyle);
    return sRC;
}				       /* MessageBox() */
/*************************************************************************
*
*  File Name   : STY_DLG.C
*
*  Description : This module contains the Dialog Procedures for the user
*		 defined dialogs as well as any support code they need.
*
*  Concepts    : Dialog procedures for user defined dialogs,
*		 initialization of controls in the dialog boxs,
*		 use of presentation parameters.
*
*  API's       :  DosAllocMem             WinQueryFocus
*		  DosFreeMem		  WinQueryPointerPos
*		  GpiQueryFonts		  WinQueryPresParams
*		  WinCreateWindow	  WinQueryWindowText
*		  WinDefDlgProc		  WinQueryWindowUShort
*		  WinDismissDlg		  WinReleasePS
*		  WinGetPS		  WinRemovePresParams
*		  WinLoadMenu		  WinSendDlgItemMsg
*		  WinLoadPointer	  WinSendMsg
*		  WinLoadString		  WinSetDlgItemText
*		  WinMapWindowPoints	  WinSetPresParams
*		  WinPopupMenu		  WinWindowFromID
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.						      *
************************************************************************/

/*  Include files, macros, defined constants, and externs	       */

#define INCL_WINWINDOWMGR
#define INCL_WINFRAMEMGR
#define INCL_WINPOINTERS
#define INCL_WININPUT
#define INCL_WINLISTBOXES
#define INCL_WINENTRYFIELDS
#define INCL_WINSTDSPIN
#define INCL_WINSTDBOOK
#define INCL_WINMLE
#define INCL_WINMENUS
#define INCL_WINSTATICS
#define INCL_WINSTDCNR
#define INCL_WINSTDSLIDER
#define INCL_WINSTDVALSET
#define INCL_WINDIALOGS
#define INCL_WINSYS
#define INCL_GPILCIDS
#define INCL_GPIBITMAPS
#define INCL_DOSMEMMGR

#include <os2.h>
#include <string.h>
#include <stdlib.h>
#include "sty_main.h"
#include "sty_dlg.h"
#include "sty_xtrn.h"
#include "sty_help.h"

typedef struct _USERRECORD
{
  RECORDCORE  recordCore;
  CDATE	      date;
  CTIME	      time;
  PSZ	      recordData;
} USERRECORD, *PUSERRECORD;

#define COLORNAMELEN	20
#define NUMCOLORS	15  /* number of colors used in PP Demo */
#define NUMSPINCOLORS	16  /* number of colors used in SPIN Demo */
#define NUMFONTS	 4  /* number of fonts used in PP Demo */
#define FONTPOINTSIZE	80  /* point size to use in PP Demo */
#define PPFONTPOINTSIZE	 2		/* length of font point prefix */

/*  Global variables						       */
					/* array of clr names	       */
static CHAR apszPresParamColor[NUMCOLORS][COLORNAMELEN];
static PSZ *apszPresParamFont = NULL;
static LONG lNumFonts;
static CNRINFO cnrinfo;
static ULONG ulCnrAttributes;
static RECORDINSERT recordInsert;
static PUSERRECORD pUserRecord;
static PFIELDINFO pFieldInfo, firstFieldInfo;
static FIELDINFOINSERT fieldInfoInsert;
static PFIELDINFOINSERT pFieldInfoInsert;
static CHAR pszViewText[] = "Text for Text View.";
static CHAR pszViewIcon[] = "Text for Icon View.";
static CHAR pszViewName[] = "Text for Name View.";
static CHAR pszColumnText1[]= "Data";
static CHAR pszColumnText2[]= "Date";
static CHAR pszColumnText3[]= "Time";
static CHAR pszSampleData[] = "Sample Data";
static CHAR pszCnrTitle[] = "Sample Container";

/*
 * Set up an array of colors in the same order as the stringtable
 * constants
 */
static ULONG aulColor[NUMCOLORS-1] =
	      { CLR_BLUE, CLR_RED, CLR_PINK, CLR_GREEN, CLR_CYAN,
		CLR_YELLOW, CLR_DARKGRAY, CLR_DARKBLUE, CLR_DARKRED,
		CLR_DARKPINK, CLR_DARKGREEN, CLR_DARKCYAN, CLR_BROWN,
		CLR_PALEGRAY };

/*  Entry point declarations					       */

MRESULT EXPENTRY ProdInfoDlgProc(HWND hwnd, USHORT msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY DemoDlgProc(HWND hwnd, USHORT msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY PresParamDemoDlgProc(HWND hwnd, USHORT msg, MPARAM mp1,
				      MPARAM mp2);
BOOL InitializeValueSet(HWND hwnd);
BOOL InitializeSpinButton(HWND hwnd);
BOOL InitializeSlider(HWND hwnd);
BOOL InitializeNoteBook(HWND hwnd);
BOOL InitializeContainer(HWND hwnd);
BOOL LoadListBox(HWND hwnd);
BOOL InitPresParamDemoDlg(HWND hwnd);
BOOL UpdatePresParamDemoDlg(HWND hwnd);
VOID ShowDlgHelp(HWND hwnd);
VOID SetSysMenu(HWND hwnd);


/*********************************************************************
 *  Name : ProdInfoDlgProc
 *
 *  Description : Processes all messages sent to the Product
 *		  Information dialog box.
 *
 *  Concepts : Called for each message sent to the Product
 *	       Information dialog box.	The Product
 *	       Information box only has a button control so
 *	       this routine only processes WM_COMMAND
 *	       messages.  Any WM_COMMAND posted must have come
 *	       from the Ok button so we dismiss the dialog
 *	       upon receiving it.
 *
 *  API's : WinDismissDlg
 *	    WinDefDlgProc
 *
 * Parameters	: hwnd - Window handle to which message is addressed
 *		  msg - Message type
 *		  mp1 - First message parameter
 *		  mp2 - Second message parameter
 *
 *  Returns : Dependent upon message sent
 *
 ****************************************************************/
MRESULT EXPENTRY ProdInfoDlgProc( HWND hwnd, USHORT msg, MPARAM mp1,
				  MPARAM mp2)
{
   switch(msg)
   {
      case WM_COMMAND:
	 /*
	  * No matter what the command, close the dialog
	  */
	 WinDismissDlg(hwnd, TRUE);
	 break;

      case WM_HELP:
	 ShowDlgHelp(hwnd);
	 break;

      default:
	 return(WinDefDlgProc(hwnd, msg, mp1, mp2));
	 break;
   }
   return (MRESULT)0;
}	    /* End of ProdInfolDlgProc()			       */


/*********************************************************************
 *  Name : DemoDlgProc
 *
 *  Description : Processes all messages sent to all Demo dialogs.
 *
 *  Concepts : Called for each message sent to a demo dialog box.
 *	       A switch statement branches to the routines to be
 *	       performed for each message processed.  Any messages
 *	       not specifically process are passed to the default
 *	       window procedure WinDefDlgProc().
 *
 *  API's : WinDismissDlg
 *	    WinLoadMenu
 *	    WinQueryPointerPos
 *	    WinMapWindowPoints
 *	    WinPopupMenu
 *	    WinSendDlgItemMsg
 *	    WinSetDlgItemText
 *	    WinDefDlgProc
 *
 * Parameters	: hwnd - Window handle to which message is addressed
 *		  msg - Message type
 *		  mp1 - First message parameter
 *		  mp2 - Second message parameter
 *
 *  Returns : Dependent upon message sent
 *
 ****************************************************************/
MRESULT EXPENTRY DemoDlgProc( HWND hwnd, USHORT msg, MPARAM mp1,
			      MPARAM mp2)
{
   CHAR	     acBuffer[4];
   CHAR	     *cData;
   PSHORT    psIdDlg;

   cnrinfo.pszCnrTitle = pszCnrTitle;
   ulCnrAttributes = CA_CONTAINERTITLE | CA_TITLESEPARATOR;

   switch(msg)
   {
      case WM_INITDLG:

	 SetSysMenu(hwnd);
	 psIdDlg = (PSHORT) mp2;

	 switch(*psIdDlg)
	 {
	/*
	 * The ShowDemoDlg() filled mp2 with a pointer to the id of
	 * the dialog template used to create the dialog box.
	 */
	    case IDD_LISTBOXDLG:
	    /*
	     * Load some text into the list boxes.  If any of the
	     * LoadListBox() routines fail, abort the dialog
	     */
	       if (!LoadListBox(WinWindowFromID(hwnd, IDC_LISTBOX)) ||
		   !LoadListBox(WinWindowFromID(hwnd, IDC_MULTISELLISTBOX)))
	       {
		  WinDismissDlg(hwnd, FALSE);
	       }
	       break;

	    case IDD_COMBOBOXDLG:
	    /*
	     * Load some text into the combo boxes.  If any of the
	     * LoadListBox() routines fail, abort the dialog
	     */
	       if (!LoadListBox(WinWindowFromID(hwnd, IDC_SIMPLE)) ||
		   !LoadListBox(WinWindowFromID(hwnd, IDC_DROPDOWN)) ||
		   !LoadListBox(WinWindowFromID(hwnd, IDC_DROPDOWNLIST)))
	       {
		  WinDismissDlg(hwnd, FALSE);
	       }
	       break;

	    case IDD_SPINBUTTONDLG:
	    /*
	     * Initialize the master and servant Spinbuttons.
	     * If the initialization routine fails, abort
	     * the dialog
	     */
	       if (!InitializeSpinButton(hwnd))
	       {
		  WinDismissDlg(hwnd, FALSE);
	       }
	       break;

	    case IDD_VALUESETDLG:
	    /*
	     * Initialize the Valueset control.
	     * If the initialization routine fails, abort
	     * the dialog
	     */
	       if (!InitializeValueSet(hwnd))
	       {
		  WinDismissDlg(hwnd, FALSE);
	       }
	       break;

	    case IDD_CONTAINERDLG:
	    /*
	     * Initialize the Container control.
	     * If the initialization routine fails, abort
	     * the dialog
	     */
	       cnrinfo.flWindowAttr = CV_ICON | ulCnrAttributes;
	       if (!InitializeContainer(hwnd))
	       {
		  WinDismissDlg(hwnd, FALSE);
	       }
	       break;

	    case IDD_NOTEBOOKDLG:
	    /*
	     * Initialize the Notebook control.
	     * If the initialization routine fails, abort
	     * the dialog
	     */
	       if (!InitializeNoteBook(hwnd))
	       {
		  WinDismissDlg(hwnd, FALSE);
	       }
	       break;

	    case IDD_SLIDERDLG:
	    /*
	     * Initialize the Slider control.
	     * If the initialization routine fails, abort
	     * the dialog
	     */
	       if (!InitializeSlider(hwnd))
	       {
		  WinDismissDlg(hwnd, FALSE);
	       }
	       break;

	    default:
	       break;
	 }
	 break;

      case WM_CONTROL:
	 /*
	  * Process the WM_CONTROL messages for the slider and valueset
	  * set controls.
	  */
	 switch(SHORT2FROMMP(mp1))
	 {
	    case CN_CONTEXTMENU:
	    {
	       POINTL point;
	       HWND hwndMenu;
	       HWND hwndContainer;
	       /*
		* If we receive a EN_CONTEXTMENU MESSAGE and if the
		* current dialog if the container dialog, display a
		* popup menu that allows the user to change the
		* container view.
		*/
		hwndContainer = WinWindowFromID(hwnd,IDC_CONTAINER);

		hwndMenu = WinLoadMenu(hwnd, 0, IDD_CONTAINERMENU);
		WinQueryPointerPos(HWND_DESKTOP, &point);
		WinMapWindowPoints(HWND_DESKTOP,hwndContainer,&point,1);

		WinPopupMenu(hwndContainer, hwnd, hwndMenu,
			     point.x, point.y,
			     IDM_ICON, PU_NONE | PU_SELECTITEM |
			     PU_MOUSEBUTTON1 | PU_MOUSEBUTTON2 | PU_KEYBOARD);
	       break;
	    }
	    case SLN_CHANGE:
	    {
	       LONG ulValue;

	       if (SHORT1FROMMP(mp1) == IDC_HSLIDER)
	       {
		  ulValue = (ULONG) WinSendDlgItemMsg(hwnd, IDC_HSLIDER,
		     SLM_QUERYSLIDERINFO,
		     MPFROM2SHORT(SMA_SLIDERARMPOSITION,SMA_INCREMENTVALUE),
		     NULL);
		  cData = ltoa(ulValue,acBuffer,10);
		  WinSetDlgItemText(hwnd,IDC_HSLIDERDATA, cData);
	       }
	       else
	       {
		  ulValue = (ULONG) WinSendDlgItemMsg(hwnd, IDC_VSLIDER,
		     SLM_QUERYSLIDERINFO,
		     MPFROM2SHORT(SMA_SLIDERARMPOSITION,SMA_INCREMENTVALUE),
		     NULL);
		  cData = ltoa(ulValue,acBuffer,10);
		  WinSetDlgItemText(hwnd,IDC_VSLIDERDATA, cData);
	       }
	       break;
	    }
	    case VN_SELECT:
	    case VN_ENTER:
	    {
	       CHAR  pszNotificationTxt[256];
	       CHAR  pszTmp[5];
	       ULONG ulRowCol;

	       ulRowCol = (ULONG)WinSendDlgItemMsg(hwnd, IDC_VALUESET,
		  VM_QUERYSELECTEDITEM, NULL, NULL);

	       if ((SHORT2FROMMP(mp1)) == VN_SELECT)
		  strcpy (pszNotificationTxt, "VN_SELECT for item at row ");
	       else
		  strcpy (pszNotificationTxt, "VN_ENTER for item at row ");

	       itoa(SHORT1FROMMP(ulRowCol), pszTmp, 10);
	       strcat (pszNotificationTxt, pszTmp);
	       strcat (pszNotificationTxt, ",Column ");
	       itoa(SHORT2FROMMP(ulRowCol), pszTmp, 10);
	       strcat (pszNotificationTxt, pszTmp);
	       WinSetDlgItemText(hwnd,IDC_VALUESETTEXT, pszNotificationTxt);
	       break;
	    }
	 }
	 break;
      case WM_COMMAND:
	 switch( SHORT1FROMMP( mp1 ) )	   /* Extract the command value	   */
	 {
	    /*
	     * Process the command messages from the container popup menu
	     */
	    case IDM_ICON:
	       cnrinfo.flWindowAttr = CV_ICON | ulCnrAttributes;
	       WinSendDlgItemMsg(hwnd,IDC_CONTAINER,CM_SETCNRINFO,&cnrinfo,
			      MPFROMLONG(CMA_FLWINDOWATTR));
	       break;

	    case IDM_NAME:
	       cnrinfo.flWindowAttr = CV_NAME | ulCnrAttributes;
	       WinSendDlgItemMsg(hwnd,IDC_CONTAINER,CM_SETCNRINFO,&cnrinfo,
			     MPFROMLONG(CMA_FLWINDOWATTR));
	       break;

	    case IDM_TEXT:
	       cnrinfo.flWindowAttr = CV_TEXT | ulCnrAttributes;
	       WinSendDlgItemMsg(hwnd,IDC_CONTAINER,CM_SETCNRINFO,&cnrinfo,
				MPFROMLONG(CMA_FLWINDOWATTR));
	       break;

	    case IDM_DETAIL:
	       cnrinfo.flWindowAttr = CV_DETAIL | ulCnrAttributes |
		  CA_DETAILSVIEWTITLES;

	       WinSendDlgItemMsg(hwnd,IDC_CONTAINER,CM_SETCNRINFO,&cnrinfo,
				MPFROMLONG(CMA_FLWINDOWATTR));

	       WinSendDlgItemMsg(hwnd,IDC_CONTAINER,
				 CM_INVALIDATEDETAILFIELDINFO,	    /*@@@RBS*/
				 NULL, NULL);

	       break;

	    case DID_OK:
	    case DID_CANCEL:	      /* The Cancel pushbutton or Escape key */
	       WinDismissDlg( hwnd, TRUE );	/* Removes the dialog box    */
	       return (MRESULT)FALSE;

	    default:
	       break;
	 }
	 break;

      case WM_HELP:
	 ShowDlgHelp(hwnd);
	 break;

      default:
	 return(WinDefDlgProc(hwnd, msg, mp1, mp2));
	 break;
   }
   return (MRESULT)0;
}					     /* End of DemoDlgProc()	    */

/*********************************************************************
 *  Name : LoadListBox
 *
 *  Description : Loads the demo list box with 0 through 9
 *
 *
 *  Concepts : Called each time a demo list box is
 *	       initialized.  A for 0 to 9 loop is converts
 *	       the INT to a string which is added to the
 *	       listbox via LM_INSERTITEM
 *
 *  API's : WinLoadString
 *	    WinSendMsg
 *
 *  Parameters : hwnd - Window handle of the list box.
 *
 *  Returns: TRUE if list box is loaded successfully, FALSE otherwise
 *
 ****************************************************************/
BOOL LoadListBox(HWND hwnd)
{
   ULONG ulCounter;
   CHAR pszTemp[MESSAGELEN];
   SHORT sResult;

   for(ulCounter = 0; ulCounter < 10; ulCounter++)
   {
      if (!WinLoadString(hab, (HMODULE)0, (IDS_LISTBOX1 + ulCounter),
			MESSAGELEN, (PSZ)pszTemp))
      {
	 MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
	 return FALSE;
      }
      sResult = (SHORT) WinSendMsg(hwnd, LM_INSERTITEM,
			       MPFROMSHORT(LIT_SORTASCENDING),
			       MPFROMP((PSZ)pszTemp));

      if (sResult == LIT_ERROR || sResult == LIT_MEMERROR)
      {
	 MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);

	 return FALSE;
      }
    }
    return TRUE;

}					   /*	 End of LoadListBox()	    */


/*********************************************************************
 *  Name : PresParamDemoDlgProc
 *
 *  Description : Processes all messages sent to the PresParamDemo
 *		  dialog.
 *
 *  Concepts : Called for each message sent to the PresParamDemo
 *	       dialog box.  A switch statement branches to the
 *	       routines to be performed for each message
 *	       processed.  Any messages not specifically process
 *	       are passed to the default window procedure
 *	       WinDefDlgProc().
 *
 *  API's : WinDismissDlg
 *	    WinDefDlgProc
 *
 *  Parameters	 : hwnd - Window handle to which message is addressed
 *		   msg - Message type
 *		   mp1 - First message parameter
 *		   mp2 - Second message parameter
 *
 *  Returns: Dependent upon message sent
 *
 ****************************************************************/
MRESULT EXPENTRY PresParamDemoDlgProc( HWND hwnd, USHORT msg,
				       MPARAM mp1, MPARAM mp2)
{
   switch(msg)
   {
      case WM_INITDLG:
	 /*
	  * If initialization fails, abort the dialog
	  */
	 if (!InitPresParamDemoDlg(hwnd))
	     WinDismissDlg(hwnd, FALSE);
	 return (MRESULT)FALSE;
	 break;

      case WM_COMMAND:
	 switch(SHORT1FROMMP(mp1))
	 {
	    case IDC_CANCEL:
	    /*
	     * If done, close the dialog
	     */
	       WinDismissDlg(hwnd, TRUE);
	       break;

	    case IDC_APPLY:
	    /*
	     * Update the dialog box
	     */
	       UpdatePresParamDemoDlg(hwnd);
	       break;

	    default:
	       break;
	 }
	 break;

      case WM_HELP:
	 ShowDlgHelp(hwnd);
	 break;

      default:
	 return(WinDefDlgProc(hwnd, msg, mp1, mp2));
	 break;
   }
   return (MRESULT)0;
}				       /* End of PresParamDemoDlgProc() */

/*********************************************************************
 *  Name : InitPresParamDemoDlg
 *
 *  Description : Places the colors and fonts into the
 *		  PresParamDemoDlg's comboboxes.
 *
 *  Concepts : Called when the PP demo dialog is initialized.
 *	       LM_INSERTITEM is sent to each combobox for the
 *	       color or font string added to the combobox.
 *
 *  API's : WinLoadString
 *	    WinWindowFromID
 *	    WinSendMsg
 *	    GpiQueryFonts
 *	    WinGetPS
 *	    WinReleasePS
 *	    DosAllocMem
 *	    DosFreeMem
 *
 *  Parameters : hwnd - Window handle of the dialog
 *
 *  Returns: TRUE if initialization is successfull, FALSE if not
 *
 ****************************************************************/
BOOL InitPresParamDemoDlg(HWND hwnd)
{
   HWND hwndTemp;
   ULONG ulCounter;
   MRESULT mresult;
   PFONTMETRICS pfm, pfmSave;
   LONG lTemp, lFonts;
   HPS hps;
   PSZ *ppszT;
   BOOL bHaveFont;

   /*
    * Load the color table
    */
   for (ulCounter = 0; ulCounter < NUMCOLORS; ulCounter++)
   {
      if (!WinLoadString(hab, (HMODULE)0, (ulCounter + IDS_FIRSTCOLOR),
	     COLORNAMELEN, (PSZ)apszPresParamColor[ulCounter]))
      {
	 MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
	 return FALSE;
      }
   }
   /*
    * Load foreground color combo box
    */
   hwndTemp = WinWindowFromID(hwnd, IDC_FORECOLORLIST);

   for(ulCounter = 0; ulCounter < NUMCOLORS; ulCounter++)
   {
      mresult = WinSendMsg(hwndTemp, LM_INSERTITEM,
			  MPFROMSHORT(LIT_SORTASCENDING),
			  MPFROMP((PSZ)apszPresParamColor[ulCounter]));

      if (((SHORT)mresult) == LIT_ERROR || ((SHORT)mresult) == LIT_MEMERROR)
      {
	 MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR,
	      FALSE);
	 return FALSE;
      }
   }

   /*
   * Load background color combo box
   */
   hwndTemp = WinWindowFromID(hwnd, IDC_BACKCOLORLIST);

   for(ulCounter = 0; ulCounter < NUMCOLORS; ulCounter++)
   {
      mresult = WinSendMsg(hwndTemp, LM_INSERTITEM,
			    MPFROMSHORT(LIT_SORTASCENDING),
			    MPFROMP((PSZ)apszPresParamColor[ulCounter]));

       if (((SHORT)mresult) == LIT_ERROR || ((SHORT)mresult) == LIT_MEMERROR)
       {
	  MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR,
		FALSE);
	  return FALSE;
       }
   }
   /*
    * Fonts.  Find all of the fonts of point size desired and normal
    * weight.  Put the facenames in the combo box
    */
   hwndTemp = WinWindowFromID(hwnd, IDC_FONTLIST);
   hps = WinGetPS(hwndTemp);

   /*
    * Determine the number of fonts available
    */
   lFonts = 0;
   lTemp = 0;
   lFonts = GpiQueryFonts(hps, QF_PUBLIC, NULL, &lTemp,
		  (ULONG)sizeof(FONTMETRICS), (PFONTMETRICS)NULL);

   if (lFonts == GPI_ALTERROR)
   {
       MessageBox(hwndMain, IDMSG_CANNOTLOADFONTS, MB_OK | MB_ERROR, FALSE);
       WinReleasePS(hps);
       return FALSE;
   }

   /*
    * Allocate buffer for fontmetric structures
    */
   if (DosAllocMem((PPVOID)&pfm, lFonts * (ULONG)sizeof(FONTMETRICS),
	   fALLOC))
   {
      MessageBox(hwndMain, IDMSG_CANNOTALLOCATEMEMORY, MB_OK | MB_ERROR,
	    FALSE);
      WinReleasePS(hps);
      return FALSE;
   }
   pfmSave = pfm;

   /*
    * Get all fonts
    */
   lTemp = GpiQueryFonts(hps, QF_PUBLIC, NULL, &lFonts,
		(ULONG)sizeof(FONTMETRICS), (PFONTMETRICS)pfm);

   WinReleasePS(hps);

   if (lTemp == GPI_ALTERROR)
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADFONTS, MB_OK | MB_ERROR, FALSE);
      return FALSE;
   }

   /*
    * Allocate buffer for array of string names, freeing the first
    * buffer if necessary
    */
   if ((BOOL)apszPresParamFont)
   {
      ppszT = apszPresParamFont;
      while ((BOOL)*ppszT)
      {
	 DosFreeMem(*ppszT++);
      }

      DosFreeMem(apszPresParamFont);
   }

   if (DosAllocMem((PPVOID)&apszPresParamFont,
	  (lFonts + 1) * (ULONG)sizeof(PSZ), fALLOC))
   {
      MessageBox(hwndMain, IDMSG_CANNOTALLOCATEMEMORY, MB_OK | MB_ERROR,
	   FALSE);
      DosFreeMem((PVOID)pfmSave);
      apszPresParamFont = NULL;
      return FALSE;
   }

   /*
    * Initialize array to NULL
    */
   lTemp = 0;
   ppszT = apszPresParamFont;
   while (lTemp++ < lFonts)
       *ppszT++ = (PSZ)NULL;
   *ppszT = (PSZ)NULL;


   /*
    * Walk through all fonts.  If the font matches the point size
    * desired and has a weight and width class of normal (5) and
    * no special attributes (e. g. italic, underline, etc.).  If
    * it does, then add its string to the combo box
    */
   lNumFonts = 0;
   ppszT = apszPresParamFont;

   while (lFonts--)
   {
      if (pfm->sNominalPointSize == FONTPOINTSIZE &&
	     pfm->usWeightClass == 5 && pfm->usWidthClass == 5 &&
	     pfm->fsSelection == 0)
      {
      /*
       * Make sure we don't have this font.  If we don't,
       * then add the font to the list
       */
	 lTemp = 0;
	 bHaveFont = FALSE;
	 while (lTemp < lNumFonts)
	 {
	    if (!strcmp(pfm->szFacename, apszPresParamFont[(INT)lTemp]))
	    {
	       bHaveFont = TRUE;
	       break;
	    }
	    else
	       lTemp++;
	 }

	 if (!bHaveFont)
	 {
	    if (DosAllocMem((PPVOID)ppszT,
		(LONG)(FACESIZE * sizeof(CHAR)), fALLOC))
	    {
	       MessageBox(hwndMain, IDMSG_CANNOTALLOCATEMEMORY,
		  MB_OK | MB_ERROR, FALSE);
	       DosFreeMem((PVOID)pfmSave);
	       return FALSE;
	     }

	     strcpy(*ppszT++, pfm->szFacename);
	     lNumFonts++;
	 }
      }
      pfm++;
   }

   /*
    * Install the name of each font into the combo box
    */
   ppszT = apszPresParamFont;
   while ((BOOL)*ppszT)
   {
      mresult = WinSendMsg(hwndTemp, LM_INSERTITEM,
		 MPFROMSHORT(LIT_SORTASCENDING), MPFROMP((PSZ)*ppszT++));

      if (((SHORT)mresult) == LIT_ERROR || ((SHORT)mresult) == LIT_MEMERROR)
      {
	 MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR,
	      FALSE);
	 DosFreeMem((PVOID)pfmSave);
	 return FALSE;
      }
   }

   /*
    * Add "DefaulTemp" text onto the end
    */
   mresult = WinSendMsg(hwndTemp, LM_INSERTITEM,
	     MPFROMSHORT(LIT_SORTASCENDING),
	     MPFROMP(apszPresParamColor[IDS_DEFAULT - IDS_FIRSTCOLOR]));

   if (((SHORT)mresult) == LIT_ERROR || ((SHORT)mresult) == LIT_MEMERROR)
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
      DosFreeMem((PVOID)pfmSave);
      return FALSE;
   }
   DosFreeMem((PVOID)pfmSave);
   return TRUE;
}				       /* End of InitPresParamDemoDlg()	  */

/*********************************************************************
 *  Name : UpdatePresParamDemoDlg
 *
 *  Description : Sets/Removes the Presentation Parameter of the sample
 *		  text window depending upon the parameters chosen,
 *
 *  Concepts : Called when user wants to update the window.  The string
 *	       of each combobox is queried and then the color or font
 *	       is set depending upon the string chosen.
 *
 *  API's : WinWindowFromID
 *	    WinQueryWindowText
 *	    WinSendMsg
 *	    WinSetPresParams
 *	    WinQueryPresParams
 *	    WinRemovePresParams
 *
 *  Parameters : hwnd - Handle of Presentation Params dialog
 *
 *  Returns: TRUE if update is successfull, FALSE if not
 *
 ****************************************************************/
BOOL UpdatePresParamDemoDlg(HWND hwnd)
{
   HWND hwndTemp, hwndSampleText, hwndSampleButton;
   CHAR pszTemp[COLORNAMELEN];
   BYTE abBuf[FACESIZE + PPFONTPOINTSIZE];
   ULONG ulColor, ulPresParams;
   SHORT sCounter;

   /*
    * Get window handle of the sample text box
    */
   hwndSampleText = WinWindowFromID(hwnd, IDC_SAMPLETEXT);
   hwndSampleButton = WinWindowFromID(hwnd, IDC_CHECKBOX);

   /*
    * Get the text of the foreground color combobox
   */
   hwndTemp = WinWindowFromID(hwnd, IDC_FORECOLORLIST);

   if (WinQueryWindowText(hwndTemp, COLORNAMELEN, (PSZ)pszTemp))
   {
   /*
    * Find the text in the list of color names
    */
      sCounter = 0;
      while (sCounter < NUMCOLORS)
      {
	 if (!strcmp(pszTemp, apszPresParamColor[sCounter]))
	 {
	    ulColor = aulColor[sCounter];
	    break;
	 }
	 else
	    sCounter++;
      }

      /*
       * If color is not default, set the color.  If the default is
       * selected, then remove the color presentation parameter if
       * it exists.  If the value is not a valid color, then don't
       * don't do anything
       */
       if (sCounter < NUMCOLORS)
       {
	  sCounter += IDS_FIRSTCOLOR;
	  if (sCounter < IDS_DEFAULT)
	  {
	     if (!WinSetPresParam(hwndSampleText, PP_FOREGROUNDCOLORINDEX,
		   (ULONG)sizeof(LONG), (PVOID)&ulColor) ||
		   !WinSetPresParam(hwndSampleButton,
		   PP_FOREGROUNDCOLORINDEX, (ULONG)sizeof(LONG),
		   (PVOID)&ulColor))
	     {
		MessageBox(hwndMain, IDMSG_CANNOTSETPP, MB_OK | MB_ERROR, FALSE);
	     }
	  }
	  else
	  {
	  /*
	   * If setting presentation parameter to the default, remove
	   * the presentation parameter, but only if it has been
	   * set
	   */
	      if (sCounter == IDS_DEFAULT &&
		   WinQueryPresParam(hwndSampleText, PP_FOREGROUNDCOLORINDEX,
		   0, &ulPresParams, (ULONG)sizeof(LONG), (PVOID)&ulColor,
		   QPF_NOINHERIT) != 0)
	      {
		 if (!WinRemovePresParam(hwndSampleText,
		     PP_FOREGROUNDCOLORINDEX) ||
		     !WinRemovePresParam(hwndSampleButton,
		     PP_FOREGROUNDCOLORINDEX))
		 {
		    MessageBox(hwndMain, IDMSG_CANNOTSETPP, MB_OK | MB_ERROR,
			 FALSE);
		 }
	      }
	  }
       }
   }

   /*
    * Do the same for the background color combobox
    */
   hwndTemp = WinWindowFromID(hwnd, IDC_BACKCOLORLIST);
   if (WinQueryWindowText(hwndTemp, COLORNAMELEN, (PSZ)pszTemp))
   {
   /*
    * Find the text in the list of color names
   */
      sCounter = 0;
      while (sCounter < NUMCOLORS)
      {
	 if (!strcmp(pszTemp, apszPresParamColor[sCounter]))
	 {
	    ulColor = aulColor[sCounter];
	    break;
	 }
	 else
	    sCounter++;
      }

      /*
       * If color is not default, set the color.  If the default is
       * selected, then remove the color presentation parameter.  If
       * the value is not a valid color, the don't do anything
       */
       if (sCounter < NUMCOLORS)
       {
	  sCounter += IDS_FIRSTCOLOR;
	  if (sCounter < IDS_DEFAULT)
	  {
	     if (!WinSetPresParam(hwndSampleText, PP_BACKGROUNDCOLORINDEX,
		 (ULONG)sizeof(LONG), (PVOID)&ulColor) ||
		 !WinSetPresParam(hwndSampleButton, PP_BACKGROUNDCOLORINDEX,
		 (ULONG)sizeof(LONG), (PVOID)&ulColor))
	     {
		MessageBox(hwndMain, IDMSG_CANNOTSETPP, MB_OK | MB_ERROR,
		      FALSE);
	     }
	  }
	  else
	  {
	     if (sCounter == IDS_DEFAULT &&
		  WinQueryPresParam(hwndSampleText,
		  PP_BACKGROUNDCOLORINDEX, 0, &ulPresParams, (ULONG)sizeof(LONG),
		  (PVOID)&ulColor, QPF_NOINHERIT) != 0)
	     {
		if (!WinRemovePresParam(hwndSampleText,
		    PP_BACKGROUNDCOLORINDEX) ||
		    !WinRemovePresParam(hwndSampleButton,
		    PP_BACKGROUNDCOLORINDEX))
		{
		   MessageBox(hwndMain, IDMSG_CANNOTSETPP, MB_OK | MB_ERROR,
			 FALSE);
		}
	     }
	  }
       }
   }

   /*
    * Get the text of the font combobox
    */
   hwndTemp = WinWindowFromID(hwnd, IDC_FONTLIST);
   if (WinQueryWindowText(hwndTemp, FACESIZE, (PSZ)pszTemp))
   {
   /*
    * If Font selected is "Default", remove font pres. param.
    */
      if (!strcmp(pszTemp, apszPresParamColor[IDS_DEFAULT - IDS_FIRSTCOLOR]))
      {
	 if (WinQueryPresParam(hwndSampleText, PP_FONTNAMESIZE, 0,
	      &ulPresParams, (ULONG)(FACESIZE + PPFONTPOINTSIZE), (PVOID)abBuf,
	      QPF_NOINHERIT) != 0)
	 {
	    if (!WinRemovePresParam(hwndSampleText, PP_FONTNAMESIZE) ||
		!WinRemovePresParam(hwndSampleButton, PP_FONTNAMESIZE))
	    {
	       MessageBox(hwndMain, IDMSG_CANNOTSETPP, MB_OK | MB_ERROR,
		    FALSE);
	    }
	 }
      }
      else
      {
      /*
       * Font is not default.
       * AbBuf will hold the font point size and name in
       * the form <pt>.<name>.	First we fill abBuf with the
       * font point prefix and then append the font name
       * retrieved from the combobox.
       */

	 if (!WinLoadString(hab, (HMODULE)0, IDS_PPFONTPOINT,
	      COLORNAMELEN, (PSZ)abBuf))
	 {
	    MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR,
		 FALSE);
	    return FALSE;
	 }
	 strcat((PSZ)abBuf, pszTemp);

	 if (!WinSetPresParam(hwndSampleText, PP_FONTNAMESIZE,
	     (ULONG)strlen((PSZ)abBuf) + 1, (PVOID)abBuf) ||
	     !WinSetPresParam(hwndSampleButton, PP_FONTNAMESIZE,
	     (ULONG)strlen((PSZ)abBuf) + 1, (PVOID)abBuf))
	 {
	    MessageBox(hwndMain, IDMSG_CANNOTSETPP, MB_OK | MB_ERROR,
		 FALSE);
	 }
      }
   }
   return TRUE;
}				      /* End of UpdatePresParamDemoDlg() */

/*********************************************************************
 *  Name : ShowDlgHelp
 *
 *  Description : Displays the help panel for the current selected
 *		  item in the dialog window
 *
 *  Concepts : Called each time a WM_HELP message is posted to a
 *	       dialog gets the id value of the window and determine
 *	       which help panel to display.  Then sends a message
 *	       to the help instance to display the panel.  If the
 *	       dialog or item is not included here, then the
 *	       unknown dialog or unknown item panel is displayed.
 *
 *  API's : WinQueryFocus
 *	    WinQueryWindowUShort
 *	    WinWindowFromID
 *
 *  Parameters : hwnd - Handle of the dialog box
 *
 *  Returns: Void
 *
 ****************************************************************/
VOID ShowDlgHelp(HWND hwnd)
{
   SHORT idPanel, idDlg, idItem;
   HWND hwndFocus;

   /*
   * Get the id of the dialog box
   */
   idDlg = WinQueryWindowUShort(hwnd, QWS_ID);

   /*
    * Finds which window has the focus and gets its id
    */
   hwndFocus = WinQueryFocus(HWND_DESKTOP);
   idItem = WinQueryWindowUShort(hwndFocus, QWS_ID);

   switch(idDlg)
   {
      case IDD_BUTTONSDLG:
	 switch(idItem)
	 {
	    case IDC_RADIO1:
	    case IDC_RADIO2:
	    case IDC_RADIO3:
	       idPanel = PANEL_BUTTONSDLG_RADIO;
	       break;

	    case IDC_CHECKBOX:
	       idPanel = PANEL_BUTTONSDLG_CHECKBOX;
	       break;

	    case IDC_3STATE:
	       idPanel = PANEL_BUTTONSDLG_THREESTATE;
	       break;

	    case IDC_PUSHBUTTON:
	       idPanel = PANEL_BUTTONSDLG_PUSHBUTTON;
	       break;

	    case IDC_OK:
	       idPanel = PANEL_BUTTONSDLG_OK;
	       break;

	    case IDC_HELP:
	       idPanel = PANEL_BUTTONSDLG_HELP;
	       break;

	    default:
	       idPanel = PANEL_UNKNOWN;
	       break;
	 }
	 break;

      case IDD_LISTBOXDLG:
	 switch(idItem)
	 {
	    case IDC_LISTBOX:
	       idPanel = PANEL_LISTBOXDLG_SINGLE;
	       break;

	    case IDC_MULTISELLISTBOX:
	       idPanel = PANEL_LISTBOXDLG_MULTIPLE;
	       break;

	    case IDC_OK:
	       idPanel = PANEL_LISTBOXDLG_OK;
	       break;

	    case IDC_HELP:
	       idPanel = PANEL_LISTBOXDLG_HELP;
	       break;

	    default:
	       idPanel = PANEL_UNKNOWN;
	       break;
	 }
	 break;

      case IDD_COMBOBOXDLG:
	 switch(idItem)
	 {
	    case IDC_SIMPLE:
	       idPanel = PANEL_COMBOBOXDLG_SIMPLE;
	       break;

	    case IDC_DROPDOWN:
	       idPanel = PANEL_COMBOBOXDLG_DROPDOWN;
	       break;

	    case IDC_DROPDOWNLIST:
	       idPanel = PANEL_COMBOBOXDLG_DROPDOWNLIST;
	       break;

	    case IDC_OK:
	       idPanel = PANEL_COMBOBOXDLG_OK;
	       break;

	    case IDC_HELP:
	       idPanel = PANEL_COMBOBOXDLG_HELP;
	       break;

	    default:
	       /*
		* Check to see if window that has the focus is the
		* entry field of the combobox.	If it is, then
		* call the appropriate combobox help panel.  If
		* not, then call the unknown panel
		*/
	       if (WinWindowFromID(WinWindowFromID(hwnd, IDC_SIMPLE),
		   CBID_EDIT) == hwndFocus)
	       {
		  idPanel = PANEL_COMBOBOXDLG_SIMPLE;
	       }
	       else
		  if (WinWindowFromID(WinWindowFromID(hwnd, IDC_DROPDOWN),
		     CBID_EDIT) == hwndFocus)
		  {
		       idPanel = PANEL_COMBOBOXDLG_DROPDOWN;
		  }
		  else
		       if (WinWindowFromID(
			   WinWindowFromID(hwnd, IDC_DROPDOWNLIST),
			   CBID_EDIT) == hwndFocus)
		       {
			  idPanel = PANEL_COMBOBOXDLG_DROPDOWNLIST;
		       }
		       else
			  idPanel = PANEL_UNKNOWN;
	      break;
	 }
	 break;

      case IDD_ENTRYFIELDDLG:
	 switch(idItem)
	 {
	    case IDC_ENTRY:
	       idPanel = PANEL_ENTRYFIELDDLG_ENTRY;
	       break;

	    case IDC_MLE:
	       idPanel = PANEL_ENTRYFIELDDLG_MLE;
	       break;

	    case IDC_OK:
	       idPanel = PANEL_ENTRYFIELDDLG_OK;
	       break;

	    case IDC_HELP:
	       idPanel = PANEL_ENTRYFIELDDLG_HELP;
	       break;

	    default:
	       idPanel = PANEL_UNKNOWN;
	       break;
	 }
	 break;

      case IDD_STATICDLG:
	 switch(idItem)
	 {
	    case IDC_OK:
	       idPanel = PANEL_STATICDLG_OK;
	       break;

	    case IDC_HELP:
	       idPanel = PANEL_STATICDLG_HELP;
	       break;

	    default:
	       idPanel = PANEL_UNKNOWN;
	       break;
	 }
	 break;

      case IDD_PPDEMODLG:
	 switch(idItem)
	 {
	    case IDC_FORECOLORLIST:
	       idPanel = PANEL_PPDEMODLG_FORECOLORLIST;
	       break;

	    case IDC_BACKCOLORLIST:
	       idPanel = PANEL_PPDEMODLG_BACKCOLORLIST;
	       break;

	    case IDC_FONTLIST:
	       idPanel = PANEL_PPDEMODLG_FONTLIST;
	       break;

	    case IDC_CHECKBOX:
	       idPanel = PANEL_PPDEMODLG_TESTBUTTON;
	       break;

	    case IDC_CANCEL:
	       idPanel = PANEL_PPDEMODLG_CANCEL;
	       break;

	    case IDC_APPLY:
	       idPanel = PANEL_PPDEMODLG_APPLY;
	       break;

	    case IDC_HELP:
	       idPanel = PANEL_PPDEMODLG_HELP;
	       break;

	    default:
	    /*
	     * Check to see if window that has the focus is the
	     * entry field of the combobox.  If it is, then
	     * call the appropriate combobox help panel.  If
	     * not, then call the unknown panel
	     */
	       if (WinWindowFromID(
		   WinWindowFromID(hwnd, IDC_FORECOLORLIST),
		   CBID_EDIT) == hwndFocus)
	       {
		  idPanel = PANEL_PPDEMODLG_FORECOLORLIST;
	       }
	       else
		  if (WinWindowFromID(
		      WinWindowFromID(hwnd, IDC_BACKCOLORLIST),
		      CBID_EDIT) == hwndFocus)
		  {
		     idPanel = PANEL_PPDEMODLG_BACKCOLORLIST;
		  }
		  else
		     if(WinWindowFromID(
			WinWindowFromID(hwnd, IDC_FONTLIST),
			CBID_EDIT) == hwndFocus)
		     {
			idPanel = PANEL_PPDEMODLG_FONTLIST;
		     }
		     else
			idPanel = PANEL_UNKNOWN;
	       break;
	 }
	 break;

      case IDD_CONTAINERDLG:
	 switch(idItem)
	 {
	    case IDC_CONTAINER:
	       idPanel = PANEL_CONTAINERDLG_CONTAINER;
	       break;

	    case IDC_OK:
	       idPanel = PANEL_CONTAINERDLG_OK;
	       break;

	    case IDC_CANCEL:
	       idPanel = PANEL_CONTAINERDLG_CANCEL;
	       break;

	    case IDC_HELP:
	       idPanel = PANEL_CONTAINERDLG_HELP;
	       break;

	    default:
	       idPanel = PANEL_UNKNOWN;
	       break;
	 }
	 break;
      case IDD_NOTEBOOKDLG:
	 switch(idItem)
	 {
	    case IDC_NOTEBOOK:
	       idPanel = PANEL_NOTEBOOKDLG_NOTEBOOK;
	       break;

	    case IDC_OK:
	       idPanel = PANEL_NOTEBOOKDLG_OK;
	       break;

	    case IDC_CANCEL:
	       idPanel = PANEL_NOTEBOOKDLG_CANCEL;
	       break;

	    case IDC_HELP:
	       idPanel = PANEL_NOTEBOOKDLG_HELP;
	       break;

	    default:
	       idPanel = PANEL_UNKNOWN;
	       break;
	}
	break;
      case IDD_SLIDERDLG:
	 switch(idItem)
	 {
	    case IDC_VSLIDER:
	       idPanel = PANEL_SLIDERDLG_VSLIDER;
	       break;

	    case IDC_HSLIDER:
	       idPanel = PANEL_SLIDERDLG_HSLIDER;
	       break;

	    case IDC_OK:
	       idPanel = PANEL_SLIDERDLG_OK;
	       break;

	    case IDC_CANCEL:
	       idPanel = PANEL_SLIDERDLG_CANCEL;
	       break;

	    case IDC_HELP:
	       idPanel = PANEL_SLIDERDLG_HELP;
	       break;

	    default:
	       idPanel = PANEL_UNKNOWN;
	       break;
	 }
	 break;
      case IDD_VALUESETDLG:
	 switch(idItem)
	 {
	    case IDC_VALUESET:
	       idPanel = PANEL_VALUESETDLG_VALUESET;
	       break;

	    case IDC_OK:
	       idPanel = PANEL_VALUESETDLG_OK;
	       break;

	    case IDC_CANCEL:
	       idPanel = PANEL_VALUESETDLG_CANCEL;
	       break;

	    case IDC_HELP:
	       idPanel = PANEL_VALUESETDLG_HELP;
	       break;

	    default:
	       idPanel = PANEL_UNKNOWN;
	       break;
	 }
	 break;
      case IDD_SPINBUTTONDLG:
	 switch(idItem)
	 {
	    case IDC_MASTER:
	       idPanel = PANEL_SPINBUTTONDLG_MASTER;
	       break;

	    case IDC_SERVANT:
	       idPanel = PANEL_SPINBUTTONDLG_SERVANT;
	       break;

	    case IDC_OK:
	       idPanel = PANEL_SPINBUTTONDLG_OK;
	       break;

	    case IDC_CANCEL:
	       idPanel = PANEL_SPINBUTTONDLG_CANCEL;
	       break;

	    case IDC_HELP:
	       idPanel = PANEL_SPINBUTTONDLG_HELP;
	       break;

	    default:
	       idPanel = PANEL_UNKNOWN;
	       break;
	 }
	 break;

      case IDD_PRODINFO:
	 idPanel = PANEL_ABOUTBOX;
	 break;

      default:
	 idPanel = PANEL_UNKNOWNDLG;
	 break;
   }
   DisplayHelpPanel(idPanel);
}					/* End of ShowDlgHelp()	       */

/*********************************************************************
 *  Name : InitializeValueSet
 *
 *  Description : Loads the demo Value Set with 4 different icons
 *		  and with 4 colors derived form the color index.
 *
 *  Concepts : Called each time a demo Value Set is initialized A
 *	       for 1 to 4 loop sets an Icon in each column of the
 *	       First row of the Value Set via a VM_SETITEM
 *	       message.	 The Second row is set to a color by
 *	       sending the VM_SETITEMATTR message.
 *
 *  API's : WinSendDlgItemMsg
 *
 *  Parameters : hwnd - Handle of the Valueset dialog.
 *
 *  Returns: TRUE if Value Set is loaded successfully, FALSE otherwise
 *
 ****************************************************************/
BOOL InitializeValueSet(HWND hwnd)
{
   USHORT usIndex;
   for (usIndex = 1; usIndex <= 4;usIndex++)
   {
     if ( !WinSendDlgItemMsg(hwnd, IDC_VALUESET, VM_SETITEM,
	   MPFROM2SHORT(1,usIndex),
	   MPFROMLONG( WinLoadPointer(HWND_DESKTOP, 0,
	   (IDR_MAIN + usIndex)))))
	 return FALSE;

     if ( !WinSendDlgItemMsg( hwnd,IDC_VALUESET, VM_SETITEMATTR,
	  MPFROM2SHORT(2,usIndex),
	  MPFROM2SHORT( VIA_COLORINDEX, TRUE )))
	return FALSE;

     if ( !WinSendDlgItemMsg(hwnd, IDC_VALUESET, VM_SETITEM,
	  MPFROM2SHORT(2,usIndex),
	  MPFROMSHORT(usIndex)))
	return FALSE;
   }
   return TRUE;
}					/* End of InitializeValueset	*/
/*********************************************************************
 *  Name : InitializeSlider
 *
 *  Description :  Set the Sliders Tick size and Scale Text.
 *
 *  Concepts : Called each time a demo Slider controls ar initialized
 *	       Ses the he initail value of the sliders output display
 *	       to 0. A for 0 to 10 for loop sets the ruler text and
 *	       tick size for both the Horizontal and Vertical Sliders
 *	       via SLM_SETSCALETEXT and SLM_SETTICKSIZE message.
 *
 *  API's : WinSendDlgItemMsg
 *
 *  Parameters : hwnd - Handle of the Slider dialog.
 *
 *  Returns: TRUE if Sliders are initialized successfully, FALSE otherwise
 *
 *******************************************************************/
BOOL InitializeSlider(HWND hwnd)
{
   USHORT usIndex;
   CHAR	  acBuffer[4];
   CHAR	  *cData;


   cData = ltoa(0,acBuffer,10);
   WinSetDlgItemText(hwnd,IDC_HSLIDERDATA, cData);
   WinSetDlgItemText(hwnd,IDC_VSLIDERDATA, cData);
   for (usIndex = 0;usIndex < 10 ;usIndex ++ )
   {
      itoa(usIndex,acBuffer,10);
      if ( !WinSendDlgItemMsg(hwnd, IDC_HSLIDER, SLM_SETTICKSIZE,
	       MPFROM2SHORT(usIndex, 5), NULL))
	return FALSE;

      if ( !WinSendDlgItemMsg(hwnd, IDC_HSLIDER, SLM_SETSCALETEXT,
	       MPFROMSHORT(usIndex), MPFROMP(acBuffer)))
	return FALSE;

      if ( !WinSendDlgItemMsg(hwnd, IDC_VSLIDER, SLM_SETTICKSIZE,
	       MPFROM2SHORT(usIndex, 5), NULL))
	return FALSE;

      if ( !WinSendDlgItemMsg(hwnd, IDC_VSLIDER, SLM_SETSCALETEXT,
		 MPFROMSHORT(usIndex), MPFROMP(acBuffer)))
	return FALSE;
   }
   return TRUE;
}					/* End of InitializeSlider	*/

/*********************************************************************
 *  Name : InitializeSpinButton
 *
 *  Description : Set the intital values for the spin button controls.
 *
 *  Concepts : Sends a SPBM_SETARRAY to the Master Spin Button to set
 *	       the values (text strings) available to the control.
 *	       Sets the initial value to the array index of 0 by
 *	       sending a SPBM_SETCURRENTVALUE.	The Servant Spin Button
 *	       is initialized to the range 0 to 100 by sending a
 *	       SPBM_SETLIMITS message.	Sends a SPBM_SETMASTER message
 *	       to set the MASTER/SERVANT relationship between the two
 *	       spin buttons.
 *
 *  API's : WinSendDlgItemMsg
 *	    WinWindowFromID
 *
 *  Parameters : hwnd - Handle of the Spinnbutton dialog.
 *
 *  Returns: TRUE if Spinbuttons are initialized successfully, FALSE otherwise
 *
 ****************************************************************/
BOOL InitializeSpinButton(HWND hwnd)
{
   static PSZ	spinColors[] = {"White", "Black", "Blue", "Red"," Pink",
		     "Green", "Cyan", "Yellow", "Dark Grey", "Dark Blue",
		     "Dark Red", "Dark Pink", "Dark Green", "Dark Cyan",
		     "Brown", "Pale Grey"};

   if ( !WinSendDlgItemMsg( hwnd, IDC_MASTER, SPBM_SETARRAY, spinColors,
	     MPFROMLONG(NUMSPINCOLORS)))
      return FALSE;

   if ( !WinSendDlgItemMsg( hwnd, IDC_MASTER, SPBM_SETCURRENTVALUE,
	     MPFROMLONG(0), NULL))
      return FALSE;

   if ( !WinSendDlgItemMsg( hwnd, IDC_SERVANT, SPBM_SETLIMITS,
	     MPFROMLONG(100), MPFROMLONG(0)))
      return FALSE;

   if ( !WinSendDlgItemMsg( hwnd, IDC_SERVANT, SPBM_SETCURRENTVALUE,
	     MPFROMLONG(0), NULL))
      return FALSE;

   if (!WinSendDlgItemMsg(
	   hwnd,
	   IDC_SERVANT,
	   SPBM_SETMASTER,
	   MPFROMHWND( WinWindowFromID(hwnd, IDC_MASTER)),
	   MPVOID)
      )
      return FALSE;
   return TRUE;
}					/* End of InitializeSpinbutton	*/

/*********************************************************************
 *  Name : InitializeNotebook
 *
 *  Description : Set the intital pages for a notebook control.
 *
 *  Concepts : Called each time a demo NoteBook Control is
 *	       initialized Sends a BKM_INSERTPAGE message to the
 *	       notebook control to insert the first page into the
 *	       control.	 Sets the status line text for the first page
 *	       by sending a BKM_SETSTATUSLINETEXT message.  Creates a
 *	       window containing a bitmap and associates the whidow
 *	       with the notebook by sending a BKM_SETPAGEWINDOWHWND
 *	       message.	 Repeats these steps with the execption of
 *	       createing a MLE for use in the second notebook page.
 *
 *  API's : WinSendDlgItemMsg
 *	    WinCreateWindow
 *	    WinSendMsg
 *
 *  Parameters :  hwnd - Handle of the Notebook dialog
 *
 *  Returns: TRUE if The NoteBook is initialized successfully, FALSE otherwise
 *
 ****************************************************************/
BOOL InitializeNoteBook(HWND hwnd)
{
   HWND hwndPage;
   ULONG ulPageId;
   ULONG ipt = 0;
   CHAR pszMleBuffer[512];
   PSZ	 pszNoteBookText =
   {"Applications written for the Presentation Manager have full\
    access to the complete set of user interface tools: menus,\
    icons, scroll bars, etc., and often present a WYSIWYG\
    (what-you-see-is-what-you-get) view of their data.\
    Presentation Manager programs often make extensive use\
    of a mouse and display, and they have access to all the\
    32-bit features of version 2.0."};

   /*
    * Insert the first page.
    */
   ulPageId = (LONG)WinSendDlgItemMsg(hwnd, IDC_NOTEBOOK,
	BKM_INSERTPAGE, NULL,
	MPFROM2SHORT((BKA_STATUSTEXTON | BKA_AUTOPAGESIZE | BKA_MAJOR),
	BKA_LAST));

   if ( !ulPageId)
     return FALSE;

   if ( !WinSendDlgItemMsg(hwnd, IDC_NOTEBOOK,
	BKM_SETSTATUSLINETEXT, MPFROMLONG(ulPageId),
	MPFROMP("Page 1 of 2")))
     return FALSE;

   if ( !WinSendDlgItemMsg(hwnd, IDC_NOTEBOOK,
	BKM_SETTABTEXT, MPFROMLONG(ulPageId),
	MPFROMP("~1")))
     return FALSE;

   hwndPage =
   WinCreateWindow(		  /* parent-window handle		     */
      hwnd,			  /* pointer to registered class name	     */
      WC_STATIC,		  /* pointer to window text		     */
      "#6",			  /* window style			     */
      WS_VISIBLE | SS_BITMAP,	  /* horizontal position of window	     */
      0,			  /* vertical position of window	     */
      0,			  /* window width			     */
      0,			  /* window height			     */
      0,			  /* owner-window handle		     */
      NULLHANDLE,		  /* handle to sibling window		     */
      HWND_TOP,			  /* window identifier			     */
      0,			  /* pointer to buffer			     */
      NULL,			  /* pointer to structure with pres. params. */
      NULL);

   if (!hwndPage)
     return FALSE;

   if ( !WinSendDlgItemMsg(hwnd, IDC_NOTEBOOK,
	 BKM_SETPAGEWINDOWHWND, MPFROMLONG(ulPageId),
	 MPFROMHWND(hwndPage)))
     return FALSE;

   /*
    * Insert the second page.
    */
    ulPageId = (LONG)WinSendDlgItemMsg(hwnd, IDC_NOTEBOOK,
	 BKM_INSERTPAGE, NULL,
	 MPFROM2SHORT((BKA_STATUSTEXTON | BKA_AUTOPAGESIZE | BKA_MAJOR),
	 BKA_LAST));

   if (!ulPageId)
     return FALSE;

   if ( !WinSendDlgItemMsg(hwnd, IDC_NOTEBOOK,
	 BKM_SETSTATUSLINETEXT, MPFROMLONG(ulPageId),
	 MPFROMP("Page 2 of 2")))
     return FALSE;

   if ( !WinSendDlgItemMsg(hwnd, IDC_NOTEBOOK,
	BKM_SETTABTEXT, MPFROMLONG(ulPageId),
	MPFROMP("~2")))
     return FALSE;

   hwndPage =
   WinCreateWindow(
      hwnd,			  /* parent-window handle		     */
      WC_MLE,			  /* pointer to registered class name	     */
      NULL,			  /* pointer to window text		     */
      WS_VISIBLE | MLS_WORDWRAP | /* window style			     */
	 MLS_READONLY,
      0,			  /* horizontal position of window	     */
      0,			  /* vertical position of window	     */
      0,			  /* window width			     */
      0,			  /* window height			     */
      NULLHANDLE,		  /* owner-window handle		     */
      HWND_TOP,			  /* handle to sibling window		     */
      0,			  /* window identifier			     */
      NULL,			  /* pointer to buffer			     */
      NULL);			  /* pointer to structure with pres. params. */

   if (!hwndPage)
     return FALSE;

   if ( !WinSendMsg(hwndPage, MLM_SETIMPORTEXPORT,
	 MPFROMP(pszMleBuffer),
	 MPFROMSHORT(sizeof(pszMleBuffer))))
     return FALSE;

     memset(pszMleBuffer,'\0',sizeof(pszMleBuffer));
     strcpy(pszMleBuffer, pszNoteBookText);

   if ( !WinSendMsg(hwndPage, MLM_IMPORT, &ipt,
	 MPFROMSHORT(sizeof(pszMleBuffer))))
     return FALSE;

   if( !WinSendDlgItemMsg(hwnd, IDC_NOTEBOOK,
	 BKM_SETPAGEWINDOWHWND, MPFROMLONG(ulPageId),
	 MPFROMHWND(hwndPage)))
     return FALSE;

   return TRUE;
}					/* End of InitializeNotebook	*/

/*********************************************************************
 *  Name : InitializeContainer
 *
 *  Description : Initialize and insert a record into the container.
 *
 *
 *  Concepts : Called each time a demo Container Control is initialized.
 *	       Allocates and inserts a user record into a container.
 *	       Allocates and inserst  details view information.
 *	       Sets the containers info.
 *
 *  API's : WinLoadPointer
 *	    WinSendDlgItemMsg
 *
 *  Parameters : hwnd - Handle of the container dialog.
 *
 *  Returns: TRUE if The Container is initialized successfully, FALSE otherwise
 *
 ****************************************************************/
BOOL InitializeContainer(HWND hwnd)
{

  USHORT	    nRecords = 1;
  HPOINTER	    hptr;
  ULONG		    cbRecordData;

  hptr = WinLoadPointer(HWND_DESKTOP, 0, IDR_MAIN);

  cbRecordData = (LONG) (sizeof(USERRECORD) - sizeof(RECORDCORE));
  pUserRecord = WinSendDlgItemMsg(hwnd,IDC_CONTAINER,
		   CM_ALLOCRECORD, MPFROMLONG(cbRecordData) ,
		   MPFROMSHORT(nRecords));

  pUserRecord->recordCore.cb = sizeof(RECORDCORE);		/*RBS*/
  pUserRecord->recordCore.pszText = pszViewText;
  pUserRecord->recordCore.pszIcon = pszViewIcon;
  pUserRecord->recordCore.pszName = pszViewName;
  pUserRecord->recordCore.hptrIcon = hptr;

  pUserRecord->date.day = 11;
  pUserRecord->date.month = 11;
  pUserRecord->date.year = 11;
  pUserRecord->time.seconds    = 12;
  pUserRecord->time.minutes    = 12;
  pUserRecord->time.hours      = 12;
  pUserRecord->recordData = (PSZ)pszSampleData;

  recordInsert.cb = sizeof(RECORDINSERT);		    /*RBS*/
  recordInsert.pRecordParent= NULL;
  recordInsert.pRecordOrder = (PRECORDCORE)CMA_END;
  recordInsert.zOrder = CMA_TOP;
  recordInsert.cRecordsInsert = 1;
  recordInsert.fInvalidateRecord = TRUE;

  WinSendDlgItemMsg(hwnd,IDC_CONTAINER, CM_INSERTRECORD,
		   (PRECORDCORE)pUserRecord, &recordInsert);

  pFieldInfo = WinSendDlgItemMsg(hwnd, IDC_CONTAINER,
			CM_ALLOCDETAILFIELDINFO,MPFROMLONG(3), NULL);

  firstFieldInfo = pFieldInfo;

  pFieldInfo->cb = sizeof(FIELDINFO);			    /*RBS*/
  pFieldInfo->flData = CFA_STRING | CFA_HORZSEPARATOR | CFA_CENTER |
			 CFA_SEPARATOR;
  pFieldInfo->flTitle = CFA_CENTER;
  pFieldInfo->pTitleData = (PVOID) pszColumnText1;
  pFieldInfo->offStruct = FIELDOFFSET(USERRECORD,recordData);
  pFieldInfo = pFieldInfo->pNextFieldInfo;

  pFieldInfo->cb = sizeof(FIELDINFO);			    /*RBS*/
  pFieldInfo->flData = CFA_DATE | CFA_HORZSEPARATOR | CFA_CENTER |
			 CFA_SEPARATOR;
  pFieldInfo->flTitle = CFA_CENTER;
  pFieldInfo->pTitleData =  (PVOID) pszColumnText2;
  pFieldInfo->offStruct = FIELDOFFSET(USERRECORD,date);
  pFieldInfo = pFieldInfo->pNextFieldInfo;

  pFieldInfo->cb = sizeof(FIELDINFO);			    /*RBS*/
  pFieldInfo->flData = CFA_TIME | CFA_HORZSEPARATOR | CFA_CENTER |
			 CFA_SEPARATOR;
  pFieldInfo->flTitle = CFA_CENTER;
  pFieldInfo->pTitleData = (PVOID) pszColumnText3;
  pFieldInfo->offStruct = FIELDOFFSET(USERRECORD,time);


  fieldInfoInsert.cb = (ULONG)(sizeof(FIELDINFOINSERT));    /*RBS*/
  fieldInfoInsert.pFieldInfoOrder = (PFIELDINFO)CMA_FIRST;
  fieldInfoInsert.cFieldInfoInsert = 3;
  fieldInfoInsert.fInvalidateFieldInfo = TRUE;		    /*RBS*/

  pFieldInfoInsert = &fieldInfoInsert;

  WinSendDlgItemMsg(hwnd,IDC_CONTAINER, CM_INSERTDETAILFIELDINFO,
		    MPFROMP(firstFieldInfo),
		    MPFROMP(pFieldInfoInsert));

  WinSendDlgItemMsg(hwnd,IDC_CONTAINER,CM_SETCNRINFO,&cnrinfo,
		     MPFROMLONG(CMA_FLWINDOWATTR | CMA_CNRTITLE));

return TRUE;
}					/* End of InitializeContainer	 */
/***********************************************************
 * Name		: SetSysMenu
 *
 * Description	: Procedure to remove unselectable items from
 *		  the window system menu.
 *
 * Concepts	: This routine determines the number of items
 *		  in the system menu, loops through those
 *		  items removing disabled menu items and menu
 *		  seperators.
 *
 * API's        : WinMessageBox
 *
 * Parameters	: None
 *
 * Return	: None
 *
 **************************************************************/
VOID SetSysMenu(HWND hwndDlg)
{
  SHORT sMenuItems;
  USHORT usItemid;
  MENUITEM menuItem;
  HWND	hwndSubMenu;

  /* Determine the definition of the system menu */
  WinSendDlgItemMsg(hwndDlg, FID_SYSMENU, MM_QUERYITEM,
		    MPFROM2SHORT((SHORT)SC_SYSMENU,FALSE),
		    MPFROMP(&menuItem));

  hwndSubMenu = menuItem.hwndSubMenu;

  /* Find the number of items in the in the submenu */
  sMenuItems = (SHORT)WinSendMsg(hwndSubMenu,
				 MM_QUERYITEMCOUNT,NULL,NULL);
  /*
   * Loop through the submenu items and remove disabled
   * menu items and menu separators.
   */
  for ( ; sMenuItems >= 0 ;sMenuItems-- )
  {
    /* Find the item ID for the current position. */
    usItemid = (USHORT)WinSendMsg(hwndSubMenu,MM_ITEMIDFROMPOSITION,
			 MPFROMSHORT(sMenuItems), NULL);

    /* Query the definition of the current item*/
    WinSendMsg(hwndSubMenu, MM_QUERYITEM,
	       MPFROM2SHORT(usItemid,FALSE), MPFROMP(&menuItem));

   /*
    * If the menu item is disabled or the item has a style
    * of MIS_SEPARATOR - delete it.
    */
    if ((BOOL)(WinSendMsg(hwndSubMenu, MM_QUERYITEMATTR,
	  MPFROM2SHORT(usItemid,FALSE), (MPARAM)MIA_DISABLED)) ||
	  (menuItem.afStyle & MIS_SEPARATOR))
    {
      WinSendMsg(hwndSubMenu, MM_DELETEITEM,
		MPFROM2SHORT(usItemid,FALSE),NULL);
    }
  }
}					/* End of SetSysMenu()		 */
/*************************************************************************
*
*  File Name   : STY_EDIT.C
*
*  Description : This module contains the code for the WM_COMMAND
*		 messages posted by the standard edit menu.
*
*  Concepts    : Demonstrates the cut, paste, copy, undo, and
*		 clear features of an MLE control.
*
*  API's       : WinSendMsg
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.						      *
*
************************************************************************/

/*  Include files, macros, defined constants, and externs		*/

#define INCL_WINMLE

#include <os2.h>
#include "sty_main.h"
#include "sty_xtrn.h"

extern LONG lClrForeground;			    /* color for window text */
extern LONG lClrBackground;			     /* color for background */

/*********************************************************************
 *  Name: EditUndo
 *
 *  Description : Processes the Edit menu's Undo item.
 *
 *  Concepts : Called whenever Undo from the Edit menu is selected
 *	       Sends a MLM_UNDO message to the MLE control.
 *
 *  API's : WinSendMsg
 *
 *  Parameters : mp2 - Message parameter
 *
 *  Returns: Void
 *
 ****************************************************************/
VOID EditUndo(MPARAM mp2)
{
 ULONG undoFlag;
  /*
   *   Tell MLE to undo last operation
   */
   if(!WinSendMsg(hwndMLE, MLM_UNDO, NULL, NULL))
	MessageBox(hwndMLE, IDMSG_UNDOFAILED, MB_OK | MB_ERROR, FALSE);

  /*
   *   Get the MLE's colors in case he just changed them back
   *   We're just using the hi-ushort (operation) regardless of the
   *   value of the lo-ushort (boolean) undo-redo flag.
   */
   undoFlag=(ULONG)WinSendMsg(hwndMLE, MLM_QUERYUNDO, NULL, NULL) ;
   if (undoFlag)
   {
      switch (HIUSHORT(undoFlag))
      {
	 case MLM_SETTEXTCOLOR:
	 case MLM_SETBACKCOLOR:
	    lClrForeground =
	       (ULONG)WinSendMsg(hwndMLE,MLM_QUERYTEXTCOLOR, NULL, NULL);
	    lClrBackground =
	       (ULONG)WinSendMsg(hwndMLE,MLM_QUERYBACKCOLOR, NULL, NULL);
	    WinInvalidateRect(hwndMLE, NULL, TRUE);
	    break;
	 default:
	    break;
      }	   /* endswitch HIUSHORT(undoFlag) */

   } /* end if (UndoFlag) */

  /*
   * This routine currently doesn't use the mp2 parameter but
   * it is referenced here to prevent an 'Unreferenced Parameter'
   * warning at compile time.
   */
   mp2 = mp2;

}   /*	End of EditUndo()						*/

/*********************************************************************
 *  Name: EditCut
 *
 *  Description : Processes the Edit menu's Cut item.
 *
 *  Concepts : Called whenever Cut from the Edit menu is selected
 *	       Sends a MLM_CUT message to the MLE control.
 *
 *  API's : WinSendMsg
 *
 *  Parameters : mp2 - Message parameter
 *
 *  Returns: Void
 *
 ****************************************************************/
VOID EditCut(MPARAM mp2)
{
   WinSendMsg(hwndMLE, MLM_CUT, NULL, NULL);
 /*
  * This routine currently doesn't use the mp2 parameter but
  * it is referenced here to prevent an 'Unreferenced Parameter'
  * warning at compile time.
  */
   mp2 = mp2;
}   /*	End of EditCut()						*/

/*********************************************************************
 *  Name: EditCopy
 *
 *  Description : Processes the Edit menu's Copy item.
 *
 *  Concepts : Called whenever Copy from the Edit menu is selected
 *	       Sends a MLM_COPY message to the MLE control.
 *
 *  API's : WinSendMsg
 *
 *  Parameters : mp2 - Message parameter
 *
 *  Returns: Void
 *
 ****************************************************************/
VOID EditCopy(MPARAM mp2)
{
   WinSendMsg(hwndMLE, MLM_COPY, NULL, NULL);
 /*
  * This routine currently doesn't use the mp2 parameter but
  * it is referenced here to prevent an 'Unreferenced Parameter'
  * warning at compile time.
  */
   mp2 = mp2;
}   /*	 End of EditCopy()						*/

/*********************************************************************
 *  Name: EditPaste
 *
 *  Description : Processes the Edit menu's Paste item.
 *
 *  Concepts : Called whenever Paste from the Edit menu is selected
 *	       Sends a MLM_PASTE message to the MLE control.
 *
 *  API's : WinSendMsg
 *
 *  Parameters : mp2 - Message parameter
 *
 *  Returns: Void
 *
 ****************************************************************/
VOID EditPaste(MPARAM mp2)
{
   WinSendMsg(hwndMLE, MLM_PASTE, NULL, NULL);
 /*
  * This routine currently doesn't use the mp2 parameter but
  * it is referenced here to prevent an 'Unreferenced Parameter'
  * warning at compile time.
  */
   mp2 = mp2;
}   /* End of EditPaste()						*/

/*********************************************************************
 *  Name: EditClear
 *
 *  Description : Processes the Edit menu's Clear item.
 *
 *  Concepts : Called whenever Clear from the Edit menu is selected
 *	       Sends a MLM_CLEAR message to the MLE control.
 *
 *  API's : WinSendMsg
 *
 *  Parameters : mp2 - Message parameter
 *
 *  Returns: Void
 *
 ****************************************************************/
VOID EditClear(MPARAM mp2)
{
   WinSendMsg(hwndMLE, MLM_CLEAR, NULL, NULL);
 /*
  * This routine currently doesn't use the mp2 parameter but
  * it is referenced here to prevent an 'Unreferenced Parameter'
  * warning at compile time.
  */
   mp2 = mp2;
}   /* End of EditClear()						*/
/*************************************************************************
*
*  File Name   : STY_FILE.C
*
*  Description : This module contains the code for the
*		 WM_COMMAND messages posted by the standard
*		 File menu.
*
*  Concepts    : Open, close, read, write of files.
*		 File selection through the use of the
*		 standard file fialog.
*
*  API's       : WinSendMsg
*		 WinLoadString
*		 WinFileDlg
*		 DosOpen
*		 DosQueryFileInfo
*		 DosClose
*		 DosRead
*		 DosAllocMem
*		 DosFreeMem
*		 WinPostMsg
*		 DosWrite
*		 WinQueryTaskTitle
*		 WinLoadString
*		 WinSetWindowText
*		 WinQueryWindowULong
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.						      *
*
************************************************************************/

/*  Include files, macros, defined constants, and externs		*/

#define INCL_WINFRAMEMGR
#define INCL_WINWINDOWMGR
#define INCL_WINSWITCHLIST
#define INCL_WINMLE
#define INCL_WINSTDFILE

#include <os2.h>
#include <string.h>
#include "sty_main.h"
#include "sty_xtrn.h"
#include "sty_help.h"
#include "sty_dlg.h"

/*  Global variables							*/

CHAR szFullPath[CCHMAXPATH] = "";

/*********************************************************************
 *  Name: FileNew
 *
 *  Description : Processes the File menu's New item
 *
 *  Concepts : Called whenever New from the File menu is selected.
 *
 *  API's : WinSendMsg
 *
 *  Parameters : mp2 - Message parameter 2
 *
 *  Returns : VOID
 *
 ****************************************************************/
VOID FileNew( MPARAM mp2)
{
   SHORT sMsgBoxResponce;

   /* Save file if changed						*/
   if ((BOOL)WinSendMsg(hwndMLE, MLM_QUERYCHANGED, NULL, NULL))
   {
      sMsgBoxResponce = MessageBox(hwndMLE, IDMSG_FILECHANGED,
	   MB_QUERY | MB_YESNOCANCEL, FALSE);

      if (sMsgBoxResponce == MBID_CANCEL)   /* if user cancels the New,	 */
	 return;			   /* then return		*/
      else
	 if (sMsgBoxResponce == MBID_YES)
	    FileSave(NULL);
      /*
       * If sMsgBoxResponce == MBID_NO, continue with New File processing
       */
   }

   /*
    * disable redrawing of the MLE so the text doesn't "flash" when
    * the MLE is cleared
    */
   WinSendMsg(hwndMLE, MLM_DISABLEREFRESH, NULL, NULL);

   /*
    * Clear the MLE by selecting all of the text and clearing it
    */
   WinSendMsg(hwndMLE, MLM_SETSEL, MPFROMSHORT(NULL),
	     (MPARAM)WinSendMsg(hwndMLE, MLM_QUERYTEXTLENGTH, NULL, NULL));

   WinSendMsg(hwndMLE, MLM_CLEAR, NULL, NULL);

   /*
    * Reset the changed flag
    */
   WinSendMsg(hwndMLE, MLM_SETCHANGED, MPFROMSHORT((BOOL)FALSE), NULL);

   /*
    * Enable redrawing of the MLE
    */
   WinSendMsg(hwndMLE, MLM_ENABLEREFRESH, NULL, NULL);

   /*
    * Reset file name to NULL and update the main title bar
    */
   szFullPath[0] = 0;
   UpdateTitleText(hwndMainFrame);

   /*
    *  This routine currently doesn't use the mp2 parameter but
    *  it is referenced here to prevent an 'Unreferenced Parameter'
    *  warning at compile time.
    */
   mp2 = mp2;
}   /* En of FileNew()							*/

/*********************************************************************
 *  Name: FileOpen
 *
 *  Description : Processes the File menu's Open item.
 *
 *  Concepts : Called whenever New from the File menu is
 *	       selected.  Calls the standard file open
 *	       dialog to get the file name.  The file name
 *	       is passed onto DosOpen which returns the
 *	       handle to the file.  The file input
 *	       procedure is called and then the file
 *	       handle is closed.
 *
 *  API's : WinLoadString
 *	    WinFileDlg
 *	    DosOpen
 *	    DosQueryFileInfo
 *	    DosClose
 *	    DosRead
 *	    DosAllocMem
 *	    DosFreeMem
 *
 *  Parameters : mp2 - Message parameter 2
 *
 *  Returns : VOID
 *
 ****************************************************************/
VOID FileOpen( MPARAM mp2)
{
   FILEDLG fileDialog;
   HFILE hfile;
   ULONG ulAction;
   FILESTATUS fileStatus;
   PVOID pvBuf;
   CHAR szTitle[MESSAGELEN], szButton[MESSAGELEN];
   IPT iptOffset;		    /* insert position */

   fileDialog.cbSize = sizeof(FILEDLG);

   if (!WinLoadString(hab, (HMODULE)0, IDS_OPENDLGTITLE, MESSAGELEN, szTitle))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, TRUE);
      return;
   }

   if (!WinLoadString(hab,(HMODULE)0, IDS_OPENDLGBUTTON, MESSAGELEN, szButton))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, TRUE);
      return;
   }

   fileDialog.pszTitle = szTitle;
   fileDialog.pszOKButton = szButton;
   fileDialog.ulUser = 0;
   fileDialog.fl = FDS_HELPBUTTON | FDS_CENTER | FDS_OPEN_DIALOG;
   fileDialog.pfnDlgProc = (PFNWP)OpenSaveFilterDlgProc;
   fileDialog.lReturn = 0;
   fileDialog.lSRC = 0;
   fileDialog.hMod = (HMODULE)0;
   fileDialog.usDlgId = IDD_FILEOPEN;
   fileDialog.x = 0;
   fileDialog.y = 0;

   if (!WinLoadString(hab, (HMODULE)0, IDS_FILEOPENEXT, CCHMAXPATH,
		     fileDialog.szFullFile))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, TRUE);
      return;
   }

   fileDialog.pszIType = NULL;
   fileDialog.papszITypeList = NULL;
   fileDialog.pszIDrive = NULL;
   fileDialog.papszIDriveList = NULL;
   fileDialog.sEAType = 0;
   fileDialog.papszFQFilename = NULL;
   fileDialog.ulFQFCount = 0;

   /*
    *Call the standard file dialog to get the file
    */
   if (!WinFileDlg(HWND_DESKTOP, hwndMain, (PFILEDLG)&fileDialog))
       return;

   /*
    *  Upon sucessful return of a file, open it for reading
    */

   if (fileDialog.lReturn == ID_OK)
   {
      if ( DosOpen(fileDialog.szFullFile, &hfile, &ulAction, 0, FILE_NORMAL,
	     FILE_OPEN, OPEN_ACCESS_READONLY | OPEN_SHARE_DENYNONE, NULL))
      {
	 MessageBox(hwndMain, IDMSG_CANNOTOPENINPUTFILE, MB_OK | MB_ERROR,
	    FALSE);
	 return;
      }
      /*
       * Copy file name into file name buffer
       */
      strcpy(szFullPath, fileDialog.szFullFile);

      /*
       * Get the length of the file
       */

      if (DosQueryFileInfo(hfile, 1, (PVOID)&fileStatus, sizeof(FILESTATUS)))
      {
	 MessageBox(hwndMain, IDMSG_CANNOTGETFILEINFO, MB_OK | MB_ERROR,
	      FALSE);
	 DosClose(hfile);
	 return;
      }
      /*
       * Allocate a buffer for the file
       */
      if (DosAllocMem((PPVOID)&pvBuf, (ULONG)fileStatus.cbFileAlloc, fALLOC))
      {
	 MessageBox(hwndMain, IDMSG_CANNOTALLOCATEMEMORY, MB_OK | MB_ERROR,
	      FALSE);

	 DosClose(hfile);
	 return;
      }
      /*
       * Read in the file
       */
      if (DosRead(hfile, pvBuf, fileStatus.cbFileAlloc, &ulAction))
      {
	 MessageBox(hwndMain, IDMSG_CANNOTREADFILE, MB_OK | MB_ERROR,
	      FALSE);

	 DosClose(hfile);
	 return;
      }
      /*
       * Set the file into the MLE
       */
      WinSendMsg(hwndMLE, MLM_SETIMPORTEXPORT, MPFROMP((PBYTE)pvBuf),
	  MPFROMSHORT(fileStatus.cbFileAlloc));

      /*
       * Import to MLE starting at offset 0
       */

      iptOffset = 0;
      WinSendMsg(hwndMLE, MLM_IMPORT, MPFROMP(&iptOffset),
	  MPFROMSHORT(fileStatus.cbFileAlloc));

      /*
       * Reset the changed flag
       */
      WinSendMsg(hwndMLE, MLM_SETCHANGED, MPFROMSHORT((BOOL)FALSE), NULL);

      DosFreeMem(pvBuf);

      DosClose(hfile);

      UpdateTitleText(hwndMainFrame);
   }
   /*
    *  This routine currently doesn't use the mp2 parameter but
    *  it is referenced here to prevent an 'Unreferenced Parameter'
    *  warning at compile time.
    */
   mp2 = mp2;
}   /* End of FileOpen()						*/


/*********************************************************************
 *  Name: FileSave
 *
 *  Description : Processes the File menu's Save item.
 *
 *  Concepts : Gets file name for untitled files, opens file
 *	       writes file to disk, closes file.
 *
 *  API's : DosOpen
 *	    DosClose
 *
 *  Parameters : mp2 - Message parameter 2
 *
 *  Returns : VOID
 *
 ****************************************************************/
VOID FileSave( MPARAM mp2)
{
   HFILE hfile;
   ULONG ulAction;
   /*
    * If the file currently is untitled, we will need to get a file
    * name from the user before we can open the file.  Getting a
    * file name is normally done during the FileSaveAs operation
    * so we will treat this save as a SaveAs and call FileSaveAs().
    * If the file is titled, then we save the file.
    *
    * NOTE:  This routine will be called by FileSaveAs(), but only
    *  after a valid file name has been obtained.  So, FileSaveAs()
    *  will not be called again from this routine.
    */
   if (szFullPath[0] == 0)
   {
      FileSaveAs(mp2);
      return;
   }

   /*
    * Open the file
    */
   if ( DosOpen(szFullPath, &hfile, &ulAction, 0, FILE_NORMAL, FILE_OPEN |
       FILE_CREATE, OPEN_ACCESS_WRITEONLY | OPEN_SHARE_DENYNONE, NULL))
   {
      MessageBox(hwndMain, IDMSG_CANNOTOPENOUTPUTFILE, MB_OK | MB_ERROR,
	   FALSE);
      return;
   }

   WriteFileToDisk(hfile);

   DosClose(hfile);
   /*
    *  This routine currently doesn't use the mp2 parameter but
    *  it is referenced here to prevent an 'Unreferenced Parameter'
    *  warning at compile time.
    */
   mp2 = mp2;

}   /*	End of FileSave()						*/

/*********************************************************************
 *  Name: FileSaveAs
 *
 *  Description : Processes the File menu's Save As item.
 *
 *  Concepts : Called whenever Save As from the File menu is
 *	       selected.
 *
 *  API's : DosOpen
 *	    DosClose
 *
 *  Parameters : mp2 - Message parameter 2
 *
 *  Returns : VOID
 *
 ********************************************************************/
VOID FileSaveAs( MPARAM mp2)
{
   HFILE hfile;
   ULONG ulAction;
   SHORT sMsgBoxResponce;

   /*
    * Infinite loop until we break out of it
    */
   while(TRUE)
   {
   /*
    * If no file name, then get a file name
    */
     if (!GetFileName())
	return;
   /*
    * See if the file exists.  If it does, then confirm that the
    * user wants to overwrite it.  If he doesn't, then get a new
    * file name
    */
    if ( DosOpen(szFullPath,	     /* file name from, GetFileName()	 */
		   &hfile,	    /* handle of opened file		*/
		   &ulAction,
		   0,
		   FILE_NORMAL,
		   FILE_OPEN | FILE_CREATE,
		   OPEN_ACCESS_WRITEONLY | OPEN_SHARE_DENYNONE,
		   NULL))
     {
	MessageBox(hwndMain, IDMSG_CANNOTOPENOUTPUTFILE, MB_OK | MB_ERROR,
	     FALSE);
	return;
     }
     else
	DosClose(hfile);

     /*
      * If file exists, ask if we want to overwrite it
      */
     if (ulAction == FILE_EXISTED)
     {
       sMsgBoxResponce = MessageBox(hwndMLE, IDMSG_OVERWRITEFILE, MB_QUERY |
	    MB_YESNOCANCEL, FALSE);

       if (sMsgBoxResponce == MBID_CANCEL)
	  return;

	if (sMsgBoxResponce == MBID_YES)
	   break;
       /*
	* If user selected no, repeat the sequence
	*/
      }
      else
	 break;			     /* file didn't exist               */
   }				     /* while(TRUE)			*/
   UpdateTitleText(hwndMainFrame);
   /*
    * Now that we have a valid file name, save the file.  This is
    * normally done under the File Save function so we can just
    * call the FileSave() function here.  Note that FileSave() will
    * not call FileSaveAs() back since there is a valid file name
    */
    FileSave(mp2);
   /*
    *  This routine currently doesn't use the mp2 parameter but
    *  it is referenced here to prevent an 'Unreferenced Parameter'
    *  warning at compile time.
    */
   mp2 = mp2;
}	/* End of FileSaveAs()						*/

/****************************************************************
 *  Name: WriteFileToDisk
 *
 *  Description : Writes the current file to the file in szFileName
 *
 *  Concepts : Called from FileSave and FileSaveAs when a file is
 *	       to be saved to disk.  Routine uses the file handle
 *	       specified and gets the text from the MLE and
 *	       writes the text to the file.
 *
 *  API's : WinSendmsg
 *	    DosAllocMem
 *	    DosWrite
 *	    DosFreeMem
 *
 *  Parameters : hfile - handle of file to save
 *
 *  Returns: Void
 *
 ****************************************************************/
VOID WriteFileToDisk( HFILE hfile)
{
   ULONG ulWrite;
   PVOID pvBuf;
   ULONG ulFileLen;
   ULONG ulOffset;	       /* offset in buffer		      */
   ULONG cbExport;	       /* # of bytes to export from the MLE   */


   /*
    * Get the length of the file
    */
   ulFileLen = (ULONG)WinSendMsg(hwndMLE, MLM_QUERYTEXTLENGTH, NULL, NULL);
   if (!ulFileLen)
       return;

   /*
    * Allocate a buffer for the file
    */
   if (DosAllocMem((PPVOID) &pvBuf, ulFileLen, fALLOC))
   {
      MessageBox(hwndMLE, IDMSG_CANNOTALLOCATEMEMORY, MB_OK | MB_ERROR,
	   FALSE);
      return;
   }

   /*
    * Get the file from the MLE
    */
   cbExport = ulFileLen;
   WinSendMsg(hwndMLE, MLM_SETIMPORTEXPORT, MPFROMP((PBYTE)pvBuf),
	MPFROMLONG(cbExport));

   /*
   * Export MLE starting at offset 0
   */
   ulOffset = 0;
   WinSendMsg(hwndMLE, MLM_EXPORT, MPFROMP(&ulOffset), MPFROMLONG(&cbExport));

   /*
    * Write the file
    */
   if (DosWrite(hfile, pvBuf, ulFileLen, &ulWrite))
   {
      MessageBox(hwndMLE, IDMSG_CANNOTWRITETOFILE, MB_OK | MB_ERROR, FALSE);
      return;
   }

   /*
    * Reset the changed flag
    */
   WinSendMsg(hwndMLE, MLM_SETCHANGED, MPFROMSHORT((BOOL)FALSE), NULL);

   DosFreeMem(pvBuf);
}	   /*	End of WriteFileToDisk()				*/

/*********************************************************************
 *  Name : GetFileName
 *
 *  Description : Gets the name of the save file.
 *
 *  Concepts : Called when the user is needs to supply a name
 *	       for the file to be saved.  Calls the standard
 *	       file open dialog to get the file name.
 *
 *  API's : WinLoadString
 *	    WinFileDlg
 *
 *  Parameters : None
 *
 *  Returns: Void
 *
 ****************************************************************/
BOOL GetFileName(VOID)
{
    FILEDLG fileDialog;
    CHAR szTitle[MESSAGELEN], szButton[MESSAGELEN];

    if (!WinLoadString(hab, (HMODULE)0, IDS_SAVEDLGTITLE, MESSAGELEN, szTitle))
    {
       MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, TRUE);
       return FALSE;
    }

    if (!WinLoadString(hab,(HMODULE)0, IDS_SAVEDLGBUTTON, MESSAGELEN, szButton))
    {
       MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, TRUE);
       return FALSE;
    }

    fileDialog.cbSize = sizeof(FILEDLG);       /* Size of FILEDLG structure. */
    fileDialog.fl = FDS_HELPBUTTON |   /* FDS_ flags. Alter behavior of dlg. */
		     FDS_CENTER | FDS_SAVEAS_DIALOG | FDS_ENABLEFILELB;
    fileDialog.ulUser = 0;			      /* User defined field. */
    fileDialog.lReturn = 0;	       /* Result code from dialog dismissal. */
    fileDialog.lSRC = 0;			      /* System return code. */
    fileDialog.pszTitle = szTitle;	  /* String to display in title bar. */
    fileDialog.pszOKButton = szButton;	  /* String to display in OK button. */
				       /* Entry point to custom dialog proc. */
    fileDialog.pfnDlgProc = (PFNWP)OpenSaveFilterDlgProc;
    fileDialog.pszIType = NULL;		/* Pointer to string containing	     */
					/*   initial EA type filter. Type    */
					/*   does not have to exist in list. */
    fileDialog.papszITypeList = NULL;	/* Pointer to table of pointers that */
					/*   point to null terminated Type   */
					/*   strings. End of table is marked */
					/*   by a NULL pointer.		     */
    fileDialog.pszIDrive = NULL;	  /* Pointer to string containing    */
					  /*   initial drive. Drive does not */
					  /*   have to exist in drive list.  */
    fileDialog.papszIDriveList = NULL;	/* Pointer to table of pointers that */
					/*   point to null terminated Drive  */
					/*   strings. End of table is marked */
						       /* by a NULL pointer. */
    fileDialog.hMod = (HMODULE)0;	     /* Custom File Dialog template. */
    strcpy(fileDialog.szFullFile, szFullPath); /* Initial or selected fully  */
					       /*   qualified path and file. */
    fileDialog.papszFQFilename = NULL;	/* Pointer to table of pointers that */
					/*   point to null terminated FQFname*/
					/*   strings. End of table is marked */
					/*   by a NULL pointer.		     */
    fileDialog.ulFQFCount = 0;			 /* Number of files selected */
    fileDialog.usDlgId = IDD_FILESAVE;			/* Custom dialog id. */
    fileDialog.x = 0;			       /* X coordinate of the dialog */
    fileDialog.y = 0;			       /* Y coordinate of the dialog */
    fileDialog.sEAType = 0;			 /* Selected file's EA Type. */


    /*
     * Get the file
     */
    if (!WinFileDlg(HWND_DESKTOP, hwndMLE, (PFILEDLG)&fileDialog))
	return FALSE;

    if (fileDialog.lReturn != ID_OK)
	return FALSE;

    /*
     * Copy file name and path returned into buffers
     */
    strcpy(szFullPath, fileDialog.szFullFile);

    return TRUE;

}   /* End of GetFileName() */


/*********************************************************************
 *  Name : UpdateTitleText
 *
 *  Description : Updates the text in the main window's title bar
 *		  to display the app name, followed by the
 *		  separator, followed by the file name
 *
 *  Concepts : Called at init time and when the text file is
 *	       changed gets the program name, appends the
 *	       separator, and appends the file name.
 *
 *  API's : WinQueryTaskTitle
 *	    WinLoadString
 *	    WinSetWindowText
 *
 *  Parameters : hwnd - handle of the main window
 *
 *  Returns : Void
 *
 ****************************************************************/
VOID UpdateTitleText(HWND hwnd)
{
/*  CHAR szBuf[MAXNAMEL]; */
    CHAR szBuf[CCHMAXPATH + MAXNAMEL];
    CHAR szSeparator[TITLESEPARATORLEN+1];
    PSZ pszTitle;

    WinQueryTaskTitle(0, szBuf, MAXNAMEL);

    WinLoadString(hab, (HMODULE)0, IDS_TITLEBARSEPARATOR, TITLESEPARATORLEN,
	 szSeparator);

    strcat(szBuf, szSeparator);

    if (szFullPath[0] == '\0')
       pszTitle = szUntitled;
    else
       pszTitle = szFullPath;

    strcat(szBuf, pszTitle);

    /***********************************************************************
    * If title is longer that maximum allowable, show the most significant *
    * portion of it (filename end of path).				   *
    ***********************************************************************/
    if (strlen(szBuf) + 1 > MAXNAMEL)
       pszTitle = &szBuf[strlen(szBuf) - MAXNAMEL + 1];
    else
       pszTitle = szBuf;

    WinSetWindowText(WinWindowFromID(hwnd, FID_TITLEBAR), pszTitle);

}	   /*  End of UpdateTitleText()					     */


/***********************************************************
 * Name		: OpenSaveFilterProc
 *
 * Description	: Procedure to handle wm_help messages for
 *		  the file open/save dialog.
 *
 * Concepts	: This routine handles the WM_HELP messages for
 *		  the dialog boxs created with the WinFileDlg
 *		  Checks the flags used on the call to determine
 *		  the correct help panel to display.
 *
 * API's        : WinQueryWIndowULong
 *		  WinSendMessage
 *
 * Parameters	: hwnd - Window handle to which message is addressed
 *		  msg - Message type
 *		  mp1 - First message parameter
 *		  mp2 - Second message parameter
 *
 *  Returns : Dependent upon message sent
 **************************************************************/

MRESULT APIENTRY OpenSaveFilterDlgProc(HWND hwnd, USHORT msg,
				       MPARAM mp1, MPARAM mp2)
{
   if(msg == WM_HELP)
   {
      PFILEDLG pOpenSaveFileDlgStruct;
      /*
       * Get a pointer to the file dialog structure.
       */
      pOpenSaveFileDlgStruct = (PFILEDLG) WinQueryWindowULong(hwnd, QWL_USER);

      /*
       * If this is an the File Open dialog, display the file open help
       * panel.
       */
      if (pOpenSaveFileDlgStruct->fl & FDS_OPEN_DIALOG)
      {
	 DisplayHelpPanel(PANEL_FILEOPEN);
	 return (MRESULT)FALSE ;
      }

      /*
       * If this is an the File Save or Save As dialog, display the file
       * Save As help panel.
       */

      if (pOpenSaveFileDlgStruct->fl & FDS_SAVEAS_DIALOG)
      {
	 DisplayHelpPanel(PANEL_FILESAVEAS);
	 return (MRESULT)FALSE ;
      }
   }
   return WinDefFileDlgProc( hwnd, msg, mp1, mp2 );
}					/* End of OpenSaveFilterDlgProc	 */

/*************************************************************************
*
*  File Name   : STY_HELP.C
*
*  Description : This module contains all the routines for
*		 interfacing with the IPF help manager.
*
*  Concepts    : Help initialization and termination, handling of
*		 help menu items.
*
*  API's       : WinCreateHelpInstance
*		 WinAssociateHelpInstance
*		 WinLoadString
*		 WinSendMsg
*		 WinDlgBox
*		 WinDestroyHelpInstance
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.						      *
*
************************************************************************/

/*  Include files, macros, defined constants, and externs	*/

#define	 INCL_WINHELP

#include <os2.h>
#include <string.h>
#include "sty_main.h"
#include "sty_xtrn.h"
#include "sty_dlg.h"
#include "sty_help.h"

#define HELPLIBRARYNAMELEN  20

/*  Global variables						*/
static HWND hwndHelpInstance;
static CHAR szLibName[HELPLIBRARYNAMELEN];
static CHAR szWindowTitle[HELPLIBRARYNAMELEN];


/*  Entry point declarations					*/
MRESULT EXPENTRY ProdInfoDlgProc(HWND hwnd, USHORT msg,
				 MPARAM mp1, MPARAM mp2);

/***************************************************************
 *  Name: InitHelp
 *
 *  Description : Initializes the IPF help facility
 *
 *  Concepts : Initializes the HELPINIT structure and creates the
 *	       help instance.  If successful, the help instance
 *	       is associated with the main window
 *
 *  API's : WinCreateHelpInstance
 *	    WinAssociateHelpInstance
 *	    WinLoadString
 *
 *  Parameters : None
 *
 *  Returns:  None
 *
 ****************************************************************/
VOID InitHelp(VOID)
{
  HELPINIT helpInit;

  /* if we return because of an error, Help will be disabled		    */
  fHelpEnabled = FALSE;

  /* inititalize help init structure					    */
  helpInit.cb = sizeof(HELPINIT);
  helpInit.ulReturnCode = 0L;

  helpInit.pszTutorialName = (PSZ)NULL;	  /* if tutorial added,		    */
					  /* add name here		    */
  helpInit.phtHelpTable = (PHELPTABLE)MAKELONG(STYLE_HELP_TABLE,
			   0xFFFF);
  helpInit.hmodHelpTableModule = (HMODULE)0;
  helpInit.hmodAccelActionBarModule = (HMODULE)0;
  helpInit.idAccelTable = 0;
  helpInit.idActionBar = 0;

  if (!WinLoadString(hab, (HMODULE)0, IDS_HELPWINDOWTITLE,
		    HELPLIBRARYNAMELEN, (PSZ)szWindowTitle))
  {
     MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
     return;
  }
  helpInit.pszHelpWindowTitle = (PSZ)szWindowTitle;
  helpInit.fShowPanelId = CMIC_HIDE_PANEL_ID;

  if (!WinLoadString(hab, (HMODULE)0, IDS_HELPLIBRARYNAME,
       HELPLIBRARYNAMELEN, (PSZ)szLibName))
  {
     MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
     return;
  }

  helpInit.pszHelpLibraryName = (PSZ)szLibName;

  /* creating help instance						    */
  hwndHelpInstance = WinCreateHelpInstance(hab, &helpInit);

  if (!hwndHelpInstance || helpInit.ulReturnCode)
  {
     MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, MB_OK | MB_ERROR, TRUE);
     return;
  }

  /* associate help instance with main frame				    */
  if (!WinAssociateHelpInstance(hwndHelpInstance, hwndMainFrame))
  {
     MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, MB_OK | MB_ERROR, TRUE);
     return;
  }

  /* help manager is successfully initialized so set flag to TRUE	    */
  fHelpEnabled = TRUE;

}   /*						End of InitHelp()	    */

/*********************************************************************
 *  Name: HelpUsingHelp
 *
 *  Description : Processes the WM_COMMAND message posted
 *		  by the Using Help item of the Help menu
 *
 *  Concepts : Called from MainCommand when the Using Help menu item
 *	       is selected.  Sends an HM_DISPLAY_HELP message to the
 *	       help instance so that the default Using Help is
 *	       displayed.
 *
 *  API's : WinSendMsg
 *
 *  Parameters :  mp2 - Message parameter 2
 *
 *  Returns: None
 *
 ****************************************************************/
VOID  HelpUsingHelp(MPARAM mp2)
{
/*    this just displays the system help for help panel			      */
  if (fHelpEnabled)
  {
    if ((BOOL)WinSendMsg(hwndHelpInstance, HM_DISPLAY_HELP, NULL, NULL))
    {
       MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, MB_OK | MB_ERROR, FALSE);
    }
  }
 /*
  * This routine currently doesn't use the mp2 parameter but
  * it is referenced here to prevent an 'Unreferenced Parameter'
  * warning at compile time.
  */
  mp2 = mp2;
}   /* End of HelpUsingHelp()						     */

/*********************************************************************
 *  Name: HelpUsingHelp
 *
 *  Description : Processes the WM_COMMAND message posted
 *		  by the General Help item of the Help menu
 *
 *  Concepts : Called from MainCommand when the General Help menu item
 *	       is selected.  Sends an HM_EXT_HELP message to the
 *	       help instance so that the default Extended Help is
 *	       displayed.
 *
 *  API's : WinSendMsg
 *
 *  Parameters :  mp2 - Message parameter 2
 *
 *  Returns: None
 *
 ****************************************************************/
VOID  HelpGeneral(MPARAM mp2)
{
/*   this just displays the system General help panel			    */
   if (fHelpEnabled)
   {
     if ((BOOL)WinSendMsg(hwndHelpInstance, HM_EXT_HELP, NULL, NULL))
     {
	MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, MB_OK | MB_ERROR, FALSE);
     }
   }
   /*
    * This routine currently doesn't use the mp2 parameter but
    * it is referenced here to prevent an 'Unreferenced Parameter'
    * warning at compile time.
    */
    mp2 = mp2;

}	/* End of HelpGeneral()					     */

/*********************************************************************
 *  Name: HelpKeys
 *
 *  Description : Processes the WM_COMMAND message posted
 *		  by the Keys Help item of the Help menu
 *
 *  Concepts : Called from MainCommand when the Keys Help menu item
 *	       is selected.  Sends an HM_KEYS_HELP message to the
 *	       help instance so that the default Extended Help is
 *	       displayed.
 *
 *  API's : WinSendMsg
 *
 *  Parameters :  mp2 - Message parameter 2
 *
 *  Returns: None
 *
 ****************************************************************/
VOID  HelpKeys(MPARAM mp2)
{
/* this just displays the system keys help panel			      */
  if (fHelpEnabled)
  {
    if ((BOOL)WinSendMsg(hwndHelpInstance, HM_KEYS_HELP, NULL, NULL))
    {
      MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, MB_OK | MB_ERROR, FALSE);
    }
  }
/*
 * This routine currently doesn't use the mp2 parameter but
 * it is referenced here to prevent an 'Unreferenced Parameter'
 * warning at compile time.
 */
  mp2 = mp2;
}   /*	 End of HelpKeys()						      */

/*********************************************************************
 *  Name: HelpIndex
 *
 *  Description : Processes the WM_COMMAND message posted
 *		  by the Index Help item of the Help menu
 *
 *  Concepts : Called from MainCommand when the Index Help menu item
 *	       is selected.  Sends an HM_INDEX_HELP message to the
 *	       help instance so that the default Extended Help is
 *	       displayed.
 *
 *  API's : WinSendMsg
 *
 *  Parameters :  mp2 - Message parameter 2
 *
 *  Returns: None
 *
 ****************************************************************/
VOID  HelpIndex(MPARAM mp2)
{
/* this just displays the system help index panel			      */
  if (fHelpEnabled)
  {
    if ((BOOL)WinSendMsg(hwndHelpInstance, HM_HELP_INDEX, NULL, NULL))
    {
       MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, MB_OK | MB_ERROR, FALSE);
    }
  }
 /*
  * This routine currently doesn't use the mp2 parameter but
  * it is referenced here to prevent an 'Unreferenced Parameter'
  * warning at compile time.
  */
  mp2 = mp2;
}   /* End of HelpIndex()						      */

/*********************************************************************
 *  Name: HelpProdInfo
 *
 *  Description : Processes the WM_COMMAND message posted
 *		  by the Index Help item of the Help menu
 *
 *  Concepts : Called from MainCommand when the Product
 *	       information Help menu item is selected.
 *	       Calls WinDlgBox to display the Product
 *	       Information dialog.
 *
 *  API's : WinDlgBox
 *
 *  Parameters :  mp2 - Message parameter 2
 *
 *  Returns: None
 *
 ****************************************************************/
VOID  HelpProdInfo( MPARAM mp2)
{
/* display the Product Information dialog				      */
  WinDlgBox(HWND_DESKTOP, hwndMain, (PFNWP)ProdInfoDlgProc, (HMODULE)0,
	    IDD_PRODINFO, (PVOID)NULL);
 /*
  * This routine currently doesn't use the mp2 parameter but
  * it is referenced here to prevent an 'Unreferenced Parameter'
  * warning at compile time.
  */
    mp2 = mp2;

}   /* End of HelpProdInfo()						      */

/*********************************************************************
 *  Name: DisplayHelp
 *
 *  Description : Displays the help panel indicated
 *
 *  Concepts : Displays the help panel whose id is passed to
 *	       the routine.  Called whenever a help panel is
 *	       desired to be displayed, usually from the
 *	       WM_HELP processing of the dialog boxes.
 *
 *  API's : WinSendMsg
 *
 *  Parameters : idPanel - Id of the halp panel to be displayed
 *
 *  Returns: None
 *
 ****************************************************************/
VOID DisplayHelpPanel(SHORT idPanel)
{
  if (fHelpEnabled)
  {
    if ((BOOL)WinSendMsg(hwndHelpInstance, HM_DISPLAY_HELP,
	    MPFROM2SHORT(idPanel, NULL), MPFROMSHORT(HM_RESOURCEID)))
    {
      MessageBox(hwndMainFrame, IDMSG_HELPDISPLAYERROR,
		 MB_OK | MB_ERROR, TRUE);
    }
  }
}   /*	  End of DisplayHelpPanel()				      */

/*********************************************************************
 *  Name: DestroyHelpInstance
 *
 *  Description : Destroys the help instance for the application
 *
 *  Concepts : Called after exit from message loop. Calls
 *	       WinDestroyHelpInstance() to destroy the
 *	       help instance.
 *
 *  API's : WinDestroyHelpInstance
 *
 *  Parameters : None
 * None
 *  Returns:
 *
 ****************************************************************/
VOID DestroyHelpInstance(VOID)
{
  if ((BOOL)hwndHelpInstance)
  {
     WinDestroyHelpInstance(hwndHelpInstance);
  }

}   /*	      End of DestroyHelpInstance()				      */
/*************************************************************************
*
*  File Name   : STY_INIT.C
*
*  Description : This module contains the code for application
*		 initialization as well as the code for exit list
*		 processing
*
*  Concepts    : Application initialization and Exit list processing
*
*  API's       : DosExit
*		 DosExitList
*		 WinCreateWindow
*		 WinDestroyMsgQueue
*		 WinDistroyWindow
*		 WinIsWindow
*		 WinLoadString
*		 WinQueryWindowRect
*		 WinRegisterClass
*		 WinTerminate
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.						      *
*
************************************************************************/

/*  Include files, macros, defined constants, and externs		*/

#define	 INCL_WINWINDOWMGR
#define	 INCL_WINMLE
#define	 INCL_DOSPROCESS

#include <os2.h>
#include <string.h>
#include "sty_main.h"
#include "sty_xtrn.h"
#include "sty_dlg.h"

#define RETURN_ERROR	    1		    /* error return in DosExit	*/

/*  Global variables							*/

HWND hwndMLE;
extern LONG lClrForeground;			    /* color for window text */
extern LONG lClrBackground;			     /* color for background */
extern LONG lClrDefaultForeground;		    /* color for window text */
extern LONG lClrDefaultBackground;		     /* color for background */

/*********************************************************************
 *  Name: Init
 *
 *  Description : Performs initialization functions required
 *		  before the main window can be created.
 *
 *  Concepts :	Window class registration and addition of exit
 *		procedure to Exit list.
 *
 *  API's : DosExit
 *	    DosExitList
 *	    WinLoadString
 *	    WinRegisterClass
 *
 *  Parameters :  None
 *
 *  Returns: TRUE  - initialization is successful
 *	     FALSE - initialization failed
 *
 ****************************************************************/
BOOL Init(VOID)
{
    /* Add ExitProc to the exit list to handle the exit processing.  If
     * there is an error, then terminate the process since there have
     * not been any resources allocated yet
     */
    if(DosExitList(EXLST_ADD, (PFNEXITLIST)ExitProc))  {
	MessageBox(HWND_DESKTOP,
		   IDMSG_CANNOTLOADEXITLIST,
		   MB_OK | MB_ERROR,
		   TRUE);
	DosExit(EXIT_PROCESS, RETURN_ERROR);
    }

    /* load application name from resource file */
    if(!WinLoadString(hab, (HMODULE)0, IDS_APPNAME, MAXNAMEL, szAppName))
	return FALSE;

    /* load "untitled" string */
    if(!WinLoadString(hab, (HMODULE)0, IDS_UNTITLED, MESSAGELEN, szUntitled))
	return FALSE;

    /* register the main client window class */
    if(!WinRegisterClass(hab,
			(PSZ)szAppName,
			(PFNWP)MainWndProc,
			CS_SIZEREDRAW | CS_CLIPCHILDREN,
			0))  {
	return FALSE;
    }

    /*
     * Add any command line processing here
     */
    return TRUE;
}		/* End of Init()	  */

/*********************************************************************
 *  Name: InitMainWindow
 *
 *  Description : Performs initialization functions required
 *		  when the main window can be created.
 *
 *  Concepts : Performs initialization functions required
 *	       when the main window is created.	 Called once
 *	       during the WM_CREATE processing when the main
 *	       window is created.
 *
 *
 *  API's : WinQueryWindowRect
 *	    WinCreateWindow
 *
 *  Parameters : hwnd - client window handle
 *		 mp1 - First message parameter
 *		 mp2 - Second message parameter
 *
 *  Returns: TRUE  - initialization failed
 *	     FALSE - initialization is successful
 *
 ****************************************************************/
MRESULT InitMainWindow(HWND hwnd, MPARAM mp1, MPARAM mp2)
{
    RECTL rcl;

    UpdateTitleText(((PCREATESTRUCT)PVOIDFROMMP(mp2))->hwndParent);

    WinQueryWindowRect(hwnd, (PRECTL)&rcl);

    /* create MLE window the same size as the client */

    hwndMLE = WinCreateWindow(hwnd, WC_MLE, (PSZ)NULL,
			      MLS_HSCROLL | MLS_VSCROLL | WS_VISIBLE,
			      rcl.xLeft,  rcl.yBottom,
			      rcl.xRight, rcl.yTop,
			      hwnd, HWND_TOP, ID_MLE, NULL, NULL);
    if(!hwndMLE)
	return (MRESULT)TRUE;

    /*
     * Set default colors
     */

    WinSendMsg(hwndMLE, MLM_SETTEXTCOLOR, MPFROMLONG(lClrDefaultForeground),
									NULL);
    WinSendMsg(hwndMLE, MLM_SETBACKCOLOR, MPFROMLONG(lClrDefaultBackground),
									NULL);
    WinSendMsg(hwndMLE, MLM_RESETUNDO, NULL, NULL);

    /*
     *	This routine currently doesn't use the mp1 and mp2 parameters so
     *	it is referenced here to prevent an 'Unreferenced Parameter'
     *	warning at compile time
     */
    mp1 = mp1;
    mp2 = mp2;

    /* return FALSE to continue window creation, TRUE to abort it */
    return (MRESULT)FALSE;
}	 /* End of InitMainWindow() */

/*********************************************************************
 *  Name:  ExitProc
 *
 *  Description : Cleans up certain resources when the
 *		  application terminates
 *
 *  Concepts : Global resources, such as the main window an
 *	       message queue, are destroyed and any system
 *	       resources used are freed
 *
 *  API's : WinIsWindow
 *	    WinDestroyWindow
 *	    WinDestroyMsgQueue
 *	    WinTerminate
 *	    DosExitList
 *
 *  Parameters : USHORT -  termination code
 *
 *  Returns:  Returns EXLST_EXIT to the DosExitList handler
 *
 ****************************************************************/
VOID APIENTRY ExitProc(USHORT usTermCode)
{
 /* destroy the main window if it exists		       */
    if(WinIsWindow(hab, hwndMainFrame))
	WinDestroyWindow(hwndMainFrame);

    /*
     *	    Any other system resources used
     *	    (e.g. memory or files) should be freed here
     */

    WinDestroyMsgQueue(hmq);

    WinTerminate(hab);

    /*
     * Termination complete
     */
    DosExitList(EXLST_EXIT, (PFNEXITLIST)ExitProc);

    /*
     * This routine currently doesn't use the usTermCode parameter so
     *	it is referenced here to prevent an 'Unreferenced Parameter'
     *	warning at compile time
     */
    usTermCode = usTermCode;
}				   /*	  End of ExitProc()	      */
/*************************************************************************
*
*  File Name   : Sty_main.c
*
*  Description : This PM sample application demonstates the
*		 standard menus, dialogs, and controls found
*		 in most PM applications.
*
*  Concepts    : PM window creation
*		 Menu Creation
*		 Dialog box creation
*		 Presentation parameters
*		 Initizalition and display of PM controls
*		 Help creation and initialization
*
*  API's       :
*  -------------
*  DosAllocMem		    WinFontDlg		   WinCreateStdWindow
*  DosBeep		    WinGetMsg		   WinCreateWindow
*  DosClose		    WinGetPs		   WinDefDlgProc
*  DosExit		    WinInitialize	   WinDefDlgProc
*  DosExitList		    WinIsWindow		   WinDefWindowProc
*  DosFreeMem		    WinLoadMenu		   WinDestroyHelpINstance
*  DosOpen		    WinLoadString	   WinDestroyWIndow
*  DosRead		    WinMapWIndowPoints	   WinDismissDlg
*  DosWrite		    WinMessageBox	   WinDispatchMsg
*  GpiCreateLogFont	    WinOpenClipbrd	   WinDlgBox
*  GpiDeleteSetID	    WinPopupMenu	   WinEndPaint
*  GpiQueryFontMetrics	    WinPostMsg		   WinSendMsg
*  GpiQueryFonts	    WinQueryClipbrdFmtInfo WinSetDlgItemText
*  GpiSetCharSet	    WinQueryFocus	   WinSetFocus
*  WinSendDlgItemMsg	    WinQueryTaskTitle	   WinSetPresParms
*  WinTerminate		    WinQueryWindowPos	   WinSetWindosPos
*  WinAlarm		    WinQueryWindowRect	   WinSetWindowText
*  WinAssociateHelpInstance WinQueryWindowText	   WinTerminate
*  WinBeginPaint	    WinQueryWindowUShort   WinWindosFormID
*  WinCloseClipbrd	    WinRegisterClass	   WinDestroyMsgQueue
*  WinCreateHelpInstance    WinReleasePS	   WinFileDlg
*  WinCreateMsgQueue	    WinRemovePresParms	   WinFillRect
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.						      *
*
************************************************************************/

/* Include files, macros, defined constants, and externs		*/

#define	 INCL_WINHELP

#include <os2.h>
#include "sty_main.h"
#include "sty_xtrn.h"
#include "sty_help.h"

#define RETURN_SUCCESS	    0		 /* successful return in DosExit */
#define RETURN_ERROR	    1		 /* error return in DosExit	 */
#define BEEP_WARN_FREQ	    60		 /* frequency of warning beep	 */
#define BEEP_WARN_DUR	   100		 /* duration of warning beep	 */


/*  Global variables							 */

HWND hwndMainFrame;		     /* handle to the main frame window */
HWND hwndMain;			     /* handle to the main client window */
HDC  hdcMain;			     /* handle to the DC of the client */
HAB hab;			     /* anchor block for the process */
HMQ hmq;			     /* handle to the process' message queue */
CHAR szAppName[MAXNAMEL];	     /* buffer for application name string */
CHAR szUntitled[MESSAGELEN];	     /* buffer for "Untitled" string */
BOOL fHelpEnabled;		     /* flag to determine if help is enabled */

/****************************************************************
 *  Name:   main()
 *
 *  Description: Entry point of program.
 *
 *  Concepts: Obtains anchor block handle and creates message
 *	      queue.  Calls the initialization routine.
 *	      Creates the main frame window which creates the
 *	      main client window.  Polls the message queue
 *	      via Get/Dispatch Msg loop.  Upon exiting the
 *	      loop, exits.
 *
 *  API's   :  WinInitilize
 *	       DosBeep
 *	       WinCreateMsgQueue
 *	       WinTerminate
 *	       WinCreateStdWindow
 *	       WinSetWindowText
 *	       WinGetMsg
 *	       WinDispatchMsg
 *
 *  Parameters: None
 *
 *  Returns:
 *	    1 - if sucessful execution completed
 *	    0 - if error
\****************************************************************/
int main (VOID)
{
   QMSG qmsg;	       /* message structure */
   ULONG ulCtlData;	 /* frame control data */

   hab = WinInitialize(0);
   if(!hab)
   {
      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      return(RETURN_ERROR);
   }

   hmq = WinCreateMsgQueue(hab, 0);
   if(!hmq)
   {
      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      WinTerminate(hab);
      return(RETURN_ERROR);
   }

   if(!Init())
   {
      MessageBox(HWND_DESKTOP, IDMSG_INITFAILED, MB_OK | MB_ERROR, TRUE);
      return(RETURN_ERROR);
   }

   /* NOTE:  clean up from here is handled by the DosExitList processing */

   /* create the main window */
   ulCtlData = FCF_STANDARD;

   hwndMainFrame = WinCreateStdWindow(HWND_DESKTOP, WS_VISIBLE,
				      (PVOID)&ulCtlData, (PSZ)szAppName,
				      (PSZ)NULL, WS_VISIBLE,
				      (HMODULE)NULL, IDR_MAIN,
				      (PHWND)&hwndMain);

   if(!hwndMainFrame)
   {
      MessageBox(HWND_DESKTOP, IDMSG_MAINWINCREATEFAILED, MB_OK | MB_ERROR,
		  TRUE);
      return(RETURN_ERROR);
   }

   WinSetWindowText(hwndMainFrame, szAppName);

   InitHelp();

   /* Get/Dispatch Message loop					 */
   while(WinGetMsg(hab, (PQMSG)&qmsg, 0, 0, 0))
       WinDispatchMsg(hab, (PQMSG)&qmsg);

   DestroyHelpInstance();

   return(RETURN_SUCCESS);

} /* End of main porcedure  */



/****************************************************************
 *  Name:   MainWndProc
 *
 *  Description : Window procedure for the main clent window.
 *
 *  Concepts : Processes the messages sent to the main client
 *	       window.	This routine processes the basic
 *	       messages all client windows should process and
 *	       passes all others onto UserWndProc where the
 *	       developer can process any others.
 *
 *  API's : None
 *
 * Parameters	: hwnd - Window handle to which message is addressed
 *		  msg - Message type
 *		  mp1 - First message parameter
 *		  mp2 - Second message parameter
 *
 *  Returns:  Return values are determined by each message
 *
 ****************************************************************/
MRESULT EXPENTRY MainWndProc(HWND hwnd, USHORT msg, MPARAM mp1, MPARAM mp2)
{
   switch(msg)
   {
      case WM_CREATE:
	 return(InitMainWindow(hwnd, mp1, mp2));
	 break;

      case WM_PAINT:
	 MainPaint(hwnd);
	 break;

      case WM_COMMAND:
	 MainCommand(mp1, mp2);
	 break;

      case WM_INITMENU:
	 InitMenu(mp1, mp2);
	 break;

      case HM_QUERY_KEYS_HELP:
	 return (MRESULT)PANEL_HELPKEYS;     /* return id of key help panel */
	 break;

    /*
     * Any messages not processed are passed on
     * to the user's window proc.  It is
     * responsible for passing any messages it
     * doesn't handle onto WinDefWindowProc()
     */
      default:
	 return(UserWndProc(hwnd, msg, mp1, mp2));
	 break;

   }
   return (MRESULT)0; /* all window procedures should return 0 as a default */

}   /* End of MainWndProc() */

/*********************************************************************
 *  Name:   MessageBox
 *
 *  Description : Message Box procedure
 *
 *  Concepts : Displays the warning message box with the message
 *	       given in idMsg retrived from the message table;
 *	       Called wherever an error occurs and a message should
 *	       be displayed to the user
 *
 *  API's : WinLoadString
 *	    WinLoadMessage
 *	    WinAlarm
 *	    WinMessageBox
 *
 *  Parameters :  hwndOwner - window handle of the owner of the
 *			      message box
 *		  idMsg	    - id of message to be retrieved from
 *			      resource file
 *		  fsStyle   - message box style
 *		  fBeep	    - flag to sound alarm
 *
 *  Returns: SHORT
 *
\****************************************************************/
SHORT MessageBox(HWND hwndOwner, SHORT idMsg, SHORT fsStyle, BOOL fBeep)
{
   CHAR szText[MESSAGELEN];
   CHAR szTitle[MESSAGELEN];
   PSZ	pszTitle = NULL;

   if(!WinLoadMessage(hab, (HMODULE)NULL, idMsg, MESSAGELEN, (PSZ)szText))
   {
      WinAlarm(HWND_DESKTOP, WA_ERROR);
      return (SHORT)MBID_ERROR;
   }

   if(fBeep)
      WinAlarm(HWND_DESKTOP, WA_ERROR);

   if ( (fsStyle & MB_WARNING)			      /* use warning title ? */
       && WinLoadString(hab, (HMODULE)0, IDS_WARNING, MESSAGELEN, szTitle) )
	 pszTitle = szTitle;
   else
      pszTitle = NULL; /* default to error title */

   return(WinMessageBox(HWND_DESKTOP, hwndOwner, szText, pszTitle,
	  IDD_MSGBOX, fsStyle));

}   /* End of MessageBox() */

/****************************************************************\
 *  Name:   MainCommand
 *
 *  Purpose: Main window WM_COMMAND processing procedure
 *
 *  Concepts : Routine is called whenever a WM_COMMAND message is
 *	       posted to the main window.  A switch statement
 *	       branches on the id of the menu item that posted the
 *	       message and the appropriate action for that item is
 *	       taken.  Any menu ids that are not part of the
 *	       standard menu set are passed onto the user defined
 *	       WM_COMMAND processing procedure.
 *
 *  API's : WinPostMsg
 *
 *  Parameters :  mp1 - First message parameter
 *		  mp2 - Second message parameter
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID MainCommand(MPARAM mp1, MPARAM mp2)
{
   switch(SHORT1FROMMP(mp1))
   {
      case IDM_EXIT:
	 WinPostMsg( hwndMain, WM_QUIT, NULL, NULL );
	 break;

      case IDM_FILENEW:
	 FileNew(mp2);
	 break;

      case IDM_FILEOPEN:
	 FileOpen(mp2);
	 break;

      case IDM_FILESAVE:
	 FileSave(mp2);
	 break;

      case IDM_FILESAVEAS:
	 FileSaveAs(mp2);
	 break;

      case IDM_EDITUNDO:
	 EditUndo(mp2);
	 break;

      case IDM_EDITCUT:
	 EditCut(mp2);
	 break;

      case IDM_EDITCOPY:
	 EditCopy(mp2);
	  break;

      case IDM_EDITPASTE:
	 EditPaste(mp2);
	 break;

      case IDM_EDITCLEAR:
	 EditClear(mp2);
	 break;

      case IDM_HELPUSINGHELP:
	 HelpUsingHelp(mp2);
	 break;

      case IDM_HELPGENERAL:
	 HelpGeneral(mp2);
	 break;

      case IDM_HELPKEYS:
	 HelpKeys(mp2);
	 break;

      case IDM_HELPINDEX:
	 HelpIndex(mp2);
	 break;

      case IDM_HELPPRODINFO:
	 HelpProdInfo(mp2);
	 break;
    /*
     * User command processing routine is called
     * here so any ids not procecessed here can be
     * processed
     */
      default:
	 UserCommand(mp1, mp2);
	 break;
   }
}   /* MainCommand() */
/*************************************************************************
*
*  File Name   : STY_PNT.C
*
*  Description :This module contains the code for the
*		main client window painting
*
*  Concepts    : Painting of main client window.
*
*  API's       : WinBeginPaint
*		 WinFillRect
*		 WinEndPaint
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.						      *
*
************************************************************************/

/*  Include files, macros, defined constants, and externs		*/

#define	 INCL_WINSYS

#include <os2.h>
#include "sty_main.h"
#include "sty_xtrn.h"

/*  Global variables							*/

/*  Entry point declarations						*/

/****************************************************************
 *  Name:   MainPaint
 *
 *  Description : Main client painting routine
 *
 *  Concepts :	Routine is called whenver the client window
 *		procedure receives a WM_PAINT message begins
 *		painting by calling WinBeginPaint and
 *		retriving the HPS for the window performs any
 *		painting desired ends painting by calling
 *		WinEndPaint
 *
 *  API's :  WinBeginPaint
 *	     WinFillRect
 *	     WinEndPaint
 *
 *  Parameters : hwnd - handle of window to paint
 *
 *  Returns :  VOID
 *
 ****************************************************************/
VOID MainPaint(HWND hwnd)
{
    RECTL rclUpdate;
    HPS hps;

    hps = WinBeginPaint(hwnd, NULLHANDLE, (PRECTL)&rclUpdate);

    /* fill update rectangle with window color */
    WinFillRect(hps, (PRECTL)&rclUpdate, SYSCLR_WINDOW);

    /*
     * Add painting routines here.  Hps is now the HPS for
     * the window and rclUpdate contains the update rectangle.
     */

    WinEndPaint(hps);

}   /* MainPaint() */
/*************************************************************************
*
*  File Name   : STY_USER.C
*
*  Description : This module contains the code for processing
*		 messages sent to the standard window that the
*		 standard window does not process.
*
*  Concepts    : Message processing
*
*  API's       : WinSetWindowPos
*		 WinSetFocus
*		 WinDefWIndowProc
*		 WinDlgBox
*		 WinSendMsg
*		 WinOpenClipbrd
*		 WinQueryClipbrdFmtInfo
*		 WinCloseClipbrd
*		 WinMessageBox
*		 WinLoadString
*		 WinSendMsg
*		 GpiCreateLogFont
*		 GpiSetCharSet
*		 GpiQueryFontMetrics
*		 GpiDeleteSetId
*		 WinGetPS
*		 WinReleasePS
*		 WinFontDlg
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.						      *
*
************************************************************************/

/*  Include files, macros, defined constants, and externs		*/

#define INCL_WINMENUS
#define INCL_WINWINDOWMGR
#define INCL_WINCLIPBOARD
#define INCL_WINMLE
#define INCL_WINSTDFONT
#define INCL_GPILCIDS
#define INCL_GPIPRIMITIVES
#define INCL_WINSYS
#define INCL_DOSDEVICES	  /* Device values */

#include <os2.h>
#include "sty_main.h"
#include "sty_xtrn.h"
#include "sty_dlg.h"
#include <string.h>

/*  Global variables */

LONG lClrForeground = CLR_BLACK;		    /* color for window text */
LONG lClrBackground = CLR_WHITE;		     /* color for background */

LONG lClrDefaultForeground = CLR_BLACK;		    /* color for window text */
LONG lClrDefaultBackground = CLR_WHITE;		     /* color for background */

/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/

VOID SetForegroundColor(SHORT idMenu);
VOID SetBackgroundColor(SHORT idMenu);
VOID SetFont(VOID);
VOID ConvertVectorFontSize(FIXED fxPointSize, PFATTRS pfattrs);
MRESULT EXPENTRY DemoDlgProc(HWND hwnd, USHORT msg,
				  MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY PresParamDemoDlgProc(HWND hwnd, USHORT msg,
				  MPARAM mp1, MPARAM mp2);
VOID ShowDemoDlg(SHORT idMenuItem);
VOID ShowDemoMsgBox(SHORT idMenuItem);

/*********************************************************************
 *  Name: UserWndProc
 *
 *  Description : Process any messages sent to hwndMain
 *		  that are not processed by the standard
 *		  window procedure.
 *
 *  Concepts : Routine is called for each message MainWndProc does
 *	       not process.  A switch statement branches control
 *	       based upon the message passed.  Any messages not
 *	       processed here must be passed onto
 *	       WinDefWindowProc()
 *
 *  API's : WinSetWindowPos
 *	    WinSetFocus
 *	    WinDefWIndowProc
 *
 * Parameters	: hwnd - Window handle to which message is addressed
 *		  msg - Message type
 *		  mp1 - First message parameter
 *		  mp2 - Second message parameter
 *
 *  Returns: Return value depended upon the message processed
 *
 ****************************************************************/
MRESULT UserWndProc( HWND hwnd, USHORT msg, MPARAM mp1, MPARAM mp2)
{
   switch(msg)
   {
      case WM_SIZE:
	 /*
	  * Re-size the MLE to be the same width and height
	  * as the client window
	  */
	 WinSetWindowPos(hwndMLE, HWND_TOP, 0, 0, SHORT1FROMMP(mp2),
			    SHORT2FROMMP(mp2), SWP_SIZE);
	 break;

      case WM_SETFOCUS:
	 if(SHORT1FROMMP(mp1))
	 {
	    WinPostMsg(hwnd, SM_SETFOCUS, NULL, NULL);
	 }
	 break;

      case SM_SETFOCUS:
	 WinSetFocus(HWND_DESKTOP, hwndMLE);
	 break;

      default:
	 /*
	  * Default must call WinDefWindowProc()
	  */
	 return(WinDefWindowProc(hwnd, msg, mp1, mp2));
	 break;
   }

   return (MRESULT)0;

}   /*	  End of UserWndProc()						*/

/*********************************************************************
 *  Name: UserCommand
 *
 *  Description : Process any WM_COMMAND messages send to
 *		  hwndMain that are not processed by MainCommand
 *
 *  Concepts : Routine is called for each WM_COMMAND that is not
 *	       posted by a standard menu item. A switch statement
 *	       branches control based upon the id of the control
 *	       which posted the message.
 *
 *  API's : WinDlgBox
 *
 *  Parameters :  mp1 - First message parameter
 *		  mp2 - Second message parameter
 *
 *  Returns: Void
 *
 ****************************************************************/
VOID UserCommand(MPARAM mp1, MPARAM mp2)
{
   switch(SHORT1FROMMP(mp1))
   {
      case IDM_OPTIONSFORECOLORBLACK:
      case IDM_OPTIONSFORECOLORBLUE:
      case IDM_OPTIONSFORECOLORRED:
      case IDM_OPTIONSFORECOLORDEFAULT:
	  SetForegroundColor(SHORT1FROMMP(mp1));
	  break;

      case IDM_OPTIONSBACKCOLORPINK:
      case IDM_OPTIONSBACKCOLORCYAN:
      case IDM_OPTIONSBACKCOLORYELLOW:
      case IDM_OPTIONSBACKCOLORDEFAULT:
	  SetBackgroundColor(SHORT1FROMMP(mp1));
	  break;

      case IDM_OPTIONSFONT:
	  SetFont();
	  break;

      case IDM_DEMODLGBUTTONS:
      case IDM_DEMODLGLISTBOXES:
      case IDM_DEMODLGCOMBOBOXES:
      case IDM_DEMODLGENTRYFIELDS:
      case IDM_DEMODLGSTATIC:
      case IDM_DEMODLGSLIDER:
      case IDM_DEMODLGSPINBUTTON:
      case IDM_DEMODLGVALUESET:
      case IDM_DEMODLGNOTEBOOK:
      case IDM_DEMODLGCONTAINER:
	  ShowDemoDlg(SHORT1FROMMP(mp1));
	  break;

      case IDM_DEMOMSGBOXOK:
      case IDM_DEMOMSGBOXOKCANCEL:
      case IDM_DEMOMSGBOXYESNO:
      case IDM_DEMOMSGBOXYESNOCANCEL:
      case IDM_DEMOMSGBOXRETRYCANCEL:
      case IDM_DEMOMSGBOXABORT:
      case IDM_DEMOMSGBOXENTER:
      case IDM_DEMOMSGBOXENTERCANCEL:
      case IDM_DEMOMSGBOXQUERY:
      case IDM_DEMOMSGBOXWARNING:
      case IDM_DEMOMSGBOXINFO:
      case IDM_DEMOMSGBOXCRITICAL:
      case IDM_DEMOMSGBOXAPP:
      case IDM_DEMOMSGBOXSYS:
      case IDM_DEMOMSGBOXHELP:
	  ShowDemoMsgBox(SHORT1FROMMP(mp1));
	  break;

      case IDM_DEMODLGPP:
	  WinDlgBox(hwndMain, hwndMain, (PFNWP)PresParamDemoDlgProc,
		    (HMODULE)0, IDD_PPDEMODLG, (PVOID)NULL);
	  break;

      default:
	  break;
   }
 /*
  * This routine currently doesn't use the mp2 parameter but
  * it is referenced here to prevent an 'Unreferenced Parameter'
  * warning at compile time.
  */
  mp2 = mp2;
}   /*	  End of UserCommand()						*/

/*********************************************************************
 *  Name: InitMenu
 *
 *  Description : Processes the WM_INITMENU message for the main
 *		  window, disabling any menus that are not active
 *
 *  Concepts : Routine is called each time a menu is selected.	A
 *	       switch statement branches control based upon the
 *	       id of the menu which is being displayed.
 *
 *  API's : WinSendMsg
 *	    WinOpenClipbrd
 *	    WinQueryClipbrdFmtInfo
 *	    WinCloseClipbrd
 *
 *  Parameters :  mp1 - First message parameter
 *		  mp2 - Second message parameter
 *
 *  Returns: Nome
 *
 ****************************************************************/
VOID InitMenu( MPARAM mp1, MPARAM mp2)
{
   ULONG  ulFmtInfo;
   BOOL bEnable;
   MRESULT mr1, mr2;

   switch(SHORT1FROMMP(mp1))
   {
      case IDM_HELP:
      /*
       * Enable or disable the Help menu depending upon whether the
       * help manager has been enabled
       */
	 EnableMenuItem(HWNDFROMMP(mp2), IDM_HELPUSINGHELP, fHelpEnabled);
	 EnableMenuItem(HWNDFROMMP(mp2), IDM_HELPGENERAL, fHelpEnabled);
	 EnableMenuItem(HWNDFROMMP(mp2), IDM_HELPKEYS, fHelpEnabled);
	 EnableMenuItem(HWNDFROMMP(mp2), IDM_HELPINDEX, fHelpEnabled);
	 break;

      case IDM_EDIT:
      /*
       * if text is selected in the MLE, the enable the Cut, Copy,
       * and Clear menus.  Otherwise, do not
       */
	 mr1 = WinSendMsg(hwndMLE, MLM_QUERYSEL,
			   MPFROMSHORT(MLFQS_MINSEL), NULL);

	 mr2 = WinSendMsg(hwndMLE, MLM_QUERYSEL,
			   MPFROMSHORT(MLFQS_MAXSEL), NULL);

	 if (mr1 != mr2)
	    bEnable = TRUE;
	 else
	    bEnable = FALSE;

	 EnableMenuItem(HWNDFROMMP(mp2), IDM_EDITCUT, bEnable);
	 EnableMenuItem(HWNDFROMMP(mp2), IDM_EDITCOPY, bEnable);
	 EnableMenuItem(HWNDFROMMP(mp2), IDM_EDITCLEAR, bEnable);

	 /*
	  * determine if the MLE can Undo the last action.  If it can't,
	  * then disable he Undo menu
	  */

	 mr1 =	WinSendMsg(hwndMLE, MLM_QUERYUNDO, NULL, NULL);
	 if (mr1 != 0)
	    bEnable = TRUE;
	 else
	    bEnable = FALSE;

	 EnableMenuItem(HWNDFROMMP(mp2), IDM_EDITUNDO, bEnable);

	 /*
	  * determine if the clipboard has some text on it.  If it
	  * doesn't, then disable the Paste menu
	  */
	 if(WinOpenClipbrd(hab))
	 {
	   if (WinQueryClipbrdFmtInfo(hab, CF_TEXT, &ulFmtInfo))
	      bEnable = TRUE;
	   else
	      bEnable = FALSE;
	   WinCloseClipbrd(hab);
	 }
	 else
	    bEnable = TRUE;

	 EnableMenuItem(HWNDFROMMP(mp2), IDM_EDITPASTE, bEnable);
	 break;

      case IDM_OPTIONSFORECOLOR:
	 {
	  LONG lColor;
	  BOOL bBlack = TRUE;
	  BOOL bBlue = TRUE;
	  BOOL bRed = TRUE;
	  BOOL bDefault = TRUE;

	  lColor = (LONG)WinSendMsg(hwndMLE,MLM_QUERYTEXTCOLOR, NULL, NULL);
	  switch (lColor)
	  {
	     case CLR_BLACK:
		bBlack = FALSE;
		break;
	     case CLR_BLUE:
		bBlue = FALSE;
		break;
	     case CLR_RED:
		bRed = FALSE;
		break;
	     default:
		bDefault = FALSE;
		break;
	   }

	   EnableMenuItem(HWNDFROMMP(mp2), IDM_OPTIONSFORECOLORBLACK,
			   bBlack);
	   EnableMenuItem(HWNDFROMMP(mp2), IDM_OPTIONSFORECOLORBLUE, bBlue);
	   EnableMenuItem(HWNDFROMMP(mp2), IDM_OPTIONSFORECOLORRED, bRed);
	   EnableMenuItem(HWNDFROMMP(mp2), IDM_OPTIONSFORECOLORDEFAULT,
			   bDefault);
	 }
	 break;
      case IDM_OPTIONSBACKCOLOR:
	 {
	  LONG lColor;
	  BOOL bYellow = TRUE;
	  BOOL bPink = TRUE;
	  BOOL bCyan = TRUE;
	  BOOL bDefault = TRUE;

	  lColor = (LONG)WinSendMsg(hwndMLE,MLM_QUERYBACKCOLOR, NULL, NULL);
	  switch (lColor)
	  {
	     case CLR_YELLOW:
		bYellow = FALSE;
		break;
	     case CLR_PINK:
		bPink = FALSE;
		break;
	     case CLR_CYAN:
		bCyan = FALSE;
		break;
	     default:
		bDefault = FALSE;
		break;
	   }

	   EnableMenuItem(HWNDFROMMP(mp2), IDM_OPTIONSBACKCOLORYELLOW,
			   bYellow);
	   EnableMenuItem(HWNDFROMMP(mp2), IDM_OPTIONSBACKCOLORPINK, bPink);
	   EnableMenuItem(HWNDFROMMP(mp2), IDM_OPTIONSBACKCOLORCYAN, bCyan);
	   EnableMenuItem(HWNDFROMMP(mp2), IDM_OPTIONSBACKCOLORDEFAULT,
			   bDefault);
	 }
	 break;

      default:
	  break;
   }
}   /*	     End of InitMenu()						*/

/*********************************************************************
 *  Name: EnableMenuItem
 *
 *  Description : Enables or disables menu item.
 *
 *  Concepts : Called whenever a menu item is to be enabled or
 *	       disabled.  Sends a MM_SETITEMATTR to the menu with
 *	       the given item id.  Sets the MIA_DISABLED
 *	       attribute flag if the item is to be disabled,
 *	       clears the flag if enabling.
 *
 *  API's : WinSendMsg
 *
 *  Parameters	 : hwnd - Window handle of the menu
 *		   sIditem  - Id of the menu item.
 *		   bEnable - Enable/Disable flag
 *
 *  Returns: Void
 *
 ****************************************************************/
VOID EnableMenuItem( HWND hwndMenu, SHORT sIditem, BOOL bEnable)
{
  SHORT sFlag;

  if(bEnable)
    sFlag = 0;
  else
    sFlag = MIA_DISABLED;

  WinSendMsg(hwndMenu, MM_SETITEMATTR, MPFROM2SHORT(sIditem, TRUE),
	       MPFROM2SHORT(MIA_DISABLED, sFlag));

}   /*	       End of EnableMenuItem()					*/

/*********************************************************************
 *  Name: ShowDemoDlg
 *
 *  Description : Displays the demonstration dialog for the menu
 *		  id chosen.
 *
 *  Concepts : Called whenever a menu item from the Dialog Box
 *	       menu of the Demo menu is selected.  Determines the
 *	       id of the dialog template and creates a dialog of
 *	       that template.
 *
 *  API's : WinDlgBox
 *
 *  Parameters :   sIdMenuItem - Id of the menu item.
 *
 *  Returns: Void
 *
 ****************************************************************/
VOID ShowDemoDlg( SHORT sIdMenuItem)
{
  static SHORT sIdDlg;

  switch(sIdMenuItem)
  {
     case IDM_DEMODLGBUTTONS:
	 sIdDlg = IDD_BUTTONSDLG;
	 break;

     case IDM_DEMODLGLISTBOXES:
	 sIdDlg = IDD_LISTBOXDLG;
	 break;

     case IDM_DEMODLGCOMBOBOXES:
	 sIdDlg = IDD_COMBOBOXDLG;
	 break;

     case IDM_DEMODLGENTRYFIELDS:
	 sIdDlg = IDD_ENTRYFIELDDLG;
	 break;

     case IDM_DEMODLGSTATIC:
	 sIdDlg = IDD_STATICDLG;
	 break;

     case IDM_DEMODLGSLIDER:
	 sIdDlg = IDD_SLIDERDLG;
	 break;

     case IDM_DEMODLGSPINBUTTON:
	 sIdDlg = IDD_SPINBUTTONDLG;
	 break;

     case IDM_DEMODLGVALUESET:
	 sIdDlg = IDD_VALUESETDLG;
	 break;

     case IDM_DEMODLGNOTEBOOK:
	 sIdDlg = IDD_NOTEBOOKDLG;
	 break;
     case IDM_DEMODLGCONTAINER:
	 sIdDlg = IDD_CONTAINERDLG;
	 break;

     default:	 /* unknown menu id */
	 return;
	 break;
  }

  WinDlgBox(HWND_DESKTOP, hwndMain,
	   (PFNWP)DemoDlgProc,		/* all demos use DemoDlgProc	*/
	   (HMODULE)0,
	   sIdDlg,			/* id of template		*/
	   (PVOID)&sIdDlg);		/* pass id as mp2 of WM_INITDLG */

}   /*	    End of ShowDemoDlg()					*/


/*********************************************************************
 *  Name: ShowDemoMsgBox
 *
 *  Description : Displays the demonstration message box for the menu
 *		  id chosen.
 *
 *  Concepts :	Called whenever a menu item from the Message Box menu
 *		of the Demo menu is selected.  Determines the options
 *		for the message box and then creates the box.
 *
 *  API's : WinLoadString
 *	    WinMessageBox
 *
 *  Parameters : sIdMenuItem - Id of the menu item.
 *
 *  Returns: VOID
 *
 ****************************************************************/
VOID ShowDemoMsgBox( SHORT sIdMenuItem)
{
  SHORT sOptions, sIdText;
  CHAR szText[MESSAGELEN];

  switch(sIdMenuItem)
  {
     case IDM_DEMOMSGBOXOK:
	sOptions = MB_OK | MB_MOVEABLE;
	sIdText = IDS_DEMOMSGBOXOK;
	break;

     case IDM_DEMOMSGBOXOKCANCEL:
	sOptions = MB_OKCANCEL | MB_MOVEABLE;
	sIdText = IDS_DEMOMSGBOXOKCANCEL;
	break;

     case IDM_DEMOMSGBOXYESNO:
	sOptions = MB_YESNO | MB_MOVEABLE;
	sIdText = IDS_DEMOMSGBOXYESNO;
	break;

     case IDM_DEMOMSGBOXYESNOCANCEL:
	sOptions = MB_YESNOCANCEL | MB_MOVEABLE;
	sIdText = IDS_DEMOMSGBOXYESNOCANCEL;
	break;

     case IDM_DEMOMSGBOXRETRYCANCEL:
	sOptions = MB_RETRYCANCEL | MB_MOVEABLE;
	sIdText = IDS_DEMOMSGBOXRETRYCANCEL;
	break;

     case IDM_DEMOMSGBOXABORT:
	sOptions = MB_ABORTRETRYIGNORE | MB_MOVEABLE;
	sIdText = IDS_DEMOMSGBOXABORT;
	break;

     case IDM_DEMOMSGBOXENTER:
	sOptions = MB_ENTER | MB_MOVEABLE;
	sIdText = IDS_DEMOMSGBOXENTER;
	break;

     case IDM_DEMOMSGBOXENTERCANCEL:
	sOptions = MB_ENTERCANCEL | MB_MOVEABLE;
	sIdText = IDS_DEMOMSGBOXENTERCANCEL;
	break;

     case IDM_DEMOMSGBOXQUERY:
	sOptions = MB_OK | MB_QUERY | MB_MOVEABLE;
	sIdText = IDS_DEMOMSGBOXQUERY;
	break;

     case IDM_DEMOMSGBOXWARNING:
	sOptions = MB_OK | MB_WARNING | MB_MOVEABLE;
	sIdText = IDS_DEMOMSGBOXWARNING;
	break;

     case IDM_DEMOMSGBOXINFO:
	sOptions = MB_OK | MB_INFORMATION | MB_MOVEABLE;
	sIdText = IDS_DEMOMSGBOXINFO;
	break;

     case IDM_DEMOMSGBOXCRITICAL:
	sOptions = MB_OK | MB_CRITICAL | MB_MOVEABLE;
	sIdText = IDS_DEMOMSGBOXCRITICAL;
	break;

     case IDM_DEMOMSGBOXAPP:
	sOptions = MB_OK | MB_APPLMODAL | MB_MOVEABLE;
	sIdText = IDS_DEMOMSGBOXAPP;
	break;

     case IDM_DEMOMSGBOXSYS:
	sOptions = MB_OK | MB_SYSTEMMODAL | MB_MOVEABLE;
	sIdText = IDS_DEMOMSGBOXSYS;
	break;

     case IDM_DEMOMSGBOXHELP:
	sOptions = MB_OK | MB_HELP | MB_MOVEABLE;
	sIdText = IDS_DEMOMSGBOXHELP;
	break;

     default:
	/*
	* Unknown menu id
	*/
	return;
	break;
  }

  /*
  * Get the text for the message box
  */
  if(!WinLoadString(hab, (HMODULE)0, sIdText, MESSAGELEN, (PSZ)szText))
  {
     MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
	return;
  }

  /* bring up the message box						*/
  WinMessageBox(HWND_DESKTOP, hwndMain, szText, szAppName, IDD_DEMOMSGBOX,
		sOptions);

}   /*	 End of ShowDemoMsgBox()					*/

/*********************************************************************
 *  Name: SetForegroundColor
 *
 *  Description : Allows the user to select a color for the
 *		  window foreground
 *
 *  Concepts : Routine is called each time the user selects one
 *	       of the Foreground colors listed in the Foreground
 *	       Color submenu of the Options menu.  A switch
 *	       statement determines which menu item was chosen
 *	       and then the appropriate color is placed into
 *	       lClrForeground.
 *
 *  API's : WinSendMsg
 *
 *  Parameters : sIdItem - Id of the menu item.
 *
 *  Returns: Void
 *
 ****************************************************************/
VOID SetForegroundColor(SHORT sIdMenu)
{
   switch(sIdMenu)
   {
      case IDM_OPTIONSFORECOLORBLACK:
	 lClrForeground = CLR_BLACK;
	 break;

      case IDM_OPTIONSFORECOLORBLUE:
	 lClrForeground = CLR_BLUE;
	 break;

      case IDM_OPTIONSFORECOLORRED:
	 lClrForeground = CLR_RED;
	 break;

      /*
       *  For any others, including IDM_OPTIONSBACKCOLORDEFAULT, set
       *  the background color to the default back color
       */
      default:
	 lClrForeground = lClrDefaultForeground;
	 break;
   }
   WinSendMsg(hwndMLE, MLM_SETTEXTCOLOR, MPFROMLONG(lClrForeground), NULL);
}   /*	 End of SetForegroundColor()					*/

/*********************************************************************
 *  Name: SetBackgroundColor
 *
 *  Description : Allows the user to select a color for the
 *		  window Background
 *
 *  Concepts : Routine is called each time the user selects one
 *	       of the Background colors listed in the Background
 *	       Color submenu of the Options menu.  A switch
 *	       statement determines which menu item was chosen
 *	       and then the appropriate color is placed into
 *	       lClrBackground.
 *
 *  API's : WinSendMsg
 *
 *  Parameters : sIdItem - Id of the menu item.
 *
 *  Returns: Void
 *
 ****************************************************************/
VOID SetBackgroundColor( SHORT idMenu)
{
   switch(idMenu)
   {
      case IDM_OPTIONSBACKCOLORPINK:
	 lClrBackground = CLR_PINK;
	 break;

      case IDM_OPTIONSBACKCOLORCYAN:
	 lClrBackground = CLR_CYAN;
	 break;

      case IDM_OPTIONSBACKCOLORYELLOW:
	 lClrBackground = CLR_YELLOW;
	 break;

      /*
       *  For any others, including IDM_OPTIONSBACKCOLORDEFAULT, set
       *  the background color to the default back color
       */
      default:
	 lClrBackground = lClrDefaultBackground;
	 break;
   }
   WinSendMsg(hwndMLE, MLM_SETBACKCOLOR, MPFROMLONG(lClrBackground), NULL);
}   /*	End of SetBackgroundColor()					*/


/*********************************************************************
 *  Name: SetFont
 *
 *  Description : Allows the user to select a font for the text
 *		  displayed in the MLE.
 *
 *  Concepts : Routine is called each time the user selects the
 *	       Font menu item from the Options menu.  The
 *	       standard font dialog is called with the current
 *	       available fonts.	 If the user selects one, then
 *	       the MLM_SETFONT message is sent to the MLE to
 *	       display its text to the font chosen.
 *
 *  API's : WinSendMsg
 *	    GpiCreateLogFont
 *	    GpiSetCharSet
 *	    GpiQueryFontMetrics
 *	    GpiDeleteSetId
 *	    WinGetPS
 *	    WinReleasePS
 *	    WinLoadString
 *	    WinFontDlg
 *
 *  Parameters :  None
 *
 *  Returns: None
 *
 ****************************************************************/
VOID SetFont(void)
{
   FONTDLG fontDlg;
   HPS hpsMLE;
   FONTMETRICS fontMetrics;
   CHAR szTitle[MESSAGELEN];
   CHAR szFamily[CCHMAXPATH];
   static fxPointSize = 0;	      /* keep track of this for vector fonts */

   memset(&fontDlg, 0, sizeof(fontDlg));	    /* initialize all fields */
   /*
    * Get the current font attributes
    */
   hpsMLE = WinGetPS(hwndMLE);
   WinSendMsg(hwndMLE, MLM_QUERYFONT,
      MPFROMP((PFATTRS)&(fontDlg.fAttrs)), NULL);

   /* create system default font */

   GpiCreateLogFont(
      hpsMLE,
      (PSTR8)fontDlg.fAttrs.szFacename,
      1,
      &(fontDlg.fAttrs));

   GpiSetCharSet(hpsMLE, 1);

   GpiQueryFontMetrics(hpsMLE, sizeof(FONTMETRICS), &fontMetrics);

   GpiSetCharSet(hpsMLE, LCID_DEFAULT);
   GpiDeleteSetId(hpsMLE, 1);
   WinReleasePS(hpsMLE);
   if(!WinLoadString(hab, (HMODULE)0, IDS_FONTDLGTITLE, MESSAGELEN, szTitle))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, TRUE);
      return;
   }

   /*
    * Initialize the FONTDLG structure with the current font
    */
   fontDlg.cbSize     = sizeof(FONTDLG);		  /* sizeof(FONTDLG) */
   fontDlg.hpsScreen  = WinGetScreenPS(HWND_DESKTOP);  /* Screen presentation space */
   fontDlg.hpsPrinter = NULLHANDLE;	       /* Printer presentation space */
   fontDlg.pszTitle	 = szTitle;	  /* Application supplied title	     */
   fontDlg.pszPreview	 = NULL;	  /* String to print in preview wndw */
   fontDlg.pszPtSizeList = NULL;	  /* Application provided size list  */
   fontDlg.pfnDlgProc	 = NULL;	  /* Dialog subclass procedure	     */
   strcpy(szFamily, fontMetrics.szFamilyname); /* Family name of font	     */
   fontDlg.pszFamilyname = szFamily;	  /* point to Family name of font    */
   fontDlg.fxPointSize = fxPointSize;	  /* Point size the user selected    */
   fontDlg.fl		= FNTS_CENTER |	  /* FNTS_* flags - dialog styles    */
			   FNTS_INITFROMFATTRS;
   fontDlg.flFlags	= 0;		  /* FNTF_* state flags		     */
					  /* Font type option bits	     */
   fontDlg.flType	= (LONG) fontMetrics.fsType;
   fontDlg.flTypeMask	= 0;		  /* Mask of which font types to use */
   fontDlg.flStyle	= 0;		  /* The selected style bits	     */
   fontDlg.flStyleMask	= 0;		  /* Mask of which style bits to use */
   fontDlg.clrFore	= lClrForeground; /* Selected foreground color	     */
   fontDlg.clrBack	= lClrBackground; /* Selected background color	     */
   fontDlg.ulUser	= 0;		  /* Blank field for application     */
   fontDlg.lReturn	= 0;		  /* Return Value of the Dialog	     */
   fontDlg.lSRC		= 0;		  /* System return code.	     */
   fontDlg.lEmHeight	= 0;		  /* Em height of the current font   */
   fontDlg.lXHeight	= 0;		  /* X height of the current font    */
   fontDlg.lExternalLeading = 0;	  /* External Leading of font	     */
   fontDlg.hMod		= 0;		  /* Module to load custom template  */
					  /* Nominal Point Size of font	     */
   fontDlg.sNominalPointSize = fontMetrics.sNominalPointSize;
   fontDlg.usWeight = fontMetrics.usWeightClass; /* The boldness of the font */
   fontDlg.usWidth = fontMetrics.usWidthClass;	/* The width of the font     */
   fontDlg.x		= 0;		  /* X coordinate of the dialog	     */
   fontDlg.y		= 0;		  /* Y coordinate of the dialog	     */
   fontDlg.usDlgId	= IDD_FONT;	  /* ID of a custom dialog template  */
   fontDlg.usFamilyBufLen = sizeof(szFamily); /*Length of family name buffer */
// fontDlg.fAttrs;			  /* Font attribute structure	     */

   /*
    *	Bring up the standard Font Dialog
    */

   if(WinFontDlg(HWND_DESKTOP, hwndMLE, &fontDlg) != DID_OK)
   {
      WinReleasePS(fontDlg.hpsScreen);
      return;
   }
   fxPointSize = fontDlg.fxPointSize;	  /* save point size for next dialog */

   /*
    *	If outline font, calculate the maxbaselineext and
    *	avecharwidth for the point size selected
    */

   if ( fontDlg.fAttrs.fsFontUse == FATTR_FONTUSE_OUTLINE )
   {
      ConvertVectorFontSize(fontDlg.fxPointSize, &fontDlg.fAttrs);
   }

   /*
    *	Query FONTMETRICS again to determine if font has been ISO9241
    *	tested and if it complies to the ISO9241 standard.
    */

   hpsMLE = WinGetPS(hwndMLE);
   GpiQueryFontMetrics(hpsMLE, sizeof(FONTMETRICS), &fontMetrics);

   if (fontMetrics.fsSelection & FM_SEL_ISO9241_TESTED)
   {
      /*
       *   Values of fbPassed/FailedISO field in the PANOSE structure below
       *   indicate if any displays with ISO support pass/fail compliance test.
       *   If desired, you could also determine the display type to narrow
       *   down which of the following bit tests are necessary.
       */

      if ((fontMetrics.panose.fbFailedISO & FM_ISO_9515_640 ) &&
	  (fontMetrics.panose.fbFailedISO & FM_ISO_9515_1024) &&
	  (fontMetrics.panose.fbFailedISO & FM_ISO_9517_640 ) &&
	  (fontMetrics.panose.fbFailedISO & FM_ISO_9517_1024) &&
	  (fontMetrics.panose.fbFailedISO & FM_ISO_9518_640 ))
      {
	 /*
	  *   font selected fails ISO compliance test on all diplays
	  *   tested above.
	  */
	 MessageBox(hwndMain, IDMSG_ISOFAILED, MB_OK | MB_WARNING, FALSE);
      }
   }
   else
   {  /* font isn't tested for ISO compliance */
      MessageBox(hwndMain, IDMSG_ISONOTTESTED, MB_OK | MB_WARNING, FALSE);
   }

   WinReleasePS(fontDlg.hpsScreen);
   WinReleasePS(hpsMLE);
   WinSendMsg(hwndMLE, MLM_SETFONT, MPFROMP(&(fontDlg.fAttrs)), NULL);

}   /* End of SetFont()							*/

/*
 *   Convert vector font size using point size and fAttrs structure and
 *   return it in that structure.
 */

VOID ConvertVectorFontSize(FIXED fxPointSize, PFATTRS pfattrs)
{
  HPS	hps;
  HDC	hDC;
  LONG	lxFontResolution;
  LONG	lyFontResolution;
  SIZEF sizef;

  hps = WinGetScreenPS(HWND_DESKTOP);	     /* Screen presentation space */

  /*
   *   Query device context for the screen and then query
   *   the resolution of the device for the device context.
   */

  hDC = GpiQueryDevice(hps);
  DevQueryCaps( hDC, CAPS_HORIZONTAL_FONT_RES, (LONG)1, &lxFontResolution);
  DevQueryCaps( hDC, CAPS_VERTICAL_FONT_RES, (LONG)1, &lyFontResolution);

  /*
   *   Calculate the size of the character box, based on the
   *   point size selected and the resolution of the device.
   *   The size parameters are of type FIXED, NOT int.
   *   NOTE: 1 point == 1/72 of an inch.
   */

  sizef.cx = (FIXED)(((fxPointSize) / 72 ) * lxFontResolution );
  sizef.cy = (FIXED)(((fxPointSize) / 72 ) * lyFontResolution );

  pfattrs->lMaxBaselineExt = MAKELONG( HIUSHORT( sizef.cy ), 0 );
  pfattrs->lAveCharWidth   = MAKELONG( HIUSHORT( sizef.cx ), 0 );
  WinReleasePS(hps);

}   /* end ConvertVectorPointSize() */
#ifndef lint
static char *sccsid = "@(#)suep.c 1.3 1/22/92 16:11:05 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define setUpEnvProcessor_Class_Source
#include "suep.ih"

/* ************************************************************ */
SOM_Scope void SOMLINK suProcessOptions(setUpEnvProcessor * somSelf)
{
    int n = 0;
    fileMgr *myfm;
    page *thisPage;
    TPWord *thisWord;

    setUpEnvProcessorMethodDebug("setUpEnvProcessor", "suProcessOptions");
    thisPage = _epGetPage(somSelf);
    myfm = _epGetFileMgr(somSelf);

    for (;;) {
	thisWord = readToken(myfm);
/*  _print(thisWord, stdout); */
	if (_tpwType(thisWord) == TP_EOF) {
	    _somFree(thisWord);
	    break;
	}
	else if (_tpwType(thisWord) == TP_TOKEN)
	    _epStartUpNewEnvironment(somSelf, thisWord);
	else if (_match(thisWord, "width"))
	    _pgSetWidth(thisPage, _suReadIntWord(somSelf));
	else if (_match(thisWord, "height"))
	    _pgSetHeight(thisPage, _suReadIntWord(somSelf));
	else if (_match(thisWord, "columns"))
	    _pgSetNumberOfColumns(thisPage, _suReadIntWord(somSelf));
	_somFree(thisWord);
    }
    thisPage = _epGetPage(somSelf);
    _pgPrint(thisPage, stdout);
}

/* ************************************************************ */
SOM_Scope int SOMLINK suReadIntWord(setUpEnvProcessor * somSelf)
{
    TPWord *thisWord;
    int returnValue;
    setUpEnvProcessorMethodDebug("setUpEnvProcessor", "suReadIntWord");

    thisWord = readToken(_epGetFileMgr(somSelf));  /* Blank */
    _somFree(thisWord);
    thisWord = readToken(_epGetFileMgr(somSelf));  /* Number */
    returnValue = _wordToInt(thisWord);
    _somFree(thisWord);
    return returnValue;
}
/*==============================================================*\
 *  Svrpgame.c - game processing routine: processing of client
 *		 messages and game algorithm.
 *	Copyright 1992, IBM Corp.
 *
 *  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *  sample code created by IBM Corporation. This sample code is not
 *  part of any standard or IBM product and is provided to you solely
 *  for	 the purpose of assisting you in the development of your
 *  applications.  The code is provided "AS IS", without
 *  warranty of any kind.  IBM shall not be liable for any damages
 *  arising out of your use of the sample code, even if they have been
 *  advised of the possibility of   such damages.						      *
 *
 *
\*==============================================================*/


#define INCL_DOSPROCESS
#define INCL_DOSNMPIPES
#define INCL_DOSMEMMGR
#define INCL_WINMESSAGEMGR
#define INCL_DOSERRORS
#define INCL_DOSFILEMGR

#include <os2.h>

#include <stddef.h>
#include <stdlib.h>
#include <string.h>

#include "namepipe.h"
#include "svrpglbl.h"
#include "svrpmain.h"
#include "svrpxtrn.h"


VOID GameThread(VOID *hpTempPipe)
{
   HPIPE   hpGamePipe;
   BOOL	   fQuit=FALSE;
   PPIB	   dummy;
   PTIB	   ptibThrdInfo;
   ULONG   ulID;
   USHORT  usMsg, usData, GameBoard[DIVISIONS][DIVISIONS], usTotalMoves=0;

   /* save pipe handle in own memory */
   hpGamePipe = *(HPIPE *)hpTempPipe;

   /* get thread ID for use in displaying messages */
   if((BOOL)DosGetInfoBlocks(&ptibThrdInfo, &dummy))
   {
      ulID = 0;
   }

   else
   {
      ulID = ptibThrdInfo->tib_ptib2->tib2_ultid;
   }

   InitBoard(GameBoard);

   /* initialize random number generator */
   srand((unsigned) ulID);

   if(!(BOOL)DosConnectNPipe(hpGamePipe))
   {
      while (!fAppExit &&
	     !fQuit &&
	     !(BOOL)(Pipe_IO(CLIENT, hpGamePipe, &usMsg, &usData, ulID)) &&
	     !fAppExit)
      {
	 switch (usMsg)
	 {
	    case CLIENT_MOVE:
	       /* enter move from message */
	       *((USHORT *)GameBoard + usData) = CLIENT_NUM;
	       usTotalMoves++;

	       /* test for win if total moves >= DIVISIONS*2-1 */
	       if (usTotalMoves >= DIVISIONS*2-1 &&
		   ((BOOL)(usData=WinTest(GameBoard)) ||
		    usTotalMoves == DIVISIONS*DIVISIONS))
	       {
		  /* notify of win or draw, and break (switch) on return */
		  if (!usData)
		  {
		     usData = DIVISIONS*DIVISIONS;
		     usMsg = WIN_DRAW;
		  }

		  else
		  {
		     usMsg = WIN_CLIENT;
		  }

		  if ((BOOL)Pipe_IO(SERVER, hpGamePipe, &usMsg, &usData, ulID))
		  {
		     WinPostMsg(hwndMain, WM_MSG, MPFROMLONG(IDMSG_PIPE_WRITE_FAILED), MPVOID);
		     fQuit = TRUE;
		     break;
		  }

		  /* call InitBoard on win */
		  InitBoard(GameBoard);
		  usTotalMoves = 0;

		  break;  /* switch */
	       }

	       /* NO BREAK */

	    case YOU_FIRST:
	       /* get move if there are moves left */
	       usData = GetMove(GameBoard, usTotalMoves);
	       usTotalMoves++;

	       /* test for win if total moves >= DIVISIONS*2-1 */
	       if (usTotalMoves >= DIVISIONS*2-1 &&
		   ((BOOL)(usMsg=WinTest(GameBoard)) ||
		    usTotalMoves == DIVISIONS*DIVISIONS))
	       {
		  /* write game_won message with winning move */
		  if (!usMsg)
		  {
		     usMsg = WIN_DRAW;
		  }

		  else
		  {
		     usMsg = WIN_SERVER;
		  }

		  if ((BOOL)Pipe_IO(SERVER, hpGamePipe, &usMsg, &usData, ulID))
		  {
		     WinPostMsg(hwndMain, WM_MSG, MPFROMLONG(IDMSG_PIPE_WRITE_FAILED), MPVOID);
		     fQuit = TRUE;
		     break;
		  }

		  /* call InitBoard on win */
		  InitBoard(GameBoard);
		  usTotalMoves = 0;
	       }

	       /* else */
	       else
	       {
		  /* write move to client */
		  usMsg = SERVER_MOVE;
		  if ((BOOL)Pipe_IO(SERVER, hpGamePipe, &usMsg, &usData, ulID))
		  {
		     WinPostMsg(hwndMain, WM_MSG, MPFROMLONG(IDMSG_PIPE_WRITE_FAILED), MPVOID);
		     fQuit = TRUE;
		  }
	       }
	       break;

	    case ERROR_MSG:
	       /* post the error to message queue */
	       WinPostMsg(hwndMain, WM_MSG, MPFROMSHORT(usData), MPVOID);

	    case CLIENT_QUIT:
	       /* quit while */
	       fQuit = TRUE;
	 }
      }

      DosDisConnectNPipe(hpGamePipe);
   }

   DosClose(hpGamePipe);
}


/*
 *  Check for pieces owning entire row, column, or diagonal.
 */
USHORT WinTest(USHORT GameBoard[DIVISIONS][DIVISIONS])
{
   USHORT  usWinner=0, usTotal1=0, usTotal2=0, usTotal3=0, usTotal4=0;
   int	   i, j;

   for (i = 0; i < DIVISIONS && !(BOOL)usWinner; i++)
   {
      for (j = 0; j < DIVISIONS && !(BOOL)usWinner; j++)
      {
	 usTotal1 += GameBoard[i][j];
	 usTotal2 += GameBoard[j][i];
      }

      if (SERVER_NUM * DIVISIONS == usTotal1 || CLIENT_NUM * DIVISIONS == usTotal1)
      {
	 usWinner = usTotal1/(USHORT)DIVISIONS;
      }

      else if (SERVER_NUM * DIVISIONS == usTotal2 || CLIENT_NUM * DIVISIONS == usTotal2)
      {
	 usWinner = usTotal2/(USHORT)DIVISIONS;
      }

      else
      {
	 usTotal1 = usTotal2 = 0;
	 usTotal3 += GameBoard[i][i];
	 usTotal4 += GameBoard[i][DIVISIONS-i-1];
      }
   }

   if (SERVER_NUM * DIVISIONS == usTotal3 || CLIENT_NUM * DIVISIONS == usTotal3)
   {
      usWinner = usTotal3/(USHORT)DIVISIONS;
   }

   else if (SERVER_NUM * DIVISIONS == usTotal4 || CLIENT_NUM * DIVISIONS == usTotal4)
   {
      usWinner = usTotal4/(USHORT)DIVISIONS;
   }

   return(usWinner);
}


USHORT GetMove(USHORT GameBoard[DIVISIONS][DIVISIONS], USHORT usTotalMoves)
{
   USHORT  usMovesLeft;
   int	   i, j;

   usMovesLeft = (USHORT)((USHORT)DIVISIONS * (USHORT)DIVISIONS - usTotalMoves);

   /* a poor man's AI */
   usMovesLeft = (USHORT)((usMovesLeft * rand()) / (RAND_MAX + 1));

   for (i = 0; i < DIVISIONS; i++)
   {
      for (j = 0; j < DIVISIONS; j++)
      {
	 if (0 == GameBoard[i][j] && 0 == usMovesLeft--)
	 {
	    GameBoard[i][j] = SERVER_NUM;
	    return((USHORT)(i * DIVISIONS + j));
	 }
      }
   }
   return( 0 );
}


/*
 *  Reset game board.
 */
VOID InitBoard(USHORT GameBoard[DIVISIONS][DIVISIONS])
{
   int i, j;

   for (i = 0; i < DIVISIONS; i++)
      for (j = 0; j < DIVISIONS; j++)
	 GameBoard[i][j] = 0;
}
/*==============================================================*\
 *  Svrphelp.c - routines for the help manager interface
 *	Copyright 1992 IBM Corp.
 *--------------------------------------------------------------
 *
 *  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *  sample code created by IBM Corporation. This sample code is not
 *  part of any standard or IBM product and is provided to you solely
 *  for	 the purpose of assisting you in the development of your
 *  applications.  The code is provided "AS IS", without
 *  warranty of any kind.  IBM shall not be liable for any damages
 *  arising out of your use of the sample code, even if they have been
 *  advised of the possibility of   such damages.						      *
 *
 *--------------------------------------------------------------
 *
 *  This module contains all the routines for interfacing with
 *  the IPF help manager.
 *
 *--------------------------------------------------------------
 *
 *  This source file contains the following functions:
 *
 *	    InitHelp()
 *	    HelpHelpForHelp(mp2)
 *	    HelpExtended(mp2)
 *	    HelpKeys(mp2)
 *	    HelpIndex(mp2)
 *	    HelpTutorial(mp2)
 *	    HelpAbout(mp2)
 *	    DisplayHelpPanel(idPanel)
 *	    DestroyHelpInstance()
 *
\*==============================================================*/



/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/

#define	 INCL_WINHELP

#include <os2.h>
#include <string.h>
#include "svrpmain.h"
#include "svrphelp.h"
#include "svrpxtrn.h"
#include "svrpglbl.h"

#define HELPLIBRARYNAMELEN  20

/* If DEBUG is defined, then the help panels will display their
 *  id values on their title bar.  This is useful for determining
 *  which help panels are being shown for each dialog item.  When
 *  the DEBUG directive is not defined, then the panel ids are not
 *  displayed.
 */

/* #define  DEBUG */


/*--------------------------------------------------------------*\
 *  Global variables
\*--------------------------------------------------------------*/
static HWND hwndHelpInstance;
static CHAR szLibName[HELPLIBRARYNAMELEN];
static CHAR szWindowTitle[HELPLIBRARYNAMELEN];


/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/
MRESULT EXPENTRY AboutBoxDlgProc(HWND	hwnd,
				 ULONG	msg,
				 MPARAM mp1,
				 MPARAM mp2);



/****************************************************************\
 *  Routine for initializing the help manager
 *--------------------------------------------------------------
 *
 *  Name:   InitHelp()
 *
 *  Purpose: Initializes the IPF help facility
 *
 *  Usage:  Called once during initialization of the program
 *
 *  Method: Initializes the HELPINIT structure and creates the
 *	    help instance.  If successful, the help instance
 *	    is associated with the main window
 *
 *  Returns:
 *
\****************************************************************/
VOID InitHelp(VOID)
{
   HELPINIT hini;

   /* if we return because of an error, Help will be disabled */
   fHelpEnabled = FALSE;

   /* initialize help init structure */
   hini.cb = sizeof(HELPINIT);
   hini.ulReturnCode = 0L;

   hini.pszTutorialName = (PSZ)NULL;   /* if tutorial added, add name here */

   hini.phtHelpTable = (PHELPTABLE)MAKELONG(SVRP_HELP_TABLE, 0xFFFF);
   hini.hmodHelpTableModule = (HMODULE)0;
   hini.hmodAccelActionBarModule = (HMODULE)0;
   hini.idAccelTable = 0;
   hini.idActionBar = 0;

   if(!WinLoadString(hab,
		     (HMODULE)0,
		     IDS_HELPWINDOWTITLE,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szWindowTitle))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
      return;
   }

   hini.pszHelpWindowTitle = (PSZ)szWindowTitle;

   /* if debugging, show panel ids, else don't */
#ifdef DEBUG
    hini.fShowPanelId = CMIC_SHOW_PANEL_ID;
#else
    hini.fShowPanelId = CMIC_HIDE_PANEL_ID;
#endif

   if(!WinLoadString(hab,
		     (HMODULE)0,
		     IDS_HELPLIBRARYNAME,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szLibName))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
      return;
   }

   hini.pszHelpLibraryName = (PSZ)szLibName;

   /* creating help instance */
   hwndHelpInstance = WinCreateHelpInstance(hab, &hini);

   if(hwndHelpInstance == NULLHANDLE || hini.ulReturnCode)
   {
      MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, MB_OK | MB_ERROR, TRUE);
      return;
   }

   /* associate help instance with main frame */
   if(!WinAssociateHelpInstance(hwndHelpInstance, hwndMainFrame))
   {
      MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, MB_OK | MB_ERROR, TRUE);
      return;
   }

   /* help manager is successfully initialized so set flag to TRUE */
   fHelpEnabled = TRUE;

}  /* InitHelp() */


/****************************************************************\
 *  Processes the Help for Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpHelpForHelp(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Help for Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Help for Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_DISPLAY_HELP message to the help
 *	    instance so that the default Help For Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpHelpForHelp(MPARAM mp2)  /* second parameter of WM_COMMAND message */
{

   /* this just displays the system help for help panel */
   if(fHelpEnabled)
   {
      if(WinSendMsg(hwndHelpInstance, HM_DISPLAY_HELP, MPVOID, MPVOID))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    MB_OK | MB_ERROR,
		    FALSE);
      }
   }
}   /* HelpHelpForHelp() */


/****************************************************************\
 *  Processes the Extended Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpExtended(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Extended Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Extended Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_EXT_HELP message to the help
 *	    instance so that the default Extended Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpExtended(MPARAM mp2)
{

   /* this just displays the system extended help panel */
   if(fHelpEnabled)
   {
      if((BOOL32)WinSendMsg(hwndHelpInstance, HM_EXT_HELP, NULL, NULL))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    MB_OK | MB_ERROR,
		    FALSE);
      }
   }
}   /* HelpExtended() */


/****************************************************************\
 *  Processes the Keys Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpKeys(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Keys Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Keys Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_KEYS_HELP message to the help
 *	    instance so that the default Keys Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpKeys(MPARAM mp2)
{

   /* this just displays the system keys help panel */
   if(fHelpEnabled)
   {
      if(WinSendMsg(hwndHelpInstance, HM_KEYS_HELP, MPVOID, MPVOID))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    MB_OK | MB_ERROR,
		    FALSE);
      }
   }
}   /* HelpKeys() */


/****************************************************************\
 *  Processes the Index Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpIndex(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Index Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Index Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_INDEX_HELP message to the help
 *	    instance so that the default Index Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpIndex(MPARAM mp2)
{

   /* this just displays the system help index panel */
   if(fHelpEnabled)
   {
      if(WinSendMsg(hwndHelpInstance, HM_HELP_INDEX, MPVOID, MPVOID))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    MB_OK | MB_ERROR,
		    FALSE);
      }
   }
}   /* HelpIndex() */


/****************************************************************\
 *  Processes the Tutorial Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpTutorial(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Tutorial Help item of the Help menu.  While the
 *	      standard template application does not include a
 *	      Tutorial menu item, you can add one if your
 *	      application has a tutorial.
 *
 *  Usage:  Called from MainCommand when the Tutorial Help
 *	    menu item is selected
 *
 *  Method:
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpTutorial(MPARAM mp2)
{

   /*--------------------------------------------------------------*\
    *  Insert code for any tutorial here
   \*--------------------------------------------------------------*/


}   /* HelpTutorial() */


/****************************************************************\
 *  Processes the About command from the Help menu
 *--------------------------------------------------------------
 *
 *  Name:   HelpAbout(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      About item of the Help menu
 *
 *  Usage:  Called from MainCommand when the About
 *	    menu item is selected
 *
 *  Method: Calls WinDlgBox to display the about box dialog.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpAbout(MPARAM mp2)
{

   /* display the AboutBox dialog */
   WinDlgBox(HWND_DESKTOP,
	     hwndMainFrame,
	     AboutBoxDlgProc,
	     0,
	     IDD_ABOUTBOX,
	     (PVOID)NULL);
}   /* HelpAbout() */


/****************************************************************\
 *  Displays the help panel indicated
 *--------------------------------------------------------------
 *
 *  Name:   DisplayHelpPanel(idPanel)
 *
 *  Purpose: Displays the help panel whose id is given
 *
 *  Usage:  Called whenever a help panel is desired to be
 *	    displayed, usually from the WM_HELP processing
 *	    of the dialog boxes
 *
 *  Method: Sends HM_DISPLAY_HELP message to the help instance
 *
 *  Returns:
 *
\****************************************************************/
VOID DisplayHelpPanel(SHORT idPanel)  /* ID of the help panel to be displayed */
{

   if(fHelpEnabled)
   {
      if(WinSendMsg(hwndHelpInstance,
	    HM_DISPLAY_HELP,
	    MPFROMLONG(MAKELONG(idPanel, NULL)),
	    MPFROMSHORT(HM_RESOURCEID)))
      {
	 MessageBox(hwndMainFrame,
		    IDMSG_HELPDISPLAYERROR,
		    MB_OK | MB_ERROR,
		    TRUE);
      }
   }
}   /* DisplayHelpPanel() */



/****************************************************************\
 *  Destroys the help instance
 *--------------------------------------------------------------
 *
 *  Name:   DestroyHelpInstance(VOID)
 *
 *  Purpose: Destroys the help instance for the application
 *
 *  Usage:  Called after exit from message loop
 *
 *  Method: Calls WinDestroyHelpInstance() to destroy the
 *	    help instance
 *
 *  Returns:
 *
\****************************************************************/
VOID DestroyHelpInstance(VOID)
{

   if(hwndHelpInstance != NULLHANDLE)
   {
      WinDestroyHelpInstance(hwndHelpInstance);
   }
}   /* DestroyHelpInstance() */


/****************************************************************\
 *  Dialog procedure for the About dialog box
 *--------------------------------------------------------------
 *
 *  Name:   AboutBoxDlgProc(hwnd, msg, mp1, mp2)
 *
 *  Purpose: Processes all messages sent to the About Box
 *
 *  Usage:  Called for each message sent to the About Box
 *	    dialog box.
 *
 *  Method: the about box only has a button control so this
 *	    routine only processes WM_COMMAND messages.	 Any
 *	    WM_COMMAND posted must have come from the Ok
 *	    button so we dismiss the dialog upon receiving it.
 *
 *  Returns: Dependent upon message sent
 *
\****************************************************************/
MRESULT EXPENTRY AboutBoxDlgProc(HWND	hwnd,	   /* handle of window */
				 ULONG	msg,	 /* id of message */
				 MPARAM mp1,	 /* first message parameter */
				 MPARAM mp2)	 /* second message parameter */
{
   switch(msg)
   {
      case WM_COMMAND:
	 /* no matter what the command, close the dialog */
	 WinDismissDlg(hwnd, TRUE);
	 break;

      default:
	 return(WinDefDlgProc(hwnd, msg, mp1, mp2));
	 break;
   }

   return (MRFROMLONG(0));

}   /* AboutBoxWndProc() */
/*==============================================================*\
 *  svrpmain.c - Pipe Server end of Tic-Tac-Toe sample app
 *	Copyright 1992 IBM Corp.
 *--------------------------------------------------------------
 *
 *  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *  sample code created by IBM Corporation. This sample code is not
 *  part of any standard or IBM product and is provided to you solely
 *  for	 the purpose of assisting you in the development of your
 *  applications.  The code is provided "AS IS", without
 *  warranty of any kind.  IBM shall not be liable for any damages
 *  arising out of your use of the sample code, even if they have been
 *  advised of the possibility of   such damages.						      *
 *
 *--------------------------------------------------------------
 *
 *  This c file contains the window creation routines and
 *  manages the PM message queue.
 *
\*==============================================================*/



/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/
#define INCL_WINHELP
#define INCL_WININPUT
#define INCL_DOSPROCESS
#define INCL_DOSNMPIPES
#define INCL_WINMESSAGEMGR
#define INCL_WINWINDOWMGR
#define INCL_WINMENUS
#define INCL_WINFRAMEMGR

#include <os2.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "svrpmain.h"
#include "svrphelp.h"
#include "svrpxtrn.h"

#define	 THRD_EXIT_TIMEOUT  10

/*--------------------------------------------------------------*\
 *  Global variables
\*--------------------------------------------------------------*/

HWND   hwndMainFrame = NULLHANDLE;    /* handle to the main frame window */
HWND   hwndMain;		      /* handle to the main client window */
HAB    hab;			      /* anchor block for the process */
HMQ    hmq;			      /* handle to the process' message queue */
CHAR   szAppName[MAXNAMEL];	      /* buffer for application name string */
BOOL   fHelpEnabled;		      /* flag to determine if help is enabled */
SHORT  sTotalMsgs;
CHAR   PipeMsgs[MAX_MESSAGES][MESSAGE_LEN];
HPIPE  hpStartPipe;
BOOL   fAppExit=FALSE;		      /* application ending flag */
BOOL   fThrdsDead=FALSE;	      /* notification of thread exitting */

unsigned int  iIndex=0;		      /* beginning of circular buffer */


/****************************************************************\
 *  Main routine
 *--------------------------------------------------------------
 *
 *  Name:   main()
 *
 *  Purpose: Initializes the PM environment, calls the
 *		initialization routine, creates the main
 *		window,	 and polls the message queue
 *
 *  Usage:
 *
 *  Method:
 *	    - obtains anchor block handle and creates message
 *		queue
 *	    - calls the initialization routine
 *	    - creates the main frame window which creates the
 *		main client window
 *	    - polls the message queue via Get/Dispatch Msg loop
 *	    - upon exiting the loop, exits
 *
 *  Returns:
 *	    0 - if successful execution completed
 *	    1 - if error
\****************************************************************/
INT main(int argc, char *argv[])
{
   QMSG qmsg;	       /* message structure */

   hab = WinInitialize(0);

   if(!hab)
   {
      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      return(RETURN_ERROR);
   }

   hmq = WinCreateMsgQueue(hab, 0);

   if(!hmq)
   {
      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      WinTerminate(hab);
      return(RETURN_ERROR);
   }

   if(!Init(argc, argv))
   {
      if(hwndMainFrame == NULLHANDLE)
      {
	  MessageBox(HWND_DESKTOP,
		     IDMSG_MAINWINCREATEFAILED,
		     MB_OK | MB_ERROR,
		     TRUE);
      }

      else
      {
	 MessageBox(HWND_DESKTOP,
		    IDMSG_INITFAILED,
		    MB_OK | MB_ERROR,
		    TRUE);

      }
      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      if (WinIsWindow(hab, hwndMainFrame))
      {
	 WinDestroyWindow(hwndMainFrame);
      }
      WinDestroyMsgQueue(hmq);
      WinTerminate(hab);
      return(RETURN_ERROR);
   }

   /* Get-Dispatch Message loop */
   while(WinGetMsg(hab, (PQMSG)&qmsg, NULLHANDLE, 0, 0))
      WinDispatchMsg(hab, (PQMSG)&qmsg);

   /* destroy the help instance */
   DestroyHelpInstance();

   if (WinIsWindow(hab, hwndMainFrame))
   {
      WinDestroyWindow(hwndMainFrame);
   }
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   return(RETURN_SUCCESS);

}   /* main() */


/****************************************************************\
 *  Main client window procedure
 *--------------------------------------------------------------
 *
 *  Name:   MainWndProc(hwnd, msg, mp1, mp2)
 *
 *  Purpose: Processes the messages sent to the main client
 *		window.	 This routine processes the basic
 *		messages all client windows should process
 *		and passes all others onto WinDefWindowProc.
 *
 *  Usage:  Called for each message placed in the main
 *	    window's message queue
 *
 *  Method: a switch statement branches to the routines to be
 *	    performed for each message processed.
 *
 *  Returns:  Return values are determined by each message
 *
\****************************************************************/
MRESULT EXPENTRY MainWndProc(HWND   hwnd,      /* handle of window */
			     ULONG  msg,     /* id of message */
			     MPARAM mp1,     /* first message parameter */
			     MPARAM mp2)     /* second message parameter */
{
   static int  iCloseCount=0;

   switch(msg)
   {
      case WM_CREATE:
	 return(InitMainWindow(hwnd, mp1, mp2));
	 break;

      case WM_PAINT:
	 MainPaint(hwnd, PipeMsgs, iIndex, sTotalMsgs);
	 break;

      case WM_SIZE:
	 MainSize(hwnd, sTotalMsgs, mp1, mp2);
	 break;

      case WM_HSCROLL:
	 MainHorizScroll(hwnd, mp2);
	 break;

      case WM_VSCROLL:
	 MainVertScroll(hwnd, mp2);
	 break;

      case WM_CHAR:
	 switch (SHORT2FROMMP(mp2))
	 {
	    case VK_LEFT:
	    case VK_RIGHT:
	       return MainCharHScroll (hwnd, msg, mp1, mp2) ;
	    case VK_UP:
	    case VK_DOWN:
	    case VK_PAGEUP:
	    case VK_PAGEDOWN:
	       return MainCharVScroll (hwnd, msg, mp1, mp2) ;
	 }
	 break ;

      case WM_COMMAND:
	 MainCommand(mp1, mp2);
	 break;

      case HM_QUERY_KEYS_HELP:
	 return (MRESULT)PANEL_HELPKEYS;   /* return id of key help panel */
	 break ;

      case WM_PIPEMSG:
	 /* copy message into circular array, with index being next free spot in array */
	 strcpy(PipeMsgs[iIndex], (CHAR *)PVOIDFROMMP(mp1));

	 /* increment index, or reset to 0 as appropriate */
	 iIndex = (iIndex < MAX_MESSAGES-1) ? iIndex+1 : 0;

	 /* increment total message count until buffer is filled */
	 sTotalMsgs = min(MAX_MESSAGES, sTotalMsgs+1);

	 MainUpdateMsg(hwnd, PipeMsgs, iIndex, sTotalMsgs);
	 break;

      case WM_MSG:
	 /* display messages from threads w/o a message queue */
	 MessageBox(hwndMain, SHORT1FROMMP(mp1), MB_OK | MB_ICONEXCLAMATION, TRUE);
	 break;

      case WM_CLOSE:
	 fAppExit = TRUE;
	 DosClose(hpStartPipe);	 /* break start pipe */

	 /* give other thread a chance to exit */
	 /* but don't wait around forever for it */

	 for (iCloseCount = 0; FALSE == fThrdsDead && iCloseCount < THRD_EXIT_TIMEOUT; iCloseCount++)
	 {
	    DosSleep(0);
	 }

	 /* else process the WM_CLOSE */

   /*--------------------------------------------------*\
    *	   Any messages not processed are passed on
    *	   to WinDefWindowProc.
   \*--------------------------------------------------*/

      default:
	 return(WinDefWindowProc(hwnd, msg, mp1, mp2));
	 break;
   }

   return (MRFROMLONG(0));	/* all window procedures should return 0 as a default */

}   /* MainWndProc() */


/****************************************************************\
 *  Message Box procedure
 *--------------------------------------------------------------
 *
 *  Name:   MessageBox(hwndOwner, nIdMsg, fsStyle, fBeep)
 *
 *  Purpose: Displays the message box with the message
 *		given in idMsg retrieved from the message table
 *		and using the style flags in fsStyle
 *
 *  Usage:  Called whenever a MessageBox is to be displayed
 *
 *  Method: - Message string is loaded from the process'
 *		message table
 *	    - Alarm beep is sounded if desired
 *	    - Message box with the message is displayed
 *	    - WinMessageBox return value is returned
 *
 *  Returns: return value from WinMessageBox()
 *
\****************************************************************/

ULONG MessageBox(HWND  hwndOwner,  /* handle of the message box's owner */
		 ULONG idMsg,	   /* id if the message in the message table */
		 ULONG fsStyle,	   /* style of the message box */
		 BOOL  fBeep)	   /* if TRUE, beep before message box is displayed */
{
   CHAR szText[TITLE_LEN];

   if(!WinLoadMessage(hab,
		     (HMODULE)NULL,
		     idMsg,
		     TITLE_LEN,
		     (PSZ)szText))
   {
      WinAlarm(HWND_DESKTOP, WA_ERROR);
      return MBID_ERROR;
   }

   if(fBeep)  {
      WinAlarm(HWND_DESKTOP, WA_ERROR);
   }

   return(WinMessageBox(HWND_DESKTOP,
			hwndOwner,
			szText,
			"Server Error",
			MSGBOXID,
			fsStyle));

}   /* MessageBox() */


/****************************************************************\
 *  Main window WM_COMMAND processing procedure
 *--------------------------------------------------------------
 *
 *  Name:   MainCommand(mp1, mp2)
 *
 *  Purpose: Calls the appropriate procedures that deal with
 *		the selected menu item.
 *
 *  Usage:  Routine is called whenever a WM_COMMAND message
 *	    is posted to the main window.
 *
 *  Method: a switch statement branches on the id of the
 *	    menu item that posted the message and the
 *	    appropriate action for that item is taken.
 *
 *  Returns:
 *
\****************************************************************/
VOID MainCommand(MPARAM mp1, MPARAM mp2)
{

   switch(SHORT1FROMMP(mp1))
   {
      case IDM_FILEEXIT:
	 FileExit();
	 break;

      case IDM_OPTIONCLEAR:
	 iIndex = sTotalMsgs = 0;
	 MainPurgeWindow();
	 break;

      case IDM_HELPHELPFORHELP:
	 HelpHelpForHelp(mp2);
	 break;

      case IDM_HELPEXTENDED:
	 HelpExtended(mp2);
	 break;

      case IDM_HELPKEYS:
	 HelpKeys(mp2);
	 break;

      case IDM_HELPINDEX:
	 HelpIndex(mp2);
	 break;

      case IDM_HELPTUTORIAL:
	 HelpTutorial(mp2);
	 break;

      case IDM_HELPABOUT:
	 HelpAbout(mp2);
	 break;

      default:
	 break;
    }

}   /* MainCommand() */


/****************************************************************\
 *  Initialization routine
 *--------------------------------------------------------------
 *
 *  Name:   Init()
 *
 *  Purpose: Performs initialization functions.
 *
 *  Usage:  Called once before the message queue is queried.
 *
 *  Method:
 *	    - starts processing thread
 *	    - registers all window classes
 *
 *  Returns:
 *	    TRUE - initialization is successful
 *	    FALSE - initialization failed
\****************************************************************/
BOOL Init(int argc, char *argv[])
{
   ULONG  flCtlData;	/* frame control data */
   CHAR	  pszBuff[CCHMAXPATH];
   RESULTCODES	resc;



   /* load application name from resource file */
   if(!WinLoadString(hab, 0, IDS_APPNAME, MAXNAMEL, szAppName))
   {
      return FALSE;
   }

   /* register the main client window class */
   if(!WinRegisterClass(hab,
			(PSZ)szAppName,
			MainWndProc,
			CS_SIZEREDRAW | CS_CLIPCHILDREN,
			0))
   {
      return FALSE;
   }

   flCtlData = FCF_STANDARD | FCF_VERTSCROLL | FCF_HORZSCROLL;

   if (NULLHANDLE == (hwndMainFrame = WinCreateStdWindow(HWND_DESKTOP,
							 WS_VISIBLE,
							 (PULONG)&flCtlData,
							 (PSZ)szAppName,
							 NULL,
							 WS_VISIBLE,
							 (HMODULE)NULL,
							 IDR_MAIN,
							 (PHWND)&hwndMain)))
      return FALSE;

   WinSetWindowText(hwndMainFrame, szAppName);

   if (!(BOOL)(hpStartPipe=InitThreads()))
   {
      return FALSE;
   }

   if (argc > 1)
   {
      if ((BOOL)DosExecPgm(pszBuff, CCHMAXPATH, EXEC_ASYNC, NULL, NULL, &resc, argv[1]))
      {
	 MessageBox(hwndMain, IDMSG_CANNOT_EXEC_CLIENT, MB_CUAWARNING | MB_OK, TRUE);
      }
   }

   InitHelp();

   return TRUE;
}  /* Init() */


/****************************************************************\
 *  Exit routine
 *--------------------------------------------------------------
 *
 *  Name:   FileExit(mp2)
 *
 *  Purpose: Processes the File menu's Exit item.
 *
 *  Usage:  called whenever Exit from the file menu is
 *	    selected
 *
 *  Method:  Routine posts a WM_CLOSE message to the main
 *	     application window.
 *
 *  Returns:
 *
\****************************************************************/
VOID FileExit()
{

   WinPostMsg(hwndMain, WM_CLOSE, (MPARAM)NULL, (MPARAM)NULL);

}   /* FileExit() */
/*==============================================================*\
 *  svrppnt.c - routines for the painting of the main window
 *	Copyright 1992, IBM Corp.
 *--------------------------------------------------------------
 *
 *  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *  sample code created by IBM Corporation. This sample code is not
 *  part of any standard or IBM product and is provided to you solely
 *  for	 the purpose of assisting you in the development of your
 *  applications.  The code is provided "AS IS", without
 *  warranty of any kind.  IBM shall not be liable for any damages
 *  arising out of your use of the sample code, even if they have been
 *  advised of the possibility of   such damages.						      *
 *
 *--------------------------------------------------------------
 *
 *  This module contains the code for the main client window
 *  painting
 *
\*==============================================================*/



/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/

#define INCL_WINMESSAGEMGR
#define INCL_WINWINDOWMGR
#define INCL_GPICONTROL
#define INCL_GPIPRIMITIVES
#define INCL_GPILCIDS
#define INCL_DOSPROCESS
#define INCL_WINFRAMEMGR
#define INCL_WINSCROLLBARS

#include <os2.h>
#include <stdlib.h>
#include <string.h>
#include "svrpmain.h"
#include "svrpglbl.h"
/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/

#include "svrpxtrn.h"


/* returns offset from beginning of circular array */
#define	 BUFF_OFFSET(index, offset)  (((index)+(offset) < MAX_MESSAGES) ? (index)+(offset) : (index)+(offset)-MAX_MESSAGES)

/*--------------------------------------------------------------*\
 *  Global (module) variables
\*--------------------------------------------------------------*/

HWND  hwndHscroll, hwndVscroll ;
LONG  sHscrollMax=0, sVscrollMax=0, sHscrollPos=0, sVscrollPos=0, cxChar,
      cxCaps, cyChar, cyDesc, cxClient, cyClient, cxTextTotal;


/****************************************************************\
 *  Main client painting routine
 *--------------------------------------------------------------
 *
 *  Name:   MainPaint(hwnd)
 *
 *  Purpose: Paints the main client window.
 *
 *  Usage:  Routine is called whenver the client window
 *	    procedure receives a WM_PAINT message
 *
 *  Method:
 *	    - begins painting by calling WinBeginPaint
 *		and retrieving the HPS for the window
 *	    - performs any painting desired
 *	    - ends painting by calling WinEndPaint
 *
 *  Returns:
 *
\****************************************************************/
VOID MainPaint(HWND hwnd,				  /* handle to window */
	       CHAR PipeMsgs[MAX_MESSAGES][MESSAGE_LEN],  /* array of messages */
	       unsigned int uiIndex,			  /* beginning of circular array */
	       SHORT sTotalMsgs)			  /* total number of messages */
{
   RECTL	 rclInvalid;
   HPS		 hps;
   LONG		 sPaintBeg, sPaintEnd, sLine;
   POINTL	 ptl;
   unsigned int	 uiOffset;

   uiOffset = (sTotalMsgs < MAX_MESSAGES) ? 0 : uiIndex;

   hps = WinBeginPaint(hwnd, NULLHANDLE, (PRECTL)&rclInvalid);
   GpiErase(hps);

   sPaintBeg = max(0, sVscrollPos + (cyClient - rclInvalid.yTop) / cyChar);
   sPaintEnd = min(sTotalMsgs, sVscrollPos + (cyClient - rclInvalid.yBottom) / cyChar + 1);

   for (sLine = sPaintBeg ; sLine < sPaintEnd ; sLine++)
   {
      ptl.x = cxCaps - sHscrollPos ;
      ptl.y = cyClient - cyChar * (BUFF_OFFSET(uiOffset,sLine) + 1 - sVscrollPos) + cyDesc ;

      GpiCharStringAt (hps, &ptl,
		       (LONG) strlen (PipeMsgs[BUFF_OFFSET(uiOffset,sLine)]),
		       PipeMsgs[BUFF_OFFSET(uiOffset,sLine)]) ;
   }

   WinEndPaint (hps) ;
}   /* MainPaint() */


/****************************************************************\
 *  Initialization routine
 *--------------------------------------------------------------
 *
 *  Name:   InitMainWindow(hwnd, mp1, mp2)
 *
 *  Purpose: Performs initialization functions required
 *		when the main window is created.
 *
 *  Usage:  Called once during the WM_CREATE processing when
 *	    the main window is created.
 *
 *  Method:
 *
 *  Returns: value to be returned from the WM_CREATE message:
 *	    TRUE - window creation should stop
 *	    FALSE - window creation should continue
\****************************************************************/

MRESULT InitMainWindow(HWND hwnd,      /* handle to the main client window */
		       MPARAM mp1,     /* first parameter of WM_CREATE message */
		       MPARAM mp2)     /* second parameter of WM_CREATE message */
{
   FONTMETRICS fm;
   HPS	       hps;

   hps = WinGetPS (hwnd) ;
   GpiQueryFontMetrics (hps, (LONG) sizeof fm, &fm) ;

   cxChar = fm.lAveCharWidth ;
   cxCaps = fm.lEmInc ;
   cyChar = fm.lMaxBaselineExt ;
   cyDesc = fm.lMaxDescender ;

   WinReleasePS (hps) ;

   cxTextTotal = MESSAGE_LEN * cxChar ;

   hwndHscroll = WinWindowFromID (
		       WinQueryWindow (hwnd, QW_PARENT),
		       FID_HORZSCROLL) ;

   hwndVscroll = WinWindowFromID (
		       WinQueryWindow (hwnd, QW_PARENT),
		       FID_VERTSCROLL) ;

   return (MRFROMLONG(0));
}


/****************************************************************\
 *  Window sizing routine
 *--------------------------------------------------------------
 *
 *  Name:   InitMainWindow(hwnd, mp1, mp2)
 *
 *  Purpose: Adjusts scroll bars and window parameters
 *		when the main window is resized.
 *
 *  Usage:  Called when the client window receives a WM_SIZE
 *	    message.
 *
 *  Method:
 *
 *  Returns:
\****************************************************************/

MRESULT MainSize(HWND hwnd,	 /* handle to the main client window */
		 SHORT sTotalMsgs,
		 MPARAM mp1,	 /* first parameter of WM_SIZE message */
		 MPARAM mp2)	 /* second parameter of WM_SIZE message */
{

   cxClient = SHORT1FROMMP (mp2) ;
   cyClient = SHORT2FROMMP (mp2) ;

   sHscrollMax = max (0, cxTextTotal - cxClient) ;
   sHscrollPos = min (sHscrollPos, sHscrollMax) ;

   WinSendMsg (hwndHscroll, SBM_SETSCROLLBAR,
			    MPFROM2SHORT (sHscrollPos, 0),
			    MPFROM2SHORT (0, sHscrollMax)) ;

   WinEnableWindow (hwndHscroll, (BOOL)((sHscrollMax != 0) ? TRUE : FALSE)) ;

   sVscrollMax = max (0, sTotalMsgs - cyClient / cyChar) ;
   sVscrollPos = min (sVscrollPos, sVscrollMax) ;

   WinSendMsg (hwndVscroll, SBM_SETSCROLLBAR,
			    MPFROM2SHORT (sVscrollPos, 0),
			    MPFROM2SHORT (0, sVscrollMax)) ;

   WinEnableWindow (hwndVscroll, (BOOL)((sVscrollMax != 0) ? TRUE : FALSE)) ;

   return (MRFROMLONG(0));
}


/****************************************************************\
 *  Horizontal scrolling routine
 *--------------------------------------------------------------
 *
 *  Name:   MainHorizScroll(hwnd, mp1, mp2)
 *
 *  Purpose: Scrolls window horizontally.
 *
 *  Usage:  Called when the client window receives a WM_HSCROLL
 *	    message.
 *
 *  Method:
 *
 *  Returns:
\****************************************************************/

MRESULT MainHorizScroll(HWND hwnd,   /* handle to the main client window */
			MPARAM mp2)
{
   LONG sHscrollInc;

   switch (SHORT2FROMMP (mp2))
   {
      case SB_LINELEFT:
	 sHscrollInc = -cxCaps ;
	 break ;

      case SB_LINERIGHT:
	 sHscrollInc = cxCaps ;
	 break ;

      case SB_PAGELEFT:
	 sHscrollInc = -8 * cxCaps ;
	 break ;

      case SB_PAGERIGHT:
	 sHscrollInc = 8 * cxCaps ;
	 break ;

      case SB_SLIDERPOSITION:
	 sHscrollInc = SHORT1FROMMP (mp2) - sHscrollPos;
	 break ;

      default:
	 sHscrollInc = 0;
	 break ;
   }

   sHscrollInc = max (-sHscrollPos,
		 min (sHscrollInc, sHscrollMax - sHscrollPos)) ;

   if (sHscrollInc != 0)
   {
      sHscrollPos += sHscrollInc ;
      WinScrollWindow ((HWND)hwnd, -sHscrollInc, 0, (PRECTL)NULL,
		       (PRECTL)NULL, (HRGN)NULL, (PRECTL)NULL,
		       SW_INVALIDATERGN);

      WinSendMsg (hwndHscroll, SBM_SETPOS,
		  MPFROMSHORT (sHscrollPos), MPVOID) ;
   }
   return (MRFROMLONG(0));
}


/****************************************************************\
 *  Vertical scrolling routine
 *--------------------------------------------------------------
 *
 *  Name:   MainVertScroll(hwnd, mp2)
 *
 *  Purpose: Scrolls window vertically.
 *
 *  Usage:  Called when the client window receives a WM_VSCROLL
 *	    message.
 *
 *  Method:
 *
 *  Returns:
\****************************************************************/

MRESULT MainVertScroll(HWND hwnd,      /* handle to the main client window */
		       MPARAM mp2)
{
   LONG sVscrollInc;

   switch (SHORT2FROMMP (mp2))
   {
      case SB_LINEUP:
	 sVscrollInc = -1 ;
	 break ;

      case SB_LINEDOWN:
	 sVscrollInc = 1 ;
	 break ;

      case SB_PAGEUP:
	 sVscrollInc = min (-1, -cyClient / cyChar) ;
	 break ;

      case SB_PAGEDOWN:
	 sVscrollInc = max (1, cyClient / cyChar) ;
	 break ;

      case SB_SLIDERTRACK:
	 sVscrollInc = SHORT1FROMMP (mp2) - sVscrollPos;
	 break ;

      default:
	 sVscrollInc = 0;
	 break ;
   }

   sVscrollInc = max (-sVscrollPos,
		 min (sVscrollInc, sVscrollMax - sVscrollPos)) ;

   if (sVscrollInc != 0)
   {
      sVscrollPos += sVscrollInc ;
      WinScrollWindow ((HWND)hwnd, 0, (cyChar * sVscrollInc),
		     (PRECTL)NULL, (PRECTL)NULL, (HRGN)NULL,
		     (PRECTL)NULL, SW_INVALIDATERGN);

      WinSendMsg (hwndVscroll, SBM_SETPOS,
		  MPFROMSHORT (sVscrollPos), MPVOID) ;
      WinUpdateWindow (hwnd) ;
   }
   return (MRFROMLONG(0));
}


/****************************************************************\
 *
 *  Name:   MainCharHScroll(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
 *
 *  Purpose:
 *
 *  Usage:
 *
 *  Method:
 *
 *  Returns:
\****************************************************************/

MRESULT MainCharHScroll(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{

   return (WinSendMsg(hwndHscroll, msg, mp1, mp2));
}


/****************************************************************\
 *
 *  Name:   MainCharVScroll(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
 *
 *  Purpose:
 *
 *  Usage:
 *
 *  Method:
 *
 *  Returns:
\****************************************************************/

MRESULT MainCharVScroll(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{

   return (WinSendMsg(hwndVscroll, msg, mp1, mp2));
}


/****************************************************************\
 *  Update messages
 *--------------------------------------------------------------
 *
 *  Name:   MainUpdateMsg(hwnd)
 *
 *  Purpose: Update portion of screen with new messages.
 *
 *  Usage:  Called when a new message is read
	    from or written to the pipe.
 *
 *  Method:
 *
 *  Returns:
\****************************************************************/

VOID MainUpdateMsg(HWND hwnd,
		   CHAR PipeMsgs[MAX_MESSAGES][MESSAGE_LEN],
		   unsigned int index,
		   SHORT sTotalMsgs)
{
   RECTL rclInvalid;

   /* if it will fit in the window */
   if (sTotalMsgs <= cyClient/cyChar + sVscrollPos + 1)
   {
      rclInvalid.yBottom = max(0, cyClient - sTotalMsgs * cyChar);
      rclInvalid.yTop = (cyClient - (sTotalMsgs - sVscrollPos - 1) * cyChar);
      rclInvalid.xLeft = 0;
      rclInvalid.xRight = cxClient;
      WinInvalidateRect(hwnd, &rclInvalid, FALSE);
      MainPaint(hwnd, PipeMsgs, index, sTotalMsgs);
   }

   /* if lines exceed window */
   if (sTotalMsgs > cyClient/cyChar)
   {
      WinEnableWindow (hwndVscroll, TRUE) ;
      sVscrollMax = sTotalMsgs - cyClient / cyChar;
      sVscrollPos = min (sVscrollPos, sVscrollMax) ;

      WinSendMsg (hwndVscroll, SBM_SETSCROLLBAR,
			       MPFROM2SHORT (sVscrollPos, 0),
			       MPFROM2SHORT (0, sVscrollMax)) ;

      /* if new msg is just off screen */
      if (sTotalMsgs == cyClient/cyChar + sVscrollPos + 1)
      {
	 MainVertScroll(hwnd, MPFROM2SHORT(0, SB_LINEDOWN));
      }

      /* tell user message was received */
      else
      {
	 DosBeep(1000, 100);
      }
   }
}


/*
 *  Empty Client window of messages
 */
VOID MainPurgeWindow()
{

   sVscrollMax = 0;
   sVscrollPos = 0;
   WinSendMsg (hwndVscroll, SBM_SETSCROLLBAR,
			    MPFROM2SHORT (sVscrollPos, 0),
			    MPFROM2SHORT (0, sVscrollMax)) ;

   WinEnableWindow (hwndVscroll, FALSE) ;
   WinInvalidateRect(hwndMain, NULL, FALSE);
}
/*==============================================================*\
 *  Svrpthrd.c - pipe processing routine: initialization and
 *		 and message display threads.
 *
 *	Copyright 1992, IBM Corp.
 *
 *  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *  sample code created by IBM Corporation. This sample code is not
 *  part of any standard or IBM product and is provided to you solely
 *  for	 the purpose of assisting you in the development of your
 *  applications.  The code is provided "AS IS", without
 *  warranty of any kind.  IBM shall not be liable for any damages
 *  arising out of your use of the sample code, even if they have been
 *  advised of the possibility of   such damages.						      *
 *
 *
\*==============================================================*/


#define INCL_DOSPROCESS
#define INCL_DOSNMPIPES
#define INCL_DOSSEMAPHORES
#define INCL_DOSMEMMGR
#define INCL_WINMESSAGEMGR
#define INCL_DOSERRORS
#define INCL_DOSFILEMGR

#include <os2.h>

#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "svrpglbl.h"
#include "svrpmain.h"
#include "svrpxtrn.h"
#include "namepipe.h"


#define STACKSIZE    8192


HEV    hevMsgRcvd;   /* event semaphore for displaying pipe messages */
extern
HPIPE  hpStartPipe;  /* handle to pipe through which start requests are made */


/* setup and start threads to manage pipes */
HPIPE InitThreads()
{
   BOOL	   fSuccess=FALSE;
   ULONG   ulErrorMsg=0;

   if ((BOOL)DosCreateEventSem(NULL, &hevMsgRcvd, 0L, FALSE))
   {
      ulErrorMsg = IDMSG_CREATE_SEM_FAILED;
   }

   else if((BOOL)DosCreateNPipe(START_PIPE_NAME,
			    &hpStartPipe,
			    FS_SVR_STARTPIPE_OPEN_MODE,
			    FS_SVR_STARTPIPE_PIPE_MODE,
			    sizeof(PIPE_MSG)*3,
			    sizeof(PIPE_MSG)*3,
			    PIPE_TIMEOUT))
   {
      ulErrorMsg = IDMSG_CREATE_PIPE_FAILED;
   }

   else if (0 > _beginthread(DisplayPipeMsg,
			     NULL,
			     STACKSIZE,
			     NULL))
   {
      ulErrorMsg = IDMSG_CREATE_THREAD_FAILED;
   }

   else if (0 > _beginthread(ConnectPlayer,
			     NULL,
			     STACKSIZE,
			     NULL))
   {
      ulErrorMsg = IDMSG_CREATE_THREAD_FAILED;
   }

   else
   {
      fSuccess = TRUE;
   }

   if (!fSuccess)
   {
      MessageBox(hwndMain, ulErrorMsg, MB_OK | MB_ERROR, TRUE);
      hpStartPipe = (HPIPE)0;					/* TEST CODE */
   }

   return (hpStartPipe);					/* TEST CODE */
}


VOID ConnectPlayer(VOID *dummy)
{
   USHORT  usMsgType, usErrorMsg=0;
   HPIPE   hpGamePipe[2];  /* buffer pipe handles */
   BOOL	   fExit=FALSE;
   int	   iPipeIndex=0;
   APIRET  apirc;

   while (!fAppExit &&	/* test for end before */
	  !fExit &&
	  !(BOOL)(apirc=DosConnectNPipe(hpStartPipe)) &&  /* wait to connect next player */
	  !fAppExit)	/* and after waiting */
   {
      usMsgType = ERROR_MSG;

      if ((BOOL)DosCreateNPipe(GAME_PIPE_NAME,	/* create pipe for next player */
		       &hpGamePipe[iPipeIndex],
		       FS_SVR_GAMEPIPE_OPEN_MODE,
		       FS_SVR_GAMEPIPE_PIPE_MODE,
		       sizeof(PIPE_MSG)*3,
		       sizeof(PIPE_MSG)*3,
		       PIPE_TIMEOUT))
      {
	 usErrorMsg = IDMSG_CREATE_PIPE_FAILED;
      }

      else if (0 > _beginthread(GameThread,   /* begin game thread */
				NULL,
				STACKSIZE,
				(VOID *)&hpGamePipe[iPipeIndex]))
      {
	 usErrorMsg = IDMSG_CREATE_THREAD_FAILED;
	 DosClose(hpGamePipe[iPipeIndex]);  /* close the created pipe */
      }

      else
      {
	 usMsgType = START_MSG;
      }

      /* write start message to client, if we have an error, notify him */
      /* and close pipe, 'cause we could care less about him now */
      if ((BOOL)Pipe_IO(SERVER, hpStartPipe, &usMsgType, &usErrorMsg, 0) &&
	  usMsgType != ERROR_MSG)
      {
	 usErrorMsg = IDMSG_PIPE_WRITE_FAILED;
      }

      /* read confirmation from client. if he has an error, this is how he notifies us */
      else if ((BOOL)Pipe_IO(CLIENT, hpStartPipe, &usMsgType, &usErrorMsg, 0))
      {
	 usErrorMsg = IDMSG_PIPE_READ_FAILED;
      }

      else if (ERROR_MSG == usMsgType)	/* the client cannot use the game pipe */
      {
	 /* notify the thread here.  We can write to its pipe like
	    we were the client and tell it of a fatal error condition. */
	 if (Pipe_IO(SERVER, hpGamePipe[iPipeIndex], &usMsgType, &usErrorMsg, 0))
	 {
	    /* if we cannot talk to the thread, we are in deep doo-doo, as the
	       next client might try to grab the same busted pipe.  Disconnect
	       it, hope for the best, and let the game thread do what it will */
	    DosDisConnectNPipe(hpGamePipe[iPipeIndex]);
	    DosClose(hpGamePipe[iPipeIndex]);
	 }
      }

      else
      {
	 iPipeIndex = 1 - iPipeIndex;  /* flip index value */
      }

      if ((BOOL)DosDisConnectNPipe(hpStartPipe))  /* disconnect start pipe */
      {
	 usErrorMsg = IDMSG_START_PIPE_ERROR;
	 fExit = TRUE;
      }

      if ((BOOL)usErrorMsg)
      {
	 WinPostMsg(hwndMain, WM_MSG, MPFROMLONG(usErrorMsg), MPVOID);
	 usErrorMsg = 0;
      }
   }

   /* if the connect bombed, and not because we closed the pipe on it... */
   if (!fAppExit)
   {
      WinPostMsg(hwndMain, WM_MSG, MPFROMLONG(IDMSG_CONNECT_FAILED), MPVOID);
      WinPostMsg(hwndMain, WM_COMMAND, MPFROMLONG(IDM_FILEEXIT), MPVOID);
      fAppExit = TRUE;
   }

   DosPostEventSem(hevMsgRcvd);	 /* notify DisplayPipeMsg */
   DosClose(hpGamePipe[0]);	 /* close what you can in case */
   DosClose(hpGamePipe[1]);	 /*   the game thread can't.   */
   fThrdsDead = TRUE;		 /* outta here... */
}


#define	 BUFFSIZE  10

/* buffer for pipe messages to be formatted and displayed */
struct
   {
      BOOL	fServer;
      ULONG	ulID;
      PIPE_MSG	pmsgMsg;
      CHAR	pszMsgString[MESSAGE_LEN];
   }
   stMsgBuff[BUFFSIZE];


/* Write or read to given pipe and write message to display buffer.
 */
APIRET Pipe_IO(BOOL fServer, HPIPE hpPipe, USHORT *usType, USHORT *usData, ULONG ulID)
{
   static int iMsgIndex=0;
   PIPE_MSG   pmsgPipeMsg;
   APIRET     apiRC;
   ULONG      ulCount;

   if (fServer)	 /* outgoing, from the server */
   {
      pmsgPipeMsg.usMsgType = *usType;
      pmsgPipeMsg.usMsgData = *usData;
      apiRC = DosWrite(hpPipe, (VOID *)&pmsgPipeMsg, sizeof(PIPE_MSG), &ulCount);

      DosEnterCritSec();   /* the update to the message buffer should be atomic */

      stMsgBuff[iMsgIndex].fServer = fServer;
      stMsgBuff[iMsgIndex].pmsgMsg.usMsgType = *usType;
      stMsgBuff[iMsgIndex].pmsgMsg.usMsgData = *usData;
      stMsgBuff[iMsgIndex].ulID = ulID;
      iMsgIndex = (iMsgIndex < BUFFSIZE-1) ? iMsgIndex+1 : 0;

      DosExitCritSec();

      DosPostEventSem(hevMsgRcvd);  /* tell displaypipemsg() to display */
   }

   else if(!(apiRC = DosRead(hpPipe, (VOID *)&pmsgPipeMsg, sizeof(PIPE_MSG), &ulCount))
	   && ulCount > 0)
   {
      *usType = pmsgPipeMsg.usMsgType;
      *usData = pmsgPipeMsg.usMsgData;

      DosEnterCritSec();

      stMsgBuff[iMsgIndex].fServer = fServer;
      stMsgBuff[iMsgIndex].pmsgMsg.usMsgType = *usType;
      stMsgBuff[iMsgIndex].pmsgMsg.usMsgData = *usData;
      stMsgBuff[iMsgIndex].ulID = ulID;
      iMsgIndex = (iMsgIndex < BUFFSIZE-1) ? iMsgIndex+1 : 0;

      DosExitCritSec();

      DosPostEventSem(hevMsgRcvd);
   }

   /* DosRead returns an error code of 0 and 0 bytes read with a broken pipe */

   else if (0 == ulCount)
   {
      apiRC = ERROR_BROKEN_PIPE;
   }

   return(apiRC);
}


VOID DisplayPipeMsg(VOID *dummy)
{
   ULONG       ulPosts;
   static int  iMsgIndex=0;
   CHAR	       *pszSender, *pszType;

   while (!DosWaitEventSem(hevMsgRcvd, SEM_INDEFINITE_WAIT) &&
	  !fAppExit)
   {
      DosResetEventSem(hevMsgRcvd, &ulPosts);
      while (ulPosts-- > 0)		 /* format all of the messages posted */
      {
	 /* format pipe message here */
	 if (stMsgBuff[iMsgIndex].fServer)
	 {
	    pszSender = "SERVER";
	 }

	 else
	 {
	    pszSender = "CLIENT";
	 }

	 switch (stMsgBuff[iMsgIndex].pmsgMsg.usMsgType)
	 {
	    case START_MSG:
	       pszType = START_MSG_TEXT;
	       break;

	    case CLIENT_MOVE:
	       pszType = CLIENT_MOVE_TEXT;
	       break;

	    case YOU_FIRST:
	       pszType = YOU_FIRST_TEXT;
	       break;

	    case ERROR_MSG:
	       pszType = ERROR_MSG_TEXT;
	       break;

	    case CLIENT_QUIT:
	       pszType = CLIENT_QUIT_TEXT;
	       break;

	    case WIN_CLIENT:
	       pszType = WIN_CLIENT_TEXT;
	       break;

	    case WIN_SERVER:
	       pszType = WIN_SERVER_TEXT;
	       break;

	    case SERVER_MOVE:
	       pszType = SERVER_MOVE_TEXT;
	       break;

	    case WIN_DRAW:
	       pszType = WIN_DRAW_TEXT;
	       break;

	    default:
	       pszType = "UNKNOWN";
	 }

	 /* format the text of the message */
	 sprintf(stMsgBuff[iMsgIndex].pszMsgString, "Thread %03u, %s Message: %s: %u", stMsgBuff[iMsgIndex].ulID, pszSender, pszType, stMsgBuff[iMsgIndex].pmsgMsg.usMsgData);

	 /* post pointer to said message to the PM thread */
	 WinPostMsg(hwndMain, WM_PIPEMSG, MPFROMP(stMsgBuff[iMsgIndex].pszMsgString), MPVOID);

	 /* increment circular list index */
	 iMsgIndex = (iMsgIndex < BUFFSIZE-1) ? iMsgIndex+1 : 0;
      }
   }

   DosCloseEventSem(hevMsgRcvd);
}
/*==============================================================*\
 *  Help.c - routines for the help manager interface
 *	Copyright 1992 IBM Corp.
 *--------------------------------------------------------------
 *
 *  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *  sample code created by IBM Corporation. This sample code is not
 *  part of any standard or IBM product and is provided to you solely
 *  for	 the purpose of assisting you in the development of your
 *  applications.  The code is provided "AS IS", without
 *  warranty of any kind.  IBM shall not be liable for any damages
 *  arising out of your use of the sample code, even if they have been
 *  advised of the possibility of   such damages.
 *
 *--------------------------------------------------------------
 *
 *  This module contains all the routines for interfacing with
 *  the IPF help manager.
 *
 *--------------------------------------------------------------
 *
 *  This source file contains the following functions:
 *
 *	    InitHelp()
 *	    HelpHelpForHelp(mp2)
 *	    HelpExtended(mp2)
 *	    HelpKeys(mp2)
 *	    HelpIndex(mp2)
 *	    HelpTutorial(mp2)
 *	    HelpAbout(mp2)
 *	    DisplayHelpPanel(idPanel)
 *	    DestroyHelpInstance()
 *
\*==============================================================*/



/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/

#define	 INCL_WINHELP

#include <os2.h>
#include <string.h>
#include "svrqmain.h"
#include "svrqhelp.h"
#include "svrqxtrn.h"
#include "svrqglbl.h"

#define HELPLIBRARYNAMELEN  20

/* If DEBUG is defined, then the help panels will display their
 *  id values on their title bar.  This is useful for determining
 *  which help panels are being shown for each dialog item.  When
 *  the DEBUG directive is not defined, then the panel ids are not
 *  displayed.
 */

/* #define  DEBUG */


/*--------------------------------------------------------------*\
 *  Global variables
\*--------------------------------------------------------------*/
static HWND hwndHelpInstance;
static CHAR szLibName[HELPLIBRARYNAMELEN];
static CHAR szWindowTitle[HELPLIBRARYNAMELEN];


/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/
MRESULT EXPENTRY AboutBoxDlgProc(HWND	hwnd,
				 ULONG	msg,
				 MPARAM mp1,
				 MPARAM mp2);



/****************************************************************\
 *  Routine for initializing the help manager
 *--------------------------------------------------------------
 *
 *  Name:   InitHelp()
 *
 *  Purpose: Initializes the IPF help facility
 *
 *  Usage:  Called once during initialization of the program
 *
 *  Method: Initializes the HELPINIT structure and creates the
 *	    help instance.  If successful, the help instance
 *	    is associated with the main window
 *
 *  Returns:
 *
\****************************************************************/
VOID InitHelp(VOID)
{
   HELPINIT hini;

   /* if we return because of an error, Help will be disabled */
   fHelpEnabled = FALSE;

   /* initialize help init structure */
   hini.cb = sizeof(HELPINIT);
   hini.ulReturnCode = 0L;

   hini.pszTutorialName = (PSZ)NULL;   /* if tutorial added, add name here */

   hini.phtHelpTable = (PHELPTABLE)MAKELONG(SVRQ_HELP_TABLE, 0xFFFF);
   hini.hmodHelpTableModule = 0L;
   hini.hmodAccelActionBarModule = 0L;
   hini.idAccelTable = 0;
   hini.idActionBar = 0;

   if(!WinLoadString(hab,
		     0,
		     IDS_HELPWINDOWTITLE,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szWindowTitle))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
      return;
   }

   hini.pszHelpWindowTitle = (PSZ)szWindowTitle;

   /* if debugging, show panel ids, else don't */
#ifdef DEBUG
    hini.fShowPanelId = CMIC_SHOW_PANEL_ID;
#else
    hini.fShowPanelId = CMIC_HIDE_PANEL_ID;
#endif

   if(!WinLoadString(hab,
		     0,
		     IDS_HELPLIBRARYNAME,
		     HELPLIBRARYNAMELEN,
		     (PSZ)szLibName))
   {
      MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, MB_OK | MB_ERROR, FALSE);
      return;
   }

   hini.pszHelpLibraryName = (PSZ)szLibName;

   /* creating help instance */
   hwndHelpInstance = WinCreateHelpInstance(hab, &hini);

   if(hwndHelpInstance == NULLHANDLE || hini.ulReturnCode)
   {
      MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, MB_OK | MB_ERROR, TRUE);
      return;
   }

   /* associate help instance with main frame */
   if(!WinAssociateHelpInstance(hwndHelpInstance, hwndMainFrame))
   {
      MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, MB_OK | MB_ERROR, TRUE);
      return;
   }

   /* help manager is successfully initialized so set flag to TRUE */
   fHelpEnabled = TRUE;

}  /* InitHelp() */


/****************************************************************\
 *  Processes the Help for Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpHelpForHelp(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Help for Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Help for Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_DISPLAY_HELP message to the help
 *	    instance so that the default Help For Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpHelpForHelp(MPARAM mp2)
{

   /* this just displays the system help for help panel */
   if(fHelpEnabled)
   {
      if(WinSendMsg(hwndHelpInstance, HM_DISPLAY_HELP, MPVOID, MPVOID))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    MB_OK | MB_ERROR,
		    FALSE);
      }
   }
}   /* HelpHelpForHelp() */


/****************************************************************\
 *  Processes the Extended Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpExtended(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Extended Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Extended Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_EXT_HELP message to the help
 *	    instance so that the default Extended Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpExtended(MPARAM mp2)
{

   /* this just displays the system extended help panel */
   if(fHelpEnabled)
   {
      if((BOOL32)WinSendMsg(hwndHelpInstance, HM_EXT_HELP, NULL, NULL))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    MB_OK | MB_ERROR,
		    FALSE);
      }
   }
}   /* HelpExtended() */


/****************************************************************\
 *  Processes the Keys Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpKeys(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Keys Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Keys Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_KEYS_HELP message to the help
 *	    instance so that the default Keys Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpKeys(MPARAM mp2)
{

   /* this just displays the system keys help panel */
   if(fHelpEnabled)
   {
      if(WinSendMsg(hwndHelpInstance, HM_KEYS_HELP, MPVOID, MPVOID))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    MB_OK | MB_ERROR,
		    FALSE);
      }
   }
}   /* HelpKeys() */


/****************************************************************\
 *  Processes the Index Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpIndex(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Index Help item of the Help menu
 *
 *  Usage:  Called from MainCommand when the Index Help
 *	    menu item is selected
 *
 *  Method: Sends an HM_INDEX_HELP message to the help
 *	    instance so that the default Index Help is
 *	    displayed.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpIndex(MPARAM mp2)
{

   /* this just displays the system help index panel */
   if(fHelpEnabled)
   {
      if(WinSendMsg(hwndHelpInstance, HM_HELP_INDEX, MPVOID, MPVOID))
      {
	 MessageBox(hwndMain,
		    IDMSG_HELPDISPLAYERROR,
		    MB_OK | MB_ERROR,
		    FALSE);
      }
   }
}   /* HelpIndex() */


/****************************************************************\
 *  Processes the Tutorial Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:   HelpTutorial(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      Tutorial Help item of the Help menu.  While the
 *	      standard template application does not include a
 *	      Tutorial menu item, you can add one if your
 *	      application has a tutorial.
 *
 *  Usage:  Called from MainCommand when the Tutorial Help
 *	    menu item is selected
 *
 *  Method:
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpTutorial(MPARAM mp2)
{

   /*--------------------------------------------------------------*\
    *  Insert code for any tutorial here
   \*--------------------------------------------------------------*/
}   /* HelpTutorial() */


/****************************************************************\
 *  Processes the About command from the Help menu
 *--------------------------------------------------------------
 *
 *  Name:   HelpAbout(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the
 *	      About item of the Help menu
 *
 *  Usage:  Called from MainCommand when the About
 *	    menu item is selected
 *
 *  Method: Calls WinDlgBox to display the about box dialog.
 *
 *  Returns:
 *
\****************************************************************/
VOID  HelpAbout(MPARAM mp2)
{

   /* display the AboutBox dialog */
   WinDlgBox(HWND_DESKTOP,
	     hwndMainFrame,
	     AboutBoxDlgProc,
	     0,
	     IDD_ABOUTBOX,
	     (PVOID)NULL);
}   /* HelpAbout() */


/****************************************************************\
 *  Displays the help panel indicated
 *--------------------------------------------------------------
 *
 *  Name:   DisplayHelpPanel(idPanel)
 *
 *  Purpose: Displays the help panel whose id is given
 *
 *  Usage:  Called whenever a help panel is desired to be
 *	    displayed, usually from the WM_HELP processing
 *	    of the dialog boxes
 *
 *  Method: Sends HM_DISPLAY_HELP message to the help instance
 *
 *  Returns:
 *
\****************************************************************/
VOID DisplayHelpPanel(SHORT idPanel)  /* ID of the help panel to be displayed */
{

   if(fHelpEnabled)
   {
      if((BOOL32)WinSendMsg(hwndHelpInstance,
		    HM_DISPLAY_HELP,
		    MPFROMLONG(MAKELONG(idPanel, NULL)),
		    MPFROMSHORT(HM_RESOURCEID)))
      {
	 MessageBox(hwndMainFrame,
		    IDMSG_HELPDISPLAYERROR,
		    MB_OK | MB_ERROR,
		    TRUE);
      }
   }
}   /* DisplayHelpPanel() */



/****************************************************************\
 *  Destroys the help instance
 *--------------------------------------------------------------
 *
 *  Name:   DestroyHelpInstance(VOID)
 *
 *  Purpose: Destroys the help instance for the application
 *
 *  Usage:  Called after exit from message loop
 *
 *  Method: Calls WinDestroyHelpInstance() to destroy the
 *	    help instance
 *
 *  Returns:
 *
\****************************************************************/
VOID DestroyHelpInstance(VOID)
{

   if(hwndHelpInstance != NULLHANDLE)
   {
      WinDestroyHelpInstance(hwndHelpInstance);
   }
}   /* DestroyHelpInstance() */


/****************************************************************\
 *  Dialog procedure for the About dialog box
 *--------------------------------------------------------------
 *
 *  Name:   AboutBoxDlgProc(hwnd, msg, mp1, mp2)
 *
 *  Purpose: Processes all messages sent to the About Box
 *
 *  Usage:  Called for each message sent to the About Box
 *	    dialog box.
 *
 *  Method: the about box only has a button control so this
 *	    routine only processes WM_COMMAND messages.	 Any
 *	    WM_COMMAND posted must have come from the Ok
 *	    button so we dismiss the dialog upon receiving it.
 *
 *  Returns: Dependent upon message sent
 *
\****************************************************************/
MRESULT EXPENTRY AboutBoxDlgProc(HWND	hwnd,	 /* handle of window */
				 ULONG	msg,	 /* id of message */
				 MPARAM mp1,	 /* first message parameter */
				 MPARAM mp2)	 /* second message parameter */
{
   switch(msg)
   {
      case WM_COMMAND:
	 /* no matter what the command, close the dialog */
	 WinDismissDlg(hwnd, TRUE);
	 break;

      default:
	 return(WinDefDlgProc(hwnd, msg, mp1, mp2));
	 break;
   }

   return (MRFROMLONG(0));

}   /* AboutBoxWndProc() */
/*==============================================================*\
 *  Svrqmain.c - Queue Server sample app
 *	Copyright 1992 IBM Corp.
 *--------------------------------------------------------------
 *
 *  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *  sample code created by IBM Corporation. This sample code is not
 *  part of any standard or IBM product and is provided to you solely
 *  for	 the purpose of assisting you in the development of your
 *  applications.  The code is provided "AS IS", without
 *  warranty of any kind.  IBM shall not be liable for any damages
 *  arising out of your use of the sample code, even if they have been
 *  advised of the possibility of   such damages.
 *
 *--------------------------------------------------------------
 *
 *  This c file contains the window creation routines and
 *  manages the PM message queue.
 *
\*==============================================================*/



/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/
#define INCL_WINHELP
#define INCL_WININPUT
#define INCL_DOSPROCESS
#define INCL_DOSQUEUES
#define INCL_WINMESSAGEMGR
#define INCL_WINWINDOWMGR
#define INCL_WINMENUS
#define INCL_WINFRAMEMGR

#include <os2.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "svrqmain.h"
#include "svrqhelp.h"
#include "svrqxtrn.h"

#define	 THRD_EXIT_TIMEOUT  10

/*--------------------------------------------------------------*\
 *  Global variables
\*--------------------------------------------------------------*/

HWND   hwndMainFrame = NULLHANDLE;    /* handle to the main frame window */
HWND   hwndMain;		      /* handle to the main client window */
HAB    hab;			      /* anchor block for the process */
HMQ    hmq;			      /* handle to the process' message queue */
CHAR   szAppName[MAXNAMEL];	      /* buffer for application name string */
CHAR   szUntitled[TITLE_LEN];	      /* buffer for "Untitled" string */
BOOL   fHelpEnabled;		      /* flag to determine if help is enabled */
HQUEUE hqQ;
SHORT  sTotalMsgs;
CHAR   SvrQMsgs[MAX_MESSAGES][MESSAGE_LEN+38];
BOOL   fThrdsDead=FALSE;	      /* notification of thread exitting */

unsigned int  iIndex=0;		      /* beginning of circular buffer */


/****************************************************************\
 *  Main routine
 *--------------------------------------------------------------
 *
 *  Name:   main()
 *
 *  Purpose: Initializes the PM environment, calls the
 *		initialization routine, creates the main
 *		window,	 and polls the message queue
 *
 *  Usage:
 *
 *  Method:
 *	    - obtains anchor block handle and creates message
 *		queue
 *	    - calls the initialization routine
 *	    - creates the main frame window which creates the
 *		main client window
 *	    - polls the message queue via Get/Dispatch Msg loop
 *	    - upon exiting the loop, exits
 *
 *  Returns:
 *	    0 - if successful execution completed
 *	    1 - if error
\****************************************************************/
INT main(int argc, char *argv[])
{
   QMSG	       qmsg;	      /* message structure */
   static int  iTimeOut=THRD_EXIT_TIMEOUT;

   hab = WinInitialize(0);

   if(!hab)
   {
      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      return(RETURN_ERROR);
   }

   hmq = WinCreateMsgQueue(hab, 0);

   if(!hmq)
   {
      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      WinTerminate(hab);
      return(RETURN_ERROR);
   }

   if(!Init(argc, argv))
   {
      if(hwndMainFrame == NULLHANDLE)
      {
	  MessageBox(HWND_DESKTOP,
		     IDMSG_MAINWINCREATEFAILED,
		     MB_OK | MB_ERROR,
		     TRUE);
      }

      else
      {
	 MessageBox(HWND_DESKTOP,
		    IDMSG_INITFAILED,
		    MB_OK | MB_ERROR,
		    TRUE);

      }
      DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
      if (WinIsWindow(hab, hwndMainFrame))
      {
	 WinDestroyWindow(hwndMainFrame);
      }
      WinDestroyMsgQueue(hmq);
      WinTerminate(hab);
      return(RETURN_ERROR);
   }

   /* Get-Dispatch Message loop */
   while(WinGetMsg(hab, (PQMSG)&qmsg, NULLHANDLE, 0, 0))
      WinDispatchMsg(hab, (PQMSG)&qmsg);


   /* destroy the help instance */
   DestroyHelpInstance();

   if (WinIsWindow(hab, hwndMainFrame))
      WinDestroyWindow(hwndMainFrame);
   WinDestroyMsgQueue(hmq);

   /* give other thread a chance to exit */
   while (!fThrdsDead && iTimeOut--)
   {
      DosSleep(0);
   }

   WinTerminate(hab);
   return(RETURN_SUCCESS);

}   /* main() */


/****************************************************************\
 *  Main client window procedure
 *--------------------------------------------------------------
 *
 *  Name:   MainWndProc(hwnd, msg, mp1, mp2)
 *
 *  Purpose: Processes the messages sent to the main client
 *		window.	 This routine processes the basic
 *		messages all client windows should process
 *		and passes all others onto WinDefWindowProc.
 *
 *  Usage:  Called for each message placed in the main
 *	    window's message queue
 *
 *  Method: a switch statement branches to the routines to be
 *	    performed for each message processed.
 *
 *  Returns:  Return values are determined by each message
 *
\****************************************************************/
MRESULT EXPENTRY MainWndProc(HWND   hwnd,    /* handle of window */
			     ULONG  msg,     /* id of message */
			     MPARAM mp1,     /* first message parameter */
			     MPARAM mp2)     /* second message parameter */
{
   QDATA       *pqdataQ;

   switch(msg)
   {
      case WM_CREATE:
	 return(InitMainWindow(hwnd, mp1, mp2));
	 break;

      case WM_PAINT:
	 MainPaint(hwnd, SvrQMsgs, iIndex, sTotalMsgs);
	 break;

      case WM_SIZE:
	 MainSize(hwnd, sTotalMsgs, mp1, mp2);
	 break;

      case WM_HSCROLL:
	 MainHorizScroll(hwnd, mp2);
	 break;

      case WM_VSCROLL:
	 MainVertScroll(hwnd, mp2);
	 break;

      case WM_CHAR:
	 switch (SHORT2FROMMP(mp2))
	 {
	    case VK_LEFT:
	    case VK_RIGHT:
	       return MainCharHScroll (hwnd, msg, mp1, mp2) ;
	    case VK_UP:
	    case VK_DOWN:
	    case VK_PAGEUP:
	    case VK_PAGEDOWN:
	       return MainCharVScroll (hwnd, msg, mp1, mp2) ;
	 }
	 break ;

      case WM_COMMAND:
	 MainCommand(mp1, mp2);
	 break;

      case HM_QUERY_KEYS_HELP:
	 return (MRESULT)PANEL_HELPKEYS;   /* return id of key help panel */
	 break ;

      case WM_NEWQMSG:
	 /* copy message into circular array, with index being next free spot in array */
	 pqdataQ = (QDATA *)PVOIDFROMMP(mp1);
	 sprintf(SvrQMsgs[iIndex],
		 "Process ID: %03lu, Priority: %02hu,  Message: %s",
		 pqdataQ->pidProcess,
		 pqdataQ->usPriority,
		 pqdataQ->pszMsg);

	 /* increment index, or reset to 0 as appropriate */
	 iIndex = (iIndex < MAX_MESSAGES-1) ? iIndex+1 : 0;

	 /* increment total message count until buffer is filled */
	 sTotalMsgs = min(MAX_MESSAGES, sTotalMsgs+1);

	 MainUpdateMsg(hwnd, SvrQMsgs, iIndex, sTotalMsgs);
	 break;

      case WM_MSG:
	 MessageBox(hwndMain, (ULONG)SHORT1FROMMP(mp1), MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL, TRUE);
	 break;

      case WM_CLOSE:
	 DosWriteQueue(hqQ, WM_CLOSE, 0, NULL, 15);

	 /* process the WM_CLOSE */

   /*--------------------------------------------------*\
    *	   Any messages not processed are passed on
    *	   to WinDefWindowProc.
   \*--------------------------------------------------*/

      default:
	 return(WinDefWindowProc(hwnd, msg, mp1, mp2));
	 break;
   }

   return (MRFROMLONG(0));	/* all window procedures should return 0 as a default */

}   /* MainWndProc() */


/****************************************************************\
 *  Message Box procedure
 *--------------------------------------------------------------
 *
 *  Name:   MessageBox(hwndOwner, nIdMsg, fsStyle, fBeep)
 *
 *  Purpose: Displays the message box with the message
 *		given in idMsg retrieved from the message table
 *		and using the style flags in fsStyle
 *
 *  Usage:  Called whenever a MessageBox is to be displayed
 *
 *  Method: - Message string is loaded from the process'
 *		message table
 *	    - Alarm beep is sounded if desired
 *	    - Message box with the message is displayed
 *	    - WinMessageBox return value is returned
 *
 *  Returns: return value from WinMessageBox()
 *
\****************************************************************/

ULONG MessageBox(HWND hwndOwner,  /* handle of the message box's owner */
		 ULONG idMsg,	  /* id if the message in the message table */
		 ULONG fsStyle,	  /* style of the message box */
		 BOOL fBeep)	  /* if TRUE, beep before message box is displayed */
{
   CHAR szText[TITLE_LEN];

   if(!WinLoadMessage(hab,
		     (HMODULE)NULL,
		     idMsg,
		     TITLE_LEN,
		     (PSZ)szText))
   {
      WinAlarm(HWND_DESKTOP, WA_ERROR);
      return MBID_ERROR;
   }

   if(fBeep)  {
      WinAlarm(HWND_DESKTOP, WA_ERROR);
   }

   return(WinMessageBox(HWND_DESKTOP,
			hwndOwner,
			szText,
			(PSZ)NULL,
			MSGBOXID,
			fsStyle));

}   /* MessageBox() */


/****************************************************************\
 *  Main window WM_COMMAND processing procedure
 *--------------------------------------------------------------
 *
 *  Name:   MainCommand(mp1, mp2)
 *
 *  Purpose: Calls the appropriate procedures that deal with
 *		the selected menu item.
 *
 *  Usage:  Routine is called whenever a WM_COMMAND message
 *	    is posted to the main window.
 *
 *  Method: a switch statement branches on the id of the
 *	    menu item that posted the message and the
 *	    appropriate action for that item is taken.
 *
 *  Returns:
 *
\****************************************************************/
VOID MainCommand(MPARAM mp1, MPARAM mp2)
{

   switch(SHORT1FROMMP(mp1))
   {
      case IDM_FILEEXIT:
	 FileExit();
	 break;

      case IDM_OPTIONPURGE:
	 iIndex = sTotalMsgs = 0;

	 /* get memory thread, write priority 15 message to tell thread to purge Q */
	 DosWriteQueue(hqQ, IDM_OPTIONPURGE, 0, NULL, 15);
	 MainPurgeWindow();
	 break;

      case IDM_HELPHELPFORHELP:
	 HelpHelpForHelp(mp2);
	 break;

      case IDM_HELPEXTENDED:
	 HelpExtended(mp2);
	 break;

      case IDM_HELPKEYS:
	 HelpKeys(mp2);
	 break;

      case IDM_HELPINDEX:
	 HelpIndex(mp2);
	 break;

      case IDM_HELPTUTORIAL:
	 HelpTutorial(mp2);
	 break;

      case IDM_HELPABOUT:
	 HelpAbout(mp2);
	 break;

      default:
	 break;
    }

}   /* MainCommand() */


/****************************************************************\
 *  Initialization routine
 *--------------------------------------------------------------
 *
 *  Name:   Init()
 *
 *  Purpose: Performs initialization functions.
 *
 *  Usage:  Called once before the message queue is queried.
 *
 *  Method:
 *	    - starts processing thread
 *	    - registers all window classes
 *
 *  Returns:
 *	    TRUE - initialization is successful
 *	    FALSE - initialization failed
\****************************************************************/
BOOL Init(int argc, char *argv[])
{
   PTIB	  ptibDummy;
   PIB	  *ppibProcess;
   ULONG  flCtlData;	/* frame control data */
   CHAR	  pszBuff[CCHMAXPATH];
   RESULTCODES	resc;


   /* load application name from resource file */
   if(!WinLoadString(hab, 0, IDS_APPNAME, MAXNAMEL, szAppName))
      return FALSE;

   /* register the main client window class */
   if(!WinRegisterClass(hab,
			(PSZ)szAppName,
			MainWndProc,
			CS_SIZEREDRAW | CS_CLIPCHILDREN,
			0))
   {
      return FALSE;
   }

   flCtlData = FCF_STANDARD | FCF_VERTSCROLL | FCF_HORZSCROLL;

   if (NULLHANDLE == (hwndMainFrame = WinCreateStdWindow(HWND_DESKTOP,
							 WS_VISIBLE,
							 (PULONG)&flCtlData,
							 (PSZ)szAppName,
							 (PSZ)NULL,
							 WS_VISIBLE,
							 (HMODULE)NULL,
							 IDR_MAIN,
							 &hwndMain)))
      return FALSE;

   WinSetWindowText(hwndMainFrame, szAppName);

   if (DosGetInfoBlocks(&ptibDummy, &ppibProcess) ||
       !(hqQ = InitQ((*ppibProcess).pib_ulpid,	/* proccess that will send WM_CLOSE command */
		     hwndMainFrame)))		/* window to post to */
      return FALSE;

   if (argc > 1)
   {
      if ((BOOL)DosExecPgm(pszBuff, CCHMAXPATH, EXEC_ASYNC, NULL, NULL, &resc, argv[1]))
      {
	 MessageBox(hwndMain, IDMSG_CANNOT_EXEC_CLIENT, MB_CUAWARNING | MB_OK, TRUE);
      }
   }

   InitHelp();

   return TRUE;
}  /* Init() */


/****************************************************************\
 *  Exit routine
 *--------------------------------------------------------------
 *
 *  Name:   FileExit(mp2)
 *
 *  Purpose: Processes the File menu's Exit item.
 *
 *  Usage:  called whenever Exit from the file menu is
 *	    selected
 *
 *  Method:  Routine posts a WM_CLOSE message to the main
 *	     application window.
 *
 *  Returns:
 *
\****************************************************************/
VOID FileExit()
{

   WinPostMsg(hwndMain, WM_CLOSE, (MPARAM)NULL, (MPARAM)NULL);

}   /* FileExit() */


/*==============================================================*\
 *  Pnt.c - routines for the painting of the main window
 *	Copyright 1990, 1992 IBM Corp.
 *--------------------------------------------------------------
 *
 *  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *  sample code created by IBM Corporation. This sample code is not
 *  part of any standard or IBM product and is provided to you solely
 *  for	 the purpose of assisting you in the development of your
 *  applications.  The code is provided "AS IS", without
 *  warranty of any kind.  IBM shall not be liable for any damages
 *  arising out of your use of the sample code, even if they have been
 *  advised of the possibility of   such damages.
 *
 *--------------------------------------------------------------
 *  This module contains the code for the main client window
 *  painting
 *
\*==============================================================*/



/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/

#define INCL_WINMESSAGEMGR
#define INCL_WINWINDOWMGR
#define INCL_GPICONTROL
#define INCL_GPIPRIMITIVES
#define INCL_GPILCIDS
#define INCL_DOSPROCESS
#define INCL_WINFRAMEMGR
#define INCL_WINSCROLLBARS

#include <os2.h>
#include <stdlib.h>
#include <string.h>
#include "svrqmain.h"
#include "svrqglbl.h"
/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/

#include "svrqxtrn.h"


/* returns offset from beginning of circular queue */
#define	 BUFF_OFFSET(index, offset)  (((index)+(offset) < MAX_MESSAGES) ? (index)+(offset) : (index)+(offset)-MAX_MESSAGES)

/*--------------------------------------------------------------*\
 *  Global (module) variables
\*--------------------------------------------------------------*/

HWND  hwndHscroll, hwndVscroll ;
LONG  sHscrollMax=0, sVscrollMax=0, sHscrollPos=0, sVscrollPos=0, cxChar,
      cxCaps, cyChar, cyDesc, cxClient, cyClient, cxTextTotal;


/****************************************************************\
 *  Main client painting routine
 *--------------------------------------------------------------
 *
 *  Name:   MainPaint(hwnd)
 *
 *  Purpose: Paints the main client window.
 *
 *  Usage:  Routine is called whenver the client window
 *	    procedure receives a WM_PAINT message
 *
 *  Method:
 *	    - begins painting by calling WinBeginPaint
 *		and retrieving the HPS for the window
 *	    - performs any painting desired
 *	    - ends painting by calling WinEndPaint
 *
 *  Returns:
 *
\****************************************************************/
VOID MainPaint(HWND hwnd,				     /* handle to window */
	       CHAR SvrQMsgs[MAX_MESSAGES][MESSAGE_LEN+38],  /* array of messages */
	       unsigned int uiIndex,			     /* beginning of circular array */
	       SHORT sTotalMsgs)			     /* total number of messages */
{
   RECTL	 rclInvalid;
   HPS		 hps;
   LONG		 sPaintBeg, sPaintEnd, sLine;
   POINTL	 ptl;
   unsigned int	 uiOffset;

   uiOffset = (sTotalMsgs < MAX_MESSAGES) ? 0 : uiIndex;

   hps = WinBeginPaint(hwnd, NULLHANDLE, (PRECTL)&rclInvalid);
   GpiErase(hps);

   sPaintBeg = max(0, sVscrollPos + (cyClient - rclInvalid.yTop) / cyChar);
   sPaintEnd = min(sTotalMsgs, sVscrollPos + (cyClient - rclInvalid.yBottom) / cyChar + 1);

   for (sLine = sPaintBeg ; sLine < sPaintEnd ; sLine++)
   {
      ptl.x = cxCaps - sHscrollPos ;
      ptl.y = cyClient - cyChar * (BUFF_OFFSET(uiOffset,sLine) + 1 - sVscrollPos) + cyDesc ;

      GpiCharStringAt (hps, &ptl,
		       (LONG) strlen (SvrQMsgs[BUFF_OFFSET(uiOffset,sLine)]),
		       SvrQMsgs[BUFF_OFFSET(uiOffset,sLine)]) ;
   }

   WinEndPaint (hps) ;
}   /* MainPaint() */


/****************************************************************\
 *  Initialization routine
 *--------------------------------------------------------------
 *
 *  Name:   InitMainWindow(hwnd, mp1, mp2)
 *
 *  Purpose: Performs initialization functions required
 *		when the main window is Copyright.
 *
 *  Usage:  Called once during the WM_CREATE processing when
 *	    the main window is Copyright.
 *
 *  Method:
 *
 *  Returns: value to be returned from the WM_CREATE message:
 *	    TRUE - window creation should stop
 *	    FALSE - window creation should continue
\****************************************************************/

MRESULT InitMainWindow(HWND hwnd,      /* handle to the main client window */
		       MPARAM mp1,     /* first parameter of WM_CREATE message */
		       MPARAM mp2)     /* second parameter of WM_CREATE message */
{
   FONTMETRICS fm;
   HPS	       hps;

   hps = WinGetPS (hwnd) ;
   GpiQueryFontMetrics (hps, (LONG) sizeof fm, &fm) ;

   cxChar = fm.lAveCharWidth ;
   cxCaps = fm.lEmInc ;
   cyChar = fm.lMaxBaselineExt ;
   cyDesc = fm.lMaxDescender ;

   WinReleasePS (hps) ;

   cxTextTotal = MESSAGE_LEN * cxChar ;

   hwndHscroll = WinWindowFromID (
		       WinQueryWindow (hwnd, QW_PARENT),
		       FID_HORZSCROLL) ;

   hwndVscroll = WinWindowFromID (
		       WinQueryWindow (hwnd, QW_PARENT),
		       FID_VERTSCROLL) ;

   return (MRFROMLONG(0));
}


/****************************************************************\
 *  Window sizing routine
 *--------------------------------------------------------------
 *
 *  Name:   InitMainWindow(hwnd, mp1, mp2)
 *
 *  Purpose: Adjusts scroll bars and window parameters
 *		when the main window is resized.
 *
 *  Usage:  Called when the client window receives a WM_SIZE
 *	    message.
 *
 *  Method:
 *
 *  Returns:
\****************************************************************/

MRESULT MainSize(HWND	hwnd,	 /* handle to the main client window */
		 USHORT sTotalMsgs,
		 MPARAM mp1,	 /* first parameter of WM_CREATE message */
		 MPARAM mp2)	 /* second parameter of WM_CREATE message */
{

   cxClient = SHORT1FROMMP (mp2) ;
   cyClient = SHORT2FROMMP (mp2) ;

   sHscrollMax = max (0, cxTextTotal - cxClient) ;
   sHscrollPos = min (sHscrollPos, sHscrollMax) ;

   WinSendMsg (hwndHscroll, SBM_SETSCROLLBAR,
			    MPFROM2SHORT (sHscrollPos, 0),
			    MPFROM2SHORT (0, sHscrollMax)) ;

   WinEnableWindow (hwndHscroll, (BOOL)((sHscrollMax != 0) ? TRUE : FALSE)) ;

   sVscrollMax = max (0, sTotalMsgs - cyClient / cyChar) ;
   sVscrollPos = min (sVscrollPos, sVscrollMax) ;

   WinSendMsg (hwndVscroll, SBM_SETSCROLLBAR,
			    MPFROM2SHORT (sVscrollPos, 0),
			    MPFROM2SHORT (0, sVscrollMax)) ;

   WinEnableWindow (hwndVscroll, (BOOL)((sVscrollMax != 0) ? TRUE : FALSE)) ;

   /* referenced to prevent compiler error */
   return (MRFROMLONG(0));
}


/****************************************************************\
 *  Horizontal scrolling routine
 *--------------------------------------------------------------
 *
 *  Name:   MainHorizScroll(hwnd, mp1, mp2)
 *
 *  Purpose: Scrolls window horizontally.
 *
 *  Usage:  Called when the client window receives a WM_HSCROLL
 *	    message.
 *
 *  Method:
 *
 *  Returns:
\****************************************************************/

MRESULT MainHorizScroll(HWND hwnd,   /* handle to the main client window */
			MPARAM mp2)  /* second parameter of WM_CREATE message */
{
   LONG sHscrollInc;

   switch (SHORT2FROMMP (mp2))
   {
      case SB_LINELEFT:
	 sHscrollInc = -cxCaps ;
	 break ;

      case SB_LINERIGHT:
	 sHscrollInc = cxCaps ;
	 break ;

      case SB_PAGELEFT:
	 sHscrollInc = -8 * cxCaps ;
	 break ;

      case SB_PAGERIGHT:
	 sHscrollInc = 8 * cxCaps ;
	 break ;

      case SB_SLIDERPOSITION:
	 sHscrollInc = SHORT1FROMMP (mp2) - sHscrollPos;
	 break ;

      default:
	 sHscrollInc = 0;
	 break ;
   }

   sHscrollInc = max (-sHscrollPos,
		 min (sHscrollInc, sHscrollMax - sHscrollPos)) ;

   if (sHscrollInc != 0)
   {
      sHscrollPos += sHscrollInc ;
      WinScrollWindow ((HWND)hwnd, -sHscrollInc, 0, (PRECTL)NULL,
		       (PRECTL)NULL, (HRGN)NULL, (PRECTL)NULL,
		       SW_INVALIDATERGN);

      WinSendMsg (hwndHscroll, SBM_SETPOS,
		  MPFROMSHORT (sHscrollPos), MPVOID) ;
   }
   return (MRFROMLONG(0));
}


/****************************************************************\
 *  Vertical scrolling routine
 *--------------------------------------------------------------
 *
 *  Name:   MainVertScroll(hwnd, mp2)
 *
 *  Purpose: Scrolls window vertically.
 *
 *  Usage:  Called when the client window receives a WM_VSCROLL
 *	    message.
 *
 *  Method:
 *
 *  Returns:
\****************************************************************/

MRESULT MainVertScroll(HWND hwnd,      /* handle to the main client window */
		       MPARAM mp2)     /* second parameter of WM_CREATE message */
{
   LONG sVscrollInc;

   switch (SHORT2FROMMP (mp2))
   {
      case SB_LINEUP:
	 sVscrollInc = -1 ;
	 break ;

      case SB_LINEDOWN:
	 sVscrollInc = 1 ;
	 break ;

      case SB_PAGEUP:
	 sVscrollInc = min (-1, -cyClient / cyChar) ;
	 break ;

      case SB_PAGEDOWN:
	 sVscrollInc = max (1, cyClient / cyChar) ;
	 break ;

      case SB_SLIDERTRACK:
	 sVscrollInc = SHORT1FROMMP (mp2) - sVscrollPos;
	 break ;

      default:
	 sVscrollInc = 0;
	 break ;
   }

   sVscrollInc = max (-sVscrollPos,
		 min (sVscrollInc, sVscrollMax - sVscrollPos)) ;

   if (sVscrollInc != 0)
   {
      sVscrollPos += sVscrollInc ;
      WinScrollWindow ((HWND)hwnd, 0, (cyChar * sVscrollInc),
		     (PRECTL)NULL, (PRECTL)NULL, (HRGN)NULL,
		     (PRECTL)NULL, SW_INVALIDATERGN);

      WinSendMsg (hwndVscroll, SBM_SETPOS,
		  MPFROMSHORT (sVscrollPos), MPVOID) ;
      WinUpdateWindow (hwnd) ;
   }
   return (MRFROMLONG(0));
}


/****************************************************************\
 *  Update messages
 *--------------------------------------------------------------
 *
 *  Name:   MainCharHScroll(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
 *
 *  Purpose:
 *
 *  Usage:
 *
 *  Method:
 *
 *  Returns:
\****************************************************************/

MRESULT MainCharHScroll(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{

   /* referenced to prevent compiler error */
   hwnd = hwnd;
   return (WinSendMsg(hwndHscroll, msg, mp1, mp2));
}


/****************************************************************\
 *  Update messages
 *--------------------------------------------------------------
 *
 *  Name:   MainCharVScroll(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
 *
 *  Purpose:
 *
 *  Usage:
 *
 *  Method:
 *
 *  Returns:
\****************************************************************/

MRESULT MainCharVScroll(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{

   return (WinSendMsg(hwndVscroll, msg, mp1, mp2));
}


/****************************************************************\
 *  Update messages
 *--------------------------------------------------------------
 *
 *  Name:   MainUpdateMsg(hwnd)
 *
 *  Purpose: Update portion of screen with new messages.
 *
 *  Usage:  Called when a new message is read from the queue.
 *
 *  Method:
 *
 *  Returns:
\****************************************************************/

VOID MainUpdateMsg(HWND hwnd,
		   CHAR SvrQMsgs[MAX_MESSAGES][MESSAGE_LEN+38],
		   unsigned int index,
		   SHORT sTotalMsgs)
{
   RECTL rclInvalid;

   /* if it will fit in the window */
   if (sTotalMsgs <= cyClient/cyChar + sVscrollPos + 1)
   {
      rclInvalid.yBottom = (LONG)max(0, cyClient - sTotalMsgs * cyChar);
      rclInvalid.yTop = (LONG)(cyClient - (sTotalMsgs - sVscrollPos - 1) * cyChar);
      rclInvalid.xLeft = 0L;
      rclInvalid.xRight = (LONG)cxClient;
      WinInvalidateRect(hwnd, &rclInvalid, FALSE);
      MainPaint(hwnd, SvrQMsgs, index, sTotalMsgs);
   }

   /* if lines exceed window */
   if (sTotalMsgs > cyClient/cyChar)
   {
      WinEnableWindow (hwndVscroll, TRUE) ;
      sVscrollMax = sTotalMsgs - cyClient / cyChar;
      sVscrollPos = min (sVscrollPos, sVscrollMax) ;

      WinSendMsg (hwndVscroll, SBM_SETSCROLLBAR,
			       MPFROM2SHORT (sVscrollPos, 0),
			       MPFROM2SHORT (0, sVscrollMax)) ;

      /* if new msg is just off screen */
      if (sTotalMsgs == cyClient/cyChar + sVscrollPos + 1)
      {
	 MainVertScroll(hwnd, MPFROM2SHORT(0, SB_LINEDOWN));
      }

      else
      {
	 DosBeep(1000, 100);
      }
   }
}



VOID MainPurgeWindow()
{

   sVscrollMax = 0;
   sVscrollPos = 0;
   WinSendMsg (hwndVscroll, SBM_SETSCROLLBAR,
			    MPFROM2SHORT (sVscrollPos, 0),
			    MPFROM2SHORT (0, sVscrollMax)) ;

   WinEnableWindow (hwndVscroll, FALSE) ;
   WinInvalidateRect(hwndMain, NULL, FALSE);
}
/*==============================================================*\
 *  Svrqthrd.c - queue processing routine: initialization and
 *		 processing thread.
 *	Copyright 1992, IBM Corp.
 *
 *--------------------------------------------------------------
 *
 *  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *  sample code created by IBM Corporation. This sample code is not
 *  part of any standard or IBM product and is provided to you solely
 *  for	 the purpose of assisting you in the development of your
 *  applications.  The code is provided "AS IS", without
 *  warranty of any kind.  IBM shall not be liable for any damages
 *  arising out of your use of the sample code, even if they have been
 *  advised of the possibility of   such damages.
 *
\*==============================================================*/


#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#define INCL_DOSQUEUES
#define INCL_DOSMEMMGR
#define INCL_WINMESSAGEMGR
#define INCL_DOSERRORS

#include <os2.h>

#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>

#include "svrqglbl.h"
#include "svrqmain.h"
#include "queue.h"
#include "svrqxtrn.h"


#define STACKSIZE    8192

static HQUEUE hqQ;

HQUEUE InitQ(PID  pidParent,   /* proccess that will send WM_CLOSE command */
	     HWND hwndParent)  /* window to post to */
{
   ULONG	      ulErrorMsg;
   BOOL		      fError=FALSE;
   static THREADPARAM tpThrdParm;

   if (!DosCreateQueue(&hqQ,
		       QUE_PRIORITY,
		       "\\queues\\" Q_NAME))
   {
      tpThrdParm.pidParent = pidParent;
      tpThrdParm.hwndParent = hwndParent;

      if( _beginthread(ReadQMessage,
			   NULL,
			   STACKSIZE,
			   (VOID *)&tpThrdParm) == -1 )
      {
	 ulErrorMsg = IDMSG_CREATE_THREAD_FAILED;
	 fError = TRUE;
      }
   }

   else
   {
      ulErrorMsg = IDMSG_CREATE_Q_FAILED;
      fError = TRUE;
   }

   if (fError)
   {
      MessageBox(HWND_DESKTOP,
		 ulErrorMsg,
		 MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL,
		 TRUE);
      return(0);
   }

   else
   {
      return (hqQ);
   }
}


#define	 MAXBUFF  10

VOID ReadQMessage(VOID *tpThrdParm)
{
   PVOID	pvdQMsg;
   BYTE		bPriority;
   REQUESTDATA	reqQdata;
   ULONG	cbRead;
   BOOL		fClose=FALSE, fError=FALSE;
   int		index=0;
   QDATA	qdataBuffer[MAXBUFF];
   PID		pidParent;
   HWND		hwndParent;

   pidParent = ((THREADPARAM *)tpThrdParm)->pidParent;
   hwndParent = ((THREADPARAM *)tpThrdParm)->hwndParent;

   while (!fClose && !fError)
   {
      if (!(DosReadQueue(hqQ,		  /* queue handle				*/
			 &reqQdata,	  /* queue result, incl. process id and request */
			 &cbRead,	  /* count of bytes in element			*/
		(VOID **)&pvdQMsg,	  /* address of element				*/
			 0,		  /* element number to read			*/
			 DCWW_WAIT,	  /* wait for element				*/
			 &bPriority,	  /* received element priority			*/
			 (HEV) NULL))) {  /* semaphore handle (not used)		*/

	 /* if parent process sends message to die... */

	 if (pidParent == reqQdata.pid && WM_CLOSE == reqQdata.ulData)
	 {
	    fClose = TRUE;
	 }

	 /* copy the string to some internal buffer, and post a message to the window
	  * to copy the new text to its own buffer and do what it will.
	  */
	 else
	 {
	    /* format the message */
	    switch(reqQdata.ulData)
	    {
	       case Q_MSG_DATE:
		  sprintf(qdataBuffer[index].pszMsg,
			  "Date -- Day: %d Month: %d Year: %d",
			  ((Q_DATE *)pvdQMsg)->usDay,
			  ((Q_DATE *)pvdQMsg)->usMonth,
			  ((Q_DATE *)pvdQMsg)->usYear);
		  break;

	       case Q_MSG_TEXT:
	       default:
		  strncpy(qdataBuffer[index].pszMsg, (CHAR *)pvdQMsg, cbRead);
		  break;
	    }

	    qdataBuffer[index].pidProcess = reqQdata.pid;
	    qdataBuffer[index].usPriority = bPriority;
	    WinPostMsg(hwndParent, WM_NEWQMSG, MPFROMP(&(qdataBuffer[index])), MPVOID);
	    index = (index < MAXBUFF-1) ? index+1 : 0;

	 /* after posting the message, unmark the memory and start the loop again
	  *
	  * CAVEAT: We are getting the offset by zeroing out the lower 16 bits
	  * of the block offset.  This can ONLY be done if the memory allocated
	  * is less than 64K.  Otherwise, the client must somehow (in the queue
	  * message would probably be a good idea) pass the offset to the server.
	  *
	  */
	    DosSubFreeMem((VOID *)((ULONG)pvdQMsg & ~(ULONG)0xFFFF), pvdQMsg, cbRead);
/*	      DosSubFreeMem(MAKEP(SELECTOROF(pvdQMsg), 0), pvdQMsg, cbRead);*/
	 }
      }

      else
      {
	 WinPostMsg(hwndMain, WM_MSG, MPFROMSHORT(IDMSG_READ_Q_ERROR), MPVOID);
	 fError = TRUE;
      }
   }

   DosCloseQueue(hqQ);
   fThrdsDead=TRUE;
}
#ifndef lint
static char *sccsid = "@(#)textline.c 1.3 1/22/92 16:11:00 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define textLine_Class_Source
#include "textline.ih"
#include "helper.h"
#include "tpword.h"

/* ************************************************************ */
SOM_Scope void SOMLINK tlInit(textLine * somSelf,
			       int newSize)
{
    textLineData *somThis = textLineGetData(somSelf);
    textLineMethodDebug("textLine", "tlInit");
    _totalChars = 0;
    _maxSize = newSize;
}

/* ************************************************************ */
SOM_Scope int SOMLINK tlCharsInLine(textLine * somSelf)
{
    textLineData *somThis = textLineGetData(somSelf);
    textLineMethodDebug("textLine", "tlCharsInLine");
    return _totalChars;

}

/* ************************************************************ */
SOM_Scope int SOMLINK tlCharsLeft(textLine * somSelf)
{
    textLineData *somThis = textLineGetData(somSelf);
    textLineMethodDebug("textLine", "tlCharsLeft");
    return _maxSize - _totalChars;
}

/* ************************************************************ */
SOM_Scope baseType *SOMLINK llAddTail(textLine * somSelf,
				       baseType * newElement)
{
    textLineData *somThis = textLineGetData(somSelf);
    TPWord *myWord = (TPWord *) newElement;
    int newTotal;
    textLineMethodDebug("textLine", "llAddTail");

    newTotal = _totalChars + _getLength(newElement);
    if (newTotal <= _maxSize) {
	_totalChars = newTotal;
	return (parent_llAddTail(somSelf, newElement));
    }
    else
	return newElement;
}

/* ************************************************************ */
SOM_Scope baseType *SOMLINK llAddHead(textLine * somSelf,
				       baseType * newElement)
{
    textLineData *somThis = textLineGetData(somSelf);
    TPWord *myWord = (TPWord *) newElement;
    int newTotal;
    textLineMethodDebug("textLine", "llAddHead");

    newTotal = _totalChars + _getLength(newElement);
    if (newTotal <= _maxSize) {
	_totalChars = newTotal;
	return (parent_llAddHead(somSelf, newElement));
    }
    else
	return newElement;
}

/* ************************************************************ */
SOM_Scope baseType *SOMLINK llReplace(textLine * somSelf,
				       baseType * newElement)
{
    textLineData *somThis = textLineGetData(somSelf);
    textLineMethodDebug("textLine", "llReplace");
    shouldHaveOverridden(somSelf, "llReplace");
    newElement;
    return (baseType *) NULL;
}

/* ************************************************************ */
SOM_Scope void SOMLINK somInit(textLine * somSelf)
{
    textLineData *somThis = textLineGetData(somSelf);
    textLineMethodDebug("textLine", "somInit");
    parent_somInit(somSelf);
    _maxSize = 0;
    _totalChars = 0;
}

/* ************************************************************ */
SOM_Scope void SOMLINK somUninit(textLine * somSelf)
{
    textLineData *somThis = textLineGetData(somSelf);
    textLineMethodDebug("textLine", "somUninit");

    parent_somUninit(somSelf);
}

/* ************************************************************ */
SOM_Scope void SOMLINK somDumpSelfInt(textLine * somSelf,
				       int level)
{
    textLineData *somThis = textLineGetData(somSelf);
    textLineMethodDebug("textLine", "somDumpSelfInt");

    parent_somDumpSelfInt(somSelf, level);
}
/**************************************************************************
 *  File name  :  thrd.c
 *
 *  Description:  This module contains the code for a background processing
 *		  thread as well as the code for any routines used in that
 *		  thread.
 *
 *		  This thread uses an object window to facilitate
 *		  communication with the main thread.  The main thread can
 *		  communicate with the background thread through messages.
 *		  You define your own window messages in main.h, post or send
 *		  them to the background thread through the routines provided
 *		  in this file, and then process the messages in the
 *		  ObjectWndProc() routine.  The object window then sends
 *		  other messages back to the main window to notify the main
 *		  window as to the status of the task or with the final
 *		  result.
 *
 *		  An object window is used as the main window of the thread
 *		  for several reasons.	The window is hidden, so it is
 *		  never displayed on the screen.  Since it is hidden, the
 *		  window does not have to process most of the window
 *		  messages that are processed by visible windows, e.g.
 *		  WM_PAINT, WM_SIZE, WM_SETFOCUS, etc.	This window will
 *		  never receive the focus so it need not process input
 *		  messages.  You can, however, send all mouse and keyboard
 *		  messages to this window and have it process all input if
 *		  you wish.  Since the window does not belong to any focus
 *		  or activation chains, you can block this thread on a
 *		  semaphore without having the system lock up or use the
 *		  window manager semaphore routines such as
 *		  WinMsgSemWait().
 *
 *		  The BackgroundThread() routine is designed to create only
 *		  one thread.  Should you try to create another one, the
 *		  call will fail.  The thread uses several variables
 *		  which are defined globally within this module.  In order
 *		  to enable this routine to create multiple threads, you
 *		  will need to make these variables local.  You will also
 *		  need to differentiate between the different object
 *		  windows created so that you can specify which thread will
 *		  receive a posted message.
 *
 *		  In order to enable the use of the second thread, define
 *		  the BACKGROUND_THREAD constant found in main.h.
 *
 *		  This source file contains the following functions:
 *
 *		  BackgroundThread()
 *		  CreateBackgroundThread()
 *		  DestroyBackgroundThread()
 *		  PostBkThreadMsg(msg, mp1, mp2)
 *		  SendBkThreadMsg(msg, mp1, mp2)
 *		  ObjectWndProc(hwnd, msg, mp1, mp2)
 *
 *  Concepts   :  background thread
 *
 *  API's      :  WinInitialize
 *		  WinPostMsg
 *		  DosExit
 *		  WinCreateMsgQueue
 *		  WinTerminate
 *		  WinLoadString
 *		  WinRegisterClass
 *		  WinCreateWindow
 *		  DosPostEventSem
 *		  WinGetMsg
 *		  WinDispatchMsg
 *		  WinIsWindow
 *		  WinDestroyWindow
 *		  WinDestroyMsgQueue
 *		  DosCreateEventSem
 *		  DosCreateThread
 *		  WinWaitEventSem
 *		  DosWaitThread
 *		  WinDefWindowProc
 *
 *  Required
 *    Files    :  OS2.H, MAIN.H, XTRN.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/
/*
 *  Include files, macros, defined constants, and externs
 */

#define	 INCL_DOSPROCESS
#define	 INCL_DOSSEMAPHORES
#define  INCL_WINMESSAGEMGR

#include <os2.h>
#include "main.h"
#include "xtrn.h"

#define THREADSTACKSIZE	    8192L
#define SEM_TIMEOUT	   10000L

/*
 *  Global variables
 */
static HAB habBkThread;
static HMQ hmqBkThread;
static TID tidBkThread;
static HWND hwndObject;
static CHAR szObjectClass[MAXNAMEL];
static BOOL fThreadCreated = FALSE;
static HEV hevThreadInit;   /* semaphore for thread initialization */

VOID BackgroundThread (ULONG);

MRESULT EXPENTRY ObjectWndProc(HWND, ULONG, MPARAM, MPARAM);

/**************************************************************************
 *
 *  Name       : BackgroundThread(ulThreadParam)
 *
 *  Description: Routine is a background thread used for tasks to be
 *		 completed in the background.
 *
 *  Concepts:	 Routine is called at initialization time to create
 *		 a background processing thread.
 *
 *		 The routine initializes itself as a PM thread and creates
 *		 a message queue.  It then creates an object window
 *		 through which it will receive and send messages.
 *		 It then polls through a message loop, processing any
 *		 messages it receives in the object window's window
 *		 procedure.  When the loop ends, it terminates.
 *
 *  API's      :  WinInitialize
 *		  WinPostMsg
 *		  DosExit
 *		  WinCreateMsgQueue
 *		  WinLoadString
 *		  WinRegisterClass
 *		  WinCreateWindow
 *		  DosPostEventSem
 *		  WinGetMsg
 *		  WinDispatchMsg
 *		  WinIsWindow
 *		  WinDestroyWindow
 *		  WinDestroyMsgQueue
 *
 *  Parameters :  ulThreadParam = thread parameter
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID BackgroundThread(ULONG ulThreadParam)
{
   QMSG qmsg;

   /* create message queue for thread */
   habBkThread = WinInitialize(0);
   if(habBkThread == NULLHANDLE)
   {
      WinPostMsg(hwndMain, TM_THREADINITFAILED, (MPARAM)NULL, (MPARAM)NULL);
      DosExit(EXIT_THREAD, 0L);
   }

   hmqBkThread = WinCreateMsgQueue(habBkThread, 0);
   if(hmqBkThread == NULLHANDLE)
   {
      WinPostMsg(hwndMain, TM_THREADINITFAILED, (MPARAM)NULL, (MPARAM)NULL);

      WinTerminate(habBkThread);
      DosExit(EXIT_THREAD, 0L);
   }

   /* load the string for the object window class and register the class */
   if(WinLoadString(habBkThread,
		    (HMODULE)NULLHANDLE,
		    IDS_OBJECTCLASS,
		    MAXNAMEL,
		    (PSZ)szObjectClass)
      &&
	      /* register the main client window class */
      WinRegisterClass(habBkThread,
		       (PSZ)szObjectClass,
		       (PFNWP)ObjectWndProc,
		       0L,
		       0L)
      &&
	    /* create the object window */
      (NULLHANDLE != (hwndObject = WinCreateWindow(HWND_OBJECT,
				    (PSZ)szObjectClass,
				    (PSZ)NULL,
				    0L,
				    0L,
				    0L,
				    0L,
				    0L,
				    (HWND)NULLHANDLE,
				    HWND_TOP,
				    OBJECTID,
				    (PVOID)NULL,
				    (PVOID)NULL))))
   {
      /* set thread created flag so another thread of this type
       * cannot be created.
       */
      fThreadCreated = TRUE;

      /* clear initialization semaphore */
      DosPostEventSem(hevThreadInit);

      /* message loop */
      while(WinGetMsg(habBkThread, &qmsg, (HWND)NULLHANDLE, 0L, 0L))
	 WinDispatchMsg(habBkThread, &qmsg);
   }
   else
   {
      WinPostMsg(hwndMain, TM_THREADINITFAILED, NULL, NULL);
   }

   /* destroy object window, clean up message queue and terminate */
   if(WinIsWindow(habBkThread, hwndObject))
      WinDestroyWindow(hwndObject);

   WinDestroyMsgQueue(hmqBkThread);
   WinTerminate(habBkThread);

   /* If termination is due to an error initializing the thread, then
       clear the initialization semaphore so that the main thread
       can continue. */
   if(!fThreadCreated)
      DosPostEventSem(hevThreadInit);

   DosExit(EXIT_THREAD, 0L);

   /* the thread parameter is not currently used */
   ulThreadParam = ulThreadParam;
}   /* End of BackgroundThread */


/**************************************************************************
 *
 *  Name       : CreateBackgroundThread()
 *
 *  Description: Creates the background thread
 *
 *  Concepts:	 Routine is called at initialization time to create
 *		 a background processing thread.
 *
 *		 The routine calls DosCreateThread with the Background
 *		 thread routine.
 *
 *  API's      :  DosCreateEventSem
 *		  DosCreateThread
 *		  WinWaitEventSem
 *
 *  Parameters :  [none]
 *
 *  Return     :  TRUE = thread is created successfully
 *		  FALSE = not, or if the thread was already created
 *
 *************************************************************************/
BOOL CreateBackgroundThread(VOID)
{
   ULONG sRet;

   if(!fThreadCreated)
   {
      DosCreateEventSem((PSZ)NULL, &hevThreadInit, 0L, FALSE);
      sRet = (ULONG)DosCreateThread(&tidBkThread,
				    (PFNTHREAD)BackgroundThread,
				    0L,
				    0L,
				    THREADSTACKSIZE);
   }
   else
      return FALSE;

   /* wait until the thread has finished initialization */
   if(WinWaitEventSem(hevThreadInit, SEM_TIMEOUT))
      return FALSE;

   return((BOOL)(sRet == 0L));
}   /* End of CreateBackgroundThread   */

/**************************************************************************
 *
 *  Name       : DestroyBackgroundThread()
 *
 *  Description: Destroys the background thread
 *
 *  Concepts:	 Routine is called at exit time to destroy the
 *		 background processing thread.
 *
 *		 The routine posts a WM_CLOSE message to the object window
 *		 to end its message loop.  It then waits to make sure that
 *		 the thread has been terminated before it returns.
 *
 *  API's      :  DosWaitThread
 *
 *  Parameters :  [none]
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID DestroyBackgroundThread(VOID)
{
   PostBkThreadMsg(WM_CLOSE, (MPARAM)NULL, (MPARAM)NULL);
   DosWaitThread(&tidBkThread, 0L);
}   /* End of DestroyBackgroundThread	*/


/**************************************************************************
 *
 *  Name       : PostBkThreadMsg(msg, mp1, mp2)
 *
 *  Description: Routine posts a message to the object window of the
 *		 background thread.
 *
 *  Concepts:	 Routine is called whenever a message is to be posted to
 *		 the background processing thread.
 *
 *		 The routine posts the message to the object window of the
 *		 thread.
 *
 *  API's      :  WinPostMsg
 *
 *  Parameters :  msg = the message i.d.
 *		  mp1 = first message parameter
 *		  mp2 = second message parameter
 *
 *  Return     :  the return value from WinPostMsg().
 *
 *************************************************************************/
BOOL PostBkThreadMsg(ULONG msg, MPARAM mp1, MPARAM mp2)
{
   return(WinPostMsg(hwndObject, msg, mp1, mp2));
}   /* End of PostBkThreadMsg	*/


/**************************************************************************
 *
 *  Name       : SendBkThreadMsg(msg, mp1, mp2)
 *
 *  Description: Routine sends a message to the object window of the
 *		 background thread.
 *
 *  Concepts:	 Routine is called whenever a message is to be sent to
 *		 the background processing thread.
 *
 *		 The routine sends the message to the object window of the
 *		 thread.
 *
 *  API's      :  WinSendMsg
 *
 *  Parameters :  msg = the message i.d.
 *		  mp1 = first message parameter
 *		  mp2 = second message parameter
 *
 *  Return     :  the return value from WinSendMsg().
 *
 *************************************************************************/
MRESULT SendBkThreadMsg(ULONG msg, MPARAM mp1, MPARAM mp2)
{
   return(WinSendMsg(hwndObject, msg, mp1, mp2));
}   /* End of SendBkThreadMsg	*/



/**************************************************************************
 *
 *  Name       : ObjectWndProc(hwnd, msg, mp1, mp2)
 *
 *  Description: Processes all messages sent to the Object window
 *
 *  Concepts:	 Called for each message sent to the Object window.
 *
 *		 The Object window processes the messages that tell
 *		 the background thread what action to take.  Since
 *		 the object window is not visible, it will not
 *		 process any of the standard window messages.
 *
 *  API's      :  WinDefWindowProc
 *
 *  Parameters :  hwnd= window handle
 *		  msg = the message i.d.
 *		  mp1 = first message parameter
 *		  mp2 = second message parameter
 *
 *  Return     :  dependent on message sent
 *
 *************************************************************************/
MRESULT EXPENTRY ObjectWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   switch(msg)
   {
       /*
	*  Include any user-defined messages to determine which
	*  action the background thread should take.
	*/

   default:
      return (WinDefWindowProc(hwnd, msg, mp1, mp2));
      break;
   }
   return (MRESULT)NULL;
}   /* End of ObjectWndProc   */
/***************************  End of thrd.c  ****************************/
#ifndef lint
static char *sccsid = "@(#)tpword.c 1.3 1/22/92 16:11:32 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define TPWord_Class_Source
#include <string.h>
#include "tpword.ih"

/* ************************************************************ */
SOM_Scope int SOMLINK tpwType(TPWord * somSelf)
{
/* TPWordData *somThis = TPWordGetData(somSelf); */
     TPWordMethodDebug("TPWord", "tpwType");

    if (_match(somSelf, "[[EOF]]"))
	return TP_EOF;
    else if (_match(somSelf, "[["))
	return TP_TOKEN;
    else if (_match(somSelf, "\n\n"))
	return TP_PARAGRAPH_BREAK;
    else if (_match(somSelf, "\n"))
	return TP_LINE_BREAK;
    else if (_match(somSelf, " "))
	return TP_BLANK_SPACE;
    else
	return TP_WORD;
}

TPWord *readToken(fileMgr * myFile)
{
    char buffer[100];
    int nxtChr;
    int n = 0;
    int brackets;
    TPWord *newWord;
    nxtChr = _fmPeekChar(myFile, 0);

/* Check for string of blanks.
   --------------------------- */
    if (nxtChr == ' ') {
	while (_fmPeekChar(myFile, 0) == ' ') {
	    buffer[n++] = (char) _fmGetChar(myFile);
	}
    }
/* Check for string of newlines.
   ----------------------------- */
    else if (nxtChr == '\n') {
	while (_fmPeekChar(myFile, 0) == '\n') {
	    buffer[n++] = (char) _fmGetChar(myFile);
	}
    }
/* Check for EOF.
   -------------- */
    else if (nxtChr == EOF) {
	strcpy(buffer, "[[EOF]]");
	n = strlen(buffer);
    }
/* Check for special token.
   ------------------------ */
    else if ((nxtChr == '[') && (_fmPeekChar(myFile, 1) == '[')) {
	brackets = 0;
	while (brackets < 2) {
	    nxtChr = _fmGetChar(myFile);
	    buffer[n++] = (char) nxtChr;
	    if (nxtChr == ']')
		brackets++;
	    else
		brackets = 0;
	}
    }
/* Otherwise, handle as word.
   -------------------------- */
    else {
	for (;;) {
	    nxtChr = _fmPeekChar(myFile, 0);
	    if (nxtChr == ' ')
		break;
	    if (nxtChr == '\n')
		break;
	    if (nxtChr == EOF)
		break;
	    if (nxtChr == '[')
		break;
	    buffer[n++] = (char) _fmGetChar(myFile);
	}
    }
/* Return converted buffer.
   ------------------------ */
    buffer[n] = '\0';
    newWord = TPWordNew();
    _wordInit1(newWord, buffer);
    return newWord;
}
#ifndef lint
static char *sccsid = "@(#)txtep.c 1.3 1/22/92 16:11:45 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define txtEnvProcessor_Class_Source
#include "txtep.ih"
#include "tpword.h"
#include "textline.h"
#include "page.h"
#include "colblk.h"

#define PARAGRAPH_INDENTATION 0
#define LINE_INDENTATION 0

/* ************************************************************ */
SOM_Scope void SOMLINK tpProcessWord(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    textLine *thisLine = _tpGetLine(somSelf);
    page *thisPage;
    txtEnvProcessorMethodDebug("txtEnvProcessor", "tpProcessWord");

    thisPage = _epGetPage(somSelf);
    _thisCB = _pgGetColumnBlock(thisPage);
    if (!_cbLinesLeft(_thisCB))
	_tpProcessFullPage(somSelf);
    if (_getLength(_thisWord) > _tlCharsLeft(thisLine)) {
	_tpProcessFullLine(somSelf);
	_tpProcessNewLine(somSelf);
	thisLine = _tpGetLine(somSelf);
    }
    _llAddTail(thisLine, (baseType *) _thisWord);
}

/* ************************************************************ */
SOM_Scope void SOMLINK tpProcessBlanks(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    textLine *thisLine = _tpGetLine(somSelf);
    txtEnvProcessorMethodDebug("txtEnvProcessor", "tpProcessBlanks");

    if (!_tlCharsLeft(thisLine)) {
	_somFree(_thisWord);
	return;
    }
    _tpProcessWord(somSelf);

}

/* ************************************************************ */
SOM_Scope void SOMLINK tpProcessLineBreak(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    textLine *thisLine = _tpGetLine(somSelf);
    txtEnvProcessorMethodDebug("txtEnvProcessor", "tpProcessLineBreak");

    _somFree(_thisWord);
    if (!_tlCharsInLine(thisLine))
	return;
    if (!_tlCharsLeft(thisLine))
	return;
    _thisWord = TPWordNew();
    _wordInit1(_thisWord, " ");
    _tpProcessWord(somSelf);

}

/* ************************************************************ */
SOM_Scope void SOMLINK tpProcessFullLine(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    textLine *thisLine = _tpGetLine(somSelf);
    page *thisPage;
    txtEnvProcessorMethodDebug("txtEnvProcessor", "tpProcessFullLine");

    thisPage = _epGetPage(somSelf);
    _thisCB = _pgGetColumnBlock(thisPage);
    _llAddTail(_thisCB, (baseType *) thisLine);

    thisLine = textLineNew();
    _tlInit(thisLine, _cbGetColumnWidth(_thisCB));
    _tpSetLine(somSelf, thisLine);
}

/* ************************************************************ */
SOM_Scope void SOMLINK tpProcessFullPage(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    page *thisPage;
    txtEnvProcessorMethodDebug("txtEnvProcessor", "tpProcessFullPage");

    thisPage = _epGetPage(somSelf);
    _pgPrint(thisPage, stdout);
    _thisCB = _pgGetColumnBlock(thisPage);
}

/* ************************************************************ */
SOM_Scope void SOMLINK tpProcessNewLine(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    int charsToIndent;
    TPWord *blanks;
    textLine *thisLine;
    txtEnvProcessorMethodDebug("txtEnvProcessor", "tpProcessNewLine");

    charsToIndent = _epGetLineIndentation(somSelf);
    if (charsToIndent) {
	thisLine = _tpGetLine(somSelf);
	blanks = TPWordNew();
	_wordInit2(blanks, ' ', charsToIndent);
	_llAddTail(thisLine, (baseType *) blanks);
    }
}

/* ************************************************************ */
SOM_Scope void SOMLINK tpProcessNewParagraph(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    int charsToIndent;
    TPWord *blanks;
    textLine *thisLine;
    txtEnvProcessorMethodDebug("txtEnvProcessor", "tpProcessNewParagraph");

    charsToIndent = _epGetParagraphIndentation(somSelf);
    _tpProcessFullLine(somSelf);
    _tpProcessNewLine(somSelf);
    thisLine = _tpGetLine(somSelf);

    if (charsToIndent) {
	blanks = TPWordNew();
	_wordInit2(blanks, ' ', charsToIndent);
	_llAddTail(thisLine, (baseType *) blanks);
    }
    _somFree(_thisWord);
}

/* ************************************************************ */
SOM_Scope textLine *SOMLINK tpGetLine(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    txtEnvProcessorMethodDebug("txtEnvProcessor", "tpGetLine");

    if (!_thisLine) {
	_thisLine = textLineNew();
	_tlInit(_thisLine, _cbGetColumnWidth(_thisCB));
    }
    return _thisLine;
}

/* ************************************************************ */
SOM_Scope void SOMLINK tpSetLine(txtEnvProcessor * somSelf,
				  textLine * newLine)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    txtEnvProcessorMethodDebug("txtEnvProcessor", "tpSetLine");
    _thisLine = newLine;
}

/* ************************************************************ */
SOM_Scope void SOMLINK epProcessEnvironment(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);

/* Declare local variables.
   ------------------------ */
    page *thisPage;
    fileMgr *thisFile;
    int n = 0;
/* char *myClass = getClassName(); */
    thisPage = _epGetPage(somSelf);
    thisFile = _epGetFileMgr(somSelf);
    txtEnvProcessorMethodDebug("txtEnvProcessor", "epProcessEnvironment");

/* Prepare for looping.
   -------------------- */
    _epInitializeEnvironment(somSelf);

/* Loop until end of file.
   ----------------------- */
    while (_thisWord = readToken(thisFile)) {
/*    _print(_thisWord, stdout); */
	if (_tpwType(_thisWord) == TP_EOF) {
	    _somFree(_thisWord);
	    break;
	}
	if (_match(_thisWord, "[[end_environment]]")) {
	    _epShutdownEnvironment(somSelf);
	    break;
	}
	switch (_tpwType(_thisWord)) {
	    case TP_LINE_BREAK:
		_tpProcessLineBreak(somSelf);
		continue;
	    case TP_WORD:
		_tpProcessWord(somSelf);
		continue;
	    case TP_PARAGRAPH_BREAK:
		_tpProcessNewParagraph(somSelf);
		continue;
	    case TP_BLANK_SPACE:
		_tpProcessBlanks(somSelf);
		continue;
	    case TP_TOKEN:
		_epStartUpNewEnvironment(somSelf, _thisWord);
		_somFree(_thisWord);
		continue;
	}
    }
    _tpProcessFullLine(somSelf);
}

/* ************************************************************ */
SOM_Scope void SOMLINK epShutdownEnvironment(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    envProcessor *lastEnv;
    txtEnvProcessorMethodDebug("txtEnvProcessor", "epShutdownEnvironment");

    lastEnv = _epGetPreviousEnv(somSelf);
    if (lastEnv)
	_epInitializeEnvironment(lastEnv);
}

/* ************************************************************ */
SOM_Scope void SOMLINK epInitializeEnvironment(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    int charsToIndent;
    TPWord *blanks;
    TPWord *lineFeed;
    textLine *thisLine;
    fileMgr *thisFile;

    txtEnvProcessorMethodDebug("txtEnvProcessor",
			       "epInitializeEnvironment");

    thisFile = _epGetFileMgr(somSelf);
    lineFeed = readToken(thisFile);
    _somFree(lineFeed);
    charsToIndent = _epGetParagraphIndentation(somSelf);
    _tpProcessNewLine(somSelf);

    thisLine = _tpGetLine(somSelf);
    if (charsToIndent) {
	blanks = TPWordNew();
	_wordInit2(blanks, ' ', charsToIndent);
	_llAddTail(thisLine, (baseType *) blanks);
    }
}

/* ************************************************************ */
SOM_Scope void SOMLINK epPrepareForNewEnvironment(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    txtEnvProcessorMethodDebug("txtEnvProcessor",
			       "epPrepareForNewEnvironment");
    _tpProcessFullLine(somSelf);
}

/* ************************************************************ */
SOM_Scope int SOMLINK epGetParagraphIndentation(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    envProcessor *previousEnv;
    txtEnvProcessorMethodDebug("txtEnvProcessor",
			       "epGetParagraphIndentation");

    previousEnv = _epGetPreviousEnv(somSelf);
    if (previousEnv)
	return _epGetParagraphIndentation(previousEnv) +
	    PARAGRAPH_INDENTATION;
    else
	return 0;
}

/* ************************************************************ */
SOM_Scope int SOMLINK epGetLineIndentation(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    envProcessor *previousEnv;
    txtEnvProcessorMethodDebug("txtEnvProcessor", "epGetLineIndentation");

    previousEnv = _epGetPreviousEnv(somSelf);
    if (previousEnv)
	return _epGetLineIndentation(previousEnv) +
	    LINE_INDENTATION;
    else
	return 0;
}

/* ************************************************************ */
SOM_Scope void SOMLINK somUninit(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    txtEnvProcessorMethodDebug("txtEnvProcessor", "somUninit");
    if (_thisWord)
	_somFree(_thisWord);
    if (_thisLine)
	_somFree(_thisLine);
    parent_somUninit(somSelf);
}

/* ************************************************************ */
SOM_Scope void SOMLINK somInit(txtEnvProcessor * somSelf)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    txtEnvProcessorMethodDebug("txtEnvProcessor", "somInit");
    parent_somInit(somSelf);

    _thisWord = 0;
    _thisLine = 0;
    _thisCB = 0;
}

/* ************************************************************ */
SOM_Scope void SOMLINK epInit1(txtEnvProcessor * somSelf,
				envProcessor * lastEnv)
{
    txtEnvProcessorData *somThis = txtEnvProcessorGetData(somSelf);
    page *thisPage;

    txtEnvProcessorMethodDebug("txtEnvProcessor", "epInit1");
    parent_epInit1(somSelf, lastEnv);

    thisPage = _epGetPage(somSelf);
    _thisCB = _pgGetColumnBlock(thisPage);
}
/*static char *SCCSID = "@(#)udtime.c   6.7 92/02/18";*/
/*=========================================================================\
 *									   *
 *	 FILE: udtime.c							   *
 *									   *
 *	 DESCRIPTION:  miscellaneous time and date functions		   *
 *									   *
 *									   *
 *									   *
 *	Copyright 1992	   IBM Corp.					   *
 *									   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have been *
 *	advised of the possibility of	such damages.			   *
 *									   *
 *-------------------------------------------------------------------------*
 *
 *--------------------------------------------------------------
 *
 *  This source file contains the following functions:
 *	TimeDlgProc
 *	GetControlCoordinates
 *	PanelDlgFilter
 *	ChangeDateTime
 *	ControlMinmax
 *	PanelPaint
 *	PaintDateTime
 *	GetDate
 *	GetTime
 *	PanelVScrolls
 *	TimeInit
 *	MouseTrack
 *	GetCountryDependent
 *	BringUpArrows
 *	FixDate
 *	SetDate
 *	SetTime
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/
#define INCL_WINDIALOGS
#define INCL_WINBUTTONS
#define INCL_WINSYS
#define INCL_WINMESSAGEMGR
#define INCL_WINSHELLDATA
#define INCL_WINFRAMEMGR
#define INCL_WINPOINTERS
#define INCL_WINSWITCHLIST
#define INCL_WIN
#define INCL_DOSNLS
#define INCL_GPITRANSFORMS
#define INCL_DOSSEMAPHORES
#define INCL_DOSDATETIME

#include <os2.h>
#include <string.h>
#include <stdlib.h>
#include "clock.h"
#include "res.h"
#include "clkdata.h"




/*--------------------------------------------------------------*\
 *  Global variables  and definitions for this file
\*--------------------------------------------------------------*/


SHORT DaysPerMonth[13] =
       {0,31,28,31,30,31,30,31,31,30,31,30,31};

/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/

MRESULT EXPENTRY TimeDlgProc(HWND, ULONG, MPARAM, MPARAM);
VOID	GetControlCoordinates( HWND, HWND, SHORT *, SHORT *, SHORT *);
BOOL	PanelDlgFilter( HWND, USHORT, MPARAM, MPARAM);
VOID	ChangeDateTime( HPS, HWND, SHORT, CHAR );
VOID	ControlMinmax( MPARAM,HWND);
VOID	PanelPaint(  HPS );
VOID	PaintDateTime( HPS );
VOID	GetDate(void);
VOID	GetTime(void);
VOID	PanelVScrolls( HWND, USHORT,  MPARAM);
VOID	TimeInit(HWND);
SHORT	MouseTrack( MPARAM );
VOID	GetCountryDependent(VOID);
VOID	BringUpArrows( HWND, SHORT );
VOID	FixDate( SHORT );
VOID	SetDate(void);
VOID	SetTime(void);
/****************************************************************\
 *  Routine Name:
 *--------------------------------------------------------------
 *
 *  Name:TimeDlgProc()
 *
 *  Purpose:
 *  This routine will handle the  processing necessary for the
 *  time dialog box.
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
MRESULT
EXPENTRY TimeDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    HPS	 hpsPanel;

    switch (msg)
    {

    case WM_INITDLG:
	/*
	 * Dialog boxes have no way to tell pmwin to ignore the x,y pos.  So
	 * we have to make pmwin decide anyway where to put this dialog box.
	 */
	hDateTime = hwnd; /* put in a global var, so everybody know we
			     already have an opened dialog box */
	TimeInit (hwnd);
	return ( (MRESULT) 0L);
	break;

    case WM_CHAR:
	if (!bIsIconic)
	    PanelDlgFilter( hwnd, msg, mp1, mp2);
	break;

    case WM_BUTTON1DOWN:
	if (bIsIconic)
	    return (WinDefDlgProc( hwnd, msg, mp1, mp2));
	else
	{
	    hpsPanel = WinGetPS(hwnd);
	    ChangeDateTime( hpsPanel, hwnd, MouseTrack(mp1 ),0 );
	    WinReleasePS( hpsPanel);
	    return( WinDefDlgProc( hwnd, msg, mp1, mp2) );
	}
	break;

    case WM_COMMAND:
	switch (LOUSHORT(mp1))
	{
	case MBID_OK:
	    if (fTimeFreez) SetTime();
	    if (fDateFreez) SetDate();
	    /*Fall through to cancel*/

	case MBID_CANCEL:
	   /*The code here is executed also on MBID_OK*/
	    hDateTime = (HWND)NULL;
	    WinDismissDlg( hwnd, 0);
	    break;
	}
	break;


    case WM_MINMAXFRAME:
	ControlMinmax( mp1, hwnd );
	break;

    case WM_PAINT:
	if ( bIsIconic )
	    return( WinDefDlgProc( hwnd, msg, mp1, mp2) );
	else {
	    WinDefDlgProc(hwnd, msg, mp1, mp2);
	    hpsPanel = WinGetPS(hwnd);
	    PanelPaint(	 hpsPanel);
	    WinReleasePS( hpsPanel);
	}
	break;
    case WM_TIMER:
	hpsPanel = WinGetPS(hwnd);
	if ( LOUSHORT( mp1) == IDR_MAIN ) {
	   if ( !(fTimeFreez)) GetTime();
	   if ( !(fDateFreez )) GetDate();
	   PaintDateTime( hpsPanel);
	}
	WinReleasePS( hpsPanel);
	break;
    case WM_VSCROLL:
	if ( bIsIconic )
	    break;
	PanelVScrolls( hwnd,
		       HIUSHORT(mp2),
		       mp1     );
	break;



    default:
	return(WinDefDlgProc(hwnd, msg, mp1, mp2));
	break;
    }
   return( (MRESULT)0L);
}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:GetControlCoordinates()
 *
 *  Purpose: Get coordinates for the current dialog box.
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
VOID
GetControlCoordinates( HWND hDlg, HWND hwnd, SHORT *px, SHORT *py,
				 SHORT *px2)
{
    WRECT wrcT;

    WinQueryWindowRect(hwnd, (PRECTL)&wrcT);

    /* Convert rect. relative coord.s to dlg relative coord.s Joho.  */

    WinMapWindowPoints( hwnd, hDlg, (PPOINTL)&wrcT, 2);

    /* Convert window coord.s to dialog coord.s (==font transform)   */

    WinMapDlgPoints( hDlg, (PPOINTL)&wrcT, 2, FALSE);

   *px = wrcT.xLeft;
   *py = wrcT.yBottom;
   *px2 = wrcT.xRight;

}


/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns: VOID
 *
 *
\****************************************************************/
VOID
TimeInit(HWND hwnd)
{
    SHORT	xTime, yTime;
    SHORT	xDate, yDate;
    SHORT	x2Time, x2Date;


    fTimeFreez = FALSE;
    fDateFreez = FALSE;



    /*****************************************************************/
    /*	Get focus items' handles                                     */
    /*****************************************************************/
    hTime = WinWindowFromID(hwnd,TIME);
    hDate = WinWindowFromID(hwnd,DATE);
    hTimeScroll = WinWindowFromID(hwnd,SCROLL_TIME);
    hDateScroll = WinWindowFromID(hwnd,SCROLL_DATE);



    /**************************************************/
    /*	Get coords of time and date		      */
    /**************************************************/

    GetControlCoordinates( hwnd, hTime, &xTime, &yTime, &x2Time);
    GetControlCoordinates( hwnd, hDate, &xDate, &yDate, &x2Date);

    hCurrentFocus = (HWND)NULL;	       /* init focus to nowt	    */


    /*****************************************************************/
    /*	Rectangles and locations for Hit-tests and drawing.	     */
    /*****************************************************************/

    /*****************************************************************/
    /*	Date rectangles						     */
    /*****************************************************************/
    rDateAssign[0].yTop =
    rDateAssign[1].yTop =
    rDateAssign[2].yTop =
    rDateSep[0].yTop	=
    rDateSep[1].yTop	= yDate + (UCHAR)15;

    rDateAssign[0].yBottom =
    rDateAssign[1].yBottom =
    rDateAssign[2].yBottom =
    rDateSep[0].yBottom	   =
    rDateSep[1].yBottom	   = yDate +  (UCHAR)3;

    rDateAssign[0].xLeft   = xDate + (UCHAR)4;

    rDateAssign[0].xRight = rDateSep[0].xLeft	 = xDate + (SHORT)16;
    rDateSep[0].xRight	  = rDateAssign[1].xLeft = xDate + (SHORT)20;
    rDateAssign[1].xRight = rDateSep[1].xLeft	 = xDate + (SHORT)32;
    rDateSep[1].xRight	  = rDateAssign[2].xLeft = xDate + (SHORT)36;

    rDateAssign[2].xRight = xDate + (SHORT)48;

    /*****************************************************************/
    /*	Now map the Dlg coord.s into Window coord.s ready for rect.s */
    /*****************************************************************/

    WinMapDlgPoints( hwnd, (PPOINTL)&rDateAssign[0], 2, TRUE);
    WinMapDlgPoints( hwnd, (PPOINTL)&rDateSep[0],    2, TRUE);
    WinMapDlgPoints( hwnd, (PPOINTL)&rDateAssign[1], 2, TRUE);
    WinMapDlgPoints( hwnd, (PPOINTL)&rDateSep[1],    2, TRUE);
    WinMapDlgPoints( hwnd, (PPOINTL)&rDateAssign[2], 2, TRUE);


    /*****************************************************************/
    /*	time Rectangles						     */
    /*****************************************************************/
    rDateTime[HOUR].yTop   =
    rDateTime[MINUTE].yTop =
    rDateTime[SECOND].yTop =
    rTimeSep[0].yTop	   =
    rTimeSep[1].yTop	   =
    rTimeSep[2].yTop	   = yTime + (SHORT)15;

    rDateTime[HOUR].yBottom   =
    rDateTime[MINUTE].yBottom =
    rDateTime[SECOND].yBottom =
    rTimeSep[0].yBottom	      =
    rTimeSep[1].yBottom	      =
    rTimeSep[2].yBottom	      = yTime +	 (SHORT)3;

    rDateTime[HOUR].xLeft = xTime + (SHORT)4;

    rDateTime[HOUR].xRight   = rTimeSep[0].xLeft       = xTime + (SHORT)16;
    rTimeSep[0].xRight	     = rDateTime[MINUTE].xLeft = xTime + (SHORT)20;
    rDateTime[MINUTE].xRight = rTimeSep[1].xLeft       = xTime + (SHORT)32;
    rTimeSep[1].xRight	     = rDateTime[SECOND].xLeft = xTime + (SHORT)36;

    rDateTime[SECOND].xRight = xTime + (SHORT)48;

    rTimeSep[AM_PM].xLeft    = xTime + (SHORT)50;
    rTimeSep[AM_PM].xRight   = xTime + (SHORT)64;

    /*****************************************************************/
    /*	Now map the Dlg coord.s into Window coord.s ready for rect.s */
    /*****************************************************************/

    WinMapDlgPoints( hwnd, (PPOINTL)&rDateTime[HOUR],	2, TRUE);
    WinMapDlgPoints( hwnd, (PPOINTL)&rTimeSep[0],	2, TRUE);
    WinMapDlgPoints( hwnd, (PPOINTL)&rDateTime[MINUTE], 2, TRUE);
    WinMapDlgPoints( hwnd, (PPOINTL)&rTimeSep[1],	2, TRUE);
    WinMapDlgPoints( hwnd, (PPOINTL)&rDateTime[SECOND], 2, TRUE);
    WinMapDlgPoints( hwnd, (PPOINTL)&rTimeSep[AM_PM],	2, TRUE);

    /*****************************************************************/
    /*	Get time repaint region					     */
    /*****************************************************************/
    WinSetRect( hab,
		(PRECTL)&rRepaintTime,
		rDateTime[HOUR].xLeft,	  rDateTime[HOUR].yBottom,
		rDateTime[SECOND].xRight, rDateTime[SECOND].yTop   );
    GetCountryDependent();




    /* for the time and date scroll bars (spin buttons), just set the slider */
    /* position in the middle of the range and never move it.	 */
    WinSendMsg( hTimeScroll,SBM_SETSCROLLBAR,
		MPFROMLONG(2),
		MPFROM2SHORT(1,3));
    WinSendMsg( hDateScroll,SBM_SETSCROLLBAR,
		MPFROMLONG(2),
		MPFROM2SHORT(1,3));


}

/*********************************************************************/
/*  This routine does not actually filter the keystrokes, but	     */
/*  merely observes them in passing. It calls the DefDlgProc BEFORE  */
/*  taking any action of its own, to prevent WinSetFocus calls (in   */
/*  routines such as BringUpArrows in ChangeDateTime) from screwing  */
/*  up the DlgProc behaviour.					     */
/*********************************************************************/

BOOL
PanelDlgFilter( HWND hwnd, USHORT msg, MPARAM mp1, MPARAM mp2)
{
   SHORT    Hit;		       /* item "hit", ala mouse hit */
   SHORT    Key, iter;
   HPS	    hPS;
   CHAR	    UserSpecifiedVal;	       /* value user typed in for time or date field  */
   COUNTRYCODE DosCyCode;
   COUNTRYINFO DosCyInfo;
   BOOL	       DosCy;
   USHORT      Country;
   ULONG       iTemp;
   SHORT       Position4;
   SHORT       Position6;

    /*****************************************************************/
    /*	    Tabs						     */
    /*****************************************************************/

    Key = SHORT2FROMMP(mp2);	       /* Keep the VKey around	     */
    UserSpecifiedVal =	CHAR1FROMMP(mp2);   /* Keep the VKey around	  */

    hCurrentFocus = WinQueryFocus( HWND_DESKTOP); /* Debug    */

    WinDefDlgProc( hwnd, msg, mp1, mp2); /* Process NOW **************/

    hCurrentFocus = WinQueryFocus( HWND_DESKTOP);

    if ( !(SHORT1FROMMP(mp1) & KC_KEYUP) &&
	  (SHORT1FROMMP(mp1) & KC_VIRTUALKEY) &&
	  ( (Key == VK_TAB) || (Key == VK_BACKTAB) ) ) {


	/*************************************************************/
	/*  Set time or date active if they get focus		     */
	/*************************************************************/
	/*  NOTE that ChangeDateTime calls BringUpArrows which	     */
	/*  does WinSetFocus.					     */
	/*************************************************************/

	if (hCurrentFocus == hDate) {
	    hPS = WinGetPS( hwnd);
	    ChangeDateTime( hPS, hwnd, sFirstDate, 0 );
	    WinReleasePS( hPS);
	}
	else if (hCurrentFocus == hTime) {
	    hPS = WinGetPS( hwnd);
	    ChangeDateTime( hPS, hwnd, sFirstTime, 0 );
	    WinReleasePS( hPS);
	}

	return(TRUE);

    } /* endif it's a Tab/Backtab */


    /*****************************************************************/
    /*	    Arrows						     */
    /*****************************************************************/

    if ( !(SHORT1FROMMP(mp1) & KC_KEYUP) &&
	  (SHORT1FROMMP(mp1) & KC_VIRTUALKEY) &&
	 !(SHORT1FROMMP(mp1) & KC_CHAR) &&
	  ( (hCurrentFocus == hTime) || (hCurrentFocus == hDate) ) ) {

	Hit = Selected;		       /* init ID-or-action	     */

	/* determine which field to highlight by default for date field, */
	/* depending on the date format for the particular country. SNOR */

	DosCyCode.country = 0;		   /* Get default		 */
	DosCyCode.codepage = 0;		   /* Get current process CP	 */
	DosCy = (BOOL)!DosQueryCtryInfo( sizeof(COUNTRYINFO),
				 (PCOUNTRYCODE)&DosCyCode,
				 (PCOUNTRYINFO)&DosCyInfo,
				 (PULONG)&iTemp		  );

	/*****************************************************************/
	/*  If no info found by Dos, set USA				 */
	/*****************************************************************/
	Country = (USHORT)(DosCy ? DosCyInfo.country : COUNTRY_USA) ;

	/*****************************************************************/
	/* that cool way of doing date format				 */
	/*****************************************************************/
	iTemp = PrfQueryProfileInt( HINI_USER,
				    (PSZ)"PM_National",
				    (PSZ)"iDate",
				    (SHORT ) ( DosCy ? DosCyInfo.fsDateFmt
					       : 0 )  );
	switch(iTemp)
	{
	case 2:
	    /*************************************************************/
	    /*			    YMD					 */
	    /*************************************************************/
	    Position4 = YEAR;
	    Position6 = DAY;
	    break;
	case 1:
	    /*************************************************************/
	    /*			    DMY					 */
	    /*************************************************************/
	    Position4 = DAY;
	    Position6 = YEAR;
	    break;
	case 0:
	default:
	    /*************************************************************/
	    /*			    MDY	       USA == default		 */
	    /*************************************************************/
	    Position4 = MONTH;
	    Position6 = YEAR;
	    break;
	}

	switch(Key)
	{


	case VK_UP:
	    if (Selected == NOSELECT)
		Hit = ( (hCurrentFocus == hTime) ? (SHORT) HOUR : Position4);
	    else
		Hit = ((hCurrentFocus == hTime) ? (SHORT)UPTIME : (SHORT)UPDATE);
	    break;
	case VK_DOWN:
	    if (Selected == NOSELECT)
		Hit = ((hCurrentFocus == hTime) ? (SHORT) SECOND : Position6);
	    else
		Hit = ((hCurrentFocus == hTime) ? (SHORT) DOWNTIME : (SHORT)DOWNDATE);
	    break;
	case VK_LEFT:
	    if (Selected == NOSELECT)
		Hit = ((hCurrentFocus == hTime) ?  (SHORT)SECOND : Position4);
	    break;
	case VK_RIGHT:
	    if (Selected == NOSELECT)
		Hit = ((hCurrentFocus == hTime) ? (SHORT)HOUR : Position6);
	    break;
	default:
	    return(TRUE);
	    break;
	}

	hPS = WinGetPS(hwnd);
	for ( iter = 0;
	      iter < (SHORT)CHAR3FROMMP(mp1);
	      iter++		       ) { /* repeatcount times	     */

	    if (Key == VK_LEFT) {
		Hit = asLeftOf[Hit];
	    }
	    if (Key == VK_RIGHT) {
		Hit = asRightOf[Hit];
	    }

	    ChangeDateTime(hPS, hwnd, Hit, 0);
	}
	WinReleasePS(hPS);
	return(TRUE);
    }

    /*****************************************************************/
    /*	    Time or Date values					     */
    /*****************************************************************/
    if ( ( (hCurrentFocus == hTime) || (hCurrentFocus == hDate) ) &&
	 (!(SHORT1FROMMP(mp1) & KC_KEYUP)) &&
	 (SHORT1FROMMP(mp1) & KC_CHAR)) {

	/* check to make sure the value typed in is numeric */
	/* if it is not numeric then beep and return true   */
	if ((UserSpecifiedVal > '9') || (UserSpecifiedVal < '0')) {
	    WinAlarm (HWND_DESKTOP, WA_WARNING);
	    return (TRUE);
	}

	/* otherwise it is a numeric value			  */
	/* now change it from an ascii value to its numeric value */
	UserSpecifiedVal -= 48;

	/*Freez time or date*/
	if (hCurrentFocus == hTime) fTimeFreez = TRUE;
	else fDateFreez = TRUE;

	/*Update value*/
	Hit = ( (hCurrentFocus == hTime) ? (SHORT)TYPETIME : (SHORT)TYPEDATE);
	hPS = WinGetPS(hwnd);
	ChangeDateTime(hPS, hwnd, Hit, UserSpecifiedVal);
	WinReleasePS(hPS);
	return(TRUE);
    }


    return(TRUE);
}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ChangeDateTime()
 *
 *  Purpose:
 *     This function handles the user interface for changing the date and
 *     time.
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
VOID
ChangeDateTime( HPS hpsPanel, HWND hwnd, SHORT HitRect, CHAR UserSpecifiedValue)
{
    SHORT onesdigit;
    SHORT newvalue;
    SHORT convertflag = FALSE;
    SHORT savevalue;
    COUNTRYCODE DosCyCode;
    COUNTRYINFO DosCyInfo;
    BOOL	DosCy;
    USHORT	Country;
    ULONG	iTemp;
    SHORT	Position4;
    SHORT	Position6;

    switch(HitRect)
    {

    case HOUR:
    case MINUTE:
    case SECOND:
	fTimeFreez = TRUE;
	if (Selected == NOSELECT)      /* nothing selected	     */
	    BringUpArrows(hwnd,HitRect);
	else {			       /* take care of prev seln     */
	    if ( (Selected>=MONTH) && (Selected<=YEAR) ) {
				       /* if date item prev selected */
		PaintDateTime(hpsPanel);
		BringUpArrows(hwnd,HitRect);
	    }
	    wPrevDateTime[Selected] = -1; /* unhilite hilited */
	}

	PreviousSelected = Selected;	    /*save previously selected item */
	Selected = HitRect;
	PaintDateTime(hpsPanel);
	break;

    case MONTH:
    case DAY:
    case YEAR:
	fDateFreez = TRUE;
	if (Selected == NOSELECT)      /* nothing selected	     */
	    BringUpArrows(hwnd,HitRect);
	else {			       /* take care of prev seln     */
	    if ( (Selected>=HOUR) && (Selected<=SECOND) ) {
				       /* if time item prev selected */
		BringUpArrows(hwnd,HitRect);
	    }
	    wPrevDateTime[Selected] = -1; /* unhilite hilited */
	}
	PreviousSelected = Selected;	    /* @SNOR EviL save previously selected item */
	Selected = HitRect;
	PaintDateTime(hpsPanel);
	break;

    case UPTIME:
    case DOWNTIME:
	if ( (Selected>=HOUR) && (Selected<=SECOND) ) {
				       /* if time item hilited	     */
	    /* incr/decr */
	    if (HitRect == UPTIME)
		wDateTime[Selected] += 1;
	    else
		wDateTime[Selected] -= 1;

	    /* take care of wraparound */
	    if (wDateTime[Selected] > wModulos[Selected])
		wDateTime[Selected] = HOUR;
	    if (wDateTime[Selected] < HOUR)
		wDateTime[Selected] = wModulos[Selected];

	    PaintDateTime(hpsPanel);	  /* show changed item		*/
	}
	else
	    ChangeDateTime( hpsPanel,hwnd,
			    (SHORT)( (HitRect == UPTIME) ? HOUR : SECOND), 0  );
	break;

    case UPDATE:
    case DOWNDATE:
	if ( (Selected>=MONTH) && (Selected<=YEAR) ) {
				       /* if date item hilited	     */

	    /* incr/decr */
	    if (HitRect == UPDATE)
		wDateTime[Selected] += 1;
	    else
		wDateTime[Selected] -= 1;

	    /* take care of wraparound */
	    FixDate(Selected);

	    PaintDateTime(hpsPanel);	  /* show changed item	     */
	}
	else
	{
	    /* determine which field to highlight by default for date field, */
	    /* depending on the date format for the particular country. */

	    DosCyCode.country = 0;	       /* Get default		     */
	    DosCyCode.codepage = 0;	       /* Get current process CP     */
	    DosCy = (BOOL) !DosGetCtryInfo( sizeof(COUNTRYINFO),
				     (PCOUNTRYCODE)&DosCyCode,
				     (PCOUNTRYINFO)&DosCyInfo,
				     (PULONG)&iTemp	      );

	    /*****************************************************************/
	    /*	If no info found by Dos, set USA			     */
	    /*****************************************************************/
	    Country = (USHORT) (DosCy ? DosCyInfo.country : COUNTRY_USA );

	    /*****************************************************************/
	    /* that cool way of doing date format	     @SNOR	     */
	    /*****************************************************************/
	    iTemp = PrfQueryProfileInt( HINI_USER,
					(PSZ)"PM_National",
					(PSZ)"iDate",
					(SHORT )( DosCy ? DosCyInfo.fsDateFmt
						 : 0 )	);
	    switch(iTemp) {
	    case 2:
		/*************************************************************/
		/*			YMD		     @SNOR	     */
		/*************************************************************/
		Position4 = YEAR;
		Position6 = DAY;
		break;
	    case 1:
		/*************************************************************/
		/*			DMY		     @SNOR	     */
		/*************************************************************/
		Position4 = DAY;
		Position6 = YEAR;
		break;
	    case 0:
	    default:
		/*************************************************************/
		/*			MDY	   USA == default   @SNOR    */
		/*************************************************************/
		Position4 = MONTH;
		Position6 = YEAR;
		break;
	    }

	    ChangeDateTime( hpsPanel, hwnd,
			    (SHORT)
			     ( (HitRect == UPDATE) ? Position4 : Position6) ,
				   0);
	}
	break;
    case TYPETIME:
	savevalue = wDateTime[Selected];

	/* if this is the first value typed in for this selected field, */
	/* then replace it in the ones digit of the field		*/
	if (Selected != PreviousSelected) {

	    /* treat hour with care if we are in 12 hr. format, */
	    /* cuz it is stored in 24 hour format.		*/
	    /* convert it to 12 hour format, cuz that is what	*/
	    /* the user sees on the screen, and then later	*/
	    /* convert it back.					*/
	    if ((Selected == HOUR) && bTwelveHourFormat) {
		if (wDateTime[HOUR] > 12) {
		    wDateTime[HOUR] -= 12;
		    convertflag = TRUE;
		}
		if (wDateTime[HOUR] == 0) {
		    wDateTime[HOUR] = 12;
		    convertflag = TRUE;
		}
		if (wDateTime[HOUR] == 12) {
		    wDateTime[HOUR] = 0;
		    convertflag = TRUE;
		}
	    }

	    onesdigit = wDateTime[Selected] % (SHORT)10;
	    wDateTime[Selected] -= onesdigit;
	    wDateTime[Selected] += UserSpecifiedValue;

	    /* if necessary, convert back to 24 hour format */
	    if (convertflag) {
		if (wDateTime[HOUR] > 12) {   /* invalid time */
		    WinAlarm(HWND_DESKTOP, WA_WARNING);
		    convertflag = FALSE;
		    PreviousSelected = NOSELECT;
		    wDateTime[HOUR] = savevalue;
		    return;
		}
		else if (wDateTime[HOUR] == 12) {
		    wDateTime[HOUR] = 0;
		    convertflag = FALSE;
		}
		else {
		    wDateTime[HOUR] += 12;
		    convertflag = FALSE;
		}
	    }
	    PreviousSelected = Selected;
	}

	/* otherwise, if this isnt the first value typed in for this	  */
	/* selected field, then insert it into the ones field		  */
	else {


	    /* treat hour with care if we are in 12 hr. format, */
	    /* cuz it is stored in 24 hour format.		*/
	    /* convert it to 12 hour format, cuz that is what	*/
	    /* the user sees on the screen, and then later	*/
	    /* convert it back.					*/
	    if ((Selected == HOUR) && bTwelveHourFormat) {
		if (wDateTime[HOUR] > 12) {
		    wDateTime[HOUR] -= 12;
		    convertflag = TRUE;
		}
	    }

	    onesdigit		= wDateTime[Selected] % (SHORT)10;
	    wDateTime[Selected] = ( (onesdigit* (SHORT)10)+UserSpecifiedValue);

	    /* handle invalid settings here */
	    if (Selected == HOUR){
		if ((bTwelveHourFormat) && (wDateTime[HOUR] > 12)){
		    WinAlarm(HWND_DESKTOP, WA_WARNING);
		    wDateTime[HOUR] = savevalue;
		    PreviousSelected = NOSELECT;
		    return;
		}
		else if ((!bTwelveHourFormat) && (wDateTime[HOUR] > 24)){
		    WinAlarm(HWND_DESKTOP, WA_WARNING);
		    wDateTime[HOUR] = savevalue;
		    PreviousSelected = NOSELECT;
		    return;
		}
	    }
	    if ((Selected == MINUTE) && (wDateTime[MINUTE] > 60)){
		WinAlarm(HWND_DESKTOP, WA_WARNING);
		wDateTime[MINUTE] = savevalue;
		PreviousSelected = NOSELECT;
		return;
	    }
	    if ((Selected == SECOND) && (wDateTime[SECOND] > 60)){
		WinAlarm(HWND_DESKTOP, WA_WARNING);
		wDateTime[SECOND] = savevalue;
		PreviousSelected = NOSELECT;
		return;
	    }  /* if it passes those tests then it is a valid setting */

	    /* if necessary, convert back to 24 hour format */
	    if (convertflag) {
		if (wDateTime[HOUR] == 12) {
		    wDateTime[HOUR] = 0;
		    convertflag = FALSE;
		}
		else {
		    wDateTime[HOUR] += 12;
		    convertflag = FALSE;
		}
	    }
	}

	/* finally, update screen					   */
	PaintDateTime(hpsPanel);
	break;

    case TYPEDATE:					    /* @SNOR EviL */
	savevalue = wDateTime[Selected];

	/* if this is the first value typed in for this selected field, */
	/* then replace it in the ones digit of the field		*/
	if (Selected != PreviousSelected)
	{
		onesdigit = wDateTime[Selected] % (SHORT)10;
		wDateTime[Selected] -= onesdigit;
		wDateTime[Selected] += UserSpecifiedValue;
		PreviousSelected = Selected;
	}

	/* otherwise, if this isnt the first value typed in for this	  */
	/* selected field, then insert it into the ones field		  */
	else {

	    /* take special care not to trash the century if this is the */
	    /* year field.						 */
	    if (Selected == YEAR) {
		onesdigit = wDateTime[Selected] % (SHORT)10;
		newvalue  = ((onesdigit* (SHORT)10)+UserSpecifiedValue);

		if (newvalue >= (SHORT)80)
		    wDateTime[Selected] = (SHORT)1900 + newvalue;
		else
		    wDateTime[Selected] = (SHORT)2000 + newvalue;
	    }
	    else
	    {
		onesdigit	    = wDateTime[Selected] % (SHORT)10;
		wDateTime[Selected] = ((onesdigit* (SHORT)10)+UserSpecifiedValue);
	    }
	}

	/* test for valid value */
	if ((Selected == MONTH) && (wDateTime[MONTH] > 12)){
	    WinAlarm(HWND_DESKTOP, WA_WARNING);
	    wDateTime[MONTH] = savevalue;
	    PreviousSelected = NOSELECT;
	    return;
	}
	if ((Selected == DAY) && (wDateTime[DAY] > 31)){
	    WinAlarm(HWND_DESKTOP, WA_WARNING);
	    wDateTime[DAY] = savevalue;
	    PreviousSelected = NOSELECT;
	    return;
	}

	/* finally, update screen					   */
	PaintDateTime(hpsPanel);
	break;

    default:			       /* outside relevant date/time */
	if (Selected != NOSELECT) {    /* end "usSet" mode	       */
	    wPrevDateTime[Selected] = -1; /* unhilite hilited	     */
	    PreviousSelected = Selected;
	    Selected = NOSELECT;
	    PaintDateTime( hpsPanel);
	}
	break;

    }
}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ControlMinMax()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
VOID ControlMinmax( MPARAM mp1,HWND hwnd )
{

    bIsIconic = (BOOL)( (((PSWP)mp1)->fl & SWP_MINIMIZE) != (SHORT) 0);

    if ( bIsIconic )
    {
	  /*
	   *A bad thing in dialog boxes is that when they are minimized they
	   *still draw there control windows over the supplied icon. So we
	   *find if we are minimizing or restoring and hide the control window
	   *in the left button, happen to be MBID_OK
	   */
	   WinShowWindow(WinWindowFromID(hwnd,MBID_OK),FALSE);


    }
}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
VOID  PanelPaint(  HPS hpsPanel)
{
   SHORT   iter;

    /*****************************************************************/
    /*	Write the date and time					     */
    /*****************************************************************/

    /*****************************************************************/
    /*	Paint static fields					     */
    /*****************************************************************/

    for(iter=0; iter<2; iter++)
    {
	WinDrawText( hpsPanel,
		     -1,
		     (PSZ)szTimeSep,
		     (PRECTL)&rTimeSep[iter],
		     SYSCLR_WINDOWTEXT,
		     SYSCLR_WINDOW,
		     DT_CENTER | DT_VCENTER );
	WinDrawText( hpsPanel,
		     -1,
		     (PSZ)szDateSep,
		     (PRECTL)&rDateSep[iter],
		     SYSCLR_WINDOWTEXT,
		     SYSCLR_WINDOW,
		     DT_CENTER | DT_VCENTER );
    }

    /*****************************************************************/
    /*	Paint varying fields					     */
    /*****************************************************************/
    if (Selected == NOSELECT)
    {
       if (!fDateFreez) GetDate();
       if (!fTimeFreez) GetTime();
    }

    for (iter=0;iter<6;iter++)	  /* ensure all fields get painted   */
       wPrevDateTime[iter] = -1;
    PaintDateTime( hpsPanel);


    /*****************************************************************/
    /*	This call was causing a problem where hitting Alt when	     */
    /*	Time or Date selected didn't get rid of Menu highlight.      */
    /*	I'm not sure what it was doing here anyway...                */
    /*****************************************************************/

}   /* End of PanelPaint */
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:PaintDateTime()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns: VOID
 *
 *
\****************************************************************/
VOID  PaintDateTime(HPS hpsPanel)
{
    SHORT   iter;
    CHAR  szNumber[4];		       /* ascii value		     */
    CHAR  szPadding[4];		       /* pad numbers on left	     */
    SHORT   wHourSave;			 /* hours altered for 12hr fmt	*/
    SHORT   wYearSave;			 /* year moduloed 100	       */

    /*****************************************************************/
    /*	Save hours and year first. Outside here yields: Cur. held     */
    /*	as DOS uses; Prev. as drawn in panel. Inside here: both	     */
    /*	Cur and Prev drawn as in Panel.				     */
    /*****************************************************************/
    wHourSave = wDateTime[HOUR];
    wYearSave = wDateTime[YEAR];

    if (bTwelveHourFormat)
    {
	if (wDateTime[HOUR] > 12)
	    wDateTime[HOUR] -= 12;
	if (wDateTime[HOUR] == 0)
	    wDateTime[HOUR] = 12;
    }

    /*****************************************************************/
    /*	Set 1159 & 2359 (i.e. "am" "pm" etc.).			     */
    /*****************************************************************/
    if (wPrevDateTime[HOUR] != wDateTime[HOUR])
    {
	WinFillRect( hpsPanel,
		     (PRECTL)&rTimeSep[AM_PM],
		     SYSCLR_WINDOW	       );
	WinDrawText( hpsPanel,
		     -1,
		     ( (wHourSave < 12) ? (PSZ)szAnteMeridian
					: (PSZ)szPostMeridian ),
		     (PRECTL)&rTimeSep[AM_PM],
		     SYSCLR_WINDOWTEXT,
		     SYSCLR_WINDOW,
		     DT_CENTER | DT_VCENTER );
    }

    /*****************************************************************/
    /*	Save the century for DOS				     */
    /*****************************************************************/
    wDateTime[YEAR] %= 100;

    /*****************************************************************/
    /*	Write each field if changed or selected			     */
    /*****************************************************************/
    for (iter=0;iter< (SHORT) 6;iter++)
    {		   /* (hh)-mm-ss/mm-dd-yy */

	if ( (wDateTime[iter] != wPrevDateTime[iter])
	     || (iter == Selected)		      )
	{

	    /*********************************************************/
	    /*	Get the digit string				     */
	    /*********************************************************/
	    itoa(wDateTime[iter],szNumber,10);

	    /*********************************************************/
	    /*	Pad if less than 2 digits; blank pad iff	     */
	    /*	!bLeadingZero and is leftmost of time or date	     */
	    /*	(remember date format is dependent on coutry format) */
	    /*********************************************************/
	    if( wDateTime[iter]<10 )
	    {
		strcpy( szPadding,
			( !bLeadingZero
			  && ( (iter == HOUR) ||
			       ( rDateTime[iter].xLeft
				 == rDateAssign[0].xLeft ) )
			  ? " "
			  : "0" )
		      );

		strcat( szPadding, szNumber);
		strcpy( szNumber, szPadding);

	    }  /* endif <10 */

	    /* draw field */
	    WinFillRect( hpsPanel,
			 (PRECTL)&rDateTime[iter],
			 SYSCLR_WINDOW		   );
	    WinDrawText( hpsPanel,
			 -1,
			 (PSZ)szNumber,
			 (PRECTL)&rDateTime[iter],
			 SYSCLR_WINDOWTEXT,
			 SYSCLR_WINDOW,
			 DT_CENTER | DT_VCENTER );

	    /* hilite if selected */
	    if (iter == Selected)
		WinInvertRect( hpsPanel,
			       (PRECTL)&rDateTime[iter]);

	}  /* end if != ... */

	/*************************************************************/
	/*  Set new previous datetime				     */
	/*************************************************************/
	wPrevDateTime[iter] = wDateTime[iter];

    }	 /* end for */

    /*****************************************************************/
    /*	Restore hours and year for setting date/time		      */
    /*****************************************************************/
   wDateTime[HOUR] = wHourSave;
   wDateTime[YEAR] = wYearSave;

}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name: GetTime
 *
 *  Purpose:
 *  Get the current date and time.
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    1 - if sucessful execution completed
 *	    0 - if error
\****************************************************************/
VOID  GetTime(VOID)
{
    struct _DATETIME DT;

    DosGetDateTime( (LPDT)&DT);
    wDateTime[HOUR]   = (USHORT)DT.hours;
    wDateTime[MINUTE] = (USHORT)DT.minutes;
    wDateTime[SECOND] = (USHORT)DT.seconds;
}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:GetDate()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    1 - if sucessful execution completed
 *	    0 - if error
\****************************************************************/
VOID  GetDate(VOID)
{
    struct _DATETIME DT;

    DosGetDateTime( (LPDT)&DT);
    wDateTime[MONTH] = (USHORT)DT.month;
    wDateTime[DAY]   = (USHORT)DT.day;
    wDateTime[YEAR]  =	     DT.year; /* Year is two bytes	    */
}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:PanelVScrolls()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
VOID  PanelVScrolls(HWND hwnd,USHORT ScrollMsg,MPARAM idScroll)
{
    HPS	 hpsPanel;

    hpsPanel = WinGetPS(hwnd);
    switch(ScrollMsg)
    {
    case SB_LINEUP:		       /* line left		     */
    case SB_PAGEUP:		       /* page left		     */

	if (idScroll == (MPARAM)SCROLL_TIME)
	    ChangeDateTime( hpsPanel, hwnd, UPTIME,  0);
	else
	    ChangeDateTime( hpsPanel, hwnd, UPDATE, 0);
	WinReleasePS( hpsPanel);
	break;


    case SB_LINEDOWN:		       /* line right		     */
    case SB_PAGEDOWN:		       /* page right		     */

	if (idScroll == (MPARAM)SCROLL_TIME)
	    ChangeDateTime( hpsPanel, hwnd, DOWNTIME, 0);
	else
	    ChangeDateTime( hpsPanel, hwnd, DOWNDATE, 0);
	WinReleasePS( hpsPanel);
	break;

    default:
	WinReleasePS( hpsPanel);
	break;
    }
}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:MouseTrack()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    Offset for mouse pointer if the mouse was hit
\****************************************************************/
SHORT MouseTrack(MPARAM mp1)
{
    POINTL  ptl;
    SHORT   iter;

    ptl.x = (ULONG)LOUSHORT( mp1);
    ptl.y = (ULONG)HIUSHORT( mp1);

    for (iter=0;iter<6;iter++)
	if ( WinPtInRect( hab,
			  (PRECTL)&rDateTime[iter],
			  &ptl)	     )
	    return(iter);

    return(NOSELECT);
}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:GetCountryDependent()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns: VOID
 *
 *
\****************************************************************/
VOID GetCountryDependent(VOID )
{
    ULONG	iTemp;
    COUNTRYCODE DosCyCode;
    COUNTRYINFO DosCyInfo;
    USHORT	Country;
    BOOL	DosCy;

    /*****************************************************************/
    /*	Get the DOS country info to use as default if OS2.INI lacks. */
    /*****************************************************************/
    DosCyCode.country = 0;	       /* Get default		     */
    DosCyCode.codepage = 0;	       /* Get current process CP     */
    DosCy = (BOOL) !DosGetCtryInfo( sizeof(COUNTRYINFO),
			     (PCOUNTRYCODE)&DosCyCode,
			     (PCOUNTRYINFO)&DosCyInfo,
			     (PULONG)&iTemp	      );
    /*****************************************************************/
    /*	If no info found by Dos, set USA			     */
    /*****************************************************************/
    Country = (USHORT)( DosCy ? DosCyInfo.country : COUNTRY_USA) ;

    /*****************************************************************/
    /* get 12/24 hours format flag				      */
    /*****************************************************************/
    iTemp = PrfQueryProfileInt( HINI_USER,
				(PSZ)"PM_National",
				(PSZ)"iTime",
				(SHORT) (DosCy ? DosCyInfo.fsTimeFmt
					 : 0  ) );
    /*****************************************************************/
    /* 0 == twelve hours format; 1 == twenty-four hours format	       */
    /*****************************************************************/
    bTwelveHourFormat = (BOOL) !iTemp;

    /*****************************************************************/
    /* leading zero						     */
    /*****************************************************************/
    bLeadingZero = (BOOL)PrfQueryProfileInt( HINI_USER,
					     (PSZ)"PM_National",
					     (PSZ)"iLzero",
					     0			);


    /*****************************************************************/
    /* date separator string					     */
    /*****************************************************************/
    PrfQueryProfileString( HINI_USER,
			   (PSZ)"PM_National",
			   (PSZ)"sDate",
			   DosCy ? (PSZ)DosCyInfo.szDateSeparator
				 : (PSZ)"/",
			   (PSZ)szDateSep,
			   (ULONG)DATE_SEP_LEN+1			 );


    /*****************************************************************/
    /* time separator string					     */
    /*****************************************************************/
    PrfQueryProfileString( HINI_USER,
			   (PSZ)"PM_National",
			   (PSZ)"sTime",
			   DosCy ? (PSZ)DosCyInfo.szTimeSeparator
				 : (PSZ)":",
			   (PSZ)szTimeSep,
			   (ULONG)TIME_SEP_LEN+1			 );

    /*****************************************************************/
    /* AM/PM strings						     */
    /*****************************************************************/
    PrfQueryProfileString( HINI_USER,
			   (PSZ)"PM_National",
			   (PSZ)"s1159",
			   Country == COUNTRY_USA
			    ? (PSZ)"AM"
			    : Country == COUNTRY_UK
			      ? (PSZ)"am"
			      : (PSZ)"",
			   (PSZ)szAnteMeridian,
			   (ULONG)STRING_AM_LEN+1	    );
    PrfQueryProfileString( HINI_USER,
			   (PSZ)"PM_National",
			   (PSZ)"s2359",
			   Country == COUNTRY_USA
			    ? (PSZ)"PM"
			    : Country == COUNTRY_UK
			      ? (PSZ)"pm"
			      : (PSZ)"",
			   (PSZ)szPostMeridian,
			   (ULONG)STRING_PM_LEN+1	    );

    sFirstTime = HOUR;
    asLeftOf[HOUR] = SECOND;
    asLeftOf[MINUTE] = HOUR;
    asLeftOf[SECOND] = MINUTE;
    asRightOf[HOUR] = MINUTE;
    asRightOf[MINUTE] = SECOND;
    asRightOf[SECOND] = HOUR;

    /*****************************************************************/
    /* that cool way of doing date format			     */
    /*****************************************************************/
    vusDateFormat = iTemp = PrfQueryProfileInt( HINI_USER,
				(PSZ)"PM_National",
				(PSZ)"iDate",
				(SHORT ) ( DosCy ? DosCyInfo.fsDateFmt
					  : 0 )	 );
    switch(iTemp)
    {
    case 2:
	/*************************************************************/
	/*			YMD				     */
	/*************************************************************/
	WinCopyRect( hab,
		     (PRECTL)&rDateTime[YEAR],
		     (PRECTL)&rDateAssign[0]	);
	WinCopyRect( hab,
		     (PRECTL)&rDateTime[MONTH],
		     (PRECTL)&rDateAssign[1]	);
	WinCopyRect( hab,
		     (PRECTL)&rDateTime[DAY],
		     (PRECTL)&rDateAssign[2]	);
	sFirstDate = YEAR;
	asLeftOf[YEAR] = DAY;
	asLeftOf[MONTH] = YEAR;
	asLeftOf[DAY] = MONTH;
	asRightOf[YEAR] = MONTH;
	asRightOf[MONTH] = DAY;
	asRightOf[DAY] = YEAR;
	break;
    case 1:
	/*************************************************************/
	/*			DMY				     */
	/*************************************************************/
	WinCopyRect( hab,
		     (PRECTL)&rDateTime[DAY],
		     (PRECTL)&rDateAssign[0]	);
	WinCopyRect( hab,
		     (PRECTL)&rDateTime[MONTH],
		     (PRECTL)&rDateAssign[1]	);
	WinCopyRect( hab,
		     (PRECTL)&rDateTime[YEAR],
		     (PRECTL)&rDateAssign[2]	);
	sFirstDate = DAY;
	asLeftOf[YEAR] = MONTH;
	asLeftOf[MONTH] = DAY;
	asLeftOf[DAY] = YEAR;
	asRightOf[YEAR] = DAY;
	asRightOf[MONTH] = YEAR;
	asRightOf[DAY] = MONTH;
	break;
    case 0:
    default:
	/*************************************************************/
	/*			MDY	   USA == default	     */
	/*************************************************************/
	WinCopyRect( hab,
		     (PRECTL)&rDateTime[MONTH],
		     (PRECTL)&rDateAssign[0]	);
	WinCopyRect( hab,
		     (PRECTL)&rDateTime[DAY],
		     (PRECTL)&rDateAssign[1]	);
	WinCopyRect( hab,
		     (PRECTL)&rDateTime[YEAR],
		     (PRECTL)&rDateAssign[2]	);
	sFirstDate = MONTH;
	asLeftOf[YEAR] = DAY;
	asLeftOf[MONTH] = YEAR;
	asLeftOf[DAY] = MONTH;
	asRightOf[YEAR] = MONTH;
	asRightOf[MONTH] = DAY;
	asRightOf[DAY] = YEAR;
	break;
    }


}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:BringUpArrows.
 *
 *  Purpose:
 *    Take care of up down arrows
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
VOID BringUpArrows(HWND hwnd,SHORT Item)
{

   if( (Item>=HOUR) && (Item<=SECOND) )
   {	 /* time item		*/

      /* Set focus to current groupbox if control panel has focus */
      if ( WinQueryWindow(WinQueryFocus(HWND_DESKTOP), QW_PARENT) == hwnd )
      {
	 WinSetFocus(HWND_DESKTOP, hTime);
	 hCurrentFocus = hTime;

      }
   } /* endif time */

   else if( (Item>=MONTH) && (Item<=YEAR) )
   {   /* date item	    */

      /* Set focus to current groupbox if control panel has focus */
      if ( WinQueryWindow(WinQueryFocus(HWND_DESKTOP), QW_PARENT) == hwnd)
      {
	 WinSetFocus(HWND_DESKTOP, hDate);
	 hCurrentFocus = hDate;


      }
   } /* endif Date */

}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name: FixDate
 *
 *  Purpose:
 *  Takes care of date wraparound
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
VOID  FixDate(SHORT Field)
{
    switch(Field)
    {
    case MONTH:
	if (wDateTime[MONTH] > 12)
	    wDateTime[MONTH] = 1;
	if (wDateTime[MONTH] < 1)
	    wDateTime[MONTH] = 12;
	FixDate(DAY);			 /* keep day in new bounds   */
	break;

    case DAY:
	/* check for leap year */
	if ( ( (wDateTime[YEAR] % 4 == 0 && wDateTime[YEAR] % 100 != 0)
	       || wDateTime[YEAR] % 400 == 0
	     ) && wDateTime[MONTH] == 2
	   ) {
	    if(wDateTime[DAY] > 29) wDateTime[DAY] = 1;
	    if(wDateTime[DAY] < 1) wDateTime[DAY] = 29;
	}
	else
	{   /* non-leap year   */
	    if (wDateTime[DAY] > DaysPerMonth[wDateTime[MONTH]])
		wDateTime[DAY] = 1;
	    if (wDateTime[DAY] < 1)
		wDateTime[DAY] = DaysPerMonth[wDateTime[MONTH]];
	}
	break;

    case YEAR:
	if (wDateTime[YEAR] > 2079)
	    wDateTime[YEAR] = 1980;
	if (wDateTime[YEAR] < 1980)
	    wDateTime[YEAR] = 2079;
	FixDate(DAY);			 /* for leap yr. to non-leap */
	break;

   }

}


/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:Settime
 *
 *  Purpose:
 *  Sets the system time.
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    1 - if sucessful execution completed
 *	    0 - if error
\****************************************************************/
VOID  SetTime(VOID)
{
    struct _DATETIME DT;
    APIRET rc;

    DosGetDateTime( (LPDT)&DT);
    DT.hours   = (BYTE)wDateTime[HOUR]	;
    DT.minutes = (BYTE)wDateTime[MINUTE];
    DT.seconds = (BYTE)wDateTime[SECOND];
    rc = DosSetDateTime( (LPDT)&DT);
    if (rc)
    {
	  WinAlarm(HWND_DESKTOP, WA_WARNING);
    }
    /*
     *if the alarm
     *is set then update
     *it
     */
     if(cp.alarm.usMode & AM_ACTIVE )
     {
	  AlarmSetTimer(cp.alarm.uchHour,
			      cp.alarm.uchMinutes);
     }

}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:SetDate()
 *
 *  Purpose:
 *  Set system date.
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns: VOID
 *
 *
\****************************************************************/
VOID SetDate(VOID)
{
    struct _DATETIME DT;
    APIRET rc;

    DosGetDateTime( (LPDT)&DT);
    DT.month = (BYTE)wDateTime[MONTH];
    DT.day   = (BYTE)wDateTime[DAY]  ;
    DT.year  =	     wDateTime[YEAR] ; /* Year is two bytes	     */
    rc = DosSetDateTime( (LPDT)&DT);
    if (rc)
    {
	  WinAlarm(HWND_DESKTOP, WA_WARNING);
    }

    /*
     *if the alarm
     *is set then update
     *it
     */
     if(cp.alarm.usMode & AM_ACTIVE )
     {

	  AlarmSetTimer(cp.alarm.uchHour,
			      cp.alarm.uchMinutes);
     }
}

/*--------------------------------------------------------------*\
 *  End of file :udtime.c
\*--------------------------------------------------------------*/
/**************************************************************************
 *  File name  :  user.c
 *
 *  Description:  This module contains the code for processing messages
 *		  sent to the standard window that the standard window does
 *		  not process.	The application developer need only modify
 *		  this file in order to implement new menu items or process
 *		  messages not handled by the standard message routine.
 *
 *		  This source file contains the following functions:
 *
 *		  UserWndProc(hwnd, msg, mp1, mp2)
 *		  UserCommand(mp1, mp2)
 *
 *  Concepts   :  message processing
 *
 *  API's      :  WinDefWindowProc
 *		  WinSendMsg
 *
 *    Files    :  OS2.H, MAIN.H, DLG.H, XTRN.H
 *
 *  Copyright (C) 1991 IBM Corporation
 *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *	sample code created by IBM Corporation. This sample code is not
 *	part of any standard or IBM product and is provided to you solely
 *	for  the purpose of assisting you in the development of your
 *	applications.  The code is provided "AS IS", without
 *	warranty of any kind.  IBM shall not be liable for any damages
 *	arising out of your use of the sample code, even if they have been
 *	advised of the possibility of such damages.						       *
 *************************************************************************/

/*
 *  Include files, macros, defined constants, and externs
 */

#define INCL_WINMENUS

#include <os2.h>
#include "main.h"
#include "dlg.h"
#include "xtrn.h"

/*
 *  Global variables
 */


/*
 *  Entry point declarations
 */


/**************************************************************************
 *
 *  Name       : UserWndProc(hwnd, msg, mp1, mp2)
 *
 *  Description: Process any messages sent to hwndMain that
 *		 are not processed by the standard window procedure.
 *
 *  Concepts:	 Routine is called for each message MainWndProc
 *		 does not process.
 *
 *		 A switch statement branches control based upon
 *		 the message passed.  Any messages not processed
 *		 here must be passed onto WinDefWindowProc().
 *
 *  API's      : WinDefWindowProc
 *
 *  Parameters :  hwnd = window handle
 *		  msg  = message i.d.
 *		  mp1  = first message parameter
 *		  mp2  = second message parameter
 *
 *  Return     :  Return value dependent upon the message processed
 *
 *************************************************************************/
MRESULT UserWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   switch(msg)
   {
   /*
    *  Add case statements for message ids you wish to process.
    */

   default:    /* default must call WinDefWindowProc() */
      return(WinDefWindowProc(hwnd, msg, mp1, mp2));
      break;
   }
   return (MRESULT)0;
}   /* End of UserWndProc   */


/**************************************************************************
 *
 *  Name       : UserCommand(mp1, mp2)
 *
 *  Description: Process any WM_COMMAND messages sent to hwndMain
 *		 that are not processed by MainCommand.
 *
 *  Concepts:	 Routine is called for each WM_COMMAND that is
 *		 not posted by a standard menu item.
 *
 *		 A switch statement branches control based upon
 *		 the id of the control which posted the message.
 *
 *  API's      :  [none]
 *
 *  Parameters :  mp1  = first message parameter
 *		  mp2  = second message parameter
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID UserCommand(MPARAM mp1, MPARAM mp2)
{
   switch(SHORT1FROMMP(mp1))
   {

   /*
    *  Add case statements for menuitem ids you wish to process.
    */

   default:
      break;
   }

   /* This routine currently doesn't use the mp2 parameter but
    *  it is referenced here to prevent an 'Unreferenced Parameter'
    *  warning at compile time.
    */
   mp2 = mp2;
}   /* End of UserCommand  */

/**************************************************************************
 *
 *  Name       : InitMenu()
 *
 *  Description: Processes the WM_INITMENU message for the main window,
 *		 disabling any menus that are not active.
 *
 *  Concepts:	 Routine is called each time a menu is dropped.
 *
 *		 A switch statement branches control based upon
 *		 the id of the menu that is being displayed.
 *
 *  API's      :  [none]
 *
 *  Parameters :  mp1  = first message parameter
 *		  mp2  = second message parameter
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID InitMenu(MPARAM mp1, MPARAM mp2)
{
	      /* define a shorthand way of denoting the menu handle */
#define hwndMenu	HWNDFROMMP(mp2)

   switch(SHORT1FROMMP(mp1))
   {
   case IDM_FILE:
      break;

   case IDM_HELP:
	    /*
	     * Enable or disable the Help menu depending upon whether the
	     * help manager has been enabled
	     */
	EnableMenuItem(hwndMenu, IDM_HELPUSINGHELP, fHelpEnabled);
	EnableMenuItem(hwndMenu, IDM_HELPGENERAL, fHelpEnabled);
	EnableMenuItem(hwndMenu, IDM_HELPKEYS, fHelpEnabled);
	EnableMenuItem(hwndMenu, IDM_HELPINDEX, fHelpEnabled);

	 /*  REMEMBER: add a case for IDM_HELPTUTORIAL if you include
	  *  the Tutorial menu item.
	  */

       break;

    default:
       break;
    }

#undef hwndMenu
}   /* End of InitMenu	 */

/**************************************************************************
 *
 *  Name       : EnableMenuItem(hwndMenu, idItem, fEnable)
 *
 *  Description: Enables or disables the menu item
 *
 *  Concepts:	 Called whenever a menu item is to be enabled or
 *		 disabled
 *
 *		 Sends a MM_SETITEMATTR to the menu with the
 *		 given item id.	 Sets the MIA_DISABLED attribute
 *		 flag if the item is to be disabled, clears the flag
 *		 if enabling.
 *
 *  API's      : WinSendMsg
 *
 *  Parameters :  hwndmenu = menu window handle
 *		  idItem   = menu item i.d.
 *		  fEnable  = enable (yes) or disable (no)
 *
 *  Return     :  [none]
 *
 *************************************************************************/
VOID EnableMenuItem(HWND hwndMenu, USHORT idItem, BOOL fEnable)
{
   SHORT fsFlag;

   if(fEnable)
      fsFlag = 0;
   else
      fsFlag = MIA_DISABLED;

   WinSendMsg(hwndMenu,
	      MM_SETITEMATTR,
	      MPFROM2SHORT(idItem, TRUE),
	      MPFROM2SHORT(MIA_DISABLED, fsFlag));

}   /* End of EnableMenuItem() */
/***************************  End of user.c  ****************************/
/*static char *SCCSID = "@(#)vmm_dlg.c	6.12 92/03/18";*/
/*==============================================================*\
 *  VMM_DLG.C - window procedures for the dialog boxes as well  *
 *              as utility procedures used by them              *
 *      (C) Copyright IBM Corporation 1992.                     *
 *--------------------------------------------------------------*
 *                                                              *
 *  This module contains the Dialog Procedures for the user     *
 *  defined dialogs as well as any support code they need       *
 *                                                              *
 *--------------------------------------------------------------*
 *                                                              *
 *  This source file contains the following functions:          *
 *                                                              *
 *           AllocMemDlgProc(hwnd, msg, mp1, mp2)               *
 *           SetMem1DlgProc( hwnd, msg, mp1, mp2)               *
 *           SetMem2DlgProc( hwnd, msg, mp1, mp2)               *
 *           ReadMemDlgProc( hwnd, msg, mp1, mp2)               *
 *           WriteMemDlgProc(hwnd, msg, mp1, mp2)               *
 *           FreeMemDlgProc( hwnd, msg, mp1, mp2)               *
 *                                                              *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs       *
\*--------------------------------------------------------------*/
#include "vmm.h"

/****************************************************************\
 *  Dialog procedure for the Allocate Memory dialog             *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    AllocMemDlgProc(hwnd, msg, mp1, mp2)               *
 *                                                              *
 *  Purpose: Processes all messages sent to the AllocMem dialog *
 *                                                              *
 *  Usage:   Called for each message sent to the dialog box.    *
 *                                                              *
 *  Method:  a switch statement branches to the routines to be  *
 *           performed for each message processed. Any messages *
 *           not specifically processed are passed to the       *
 *           default window procedure WinDefDlgProc()           *
 *                                                              *
 *  Returns: Dependent upon message sent                        *
 *                                                              *
\****************************************************************/
MRESULT EXPENTRY AllocMemDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    static POBJSTRUCT pObj;
    MRESULT sRC;

    switch (msg) {
        case WM_INITDLG:

            pObj = PVOIDFROMMP(mp2);
            FixSysMenu(hwnd);

            ltoa(
                   (pObj->ulSize) ,(CHAR *) szBuffer, 10);  /* radix=10 */

            WinSetDlgItemText(hwnd, IDD_EDITSIZE, szBuffer);

            WinSendDlgItemMsg(hwnd, IDD_READ, BM_SETCHECK,
                   MPFROMSHORT((pObj->ulAttr & PAG_READ) ? 1 : 0), (MPARAM)0L);

            WinSendDlgItemMsg(hwnd, IDD_EXECUTE, BM_SETCHECK,
                 MPFROMSHORT((pObj->ulAttr & PAG_EXECUTE) ? 1 : 0),(MPARAM)0L);

            WinSendDlgItemMsg(hwnd, IDD_WRITE, BM_SETCHECK,
                 MPFROMSHORT((pObj->ulAttr & PAG_WRITE) ? 1 : 0),(MPARAM)0L);

            WinSendDlgItemMsg(hwnd, IDD_GUARD, BM_SETCHECK,
                 MPFROMSHORT((pObj->ulAttr & PAG_GUARD) ? 1 : 0),(MPARAM)0L);

            WinSendDlgItemMsg(hwnd, IDD_COMMIT, BM_SETCHECK,
                 MPFROMSHORT((pObj->ulAttr & PAG_COMMIT) ? 1 : 0),(MPARAM)0L);

            WinSendDlgItemMsg(hwnd, IDD_TILE, BM_SETCHECK,
                 MPFROMSHORT((pObj->ulAttr & OBJ_TILE) ? 1 : 0),(MPARAM)0L);

            return((MRESULT)FALSE);
                           /* Let the focus go to where the system puts it */

        case WM_COMMAND:
            switch (SHORT1FROMMP(mp1)) {
                case DID_OK:
                    WinQueryDlgItemText(hwnd, IDD_EDITSIZE, MAX_EDIT_BUFF,
                                          szBuffer);    /* Get user's size */
                    pObj->ulSize = atol(szBuffer);
                    pObj->ulSize *= 1000L;
                    pObj->ulAttr =
                  ((WinSendDlgItemMsg(hwnd,IDD_READ,BM_QUERYCHECK,(MPARAM)0L,
                       (MPARAM)0L) == (MRESULT)1L) ? (ULONG)PAG_READ : 0L)    |
                  ((WinSendDlgItemMsg(hwnd,IDD_EXECUTE,BM_QUERYCHECK,(MPARAM)0L,
                       (MPARAM)0L) == (MRESULT)1L) ? (ULONG)PAG_EXECUTE : 0L) |
                  ((WinSendDlgItemMsg(hwnd,IDD_WRITE,BM_QUERYCHECK,(MPARAM)0L,
                       (MPARAM)0L) == (MRESULT)1L) ? (ULONG)PAG_WRITE : 0L)   |
                  ((WinSendDlgItemMsg(hwnd,IDD_GUARD,BM_QUERYCHECK,(MPARAM)0L,
                       (MPARAM)0L) == (MRESULT)1L) ? (ULONG)PAG_GUARD : 0L)   |
                  ((WinSendDlgItemMsg(hwnd,IDD_COMMIT,BM_QUERYCHECK,(MPARAM)0L,
                       (MPARAM)0L) == (MRESULT)1L) ? (ULONG)PAG_COMMIT : 0L)  |
                  ((WinSendDlgItemMsg(hwnd,IDD_TILE,BM_QUERYCHECK,(MPARAM)0L,
                       (MPARAM)0L) == (MRESULT)1L) ? (ULONG)OBJ_TILE : 0L);

                    if (((pObj->ulAttr & PAG_READ) == 0L)  /* Disable READ */
                         && ((pObj->ulAttr & PAG_EXECUTE) != 0L))
                    {
                       MessageBox(hwnd, IDMSG_UNSETREADERROR, "Error !",
                                    MB_OK | MB_INFORMATION, TRUE);
                       pObj->ulAttr = pObj->ulAttr | PAG_READ;
                    }
                    if (((pObj->ulAttr & PAG_READ) == 0L)  /* Disable READ */
                         && ((pObj->ulAttr & PAG_WRITE) != 0L))
                    {
                       MessageBox(hwnd, IDMSG_UNSETREADERROR2, "Error !",
                                    MB_OK | MB_INFORMATION, TRUE);
                       pObj->ulAttr = pObj->ulAttr | PAG_READ;
                    }
                    WinDismissDlg(hwnd, TRUE);
                    return((MRESULT)0L);

                case DID_CANCEL:
                    WinDismissDlg(hwnd, FALSE);
                    return((MRESULT)0L);

                default:
                    sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
                    return sRC;
                }
            break;

        case WM_CLOSE:
           WinDismissDlg(hwnd, FALSE);
           return((MRESULT)0L);

        default:
            sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
            return sRC;
    }
    return((MRESULT)0L);
}

/****************************************************************\
 *  Dialog procedure for the Set Memory dialog                  *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    SetMem1DlgProc(hwnd, msg, mp1, mp2)                *
 *                                                              *
 *  Purpose: Processes all messages sent to the SetMem1 dialog  *
 *                                                              *
 *  Usage:   Called for each message sent to the dialog box.    *
 *                                                              *
 *  Method:  a switch statement branches to the routines to be  *
 *           performed for each message processed.  Any messages*
 *           not specifically processed are passed to the       *
 *           default window procedure WinDefDlgProc()           *
 *                                                              *
 *  Returns: Dependent upon message sent                        *
 *                                                              *
\****************************************************************/
MRESULT EXPENTRY SetMem1DlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   static POBJSTRUCT pObj;
   ULONG  ulIndexLow;
   MRESULT sRC;

   switch (msg) {
       case WM_INITDLG:  /* address of buffer pointed to by pCreateParams */
           pObj = PVOIDFROMMP(mp2);
           FixSysMenu(hwnd);

           WinSetDlgItemText(hwnd, IDD_EDITSIZE, SZDEFAULT_SIZE);

           return((MRESULT)FALSE);
                         /* Let the focus go to where the system puts it */

       case WM_COMMAND:
           switch (SHORT1FROMMP(mp1)) {
               case DID_OK:
                   WinQueryDlgItemText(hwnd, IDD_ADDRESS, MAX_EDIT_BUFF,
                                              szBuffer);
                   sscanf(szBuffer,"%p",&(pObj->pvAddress));

                   WinQueryDlgItemText(hwnd, IDD_EDITSIZE, MAX_EDIT_BUFF,
                                              szBuffer);
                   sscanf(szBuffer,"%p",&(pObj->ulSize));

                   ulIndexLow = 0;
                                            /* Look for the pointed page */
                   while((apgentry[ulIndexLow].pvAddress != pObj->pvAddress)
                                      && (ulIndexLow < ulFreePage))
                       ulIndexLow++;
                   if(ulIndexLow == ulFreePage)       /* Illeage address */
                   {
                      MessageBox(hwnd, IDMSG_ERRORADDRESS, "Error !",
                                       MB_OK | MB_MOVEABLE, TRUE);
                      return (MRESULT)0L;
                   }
                   WinDismissDlg(hwnd, TRUE);
                   return((MRESULT)0L);

               case DID_CANCEL:
                   WinDismissDlg(hwnd, FALSE);
                   return((MRESULT)0L);

               default:
                   sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
                   return sRC;
           }
           break;

        case WM_CLOSE:
           WinDismissDlg(hwnd, FALSE);
           return((MRESULT)0L);

       default:
           sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
           return sRC;
       }
       return((MRESULT)0L);
}

/****************************************************************\
 *  Dialog procedure for the Set Memory dialog                  *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    SetMem2DlgProc(hwnd, msg, mp1, mp2)                *
 *                                                              *
 *  Purpose: Processes all messages sent to the SetMem2 dialog. *
 *                                                              *
 *  Usage:   Called for each message sent to the dialog box.    *
 *                                                              *
 *  Method:  a switch statement branches to the routines to be  *
 *           performed for each message processed.  Any messages*
 *           not specifically processed are passed to the       *
 *           default window procedure WinDefDlgProc()           *
 *                                                              *
 *  Returns: Dependent upon message sent                        *
 *                                                              *
\****************************************************************/
MRESULT EXPENTRY SetMem2DlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   static POBJSTRUCT pObj;
   ULONG ulRegionSize, ulFlags=0L;
   ULONG rc;
   MRESULT sRC;

   switch (msg) {
       case WM_INITDLG:
           pObj = PVOIDFROMMP(mp2);
           FixSysMenu(hwnd);

           rc = DosQueryMem(pObj->pvAddress, &ulRegionSize, &ulFlags);
           if (rc)                                      /* Query is fail */
           {
               VMM_Error("DosQueryMem()", rc);
               WinDismissDlg(hwnd, FALSE);
               return((MRESULT)FALSE);
           }
           memset(szBuffer,0,sizeof(szBuffer) );
           sprintf(szBuffer, "Address of memory =0x%p",pObj->pvAddress);
           WinSetDlgItemText(hwnd, IDD_ADDRESS, szBuffer);

           WinSendDlgItemMsg(hwnd, IDD_READ, BM_SETCHECK,
                 MPFROMSHORT((ulFlags & PAG_READ) ? 1 : 0),(MPARAM)0L);
           WinSendDlgItemMsg(hwnd, IDD_EXECUTE, BM_SETCHECK,
                 MPFROMSHORT((ulFlags & PAG_EXECUTE) ? 1 : 0),(MPARAM)0L);
           WinSendDlgItemMsg(hwnd, IDD_WRITE, BM_SETCHECK,
                 MPFROMSHORT((ulFlags & PAG_WRITE) ? 1 : 0),(MPARAM)0L);
           WinSendDlgItemMsg(hwnd, IDD_GUARD, BM_SETCHECK,
                 MPFROMSHORT((ulFlags & PAG_GUARD) ? 1 : 0),(MPARAM)0L);
           WinSendDlgItemMsg(hwnd, IDD_DEFAULT, BM_SETCHECK,
                 MPFROMSHORT(1), (MPARAM)0L);

           return((MRESULT)FALSE);
                           /* Let the focus go to where the system puts it */
       case WM_CONTROL:
           switch (SHORT1FROMMP(mp1)) {
               case IDD_DECOMMIT:
                            /* Can't change attributes when de-committing */
                   if (SHORT2FROMMP(mp1) == BN_CLICKED)
                   {
                    if((WinSendDlgItemMsg(hwnd,IDD_DECOMMIT,BM_QUERYCHECK,
                        (MPARAM)0L,(MPARAM)0L) == (MRESULT)1L) ? TRUE : FALSE)
                    {
            /* If we are decommitting memory, don't change any attributes */
        WinSendDlgItemMsg(hwnd, IDD_READ, BM_SETCHECK,(MPARAM)0L,(MPARAM)0L);
        WinSendDlgItemMsg(hwnd, IDD_EXECUTE, BM_SETCHECK,(MPARAM)0L,(MPARAM)0L);
        WinSendDlgItemMsg(hwnd, IDD_WRITE, BM_SETCHECK,(MPARAM)0L,(MPARAM)0L);
        WinSendDlgItemMsg(hwnd, IDD_GUARD, BM_SETCHECK,(MPARAM)0L,(MPARAM)0L);
                    }
                   }             /* tell it we didn't process the message */
                   return((MRESULT)TRUE);

               case IDD_DEFAULT:
                   if (SHORT2FROMMP(mp1) == BN_CLICKED)
                   {
                    if ((WinSendDlgItemMsg(hwnd,IDD_DEFAULT,BM_QUERYCHECK,
                          (MPARAM)0L,(MPARAM)0L) == (MRESULT)1L) ?
                          TRUE : FALSE)
                    {               /* Reset attributes to initial values */
                     WinSendDlgItemMsg(hwnd, IDD_READ, BM_SETCHECK,
                                            MPFROMLONG(1L),(MPARAM)0L);
                     WinSendDlgItemMsg(hwnd, IDD_EXECUTE, BM_SETCHECK,
                                            MPFROMLONG(1L),(MPARAM)0L);
                     WinSendDlgItemMsg(hwnd, IDD_WRITE, BM_SETCHECK,
                                            MPFROMLONG(1L),(MPARAM)0L);
                     WinSendDlgItemMsg(hwnd, IDD_GUARD, BM_SETCHECK,
                                            (MPARAM)0L,(MPARAM)0L);
                    }
                   }             /* tell it we didn't process the message */
                   return((MRESULT)TRUE);

               case IDD_COMMIT:
                   /* For these cases, put the attributes back the way
                      they were, this is for whenthe user clicks on de-commit,
                      then, clicks back on default or commit since we cleared
                      the attribute flags when they clicked on decommit */

                   if (SHORT2FROMMP(mp1) == BN_CLICKED)
                   {
                      rc=DosQueryMem(pObj->pvAddress, &ulRegionSize, &ulFlags);
                      if (rc)
                      {
                          VMM_Error("DosQueryMem()", rc);

                          WinDismissDlg(hwnd, FALSE);
                          return((MRESULT)FALSE);
                      }
                     WinSendDlgItemMsg(hwnd, IDD_READ, BM_SETCHECK,
                      MPFROMSHORT((ulFlags & PAG_READ) ? 1 : 0),(MPARAM)0L);
                     WinSendDlgItemMsg(hwnd, IDD_EXECUTE, BM_SETCHECK,
                      MPFROMSHORT((ulFlags & PAG_EXECUTE) ? 1 : 0),(MPARAM)0L);
                     WinSendDlgItemMsg(hwnd, IDD_WRITE, BM_SETCHECK,
                      MPFROMSHORT((ulFlags & PAG_WRITE) ? 1 : 0),(MPARAM)0L);
                     WinSendDlgItemMsg(hwnd, IDD_GUARD, BM_SETCHECK,
                      MPFROMSHORT((ulFlags & PAG_GUARD) ? 1 : 0),(MPARAM)0L);
                   }
                   return((MRESULT)TRUE);
                                /* tell it we didn't process the message */
               default:
                   return((MRESULT)TRUE);
           }
           break;

       case WM_COMMAND:
           switch (SHORT1FROMMP(mp1)) {
               case DID_OK:
                   pObj->ulAttr =
                 ( (WinSendDlgItemMsg(hwnd,IDD_READ,BM_QUERYCHECK,(MPARAM)0L,
                    (MPARAM)0L) == (MRESULT) 1L) ? (ULONG)PAG_READ : 0L ) |
                 ( (WinSendDlgItemMsg(hwnd,IDD_EXECUTE,BM_QUERYCHECK,(MPARAM)0L,
                    (MPARAM)0L) == (MRESULT) 1L) ? (ULONG)PAG_EXECUTE : 0L ) |
                 ( (WinSendDlgItemMsg(hwnd,IDD_WRITE,BM_QUERYCHECK,(MPARAM)0L,
                    (MPARAM)0L) == (MRESULT) 1L) ? (ULONG)PAG_WRITE : 0L ) |
                 ( (WinSendDlgItemMsg(hwnd,IDD_GUARD,BM_QUERYCHECK,(MPARAM)0L,
                    (MPARAM)0L) == (MRESULT) 1L) ? (ULONG)PAG_GUARD : 0L ) |
                 ( (WinSendDlgItemMsg(hwnd,IDD_COMMIT,BM_QUERYCHECK,(MPARAM)0L,
                    (MPARAM)0L) == (MRESULT) 1L) ? (ULONG)PAG_COMMIT : 0L ) |
                 ( (WinSendDlgItemMsg(hwnd,IDD_DECOMMIT,BM_QUERYCHECK,(MPARAM)0L,
                    (MPARAM)0L) == (MRESULT) 1L) ? (ULONG)PAG_DECOMMIT : 0L );

                  if (((pObj->ulAttr & PAG_READ) == 0L)  /* Disable READ */
                       && ((pObj->ulAttr & PAG_EXECUTE) != 0L))
                  {
                     MessageBox(hwnd, IDMSG_UNSETREADERROR, "Error !",
                                  MB_OK | MB_INFORMATION, TRUE);
                     pObj->ulAttr = pObj->ulAttr | PAG_READ;
                  }
                  if (((pObj->ulAttr & PAG_READ) == 0L)  /* Disable READ */
                       && ((pObj->ulAttr & PAG_WRITE) != 0L))
                  {
                     MessageBox(hwnd, IDMSG_UNSETREADERROR2, "Error !",
                                  MB_OK | MB_INFORMATION, TRUE);
                     pObj->ulAttr = pObj->ulAttr | PAG_READ;
                  }
                /**************************************************************
                 *if ((pObj->ulAttr & PAG_EXECUTE) == 0L)  //Disable EXECUTE//*
                 *{                                                           *
                 *  NOTE :                                                    *
                 *  When user disables the EXECUTE and call DosSetMem() to    *
                 *  change attribute, this program doesn't return error       *
                 *  and still attach the EXECUTE attribute on it.             *
                 *  That is because there are a bug in Intel-80386 chip, it   *
                 *  makes the DosSetMem() not work normally.                  *
                 *}                                                           *
                 **************************************************************/

                  WinDismissDlg(hwnd, TRUE);
                  return((MRESULT)FALSE);
                                   /* tell system we did process the message */

               case DID_CANCEL:
                  WinDismissDlg(hwnd, FALSE);
                  return((MRESULT)FALSE);
                                /* tell system we did process the message */
               default:         /* tell it we didn't process the message */
                  sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
                  return sRC;
           }
           break;

       case WM_CLOSE:
          WinDismissDlg(hwnd, FALSE);
          return((MRESULT)0L);

       default:
           sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
           return sRC;
       }
   return((MRESULT)TRUE);
}

/****************************************************************\
 *  Dialog procedure for the Read Memory dialog                 *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    ReadMemDlgProc(hwnd, msg, mp1, mp2)                *
 *                                                              *
 *  Purpose: Processes all messages sent to the Read Memory     *
 *            dialog                                            *
 *                                                              *
 *  Usage:   Called for each message sent to the dialog box.    *
 *                                                              *
 *  Method:  a switch statement branches to the routines to be  *
 *           performed for each message processed.  Any messages*
 *           not specifically processed are passed to the       *
 *           default window procedure WinDefDlgProc()           *
 *                                                              *
 *  Returns: Dependent upon message sent                        *
 *                                                              *
\****************************************************************/
MRESULT EXPENTRY ReadMemDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   static POBJSTRUCT pObj;
   ULONG  ulIndexLow;
   MRESULT sRC;

   switch (msg) {
       case WM_INITDLG:
           pObj = PVOIDFROMMP(mp2);
           FixSysMenu(hwnd);

           return((MRESULT)FALSE);
                           /* Let the focus go to where the system puts it */

       case WM_COMMAND:
           switch (SHORT1FROMMP(mp1)) {
               case DID_OK:
                   WinQueryDlgItemText(hwnd, IDD_ADDRESS, MAX_EDIT_BUFF,
                                           szBuffer);
                   sscanf(szBuffer,"%p",&(pObj->pvAddress));

                   ulIndexLow = 0;
                                            /* Look for the pointed page */
                   while((apgentry[ulIndexLow].pvAddress != pObj->pvAddress)
                                    && (ulIndexLow < ulFreePage))
                       ulIndexLow++;
                   if(ulIndexLow == ulFreePage)       /* Illeage address */
                   {
                      MessageBox(hwnd, IDMSG_ERRORADDRESS, "Error !",
                                       MB_OK | MB_MOVEABLE, TRUE);
                      return (MRESULT)0L;
                   }

                   WinDismissDlg(hwnd, TRUE);
                   return((MRESULT)TRUE);

               case DID_CANCEL:
                   WinDismissDlg(hwnd, FALSE);
                   return((MRESULT)TRUE);

               default:
                   sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
                   return sRC;
               }
           break;

       case WM_CLOSE:
          WinDismissDlg(hwnd, FALSE);
          return((MRESULT)0L);

       default:
           sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
           return sRC;
       }
   return (MRESULT)0L;
}

/****************************************************************\
 *  Dialog procedure for the Write Memory dialog                *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    WriteMemDlgProc(hwnd, msg, mp1, mp2)               *
 *                                                              *
 *  Purpose: Processes all messages sent to the WriteMem dialog.*
 *                                                              *
 *  Usage:   Called for each message sent to the dialog box.    *
 *                                                              *
 *  Method:  a switch statement branches to the routines to be  *
 *           performed for each message processed.  Any messages*
 *           not specifically processed are passed to the       *
 *           default window procedure WinDefDlgProc()           *
 *                                                              *
 *  Returns: Dependent upon message sent                        *
 *                                                              *
\****************************************************************/
MRESULT EXPENTRY WriteMemDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   PVOID   pvMemAddress=0;
   ULONG   ulIndexLow;
   MRESULT sRC;

   switch (msg) {
       case WM_INITDLG:
           FixSysMenu(hwnd);
           return((MRESULT)FALSE);
                       /* Let the the focus go to where the system puts it */
       case WM_COMMAND:
           switch (SHORT1FROMMP(mp1)) {
               case DID_OK:
                   WinQueryDlgItemText(hwnd, IDD_ADDRESS, MAX_EDIT_BUFF,
                                           szBuffer);
                   sscanf(szBuffer,"%p",&pvMemAddress);

                   ulIndexLow = 0;
                                            /* Look for the pointed page */
                   while((apgentry[ulIndexLow].pvAddress != pvMemAddress)
                                    && (ulIndexLow < ulFreePage))
                       ulIndexLow++;
                   if(ulIndexLow == ulFreePage)       /* Illeage address */
                   {
                      MessageBox(hwnd, IDMSG_ERRORADDRESS, "Error !",
                                       MB_OK | MB_MOVEABLE, TRUE);
                      return (MRESULT)0L;
                   }
                   memset(szBuffer,0,sizeof(szBuffer) );
                   WinQueryDlgItemText(hwnd, IDD_DATA, MAX_EDIT_BUFF, szBuffer);
                   strcpy(pvMemAddress, szBuffer);  /* let 'em go for it.
                                                 it may cause a GP fault */
                   WinDismissDlg(hwnd, TRUE);
                   return((MRESULT)TRUE);

               case DID_CANCEL:
                   WinDismissDlg(hwnd, FALSE);
                   return((MRESULT)TRUE);

               default:
                   sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
                   return sRC;
               }
           break;

       case WM_CLOSE:
          WinDismissDlg(hwnd, FALSE);
          return((MRESULT)0L);

       default:
           sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
           return sRC;
       }
   return (MRESULT)0L;

}

/****************************************************************\
 *  Dialog procedure for the Free Memory dialog                 *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    FreeMemDlgProc(hwnd, msg, mp1, mp2)                *
 *                                                              *
 *  Purpose: Processes all messages sent to the FreeMem dialog  *
 *                                                              *
 *  Usage:   Called for each message sent to the Free Memory    *
 *           dialog box.                                        *
 *                                                              *
 *  Method:  a switch statement branches to the routines to be  *
 *           performed for each message processed.  Any messages*
 *           not specifically processed are passed to the       *
 *           default window procedure WinDefDlgProc()           *
 *                                                              *
 *  Returns: Dependent upon message sent                        *
 *                                                              *
\****************************************************************/
MRESULT EXPENTRY FreeMemDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   static POBJSTRUCT pObj;
   MRESULT sRC;
   ULONG  ulIndexLow;

   switch (msg) {
       case WM_INITDLG:
           pObj = PVOIDFROMMP(mp2);
           FixSysMenu(hwnd);
           return((MRESULT)FALSE);
                     /* Let the the focus go to where the system puts it */

       case WM_COMMAND:
           switch (SHORT1FROMMP(mp1)) {
               case DID_OK:
                   WinQueryDlgItemText(hwnd, IDD_ADDRESS, MAX_EDIT_BUFF,
                                              szBuffer);
                   sscanf(szBuffer,"%p",&(pObj->pvAddress));

                   ulIndexLow = 0;
                                            /* Look for the pointed page */
                   while((apgentry[ulIndexLow].pvAddress != pObj->pvAddress)
                                    && (ulIndexLow < ulFreePage))
                       ulIndexLow++;
                   if(ulIndexLow == ulFreePage)       /* Illeage address */
                   {
                      MessageBox(hwnd, IDMSG_ERRORADDRESS, "Error !",
                                       MB_OK | MB_MOVEABLE, TRUE);
                      return (MRESULT)0L;
                   }
                   WinDismissDlg(hwnd, TRUE);
                   break;

               case DID_CANCEL:
                   WinDismissDlg(hwnd, FALSE);
                   break;
               }
           break;

       case WM_CLOSE:
          WinDismissDlg(hwnd, FALSE);
          return((MRESULT)0L);

       default:
           sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
           return sRC;
       }
   return (MRESULT)0L;
}
/*static char *SCCSID = "@(#)vmm_help.c	6.16 92/02/18";*/
/*==============================================================*\
 *  VMM_HELP.C - routines for help information                  *
 *      (C) Copyright IBM Corporation 1992.                     *
 *--------------------------------------------------------------*
 *                                                              *
 *  This module contains all the routines for interfacing with  *
 *  the IPF help manager.                                       *
 *                                                              *
 *--------------------------------------------------------------*
 *                                                              *
 *  This source file contains the following functions:          *
 *                                                              *
 *          InitHelp()                                          *
 *          HelpHelpForHelp(mp2)                                *
 *          HelpExtended(mp2)                                   *
 *          HelpKeys(mp2)                                       *
 *          HelpIndex(mp2)                                      *
 *          HelpAbout(mp2)                                      *
 *          DisplayHelpPanel(idPanel)                           *
 *          DestroyHelpInstance(VOID)                           *
 *          AboutDlgProc(hwnd, msg, mp1, mp2)                   *
 *          FixSysMenu()                                        *
 *                                                              *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs       *
\*--------------------------------------------------------------*/
#include "vmm.h"

/****************************************************************\
 *  Routine for initializing the help manager
 *--------------------------------------------------------------
 *
 *  Name:    InitHelp()
 *
 *  Purpose: Initializes the IPF help facility
 *
 *  Usage:   Called once during initialization of the program
 *
 *  Method:  Initializes the HELPINIT structure and creates the help
 *           instance. If successful, the help instance is associated
 *           with the main window
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID InitHelp(VOID)
{
   HELPINIT hini;

    /* If we return because of an error, Help will be disabled */
   fHelpEnabled = FALSE;
                             /* Initialize help init structure */
   hini.cb = sizeof(HELPINIT);
   hini.ulReturnCode = 0;
                           /* If tutorial added, add name here */
   hini.pszTutorialName = (PSZ)NULL;

   hini.phtHelpTable = (PHELPTABLE)MAKELONG(VMM_HELP_TABLE, 0xFFFF);
   hini.hmodHelpTableModule = 0;
   hini.hmodAccelActionBarModule = 0;
   hini.idAccelTable = 0;
   hini.idActionBar = 0;

   if(!WinLoadString(hab,
                     0,
                     IDS_HELPWINDOWTITLE,
                     HELPLIBRARYNAMELEN,
                     (PSZ)szWindowTitle))
   {
       MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, "Error !",
                             MB_OK | MB_ERROR, TRUE);
       return;
   }
   hini.pszHelpWindowTitle = (PSZ)szWindowTitle;

                   /* If debugging, show panel ids, else don't */
#ifdef DEBUG
   hini.fShowPanelId = CMIC_SHOW_PANEL_ID;
#else
   hini.fShowPanelId = CMIC_HIDE_PANEL_ID;
#endif

   if(!WinLoadString(hab,
                     0,
                     IDS_HELPLIBRARYNAME,
                     HELPLIBRARYNAMELEN,
                     (PSZ)szLibName))
   {
       MessageBox(hwndMain, IDMSG_CANNOTLOADSTRING, "Error !",
                             MB_OK | MB_ERROR, TRUE);
       return;
   }
   hini.pszHelpLibraryName = (PSZ)szLibName;
                                     /* Creating help instance */
   hwndHelpInstance = WinCreateHelpInstance(hab, &hini);

   if(hwndHelpInstance == 0L || hini.ulReturnCode)
   {
       MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, "Error !",
                                    MB_OK | MB_ERROR, TRUE);
       return;
   }
                    /* Associate help instance with main frame */
   if(!WinAssociateHelpInstance(hwndHelpInstance, hwndMainFrame))
   {
       MessageBox(hwndMainFrame, IDMSG_HELPLOADERROR, "Error !",
                                 MB_OK | MB_ERROR, TRUE);
       return;
   }
/* Help manager is successfully initialized so set flag to TRUE */
   fHelpEnabled = TRUE;
   return;
}                                                 /* InitHelp() */

/****************************************************************\
 *  Processes the Help for Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpHelpForHelp(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Help for
 *           Help item of the Help menu
 *
 *  Usage:   Called from MainCommand when the Help for Help menu item
 *           is selected
 *
 *  Method:  Sends an HM_DISPLAY_HELP message to the help instance so
 *           that the default Help For Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpHelpForHelp(MPARAM mp2)
{
          /* This just displays the system help for help panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_DISPLAY_HELP,(MPARAM)0,(MPARAM)0))
           MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, "Error !",
                      MB_OK | MB_ERROR, TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.                                    */
   return;
}                                          /* HelpHelpForHelp() */

/****************************************************************\
 *  Processes the Extended Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpExtended(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Extended
 *           Help item of the Help menu.
 *
 *  Usage:   Called from MainCommand when the Extended Help menu item
 *           is selected.
 *
 *  Method:  Sends an HM_EXT_HELP message to the help instance so that
 *           the default Extended Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpExtended(MPARAM mp2)
{
          /* This just displays the system extended help panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_EXT_HELP,(MPARAM)0L,(MPARAM)0L))
           MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, "Error !",
                      MB_OK | MB_ERROR, TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.                                    */
   return;
}                                             /* HelpExtended() */

/****************************************************************\
 *  Processes the Keys Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpKeys(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Keys Help
 *           item of the Help menu.
 *
 *  Usage:   Called from MainCommand when the Keys Help menu item is
 *           selected
 *
 *  Method:  Sends an HM_KEYS_HELP message to the help instance so that
 *           the default Keys Help is displayed.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpKeys(MPARAM mp2)
{
               /* This just displays the system keys help panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_KEYS_HELP,(MPARAM)0L,(MPARAM)0L))
          MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, "Error !",
                      MB_OK | MB_ERROR, TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.                                    */
   return;
}                                                 /* HelpKeys() */

/****************************************************************\
 *  Processes the Index Help command from the menu bar
 *--------------------------------------------------------------
 *
 *  Name:    HelpIndex(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the Index Help
 *           item of the Help menu
 *
 *  Usage:   Called from MainCommand when the Index Help menu item
 *           is selected
 *
 *  Method:  Sends an HM_INDEX_HELP message to the help instance so
 *           that the default Index Help is displayed.
 *
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpIndex(MPARAM mp2)
{
             /* This just displays the system help index panel */
   if(fHelpEnabled)
     if((LONG)WinSendMsg(hwndHelpInstance,HM_HELP_INDEX,(MPARAM)0L,(MPARAM)0L))
           MessageBox(hwndMain, IDMSG_HELPDISPLAYERROR, "Error !",
                      MB_OK | MB_ERROR, TRUE);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.                                    */
   return;
}                                                /* HelpIndex() */

/****************************************************************\
 *  Processes the About command from the Help menu
 *--------------------------------------------------------------
 *
 *  Name:    HelpAbout(mp2)
 *
 *  Purpose: Processes the WM_COMMAND message posted by the About item
 *           of the Help menu
 *
 *  Usage:   Called from MainCommand when the About menu item is selected
 *
 *  Method:  Calls WinDlgBox to display the about box dialog.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID HelpAbout(MPARAM mp2)
{
                                /* Display the AboutBox dialog */
   WinDlgBox(HWND_DESKTOP,
                hwndMain,
                AboutDlgProc,
                (HMODULE)0,
                IDD_PRODUCTINFO,
                NULL);

   /* This routine currently doesn't use the mp2 parameter but     *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'*
   \*  warning at compile time.                                    */
   return;
}                                                /* HelpAbout() */

/****************************************************************\
 *  Displays the help panel indicated
 *--------------------------------------------------------------
 *
 *  Name:    DisplayHelpPanel(idPanel)
 *
 *  Purpose: Displays the help panel whose id is given
 *
 *  Usage:   Called whenever a help panel is desired to be displayed,
 *           usually from the WM_HELP processing of the dialog boxes
 *
 *  Method:  Sends HM_DISPLAY_HELP message to the help instance
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID DisplayHelpPanel(LONG idPanel)
{
   if(fHelpEnabled)
       if((LONG)WinSendMsg(hwndHelpInstance,
                     HM_DISPLAY_HELP,
                     MPFROMLONG(MAKELONG(idPanel, NULL)),
                     MPFROMSHORT(HM_RESOURCEID)))

           MessageBox(hwndMainFrame, IDMSG_HELPDISPLAYERROR, "Error !",
                      MB_OK | MB_ERROR, TRUE);
   return;
}                                         /* DisplayHelpPanel() */

/****************************************************************\
 *  Destroys the help instance
 *--------------------------------------------------------------
 *
 *  Name:    DestroyHelpInstance(VOID)
 *
 *  Purpose: Destroys the help instance for the application
 *
 *  Usage:   Called after exit from message loop
 *
 *  Method:  Calls WinDestroyHelpInstance() to destroy the help instance
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID DestroyHelpInstance(VOID)
{
   if(hwndHelpInstance != 0L)
   {
       WinDestroyHelpInstance(hwndHelpInstance);
   }
   return;
}                                      /* DestroyHelpInstance() */

/****************************************************************\
 *
 * Name:    AboutDlgProc(hwnd, msg, mp1, mp2)
 *
 * Purpose: Handles all the messages associated with the About dialog.
 *
 * Usage:   Called from HelpAbout() when about menu be selected.
 *
 * Returns:
 *
\****************************************************************/
MRESULT EXPENTRY AboutDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   MRESULT sRC;

   switch(msg)
   {
      case WM_INITDLG:
         FixSysMenu(hwnd);
         return (MRESULT)0L;

      case WM_COMMAND:
         WinDismissDlg(hwnd, TRUE);
         return (MRESULT)0L;

      default:
         sRC = WinDefDlgProc(hwnd, msg, mp1, mp2);
         return sRC;
   }
   return (MRESULT)0L;
}

/****************************************************************\
 * Name:    FixSysMenu()                                         *
 *                                                               *
 * Purpose: This routine removes the Restore, Size, Minimize, and*
 *          Maximize options from the system menu of a dialog.   *
 *                                                               *
 * Usage  : Called during the WM_INITDLG of a dialog procedure.  *
 *                                                               *
 * Returns: VOID                                                 *
 *                                                               *
\****************************************************************/
VOID FixSysMenu(HWND hwndDlg)
{
   HWND hwndMenu;                                   /* handle to system menu */

   hwndMenu = WinWindowFromID(hwndDlg, FID_SYSMENU);

   WinSendMsg(hwndMenu,               /* delete Restore from the system menu */
              MM_DELETEITEM,
              MPFROM2SHORT(SC_RESTORE, TRUE),
              MPFROMP(NULL));

   WinSendMsg(hwndMenu,                  /* delete Size from the system menu */
              MM_DELETEITEM,
              MPFROM2SHORT(SC_SIZE, TRUE),
              MPFROMP(NULL));

   WinSendMsg(hwndMenu,              /* delete Minimize from the system menu */
              MM_DELETEITEM,
              MPFROM2SHORT(SC_MINIMIZE, TRUE),
              MPFROMP(NULL));

   WinSendMsg(hwndMenu,              /* delete Maximize from the system menu */
              MM_DELETEITEM,
              MPFROM2SHORT(SC_MAXIMIZE, TRUE),
              MPFROMP(NULL));
   return;
}
/*static char *SCCSID = "@(#)vmm_init.c	6.12 92/02/18";*/
/*==============================================================*\
 *  VMM_INIT.C - routines for initialization and exit processing*
 *    (C) Copyright IBM Corporation 1992.                       *
 *--------------------------------------------------------------*
 *                                                              *
 *  This module contains the code for application initialization*
 *  as well as the code for exit list processing                *
 *                                                              *
 *--------------------------------------------------------------*
 *                                                              *
 *  This source file contains the following functions:          *
 *                                                              *
 *      Init() - initialization routines                        *
 *      ExitProc(usTermCode) - exit list processing procedure   *
 *      GPFHandler(parg) - GPFault and guard page excep handler *
 *                                                              *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs       *
\*--------------------------------------------------------------*/
#include "vmm.h"

/****************************************************************\
 *  Initialization routine                                      *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    Init()                                             *
 *                                                              *
 *  Purpose: Performs initialization functions required before  *
 *           the main window can be created.                    *
 *                                                              *
 *  Usage:   Called once before the main window is created.     *
 *                                                              *
 *  Method:  - installs the routine ExitProc into the           *
 *              DosExitList chain                               *
 *           - registers all window classes                     *
 *           - performs any command line processing             *
 *                                                              *
 *  Returns: TRUE - initialization is successful                *
 *           FALSE - initialization failed                      *
 *                                                              *
\****************************************************************/
BOOL Init(VOID)
{
    /* Add ExitProc to the exit list to handle the exit processing */
#ifndef VER630
    if(DosExitList(EXLST_ADD, ExitProc))
    {
        return FALSE;
    }
#endif

                       /* load application name from resource file */
    if(!WinLoadString(hab, (HMODULE)0, IDS_APPNAME, MAXAPPNAMELEN, szAppName))
        return FALSE;
    if(!WinLoadString(hab, 0, IDS_UNTITLED, MESSAGELEN, szUntitled))
        return FALSE;
                          /* register the main client window class */
    if(WinRegisterClass(hab,
                        (PSZ)szAppName,
                        (PFNWP)MainWndProc,
                        CS_SIZEREDRAW | CS_SYNCPAINT | CS_CLIPCHILDREN,
                        0) == 0)
        return FALSE;

    /* Turn off hard-error popup after GP-FAULT. No return codes
       checked as it is cosmetic and if it doesn't work the only side
       effect will be to have the default hard-error popup show up. */

    DosError(FERR_DISABLEEXCEPTION | FERR_DISABLEHARDERR);

    return TRUE;

}  /* Init() */

/****************************************************************\
 *  Exit list processing procedure                              *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    ExitProc(usTermCode)                               *
 *                                                              *
 *  Purpose: Cleans up certain resources when the application   *
 *           terminates                                         *
 *                                                              *
 *  Usage:   Routine is called by DosExitList when the          *
 *           application exits                                  *
 *                                                              *
 *  Method:  global resources, such as the main window and      *
 *           message queue, are destroyed and any system        *
 *           resources used are freed                           *
 *                                                              *
 *  Returns: Returns EXLST_EXIT to the DosExitList handler      *
 *                                                              *
\****************************************************************/
VOID APIENTRY ExitProc(ULONG usTermCode)
                                  /* code for the reason for termination */
{
   WinDestroyWindow(hwndMainFrame);
   /*--------------------------------------------------*\
    *      Any other system resources used             *
    *      (e.g. memory or files) should be freed here *
   \*--------------------------------------------------*/
   WinDestroyMsgQueue(hmq);

   WinTerminate(hab);

   DosExitList(EXLST_EXIT, (PFNEXITLIST)0L);    /* termination complete */

   /* This routine currently doesn't use the usTermCode parameter so *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'  *
   \*  warning at compile time                                       */
   return;
}                                                          /* ExitProc() */

/****************************************************************\
 *  Do nothing Guard Page Exception Handler                     *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    GPFHandler(PXCPT)                                  *
 *                                                              *
 *  Purpose: To notify user when a guard page entered exception *
 *           occurs                                             *
 *                                                              *
 *  Usage:   Routine is called when a guard page is accessed    *
 *                                                              *
 *  Method:  Whenever a guard page is accessed, a message       *
 *           box is put on the screen indicating this.          *
 *                                                              *
 *  Returns: Returns HANDLED if guard page exception,           *
 *           otherwise, returns NOT_HANDLED                     *
\****************************************************************/
ULONG GPFHandler(PEXCEPTIONREPORTRECORD parg)
{
    ULONG   flMemAttrs=0;
    ULONG   ulMemSize;
    CHAR    szText[MESSAGELEN];
    USHORT  usRet;

    /* Notify the user when they have accessed a guard page, and let
       the system default guard page handler handle the exception. */

    if(parg->ExceptionNum == XCPT_GUARD_PAGE_VIOLATION)
    {
        MessageBox(hwndMain, IDMSG_ACCESSGUARDPAGE, "Note !",
                        MB_MOVEABLE | MB_OK | MB_ICONASTERISK, FALSE);

        WinInvalidateRect(hwndMain,NULL,TRUE);

        return(XCPT_CONTINUE_EXECUTION);
    }
    if(parg->ExceptionNum == XCPT_ACCESS_VIOLATION)
    {
        if (parg->ExceptionInfo[1])
        {
            ulMemSize = 1L;
            DosQueryMem((PVOID)(parg->ExceptionInfo[1]),
                        &ulMemSize,&flMemAttrs);

            /* If the exception is due to accessing a page that has
               been allocated but not committed, then commit the page.
               Otherwise, GP Fault. */

            if (((flMemAttrs & PAG_FREE) || (flMemAttrs & PAG_COMMIT)) == 0)
            {
               WinLoadMessage(hab, (HMODULE)NULL, IDMSG_COMMITTTOWRITE,
                                    MESSAGELEN, (PSZ)szText);
               WinAlarm(HWND_DESKTOP, WA_ERROR);
               usRet = WinMessageBox(HWND_DESKTOP,
                                     hwndMain,
                                     szText,
                                     (PSZ)"Warning !",
                                     IDM_MSGBOX,
                                     MB_YESNO | MB_ICONASTERISK);
               switch(usRet)
               {
                  case MBID_YES:
                      if (DosSetMem((PVOID)(parg->ExceptionInfo[1]),
                                 1L,PAG_DEFAULT | PAG_COMMIT) != 0L)
                      {
                         DosExit(EXIT_PROCESS, RETURN_ERROR);
                         return(XCPT_CONTINUE_SEARCH);
                      }
                      else                        /* Commit successfully */
                         return(XCPT_CONTINUE_EXECUTION);

                  case MBID_NO:
                      DosExit(EXIT_PROCESS, RETURN_ERROR);
                      return(XCPT_CONTINUE_SEARCH);
               }
            }
        }
    /* At this point, we have a GP Fault. We cannot recover, so raise the
    terminate process exception and return (GP Fault) exception handled. */

        MessageBox(hwndMain, IDMSG_PROTECTIONERROR, "Error !",
                    MB_MOVEABLE | MB_OK | MB_ICONHAND, TRUE);

        DosExit(EXIT_PROCESS, RETURN_ERROR);
        return(XCPT_CONTINUE_SEARCH);
    }
 /* The exception is not one that we handle, so pass it on as NOT_HANDLED. */
    DosExit(EXIT_PROCESS, RETURN_ERROR);
    return(XCPT_CONTINUE_SEARCH);
}
/*static char *SCCSID = "@(#)vmm_main.c	6.19 92/02/18";*/
/*==============================================================*\
 *  VMM_MAIN.C - Sample PM application                          *
 *                                                              *
 *      (C) Copyright IBM Corporation 1992                      *
 *                                                              *
 *   DISCLAIMER OF WARRANTIES.  The following [enclosed] code is*
 *   sample code created by IBM Corporation. This sample code is*
 *   not part of any standard IBM product and is provided to you*
 *   solely forthe purpose of assisting you in the development  *
 *   of your applications.  The code is provided "AS IS",       *
 *   without warranty of any kind. No IBM shall be liable for   *
 *   any damages arising out of your use of the sample code,    *
 *   even if they have been advised of the possibility of       *
 *   such damages.                                              *
 *                                                              *
 *--------------------------------------------------------------*
 *                                                              *
 *  This application serves two distinct purposes. First, it    *
 *  demonstrates the standard menus and dialogs that most PM    *
 *  applications will contain.  The Demo menu calls dialog      *
 *  boxes that demonstrate all of the controls available for    *
 *  use in a dialog box.  There is also a dialog box which      *
 *  demonstrates the setting and removing of control            *
 *  Presentation Parameters.  Finally, the demo menu also has   *
 *  menu items that demonstrate the various types of message    *
 *  boxes that the system supports.                             *
 *                                                              *
 *  This application also serves as a template that can be      *
 *  easily modified by an application developer.  The source    *
 *  files are organized so that the overhead code that should   *
 *  be in all applications is located in the same files so      *
 *  that these files do not need to be modified.  The routines  *
 *  that deal with application specific code are also located   *
 *  in their own modules.  An application developer need only   *
 *  change these files in order to modify this template for     *
 *  his application.                                            *
 *                                                              *
 *--------------------------------------------------------------*
 *                                                              *
 *  This source file contains the following functions:          *
 *                                                              *
 *      main() - main routine                                   *
 *      MainWndProc(hwnd, msg, mp1, mp2) - main window procedure*
 *      MainCommand(mp1, mp2) - WM_COMMAND processing of Main   *
 *      MessageBox(hwnd nId, pszMsg, fsStyle, bBeep)            *
 *      DisplayPage(hps, pptl, ulPageIndex)                     *
 *      EnableMenuItem(hwnd, sMenuItem, fEnable)                *
 *                                                              *
\*==============================================================*/
/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs       *
\*--------------------------------------------------------------*/
#include "vmm.h"

/****************************************************************\
 *  Main routine                                                *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    main()                                             *
 *                                                              *
 *  Purpose: Initializes the PM environment, calls the          *
 *              initialization routine, creates the main        *
 *              window,  and polls the message queue            *
 *                                                              *
 *  Usage:                                                      *
 *                                                              *
 *  Method:  -obtains anchor block handle and creates message   *
 *              queue                                           *
 *           -calls the initialization routine                  *
 *           -creates the main frame window which creates the   *
 *              main client window                              *
 *           -polls the message queue via Get/Dispatch Msg loop *
 *           -upon exiting the loop, exits                      *
 *                                                              *
 *  Returns: 1 - if sucessful execution completed               *
 *           0 - if error                                       *
\****************************************************************/
INT  main(VOID)
{
    QMSG qmsg;                                      /* message structure */
    ULONG ctlData;                                 /* frame control data */
    EXCEPTIONREGISTRATIONRECORD ExceptionStruct;

    ulFreePage = 0L;
    strcpy(szWindowText,"VMM Sample");
    hab = WinInitialize(0);
    if(!hab)
    {
        DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
        DosExit(EXIT_PROCESS, RETURN_ERROR);
    }
                                             /* find a define for this v */
    hmq = WinCreateMsgQueue(hab, 0);
    if(!hmq)
    {
        DosBeep(BEEP_WARN_FREQ, BEEP_WARN_DUR);
        WinTerminate(hab);
        DosExit(EXIT_PROCESS, RETURN_ERROR);
    }
    if(!Init())
    {
        MessageBox(HWND_DESKTOP, IDMSG_INITFAILED, "Error !",
                            MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
        DosExit(EXIT_PROCESS, RETURN_ERROR);
    }
                                               /* create the main window */
    ctlData = FCF_STANDARD | FCF_VERTSCROLL;
    hwndMainFrame = WinCreateStdWindow(HWND_DESKTOP,
                                       WS_VISIBLE,
                                       (PVOID)&ctlData,
                                       (PSZ)szAppName,
                                       (PSZ)NULL,
                                       WS_VISIBLE,
                                       (HMODULE)NULL,
                                       IDR_RESOURCE,
                                       (PHWND)&hwndMain);
    if(!hwndMainFrame)
    {
        MessageBox(HWND_DESKTOP, IDMSG_MAINWINCREATEFAILED, "Error !",
                            MB_OK | MB_ERROR | MB_MOVEABLE, TRUE);
        DosExit(EXIT_PROCESS, RETURN_ERROR);
    }
   InitHelp();
                         /* Invoke exception management, and direction user
                             exception handling function to GPFHandler() */
   ExceptionStruct.ExceptionHandler = (_ERR *)&GPFHandler;
   DosSetExceptionHandler(&ExceptionStruct) ;

                                            /* Get/Dispatch Message loop */
   while(WinGetMsg(hab, (PQMSG)&qmsg, 0L, 0L, 0L))
       WinDispatchMsg(hab, (PQMSG)&qmsg);

                                        /* Release exception managerment */
   DosUnsetExceptionHandler(&ExceptionStruct) ;

   DestroyHelpInstance();                   /* destroy the help instance */
#ifdef VER630
                                     /* will normally be put in ExitProc */
    WinDestroyWindow(hwndMainFrame);

    /*--------------------------------------------------*\
     *      Any other system resources used             *
     *      (e.g. memory or files) should be freed here *
    \*--------------------------------------------------*/
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);

#endif

    DosExit(EXIT_PROCESS, RETURN_SUCCESS);
    return 0L;
}                                                              /* main() */

/****************************************************************\
 *  Main client window procedure                                *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    MainWndProc(hwnd, msg, mp1, mp2)                   *
 *                                                              *
 *  Purpose: Processes the messages sent to the main client     *
 *           window. This routine processes the basic messages  *
 *           all client windows should process and passes all   *
 *           others onto UserWndProc where the developer can    *
 *           process any others.                                *
 *                                                              *
 *  Usage:   Called for each message placed in the main         *
 *           window's message queue                             *
 *                                                              *
 *  Method:  a switch statement branches to the routines to be  *
 *           performed for each message processed. Any messages *
 *           not specifically process are passed to the user's  *
 *           message processing procedure UserWndProc().        *
 *                                                              *
 *  Returns: Return values are determined by each message       *
 *                                                              *
\****************************************************************/
MRESULT EXPENTRY MainWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   static LONG sVscrollMax;
   MRESULT sRC;

   switch(msg)
   {
       case WM_CREATE:

           sVscrollMax =  MAXPAGES*(BOX_HEIGHT+VERT_SPACING);

           hwndVscroll = WinWindowFromID(
                              WinQueryWindow(hwnd, QW_PARENT),
                              FID_VERTSCROLL);
           WinSendMsg(hwndVscroll, SBM_SETSCROLLBAR,
                                  MPFROM2SHORT(sVscrollPos, 0),
                                  MPFROM2SHORT(0, sVscrollMax) );
           break;

       case WM_VSCROLL:
           switch (SHORT2FROMMP(mp2))
           {
               case SB_LINEUP:
                   sVscrollPos -= SMALL_BOX_HEIGHT;
                   break;

               case SB_LINEDOWN:
                   sVscrollPos += SMALL_BOX_HEIGHT;
                   break;

               case SB_PAGEUP:
                   sVscrollPos -= BOX_HEIGHT+VERT_SPACING;
                   break;

               case SB_PAGEDOWN:
                   sVscrollPos += BOX_HEIGHT+VERT_SPACING;
                   break;

               case SB_SLIDERTRACK:
               case SB_SLIDERPOSITION:
                   sVscrollPos = SHORT1FROMMP(mp2);
                   break;
           }
           sVscrollPos = max(0, min(sVscrollPos, sVscrollMax) );

           if(sVscrollPos != SHORT1FROMMR(WinSendMsg(hwndVscroll,
                                     SBM_QUERYPOS, (MPARAM)NULL, (MPARAM)NULL)))
           {
              WinSendMsg(hwndVscroll, SBM_SETPOS,
                               MPFROMSHORT(sVscrollPos), NULL);
              WinInvalidateRect(hwnd, NULL, FALSE);
           }
           break;

       case WM_CHAR:
           switch (SHORT2FROMMP(mp2))
           {
               case VK_LEFT:
               case VK_UP:
                   sVscrollPos -= SMALL_BOX_HEIGHT;
                   break;

               case VK_DOWN:
               case VK_RIGHT:
                   sVscrollPos += SMALL_BOX_HEIGHT;
                   break;

               case VK_PAGEUP:
                   sVscrollPos -= BOX_HEIGHT+VERT_SPACING;
                   break;

               case VK_PAGEDOWN:
                   sVscrollPos += BOX_HEIGHT+VERT_SPACING;
                   break;
           }
           sVscrollPos = max(0, min(sVscrollPos, sVscrollMax) );

           if(sVscrollPos != SHORT1FROMMR(WinSendMsg(hwndVscroll,
                                     SBM_QUERYPOS, (MPARAM)NULL, (MPARAM)NULL)))
           {
              WinSendMsg(hwndVscroll, SBM_SETPOS,
                               MPFROMSHORT(sVscrollPos), NULL);
              WinInvalidateRect(hwnd, NULL, FALSE);
           }
           break;

       case WM_PAINT:
           MainPaint(hwnd);
           break;

       case WM_COMMAND:
           MainCommand(mp1, mp2);
           break;

   /*--------------------------------------------------*\
    *      Any messages not processed are passed on    *
    *      to the user's window proc.  It is           *
    *      responsible for passing any messages it     *
    *      doesn't handle onto WinDefWindowProc()      *
   \*--------------------------------------------------*/
       case HM_QUERY_KEYS_HELP:
           return ((MRESULT)PANEL_KEYSHELP);

       default:
           sRC = WinDefWindowProc(hwnd, msg, mp1, mp2);
           return sRC;
   }
   return ((MRESULT)0L);  /* window procedures should return 0 as a default */
}                                                        /* MainWndProc() */

/****************************************************************\
 *  Main client painting routine                                *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    MainPaint(hwnd)                                    *
 *                                                              *
 *  Purpose: Paints the main client window.                     *
 *                                                              *
 *  Usage:   Routine is called whenver the client window        *
 *           procedure receives a WM_PAINT message              *
 *                                                              *
 *  Method:  -begins painting by calling WinBeginPaint          *
 *              and retriving the HPS for the window            *
 *           -paint page info boxes                             *
 *                                                              *
 *           -ends painting by calling WinEndPaint              *
 *                                                              *
 *  Returns: VOID                                               *
 *                                                              *
\****************************************************************/
VOID MainPaint(HWND hwnd)
{
    HPS    hps;
    USHORT i;
    POINTL ptl;
    RECTL  rect;
    SIZEL  sizl;
    char   szBuff[BUFF_SIZE];

    sizl.cx = 0L;
    sizl.cy = 0L;

    hps = WinBeginPaint(hwnd, 0L, 0L);
    GpiSetPS(hps, &sizl, PU_LOMETRIC);

    WinQueryWindowRect(hwnd, &rect);
    WinFillRect(hps, (PRECTL)&rect, CLR_BACKGROUND);

    /* convert the coords of the window to world coords */
    GpiConvert(hps, CVTC_DEVICE, CVTC_WORLD, 2L, (PPOINTL) &rect);

    ptl.x = HORZ_INDENT*3;
    ptl.y = rect.yTop - (BOX_HEIGHT+VERT_SPACING) + sVscrollPos;
    GpiMove(hps, &ptl);

    ptl.x += BOX_WIDTH;
    ptl.y += BOX_HEIGHT;
    GpiSetColor(hps, CLR_GREEN);
    GpiBox(hps, DRO_OUTLINE, &ptl, 0L, 0L);

    ptl.x = HORZ_INDENT*3 + HORZ_SPACING*3 + BOX_WIDTH;
    ptl.y = rect.yTop - (BOX_HEIGHT+VERT_SPACING) + sVscrollPos;
    GpiMove(hps, &ptl);

    ptl.x += BOX_WIDTH;
    ptl.y += BOX_HEIGHT;
    GpiSetColor(hps, CLR_RED);
    GpiBox(hps, DRO_OUTLINE, &ptl, 0L, 0L);

    GpiSetColor(hps, CLR_BLACK);

    ptl.x = HORZ_INDENT*3+30;
    ptl.y = rect.yTop - (VERT_SPACING+SMALL_BOX_HEIGHT) + 30 + sVscrollPos;
    strcpy(szBuff,"Committed");
    GpiCharStringAt(hps, &ptl, (LONG) strlen(szBuff), szBuff);

    ptl.y -= SMALL_BOX_HEIGHT;
    strcpy(szBuff,"page");
    GpiCharStringAt(hps, &ptl, (LONG) strlen(szBuff), szBuff);


    ptl.x = HORZ_INDENT*3+30 + HORZ_SPACING*3 + BOX_WIDTH ;
    ptl.y = rect.yTop - (VERT_SPACING+SMALL_BOX_HEIGHT) + 30 + sVscrollPos;
    strcpy(szBuff,"Non-Committed");
    GpiCharStringAt(hps, &ptl, (LONG) strlen(szBuff), szBuff);

    ptl.y -= SMALL_BOX_HEIGHT;
    strcpy(szBuff,"page");
    GpiCharStringAt(hps, &ptl, (LONG) strlen(szBuff), szBuff);

    ptl.x = HORZ_INDENT;                           /* 1'st page location */
    ptl.y = rect.yTop - 2*(BOX_HEIGHT+VERT_SPACING) + sVscrollPos;

    for (i=0;((ULONG) i)<ulFreePage; i++)
    {
        DisplayPage(hps, &ptl, i);             /* Redisplay alloc status */
        ptl.x += BOX_WIDTH+HORZ_SPACING;

        if (ptl.x+BOX_WIDTH > rect.xRight)
        {                 /* If next page over window, move to next line */
           ptl.x = HORZ_INDENT+BOX_WIDTH+HORZ_SPACING;
           ptl.y -= (BOX_HEIGHT+VERT_SPACING);
        }
    /* If the next page is a base page, display it on a new line for clarity */

        if (apgentry[i+1].fBaseAddr)
        {
            ptl.x = HORZ_INDENT;
            ptl.y -= (BOX_HEIGHT+VERT_SPACING);
        }
    }
    WinEndPaint(hps);
    return;
}                                                   /* MainPaint() */

/****************************************************************\
 *  Main window WM_COMMAND processing procedure                 *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:   MainCommand(mp1, mp2)                               *
 *                                                              *
 *  Purpose:Calls the appropriate procedures that deal with     *
 *           the selected menu item.                            *
 *                                                              *
 *  Usage:  Routine is called whenever a WM_COMMAND message     *
 *          is posted to the main window.                       *
 *                                                              *
 *  Method: a switch statement branches on the id of the        *
 *          menu item that posted the message and the           *
 *          appropriate action for that item is taken.  Any     *
 *          menu ids that are not part of the standard menu     *
 *          set are passed onto the user defined WM_COMMAND     *
 *          processing procedure.                               *
 *                                                              *
 *  Returns:                                                    *
 *                                                              *
\****************************************************************/
VOID MainCommand(MPARAM mp1, MPARAM mp2)
{
    switch(SHORT1FROMMP(mp1))
    {
        case IDM_GENERALHELP:
           HelpExtended(mp2);
           return;

        case IDM_USINGHELP:
           HelpHelpForHelp(mp2);
           return;

        case IDM_TUTORIAL:
           HelpKeys(mp2);
           return;

        case IDM_HELPINDEX:
           HelpIndex(mp2);
           return;

        case IDM_HELPPRODUCTINFO:
           HelpAbout(mp2);
           return;

    /*--------------------------------------------------*\
     *      User command processing routine is called   *
     *      here so any ids not procecessed here can be *
     *      processed                                   *
    \*--------------------------------------------------*/
        default:
            UserCommand(mp1, mp2);
            break;
    }
    return;
}                                                /* MainCommand() */

/****************************************************************\
 *  Exit routine                                                *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    DisplayPage(hps, pptl, ulPageIndex)                *
 *                                                              *
 *  Purpose: Processes the VMM menu's Exit item.                *
 *                                                              *
 *  Usage:   called whenever Exit from the VMM menu is          *
 *           selected                                           *
 *                                                              *
 *  Method:  Routine posts a WM_CLOSE message to the main       *
 *           application window.                                *
 *                                                              *
 *  Returns: VOID                                               *
 *                                                              *
\****************************************************************/
VOID DisplayPage(HPS hps, PPOINTL pptl, ULONG ulPageIndex)
{
    POINTL ptl;
    MATRIXLF matrix;
    ULONG ulAccess=0;
    ULONG ulRegionSize;
    PVOID pMem;
    char szBuff[BUFF_SIZE];

    pMem = apgentry[ulPageIndex].pvAddress;

    /* We don't check the return code here since we assume that the array
       contains good addresses since we verified them when we put them in
       the array.  */                     /* Get memory size & attributes */
    DosQueryMem(pMem, &ulRegionSize, &ulAccess);

    matrix.fxM11 = MAKEFIXED(1,0);
    matrix.fxM12 = 0L;
    matrix.lM13  = 0L;
    matrix.fxM21 = 0L;
    matrix.fxM22 = MAKEFIXED(1,0);
    matrix.lM23  = 0L;
    matrix.lM31  = pptl->x;                             /* x translation */
    matrix.lM32  = pptl->y;                             /* y translation */
    matrix.lM33  = 1L;

    GpiSetDefaultViewMatrix(hps, 9L, &matrix,TRANSFORM_REPLACE);

    ptl.x = 0L;
    ptl.y = 0L;
    GpiMove(hps, &ptl);

    ptl.x = BOX_WIDTH;
    ptl.y = BOX_HEIGHT;

    /* set outline color to CLR_RED for uncommitted, CLR_GREEN for committed */
    if (ulAccess & PAG_COMMIT)
    {
        GpiSetColor(hps, CLR_GREEN);
    }
    else
        GpiSetColor(hps, CLR_RED);

    GpiBox(hps, DRO_OUTLINE, &ptl, 0L, 0L);

    /* should query sys values in case the default is not black ? */
    GpiSetColor(hps, CLR_BLACK);

    szBuff[0]='\000';
    if (ulAccess & PAG_READ)
        strcat(szBuff, "R");

    if (ulAccess & PAG_WRITE)
        strcat(szBuff, "W");

    if (ulAccess & PAG_EXECUTE)
        strcat(szBuff, "E");

    if (ulAccess & PAG_GUARD)
        strcat(szBuff, "G");

    if (ulAccess & PAG_DEFAULT)
        strcat(szBuff, "Def");

    if (ulAccess & PAG_BASE)
        strcat(szBuff, "Base");

    ptl.x = HORZ_INDENT;
    ptl.y = VERT_INDENT;
    GpiCharStringAt(hps, &ptl, (LONG) strlen(szBuff), szBuff);

    ptl.x = 0;
    ptl.y = SMALL_BOX_HEIGHT;

    GpiMove(hps, &ptl);

    ptl.x = BOX_WIDTH;
    ptl.y = SMALL_BOX_HEIGHT;
    GpiLine(hps, &ptl);

    /* Get base address of current page */
    sprintf(szBuff, "0x%p", pMem);

    ptl.x = HORZ_INDENT;
    ptl.y = SMALL_BOX_HEIGHT+VERT_INDENT;
    GpiCharStringAt(hps, &ptl, (LONG) strlen(szBuff), szBuff);
    return;
}

/****************************************************************\
 *  Message Box procedure                                       *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    MessageBox(hwndOwner, nIdMsg,pszMsg,fsStyle, bBeep)*
 *                                                              *
 *  Purpose: Displays the warning message box with the message  *
 *              given in nIdMsg retrived from the message table *
 *                                                              *
 *  Usage:   Called whever an error occurs and a message wishes *
 *           to be displayed to the user                        *
 *                                                              *
 *  Method:  - Message string is loaded from the process'       *
 *              message table                                   *
 *           - Alarm beep is sounded if desired                 *
 *           - Message box with the message is displayed        *
 *                                                              *
 *  Returns:                                                    *
 *                                                              *
\****************************************************************/
VOID MessageBox(HWND hwndOwner, LONG nIdMsg, PSZ pszMsg, LONG fsStyle,
                     BOOL bBeep)
{
    CHAR szText[MESSAGELEN];

    if(!WinLoadMessage(hab, (HMODULE)NULL, nIdMsg, MESSAGELEN, (PSZ)szText))
    {
        WinAlarm(HWND_DESKTOP, WA_ERROR);
        return;
    }
    if(bBeep)
        WinAlarm(HWND_DESKTOP, WA_ERROR);

    WinMessageBox(HWND_DESKTOP,
                  hwndOwner,
                  szText,
                  (PSZ)pszMsg,
                  IDM_MSGBOX,
                  fsStyle);
    return;
}                                                   /* MessageBox() */

/****************************************************************\
 *  EnableMenuItem procedure                                    *
 *--------------------------------------------------------------*
 *                                                              *
 * Name:    EnableMenuItem(hwnd, sMenuItem, fEnable)            *
 *                                                              *
 * Purpose: This routine handles enabling/disabling of menu     *
 *          items. This is done by getting Parent and Menu hwnd *
 *          handles then sending the appropriate message.       *                     *
 *                                                              *
 * Usage:   Routine is called when enable or disable one item   *
 *          from menu.                                          *
 *                                                              *
 * Method:                                                      *
 *                                                              *
 * Returns: VOID                                                *
 *                                                              *
\****************************************************************/
VOID EnableMenuItem(HWND hwnd, LONG sMenuItem, BOOL fEnable)
{
   HWND hwndParent = WinQueryWindow(hwnd, QW_PARENT);
   HWND hwndMenu   = WinWindowFromID(hwndParent,FID_MENU);

   WinSendMsg(hwndMenu, MM_SETITEMATTR,
              MPFROM2SHORT(sMenuItem, TRUE),
              MPFROM2SHORT(MIA_DISABLED, fEnable ? 0 : MIA_DISABLED));
   return;
}
/*static char *SCCSID = "@(#)vmm_user.c	6.11 92/02/19";*/
/*==================================================================*\
 *  VMM_USER.C - routines for handling messages not processed       *
 *              by the standard message processing routine          *
 *      (C) Copyright IBM Corporation 1992                          *
 *------------------------------------------------------------------*
 *                                                                  *
 *  This module contains the code for processing messages sent      *
 *  to the standard window that the standard window does not        *
 *  process.  The application developer need only modify this       *
 *  file in order to implement new menu items or process            *
 *  messages not handled by the standard message routine.           *
 *                                                                  *
 *  This module also contains some routines that demonstate the     *
 *  various dialog box controls and message box types that can      *
 *  be used.  The sample code should be deleted when this           *
 *  module is modified for an application.  The demonstration       *
 *  code is identified by comments.                                 *
 *                                                                  *
 *------------------------------------------------------------------*
 *                                                                  *
 *  This source file contains the following functions:              *
 *                                                                  *
 *      UserCommand(mp1, mp2) - user WM_COMMAND processor           *
 *      VMM_Error(pszFunction, ulErrorCode) - Error processing      *
 *      CleanUpArray(pvAddress) - Page table maintenance            *
 *      StoreInArray(pvAddress, ulNumPages) - Page table maintenance*
 *                                                                  *
\*==================================================================*/
/*------------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs           *
\*------------------------------------------------------------------*/
#include "vmm.h"

/*--------------------------------------------------------------*\
 *  Global variables                                            *
\*--------------------------------------------------------------*/
MSGENTRY    amsgentry[] =
    {
        { ERROR_INVALID_PARAMETER,
          "%s\n\nInvalid Parameter",
          MB_ICONASTERISK
        },

        { ERROR_ACCESS_DENIED,
          "%s\n\nAccess to Memory Denied",
          MB_ICONASTERISK
        },

        { ERROR_NOT_ENOUGH_MEMORY,
          "%s\n\nInsufficient Memory",
          MB_ICONASTERISK
        },

        { ERROR_INVALID_ACCESS,
          "%s\n\nAn Invalid access to memory was"
          " attempted.",
          MB_ICONASTERISK
        },

        { ERROR_INVALID_ADDRESS,
          "%s\n\nAddress Given is Invalid.",
          MB_ICONASTERISK
        },

        { ERROR_INTERRUPT,
          "%s\n\nThe call was interrupted by an external"
          " event and was not completed. Please retry the"
          " operation.",
          MB_ICONASTERISK
        },

    /* Errors following are application defined */

        { VMERR_MAX_ALLOCATED,
          "%s\n\nThe allocation has surpassed"
          " this application's maximum number of displayable"
          " pages of %u. Each page contains 4096 bytes"
          " of data.",
          MB_ICONASTERISK
        },

        { VMERR_ZERO_ALLOCATED,
          "%s\n\nA minimum of 1 byte must be specified for"
          " an allocation.",
          MB_ICONASTERISK
        },

        { VMERR_TILE_ONLY,
          "%s\n\nAllocation attempted with"
          " tiled attribute and no access"
          " protection specifed. Access protection required to"
          " properly allocate memory.",
          MB_ICONASTERISK
        },

        { VMERR_COMMIT_AND_TILE_ONLY,
          "%s\n\nAllocation attempted with no access"
          " protection specified. Access protection required to"
          " properly allocate memory.",
          MB_ICONASTERISK
        },

        { VMERR_ALREADY_FREED,
          "%s\n\nThe memory address specified to be"
          " freed has not been allocated. Only previously"
          " allocated memory may be freed.",
          MB_ICONASTERISK
        },

        { VMERR_NOT_BASEPAGE,
          "%s\n\nThe memory address specified to be"
          " freed is not a base-page address. Only"
          " base pages"
          " may be freed.",
          MB_ICONASTERISK
        },

        { VMERR_DECOMMIT_RESERVED,
          "%s\n\nThe memory specified to be"
          " decommitted is in a reserved"
          " state. Memory must"
          " be committed before it can be decommitted.",
          MB_ICONASTERISK
        },

        { VMERR_ACCESS_ON_RESERVED,
          "%s\n\nAccess protection specified for"
          " reserved memory. Access protection may "
          " only be specified for committed memory.",
          MB_ICONASTERISK
        },

        { VMERR_ACCESS_AND_DECOMMIT,
          "%s\n\nAccess protection specified when"
          " attempting to decommit memory. No access protection"
          " may be specified when decommitting memory.",
          MB_ICONASTERISK
        },

        { VMERR_COMMIT_ON_COMMITTED,
          "%s\n\nCommit Memory specified for"
          " previously"
          " committed memory. Choose \"Default\" or \""
          "Decommit\" for committed memory.",
          MB_ICONASTERISK
        },

        { VMERR_COMMIT_ONLY,
          "%s\n\nCommit Memory specified with"
          " no access"
          " protection specifed. Access protection required when"
          " committing memory.",
          MB_ICONASTERISK
        },

        { VMERR_SET_NO_PARMS,
          "%s\n\nNo parameters specified. Parameters"
          " must be specified when using %s.",
          MB_ICONASTERISK
        },

        { VMERR_SET_ZERO_SIZE,
          "%s\n\nSetting allocation attributes and/or access protection"
          " on zero bytes is not permitted."
          " A minimum size of one byte must be specified to set"
          " allocation attributes and/or access protection on memory.",
          MB_ICONASTERISK
        },

        { VMERR_SET_ON_FREE,
          "%s\n\nSetting allocation attributes and/or access protection"
          " on non-allocated memory is not"
          " permitted. Memory must be allocated before allocation attributes"
          " or access protection may be specified for it.",
          MB_ICONASTERISK
        },

        { VMERR_DEFAULT,
          "%s\n\n Error #%u occured during the call.",
          MB_ICONASTERISK
        }
    };

/****************************************************************\
 *  DOS API and Application Specific Error reporting routine    *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    VMM_Error(pszFunction, ulErrorCode)                *
 *                                                              *
 *  Purpose: Display errors returned by system calls to         *
 *           the user when they occur. All other error handling *
 *           is done inside the functions themselves            *
 *                                                              *
 *  Usage:   Routine is called for each error that the dialog   *
 *           functions do not process                           *
 *                                                              *
 *  Method:  A switch statement branches control based upon     *
 *           the error number passed. Any message that comes    *
 *           in that is not known is given a generic message.   *
 *           The message is displayed with WinMessageBox        *
 *                                                              *
 *  Returns: VOID                                               *
 *                                                              *
\****************************************************************/
VOID VMM_Error(PSZ pszFunction, ULONG ulErrorCode)
{
    CHAR    szTempBuf[BUFF_SIZE];
    ULONG   ulMsgIndex;

    ulMsgIndex = 0L;
                                                 /* Serach error message */
    while((amsgentry[ulMsgIndex].ulMsgNum != ulErrorCode) &&
          (amsgentry[ulMsgIndex].ulMsgNum != VMERR_DEFAULT))
        ulMsgIndex++;

    strcpy(szTempBuf,amsgentry[ulMsgIndex].szMsgText);

    if (amsgentry[ulMsgIndex].ulMsgNum == VMERR_DEFAULT)
    {
        sprintf(szBuffer,szTempBuf,pszFunction,ulErrorCode);
    }
    else if (amsgentry[ulMsgIndex].ulMsgNum == VMERR_MAX_ALLOCATED)
    {
        sprintf(szBuffer,szTempBuf,pszFunction,MAXPAGES);
    }
    else if (amsgentry[ulMsgIndex].ulMsgNum == VMERR_SET_NO_PARMS)
    {
        sprintf(szBuffer,szTempBuf,pszFunction,pszFunction);
    }
    else
    {
        sprintf(szBuffer,szTempBuf,pszFunction);
    }
    WinAlarm(HWND_DESKTOP, WA_ERROR);
    WinMessageBox(HWND_DESKTOP,
                  hwndMain,
                  szBuffer,
                  szAppName,
                  0,
                  MB_OK | MB_MOVEABLE | amsgentry[ulMsgIndex].usMsgIcon);
    return;
}

/****************************************************************\
 *  Procedure to remove freed pages from array                  *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    CleanUpArray(pvAddress)                            *
 *                                                              *
 *  Purpose: Remove pages that the user indicated from the      *
 *           array of pages stored                              *
 *                                                              *
 *  Usage:   Routine is called after each successful free       *
 *           memory call issued by the user                     *
 *                                                              *
 *  Method:  Pages are removed by finding the address in the    *
 *           array that matches what the user input, and then   *
 *           removing all subsequent pages until another base   *
 *           page is found or the last stored page is reached   *
 *                                                              *
 *  Returns: VOID                                               *
 *                                                              *
\****************************************************************/
VOID CleanUpArray(PVOID pvAddress)
{
    ULONG   ulIndexLow;
    ULONG   ulIndexHigh;

    /* At entry, we know that the pvAddress page is a base page and we
       need to free up the pages associated with the base page for the
       object. To do this, we find the next base address. We then make
       the copies. */

    ulIndexLow = 0;
                                            /* Look for the pointed page */
    while((apgentry[ulIndexLow].pvAddress != pvAddress) &&
          (ulIndexLow < ulFreePage))
        ulIndexLow++;

    if (ulIndexLow < ulFreePage)
    {
        apgentry[ulIndexLow].fBaseAddr = FALSE;
        ulIndexHigh = ulIndexLow + 1;
                                          /* Look for the next base page */
        while((apgentry[ulIndexHigh].fBaseAddr == FALSE) &&
              (ulIndexHigh < ulFreePage))
            ulIndexHigh++;

        while(ulIndexHigh < ulFreePage)
            apgentry[ulIndexLow++] = apgentry[ulIndexHigh++];

        ulFreePage -= (ulIndexHigh-ulIndexLow);/* Reset the starting page */
        MessageBox(HWND_DESKTOP, IDMSG_SUCCESSFREE, "Note !",  MB_OK, FALSE);
    }
              /* If DosFreeMem worked but the address is not in our page
              array, then don't modify the array or the ulFreePage count. */

    if (!ulFreePage)         /* No memory is allocated */
    {
       EnableMenuItem(hwndMain,IDM_VMMFREE,FALSE);
       EnableMenuItem(hwndMain,IDM_VMMSET,FALSE);
       EnableMenuItem(hwndMain,IDM_VMMWRITE,FALSE);
       EnableMenuItem(hwndMain,IDM_VMMREAD,FALSE);
    }
    return;
}

/****************************************************************\
 *  Procedure to store allocated pages in array                 *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:    StoreInArray(pvAddress,ulNumPages)                 *
 *                                                              *
 *  Purpose: Store pages that were just successfully allocated  *
 *           in our array so we can track them                  *
 *                                                              *
 *  Usage:   Routine is called after each successful allocation *
 *           of memory by the user                              *
 *                                                              *
 *  Method:  The pages are added to the end of the array based  *
 *           upon the current status of our global end of array *
 *           index variable (ulFreePage)                        *
 *                                                              *
 *  Returns: VOID                                               *
 *                                                              *
\****************************************************************/
VOID StoreInArray(PVOID pvAddress, ULONG ulNumPages )
{
    ULONG   temp;

    /* Set all base indicators for the new pages to FALSE, and set the
       addresses for the pages. */

    for(temp = 0L; temp < ulNumPages; temp++)
    {
        apgentry[temp+ulFreePage].pvAddress = (PVOID)((ULONG)pvAddress +
                                              (PAGESIZE * temp));
        apgentry[temp+ulFreePage].fBaseAddr = FALSE;
    }
    /* Set the base indicator of the first page in the object to be
       TRUE */
    apgentry[ulFreePage].fBaseAddr = TRUE;
    ulFreePage += ulNumPages;       /* Move to new starting of free page */

    EnableMenuItem(hwndMain,IDM_VMMFREE,TRUE);
    EnableMenuItem(hwndMain,IDM_VMMSET,TRUE);
    EnableMenuItem(hwndMain,IDM_VMMWRITE,TRUE);
    EnableMenuItem(hwndMain,IDM_VMMREAD,TRUE);
    return;
}

/****************************************************************\
 *  Non-standard menu item command processing procedure         *
 *--------------------------------------------------------------*
 *                                                              *
 *  Name:   UserCommand(mp1, mp2)                               *
 *                                                              *
 *  Purpose: Process any WM_COMMAND messages send to hwndMain   *
 *              that are not processed by MainCommand           *
 *                                                              *
 *  Usage:  Routine is called for each WM_COMMAND that is       *
 *          not posted by a standard menu item                  *
 *                                                              *
 *  Method: A switch statement branches control based upon      *
 *          the id of the control which posted the message      *
 *                                                              *
 *  Returns:                                                    *
\****************************************************************/
VOID UserCommand(MPARAM mp1, MPARAM mp2)
{
   PVOID   pvMemAddress=0L;

   ULONG   ulTempRegionSize;
   ULONG   flTempAttributes=0L;

   ULONG   ulPages;                /* Number of pages requested by user */
   ULONG   rc;                      /* Return Code variable from calls  */
   ULONG   rc2;         /* Return Code variable for investigative calls */

   switch(SHORT1FROMMP(mp1))
   {
   /*--------------------------------------------------------------*\
    *  Add case statements for menuitem ids you wish to process    *
   \*--------------------------------------------------------------*/
      case IDM_VMMALLOC:
          ObjAlloc.ulSize = 4;         /* Default size 4 k to allocate */
          ObjAlloc.ulAttr =                          /* Default attrib */
                    PAG_READ | PAG_WRITE | PAG_EXECUTE;
          ObjAlloc.pvAddress = '\000';

          if(WinDlgBox(HWND_DESKTOP,
                       hwndMain,
                       (PFNWP) AllocMemDlgProc,
                       (HMODULE)0,
                       (ULONG) IDD_ALLOCMEM,
                       (PVOID) &ObjAlloc) )
          {
                          /* Figure out the number of pages requested. */
              ulPages = (ObjAlloc.ulSize / PAGESIZE);
              if ((ObjAlloc.ulSize % PAGESIZE) != 0L)
                  ulPages++;                          /* One more page */

              /* If the number of pages requested is zero (zero
                 bytes specified), or the number of pages is greater
                 than the number left in the array, report the error
                 condition. Otherwise, make the DosAllocMem call and
                 set any error condition returned by the call. */

              if (ulPages == 0L)
              {
                  rc = VMERR_ZERO_ALLOCATED;
              }
              else if (ulPages + ulFreePage > MAXPAGES + 1)
              {
                  rc = VMERR_MAX_ALLOCATED;
              }
              else
              {
                  rc = DosAllocMem(&pvMemAddress,
                                   ObjAlloc.ulSize,
                                   ObjAlloc.ulAttr);
              }
              /* If an error has occured, display it. Otherwise,
                 process the request. */

              if (rc != 0L)
              {
                  if (ObjAlloc.ulAttr == 0L)
                  {
                      rc = VMERR_SET_NO_PARMS;
                  }
                  else if (ObjAlloc.ulAttr == PAG_COMMIT)
                  {
                      rc = VMERR_COMMIT_ONLY;
                  }
                  else if (ObjAlloc.ulAttr == (PAG_COMMIT | OBJ_TILE))
                  {
                      rc = VMERR_COMMIT_AND_TILE_ONLY;
                  }
                  else if (ObjAlloc.ulAttr == OBJ_TILE)
                  {
                      rc = VMERR_TILE_ONLY;
                  }
                  VMM_Error("DosAllocMem()",rc);
              }
              else
              {
                  StoreInArray(pvMemAddress,ulPages);
                  WinInvalidateRect(hwndMain, NULL, TRUE);
              }
          }
          break;

      case IDM_VMMFREE:

          ObjAlloc.pvAddress = '\000';
          if (WinDlgBox(HWND_DESKTOP,
                    hwndMain,
                    (PFNWP) FreeMemDlgProc,
                    (HMODULE)0,
                    (ULONG) IDD_FREEMEM,
                    (PVOID) &ObjAlloc ) != 0)
          {
              rc = DosFreeMem(ObjAlloc.pvAddress);

              if (rc != 0L)
              {                                  /* DosFreeMem is fail */
                  /* Try to figure out why the error occured based
                     on actual page attributes of page requested to be
                     freed. */
                  rc2 = DosQueryMem(ObjAlloc.pvAddress,
                                    &ulTempRegionSize,
                                    &flTempAttributes);
                  if (rc2 == 0L)
                  /* If the page requested to be freed was already
                     in the freed state, or the requested page in the
                     object to be freed is not the base page of the
                     object, set the appropriate error condition. */
                  {
                      if ((flTempAttributes & PAG_FREE) != 0L)
                      {
                          rc = VMERR_ALREADY_FREED;
                      }
                      else if ((flTempAttributes & PAG_BASE) == 0L)
                      {
                          rc = VMERR_NOT_BASEPAGE;
                      }
                  }
                  VMM_Error("DosFreeMem()",rc);
              }
              else
              {
                  CleanUpArray(ObjAlloc.pvAddress);
                  WinInvalidateRect(hwndMain, NULL, TRUE);
              }
          }
          break;

      case IDM_VMMSET:

          ObjAlloc.pvAddress = '\000';
          if (WinDlgBox(HWND_DESKTOP,
                        hwndMain,
                        (PFNWP) SetMem1DlgProc,
                        (HMODULE)0,
                        (ULONG) IDD_SETMEM1,
                        (PVOID) &ObjAlloc ))
          {
              if (WinDlgBox(HWND_DESKTOP,
                            hwndMain,
                            (PFNWP) SetMem2DlgProc,
                            (HMODULE)0,
                            (ULONG) IDD_SETMEM2,
                            (PVOID) &ObjAlloc ))
              {
                  rc = DosSetMem(ObjAlloc.pvAddress,
                                 ObjAlloc.ulSize,
                                 ObjAlloc.ulAttr);

                  /* If an error occured making the DosSetMem call,
                     try to figure out the cause of the error by
                     studying the requested access and the access on
                     the memory prior to the DosSetMem call. */

                  if (rc != 0L)
                  {
                      ulTempRegionSize = 1L;

                      rc2 = DosQueryMem(ObjAlloc.pvAddress,
                                        &ulTempRegionSize,
                                        &flTempAttributes);
                      if (rc2 == 0L)
                      {
                          rc = 0L;
                          /* If no attributes, commit with no other
                             attributes, or a size of zero was
                             specified, set the appropriate error
                             condition. */

                          if (ObjAlloc.ulAttr == 0L)
                          {
                              rc = VMERR_SET_NO_PARMS;
                          }
                          else if (ObjAlloc.ulAttr == PAG_COMMIT)
                          {
                              rc = VMERR_COMMIT_ONLY;
                          }
                          else if (ObjAlloc.ulSize == 0L)
                          {
                              rc = VMERR_SET_ZERO_SIZE;
                          }
                          /* If memory is not allocated then set
                             error condition. */

                          else if ((ObjAlloc.ulAttr & PAG_FREE) != 0L)
                          {
                              rc = VMERR_SET_ON_FREE;
                          }
                          /* If the memory was already in the
                             reserved state and the user attempted to
                             decommit it or set attributes for it, set
                             the error condition. */

                          else if ((flTempAttributes & PAG_COMMIT) == 0L)
                          {
                              if ((ObjAlloc.ulAttr & PAG_DECOMMIT) != 0L)
                              {
                                  rc = VMERR_DECOMMIT_RESERVED;
                              }
                              else if ((ObjAlloc.ulAttr & ~PAG_COMMIT) != 0L)
                              {
                                  rc = VMERR_ACCESS_ON_RESERVED;
                              }
                          }
                          /* If the memory was in a committed state
                             and the user attempted to decommit it and
                             set attributes, or the user attempts to
                             commit the memory, set the appropriate
                             error condition. */
                          else
                          {
                              if (((ObjAlloc.ulAttr &  PAG_DECOMMIT) != 0L)
                                && ((ObjAlloc.ulAttr & ~PAG_DECOMMIT) != 0L))
                              {
                                  rc = VMERR_ACCESS_AND_DECOMMIT;
                              }
                              else if ((ObjAlloc.ulAttr & PAG_COMMIT) != 0L)
                              {
                                  rc = VMERR_COMMIT_ON_COMMITTED;
                              }
                          }
                      }
                      VMM_Error("DosSetMem()",rc);
                  }
                  else
                  {
                      WinInvalidateRect(hwndMain, NULL, TRUE);
                  }
              }
          }
          break;

      case IDM_VMMWRITE:

          ObjAlloc.pvAddress = '\000';
          if (WinDlgBox(HWND_DESKTOP,
                        hwndMain,
                        (PFNWP) WriteMemDlgProc,
                        (HMODULE)0,
                        (ULONG) IDD_WRITEMEM,
                        (PVOID) NULL))

              WinInvalidateRect(hwndMain, NULL, TRUE);
          break;

      case IDM_VMMREAD:

          ObjAlloc.pvAddress = '\000';
          if (WinDlgBox(HWND_DESKTOP,
                        hwndMain,
                        (PFNWP) ReadMemDlgProc,
                        (HMODULE)0,
                        (ULONG) IDD_READMEM,
                        (PVOID) &ObjAlloc ))
          {
             if ( *( (CHAR *)(ObjAlloc.pvAddress) )== 0L )
             {
              sprintf(szBuffer, "Address %p doesn't contain data.",
                                    ObjAlloc.pvAddress);
              memset(ObjAlloc.pvAddress,0,sizeof(ObjAlloc.pvAddress));
             } else {
                     sprintf(szBuffer, "Address %p contains\n %s",
                               ObjAlloc.pvAddress, ObjAlloc.pvAddress);
                    }
              WinMessageBox(HWND_DESKTOP,
                            hwndMain,
                            szBuffer,
                            "Read Memory",
                            0,
                            MB_INFORMATION| MB_OK | MB_MOVEABLE);

              WinInvalidateRect(hwndMain, NULL, TRUE);
          }
          break;

      default:
          break;
   }
   /* This routine currently doesn't use the mp2 parameter but       *\
    *  it is referenced here to prevent an 'Unreferenced Parameter'  *
   \*  warning at compile time.                                      */
   return;
}                                                    /* UserCommand() */
/*=========================================================================\
 *									   *
 *	 FILE:wmouse.c							   *
 *									   *
 *	 DESCRIPTION:							   *
 *									   *
 *									   *
 *									   *
 *	Created 1991  IBM Corp.						   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *	*
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have been *
 *	advised of the possibility of	such damages.			   *				   *
 *									   *
 *-------------------------------------------------------------------------*
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *--------------------------------------------------------------
 *
 *  This source file contains the following functions:
 *
 *
 *
 *
 *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/
#define	 INCL_DOS
#define	 INCL_VIO
#define	 INCL_KBD
#define	 INCL_MOU
#define	 INCL_DOSPROCESS

#include <os2.h>
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <string.h>
#include <stdlib.h>
#include "worms.h"
#include "wrmthrd.h"
#include "wrmhelp.h"



/*--------------------------------------------------------------*\
 *  Global variables  and definitions for this file
\*--------------------------------------------------------------*/

MOUEVENTINFO mouev;
HMOU hmou;
/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/
VOID WmouseFunctions(SHORT sCol);
/****************************************************************\
 *  Routine Name:
 *--------------------------------------------------------------
 *
 *  Name:
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
VOID WReadMouse(PVOID pvMessageData)
{

     USHORT fWait = MOU_WAIT;
     NOPTRRECT mourt = { 0,0,24,79 };


     /*
      *open the handle
      *for the mouse
      */
     MouOpen(NULL,&hmou);
     MouDrawPtr(hmou);

     do
     {
	  /*
	   *sit and wait on
	   *the event queue
	   */
	  MouReadEventQue(&mouev,&fWait,hmou);

	  if(mouev.time && !bHelpEnabled)
	  {
	       if(mouev.fs & MOUSE_BN1_DOWN )
	       {
		    MouRemovePtr(&mourt,hmou);
		    /*
		     *if the button is clicked
		     *on any of the available functions
		     */
		    if(mouev.row == (TOP_ROW + 2) )
		    {
			 WmouseFunctions(mouev.col);
		    }

	       }
	       MouDrawPtr(hmou);
	  }

     }while(!fQuit );


     DosExit(EXIT_THREAD, 0L );
}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    VOID
 *
\****************************************************************/
VOID WmouseFunctions(SHORT sCol)
{

     /*
      *the add selection
      */
     if(sCol >= 5  && sCol <= 7)
     {
	  WormCreate();
     }
     /*
      *the delete
      *key
      */
     else if(sCol >= 22 && sCol	 <=  27)
     {
	  WormDelete();
     }
     /*
      *exit the process
      */
     else if(sCol >= 47 && sCol	 <=  50 )
     {

	 /*
	  *display hit any key to exit
	  */
	 fQuit = TRUE;
	 Message(ENTER_TO_EXIT,FALSE,FALSE,TRUE,TRUE);
     }

     /*
      *the help menu
      */
     else if(sCol >= 62 && sCol	 <=  65 )
     {

	if( WormHelp() )
	{
	       ErrorMessage(ERROR_DISP_HELP,TRUE);
	}
     }
     else
     {
	  DosBeep(600,175);
     }


}
/*--------------------------------------------------------------*\
 *  End of file : wmouse.c
\*--------------------------------------------------------------*/
/*static char *SCCSID = "@(#)wndproc.c  6.11 92/03/10";*/

#define DISABLE 1

/*=========================================================================\
 *									   *
 *	 FILE:wndproc.c							   *
 *									   *
 *	 DESCRIPTION:	 Window procedure for clock client window	   *
 *									   *
 *									   *
 *									   *
 *	Copyright 1989, 1990, 1992 IBM Corp.				   *
 *									   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have been *
 *	advised of the possibility of	such damages.			   *
 *									   *
 *-------------------------------------------------------------------------*
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *--------------------------------------------------------------
 *
 *  This source file contains the following functions:
 *
 *
 *
 *
 *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/

#define INCL_DEV
#define INCL_WININPUT
#define INCL_WINFRAMEMGR
#define INCL_WINTRACKRECT
#define INCL_WINMENUS
#define INCL_WINSYS
#define INCL_WINTIMER
#define INCL_WINMESSAGEMGR
#define INCL_WINSHELLDATA
#define INCL_WINWINDOWMGR
#define INCL_WINHELP
#define INCL_GPICONTROL
#define INCL_GPIPRIMITIVES
#define INCL_GPILOGCOLORTABLE
#define INCL_GPIBITMAPS
#define INCL_GPITRANSFORMS
#define INCL_DOSSEMAPHORES
#define INCL_DOSDATETIME


#include <os2.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "clock.h"
#include "res.h"
#include "clkdata.h"
#include "help.h"

/*--------------------------------------------------------------*\
 *  Global variables and definitions for this file
\*--------------------------------------------------------------*/

/* Fields marked (RT) are filled in at run-time */

#define RESOURCEFLAG	0xFFFF0000

CHAR szHelpTitle [MAXTITLELENGTH + 1];


/*d-------------------------------------------------------------*\
 *  Entry point declarations
\*-------------------------------------------------------------k*/

MRESULT EXPENTRY ClkTicksDlgProc (HWND hWnd,ULONG usMessage,
				  MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY ClkColorsDlgProc(HWND hWnd,ULONG usMessage,
				  MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY TimeDlgProc(HWND hWnd,ULONG usMessage,
			     MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY AlarmDlgProc (HWND hWnd,ULONG usMessage,
			       MPARAM mp1, MPARAM mp2);
VOID FAR SaveApplication (HWND hWnd);

VOID ClkPaint (HWND);
VOID ClkCreate (HWND);
VOID ClkDestroy (HWND);
VOID ClkMinmax (HWND, PSWP);
VOID ClkSize (HWND);
VOID ClkTimer (HWND);
VOID ClkCommand (HWND, MPARAM,MPARAM );
VOID GetArrangedDate (CHAR []);
VOID ClkDrawDate (HPS, USHORT);

VOID ClkHideFrameControls (HWND);
VOID ClkShowFrameControls (HWND);
VOID DrawDigitalTime (HWND);
VOID GetCountryDependent (VOID);
VOID SetDispMode (VOID);
VOID SetRGBColors (VOID);
VOID ShadeLight	  (PLONG );
BYTE LightRGBByte (BYTE);
BYTE ShadeRGBByte (BYTE);
VOID InitMenu(MPARAM mp1, MPARAM mp2);
VOID EnableMenuItem(HWND hwndMenu, SHORT idItem, BOOL fEnable);
/****************************************************************\
 *  Routine Name:ClkWndProc()
 *--------------------------------------------------------------
 *
 *  Name:
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns: MRESULT()
 *
 *
\****************************************************************/

MRESULT EXPENTRY ClkWndProc (HWND hwnd, ULONG usMsg, MPARAM mp1, MPARAM mp2)
{
    switch (usMsg) {

    case WM_CREATE:
	ClkCreate (hwnd);
	return (WinDefWindowProc (hwnd, usMsg, mp1, mp2));

    case WM_DESTROY:
	ClkDestroy (hwnd);
	return (WinDefWindowProc (hwnd, usMsg, mp1, mp2));

    case WM_TIMER:
	ClkTimer (hwnd);
	if ( (BOOL) hDateTime)
	    WinSendMsg (hDateTime, WM_TIMER, mp1, mp2);
	break;

    case WM_PAINT:
	ClkPaint (hwnd);
	break;

    case WM_MINMAXFRAME:
	ClkMinmax (hwnd, (PSWP)mp1);
	break;

    case WM_SIZE:
	ClkSize (hwnd);
	return (WinDefWindowProc (hwnd, usMsg, mp1, mp2));

    case WM_COMMAND:
	ClkCommand (hwnd, mp1,mp2);
	break;

    case WM_BUTTON1DOWN:
	return WinSendMsg (hwndFrame, WM_TRACKFRAME,
			   MPFROMSHORT((USHORT)mp2 | TF_MOVE), MPVOID);

    case WM_BUTTON1DBLCLK:
	if (cp.fControlsHidden)
	    ClkShowFrameControls (hwndFrame);
	else
	    ClkHideFrameControls (hwndFrame);
	break;

    case WM_TRANSLATEACCEL:
	return WinSendMsg(hwndFrame, usMsg, mp1, mp2);
	break;

    case WM_SAVEAPPLICATION:
	/***********************************************************\
	*  Task Manager option to Save Desktop sends this message.
	*  Save window state (MIN/RESTORE) and position in OS2.INI
	\***********************************************************/
	SaveApplication (hwndFrame);
	break;

     case WM_INITMENU:
	 InitMenu(mp1, mp2);
	 break;

    case HM_QUERY_KEYS_HELP:
	return (MRESULT)PANEL_HELPKEYS;	  /* return id of key help panel */
	break;

    default:
	/* let default window procedure handle it. */
	return (WinDefWindowProc (hwnd, usMsg, mp1, mp2));
    }

    return (MRFROMLONG(0));
}



/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ClkCreate()
 *
 *  Purpose:Intialize a newly created client window
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    1 - if sucessful execution completed
 *	    0 - if error
\****************************************************************/
VOID ClkCreate ( HWND hwnd )
{
    LONG cxScreen , cyScreen;  /* screen dimensions */
    LONG xLeft , yBottom ;	/* frame window location */
    ULONG cbBuf;
    LONG cyHeight;
    LONG cxWidth;

    hwndClient = hwnd;

    WinLoadString(hab, NULLHANDLE, IDS_TITLE,  0, (PSZ)szTitle	 );
    WinLoadString(hab, NULLHANDLE, IDS_HELPTITLE, 256, (PSZ)szHelpTitle);
    GetCountryDependent();
    /* we are called before the global hwndFrame is valid */
    hwndFrame = WinQueryWindow ( hwnd , QW_PARENT) ;
    hwndTitleBar = WinWindowFromID ( hwndFrame , FID_TITLEBAR ) ;
    hwndSysMenu = WinWindowFromID ( hwndFrame , FID_SYSMENU ) ;
    hwndMinMax = WinWindowFromID ( hwndFrame , FID_MINMAX ) ;

    /* load our menus */
    hwndMenu = WinLoadMenu (hwndFrame, NULLHANDLE, IDR_MAIN);
    /* determine screen dimensions */
    /* open a device context and create a presentation space */

    hdc = WinOpenWindowDC (hwnd);
    hps = GpiCreatePS (hab, hdc, &sizl, PU_ARBITRARY | GPIT_MICRO |
	    GPIA_ASSOC);

    /*
     * Create our off-screen 'buffer'.
     */
    hdcBuffer = DevOpenDC ( (HAB)0L, OD_MEMORY, "*", 0L, NULL, hdc);
    hpsBuffer = GpiCreatePS (hab, hdcBuffer, &sizl, PU_ARBITRARY |
			       GPIT_MICRO | GPIA_ASSOC);

    GpiCreateLogColorTable (hpsBuffer, 0, LCOLF_RGB, 0, 0, (PLONG)NULL);

    /* get the device resolutions so we can make the face appear circular */
    DevQueryCaps (hdc, (LONG)CAPS_VERTICAL_RESOLUTION,(LONG) 1L, &cyRes);
    DevQueryCaps (hdc, CAPS_HORIZONTAL_RESOLUTION, 1L, &cxRes);
    DevQueryCaps (hdc, CAPS_COLOR_PLANES, 1L, &cColorPlanes);
    DevQueryCaps (hdc, CAPS_COLOR_BITCOUNT, 1L, &cColorBitcount);

    cxScreen = WinQuerySysValue (HWND_DESKTOP, SV_CXSCREEN);
    cyScreen = WinQuerySysValue (HWND_DESKTOP, SV_CYSCREEN);

    /*
     * Calculate an initial window position and size.
     */
    xLeft = cxScreen / 8;
    yBottom = cyScreen / 2;
    cxWidth = cxScreen / 3;
    cyHeight = cyScreen / 2;
    WinSetWindowPos (hwndFrame, NULLHANDLE, xLeft, yBottom,
		       cxWidth, cyHeight,
		       SWP_SIZE | SWP_MOVE | SWP_ACTIVATE);

    cbBuf = sizeof(cp);
    if (!PrfQueryProfileData(hab, SZ_APPNAME, SZ_KEYNAME, &cp, &cbBuf))
    {
	cp.usMajorTickPref = CLKTM_ALWAYS;
	cp.usMinorTickPref = CLKTM_NOTICONIC;
	cp.clrBackground = 0x00008080;
	cp.clrFace = 0x00008080;
	cp.clrHourHand = RGB_RED;
	cp.clrMinuteHand = RGB_RED;
	cp.fControlsHidden = FALSE;
	cp.usDispMode = DM_TIME | DM_ANALOG | DM_SECONDHAND;
	cp.alarm.uchHour = 0;
	cp.alarm.uchMinutes = 0;
	cp.alarm.usMode = 0;
	SetRGBColors();
	/* position the window and make it visible */
	WinSetWindowPos( hwndFrame , NULLHANDLE ,
			   xLeft , yBottom ,
			   cxWidth , cyHeight ,
			   SWP_SIZE | SWP_MOVE | SWP_ACTIVATE);
	WinQueryWindowPos(hwndFrame, &cp.swp);
    }
    else
    { /*Protect against garbage swp*/

	cp.swp.hwnd = hwndFrame;
	cp.swp.hwndInsertBehind = HWND_TOP;

	cp.swp.fl = (cp.swp.fl & (SWP_MINIMIZE | SWP_MAXIMIZE)) | SWP_SIZE | SWP_MOVE | SWP_ACTIVATE;
	SetRGBColors();
	WinSetMultWindowPos(hab, &cp.swp, 1);
    }

    if (cp.fControlsHidden)
	ClkHideFrameControls (hwndFrame);

    /*
     * Check relevant items.
     */
    WinSendMsg( hwndMenu,
		MM_SETITEMATTR,
		MPFROM2SHORT( IDM_TIME, TRUE),
		MPFROM2SHORT( MIA_CHECKED,
			      ( (cp.usDispMode & DM_TIME)?  MIA_CHECKED
				      : ~MIA_CHECKED) ) );
    WinSendMsg( hwndMenu,
		MM_SETITEMATTR,
		MPFROM2SHORT( IDM_DATE, TRUE),
		MPFROM2SHORT( MIA_DISABLED,
			      ( (!(cp.usDispMode & DM_TIME))?  MIA_DISABLED
				      : ~MIA_DISABLED) ) );
    WinSendMsg( hwndMenu,
		MM_SETITEMATTR,
		MPFROM2SHORT( IDM_DATE, TRUE),
		MPFROM2SHORT( MIA_CHECKED,
			      ( (cp.usDispMode & DM_DATE)?  MIA_CHECKED
				      : ~MIA_CHECKED) ) );
    WinSendMsg( hwndMenu,
		MM_SETITEMATTR,
		MPFROM2SHORT( IDM_TIME, TRUE),
		MPFROM2SHORT( MIA_DISABLED,
			      ( ((!(cp.usDispMode & DM_DATE) || (cp.usDispMode & DM_ANALOG)))?	MIA_DISABLED
				      : ~MIA_DISABLED) ) );
    WinSendMsg( hwndMenu,
		MM_SETITEMATTR,
		MPFROM2SHORT( (cp.usDispMode & DM_DIGITAL)
							  ?IDM_DIGITAL
							  :IDM_ANALOG,
			       TRUE),
		MPFROM2SHORT( MIA_CHECKED,
			      MIA_CHECKED));

    WinSendMsg(hwndMenu, MM_SETITEMATTR, MPFROM2SHORT(IDM_SECONDHAND, TRUE),
		MPFROM2SHORT( MIA_CHECKED,
			      ( (cp.usDispMode & DM_SECONDHAND) ? MIA_CHECKED
				      : ~MIA_CHECKED)));


    /*
     * Disable these items if the digital clock is visible
     * since they won't apply.
     */
    if (cp.usDispMode & DM_DIGITAL)
    {
	WinSendMsg (hwndMenu, MM_SETITEMATTR,
		MPFROM2SHORT(IDM_SECONDHAND, TRUE),
		MPFROM2SHORT(MIA_DISABLED, MIA_DISABLED));

	WinSendMsg (hwndMenu, MM_SETITEMATTR,
		MPFROM2SHORT( IDM_TICKS, TRUE), MPFROM2SHORT( MIA_DISABLED,
		MIA_DISABLED));
    }

    /* have we been asked to start as an icon? */
    if (fStartAsIcon)
	WinSetWindowPos(hwndFrame, NULLHANDLE, 0, 0, 0, 0, SWP_MINIMIZE);

    WinShowWindow(hwndFrame, TRUE);

    /* get the time in a format for dislaying */
    DosGetDateTime(&dt);
    dt.hours = (UCHAR )(dt.hours * (UCHAR) 5) % (UCHAR) 60 + dt.minutes / (UCHAR)12;

    /* start a timer */
    WinStartTimer (hab, hwnd, IDR_MAIN, 1000);

    WinLoadString(hab, NULLHANDLE, IDS_TITLE, 80, (PSZ)szTitle);
    GetCountryDependent();

}


/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ClkDestroy()
 *
 *  Purpose: Destroy clock face.
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:VOID
 *
 *
\****************************************************************/
VOID ClkDestroy (HWND hwnd)
{
    HBITMAP hbm;

    hbm = GpiSetBitmap (hpsBuffer, NULLHANDLE);

    if (hbm != NULLHANDLE)
	GpiDeleteBitmap (hbm);

    GpiDestroyPS (hpsBuffer);
    DevCloseDC (hdcBuffer);
}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name: ClkSize()
 *
 *  Purpose:When the window has been sized, we calculate  a page
 *	    rectangle which: (a) fills the window rectangle in either
 *	    the x or y dimension, (b) appears square, and (c) is centered
 *	    in the window rectangle
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
VOID ClkSize (HWND hwnd)
{
    RECTL rclWindow;
    SIZEF sizef;
    LONG cxSquare, cySquare, cxEdge, cyEdge;
    LONG cyHeight;
    LONG cxWidth;
    HBITMAP hbm;
    BITMAPINFOHEADER bmp;

    /*
     * First get rid of any buffer bitmap already there.
     */
    hbm = GpiSetBitmap (hpsBuffer, NULLHANDLE);

    if (hbm != NULLHANDLE)
	GpiDeleteBitmap (hbm);

    /*
     * Get the width and height of the window rectangle.
     */
    WinQueryWindowRect (hwnd, &rclWindow);
    cxWidth = rclWindow.xRight - rclWindow.xLeft - 2;
    cyHeight = rclWindow.yTop - rclWindow.yBottom - 2;

    /*
     * Now create a bitmap the size of the window.
     */
    bmp.cbFix = sizeof(BITMAPINFOHEADER);
    bmp.cx = (SHORT)cxWidth;
    bmp.cy = (SHORT)cyHeight;
    bmp.cPlanes = (SHORT)cColorPlanes;
    bmp.cBitCount = (SHORT)cColorBitcount;
    hbm = GpiCreateBitmap(hpsBuffer, (PBITMAPINFOHEADER2)&bmp,
			  0x0000, (PBYTE)NULL, (PBITMAPINFO2)NULL);
    GpiSetBitmap (hpsBuffer, hbm);

    /*
     * Assume the size of the page rectangle is constrained in the y
     * dimension,compute the x size which would make the rectangle appear
     * square, then check the assumption and do the reverse calculation
     * if necessary.
     */
    cySquare = cyHeight - 2;
    cxSquare = ( cyHeight * cxRes ) / cyRes;

    if (cxWidth < cxSquare)
    {
	cxSquare = cxWidth - 2;
	cySquare = (cxWidth * cyRes) / cxRes;
    }

    /*
     * Fill in the page rectangle and set the page viewport.
     */
    cxEdge = (cxWidth - cxSquare ) / 2;
    cyEdge = (cyHeight - cySquare ) / 2;
    rclPage.xLeft = cxEdge;
    rclPage.xRight = cxWidth - cxEdge;
    rclPage.yBottom = cyEdge;
    rclPage.yTop = cyHeight - cyEdge;

    /*
     * Determine where to put the date. If we have room under the clock, we
     * put it there. If we have more room on the left we put it there. If we
     * have more room in the midlle, it goes there.
     */
    if (cp.usDispMode & DM_DATE)
    {
	vclrDate[SURFACE] = vclrBG[SHADE];
	vclrDate[LIGHT] = vclrBG[LIGHT];
	vclrDate[SHADE] = vclrBG[SHADE];
	vclrDate[BACKGROUND] = vclrBG[SURFACE];
	if (cyHeight > (cySquare*6/5)) { /*Goes under*/
	    vmatlfDateTrans.lM31 = (LONG)15;		/*Horizontal*/
	    vmatlfDateTrans.lM32 = -(LONG)17;	 /*vertical*/
	    vmatlfDateScale.fxM11 = MAKEFIXED(2,0x8000);
	    vmatlfDateScale.fxM22 = MAKEFIXED(2,0x8000);
	    rclPage. yTop += cyEdge;
	    rclPage. yBottom += cyEdge;
	    vusDatePos = DP_UNDER;
	}
	else
	{
	    if (cxWidth > (cxSquare * 31/10 ))
	    {
		vmatlfDateTrans.lM31 = -(LONG)53 ;	      /*Horizontal*/
		vmatlfDateTrans.lM32 = (LONG)04;    /*vertical*/
		vmatlfDateScale.fxM11 = MAKEFIXED(7,0xe000);
		vmatlfDateScale.fxM22 = MAKEFIXED(7,0xe000);
		rclPage.xRight += cxEdge;
		rclPage.xLeft += cxEdge;
		vusDatePos = DP_LEFTMIDDLE;

	    }
	    else
	    {
		if (cxWidth > (cxSquare * 2)) { /*Goes on the left*/
		    vmatlfDateTrans.lM31 = -(LONG)52 ;		  /*Horizontal*/
		    vmatlfDateTrans.lM32 = (LONG)2;    /*vertical*/
		    vmatlfDateScale.fxM11 = MAKEFIXED(3,0xd000);
		    vmatlfDateScale.fxM22 = MAKEFIXED(3,0xd000);
		    rclPage.xRight += cxEdge;
		    rclPage.xLeft += cxEdge;
		    vusDatePos = DP_LEFTDOWN  ;

		}
		else
		{   /*Goes inside*/
		    vmatlfDateTrans.lM31 = (LONG)24 ;		 /*Horizontal*/
		    vmatlfDateTrans.lM32 = (LONG)23;	/*vertical*/
		    vmatlfDateScale.fxM11 = MAKEFIXED(2,0);
		    vmatlfDateScale.fxM22 = MAKEFIXED(2,0);
		    vclrDate[SURFACE] = vclrFace[SHADE] ;
		    vclrDate[LIGHT] = vclrFace[LIGHT] ;
		    vclrDate[SHADE] = vclrFace[SHADE];
		    vclrDate[BACKGROUND] = vclrFace[SURFACE];
		    vusDatePos = DP_INSIDE;
		}
	    }
	}
    }

    f = GpiSetPageViewport (hps, &rclPage);
    f = GpiSetPageViewport (hpsBuffer, &rclPage);

    /*
     * Are we iconic?
     */
    f = WinQueryWindowPos (hwndFrame, &swp);
    fIconic = (BOOL)(swp.fl & SWP_MINIMIZE );
    fShowSecondHand = (BOOL) !(fIconic);

    GpiQueryCharBox(hpsBuffer, &sizef);
    GpiSetCharBox(hpsBuffer, &sizef);

    fBufferDirty = TRUE;
}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ClkMinMax()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    VOID
 *
\****************************************************************/
VOID ClkMinmax (HWND hwnd, PSWP pswp)
{
    char achFinalDate[10];
    HWND hwndFrame;


    /*
     * We want the date as the icon text if the clock is
     * minimized and the user has selected both date and
     * time be displayed.
     */
    if ((cp.usDispMode & (DM_TIME | DM_DATE)) == (DM_TIME | DM_DATE))
    {
	hwndFrame = WinQueryWindow (hwnd, QW_PARENT);
	if (pswp->fl & SWP_MINIMIZE) {
	    GetArrangedDate (achFinalDate);
	    WinSetWindowText (hwndFrame, achFinalDate);
	} else {
	    WinSetWindowText (hwndFrame, "Clock");
	}
    }
}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ClkTimer()
 *
 *  Purpose: Handles window timer events
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    1 - if sucessful execution completed
 *	    0 - if error
\****************************************************************/
VOID ClkTimer (HWND hwnd)
{
    DATETIME	dtNew;
    static time_t lTimeChangeCheck = 0L;
    time_t	lTime;

    DosGetDateTime ( &dtNew ) ;

    if (cp.usDispMode & DM_ANALOG)
    {

	/* get the new time */
	DosGetDateTime (&dtNew);

	/* adjust the hour hand */
	dtNew.hours = (dtNew.hours * (UCHAR) 5 ) % (UCHAR) 60
		      + dtNew.minutes / (UCHAR)12;

	/* if we must move the hour and minute hands, redraw it all */
	if (dtNew.minutes != dt.minutes)
	{

	    ClkDrawFace(hpsBuffer);
	    ClkDrawDate(hpsBuffer, DM_REDRAW);
	    ClkDrawHand(hpsBuffer, HT_HOUR_SHADE, dtNew.hours);
	    ClkDrawHand(hpsBuffer, HT_MINUTE_SHADE, dtNew.minutes);
	    ClkDrawHand(hpsBuffer, HT_HOUR, dtNew.hours);
	    ClkDrawHand(hpsBuffer, HT_MINUTE, dtNew.minutes);

	    UpdateScreen (hps, NULL);

	    if (fShowSecondHand && (cp.usDispMode & DM_SECONDHAND))
	    {
		GpiSetMix(hps, FM_INVERT);
		ClkDrawHand(hps, HT_SECOND, dtNew.seconds);
	    }
	}

	/* otherwise just undraw the old second hand and draw the new */
	else if (fShowSecondHand  && (cp.usDispMode & DM_SECONDHAND))
	{
	    GpiSetMix(hps, FM_INVERT);
	    ClkDrawHand(hps, HT_SECOND, dt.seconds);
	    ClkDrawHand(hps, HT_SECOND, dtNew.seconds);
	}

	dt = dtNew ;
    }
    else /*Must be Digital*/
    {
	DrawDigitalTime(hwnd);
    }

    /*
     *if this is the first
     *time through init it
     */
    if(!lTimeChangeCheck)
    {
	  time(&lTimeChangeCheck);

    }

    /*
     *a quick check to see if
     *any other session
     *adjusted our time
     *if so reset the timer
     */
    else
    {
	  time(&lTime);
	  /*
	   *did the clock get changed by more than 60 seconds
	   */
	  if( lTime  > ( lTimeChangeCheck  + 60L ) ||
	      lTimeChangeCheck > ( lTime   + 60L ) )
	  {

	       AlarmSetTimer(cp.alarm.uchHour,
				   cp.alarm.uchMinutes);
	  }
	  lTimeChangeCheck = lTime;
     }

}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:DrawDigitalTime()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    1 - if sucessful execution completed
 *	    0 - if error
\****************************************************************/

VOID DrawDigitalTime(HWND hwnd)
{
    RECTL rcl;
    RECTL rclChar;
    RECTL rclCharOld;
    RECTL rclTime;
    RECTL rclAmPm;
    RECTL rclDate;
    HPS hpsWnd;
    SIZEF sizef;
    USHORT usi;
    ULONG  ulCharWidth,ulCharModulu;
    char achTime[9];
    char achFinalDate[9];
    time_t     tTime;
    struct tm  *pLocalTime;

    WinQueryWindowRect (hwnd, &rcl);
    hpsWnd = WinGetPS (hwnd);

    memset(achTime,0,sizeof(achTime) );
    memset(achFinalDate,0,sizeof(achFinalDate) );

    GpiCreateLogColorTable (hpsWnd, LCOL_RESET, LCOLF_RGB, 0, 0,
				 (PLONG) NULL);

    /*
     *if black hands and black background
     *selected force the background to
     *blue
     */

    if( !cp.clrMinuteHand && !cp.clrBackground )
    {
	  cp.clrBackground = RGB_BLUE;
    }



    switch (cp.usDispMode & (DM_TIME | DM_DATE))
    {
    case DM_DATE:
	rclDate = rcl;
	break;

    case DM_TIME | DM_DATE:
	if (!fIconic)
	{
	    rclTime = rclDate = rcl;
	    rclTime.yBottom = rclDate.yTop = rcl.yTop / 2;
	    break;
	} /*else fall through*/

    case DM_TIME:
	rclTime = rcl;
	break;
    }

    if (cp.usDispMode & DM_TIME)
    {

	rclAmPm = rclTime;
	time(&tTime);
	pLocalTime = localtime(&tTime);
	if (bTwelveHourFormat)
	{
	   strftime(achTime, sizeof(achTime), "%I %M %S", pLocalTime);
	}
	else
	{
	   strftime(achTime, sizeof(achTime), "%H %M %S", pLocalTime);
	}

	/*insert country time separator*/
	achTime[2] = achTime[5] = szTimeSep[0];
	achTime[8] = '\000';
	/*Process 12 hours mode*/
	if (bTwelveHourFormat)
	{

	    if (fIconic)
	    {
		rclTime.yBottom = rclAmPm.yTop = rclTime.yTop / 2;
	    }
	    else
	    {
		rclTime.xRight = rcl.xRight * 8 / 11;
		rclAmPm.xLeft = rclTime.xRight;
	    }

	    strcpy(achAmPm,szAnteMeridian);

	    if (pLocalTime->tm_hour >= 12)
	    {
		strcpy(achAmPm,szPostMeridian);
	    }

	}

	GpiSetCharMode(hpsWnd, CM_MODE3);

	if (fIconic)
	{
	    sizef.cx = MAKEFIXED(LOUSHORT((rclTime.xRight - rclTime.xLeft)
		    / 3), 0);
	    sizef.cy = MAKEFIXED(LOUSHORT((rclTime.yTop - rclTime.yBottom)
		    * 1400 / 1000), 0);
	}
	else
	{
	    sizef.cx = MAKEFIXED(LOUSHORT((rclTime.xRight - rclTime.xLeft)
		    / 6), 8000);
	    sizef.cy = MAKEFIXED(LOUSHORT((rclTime.yTop - rclTime.yBottom)
		    * 1000 / 1500), 0);
	}

	GpiSetCharBox(hpsWnd, &sizef);

	if (bTwelveHourFormat)
	{

	    if( strcmp(achAmPm,achOldAmPm) )
	    {
		WinFillRect(hpsWnd, &rclAmPm, cp.clrBackground);
		WinDrawText(hpsWnd, sizeof(achAmPm) - 1, (PSZ)achAmPm,
			(PRECTL)&rclAmPm, cp.clrMinuteHand, cp.clrBackground,
			DT_CENTER | DT_VCENTER );
	    }
	}

	if (!fIconic)
	{

	    WinDrawText(hpsWnd, sizeof(achTime) - 1 , (PSZ)achTime,
		    (PRECTL)&rclTime, cp.clrMinuteHand, cp.clrBackground,
		    DT_CENTER | DT_VCENTER | DT_QUERYEXTENT);

	    ulCharWidth = (rclTime.xRight - rclTime.xLeft) / (sizeof(achTime) - 1 );
	    ulCharModulu = (rclTime.xRight - rclTime.xLeft) % (sizeof(achTime) - 1 );
	    rclCharOld.xRight = rclTime.xLeft;

	    rclChar.yTop = rclTime.yTop;
	    rclChar.yBottom = rclTime.yBottom;

	    for (usi = 0; usi < (sizeof(achTime)); usi++)
	    {
		rclChar.xLeft = rclCharOld.xRight + (ULONG)1;
		rclChar.xRight = rclChar.xLeft + ulCharWidth +
			((ulCharModulu > 0L) ? 1L : 0L);

		if (ulCharModulu)
		    ulCharModulu--;

		if (achTime[usi] == szTimeSep[0])
		{
		    rclChar.xRight -= 3;
		}
		else
		{
		    rclChar.xRight += 1;
		}

		rclCharOld = rclChar;

		if (achTime[usi] != achOldTime[usi])
		{
		    WinFillRect (hpsWnd, &rclChar, cp.clrBackground);
		    if (!((usi == 0) && (achTime[0] == '0') &&
			    (bTwelveHourFormat)))
			WinDrawText (hpsWnd, 1, (PSZ)&achTime[usi], &rclChar,
				cp.clrMinuteHand, cp.clrBackground,
				DT_CENTER | DT_VCENTER);
		}
	    }
	}
	else
	{   /*Iconic. just draw if minute changed*/

	    if (strncmp(achTime,achOldTime,5))
	    {
		WinFillRect(hpsWnd,&rclTime,cp.clrBackground);
		WinDrawText(hpsWnd, sizeof(achTime) - 4 , (PSZ)achTime,
			(PRECTL)&rclTime, cp.clrMinuteHand, cp.clrBackground,
			DT_CENTER | DT_VCENTER);
	    }
	}
    }

    if ((!(cp.usDispMode & DM_TIME)) || ((cp.usDispMode & DM_DATE) &&
	    (!fIconic)))
    {
	GetArrangedDate(achFinalDate);
	if (strncmp(achFinalDate, achOldDate,
		sizeof(achFinalDate) - fIconic ? 4 : 1))
	{

	    WinFillRect (hpsWnd, &rclDate, cp.clrBackground);
	    GpiSetCharMode (hpsWnd, CM_MODE3);

	    sizef.cx = MAKEFIXED(LOUSHORT(
			    (rclDate.xRight - rclDate.xLeft) / 5), 0);
	    sizef.cy = MAKEFIXED(LOUSHORT(
			    (rclDate.yTop - rclDate.yBottom) * 1000 / 1500), 0);

	    GpiSetCharBox(hpsWnd, &sizef);
	    WinDrawText(hpsWnd,
			(sizeof(achFinalDate) - (fIconic ? 4 : 1) ),
			(PSZ)achFinalDate,(PRECTL)&rclDate,
			(LONG)cp.clrMinuteHand,
			(LONG)cp.clrBackground,
			(ULONG )(DT_CENTER | DT_VCENTER ) );
	}
    }

    WinReleasePS(hpsWnd);

    strncpy(achOldTime,achTime,sizeof(achOldTime));
    strncpy(achOldAmPm,achAmPm,sizeof(achOldAmPm));
    strncpy(achOldDate,achFinalDate,sizeof(achOldDate));
}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ClkCommand()
 *
 *  Purpose:Handle  WM_COMMAND events.
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    VOID
 *
\****************************************************************/
VOID ClkCommand ( HWND hwnd , MPARAM mp1, MPARAM mp2 )
{
    DATETIME  dtNew ;

    switch ( SHORT1FROMMP ( mp1 ) )
    {

	case IDM_TICKS :
	    WinDlgBox ( HWND_DESKTOP , hwndFrame , ClkTicksDlgProc ,
			NULLHANDLE ,
			IDD_TICKS , (PVOID )NULL ) ;
	    break;

	case IDM_EXIT:
	    /*
	     *post the event semaphore
	     *for our alarm thread
	     */
	    fEndThread = TRUE;
	    DosPostEventSem(TimerResources.hTimerDev);
	    WinPostMsg(hwnd, WM_QUIT,MPVOID, MPVOID);


	    break;

	case IDM_COLORS :
	    WinDlgBox ( HWND_DESKTOP , hwndFrame ,ClkColorsDlgProc ,
			NULLHANDLE ,
			IDD_COLORS , NULL ) ;
	    SetRGBColors();
	    ClkSize(hwnd);
	    break ;

	case IDM_TOGGLECONTROLS :
	    if (cp.fControlsHidden) {
		ClkShowFrameControls( hwndFrame );
	    } else {
		ClkHideFrameControls ( hwndFrame ) ;
	    }
	    break ;

	case IDM_DATETIME:
	    if (hDateTime == NULLHANDLE)
	    {
		WinDlgBox(HWND_DESKTOP,hwndFrame,TimeDlgProc,
			  NULLHANDLE,IDD_TIME ,NULL);
		dt.minutes += 2; /*Fool the ClkTimer proc. It will now think it have
				  to redraw*/
	    } else {
		WinSetFocus (HWND_DESKTOP, hDateTime);
	    }
	    break;
	case IDM_ALARM:
	    if (hAlarmTime == (HWND)NULL)
	    {
		WinDlgBox(HWND_DESKTOP,hwndFrame,AlarmDlgProc,
			  NULLHANDLE,IDD_ALARM ,NULL);
	    }
	    else
	    {
		WinSetFocus(HWND_DESKTOP,hAlarmTime);
	    }

	    break;

	case IDM_SECONDHAND:
	    cp.usDispMode = ((cp.usDispMode & DM_SECONDHAND) ?
		    (cp.usDispMode & (~DM_SECONDHAND)) : (cp.usDispMode | DM_SECONDHAND));

	    GpiSetMix(hps, FM_INVERT);

	    /*
	     * Depending on the current mode draw or remove the second hand.
	     */
	    if (cp.usDispMode & DM_SECONDHAND) {
		DosGetDateTime(&dtNew);
		ClkDrawHand(hps, HT_SECOND, dtNew.seconds);
		dt.seconds = dtNew.seconds;
	    } else {
		ClkDrawHand(hps, HT_SECOND, dt.seconds);
	    }

	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_SECONDHAND, TRUE),
			MPFROM2SHORT( MIA_CHECKED,
				      ( (cp.usDispMode & DM_SECONDHAND)?  MIA_CHECKED
					      : ~MIA_CHECKED) ) );
	    break;

	case IDM_TIME:
	    cp.usDispMode = ((cp.usDispMode & DM_TIME) ? (cp.usDispMode & (~DM_TIME))
						      : (cp.usDispMode | DM_TIME));

	    WinSendMsg(hwndMenu, MM_SETITEMATTR, MPFROM2SHORT(IDM_TIME, TRUE),
		    MPFROM2SHORT(MIA_CHECKED, ((cp.usDispMode & DM_TIME) ?
		    MIA_CHECKED : ~MIA_CHECKED)));

	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_DATE, TRUE),
			MPFROM2SHORT( MIA_DISABLED,
				      ( (!(cp.usDispMode & DM_TIME)) ? MIA_DISABLED
					      : ~MIA_DISABLED) ) );
	    ClkSize(hwnd);
	    WinInvalidateRect(hwnd, NULL, TRUE);
	    break;

	case IDM_DATE:
	    cp.usDispMode = ((cp.usDispMode & DM_DATE) ? (cp.usDispMode & (~DM_DATE))
						      : (cp.usDispMode | DM_DATE));
	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_DATE, TRUE),
			MPFROM2SHORT( MIA_CHECKED,
				      ( (cp.usDispMode & DM_DATE)?  MIA_CHECKED
					      : ~MIA_CHECKED) ) );
	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_TIME, TRUE),
			MPFROM2SHORT( MIA_DISABLED,
				      ( ((!(cp.usDispMode & DM_DATE)) || (cp.usDispMode & DM_ANALOG))?	MIA_DISABLED
					      : ~MIA_DISABLED) ) );
	    ClkSize(hwnd);
	    WinInvalidateRect(hwnd,(PRECTL)NULL,TRUE);

	    break;
	case IDM_DIGITAL:
	    cp.usDispMode |=  DM_DIGITAL;
	    cp.usDispMode &=  (~DM_ANALOG);
	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_DIGITAL, TRUE),
			MPFROM2SHORT( MIA_CHECKED,
				      MIA_CHECKED));
	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_ANALOG , TRUE),
			MPFROM2SHORT( MIA_CHECKED,
				     ~MIA_CHECKED));
	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_SECONDHAND, TRUE),
			MPFROM2SHORT( MIA_DISABLED,
					MIA_DISABLED));
	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_TICKS, TRUE),
			MPFROM2SHORT( MIA_DISABLED,
					MIA_DISABLED));
	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_TIME, TRUE),
			MPFROM2SHORT( MIA_DISABLED,
				      ( ((!(cp.usDispMode & DM_DATE)) || (cp.usDispMode & DM_ANALOG))?	MIA_DISABLED
					      : ~MIA_DISABLED) ) );
	    WinInvalidateRect(hwnd,(PRECTL)NULL,TRUE);
	    break;
	case IDM_ANALOG :
	    cp.usDispMode |=  DM_ANALOG;
	    cp.usDispMode &=  (~DM_DIGITAL);
	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_ANALOG, TRUE),
			MPFROM2SHORT( MIA_CHECKED,
				      MIA_CHECKED));
	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_DIGITAL, TRUE),
			MPFROM2SHORT( MIA_CHECKED,
				     ~MIA_CHECKED));
	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_TIME, TRUE),
			MPFROM2SHORT( MIA_DISABLED,
					MIA_DISABLED));
	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_DATE, TRUE),
			MPFROM2SHORT( MIA_DISABLED,
					~MIA_DISABLED));

	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_SECONDHAND, TRUE),
			MPFROM2SHORT( MIA_DISABLED,
					~MIA_DISABLED));
	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_TICKS, TRUE),
			MPFROM2SHORT( MIA_DISABLED,
					~MIA_DISABLED));

	    cp.usDispMode |= DM_TIME;
	    WinSendMsg( hwndMenu,
			MM_SETITEMATTR,
			MPFROM2SHORT( IDM_TIME, TRUE),
			MPFROM2SHORT( MIA_CHECKED,
				      MIA_CHECKED));
	    WinInvalidateRect(hwnd,(PRECTL)NULL,TRUE);
	    break;


	case IDM_HELPHELPFORHELP:
	    HelpHelpForHelp(mp2);
	    break;

	case IDM_HELPEXTENDED:
	    HelpExtended(mp2);
	    break;

	case IDM_HELPKEYS:
	    HelpKeys(mp2);
	    break;

	case IDM_HELPINDEX:
	    HelpIndex(mp2);
	    break;

	case IDM_HELPTUTORIAL:
	    HelpTutorial(mp2);
	    break;

	case IDM_HELPABOUT:
	    HelpAbout(mp2);
	    break;

     case IDM_ALARM_EXPIRED:
	   WinMessageBox(HWND_DESKTOP,
			 hwndFrame,
			 (PSZ)"Alarm Expired",
			 (PSZ)"The Bells Are Ringing",
			 0,
			 MB_OK);
	    break;
    }
}


/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ClkHideFrameControls
 *
 *  Purpose:Hide the title bar and associted controls
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
VOID ClkHideFrameControls ( HWND hwndFrame )
{

    WinSetParent ( hwndTitleBar , HWND_OBJECT , FALSE ) ;
    WinSetParent ( hwndSysMenu , HWND_OBJECT , FALSE ) ;
    WinSetParent ( hwndMinMax , HWND_OBJECT , FALSE ) ;
    WinSetParent ( hwndMenu , HWND_OBJECT , FALSE ) ;

    WinSendMsg ( hwndFrame , WM_UPDATEFRAME ,
		 MPFROMLONG( FCF_TITLEBAR | FCF_SYSMENU | FCF_MINMAX | FCF_MENU ) ,
		 MPVOID) ;

    cp.fControlsHidden = TRUE ;
}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ClkShowFrameControls
 *
 *  Purpose:Show the title bar and associated contols
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    VOID
 *
\****************************************************************/


VOID ClkShowFrameControls ( HWND hwndFrame )
{

    WinSetParent ( hwndTitleBar , hwndFrame , FALSE ) ;
    WinSetParent ( hwndSysMenu , hwndFrame , FALSE ) ;
    WinSetParent ( hwndMinMax , hwndFrame , FALSE ) ;
    WinSetParent ( hwndMenu , hwndFrame , FALSE ) ;

    WinSendMsg ( hwndFrame , WM_UPDATEFRAME ,
		MPFROMLONG( FCF_TITLEBAR | FCF_SYSMENU | FCF_MINMAX | FCF_MENU ) ,
		MPVOID) ;
    WinInvalidateRect ( hwndFrame , NULL , TRUE ) ;

    cp.fControlsHidden = FALSE ;
}


/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:GetArrangedDate()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID GetArrangedDate(CHAR achFinalDate[])
{
    time_t     tTime;
    struct tm  *pLocalTime;

    time(&tTime);
    pLocalTime = localtime(&tTime);
    switch (vusDateFormat)
    {
	case 2: /*YMD*/
	    if (fIconic)
	    {
	       strftime(achFinalDate, sizeof(achFinalDate), "%m %d %y", pLocalTime);
	    }
	    else
	    {
	       strftime(achFinalDate, sizeof(achFinalDate), "%y %m %d", pLocalTime);
	    }
    /*put date separators*/
	    achFinalDate[2] = achFinalDate[5] = szDateSep[0];
	    break;

	case 1: /*DMY*/
	    strftime(achFinalDate, sizeof(achFinalDate), "%d %m %y", pLocalTime);
	    achFinalDate[2] = achFinalDate[5] = szDateSep[0];
	    break;

	default: /*MDY*/
	    strftime(achFinalDate, 9, "%m %d %y", pLocalTime);
	    achFinalDate[2] = achFinalDate[5] = szDateSep[0];
	    break;
    }
    achFinalDate[8] = '\0';
}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:SaveApplication()
 *
 *  Purpose:Handle the	 WM_SAVEAPPLICATION message from the desktop
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns: VOID
 *
 *
\****************************************************************/
VOID FAR SaveApplication( HWND hwnd )
{

    WinQueryWindowPos( hwnd, (PSWP)&cp.swp);
    PrfWriteProfileData(hab, SZ_APPNAME, SZ_KEYNAME, &cp, sizeof(cp));
}


/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name: SetRGBColors
 *
 *  Purpose: Set the RGB schema so that each time a user changes the
 *	     color we update it here.
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:VOID
 *
 *
\****************************************************************/
VOID SetRGBColors(VOID)
{
    vclrFace[SURFACE] = cp.clrFace;
    vclrBG[SURFACE] = cp.clrBackground;
    vclrHands[SURFACE] = cp.clrMinuteHand;
    vclrMajorTicks[SURFACE] = cp.clrHourHand;

    /*Fill color tables*/
    ShadeLight(vclrMajorTicks);

    vclrMinorTicks[SURFACE] = vclrFace[SURFACE];
    ShadeLight(vclrMinorTicks);

    ShadeLight(vclrFace);

    vclrRing[SURFACE] = vclrFace[SURFACE];
    ShadeLight(vclrRing);

    #ifdef DISABLE
    ShadeLight(vclrHands);
    #endif
    vclrHands[SHADE] = RGB_BLACK;

    ShadeLight(vclrBG);
}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ShadeLight()
 *
 *  Purpose: Find the shade and light color index values and
 *	     install them in the colors	  array of the element
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
VOID ShadeLight(PLONG nplColors)
{
   typedef  union  _RGBLONG
   {
	RGB rgb;
	LONG lng;
   } RGBLONG ;
   RGBLONG  rgbSurface,rgbShade,rgbLight;

   rgbSurface.lng = rgbShade.lng = rgbLight.lng = 0L;

   #ifdef DISABLE
   rgbSurface.lng = GpiQueryRGBColor(hps,0L,0L);
   #endif
   rgbSurface.lng = nplColors[SURFACE];
   rgbShade.rgb.bBlue = ShadeRGBByte(rgbSurface.rgb.bBlue);
   rgbShade.rgb.bRed = ShadeRGBByte(rgbSurface.rgb.bRed);
   rgbShade.rgb.bGreen = ShadeRGBByte(rgbSurface.rgb.bGreen);
   rgbLight.rgb.bBlue = LightRGBByte(rgbSurface.rgb.bBlue);
   rgbLight.rgb.bRed = LightRGBByte(rgbSurface.rgb.bRed);
   rgbLight.rgb.bGreen = LightRGBByte(rgbSurface.rgb.bGreen);
   nplColors[SHADE] = rgbShade.lng;
   nplColors[LIGHT] = rgbLight.lng;
}


/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ShadeRGBByte
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/

BYTE ShadeRGBByte(BYTE brgb)
{
  #define SHADER   ( (BYTE) 0x50)

  if (brgb > SHADER)
  {
     return (brgb - SHADER);
  }
  else
  {
     return (0);
  }

}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:LightRGBByte
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
BYTE LightRGBByte(BYTE brgb)
{

  #define LIGHTER  ( (BYTE) 0x40)

  if (brgb < (0xff - LIGHTER) )
  {
     return (brgb + LIGHTER);
  }

  else return (0xff);

}



/****************************************************************\
 *  Menu item intialization routine
 *--------------------------------------------------------------
 *
 *  Name:   InitMenu(mp1, mp2)
 *
 *  Purpose: Processes the WM_INITMENU message for the main window,
 *		disabling any menus that are not active
 *
 *  Usage:  Routine is called each time a menu is dropped
 *
 *  Method: A switch statement branches control based upon
 *	    the id of the menu that is being displayed
 *
 *  Returns:
\****************************************************************/
VOID InitMenu(MPARAM mp1, MPARAM mp2)
{

    /* define a shorthand way of denoting the menu handle */
    #define hwndMenu	    HWNDFROMMP(mp2)

    switch(SHORT1FROMMP(mp1))
    {

	case IDM_HELP:
	    /*
	     * Enable or disable the Help menu depending upon whether the
	     * help manager has been enabled
	     */
	    EnableMenuItem(hwndMenu, IDM_HELPHELPFORHELP, fHelpEnabled);
	    EnableMenuItem(hwndMenu, IDM_HELPEXTENDED, fHelpEnabled);
	    EnableMenuItem(hwndMenu, IDM_HELPKEYS, fHelpEnabled);
	    EnableMenuItem(hwndMenu, IDM_HELPINDEX, fHelpEnabled);

	    /** REMEMBER: add a case for IDM_HELPTUTORIAL if you include
		the Tutorial menu item	 **/

	    break;

	default:
	    break;
    }

    #undef hwndMenu

}   /* InitMenu() */


/****************************************************************\
 *  Enables/Disables the menu item of the given menu
 *--------------------------------------------------------------
 *
 *  Name:   EnableMenuItem(hwndMenu, idItem, fEnable)
 *
 *  Purpose: Enables or disables the menu item
 *
 *  Usage:  Called whenever a menu item is to be enabled or
 *	    disabled
 *
 *  Method: Sends a MM_SETITEMATTR to the menu with the
 *	    given item id.  Sets the MIA_DISABLED attribute
 *	    flag if the item is to be disabled, clears the flag
 *	    if enabling
 *
 *  Returns:
 *
\****************************************************************/
VOID EnableMenuItem(HWND hwndMenu, SHORT idItem, BOOL fEnable)
{
    SHORT fsFlag;

    if(fEnable)
	fsFlag = 0;
    else
	fsFlag = MIA_DISABLED;

    WinSendMsg(hwndMenu,
	       MM_SETITEMATTR,
	       MPFROM2SHORT(idItem, TRUE),
	       MPFROM2SHORT(MIA_DISABLED, fsFlag));

}   /* EnableMenuItem() */


/*--------------------------------------------------------------*\
 *  End of file :wndproc.c
\*--------------------------------------------------------------*/
#ifndef lint
static char *sccsid = "@(#)word.c 1.3 1/22/92 16:12:04 [1/26/92] (c)IBM Corp. 1992";
#endif

/*
 * This class is adapted from the book
 *   Class Construction in C and C++, Object Oriented Fundamentals
 *   by Roger Sessions, Copyright (c) 1992 Prentice Hall.
 * Reprinted with permission.
 */

#define word_Class_Source
#include "word.ih"
#include <stdlib.h>
#include <string.h>

static int nNews = 0;
static int nDeletes = 0;
#define PARRAY_SIZE		1000
static char *parray[PARRAY_SIZE];


/* ************************************************************ */
SOM_Scope word *SOMLINK wordInit1(word * somSelf,
				   char *string)
{
    wordData *somThis = wordGetData(somSelf);
    wordMethodDebug("word", "wordInit1");

    if (_storage)
	free(_storage);
    _storage = malloc(strlen(string) + 1);
    strcpy(_storage, string);
    _length = strlen(string);
    parray[nNews] = _storage;
    nNews++;
    return somSelf;
}

/* ************************************************************ */
SOM_Scope word *SOMLINK wordInit2(word * somSelf,
				   char newChar,
				   int nChars)
{
    wordData *somThis = wordGetData(somSelf);
    int n;

    wordMethodDebug("word", "wordInit2");

    if (_storage)
	free(_storage);
    _storage = malloc(nChars + 1);
    for (n = 0; n < nChars; n++) {
	_storage[n] = newChar;
    }
    _storage[n] = '\0';
    _length = strlen(_storage);
    parray[nNews] = _storage;
    nNews++;
    return somSelf;
}

/* ************************************************************ */
SOM_Scope int SOMLINK getLength(word * somSelf)
{
    wordData *somThis = wordGetData(somSelf);
    wordMethodDebug("word", "getLength");
    return _length;
}

/* ************************************************************ */
SOM_Scope int SOMLINK wordToInt(word * somSelf)
{
    wordData *somThis = wordGetData(somSelf);
    wordMethodDebug("word", "wordToInt");
    return atoi(_storage);
}

/* ************************************************************ */
SOM_Scope int SOMLINK match(word * somSelf,
			     void *target)
{
    wordData *somThis = wordGetData(somSelf);
    int targetLength = strlen(target);
    wordMethodDebug("word", "match");
    return (!strncmp(_storage, target, targetLength));
}

/* ************************************************************ */
SOM_Scope void SOMLINK print(word * somSelf,
			      FILE * outputFile)
{
    wordData *somThis = wordGetData(somSelf);
    wordMethodDebug("word", "print");

    fprintf(outputFile, "%s", _storage);
    fflush(outputFile);
}

/* ************************************************************ */
SOM_Scope void SOMLINK somInit(word * somSelf)
{
    wordData *somThis = wordGetData(somSelf);
    wordMethodDebug("word", "somInit");
    parent_somInit(somSelf);
    _storage = 0;
}

/* ************************************************************ */
SOM_Scope void SOMLINK somUninit(word * somSelf)
{
    wordData *somThis = wordGetData(somSelf);
    wordMethodDebug("word", "somUninit");
    if (_storage)
	free(_storage);
    parent_somUninit(somSelf);
}

/* ************************************************************ */
SOM_Scope void SOMLINK somDumpSelfInt(word * somSelf,
				       int level)
{
    wordData *somThis = wordGetData(somSelf);
    wordMethodDebug("word", "somDumpSelfInt");
    parent_somDumpSelfInt(somSelf, level);
}

void showWordStats()
{
    int n;
    printf("\n");
    printf("   nNews: %d\n", nNews);
    printf("nDeletes: %d\n", nDeletes);
    for (n = 0; n < PARRAY_SIZE; n++) {
	if (parray[n]) {
	    printf("n: %d storage: %s\n", n, parray[n]);
	}
    }
}


/* ************************************************************ */
SOM_Scope void SOMLINK wrdReplace(word * somSelf,
				   char *newWord)
{
    wordData *somThis = wordGetData(somSelf);
    wordMethodDebug("word", "wrdReplace");

    _length = strlen(newWord);
    if (_storage)
	free(_storage);
    _storage = malloc(_length + 1);
    strcpy(_storage, newWord);
}
/*=========================================================================\
 *									   *
 *	 FILE:worms.c							   *
 *									   *
 *	 DESCRIPTION:	 Full Screen Mixed-mode programming sample	   *
 *									   *
 *	Created 1991  IBM Corp.						   *
 *									   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *	*
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have been *
 *	advised of the possibility of	such damages.			   *				   *
 *									   *
 *-------------------------------------------------------------------------*
 *  This source file contains the following functions:
 *
 *  main
 *  WormsMainProcess
 *  ProcessCmdLine
 *  ErrorMessage
 *  WormsExit
 *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/


#define	 INCL_VIO
#define	 INCL_KBD
#define	 INCL_MOU
#define	 INCL_DOSPROCESS
#define	 INCL_DOSSEMAPHORES


#include <os2.h>
#include <string.h>
#include <stddef.h>
#include <string.h>
#include <stdlib.h>
#include "worms.h"
#include "wrmthrd.h"
#include "init.h"
#include "wrmhelp.h"

/*--------------------------------------------------------------*\
 *Global definitions for this module
\*--------------------------------------------------------------*/


#define STACK_SIZE_WORMTHRD    32678
#define BOX_ROW 6
#define BOX_COL 10
#define HEIGHT_BOX 9
#define BOX_WIDTH  70
#define DEBUG	1

/*--------------------------------------------------------------*\
 *  Global  variables for this module
\*--------------------------------------------------------------*/

SHORT  sCurrentThread = 0;
BOOL   fThreadsContinue = TRUE;
BOOL   fSilent = FALSE;
SHORT  sStartWorms = 1;
BOOL   fQuit  = FALSE;			      /*Global quit flag all threads*/
BOOL   fDraw  = TRUE;			      /*Global draw flag all threads*/
BOOL   bHelpEnabled  = FALSE;
BOOL   bMessage	     = FALSE;

VIOCURSORINFO viociCursor;
VIOMODEINFO   VioModeInfo;
HVIO  hvio = 0 ;
THREAD_DATA ThreadData[] =
/*					 background/text			   */
/*  TID Active Row	     Col	  Attribute		  sCurrentDirection*/
{
    0L, FALSE, BOT_ROW	/ 2 ,FIRST_COL	,MKATRB(WM_BLUE,WM_RED)	       ,0,
    0L, FALSE, FIRST_ROW    ,RGT_COL	,MKATRB(WM_BROWN,WM_CYAN)      ,0,
    0L, FALSE, BOT_ROW	    ,RGT_COL / 2,MKATRB(WM_MAGENTA,WM_PALEGRAY),0,
    0L, FALSE, FIRST_ROW + 5,RGT_COL / 4,MKATRB(WM_LRED,WM_GREEN)      ,0,
    0L, FALSE, BOT_ROW	    ,RGT_COL - 3,MKATRB(WM_YELLOW,WM_WHITE)    ,0,
    0L, FALSE, BOT_ROW	- 4 ,FIRST_COL	,MKATRB(WM_GREEN,WM_LBLUE)     ,0,
    0L, FALSE, FIRST_ROW + 4,RGT_COL	,MKATRB(WM_BROWN,WM_YELLOW)    ,0,
    0L, FALSE, BOT_ROW	- 2 ,RGT_COL / 2,MKATRB(WM_DKGREY,WM_GREEN)    ,0,
    0L, FALSE, FIRST_ROW    ,RGT_COL / 4,MKATRB(WM_BLUE,WM_RED)	       ,0,
    0L, FALSE, BOT_ROW	- 3 ,RGT_COL - 3,MKATRB(WM_WHITE,WM_LBLUE)     ,0,

    0L, FALSE, BOT_ROW	/ 2 ,FIRST_COL	,MKATRB(WM_BLUE,WM_RED)	       ,0,
    0L, FALSE, FIRST_ROW    ,RGT_COL	,MKATRB(WM_BROWN,WM_CYAN)      ,0,
    0L, FALSE, BOT_ROW	    ,RGT_COL / 2,MKATRB(WM_MAGENTA,WM_PALEGRAY),0,
    0L, FALSE, FIRST_ROW + 5,RGT_COL / 4,MKATRB(WM_LRED,WM_GREEN)      ,0,
    0L, FALSE, BOT_ROW	    ,RGT_COL - 3,MKATRB(WM_YELLOW,WM_WHITE)    ,0,
    0L, FALSE, BOT_ROW	- 4 ,FIRST_COL	,MKATRB(WM_GREEN,WM_LBLUE)     ,0,
    0L, FALSE, FIRST_ROW + 4,RGT_COL	,MKATRB(WM_BROWN,WM_YELLOW)    ,0,
    0L, FALSE, BOT_ROW	- 2 ,RGT_COL / 2,MKATRB(WM_DKGREY,WM_GREEN)    ,0,
    0L, FALSE, FIRST_ROW    ,RGT_COL / 4,MKATRB(WM_BLUE,WM_RED)	       ,0,
    0L, FALSE, BOT_ROW	- 3 ,RGT_COL - 3,MKATRB(WM_WHITE,WM_LBLUE)     ,0,

    0L, FALSE, BOT_ROW	/ 2 ,FIRST_COL	,MKATRB(WM_BLUE,WM_RED)	       ,0,
    0L, FALSE, FIRST_ROW    ,RGT_COL	,MKATRB(WM_BROWN,WM_CYAN)      ,0,
    0L, FALSE, BOT_ROW	    ,RGT_COL / 2,MKATRB(WM_MAGENTA,WM_PALEGRAY),0,
    0L, FALSE, FIRST_ROW + 5,RGT_COL / 4,MKATRB(WM_LRED,WM_GREEN)      ,0,
    0L, FALSE, BOT_ROW	    ,RGT_COL - 3,MKATRB(WM_YELLOW,WM_WHITE)    ,0,
    0L, FALSE, BOT_ROW	- 4 ,FIRST_COL	,MKATRB(WM_GREEN,WM_LBLUE)     ,0,
    0L, FALSE, FIRST_ROW + 4,RGT_COL	,MKATRB(WM_BROWN,WM_YELLOW)    ,0,
    0L, FALSE, BOT_ROW	- 2 ,RGT_COL / 2,MKATRB(WM_DKGREY,WM_GREEN)    ,0,
    0L, FALSE, FIRST_ROW    ,RGT_COL / 4,MKATRB(WM_BLUE,WM_RED)	       ,0,
    0L, FALSE, BOT_ROW	- 3 ,RGT_COL - 3,MKATRB(WM_WHITE,WM_LBLUE)     ,0,
};
CHAR *pszBox [HEIGHT_BOX]=
{
"ͻ",
"                                                        ",
"               Process  Message:                        ",
"                                                        ",
"                                                        ",
"                                                        ",
"                                                        ",
"                                                        ",
"ͼ",
};
CHAR *pszWormMessages [] =
{
     "Worms Mixed-Mode Program Normal Exit",
     "Undetermined Error Occurred",
     "Worms Mixed Mode Program Initialization Failure",
     "Maximum Number of Threads Reached for this Process",
     "Error Creating Thread",
     "Unable To Display Help Screen",
     "Unable To Create  Mouse Event Thread",
     "Hit Any Key to Exit Process",
     "Waiting for Threads To Exit",
     "Any Key to Continue",
};

#define	   MAX_ERROR_MSGS (sizeof (pszErrorMessage) )
#define	   MAX_THREADS	  ( ( sizeof(ThreadData) / sizeof(THREAD_DATA) ) -1 )
#define	   ONCE		while( 0 )
/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/
INT
main (SHORT sArgc , CHAR *ppArgv[]);
VOID
WormsExit(SHORT sExitStatus);
BOOL
WormsMainProcess(SHORT *psStatus);
BOOL
ProcessCmdLine(SHORT sArgc,CHAR **ppArgv);

/****************************************************************\
 *  Routine Name:main()
 *--------------------------------------------------------------
 *
 *  Name: main()
 *
 *  Purpose:Main entry point for  the worms program
 *
 *
 *
 *  Usage: Main entry point for the worms program.
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *
\****************************************************************/
INT
main (SHORT sArgc,CHAR	*ppArgv[])
{

    SHORT     sExitStatus = WRM_NORMAL_EXIT;

    do
    {

	 /*
	  *process the command line
	  */
	 if(ProcessCmdLine(sArgc,ppArgv) )
	 {
	       break;
	 }

	 /*
	  *initialize resources
	  */
	 if(Init(&sExitStatus) )
	 {
	       ErrorMessage(sExitStatus,TRUE);
	       break;

	 }
	 /*
	  *start up the main process
	  */
	 if(WormsMainProcess(&sExitStatus) )
	 {
	       ErrorMessage(sExitStatus,TRUE);
	       break;

	 }

    } ONCE;
    WormsExit(WRM_NORMAL_EXIT);

    return( (INT) sExitStatus);


}/*main entry point*/

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:WormsMainProcess
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    FALSE - if sucessful execution completed
 *	    TRUE  - if error ,See *psStatus for error definition
\****************************************************************/
BOOL
WormsMainProcess(SHORT *psStatus)
{
    BOOL fError = FALSE;
    KBDKEYINFO	  kbdkeyinfo;
    USHORT	usId;
    ULONG ulPosts;


    do
    {
	  /*
	   *sit here and wait on
	   *user input
	   */
	  KbdCharIn(&kbdkeyinfo,IO_WAIT,
		     0) ;
	  /*
	   *if help was enabled don't allow any other input
	   */
	  if(!bHelpEnabled && !bMessage)
	  {
	       /*
		*regular keys
		*/
	       if( kbdkeyinfo.chChar )
	       {
		    switch(kbdkeyinfo.chChar)
		    {
		    case 'd':
		    case 'D':
			   WormDelete();
			   break;
		    case 'e':
		    case 'E':
			 fQuit = TRUE;
			 fDraw = FALSE;
			 break;
		    case 'a':
		    case 'A':
			 WormCreate();
			 break;
		    case 'h':
		    case 'H':
			 if( WormHelp() )
			 {
			      ErrorMessage(ERROR_DISP_HELP,TRUE);
			 }
			 break;
		    default:
			 DosBeep(1200,175);
			 break;
		    }
	       }
	       /*
		*extended keys
		*/
	       else
	       {
		    switch(kbdkeyinfo.chScan )
		    {
		    case F1:
			 if( WormHelp() )
			 {
			      ErrorMessage(ERROR_DISP_HELP,TRUE);
			 }
			 break;
		    default:
			 DosBeep(1200,175);
			 break;
		    }
	       }

	  }
	  /*
	   *another threads  waiting for keyboard input
	   *free them up
	   */
	  else
	  {
	       DosPostEventSem(hevWormSem);
	  }

    }while(!fQuit );

    /*
     *set each thread as inactive
     */
    for(usId = 2; usId <= MAX_THREADS + 2; usId++)
    {
	  ThreadData[usId - 2].fActive = FALSE;
    }

     /*
      *make sure we don't get
      *pre-empted
      */
     DosEnterCritSec();
     ulPosts = 0;
     DosResetEventSem(hevDrawOk,&ulPosts);
     DosExitCritSec();

     /*
      *wait till all of the
      *threads have
      *posted on the way out
      */
     while(ulPosts < sCurrentThread)
     {
	  DosWaitEventSem(hevDrawOk,SEM_INDEFINITE_WAIT);
	  DosQueryEventSem(hevDrawOk,&ulPosts);
     }
    /*
     *display message that process is shutting down
     */
    Message(WAITING_THREADS_EXIT,FALSE,FALSE,TRUE,FALSE);
    return ( fError) ;
}/*main process loop */

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name: WormCreate()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    TRUE   - Error occurred
 *	    FALSE  - No error occurred
\****************************************************************/
BOOL
WormCreate(VOID )
{

    if( sCurrentThread	== MAX_THREADS )
    {
	  /*
	   *thread limit exceeeded
	   */
	   ErrorMessage(MAX_THREADS_EXCEEDED,TRUE );
	   return(TRUE);

    }
    ThreadData[sCurrentThread].fActive = TRUE;
    ThreadData[sCurrentThread].tidWorm =
			    _beginthread( WormThread,
				       NULL,
				       STACK_SIZE_WORMTHRD,
				       &ThreadData[sCurrentThread]);
    if(ThreadData[sCurrentThread].tidWorm ==  -1 )
    {
	  ErrorMessage(ERROR_CREATING_THREAD,TRUE );
	  return(TRUE);
    }
    sCurrentThread++;

    return(FALSE);

}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name: ErrorMessage()
 *
 *  Purpose: Display Error Messages to the user.
 *
 *
 *
 *  Usage: sErrorMessage - Message number to display.
 *	   fBeep	 - Beep or not.
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:   VOID
\****************************************************************/
VOID ErrorMessage(SHORT sErrorMessage,BOOL fBeep)

{

    KBDKEYINFO	  kbdkeyinfo;
    BYTE  bAttr	 = MKATRB(WM_RED,WM_WHITE );
    USHORT usAttrib = VP_WAIT | VP_OPAQUE;
    USHORT  usRow,usIndex;
    USHORT  usStatus = MOUSE_DISABLED;
    BYTE bCell[2];
    PVOID pvSaveWindBuf;
    PTIB   ptib ;
    PPIB   ppib	 ;
    ULONG  ulPosts;

    bCell[0] = 0x20;
    bCell[1] = WM_BACKGROUND;
    bMessage = TRUE;


    if(fBeep)
    {
	  DosBeep(675,1200);
    }

     /*
      *freeze all threads
      *while pop-up is up
      */
     SuspendAllThreads();
     /*
      *make sure each thread has had enough time
      *to complete
      *what they are doin before waiting on the drawing semaphore
      */
//   DosSleep(PAUSE_TIME * 40);
     /*
      *read the screen and save
      *it
      */
     if(SaveScreen(&pvSaveWindBuf) )
     {
	  return;
     }

     VioScrollDn(0,0,0xFFFF,0xFFFF,0xFFFF,bCell,hvio);


    /*
     *put up the  message box
     */
     for(usRow = BOX_ROW,usIndex = 0;usIndex < HEIGHT_BOX; usIndex++,
							  usRow++ )
     {
	VioWrtCharStrAtt(pszBox[usIndex],strlen(pszBox[usIndex]),
		     usRow,
		     BOX_COL,
		     &bAttr,
		     hvio );
     }

     /*
      *display
      *error message
      */
      VioWrtCharStrAtt( pszWormMessages[sErrorMessage],
			 strlen(pszWormMessages[sErrorMessage]),
			 BOX_ROW + 5,
			 ( ((LAST_COL - FIRST_COL ) -
				    strlen(pszWormMessages[sErrorMessage])) / 2) ,
			 &bAttr,
			 hvio );
       /*
	*any key to continue
	*/
       VioWrtCharStrAtt( pszWormMessages[ANY_KEY_TO_CONTINUE],
			 strlen(pszWormMessages[ANY_KEY_TO_CONTINUE]),
			 BOX_ROW + 6,
			 ( ((LAST_COL - FIRST_COL ) -
				    strlen(pszWormMessages[ANY_KEY_TO_CONTINUE])) / 2) ,
			 &bAttr,
			 hvio );

      DosGetInfoBlocks(&ptib,&ppib);
      /*
       *if we are not
       *calling from thread
       *one suspend the calling thread
       *so only one thread at a time
       *is hitting the keyboard queue
       */
      if(ptib->tib_ptib2->tib2_ultid != 1 )
      {
	  DosWaitEventSem(hevWormSem,SEM_INDEFINITE_WAIT);
	  DosResetEventSem(hevWormSem,&ulPosts);
      }
      else
      {
	 /*
	  *wait for any
	  *response if thread 1
	  */
	  KbdCharIn(&kbdkeyinfo,IO_WAIT,
			 0) ;
      }

      VioScrollDn(0,0,0xFFFF,0xFFFF,0xFFFF,bCell,hvio);
      /*
       *restore the screen
       */
      ReDisplayScreen(pvSaveWindBuf);

       /*
	*resume all threads
	*/
     ResumeAllThreads();

     bMessage = FALSE;
}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name: Message()
 *
 *  Purpose:Generic message routine. Allows all threads to continue,
 *	    while message is up.
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:   VOID
 *
 *
\****************************************************************/
VOID Message( SHORT sErrorMessage,BOOL fBeep,BOOL fKeyBoardWait,
		   BOOL fClsConsole,BOOL fSuspendThreads )
{
    KBDKEYINFO	  kbdkeyinfo;
    BYTE  bAttr	 = MKATRB(WM_RED,WM_WHITE );
    USHORT usAttrib = VP_WAIT | VP_OPAQUE;
    USHORT  usRow,usIndex;
    BYTE bCell[2];
    BYTE bhAttr = WM_BACKGROUND;

    bCell[0] = 0x20;
    bCell[1] = WM_BACKGROUND;

     /*
      *display
      *the error message to the
      *screen
      */
      if(fBeep)
      {
	  DosBeep(675,1200);
      }

      if(fSuspendThreads)
      {
	  SuspendAllThreads();
      }

      DosSleep(1000L);
      if(fClsConsole)
      {
	  /*
	   *clear the screen
	   */
	  VioScrollDn(0,0,0xFFFF,0xFFFF,0xFFFF,bCell,hvio);
      }

       /*
	*put up the  message box
	*/

       for(usRow = BOX_ROW,usIndex = 0;usIndex < HEIGHT_BOX; usIndex++,
							     usRow++ )
       {
	  VioWrtCharStrAtt(pszBox[usIndex],strlen(pszBox[usIndex]),
			usRow,
			BOX_COL,
			&bAttr,
			hvio );
       }

       /*
	*display
	*message
	*/
       VioWrtCharStrAtt( pszWormMessages[sErrorMessage],
			 strlen(pszWormMessages[sErrorMessage]),
			 BOX_ROW + 5,
			 ( ((LAST_COL - FIRST_COL ) -
				    strlen(pszWormMessages[sErrorMessage])) / 2) ,
			 &bAttr,
			 hvio );

       /*
	*sit here and wait on
	*user input
	*/
       if(fKeyBoardWait)
       {

	   VioWrtCharStrAtt( pszWormMessages[sErrorMessage],
			     strlen(pszWormMessages[sErrorMessage]),
			     BOX_ROW + 6,
			     ( ((LAST_COL - FIRST_COL ) -
					strlen(pszWormMessages[ANY_KEY_TO_CONTINUE])) / 2) ,
			     &bAttr,
			     hvio );
	   KbdCharIn(&kbdkeyinfo,IO_WAIT,
		      0 ) ;
       }

}

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:WormsExit()
 *
 *  Purpose: Generic exit routine. All exit processing should be done
 *	     at this point.
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:   VOID
 *
 *
\****************************************************************/
VOID
WormsExit(SHORT sExitStatus)
{

     USHORT usRow,usCol;
     BYTE bCell[2];
     BYTE bhAttr = MKATRB(WM_BLUE,WM_RED);

     bCell[0] = 0x20;
     bCell[1] = WM_BACKGROUND;


     /*
      *do any clean up
      *necessary
      */


     /*
      *clear the screen
      */
     VioScrollDn(0,0,0xFFFF,0xFFFF,0xFFFF,bCell,hvio);

     /*
      *reset the old
      *cursor
      */
     VioSetCurType(&viociCursor,hvio);
     /*
      *display the exit message
      */
     VioWrtCharStrAtt( pszWormMessages[sExitStatus],
		       strlen(pszWormMessages[sExitStatus]),
		       2,1,
		       &bhAttr,hvio );
     VioSetCurPos(3,2,hvio);

}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ProcessCmdLine()
 *
 *  Purpose:Parse arguments passed on the command line.
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	  FALSE	  - at present time
 *
\****************************************************************/
BOOL ProcessCmdLine(SHORT sArgc,CHAR **ppArgv)
{
     SHORT sArgnum = 1;
     BOOL  fError = FALSE;

     while(--sArgc )
     {
	  if( *ppArgv[sArgnum] == '-'	||
	      *ppArgv[sArgnum] == '/' )
	  {

	       switch(*(ppArgv[sArgnum] + 1) )
	       {
	       case 'S':
	       case 's':
		    fSilent = TRUE;
		    break;
	       case '1':
	       case '2':
	       case '3':
	       case '4':
	       case '5':
	       case '6':
	       case '7':
	       case '8':
	       case '9':
		    sStartWorms = atoi(ppArgv[sArgnum] + 1);
		    if(sStartWorms > MAX_THREADS )
		    {
			 sStartWorms = MAX_THREADS;
		    }
		    break;
	       }
	  }
	  sArgnum++;
     }
     return(fError);
}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:WormDelete()
 *
 *  Purpose:Set the active flag to false for the last active
 *  thread to FALSE.
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *
 *	    VOID
\****************************************************************/
VOID WormDelete(VOID )
{

      if(sCurrentThread > 0 )
      {
	 ThreadData[--sCurrentThread].fActive = FALSE;
      }
      else
      {
	  DosBeep(675,1200);
      }

}



/*=========================================================================\
 *									   *
 *	 FILE:wrmhelp.c							   *
 *									   *
 *	 DESCRIPTION:							   *
 *									   *
 *									   *
 *									   *
 *	Copyright 1991 , IBM Corp.					   *
 *									   *
 *-------------------------------------------------------------------------*
 *									   *
 *									   *
 *									   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *	*
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have been *
 *	advised of the possibility of	such damages.			   *				   *
 *									   *
 *									   *
 *									   *
 *									   *
 *									   *
 *									   *
 *									   *
 *									   *
 *--------------------------------------------------------------------------
 *
 *  This source file contains the following functions:
 *
 * WormHelp
 * SuspendAllThreads
 * SaveScreen
 * ResumeAllThreads
 * RedisplayScreen
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/
#define	 INCL_DOSMEMMGR
#define	 INCL_KBD
#define	 INCL_VIO
#define	 INCL_MOU
#define	 INCL_DOSPROCESS
#define	 INCL_DOSSEMAPHORES
#include <os2.h>
#include <string.h>
#include "worms.h"
#include "wrmthrd.h"
#include "wrmhelp.h"

/*--------------------------------------------------------------*\
 *  Global variables  and definitions for this file
\*--------------------------------------------------------------*/

CHAR *pszHelp =
"                                                                              \
                                                                                \
                        Worms  Mixed Mode Overview                              \
                                                                                \
                                                                                \
     This program is a sample application   intended to demonstrate calling     \
     16 - bit API's from 32 bit code.   The Vio, Mou, and KBD subsystem are     \
     used for this example. Each thread is started with a unique color code     \
     and  will  randomly  move  about the screen. Each time another worm is     \
     encountered  the  worms  color  will  change to red, then revert back.     \
                                                                                \
                        Worms Mixed Mode Help                                   \
                                                                                \
     Additional threads (Worms) may be started by entering 'A' at the keyboard. \
     Worms may be Deleted by entering 'D' at the keyboard. The mouse may also   \
     be used to add worms or delete worms by using the mouse buttons.           \
     To exit from the program enter 'E'.                                        \
                                                                                \
     From the command line the following options may be specified.              \
                                                                                \
                                                                                \
      worms -s         Silent Mode                                              \
      worms -x         Where x  is a value from 1 to 30 indicating the number   \
                       of worms to start of with. Default is 1.                 \
                                                                                \
                                                                                \
                       Copyright     IBM Corp.   1992                           \
                                                                                \
                                                                                \
                                                                                \
";

PVOID pvSaveWindBuf;


/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/

/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:WormHelp()
 *
 *  Purpose: This routine displays the help screen for the
 *	     worms program.
 *
 *
 *  Usage:
 *
 *  Method:    This routine is the main flow control for the help
 *	    -  routine. The other threads will be suspended,the
 *	       current screen is saved in a allocated buffer,
 *	    -  display the help screen, wait for a keystroke,
 *	    -  restore the old screen,resume child threads and
 *	       free buffer.
 *	    -
 *	    -
 *
 *  Returns:
 *	    TRUE    - Error Occurred.
 *	    FALSE     No Error Occurred
\****************************************************************/
BOOL
WormHelp(VOID )
{

    KBDKEYINFO	  kbdkeyinfo;
    PTIB   ptib ;
    PPIB   ppib	 ;
    ULONG  ulPosts;

    bHelpEnabled  = TRUE;

     /*
      *freeze all worms
      */
      if(SuspendAllThreads() )
      {
	  return(TRUE);
      }

     /*
      *read the screen
      *and save it
      */
      if(SaveScreen(&pvSaveWindBuf) )
      {
	  return(TRUE);
      }

     /*
      *display the help screen
      */
      DisplayHelp();

      DosGetInfoBlocks(&ptib,&ppib);
      /*
       *if we are not
       *calling from thread
       *one suspend thread,
       *so only one thread at a time
       *is hitting the keyboard queue
       */
      if(ptib->tib_ptib2->tib2_ultid != 1 )
      {
	  DosWaitEventSem(hevWormSem,SEM_INDEFINITE_WAIT);
	  DosResetEventSem(hevWormSem,&ulPosts);
      }
      else
      {
	 /*
	  *wait for any
	  *response if thread 1
	  */
	  KbdCharIn(&kbdkeyinfo,IO_WAIT,
			 0) ;
      }



     /*
      *redisplay the saved screen
      */
      ReDisplayScreen(pvSaveWindBuf);



     /*
      *allow all child threads to resume
      */
     bHelpEnabled  = FALSE;


     ResumeAllThreads();
     return(FALSE);

}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:SuspendAllThreads()
 *
 *  Purpose: This routine allow the calling thread to force the
 *	     other threads that are drawing to the screen to wait
 *	     until this thread is done. The worm (threads) will block
 *	     on the hevDrawSem until it is cleared again. The calling
 *	     thread will wait until the post count on the hevDrawOK
 *	     sem is equal to the number of worms before returnning.
 *
 *  Returns:
 *	    FALSE - if sucessful execution completed
 *	    TRUE  - if error
\****************************************************************/
BOOL
SuspendAllThreads(VOID )
{
     BOOL fError = FALSE;
     ULONG ulPosts =0L;

     fDraw = FALSE;

     /*
      *make sure we don't get
      *pre-empted
      */
     DosEnterCritSec();
     DosResetEventSem(hevDrawOk,&ulPosts);
     ulPosts = 0;

     DosResetEventSem(hevDrawSem,&ulPosts);
     ulPosts = 0;
     DosExitCritSec();
     /*
      *wait till all of the
      *threads have
      *posted
      */
     while(ulPosts < sCurrentThread)
     {
	  DosWaitEventSem(hevDrawOk,SEM_INDEFINITE_WAIT);
	  DosQueryEventSem(hevDrawOk,&ulPosts);

     }

     return(fError );

}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name: DisplayHelp()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	   TRUE	  - Error occurred
 *	   FALSE    No error occurred
\****************************************************************/
BOOL
DisplayHelp(VOID )
{
     BYTE bCell[2];
     BYTE bhAttr =  MKATRB(WM_PALEGRAY,WM_BLUE);


     bCell[0] = 0x20;
     bCell[1] = MKATRB(WM_PALEGRAY,WM_BLUE);


     VioScrollDn(0,0,0xFFFF,0xFFFF,0xFFFF,bCell,hvio);
     VioWrtCharStrAtt(pszHelp,strlen(pszHelp),
			      TOP_ROW,LEFT_COL,&bhAttr,hvio );
     return FALSE;
}


/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:ResumeAllThreads()
 *
 *  Purpose:
 *
 *
 *
 *  Usage:
 *
 *  Method:
 *	    -
 *
 *	    -
 *	    -
 *
 *	    -
 *	    -
 *
 *  Returns:
 *	    FALSE - is always returned
\****************************************************************/
BOOL
ResumeAllThreads(VOID )
{

     fDraw = TRUE;
     DosPostEventSem(hevDrawSem);
     return( FALSE );
}
/*--------------------------------------------------------------*\
 *  End of file :wrmhelp.c
\*--------------------------------------------------------------*/
/*=========================================================================\
 *									   *
 *	 FILE: wrmthrd.c						   *
 *									   *
 *	 DESCRIPTION:							   *
 *									   *
 *									   *
 *	Created 1991  IBM Corp.						   *
 *									   *
 *	DISCLAIMER OF WARRANTIES.  The following [enclosed] code is	   *
 *	sample code created by IBM Corporation. This sample code is not	   *
 *	part of any standard or IBM product and is provided to you solely  *
 *	for  the purpose of assisting you in the development of your	   *	*
 *	applications.  The code is provided "AS IS", without		   *
 *	warranty of any kind.  IBM shall not be liable for any damages	   *
 *	arising out of your use of the sample code, even if they have been *
 *	advised of the possibility of	such damages.			   *				   *
 *									   *
 *-------------------------------------------------------------------------*
 *--------------------------------------------------------------
 *
 *  This source file contains the following functions:
 *
 *
 *  move_worm_up
 *  move_worm_down
 *  move_worm_right
 *  move_worm_left
 *  move_worm_zigup
 *
 *
 *
\*==============================================================*/

/*--------------------------------------------------------------*\
 *  Include files, macros, defined constants, and externs
\*--------------------------------------------------------------*/

#define	 INCL_DOS
#define	 INCL_VIO
#define	 INCL_KBD
#define	 INCL_MOU
#define	 INCL_DOSPROCESS
#define	 INCL_DOSSEMAPHORES

#include <os2.h>
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <string.h>
#include <stdlib.h>
#include "worms.h"
#include "wrmthrd.h"
/*--------------------------------------------------------------*\
 *  Global variables  and definitions for this file
\*--------------------------------------------------------------*/
CHAR *pszLeftWorm   =	   "<<<------->";
CHAR *pszRightWorm  =	   "<------->>>";
CHAR *pszBlank	    =	   "               ";
CHAR achUpWorm[10]  =	   {'^','^','|','|','|','v'};
CHAR achDownWorm[10]=	   {'^','^','|','|','|','v'};
SHORT asWidths	 [] =	   {2,4,8,16};
SHORT asHorizWidths  [] =  {HOR_WIDTH / 2, HOR_WIDTH /8,HOR_WIDTH,HOR_WIDTH / 3};
SHORT asVertHeights  [] =  {HEIGHT / 4,HEIGHT / 8, HEIGHT / 2, HEIGHT  };
SHORT sDirection = 0;
SHORT sVertHeight = 0;
SHORT sRefresh = 1;
#define DEBUG		   0
#define MAX_LEN_WORM	   48
#define FILE_NAME	   "TEST.???"

/*--------------------------------------------------------------*\
 *  Entry point declarations
\*--------------------------------------------------------------*/

VOID move_worm_up( USHORT *pusCurrentRow,USHORT *pusCurrentCol,
		     PBYTE  pbAttribute,
		     SHORT *psCurrentDirection,
		     LONG  tidWorm);
VOID move_worm_down( USHORT *pusCurrentRow,USHORT *pusCurrentCol,
		     PBYTE  pbAttribute,
		     SHORT *psCurrentDirection,
		     LONG  tidWorm);
VOID move_worm_right( USHORT *pusCurrentRow,USHORT *pusCurrentCol,
		     PBYTE  pbAttribute,
		     SHORT *psCurrentDirection,
		     LONG  tidWorm);
VOID move_worm_left( USHORT *pusCurrentRow,USHORT *pusCurrentCol,
		     PBYTE  pbAttribute,
		     SHORT *psCurrentDirection,
		     LONG  tidWorm);
VOID move_worm_zigup(USHORT *pusCurrentRow,USHORT *pusCurrentCol,
		      PBYTE pbAttribute,
		      SHORT *psCurrentDirection,
		      LONG tidWorm);
/****************************************************************\
 *  Routine Name:wrmthrd()
 *--------------------------------------------------------------
 *
 *  Name:
 *
 *  Purpose: This routine allows each thread to draw to the screen.
 *	     Each thread will stay in this loop, until the thread
 *	     dies, or is terminated. Each thread may draw to the
 *	     unless the semaphore is set by thread one or indicating
 *	     that one of the parent threads wants control of the
 *	     screeen.
 *
 *  Returns: There is no return value. The thread terminates.
 *
\****************************************************************/
VOID _Optlink
WormThread(PVOID pvMessage)
{

     PTHREAD_DATA pThreadData;
     SHORT  sDummy;
     SHORT  asDirection [] = { UP,RIGHT,LEFT,DOWN};



     srand(sDummy);
     pThreadData =  (PTHREAD_DATA) pvMessage;
     /*
      *start the worm  off
      */
     if(sDirection == ( sizeof(asDirection) / sizeof(SHORT) ) )
     {
	  sDirection = 0;
     }
     pThreadData->sCurrentDirection = asDirection[sDirection++];
     do
     {
	  switch(pThreadData->sCurrentDirection)
	  {
	  case UP:
	       move_worm_up( &pThreadData->usCurrentRow,&pThreadData->usCurrentCol,
			     &pThreadData->bAttribute,
			     &pThreadData->sCurrentDirection,
			      pThreadData->tidWorm);
	       break;
	  case DOWN:
	       move_worm_down( &pThreadData->usCurrentRow,&pThreadData->usCurrentCol,
			       &pThreadData->bAttribute,
			       &pThreadData->sCurrentDirection,
				pThreadData->tidWorm);
	       break;

	  case LEFT:
	       move_worm_left( &pThreadData->usCurrentRow,&pThreadData->usCurrentCol,
			       &pThreadData->bAttribute,
			       &pThreadData->sCurrentDirection,
				pThreadData->tidWorm );
	       break;
	  case RIGHT:
	       move_worm_right( &pThreadData->usCurrentRow,&pThreadData->usCurrentCol,
				&pThreadData->bAttribute,
				&pThreadData->sCurrentDirection,
				 pThreadData->tidWorm );
	       break;
	  case ZIG_UP:
	       move_worm_zigup( &pThreadData->usCurrentRow,&pThreadData->usCurrentCol,
			     &pThreadData->bAttribute,
			     &pThreadData->sCurrentDirection,
			      pThreadData->tidWorm );
	       break;
	  default:
	       pThreadData->usCurrentRow = ( LAST_ROW - FIRST_ROW ) /2;
	       pThreadData->usCurrentCol = ( LAST_COL - FIRST_COL ) /2;
	       if(sDirection == ( sizeof(asDirection) / sizeof(SHORT) ) )
	       {
		    sDirection = 0;
	       }
	       pThreadData->sCurrentDirection = asDirection[sDirection++];
	       break;
	  }
	  DosSleep(PAUSE_TIME);
	  /*
	   *if set,then the thread that services the console,or the
	   *thread that services the mouse queue wants control of
	   *the screen
	   */
	  DosPostEventSem(hevDrawOk);
	  DosWaitEventSem(hevDrawSem,SEM_INDEFINITE_WAIT);

	}while(pThreadData->fActive);

     pThreadData->tidWorm = 0;
     /*
      *if the process is to exit
      *post the semaphore on the way out
      */
      if(fQuit)
      {
	  DosPostEventSem(hevDrawOk);
      }

    /*
     *should alway be called
     *to free any runtime resources this thread
     *might be using
     */
    _endthread();

}/*WormThread*/
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:move_worm_down()
 *
 *  Purpose: Draw the worm down the screen vertically and set up to go to
 *	     another direction.
 *  Returns: VOID
 *
\****************************************************************/
VOID move_worm_down(USHORT *pusCurrentRow,USHORT *pusCurrentCol,PBYTE pbAttribute,
		      SHORT *psCurrentDirection,
		      LONG  tidWorm )

{

     USHORT sRow;
     SHORT  sPos = 0;
     SHORT  sStartRow;
     CHAR  achCell[2];
     BYTE  bAttribute;
     USHORT  usCount;
     BOOL  fOnce = TRUE;
     BYTE  bBackGround = WM_BACKGROUND;

     if(sVertHeight  == (sizeof(asVertHeights) / sizeof(SHORT ) ) )
     {
	  sVertHeight = 0;
     }
     if(*pusCurrentRow <= FIRST_ROW || *pusCurrentRow >= LAST_ROW )
     {
	  *pusCurrentRow = ( LAST_ROW - asVertHeights[sVertHeight++]) ;
     }

     if(*pusCurrentRow < FIRST_ROW || *pusCurrentRow > LAST_ROW )
     {
	  *pusCurrentRow = (FIRST_ROW + 1);
     }
     sStartRow = *pusCurrentRow;
     usCount = sizeof(achCell);
     bAttribute = *pbAttribute;
     for(sRow = (*pusCurrentRow + WIDTH); *pusCurrentRow < LAST_ROW && fDraw; (*pusCurrentRow)++ )
     {
	  /*
	   *read the current attribute
	   *on the screen
	   *if another worm
	   */
	  VioReadCellStr(achCell,&usCount,*pusCurrentRow,*pusCurrentCol,hvio);
	  if(!fSilent)
	  {
	       if(achCell[0] != ' ' && fOnce )
	       {
		    DosBeep(600,175);
		    DosBeep(1200,175);
		    bAttribute = 0x4F;
		    fOnce = FALSE;
	       }
	  }
	  VioWrtCharStrAtt( &achDownWorm[sPos],1,
			    *pusCurrentRow,*pusCurrentCol,&bAttribute,
			    hvio );
	  DosSleep(PAUSE_TIME);
	  if(!achUpWorm[sPos++] )
	  {
		for(; sStartRow <= (*pusCurrentRow ) && fDraw;sStartRow++)
		{
		    VioWrtCharStrAtt( &pszBlank[0],1,
				      sStartRow,*pusCurrentCol,&bBackGround,
				      hvio );
		}
		sPos = 0;
	  }

     }
     /*
      *clean off any tail we
      *left behind
      */
     if(sPos)
     {
	  for(; sStartRow <= (*pusCurrentRow ) ;sStartRow++)
	  {
	      VioWrtCharStrAtt( &pszBlank[sPos],1,
				sStartRow,*pusCurrentCol,&bBackGround,
				hvio );
	  }
     }

    /*
     *if we stopped drawing
     *come back to the same spot
     */
    if(fDraw)
    {
	 *psCurrentDirection = (rand() % MAX_DIRECTIONS);
	 *pusCurrentRow = (rand() % HEIGHT);
	 *pusCurrentCol = ( (rand() % HOR_WIDTH) /  asWidths[rand() %  4] + 1);
    }

}
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:move_worm_up()
 *
 *  Purpose:Redraw the worm moving vertically up the screen.
 *	    Draw until the bottom of the screen or fDraw flag has
 *	    been reset.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID move_worm_up(USHORT *pusCurrentRow,USHORT *pusCurrentCol,PBYTE pbAttribute,
		      SHORT *psCurrentDirection,
		      LONG tidWorm )

{

     USHORT sRow;
     SHORT  sPos;
     SHORT  sStartRow;
     BYTE  bBackGround = WM_BACKGROUND;
     static SHORT sVertHeight = 0;

     if(sVertHeight  == (sizeof(asVertHeights) / sizeof(SHORT ) ) )
     {
	  sVertHeight = 0;
     }
     if(*pusCurrentRow <= FIRST_ROW || *pusCurrentRow >= LAST_ROW )
     {
	  *pusCurrentRow = ( LAST_ROW - asVertHeights[sVertHeight]) ;
     }
     sStartRow = *pusCurrentRow;
     for(sRow = (*pusCurrentRow - WIDTH),sPos = 0;
			    (*pusCurrentRow > FIRST_ROW )&& fDraw;
			    (*pusCurrentRow)--)
     {
	  /*
	   *read the current attribute
	   *on the screen
	   *if another worm beep
	   */
	  VioWrtCharStrAtt( &achUpWorm[sPos],1,
			    *pusCurrentRow,*pusCurrentCol,pbAttribute,
			    hvio );
	  DosSleep(PAUSE_TIME);
	  if(!achUpWorm[sPos++] )
	  {
		for(; sStartRow >= (*pusCurrentRow ) && fDraw;sStartRow--)
		{
		    VioWrtCharStrAtt( &pszBlank[0],1,
				      sStartRow,*pusCurrentCol,&bBackGround,
				      hvio );
		}
		sPos = 0;
	  }


     }
     /*
      *clean up any head on the screen
      */
    if(sPos)
    {
	  for(; sStartRow >= (*pusCurrentRow ) ;sStartRow--)
	  {
	      VioWrtCharStrAtt( &pszBlank[0],1,
				sStartRow,*pusCurrentCol,&bBackGround,
				hvio );
	  }
    }

    /*
     *if we stopped drawing
     *come back to the same spot
     */
    if(fDraw)
    {
	 *psCurrentDirection = ( rand() % MAX_DIRECTIONS);
	 *pusCurrentRow = ( (rand() % HEIGHT)  );
	 *pusCurrentCol = ( (rand() % HOR_WIDTH)/  asWidths[rand() %  4] + 1) ;
    }
}


/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:move_worm_right()
 *
 *  Purpose:Move the worm to the right side of the screen and wrap
 *	    around.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID move_worm_right(USHORT *pusCurrentRow,USHORT *pusCurrentCol,PBYTE pbAttribute,
		      SHORT *psCurrentDirection,
		      LONG  tidWorm )

{
     SHORT sCol;
     USHORT usSize;
     BYTE  bAttribute;
     BOOL  fOnce = TRUE;
     static SHORT sHorizWidth = 0;
     BYTE  bBackGround = WM_BACKGROUND;
     USHORT usOldRow,usOldCol;
     CHAR  achCell[ MAX_LEN_WORM ];
     USHORT usCount;


     if(*pusCurrentRow < FIRST_ROW || *pusCurrentRow > LAST_ROW )
     {
	  *pusCurrentRow = (FIRST_ROW + 1);
     }
     if(sHorizWidth == (sizeof(asHorizWidths) / sizeof(SHORT ) ) )
     {
	  sHorizWidth = 0;
     }

     usSize = sizeof(achCell);
     bAttribute = *pbAttribute;

     usOldRow = *pusCurrentRow;
     usOldCol = *pusCurrentCol;
     usCount = strlen(pszRightWorm);
     VioReadCellStr(achCell,&usCount,usOldRow,usOldCol,hvio);
     for(sCol = (*pusCurrentCol + asHorizWidths[sHorizWidth++]);
		      (*pusCurrentCol) <= sCol && fDraw;
			   (*pusCurrentCol)++ )
     {
	  /*
	   *read the current attribute
	   *on the screen
	   *if another worm
	   */
	  VioReadCellStr(achCell,&usSize,*pusCurrentRow,*pusCurrentCol,hvio);
	  if(!fSilent)
	  {
	       if(achCell[0] != ' ' && fOnce )
	       {
		    DosBeep(600,175);
		    DosBeep(1200,175);
		    bAttribute = 0x4F;
		    fOnce = FALSE;
	       }
	  }

	  VioWrtCharStrAtt( pszRightWorm,strlen(pszRightWorm),
			    *pusCurrentRow,*pusCurrentCol,&bAttribute,
			    hvio );
	  /*
	   *erase the last one
	   *by setting the background
	   *color
	   */
	  DosSleep(PAUSE_TIME);
	  VioWrtCharStrAtt( pszBlank,strlen(pszRightWorm),
		       *pusCurrentRow,(*pusCurrentCol),&bBackGround,
		       hvio );


    }

    /*
     *if we stopped drawing
     *come back to the same spot
     */
    if(fDraw)
    {
	 VioWrtCellStr(achCell,usCount,usOldRow,usOldCol,hvio);
	 *psCurrentDirection = (rand() %  MAX_DIRECTIONS);
	 *pusCurrentCol = ( (rand() % HOR_WIDTH) + 1/  asWidths[rand() %  4] + 1);
	 *pusCurrentRow = ( (rand() % HEIGHT) );
    }

}


/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:move_worm_zigup
 *
 *  Purpose:Draw the worm in a diagonal direction moving upwards.
 *
 *  Returns:
 *	    VOID
\****************************************************************/
VOID move_worm_zigup(USHORT *pusCurrentRow,USHORT *pusCurrentCol,
		      PBYTE pbAttribute,
		      SHORT *psCurrentDirection,
		      LONG tidWorm )
{

     USHORT sRow;
     SHORT  sPos;
     SHORT  sStartRow,sStartCol;
     BYTE  bBackGround = WM_BACKGROUND;

     sStartRow = *pusCurrentRow;
     sStartCol = *pusCurrentCol;
     for(sRow = (*pusCurrentRow - WIDTH),sPos = 0;
			    (*pusCurrentRow > FIRST_ROW + 1) && fDraw;
			    (*pusCurrentRow) -=2,(*pusCurrentCol)++ )
     {
	  VioWrtCharStrAtt( &achUpWorm[sPos],1,
			    *pusCurrentRow,*pusCurrentCol,pbAttribute,
			    hvio );
	  DosSleep(PAUSE_TIME);
	  if(!achUpWorm[sPos++] )
	  {
		for(; sStartRow >= (*pusCurrentRow )&& fDraw;sStartRow -=2 ,sStartCol++ )
		{
		    VioWrtCharStrAtt( &pszBlank[0],1,
				      sStartRow,sStartCol,&bBackGround,
				      hvio );
		}
		sPos = 0;
	  }


     }
     /*
      *clean up any head on the screen
      */
    if(sPos)
    {
	  for(; sStartRow >= (*pusCurrentRow );sStartRow -=2 )
	  {
	      VioWrtCharStrAtt( &pszBlank[0],1,
				sStartRow,sStartCol++,&bBackGround,
				hvio );
	  }
    }

    /*
     *if we stopped drawing
     *come back to the same spot
     */
    if(fDraw)
    {
	 *psCurrentDirection = ( rand() % MAX_DIRECTIONS);
	 *pusCurrentCol = ( (rand() % HOR_WIDTH)/  asWidths[rand() %  4] + 1);
	 *pusCurrentRow = ( (rand() % HEIGHT) );
    }

}


/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  Name:move_worm_left()
 *
 *  Purpose:Move the worm to the left side of the screen.
 *
 *  Returns: VOID
 *
\****************************************************************/
VOID move_worm_left(USHORT *pusCurrentRow,USHORT *pusCurrentCol,
		      PBYTE pbAttribute,
		      SHORT *psCurrentDirection,
		      LONG  tidWorm )

{

     USHORT sCol;
     static SHORT sHorizWidth = 0;
     BYTE  bBackGround = WM_BACKGROUND;


     if(sHorizWidth == (sizeof(asHorizWidths) / sizeof(SHORT ) ) )
     {
	  sHorizWidth = 0;
     }

     if(*pusCurrentRow < FIRST_ROW || *pusCurrentRow > LAST_ROW )
     {
	  *pusCurrentRow = (LAST_ROW - 1);
     }
    sCol = rand()  % WIDTH;
    if( sCol > *pusCurrentCol)
    {
	  sCol = sCol - *pusCurrentCol;
    }
    for( ;((*pusCurrentCol) >  sCol) && fDraw; (*pusCurrentCol)--)
    {
	 /*
	  *read the current attribute
	  *on the screen
	  *if another worm
	  */

	 VioWrtCharStrAtt( pszLeftWorm,strlen(pszLeftWorm),
			   *pusCurrentRow,*pusCurrentCol,pbAttribute,
			   hvio );

	 DosSleep(PAUSE_TIME);
	 if(!fDraw)
	 {
	       break;
	 }
	 VioWrtCharStrAtt( pszBlank,strlen(pszLeftWorm),
			   *pusCurrentRow,(*pusCurrentCol),&bBackGround,
			    hvio );

    }
    /*
     *if we stopped drawing
     *come back to the same spot
     */
    if(fDraw)
    {
	  *psCurrentDirection = (rand() %  MAX_DIRECTIONS);
	  *pusCurrentRow = ( (rand() % HEIGHT) );
	  *pusCurrentCol = ( (rand() % HOR_WIDTH)/  asWidths[rand() %  4]  + 1);
    }
}

/*--------------------------------------------------------------*\
 *  End of file : wrmthrd.c
\*--------------------------------------------------------------*/
